[![Android CI](https://github.com/andreynovikov/trekarta/actions/workflows/android.yml/badge.svg)](https://github.com/andreynovikov/trekarta/actions/workflows/android.yml)
[![CodeQL](https://github.com/andreynovikov/trekarta/actions/workflows/codeql-analysis.yml/badge.svg)](https://github.com/andreynovikov/trekarta/actions/workflows/codeql-analysis.yml)
[![GitHub release](https://img.shields.io/github/release/andreynovikov/trekarta.svg)](https://github.com/andreynovikov/trekarta/releases/latest)
[![F-Droid](https://img.shields.io/f-droid/v/mobi.maptrek)](https://f-droid.org/packages/mobi.maptrek/)
[![GitHub license](https://img.shields.io/badge/license-GPLv3-blue.svg)](LICENSE)

__Trekarta__ (former MapTrek) is designed for hiking, geocaching, off-roading, cycling, boating and all other outdoor activities. It uses offline maps so you do not need to have internet connection. You can easily import places and tracks from GPX and KML data formats or create places in application and share them to others. It lets you write the track of your journey, even in background, so you will never get lost and be able later see where you've been.

[<img src="https://play.google.com/intl/en_us/badges/images/generic/en-play-badge.png"
     alt="Get it on Google Play"
     height="80">](https://play.google.com/store/apps/details?id=mobi.maptrek)
[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
     alt="Get it on F-Droid"
     height="80">](https://f-droid.org/packages/mobi.maptrek/)

__Offline maps__

Trekarta uses OpenStreetMap based vector maps that are lightweight, offline and are constantly enhanced by contributors. Maps contain detailed topological data with elevation contours. Some map elements can be filtered out for cleaner look. Trekarta has built-in hillshades support. You can add custom maps in sqlite or mbtiles format to cover your area of interest. Custom maps will be shaded as well. Such maps can be created by yourself with SAS.Planet application from mostly any online source or converted with MapTiler and other applications from other map formats.

![](https://trekarta.info/images/maps.png)

__Hiking__

Special hiking activity mode emphasises paths and tracks on map. It visualizes path difficulty and visibility and displays hiking routes. It also displays special OSMC symbols that help you identify desired route.

![](https://trekarta.info/images/hiking.png)

__Cycling__

Special cycling activity mode reveals bicycle infrastructure. It shows cycling routes and visualizes mountain biking track difficulty and visibility.

![](https://trekarta.info/images/cycling.png)

__Skiing and skating__

Skiing activity mode displays clean winter map with mostly all skiing activities: downhill, nordic, hiking and touring. As a bonus freestyle snow-boarding, skating and sleighing areas are displayed.

![](https://trekarta.info/images/skiing.png)

__Off-road__

Unpaved, dirt, winter and ice roads are specially visualized. 4wd only roads have specific marking. Fords are displayed on all roads, even primary.

![](https://trekarta.info/images/offroad.png)

__Places__

Places can be easily imported from GPX and KML files or can be created within application. You can navigate to points and share them with others.

![](https://trekarta.info/images/places.png)

__Tracks__

Trekarta is designed to record tracks of your journey. Simply press a button when you start and press it once more when you finish. You can quit the application if you do not need to look at the map, the track will be recorded in the background.

![](https://trekarta.info/images/tracking.png)

Trekarta is developed as a hobby for personal use but is generously shared to public on as-is basis. Developers are welcome to contribute to the project. Specifically experts in OpenGL and PostGIS are much needed.

Bug reports and feature proposals are welcome in [issue tracker](https://github.com/andreynovikov/trekarta/issues), for general questions [Discussions](https://github.com/andreynovikov/trekarta/discussions) should be preferred.
