/*
 * Copyright 2013 Hannes Janetzek
 *
 * This file is part of the OpenScienceMap project (http://www.opensciencemap.org).
 *
 * This program is free software: you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.oscim.renderer.atlas;

import org.oscim.renderer.atlas.TextureAtlas.Rect;
import org.oscim.renderer.bucket.TextureItem;

public class TextureRegion {

    public TextureRegion(TextureItem texture, Rect r) {
        this.texture = texture;
        this.rect = r;
    }

    public final Rect rect;
    public final TextureItem texture;

    @Override
    public int hashCode() {
        int result = 17;
        result = 31 * result + texture.hashCode();
        result = 31 * result + rect.hashCode();
        return result;
    }
}
