/*
 The provided code is written by Tim Cooper:   tim@edval.com.au
 This code is available under the MIT licence:  https://opensource.org/licenses/MIT
*/
package com.skedgo.converter;

public class TimezoneMapper {

    public static String latLngToTimezoneString(double lat, double lng)
    {
        return timezoneStrings[getTzInt((float) lat, (float) lng)];
    }

    static String[] timezoneStrings = {
            "unknown",
            "Africa/Abidjan",
            "Africa/Accra",
            "Africa/Addis_Ababa",
            "Africa/Algiers",
            "Africa/Asmara",
            "Africa/Bamako",
            "Africa/Bangui",
            "Africa/Banjul",
            "Africa/Bissau",
            "Africa/Blantyre",
            "Africa/Brazzaville",
            "Africa/Bujumbura",
            "Africa/Cairo",
            "Africa/Casablanca",
            "Africa/Ceuta",
            "Africa/Conakry",
            "Africa/Dakar",
            "Africa/Dar_es_Salaam",
            "Africa/Djibouti",
            "Africa/Douala",
            "Africa/El_Aaiun",
            "Africa/Freetown",
            "Africa/Gaborone",
            "Africa/Harare",
            "Africa/Johannesburg",
            "Africa/Juba",
            "Africa/Kampala",
            "Africa/Khartoum",
            "Africa/Kigali",
            "Africa/Kinshasa",
            "Africa/Lagos",
            "Africa/Libreville",
            "Africa/Lome",
            "Africa/Luanda",
            "Africa/Lubumbashi",
            "Africa/Lusaka",
            "Africa/Malabo",
            "Africa/Maputo",
            "Africa/Maseru",
            "Africa/Mbabane",
            "Africa/Mogadishu",
            "Africa/Monrovia",
            "Africa/Nairobi",
            "Africa/Ndjamena",
            "Africa/Niamey",
            "Africa/Nouakchott",
            "Africa/Ouagadougou",
            "Africa/Porto-Novo",
            "Africa/Sao_Tome",
            "Africa/Tripoli",
            "Africa/Tunis",
            "Africa/Windhoek",
            "America/Adak",
            "America/Anchorage",
            "America/Anguilla",
            "America/Antigua",
            "America/Aruba",
            "America/Araguaina",
            "America/Argentina/Buenos_Aires",
            "America/Argentina/Catamarca",
            "America/Argentina/Cordoba",
            "America/Argentina/Jujuy",
            "America/Argentina/La_Rioja",
            "America/Argentina/Mendoza",
            "America/Argentina/Rio_Gallegos",
            "America/Argentina/Salta",
            "America/Argentina/San_Juan",
            "America/Argentina/San_Luis",
            "America/Argentina/Tucuman",
            "America/Argentina/Ushuaia",
            "America/Asuncion",
            "America/Atikokan",
            "America/Bahia",
            "America/Bahia_Banderas",
            "America/Barbados",
            "America/Belem",
            "America/Belize",
            "America/Blanc-Sablon",
            "America/Boa_Vista",
            "America/Bogota",
            "America/Boise",
            "America/Cambridge_Bay",
            "America/Campo_Grande",
            "America/Cancun",
            "America/Caracas",
            "America/Cayenne",
            "America/Cayman",
            "America/Chicago",
            "America/Chihuahua",
            "America/Costa_Rica",
            "America/Creston",
            "America/Cuiaba",
            "America/Curacao",
            "America/Danmarkshavn",
            "America/Dawson",
            "America/Dawson_Creek",
            "America/Denver",
            "America/Detroit",
            "America/Dominica",
            "America/Edmonton",
            "America/Eirunepe",
            "America/El_Salvador",
            "America/Fort_Nelson",
            "America/Fortaleza",
            "America/Glace_Bay",
            "America/Godthab",
            "America/Goose_Bay",
            "America/Grand_Turk",
            "America/Grenada",
            "America/Guadeloupe",
            "America/Guatemala",
            "America/Guayaquil",
            "America/Guyana",
            "America/Halifax",
            "America/Havana",
            "America/Hermosillo",
            "America/Indiana/Indianapolis",
            "America/Indiana/Knox",
            "America/Indiana/Marengo",
            "America/Indiana/Petersburg",
            "America/Indiana/Tell_City",
            "America/Indiana/Vevay",
            "America/Indiana/Vincennes",
            "America/Indiana/Winamac",
            "America/Inuvik",
            "America/Iqaluit",
            "America/Jamaica",
            "America/Juneau",
            "America/Kentucky/Louisville",
            "America/Kentucky/Monticello",
            "America/Kralendijk",
            "America/La_Paz",
            "America/Lima",
            "America/Los_Angeles",
            "America/Lower_Princes",
            "America/Maceio",
            "America/Managua",
            "America/Manaus",
            "America/Marigot",
            "America/Martinique",
            "America/Matamoros",
            "America/Mazatlan",
            "America/Miquelon",
            "America/Menominee",
            "America/Merida",
            "America/Metlakatla",
            "America/Mexico_City",
            "America/Moncton",
            "America/Monterrey",
            "America/Montevideo",
            "America/Montserrat",
            "America/Nassau",
            "America/New_York",
            "America/Nipigon",
            "America/Nome",
            "America/Noronha",
            "America/North_Dakota/Beulah",
            "America/North_Dakota/Center",
            "America/North_Dakota/New_Salem",
            "America/Ojinaga",
            "America/Panama",
            "America/Pangnirtung",
            "America/Paramaribo",
            "America/Phoenix",
            "America/Port-au-Prince",
            "America/Port_of_Spain",
            "America/Porto_Velho",
            "America/Puerto_Rico",
            "America/Punta_Arenas",
            "America/Rainy_River",
            "America/Rankin_Inlet",
            "America/Recife",
            "America/Regina",
            "America/Resolute",
            "America/Rio_Branco",
            "America/Santarem",
            "America/Santiago",
            "America/Santo_Domingo",
            "America/Sao_Paulo",
            "America/Scoresbysund",
            "America/Sitka",
            "America/St_Barthelemy",
            "America/St_Johns",
            "America/St_Kitts",
            "America/St_Lucia",
            "America/St_Thomas",
            "America/St_Vincent",
            "America/Swift_Current",
            "America/Tegucigalpa",
            "America/Thule",
            "America/Thunder_Bay",
            "America/Tijuana",
            "America/Toronto",
            "America/Tortola",
            "America/Vancouver",
            "America/Whitehorse",
            "America/Winnipeg",
            "America/Yakutat",
            "America/Yellowknife",
            "Antarctica/Casey",
            "Antarctica/Davis",
            "Antarctica/DumontDUrville",
            "Antarctica/Macquarie",
            "Antarctica/Mawson",
            "Antarctica/McMurdo",
            "Antarctica/Palmer",
            "Antarctica/Rothera",
            "Antarctica/Syowa",
            "Antarctica/Troll",
            "Antarctica/Vostok",
            "Arctic/Longyearbyen",
            "Asia/Aden",
            "Asia/Almaty",
            "Asia/Amman",
            "Asia/Anadyr",
            "Asia/Aqtau",
            "Asia/Aqtobe",
            "Asia/Ashgabat",
            "Asia/Atyrau",
            "Asia/Baghdad",
            "Asia/Bahrain",
            "Asia/Baku",
            "Asia/Bangkok",
            "Asia/Barnaul",
            "Asia/Beirut",
            "Asia/Bishkek",
            "Asia/Brunei",
            "Asia/Chita",
            "Asia/Choibalsan",
            "Asia/Colombo",
            "Asia/Damascus",
            "Asia/Dhaka",
            "Asia/Dili",
            "Asia/Dubai",
            "Asia/Dushanbe",
            "Asia/Famagusta",
            "Asia/Gaza",
            "Asia/Hebron",
            "Asia/Ho_Chi_Minh",
            "Asia/Hong_Kong",
            "Asia/Hovd",
            "Asia/Irkutsk",
            "Asia/Jakarta",
            "Asia/Jayapura",
            "Asia/Jerusalem",
            "Asia/Kabul",
            "Asia/Kamchatka",
            "Asia/Karachi",
            "Asia/Kathmandu",
            "Asia/Khandyga",
            "Asia/Kolkata",
            "Asia/Krasnoyarsk",
            "Asia/Kuala_Lumpur",
            "Asia/Kuching",
            "Asia/Kuwait",
            "Asia/Macau",
            "Asia/Magadan",
            "Asia/Makassar",
            "Asia/Manila",
            "Asia/Muscat",
            "Asia/Nicosia",
            "Asia/Novokuznetsk",
            "Asia/Novosibirsk",
            "Asia/Omsk",
            "Asia/Oral",
            "Asia/Phnom_Penh",
            "Asia/Pontianak",
            "Asia/Pyongyang",
            "Asia/Qatar",
            "Asia/Qostanay",
            "Asia/Qyzylorda",
            "Asia/Riyadh",
            "Asia/Samarkand",
            "Asia/Sakhalin",
            "Asia/Seoul",
            "Asia/Shanghai",
            "Asia/Singapore",
            "Asia/Srednekolymsk",
            "Asia/Taipei",
            "Asia/Tashkent",
            "Asia/Tbilisi",
            "Asia/Tehran",
            "Asia/Thimphu",
            "Asia/Tokyo",
            "Asia/Tomsk",
            "Asia/Ulaanbaatar",
            "Asia/Urumqi",
            "Asia/Ust-Nera",
            "Asia/Vientiane",
            "Asia/Vladivostok",
            "Asia/Yakutsk",
            "Asia/Yangon",
            "Asia/Yekaterinburg",
            "Asia/Yerevan",
            "Atlantic/Azores",
            "Atlantic/Bermuda",
            "Atlantic/Canary",
            "Atlantic/Cape_Verde",
            "Atlantic/Faroe",
            "Atlantic/Madeira",
            "Atlantic/Reykjavik",
            "Atlantic/South_Georgia",
            "Atlantic/St_Helena",
            "Atlantic/Stanley",
            "Australia/Adelaide",
            "Australia/Brisbane",
            "Australia/Broken_Hill",
            "Australia/Currie",
            "Australia/Darwin",
            "Australia/Eucla",
            "Australia/Hobart",
            "Australia/Lindeman",
            "Australia/Lord_Howe",
            "Australia/Melbourne",
            "Australia/Perth",
            "Australia/Sydney",
            "Etc/UTC",
            "Europe/Amsterdam",
            "Europe/Andorra",
            "Europe/Astrakhan",
            "Europe/Athens",
            "Europe/Belgrade",
            "Europe/Berlin",
            "Europe/Bratislava",
            "Europe/Brussels",
            "Europe/Bucharest",
            "Europe/Budapest",
            "Europe/Busingen",
            "Europe/Chisinau",
            "Europe/Copenhagen",
            "Europe/Dublin",
            "Europe/Gibraltar",
            "Europe/Guernsey",
            "Europe/Helsinki",
            "Europe/Isle_of_Man",
            "Europe/Istanbul",
            "Europe/Jersey",
            "Europe/Kaliningrad",
            "Europe/Kiev",
            "Europe/Kirov",
            "Europe/Lisbon",
            "Europe/Ljubljana",
            "Europe/London",
            "Europe/Luxembourg",
            "Europe/Madrid",
            "Europe/Malta",
            "Europe/Mariehamn",
            "Europe/Minsk",
            "Europe/Monaco",
            "Europe/Moscow",
            "Europe/Oslo",
            "Europe/Paris",
            "Europe/Podgorica",
            "Europe/Prague",
            "Europe/Riga",
            "Europe/Rome",
            "Europe/Samara",
            "Europe/San_Marino",
            "Europe/Sarajevo",
            "Europe/Saratov",
            "Europe/Simferopol",
            "Europe/Skopje",
            "Europe/Sofia",
            "Europe/Stockholm",
            "Europe/Tallinn",
            "Europe/Tirane",
            "Europe/Ulyanovsk",
            "Europe/Uzhgorod",
            "Europe/Vaduz",
            "Europe/Vatican",
            "Europe/Vienna",
            "Europe/Vilnius",
            "Europe/Volgograd",
            "Europe/Warsaw",
            "Europe/Zagreb",
            "Europe/Zaporozhye",
            "Europe/Zurich",
            "Indian/Antananarivo",
            "Indian/Chagos",
            "Indian/Christmas",
            "Indian/Cocos",
            "Indian/Comoro",
            "Indian/Kerguelen",
            "Indian/Mahe",
            "Indian/Maldives",
            "Indian/Mauritius",
            "Indian/Mayotte",
            "Indian/Reunion",
            "Pacific/Apia",
            "Pacific/Auckland",
            "Pacific/Bougainville",
            "Pacific/Chatham",
            "Pacific/Chuuk",
            "Pacific/Easter",
            "Pacific/Efate",
            "Pacific/Enderbury",
            "Pacific/Fakaofo",
            "Pacific/Fiji",
            "Pacific/Funafuti",
            "Pacific/Galapagos",
            "Pacific/Gambier",
            "Pacific/Guadalcanal",
            "Pacific/Guam",
            "Pacific/Honolulu",
            "Pacific/Kiritimati",
            "Pacific/Kosrae",
            "Pacific/Kwajalein",
            "Pacific/Majuro",
            "Pacific/Marquesas",
            "Pacific/Midway",
            "Pacific/Nauru",
            "Pacific/Niue",
            "Pacific/Norfolk",
            "Pacific/Noumea",
            "Pacific/Pago_Pago",
            "Pacific/Palau",
            "Pacific/Pitcairn",
            "Pacific/Pohnpei",
            "Pacific/Port_Moresby",
            "Pacific/Rarotonga",
            "Pacific/Saipan",
            "Pacific/Tahiti",
            "Pacific/Tarawa",
            "Pacific/Tongatapu",
            "Pacific/Wake",
            "Pacific/Wallis"
    };

    private static int getTzInt(float lat, float lng)
    {
        if (lng < 40.227580f)
            if (lng < -74.790449f)
                if (lat < 11.948729f)
                    if (lng < -148.915052f)
                        if (lat < -15.365572f)
                            if (lng < -162.907168f)
                                if (lat < -22.132469f)
                                    if (lat < -31.152578f)
                                        if (lat < -75.000000f)
                                            return 205;
                                        else
                                        if (lat < -37.433796f)
                                            return 390;
                                        else
                                            return 392;
                                    else
                                    if (lat < -29.030330f)
                                        return 390;
                                    else
                                        return 424;
                                else
                                if (lat < -18.370291f)
                                    if (lat < -19.391686f)
                                        if (lng < -178.018393f)
                                            return 398;
                                        else
                                            return 424;
                                    else
                                    if (lng < -174.409124f)
                                        if (lng < -176.450182f)
                                            return 398;
                                        else
                                            return 424;
                                    else
                                    if (lng < -171.934489f)
                                        return 412;
                                    else
                                        return 424;
                                else
                                if (lng < -175.393670f)
                                    if (lng < -176.944457f)
                                        return 398;
                                    else
                                        return 424;
                                else
                                if (lng < -173.529546f)
                                    return 424;
                                else
                                    return 420;
                            else
                            if (lat < -18.624323f)
                                if (lat < -21.595903f)
                                    if (lat < -23.126466f)
                                        if (lat < -49.301828f)
                                            return 205;
                                        else
                                            return 422;
                                    else
                                    if (lng < -157.667741f)
                                        return 420;
                                    else
                                        return 422;
                                else
                                    return 420;
                            else
                                return 422;
                        else
                        if (lng < -170.339391f)
                            if (lat < -8.332863f)
                                if (lat < -12.982796f)
                                    if (lng < -175.919039f)
                                        return 426;
                                    else
                                    if (lng < -171.122917f)
                                        return 389;
                                    else
                                        return 415;
                                else
                                if (lng < -172.263966f)
                                    if (lat < -9.006964f)
                                        return 397;
                                    else
                                        return 399;
                                else
                                if (lat < -10.844975f)
                                    return 415;
                                else
                                    return 397;
                            else
                                return 396;
                        else
                        if (lat < -8.716879f)
                            if (lng < -162.837703f)
                                if (lng < -169.212472f)
                                    return 415;
                                else
                                    return 420;
                            else
                            if (lng < -157.674746f)
                                return 420;
                            else
                            if (lng < -149.992536f)
                                return 405;
                            else
                                return 422;
                        else
                            return 405;
                    else
                    if (lat < -19.605166f)
                        if (lat < -24.280320f)
                            if (lat < -33.406000f)
                                if (lat < -48.582229f)
                                    if (lat < -66.000000f)
                                    {
                                        if (poly[0].contains(lat,lng)) return 207;
                                        else return 205;
                                    }
                                    else
                                    if (lng < -74.972849f)
                                    {
                                        if (poly[1].contains(lat,lng)) return 177;
                                        else return 169;
                                    }
                                    else
                                    {
                                        if (poly[2].contains(lat,lng)) return 177;
                                        else return 169;
                                    }
                                else
                                    return 177;
                            else
                            if (lat < -26.087000f)
                                if (lng < -143.258327f)
                                    return 422;
                                else
                                if (lat < -26.702500f)
                                    return 177;
                                else
                                    return 394;
                            else
                                return 417;
                        else
                        if (lng < -138.293890f)
                            return 422;
                        else
                        if (lng < -134.244799f)
                            return 401;
                        else
                            return 417;
                    else
                    if (lng < -140.967399f)
                        return 422;
                    else
                    if (lng < -138.120374f)
                        if (lat < -14.596066f)
                            return 422;
                        else
                            return 409;
                    else
                    if (lng < -86.850836f)
                        if (lng < -136.083016f)
                            return 422;
                        else
                        if (lat < 3.608283f)
                            return 90;
                        else
                            return 400;
                    else
                    if (lat < 4.215425f)
                        if (lat < 1.469581f)
                            if (lat < -8.981652f)
                                return 133;
                            else
                            if (lat < -3.756035f)
                                if (lng < -79.713051f)
                                {
                                    if (poly[3].contains(lat,lng)) return 112;
                                    else return 133;
                                }
                                else
                                {
                                    if (poly[4].contains(lat,lng)) return 112;
                                    else return 133;
                                }
                            else
                            if (lng < -79.655334f)
                            {
                                if (poly[5].contains(lat,lng)) return 133;
                                else return 112;
                            }
                            else
                            if (lat < -1.143227f)
                            {
                                if (poly[6].contains(lat,lng)) return 133;
                                else return 112;
                            }
                            else
                            if (lng < -77.222892f)
                            {
                                if (poly[7].contains(lat,lng)) return 80;
                                else return 112;
                            }
                            else
                            if (lat < 0.163177f)
                                if (lng < -76.006670f)
                                    return 112;
                                else
                                if (lat < -0.490025f)
                                {
                                    if (poly[8].contains(lat,lng)) return 133;
                                    else return 112;
                                }
                                else
                                {
                                    if (poly[9].contains(lat,lng)) return 80;
                                    if (poly[10].contains(lat,lng)) return 133;
                                    else return 112;
                                }
                            else
                            {
                                if (poly[11].contains(lat,lng)) return 112;
                                else return 80;
                            }
                        else
                            return 80;
                    else
                    if (lng < -83.545675f)
                    {
                        if (poly[12].contains(lat,lng)) return 137;
                        else return 90;
                    }
                    else
                    if (lng < -82.506021f)
                    {
                        if (poly[13].contains(lat,lng)) return 161;
                        else return 90;
                    }
                    else
                    if (lng < -78.648235f)
                        return 161;
                    else
                    if (lat < 7.779632f)
                    {
                        if (poly[14].contains(lat,lng)) return 161;
                        else return 80;
                    }
                    else
                    {
                        if (poly[15].contains(lat,lng)) return 161;
                        else return 80;
                    }
                else
                    return call5(lat,lng);
            else
            if (lat < 27.433543f)
                if (lng < -34.628225f)
                    return call18(lat,lng);
                else
                    return call19(lat,lng);
            else
            if (lng < 4.940364f)
                return call25(lat,lng);
            else
                return call26(lat,lng);
        else
        if (lat < 6.459000f)
            if (lat < -13.507685f)
                return call28(lat,lng);
            else
            if (lng < 137.031744f)
                if (lng < 79.769537f)
                    if (lng < 51.396615f)
                        if (lat < -9.003195f)
                            if (lng < 45.507035f)
                                if (lng < 40.934512f)
                                {
                                    if (poly[16].contains(lat,lng)) return 18;
                                    else return 38;
                                }
                                else
                                {
                                    if (poly[17].contains(lat,lng)) return 387;
                                    else return 382;
                                }
                            else
                            if (lat < -11.732889f)
                                return 378;
                            else
                                return 384;
                        else
                        if (lat < 1.448202f)
                        {
                            if (poly[18].contains(lat,lng)) return 43;
                            else return 41;
                        }
                        else
                        if (lng < 44.770743f)
                        {
                            if (poly[19].contains(lat,lng)) return 41;
                            if (poly[20].contains(lat,lng)) return 43;
                            else return 3;
                        }
                        else
                        {
                            if (poly[21].contains(lat,lng)) return 3;
                            else return 41;
                        }
                    else
                    if (lng < 56.153431f)
                        return 384;
                    else
                    if (lat < -6.892368f)
                        if (lng < 56.907685f)
                            if (lat < -8.768959f)
                                return 384;
                            else
                                return 386;
                        else
                            return 379;
                    else
                    if (lat < -5.037066f)
                        return 379;
                    else
                        return 385;
                else
                    return call27(lat,lng);
            else
            if (lng < 158.980861f)
                if (lat < -9.690684f)
                    if (lng < 144.157024f)
                        return 306;
                    else
                        return 419;
                else
                if (lng < 143.966337f)
                    if (lat < -9.484383f)
                        return 306;
                    else
                    if (lng < 142.851886f)
                        if (lng < 141.647501f)
                            if (lat < -9.445798f)
                                return 306;
                            else
                            {
                                if (poly[22].contains(lat,lng)) return 419;
                                else return 244;
                            }
                        else
                        if (lng < 142.345755f)
                        {
                            if (poly[23].contains(lat,lng)) return 306;
                            else return 419;
                        }
                        else
                        {
                            if (poly[24].contains(lat,lng)) return 306;
                            else return 419;
                        }
                    else
                    if (lng < 143.653847f)
                        if (lng < 143.338933f)
                        {
                            if (poly[25].contains(lat,lng)) return 306;
                            else return 419;
                        }
                        else
                        if (lat < -9.389158f)
                            return 306;
                        else
                            return 419;
                    else
                    if (lat < -9.088012f)
                        return 306;
                    else
                        return 419;
                else
                if (lat < -0.557358f)
                    if (lng < 144.296103f)
                        if (lat < -9.305249f)
                            return 306;
                        else
                            return 419;
                    else
                    if (lng < 154.622311f)
                    {
                        if (poly[26].contains(lat,lng)) return 391;
                        else return 419;
                    }
                    else
                    if (lat < -6.377546f)
                    {
                        if (poly[27].contains(lat,lng)) return 391;
                        else return 402;
                    }
                    else
                        return 391;
                else
                if (lng < 154.023397f)
                    return 393;
                else
                    return 418;
            else
            if (lat < -4.810850f)
                if (lng < 169.050657f)
                    if (lat < -12.871378f)
                        if (lng < 163.592134f)
                            return 395;
                        else
                            return 402;
                    else
                        return 402;
                else
                if (lat < -11.406307f)
                    if (lng < 170.396467f)
                        return 402;
                    else
                        return 398;
                else
                    return 399;
            else
            if (lng < 172.373701f)
                if (lng < 168.336144f)
                    if (lng < 160.917151f)
                        if (lat < 0.877112f)
                            return 391;
                        else
                            return 418;
                    else
                    if (lng < 163.236405f)
                        return 406;
                    else
                    if (lat < 2.544000f)
                        return 408;
                    else
                        return 411;
                else
                if (lat < -0.645000f)
                    return 423;
                else
                    return 408;
            else
                return 423;
        else
        if (lng < 115.212170f)
            if (lat < 28.246987f)
                return call43(lat,lng);
            else
            if (lng < 69.957225f)
                if (lat < 43.586429f)
                    if (lng < 51.009030f)
                        return call32(lat,lng);
                    else
                        return call33(lat,lng);
                else
                if (lat < 54.891446f)
                    return call36(lat,lng);
                else
                if (lat < 55.442170f)
                    if (lng < 53.915395f)
                    {
                        if (poly[28].contains(lat,lng)) return 293;
                        else return 350;
                    }
                    else
                    if (lng < 59.172064f)
                    {
                        if (poly[29].contains(lat,lng)) return 350;
                        else return 293;
                    }
                    else
                    {
                        if (poly[30].contains(lat,lng)) return 293;
                        else return 213;
                    }
                else
                if (lat < 73.603159f)
                    return call35(lat,lng);
                else
                    return 350;
            else
                return call42(lat,lng);
        else
            return call46(lat,lng);
    }

    private static int call0(float lat, float lng)
    {
        if (lat < 31.541963f)
            if (lng < -105.630949f)
                if (lat < 28.333599f)
                    if (lng < -107.815375f)
                        if (lat < 26.729418f)
                        {
                            if (poly[31].contains(lat,lng)) return 89;
                            if (poly[32].contains(lat,lng)) return 116;
                            else return 142;
                        }
                        else
                        if (lng < -108.907589f)
                        {
                            if (poly[33].contains(lat,lng)) return 89;
                            if (poly[34].contains(lat,lng)) return 89;
                            else return 116;
                        }
                        else
                        if (lat < 27.531508f)
                        {
                            if (poly[35].contains(lat,lng)) return 116;
                            if (poly[36].contains(lat,lng)) return 142;
                            else return 89;
                        }
                        else
                        {
                            if (poly[37].contains(lat,lng)) return 116;
                            if (poly[38].contains(lat,lng)) return 116;
                            if (poly[39].contains(lat,lng)) return 116;
                            if (poly[40].contains(lat,lng)) return 116;
                            else return 89;
                        }
                    else
                    if (lat < 26.729418f)
                        if (lng < -106.723162f)
                        {
                            if (poly[41].contains(lat,lng)) return 89;
                            if (poly[42].contains(lat,lng)) return 149;
                            else return 142;
                        }
                        else
                        {
                            if (poly[43].contains(lat,lng)) return 149;
                            else return 89;
                        }
                    else
                    {
                        if (poly[44].contains(lat,lng)) return 149;
                        else return 89;
                    }
                else
                if (lng < -107.815375f)
                    if (lat < 29.937781f)
                    {
                        if (poly[45].contains(lat,lng)) return 116;
                        else return 89;
                    }
                    else
                    if (lng < -108.907589f)
                    {
                        if (poly[46].contains(lat,lng)) return 97;
                        if (poly[47].contains(lat,lng)) return 160;
                        if (poly[48].contains(lat,lng)) return 164;
                        else return 116;
                    }
                    else
                    if (lat < 30.739872f)
                    {
                        if (poly[49].contains(lat,lng)) return 89;
                        if (poly[50].contains(lat,lng)) return 116;
                        else return 160;
                    }
                    else
                    {
                        if (poly[51].contains(lat,lng)) return 89;
                        if (poly[52].contains(lat,lng)) return 97;
                        if (poly[53].contains(lat,lng)) return 116;
                        else return 160;
                    }
                else
                if (lat < 29.937781f)
                {
                    if (poly[54].contains(lat,lng)) return 160;
                    else return 89;
                }
                else
                if (lng < -106.723162f)
                {
                    if (poly[55].contains(lat,lng)) return 160;
                    else return 89;
                }
                else
                {
                    if (poly[56].contains(lat,lng)) return 89;
                    if (poly[57].contains(lat,lng)) return 97;
                    else return 160;
                }
            else
            if (lat < 28.333599f)
                if (lng < -103.446522f)
                    if (lat < 26.729418f)
                    {
                        if (poly[58].contains(lat,lng)) return 89;
                        if (poly[59].contains(lat,lng)) return 89;
                        else return 149;
                    }
                    else
                    if (lng < -104.538735f)
                        return 89;
                    else
                    if (lat < 27.531508f)
                    {
                        if (poly[60].contains(lat,lng)) return 89;
                        if (poly[61].contains(lat,lng)) return 141;
                        if (poly[62].contains(lat,lng)) return 141;
                        else return 149;
                    }
                    else
                    {
                        if (poly[63].contains(lat,lng)) return 89;
                        if (poly[64].contains(lat,lng)) return 141;
                        if (poly[65].contains(lat,lng)) return 141;
                        else return 149;
                    }
                else
                if (lat < 26.729418f)
                    return 149;
                else
                if (lng < -102.354308f)
                {
                    if (poly[66].contains(lat,lng)) return 141;
                    else return 149;
                }
                else
                {
                    if (poly[67].contains(lat,lng)) return 141;
                    if (poly[68].contains(lat,lng)) return 141;
                    else return 149;
                }
            else
            if (lng < -103.446522f)
                if (lat < 29.937781f)
                    if (lng < -104.538735f)
                    {
                        if (poly[69].contains(lat,lng)) return 88;
                        if (poly[70].contains(lat,lng)) return 89;
                        else return 160;
                    }
                    else
                    if (lat < 29.135690f)
                        if (lng < -103.992628f)
                        {
                            if (poly[71].contains(lat,lng)) return 160;
                            else return 89;
                        }
                        else
                        {
                            if (poly[72].contains(lat,lng)) return 88;
                            if (poly[73].contains(lat,lng)) return 89;
                            if (poly[74].contains(lat,lng)) return 141;
                            if (poly[75].contains(lat,lng)) return 141;
                            if (poly[76].contains(lat,lng)) return 149;
                            else return 160;
                        }
                    else
                    {
                        if (poly[77].contains(lat,lng)) return 160;
                        else return 88;
                    }
                else
                {
                    if (poly[78].contains(lat,lng)) return 88;
                    if (poly[79].contains(lat,lng)) return 89;
                    if (poly[80].contains(lat,lng)) return 89;
                    if (poly[81].contains(lat,lng)) return 97;
                    else return 160;
                }
            else
            if (lat < 29.937781f)
                if (lng < -102.354308f)
                    if (lat < 29.135690f)
                    {
                        if (poly[82].contains(lat,lng)) return 88;
                        if (poly[83].contains(lat,lng)) return 149;
                        if (poly[84].contains(lat,lng)) return 149;
                        if (poly[85].contains(lat,lng)) return 160;
                        else return 141;
                    }
                    else
                    {
                        if (poly[86].contains(lat,lng)) return 141;
                        else return 88;
                    }
                else
                {
                    if (poly[87].contains(lat,lng)) return 88;
                    if (poly[88].contains(lat,lng)) return 149;
                    else return 141;
                }
            else
                return 88;
        else
        {
            if (poly[89].contains(lat,lng)) return 88;
            if (poly[90].contains(lat,lng)) return 160;
            if (poly[91].contains(lat,lng)) return 164;
            else return 97;
        }
    }

    private static int call1(float lat, float lng)
    {
        if (lng < -109.999802f)
            if (lat < 19.534042f)
                return 147;
            else
            if (lat < 32.494077f)
                if (lat < 28.000000f)
                    if (lng < -115.528715f)
                        return 142;
                    else
                    {
                        if (poly[92].contains(lat,lng)) return 116;
                        else return 142;
                    }
                else
                if (lng < -117.990989f)
                    return 192;
                else
                {
                    if (poly[93].contains(lat,lng)) return 116;
                    if (poly[94].contains(lat,lng)) return 164;
                    else return 192;
                }
            else
            if (lng < -111.320808f)
                if (lng < -117.338623f)
                {
                    if (poly[95].contains(lat,lng)) return 192;
                    else return 134;
                }
                else
                if (lng < -114.329716f)
                    if (lat < 35.226383f)
                        if (lng < -115.834170f)
                        {
                            if (poly[96].contains(lat,lng)) return 192;
                            else return 134;
                        }
                        else
                        if (lat < 33.860230f)
                        {
                            if (poly[97].contains(lat,lng)) return 134;
                            if (poly[98].contains(lat,lng)) return 192;
                            else return 164;
                        }
                        else
                        {
                            if (poly[99].contains(lat,lng)) return 164;
                            if (poly[100].contains(lat,lng)) return 164;
                            else return 134;
                        }
                    else
                    {
                        if (poly[101].contains(lat,lng)) return 164;
                        else return 134;
                    }
                else
                if (lat < 35.226383f)
                {
                    if (poly[102].contains(lat,lng)) return 134;
                    else return 164;
                }
                else
                if (lng < -112.825262f)
                {
                    if (poly[103].contains(lat,lng)) return 97;
                    if (poly[104].contains(lat,lng)) return 134;
                    else return 164;
                }
                else
                {
                    if (poly[105].contains(lat,lng)) return 164;
                    else return 97;
                }
            else
            if (lat < 36.430649f)
            {
                if (poly[106].contains(lat,lng)) return 97;
                if (poly[107].contains(lat,lng)) return 97;
                else return 164;
            }
            else
            {
                if (poly[108].contains(lat,lng)) return 164;
                else return 97;
            }
        else
        if (lat < 25.125236f)
            if (lng < -102.295513f)
                if (lng < -109.196542f)
                    return 142;
                else
                if (lat < 21.436715f)
                    if (lng < -104.519534f)
                        if (lat < 20.163373f)
                            return 147;
                        else
                        {
                            if (poly[109].contains(lat,lng)) return 74;
                            if (poly[110].contains(lat,lng)) return 147;
                            else return 142;
                        }
                    else
                    {
                        if (poly[111].contains(lat,lng)) return 142;
                        else return 147;
                    }
                else
                if (lng < -105.473049f)
                    if (lat < 23.280975f)
                    {
                        if (poly[112].contains(lat,lng)) return 149;
                        else return 142;
                    }
                    else
                    if (lng < -107.061817f)
                    {
                        if (poly[113].contains(lat,lng)) return 149;
                        else return 142;
                    }
                    else
                    if (lat < 24.203106f)
                    {
                        if (poly[114].contains(lat,lng)) return 149;
                        else return 142;
                    }
                    else
                    {
                        if (poly[115].contains(lat,lng)) return 142;
                        else return 149;
                    }
                else
                if (lat < 23.280975f)
                    if (lng < -103.884281f)
                        if (lat < 22.358845f)
                        {
                            if (poly[116].contains(lat,lng)) return 147;
                            if (poly[117].contains(lat,lng)) return 149;
                            else return 142;
                        }
                        else
                        if (lng < -104.678665f)
                        {
                            if (poly[118].contains(lat,lng)) return 149;
                            else return 142;
                        }
                        else
                        {
                            if (poly[119].contains(lat,lng)) return 142;
                            if (poly[120].contains(lat,lng)) return 142;
                            if (poly[121].contains(lat,lng)) return 147;
                            else return 149;
                        }
                    else
                    {
                        if (poly[122].contains(lat,lng)) return 142;
                        else return 147;
                    }
                else
                if (lng < -103.884281f)
                {
                    if (poly[123].contains(lat,lng)) return 147;
                    else return 149;
                }
                else
                {
                    if (poly[124].contains(lat,lng)) return 149;
                    else return 147;
                }
            else
            if (lat < 19.829871f)
                return 147;
            else
            if (lng < -99.252157f)
                if (lat < 22.477554f)
                {
                    if (poly[125].contains(lat,lng)) return 149;
                    else return 147;
                }
                else
                if (lng < -100.773835f)
                {
                    if (poly[126].contains(lat,lng)) return 149;
                    else return 147;
                }
                else
                if (lat < 23.801395f)
                    if (lng < -100.012996f)
                    {
                        if (poly[127].contains(lat,lng)) return 149;
                        if (poly[128].contains(lat,lng)) return 149;
                        else return 147;
                    }
                    else
                    {
                        if (poly[129].contains(lat,lng)) return 147;
                        if (poly[130].contains(lat,lng)) return 147;
                        else return 149;
                    }
                else
                {
                    if (poly[131].contains(lat,lng)) return 147;
                    else return 149;
                }
            else
            {
                if (poly[132].contains(lat,lng)) return 141;
                if (poly[133].contains(lat,lng)) return 149;
                else return 147;
            }
        else
        if (lng < -101.262095f)
            return call0(lat,lng);
        else
        if (lat < 31.541963f)
            if (lng < -96.893242f)
                if (lat < 28.333599f)
                    if (lng < -99.077668f)
                        if (lat < 26.729418f)
                        {
                            if (poly[134].contains(lat,lng)) return 88;
                            if (poly[135].contains(lat,lng)) return 149;
                            else return 141;
                        }
                        else
                        if (lng < -100.169882f)
                        {
                            if (poly[136].contains(lat,lng)) return 88;
                            if (poly[137].contains(lat,lng)) return 149;
                            else return 141;
                        }
                        else
                        if (lat < 27.531508f)
                        {
                            if (poly[138].contains(lat,lng)) return 88;
                            if (poly[139].contains(lat,lng)) return 149;
                            else return 141;
                        }
                        else
                        {
                            if (poly[140].contains(lat,lng)) return 141;
                            else return 88;
                        }
                    else
                    if (lat < 26.729418f)
                        if (lng < -97.999794f)
                            if (lat < 25.927327f)
                            {
                                if (poly[141].contains(lat,lng)) return 141;
                                else return 149;
                            }
                            else
                            {
                                if (poly[142].contains(lat,lng)) return 88;
                                if (poly[143].contains(lat,lng)) return 149;
                                else return 141;
                            }
                        else
                        {
                            if (poly[144].contains(lat,lng)) return 88;
                            if (poly[145].contains(lat,lng)) return 149;
                            else return 141;
                        }
                    else
                        return 88;
                else
                {
                    if (poly[146].contains(lat,lng)) return 88;
                    if (poly[147].contains(lat,lng)) return 149;
                    else return 141;
                }
            else
                return 88;
        else
            return 88;
    }

    private static int call2(float lat, float lng)
    {
        if (lat < 53.016461f)
            if (lng < -111.043564f)
                if (lat < 46.037723f)
                    if (lng < -117.975222f)
                    {
                        if (poly[148].contains(lat,lng)) return 81;
                        else return 134;
                    }
                    else
                    if (lat < 41.998206f)
                    {
                        if (poly[149].contains(lat,lng)) return 81;
                        if (poly[150].contains(lat,lng)) return 97;
                        else return 134;
                    }
                    else
                    if (lng < -114.509393f)
                        if (lat < 44.017964f)
                        {
                            if (poly[151].contains(lat,lng)) return 134;
                            else return 81;
                        }
                        else
                        if (lng < -116.242308f)
                            if (lat < 45.027844f)
                            {
                                if (poly[152].contains(lat,lng)) return 134;
                                else return 81;
                            }
                            else
                            {
                                if (poly[153].contains(lat,lng)) return 81;
                                else return 134;
                            }
                        else
                        {
                            if (poly[154].contains(lat,lng)) return 81;
                            if (poly[155].contains(lat,lng)) return 97;
                            if (poly[156].contains(lat,lng)) return 97;
                            else return 134;
                        }
                    else
                    if (lat < 44.017964f)
                    {
                        if (poly[157].contains(lat,lng)) return 97;
                        else return 81;
                    }
                    else
                    if (lng < -112.776478f)
                        if (lat < 45.027844f)
                        {
                            if (poly[158].contains(lat,lng)) return 97;
                            else return 81;
                        }
                        else
                        {
                            if (poly[159].contains(lat,lng)) return 81;
                            if (poly[160].contains(lat,lng)) return 134;
                            if (poly[161].contains(lat,lng)) return 134;
                            else return 97;
                        }
                    else
                    {
                        if (poly[162].contains(lat,lng)) return 81;
                        else return 97;
                    }
                else
                if (lng < -120.508865f)
                {
                    if (poly[163].contains(lat,lng)) return 134;
                    else return 195;
                }
                else
                if (lng < -115.776215f)
                    if (lat < 49.527092f)
                        if (lng < -118.142540f)
                        {
                            if (poly[164].contains(lat,lng)) return 195;
                            else return 134;
                        }
                        else
                        if (lat < 47.782407f)
                        {
                            if (poly[165].contains(lat,lng)) return 97;
                            else return 134;
                        }
                        else
                        {
                            if (poly[166].contains(lat,lng)) return 97;
                            if (poly[167].contains(lat,lng)) return 100;
                            if (poly[168].contains(lat,lng)) return 100;
                            if (poly[169].contains(lat,lng)) return 134;
                            if (poly[170].contains(lat,lng)) return 195;
                            else return 91;
                        }
                    else
                    if (lng < -118.142540f)
                    {
                        if (poly[171].contains(lat,lng)) return 100;
                        if (poly[172].contains(lat,lng)) return 100;
                        else return 195;
                    }
                    else
                    if (lat < 51.271777f)
                        if (lng < -116.959377f)
                        {
                            if (poly[173].contains(lat,lng)) return 100;
                            else return 195;
                        }
                        else
                        {
                            if (poly[174].contains(lat,lng)) return 91;
                            if (poly[175].contains(lat,lng)) return 91;
                            if (poly[176].contains(lat,lng)) return 195;
                            else return 100;
                        }
                    else
                    {
                        if (poly[177].contains(lat,lng)) return 195;
                        if (poly[178].contains(lat,lng)) return 195;
                        else return 100;
                    }
                else
                {
                    if (poly[179].contains(lat,lng)) return 100;
                    if (poly[180].contains(lat,lng)) return 134;
                    else return 97;
                }
            else
            {
                if (poly[181].contains(lat,lng)) return 97;
                if (poly[182].contains(lat,lng)) return 173;
                else return 100;
            }
        else
        if (lat < 63.201980f)
            if (lng < -129.932869f)
                if (lat < 60.001555f)
                {
                    if (poly[183].contains(lat,lng)) return 196;
                    else return 195;
                }
                else
                {
                    if (poly[184].contains(lat,lng)) return 199;
                    else return 196;
                }
            else
            if (lng < -118.648599f)
                if (lat < 58.000000f)
                    if (lng < -124.290734f)
                    {
                        if (poly[185].contains(lat,lng)) return 96;
                        else return 195;
                    }
                    else
                    if (lng < -121.469667f)
                        if (lat < 55.508230f)
                        {
                            if (poly[186].contains(lat,lng)) return 96;
                            else return 195;
                        }
                        else
                        if (lng < -122.880200f)
                            if (lat < 56.754115f)
                            {
                                if (poly[187].contains(lat,lng)) return 195;
                                else return 96;
                            }
                            else
                            {
                                if (poly[188].contains(lat,lng)) return 195;
                                else return 96;
                            }
                        else
                            return 96;
                    else
                    if (lat < 55.508230f)
                        if (lng < -120.059133f)
                        {
                            if (poly[189].contains(lat,lng)) return 195;
                            else return 96;
                        }
                        else
                        {
                            if (poly[190].contains(lat,lng)) return 96;
                            if (poly[191].contains(lat,lng)) return 100;
                            else return 195;
                        }
                    else
                    {
                        if (poly[192].contains(lat,lng)) return 100;
                        else return 96;
                    }
                else
                if (lng < -124.290734f)
                    if (lng < -127.111802f)
                        if (lat < 60.600990f)
                        {
                            if (poly[193].contains(lat,lng)) return 103;
                            if (poly[194].contains(lat,lng)) return 196;
                            else return 195;
                        }
                        else
                        if (lng < -128.522335f)
                        {
                            if (poly[195].contains(lat,lng)) return 199;
                            else return 196;
                        }
                        else
                        {
                            if (poly[196].contains(lat,lng)) return 199;
                            if (poly[197].contains(lat,lng)) return 199;
                            else return 196;
                        }
                    else
                    if (lat < 60.600990f)
                        if (lng < -125.701268f)
                        {
                            if (poly[198].contains(lat,lng)) return 195;
                            if (poly[199].contains(lat,lng)) return 196;
                            else return 103;
                        }
                        else
                        {
                            if (poly[200].contains(lat,lng)) return 195;
                            if (poly[201].contains(lat,lng)) return 196;
                            if (poly[202].contains(lat,lng)) return 199;
                            else return 103;
                        }
                    else
                    if (lng < -125.701268f)
                    {
                        if (poly[203].contains(lat,lng)) return 199;
                        else return 196;
                    }
                    else
                    {
                        if (poly[204].contains(lat,lng)) return 199;
                        else return 196;
                    }
                else
                {
                    if (poly[205].contains(lat,lng)) return 100;
                    if (poly[206].contains(lat,lng)) return 103;
                    if (poly[207].contains(lat,lng)) return 196;
                    else return 199;
                }
            else
            {
                if (poly[208].contains(lat,lng)) return 173;
                if (poly[209].contains(lat,lng)) return 199;
                else return 100;
            }
        else
        if (lng < -129.812706f)
            if (lat < 63.573302f)
            {
                if (poly[210].contains(lat,lng)) return 196;
                else return 199;
            }
            else
            {
                if (poly[211].contains(lat,lng)) return 196;
                else return 199;
            }
        else
        {
            if (poly[212].contains(lat,lng)) return 82;
            else return 199;
        }
    }

    private static int call3(float lat, float lng)
    {
        if (lng < -88.500000f)
            if (lat < 53.375000f)
                if (lng < -107.756288f)
                {
                    if (poly[213].contains(lat,lng)) return 173;
                    else return 188;
                }
                else
                if (lng < -101.392420f)
                {
                    if (poly[214].contains(lat,lng)) return 197;
                    else return 173;
                }
                else
                {
                    if (poly[215].contains(lat,lng)) return 193;
                    else return 197;
                }
            else
            if (lat < 59.999511f)
                if (lng < -101.735099f)
                    if (lat < 53.710706f)
                    {
                        if (poly[216].contains(lat,lng)) return 197;
                        else return 173;
                    }
                    else
                    {
                        if (poly[217].contains(lat,lng)) return 197;
                        if (poly[218].contains(lat,lng)) return 199;
                        else return 173;
                    }
                else
                if (lng < -95.117549f)
                    return 197;
                else
                if (lat < 56.687256f)
                {
                    if (poly[219].contains(lat,lng)) return 171;
                    if (poly[220].contains(lat,lng)) return 193;
                    else return 197;
                }
                else
                if (lng < -91.808775f)
                    if (lat < 58.343286f)
                    {
                        if (poly[221].contains(lat,lng)) return 171;
                        else return 197;
                    }
                    else
                    {
                        if (poly[222].contains(lat,lng)) return 197;
                        else return 171;
                    }
                else
                {
                    if (poly[223].contains(lat,lng)) return 193;
                    if (poly[224].contains(lat,lng)) return 197;
                    else return 171;
                }
            else
            {
                if (poly[225].contains(lat,lng)) return 82;
                if (poly[226].contains(lat,lng)) return 171;
                if (poly[227].contains(lat,lng)) return 199;
                else return 174;
            }
        else
        if (lat < 62.989698f)
            if (lng < -81.645224f)
                if (lat < 56.187094f)
                    if (lng < -85.072612f)
                    {
                        if (poly[228].contains(lat,lng)) return 193;
                        else return 171;
                    }
                    else
                    if (lat < 52.785792f)
                    {
                        if (poly[229].contains(lat,lng)) return 126;
                        else return 193;
                    }
                    else
                    {
                        if (poly[230].contains(lat,lng)) return 126;
                        if (poly[231].contains(lat,lng)) return 171;
                        else return 193;
                    }
                else
                {
                    if (poly[232].contains(lat,lng)) return 126;
                    if (poly[233].contains(lat,lng)) return 171;
                    if (poly[234].contains(lat,lng)) return 193;
                    else return 72;
                }
            else
            if (lat < 56.187094f)
                if (lng < -78.217837f)
                    if (lat < 52.785792f)
                        if (lng < -79.931531f)
                        {
                            if (poly[235].contains(lat,lng)) return 193;
                            else return 126;
                        }
                        else
                        if (lat < 51.085141f)
                            return 193;
                        else
                        if (lng < -79.074684f)
                        {
                            if (poly[236].contains(lat,lng)) return 193;
                            else return 126;
                        }
                        else
                        {
                            if (poly[237].contains(lat,lng)) return 126;
                            else return 193;
                        }
                    else
                    if (lng < -79.931531f)
                        return 126;
                    else
                    if (lat < 54.486443f)
                        if (lng < -79.074684f)
                        {
                            if (poly[238].contains(lat,lng)) return 193;
                            if (poly[239].contains(lat,lng)) return 193;
                            if (poly[240].contains(lat,lng)) return 193;
                            if (poly[241].contains(lat,lng)) return 193;
                            if (poly[242].contains(lat,lng)) return 193;
                            if (poly[243].contains(lat,lng)) return 193;
                            if (poly[244].contains(lat,lng)) return 193;
                            if (poly[245].contains(lat,lng)) return 193;
                            if (poly[246].contains(lat,lng)) return 193;
                            if (poly[247].contains(lat,lng)) return 193;
                            else return 126;
                        }
                        else
                        if (lat < 53.636117f)
                        {
                            if (poly[248].contains(lat,lng)) return 193;
                            else return 126;
                        }
                        else
                        {
                            if (poly[249].contains(lat,lng)) return 126;
                            if (poly[250].contains(lat,lng)) return 126;
                            if (poly[251].contains(lat,lng)) return 126;
                            if (poly[252].contains(lat,lng)) return 126;
                            if (poly[253].contains(lat,lng)) return 126;
                            if (poly[254].contains(lat,lng)) return 126;
                            if (poly[255].contains(lat,lng)) return 126;
                            if (poly[256].contains(lat,lng)) return 126;
                            if (poly[257].contains(lat,lng)) return 126;
                            else return 193;
                        }
                    else
                    {
                        if (poly[258].contains(lat,lng)) return 193;
                        else return 126;
                    }
                else
                {
                    if (poly[259].contains(lat,lng)) return 126;
                    else return 193;
                }
            else
            if (lng < -78.217837f)
            {
                if (poly[260].contains(lat,lng)) return 193;
                if (poly[261].contains(lat,lng)) return 193;
                else return 126;
            }
            else
            if (lat < 59.588396f)
            {
                if (poly[262].contains(lat,lng)) return 193;
                else return 126;
            }
            else
            if (lng < -76.504143f)
                if (lat < 61.289047f)
                {
                    if (poly[263].contains(lat,lng)) return 193;
                    else return 126;
                }
                else
                {
                    if (poly[264].contains(lat,lng)) return 193;
                    else return 126;
                }
            else
            {
                if (poly[265].contains(lat,lng)) return 193;
                else return 126;
            }
        else
        if (lat < 73.157443f)
            if (lng < -81.645224f)
                if (lat < 68.073571f)
                    if (lng < -85.072612f)
                        if (lat < 65.531634f)
                        {
                            if (poly[266].contains(lat,lng)) return 72;
                            else return 171;
                        }
                        else
                        {
                            if (poly[267].contains(lat,lng)) return 72;
                            if (poly[268].contains(lat,lng)) return 72;
                            else return 171;
                        }
                    else
                    if (lat < 65.531634f)
                        if (lng < -83.358918f)
                            if (lat < 64.260666f)
                            {
                                if (poly[269].contains(lat,lng)) return 126;
                                if (poly[270].contains(lat,lng)) return 171;
                                else return 72;
                            }
                            else
                            {
                                if (poly[271].contains(lat,lng)) return 126;
                                if (poly[272].contains(lat,lng)) return 171;
                                else return 72;
                            }
                        else
                        if (lat < 64.260666f)
                        {
                            if (poly[273].contains(lat,lng)) return 72;
                            else return 126;
                        }
                        else
                        {
                            if (poly[274].contains(lat,lng)) return 72;
                            else return 126;
                        }
                    else
                    {
                        if (poly[275].contains(lat,lng)) return 72;
                        if (poly[276].contains(lat,lng)) return 72;
                        if (poly[277].contains(lat,lng)) return 171;
                        if (poly[278].contains(lat,lng)) return 171;
                        else return 126;
                    }
                else
                {
                    if (poly[279].contains(lat,lng)) return 171;
                    else return 126;
                }
            else
            {
                if (poly[280].contains(lat,lng)) return 72;
                if (poly[281].contains(lat,lng)) return 72;
                else return 126;
            }
        else
        {
            if (poly[282].contains(lat,lng)) return 171;
            else return 126;
        }
    }

    private static int call4(float lat, float lng)
    {
        if (lat < 47.575298f)
            if (lng < -100.260872f)
                if (lng < -102.432684f)
                    if (lng < -103.434273f)
                    {
                        if (poly[283].contains(lat,lng)) return 88;
                        else return 97;
                    }
                    else
                    if (lng < -103.093448f)
                    {
                        if (poly[284].contains(lat,lng)) return 88;
                        else return 97;
                    }
                    else
                    {
                        if (poly[285].contains(lat,lng)) return 88;
                        else return 97;
                    }
                else
                if (lat < 42.766993f)
                {
                    if (poly[286].contains(lat,lng)) return 97;
                    else return 88;
                }
                else
                if (lat < 45.171146f)
                {
                    if (poly[287].contains(lat,lng)) return 97;
                    else return 88;
                }
                else
                if (lat < 46.373222f)
                {
                    if (poly[288].contains(lat,lng)) return 88;
                    if (poly[289].contains(lat,lng)) return 159;
                    else return 97;
                }
                else
                if (lng < -101.346778f)
                {
                    if (poly[290].contains(lat,lng)) return 88;
                    if (poly[291].contains(lat,lng)) return 97;
                    if (poly[292].contains(lat,lng)) return 158;
                    if (poly[293].contains(lat,lng)) return 159;
                    else return 157;
                }
                else
                {
                    if (poly[294].contains(lat,lng)) return 97;
                    if (poly[295].contains(lat,lng)) return 157;
                    if (poly[296].contains(lat,lng)) return 158;
                    if (poly[297].contains(lat,lng)) return 159;
                    else return 88;
                }
            else
            if (lat < 38.929415f)
                if (lng < -86.679886f)
                    if (lng < -93.470379f)
                        return 88;
                    else
                    if (lng < -90.075132f)
                        return 88;
                    else
                    if (lng < -88.377509f)
                        return 88;
                    else
                    if (lng < -87.528698f)
                    {
                        if (poly[298].contains(lat,lng)) return 123;
                        if (poly[299].contains(lat,lng)) return 123;
                        else return 88;
                    }
                    else
                    if (lat < 38.444052f)
                    {
                        if (poly[300].contains(lat,lng)) return 117;
                        if (poly[301].contains(lat,lng)) return 119;
                        if (poly[302].contains(lat,lng)) return 120;
                        if (poly[303].contains(lat,lng)) return 121;
                        if (poly[304].contains(lat,lng)) return 123;
                        else return 88;
                    }
                    else
                    {
                        if (poly[305].contains(lat,lng)) return 88;
                        if (poly[306].contains(lat,lng)) return 88;
                        if (poly[307].contains(lat,lng)) return 88;
                        if (poly[308].contains(lat,lng)) return 117;
                        if (poly[309].contains(lat,lng)) return 120;
                        else return 123;
                    }
                else
                if (lng < -85.405100f)
                    if (lng < -86.042493f)
                        if (lat < 38.444045f)
                            if (lng < -86.361189f)
                            {
                                if (poly[310].contains(lat,lng)) return 88;
                                if (poly[311].contains(lat,lng)) return 117;
                                if (poly[312].contains(lat,lng)) return 121;
                                if (poly[313].contains(lat,lng)) return 153;
                                if (poly[314].contains(lat,lng)) return 153;
                                else return 119;
                            }
                            else
                            {
                                if (poly[315].contains(lat,lng)) return 117;
                                if (poly[316].contains(lat,lng)) return 129;
                                if (poly[317].contains(lat,lng)) return 153;
                                else return 119;
                            }
                        else
                            return 117;
                    else
                    {
                        if (poly[318].contains(lat,lng)) return 117;
                        if (poly[319].contains(lat,lng)) return 153;
                        if (poly[320].contains(lat,lng)) return 153;
                        else return 129;
                    }
                else
                {
                    if (poly[321].contains(lat,lng)) return 117;
                    if (poly[322].contains(lat,lng)) return 122;
                    else return 153;
                }
            else
            if (lat < 41.433800f)
                if (lng < -86.466347f)
                {
                    if (poly[323].contains(lat,lng)) return 117;
                    if (poly[324].contains(lat,lng)) return 118;
                    if (poly[325].contains(lat,lng)) return 124;
                    else return 88;
                }
                else
                {
                    if (poly[326].contains(lat,lng)) return 153;
                    else return 117;
                }
            else
            if (lng < -87.263670f)
                if (lng < -93.762271f)
                    return 88;
                else
                if (lng < -90.512970f)
                    return 88;
                else
                if (lat < 44.504549f)
                    return 88;
                else
                if (lng < -88.888320f)
                {
                    if (poly[327].contains(lat,lng)) return 88;
                    if (poly[328].contains(lat,lng)) return 98;
                    else return 144;
                }
                else
                if (lat < 46.039924f)
                    if (lng < -88.075995f)
                    {
                        if (poly[329].contains(lat,lng)) return 144;
                        if (poly[330].contains(lat,lng)) return 144;
                        else return 88;
                    }
                    else
                    {
                        if (poly[331].contains(lat,lng)) return 88;
                        if (poly[332].contains(lat,lng)) return 88;
                        if (poly[333].contains(lat,lng)) return 98;
                        if (poly[334].contains(lat,lng)) return 98;
                        else return 144;
                    }
                else
                {
                    if (poly[335].contains(lat,lng)) return 88;
                    if (poly[336].contains(lat,lng)) return 144;
                    else return 98;
                }
            else
            if (lng < -81.027060f)
                if (lng < -84.145365f)
                {
                    if (poly[337].contains(lat,lng)) return 88;
                    if (poly[338].contains(lat,lng)) return 117;
                    if (poly[339].contains(lat,lng)) return 153;
                    if (poly[340].contains(lat,lng)) return 193;
                    else return 98;
                }
                else
                {
                    if (poly[341].contains(lat,lng)) return 98;
                    if (poly[342].contains(lat,lng)) return 98;
                    if (poly[343].contains(lat,lng)) return 153;
                    else return 193;
                }
            else
            {
                if (poly[344].contains(lat,lng)) return 193;
                else return 153;
            }
        else
        if (lat < 49.384490f)
            if (lng < -95.153150f)
                if (lng < -102.711964f)
                {
                    if (poly[345].contains(lat,lng)) return 97;
                    if (poly[346].contains(lat,lng)) return 97;
                    if (poly[347].contains(lat,lng)) return 173;
                    else return 88;
                }
                else
                if (lat < 47.615253f)
                    if (lng < -102.250025f)
                    {
                        if (poly[348].contains(lat,lng)) return 97;
                        else return 88;
                    }
                    else
                    {
                        if (poly[349].contains(lat,lng)) return 97;
                        else return 88;
                    }
                else
                {
                    if (poly[350].contains(lat,lng)) return 88;
                    if (poly[351].contains(lat,lng)) return 197;
                    else return 173;
                }
            else
            if (lng < -90.000000f)
                if (lng < -92.576575f)
                {
                    if (poly[352].contains(lat,lng)) return 88;
                    if (poly[353].contains(lat,lng)) return 170;
                    else return 197;
                }
                else
                if (lng < -91.288287f)
                {
                    if (poly[354].contains(lat,lng)) return 88;
                    if (poly[355].contains(lat,lng)) return 197;
                    else return 72;
                }
                else
                {
                    if (poly[356].contains(lat,lng)) return 88;
                    if (poly[357].contains(lat,lng)) return 193;
                    if (poly[358].contains(lat,lng)) return 197;
                    else return 72;
                }
            else
            if (lat < 48.515693f)
            {
                if (poly[359].contains(lat,lng)) return 88;
                if (poly[360].contains(lat,lng)) return 98;
                if (poly[361].contains(lat,lng)) return 191;
                else return 193;
            }
            else
            {
                if (poly[362].contains(lat,lng)) return 193;
                else return 154;
            }
        else
            return call3(lat,lng);
    }

    private static int call5(float lat, float lng)
    {
        if (lat < 37.958689f)
            if (lng < -92.524388f)
                if (lng < -154.592785f)
                    if (lng < -177.116176f)
                        return 410;
                    else
                        return 404;
                else
                    return call1(lat,lng);
            else
            if (lat < 18.851981f)
                if (lng < -82.172962f)
                    if (lng < -87.101885f)
                        if (lat < 16.298406f)
                            if (lng < -90.424127f)
                                if (lat < 16.259052f)
                                {
                                    if (poly[363].contains(lat,lng)) return 147;
                                    else return 111;
                                }
                                else
                                {
                                    if (poly[364].contains(lat,lng)) return 111;
                                    else return 147;
                                }
                            else
                            if (lat < 14.277527f)
                                if (lng < -88.763006f)
                                {
                                    if (poly[365].contains(lat,lng)) return 111;
                                    if (poly[366].contains(lat,lng)) return 189;
                                    else return 102;
                                }
                                else
                                {
                                    if (poly[367].contains(lat,lng)) return 102;
                                    if (poly[368].contains(lat,lng)) return 137;
                                    else return 189;
                                }
                            else
                            if (lng < -88.763006f)
                                if (lat < 15.287966f)
                                {
                                    if (poly[369].contains(lat,lng)) return 102;
                                    if (poly[370].contains(lat,lng)) return 189;
                                    else return 111;
                                }
                                else
                                {
                                    if (poly[371].contains(lat,lng)) return 77;
                                    else return 111;
                                }
                            else
                            {
                                if (poly[372].contains(lat,lng)) return 77;
                                if (poly[373].contains(lat,lng)) return 111;
                                else return 189;
                            }
                        else
                        if (lng < -90.371441f)
                            if (lat < 17.575193f)
                            {
                                if (poly[374].contains(lat,lng)) return 111;
                                else return 147;
                            }
                            else
                            {
                                if (poly[375].contains(lat,lng)) return 111;
                                if (poly[376].contains(lat,lng)) return 147;
                                else return 145;
                            }
                        else
                        if (lng < -88.736663f)
                        {
                            if (poly[377].contains(lat,lng)) return 77;
                            if (poly[378].contains(lat,lng)) return 111;
                            if (poly[379].contains(lat,lng)) return 145;
                            else return 84;
                        }
                        else
                        {
                            if (poly[380].contains(lat,lng)) return 84;
                            else return 77;
                        }
                    else
                    if (lat < 15.033118f)
                        if (lat < 12.408226f)
                            return 137;
                        else
                        if (lng < -83.042535f)
                            if (lng < -85.072210f)
                                if (lat < 13.720672f)
                                {
                                    if (poly[381].contains(lat,lng)) return 189;
                                    else return 137;
                                }
                                else
                                if (lng < -86.087047f)
                                {
                                    if (poly[382].contains(lat,lng)) return 137;
                                    else return 189;
                                }
                                else
                                {
                                    if (poly[383].contains(lat,lng)) return 189;
                                    else return 137;
                                }
                            else
                            if (lat < 13.720672f)
                                return 137;
                            else
                            if (lng < -84.057372f)
                            {
                                if (poly[384].contains(lat,lng)) return 189;
                                else return 137;
                            }
                            else
                            {
                                if (poly[385].contains(lat,lng)) return 189;
                                else return 137;
                            }
                        else
                        if (lat < 14.688147f)
                            return 137;
                        else
                            return 189;
                    else
                        return 189;
                else
                if (lat < 16.057127f)
                    return 80;
                else
                if (lng < -75.496288f)
                    return 127;
                else
                    return 165;
            else
            if (lng < -86.493266f)
                if (lat < 21.830571f)
                    if (lng < -91.750739f)
                        return 145;
                    else
                    if (lng < -89.122003f)
                    {
                        if (poly[386].contains(lat,lng)) return 84;
                        if (poly[387].contains(lat,lng)) return 84;
                        else return 145;
                    }
                    else
                    {
                        if (poly[388].contains(lat,lng)) return 145;
                        if (poly[389].contains(lat,lng)) return 145;
                        else return 84;
                    }
                else
                if (lat < 22.783270f)
                    return 145;
                else
                {
                    if (poly[390].contains(lat,lng)) return 121;
                    else return 88;
                }
            else
            if (lat < 23.481697f)
                if (lat < 19.596903f)
                    return 87;
                else
                if (lat < 19.973824f)
                    if (lng < -79.511095f)
                        return 87;
                    else
                    {
                        if (poly[391].contains(lat,lng)) return 153;
                        else return 115;
                    }
                else
                {
                    if (poly[392].contains(lat,lng)) return 152;
                    else return 115;
                }
            else
            if (lng < -84.575844f)
                if (lat < 33.673127f)
                    if (lat < 31.530347f)
                    {
                        if (poly[393].contains(lat,lng)) return 88;
                        else return 153;
                    }
                    else
                    {
                        if (poly[394].contains(lat,lng)) return 153;
                        else return 88;
                    }
                else
                if (lat < 35.815908f)
                {
                    if (poly[395].contains(lat,lng)) return 153;
                    else return 88;
                }
                else
                if (lat < 36.887299f)
                {
                    if (poly[396].contains(lat,lng)) return 88;
                    if (poly[397].contains(lat,lng)) return 130;
                    else return 153;
                }
                else
                {
                    if (poly[398].contains(lat,lng)) return 88;
                    if (poly[399].contains(lat,lng)) return 130;
                    if (poly[400].contains(lat,lng)) return 130;
                    else return 153;
                }
            else
            if (lng < -82.585009f)
                return 153;
            else
            {
                if (poly[401].contains(lat,lng)) return 152;
                else return 153;
            }
        else
        if (lng < -108.824497f)
            if (lng < -141.000000f)
                if (lat < 57.465233f)
                    if (lng < -162.000000f)
                        if (lng < -171.954674f)
                            return 53;
                        else
                        if (lat < 53.299009f)
                        {
                            if (poly[402].contains(lat,lng)) return 155;
                            else return 53;
                        }
                        else
                            return 155;
                    else
                        return 54;
                else
                if (lng < -174.939411f)
                    return 215;
                else
                if (lng < -162.000000f)
                    if (lat < 64.008111f)
                        return 155;
                    else
                    if (lng < -168.924586f)
                    {
                        if (poly[403].contains(lat,lng)) return 155;
                        else return 215;
                    }
                    else
                        return 155;
                else
                if (lng < -145.834392f)
                    return 54;
                else
                {
                    if (poly[404].contains(lat,lng)) return 196;
                    else return 54;
                }
            else
            if (lng < -129.974167f)
                if (lat < 60.352505f)
                    if (lat < 55.300967f)
                        if (lat < 54.456000f)
                            return 195;
                        else
                        {
                            if (poly[405].contains(lat,lng)) return 146;
                            if (poly[406].contains(lat,lng)) return 195;
                            if (poly[407].contains(lat,lng)) return 195;
                            else return 181;
                        }
                    else
                    if (lat < 59.798041f)
                        if (lng < -135.487083f)
                        {
                            if (poly[408].contains(lat,lng)) return 181;
                            if (poly[409].contains(lat,lng)) return 195;
                            if (poly[410].contains(lat,lng)) return 198;
                            else return 128;
                        }
                        else
                        if (lng < -132.730625f)
                            if (lat < 57.549504f)
                            {
                                if (poly[411].contains(lat,lng)) return 128;
                                else return 181;
                            }
                            else
                            {
                                if (poly[412].contains(lat,lng)) return 181;
                                if (poly[413].contains(lat,lng)) return 195;
                                if (poly[414].contains(lat,lng)) return 195;
                                else return 128;
                            }
                        else
                        {
                            if (poly[415].contains(lat,lng)) return 128;
                            if (poly[416].contains(lat,lng)) return 195;
                            else return 181;
                        }
                    else
                    {
                        if (poly[417].contains(lat,lng)) return 195;
                        if (poly[418].contains(lat,lng)) return 198;
                        else return 196;
                    }
                else
                if (lat < 63.588796f)
                    if (lat < 63.337384f)
                    {
                        if (poly[419].contains(lat,lng)) return 199;
                        else return 196;
                    }
                    else
                    {
                        if (poly[420].contains(lat,lng)) return 199;
                        else return 196;
                    }
                else
                if (lng < -139.277500f)
                {
                    if (poly[421].contains(lat,lng)) return 196;
                    else return 95;
                }
                else
                if (lng < -134.625833f)
                {
                    if (poly[422].contains(lat,lng)) return 199;
                    else return 196;
                }
                else
                if (lat < 67.027228f)
                    if (lng < -132.300000f)
                        if (lat < 65.308012f)
                        {
                            if (poly[423].contains(lat,lng)) return 199;
                            else return 196;
                        }
                        else
                        if (lng < -133.462917f)
                        {
                            if (poly[424].contains(lat,lng)) return 199;
                            else return 196;
                        }
                        else
                        {
                            if (poly[425].contains(lat,lng)) return 196;
                            else return 199;
                        }
                    else
                    if (lat < 65.308012f)
                    {
                        if (poly[426].contains(lat,lng)) return 199;
                        else return 196;
                    }
                    else
                    {
                        if (poly[427].contains(lat,lng)) return 196;
                        if (poly[428].contains(lat,lng)) return 196;
                        else return 199;
                    }
                else
                {
                    if (poly[429].contains(lat,lng)) return 125;
                    else return 199;
                }
            else
                return call2(lat,lng);
        else
            return call4(lat,lng);
    }

    private static int call6(float lat, float lng)
    {
        if (lng < -62.609179f)
            if (lat < -41.992126f)
                if (lng < -69.048916f)
                    if (lng < -71.919683f)
                    {
                        if (poly[430].contains(lat,lng)) return 60;
                        if (poly[431].contains(lat,lng)) return 60;
                        if (poly[432].contains(lat,lng)) return 60;
                        if (poly[433].contains(lat,lng)) return 60;
                        else return 177;
                    }
                    else
                    if (lat < -43.996000f)
                        if (lng < -70.484300f)
                            if (lat < -44.997937f)
                            {
                                if (poly[434].contains(lat,lng)) return 60;
                                else return 177;
                            }
                            else
                            {
                                if (poly[435].contains(lat,lng)) return 60;
                                else return 177;
                            }
                        else
                            return 60;
                    else
                    {
                        if (poly[436].contains(lat,lng)) return 60;
                        if (poly[437].contains(lat,lng)) return 66;
                        else return 177;
                    }
                else
                {
                    if (poly[438].contains(lat,lng)) return 66;
                    else return 60;
                }
            else
            if (lng < -64.780716f)
                if (lat < -35.192695f)
                    if (lng < -69.592084f)
                        if (lat < -38.592410f)
                            if (lng < -71.997768f)
                                return 177;
                            else
                            if (lat < -40.292268f)
                            {
                                if (poly[439].contains(lat,lng)) return 66;
                                if (poly[440].contains(lat,lng)) return 66;
                                else return 177;
                            }
                            else
                            if (lng < -70.794926f)
                                if (lat < -39.442339f)
                                {
                                    if (poly[441].contains(lat,lng)) return 177;
                                    if (poly[442].contains(lat,lng)) return 177;
                                    else return 66;
                                }
                                else
                                {
                                    if (poly[443].contains(lat,lng)) return 177;
                                    else return 66;
                                }
                            else
                                return 66;
                        else
                        if (lng < -71.900482f)
                            return 177;
                        else
                        if (lat < -36.892553f)
                        {
                            if (poly[444].contains(lat,lng)) return 64;
                            if (poly[445].contains(lat,lng)) return 177;
                            else return 66;
                        }
                        else
                        if (lng < -70.746283f)
                        {
                            if (poly[446].contains(lat,lng)) return 66;
                            else return 177;
                        }
                        else
                        if (lat < -36.042624f)
                        {
                            if (poly[447].contains(lat,lng)) return 64;
                            if (poly[448].contains(lat,lng)) return 177;
                            else return 66;
                        }
                        else
                        {
                            if (poly[449].contains(lat,lng)) return 64;
                            else return 177;
                        }
                    else
                    {
                        if (poly[450].contains(lat,lng)) return 66;
                        if (poly[451].contains(lat,lng)) return 68;
                        else return 64;
                    }
                else
                if (lng < -68.711575f)
                    if (lat < -31.792980f)
                        if (lng < -70.677005f)
                            return 177;
                        else
                        if (lat < -33.492837f)
                        {
                            if (poly[452].contains(lat,lng)) return 177;
                            else return 64;
                        }
                        else
                        if (lng < -69.694290f)
                            if (lat < -32.642908f)
                            {
                                if (poly[453].contains(lat,lng)) return 64;
                                else return 177;
                            }
                            else
                            {
                                if (poly[454].contains(lat,lng)) return 64;
                                if (poly[455].contains(lat,lng)) return 64;
                                if (poly[456].contains(lat,lng)) return 177;
                                else return 67;
                            }
                        else
                        {
                            if (poly[457].contains(lat,lng)) return 64;
                            else return 67;
                        }
                    else
                    if (lat < -30.093122f)
                    {
                        if (poly[458].contains(lat,lng)) return 67;
                        else return 177;
                    }
                    else
                    if (lng < -70.265666f)
                        return 177;
                    else
                    if (lat < -29.243193f)
                    {
                        if (poly[459].contains(lat,lng)) return 63;
                        if (poly[460].contains(lat,lng)) return 177;
                        else return 67;
                    }
                    else
                    {
                        if (poly[461].contains(lat,lng)) return 63;
                        if (poly[462].contains(lat,lng)) return 177;
                        else return 67;
                    }
                else
                if (lat < -31.792980f)
                    if (lng < -66.746146f)
                        if (lat < -33.492837f)
                        {
                            if (poly[463].contains(lat,lng)) return 68;
                            if (poly[464].contains(lat,lng)) return 68;
                            else return 64;
                        }
                        else
                        if (lng < -67.728860f)
                        {
                            if (poly[465].contains(lat,lng)) return 67;
                            else return 64;
                        }
                        else
                        {
                            if (poly[466].contains(lat,lng)) return 63;
                            if (poly[467].contains(lat,lng)) return 64;
                            if (poly[468].contains(lat,lng)) return 67;
                            else return 68;
                        }
                    else
                    if (lat < -33.492837f)
                    {
                        if (poly[469].contains(lat,lng)) return 61;
                        if (poly[470].contains(lat,lng)) return 64;
                        if (poly[471].contains(lat,lng)) return 64;
                        if (poly[472].contains(lat,lng)) return 66;
                        else return 68;
                    }
                    else
                    {
                        if (poly[473].contains(lat,lng)) return 61;
                        if (poly[474].contains(lat,lng)) return 63;
                        if (poly[475].contains(lat,lng)) return 67;
                        else return 68;
                    }
                else
                if (lng < -66.746146f)
                {
                    if (poly[476].contains(lat,lng)) return 67;
                    else return 63;
                }
                else
                {
                    if (poly[477].contains(lat,lng)) return 61;
                    if (poly[478].contains(lat,lng)) return 61;
                    if (poly[479].contains(lat,lng)) return 63;
                    else return 60;
                }
            else
            {
                if (poly[480].contains(lat,lng)) return 59;
                if (poly[481].contains(lat,lng)) return 61;
                else return 66;
            }
        else
        if (lat < -30.085396f)
            if (lat < -33.261612f)
                if (lng < -60.260223f)
                {
                    if (poly[482].contains(lat,lng)) return 61;
                    else return 59;
                }
                else
                if (lng < -55.703699f)
                {
                    if (poly[483].contains(lat,lng)) return 61;
                    if (poly[484].contains(lat,lng)) return 150;
                    else return 59;
                }
                else
                {
                    if (poly[485].contains(lat,lng)) return 179;
                    else return 150;
                }
            else
            if (lng < -58.087644f)
            {
                if (poly[486].contains(lat,lng)) return 61;
                else return 150;
            }
            else
            if (lng < -54.005825f)
                if (lng < -56.046735f)
                    if (lat < -31.673504f)
                    {
                        if (poly[487].contains(lat,lng)) return 61;
                        if (poly[488].contains(lat,lng)) return 61;
                        else return 150;
                    }
                    else
                    if (lng < -57.067189f)
                    {
                        if (poly[489].contains(lat,lng)) return 61;
                        if (poly[490].contains(lat,lng)) return 179;
                        else return 150;
                    }
                    else
                    {
                        if (poly[491].contains(lat,lng)) return 150;
                        else return 179;
                    }
                else
                {
                    if (poly[492].contains(lat,lng)) return 150;
                    else return 179;
                }
            else
            {
                if (poly[493].contains(lat,lng)) return 150;
                else return 179;
            }
        else
        if (lng < -55.883574f)
            if (lat < -28.479231f)
            {
                if (poly[494].contains(lat,lng)) return 179;
                else return 61;
            }
            else
            {
                if (poly[495].contains(lat,lng)) return 179;
                else return 61;
            }
        else
        {
            if (poly[496].contains(lat,lng)) return 61;
            else return 179;
        }
    }

    private static int call7(float lat, float lng)
    {
        if (lat < -24.971517f)
            if (lng < -57.554695f)
                if (lat < -27.256324f)
                {
                    if (poly[497].contains(lat,lng)) return 71;
                    else return 61;
                }
                else
                if (lat < -25.443098f)
                {
                    if (poly[498].contains(lat,lng)) return 61;
                    else return 71;
                }
                else
                {
                    if (poly[499].contains(lat,lng)) return 71;
                    else return 61;
                }
            else
            if (lng < -55.859440f)
            {
                if (poly[500].contains(lat,lng)) return 61;
                else return 71;
            }
            else
            if (lng < -51.466260f)
                if (lng < -53.662850f)
                    if (lat < -26.177634f)
                        if (lng < -54.761145f)
                        {
                            if (poly[501].contains(lat,lng)) return 61;
                            else return 71;
                        }
                        else
                        if (lat < -26.780692f)
                        {
                            if (poly[502].contains(lat,lng)) return 61;
                            else return 179;
                        }
                        else
                        {
                            if (poly[503].contains(lat,lng)) return 71;
                            if (poly[504].contains(lat,lng)) return 179;
                            if (poly[505].contains(lat,lng)) return 179;
                            else return 61;
                        }
                    else
                    if (lng < -54.761145f)
                        return 71;
                    else
                    if (lat < -25.574576f)
                        if (lng < -54.211998f)
                        {
                            if (poly[506].contains(lat,lng)) return 71;
                            if (poly[507].contains(lat,lng)) return 179;
                            if (poly[508].contains(lat,lng)) return 179;
                            else return 61;
                        }
                        else
                        {
                            if (poly[509].contains(lat,lng)) return 179;
                            if (poly[510].contains(lat,lng)) return 179;
                            if (poly[511].contains(lat,lng)) return 179;
                            if (poly[512].contains(lat,lng)) return 179;
                            else return 61;
                        }
                    else
                    {
                        if (poly[513].contains(lat,lng)) return 61;
                        if (poly[514].contains(lat,lng)) return 61;
                        if (poly[515].contains(lat,lng)) return 61;
                        if (poly[516].contains(lat,lng)) return 61;
                        if (poly[517].contains(lat,lng)) return 61;
                        if (poly[518].contains(lat,lng)) return 71;
                        else return 179;
                    }
                else
                {
                    if (poly[519].contains(lat,lng)) return 61;
                    if (poly[520].contains(lat,lng)) return 61;
                    else return 179;
                }
            else
                return 179;
        else
        if (lng < -50.805843f)
            if (lat < -19.331948f)
                if (lng < -54.488672f)
                    if (lat < -22.151733f)
                        if (lng < -56.330086f)
                        {
                            if (poly[521].contains(lat,lng)) return 83;
                            if (poly[522].contains(lat,lng)) return 83;
                            else return 71;
                        }
                        else
                        if (lat < -23.561625f)
                        {
                            if (poly[523].contains(lat,lng)) return 83;
                            else return 71;
                        }
                        else
                        {
                            if (poly[524].contains(lat,lng)) return 71;
                            else return 83;
                        }
                    else
                    if (lng < -56.330086f)
                        if (lat < -20.741840f)
                            if (lng < -57.250793f)
                            {
                                if (poly[525].contains(lat,lng)) return 83;
                                else return 71;
                            }
                            else
                            {
                                if (poly[526].contains(lat,lng)) return 71;
                                else return 83;
                            }
                        else
                        {
                            if (poly[527].contains(lat,lng)) return 71;
                            if (poly[528].contains(lat,lng)) return 71;
                            if (poly[529].contains(lat,lng)) return 132;
                            else return 83;
                        }
                    else
                        return 83;
                else
                if (lat < -22.151733f)
                {
                    if (poly[530].contains(lat,lng)) return 71;
                    if (poly[531].contains(lat,lng)) return 83;
                    else return 179;
                }
                else
                {
                    if (poly[532].contains(lat,lng)) return 179;
                    else return 83;
                }
            else
            if (lng < -54.488672f)
                if (lat < -16.512163f)
                    if (lng < -56.330086f)
                        if (lat < -17.922055f)
                        {
                            if (poly[533].contains(lat,lng)) return 132;
                            else return 83;
                        }
                        else
                        if (lng < -57.250793f)
                        {
                            if (poly[534].contains(lat,lng)) return 92;
                            if (poly[535].contains(lat,lng)) return 132;
                            else return 83;
                        }
                        else
                        {
                            if (poly[536].contains(lat,lng)) return 92;
                            if (poly[537].contains(lat,lng)) return 92;
                            else return 83;
                        }
                    else
                    if (lat < -17.922055f)
                        return 83;
                    else
                    if (lng < -55.409379f)
                    {
                        if (poly[538].contains(lat,lng)) return 92;
                        else return 83;
                    }
                    else
                    {
                        if (poly[539].contains(lat,lng)) return 92;
                        else return 83;
                    }
                else
                    return 92;
            else
            if (lat < -16.512163f)
                if (lng < -52.647375f)
                    if (lat < -17.922055f)
                    {
                        if (poly[540].contains(lat,lng)) return 92;
                        if (poly[541].contains(lat,lng)) return 92;
                        if (poly[542].contains(lat,lng)) return 179;
                        else return 83;
                    }
                    else
                    if (lng < -53.568023f)
                    {
                        if (poly[543].contains(lat,lng)) return 92;
                        else return 83;
                    }
                    else
                    {
                        if (poly[544].contains(lat,lng)) return 179;
                        else return 92;
                    }
                else
                {
                    if (poly[545].contains(lat,lng)) return 83;
                    if (poly[546].contains(lat,lng)) return 92;
                    else return 179;
                }
            else
            if (lng < -52.647258f)
            {
                if (poly[547].contains(lat,lng)) return 179;
                else return 92;
            }
            else
            if (lat < -15.102270f)
            {
                if (poly[548].contains(lat,lng)) return 179;
                else return 92;
            }
            else
            {
                if (poly[549].contains(lat,lng)) return 179;
                else return 92;
            }
        else
        if (lng < -44.648778f)
            if (lat < -19.331948f)
                return 179;
            else
            if (lng < -47.727311f)
                return 179;
            else
            if (lat < -16.512163f)
                return 179;
            else
            if (lng < -46.188044f)
            {
                if (poly[550].contains(lat,lng)) return 73;
                else return 179;
            }
            else
            if (lat < -15.102270f)
            {
                if (poly[551].contains(lat,lng)) return 73;
                else return 179;
            }
            else
            {
                if (poly[552].contains(lat,lng)) return 179;
                if (poly[553].contains(lat,lng)) return 179;
                else return 73;
            }
        else
        if (lat < -18.741865f)
            return 179;
        else
        if (lng < -41.570246f)
            if (lat < -16.217122f)
                return 179;
            else
            if (lng < -43.109512f)
            {
                if (poly[554].contains(lat,lng)) return 179;
                else return 73;
            }
            else
            {
                if (poly[555].contains(lat,lng)) return 179;
                else return 73;
            }
        else
        if (lat < -16.217122f)
            if (lng < -40.030979f)
            {
                if (poly[556].contains(lat,lng)) return 73;
                else return 179;
            }
            else
            {
                if (poly[557].contains(lat,lng)) return 179;
                if (poly[558].contains(lat,lng)) return 179;
                else return 73;
            }
        else
        {
            if (poly[559].contains(lat,lng)) return 179;
            else return 73;
        }
    }

    private static int call8(float lat, float lng)
    {
        if (lng < -64.150670f)
            if (lat < -25.168567f)
                if (lng < -66.537674f)
                    if (lng < -69.003680f)
                    {
                        if (poly[560].contains(lat,lng)) return 60;
                        if (poly[561].contains(lat,lng)) return 63;
                        else return 177;
                    }
                    else
                    if (lat < -26.780915f)
                        if (lng < -67.770677f)
                            if (lat < -27.587090f)
                            {
                                if (poly[562].contains(lat,lng)) return 63;
                                else return 60;
                            }
                            else
                            {
                                if (poly[563].contains(lat,lng)) return 177;
                                else return 60;
                            }
                        else
                        {
                            if (poly[564].contains(lat,lng)) return 63;
                            else return 60;
                        }
                    else
                    {
                        if (poly[565].contains(lat,lng)) return 66;
                        if (poly[566].contains(lat,lng)) return 66;
                        if (poly[567].contains(lat,lng)) return 177;
                        else return 60;
                    }
                else
                if (lat < -25.700714f)
                    if (lng < -64.268303f)
                        if (lat < -27.046989f)
                        {
                            if (poly[568].contains(lat,lng)) return 60;
                            if (poly[569].contains(lat,lng)) return 61;
                            else return 69;
                        }
                        else
                        if (lng < -65.402989f)
                        {
                            if (poly[570].contains(lat,lng)) return 60;
                            if (poly[571].contains(lat,lng)) return 66;
                            else return 69;
                        }
                        else
                        {
                            if (poly[572].contains(lat,lng)) return 61;
                            if (poly[573].contains(lat,lng)) return 66;
                            else return 69;
                        }
                    else
                    {
                        if (poly[574].contains(lat,lng)) return 66;
                        else return 61;
                    }
                else
                {
                    if (poly[575].contains(lat,lng)) return 60;
                    else return 66;
                }
            else
            if (lat < -19.430473f)
                if (lng < -69.470560f)
                {
                    if (poly[576].contains(lat,lng)) return 133;
                    else return 177;
                }
                else
                if (lat < -22.299520f)
                    if (lng < -66.810615f)
                        if (lat < -23.734043f)
                        {
                            if (poly[577].contains(lat,lng)) return 62;
                            if (poly[578].contains(lat,lng)) return 177;
                            else return 66;
                        }
                        else
                        {
                            if (poly[579].contains(lat,lng)) return 62;
                            if (poly[580].contains(lat,lng)) return 66;
                            if (poly[581].contains(lat,lng)) return 177;
                            else return 132;
                        }
                    else
                    if (lat < -23.734043f)
                        if (lng < -65.480642f)
                        {
                            if (poly[582].contains(lat,lng)) return 66;
                            else return 62;
                        }
                        else
                        {
                            if (poly[583].contains(lat,lng)) return 66;
                            else return 62;
                        }
                    else
                    if (lng < -65.480642f)
                    {
                        if (poly[584].contains(lat,lng)) return 66;
                        if (poly[585].contains(lat,lng)) return 132;
                        else return 62;
                    }
                    else
                    if (lat < -23.016782f)
                    {
                        if (poly[586].contains(lat,lng)) return 66;
                        else return 62;
                    }
                    else
                    {
                        if (poly[587].contains(lat,lng)) return 62;
                        if (poly[588].contains(lat,lng)) return 132;
                        else return 66;
                    }
                else
                if (lng < -66.810615f)
                {
                    if (poly[589].contains(lat,lng)) return 177;
                    else return 132;
                }
                else
                {
                    if (poly[590].contains(lat,lng)) return 62;
                    if (poly[591].contains(lat,lng)) return 66;
                    else return 132;
                }
            else
            if (lng < -69.470560f)
            {
                if (poly[592].contains(lat,lng)) return 132;
                if (poly[593].contains(lat,lng)) return 177;
                else return 133;
            }
            else
            if (lat < -16.561425f)
            {
                if (poly[594].contains(lat,lng)) return 133;
                if (poly[595].contains(lat,lng)) return 133;
                if (poly[596].contains(lat,lng)) return 177;
                else return 132;
            }
            else
            if (lng < -66.810615f)
                if (lat < -15.126902f)
                {
                    if (poly[597].contains(lat,lng)) return 133;
                    else return 132;
                }
                else
                {
                    if (poly[598].contains(lat,lng)) return 133;
                    else return 132;
                }
            else
                return 132;
        else
        if (lat < -26.358070f)
        {
            if (poly[599].contains(lat,lng)) return 71;
            else return 61;
        }
        else
        if (lat < -19.287647f)
            if (lng < -59.068928f)
                if (lat < -22.822858f)
                    if (lng < -61.609799f)
                    {
                        if (poly[600].contains(lat,lng)) return 66;
                        if (poly[601].contains(lat,lng)) return 71;
                        else return 61;
                    }
                    else
                    {
                        if (poly[602].contains(lat,lng)) return 71;
                        else return 61;
                    }
                else
                if (lng < -61.609799f)
                    if (lat < -21.055253f)
                        if (lng < -62.880235f)
                        {
                            if (poly[603].contains(lat,lng)) return 132;
                            else return 66;
                        }
                        else
                        if (lat < -21.939056f)
                            if (lng < -62.245017f)
                            {
                                if (poly[604].contains(lat,lng)) return 61;
                                if (poly[605].contains(lat,lng)) return 71;
                                if (poly[606].contains(lat,lng)) return 71;
                                if (poly[607].contains(lat,lng)) return 132;
                                else return 66;
                            }
                            else
                            {
                                if (poly[608].contains(lat,lng)) return 61;
                                if (poly[609].contains(lat,lng)) return 61;
                                if (poly[610].contains(lat,lng)) return 61;
                                else return 71;
                            }
                        else
                        {
                            if (poly[611].contains(lat,lng)) return 132;
                            else return 71;
                        }
                    else
                    {
                        if (poly[612].contains(lat,lng)) return 71;
                        else return 132;
                    }
                else
                {
                    if (poly[613].contains(lat,lng)) return 132;
                    else return 71;
                }
            else
            if (lat < -24.634697f)
            {
                if (poly[614].contains(lat,lng)) return 71;
                else return 61;
            }
            else
            if (lat < -19.834362f)
            {
                if (poly[615].contains(lat,lng)) return 132;
                else return 71;
            }
            else
            {
                if (poly[616].contains(lat,lng)) return 132;
                else return 71;
            }
        else
        if (lng < -61.161085f)
            return 132;
        else
        if (lat < -16.490012f)
        {
            if (poly[617].contains(lat,lng)) return 92;
            else return 132;
        }
        else
        {
            if (poly[618].contains(lat,lng)) return 92;
            else return 132;
        }
    }

    private static int call9(float lat, float lng)
    {
        if (lat < 0.627796f)
            if (lng < -61.358472f)
                if (lat < -3.360249f)
                    return 138;
                else
                if (lng < -63.989208f)
                    return 138;
                else
                if (lat < -1.366227f)
                {
                    if (poly[619].contains(lat,lng)) return 79;
                    else return 138;
                }
                else
                if (lng < -62.673840f)
                    return 138;
                else
                if (lat < -0.369216f)
                {
                    if (poly[620].contains(lat,lng)) return 79;
                    else return 138;
                }
                else
                {
                    if (poly[621].contains(lat,lng)) return 138;
                    else return 79;
                }
            else
            if (lat < -3.360249f)
            {
                if (poly[622].contains(lat,lng)) return 176;
                else return 138;
            }
            else
            if (lng < -58.727736f)
                if (lat < -1.366227f)
                    return 138;
                else
                if (lng < -60.043104f)
                    if (lat < -0.369216f)
                    {
                        if (poly[623].contains(lat,lng)) return 79;
                        else return 138;
                    }
                    else
                    {
                        if (poly[624].contains(lat,lng)) return 138;
                        else return 79;
                    }
                else
                {
                    if (poly[625].contains(lat,lng)) return 79;
                    if (poly[626].contains(lat,lng)) return 176;
                    if (poly[627].contains(lat,lng)) return 176;
                    if (poly[628].contains(lat,lng)) return 176;
                    else return 138;
                }
            else
            if (lat < -1.366227f)
                if (lng < -57.412368f)
                {
                    if (poly[629].contains(lat,lng)) return 176;
                    else return 138;
                }
                else
                {
                    if (poly[630].contains(lat,lng)) return 138;
                    else return 176;
                }
            else
            {
                if (poly[631].contains(lat,lng)) return 138;
                if (poly[632].contains(lat,lng)) return 138;
                if (poly[633].contains(lat,lng)) return 138;
                else return 176;
            }
        else
        if (lng < -61.358472f)
            if (lat < 4.615840f)
                if (lng < -63.989208f)
                    if (lat < 2.621818f)
                        if (lng < -65.304576f)
                        {
                            if (poly[634].contains(lat,lng)) return 138;
                            else return 85;
                        }
                        else
                        if (lat < 1.624807f)
                        {
                            if (poly[635].contains(lat,lng)) return 138;
                            else return 85;
                        }
                        else
                        {
                            if (poly[636].contains(lat,lng)) return 79;
                            if (poly[637].contains(lat,lng)) return 138;
                            else return 85;
                        }
                    else
                    {
                        if (poly[638].contains(lat,lng)) return 79;
                        if (poly[639].contains(lat,lng)) return 79;
                        if (poly[640].contains(lat,lng)) return 79;
                        else return 85;
                    }
                else
                if (lat < 2.621818f)
                    if (lng < -62.673840f)
                        if (lat < 1.624807f)
                        {
                            if (poly[641].contains(lat,lng)) return 79;
                            else return 138;
                        }
                        else
                        if (lng < -63.331524f)
                        {
                            if (poly[642].contains(lat,lng)) return 79;
                            if (poly[643].contains(lat,lng)) return 138;
                            else return 85;
                        }
                        else
                        {
                            if (poly[644].contains(lat,lng)) return 138;
                            else return 79;
                        }
                    else
                    {
                        if (poly[645].contains(lat,lng)) return 138;
                        else return 79;
                    }
                else
                if (lng < -62.673840f)
                    if (lat < 3.618829f)
                    {
                        if (poly[646].contains(lat,lng)) return 85;
                        if (poly[647].contains(lat,lng)) return 85;
                        if (poly[648].contains(lat,lng)) return 85;
                        else return 79;
                    }
                    else
                    {
                        if (poly[649].contains(lat,lng)) return 85;
                        else return 79;
                    }
                else
                {
                    if (poly[650].contains(lat,lng)) return 85;
                    else return 79;
                }
            else
            {
                if (poly[651].contains(lat,lng)) return 113;
                else return 85;
            }
        else
        if (lat < 4.615840f)
            if (lng < -58.727736f)
                if (lat < 2.621818f)
                    if (lng < -60.043104f)
                        return 79;
                    else
                    if (lat < 1.624807f)
                    {
                        if (poly[652].contains(lat,lng)) return 113;
                        if (poly[653].contains(lat,lng)) return 176;
                        else return 79;
                    }
                    else
                    {
                        if (poly[654].contains(lat,lng)) return 113;
                        else return 79;
                    }
                else
                if (lng < -60.043104f)
                {
                    if (poly[655].contains(lat,lng)) return 85;
                    if (poly[656].contains(lat,lng)) return 113;
                    else return 79;
                }
                else
                if (lat < 3.618829f)
                {
                    if (poly[657].contains(lat,lng)) return 113;
                    else return 79;
                }
                else
                {
                    if (poly[658].contains(lat,lng)) return 79;
                    else return 113;
                }
            else
            if (lat < 2.621818f)
                if (lng < -57.412368f)
                {
                    if (poly[659].contains(lat,lng)) return 113;
                    else return 176;
                }
                else
                if (lat < 1.624807f)
                    return 176;
                else
                if (lng < -56.754684f)
                {
                    if (poly[660].contains(lat,lng)) return 163;
                    if (poly[661].contains(lat,lng)) return 176;
                    else return 113;
                }
                else
                {
                    if (poly[662].contains(lat,lng)) return 113;
                    if (poly[663].contains(lat,lng)) return 163;
                    else return 176;
                }
            else
            {
                if (poly[664].contains(lat,lng)) return 163;
                else return 113;
            }
        else
        if (lng < -58.727736f)
            if (lat < 6.609862f)
                if (lng < -60.043104f)
                    if (lat < 5.612851f)
                    {
                        if (poly[665].contains(lat,lng)) return 85;
                        if (poly[666].contains(lat,lng)) return 113;
                        if (poly[667].contains(lat,lng)) return 113;
                        else return 79;
                    }
                    else
                    {
                        if (poly[668].contains(lat,lng)) return 113;
                        else return 85;
                    }
                else
                {
                    if (poly[669].contains(lat,lng)) return 79;
                    else return 113;
                }
            else
            if (lng < -60.043104f)
                if (lat < 7.606873f)
                {
                    if (poly[670].contains(lat,lng)) return 85;
                    else return 113;
                }
                else
                {
                    if (poly[671].contains(lat,lng)) return 113;
                    else return 85;
                }
            else
            {
                if (poly[672].contains(lat,lng)) return 85;
                else return 113;
            }
        else
        {
            if (poly[673].contains(lat,lng)) return 163;
            else return 113;
        }
    }

    private static int call10(float lat, float lng)
    {
        if (lat < -9.893535f)
            if (lng < -71.171189f)
            {
                if (poly[674].contains(lat,lng)) return 175;
                else return 133;
            }
            else
            if (lng < -68.895567f)
                if (lat < -11.792956f)
                {
                    if (poly[675].contains(lat,lng)) return 133;
                    else return 132;
                }
                else
                {
                    if (poly[676].contains(lat,lng)) return 132;
                    if (poly[677].contains(lat,lng)) return 133;
                    else return 175;
                }
            else
            if (lat < -11.792956f)
            {
                if (poly[678].contains(lat,lng)) return 133;
                else return 132;
            }
            else
            {
                if (poly[679].contains(lat,lng)) return 132;
                else return 175;
            }
        else
        if (lat < -0.193865f)
            if (lng < -67.558582f)
                if (lat < -5.043700f)
                    if (lng < -71.174515f)
                        if (lat < -7.468617f)
                            if (lng < -72.982482f)
                                if (lat < -8.681076f)
                                {
                                    if (poly[680].contains(lat,lng)) return 175;
                                    if (poly[681].contains(lat,lng)) return 175;
                                    else return 133;
                                }
                                else
                                {
                                    if (poly[682].contains(lat,lng)) return 175;
                                    else return 133;
                                }
                            else
                            {
                                if (poly[683].contains(lat,lng)) return 101;
                                if (poly[684].contains(lat,lng)) return 133;
                                if (poly[685].contains(lat,lng)) return 133;
                                else return 175;
                            }
                        else
                        if (lng < -72.982482f)
                        {
                            if (poly[686].contains(lat,lng)) return 101;
                            if (poly[687].contains(lat,lng)) return 175;
                            else return 133;
                        }
                        else
                        {
                            if (poly[688].contains(lat,lng)) return 133;
                            if (poly[689].contains(lat,lng)) return 175;
                            else return 101;
                        }
                    else
                    {
                        if (poly[690].contains(lat,lng)) return 101;
                        if (poly[691].contains(lat,lng)) return 133;
                        if (poly[692].contains(lat,lng)) return 138;
                        else return 175;
                    }
                else
                if (lng < -71.174515f)
                    if (lat < -2.618782f)
                        if (lng < -72.982482f)
                            return 133;
                        else
                        if (lat < -3.831241f)
                            if (lng < -72.078499f)
                            {
                                if (poly[693].contains(lat,lng)) return 101;
                                else return 133;
                            }
                            else
                            {
                                if (poly[694].contains(lat,lng)) return 133;
                                else return 101;
                            }
                        else
                            return 133;
                    else
                    if (lng < -72.982482f)
                        if (lat < -1.406323f)
                        {
                            if (poly[695].contains(lat,lng)) return 80;
                            else return 133;
                        }
                        else
                        if (lng < -73.886466f)
                        {
                            if (poly[696].contains(lat,lng)) return 80;
                            else return 133;
                        }
                        else
                        {
                            if (poly[697].contains(lat,lng)) return 133;
                            else return 80;
                        }
                    else
                    if (lat < -1.406323f)
                        if (lng < -72.078499f)
                        {
                            if (poly[698].contains(lat,lng)) return 133;
                            else return 80;
                        }
                        else
                        {
                            if (poly[699].contains(lat,lng)) return 133;
                            else return 80;
                        }
                    else
                        return 80;
                else
                if (lat < -2.618782f)
                    if (lng < -69.366549f)
                        if (lat < -3.831241f)
                            if (lng < -70.270532f)
                                if (lat < -4.437470f)
                                    return 101;
                                else
                                if (lng < -70.722524f)
                                {
                                    if (poly[700].contains(lat,lng)) return 133;
                                    else return 101;
                                }
                                else
                                {
                                    if (poly[701].contains(lat,lng)) return 80;
                                    if (poly[702].contains(lat,lng)) return 80;
                                    if (poly[703].contains(lat,lng)) return 80;
                                    if (poly[704].contains(lat,lng)) return 101;
                                    else return 133;
                                }
                            else
                            {
                                if (poly[705].contains(lat,lng)) return 80;
                                if (poly[706].contains(lat,lng)) return 101;
                                if (poly[707].contains(lat,lng)) return 138;
                                else return 133;
                            }
                        else
                        {
                            if (poly[708].contains(lat,lng)) return 80;
                            if (poly[709].contains(lat,lng)) return 138;
                            else return 133;
                        }
                    else
                        return 138;
                else
                if (lng < -69.366549f)
                    if (lat < -1.406323f)
                    {
                        if (poly[710].contains(lat,lng)) return 133;
                        if (poly[711].contains(lat,lng)) return 138;
                        else return 80;
                    }
                    else
                    {
                        if (poly[712].contains(lat,lng)) return 138;
                        else return 80;
                    }
                else
                    return 138;
            else
            {
                if (poly[713].contains(lat,lng)) return 167;
                if (poly[714].contains(lat,lng)) return 175;
                else return 138;
            }
        else
        if (lat < 4.205010f)
            if (lng < -70.705196f)
                return 80;
            else
            if (lat < 2.005573f)
                if (lng < -68.662570f)
                    if (lat < 0.905854f)
                    {
                        if (poly[715].contains(lat,lng)) return 80;
                        else return 138;
                    }
                    else
                    {
                        if (poly[716].contains(lat,lng)) return 138;
                        else return 80;
                    }
                else
                if (lat < 0.905854f)
                    return 138;
                else
                if (lng < -67.641257f)
                {
                    if (poly[717].contains(lat,lng)) return 80;
                    if (poly[718].contains(lat,lng)) return 80;
                    else return 138;
                }
                else
                {
                    if (poly[719].contains(lat,lng)) return 85;
                    if (poly[720].contains(lat,lng)) return 138;
                    else return 80;
                }
            else
            if (lng < -68.662570f)
                return 80;
            else
            if (lat < 3.105291f)
            {
                if (poly[721].contains(lat,lng)) return 85;
                if (poly[722].contains(lat,lng)) return 138;
                if (poly[723].contains(lat,lng)) return 138;
                else return 80;
            }
            else
            {
                if (poly[724].contains(lat,lng)) return 85;
                else return 80;
            }
        else
        if (lng < -70.705196f)
        {
            if (poly[725].contains(lat,lng)) return 85;
            else return 80;
        }
        else
        if (lat < 6.404447f)
            if (lng < -68.662570f)
            {
                if (poly[726].contains(lat,lng)) return 85;
                else return 80;
            }
            else
            {
                if (poly[727].contains(lat,lng)) return 80;
                else return 85;
            }
        else
        {
            if (poly[728].contains(lat,lng)) return 80;
            else return 85;
        }
    }

    private static int call11(float lat, float lng)
    {
        if (lng < -45.696978f)
            if (lat < -4.509060f)
                if (lat < -9.100719f)
                    if (lng < -48.633171f)
                        if (lat < -11.396548f)
                            if (lng < -50.101268f)
                                if (lat < -12.544463f)
                                    if (lng < -50.835316f)
                                        return 92;
                                    else
                                    if (lat < -13.118421f)
                                    {
                                        if (poly[729].contains(lat,lng)) return 179;
                                        else return 92;
                                    }
                                    else
                                    if (lng < -50.468292f)
                                    {
                                        if (poly[730].contains(lat,lng)) return 58;
                                        if (poly[731].contains(lat,lng)) return 179;
                                        if (poly[732].contains(lat,lng)) return 179;
                                        if (poly[733].contains(lat,lng)) return 179;
                                        else return 92;
                                    }
                                    else
                                    {
                                        if (poly[734].contains(lat,lng)) return 58;
                                        if (poly[735].contains(lat,lng)) return 58;
                                        if (poly[736].contains(lat,lng)) return 58;
                                        else return 179;
                                    }
                                else
                                {
                                    if (poly[737].contains(lat,lng)) return 92;
                                    if (poly[738].contains(lat,lng)) return 179;
                                    else return 58;
                                }
                            else
                            {
                                if (poly[739].contains(lat,lng)) return 58;
                                else return 179;
                            }
                        else
                        {
                            if (poly[740].contains(lat,lng)) return 76;
                            if (poly[741].contains(lat,lng)) return 92;
                            else return 58;
                        }
                    else
                    if (lat < -11.396548f)
                        if (lng < -47.165075f)
                            if (lat < -12.544463f)
                                if (lng < -47.899123f)
                                {
                                    if (poly[742].contains(lat,lng)) return 179;
                                    else return 58;
                                }
                                else
                                {
                                    if (poly[743].contains(lat,lng)) return 179;
                                    else return 58;
                                }
                            else
                                return 58;
                        else
                        if (lat < -12.544463f)
                            if (lng < -46.431026f)
                            {
                                if (poly[744].contains(lat,lng)) return 179;
                                else return 58;
                            }
                            else
                            {
                                if (poly[745].contains(lat,lng)) return 58;
                                if (poly[746].contains(lat,lng)) return 179;
                                else return 73;
                            }
                        else
                        {
                            if (poly[747].contains(lat,lng)) return 73;
                            else return 58;
                        }
                    else
                    if (lng < -47.165075f)
                        return 58;
                    else
                    if (lat < -10.248634f)
                    {
                        if (poly[748].contains(lat,lng)) return 73;
                        if (poly[749].contains(lat,lng)) return 104;
                        if (poly[750].contains(lat,lng)) return 104;
                        else return 58;
                    }
                    else
                    if (lng < -46.431026f)
                    {
                        if (poly[751].contains(lat,lng)) return 104;
                        else return 58;
                    }
                    else
                    {
                        if (poly[752].contains(lat,lng)) return 73;
                        if (poly[753].contains(lat,lng)) return 104;
                        else return 58;
                    }
                else
                if (lng < -48.633171f)
                {
                    if (poly[754].contains(lat,lng)) return 58;
                    if (poly[755].contains(lat,lng)) return 58;
                    if (poly[756].contains(lat,lng)) return 104;
                    else return 76;
                }
                else
                if (lat < -6.804889f)
                    if (lng < -47.165075f)
                    {
                        if (poly[757].contains(lat,lng)) return 104;
                        else return 58;
                    }
                    else
                    {
                        if (poly[758].contains(lat,lng)) return 58;
                        else return 104;
                    }
                else
                if (lng < -47.165075f)
                    if (lat < -5.656975f)
                    {
                        if (poly[759].contains(lat,lng)) return 76;
                        if (poly[760].contains(lat,lng)) return 104;
                        else return 58;
                    }
                    else
                    {
                        if (poly[761].contains(lat,lng)) return 58;
                        if (poly[762].contains(lat,lng)) return 76;
                        if (poly[763].contains(lat,lng)) return 76;
                        else return 104;
                    }
                else
                    return 104;
            else
            if (lat < 0.082599f)
                if (lng < -48.633171f)
                    return 76;
                else
                if (lat < -2.213230f)
                    if (lng < -47.165075f)
                    {
                        if (poly[764].contains(lat,lng)) return 104;
                        else return 76;
                    }
                    else
                    if (lat < -3.361145f)
                    {
                        if (poly[765].contains(lat,lng)) return 76;
                        else return 104;
                    }
                    else
                    if (lng < -46.431026f)
                    {
                        if (poly[766].contains(lat,lng)) return 104;
                        if (poly[767].contains(lat,lng)) return 104;
                        if (poly[768].contains(lat,lng)) return 104;
                        else return 76;
                    }
                    else
                    {
                        if (poly[769].contains(lat,lng)) return 76;
                        if (poly[770].contains(lat,lng)) return 76;
                        if (poly[771].contains(lat,lng)) return 76;
                        if (poly[772].contains(lat,lng)) return 76;
                        else return 104;
                    }
                else
                {
                    if (poly[773].contains(lat,lng)) return 104;
                    else return 76;
                }
            else
                return 76;
        else
        if (lat < -7.262677f)
            if (lng < -40.162602f)
                if (lat < -10.477527f)
                {
                    if (poly[774].contains(lat,lng)) return 104;
                    else return 73;
                }
                else
                if (lng < -42.929790f)
                {
                    if (poly[775].contains(lat,lng)) return 104;
                    else return 73;
                }
                else
                if (lat < -8.870102f)
                    if (lng < -41.546196f)
                    {
                        if (poly[776].contains(lat,lng)) return 73;
                        else return 104;
                    }
                    else
                    {
                        if (poly[777].contains(lat,lng)) return 104;
                        if (poly[778].contains(lat,lng)) return 172;
                        else return 73;
                    }
                else
                if (lng < -41.546196f)
                    return 104;
                else
                if (lat < -8.066389f)
                {
                    if (poly[779].contains(lat,lng)) return 73;
                    if (poly[780].contains(lat,lng)) return 104;
                    else return 172;
                }
                else
                {
                    if (poly[781].contains(lat,lng)) return 172;
                    else return 104;
                }
            else
            if (lat < -10.477527f)
                if (lng < -38.150959f)
                {
                    if (poly[782].contains(lat,lng)) return 136;
                    else return 73;
                }
                else
                {
                    if (poly[783].contains(lat,lng)) return 73;
                    if (poly[784].contains(lat,lng)) return 73;
                    else return 136;
                }
            else
            if (lng < -37.395413f)
                if (lat < -8.870102f)
                    if (lng < -38.779007f)
                    {
                        if (poly[785].contains(lat,lng)) return 172;
                        else return 73;
                    }
                    else
                    if (lat < -9.673815f)
                    {
                        if (poly[786].contains(lat,lng)) return 136;
                        else return 73;
                    }
                    else
                    if (lng < -38.087210f)
                    {
                        if (poly[787].contains(lat,lng)) return 136;
                        if (poly[788].contains(lat,lng)) return 172;
                        if (poly[789].contains(lat,lng)) return 172;
                        else return 73;
                    }
                    else
                    {
                        if (poly[790].contains(lat,lng)) return 73;
                        if (poly[791].contains(lat,lng)) return 172;
                        if (poly[792].contains(lat,lng)) return 172;
                        else return 136;
                    }
                else
                if (lng < -38.779007f)
                    if (lat < -8.066389f)
                    {
                        if (poly[793].contains(lat,lng)) return 73;
                        else return 172;
                    }
                    else
                    {
                        if (poly[794].contains(lat,lng)) return 172;
                        else return 104;
                    }
                else
                {
                    if (poly[795].contains(lat,lng)) return 73;
                    if (poly[796].contains(lat,lng)) return 73;
                    if (poly[797].contains(lat,lng)) return 104;
                    if (poly[798].contains(lat,lng)) return 136;
                    else return 172;
                }
            else
            if (lat < -8.870102f)
            {
                if (poly[799].contains(lat,lng)) return 172;
                if (poly[800].contains(lat,lng)) return 172;
                if (poly[801].contains(lat,lng)) return 172;
                if (poly[802].contains(lat,lng)) return 172;
                else return 136;
            }
            else
            if (lng < -36.011819f)
                if (lat < -8.066389f)
                {
                    if (poly[803].contains(lat,lng)) return 104;
                    else return 172;
                }
                else
                {
                    if (poly[804].contains(lat,lng)) return 172;
                    if (poly[805].contains(lat,lng)) return 172;
                    else return 104;
                }
            else
            {
                if (poly[806].contains(lat,lng)) return 104;
                if (poly[807].contains(lat,lng)) return 136;
                if (poly[808].contains(lat,lng)) return 136;
                if (poly[809].contains(lat,lng)) return 136;
                else return 172;
            }
        else
            return 104;
    }

    private static int call12(float lat, float lng)
    {
        if (lat < 8.603884f)
            if (lng < -51.569364f)
                if (lng < -66.619944f)
                    return call10(lat,lng);
                else
                if (lat < -7.348293f)
                    if (lng < -58.136618f)
                        if (lng < -62.378281f)
                            if (lat < -10.520335f)
                                if (lng < -64.499112f)
                                    if (lat < -12.106357f)
                                    {
                                        if (poly[810].contains(lat,lng)) return 167;
                                        if (poly[811].contains(lat,lng)) return 167;
                                        if (poly[812].contains(lat,lng)) return 167;
                                        else return 132;
                                    }
                                    else
                                    {
                                        if (poly[813].contains(lat,lng)) return 167;
                                        else return 132;
                                    }
                                else
                                if (lat < -12.106357f)
                                    if (lng < -63.438697f)
                                    {
                                        if (poly[814].contains(lat,lng)) return 167;
                                        if (poly[815].contains(lat,lng)) return 167;
                                        else return 132;
                                    }
                                    else
                                    {
                                        if (poly[816].contains(lat,lng)) return 167;
                                        else return 132;
                                    }
                                else
                                    return 167;
                            else
                            if (lng < -64.499112f)
                                if (lat < -8.934314f)
                                    if (lng < -65.559528f)
                                        if (lat < -9.727325f)
                                        {
                                            if (poly[817].contains(lat,lng)) return 167;
                                            else return 132;
                                        }
                                        else
                                        {
                                            if (poly[818].contains(lat,lng)) return 167;
                                            else return 138;
                                        }
                                    else
                                    {
                                        if (poly[819].contains(lat,lng)) return 132;
                                        if (poly[820].contains(lat,lng)) return 138;
                                        else return 167;
                                    }
                                else
                                    return 138;
                            else
                            {
                                if (poly[821].contains(lat,lng)) return 167;
                                else return 138;
                            }
                        else
                        if (lat < -10.520335f)
                            if (lng < -60.257449f)
                                if (lat < -12.106357f)
                                    if (lng < -61.317865f)
                                    {
                                        if (poly[822].contains(lat,lng)) return 167;
                                        else return 132;
                                    }
                                    else
                                    {
                                        if (poly[823].contains(lat,lng)) return 92;
                                        if (poly[824].contains(lat,lng)) return 132;
                                        else return 167;
                                    }
                                else
                                {
                                    if (poly[825].contains(lat,lng)) return 92;
                                    else return 167;
                                }
                            else
                            {
                                if (poly[826].contains(lat,lng)) return 167;
                                else return 92;
                            }
                        else
                        if (lng < -60.257449f)
                            if (lat < -8.934314f)
                            {
                                if (poly[827].contains(lat,lng)) return 167;
                                else return 92;
                            }
                            else
                            {
                                if (poly[828].contains(lat,lng)) return 92;
                                if (poly[829].contains(lat,lng)) return 138;
                                else return 167;
                            }
                        else
                        {
                            if (poly[830].contains(lat,lng)) return 138;
                            else return 92;
                        }
                    else
                    if (lng < -54.852991f)
                    {
                        if (poly[831].contains(lat,lng)) return 176;
                        else return 92;
                    }
                    else
                    {
                        if (poly[832].contains(lat,lng)) return 92;
                        if (poly[833].contains(lat,lng)) return 176;
                        else return 76;
                    }
                else
                if (lng < -56.097000f)
                    return call9(lat,lng);
                else
                if (lat < -0.579146f)
                    if (lat < -3.963720f)
                        if (lng < -53.833182f)
                            return 176;
                        else
                        if (lat < -5.656006f)
                        {
                            if (poly[834].contains(lat,lng)) return 176;
                            else return 76;
                        }
                        else
                        {
                            if (poly[835].contains(lat,lng)) return 176;
                            else return 76;
                        }
                    else
                    if (lng < -53.833182f)
                        return 176;
                    else
                    if (lat < -2.271433f)
                    {
                        if (poly[836].contains(lat,lng)) return 176;
                        else return 76;
                    }
                    else
                    {
                        if (poly[837].contains(lat,lng)) return 176;
                        else return 76;
                    }
                else
                if (lat < 2.805427f)
                    if (lng < -53.833182f)
                        if (lat < 1.113140f)
                            return 176;
                        else
                        if (lng < -54.965091f)
                        {
                            if (poly[838].contains(lat,lng)) return 176;
                            else return 163;
                        }
                        else
                        if (lat < 1.959283f)
                        {
                            if (poly[839].contains(lat,lng)) return 76;
                            else return 176;
                        }
                        else
                        if (lng < -54.399136f)
                        {
                            if (poly[840].contains(lat,lng)) return 86;
                            if (poly[841].contains(lat,lng)) return 163;
                            if (poly[842].contains(lat,lng)) return 176;
                            else return 76;
                        }
                        else
                        {
                            if (poly[843].contains(lat,lng)) return 76;
                            if (poly[844].contains(lat,lng)) return 163;
                            else return 86;
                        }
                    else
                    if (lat < 1.113140f)
                    {
                        if (poly[845].contains(lat,lng)) return 176;
                        if (poly[846].contains(lat,lng)) return 176;
                        else return 76;
                    }
                    else
                    if (lng < -52.701273f)
                    {
                        if (poly[847].contains(lat,lng)) return 86;
                        if (poly[848].contains(lat,lng)) return 176;
                        else return 76;
                    }
                    else
                    {
                        if (poly[849].contains(lat,lng)) return 86;
                        else return 76;
                    }
                else
                if (lng < -53.833182f)
                    if (lat < 4.497713f)
                    {
                        if (poly[850].contains(lat,lng)) return 163;
                        else return 86;
                    }
                    else
                    {
                        if (poly[851].contains(lat,lng)) return 86;
                        else return 163;
                    }
                else
                {
                    if (poly[852].contains(lat,lng)) return 76;
                    else return 86;
                }
            else
                return call11(lat,lng);
        else
        if (lng < -67.990797f)
            if (lng < -69.661226f)
                if (lng < -70.927056f)
                    if (lat < 11.961238f)
                        if (lng < -72.858752f)
                        {
                            if (poly[853].contains(lat,lng)) return 85;
                            else return 80;
                        }
                        else
                        {
                            if (poly[854].contains(lat,lng)) return 85;
                            else return 80;
                        }
                    else
                    {
                        if (poly[855].contains(lat,lng)) return 85;
                        else return 80;
                    }
                else
                {
                    if (poly[856].contains(lat,lng)) return 85;
                    else return 57;
                }
            else
            {
                if (poly[857].contains(lat,lng)) return 85;
                if (poly[858].contains(lat,lng)) return 93;
                else return 131;
            }
        else
        if (lat < 12.324735f)
            if (lat < 11.562837f)
            {
                if (poly[859].contains(lat,lng)) return 85;
                else return 166;
            }
            else
            if (lng < -62.404854f)
                return 85;
            else
                return 109;
        else
        if (lng < -60.791134f)
            if (lng < -61.173214f)
            {
                if (poly[860].contains(lat,lng)) return 109;
                else return 187;
            }
            else
            {
                if (poly[861].contains(lat,lng)) return 185;
                else return 187;
            }
        else
            return 75;
    }

    private static int call13(float lat, float lng)
    {
        if (lat < -15.609703f)
            if (lng < 29.455710f)
                if (lat < -28.570615f)
                    if (lng < 16.475659f)
                    {
                        if (poly[862].contains(lat,lng)) return 52;
                        else return 25;
                    }
                    else
                    if (lng < 19.544312f)
                    {
                        if (poly[863].contains(lat,lng)) return 52;
                        else return 25;
                    }
                    else
                    {
                        if (poly[864].contains(lat,lng)) return 25;
                        else return 39;
                    }
                else
                if (lng < 17.410000f)
                    if (lat < -28.032820f)
                        if (lng < 17.080560f)
                        {
                            if (poly[865].contains(lat,lng)) return 25;
                            else return 52;
                        }
                        else
                        if (lat < -28.399580f)
                        {
                            if (poly[866].contains(lat,lng)) return 52;
                            else return 25;
                        }
                        else
                        {
                            if (poly[867].contains(lat,lng)) return 52;
                            else return 25;
                        }
                    else
                    {
                        if (poly[868].contains(lat,lng)) return 34;
                        else return 52;
                    }
                else
                if (lat < -22.090159f)
                    if (lng < 23.432855f)
                        if (lat < -25.330387f)
                            if (lng < 20.421428f)
                            {
                                if (poly[869].contains(lat,lng)) return 25;
                                else return 52;
                            }
                            else
                            if (lat < -26.950501f)
                                return 25;
                            else
                            if (lng < 21.927141f)
                                if (lat < -26.140444f)
                                {
                                    if (poly[870].contains(lat,lng)) return 23;
                                    else return 25;
                                }
                                else
                                {
                                    if (poly[871].contains(lat,lng)) return 25;
                                    else return 23;
                                }
                            else
                            {
                                if (poly[872].contains(lat,lng)) return 23;
                                if (poly[873].contains(lat,lng)) return 23;
                                else return 25;
                            }
                        else
                        {
                            if (poly[874].contains(lat,lng)) return 25;
                            if (poly[875].contains(lat,lng)) return 25;
                            if (poly[876].contains(lat,lng)) return 25;
                            if (poly[877].contains(lat,lng)) return 52;
                            else return 23;
                        }
                    else
                    if (lat < -25.330387f)
                    {
                        if (poly[878].contains(lat,lng)) return 23;
                        else return 25;
                    }
                    else
                    if (lng < 26.444282f)
                    {
                        if (poly[879].contains(lat,lng)) return 25;
                        if (poly[880].contains(lat,lng)) return 25;
                        else return 23;
                    }
                    else
                    if (lat < -23.710273f)
                    {
                        if (poly[881].contains(lat,lng)) return 23;
                        else return 25;
                    }
                    else
                    if (lng < 27.949996f)
                    {
                        if (poly[882].contains(lat,lng)) return 25;
                        else return 23;
                    }
                    else
                    {
                        if (poly[883].contains(lat,lng)) return 23;
                        if (poly[884].contains(lat,lng)) return 24;
                        else return 25;
                    }
                else
                if (lng < 23.432855f)
                    if (lat < -18.849931f)
                    {
                        if (poly[885].contains(lat,lng)) return 52;
                        else return 23;
                    }
                    else
                    if (lng < 20.421428f)
                    {
                        if (poly[886].contains(lat,lng)) return 52;
                        else return 34;
                    }
                    else
                    if (lat < -17.229817f)
                    {
                        if (poly[887].contains(lat,lng)) return 23;
                        if (poly[888].contains(lat,lng)) return 36;
                        if (poly[889].contains(lat,lng)) return 52;
                        else return 34;
                    }
                    else
                    {
                        if (poly[890].contains(lat,lng)) return 36;
                        else return 34;
                    }
                else
                if (lat < -18.849931f)
                    if (lng < 26.444282f)
                    {
                        if (poly[891].contains(lat,lng)) return 24;
                        else return 23;
                    }
                    else
                    {
                        if (poly[892].contains(lat,lng)) return 23;
                        else return 24;
                    }
                else
                if (lng < 26.444282f)
                    if (lat < -17.229817f)
                        if (lng < 24.938569f)
                            if (lat < -18.039874f)
                            {
                                if (poly[893].contains(lat,lng)) return 52;
                                if (poly[894].contains(lat,lng)) return 52;
                                else return 23;
                            }
                            else
                            {
                                if (poly[895].contains(lat,lng)) return 23;
                                if (poly[896].contains(lat,lng)) return 23;
                                if (poly[897].contains(lat,lng)) return 34;
                                if (poly[898].contains(lat,lng)) return 36;
                                else return 52;
                            }
                        else
                        if (lat < -18.039874f)
                        {
                            if (poly[899].contains(lat,lng)) return 24;
                            else return 23;
                        }
                        else
                        if (lng < 25.691426f)
                        {
                            if (poly[900].contains(lat,lng)) return 23;
                            if (poly[901].contains(lat,lng)) return 24;
                            if (poly[902].contains(lat,lng)) return 36;
                            else return 52;
                        }
                        else
                        {
                            if (poly[903].contains(lat,lng)) return 36;
                            else return 24;
                        }
                    else
                        return 36;
                else
                {
                    if (poly[904].contains(lat,lng)) return 36;
                    else return 24;
                }
            else
            if (lng < 33.102357f)
                if (lat < -23.805513f)
                {
                    if (poly[905].contains(lat,lng)) return 38;
                    if (poly[906].contains(lat,lng)) return 40;
                    else return 25;
                }
                else
                if (lat < -19.707608f)
                    if (lat < -21.756560f)
                    {
                        if (poly[907].contains(lat,lng)) return 24;
                        if (poly[908].contains(lat,lng)) return 38;
                        else return 25;
                    }
                    else
                    {
                        if (poly[909].contains(lat,lng)) return 38;
                        else return 24;
                    }
                else
                if (lat < -17.658655f)
                {
                    if (poly[910].contains(lat,lng)) return 38;
                    else return 24;
                }
                else
                if (lng < 31.279033f)
                {
                    if (poly[911].contains(lat,lng)) return 36;
                    if (poly[912].contains(lat,lng)) return 38;
                    else return 24;
                }
                else
                {
                    if (poly[913].contains(lat,lng)) return 24;
                    else return 38;
                }
            else
            if (lat < -21.265323f)
                return 38;
            else
            if (lng < 36.664969f)
                if (lat < -18.437513f)
                    return 38;
                else
                if (lng < 34.883663f)
                {
                    if (poly[914].contains(lat,lng)) return 10;
                    else return 38;
                }
                else
                {
                    if (poly[915].contains(lat,lng)) return 10;
                    else return 38;
                }
            else
                return 38;
        else
        if (lng < 24.087886f)
            if (lat < -11.404498f)
            {
                if (poly[916].contains(lat,lng)) return 36;
                else return 34;
            }
            else
            if (lng < 17.967785f)
                if (lat < -8.276794f)
                    return 34;
                else
                if (lng < 14.907735f)
                {
                    if (poly[917].contains(lat,lng)) return 30;
                    else return 34;
                }
                else
                if (lat < -6.712941f)
                {
                    if (poly[918].contains(lat,lng)) return 30;
                    else return 34;
                }
                else
                {
                    if (poly[919].contains(lat,lng)) return 34;
                    else return 30;
                }
            else
            if (lat < -8.276794f)
                if (lng < 21.027836f)
                    return 34;
                else
                if (lat < -9.840646f)
                    if (lng < 22.557861f)
                    {
                        if (poly[920].contains(lat,lng)) return 35;
                        else return 34;
                    }
                    else
                    {
                        if (poly[921].contains(lat,lng)) return 35;
                        if (poly[922].contains(lat,lng)) return 36;
                        else return 34;
                    }
                else
                {
                    if (poly[923].contains(lat,lng)) return 35;
                    else return 34;
                }
            else
            if (lng < 21.027836f)
                if (lat < -6.712941f)
                {
                    if (poly[924].contains(lat,lng)) return 30;
                    if (poly[925].contains(lat,lng)) return 35;
                    else return 34;
                }
                else
                {
                    if (poly[926].contains(lat,lng)) return 35;
                    else return 30;
                }
            else
            {
                if (poly[927].contains(lat,lng)) return 34;
                else return 35;
            }
        else
        if (lng < 33.701099f)
            if (lat < -13.998540f)
                if (lng < 33.239352f)
                {
                    if (poly[928].contains(lat,lng)) return 10;
                    if (poly[929].contains(lat,lng)) return 10;
                    if (poly[930].contains(lat,lng)) return 38;
                    else return 36;
                }
                else
                {
                    if (poly[931].contains(lat,lng)) return 10;
                    else return 38;
                }
            else
            if (lng < 30.792749f)
                if (lat < -8.271282f)
                    if (lng < 27.440317f)
                        if (lat < -11.134911f)
                            if (lng < 25.764102f)
                            {
                                if (poly[932].contains(lat,lng)) return 35;
                                else return 36;
                            }
                            else
                            {
                                if (poly[933].contains(lat,lng)) return 36;
                                else return 35;
                            }
                        else
                        {
                            if (poly[934].contains(lat,lng)) return 36;
                            else return 35;
                        }
                    else
                    if (lat < -11.134911f)
                        if (lng < 29.116533f)
                            if (lat < -12.566726f)
                            {
                                if (poly[935].contains(lat,lng)) return 35;
                                else return 36;
                            }
                            else
                            if (lng < 28.278425f)
                            {
                                if (poly[936].contains(lat,lng)) return 36;
                                else return 35;
                            }
                            else
                            {
                                if (poly[937].contains(lat,lng)) return 36;
                                if (poly[938].contains(lat,lng)) return 36;
                                else return 35;
                            }
                        else
                        {
                            if (poly[939].contains(lat,lng)) return 35;
                            else return 36;
                        }
                    else
                    {
                        if (poly[940].contains(lat,lng)) return 36;
                        else return 35;
                    }
                else
                {
                    if (poly[941].contains(lat,lng)) return 18;
                    else return 35;
                }
            else
            if (lat < -9.573815f)
                if (lat < -11.786177f)
                {
                    if (poly[942].contains(lat,lng)) return 36;
                    if (poly[943].contains(lat,lng)) return 36;
                    else return 10;
                }
                else
                {
                    if (poly[944].contains(lat,lng)) return 18;
                    if (poly[945].contains(lat,lng)) return 36;
                    else return 10;
                }
            else
            {
                if (poly[946].contains(lat,lng)) return 10;
                if (poly[947].contains(lat,lng)) return 36;
                else return 18;
            }
        else
        if (lat < -14.386368f)
            if (lng < 34.358479f)
            {
                if (poly[948].contains(lat,lng)) return 10;
                else return 38;
            }
            else
            if (lng < 34.622374f)
                if (lat < -15.002667f)
                {
                    if (poly[949].contains(lat,lng)) return 38;
                    else return 10;
                }
                else
                {
                    if (poly[950].contains(lat,lng)) return 10;
                    else return 38;
                }
            else
            {
                if (poly[951].contains(lat,lng)) return 38;
                else return 10;
            }
        else
        if (lat < -9.767729f)
            if (lng < 36.964340f)
                if (lat < -12.077048f)
                {
                    if (poly[952].contains(lat,lng)) return 38;
                    else return 10;
                }
                else
                if (lng < 35.332719f)
                {
                    if (poly[953].contains(lat,lng)) return 18;
                    if (poly[954].contains(lat,lng)) return 38;
                    else return 10;
                }
                else
                {
                    if (poly[955].contains(lat,lng)) return 38;
                    else return 18;
                }
            else
            {
                if (poly[956].contains(lat,lng)) return 38;
                else return 18;
            }
        else
        {
            if (poly[957].contains(lat,lng)) return 10;
            else return 18;
        }
    }

    private static int call14(float lat, float lng)
    {
        if (lat < 15.084000f)
            if (lng < -0.723987f)
                if (lat < 9.636901f)
                    if (lng < -4.045655f)
                    {
                        if (poly[958].contains(lat,lng)) return 47;
                        else return 1;
                    }
                    else
                    if (lat < 7.088077f)
                    {
                        if (poly[959].contains(lat,lng)) return 1;
                        else return 2;
                    }
                    else
                    {
                        if (poly[960].contains(lat,lng)) return 2;
                        if (poly[961].contains(lat,lng)) return 47;
                        else return 1;
                    }
                else
                if (lng < -4.045655f)
                    if (lat < 12.360451f)
                        if (lng < -5.706489f)
                            if (lat < 10.998676f)
                                if (lng < -6.536906f)
                                {
                                    if (poly[962].contains(lat,lng)) return 6;
                                    else return 1;
                                }
                                else
                                {
                                    if (poly[963].contains(lat,lng)) return 1;
                                    else return 6;
                                }
                            else
                                return 6;
                        else
                        if (lat < 10.998676f)
                            if (lng < -4.876072f)
                                if (lat < 10.317788f)
                                {
                                    if (poly[964].contains(lat,lng)) return 47;
                                    if (poly[965].contains(lat,lng)) return 47;
                                    if (poly[966].contains(lat,lng)) return 47;
                                    else return 1;
                                }
                                else
                                {
                                    if (poly[967].contains(lat,lng)) return 1;
                                    if (poly[968].contains(lat,lng)) return 1;
                                    if (poly[969].contains(lat,lng)) return 1;
                                    if (poly[970].contains(lat,lng)) return 6;
                                    else return 47;
                                }
                            else
                            {
                                if (poly[971].contains(lat,lng)) return 47;
                                else return 1;
                            }
                        else
                        {
                            if (poly[972].contains(lat,lng)) return 47;
                            else return 6;
                        }
                    else
                    {
                        if (poly[973].contains(lat,lng)) return 47;
                        else return 6;
                    }
                else
                if (lat < 12.360451f)
                    if (lng < -2.384821f)
                    {
                        if (poly[974].contains(lat,lng)) return 1;
                        if (poly[975].contains(lat,lng)) return 2;
                        else return 47;
                    }
                    else
                    {
                        if (poly[976].contains(lat,lng)) return 47;
                        else return 2;
                    }
                else
                {
                    if (poly[977].contains(lat,lng)) return 6;
                    else return 47;
                }
            else
            if (lng < 2.408972f)
                if (lat < 11.895485f)
                    if (lat < 8.466663f)
                        if (lat < 6.752252f)
                        {
                            if (poly[978].contains(lat,lng)) return 2;
                            if (poly[979].contains(lat,lng)) return 48;
                            else return 33;
                        }
                        else
                        if (lng < 0.842492f)
                        {
                            if (poly[980].contains(lat,lng)) return 33;
                            else return 2;
                        }
                        else
                        {
                            if (poly[981].contains(lat,lng)) return 48;
                            else return 33;
                        }
                    else
                    if (lat < 10.181074f)
                        if (lng < 0.842492f)
                            if (lat < 9.323868f)
                            {
                                if (poly[982].contains(lat,lng)) return 33;
                                else return 2;
                            }
                            else
                            {
                                if (poly[983].contains(lat,lng)) return 33;
                                else return 2;
                            }
                        else
                        {
                            if (poly[984].contains(lat,lng)) return 48;
                            else return 33;
                        }
                    else
                    if (lng < 0.842492f)
                        if (lat < 11.038280f)
                            if (lng < 0.059253f)
                            {
                                if (poly[985].contains(lat,lng)) return 33;
                                if (poly[986].contains(lat,lng)) return 47;
                                else return 2;
                            }
                            else
                            {
                                if (poly[987].contains(lat,lng)) return 2;
                                if (poly[988].contains(lat,lng)) return 47;
                                if (poly[989].contains(lat,lng)) return 48;
                                else return 33;
                            }
                        else
                        {
                            if (poly[990].contains(lat,lng)) return 33;
                            if (poly[991].contains(lat,lng)) return 47;
                            else return 2;
                        }
                    else
                    if (lat < 11.038280f)
                    {
                        if (poly[992].contains(lat,lng)) return 33;
                        if (poly[993].contains(lat,lng)) return 33;
                        if (poly[994].contains(lat,lng)) return 47;
                        if (poly[995].contains(lat,lng)) return 47;
                        else return 48;
                    }
                    else
                    {
                        if (poly[996].contains(lat,lng)) return 48;
                        if (poly[997].contains(lat,lng)) return 48;
                        else return 47;
                    }
                else
                if (lat < 13.489743f)
                {
                    if (poly[998].contains(lat,lng)) return 47;
                    if (poly[999].contains(lat,lng)) return 48;
                    if (poly[1000].contains(lat,lng)) return 48;
                    else return 45;
                }
                else
                {
                    if (poly[1001].contains(lat,lng)) return 6;
                    if (poly[1002].contains(lat,lng)) return 47;
                    else return 45;
                }
            else
            if (lat < 9.576548f)
                if (lat < 6.822822f)
                {
                    if (poly[1003].contains(lat,lng)) return 48;
                    else return 31;
                }
                else
                {
                    if (poly[1004].contains(lat,lng)) return 48;
                    else return 31;
                }
            else
            if (lat < 12.330274f)
                if (lng < 5.039725f)
                    if (lat < 10.953411f)
                    {
                        if (poly[1005].contains(lat,lng)) return 48;
                        else return 31;
                    }
                    else
                    if (lng < 3.724348f)
                    {
                        if (poly[1006].contains(lat,lng)) return 31;
                        if (poly[1007].contains(lat,lng)) return 45;
                        if (poly[1008].contains(lat,lng)) return 45;
                        if (poly[1009].contains(lat,lng)) return 45;
                        else return 48;
                    }
                    else
                    {
                        if (poly[1010].contains(lat,lng)) return 48;
                        else return 31;
                    }
                else
                    return 31;
            else
            {
                if (poly[1011].contains(lat,lng)) return 31;
                if (poly[1012].contains(lat,lng)) return 48;
                else return 45;
            }
        else
        if (lng < 0.151578f)
        {
            if (poly[1013].contains(lat,lng)) return 4;
            if (poly[1014].contains(lat,lng)) return 46;
            else return 6;
        }
        else
        if (lat < 21.258772f)
            if (lng < 3.911028f)
                if (lat < 18.171386f)
                {
                    if (poly[1015].contains(lat,lng)) return 45;
                    else return 6;
                }
                else
                if (lng < 2.031303f)
                {
                    if (poly[1016].contains(lat,lng)) return 4;
                    else return 6;
                }
                else
                {
                    if (poly[1017].contains(lat,lng)) return 4;
                    else return 6;
                }
            else
            {
                if (poly[1018].contains(lat,lng)) return 4;
                if (poly[1019].contains(lat,lng)) return 6;
                else return 45;
            }
        else
        {
            if (poly[1020].contains(lat,lng)) return 6;
            else return 4;
        }
    }

    private static int call15(float lat, float lng)
    {
        if (lng < 18.643611f)
            if (lat < 3.989000f)
                if (lat < -4.388063f)
                    if (lng < 14.197547f)
                        if (lng < 12.745379f)
                        {
                            if (poly[1021].contains(lat,lng)) return 11;
                            if (poly[1022].contains(lat,lng)) return 30;
                            else return 34;
                        }
                        else
                        if (lng < 13.471463f)
                        {
                            if (poly[1023].contains(lat,lng)) return 30;
                            if (poly[1024].contains(lat,lng)) return 34;
                            else return 11;
                        }
                        else
                        {
                            if (poly[1025].contains(lat,lng)) return 11;
                            else return 30;
                        }
                    else
                    {
                        if (poly[1026].contains(lat,lng)) return 11;
                        else return 30;
                    }
                else
                if (lng < 14.539444f)
                    if (lat < -0.589167f)
                        if (lat < -4.278450f)
                        {
                            if (poly[1027].contains(lat,lng)) return 30;
                            else return 11;
                        }
                        else
                        if (lng < 11.519834f)
                        {
                            if (poly[1028].contains(lat,lng)) return 11;
                            else return 32;
                        }
                        else
                        if (lat < -2.433809f)
                        {
                            if (poly[1029].contains(lat,lng)) return 32;
                            if (poly[1030].contains(lat,lng)) return 32;
                            if (poly[1031].contains(lat,lng)) return 32;
                            if (poly[1032].contains(lat,lng)) return 32;
                            else return 11;
                        }
                        else
                        if (lng < 13.029639f)
                        {
                            if (poly[1033].contains(lat,lng)) return 11;
                            if (poly[1034].contains(lat,lng)) return 11;
                            else return 32;
                        }
                        else
                        if (lat < -1.511488f)
                        {
                            if (poly[1035].contains(lat,lng)) return 32;
                            else return 11;
                        }
                        else
                        {
                            if (poly[1036].contains(lat,lng)) return 11;
                            else return 32;
                        }
                    else
                    if (lat < 2.449845f)
                        if (lng < 11.529307f)
                        {
                            if (poly[1037].contains(lat,lng)) return 20;
                            if (poly[1038].contains(lat,lng)) return 32;
                            else return 37;
                        }
                        else
                        if (lat < 0.930339f)
                        {
                            if (poly[1039].contains(lat,lng)) return 32;
                            else return 11;
                        }
                        else
                        if (lng < 13.034375f)
                        {
                            if (poly[1040].contains(lat,lng)) return 32;
                            else return 20;
                        }
                        else
                        if (lat < 1.690092f)
                        {
                            if (poly[1041].contains(lat,lng)) return 11;
                            else return 32;
                        }
                        else
                        {
                            if (poly[1042].contains(lat,lng)) return 11;
                            if (poly[1043].contains(lat,lng)) return 20;
                            else return 32;
                        }
                    else
                    {
                        if (poly[1044].contains(lat,lng)) return 20;
                        else return 37;
                    }
                else
                if (lat < -0.199531f)
                {
                    if (poly[1045].contains(lat,lng)) return 30;
                    else return 11;
                }
                else
                if (lat < 1.894734f)
                {
                    if (poly[1046].contains(lat,lng)) return 20;
                    if (poly[1047].contains(lat,lng)) return 30;
                    else return 11;
                }
                else
                if (lng < 16.591527f)
                    if (lat < 2.941867f)
                        if (lng < 15.565486f)
                        {
                            if (poly[1048].contains(lat,lng)) return 20;
                            else return 11;
                        }
                        else
                        {
                            if (poly[1049].contains(lat,lng)) return 7;
                            if (poly[1050].contains(lat,lng)) return 11;
                            if (poly[1051].contains(lat,lng)) return 11;
                            else return 20;
                        }
                    else
                    {
                        if (poly[1052].contains(lat,lng)) return 11;
                        if (poly[1053].contains(lat,lng)) return 20;
                        else return 7;
                    }
                else
                if (lat < 2.941867f)
                {
                    if (poly[1054].contains(lat,lng)) return 30;
                    else return 11;
                }
                else
                {
                    if (poly[1055].contains(lat,lng)) return 7;
                    if (poly[1056].contains(lat,lng)) return 30;
                    else return 11;
                }
            else
            if (lng < 8.831418f)
            {
                if (poly[1057].contains(lat,lng)) return 31;
                else return 20;
            }
            else
            if (lng < 15.179509f)
                if (lat < 4.056659f)
                {
                    if (poly[1058].contains(lat,lng)) return 7;
                    else return 20;
                }
                else
                {
                    if (poly[1059].contains(lat,lng)) return 7;
                    else return 20;
                }
            else
            {
                if (poly[1060].contains(lat,lng)) return 30;
                else return 7;
            }
        else
        if (lat < 0.121457f)
            if (lng < 23.048844f)
                if (lat < -2.513816f)
                {
                    if (poly[1061].contains(lat,lng)) return 35;
                    else return 30;
                }
                else
                {
                    if (poly[1062].contains(lat,lng)) return 35;
                    if (poly[1063].contains(lat,lng)) return 35;
                    if (poly[1064].contains(lat,lng)) return 35;
                    if (poly[1065].contains(lat,lng)) return 35;
                    else return 30;
                }
            else
            if (lat < -2.513816f)
                return 35;
            else
            if (lng < 25.251460f)
                if (lat < -1.196180f)
                {
                    if (poly[1066].contains(lat,lng)) return 30;
                    else return 35;
                }
                else
                {
                    if (poly[1067].contains(lat,lng)) return 35;
                    else return 30;
                }
            else
                return 35;
        else
        if (lng < 23.048844f)
            if (lat < 2.756730f)
            {
                if (poly[1068].contains(lat,lng)) return 35;
                if (poly[1069].contains(lat,lng)) return 35;
                else return 30;
            }
            else
            if (lng < 20.846227f)
            {
                if (poly[1070].contains(lat,lng)) return 7;
                if (poly[1071].contains(lat,lng)) return 7;
                else return 30;
            }
            else
            if (lat < 4.074367f)
            {
                if (poly[1072].contains(lat,lng)) return 35;
                if (poly[1073].contains(lat,lng)) return 35;
                if (poly[1074].contains(lat,lng)) return 35;
                else return 30;
            }
            else
            {
                if (poly[1075].contains(lat,lng)) return 30;
                if (poly[1076].contains(lat,lng)) return 35;
                else return 7;
            }
        else
        if (lat < 2.756730f)
        {
            if (poly[1077].contains(lat,lng)) return 30;
            if (poly[1078].contains(lat,lng)) return 30;
            else return 35;
        }
        else
        if (lng < 25.251460f)
            if (lat < 4.074367f)
            {
                if (poly[1079].contains(lat,lng)) return 30;
                if (poly[1080].contains(lat,lng)) return 30;
                else return 35;
            }
            else
            if (lng < 24.150152f)
            {
                if (poly[1081].contains(lat,lng)) return 35;
                else return 7;
            }
            else
            {
                if (poly[1082].contains(lat,lng)) return 35;
                else return 7;
            }
        else
        if (lat < 4.074367f)
            return 35;
        else
        if (lng < 26.352768f)
            if (lat < 4.733185f)
                return 35;
            else
            if (lng < 25.802114f)
            {
                if (poly[1083].contains(lat,lng)) return 35;
                else return 7;
            }
            else
            {
                if (poly[1084].contains(lat,lng)) return 35;
                if (poly[1085].contains(lat,lng)) return 35;
                else return 7;
            }
        else
        {
            if (poly[1086].contains(lat,lng)) return 26;
            if (poly[1087].contains(lat,lng)) return 35;
            else return 7;
        }
    }

    private static int call16(float lat, float lng)
    {
        if (lng < 15.996667f)
            if (lat < 20.353056f)
                if (lat < 12.872529f)
                    if (lng < 11.833573f)
                        if (lat < 9.132266f)
                            if (lng < 9.752025f)
                            {
                                if (poly[1088].contains(lat,lng)) return 20;
                                else return 31;
                            }
                            else
                            if (lat < 7.262135f)
                                if (lng < 10.792799f)
                                {
                                    if (poly[1089].contains(lat,lng)) return 31;
                                    else return 20;
                                }
                                else
                                {
                                    if (poly[1090].contains(lat,lng)) return 20;
                                    else return 31;
                                }
                            else
                                return 31;
                        else
                        {
                            if (poly[1091].contains(lat,lng)) return 45;
                            else return 31;
                        }
                    else
                    if (lat < 9.132266f)
                        if (lng < 13.915120f)
                        {
                            if (poly[1092].contains(lat,lng)) return 31;
                            else return 20;
                        }
                        else
                        if (lat < 7.262135f)
                        {
                            if (poly[1093].contains(lat,lng)) return 7;
                            else return 20;
                        }
                        else
                        {
                            if (poly[1094].contains(lat,lng)) return 7;
                            if (poly[1095].contains(lat,lng)) return 20;
                            else return 44;
                        }
                    else
                    if (lng < 13.915120f)
                    {
                        if (poly[1096].contains(lat,lng)) return 20;
                        else return 31;
                    }
                    else
                    if (lat < 11.002398f)
                    {
                        if (poly[1097].contains(lat,lng)) return 44;
                        else return 20;
                    }
                    else
                    if (lng < 14.955893f)
                        if (lat < 11.937464f)
                        {
                            if (poly[1098].contains(lat,lng)) return 31;
                            else return 20;
                        }
                        else
                        {
                            if (poly[1099].contains(lat,lng)) return 31;
                            if (poly[1100].contains(lat,lng)) return 44;
                            else return 20;
                        }
                    else
                    {
                        if (poly[1101].contains(lat,lng)) return 44;
                        else return 20;
                    }
                else
                if (lng < 11.833573f)
                {
                    if (poly[1102].contains(lat,lng)) return 45;
                    else return 31;
                }
                else
                if (lat < 16.612793f)
                    if (lng < 13.915120f)
                        if (lat < 14.742661f)
                            if (lng < 12.874346f)
                            {
                                if (poly[1103].contains(lat,lng)) return 45;
                                else return 31;
                            }
                            else
                            {
                                if (poly[1104].contains(lat,lng)) return 31;
                                if (poly[1105].contains(lat,lng)) return 44;
                                else return 45;
                            }
                        else
                        {
                            if (poly[1106].contains(lat,lng)) return 44;
                            else return 45;
                        }
                    else
                    {
                        if (poly[1107].contains(lat,lng)) return 20;
                        if (poly[1108].contains(lat,lng)) return 31;
                        if (poly[1109].contains(lat,lng)) return 45;
                        else return 44;
                    }
                else
                {
                    if (poly[1110].contains(lat,lng)) return 44;
                    else return 45;
                }
            else
            if (lng < 11.833573f)
            {
                if (poly[1111].contains(lat,lng)) return 45;
                if (poly[1112].contains(lat,lng)) return 50;
                else return 4;
            }
            else
            {
                if (poly[1113].contains(lat,lng)) return 4;
                if (poly[1114].contains(lat,lng)) return 44;
                if (poly[1115].contains(lat,lng)) return 50;
                else return 45;
            }
        else
        if (lat < 11.001389f)
            if (lng < 21.725372f)
                if (lng < 18.861019f)
                    if (lat < 8.196696f)
                        if (lng < 17.428843f)
                        {
                            if (poly[1116].contains(lat,lng)) return 44;
                            else return 7;
                        }
                        else
                        {
                            if (poly[1117].contains(lat,lng)) return 44;
                            else return 7;
                        }
                    else
                    {
                        if (poly[1118].contains(lat,lng)) return 7;
                        else return 44;
                    }
                else
                if (lat < 8.196696f)
                    return 7;
                else
                if (lng < 20.293195f)
                    if (lat < 9.599042f)
                        if (lng < 19.577107f)
                        {
                            if (poly[1119].contains(lat,lng)) return 44;
                            else return 7;
                        }
                        else
                        {
                            if (poly[1120].contains(lat,lng)) return 44;
                            else return 7;
                        }
                    else
                        return 44;
                else
                {
                    if (poly[1121].contains(lat,lng)) return 44;
                    else return 7;
                }
            else
            if (lng < 24.589724f)
                if (lat < 8.196696f)
                    return 7;
                else
                if (lng < 23.157548f)
                {
                    if (poly[1122].contains(lat,lng)) return 28;
                    if (poly[1123].contains(lat,lng)) return 44;
                    if (poly[1124].contains(lat,lng)) return 44;
                    else return 7;
                }
                else
                if (lat < 9.599042f)
                    if (lng < 23.873636f)
                    {
                        if (poly[1125].contains(lat,lng)) return 26;
                        if (poly[1126].contains(lat,lng)) return 28;
                        else return 7;
                    }
                    else
                    {
                        if (poly[1127].contains(lat,lng)) return 7;
                        if (poly[1128].contains(lat,lng)) return 26;
                        else return 28;
                    }
                else
                {
                    if (poly[1129].contains(lat,lng)) return 7;
                    if (poly[1130].contains(lat,lng)) return 28;
                    else return 26;
                }
            else
            if (lat < 8.196696f)
                if (lng < 26.021900f)
                {
                    if (poly[1131].contains(lat,lng)) return 26;
                    else return 7;
                }
                else
                {
                    if (poly[1132].contains(lat,lng)) return 7;
                    else return 26;
                }
            else
            if (lng < 26.021900f)
                if (lat < 9.599042f)
                {
                    if (poly[1133].contains(lat,lng)) return 7;
                    if (poly[1134].contains(lat,lng)) return 26;
                    else return 28;
                }
                else
                if (lng < 25.305812f)
                {
                    if (poly[1135].contains(lat,lng)) return 28;
                    else return 26;
                }
                else
                {
                    if (poly[1136].contains(lat,lng)) return 28;
                    else return 26;
                }
            else
            {
                if (poly[1137].contains(lat,lng)) return 28;
                else return 26;
            }
        else
        if (lat < 19.217466f)
            if (lng < 21.725372f)
                return 44;
            else
            if (lat < 15.109428f)
                if (lng < 24.589724f)
                    if (lat < 13.055408f)
                    {
                        if (poly[1138].contains(lat,lng)) return 28;
                        else return 44;
                    }
                    else
                    {
                        if (poly[1139].contains(lat,lng)) return 44;
                        else return 28;
                    }
                else
                    return 28;
            else
            {
                if (poly[1140].contains(lat,lng)) return 44;
                else return 28;
            }
        else
        {
            if (poly[1141].contains(lat,lng)) return 13;
            if (poly[1142].contains(lat,lng)) return 28;
            if (poly[1143].contains(lat,lng)) return 44;
            else return 50;
        }
    }

    private static int call17(float lat, float lng)
    {
        if (lat < 5.002966f)
            if (lng < 31.305676f)
                if (lat < 2.156907f)
                    if (lat < -1.496091f)
                        if (lng < 29.379876f)
                            if (lat < -3.322590f)
                            {
                                if (poly[1144].contains(lat,lng)) return 12;
                                if (poly[1145].contains(lat,lng)) return 18;
                                else return 35;
                            }
                            else
                            if (lng < 28.416976f)
                                return 35;
                            else
                            if (lat < -2.409340f)
                            {
                                if (poly[1146].contains(lat,lng)) return 29;
                                if (poly[1147].contains(lat,lng)) return 35;
                                else return 12;
                            }
                            else
                            {
                                if (poly[1148].contains(lat,lng)) return 29;
                                else return 35;
                            }
                        else
                        if (lat < -3.322590f)
                        {
                            if (poly[1149].contains(lat,lng)) return 12;
                            if (poly[1150].contains(lat,lng)) return 35;
                            if (poly[1151].contains(lat,lng)) return 35;
                            else return 18;
                        }
                        else
                        if (lng < 30.342776f)
                        {
                            if (poly[1152].contains(lat,lng)) return 12;
                            if (poly[1153].contains(lat,lng)) return 35;
                            else return 29;
                        }
                        else
                        if (lat < -2.409340f)
                        {
                            if (poly[1154].contains(lat,lng)) return 12;
                            if (poly[1155].contains(lat,lng)) return 29;
                            if (poly[1156].contains(lat,lng)) return 29;
                            else return 18;
                        }
                        else
                        {
                            if (poly[1157].contains(lat,lng)) return 12;
                            if (poly[1158].contains(lat,lng)) return 18;
                            if (poly[1159].contains(lat,lng)) return 18;
                            else return 29;
                        }
                    else
                    if (lng < 29.379876f)
                        return 35;
                    else
                    if (lat < 0.330408f)
                        if (lng < 30.342776f)
                        {
                            if (poly[1160].contains(lat,lng)) return 29;
                            if (poly[1161].contains(lat,lng)) return 35;
                            else return 27;
                        }
                        else
                        {
                            if (poly[1162].contains(lat,lng)) return 27;
                            if (poly[1163].contains(lat,lng)) return 29;
                            else return 18;
                        }
                    else
                    {
                        if (poly[1164].contains(lat,lng)) return 27;
                        else return 35;
                    }
                else
                if (lng < 29.379876f)
                {
                    if (poly[1165].contains(lat,lng)) return 35;
                    else return 26;
                }
                else
                if (lat < 3.579937f)
                {
                    if (poly[1166].contains(lat,lng)) return 26;
                    if (poly[1167].contains(lat,lng)) return 27;
                    else return 35;
                }
                else
                if (lng < 30.342776f)
                {
                    if (poly[1168].contains(lat,lng)) return 35;
                    else return 26;
                }
                else
                {
                    if (poly[1169].contains(lat,lng)) return 27;
                    if (poly[1170].contains(lat,lng)) return 35;
                    else return 26;
                }
            else
            if (lat < -0.998942f)
            {
                if (poly[1171].contains(lat,lng)) return 27;
                if (poly[1172].contains(lat,lng)) return 27;
                if (poly[1173].contains(lat,lng)) return 43;
                else return 18;
            }
            else
            if (lng < 35.766628f)
                if (lat < 2.002012f)
                {
                    if (poly[1174].contains(lat,lng)) return 43;
                    else return 27;
                }
                else
                if (lng < 33.536152f)
                {
                    if (poly[1175].contains(lat,lng)) return 27;
                    else return 26;
                }
                else
                {
                    if (poly[1176].contains(lat,lng)) return 26;
                    if (poly[1177].contains(lat,lng)) return 27;
                    else return 43;
                }
            else
            {
                if (poly[1178].contains(lat,lng)) return 3;
                if (poly[1179].contains(lat,lng)) return 26;
                else return 43;
            }
        else
        if (lat < 18.070992f)
            if (lat < 11.536979f)
                if (lng < 33.840828f)
                    if (lat < 8.269973f)
                    {
                        if (poly[1180].contains(lat,lng)) return 26;
                        else return 3;
                    }
                    else
                    if (lng < 30.647452f)
                    {
                        if (poly[1181].contains(lat,lng)) return 26;
                        else return 28;
                    }
                    else
                    {
                        if (poly[1182].contains(lat,lng)) return 3;
                        if (poly[1183].contains(lat,lng)) return 28;
                        if (poly[1184].contains(lat,lng)) return 28;
                        else return 26;
                    }
                else
                if (lat < 8.269973f)
                    if (lng < 37.034204f)
                        if (lat < 6.636469f)
                        {
                            if (poly[1185].contains(lat,lng)) return 26;
                            else return 3;
                        }
                        else
                        {
                            if (poly[1186].contains(lat,lng)) return 26;
                            else return 3;
                        }
                    else
                        return 3;
                else
                if (lng < 37.034204f)
                    if (lat < 9.903476f)
                    {
                        if (poly[1187].contains(lat,lng)) return 26;
                        if (poly[1188].contains(lat,lng)) return 28;
                        else return 3;
                    }
                    else
                    {
                        if (poly[1189].contains(lat,lng)) return 3;
                        if (poly[1190].contains(lat,lng)) return 26;
                        else return 28;
                    }
                else
                    return 3;
            else
            if (lng < 33.840828f)
            {
                if (poly[1191].contains(lat,lng)) return 26;
                else return 28;
            }
            else
            if (lat < 14.803986f)
                if (lng < 37.034204f)
                {
                    if (poly[1192].contains(lat,lng)) return 5;
                    if (poly[1193].contains(lat,lng)) return 28;
                    else return 3;
                }
                else
                if (lat < 13.170482f)
                    return 3;
                else
                if (lng < 38.630892f)
                {
                    if (poly[1194].contains(lat,lng)) return 5;
                    if (poly[1195].contains(lat,lng)) return 5;
                    else return 3;
                }
                else
                {
                    if (poly[1196].contains(lat,lng)) return 5;
                    else return 3;
                }
            else
            if (lng < 37.034204f)
            {
                if (poly[1197].contains(lat,lng)) return 5;
                else return 28;
            }
            else
            {
                if (poly[1198].contains(lat,lng)) return 3;
                if (poly[1199].contains(lat,lng)) return 28;
                else return 5;
            }
        else
        if (lng < 33.840828f)
        {
            if (poly[1200].contains(lat,lng)) return 28;
            else return 13;
        }
        else
        if (lat < 22.752268f)
        {
            if (poly[1201].contains(lat,lng)) return 13;
            if (poly[1202].contains(lat,lng)) return 272;
            else return 28;
        }
        else
        {
            if (poly[1203].contains(lat,lng)) return 272;
            else return 13;
        }
    }

    private static int call18(float lat, float lng)
    {
        if (lat < -13.692378f)
            if (lat < -28.393264f)
                if (lat < -45.999874f)
                    if (lat < -56.248000f)
                        if (lat < -61.600000f)
                            if (lat < -66.000000f)
                                if (lat < -86.000000f)
                                    return 205;
                                else
                                if (lng < -67.500000f)
                                    return 207;
                                else
                                {
                                    if (poly[1204].contains(lat,lng)) return 207;
                                    else return 70;
                                }
                            else
                            if (lat < -64.000000f)
                            {
                                if (poly[1205].contains(lat,lng)) return 206;
                                else return 70;
                            }
                            else
                            {
                                if (poly[1206].contains(lat,lng)) return 169;
                                else return 70;
                            }
                        else
                        if (lat < -58.362500f)
                            return 70;
                        else
                            return 169;
                    else
                    if (lng < -63.453630f)
                        if (lng < -69.122039f)
                            if (lat < -50.972131f)
                            {
                                if (poly[1207].contains(lat,lng)) return 65;
                                else return 169;
                            }
                            else
                            if (lng < -71.956244f)
                                if (lat < -48.486002f)
                                    if (lng < -73.373347f)
                                    {
                                        if (poly[1208].contains(lat,lng)) return 65;
                                        if (poly[1209].contains(lat,lng)) return 65;
                                        if (poly[1210].contains(lat,lng)) return 177;
                                        else return 169;
                                    }
                                    else
                                    if (lat < -49.729067f)
                                    {
                                        if (poly[1211].contains(lat,lng)) return 65;
                                        else return 169;
                                    }
                                    else
                                    {
                                        if (poly[1212].contains(lat,lng)) return 169;
                                        if (poly[1213].contains(lat,lng)) return 177;
                                        if (poly[1214].contains(lat,lng)) return 177;
                                        else return 65;
                                    }
                                else
                                {
                                    if (poly[1215].contains(lat,lng)) return 65;
                                    if (poly[1216].contains(lat,lng)) return 65;
                                    if (poly[1217].contains(lat,lng)) return 65;
                                    if (poly[1218].contains(lat,lng)) return 65;
                                    else return 177;
                                }
                            else
                            {
                                if (poly[1219].contains(lat,lng)) return 60;
                                if (poly[1220].contains(lat,lng)) return 177;
                                if (poly[1221].contains(lat,lng)) return 177;
                                if (poly[1222].contains(lat,lng)) return 177;
                                else return 65;
                            }
                        else
                        if (lat < -51.089499f)
                        {
                            if (poly[1223].contains(lat,lng)) return 65;
                            if (poly[1224].contains(lat,lng)) return 169;
                            else return 70;
                        }
                        else
                        {
                            if (poly[1225].contains(lat,lng)) return 60;
                            else return 65;
                        }
                    else
                    if (lng < -57.366237f)
                        return 304;
                    else
                        return 302;
                else
                    return call6(lat,lng);
            else
            if (lng < -58.171500f)
                return call8(lat,lng);
            else
            if (lat < -27.383750f)
                if (lng < -56.929806f)
                    if (lng < -57.411484f)
                    {
                        if (poly[1226].contains(lat,lng)) return 71;
                        else return 61;
                    }
                    else
                    {
                        if (poly[1227].contains(lat,lng)) return 71;
                        else return 61;
                    }
                else
                if (lng < -56.217655f)
                {
                    if (poly[1228].contains(lat,lng)) return 71;
                    else return 61;
                }
                else
                if (lng < -52.173129f)
                    if (lng < -54.195392f)
                        if (lng < -55.206523f)
                        {
                            if (poly[1229].contains(lat,lng)) return 71;
                            if (poly[1230].contains(lat,lng)) return 179;
                            if (poly[1231].contains(lat,lng)) return 179;
                            else return 61;
                        }
                        else
                        {
                            if (poly[1232].contains(lat,lng)) return 61;
                            else return 179;
                        }
                    else
                        return 179;
                else
                    return 179;
            else
                return call7(lat,lng);
        else
        if (lat < 13.583000f)
            return call12(lat,lng);
        else
        if (lng < -64.059729f)
            if (lng < -70.864359f)
                if (lat < 20.888781f)
                    if (lng < -72.827404f)
                    {
                        if (poly[1233].contains(lat,lng)) return 115;
                        if (poly[1234].contains(lat,lng)) return 152;
                        else return 165;
                    }
                    else
                    if (lat < 19.079476f)
                    {
                        if (poly[1235].contains(lat,lng)) return 165;
                        else return 178;
                    }
                    else
                    {
                        if (poly[1236].contains(lat,lng)) return 178;
                        else return 165;
                    }
                else
                {
                    if (poly[1237].contains(lat,lng)) return 152;
                    if (poly[1238].contains(lat,lng)) return 178;
                    else return 108;
                }
            else
            if (lng < -67.633762f)
                if (lng < -68.110146f)
                {
                    if (poly[1239].contains(lat,lng)) return 168;
                    else return 178;
                }
                else
                    return 168;
            else
            if (lat < 17.995840f)
                if (lng < -65.116124f)
                    return 168;
                else
                    return 186;
            else
            if (lng < -65.040186f)
            {
                if (poly[1240].contains(lat,lng)) return 186;
                else return 168;
            }
            else
            {
                if (poly[1241].contains(lat,lng)) return 186;
                else return 194;
            }
        else
        if (lng < -62.584402f)
            if (lat < 17.615815f)
                if (lat < 15.915843f)
                    return 85;
                else
                {
                    if (poly[1242].contains(lat,lng)) return 131;
                    else return 184;
                }
            else
            {
                if (poly[1243].contains(lat,lng)) return 131;
                if (poly[1244].contains(lat,lng)) return 135;
                if (poly[1245].contains(lat,lng)) return 139;
                if (poly[1246].contains(lat,lng)) return 182;
                else return 55;
            }
        else
        if (lat < 15.787222f)
            if (lat < 15.079510f)
                if (lat < 14.272500f)
                    if (lng < -61.003889f)
                    {
                        if (poly[1247].contains(lat,lng)) return 140;
                        else return 185;
                    }
                    else
                    {
                        if (poly[1248].contains(lat,lng)) return 140;
                        else return 185;
                    }
                else
                {
                    if (poly[1249].contains(lat,lng)) return 99;
                    else return 140;
                }
            else
            if (lng < -61.442500f)
            {
                if (poly[1250].contains(lat,lng)) return 110;
                else return 99;
            }
            else
            {
                if (poly[1251].contains(lat,lng)) return 110;
                else return 99;
            }
        else
        if (lng < -62.140067f)
        {
            if (poly[1252].contains(lat,lng)) return 56;
            if (poly[1253].contains(lat,lng)) return 184;
            else return 151;
        }
        else
        if (lat < 16.714000f)
        {
            if (poly[1254].contains(lat,lng)) return 151;
            else return 110;
        }
        else
        {
            if (poly[1255].contains(lat,lng)) return 151;
            else return 56;
        }
    }

    private static int call19(float lat, float lng)
    {
        if (lat < -5.149089f)
            if (lat < -36.862000f)
                if (lat < -58.803000f)
                    if (lat < -65.969656f)
                        if (lng < -5.500000f)
                            if (lat < -86.000000f)
                                return 205;
                            else
                            {
                                if (poly[1256].contains(lat,lng)) return 317;
                                else return 207;
                            }
                        else
                        if (lat < -86.000000f)
                            return 205;
                        else
                        if (lng < 0.000000f)
                            return 25;
                        else
                        {
                            if (poly[1257].contains(lat,lng)) return 209;
                            else return 208;
                        }
                    else
                        return 302;
                else
                if (lng < -25.846830f)
                    return 302;
                else
                if (lng < -9.611753f)
                    return 303;
                else
                    return 25;
            else
            if (lng < -5.423415f)
                if (lng < -34.599531f)
                    return 104;
                else
                    return 303;
            else
                return call13(lat,lng);
        else
        if (lng < 7.670478f)
            if (lng < -7.367323f)
                if (lat < 10.462040f)
                    if (lng < -15.238664f)
                        if (lat < 3.393091f)
                            return 16;
                        else
                            return 156;
                    else
                    if (lat < 9.999973f)
                        if (lng < -10.881472f)
                            if (lat < 8.056728f)
                            {
                                if (poly[1258].contains(lat,lng)) return 42;
                                else return 22;
                            }
                            else
                            if (lng < -12.638547f)
                            {
                                if (poly[1259].contains(lat,lng)) return 22;
                                else return 16;
                            }
                            else
                            {
                                if (poly[1260].contains(lat,lng)) return 22;
                                else return 16;
                            }
                        else
                        if (lat < 7.077782f)
                            if (lng < -9.124398f)
                                return 42;
                            else
                            if (lat < 5.616687f)
                            {
                                if (poly[1261].contains(lat,lng)) return 1;
                                else return 42;
                            }
                            else
                            if (lng < -8.245860f)
                            {
                                if (poly[1262].contains(lat,lng)) return 1;
                                else return 42;
                            }
                            else
                            {
                                if (poly[1263].contains(lat,lng)) return 42;
                                else return 1;
                            }
                        else
                        if (lng < -9.124398f)
                            if (lat < 8.538878f)
                                if (lng < -10.002935f)
                                {
                                    if (poly[1264].contains(lat,lng)) return 16;
                                    if (poly[1265].contains(lat,lng)) return 42;
                                    else return 22;
                                }
                                else
                                {
                                    if (poly[1266].contains(lat,lng)) return 42;
                                    else return 16;
                                }
                            else
                            {
                                if (poly[1267].contains(lat,lng)) return 22;
                                if (poly[1268].contains(lat,lng)) return 42;
                                else return 16;
                            }
                        else
                        if (lat < 8.538878f)
                            if (lng < -8.245860f)
                            {
                                if (poly[1269].contains(lat,lng)) return 1;
                                if (poly[1270].contains(lat,lng)) return 16;
                                else return 42;
                            }
                            else
                            {
                                if (poly[1271].contains(lat,lng)) return 16;
                                else return 1;
                            }
                        else
                        {
                            if (poly[1272].contains(lat,lng)) return 16;
                            else return 1;
                        }
                    else
                    {
                        if (poly[1273].contains(lat,lng)) return 1;
                        if (poly[1274].contains(lat,lng)) return 16;
                        else return 6;
                    }
                else
                if (lat < 17.407117f)
                    if (lng < -22.454775f)
                        return 298;
                    else
                    if (lat < 12.686238f)
                        if (lng < -12.180100f)
                            if (lng < -14.586488f)
                            {
                                if (poly[1275].contains(lat,lng)) return 16;
                                if (poly[1276].contains(lat,lng)) return 17;
                                if (poly[1277].contains(lat,lng)) return 17;
                                else return 9;
                            }
                            else
                            if (lng < -13.383294f)
                            {
                                if (poly[1278].contains(lat,lng)) return 9;
                                if (poly[1279].contains(lat,lng)) return 17;
                                else return 16;
                            }
                            else
                            {
                                if (poly[1280].contains(lat,lng)) return 17;
                                else return 16;
                            }
                        else
                        if (lng < -9.773711f)
                            if (lng < -10.976906f)
                                if (lat < 11.574139f)
                                    return 16;
                                else
                                if (lng < -11.578503f)
                                {
                                    if (poly[1281].contains(lat,lng)) return 17;
                                    else return 16;
                                }
                                else
                                {
                                    if (poly[1282].contains(lat,lng)) return 16;
                                    if (poly[1283].contains(lat,lng)) return 17;
                                    else return 6;
                                }
                            else
                            {
                                if (poly[1284].contains(lat,lng)) return 16;
                                else return 6;
                            }
                        else
                        if (lng < -8.570517f)
                        {
                            if (poly[1285].contains(lat,lng)) return 16;
                            else return 6;
                        }
                        else
                        {
                            if (poly[1286].contains(lat,lng)) return 16;
                            if (poly[1287].contains(lat,lng)) return 16;
                            else return 6;
                        }
                    else
                    if (lng < -12.576783f)
                        if (lng < -15.181512f)
                            if (lat < 15.046677f)
                            {
                                if (poly[1288].contains(lat,lng)) return 8;
                                else return 17;
                            }
                            else
                            {
                                if (poly[1289].contains(lat,lng)) return 46;
                                else return 17;
                            }
                        else
                        if (lat < 15.046677f)
                        {
                            if (poly[1290].contains(lat,lng)) return 8;
                            if (poly[1291].contains(lat,lng)) return 46;
                            else return 17;
                        }
                        else
                        if (lng < -13.879147f)
                        {
                            if (poly[1292].contains(lat,lng)) return 46;
                            else return 17;
                        }
                        else
                        {
                            if (poly[1293].contains(lat,lng)) return 46;
                            else return 17;
                        }
                    else
                    if (lng < -9.972053f)
                        if (lat < 15.046677f)
                            if (lng < -11.274418f)
                                if (lat < 13.866458f)
                                {
                                    if (poly[1294].contains(lat,lng)) return 17;
                                    else return 6;
                                }
                                else
                                if (lng < -11.925600f)
                                {
                                    if (poly[1295].contains(lat,lng)) return 6;
                                    if (poly[1296].contains(lat,lng)) return 46;
                                    else return 17;
                                }
                                else
                                {
                                    if (poly[1297].contains(lat,lng)) return 46;
                                    else return 6;
                                }
                            else
                                return 6;
                        else
                        {
                            if (poly[1298].contains(lat,lng)) return 6;
                            else return 46;
                        }
                    else
                    {
                        if (poly[1299].contains(lat,lng)) return 46;
                        else return 6;
                    }
                else
                {
                    if (poly[1300].contains(lat,lng)) return 4;
                    if (poly[1301].contains(lat,lng)) return 46;
                    else return 21;
                }
            else
            if (lat < 1.925760f)
                if (lat < -0.707757f)
                    return 37;
                else
                    return 49;
            else
                return call14(lat,lng);
        else
        if (lng < 27.454076f)
            if (lat < 5.392003f)
                return call15(lat,lng);
            else
                return call16(lat,lng);
        else
            return call17(lat,lng);
    }

    private static int call20(float lat, float lng)
    {
        if (lat < 53.363782f)
            if (lng < -61.250000f)
                if (lat < 32.591369f)
                    return 296;
                else
                if (lat < 48.481700f)
                    if (lng < -68.020224f)
                        if (lat < 43.613186f)
                            return 153;
                        else
                        if (lng < -71.405337f)
                        {
                            if (poly[1302].contains(lat,lng)) return 193;
                            else return 153;
                        }
                        else
                        if (lat < 46.047443f)
                        {
                            if (poly[1303].contains(lat,lng)) return 193;
                            if (poly[1304].contains(lat,lng)) return 193;
                            else return 153;
                        }
                        else
                        {
                            if (poly[1305].contains(lat,lng)) return 148;
                            if (poly[1306].contains(lat,lng)) return 153;
                            else return 193;
                        }
                    else
                    if (lng < -64.635112f)
                        if (lat < 45.838850f)
                            if (lng < -66.327668f)
                            {
                                if (poly[1307].contains(lat,lng)) return 114;
                                if (poly[1308].contains(lat,lng)) return 148;
                                else return 153;
                            }
                            else
                            {
                                if (poly[1309].contains(lat,lng)) return 148;
                                else return 114;
                            }
                        else
                        {
                            if (poly[1310].contains(lat,lng)) return 153;
                            if (poly[1311].contains(lat,lng)) return 193;
                            else return 148;
                        }
                    else
                    {
                        if (poly[1312].contains(lat,lng)) return 148;
                        if (poly[1313].contains(lat,lng)) return 193;
                        else return 114;
                    }
                else
                if (lng < -68.020224f)
                    return 193;
                else
                if (lng < -64.635112f)
                    if (lat < 50.922741f)
                        return 193;
                    else
                    if (lng < -66.327668f)
                        if (lat < 52.143261f)
                        {
                            if (poly[1314].contains(lat,lng)) return 107;
                            else return 193;
                        }
                        else
                        if (lng < -67.173946f)
                        {
                            if (poly[1315].contains(lat,lng)) return 107;
                            else return 193;
                        }
                        else
                        if (lat < 52.753522f)
                        {
                            if (poly[1316].contains(lat,lng)) return 193;
                            else return 107;
                        }
                        else
                        {
                            if (poly[1317].contains(lat,lng)) return 107;
                            if (poly[1318].contains(lat,lng)) return 107;
                            else return 193;
                        }
                    else
                    if (lat < 52.143261f)
                    {
                        if (poly[1319].contains(lat,lng)) return 193;
                        else return 107;
                    }
                    else
                    {
                        if (poly[1320].contains(lat,lng)) return 193;
                        if (poly[1321].contains(lat,lng)) return 193;
                        if (poly[1322].contains(lat,lng)) return 193;
                        if (poly[1323].contains(lat,lng)) return 193;
                        else return 107;
                    }
                else
                if (lat < 50.922741f)
                    return 193;
                else
                if (lng < -62.942556f)
                    if (lat < 52.143261f)
                    {
                        if (poly[1324].contains(lat,lng)) return 193;
                        else return 107;
                    }
                    else
                    {
                        if (poly[1325].contains(lat,lng)) return 193;
                        if (poly[1326].contains(lat,lng)) return 193;
                        else return 107;
                    }
                else
                {
                    if (poly[1327].contains(lat,lng)) return 193;
                    else return 107;
                }
            else
            if (lat < 44.250090f)
                return 114;
            else
            if (lat < 47.365000f)
                if (lng < -59.345249f)
                    if (lat < 46.471002f)
                    {
                        if (poly[1328].contains(lat,lng)) return 105;
                        else return 114;
                    }
                    else
                    {
                        if (poly[1329].contains(lat,lng)) return 183;
                        else return 114;
                    }
                else
                if (lng < -57.161134f)
                    return 183;
                else
                if (lng < -56.678682f)
                    if (lat < 47.171604f)
                        return 143;
                    else
                        return 183;
                else
                {
                    if (poly[1330].contains(lat,lng)) return 143;
                    else return 183;
                }
            else
            {
                if (poly[1331].contains(lat,lng)) return 78;
                if (poly[1332].contains(lat,lng)) return 107;
                if (poly[1333].contains(lat,lng)) return 114;
                else return 183;
            }
        else
        if (lat < 72.644741f)
            if (lng < -60.758360f)
                if (lat < 63.004262f)
                    if (lng < -67.774405f)
                        if (lat < 58.184022f)
                        {
                            if (poly[1334].contains(lat,lng)) return 107;
                            if (poly[1335].contains(lat,lng)) return 107;
                            else return 193;
                        }
                        else
                        if (lng < -71.282427f)
                        {
                            if (poly[1336].contains(lat,lng)) return 193;
                            else return 126;
                        }
                        else
                        if (lat < 60.594142f)
                            if (lng < -69.528416f)
                            {
                                if (poly[1337].contains(lat,lng)) return 126;
                                if (poly[1338].contains(lat,lng)) return 126;
                                else return 193;
                            }
                            else
                            {
                                if (poly[1339].contains(lat,lng)) return 126;
                                if (poly[1340].contains(lat,lng)) return 162;
                                else return 193;
                            }
                        else
                        {
                            if (poly[1341].contains(lat,lng)) return 162;
                            if (poly[1342].contains(lat,lng)) return 193;
                            else return 126;
                        }
                    else
                    if (lat < 58.184022f)
                        if (lng < -64.266382f)
                            if (lat < 55.773902f)
                                if (lng < -66.020393f)
                                    if (lat < 54.568842f)
                                        if (lng < -66.897399f)
                                            if (lat < 53.966312f)
                                            {
                                                if (poly[1343].contains(lat,lng)) return 193;
                                                else return 107;
                                            }
                                            else
                                            {
                                                if (poly[1344].contains(lat,lng)) return 193;
                                                if (poly[1345].contains(lat,lng)) return 193;
                                                if (poly[1346].contains(lat,lng)) return 193;
                                                if (poly[1347].contains(lat,lng)) return 193;
                                                else return 107;
                                            }
                                        else
                                        {
                                            if (poly[1348].contains(lat,lng)) return 193;
                                            else return 107;
                                        }
                                    else
                                    {
                                        if (poly[1349].contains(lat,lng)) return 107;
                                        if (poly[1350].contains(lat,lng)) return 107;
                                        else return 193;
                                    }
                                else
                                {
                                    if (poly[1351].contains(lat,lng)) return 193;
                                    else return 107;
                                }
                            else
                            {
                                if (poly[1352].contains(lat,lng)) return 107;
                                else return 193;
                            }
                        else
                        if (lat < 55.773902f)
                            if (lng < -62.512371f)
                                if (lat < 54.568842f)
                                    return 107;
                                else
                                if (lng < -63.389377f)
                                    if (lat < 55.171372f)
                                    {
                                        if (poly[1353].contains(lat,lng)) return 193;
                                        else return 107;
                                    }
                                    else
                                    {
                                        if (poly[1354].contains(lat,lng)) return 193;
                                        else return 107;
                                    }
                                else
                                {
                                    if (poly[1355].contains(lat,lng)) return 193;
                                    else return 107;
                                }
                            else
                                return 107;
                        else
                        if (lng < -62.512371f)
                            if (lat < 56.978962f)
                                if (lng < -63.389377f)
                                    if (lat < 56.376432f)
                                    {
                                        if (poly[1356].contains(lat,lng)) return 193;
                                        else return 107;
                                    }
                                    else
                                    {
                                        if (poly[1357].contains(lat,lng)) return 193;
                                        else return 107;
                                    }
                                else
                                    return 107;
                            else
                            {
                                if (poly[1358].contains(lat,lng)) return 193;
                                else return 107;
                            }
                        else
                            return 107;
                    else
                    if (lng < -64.742671f)
                        if (lat < 60.594142f)
                            if (lng < -66.258538f)
                            {
                                if (poly[1359].contains(lat,lng)) return 193;
                                else return 162;
                            }
                            else
                            if (lat < 59.389082f)
                            {
                                if (poly[1360].contains(lat,lng)) return 107;
                                if (poly[1361].contains(lat,lng)) return 162;
                                else return 193;
                            }
                            else
                            {
                                if (poly[1362].contains(lat,lng)) return 107;
                                if (poly[1363].contains(lat,lng)) return 107;
                                if (poly[1364].contains(lat,lng)) return 107;
                                if (poly[1365].contains(lat,lng)) return 107;
                                if (poly[1366].contains(lat,lng)) return 107;
                                if (poly[1367].contains(lat,lng)) return 162;
                                else return 193;
                            }
                        else
                            return 162;
                    else
                    if (lat < 60.594142f)
                        if (lng < -63.226804f)
                            if (lat < 59.389082f)
                                if (lng < -63.984737f)
                                {
                                    if (poly[1368].contains(lat,lng)) return 193;
                                    if (poly[1369].contains(lat,lng)) return 193;
                                    else return 107;
                                }
                                else
                                {
                                    if (poly[1370].contains(lat,lng)) return 193;
                                    if (poly[1371].contains(lat,lng)) return 193;
                                    else return 107;
                                }
                            else
                            {
                                if (poly[1372].contains(lat,lng)) return 162;
                                if (poly[1373].contains(lat,lng)) return 193;
                                if (poly[1374].contains(lat,lng)) return 193;
                                if (poly[1375].contains(lat,lng)) return 193;
                                if (poly[1376].contains(lat,lng)) return 193;
                                if (poly[1377].contains(lat,lng)) return 193;
                                if (poly[1378].contains(lat,lng)) return 193;
                                else return 107;
                            }
                        else
                            return 107;
                    else
                        return 162;
                else
                {
                    if (poly[1379].contains(lat,lng)) return 126;
                    else return 162;
                }
            else
            if (lat < 60.352065f)
                return 106;
            else
                return 107;
        else
        if (lng < -63.556823f)
        {
            if (poly[1380].contains(lat,lng)) return 106;
            if (poly[1381].contains(lat,lng)) return 126;
            if (poly[1382].contains(lat,lng)) return 162;
            else return 190;
        }
        else
        {
            if (poly[1383].contains(lat,lng)) return 162;
            if (poly[1384].contains(lat,lng)) return 190;
            else return 106;
        }
    }

    private static int call21(float lat, float lng)
    {
        if (lng < 20.356164f)
            if (lng < 12.516067f)
                if (lng < 7.718044f)
                    if (lat < 44.084297f)
                    {
                        if (poly[1385].contains(lat,lng)) return 349;
                        if (poly[1386].contains(lat,lng)) return 356;
                        else return 352;
                    }
                    else
                    {
                        if (poly[1387].contains(lat,lng)) return 356;
                        else return 352;
                    }
                else
                if (lat < 38.311983f)
                    return 356;
                else
                if (lng < 10.095160f)
                    if (lat < 41.434667f)
                    {
                        if (poly[1388].contains(lat,lng)) return 352;
                        else return 356;
                    }
                    else
                    {
                        if (poly[1389].contains(lat,lng)) return 356;
                        else return 352;
                    }
                else
                {
                    if (poly[1390].contains(lat,lng)) return 358;
                    else return 356;
                }
            else
            if (lat < 39.997858f)
                if (lng < 18.739011f)
                    return 356;
                else
                if (lat < 38.441447f)
                    return 321;
                else
                {
                    if (poly[1391].contains(lat,lng)) return 366;
                    else return 321;
                }
            else
            if (lng < 16.436115f)
                if (lat < 42.709641f)
                {
                    if (poly[1392].contains(lat,lng)) return 375;
                    else return 356;
                }
                else
                if (lng < 14.476091f)
                {
                    if (poly[1393].contains(lat,lng)) return 375;
                    else return 356;
                }
                else
                {
                    if (poly[1394].contains(lat,lng)) return 359;
                    else return 375;
                }
            else
            if (lat < 42.709641f)
                if (lng < 18.396140f)
                {
                    if (poly[1395].contains(lat,lng)) return 356;
                    if (poly[1396].contains(lat,lng)) return 359;
                    else return 375;
                }
                else
                if (lat < 41.353750f)
                {
                    if (poly[1397].contains(lat,lng)) return 356;
                    else return 366;
                }
                else
                if (lng < 19.376152f)
                {
                    if (poly[1398].contains(lat,lng)) return 359;
                    if (poly[1399].contains(lat,lng)) return 366;
                    if (poly[1400].contains(lat,lng)) return 366;
                    if (poly[1401].contains(lat,lng)) return 366;
                    if (poly[1402].contains(lat,lng)) return 366;
                    if (poly[1403].contains(lat,lng)) return 375;
                    else return 353;
                }
                else
                {
                    if (poly[1404].contains(lat,lng)) return 322;
                    if (poly[1405].contains(lat,lng)) return 353;
                    if (poly[1406].contains(lat,lng)) return 353;
                    if (poly[1407].contains(lat,lng)) return 353;
                    if (poly[1408].contains(lat,lng)) return 353;
                    else return 366;
                }
            else
            if (lng < 18.396140f)
                if (lat < 44.065533f)
                {
                    if (poly[1409].contains(lat,lng)) return 375;
                    else return 359;
                }
                else
                {
                    if (poly[1410].contains(lat,lng)) return 375;
                    else return 359;
                }
            else
            if (lat < 44.065533f)
                if (lng < 19.376152f)
                {
                    if (poly[1411].contains(lat,lng)) return 322;
                    if (poly[1412].contains(lat,lng)) return 322;
                    if (poly[1413].contains(lat,lng)) return 353;
                    else return 359;
                }
                else
                {
                    if (poly[1414].contains(lat,lng)) return 353;
                    if (poly[1415].contains(lat,lng)) return 359;
                    if (poly[1416].contains(lat,lng)) return 359;
                    if (poly[1417].contains(lat,lng)) return 359;
                    else return 322;
                }
            else
            if (lng < 19.376152f)
                if (lat < 44.743478f)
                {
                    if (poly[1418].contains(lat,lng)) return 322;
                    else return 359;
                }
                else
                if (lng < 18.886146f)
                {
                    if (poly[1419].contains(lat,lng)) return 375;
                    else return 359;
                }
                else
                {
                    if (poly[1420].contains(lat,lng)) return 359;
                    if (poly[1421].contains(lat,lng)) return 375;
                    else return 322;
                }
            else
            {
                if (poly[1422].contains(lat,lng)) return 359;
                if (poly[1423].contains(lat,lng)) return 359;
                if (poly[1424].contains(lat,lng)) return 375;
                else return 322;
            }
        else
        if (lat < 42.373536f)
            if (lng < 23.034051f)
                if (lat < 39.914726f)
                {
                    if (poly[1425].contains(lat,lng)) return 366;
                    else return 321;
                }
                else
                if (lng < 21.695107f)
                    if (lat < 41.144131f)
                        if (lng < 21.025636f)
                        {
                            if (poly[1426].contains(lat,lng)) return 321;
                            if (poly[1427].contains(lat,lng)) return 321;
                            if (poly[1428].contains(lat,lng)) return 362;
                            else return 366;
                        }
                        else
                        {
                            if (poly[1429].contains(lat,lng)) return 362;
                            if (poly[1430].contains(lat,lng)) return 366;
                            else return 321;
                        }
                    else
                    if (lng < 21.025636f)
                    {
                        if (poly[1431].contains(lat,lng)) return 322;
                        if (poly[1432].contains(lat,lng)) return 366;
                        else return 362;
                    }
                    else
                    {
                        if (poly[1433].contains(lat,lng)) return 362;
                        else return 322;
                    }
                else
                if (lat < 41.144131f)
                {
                    if (poly[1434].contains(lat,lng)) return 362;
                    if (poly[1435].contains(lat,lng)) return 362;
                    if (poly[1436].contains(lat,lng)) return 362;
                    else return 321;
                }
                else
                {
                    if (poly[1437].contains(lat,lng)) return 321;
                    if (poly[1438].contains(lat,lng)) return 321;
                    if (poly[1439].contains(lat,lng)) return 321;
                    if (poly[1440].contains(lat,lng)) return 321;
                    if (poly[1441].contains(lat,lng)) return 322;
                    if (poly[1442].contains(lat,lng)) return 322;
                    if (poly[1443].contains(lat,lng)) return 363;
                    else return 362;
                }
            else
            if (lng < 31.630816f)
                if (lng < 27.332433f)
                    if (lat < 40.067370f)
                    {
                        if (poly[1444].contains(lat,lng)) return 336;
                        else return 321;
                    }
                    else
                    if (lng < 25.183242f)
                    {
                        if (poly[1445].contains(lat,lng)) return 363;
                        else return 321;
                    }
                    else
                    if (lat < 41.220453f)
                    {
                        if (poly[1446].contains(lat,lng)) return 336;
                        else return 321;
                    }
                    else
                    if (lng < 26.257838f)
                    {
                        if (poly[1447].contains(lat,lng)) return 321;
                        else return 363;
                    }
                    else
                    {
                        if (poly[1448].contains(lat,lng)) return 321;
                        if (poly[1449].contains(lat,lng)) return 363;
                        else return 336;
                    }
                else
                {
                    if (poly[1450].contains(lat,lng)) return 363;
                    else return 336;
                }
            else
                return 336;
        else
        if (lng < 30.480486f)
            if (lng < 29.207957f)
                if (lng < 24.782060f)
                    if (lng < 22.569112f)
                        if (lat < 43.897480f)
                        {
                            if (poly[1451].contains(lat,lng)) return 363;
                            if (poly[1452].contains(lat,lng)) return 363;
                            else return 322;
                        }
                        else
                        {
                            if (poly[1453].contains(lat,lng)) return 326;
                            if (poly[1454].contains(lat,lng)) return 326;
                            if (poly[1455].contains(lat,lng)) return 363;
                            else return 322;
                        }
                    else
                    if (lat < 43.897480f)
                    {
                        if (poly[1456].contains(lat,lng)) return 322;
                        if (poly[1457].contains(lat,lng)) return 326;
                        else return 363;
                    }
                    else
                    {
                        if (poly[1458].contains(lat,lng)) return 322;
                        if (poly[1459].contains(lat,lng)) return 322;
                        if (poly[1460].contains(lat,lng)) return 363;
                        else return 326;
                    }
                else
                {
                    if (poly[1461].contains(lat,lng)) return 339;
                    if (poly[1462].contains(lat,lng)) return 363;
                    else return 326;
                }
            else
            {
                if (poly[1463].contains(lat,lng)) return 326;
                else return 339;
            }
        else
        if (lng < 36.674992f)
        {
            if (poly[1464].contains(lat,lng)) return 350;
            else return 361;
        }
        else
        {
            if (poly[1465].contains(lat,lng)) return 281;
            else return 350;
        }
    }

    private static int call22(float lat, float lng)
    {
        if (lat < 47.092146f)
            if (lng < 16.596770f)
                if (lng < 12.185960f)
                {
                    if (poly[1466].contains(lat,lng)) return 371;
                    if (poly[1467].contains(lat,lng)) return 371;
                    else return 356;
                }
                else
                if (lng < 12.240745f)
                    if (lat < 46.906838f)
                    {
                        if (poly[1468].contains(lat,lng)) return 371;
                        else return 356;
                    }
                    else
                    if (lat < 47.069168f)
                    {
                        if (poly[1469].contains(lat,lng)) return 356;
                        else return 371;
                    }
                    else
                    {
                        if (poly[1470].contains(lat,lng)) return 371;
                        else return 356;
                    }
                else
                if (lng < 14.418757f)
                    if (lng < 13.329751f)
                    {
                        if (poly[1471].contains(lat,lng)) return 371;
                        if (poly[1472].contains(lat,lng)) return 375;
                        else return 356;
                    }
                    else
                    if (lat < 46.256785f)
                    {
                        if (poly[1473].contains(lat,lng)) return 356;
                        if (poly[1474].contains(lat,lng)) return 375;
                        else return 342;
                    }
                    else
                    {
                        if (poly[1475].contains(lat,lng)) return 356;
                        if (poly[1476].contains(lat,lng)) return 371;
                        else return 342;
                    }
                else
                if (lng < 15.507764f)
                    if (lat < 46.256785f)
                    {
                        if (poly[1477].contains(lat,lng)) return 375;
                        else return 342;
                    }
                    else
                    {
                        if (poly[1478].contains(lat,lng)) return 371;
                        else return 342;
                    }
                else
                if (lat < 46.256785f)
                {
                    if (poly[1479].contains(lat,lng)) return 342;
                    else return 375;
                }
                else
                if (lng < 16.052267f)
                {
                    if (poly[1480].contains(lat,lng)) return 371;
                    if (poly[1481].contains(lat,lng)) return 375;
                    else return 342;
                }
                else
                {
                    if (poly[1482].contains(lat,lng)) return 327;
                    if (poly[1483].contains(lat,lng)) return 371;
                    if (poly[1484].contains(lat,lng)) return 375;
                    else return 342;
                }
            else
            if (lng < 20.611605f)
                if (lng < 18.604188f)
                {
                    if (poly[1485].contains(lat,lng)) return 375;
                    else return 327;
                }
                else
                if (lng < 19.607897f)
                    if (lat < 46.256785f)
                        if (lng < 19.106042f)
                        {
                            if (poly[1486].contains(lat,lng)) return 322;
                            if (poly[1487].contains(lat,lng)) return 327;
                            else return 375;
                        }
                        else
                        {
                            if (poly[1488].contains(lat,lng)) return 322;
                            else return 327;
                        }
                    else
                        return 327;
                else
                {
                    if (poly[1489].contains(lat,lng)) return 326;
                    if (poly[1490].contains(lat,lng)) return 327;
                    else return 322;
                }
            else
            if (lng < 22.619023f)
                if (lng < 21.615314f)
                {
                    if (poly[1491].contains(lat,lng)) return 322;
                    if (poly[1492].contains(lat,lng)) return 327;
                    else return 326;
                }
                else
                {
                    if (poly[1493].contains(lat,lng)) return 327;
                    else return 326;
                }
            else
                return 326;
        else
        if (lng < 18.859216f)
            if (lat < 49.517291f)
                if (lng < 14.675755f)
                    if (lng < 12.584024f)
                    {
                        if (poly[1494].contains(lat,lng)) return 371;
                        else return 323;
                    }
                    else
                    if (lat < 48.304719f)
                    {
                        if (poly[1495].contains(lat,lng)) return 323;
                        else return 371;
                    }
                    else
                    if (lng < 13.629890f)
                    {
                        if (poly[1496].contains(lat,lng)) return 354;
                        if (poly[1497].contains(lat,lng)) return 371;
                        else return 323;
                    }
                    else
                    {
                        if (poly[1498].contains(lat,lng)) return 323;
                        if (poly[1499].contains(lat,lng)) return 354;
                        else return 371;
                    }
                else
                if (lng < 16.767485f)
                    if (lat < 48.304695f)
                    {
                        if (poly[1500].contains(lat,lng)) return 327;
                        else return 371;
                    }
                    else
                    {
                        if (poly[1501].contains(lat,lng)) return 371;
                        else return 354;
                    }
                else
                if (lat < 48.304719f)
                    if (lng < 17.813351f)
                    {
                        if (poly[1502].contains(lat,lng)) return 324;
                        if (poly[1503].contains(lat,lng)) return 371;
                        else return 327;
                    }
                    else
                    {
                        if (poly[1504].contains(lat,lng)) return 327;
                        else return 324;
                    }
                else
                {
                    if (poly[1505].contains(lat,lng)) return 354;
                    if (poly[1506].contains(lat,lng)) return 371;
                    else return 324;
                }
            else
            if (lng < 14.675755f)
                if (lat < 51.621312f)
                    if (lng < 12.584024f)
                    {
                        if (poly[1507].contains(lat,lng)) return 354;
                        else return 323;
                    }
                    else
                    {
                        if (poly[1508].contains(lat,lng)) return 354;
                        else return 323;
                    }
                else
                {
                    if (poly[1509].contains(lat,lng)) return 374;
                    if (poly[1510].contains(lat,lng)) return 374;
                    else return 323;
                }
            else
            if (lat < 51.621312f)
                if (lng < 16.767485f)
                    if (lat < 50.569301f)
                    {
                        if (poly[1511].contains(lat,lng)) return 374;
                        else return 354;
                    }
                    else
                    {
                        if (poly[1512].contains(lat,lng)) return 323;
                        if (poly[1513].contains(lat,lng)) return 354;
                        else return 374;
                    }
                else
                if (lat < 50.569301f)
                    if (lng < 17.813351f)
                    {
                        if (poly[1514].contains(lat,lng)) return 374;
                        else return 354;
                    }
                    else
                    {
                        if (poly[1515].contains(lat,lng)) return 354;
                        else return 374;
                    }
                else
                    return 374;
            else
            {
                if (poly[1516].contains(lat,lng)) return 323;
                if (poly[1517].contains(lat,lng)) return 323;
                else return 374;
            }
        else
        if (lat < 49.613816f)
            if (lng < 21.742829f)
                if (lng < 20.301022f)
                    if (lat < 48.352981f)
                    {
                        if (poly[1518].contains(lat,lng)) return 324;
                        else return 327;
                    }
                    else
                    {
                        if (poly[1519].contains(lat,lng)) return 374;
                        else return 324;
                    }
                else
                if (lat < 48.352981f)
                {
                    if (poly[1520].contains(lat,lng)) return 324;
                    if (poly[1521].contains(lat,lng)) return 324;
                    if (poly[1522].contains(lat,lng)) return 326;
                    else return 327;
                }
                else
                {
                    if (poly[1523].contains(lat,lng)) return 327;
                    if (poly[1524].contains(lat,lng)) return 374;
                    else return 324;
                }
            else
            if (lng < 23.184635f)
                if (lat < 48.352981f)
                    if (lng < 22.463732f)
                    {
                        if (poly[1525].contains(lat,lng)) return 324;
                        if (poly[1526].contains(lat,lng)) return 326;
                        if (poly[1527].contains(lat,lng)) return 368;
                        else return 327;
                    }
                    else
                    {
                        if (poly[1528].contains(lat,lng)) return 326;
                        if (poly[1529].contains(lat,lng)) return 327;
                        else return 368;
                    }
                else
                if (lng < 22.463732f)
                {
                    if (poly[1530].contains(lat,lng)) return 327;
                    if (poly[1531].contains(lat,lng)) return 368;
                    if (poly[1532].contains(lat,lng)) return 374;
                    else return 324;
                }
                else
                {
                    if (poly[1533].contains(lat,lng)) return 324;
                    if (poly[1534].contains(lat,lng)) return 368;
                    if (poly[1535].contains(lat,lng)) return 374;
                    else return 339;
                }
            else
            if (lat < 48.352981f)
            {
                if (poly[1536].contains(lat,lng)) return 326;
                if (poly[1537].contains(lat,lng)) return 339;
                if (poly[1538].contains(lat,lng)) return 339;
                if (poly[1539].contains(lat,lng)) return 339;
                else return 368;
            }
            else
            {
                if (poly[1540].contains(lat,lng)) return 368;
                if (poly[1541].contains(lat,lng)) return 368;
                else return 339;
            }
        else
        if (lng < 21.742829f)
            return 374;
        else
        if (lat < 51.669574f)
            if (lng < 23.184635f)
            {
                if (poly[1542].contains(lat,lng)) return 339;
                else return 374;
            }
            else
            if (lat < 50.641695f)
            {
                if (poly[1543].contains(lat,lng)) return 374;
                else return 339;
            }
            else
            {
                if (poly[1544].contains(lat,lng)) return 348;
                if (poly[1545].contains(lat,lng)) return 374;
                else return 339;
            }
        else
        {
            if (poly[1546].contains(lat,lng)) return 339;
            if (poly[1547].contains(lat,lng)) return 374;
            else return 348;
        }
    }

    private static int call23(float lat, float lng)
    {
        if (lng < 30.163676f)
            if (lat < 48.491870f)
                if (lng < 27.395058f)
                    if (lat < 46.956647f)
                        return 326;
                    else
                    if (lng < 26.010750f)
                    {
                        if (poly[1548].contains(lat,lng)) return 326;
                        else return 339;
                    }
                    else
                    if (lat < 47.724259f)
                    {
                        if (poly[1549].contains(lat,lng)) return 329;
                        else return 326;
                    }
                    else
                    if (lng < 26.702904f)
                    {
                        if (poly[1550].contains(lat,lng)) return 329;
                        if (poly[1551].contains(lat,lng)) return 339;
                        else return 326;
                    }
                    else
                    if (lat < 48.108064f)
                    {
                        if (poly[1552].contains(lat,lng)) return 329;
                        else return 326;
                    }
                    else
                    {
                        if (poly[1553].contains(lat,lng)) return 326;
                        if (poly[1554].contains(lat,lng)) return 339;
                        else return 329;
                    }
                else
                if (lat < 46.956647f)
                    if (lng < 28.779367f)
                        if (lat < 46.189036f)
                        {
                            if (poly[1555].contains(lat,lng)) return 326;
                            if (poly[1556].contains(lat,lng)) return 339;
                            if (poly[1557].contains(lat,lng)) return 339;
                            else return 329;
                        }
                        else
                        {
                            if (poly[1558].contains(lat,lng)) return 329;
                            else return 326;
                        }
                    else
                    if (lat < 46.189036f)
                    {
                        if (poly[1559].contains(lat,lng)) return 326;
                        if (poly[1560].contains(lat,lng)) return 329;
                        if (poly[1561].contains(lat,lng)) return 329;
                        else return 339;
                    }
                    else
                    if (lng < 29.471522f)
                    {
                        if (poly[1562].contains(lat,lng)) return 339;
                        else return 329;
                    }
                    else
                    {
                        if (poly[1563].contains(lat,lng)) return 329;
                        else return 339;
                    }
                else
                if (lng < 28.779367f)
                    if (lat < 47.724259f)
                    {
                        if (poly[1564].contains(lat,lng)) return 326;
                        else return 329;
                    }
                    else
                    {
                        if (poly[1565].contains(lat,lng)) return 339;
                        else return 329;
                    }
                else
                {
                    if (poly[1566].contains(lat,lng)) return 329;
                    else return 339;
                }
            else
            if (lng < 27.395058f)
            {
                if (poly[1567].contains(lat,lng)) return 339;
                else return 348;
            }
            else
            if (lat < 51.108601f)
                return 339;
            else
            if (lng < 28.779367f)
            {
                if (poly[1568].contains(lat,lng)) return 348;
                else return 339;
            }
            else
            {
                if (poly[1569].contains(lat,lng)) return 348;
                if (poly[1570].contains(lat,lng)) return 348;
                else return 339;
            }
        else
        if (lat < 48.144930f)
            if (lng < 30.351124f)
                return 339;
            else
            if (lng < 35.289352f)
                if (lng < 32.820238f)
                {
                    if (poly[1571].contains(lat,lng)) return 361;
                    else return 339;
                }
                else
                if (lat < 46.783177f)
                {
                    if (poly[1572].contains(lat,lng)) return 361;
                    if (poly[1573].contains(lat,lng)) return 376;
                    else return 339;
                }
                else
                {
                    if (poly[1574].contains(lat,lng)) return 376;
                    else return 339;
                }
            else
            if (lng < 37.758466f)
                if (lat < 46.783177f)
                {
                    if (poly[1575].contains(lat,lng)) return 339;
                    if (poly[1576].contains(lat,lng)) return 339;
                    if (poly[1577].contains(lat,lng)) return 361;
                    if (poly[1578].contains(lat,lng)) return 376;
                    else return 350;
                }
                else
                if (lng < 36.523909f)
                {
                    if (poly[1579].contains(lat,lng)) return 376;
                    else return 339;
                }
                else
                {
                    if (poly[1580].contains(lat,lng)) return 350;
                    if (poly[1581].contains(lat,lng)) return 376;
                    else return 339;
                }
            else
            {
                if (poly[1582].contains(lat,lng)) return 339;
                else return 350;
            }
        else
        if (lng < 35.195628f)
            if (lat < 50.935131f)
                return 339;
            else
            if (lng < 32.679652f)
                if (lat < 52.330231f)
                    if (lng < 31.421664f)
                    {
                        if (poly[1583].contains(lat,lng)) return 339;
                        else return 348;
                    }
                    else
                    {
                        if (poly[1584].contains(lat,lng)) return 339;
                        if (poly[1585].contains(lat,lng)) return 348;
                        else return 350;
                    }
                else
                if (lng < 31.421664f)
                {
                    if (poly[1586].contains(lat,lng)) return 350;
                    else return 348;
                }
                else
                if (lat < 53.027782f)
                {
                    if (poly[1587].contains(lat,lng)) return 339;
                    if (poly[1588].contains(lat,lng)) return 348;
                    else return 350;
                }
                else
                {
                    if (poly[1589].contains(lat,lng)) return 350;
                    if (poly[1590].contains(lat,lng)) return 350;
                    if (poly[1591].contains(lat,lng)) return 350;
                    if (poly[1592].contains(lat,lng)) return 350;
                    else return 348;
                }
            else
            if (lat < 52.330231f)
                if (lng < 33.937640f)
                {
                    if (poly[1593].contains(lat,lng)) return 339;
                    else return 350;
                }
                else
                if (lat < 51.632681f)
                {
                    if (poly[1594].contains(lat,lng)) return 350;
                    else return 339;
                }
                else
                {
                    if (poly[1595].contains(lat,lng)) return 350;
                    else return 339;
                }
            else
            {
                if (poly[1596].contains(lat,lng)) return 339;
                if (poly[1597].contains(lat,lng)) return 339;
                if (poly[1598].contains(lat,lng)) return 348;
                if (poly[1599].contains(lat,lng)) return 348;
                else return 350;
            }
        else
        if (lat < 50.935131f)
            if (lng < 37.711604f)
            {
                if (poly[1600].contains(lat,lng)) return 350;
                else return 339;
            }
            else
            if (lat < 49.540031f)
            {
                if (poly[1601].contains(lat,lng)) return 350;
                else return 339;
            }
            else
            {
                if (poly[1602].contains(lat,lng)) return 339;
                else return 350;
            }
        else
        {
            if (poly[1603].contains(lat,lng)) return 339;
            else return 350;
        }
    }

    private static int call24(float lat, float lng)
    {
        if (lat < 71.384879f)
            if (lng < 15.553064f)
                if (lat < 54.399122f)
                    if (lng < 7.549946f)
                        return 323;
                    else
                    {
                        if (poly[1604].contains(lat,lng)) return 374;
                        else return 323;
                    }
                else
                if (lat < 55.099161f)
                    if (lng < 14.078231f)
                        if (lng < 11.529757f)
                        {
                            if (poly[1605].contains(lat,lng)) return 323;
                            else return 330;
                        }
                        else
                        {
                            if (poly[1606].contains(lat,lng)) return 330;
                            else return 323;
                        }
                    else
                        return 330;
                else
                if (lat < 62.278222f)
                    if (lng < 10.246714f)
                    {
                        if (poly[1607].contains(lat,lng)) return 351;
                        else return 330;
                    }
                    else
                    if (lat < 58.688691f)
                    {
                        if (poly[1608].contains(lat,lng)) return 364;
                        else return 330;
                    }
                    else
                    {
                        if (poly[1609].contains(lat,lng)) return 351;
                        else return 364;
                    }
                else
                {
                    if (poly[1610].contains(lat,lng)) return 364;
                    else return 351;
                }
            else
            if (lat < 56.450421f)
                if (lng < 26.835520f)
                    if (lng < 16.993665f)
                        if (lat < 55.307816f)
                            return 364;
                        else
                            return 374;
                    else
                    if (lng < 21.914593f)
                    {
                        if (poly[1611].contains(lat,lng)) return 355;
                        if (poly[1612].contains(lat,lng)) return 372;
                        if (poly[1613].contains(lat,lng)) return 374;
                        else return 338;
                    }
                    else
                    if (lng < 24.375056f)
                        if (lat < 55.087877f)
                            if (lng < 23.144825f)
                            {
                                if (poly[1614].contains(lat,lng)) return 338;
                                if (poly[1615].contains(lat,lng)) return 374;
                                else return 372;
                            }
                            else
                            {
                                if (poly[1616].contains(lat,lng)) return 348;
                                if (poly[1617].contains(lat,lng)) return 374;
                                else return 372;
                            }
                        else
                        {
                            if (poly[1618].contains(lat,lng)) return 372;
                            else return 355;
                        }
                    else
                    if (lat < 55.087877f)
                    {
                        if (poly[1619].contains(lat,lng)) return 372;
                        else return 348;
                    }
                    else
                    if (lng < 25.605288f)
                    {
                        if (poly[1620].contains(lat,lng)) return 372;
                        else return 355;
                    }
                    else
                    {
                        if (poly[1621].contains(lat,lng)) return 348;
                        if (poly[1622].contains(lat,lng)) return 355;
                        else return 372;
                    }
                else
                if (lng < 32.363125f)
                    if (lng < 29.599322f)
                    {
                        if (poly[1623].contains(lat,lng)) return 350;
                        if (poly[1624].contains(lat,lng)) return 355;
                        else return 348;
                    }
                    else
                    if (lng < 30.981224f)
                    {
                        if (poly[1625].contains(lat,lng)) return 350;
                        if (poly[1626].contains(lat,lng)) return 350;
                        else return 348;
                    }
                    else
                    {
                        if (poly[1627].contains(lat,lng)) return 348;
                        if (poly[1628].contains(lat,lng)) return 348;
                        else return 350;
                    }
                else
                {
                    if (poly[1629].contains(lat,lng)) return 348;
                    else return 350;
                }
            else
            if (lat < 58.599619f)
                if (lng < 19.734297f)
                    return 364;
                else
                if (lng < 30.456424f)
                    if (lng < 25.570846f)
                    {
                        if (poly[1630].contains(lat,lng)) return 365;
                        else return 355;
                    }
                    else
                    if (lng < 28.013635f)
                        if (lng < 26.792240f)
                        {
                            if (poly[1631].contains(lat,lng)) return 355;
                            else return 365;
                        }
                        else
                        if (lat < 57.525020f)
                        {
                            if (poly[1632].contains(lat,lng)) return 355;
                            if (poly[1633].contains(lat,lng)) return 365;
                            else return 350;
                        }
                        else
                        {
                            if (poly[1634].contains(lat,lng)) return 350;
                            if (poly[1635].contains(lat,lng)) return 355;
                            if (poly[1636].contains(lat,lng)) return 355;
                            else return 365;
                        }
                    else
                    {
                        if (poly[1637].contains(lat,lng)) return 355;
                        else return 350;
                    }
                else
                    return 350;
            else
            if (lng < 27.890322f)
                if (lat < 64.992249f)
                    if (lng < 21.721693f)
                    {
                        if (poly[1638].contains(lat,lng)) return 334;
                        if (poly[1639].contains(lat,lng)) return 347;
                        if (poly[1640].contains(lat,lng)) return 365;
                        else return 364;
                    }
                    else
                    {
                        if (poly[1641].contains(lat,lng)) return 350;
                        if (poly[1642].contains(lat,lng)) return 350;
                        if (poly[1643].contains(lat,lng)) return 364;
                        if (poly[1644].contains(lat,lng)) return 365;
                        else return 334;
                    }
                else
                if (lng < 21.721693f)
                    if (lng < 18.637379f)
                    {
                        if (poly[1645].contains(lat,lng)) return 364;
                        else return 351;
                    }
                    else
                    {
                        if (poly[1646].contains(lat,lng)) return 334;
                        if (poly[1647].contains(lat,lng)) return 351;
                        else return 364;
                    }
                else
                if (lat < 68.188564f)
                {
                    if (poly[1648].contains(lat,lng)) return 334;
                    else return 364;
                }
                else
                if (lng < 24.806007f)
                {
                    if (poly[1649].contains(lat,lng)) return 351;
                    if (poly[1650].contains(lat,lng)) return 364;
                    else return 334;
                }
                else
                {
                    if (poly[1651].contains(lat,lng)) return 334;
                    else return 351;
                }
            else
            if (lat < 64.959848f)
                if (lng < 34.058951f)
                    if (lat < 61.779734f)
                    {
                        if (poly[1652].contains(lat,lng)) return 334;
                        if (poly[1653].contains(lat,lng)) return 365;
                        else return 350;
                    }
                    else
                    {
                        if (poly[1654].contains(lat,lng)) return 350;
                        else return 334;
                    }
                else
                    return 350;
            else
            if (lng < 34.058951f)
                if (lat < 68.139963f)
                {
                    if (poly[1655].contains(lat,lng)) return 350;
                    else return 334;
                }
                else
                if (lng < 30.974637f)
                {
                    if (poly[1656].contains(lat,lng)) return 334;
                    if (poly[1657].contains(lat,lng)) return 350;
                    else return 351;
                }
                else
                {
                    if (poly[1658].contains(lat,lng)) return 351;
                    else return 350;
                }
            else
                return 350;
        else
            return 211;
    }

    private static int call25(float lat, float lng)
    {
        if (lng < -15.623845f)
            if (lng < -52.323198f)
                return call20(lat,lng);
            else
            if (lat < 38.109494f)
                if (lat < 29.059666f)
                    return 297;
                else
                if (lng < -24.531025f)
                    return 295;
                else
                    return 300;
            else
            if (lat < 39.926735f)
                return 295;
            else
            if (lat < 67.353000f)
                if (lng < -32.286453f)
                    return 106;
                else
                    return 301;
            else
            if (lat < 72.400000f)
            {
                if (poly[1659].contains(lat,lng)) return 180;
                else return 106;
            }
            else
            {
                if (poly[1660].contains(lat,lng)) return 94;
                else return 106;
            }
        else
        if (lat < 43.993309f)
            if (lat < 36.155038f)
                if (lat < 35.320152f)
                    if (lng < -15.127390f)
                        return 297;
                    else
                    if (lng < -4.897429f)
                        if (lng < -9.816326f)
                        {
                            if (poly[1661].contains(lat,lng)) return 21;
                            if (poly[1662].contains(lat,lng)) return 297;
                            else return 14;
                        }
                        else
                        {
                            if (poly[1663].contains(lat,lng)) return 4;
                            if (poly[1664].contains(lat,lng)) return 21;
                            else return 14;
                        }
                    else
                    if (lng < 0.021467f)
                        if (lat < 31.376848f)
                        {
                            if (poly[1665].contains(lat,lng)) return 14;
                            else return 4;
                        }
                        else
                        if (lng < -2.437981f)
                        {
                            if (poly[1666].contains(lat,lng)) return 4;
                            if (poly[1667].contains(lat,lng)) return 15;
                            else return 14;
                        }
                        else
                        {
                            if (poly[1668].contains(lat,lng)) return 14;
                            else return 4;
                        }
                    else
                        return 4;
                else
                if (lng < -5.048803f)
                    if (lat < 35.917950f)
                    {
                        if (poly[1669].contains(lat,lng)) return 14;
                        else return 15;
                    }
                    else
                    if (lat < 36.050527f)
                    {
                        if (poly[1670].contains(lat,lng)) return 345;
                        else return 14;
                    }
                    else
                    {
                        if (poly[1671].contains(lat,lng)) return 345;
                        else return 332;
                    }
                else
                if (lng < -2.811975f)
                {
                    if (poly[1672].contains(lat,lng)) return 14;
                    else return 345;
                }
                else
                {
                    if (poly[1673].contains(lat,lng)) return 14;
                    else return 4;
                }
            else
            if (lat < 42.154311f)
                if (lng < -6.189159f)
                    if (lat < 41.574832f)
                        if (lat < 38.864935f)
                        {
                            if (poly[1674].contains(lat,lng)) return 345;
                            else return 341;
                        }
                        else
                        if (lng < -8.003728f)
                            return 341;
                        else
                        if (lat < 40.219884f)
                        {
                            if (poly[1675].contains(lat,lng)) return 345;
                            else return 341;
                        }
                        else
                        {
                            if (poly[1676].contains(lat,lng)) return 345;
                            else return 341;
                        }
                    else
                    if (lng < -7.685539f)
                    {
                        if (poly[1677].contains(lat,lng)) return 345;
                        if (poly[1678].contains(lat,lng)) return 345;
                        else return 341;
                    }
                    else
                    {
                        if (poly[1679].contains(lat,lng)) return 341;
                        else return 345;
                    }
                else
                if (lat < 37.126460f)
                    if (lng < -0.881233f)
                        return 4;
                    else
                        return 345;
                else
                    return 345;
            else
            if (lng < -2.317545f)
                return 345;
            else
            if (lng < 1.311409f)
                if (lng < -0.503068f)
                {
                    if (poly[1680].contains(lat,lng)) return 352;
                    else return 345;
                }
                else
                {
                    if (poly[1681].contains(lat,lng)) return 352;
                    else return 345;
                }
            else
            if (lng < 3.125887f)
                if (lat < 43.073810f)
                    if (lng < 2.218648f)
                    {
                        if (poly[1682].contains(lat,lng)) return 319;
                        if (poly[1683].contains(lat,lng)) return 352;
                        else return 345;
                    }
                    else
                    {
                        if (poly[1684].contains(lat,lng)) return 352;
                        else return 345;
                    }
                else
                    return 352;
            else
            {
                if (poly[1685].contains(lat,lng)) return 345;
                else return 352;
            }
        else
        if (lat < 55.636000f)
            if (lng < 2.091912f)
                if (lng < -5.658236f)
                    if (lat < 50.399839f)
                        return 343;
                    else
                    if (lat < 51.934425f)
                        if (lng < -6.501750f)
                            return 331;
                        else
                            return 343;
                    else
                    if (lng < -8.335807f)
                        return 331;
                    else
                    if (lat < 53.785212f)
                        return 331;
                    else
                    if (lng < -6.997022f)
                        if (lat < 54.710606f)
                        {
                            if (poly[1686].contains(lat,lng)) return 343;
                            else return 331;
                        }
                        else
                        {
                            if (poly[1687].contains(lat,lng)) return 343;
                            if (poly[1688].contains(lat,lng)) return 343;
                            else return 331;
                        }
                    else
                    {
                        if (poly[1689].contains(lat,lng)) return 343;
                        else return 331;
                    }
                else
                if (lat < 51.227462f)
                    if (lng < -1.783162f)
                        if (lat < 48.663863f)
                            return 352;
                        else
                        {
                            if (poly[1690].contains(lat,lng)) return 333;
                            if (poly[1691].contains(lat,lng)) return 337;
                            if (poly[1692].contains(lat,lng)) return 352;
                            else return 343;
                        }
                    else
                    {
                        if (poly[1693].contains(lat,lng)) return 343;
                        else return 352;
                    }
                else
                {
                    if (poly[1694].contains(lat,lng)) return 335;
                    else return 343;
                }
            else
            if (lat < 48.742113f)
                return 352;
            else
            if (lat < 51.116515f)
                if (lng < 3.516138f)
                {
                    if (poly[1695].contains(lat,lng)) return 325;
                    if (poly[1696].contains(lat,lng)) return 325;
                    else return 352;
                }
                else
                {
                    if (poly[1697].contains(lat,lng)) return 352;
                    if (poly[1698].contains(lat,lng)) return 352;
                    else return 325;
                }
            else
            {
                if (poly[1699].contains(lat,lng)) return 325;
                if (poly[1700].contains(lat,lng)) return 325;
                if (poly[1701].contains(lat,lng)) return 352;
                else return 318;
            }
        else
        if (lng < -10.028876f)
            if (lat < 66.697330f)
                if (lat < 60.822138f)
                    return 301;
                else
                    return 343;
            else
                return 106;
        else
        if (lng < -5.419671f)
            if (lat < 59.335000f)
                return 343;
            else
            if (lat < 66.536849f)
                return 211;
            else
                return 299;
        else
        if (lng < -0.320965f)
            return 343;
        else
            return 351;
    }

    private static int call26(float lat, float lng)
    {
        if (lat < 45.421424f)
            if (lat < 37.761205f)
                if (lng < 28.374229f)
                    if (lng < 15.587107f)
                        if (lng < 11.880113f)
                            if (lat < 32.597374f)
                            {
                                if (poly[1702].contains(lat,lng)) return 4;
                                if (poly[1703].contains(lat,lng)) return 51;
                                else return 50;
                            }
                            else
                            if (lng < 8.410239f)
                                if (lat < 34.946790f)
                                {
                                    if (poly[1704].contains(lat,lng)) return 51;
                                    else return 4;
                                }
                                else
                                {
                                    if (poly[1705].contains(lat,lng)) return 51;
                                    if (poly[1706].contains(lat,lng)) return 51;
                                    else return 4;
                                }
                            else
                            {
                                if (poly[1707].contains(lat,lng)) return 4;
                                if (poly[1708].contains(lat,lng)) return 4;
                                if (poly[1709].contains(lat,lng)) return 50;
                                if (poly[1710].contains(lat,lng)) return 356;
                                else return 51;
                            }
                        else
                        if (lat < 36.285271f)
                            if (lat < 33.282408f)
                                return 50;
                            else
                            if (lng < 13.530323f)
                                return 346;
                            else
                                return 356;
                        else
                            return 356;
                    else
                    if (lat < 33.140906f)
                    {
                        if (poly[1711].contains(lat,lng)) return 13;
                        else return 50;
                    }
                    else
                    if (lng < 16.206959f)
                        return 356;
                    else
                    if (lng < 24.256735f)
                        return 321;
                    else
                    {
                        if (poly[1712].contains(lat,lng)) return 336;
                        else return 321;
                    }
                else
                if (lat < 34.105119f)
                    if (lng < 34.567324f)
                        if (lat < 28.327764f)
                        {
                            if (poly[1713].contains(lat,lng)) return 272;
                            else return 13;
                        }
                        else
                        {
                            if (poly[1714].contains(lat,lng)) return 237;
                            if (poly[1715].contains(lat,lng)) return 245;
                            else return 13;
                        }
                    else
                    if (lat < 30.769331f)
                        if (lng < 37.397452f)
                        {
                            if (poly[1716].contains(lat,lng)) return 13;
                            if (poly[1717].contains(lat,lng)) return 245;
                            if (poly[1718].contains(lat,lng)) return 272;
                            else return 214;
                        }
                        else
                        {
                            if (poly[1719].contains(lat,lng)) return 214;
                            else return 272;
                        }
                    else
                    if (lng < 37.397452f)
                        if (lat < 32.437225f)
                            if (lng < 35.982388f)
                            {
                                if (poly[1720].contains(lat,lng)) return 214;
                                if (poly[1721].contains(lat,lng)) return 245;
                                else return 238;
                            }
                            else
                            {
                                if (poly[1722].contains(lat,lng)) return 231;
                                if (poly[1723].contains(lat,lng)) return 231;
                                if (poly[1724].contains(lat,lng)) return 272;
                                else return 214;
                            }
                        else
                        if (lng < 36.015275f)
                            if (lat < 33.271172f)
                            {
                                if (poly[1725].contains(lat,lng)) return 214;
                                if (poly[1726].contains(lat,lng)) return 225;
                                if (poly[1727].contains(lat,lng)) return 225;
                                if (poly[1728].contains(lat,lng)) return 231;
                                if (poly[1729].contains(lat,lng)) return 238;
                                else return 245;
                            }
                            else
                            {
                                if (poly[1730].contains(lat,lng)) return 231;
                                if (poly[1731].contains(lat,lng)) return 231;
                                if (poly[1732].contains(lat,lng)) return 245;
                                if (poly[1733].contains(lat,lng)) return 245;
                                else return 225;
                            }
                        else
                        {
                            if (poly[1734].contains(lat,lng)) return 214;
                            if (poly[1735].contains(lat,lng)) return 214;
                            if (poly[1736].contains(lat,lng)) return 214;
                            if (poly[1737].contains(lat,lng)) return 225;
                            if (poly[1738].contains(lat,lng)) return 225;
                            else return 231;
                        }
                    else
                    {
                        if (poly[1739].contains(lat,lng)) return 220;
                        if (poly[1740].contains(lat,lng)) return 231;
                        if (poly[1741].contains(lat,lng)) return 272;
                        else return 214;
                    }
                else
                if (lng < 34.855318f)
                    if (lng < 29.729699f)
                    {
                        if (poly[1742].contains(lat,lng)) return 321;
                        else return 336;
                    }
                    else
                    if (lat < 35.384917f)
                    {
                        if (poly[1743].contains(lat,lng)) return 236;
                        else return 261;
                    }
                    else
                    {
                        if (poly[1744].contains(lat,lng)) return 236;
                        else return 336;
                    }
                else
                if (lat < 34.692354f)
                {
                    if (poly[1745].contains(lat,lng)) return 231;
                    else return 225;
                }
                else
                if (lng < 37.541449f)
                    if (lat < 36.226779f)
                    {
                        if (poly[1746].contains(lat,lng)) return 336;
                        if (poly[1747].contains(lat,lng)) return 336;
                        else return 231;
                    }
                    else
                    {
                        if (poly[1748].contains(lat,lng)) return 231;
                        if (poly[1749].contains(lat,lng)) return 231;
                        else return 336;
                    }
                else
                {
                    if (poly[1750].contains(lat,lng)) return 336;
                    else return 231;
                }
            else
                return call21(lat,lng);
        else
        if (lat < 53.725332f)
            if (lng < 10.492294f)
                if (lat < 47.808465f)
                    if (lng < 8.979315f)
                        if (lat < 46.463702f)
                            if (lng < 6.959839f)
                            {
                                if (poly[1751].contains(lat,lng)) return 356;
                                if (poly[1752].contains(lat,lng)) return 377;
                                else return 352;
                            }
                            else
                            if (lng < 7.969577f)
                            {
                                if (poly[1753].contains(lat,lng)) return 352;
                                if (poly[1754].contains(lat,lng)) return 352;
                                if (poly[1755].contains(lat,lng)) return 377;
                                else return 356;
                            }
                            else
                            {
                                if (poly[1756].contains(lat,lng)) return 377;
                                if (poly[1757].contains(lat,lng)) return 377;
                                else return 356;
                            }
                        else
                        if (lng < 6.959839f)
                        {
                            if (poly[1758].contains(lat,lng)) return 377;
                            if (poly[1759].contains(lat,lng)) return 377;
                            else return 352;
                        }
                        else
                        if (lng < 7.969577f)
                        {
                            if (poly[1760].contains(lat,lng)) return 323;
                            if (poly[1761].contains(lat,lng)) return 352;
                            if (poly[1762].contains(lat,lng)) return 352;
                            else return 377;
                        }
                        else
                        {
                            if (poly[1763].contains(lat,lng)) return 328;
                            if (poly[1764].contains(lat,lng)) return 377;
                            else return 323;
                        }
                    else
                    if (lat < 46.859075f)
                        if (lng < 9.735805f)
                        {
                            if (poly[1765].contains(lat,lng)) return 356;
                            else return 377;
                        }
                        else
                        {
                            if (poly[1766].contains(lat,lng)) return 356;
                            if (poly[1767].contains(lat,lng)) return 356;
                            if (poly[1768].contains(lat,lng)) return 371;
                            if (poly[1769].contains(lat,lng)) return 371;
                            else return 377;
                        }
                    else
                    if (lng < 10.079184f)
                        if (lng < 9.529250f)
                        {
                            if (poly[1770].contains(lat,lng)) return 323;
                            if (poly[1771].contains(lat,lng)) return 369;
                            else return 377;
                        }
                        else
                        {
                            if (poly[1772].contains(lat,lng)) return 323;
                            if (poly[1773].contains(lat,lng)) return 323;
                            if (poly[1774].contains(lat,lng)) return 369;
                            if (poly[1775].contains(lat,lng)) return 377;
                            if (poly[1776].contains(lat,lng)) return 377;
                            else return 371;
                        }
                    else
                    if (lat < 46.997125f)
                        if (lng < 10.376011f)
                        {
                            if (poly[1777].contains(lat,lng)) return 377;
                            else return 371;
                        }
                        else
                        {
                            if (poly[1778].contains(lat,lng)) return 377;
                            else return 371;
                        }
                    else
                    {
                        if (poly[1779].contains(lat,lng)) return 323;
                        else return 371;
                    }
                else
                if (lat < 50.590613f)
                    if (lng < 7.716329f)
                        if (lat < 49.199539f)
                        {
                            if (poly[1780].contains(lat,lng)) return 352;
                            else return 323;
                        }
                        else
                        if (lng < 6.328347f)
                            if (lat < 49.895076f)
                                if (lng < 5.634355f)
                                {
                                    if (poly[1781].contains(lat,lng)) return 352;
                                    else return 325;
                                }
                                else
                                {
                                    if (poly[1782].contains(lat,lng)) return 323;
                                    if (poly[1783].contains(lat,lng)) return 325;
                                    if (poly[1784].contains(lat,lng)) return 352;
                                    else return 344;
                                }
                            else
                            {
                                if (poly[1785].contains(lat,lng)) return 323;
                                if (poly[1786].contains(lat,lng)) return 323;
                                if (poly[1787].contains(lat,lng)) return 323;
                                if (poly[1788].contains(lat,lng)) return 344;
                                else return 325;
                            }
                        else
                        {
                            if (poly[1789].contains(lat,lng)) return 325;
                            if (poly[1790].contains(lat,lng)) return 344;
                            if (poly[1791].contains(lat,lng)) return 352;
                            if (poly[1792].contains(lat,lng)) return 352;
                            else return 323;
                        }
                    else
                    {
                        if (poly[1793].contains(lat,lng)) return 352;
                        else return 323;
                    }
                else
                if (lng < 7.716329f)
                    if (lat < 52.157972f)
                        if (lng < 6.328347f)
                            if (lat < 51.374293f)
                                if (lng < 5.634355f)
                                {
                                    if (poly[1794].contains(lat,lng)) return 318;
                                    else return 325;
                                }
                                else
                                if (lat < 50.982453f)
                                {
                                    if (poly[1795].contains(lat,lng)) return 318;
                                    if (poly[1796].contains(lat,lng)) return 325;
                                    else return 323;
                                }
                                else
                                {
                                    if (poly[1797].contains(lat,lng)) return 323;
                                    if (poly[1798].contains(lat,lng)) return 325;
                                    else return 318;
                                }
                            else
                            {
                                if (poly[1799].contains(lat,lng)) return 323;
                                if (poly[1800].contains(lat,lng)) return 325;
                                else return 318;
                            }
                        else
                        {
                            if (poly[1801].contains(lat,lng)) return 318;
                            else return 323;
                        }
                    else
                    {
                        if (poly[1802].contains(lat,lng)) return 318;
                        else return 323;
                    }
                else
                    return 323;
            else
            if (lng < 24.626441f)
                return call22(lat,lng);
            else
                return call23(lat,lng);
        else
            return call24(lat,lng);
    }

    private static int call27(float lat, float lng)
    {
        if (lng < 105.915805f)
            if (lng < 100.300923f)
                if (lng < 97.134961f)
                    if (lng < 81.912012f)
                        return 230;
                    else
                    if (lat < -5.446921f)
                        return 243;
                    else
                        return 381;
                else
                if (lat < 5.464190f)
                    if (lat < 4.176873f)
                    {
                        if (poly[1803].contains(lat,lng)) return 243;
                        else return 253;
                    }
                    else
                    if (lng < 99.574355f)
                        return 243;
                    else
                        return 253;
                else
                if (lng < 99.504759f)
                {
                    if (poly[1804].contains(lat,lng)) return 253;
                    else return 223;
                }
                else
                {
                    if (poly[1805].contains(lat,lng)) return 223;
                    else return 253;
                }
            else
            if (lat < 3.527061f)
                if (lat < -10.211475f)
                    return 380;
                else
                if (lat < -1.935469f)
                    return 243;
                else
                {
                    if (poly[1806].contains(lat,lng)) return 243;
                    if (poly[1807].contains(lat,lng)) return 277;
                    if (poly[1808].contains(lat,lng)) return 277;
                    else return 253;
                }
            else
            if (lng < 100.673031f)
            {
                if (poly[1809].contains(lat,lng)) return 223;
                else return 253;
            }
            else
            {
                if (poly[1810].contains(lat,lng)) return 223;
                else return 253;
            }
        else
        if (lng < 127.805486f)
            if (lng < 116.484180f)
                if (lat < 5.101186f)
                    if (lat < -5.413892f)
                    {
                        if (poly[1811].contains(lat,lng)) return 258;
                        else return 243;
                    }
                    else
                    if (lng < 111.199993f)
                        if (lat < -0.211034f)
                        {
                            if (poly[1812].contains(lat,lng)) return 267;
                            else return 243;
                        }
                        else
                        if (lng < 108.557899f)
                        {
                            if (poly[1813].contains(lat,lng)) return 267;
                            else return 243;
                        }
                        else
                        if (lat < 1.983621f)
                        {
                            if (poly[1814].contains(lat,lng)) return 243;
                            if (poly[1815].contains(lat,lng)) return 254;
                            else return 267;
                        }
                        else
                        {
                            if (poly[1816].contains(lat,lng)) return 243;
                            if (poly[1817].contains(lat,lng)) return 267;
                            else return 254;
                        }
                    else
                    if (lat < -0.156353f)
                        if (lng < 113.842086f)
                        {
                            if (poly[1818].contains(lat,lng)) return 267;
                            else return 243;
                        }
                        else
                        if (lat < -2.785122f)
                        {
                            if (poly[1819].contains(lat,lng)) return 243;
                            if (poly[1820].contains(lat,lng)) return 267;
                            else return 258;
                        }
                        else
                        {
                            if (poly[1821].contains(lat,lng)) return 267;
                            else return 258;
                        }
                    else
                    if (lng < 113.842086f)
                        if (lat < 2.251313f)
                            if (lng < 112.521039f)
                            {
                                if (poly[1822].contains(lat,lng)) return 267;
                                else return 254;
                            }
                            else
                            {
                                if (poly[1823].contains(lat,lng)) return 254;
                                if (poly[1824].contains(lat,lng)) return 258;
                                else return 267;
                            }
                        else
                            return 254;
                    else
                    if (lat < 2.472417f)
                        if (lng < 115.163133f)
                            if (lat < 1.158032f)
                                if (lng < 114.502610f)
                                {
                                    if (poly[1825].contains(lat,lng)) return 258;
                                    else return 267;
                                }
                                else
                                {
                                    if (poly[1826].contains(lat,lng)) return 267;
                                    if (poly[1827].contains(lat,lng)) return 267;
                                    else return 258;
                                }
                            else
                            if (lng < 114.502610f)
                            {
                                if (poly[1828].contains(lat,lng)) return 254;
                                if (poly[1829].contains(lat,lng)) return 267;
                                else return 258;
                            }
                            else
                            {
                                if (poly[1830].contains(lat,lng)) return 254;
                                else return 258;
                            }
                        else
                        {
                            if (poly[1831].contains(lat,lng)) return 254;
                            if (poly[1832].contains(lat,lng)) return 267;
                            else return 258;
                        }
                    else
                    if (lng < 115.163133f)
                        if (lat < 3.786801f)
                        {
                            if (poly[1833].contains(lat,lng)) return 258;
                            if (poly[1834].contains(lat,lng)) return 258;
                            else return 254;
                        }
                        else
                        if (lng < 114.502610f)
                        {
                            if (poly[1835].contains(lat,lng)) return 227;
                            else return 254;
                        }
                        else
                        {
                            if (poly[1836].contains(lat,lng)) return 254;
                            if (poly[1837].contains(lat,lng)) return 254;
                            else return 227;
                        }
                    else
                    if (lat < 3.786801f)
                    {
                        if (poly[1838].contains(lat,lng)) return 254;
                        if (poly[1839].contains(lat,lng)) return 254;
                        else return 258;
                    }
                    else
                    {
                        if (poly[1840].contains(lat,lng)) return 227;
                        if (poly[1841].contains(lat,lng)) return 258;
                        else return 254;
                    }
                else
                    return 254;
            else
            if (lat < 3.446428f)
                if (lat < -3.881070f)
                    if (lng < 122.144833f)
                        return 258;
                    else
                    {
                        if (poly[1842].contains(lat,lng)) return 244;
                        if (poly[1843].contains(lat,lng)) return 258;
                        else return 233;
                    }
                else
                {
                    if (poly[1844].contains(lat,lng)) return 244;
                    else return 258;
                }
            else
            if (lng < 119.439088f)
                if (lat < 5.115101f)
                    if (lng < 118.472828f)
                    {
                        if (poly[1845].contains(lat,lng)) return 258;
                        else return 254;
                    }
                    else
                    if (lat < 4.122173f)
                        return 254;
                    else
                    {
                        if (poly[1846].contains(lat,lng)) return 254;
                        else return 259;
                    }
                else
                {
                    if (poly[1847].contains(lat,lng)) return 259;
                    else return 254;
                }
            else
            {
                if (poly[1848].contains(lat,lng)) return 259;
                else return 258;
            }
        else
        if (lat < -10.852463f)
            return 309;
        else
        if (lat < 3.446428f)
            if (lng < 131.183524f)
            {
                if (poly[1849].contains(lat,lng)) return 416;
                else return 244;
            }
            else
            if (lat < 2.014817f)
                return 244;
            else
                return 416;
        else
            return 416;
    }

    private static int call28(float lat, float lng)
    {
        if (lat < -25.996391f)
            if (lat < -39.287226f)
                if (lat < -47.545812f)
                    if (lat < -64.000000f)
                        if (lng < 86.000000f)
                            if (lat < -86.000000f)
                                return 205;
                            else
                            if (lng < 55.000000f)
                            {
                                if (poly[1850].contains(lat,lng)) return 208;
                                else return 205;
                            }
                            else
                            if (lng < 77.500000f)
                            {
                                if (poly[1851].contains(lat,lng)) return 204;
                                else return 205;
                            }
                            else
                            {
                                if (poly[1852].contains(lat,lng)) return 205;
                                else return 201;
                            }
                        else
                        {
                            if (poly[1853].contains(lat,lng)) return 200;
                            if (poly[1854].contains(lat,lng)) return 202;
                            if (poly[1855].contains(lat,lng)) return 210;
                            if (poly[1856].contains(lat,lng)) return 315;
                            else return 205;
                        }
                    else
                    if (lng < 159.340270f)
                        if (lat < -52.187445f)
                            return 203;
                        else
                            return 383;
                    else
                        return 390;
                else
                if (lng < 146.810136f)
                    if (lng < 144.428469f)
                        if (lng < 52.617433f)
                            return 383;
                        else
                        if (lat < -40.420775f)
                            return 311;
                        else
                        {
                            if (poly[1857].contains(lat,lng)) return 311;
                            else return 308;
                        }
                    else
                        return 311;
                else
                if (lng < 148.569095f)
                    return 311;
                else
                    return 390;
            else
            if (lng < 134.366448f)
                if (lng < 122.277320f)
                    if (lng < 77.849497f)
                        return 383;
                    else
                        return 315;
                else
                if (lng < 124.235687f)
                    return 315;
                else
                if (lat < -33.684270f)
                    return 305;
                else
                {
                    if (poly[1858].contains(lat,lng)) return 309;
                    if (poly[1859].contains(lat,lng)) return 310;
                    if (poly[1860].contains(lat,lng)) return 315;
                    else return 305;
                }
            else
            if (lng < 137.999053f)
                if (lat < -33.624782f)
                    return 305;
                else
                {
                    if (poly[1861].contains(lat,lng)) return 309;
                    else return 305;
                }
            else
            if (lng < 153.695857f)
                if (lat < -38.854388f)
                    if (lat < -39.198478f)
                        if (lng < 146.594326f)
                        {
                            if (poly[1862].contains(lat,lng)) return 314;
                            else return 311;
                        }
                        else
                            return 311;
                    else
                        return 314;
                else
                if (lng < 145.847455f)
                    if (lat < -32.425390f)
                        if (lng < 141.923254f)
                            if (lat < -35.454133f)
                            {
                                if (poly[1863].contains(lat,lng)) return 314;
                                else return 305;
                            }
                            else
                            {
                                if (poly[1864].contains(lat,lng)) return 305;
                                if (poly[1865].contains(lat,lng)) return 316;
                                else return 314;
                            }
                        else
                        if (lat < -35.639889f)
                        {
                            if (poly[1866].contains(lat,lng)) return 316;
                            else return 314;
                        }
                        else
                        if (lng < 143.885355f)
                            if (lat < -34.032639f)
                                if (lng < 142.904304f)
                                    if (lat < -34.836264f)
                                        return 314;
                                    else
                                    if (lng < 142.413779f)
                                    {
                                        if (poly[1867].contains(lat,lng)) return 314;
                                        else return 316;
                                    }
                                    else
                                    {
                                        if (poly[1868].contains(lat,lng)) return 316;
                                        else return 314;
                                    }
                                else
                                {
                                    if (poly[1869].contains(lat,lng)) return 316;
                                    else return 314;
                                }
                            else
                                return 316;
                        else
                        {
                            if (poly[1870].contains(lat,lng)) return 314;
                            else return 316;
                        }
                    else
                    {
                        if (poly[1871].contains(lat,lng)) return 305;
                        if (poly[1872].contains(lat,lng)) return 306;
                        if (poly[1873].contains(lat,lng)) return 307;
                        else return 316;
                    }
                else
                if (lat < -32.425390f)
                    if (lng < 149.227650f)
                        if (lat < -35.639889f)
                            if (lng < 147.537553f)
                            {
                                if (poly[1874].contains(lat,lng)) return 316;
                                else return 314;
                            }
                            else
                            {
                                if (poly[1875].contains(lat,lng)) return 316;
                                else return 314;
                            }
                        else
                            return 316;
                    else
                    {
                        if (poly[1876].contains(lat,lng)) return 314;
                        else return 316;
                    }
                else
                if (lng < 149.771656f)
                {
                    if (poly[1877].contains(lat,lng)) return 316;
                    else return 306;
                }
                else
                if (lat < -29.210890f)
                    return 316;
                else
                if (lng < 151.733756f)
                {
                    if (poly[1878].contains(lat,lng)) return 316;
                    else return 306;
                }
                else
                if (lat < -27.603641f)
                    if (lng < 152.714807f)
                    {
                        if (poly[1879].contains(lat,lng)) return 316;
                        else return 306;
                    }
                    else
                    {
                        if (poly[1880].contains(lat,lng)) return 306;
                        else return 316;
                    }
                else
                    return 306;
            else
            if (lng < 168.226126f)
                if (lat < -30.311389f)
                    return 313;
                else
                    return 413;
            else
                return 390;
        else
        if (lng < 147.113234f)
            if (lng < 123.277466f)
                if (lng < 63.715132f)
                    if (lng < 56.050791f)
                        if (lng < 41.054591f)
                            return 38;
                        else
                        if (lng < 52.838006f)
                            return 378;
                        else
                            return 388;
                    else
                        return 386;
                else
                    return 315;
            else
            if (lng < 138.027371f)
                if (lng < 123.682389f)
                    return 315;
                else
                if (lng < 129.001483f)
                {
                    if (poly[1881].contains(lat,lng)) return 309;
                    else return 315;
                }
                else
                if (lng < 135.982432f)
                    return 309;
                else
                if (lng < 137.036848f)
                    return 309;
                else
                {
                    if (poly[1882].contains(lat,lng)) return 306;
                    else return 309;
                }
            else
                return 306;
        else
        if (lng < 153.414978f)
            if (lng < 149.238945f)
                if (lng < 148.419809f)
                    return 306;
                else
                {
                    if (poly[1883].contains(lat,lng)) return 312;
                    else return 306;
                }
            else
                return 306;
        else
        if (lng < 166.058459f)
            return 414;
        else
        if (lat < -22.139087f)
            return 414;
        else
        if (lng < 170.449982f)
            if (lat < -21.090611f)
                return 414;
            else
            {
                if (poly[1884].contains(lat,lng)) return 414;
                else return 395;
            }
        else
            return 398;
    }

    private static int call29(float lat, float lng)
    {
        if (lat < 26.335228f)
            if (lng < 89.060866f)
                if (lat < 22.121441f)
                    if (lat < 21.923331f)
                    {
                        if (poly[1885].contains(lat,lng)) return 232;
                        else return 251;
                    }
                    else
                    {
                        if (poly[1886].contains(lat,lng)) return 232;
                        else return 251;
                    }
                else
                if (lng < 84.228394f)
                    return 251;
                else
                if (lng < 86.644630f)
                    return 251;
                else
                if (lat < 24.228335f)
                    if (lng < 87.852748f)
                        return 251;
                    else
                    if (lat < 23.174888f)
                    {
                        if (poly[1887].contains(lat,lng)) return 232;
                        else return 251;
                    }
                    else
                    {
                        if (poly[1888].contains(lat,lng)) return 251;
                        else return 232;
                    }
                else
                if (lng < 87.852748f)
                    return 251;
                else
                if (lat < 25.281781f)
                {
                    if (poly[1889].contains(lat,lng)) return 251;
                    else return 232;
                }
                else
                if (lng < 88.456807f)
                {
                    if (poly[1890].contains(lat,lng)) return 232;
                    else return 251;
                }
                else
                if (lat < 25.808505f)
                {
                    if (poly[1891].contains(lat,lng)) return 251;
                    else return 232;
                }
                else
                {
                    if (poly[1892].contains(lat,lng)) return 251;
                    if (poly[1893].contains(lat,lng)) return 251;
                    else return 232;
                }
            else
            if (lat < 15.129296f)
                return 292;
            else
            if (lng < 89.139934f)
                if (lat < 22.048888f)
                    if (lat < 21.738194f)
                    {
                        if (poly[1894].contains(lat,lng)) return 251;
                        else return 232;
                    }
                    else
                    {
                        if (poly[1895].contains(lat,lng)) return 251;
                        else return 232;
                    }
                else
                if (lat < 22.208629f)
                {
                    if (poly[1896].contains(lat,lng)) return 251;
                    else return 232;
                }
                else
                {
                    if (poly[1897].contains(lat,lng)) return 251;
                    else return 232;
                }
            else
            if (lat < 21.008819f)
            {
                if (poly[1898].contains(lat,lng)) return 232;
                else return 292;
            }
            else
            if (lng < 91.809154f)
                if (lat < 23.864359f)
                {
                    if (poly[1899].contains(lat,lng)) return 251;
                    else return 232;
                }
                else
                if (lng < 90.474544f)
                    if (lat < 25.099794f)
                        return 232;
                    else
                    if (lng < 89.807239f)
                    {
                        if (poly[1900].contains(lat,lng)) return 251;
                        else return 232;
                    }
                    else
                    {
                        if (poly[1901].contains(lat,lng)) return 251;
                        else return 232;
                    }
                else
                {
                    if (poly[1902].contains(lat,lng)) return 232;
                    else return 251;
                }
            else
            if (lat < 23.672023f)
                if (lng < 93.143763f)
                    if (lat < 22.340421f)
                        if (lng < 92.476458f)
                        {
                            if (poly[1903].contains(lat,lng)) return 292;
                            else return 232;
                        }
                        else
                        {
                            if (poly[1904].contains(lat,lng)) return 232;
                            if (poly[1905].contains(lat,lng)) return 251;
                            else return 292;
                        }
                    else
                    {
                        if (poly[1906].contains(lat,lng)) return 232;
                        if (poly[1907].contains(lat,lng)) return 292;
                        if (poly[1908].contains(lat,lng)) return 292;
                        else return 251;
                    }
                else
                {
                    if (poly[1909].contains(lat,lng)) return 251;
                    if (poly[1910].contains(lat,lng)) return 251;
                    if (poly[1911].contains(lat,lng)) return 251;
                    if (poly[1912].contains(lat,lng)) return 251;
                    else return 292;
                }
            else
            if (lng < 93.143763f)
            {
                if (poly[1913].contains(lat,lng)) return 232;
                if (poly[1914].contains(lat,lng)) return 232;
                if (poly[1915].contains(lat,lng)) return 232;
                if (poly[1916].contains(lat,lng)) return 232;
                else return 251;
            }
            else
            {
                if (poly[1917].contains(lat,lng)) return 292;
                else return 251;
            }
        else
        if (lng < 88.703311f)
            if (lng < 84.049616f)
            {
                if (poly[1918].contains(lat,lng)) return 249;
                else return 251;
            }
            else
            if (lng < 86.376464f)
                if (lng < 85.213040f)
                {
                    if (poly[1919].contains(lat,lng)) return 251;
                    else return 249;
                }
                else
                {
                    if (poly[1920].contains(lat,lng)) return 251;
                    if (poly[1921].contains(lat,lng)) return 276;
                    else return 249;
                }
            else
            if (lng < 87.539887f)
                if (lat < 27.291236f)
                {
                    if (poly[1922].contains(lat,lng)) return 251;
                    else return 249;
                }
                else
                {
                    if (poly[1923].contains(lat,lng)) return 276;
                    else return 249;
                }
            else
            if (lat < 27.291108f)
                if (lng < 88.121599f)
                {
                    if (poly[1924].contains(lat,lng)) return 249;
                    else return 251;
                }
                else
                {
                    if (poly[1925].contains(lat,lng)) return 232;
                    if (poly[1926].contains(lat,lng)) return 249;
                    if (poly[1927].contains(lat,lng)) return 249;
                    else return 251;
                }
            else
            if (lng < 88.121599f)
            {
                if (poly[1928].contains(lat,lng)) return 251;
                if (poly[1929].contains(lat,lng)) return 251;
                if (poly[1930].contains(lat,lng)) return 276;
                else return 249;
            }
            else
            {
                if (poly[1931].contains(lat,lng)) return 249;
                if (poly[1932].contains(lat,lng)) return 276;
                if (poly[1933].contains(lat,lng)) return 276;
                else return 251;
            }
        else
        if (lat < 26.458975f)
            if (lng < 88.746746f)
            {
                if (poly[1934].contains(lat,lng)) return 232;
                else return 251;
            }
            else
            {
                if (poly[1935].contains(lat,lng)) return 232;
                else return 251;
            }
        else
        if (lng < 91.590842f)
            if (lng < 90.147077f)
                if (lat < 27.352981f)
                {
                    if (poly[1936].contains(lat,lng)) return 276;
                    if (poly[1937].contains(lat,lng)) return 283;
                    else return 251;
                }
                else
                {
                    if (poly[1938].contains(lat,lng)) return 251;
                    if (poly[1939].contains(lat,lng)) return 283;
                    else return 276;
                }
            else
            if (lat < 27.352981f)
            {
                if (poly[1940].contains(lat,lng)) return 283;
                else return 251;
            }
            else
            {
                if (poly[1941].contains(lat,lng)) return 251;
                if (poly[1942].contains(lat,lng)) return 251;
                if (poly[1943].contains(lat,lng)) return 276;
                if (poly[1944].contains(lat,lng)) return 276;
                else return 283;
            }
        else
        if (lng < 93.034608f)
            if (lat < 27.352981f)
            {
                if (poly[1945].contains(lat,lng)) return 283;
                else return 251;
            }
            else
            if (lng < 92.312725f)
            {
                if (poly[1946].contains(lat,lng)) return 276;
                if (poly[1947].contains(lat,lng)) return 283;
                if (poly[1948].contains(lat,lng)) return 283;
                if (poly[1949].contains(lat,lng)) return 283;
                else return 251;
            }
            else
            {
                if (poly[1950].contains(lat,lng)) return 276;
                else return 251;
            }
        else
            return 251;
    }

    private static int call30(float lat, float lng)
    {
        if (lat < 18.448556f)
            if (lng < 102.253288f)
                if (lat < 8.292758f)
                    return 223;
                else
                if (lat < 18.219182f)
                    if (lng < 102.082795f)
                    {
                        if (poly[1951].contains(lat,lng)) return 289;
                        else return 223;
                    }
                    else
                    {
                        if (poly[1952].contains(lat,lng)) return 289;
                        else return 223;
                    }
                else
                {
                    if (poly[1953].contains(lat,lng)) return 223;
                    else return 289;
                }
            else
            if (lng < 107.634999f)
                if (lat < 15.319436f)
                    if (lat < 11.749251f)
                        if (lng < 104.944143f)
                        {
                            if (poly[1954].contains(lat,lng)) return 223;
                            if (poly[1955].contains(lat,lng)) return 239;
                            else return 266;
                        }
                        else
                        if (lat < 9.969693f)
                            return 239;
                        else
                        if (lng < 106.289571f)
                            if (lat < 10.859472f)
                            {
                                if (poly[1956].contains(lat,lng)) return 266;
                                if (poly[1957].contains(lat,lng)) return 266;
                                if (poly[1958].contains(lat,lng)) return 266;
                                else return 239;
                            }
                            else
                            {
                                if (poly[1959].contains(lat,lng)) return 239;
                                if (poly[1960].contains(lat,lng)) return 239;
                                if (poly[1961].contains(lat,lng)) return 239;
                                else return 266;
                            }
                        else
                        {
                            if (poly[1962].contains(lat,lng)) return 266;
                            else return 239;
                        }
                    else
                    if (lng < 104.944143f)
                        if (lat < 13.534344f)
                        {
                            if (poly[1963].contains(lat,lng)) return 266;
                            else return 223;
                        }
                        else
                        if (lng < 103.598716f)
                        {
                            if (poly[1964].contains(lat,lng)) return 266;
                            else return 223;
                        }
                        else
                        {
                            if (poly[1965].contains(lat,lng)) return 266;
                            else return 223;
                        }
                    else
                    if (lat < 13.534344f)
                        if (lng < 106.289571f)
                        {
                            if (poly[1966].contains(lat,lng)) return 239;
                            if (poly[1967].contains(lat,lng)) return 239;
                            else return 266;
                        }
                        else
                        {
                            if (poly[1968].contains(lat,lng)) return 266;
                            else return 239;
                        }
                    else
                    if (lng < 106.289571f)
                        if (lat < 14.426890f)
                            if (lng < 105.616857f)
                            {
                                if (poly[1969].contains(lat,lng)) return 266;
                                if (poly[1970].contains(lat,lng)) return 289;
                                else return 223;
                            }
                            else
                            {
                                if (poly[1971].contains(lat,lng)) return 289;
                                else return 266;
                            }
                        else
                        {
                            if (poly[1972].contains(lat,lng)) return 223;
                            if (poly[1973].contains(lat,lng)) return 266;
                            else return 289;
                        }
                    else
                    if (lat < 14.426890f)
                    {
                        if (poly[1974].contains(lat,lng)) return 239;
                        if (poly[1975].contains(lat,lng)) return 289;
                        if (poly[1976].contains(lat,lng)) return 289;
                        else return 266;
                    }
                    else
                    if (lng < 106.962285f)
                    {
                        if (poly[1977].contains(lat,lng)) return 266;
                        else return 289;
                    }
                    else
                    {
                        if (poly[1978].contains(lat,lng)) return 239;
                        if (poly[1979].contains(lat,lng)) return 266;
                        if (poly[1980].contains(lat,lng)) return 266;
                        else return 289;
                    }
                else
                if (lng < 103.407830f)
                {
                    if (poly[1981].contains(lat,lng)) return 289;
                    else return 223;
                }
                else
                if (lng < 105.521414f)
                    if (lat < 16.883996f)
                    {
                        if (poly[1982].contains(lat,lng)) return 289;
                        if (poly[1983].contains(lat,lng)) return 289;
                        else return 223;
                    }
                    else
                    {
                        if (poly[1984].contains(lat,lng)) return 223;
                        if (poly[1985].contains(lat,lng)) return 239;
                        else return 289;
                    }
                else
                if (lat < 16.883996f)
                    if (lng < 106.578207f)
                    {
                        if (poly[1986].contains(lat,lng)) return 223;
                        if (poly[1987].contains(lat,lng)) return 223;
                        if (poly[1988].contains(lat,lng)) return 239;
                        else return 289;
                    }
                    else
                    {
                        if (poly[1989].contains(lat,lng)) return 289;
                        else return 239;
                    }
                else
                {
                    if (poly[1990].contains(lat,lng)) return 289;
                    else return 239;
                }
            else
            if (lat < 17.561326f)
                return 239;
            else
                return 276;
        else
        if (lng < 108.223287f)
            if (lng < 101.357205f)
                if (lat < 19.605225f)
                    if (lat < 19.049923f)
                    {
                        if (poly[1991].contains(lat,lng)) return 223;
                        else return 289;
                    }
                    else
                    {
                        if (poly[1992].contains(lat,lng)) return 223;
                        else return 289;
                    }
                else
                if (lat < 21.355555f)
                {
                    if (poly[1993].contains(lat,lng)) return 289;
                    else return 276;
                }
                else
                {
                    if (poly[1994].contains(lat,lng)) return 289;
                    else return 276;
                }
            else
            if (lat < 23.347772f)
                if (lng < 104.790246f)
                    if (lat < 20.898164f)
                        if (lng < 103.073725f)
                            return 289;
                        else
                        if (lat < 19.673360f)
                        {
                            if (poly[1995].contains(lat,lng)) return 239;
                            else return 289;
                        }
                        else
                        if (lng < 103.931986f)
                        {
                            if (poly[1996].contains(lat,lng)) return 239;
                            if (poly[1997].contains(lat,lng)) return 239;
                            else return 289;
                        }
                        else
                        {
                            if (poly[1998].contains(lat,lng)) return 289;
                            else return 239;
                        }
                    else
                    if (lng < 103.073725f)
                        if (lat < 22.122968f)
                            if (lng < 102.215465f)
                            {
                                if (poly[1999].contains(lat,lng)) return 276;
                                else return 289;
                            }
                            else
                            {
                                if (poly[2000].contains(lat,lng)) return 239;
                                else return 289;
                            }
                        else
                        if (lng < 102.215465f)
                        {
                            if (poly[2001].contains(lat,lng)) return 239;
                            if (poly[2002].contains(lat,lng)) return 289;
                            else return 276;
                        }
                        else
                        {
                            if (poly[2003].contains(lat,lng)) return 276;
                            if (poly[2004].contains(lat,lng)) return 289;
                            else return 239;
                        }
                    else
                    if (lat < 22.122968f)
                    {
                        if (poly[2005].contains(lat,lng)) return 289;
                        if (poly[2006].contains(lat,lng)) return 289;
                        if (poly[2007].contains(lat,lng)) return 289;
                        else return 239;
                    }
                    else
                    {
                        if (poly[2008].contains(lat,lng)) return 276;
                        else return 239;
                    }
                else
                if (lat < 20.898164f)
                {
                    if (poly[2009].contains(lat,lng)) return 289;
                    if (poly[2010].contains(lat,lng)) return 289;
                    else return 239;
                }
                else
                if (lng < 106.506766f)
                {
                    if (poly[2011].contains(lat,lng)) return 276;
                    if (poly[2012].contains(lat,lng)) return 276;
                    else return 239;
                }
                else
                if (lat < 22.122968f)
                {
                    if (poly[2013].contains(lat,lng)) return 276;
                    else return 239;
                }
                else
                {
                    if (poly[2014].contains(lat,lng)) return 239;
                    else return 276;
                }
            else
            {
                if (poly[2015].contains(lat,lng)) return 239;
                else return 276;
            }
        else
            return 276;
    }

    private static int call31(float lat, float lng)
    {
        if (lat < 6.726082f)
            if (lng < 100.205056f)
                if (lng < 100.004163f)
                {
                    if (poly[2016].contains(lat,lng)) return 253;
                    else return 223;
                }
                else
                {
                    if (poly[2017].contains(lat,lng)) return 253;
                    else return 223;
                }
            else
            if (lng < 100.624518f)
            {
                if (poly[2018].contains(lat,lng)) return 253;
                else return 223;
            }
            else
            {
                if (poly[2019].contains(lat,lng)) return 253;
                else return 223;
            }
        else
        if (lng < 97.395561f)
            if (lat < 12.069914f)
                return 292;
            else
            if (lat < 18.599493f)
            {
                if (poly[2020].contains(lat,lng)) return 223;
                else return 292;
            }
            else
            if (lat < 23.423240f)
                return 292;
            else
            if (lat < 25.835113f)
            {
                if (poly[2021].contains(lat,lng)) return 251;
                else return 292;
            }
            else
            if (lng < 95.936967f)
            {
                if (poly[2022].contains(lat,lng)) return 292;
                else return 251;
            }
            else
            if (lat < 27.041050f)
                return 292;
            else
            if (lng < 96.666264f)
            {
                if (poly[2023].contains(lat,lng)) return 292;
                else return 251;
            }
            else
            {
                if (poly[2024].contains(lat,lng)) return 276;
                if (poly[2025].contains(lat,lng)) return 292;
                else return 251;
            }
        else
        if (lng < 101.170080f)
            if (lat < 18.314450f)
                if (lng < 99.664904f)
                    if (lat < 11.823147f)
                    {
                        if (poly[2026].contains(lat,lng)) return 292;
                        else return 223;
                    }
                    else
                    if (lng < 97.548732f)
                        if (lat < 15.337759f)
                            return 292;
                        else
                        {
                            if (poly[2027].contains(lat,lng)) return 223;
                            else return 292;
                        }
                    else
                    if (lat < 15.068799f)
                        if (lat < 13.445973f)
                        {
                            if (poly[2028].contains(lat,lng)) return 223;
                            else return 292;
                        }
                        else
                        {
                            if (poly[2029].contains(lat,lng)) return 223;
                            else return 292;
                        }
                    else
                    if (lat < 16.691624f)
                        if (lng < 98.606818f)
                        {
                            if (poly[2030].contains(lat,lng)) return 223;
                            if (poly[2031].contains(lat,lng)) return 223;
                            if (poly[2032].contains(lat,lng)) return 223;
                            else return 292;
                        }
                        else
                        {
                            if (poly[2033].contains(lat,lng)) return 292;
                            if (poly[2034].contains(lat,lng)) return 292;
                            else return 223;
                        }
                    else
                    if (lng < 98.606818f)
                        if (lat < 17.503037f)
                        {
                            if (poly[2035].contains(lat,lng)) return 223;
                            else return 292;
                        }
                        else
                        {
                            if (poly[2036].contains(lat,lng)) return 292;
                            else return 223;
                        }
                    else
                        return 223;
                else
                if (lat < 10.556464f)
                    return 223;
                else
                if (lat < 18.050637f)
                {
                    if (poly[2037].contains(lat,lng)) return 289;
                    else return 223;
                }
                else
                if (lat < 18.149411f)
                {
                    if (poly[2038].contains(lat,lng)) return 289;
                    else return 223;
                }
                else
                {
                    if (poly[2039].contains(lat,lng)) return 289;
                    else return 223;
                }
            else
            if (lat < 18.554059f)
                if (lng < 97.622409f)
                    if (lat < 18.487057f)
                        if (lng < 97.461327f)
                        {
                            if (poly[2040].contains(lat,lng)) return 292;
                            else return 223;
                        }
                        else
                        {
                            if (poly[2041].contains(lat,lng)) return 292;
                            else return 223;
                        }
                    else
                    {
                        if (poly[2042].contains(lat,lng)) return 292;
                        else return 223;
                    }
                else
                {
                    if (poly[2043].contains(lat,lng)) return 289;
                    else return 223;
                }
            else
            if (lng < 97.410440f)
            {
                if (poly[2044].contains(lat,lng)) return 223;
                else return 292;
            }
            else
            if (lat < 23.400523f)
                if (lat < 20.977291f)
                    if (lng < 99.290260f)
                        if (lat < 19.765675f)
                        {
                            if (poly[2045].contains(lat,lng)) return 292;
                            if (poly[2046].contains(lat,lng)) return 292;
                            if (poly[2047].contains(lat,lng)) return 292;
                            if (poly[2048].contains(lat,lng)) return 292;
                            else return 223;
                        }
                        else
                        {
                            if (poly[2049].contains(lat,lng)) return 223;
                            if (poly[2050].contains(lat,lng)) return 223;
                            if (poly[2051].contains(lat,lng)) return 223;
                            if (poly[2052].contains(lat,lng)) return 223;
                            else return 292;
                        }
                    else
                    if (lat < 19.765675f)
                    {
                        if (poly[2053].contains(lat,lng)) return 289;
                        else return 223;
                    }
                    else
                    if (lng < 100.230170f)
                    {
                        if (poly[2054].contains(lat,lng)) return 289;
                        if (poly[2055].contains(lat,lng)) return 292;
                        else return 223;
                    }
                    else
                    {
                        if (poly[2056].contains(lat,lng)) return 223;
                        if (poly[2057].contains(lat,lng)) return 292;
                        else return 289;
                    }
                else
                if (lng < 99.290260f)
                {
                    if (poly[2058].contains(lat,lng)) return 276;
                    if (poly[2059].contains(lat,lng)) return 276;
                    else return 292;
                }
                else
                if (lat < 22.188907f)
                    if (lng < 100.230170f)
                    {
                        if (poly[2060].contains(lat,lng)) return 276;
                        else return 292;
                    }
                    else
                    {
                        if (poly[2061].contains(lat,lng)) return 276;
                        if (poly[2062].contains(lat,lng)) return 276;
                        if (poly[2063].contains(lat,lng)) return 289;
                        else return 292;
                    }
                else
                {
                    if (poly[2064].contains(lat,lng)) return 292;
                    else return 276;
                }
            else
            if (lat < 25.823755f)
                if (lng < 99.290260f)
                    if (lat < 24.612139f)
                        if (lng < 98.350350f)
                        {
                            if (poly[2065].contains(lat,lng)) return 276;
                            else return 292;
                        }
                        else
                        {
                            if (poly[2066].contains(lat,lng)) return 292;
                            else return 276;
                        }
                    else
                    {
                        if (poly[2067].contains(lat,lng)) return 292;
                        if (poly[2068].contains(lat,lng)) return 292;
                        else return 276;
                    }
                else
                    return 276;
            else
            if (lng < 99.290260f)
                if (lat < 27.035371f)
                {
                    if (poly[2069].contains(lat,lng)) return 292;
                    else return 276;
                }
                else
                {
                    if (poly[2070].contains(lat,lng)) return 292;
                    else return 276;
                }
            else
                return 276;
        else
            return call30(lat,lng);
    }

    private static int call32(float lat, float lng)
    {
        if (lat < 37.380932f)
            if (lng < 42.791612f)
                if (lat < 31.979666f)
                {
                    if (poly[2071].contains(lat,lng)) return 220;
                    else return 272;
                }
                else
                if (lat < 34.680299f)
                {
                    if (poly[2072].contains(lat,lng)) return 231;
                    else return 220;
                }
                else
                {
                    if (poly[2073].contains(lat,lng)) return 220;
                    if (poly[2074].contains(lat,lng)) return 336;
                    else return 231;
                }
            else
            if (lat < 32.813960f)
                if (lng < 46.900321f)
                {
                    if (poly[2075].contains(lat,lng)) return 255;
                    if (poly[2076].contains(lat,lng)) return 272;
                    if (poly[2077].contains(lat,lng)) return 282;
                    else return 220;
                }
                else
                if (lat < 30.530473f)
                    if (lng < 48.954676f)
                        if (lat < 29.388730f)
                        {
                            if (poly[2078].contains(lat,lng)) return 272;
                            else return 255;
                        }
                        else
                        {
                            if (poly[2079].contains(lat,lng)) return 255;
                            if (poly[2080].contains(lat,lng)) return 282;
                            else return 220;
                        }
                    else
                    {
                        if (poly[2081].contains(lat,lng)) return 255;
                        if (poly[2082].contains(lat,lng)) return 272;
                        else return 282;
                    }
                else
                {
                    if (poly[2083].contains(lat,lng)) return 220;
                    else return 282;
                }
            else
            if (lng < 46.900321f)
                if (lat < 35.097446f)
                    if (lng < 44.845967f)
                        return 220;
                    else
                    if (lat < 33.955703f)
                    {
                        if (poly[2084].contains(lat,lng)) return 282;
                        else return 220;
                    }
                    else
                    {
                        if (poly[2085].contains(lat,lng)) return 282;
                        else return 220;
                    }
                else
                if (lng < 44.845967f)
                {
                    if (poly[2086].contains(lat,lng)) return 282;
                    if (poly[2087].contains(lat,lng)) return 282;
                    if (poly[2088].contains(lat,lng)) return 336;
                    else return 220;
                }
                else
                if (lat < 36.239189f)
                {
                    if (poly[2089].contains(lat,lng)) return 282;
                    else return 220;
                }
                else
                {
                    if (poly[2090].contains(lat,lng)) return 220;
                    if (poly[2091].contains(lat,lng)) return 220;
                    else return 282;
                }
            else
                return 282;
        else
        if (lng < 50.322893f)
            if (lat < 40.669330f)
                if (lng < 45.275237f)
                    if (lng < 42.751408f)
                        return 336;
                    else
                    if (lat < 39.025131f)
                    {
                        if (poly[2092].contains(lat,lng)) return 336;
                        else return 282;
                    }
                    else
                    if (lng < 44.013323f)
                    {
                        if (poly[2093].contains(lat,lng)) return 294;
                        else return 336;
                    }
                    else
                    if (lat < 39.847231f)
                        if (lng < 44.644280f)
                        {
                            if (poly[2094].contains(lat,lng)) return 282;
                            if (poly[2095].contains(lat,lng)) return 294;
                            else return 336;
                        }
                        else
                        {
                            if (poly[2096].contains(lat,lng)) return 282;
                            if (poly[2097].contains(lat,lng)) return 294;
                            if (poly[2098].contains(lat,lng)) return 336;
                            else return 222;
                        }
                    else
                    {
                        if (poly[2099].contains(lat,lng)) return 336;
                        else return 294;
                    }
                else
                if (lng < 47.799065f)
                    if (lat < 39.025131f)
                    {
                        if (poly[2100].contains(lat,lng)) return 222;
                        if (poly[2101].contains(lat,lng)) return 222;
                        if (poly[2102].contains(lat,lng)) return 294;
                        else return 282;
                    }
                    else
                    if (lng < 46.537151f)
                        if (lat < 39.847231f)
                            if (lng < 45.906194f)
                            {
                                if (poly[2103].contains(lat,lng)) return 282;
                                if (poly[2104].contains(lat,lng)) return 294;
                                else return 222;
                            }
                            else
                            {
                                if (poly[2105].contains(lat,lng)) return 294;
                                else return 222;
                            }
                        else
                        {
                            if (poly[2106].contains(lat,lng)) return 222;
                            else return 294;
                        }
                    else
                    {
                        if (poly[2107].contains(lat,lng)) return 282;
                        if (poly[2108].contains(lat,lng)) return 294;
                        if (poly[2109].contains(lat,lng)) return 294;
                        if (poly[2110].contains(lat,lng)) return 294;
                        else return 222;
                    }
                else
                {
                    if (poly[2111].contains(lat,lng)) return 222;
                    else return 282;
                }
            else
            if (lng < 45.148935f)
                if (lng < 42.688258f)
                    if (lat < 42.127880f)
                    {
                        if (poly[2112].contains(lat,lng)) return 281;
                        else return 336;
                    }
                    else
                    {
                        if (poly[2113].contains(lat,lng)) return 350;
                        else return 281;
                    }
                else
                if (lat < 42.127880f)
                    if (lng < 43.918596f)
                    {
                        if (poly[2114].contains(lat,lng)) return 294;
                        if (poly[2115].contains(lat,lng)) return 336;
                        else return 281;
                    }
                    else
                    {
                        if (poly[2116].contains(lat,lng)) return 222;
                        if (poly[2117].contains(lat,lng)) return 222;
                        if (poly[2118].contains(lat,lng)) return 222;
                        if (poly[2119].contains(lat,lng)) return 281;
                        else return 294;
                    }
                else
                {
                    if (poly[2120].contains(lat,lng)) return 350;
                    else return 281;
                }
            else
            if (lng < 47.609613f)
                if (lat < 42.127880f)
                    if (lng < 46.379274f)
                        if (lat < 41.398605f)
                        {
                            if (poly[2121].contains(lat,lng)) return 281;
                            if (poly[2122].contains(lat,lng)) return 281;
                            if (poly[2123].contains(lat,lng)) return 294;
                            if (poly[2124].contains(lat,lng)) return 294;
                            else return 222;
                        }
                        else
                        {
                            if (poly[2125].contains(lat,lng)) return 222;
                            if (poly[2126].contains(lat,lng)) return 222;
                            if (poly[2127].contains(lat,lng)) return 350;
                            else return 281;
                        }
                    else
                    if (lat < 41.398605f)
                    {
                        if (poly[2128].contains(lat,lng)) return 281;
                        if (poly[2129].contains(lat,lng)) return 350;
                        else return 222;
                    }
                    else
                    {
                        if (poly[2130].contains(lat,lng)) return 281;
                        if (poly[2131].contains(lat,lng)) return 281;
                        if (poly[2132].contains(lat,lng)) return 350;
                        else return 222;
                    }
                else
                {
                    if (poly[2133].contains(lat,lng)) return 281;
                    else return 350;
                }
            else
            {
                if (poly[2134].contains(lat,lng)) return 222;
                else return 350;
            }
        else
        if (lat < 42.071394f)
            return 216;
        else
            return 222;
    }

    private static int call33(float lat, float lng)
    {
        if (lat < 38.285000f)
            if (lat < 34.044171f)
                if (lng < 60.483127f)
                    return 282;
                else
                if (lng < 65.220176f)
                    if (lat < 31.145579f)
                        if (lng < 62.851652f)
                        {
                            if (poly[2135].contains(lat,lng)) return 246;
                            if (poly[2136].contains(lat,lng)) return 248;
                            else return 282;
                        }
                        else
                        {
                            if (poly[2137].contains(lat,lng)) return 248;
                            else return 246;
                        }
                    else
                    {
                        if (poly[2138].contains(lat,lng)) return 282;
                        else return 246;
                    }
                else
                if (lat < 31.145579f)
                {
                    if (poly[2139].contains(lat,lng)) return 246;
                    else return 248;
                }
                else
                if (lng < 67.588701f)
                {
                    if (poly[2140].contains(lat,lng)) return 248;
                    if (poly[2141].contains(lat,lng)) return 248;
                    else return 246;
                }
                else
                if (lat < 32.594875f)
                {
                    if (poly[2142].contains(lat,lng)) return 246;
                    if (poly[2143].contains(lat,lng)) return 246;
                    else return 248;
                }
                else
                {
                    if (poly[2144].contains(lat,lng)) return 248;
                    if (poly[2145].contains(lat,lng)) return 248;
                    else return 246;
                }
            else
            if (lng < 56.756389f)
            {
                if (poly[2146].contains(lat,lng)) return 218;
                else return 282;
            }
            else
            if (lng < 63.356807f)
                if (lng < 60.056598f)
                {
                    if (poly[2147].contains(lat,lng)) return 218;
                    else return 282;
                }
                else
                if (lat < 36.164585f)
                    if (lng < 61.706702f)
                        if (lat < 35.104378f)
                        {
                            if (poly[2148].contains(lat,lng)) return 282;
                            else return 246;
                        }
                        else
                        {
                            if (poly[2149].contains(lat,lng)) return 218;
                            if (poly[2150].contains(lat,lng)) return 246;
                            else return 282;
                        }
                    else
                    {
                        if (poly[2151].contains(lat,lng)) return 246;
                        else return 218;
                    }
                else
                {
                    if (poly[2152].contains(lat,lng)) return 282;
                    else return 218;
                }
            else
            if (lng < 66.657016f)
                if (lat < 36.164585f)
                {
                    if (poly[2153].contains(lat,lng)) return 218;
                    else return 246;
                }
                else
                if (lng < 65.006912f)
                {
                    if (poly[2154].contains(lat,lng)) return 246;
                    else return 218;
                }
                else
                {
                    if (poly[2155].contains(lat,lng)) return 246;
                    if (poly[2156].contains(lat,lng)) return 273;
                    if (poly[2157].contains(lat,lng)) return 273;
                    else return 218;
                }
            else
            if (lat < 36.164585f)
                return 246;
            else
            if (lng < 68.307120f)
                if (lat < 37.224793f)
                {
                    if (poly[2158].contains(lat,lng)) return 235;
                    if (poly[2159].contains(lat,lng)) return 273;
                    if (poly[2160].contains(lat,lng)) return 273;
                    if (poly[2161].contains(lat,lng)) return 273;
                    else return 246;
                }
                else
                {
                    if (poly[2162].contains(lat,lng)) return 218;
                    if (poly[2163].contains(lat,lng)) return 235;
                    if (poly[2164].contains(lat,lng)) return 235;
                    if (poly[2165].contains(lat,lng)) return 246;
                    if (poly[2166].contains(lat,lng)) return 246;
                    if (poly[2167].contains(lat,lng)) return 246;
                    else return 273;
                }
            else
            {
                if (poly[2168].contains(lat,lng)) return 246;
                if (poly[2169].contains(lat,lng)) return 273;
                else return 235;
            }
        else
        if (lng < 65.572439f)
            if (lng < 62.755236f)
                if (lng < 56.882133f)
                {
                    if (poly[2170].contains(lat,lng)) return 216;
                    if (poly[2171].contains(lat,lng)) return 273;
                    else return 218;
                }
                else
                if (lng < 59.818685f)
                    if (lat < 40.935715f)
                        return 218;
                    else
                    if (lng < 58.350409f)
                    {
                        if (poly[2172].contains(lat,lng)) return 273;
                        else return 218;
                    }
                    else
                    {
                        if (poly[2173].contains(lat,lng)) return 273;
                        if (poly[2174].contains(lat,lng)) return 273;
                        else return 218;
                    }
                else
                if (lat < 40.935715f)
                {
                    if (poly[2175].contains(lat,lng)) return 273;
                    else return 218;
                }
                else
                {
                    if (poly[2176].contains(lat,lng)) return 218;
                    if (poly[2177].contains(lat,lng)) return 271;
                    else return 273;
                }
            else
            if (lat < 39.806350f)
            {
                if (poly[2178].contains(lat,lng)) return 273;
                else return 218;
            }
            else
            if (lng < 64.572848f)
            {
                if (poly[2179].contains(lat,lng)) return 271;
                else return 273;
            }
            else
            {
                if (poly[2180].contains(lat,lng)) return 271;
                else return 273;
            }
        else
        if (lat < 41.733579f)
            if (lng < 67.764832f)
                if (lat < 40.009289f)
                {
                    if (poly[2181].contains(lat,lng)) return 235;
                    if (poly[2182].contains(lat,lng)) return 280;
                    else return 273;
                }
                else
                {
                    if (poly[2183].contains(lat,lng)) return 213;
                    if (poly[2184].contains(lat,lng)) return 273;
                    else return 280;
                }
            else
            if (lat < 40.009289f)
                if (lng < 68.861028f)
                    if (lat < 39.147145f)
                    {
                        if (poly[2185].contains(lat,lng)) return 235;
                        else return 273;
                    }
                    else
                    {
                        if (poly[2186].contains(lat,lng)) return 235;
                        else return 280;
                    }
                else
                {
                    if (poly[2187].contains(lat,lng)) return 226;
                    if (poly[2188].contains(lat,lng)) return 280;
                    else return 235;
                }
            else
            if (lng < 68.861028f)
                if (lat < 40.871434f)
                {
                    if (poly[2189].contains(lat,lng)) return 213;
                    if (poly[2190].contains(lat,lng)) return 235;
                    if (poly[2191].contains(lat,lng)) return 235;
                    else return 280;
                }
                else
                {
                    if (poly[2192].contains(lat,lng)) return 280;
                    if (poly[2193].contains(lat,lng)) return 280;
                    else return 213;
                }
            else
            if (lat < 40.871434f)
                if (lng < 69.409127f)
                {
                    if (poly[2194].contains(lat,lng)) return 226;
                    if (poly[2195].contains(lat,lng)) return 280;
                    if (poly[2196].contains(lat,lng)) return 280;
                    if (poly[2197].contains(lat,lng)) return 280;
                    else return 235;
                }
                else
                {
                    if (poly[2198].contains(lat,lng)) return 226;
                    if (poly[2199].contains(lat,lng)) return 280;
                    else return 235;
                }
            else
            {
                if (poly[2200].contains(lat,lng)) return 213;
                else return 280;
            }
        else
        {
            if (poly[2201].contains(lat,lng)) return 271;
            if (poly[2202].contains(lat,lng)) return 273;
            else return 213;
        }
    }

    private static int call34(float lat, float lng)
    {
        if (lng < 49.288299f)
            if (lat < 52.387711f)
                if (lng < 45.089563f)
                    if (lng < 43.501662f)
                        if (lng < 43.124133f)
                        {
                            if (poly[2203].contains(lat,lng)) return 360;
                            else return 350;
                        }
                        else
                        {
                            if (poly[2204].contains(lat,lng)) return 350;
                            else return 360;
                        }
                    else
                    if (lng < 43.878043f)
                    {
                        if (poly[2205].contains(lat,lng)) return 350;
                        else return 360;
                    }
                    else
                    if (lng < 44.388141f)
                    {
                        if (poly[2206].contains(lat,lng)) return 350;
                        else return 360;
                    }
                    else
                    {
                        if (poly[2207].contains(lat,lng)) return 350;
                        else return 360;
                    }
                else
                if (lng < 45.307564f)
                    if (lng < 45.260551f)
                    {
                        if (poly[2208].contains(lat,lng)) return 350;
                        else return 360;
                    }
                    else
                    {
                        if (poly[2209].contains(lat,lng)) return 350;
                        else return 360;
                    }
                else
                if (lng < 45.360905f)
                {
                    if (poly[2210].contains(lat,lng)) return 350;
                    else return 360;
                }
                else
                if (lng < 45.430033f)
                {
                    if (poly[2211].contains(lat,lng)) return 350;
                    else return 360;
                }
                else
                {
                    if (poly[2212].contains(lat,lng)) return 357;
                    else return 360;
                }
            else
            if (lng < 45.273475f)
                if (lng < 43.925487f)
                    if (lng < 43.344869f)
                    {
                        if (poly[2213].contains(lat,lng)) return 360;
                        else return 350;
                    }
                    else
                    if (lng < 43.848071f)
                    {
                        if (poly[2214].contains(lat,lng)) return 360;
                        else return 350;
                    }
                    else
                    {
                        if (poly[2215].contains(lat,lng)) return 360;
                        else return 350;
                    }
                else
                if (lng < 44.892499f)
                {
                    if (poly[2216].contains(lat,lng)) return 360;
                    else return 350;
                }
                else
                if (lng < 45.217066f)
                {
                    if (poly[2217].contains(lat,lng)) return 360;
                    else return 350;
                }
                else
                {
                    if (poly[2218].contains(lat,lng)) return 360;
                    else return 350;
                }
            else
            if (lng < 45.426670f)
                if (lng < 45.355728f)
                {
                    if (poly[2219].contains(lat,lng)) return 360;
                    else return 350;
                }
                else
                {
                    if (poly[2220].contains(lat,lng)) return 360;
                    else return 350;
                }
            else
            if (lng < 47.357484f)
                if (lat < 53.639578f)
                    if (lng < 46.392077f)
                    {
                        if (poly[2221].contains(lat,lng)) return 360;
                        else return 350;
                    }
                    else
                    if (lat < 53.013644f)
                    {
                        if (poly[2222].contains(lat,lng)) return 350;
                        if (poly[2223].contains(lat,lng)) return 367;
                        else return 360;
                    }
                    else
                    {
                        if (poly[2224].contains(lat,lng)) return 367;
                        else return 350;
                    }
                else
                if (lng < 46.392077f)
                {
                    if (poly[2225].contains(lat,lng)) return 367;
                    if (poly[2226].contains(lat,lng)) return 367;
                    else return 350;
                }
                else
                if (lat < 54.265512f)
                {
                    if (poly[2227].contains(lat,lng)) return 367;
                    else return 350;
                }
                else
                {
                    if (poly[2228].contains(lat,lng)) return 367;
                    if (poly[2229].contains(lat,lng)) return 367;
                    else return 350;
                }
            else
            if (lat < 53.639578f)
                if (lng < 48.322892f)
                    if (lat < 53.013644f)
                    {
                        if (poly[2230].contains(lat,lng)) return 357;
                        if (poly[2231].contains(lat,lng)) return 357;
                        if (poly[2232].contains(lat,lng)) return 360;
                        else return 367;
                    }
                    else
                    {
                        if (poly[2233].contains(lat,lng)) return 357;
                        else return 367;
                    }
                else
                {
                    if (poly[2234].contains(lat,lng)) return 360;
                    if (poly[2235].contains(lat,lng)) return 360;
                    if (poly[2236].contains(lat,lng)) return 367;
                    if (poly[2237].contains(lat,lng)) return 367;
                    if (poly[2238].contains(lat,lng)) return 367;
                    else return 357;
                }
            else
            if (lng < 48.322892f)
            {
                if (poly[2239].contains(lat,lng)) return 350;
                else return 367;
            }
            else
            {
                if (poly[2240].contains(lat,lng)) return 350;
                if (poly[2241].contains(lat,lng)) return 357;
                if (poly[2242].contains(lat,lng)) return 357;
                else return 367;
            }
        else
        if (lat < 52.486204f)
            if (lng < 53.016204f)
                if (lng < 51.152252f)
                    if (lng < 50.220275f)
                    {
                        if (poly[2243].contains(lat,lng)) return 265;
                        if (poly[2244].contains(lat,lng)) return 357;
                        if (poly[2245].contains(lat,lng)) return 357;
                        else return 360;
                    }
                    else
                    if (lat < 51.866906f)
                    {
                        if (poly[2246].contains(lat,lng)) return 293;
                        if (poly[2247].contains(lat,lng)) return 357;
                        if (poly[2248].contains(lat,lng)) return 360;
                        else return 265;
                    }
                    else
                    {
                        if (poly[2249].contains(lat,lng)) return 293;
                        if (poly[2250].contains(lat,lng)) return 360;
                        if (poly[2251].contains(lat,lng)) return 360;
                        else return 357;
                    }
                else
                if (lng < 52.084228f)
                {
                    if (poly[2252].contains(lat,lng)) return 265;
                    if (poly[2253].contains(lat,lng)) return 357;
                    else return 293;
                }
                else
                {
                    if (poly[2254].contains(lat,lng)) return 293;
                    else return 265;
                }
            else
            {
                if (poly[2255].contains(lat,lng)) return 293;
                else return 265;
            }
        else
        if (lng < 50.243401f)
            if (lat < 54.219528f)
            {
                if (poly[2256].contains(lat,lng)) return 367;
                else return 357;
            }
            else
            {
                if (poly[2257].contains(lat,lng)) return 350;
                if (poly[2258].contains(lat,lng)) return 357;
                else return 367;
            }
        else
        if (lng < 53.493755f)
            if (lng < 51.868578f)
            {
                if (poly[2259].contains(lat,lng)) return 293;
                if (poly[2260].contains(lat,lng)) return 350;
                else return 357;
            }
            else
            if (lat < 53.688825f)
            {
                if (poly[2261].contains(lat,lng)) return 293;
                else return 357;
            }
            else
            if (lng < 52.681167f)
            {
                if (poly[2262].contains(lat,lng)) return 293;
                if (poly[2263].contains(lat,lng)) return 350;
                else return 357;
            }
            else
            {
                if (poly[2264].contains(lat,lng)) return 293;
                if (poly[2265].contains(lat,lng)) return 293;
                else return 350;
            }
        else
        {
            if (poly[2266].contains(lat,lng)) return 350;
            if (poly[2267].contains(lat,lng)) return 350;
            else return 293;
        }
    }

    private static int call35(float lat, float lng)
    {
        if (lng < 50.871335f)
            if (lat < 61.067393f)
                if (lat < 56.256925f)
                {
                    if (poly[2268].contains(lat,lng)) return 340;
                    else return 350;
                }
                else
                if (lng < 45.549458f)
                    return 350;
                else
                if (lng < 48.210396f)
                    if (lat < 58.662159f)
                        if (lng < 46.879927f)
                        {
                            if (poly[2269].contains(lat,lng)) return 340;
                            if (poly[2270].contains(lat,lng)) return 340;
                            else return 350;
                        }
                        else
                        if (lat < 57.459542f)
                        {
                            if (poly[2271].contains(lat,lng)) return 350;
                            else return 340;
                        }
                        else
                        {
                            if (poly[2272].contains(lat,lng)) return 350;
                            if (poly[2273].contains(lat,lng)) return 350;
                            else return 340;
                        }
                    else
                    if (lng < 46.879927f)
                    {
                        if (poly[2274].contains(lat,lng)) return 340;
                        if (poly[2275].contains(lat,lng)) return 340;
                        else return 350;
                    }
                    else
                    if (lat < 59.864776f)
                    {
                        if (poly[2276].contains(lat,lng)) return 350;
                        else return 340;
                    }
                    else
                    {
                        if (poly[2277].contains(lat,lng)) return 340;
                        else return 350;
                    }
                else
                if (lat < 58.662159f)
                    if (lng < 49.540866f)
                    {
                        if (poly[2278].contains(lat,lng)) return 350;
                        else return 340;
                    }
                    else
                    {
                        if (poly[2279].contains(lat,lng)) return 350;
                        else return 340;
                    }
                else
                {
                    if (poly[2280].contains(lat,lng)) return 340;
                    else return 350;
                }
            else
                return 350;
        else
        if (lat < 58.545842f)
            if (lng < 53.098981f)
                if (lng < 50.917326f)
                    if (lat < 56.201553f)
                    {
                        if (poly[2281].contains(lat,lng)) return 350;
                        else return 340;
                    }
                    else
                    if (lat < 56.333988f)
                    {
                        if (poly[2282].contains(lat,lng)) return 350;
                        else return 340;
                    }
                    else
                    {
                        if (poly[2283].contains(lat,lng)) return 350;
                        else return 340;
                    }
                else
                if (lat < 56.994006f)
                    if (lng < 52.008154f)
                        if (lat < 56.218088f)
                            if (lng < 51.462740f)
                            {
                                if (poly[2284].contains(lat,lng)) return 340;
                                if (poly[2285].contains(lat,lng)) return 357;
                                if (poly[2286].contains(lat,lng)) return 357;
                                if (poly[2287].contains(lat,lng)) return 357;
                                else return 350;
                            }
                            else
                            {
                                if (poly[2288].contains(lat,lng)) return 340;
                                if (poly[2289].contains(lat,lng)) return 350;
                                if (poly[2290].contains(lat,lng)) return 350;
                                else return 357;
                            }
                        else
                        {
                            if (poly[2291].contains(lat,lng)) return 357;
                            else return 340;
                        }
                    else
                    if (lat < 56.218088f)
                    {
                        if (poly[2292].contains(lat,lng)) return 350;
                        if (poly[2293].contains(lat,lng)) return 350;
                        else return 357;
                    }
                    else
                    {
                        if (poly[2294].contains(lat,lng)) return 350;
                        else return 357;
                    }
                else
                {
                    if (poly[2295].contains(lat,lng)) return 357;
                    else return 340;
                }
            else
            if (lat < 56.276134f)
                if (lng < 61.528103f)
                    if (lng < 57.313542f)
                        if (lng < 55.206261f)
                            if (lng < 54.152621f)
                                if (lng < 53.625801f)
                                {
                                    if (poly[2296].contains(lat,lng)) return 350;
                                    else return 357;
                                }
                                else
                                {
                                    if (poly[2297].contains(lat,lng)) return 350;
                                    if (poly[2298].contains(lat,lng)) return 357;
                                    else return 293;
                                }
                            else
                            {
                                if (poly[2299].contains(lat,lng)) return 350;
                                if (poly[2300].contains(lat,lng)) return 357;
                                else return 293;
                            }
                        else
                            return 293;
                    else
                        return 293;
                else
                    return 293;
            else
            if (lng < 61.528103f)
                if (lng < 57.313542f)
                    if (lng < 55.206261f)
                        if (lat < 57.410988f)
                        {
                            if (poly[2301].contains(lat,lng)) return 293;
                            if (poly[2302].contains(lat,lng)) return 350;
                            else return 357;
                        }
                        else
                        {
                            if (poly[2303].contains(lat,lng)) return 293;
                            if (poly[2304].contains(lat,lng)) return 340;
                            else return 357;
                        }
                    else
                        return 293;
                else
                    return 293;
            else
                return 293;
        else
        if (lng < 60.414280f)
            if (lat < 66.074501f)
                if (lng < 55.642808f)
                    if (lat < 62.310171f)
                        if (lng < 53.257071f)
                        {
                            if (poly[2305].contains(lat,lng)) return 293;
                            if (poly[2306].contains(lat,lng)) return 293;
                            if (poly[2307].contains(lat,lng)) return 340;
                            else return 350;
                        }
                        else
                        {
                            if (poly[2308].contains(lat,lng)) return 340;
                            if (poly[2309].contains(lat,lng)) return 340;
                            if (poly[2310].contains(lat,lng)) return 350;
                            else return 293;
                        }
                    else
                        return 350;
                else
                if (lat < 62.310171f)
                {
                    if (poly[2311].contains(lat,lng)) return 350;
                    else return 293;
                }
                else
                {
                    if (poly[2312].contains(lat,lng)) return 293;
                    else return 350;
                }
            else
                return 350;
        else
        if (lat < 66.074501f)
        {
            if (poly[2313].contains(lat,lng)) return 350;
            else return 293;
        }
        else
        if (lng < 65.185752f)
        {
            if (poly[2314].contains(lat,lng)) return 293;
            if (poly[2315].contains(lat,lng)) return 293;
            if (poly[2316].contains(lat,lng)) return 293;
            else return 350;
        }
        else
        {
            if (poly[2317].contains(lat,lng)) return 350;
            if (poly[2318].contains(lat,lng)) return 350;
            else return 293;
        }
    }

    private static int call36(float lat, float lng)
    {
        if (lng < 56.744109f)
            if (lat < 51.247608f)
                if (lng < 50.034781f)
                    if (lat < 45.187282f)
                        if (lng < 48.975853f)
                            return 216;
                        else
                            return 350;
                    else
                    if (lng < 45.131181f)
                        if (lat < 48.217445f)
                        {
                            if (poly[2319].contains(lat,lng)) return 373;
                            if (poly[2320].contains(lat,lng)) return 373;
                            else return 350;
                        }
                        else
                        if (lng < 42.679380f)
                            if (lat < 49.732527f)
                            {
                                if (poly[2321].contains(lat,lng)) return 373;
                                if (poly[2322].contains(lat,lng)) return 373;
                                if (poly[2323].contains(lat,lng)) return 373;
                                else return 350;
                            }
                            else
                            {
                                if (poly[2324].contains(lat,lng)) return 373;
                                else return 350;
                            }
                        else
                        if (lat < 49.732527f)
                        {
                            if (poly[2325].contains(lat,lng)) return 320;
                            if (poly[2326].contains(lat,lng)) return 350;
                            if (poly[2327].contains(lat,lng)) return 350;
                            if (poly[2328].contains(lat,lng)) return 350;
                            if (poly[2329].contains(lat,lng)) return 350;
                            else return 373;
                        }
                        else
                        {
                            if (poly[2330].contains(lat,lng)) return 350;
                            if (poly[2331].contains(lat,lng)) return 350;
                            if (poly[2332].contains(lat,lng)) return 360;
                            else return 373;
                        }
                    else
                    if (lat < 48.217445f)
                        if (lng < 47.582981f)
                            if (lat < 46.702364f)
                            {
                                if (poly[2333].contains(lat,lng)) return 320;
                                else return 350;
                            }
                            else
                            {
                                if (poly[2334].contains(lat,lng)) return 219;
                                if (poly[2335].contains(lat,lng)) return 265;
                                if (poly[2336].contains(lat,lng)) return 350;
                                else return 320;
                            }
                        else
                        if (lat < 46.702364f)
                        {
                            if (poly[2337].contains(lat,lng)) return 219;
                            if (poly[2338].contains(lat,lng)) return 350;
                            else return 320;
                        }
                        else
                        {
                            if (poly[2339].contains(lat,lng)) return 265;
                            if (poly[2340].contains(lat,lng)) return 320;
                            else return 219;
                        }
                    else
                    if (lng < 47.582981f)
                        if (lat < 49.732527f)
                            if (lng < 46.357081f)
                            {
                                if (poly[2341].contains(lat,lng)) return 350;
                                if (poly[2342].contains(lat,lng)) return 373;
                                else return 320;
                            }
                            else
                            {
                                if (poly[2343].contains(lat,lng)) return 219;
                                if (poly[2344].contains(lat,lng)) return 320;
                                if (poly[2345].contains(lat,lng)) return 373;
                                else return 265;
                            }
                        else
                        if (lng < 46.357081f)
                        {
                            if (poly[2346].contains(lat,lng)) return 373;
                            else return 360;
                        }
                        else
                        {
                            if (poly[2347].contains(lat,lng)) return 265;
                            if (poly[2348].contains(lat,lng)) return 360;
                            else return 373;
                        }
                    else
                    {
                        if (poly[2349].contains(lat,lng)) return 360;
                        else return 265;
                    }
                else
                if (lat < 45.170128f)
                {
                    if (poly[2350].contains(lat,lng)) return 273;
                    else return 216;
                }
                else
                if (lat < 46.520131f)
                    if (lng < 50.438264f)
                        if (lat < 45.694299f)
                            return 216;
                        else
                            return 219;
                    else
                    if (lng < 55.487919f)
                    {
                        if (poly[2351].contains(lat,lng)) return 219;
                        else return 216;
                    }
                    else
                    {
                        if (poly[2352].contains(lat,lng)) return 217;
                        if (poly[2353].contains(lat,lng)) return 219;
                        else return 216;
                    }
                else
                if (lng < 53.389445f)
                {
                    if (poly[2354].contains(lat,lng)) return 265;
                    else return 219;
                }
                else
                if (lat < 48.883870f)
                {
                    if (poly[2355].contains(lat,lng)) return 219;
                    else return 217;
                }
                else
                if (lng < 55.066777f)
                    if (lat < 50.065739f)
                    {
                        if (poly[2356].contains(lat,lng)) return 219;
                        if (poly[2357].contains(lat,lng)) return 265;
                        if (poly[2358].contains(lat,lng)) return 265;
                        else return 217;
                    }
                    else
                    if (lng < 54.228111f)
                    {
                        if (poly[2359].contains(lat,lng)) return 293;
                        else return 265;
                    }
                    else
                    {
                        if (poly[2360].contains(lat,lng)) return 217;
                        if (poly[2361].contains(lat,lng)) return 265;
                        else return 293;
                    }
                else
                {
                    if (poly[2362].contains(lat,lng)) return 293;
                    else return 217;
                }
            else
                return call34(lat,lng);
        else
        if (lat < 47.827727f)
            if (lng < 61.924863f)
            {
                if (poly[2363].contains(lat,lng)) return 217;
                if (poly[2364].contains(lat,lng)) return 273;
                else return 271;
            }
            else
            if (lng < 65.941044f)
            {
                if (poly[2365].contains(lat,lng)) return 213;
                if (poly[2366].contains(lat,lng)) return 217;
                if (poly[2367].contains(lat,lng)) return 273;
                if (poly[2368].contains(lat,lng)) return 273;
                else return 271;
            }
            else
            {
                if (poly[2369].contains(lat,lng)) return 271;
                else return 213;
            }
        else
        if (lng < 63.350667f)
            if (lat < 51.359587f)
                if (lng < 60.047388f)
                    if (lat < 49.593657f)
                        return 217;
                    else
                    if (lng < 58.395748f)
                    {
                        if (poly[2370].contains(lat,lng)) return 293;
                        if (poly[2371].contains(lat,lng)) return 293;
                        else return 217;
                    }
                    else
                    {
                        if (poly[2372].contains(lat,lng)) return 293;
                        else return 217;
                    }
                else
                if (lat < 49.593657f)
                {
                    if (poly[2373].contains(lat,lng)) return 270;
                    else return 217;
                }
                else
                if (lng < 61.699027f)
                {
                    if (poly[2374].contains(lat,lng)) return 217;
                    if (poly[2375].contains(lat,lng)) return 270;
                    else return 293;
                }
                else
                {
                    if (poly[2376].contains(lat,lng)) return 217;
                    else return 270;
                }
            else
            if (lng < 60.047388f)
            {
                if (poly[2377].contains(lat,lng)) return 270;
                else return 293;
            }
            else
            if (lat < 53.125516f)
                if (lng < 61.699027f)
                {
                    if (poly[2378].contains(lat,lng)) return 270;
                    else return 293;
                }
                else
                {
                    if (poly[2379].contains(lat,lng)) return 293;
                    else return 270;
                }
            else
            if (lng < 61.699027f)
                if (lat < 54.008481f)
                {
                    if (poly[2380].contains(lat,lng)) return 270;
                    else return 293;
                }
                else
                {
                    if (poly[2381].contains(lat,lng)) return 270;
                    if (poly[2382].contains(lat,lng)) return 270;
                    else return 293;
                }
            else
            {
                if (poly[2383].contains(lat,lng)) return 270;
                else return 293;
            }
        else
        if (lat < 51.359587f)
            if (lng < 66.653946f)
                if (lat < 49.593657f)
                {
                    if (poly[2384].contains(lat,lng)) return 213;
                    if (poly[2385].contains(lat,lng)) return 217;
                    else return 270;
                }
                else
                {
                    if (poly[2386].contains(lat,lng)) return 213;
                    else return 270;
                }
            else
            {
                if (poly[2387].contains(lat,lng)) return 270;
                else return 213;
            }
        else
        if (lng < 66.653946f)
            if (lat < 53.125516f)
            {
                if (poly[2388].contains(lat,lng)) return 270;
                else return 213;
            }
            else
            if (lng < 65.002307f)
            {
                if (poly[2389].contains(lat,lng)) return 293;
                else return 270;
            }
            else
            {
                if (poly[2390].contains(lat,lng)) return 213;
                if (poly[2391].contains(lat,lng)) return 293;
                else return 270;
            }
        else
        {
            if (poly[2392].contains(lat,lng)) return 293;
            else return 213;
        }
    }

    private static int call37(float lat, float lng)
    {
        if (lat < 33.934308f)
            if (lng < 74.729730f)
                if (lat < 31.090648f)
                {
                    if (poly[2393].contains(lat,lng)) return 251;
                    if (poly[2394].contains(lat,lng)) return 251;
                    else return 248;
                }
                else
                if (lng < 72.632080f)
                    return 248;
                else
                if (lat < 32.512478f)
                {
                    if (poly[2395].contains(lat,lng)) return 251;
                    if (poly[2396].contains(lat,lng)) return 251;
                    else return 248;
                }
                else
                {
                    if (poly[2397].contains(lat,lng)) return 251;
                    else return 248;
                }
            else
            if (lat < 31.090648f)
                return 251;
            else
            if (lng < 76.827381f)
            {
                if (poly[2398].contains(lat,lng)) return 248;
                else return 251;
            }
            else
            if (lat < 32.512478f)
            {
                if (poly[2399].contains(lat,lng)) return 276;
                else return 251;
            }
            else
            {
                if (poly[2400].contains(lat,lng)) return 276;
                if (poly[2401].contains(lat,lng)) return 276;
                else return 251;
            }
        else
        if (lng < 74.729730f)
            if (lat < 36.777969f)
                if (lng < 72.632080f)
                    if (lat < 35.356138f)
                    {
                        if (poly[2402].contains(lat,lng)) return 246;
                        else return 248;
                    }
                    else
                    if (lng < 71.583255f)
                    {
                        if (poly[2403].contains(lat,lng)) return 235;
                        if (poly[2404].contains(lat,lng)) return 248;
                        if (poly[2405].contains(lat,lng)) return 248;
                        else return 246;
                    }
                    else
                    {
                        if (poly[2406].contains(lat,lng)) return 235;
                        if (poly[2407].contains(lat,lng)) return 248;
                        else return 246;
                    }
                else
                {
                    if (poly[2408].contains(lat,lng)) return 251;
                    else return 248;
                }
            else
            if (lng < 72.632080f)
                if (lat < 38.199799f)
                {
                    if (poly[2409].contains(lat,lng)) return 235;
                    if (poly[2410].contains(lat,lng)) return 248;
                    else return 246;
                }
                else
                if (lng < 71.583255f)
                {
                    if (poly[2411].contains(lat,lng)) return 226;
                    if (poly[2412].contains(lat,lng)) return 246;
                    else return 235;
                }
                else
                {
                    if (poly[2413].contains(lat,lng)) return 235;
                    else return 226;
                }
            else
            if (lat < 38.199799f)
                if (lng < 73.680905f)
                {
                    if (poly[2414].contains(lat,lng)) return 235;
                    if (poly[2415].contains(lat,lng)) return 235;
                    if (poly[2416].contains(lat,lng)) return 248;
                    else return 246;
                }
                else
                if (lat < 37.488884f)
                    if (lng < 74.205318f)
                    {
                        if (poly[2417].contains(lat,lng)) return 235;
                        if (poly[2418].contains(lat,lng)) return 248;
                        else return 246;
                    }
                    else
                    if (lat < 37.133426f)
                    {
                        if (poly[2419].contains(lat,lng)) return 248;
                        if (poly[2420].contains(lat,lng)) return 276;
                        if (poly[2421].contains(lat,lng)) return 287;
                        else return 246;
                    }
                    else
                    {
                        if (poly[2422].contains(lat,lng)) return 235;
                        if (poly[2423].contains(lat,lng)) return 276;
                        if (poly[2424].contains(lat,lng)) return 287;
                        else return 246;
                    }
                else
                    return 235;
            else
            if (lng < 73.680905f)
            {
                if (poly[2425].contains(lat,lng)) return 226;
                if (poly[2426].contains(lat,lng)) return 276;
                if (poly[2427].contains(lat,lng)) return 287;
                else return 235;
            }
            else
            if (lat < 38.910714f)
            {
                if (poly[2428].contains(lat,lng)) return 276;
                if (poly[2429].contains(lat,lng)) return 287;
                else return 235;
            }
            else
            {
                if (poly[2430].contains(lat,lng)) return 226;
                if (poly[2431].contains(lat,lng)) return 235;
                if (poly[2432].contains(lat,lng)) return 287;
                else return 276;
            }
        else
        if (lat < 36.777969f)
            if (lng < 76.827381f)
                if (lat < 35.356138f)
                {
                    if (poly[2433].contains(lat,lng)) return 251;
                    else return 248;
                }
                else
                if (lng < 75.778556f)
                {
                    if (poly[2434].contains(lat,lng)) return 276;
                    if (poly[2435].contains(lat,lng)) return 287;
                    else return 248;
                }
                else
                if (lat < 36.067053f)
                {
                    if (poly[2436].contains(lat,lng)) return 251;
                    if (poly[2437].contains(lat,lng)) return 276;
                    if (poly[2438].contains(lat,lng)) return 287;
                    else return 248;
                }
                else
                {
                    if (poly[2439].contains(lat,lng)) return 248;
                    if (poly[2440].contains(lat,lng)) return 287;
                    else return 276;
                }
            else
            if (lat < 35.356138f)
                if (lng < 77.876206f)
                {
                    if (poly[2441].contains(lat,lng)) return 248;
                    else return 251;
                }
                else
                if (lat < 34.645223f)
                {
                    if (poly[2442].contains(lat,lng)) return 276;
                    if (poly[2443].contains(lat,lng)) return 276;
                    if (poly[2444].contains(lat,lng)) return 287;
                    else return 251;
                }
                else
                {
                    if (poly[2445].contains(lat,lng)) return 276;
                    if (poly[2446].contains(lat,lng)) return 287;
                    else return 251;
                }
            else
            if (lng < 77.876206f)
            {
                if (poly[2447].contains(lat,lng)) return 248;
                if (poly[2448].contains(lat,lng)) return 276;
                if (poly[2449].contains(lat,lng)) return 287;
                else return 251;
            }
            else
            {
                if (poly[2450].contains(lat,lng)) return 251;
                if (poly[2451].contains(lat,lng)) return 287;
                else return 276;
            }
        else
        if (lng < 76.827381f)
            if (lat < 38.199799f)
                if (lng < 75.778556f)
                    if (lat < 37.488884f)
                        if (lng < 75.254143f)
                            if (lat < 37.133426f)
                            {
                                if (poly[2452].contains(lat,lng)) return 276;
                                if (poly[2453].contains(lat,lng)) return 287;
                                else return 248;
                            }
                            else
                            {
                                if (poly[2454].contains(lat,lng)) return 235;
                                if (poly[2455].contains(lat,lng)) return 246;
                                if (poly[2456].contains(lat,lng)) return 287;
                                else return 276;
                            }
                        else
                        {
                            if (poly[2457].contains(lat,lng)) return 248;
                            if (poly[2458].contains(lat,lng)) return 287;
                            else return 276;
                        }
                    else
                    {
                        if (poly[2459].contains(lat,lng)) return 276;
                        if (poly[2460].contains(lat,lng)) return 287;
                        else return 235;
                    }
                else
                {
                    if (poly[2461].contains(lat,lng)) return 287;
                    else return 276;
                }
            else
            {
                if (poly[2462].contains(lat,lng)) return 235;
                if (poly[2463].contains(lat,lng)) return 287;
                else return 276;
            }
        else
        {
            if (poly[2464].contains(lat,lng)) return 287;
            else return 276;
        }
    }

    private static int call38(float lat, float lng)
    {
        if (lng < 80.227684f)
            if (lat < 45.885615f)
                if (lng < 76.683710f)
                    if (lat < 42.753622f)
                        if (lng < 74.911723f)
                            if (lat < 41.187625f)
                                if (lng < 74.025729f)
                                {
                                    if (poly[2465].contains(lat,lng)) return 276;
                                    if (poly[2466].contains(lat,lng)) return 287;
                                    else return 226;
                                }
                                else
                                {
                                    if (poly[2467].contains(lat,lng)) return 276;
                                    if (poly[2468].contains(lat,lng)) return 287;
                                    else return 226;
                                }
                            else
                            {
                                if (poly[2469].contains(lat,lng)) return 213;
                                else return 226;
                            }
                        else
                        if (lat < 41.187625f)
                            if (lng < 75.797716f)
                            {
                                if (poly[2470].contains(lat,lng)) return 276;
                                if (poly[2471].contains(lat,lng)) return 287;
                                else return 226;
                            }
                            else
                            {
                                if (poly[2472].contains(lat,lng)) return 276;
                                if (poly[2473].contains(lat,lng)) return 287;
                                else return 226;
                            }
                        else
                            return 226;
                    else
                    {
                        if (poly[2474].contains(lat,lng)) return 226;
                        else return 213;
                    }
                else
                if (lat < 42.753622f)
                    if (lng < 78.455697f)
                        if (lat < 41.187625f)
                        {
                            if (poly[2475].contains(lat,lng)) return 226;
                            if (poly[2476].contains(lat,lng)) return 287;
                            else return 276;
                        }
                        else
                        {
                            if (poly[2477].contains(lat,lng)) return 276;
                            if (poly[2478].contains(lat,lng)) return 287;
                            else return 226;
                        }
                    else
                    if (lat < 41.187625f)
                    {
                        if (poly[2479].contains(lat,lng)) return 287;
                        else return 276;
                    }
                    else
                    if (lng < 79.341690f)
                    {
                        if (poly[2480].contains(lat,lng)) return 213;
                        if (poly[2481].contains(lat,lng)) return 276;
                        if (poly[2482].contains(lat,lng)) return 287;
                        else return 226;
                    }
                    else
                    if (lat < 41.970624f)
                    {
                        if (poly[2483].contains(lat,lng)) return 226;
                        if (poly[2484].contains(lat,lng)) return 287;
                        else return 276;
                    }
                    else
                    if (lng < 79.784687f)
                    {
                        if (poly[2485].contains(lat,lng)) return 213;
                        else return 226;
                    }
                    else
                    if (lat < 42.362123f)
                    {
                        if (poly[2486].contains(lat,lng)) return 213;
                        if (poly[2487].contains(lat,lng)) return 276;
                        if (poly[2488].contains(lat,lng)) return 287;
                        else return 226;
                    }
                    else
                    {
                        if (poly[2489].contains(lat,lng)) return 226;
                        if (poly[2490].contains(lat,lng)) return 276;
                        if (poly[2491].contains(lat,lng)) return 276;
                        if (poly[2492].contains(lat,lng)) return 287;
                        if (poly[2493].contains(lat,lng)) return 287;
                        else return 213;
                    }
                else
                if (lng < 78.455697f)
                {
                    if (poly[2494].contains(lat,lng)) return 226;
                    else return 213;
                }
                else
                {
                    if (poly[2495].contains(lat,lng)) return 226;
                    if (poly[2496].contains(lat,lng)) return 276;
                    if (poly[2497].contains(lat,lng)) return 287;
                    else return 213;
                }
            else
            {
                if (poly[2498].contains(lat,lng)) return 224;
                else return 213;
            }
        else
        if (lat < 45.885615f)
            if (lng < 83.771658f)
                if (lat < 42.753622f)
                {
                    if (poly[2499].contains(lat,lng)) return 213;
                    if (poly[2500].contains(lat,lng)) return 213;
                    if (poly[2501].contains(lat,lng)) return 213;
                    if (poly[2502].contains(lat,lng)) return 226;
                    if (poly[2503].contains(lat,lng)) return 287;
                    else return 276;
                }
                else
                if (lng < 81.999671f)
                    if (lat < 44.319618f)
                        if (lng < 81.113677f)
                            if (lat < 43.536620f)
                            {
                                if (poly[2504].contains(lat,lng)) return 276;
                                if (poly[2505].contains(lat,lng)) return 287;
                                else return 213;
                            }
                            else
                            {
                                if (poly[2506].contains(lat,lng)) return 276;
                                if (poly[2507].contains(lat,lng)) return 287;
                                else return 213;
                            }
                        else
                        {
                            if (poly[2508].contains(lat,lng)) return 287;
                            else return 276;
                        }
                    else
                    if (lng < 81.113677f)
                    {
                        if (poly[2509].contains(lat,lng)) return 276;
                        if (poly[2510].contains(lat,lng)) return 287;
                        else return 213;
                    }
                    else
                    {
                        if (poly[2511].contains(lat,lng)) return 276;
                        if (poly[2512].contains(lat,lng)) return 287;
                        else return 213;
                    }
                else
                {
                    if (poly[2513].contains(lat,lng)) return 213;
                    if (poly[2514].contains(lat,lng)) return 287;
                    else return 276;
                }
            else
            {
                if (poly[2515].contains(lat,lng)) return 287;
                else return 276;
            }
        else
        if (lng < 83.771658f)
            if (lat < 49.017607f)
            {
                if (poly[2516].contains(lat,lng)) return 276;
                if (poly[2517].contains(lat,lng)) return 287;
                else return 213;
            }
            else
            if (lng < 81.999671f)
            {
                if (poly[2518].contains(lat,lng)) return 224;
                else return 213;
            }
            else
            {
                if (poly[2519].contains(lat,lng)) return 224;
                else return 213;
            }
        else
        if (lat < 49.017607f)
            if (lng < 85.543645f)
                if (lat < 47.451611f)
                    if (lng < 84.657652f)
                    {
                        if (poly[2520].contains(lat,lng)) return 276;
                        if (poly[2521].contains(lat,lng)) return 287;
                        else return 213;
                    }
                    else
                    {
                        if (poly[2522].contains(lat,lng)) return 276;
                        if (poly[2523].contains(lat,lng)) return 287;
                        else return 213;
                    }
                else
                {
                    if (poly[2524].contains(lat,lng)) return 276;
                    if (poly[2525].contains(lat,lng)) return 287;
                    else return 213;
                }
            else
            if (lat < 47.451611f)
            {
                if (poly[2526].contains(lat,lng)) return 213;
                if (poly[2527].contains(lat,lng)) return 287;
                else return 276;
            }
            else
            {
                if (poly[2528].contains(lat,lng)) return 276;
                if (poly[2529].contains(lat,lng)) return 287;
                else return 213;
            }
        else
        if (lng < 85.543645f)
        {
            if (poly[2530].contains(lat,lng)) return 224;
            else return 213;
        }
        else
        if (lat < 50.583604f)
            if (lng < 86.429638f)
            {
                if (poly[2531].contains(lat,lng)) return 224;
                else return 213;
            }
            else
            {
                if (poly[2532].contains(lat,lng)) return 224;
                if (poly[2533].contains(lat,lng)) return 276;
                if (poly[2534].contains(lat,lng)) return 287;
                else return 213;
            }
        else
            return 224;
    }

    private static int call39(float lat, float lng)
    {
        if (lng < 98.940959f)
            if (lat < 40.765989f)
            {
                if (poly[2535].contains(lat,lng)) return 276;
                else return 287;
            }
            else
            if (lng < 93.128295f)
                if (lat < 46.457794f)
                    if (lng < 90.221964f)
                    {
                        if (poly[2536].contains(lat,lng)) return 287;
                        else return 276;
                    }
                    else
                    if (lat < 43.611892f)
                    {
                        if (poly[2537].contains(lat,lng)) return 287;
                        else return 276;
                    }
                    else
                    if (lng < 91.675130f)
                    {
                        if (poly[2538].contains(lat,lng)) return 241;
                        if (poly[2539].contains(lat,lng)) return 287;
                        else return 276;
                    }
                    else
                    {
                        if (poly[2540].contains(lat,lng)) return 276;
                        if (poly[2541].contains(lat,lng)) return 287;
                        else return 241;
                    }
                else
                if (lng < 90.221964f)
                    if (lat < 49.303697f)
                        if (lng < 88.768798f)
                            if (lat < 47.880746f)
                            {
                                if (poly[2542].contains(lat,lng)) return 287;
                                else return 276;
                            }
                            else
                            if (lng < 88.042215f)
                                if (lat < 48.592222f)
                                {
                                    if (poly[2543].contains(lat,lng)) return 241;
                                    if (poly[2544].contains(lat,lng)) return 287;
                                    else return 276;
                                }
                                else
                                if (lng < 87.678923f)
                                {
                                    if (poly[2545].contains(lat,lng)) return 224;
                                    if (poly[2546].contains(lat,lng)) return 276;
                                    else return 287;
                                }
                                else
                                {
                                    if (poly[2547].contains(lat,lng)) return 224;
                                    if (poly[2548].contains(lat,lng)) return 276;
                                    if (poly[2549].contains(lat,lng)) return 287;
                                    else return 241;
                                }
                            else
                            {
                                if (poly[2550].contains(lat,lng)) return 224;
                                if (poly[2551].contains(lat,lng)) return 276;
                                if (poly[2552].contains(lat,lng)) return 276;
                                if (poly[2553].contains(lat,lng)) return 287;
                                if (poly[2554].contains(lat,lng)) return 287;
                                else return 241;
                            }
                        else
                        {
                            if (poly[2555].contains(lat,lng)) return 241;
                            if (poly[2556].contains(lat,lng)) return 276;
                            else return 287;
                        }
                    else
                    if (lng < 88.768798f)
                    {
                        if (poly[2557].contains(lat,lng)) return 241;
                        if (poly[2558].contains(lat,lng)) return 252;
                        else return 224;
                    }
                    else
                    if (lat < 50.726649f)
                        if (lng < 89.495381f)
                        {
                            if (poly[2559].contains(lat,lng)) return 241;
                            if (poly[2560].contains(lat,lng)) return 252;
                            else return 224;
                        }
                        else
                        {
                            if (poly[2561].contains(lat,lng)) return 241;
                            if (poly[2562].contains(lat,lng)) return 252;
                            else return 224;
                        }
                    else
                    {
                        if (poly[2563].contains(lat,lng)) return 224;
                        else return 252;
                    }
                else
                if (lat < 49.303697f)
                {
                    if (poly[2564].contains(lat,lng)) return 276;
                    if (poly[2565].contains(lat,lng)) return 287;
                    else return 241;
                }
                else
                {
                    if (poly[2566].contains(lat,lng)) return 252;
                    else return 241;
                }
            else
            if (lat < 46.457794f)
                if (lng < 96.034627f)
                    if (lat < 43.611892f)
                    {
                        if (poly[2567].contains(lat,lng)) return 241;
                        if (poly[2568].contains(lat,lng)) return 276;
                        else return 287;
                    }
                    else
                    {
                        if (poly[2569].contains(lat,lng)) return 276;
                        if (poly[2570].contains(lat,lng)) return 287;
                        else return 241;
                    }
                else
                {
                    if (poly[2571].contains(lat,lng)) return 276;
                    if (poly[2572].contains(lat,lng)) return 286;
                    if (poly[2573].contains(lat,lng)) return 287;
                    if (poly[2574].contains(lat,lng)) return 287;
                    else return 241;
                }
            else
            if (lng < 96.034627f)
            {
                if (poly[2575].contains(lat,lng)) return 252;
                else return 241;
            }
            else
            if (lat < 49.303697f)
            {
                if (poly[2576].contains(lat,lng)) return 286;
                if (poly[2577].contains(lat,lng)) return 286;
                else return 241;
            }
            else
            if (lng < 97.487793f)
            {
                if (poly[2578].contains(lat,lng)) return 252;
                if (poly[2579].contains(lat,lng)) return 286;
                else return 241;
            }
            else
            {
                if (poly[2580].contains(lat,lng)) return 252;
                else return 286;
            }
        else
        if (lat < 49.113709f)
            if (lat < 39.248044f)
                return 276;
            else
            if (lng < 107.076564f)
            {
                if (poly[2581].contains(lat,lng)) return 241;
                if (poly[2582].contains(lat,lng)) return 276;
                else return 286;
            }
            else
            if (lat < 44.180876f)
            {
                if (poly[2583].contains(lat,lng)) return 286;
                else return 276;
            }
            else
            if (lng < 111.144367f)
                return 286;
            else
            if (lat < 46.647293f)
                if (lng < 113.178269f)
                {
                    if (poly[2584].contains(lat,lng)) return 229;
                    if (poly[2585].contains(lat,lng)) return 276;
                    else return 286;
                }
                else
                {
                    if (poly[2586].contains(lat,lng)) return 276;
                    else return 229;
                }
            else
            {
                if (poly[2587].contains(lat,lng)) return 286;
                else return 229;
            }
        else
        if (lng < 107.076564f)
            if (lng < 103.008762f)
                if (lng < 100.974860f)
                {
                    if (poly[2588].contains(lat,lng)) return 242;
                    else return 286;
                }
                else
                if (lat < 50.631654f)
                {
                    if (poly[2589].contains(lat,lng)) return 242;
                    else return 286;
                }
                else
                {
                    if (poly[2590].contains(lat,lng)) return 286;
                    else return 242;
                }
            else
            {
                if (poly[2591].contains(lat,lng)) return 242;
                else return 286;
            }
        else
        if (lng < 111.144367f)
            if (lng < 109.110466f)
                if (lat < 50.631654f)
                    if (lng < 108.093515f)
                    {
                        if (poly[2592].contains(lat,lng)) return 242;
                        if (poly[2593].contains(lat,lng)) return 286;
                        else return 228;
                    }
                    else
                    {
                        if (poly[2594].contains(lat,lng)) return 242;
                        if (poly[2595].contains(lat,lng)) return 286;
                        else return 228;
                    }
                else
                {
                    if (poly[2596].contains(lat,lng)) return 228;
                    else return 242;
                }
            else
            {
                if (poly[2597].contains(lat,lng)) return 242;
                if (poly[2598].contains(lat,lng)) return 286;
                else return 228;
            }
        else
        {
            if (poly[2599].contains(lat,lng)) return 229;
            if (poly[2600].contains(lat,lng)) return 242;
            if (poly[2601].contains(lat,lng)) return 286;
            else return 228;
        }
    }

    private static int call40(float lat, float lng)
    {
        if (lat < 57.237834f)
            if (lng < 71.677329f)
                if (lat < 54.668015f)
                    if (lat < 54.184945f)
                        if (lng < 71.296101f)
                        {
                            if (poly[2602].contains(lat,lng)) return 264;
                            else return 213;
                        }
                        else
                        {
                            if (poly[2603].contains(lat,lng)) return 213;
                            else return 264;
                        }
                    else
                    {
                        if (poly[2604].contains(lat,lng)) return 213;
                        else return 264;
                    }
                else
                if (lat < 56.765223f)
                {
                    if (poly[2605].contains(lat,lng)) return 293;
                    else return 264;
                }
                else
                {
                    if (poly[2606].contains(lat,lng)) return 293;
                    else return 264;
                }
            else
            if (lng < 85.115957f)
                if (lng < 78.396643f)
                    if (lng < 75.036986f)
                        if (lat < 54.693717f)
                            if (lng < 73.357157f)
                                if (lat < 53.421658f)
                                    return 213;
                                else
                                if (lng < 72.517243f)
                                {
                                    if (poly[2607].contains(lat,lng)) return 264;
                                    else return 213;
                                }
                                else
                                {
                                    if (poly[2608].contains(lat,lng)) return 264;
                                    if (poly[2609].contains(lat,lng)) return 264;
                                    else return 213;
                                }
                            else
                            {
                                if (poly[2610].contains(lat,lng)) return 264;
                                else return 213;
                            }
                        else
                            return 264;
                    else
                    if (lat < 54.693717f)
                        if (lng < 76.716814f)
                        {
                            if (poly[2611].contains(lat,lng)) return 213;
                            if (poly[2612].contains(lat,lng)) return 264;
                            else return 263;
                        }
                        else
                        {
                            if (poly[2613].contains(lat,lng)) return 213;
                            if (poly[2614].contains(lat,lng)) return 213;
                            if (poly[2615].contains(lat,lng)) return 224;
                            else return 263;
                        }
                    else
                    if (lng < 76.716814f)
                        if (lat < 55.965775f)
                        {
                            if (poly[2616].contains(lat,lng)) return 264;
                            if (poly[2617].contains(lat,lng)) return 264;
                            else return 263;
                        }
                        else
                        {
                            if (poly[2618].contains(lat,lng)) return 264;
                            if (poly[2619].contains(lat,lng)) return 285;
                            else return 263;
                        }
                    else
                    {
                        if (poly[2620].contains(lat,lng)) return 285;
                        else return 263;
                    }
                else
                if (lng < 81.756300f)
                    if (lat < 54.693717f)
                        if (lng < 80.076471f)
                        {
                            if (poly[2621].contains(lat,lng)) return 213;
                            if (poly[2622].contains(lat,lng)) return 263;
                            else return 224;
                        }
                        else
                        {
                            if (poly[2623].contains(lat,lng)) return 263;
                            if (poly[2624].contains(lat,lng)) return 263;
                            if (poly[2625].contains(lat,lng)) return 263;
                            else return 224;
                        }
                    else
                    {
                        if (poly[2626].contains(lat,lng)) return 285;
                        else return 263;
                    }
                else
                if (lat < 54.693717f)
                    if (lng < 83.436128f)
                    {
                        if (poly[2627].contains(lat,lng)) return 263;
                        else return 224;
                    }
                    else
                    {
                        if (poly[2628].contains(lat,lng)) return 224;
                        if (poly[2629].contains(lat,lng)) return 262;
                        else return 263;
                    }
                else
                if (lng < 83.436128f)
                {
                    if (poly[2630].contains(lat,lng)) return 285;
                    else return 263;
                }
                else
                if (lat < 55.965775f)
                    if (lng < 84.276043f)
                    {
                        if (poly[2631].contains(lat,lng)) return 285;
                        else return 263;
                    }
                    else
                    {
                        if (poly[2632].contains(lat,lng)) return 263;
                        else return 262;
                    }
                else
                {
                    if (poly[2633].contains(lat,lng)) return 262;
                    if (poly[2634].contains(lat,lng)) return 263;
                    else return 285;
                }
            else
            if (lat < 55.866563f)
                if (lng < 87.259300f)
                {
                    if (poly[2635].contains(lat,lng)) return 224;
                    else return 262;
                }
                else
                if (lat < 54.008082f)
                    if (lng < 88.330972f)
                    {
                        if (poly[2636].contains(lat,lng)) return 262;
                        else return 224;
                    }
                    else
                    if (lat < 53.078841f)
                    {
                        if (poly[2637].contains(lat,lng)) return 224;
                        if (poly[2638].contains(lat,lng)) return 252;
                        else return 262;
                    }
                    else
                    {
                        if (poly[2639].contains(lat,lng)) return 262;
                        else return 252;
                    }
                else
                {
                    if (poly[2640].contains(lat,lng)) return 252;
                    else return 262;
                }
            else
            if (lng < 87.259300f)
            {
                if (poly[2641].contains(lat,lng)) return 285;
                else return 262;
            }
            else
            if (lng < 88.330972f)
            {
                if (poly[2642].contains(lat,lng)) return 285;
                else return 262;
            }
            else
            {
                if (poly[2643].contains(lat,lng)) return 262;
                if (poly[2644].contains(lat,lng)) return 285;
                else return 252;
            }
        else
        if (lat < 73.721756f)
            if (lng < 80.335949f)
                if (lat < 65.479795f)
                    if (lng < 75.802602f)
                    {
                        if (poly[2645].contains(lat,lng)) return 285;
                        if (poly[2646].contains(lat,lng)) return 293;
                        else return 264;
                    }
                    else
                    if (lat < 61.358814f)
                        if (lng < 78.069276f)
                        {
                            if (poly[2647].contains(lat,lng)) return 264;
                            if (poly[2648].contains(lat,lng)) return 293;
                            else return 285;
                        }
                        else
                        {
                            if (poly[2649].contains(lat,lng)) return 293;
                            else return 285;
                        }
                    else
                        return 293;
                else
                if (lng < 75.802602f)
                    return 293;
                else
                if (lat < 69.600775f)
                {
                    if (poly[2650].contains(lat,lng)) return 252;
                    else return 293;
                }
                else
                if (lng < 78.069276f)
                {
                    if (poly[2651].contains(lat,lng)) return 252;
                    else return 293;
                }
                else
                if (lat < 71.661266f)
                    if (lng < 79.202613f)
                    {
                        if (poly[2652].contains(lat,lng)) return 252;
                        if (poly[2653].contains(lat,lng)) return 252;
                        if (poly[2654].contains(lat,lng)) return 252;
                        else return 293;
                    }
                    else
                    {
                        if (poly[2655].contains(lat,lng)) return 293;
                        if (poly[2656].contains(lat,lng)) return 293;
                        if (poly[2657].contains(lat,lng)) return 293;
                        else return 252;
                    }
                else
                {
                    if (poly[2658].contains(lat,lng)) return 293;
                    else return 252;
                }
            else
            if (lat < 65.479795f)
                if (lng < 84.869297f)
                    if (lat < 61.358814f)
                    {
                        if (poly[2659].contains(lat,lng)) return 252;
                        if (poly[2660].contains(lat,lng)) return 293;
                        else return 285;
                    }
                    else
                    {
                        if (poly[2661].contains(lat,lng)) return 252;
                        if (poly[2662].contains(lat,lng)) return 252;
                        else return 293;
                    }
                else
                if (lat < 61.358814f)
                {
                    if (poly[2663].contains(lat,lng)) return 285;
                    if (poly[2664].contains(lat,lng)) return 293;
                    else return 252;
                }
                else
                if (lng < 87.135970f)
                    if (lat < 63.419305f)
                    {
                        if (poly[2665].contains(lat,lng)) return 293;
                        if (poly[2666].contains(lat,lng)) return 293;
                        else return 252;
                    }
                    else
                    {
                        if (poly[2667].contains(lat,lng)) return 293;
                        else return 252;
                    }
                else
                    return 252;
            else
            if (lng < 84.869297f)
                if (lat < 69.600775f)
                    if (lng < 82.602623f)
                        if (lat < 67.540285f)
                        {
                            if (poly[2668].contains(lat,lng)) return 252;
                            if (poly[2669].contains(lat,lng)) return 252;
                            if (poly[2670].contains(lat,lng)) return 252;
                            else return 293;
                        }
                        else
                        if (lng < 81.469286f)
                        {
                            if (poly[2671].contains(lat,lng)) return 293;
                            else return 252;
                        }
                        else
                        {
                            if (poly[2672].contains(lat,lng)) return 293;
                            if (poly[2673].contains(lat,lng)) return 293;
                            if (poly[2674].contains(lat,lng)) return 293;
                            else return 252;
                        }
                    else
                    {
                        if (poly[2675].contains(lat,lng)) return 293;
                        if (poly[2676].contains(lat,lng)) return 293;
                        else return 252;
                    }
                else
                {
                    if (poly[2677].contains(lat,lng)) return 293;
                    if (poly[2678].contains(lat,lng)) return 293;
                    else return 252;
                }
            else
                return 252;
        else
            return 252;
    }

    private static int call41(float lat, float lng)
    {
        if (lng < 102.307407f)
            if (lat < 63.521722f)
                if (lng < 95.855025f)
                {
                    if (poly[2679].contains(lat,lng)) return 242;
                    else return 252;
                }
                else
                if (lat < 57.835661f)
                    if (lng < 99.081216f)
                        if (lat < 54.992631f)
                            if (lng < 97.468121f)
                            {
                                if (poly[2680].contains(lat,lng)) return 242;
                                else return 252;
                            }
                            else
                            {
                                if (poly[2681].contains(lat,lng)) return 252;
                                else return 242;
                            }
                        else
                        if (lng < 97.468121f)
                        {
                            if (poly[2682].contains(lat,lng)) return 242;
                            if (poly[2683].contains(lat,lng)) return 242;
                            else return 252;
                        }
                        else
                        {
                            if (poly[2684].contains(lat,lng)) return 252;
                            if (poly[2685].contains(lat,lng)) return 252;
                            else return 242;
                        }
                    else
                    {
                        if (poly[2686].contains(lat,lng)) return 252;
                        if (poly[2687].contains(lat,lng)) return 252;
                        if (poly[2688].contains(lat,lng)) return 252;
                        else return 242;
                    }
                else
                {
                    if (poly[2689].contains(lat,lng)) return 252;
                    else return 242;
                }
            else
                return 252;
        else
        if (lat < 63.521722f)
            if (lng < 108.759788f)
                if (lat < 57.835661f)
                    return 242;
                else
                if (lng < 105.533598f)
                    if (lat < 60.678692f)
                        if (lng < 103.920502f)
                        {
                            if (poly[2690].contains(lat,lng)) return 242;
                            else return 252;
                        }
                        else
                        if (lat < 59.257177f)
                        {
                            if (poly[2691].contains(lat,lng)) return 252;
                            else return 242;
                        }
                        else
                        {
                            if (poly[2692].contains(lat,lng)) return 252;
                            else return 242;
                        }
                    else
                    {
                        if (poly[2693].contains(lat,lng)) return 242;
                        else return 252;
                    }
                else
                {
                    if (poly[2694].contains(lat,lng)) return 252;
                    else return 242;
                }
            else
            if (lat < 57.835661f)
                if (lng < 111.985979f)
                {
                    if (poly[2695].contains(lat,lng)) return 228;
                    else return 242;
                }
                else
                if (lat < 54.992631f)
                    if (lng < 113.599075f)
                    {
                        if (poly[2696].contains(lat,lng)) return 242;
                        else return 228;
                    }
                    else
                    if (lat < 53.571115f)
                    {
                        if (poly[2697].contains(lat,lng)) return 242;
                        else return 228;
                    }
                    else
                    {
                        if (poly[2698].contains(lat,lng)) return 228;
                        else return 242;
                    }
                else
                    return 242;
            else
            if (lng < 111.985979f)
                if (lat < 60.678692f)
                    if (lng < 110.372884f)
                    {
                        if (poly[2699].contains(lat,lng)) return 291;
                        else return 242;
                    }
                    else
                    {
                        if (poly[2700].contains(lat,lng)) return 291;
                        else return 242;
                    }
                else
                if (lng < 110.372884f)
                    if (lat < 62.100207f)
                    {
                        if (poly[2701].contains(lat,lng)) return 291;
                        if (poly[2702].contains(lat,lng)) return 291;
                        else return 242;
                    }
                    else
                    {
                        if (poly[2703].contains(lat,lng)) return 291;
                        else return 242;
                    }
                else
                {
                    if (poly[2704].contains(lat,lng)) return 242;
                    else return 291;
                }
            else
            if (lat < 60.678692f)
                if (lng < 113.599075f)
                {
                    if (poly[2705].contains(lat,lng)) return 291;
                    else return 242;
                }
                else
                {
                    if (poly[2706].contains(lat,lng)) return 291;
                    if (poly[2707].contains(lat,lng)) return 291;
                    else return 242;
                }
            else
                return 291;
        else
        if (lng < 108.759788f)
            if (lat < 69.207784f)
                if (lng < 105.533598f)
                {
                    if (poly[2708].contains(lat,lng)) return 291;
                    else return 252;
                }
                else
                if (lat < 66.364753f)
                    if (lng < 107.146693f)
                        if (lat < 64.943238f)
                        {
                            if (poly[2709].contains(lat,lng)) return 242;
                            if (poly[2710].contains(lat,lng)) return 291;
                            else return 252;
                        }
                        else
                        {
                            if (poly[2711].contains(lat,lng)) return 291;
                            else return 252;
                        }
                    else
                    if (lat < 64.943238f)
                        if (lng < 107.953241f)
                        {
                            if (poly[2712].contains(lat,lng)) return 242;
                            if (poly[2713].contains(lat,lng)) return 291;
                            else return 252;
                        }
                        else
                        {
                            if (poly[2714].contains(lat,lng)) return 252;
                            if (poly[2715].contains(lat,lng)) return 291;
                            if (poly[2716].contains(lat,lng)) return 291;
                            if (poly[2717].contains(lat,lng)) return 291;
                            else return 242;
                        }
                    else
                        return 291;
                else
                {
                    if (poly[2718].contains(lat,lng)) return 291;
                    else return 252;
                }
            else
            {
                if (poly[2719].contains(lat,lng)) return 291;
                else return 252;
            }
        else
        if (lat < 69.207784f)
        {
            if (poly[2720].contains(lat,lng)) return 242;
            if (poly[2721].contains(lat,lng)) return 242;
            if (poly[2722].contains(lat,lng)) return 242;
            else return 291;
        }
        else
        if (lng < 111.985979f)
            if (lat < 72.050814f)
            {
                if (poly[2723].contains(lat,lng)) return 291;
                else return 252;
            }
            else
            if (lng < 110.372884f)
            {
                if (poly[2724].contains(lat,lng)) return 291;
                if (poly[2725].contains(lat,lng)) return 291;
                else return 252;
            }
            else
            if (lat < 73.472330f)
            {
                if (poly[2726].contains(lat,lng)) return 291;
                else return 252;
            }
            else
            {
                if (poly[2727].contains(lat,lng)) return 291;
                else return 252;
            }
        else
        {
            if (poly[2728].contains(lat,lng)) return 252;
            if (poly[2729].contains(lat,lng)) return 252;
            else return 291;
        }
    }

    private static int call42(float lat, float lng)
    {
        if (lat < 52.149600f)
            if (lng < 87.315632f)
                if (lat < 39.621629f)
                    if (lng < 70.534430f)
                        if (lat < 34.047710f)
                            if (lat < 33.798521f)
                            {
                                if (poly[2730].contains(lat,lng)) return 246;
                                else return 248;
                            }
                            else
                            {
                                if (poly[2731].contains(lat,lng)) return 248;
                                else return 246;
                            }
                        else
                        if (lat < 38.208711f)
                        {
                            if (poly[2732].contains(lat,lng)) return 235;
                            else return 246;
                        }
                        else
                        {
                            if (poly[2733].contains(lat,lng)) return 226;
                            else return 235;
                        }
                    else
                    if (lng < 78.925031f)
                        return call37(lat,lng);
                    else
                    if (lat < 33.934308f)
                        if (lng < 83.120331f)
                            if (lat < 31.090648f)
                                if (lng < 81.022681f)
                                    if (lat < 29.668817f)
                                    {
                                        if (poly[2734].contains(lat,lng)) return 251;
                                        else return 249;
                                    }
                                    else
                                    {
                                        if (poly[2735].contains(lat,lng)) return 249;
                                        if (poly[2736].contains(lat,lng)) return 276;
                                        else return 251;
                                    }
                                else
                                if (lat < 29.668817f)
                                {
                                    if (poly[2737].contains(lat,lng)) return 251;
                                    if (poly[2738].contains(lat,lng)) return 276;
                                    if (poly[2739].contains(lat,lng)) return 276;
                                    else return 249;
                                }
                                else
                                if (lng < 82.071506f)
                                {
                                    if (poly[2740].contains(lat,lng)) return 251;
                                    if (poly[2741].contains(lat,lng)) return 276;
                                    else return 249;
                                }
                                else
                                {
                                    if (poly[2742].contains(lat,lng)) return 249;
                                    if (poly[2743].contains(lat,lng)) return 249;
                                    else return 276;
                                }
                            else
                            {
                                if (poly[2744].contains(lat,lng)) return 251;
                                if (poly[2745].contains(lat,lng)) return 251;
                                else return 276;
                            }
                        else
                        if (lat < 31.090648f)
                            if (lng < 85.217982f)
                                if (lat < 29.668817f)
                                    if (lng < 84.169157f)
                                    {
                                        if (poly[2746].contains(lat,lng)) return 276;
                                        if (poly[2747].contains(lat,lng)) return 276;
                                        else return 249;
                                    }
                                    else
                                    {
                                        if (poly[2748].contains(lat,lng)) return 276;
                                        else return 249;
                                    }
                                else
                                    return 276;
                            else
                            {
                                if (poly[2749].contains(lat,lng)) return 249;
                                else return 276;
                            }
                        else
                            return 276;
                    else
                    {
                        if (poly[2750].contains(lat,lng)) return 251;
                        if (poly[2751].contains(lat,lng)) return 276;
                        else return 287;
                    }
                else
                if (lng < 73.139736f)
                    if (lat < 40.785252f)
                        if (lng < 70.983890f)
                            if (lat < 39.891552f)
                            {
                                if (poly[2752].contains(lat,lng)) return 226;
                                else return 235;
                            }
                            else
                            if (lng < 70.470557f)
                            {
                                if (poly[2753].contains(lat,lng)) return 226;
                                if (poly[2754].contains(lat,lng)) return 280;
                                if (poly[2755].contains(lat,lng)) return 280;
                                else return 235;
                            }
                            else
                            {
                                if (poly[2756].contains(lat,lng)) return 226;
                                if (poly[2757].contains(lat,lng)) return 226;
                                if (poly[2758].contains(lat,lng)) return 280;
                                else return 235;
                            }
                        else
                        if (lng < 71.226069f)
                            if (lat < 40.185134f)
                            {
                                if (poly[2759].contains(lat,lng)) return 226;
                                else return 280;
                            }
                            else
                            if (lat < 40.267114f)
                            {
                                if (poly[2760].contains(lat,lng)) return 280;
                                else return 226;
                            }
                            else
                            {
                                if (poly[2761].contains(lat,lng)) return 280;
                                else return 226;
                            }
                        else
                        if (lat < 40.008003f)
                        {
                            if (poly[2762].contains(lat,lng)) return 226;
                            else return 280;
                        }
                        else
                        if (lng < 72.182902f)
                        {
                            if (poly[2763].contains(lat,lng)) return 226;
                            else return 280;
                        }
                        else
                        {
                            if (poly[2764].contains(lat,lng)) return 280;
                            else return 226;
                        }
                    else
                    if (lat < 46.467426f)
                        if (lat < 43.626339f)
                            if (lng < 71.548480f)
                                if (lat < 42.205796f)
                                    if (lng < 70.752853f)
                                        if (lat < 41.495524f)
                                        {
                                            if (poly[2765].contains(lat,lng)) return 226;
                                            if (poly[2766].contains(lat,lng)) return 226;
                                            if (poly[2767].contains(lat,lng)) return 235;
                                            if (poly[2768].contains(lat,lng)) return 235;
                                            else return 280;
                                        }
                                        else
                                        {
                                            if (poly[2769].contains(lat,lng)) return 213;
                                            if (poly[2770].contains(lat,lng)) return 226;
                                            else return 280;
                                        }
                                    else
                                    {
                                        if (poly[2771].contains(lat,lng)) return 213;
                                        if (poly[2772].contains(lat,lng)) return 213;
                                        if (poly[2773].contains(lat,lng)) return 226;
                                        else return 280;
                                    }
                                else
                                {
                                    if (poly[2774].contains(lat,lng)) return 226;
                                    if (poly[2775].contains(lat,lng)) return 280;
                                    if (poly[2776].contains(lat,lng)) return 280;
                                    else return 213;
                                }
                            else
                            if (lat < 42.205796f)
                            {
                                if (poly[2777].contains(lat,lng)) return 280;
                                else return 226;
                            }
                            else
                            {
                                if (poly[2778].contains(lat,lng)) return 226;
                                else return 213;
                            }
                        else
                            return 213;
                    else
                        return 213;
                else
                    return call38(lat,lng);
            else
            if (lat < 29.382378f)
                if (lng < 97.274264f)
                    if (lng < 92.294948f)
                        return 276;
                    else
                    if (lng < 94.784606f)
                    {
                        if (poly[2779].contains(lat,lng)) return 251;
                        else return 276;
                    }
                    else
                    if (lng < 96.029435f)
                    {
                        if (poly[2780].contains(lat,lng)) return 276;
                        else return 251;
                    }
                    else
                    {
                        if (poly[2781].contains(lat,lng)) return 251;
                        else return 276;
                    }
                else
                {
                    if (poly[2782].contains(lat,lng)) return 292;
                    else return 276;
                }
            else
                return call39(lat,lng);
        else
        if (lat < 74.893845f)
            if (lng < 71.269255f)
                if (lat < 56.046981f)
                    if (lat < 54.609784f)
                    {
                        if (poly[2783].contains(lat,lng)) return 264;
                        else return 213;
                    }
                    else
                    {
                        if (poly[2784].contains(lat,lng)) return 213;
                        if (poly[2785].contains(lat,lng)) return 293;
                        else return 264;
                    }
                else
                if (lat < 56.691085f)
                    if (lat < 56.361732f)
                        if (lng < 70.948417f)
                            if (lat < 56.304836f)
                            {
                                if (poly[2786].contains(lat,lng)) return 264;
                                else return 293;
                            }
                            else
                            {
                                if (poly[2787].contains(lat,lng)) return 264;
                                else return 293;
                            }
                        else
                        if (lng < 71.092014f)
                        {
                            if (poly[2788].contains(lat,lng)) return 293;
                            else return 264;
                        }
                        else
                        {
                            if (poly[2789].contains(lat,lng)) return 293;
                            else return 264;
                        }
                    else
                    {
                        if (poly[2790].contains(lat,lng)) return 293;
                        if (poly[2791].contains(lat,lng)) return 293;
                        else return 264;
                    }
                else
                {
                    if (poly[2792].contains(lat,lng)) return 264;
                    else return 293;
                }
            else
            if (lng < 89.402644f)
                return call40(lat,lng);
            else
                return call41(lat,lng);
        else
            return 252;
    }

    private static int call43(float lat, float lng)
    {
        if (lng < 79.395921f)
            if (lng < 60.054577f)
                if (lat < 19.000000f)
                    if (lng < 51.617770f)
                        if (lat < 14.411063f)
                            if (lng < 40.259453f)
                            {
                                if (poly[2793].contains(lat,lng)) return 5;
                                else return 3;
                            }
                            else
                            if (lng < 45.938612f)
                                if (lat < 10.435032f)
                                {
                                    if (poly[2794].contains(lat,lng)) return 41;
                                    else return 3;
                                }
                                else
                                if (lng < 43.099032f)
                                    if (lat < 12.423047f)
                                    {
                                        if (poly[2795].contains(lat,lng)) return 3;
                                        if (poly[2796].contains(lat,lng)) return 5;
                                        if (poly[2797].contains(lat,lng)) return 41;
                                        else return 19;
                                    }
                                    else
                                    {
                                        if (poly[2798].contains(lat,lng)) return 3;
                                        if (poly[2799].contains(lat,lng)) return 19;
                                        if (poly[2800].contains(lat,lng)) return 19;
                                        if (poly[2801].contains(lat,lng)) return 212;
                                        else return 5;
                                    }
                                else
                                {
                                    if (poly[2802].contains(lat,lng)) return 5;
                                    if (poly[2803].contains(lat,lng)) return 19;
                                    if (poly[2804].contains(lat,lng)) return 41;
                                    else return 212;
                                }
                            else
                            {
                                if (poly[2805].contains(lat,lng)) return 3;
                                if (poly[2806].contains(lat,lng)) return 212;
                                else return 41;
                            }
                        else
                        if (lng < 45.922675f)
                            if (lng < 43.075128f)
                            {
                                if (poly[2807].contains(lat,lng)) return 5;
                                if (poly[2808].contains(lat,lng)) return 272;
                                else return 212;
                            }
                            else
                            if (lat < 16.705531f)
                            {
                                if (poly[2809].contains(lat,lng)) return 272;
                                else return 212;
                            }
                            else
                            {
                                if (poly[2810].contains(lat,lng)) return 212;
                                else return 272;
                            }
                        else
                        {
                            if (poly[2811].contains(lat,lng)) return 272;
                            else return 212;
                        }
                    else
                    if (lat < 12.912992f)
                        return 212;
                    else
                    if (lng < 52.000000f)
                    {
                        if (poly[2812].contains(lat,lng)) return 272;
                        else return 212;
                    }
                    else
                    {
                        if (poly[2813].contains(lat,lng)) return 212;
                        else return 260;
                    }
                else
                if (lng < 51.873474f)
                    if (lat < 26.687244f)
                        if (lng < 46.050527f)
                            return 272;
                        else
                        if (lat < 22.843622f)
                            return 272;
                        else
                        if (lng < 48.962001f)
                            return 272;
                        else
                        if (lat < 24.765433f)
                        {
                            if (poly[2814].contains(lat,lng)) return 234;
                            if (poly[2815].contains(lat,lng)) return 269;
                            else return 272;
                        }
                        else
                        {
                            if (poly[2816].contains(lat,lng)) return 221;
                            if (poly[2817].contains(lat,lng)) return 272;
                            else return 269;
                        }
                    else
                    if (lng < 50.475558f)
                    {
                        if (poly[2818].contains(lat,lng)) return 282;
                        else return 272;
                    }
                    else
                        return 282;
                else
                if (lat < 25.008764f)
                    if (lng < 55.964026f)
                        if (lat < 22.004382f)
                        {
                            if (poly[2819].contains(lat,lng)) return 272;
                            else return 260;
                        }
                        else
                        {
                            if (poly[2820].contains(lat,lng)) return 260;
                            if (poly[2821].contains(lat,lng)) return 260;
                            if (poly[2822].contains(lat,lng)) return 269;
                            if (poly[2823].contains(lat,lng)) return 269;
                            if (poly[2824].contains(lat,lng)) return 272;
                            else return 234;
                        }
                    else
                    {
                        if (poly[2825].contains(lat,lng)) return 234;
                        if (poly[2826].contains(lat,lng)) return 234;
                        else return 260;
                    }
                else
                if (lng < 53.252289f)
                    if (lat < 25.361546f)
                        if (lng < 52.455827f)
                        {
                            if (poly[2827].contains(lat,lng)) return 234;
                            else return 269;
                        }
                        else
                            return 234;
                    else
                    if (lat < 26.221460f)
                        return 269;
                    else
                        return 282;
                else
                if (lng < 54.461109f)
                    if (lat < 25.580043f)
                        return 234;
                    else
                        return 282;
                else
                if (lng < 57.257843f)
                    if (lat < 26.627876f)
                        if (lng < 55.859476f)
                        {
                            if (poly[2828].contains(lat,lng)) return 282;
                            else return 234;
                        }
                        else
                        {
                            if (poly[2829].contains(lat,lng)) return 234;
                            if (poly[2830].contains(lat,lng)) return 234;
                            if (poly[2831].contains(lat,lng)) return 282;
                            if (poly[2832].contains(lat,lng)) return 282;
                            else return 260;
                        }
                    else
                    {
                        if (poly[2833].contains(lat,lng)) return 260;
                        else return 282;
                    }
                else
                    return 282;
            else
            if (lat < 12.113083f)
                if (lat < 7.310625f)
                    return 385;
                else
                    return 251;
            else
            if (lat < 12.577255f)
                return 251;
            else
            if (lng < 63.333270f)
                if (lat < 26.544310f)
                {
                    if (poly[2834].contains(lat,lng)) return 282;
                    else return 248;
                }
                else
                {
                    if (poly[2835].contains(lat,lng)) return 282;
                    else return 248;
                }
            else
            if (lng < 71.364596f)
                if (lng < 67.348933f)
                    return 248;
                else
                if (lat < 24.345118f)
                {
                    if (poly[2836].contains(lat,lng)) return 248;
                    if (poly[2837].contains(lat,lng)) return 248;
                    else return 251;
                }
                else
                if (lng < 69.356764f)
                    return 248;
                else
                if (lat < 26.296053f)
                {
                    if (poly[2838].contains(lat,lng)) return 251;
                    if (poly[2839].contains(lat,lng)) return 251;
                    else return 248;
                }
                else
                {
                    if (poly[2840].contains(lat,lng)) return 251;
                    else return 248;
                }
            else
            {
                if (poly[2841].contains(lat,lng)) return 248;
                else return 251;
            }
        else
        if (lng < 109.670985f)
            if (lng < 94.478373f)
                if (lat < 14.389697f)
                    if (lng < 82.081014f)
                        if (lat < 9.534601f)
                        {
                            if (poly[2842].contains(lat,lng)) return 251;
                            else return 230;
                        }
                        else
                        {
                            if (poly[2843].contains(lat,lng)) return 230;
                            else return 251;
                        }
                    else
                    if (lat < 13.661110f)
                        return 251;
                    else
                    {
                        if (poly[2844].contains(lat,lng)) return 251;
                        else return 292;
                    }
                else
                    return call29(lat,lng);
            else
                return call31(lat,lng);
        else
        if (lat < 10.229958f)
            if (lng < 112.663898f)
                return 239;
            else
                return 276;
        else
        if (lat < 11.398160f)
            if (lat < 11.249496f)
            {
                if (poly[2845].contains(lat,lng)) return 276;
                else return 259;
            }
            else
                return 239;
        else
        if (lng < 112.952690f)
            return 276;
        else
        if (lng < 113.630139f)
        {
            if (poly[2846].contains(lat,lng)) return 276;
            else return 256;
        }
        else
        {
            if (poly[2847].contains(lat,lng)) return 276;
            else return 240;
        }
    }

    private static int call44(float lat, float lng)
    {
        if (lat < 53.560815f)
            if (lng < 123.271244f)
            {
                if (poly[2848].contains(lat,lng)) return 291;
                else return 276;
            }
            else
            if (lat < 43.008964f)
                if (lng < 128.951950f)
                    if (lng < 126.111597f)
                        if (lat < 40.816221f)
                        {
                            if (poly[2849].contains(lat,lng)) return 276;
                            else return 268;
                        }
                        else
                        {
                            if (poly[2850].contains(lat,lng)) return 268;
                            else return 276;
                        }
                    else
                    if (lat < 40.816221f)
                        return 268;
                    else
                    if (lng < 127.531774f)
                    {
                        if (poly[2851].contains(lat,lng)) return 276;
                        else return 268;
                    }
                    else
                    {
                        if (poly[2852].contains(lat,lng)) return 276;
                        else return 268;
                    }
                else
                if (lng < 131.792303f)
                    if (lng < 130.372127f)
                        if (lat < 41.597391f)
                            return 268;
                        else
                        if (lng < 129.662038f)
                        {
                            if (poly[2853].contains(lat,lng)) return 276;
                            else return 268;
                        }
                        else
                        {
                            if (poly[2854].contains(lat,lng)) return 276;
                            else return 268;
                        }
                    else
                    {
                        if (poly[2855].contains(lat,lng)) return 268;
                        if (poly[2856].contains(lat,lng)) return 290;
                        else return 276;
                    }
                else
                    return 290;
            else
            if (lng < 130.145337f)
                if (lat < 48.284889f)
                    return 276;
                else
                if (lng < 126.708291f)
                    if (lat < 50.922852f)
                        return 276;
                    else
                    if (lng < 124.989767f)
                    {
                        if (poly[2857].contains(lat,lng)) return 291;
                        else return 276;
                    }
                    else
                    {
                        if (poly[2858].contains(lat,lng)) return 291;
                        if (poly[2859].contains(lat,lng)) return 291;
                        else return 276;
                    }
                else
                if (lat < 50.922852f)
                    if (lng < 128.426814f)
                    {
                        if (poly[2860].contains(lat,lng)) return 291;
                        else return 276;
                    }
                    else
                    {
                        if (poly[2861].contains(lat,lng)) return 291;
                        else return 276;
                    }
                else
                {
                    if (poly[2862].contains(lat,lng)) return 276;
                    if (poly[2863].contains(lat,lng)) return 276;
                    else return 291;
                }
            else
            if (lat < 48.284889f)
                if (lng < 133.582384f)
                    if (lat < 45.646927f)
                        if (lng < 131.863861f)
                        {
                            if (poly[2864].contains(lat,lng)) return 290;
                            else return 276;
                        }
                        else
                        {
                            if (poly[2865].contains(lat,lng)) return 276;
                            else return 290;
                        }
                    else
                    if (lng < 131.863861f)
                    {
                        if (poly[2866].contains(lat,lng)) return 276;
                        else return 290;
                    }
                    else
                    {
                        if (poly[2867].contains(lat,lng)) return 276;
                        else return 290;
                    }
                else
                if (lat < 45.646927f)
                    return 290;
                else
                if (lng < 135.300908f)
                    if (lat < 46.965908f)
                    {
                        if (poly[2868].contains(lat,lng)) return 276;
                        else return 290;
                    }
                    else
                    {
                        if (poly[2869].contains(lat,lng)) return 276;
                        else return 290;
                    }
                else
                    return 290;
            else
            if (lng < 133.582384f)
                if (lat < 50.922852f)
                    if (lng < 131.863861f)
                        if (lat < 49.603871f)
                        {
                            if (poly[2870].contains(lat,lng)) return 276;
                            if (poly[2871].contains(lat,lng)) return 291;
                            else return 290;
                        }
                        else
                        {
                            if (poly[2872].contains(lat,lng)) return 291;
                            else return 290;
                        }
                    else
                        return 290;
                else
                if (lng < 131.863861f)
                {
                    if (poly[2873].contains(lat,lng)) return 290;
                    if (poly[2874].contains(lat,lng)) return 290;
                    else return 291;
                }
                else
                if (lat < 52.241834f)
                {
                    if (poly[2875].contains(lat,lng)) return 291;
                    else return 290;
                }
                else
                {
                    if (poly[2876].contains(lat,lng)) return 291;
                    else return 290;
                }
            else
            if (lat < 50.922852f)
            {
                if (poly[2877].contains(lat,lng)) return 276;
                else return 290;
            }
            else
            if (lng < 135.300908f)
                if (lat < 52.241834f)
                    return 290;
                else
                if (lng < 134.441646f)
                {
                    if (poly[2878].contains(lat,lng)) return 291;
                    else return 290;
                }
                else
                {
                    if (poly[2879].contains(lat,lng)) return 291;
                    else return 290;
                }
            else
                return 290;
        else
        if (lat < 53.619653f)
            if (lng < 134.441683f)
                if (lng < 131.491725f)
                    if (lat < 53.600920f)
                    {
                        if (poly[2880].contains(lat,lng)) return 290;
                        else return 291;
                    }
                    else
                    {
                        if (poly[2881].contains(lat,lng)) return 290;
                        else return 291;
                    }
                else
                {
                    if (poly[2882].contains(lat,lng)) return 291;
                    else return 290;
                }
            else
            if (lng < 134.521271f)
            {
                if (poly[2883].contains(lat,lng)) return 291;
                else return 290;
            }
            else
            {
                if (poly[2884].contains(lat,lng)) return 290;
                else return 291;
            }
        else
        if (lat < 62.894403f)
            if (lng < 129.582626f)
                return 291;
            else
            if (lat < 58.257028f)
                if (lng < 133.301028f)
                    if (lat < 55.938340f)
                        if (lng < 131.441827f)
                        {
                            if (poly[2885].contains(lat,lng)) return 290;
                            if (poly[2886].contains(lat,lng)) return 290;
                            if (poly[2887].contains(lat,lng)) return 290;
                            else return 291;
                        }
                        else
                        if (lat < 54.778997f)
                        {
                            if (poly[2888].contains(lat,lng)) return 291;
                            if (poly[2889].contains(lat,lng)) return 291;
                            if (poly[2890].contains(lat,lng)) return 291;
                            if (poly[2891].contains(lat,lng)) return 291;
                            else return 290;
                        }
                        else
                        {
                            if (poly[2892].contains(lat,lng)) return 291;
                            else return 290;
                        }
                    else
                    if (lng < 131.441827f)
                    {
                        if (poly[2893].contains(lat,lng)) return 290;
                        if (poly[2894].contains(lat,lng)) return 290;
                        if (poly[2895].contains(lat,lng)) return 290;
                        else return 291;
                    }
                    else
                    if (lat < 57.097684f)
                    {
                        if (poly[2896].contains(lat,lng)) return 291;
                        if (poly[2897].contains(lat,lng)) return 291;
                        else return 290;
                    }
                    else
                    {
                        if (poly[2898].contains(lat,lng)) return 290;
                        else return 291;
                    }
                else
                    return 290;
            else
            if (lng < 133.301028f)
                if (lat < 60.575716f)
                    if (lng < 131.441827f)
                        return 291;
                    else
                    if (lat < 59.416372f)
                        if (lng < 132.371428f)
                        {
                            if (poly[2899].contains(lat,lng)) return 250;
                            if (poly[2900].contains(lat,lng)) return 290;
                            if (poly[2901].contains(lat,lng)) return 290;
                            else return 291;
                        }
                        else
                        {
                            if (poly[2902].contains(lat,lng)) return 250;
                            if (poly[2903].contains(lat,lng)) return 291;
                            else return 290;
                        }
                    else
                    {
                        if (poly[2904].contains(lat,lng)) return 291;
                        else return 250;
                    }
                else
                {
                    if (poly[2905].contains(lat,lng)) return 250;
                    else return 291;
                }
            else
            if (lat < 60.575716f)
            {
                if (poly[2906].contains(lat,lng)) return 290;
                else return 250;
            }
            else
            if (lng < 135.160230f)
            {
                if (poly[2907].contains(lat,lng)) return 291;
                else return 250;
            }
            else
            {
                if (poly[2908].contains(lat,lng)) return 291;
                else return 250;
            }
        else
        if (lng < 129.582626f)
            return 291;
        else
        if (lat < 67.531778f)
            if (lng < 133.301028f)
                if (lat < 65.213090f)
                    if (lng < 131.441827f)
                        return 291;
                    else
                    if (lat < 64.053747f)
                    {
                        if (poly[2909].contains(lat,lng)) return 250;
                        else return 291;
                    }
                    else
                    {
                        if (poly[2910].contains(lat,lng)) return 250;
                        if (poly[2911].contains(lat,lng)) return 291;
                        else return 290;
                    }
                else
                {
                    if (poly[2912].contains(lat,lng)) return 250;
                    if (poly[2913].contains(lat,lng)) return 291;
                    else return 290;
                }
            else
            {
                if (poly[2914].contains(lat,lng)) return 290;
                if (poly[2915].contains(lat,lng)) return 291;
                else return 250;
            }
        else
        if (lng < 133.301028f)
            if (lat < 69.850465f)
            {
                if (poly[2916].contains(lat,lng)) return 291;
                else return 290;
            }
            else
            {
                if (poly[2917].contains(lat,lng)) return 290;
                else return 291;
            }
        else
        {
            if (poly[2918].contains(lat,lng)) return 291;
            if (poly[2919].contains(lat,lng)) return 291;
            if (poly[2920].contains(lat,lng)) return 291;
            else return 290;
        }
    }

    private static int call45(float lat, float lng)
    {
        if (lng < 137.019431f)
            if (lat < 72.169153f)
                if (lng < 122.145820f)
                    if (lat < 55.396315f)
                        if (lat < 47.009896f)
                            if (lat < 42.816687f)
                                return 276;
                            else
                            if (lng < 118.678995f)
                            {
                                if (poly[2921].contains(lat,lng)) return 276;
                                else return 229;
                            }
                            else
                            {
                                if (poly[2922].contains(lat,lng)) return 229;
                                else return 276;
                            }
                        else
                        if (lat < 51.203105f)
                            if (lng < 118.678995f)
                                if (lat < 49.106501f)
                                {
                                    if (poly[2923].contains(lat,lng)) return 276;
                                    else return 229;
                                }
                                else
                                {
                                    if (poly[2924].contains(lat,lng)) return 229;
                                    if (poly[2925].contains(lat,lng)) return 276;
                                    else return 228;
                                }
                            else
                            if (lat < 49.106501f)
                            {
                                if (poly[2926].contains(lat,lng)) return 229;
                                else return 276;
                            }
                            else
                            {
                                if (poly[2927].contains(lat,lng)) return 228;
                                else return 276;
                            }
                        else
                        if (lng < 118.678995f)
                            if (lat < 53.299710f)
                                return 228;
                            else
                            if (lng < 116.945583f)
                                if (lat < 54.348013f)
                                {
                                    if (poly[2928].contains(lat,lng)) return 242;
                                    else return 228;
                                }
                                else
                                {
                                    if (poly[2929].contains(lat,lng)) return 242;
                                    else return 228;
                                }
                            else
                                return 228;
                        else
                        if (lat < 53.299710f)
                            if (lng < 120.412408f)
                            {
                                if (poly[2930].contains(lat,lng)) return 276;
                                if (poly[2931].contains(lat,lng)) return 276;
                                else return 228;
                            }
                            else
                            {
                                if (poly[2932].contains(lat,lng)) return 228;
                                if (poly[2933].contains(lat,lng)) return 228;
                                if (poly[2934].contains(lat,lng)) return 228;
                                else return 276;
                            }
                        else
                        if (lng < 120.412408f)
                            return 228;
                        else
                        if (lat < 54.348013f)
                        {
                            if (poly[2935].contains(lat,lng)) return 276;
                            if (poly[2936].contains(lat,lng)) return 276;
                            if (poly[2937].contains(lat,lng)) return 291;
                            else return 228;
                        }
                        else
                        {
                            if (poly[2938].contains(lat,lng)) return 291;
                            else return 228;
                        }
                    else
                    if (lat < 63.782734f)
                        if (lat < 59.589524f)
                            if (lng < 118.678995f)
                                if (lat < 57.492920f)
                                    if (lng < 116.945583f)
                                    {
                                        if (poly[2939].contains(lat,lng)) return 242;
                                        else return 228;
                                    }
                                    else
                                    {
                                        if (poly[2940].contains(lat,lng)) return 242;
                                        else return 228;
                                    }
                                else
                                if (lng < 116.945583f)
                                    return 242;
                                else
                                if (lat < 58.541222f)
                                {
                                    if (poly[2941].contains(lat,lng)) return 242;
                                    else return 228;
                                }
                                else
                                {
                                    if (poly[2942].contains(lat,lng)) return 291;
                                    if (poly[2943].contains(lat,lng)) return 291;
                                    if (poly[2944].contains(lat,lng)) return 291;
                                    else return 242;
                                }
                            else
                            if (lat < 57.492920f)
                                if (lng < 120.412408f)
                                    if (lat < 56.444617f)
                                    {
                                        if (poly[2945].contains(lat,lng)) return 291;
                                        if (poly[2946].contains(lat,lng)) return 291;
                                        else return 228;
                                    }
                                    else
                                    {
                                        if (poly[2947].contains(lat,lng)) return 228;
                                        else return 291;
                                    }
                                else
                                {
                                    if (poly[2948].contains(lat,lng)) return 228;
                                    if (poly[2949].contains(lat,lng)) return 228;
                                    else return 291;
                                }
                            else
                            if (lng < 120.412408f)
                                if (lat < 58.541222f)
                                {
                                    if (poly[2950].contains(lat,lng)) return 228;
                                    if (poly[2951].contains(lat,lng)) return 242;
                                    else return 291;
                                }
                                else
                                {
                                    if (poly[2952].contains(lat,lng)) return 242;
                                    if (poly[2953].contains(lat,lng)) return 242;
                                    else return 291;
                                }
                            else
                                return 291;
                        else
                        {
                            if (poly[2954].contains(lat,lng)) return 242;
                            if (poly[2955].contains(lat,lng)) return 242;
                            else return 291;
                        }
                    else
                        return 291;
                else
                    return call44(lat,lng);
            else
            if (lng < 130.330840f)
                return 291;
            else
                return 290;
        else
        if (lat < 55.394243f)
            if (lat < 41.606056f)
                return 284;
            else
            if (lng < 145.050145f)
                if (lat < 48.500150f)
                    if (lng < 141.034788f)
                    {
                        if (poly[2956].contains(lat,lng)) return 274;
                        if (poly[2957].contains(lat,lng)) return 284;
                        if (poly[2958].contains(lat,lng)) return 284;
                        else return 290;
                    }
                    else
                    {
                        if (poly[2959].contains(lat,lng)) return 284;
                        else return 274;
                    }
                else
                if (lng < 141.034788f)
                    return 290;
                else
                {
                    if (poly[2960].contains(lat,lng)) return 290;
                    else return 274;
                }
            else
            {
                if (poly[2961].contains(lat,lng)) return 284;
                else return 288;
            }
        else
        if (lat < 56.593646f)
            return 290;
        else
        if (lat < 72.761219f)
            if (lat < 65.575894f)
                if (lng < 141.011174f)
                    if (lat < 61.084770f)
                    {
                        if (poly[2962].contains(lat,lng)) return 250;
                        else return 290;
                    }
                    else
                    if (lat < 63.330332f)
                        if (lng < 139.015303f)
                        {
                            if (poly[2963].contains(lat,lng)) return 290;
                            else return 250;
                        }
                        else
                        if (lat < 62.207551f)
                        {
                            if (poly[2964].contains(lat,lng)) return 250;
                            else return 290;
                        }
                        else
                        {
                            if (poly[2965].contains(lat,lng)) return 288;
                            if (poly[2966].contains(lat,lng)) return 290;
                            else return 250;
                        }
                    else
                    if (lng < 139.015303f)
                        return 250;
                    else
                    if (lat < 64.453113f)
                    {
                        if (poly[2967].contains(lat,lng)) return 288;
                        else return 250;
                    }
                    else
                    {
                        if (poly[2968].contains(lat,lng)) return 250;
                        if (poly[2969].contains(lat,lng)) return 278;
                        else return 288;
                    }
                else
                if (lng < 146.109588f)
                    if (lat < 61.832713f)
                    {
                        if (poly[2970].contains(lat,lng)) return 257;
                        if (poly[2971].contains(lat,lng)) return 288;
                        if (poly[2972].contains(lat,lng)) return 288;
                        else return 290;
                    }
                    else
                    if (lng < 143.560381f)
                        if (lat < 63.704303f)
                        {
                            if (poly[2973].contains(lat,lng)) return 290;
                            else return 288;
                        }
                        else
                        {
                            if (poly[2974].contains(lat,lng)) return 278;
                            else return 288;
                        }
                    else
                    if (lat < 63.704303f)
                        if (lng < 144.834984f)
                        {
                            if (poly[2975].contains(lat,lng)) return 257;
                            if (poly[2976].contains(lat,lng)) return 290;
                            if (poly[2977].contains(lat,lng)) return 290;
                            else return 288;
                        }
                        else
                        if (lat < 62.768508f)
                            if (lng < 145.472286f)
                            {
                                if (poly[2978].contains(lat,lng)) return 288;
                                if (poly[2979].contains(lat,lng)) return 290;
                                else return 257;
                            }
                            else
                            {
                                if (poly[2980].contains(lat,lng)) return 288;
                                if (poly[2981].contains(lat,lng)) return 290;
                                else return 257;
                            }
                        else
                        {
                            if (poly[2982].contains(lat,lng)) return 257;
                            else return 288;
                        }
                    else
                    {
                        if (poly[2983].contains(lat,lng)) return 257;
                        if (poly[2984].contains(lat,lng)) return 278;
                        else return 288;
                    }
                else
                if (lat < 62.117818f)
                    if (lng < 148.658794f)
                        if (lat < 60.532987f)
                        {
                            if (poly[2985].contains(lat,lng)) return 290;
                            else return 257;
                        }
                        else
                        {
                            if (poly[2986].contains(lat,lng)) return 290;
                            else return 257;
                        }
                    else
                        return 257;
                else
                if (lng < 148.658794f)
                {
                    if (poly[2987].contains(lat,lng)) return 278;
                    if (poly[2988].contains(lat,lng)) return 288;
                    else return 257;
                }
                else
                {
                    if (poly[2989].contains(lat,lng)) return 278;
                    else return 257;
                }
            else
            if (lng < 144.113716f)
                if (lat < 69.168556f)
                    if (lng < 140.566574f)
                        if (lat < 67.372225f)
                            if (lng < 138.793002f)
                            {
                                if (poly[2990].contains(lat,lng)) return 250;
                                if (poly[2991].contains(lat,lng)) return 278;
                                else return 290;
                            }
                            else
                            if (lat < 66.474060f)
                            {
                                if (poly[2992].contains(lat,lng)) return 250;
                                if (poly[2993].contains(lat,lng)) return 278;
                                else return 290;
                            }
                            else
                            {
                                if (poly[2994].contains(lat,lng)) return 290;
                                if (poly[2995].contains(lat,lng)) return 290;
                                else return 278;
                            }
                        else
                        {
                            if (poly[2996].contains(lat,lng)) return 278;
                            else return 290;
                        }
                    else
                    {
                        if (poly[2997].contains(lat,lng)) return 290;
                        else return 278;
                    }
                else
                if (lng < 140.566574f)
                    return 290;
                else
                if (lat < 70.964888f)
                {
                    if (poly[2998].contains(lat,lng)) return 290;
                    else return 278;
                }
                else
                {
                    if (poly[2999].contains(lat,lng)) return 278;
                    else return 290;
                }
            else
            {
                if (poly[3000].contains(lat,lng)) return 290;
                else return 278;
            }
        else
            return 290;
    }

    private static int call46(float lat, float lng)
    {
        if (lat < 21.321781f)
            if (lng < 147.443035f)
                if (lng < 143.281718f)
                    if (lng < 136.322421f)
                        if (lng < 126.807256f)
                            if (lng < 116.028859f)
                                if (lat < 10.238836f)
                                    return 259;
                                else
                                    return 276;
                            else
                            if (lat < 7.511199f)
                                if (lng < 117.166690f)
                                {
                                    if (poly[3001].contains(lat,lng)) return 259;
                                    else return 254;
                                }
                                else
                                {
                                    if (poly[3002].contains(lat,lng)) return 254;
                                    else return 259;
                                }
                            else
                            if (lng < 116.978217f)
                                if (lat < 14.517725f)
                                    return 259;
                                else
                                    return 279;
                            else
                            {
                                if (poly[3003].contains(lat,lng)) return 276;
                                else return 259;
                            }
                        else
                        if (lng < 134.771474f)
                            return 416;
                        else
                            return 284;
                    else
                        return 393;
                else
                if (lat < 13.857141f)
                    if (lat < 9.427387f)
                        return 393;
                    else
                        return 403;
                else
                    return 421;
            else
            if (lng < 167.976848f)
                if (lng < 152.946370f)
                    return 393;
                else
                if (lng < 162.595471f)
                    if (lng < 159.969720f)
                        return 418;
                    else
                        return 408;
                else
                if (lng < 166.231718f)
                    return 408;
                else
                if (lat < 9.602000f)
                    if (lng < 166.477771f)
                        return 408;
                    else
                    if (lat < 8.399960f)
                        return 408;
                    else
                    {
                        if (poly[3004].contains(lat,lng)) return 408;
                        else return 407;
                    }
                else
                if (lat < 15.377747f)
                    return 408;
                else
                    return 425;
            else
                return 408;
        else
        if (lat < 38.623477f)
            if (lng < 132.146781f)
                if (lng < 123.391367f)
                    if (lat < 25.829900f)
                        if (lng < 122.297000f)
                            if (lng < 118.546111f)
                                if (lat < 24.207778f)
                                {
                                    if (poly[3005].contains(lat,lng)) return 279;
                                    else return 276;
                                }
                                else
                                {
                                    if (poly[3006].contains(lat,lng)) return 276;
                                    else return 279;
                                }
                            else
                            {
                                if (poly[3007].contains(lat,lng)) return 276;
                                else return 279;
                            }
                        else
                            return 284;
                    else
                    if (lng < 120.076944f)
                        if (lat < 26.037778f)
                        {
                            if (poly[3008].contains(lat,lng)) return 276;
                            else return 279;
                        }
                        else
                        {
                            if (poly[3009].contains(lat,lng)) return 276;
                            else return 279;
                        }
                    else
                    if (lng < 120.289722f)
                    {
                        if (poly[3010].contains(lat,lng)) return 276;
                        else return 279;
                    }
                    else
                    {
                        if (poly[3011].contains(lat,lng)) return 279;
                        else return 276;
                    }
                else
                if (lat < 32.448242f)
                    return 284;
                else
                if (lng < 129.832649f)
                    if (lat < 34.891740f)
                    {
                        if (poly[3012].contains(lat,lng)) return 284;
                        if (poly[3013].contains(lat,lng)) return 284;
                        else return 275;
                    }
                    else
                    if (lng < 128.374371f)
                    {
                        if (poly[3014].contains(lat,lng)) return 268;
                        else return 275;
                    }
                    else
                    {
                        if (poly[3015].contains(lat,lng)) return 268;
                        else return 275;
                    }
                else
                if (lat < 35.229229f)
                    return 284;
                else
                    return 275;
            else
                return 284;
        else
        if (lng < 151.208001f)
            return call45(lat,lng);
        else
        if (lat < 55.565445f)
            if (lng < 168.445805f)
                if (lng < 156.831768f)
                    if (lng < 152.619038f)
                    {
                        if (poly[3016].contains(lat,lng)) return 278;
                        else return 288;
                    }
                    else
                    {
                        if (poly[3017].contains(lat,lng)) return 247;
                        else return 278;
                    }
                else
                    return 247;
            else
                return 53;
        else
        if (lat < 71.770077f)
            if (lng < 174.518872f)
                if (lng < 162.863436f)
                    if (lat < 63.667761f)
                        if (lng < 157.035719f)
                        {
                            if (poly[3018].contains(lat,lng)) return 247;
                            else return 257;
                        }
                        else
                        if (lat < 59.616603f)
                            return 247;
                        else
                        if (lng < 159.949578f)
                            return 257;
                        else
                        if (lat < 61.642182f)
                        {
                            if (poly[3019].contains(lat,lng)) return 257;
                            else return 247;
                        }
                        else
                        if (lng < 161.406507f)
                            return 257;
                        else
                        if (lat < 62.654972f)
                        {
                            if (poly[3020].contains(lat,lng)) return 257;
                            else return 247;
                        }
                        else
                        {
                            if (poly[3021].contains(lat,lng)) return 247;
                            else return 257;
                        }
                    else
                    if (lng < 157.035719f)
                        if (lat < 67.718919f)
                            if (lng < 154.121860f)
                            {
                                if (poly[3022].contains(lat,lng)) return 278;
                                else return 257;
                            }
                            else
                            {
                                if (poly[3023].contains(lat,lng)) return 257;
                                else return 278;
                            }
                        else
                            return 278;
                    else
                    if (lat < 67.471376f)
                        if (lng < 159.949578f)
                            if (lat < 65.569569f)
                            {
                                if (poly[3024].contains(lat,lng)) return 215;
                                else return 257;
                            }
                            else
                            if (lng < 158.492648f)
                            {
                                if (poly[3025].contains(lat,lng)) return 215;
                                if (poly[3026].contains(lat,lng)) return 215;
                                if (poly[3027].contains(lat,lng)) return 257;
                                if (poly[3028].contains(lat,lng)) return 257;
                                else return 278;
                            }
                            else
                            {
                                if (poly[3029].contains(lat,lng)) return 257;
                                if (poly[3030].contains(lat,lng)) return 278;
                                if (poly[3031].contains(lat,lng)) return 278;
                                if (poly[3032].contains(lat,lng)) return 278;
                                else return 215;
                            }
                        else
                        {
                            if (poly[3033].contains(lat,lng)) return 215;
                            if (poly[3034].contains(lat,lng)) return 247;
                            if (poly[3035].contains(lat,lng)) return 247;
                            else return 257;
                        }
                    else
                    if (lng < 159.949578f)
                    {
                        if (poly[3036].contains(lat,lng)) return 215;
                        else return 278;
                    }
                    else
                    {
                        if (poly[3037].contains(lat,lng)) return 215;
                        else return 278;
                    }
                else
                if (lat < 63.303423f)
                    if (lng < 168.691154f)
                    {
                        if (poly[3038].contains(lat,lng)) return 215;
                        else return 247;
                    }
                    else
                    if (lng < 171.605013f)
                        if (lat < 61.516254f)
                            return 247;
                        else
                        if (lng < 170.148084f)
                        {
                            if (poly[3039].contains(lat,lng)) return 215;
                            if (poly[3040].contains(lat,lng)) return 215;
                            else return 247;
                        }
                        else
                        {
                            if (poly[3041].contains(lat,lng)) return 247;
                            if (poly[3042].contains(lat,lng)) return 247;
                            else return 215;
                        }
                    else
                    if (lng < 173.061943f)
                    {
                        if (poly[3043].contains(lat,lng)) return 215;
                        else return 247;
                    }
                    else
                    {
                        if (poly[3044].contains(lat,lng)) return 215;
                        else return 247;
                    }
                else
                if (lng < 168.691154f)
                    if (lat < 67.050994f)
                        if (lng < 165.777295f)
                            if (lat < 65.177208f)
                                if (lng < 164.320366f)
                                {
                                    if (poly[3045].contains(lat,lng)) return 215;
                                    if (poly[3046].contains(lat,lng)) return 257;
                                    if (poly[3047].contains(lat,lng)) return 257;
                                    if (poly[3048].contains(lat,lng)) return 257;
                                    else return 247;
                                }
                                else
                                {
                                    if (poly[3049].contains(lat,lng)) return 247;
                                    else return 215;
                                }
                            else
                                return 215;
                        else
                        {
                            if (poly[3050].contains(lat,lng)) return 247;
                            else return 215;
                        }
                    else
                    {
                        if (poly[3051].contains(lat,lng)) return 278;
                        else return 215;
                    }
                else
                {
                    if (poly[3052].contains(lat,lng)) return 247;
                    else return 215;
                }
            else
                return 215;
        else
            return 290;
    }

    private static class TzPolygon {

        float[] pts;

        TzPolygon(float ... D)
        {
            pts = D;
        }

        public boolean contains(float testy, float testx)
        {
            boolean inside = false;
            int n = pts.length;
            float yj = pts[n-2];
            float xj = pts[n-1];
            for (int i = 0; i < n; ) {
                float yi = pts[i++];
                float xi = pts[i++];
                if ( ((yi>testy) != (yj>testy)) && (testx < (xj-xi) * (testy-yi) / (yj-yi) + xi - 0.0001f))
                    inside = !inside;
                xj = xi;
                yj = yi;
            }
            return inside;
        }
    }


    private static TzPolygon[] poly = initPolyArray();


    private static class Initializer1 {
        private static void init() {
            poly[0] = new TzPolygon(-66.000000f,-74.790449f, -86.000000f,-74.790449f, -86.000000f,-80.000000f, -66.000000f,-80.000000f);
            poly[1] = new TzPolygon(-48.582229f,-76.021890f, -48.582229f,-74.972849f, -48.738531f,-75.261755f, -48.720811f,-75.356684f, -48.784858f,-75.570161f,
                    -48.788603f,-76.033525f);
            poly[2] = new TzPolygon(-48.631255f,-74.790449f, -48.620484f,-74.906588f, -48.582229f,-74.972849f, -48.582229f,-74.790449f);
            poly[3] = new TzPolygon(-4.463281f,-79.713051f, -4.492013f,-79.812846f, -4.413311f,-79.870644f, -4.386225f,-79.918504f, -4.398133f,-79.952250f,
                    -4.380940f,-79.991687f, -4.310753f,-80.061277f, -4.285451f,-80.135403f, -4.304381f,-80.156057f, -4.293735f,-80.176870f,
                    -4.334799f,-80.185641f, -4.340057f,-80.206549f, -4.350423f,-80.195138f, -4.353266f,-80.219057f, -4.411501f,-80.263507f,
                    -4.406661f,-80.282523f, -4.465321f,-80.329256f, -4.486128f,-80.388354f, -4.448243f,-80.449079f, -4.367830f,-80.445962f,
                    -4.199935f,-80.306395f, -4.220630f,-80.353907f, -4.197227f,-80.368469f, -4.218131f,-80.410353f, -4.196347f,-80.432743f,
                    -4.209630f,-80.450183f, -4.121701f,-80.446824f, -4.127627f,-80.467175f, -4.054915f,-80.481935f, -3.997205f,-80.445923f,
                    -3.980779f,-80.398050f, -4.017149f,-80.300771f, -4.008033f,-80.272693f, -3.948370f,-80.234984f, -3.956656f,-80.216493f,
                    -3.895305f,-80.126404f, -3.870365f,-80.159502f, -3.802971f,-80.160109f, -3.775000f,-80.192845f, -3.756035f,-80.192045f,
                    -3.756035f,-79.713051f);
            poly[4] = new TzPolygon(-4.463281f,-79.713051f, -3.756035f,-79.713051f, -3.756035f,-78.405503f, -3.782391f,-78.409367f, -3.827533f,-78.465873f,
                    -3.933821f,-78.488826f, -3.937264f,-78.524505f, -3.991963f,-78.565713f, -4.045100f,-78.567689f, -4.061588f,-78.537225f,
                    -4.134865f,-78.581154f, -4.195549f,-78.577281f, -4.226094f,-78.608955f, -4.257924f,-78.598544f, -4.332513f,-78.652273f,
                    -4.415164f,-78.634094f, -4.425148f,-78.600263f, -4.530081f,-78.661123f, -4.584883f,-78.655819f, -4.623949f,-78.706040f,
                    -4.638181f,-78.805147f, -4.666990f,-78.855937f, -4.721660f,-78.891204f, -4.765025f,-78.890487f, -4.780080f,-78.914861f,
                    -4.808531f,-78.891006f, -4.851854f,-78.915138f, -4.897899f,-78.892858f, -4.894209f,-78.972616f, -5.015931f,-79.015405f,
                    -4.969755f,-79.075886f, -4.966255f,-79.266950f, -4.898674f,-79.306087f, -4.880440f,-79.351995f, -4.837345f,-79.365552f,
                    -4.832450f,-79.395264f, -4.794079f,-79.421263f, -4.627291f,-79.487973f, -4.530312f,-79.487787f, -4.515554f,-79.562108f,
                    -4.439105f,-79.629079f);
            poly[5] = new TzPolygon(-3.756035f,-84.520219f, -3.392125f,-84.439430f, -3.392255f,-80.306572f, -3.438116f,-80.221080f, -3.485750f,-80.245823f,
                    -3.500634f,-80.215877f, -3.574856f,-80.218529f, -3.601287f,-80.190584f, -3.756035f,-80.192598f);
            poly[6] = new TzPolygon(-3.756035f,-78.405503f, -3.735388f,-78.402476f, -3.693202f,-78.423437f, -3.677180f,-78.393217f, -3.560102f,-78.391188f,
                    -3.529699f,-78.364930f, -3.427103f,-78.341385f, -3.367933f,-78.349831f, -3.395347f,-78.313688f, -3.398582f,-78.246726f,
                    -3.502763f,-78.231455f, -3.500079f,-78.187079f, -3.462695f,-78.146753f, -3.362668f,-78.197809f, -3.278806f,-78.108674f,
                    -3.216360f,-78.091812f, -3.227392f,-78.064909f, -3.190982f,-78.036072f, -3.190622f,-78.010772f, -3.158505f,-78.011297f,
                    -3.069962f,-77.948023f, -3.000373f,-77.843934f, -2.591136f,-76.632708f, -2.124938f,-76.044356f, -1.549618f,-75.584994f,
                    -1.562957f,-75.559159f, -1.143227f,-75.442469f, -1.143227f,-74.790449f, -3.756035f,-74.790449f);
            poly[7] = new TzPolygon(0.362697f,-77.222892f, 0.363221f,-77.287580f, 0.400756f,-77.370810f, 0.387642f,-77.389058f, 0.438737f,-77.430783f,
                    0.401243f,-77.526461f, 0.530696f,-77.521218f, 0.605000f,-77.480821f, 0.655921f,-77.479623f, 0.650276f,-77.559835f,
                    0.705188f,-77.666112f, 0.737207f,-77.675385f, 0.741574f,-77.697898f, 0.814530f,-77.664002f, 0.840051f,-77.694756f,
                    0.841134f,-77.774507f, 0.802178f,-77.842696f, 0.823435f,-77.960655f, 0.856020f,-77.988569f, 0.896853f,-78.087861f,
                    0.932248f,-78.111768f, 0.925229f,-78.158653f, 0.946954f,-78.199205f, 0.997163f,-78.202313f, 1.055852f,-78.281830f,
                    1.099505f,-78.251070f, 1.111425f,-78.282216f, 1.191146f,-78.310583f, 1.160018f,-78.417561f, 1.139925f,-78.429633f,
                    1.189810f,-78.432084f, 1.187404f,-78.515771f, 1.212827f,-78.514394f, 1.250518f,-78.552504f, 1.248514f,-78.619176f,
                    1.319855f,-78.663472f, 1.469581f,-78.868686f, 1.469581f,-77.222892f);
            poly[8] = new TzPolygon(-1.143227f,-75.442469f, -0.933777f,-75.384239f, -0.984452f,-75.313749f, -0.971293f,-75.192504f, -0.933832f,-75.233515f,
                    -0.869167f,-75.221241f, -0.834452f,-75.252397f, -0.800810f,-75.241754f, -0.787322f,-75.268450f, -0.763563f,-75.253256f,
                    -0.731465f,-75.276087f, -0.695247f,-75.249136f, -0.664658f,-75.274243f, -0.628358f,-75.223306f, -0.601047f,-75.240701f,
                    -0.550304f,-75.227940f, -0.518237f,-75.247103f, -0.530454f,-75.268558f, -0.501426f,-75.270691f, -0.494676f,-75.312973f,
                    -0.490025f,-75.314318f, -0.490025f,-74.790449f, -1.143227f,-74.790449f);
            poly[9] = new TzPolygon(0.163177f,-75.899058f, 0.163177f,-74.790449f, -0.193865f,-74.790449f, -0.188798f,-74.793490f, -0.243279f,-74.883279f,
                    -0.202360f,-74.912032f, -0.225712f,-74.927919f, -0.154980f,-74.972685f, -0.148687f,-75.011932f, -0.081799f,-75.077451f,
                    -0.044719f,-75.162138f, -0.049238f,-75.211292f, -0.125137f,-75.273418f, -0.086488f,-75.428461f, -0.018885f,-75.530051f,
                    -0.026579f,-75.574527f, 0.014277f,-75.581909f, 0.047608f,-75.632203f, 0.031271f,-75.652118f, 0.050840f,-75.806614f,
                    0.132488f,-75.854585f, 0.118397f,-75.878275f, 0.138809f,-75.881988f, 0.139542f,-75.905475f, 0.162248f,-75.897766f);
            poly[10] = new TzPolygon(-0.490025f,-75.314318f, -0.452706f,-75.325107f, -0.463605f,-75.349219f, -0.434213f,-75.388171f, -0.186747f,-75.535764f,
                    -0.190039f,-75.602184f, -0.113675f,-75.615531f, -0.131836f,-75.568956f, -0.114357f,-75.516197f, -0.169952f,-75.406389f,
                    -0.146061f,-75.364741f, -0.163719f,-75.353155f, -0.160093f,-75.312890f, -0.126345f,-75.259923f, -0.039282f,-75.192752f,
                    -0.081799f,-75.077451f, -0.148687f,-75.011932f, -0.154980f,-74.972685f, -0.225712f,-74.927919f, -0.202360f,-74.912032f,
                    -0.243279f,-74.883279f, -0.188798f,-74.793490f, -0.193865f,-74.790449f, -0.490025f,-74.790449f);
            poly[11] = new TzPolygon(0.362697f,-77.222892f, 0.362635f,-77.215207f, 0.389524f,-77.166031f, 0.372330f,-77.113308f, 0.284301f,-77.076109f,
                    0.277374f,-77.027441f, 0.294349f,-77.006691f, 0.266003f,-76.985718f, 0.276764f,-76.933267f, 0.246030f,-76.907590f,
                    0.238961f,-76.845635f, 0.264371f,-76.797537f, 0.248242f,-76.756071f, 0.263500f,-76.767363f, 0.288619f,-76.732950f,
                    0.268980f,-76.712534f, 0.270672f,-76.655712f, 0.251075f,-76.653151f, 0.261912f,-76.625590f, 0.218660f,-76.586342f,
                    0.258652f,-76.532835f, 0.236406f,-76.504040f, 0.239446f,-76.446771f, 0.257735f,-76.434586f, 0.234402f,-76.427007f,
                    0.240654f,-76.412699f, 0.379616f,-76.411361f, 0.382987f,-76.339841f, 0.433886f,-76.314210f, 0.421223f,-76.296878f,
                    0.437080f,-76.278335f, 0.376830f,-76.226437f, 0.388252f,-76.158492f, 0.371158f,-76.132942f, 0.315884f,-76.113372f,
                    0.335968f,-76.067882f, 0.296487f,-76.003681f, 0.256318f,-75.982395f, 0.247925f,-76.005430f, 0.238294f,-75.959221f,
                    0.203104f,-75.954586f, 0.163177f,-75.899058f, 0.163177f,-77.222892f);
            poly[12] = new TzPolygon(11.948729f,-86.810568f, 11.948729f,-83.615384f, 11.614625f,-83.545675f, 11.505393f,-83.624088f, 11.460968f,-83.697600f,
                    11.391315f,-83.718428f, 11.362488f,-83.769886f, 11.283199f,-83.769886f, 11.068048f,-83.695149f, 10.997920f,-83.628370f,
                    10.928172f,-83.669225f, 10.939851f,-83.698032f, 10.818222f,-83.660670f, 10.787861f,-83.694237f, 10.770588f,-83.789630f,
                    10.717579f,-83.862686f, 10.707657f,-83.931193f, 10.791619f,-84.021017f, 10.759754f,-84.070279f, 10.764361f,-84.125135f,
                    10.787002f,-84.136952f, 10.781758f,-84.202708f, 10.815617f,-84.237621f, 10.840680f,-84.214727f, 10.873430f,-84.225262f,
                    10.918032f,-84.322876f, 10.995846f,-84.358676f, 10.955404f,-84.420252f, 10.960891f,-84.450192f, 11.051070f,-84.574811f,
                    11.038395f,-84.606084f, 11.084402f,-84.680546f, 10.943439f,-84.910233f, 11.126204f,-85.357171f, 11.128836f,-85.423656f,
                    11.168113f,-85.523283f, 11.210044f,-85.560395f, 11.219568f,-85.609900f, 11.069014f,-85.706119f, 11.075878f,-85.897878f,
                    11.683930f,-86.626954f, 11.923883f,-86.799320f);
            poly[13] = new TzPolygon(7.420856f,-82.506021f, 7.935534f,-82.945565f, 8.051847f,-82.890467f, 8.176042f,-82.902863f, 8.210353f,-82.935811f,
                    8.272782f,-82.941755f, 8.289329f,-82.974950f, 8.271259f,-82.989611f, 8.333426f,-83.051724f, 8.372535f,-82.984046f,
                    8.435004f,-82.930922f, 8.439673f,-82.868383f, 8.480288f,-82.839579f, 8.635995f,-82.830006f, 8.765126f,-82.919159f,
                    8.773740f,-82.885445f, 8.817389f,-82.862470f, 8.829270f,-82.884344f, 8.852720f,-82.860890f, 8.878409f,-82.773262f,
                    8.922259f,-82.711897f, 8.985499f,-82.741726f, 9.003611f,-82.801389f, 9.087904f,-82.887118f, 9.078469f,-82.935930f,
                    9.473125f,-82.936078f, 9.501413f,-82.842580f, 9.566924f,-82.884793f, 9.621591f,-82.854201f, 9.588903f,-82.743867f,
                    9.494122f,-82.671230f, 9.511394f,-82.654801f, 9.493644f,-82.639056f, 9.504265f,-82.605838f, 9.559461f,-82.599976f,
                    9.541496f,-82.553144f, 9.571984f,-82.565013f, 9.653892f,-82.506021f);
            poly[14] = new TzPolygon(7.779632f,-78.641949f, 7.779632f,-77.347444f, 7.765696f,-77.342224f, 7.772445f,-77.399046f, 7.725306f,-77.398005f,
                    7.658417f,-77.440411f, 7.662741f,-77.465686f, 7.567106f,-77.491171f, 7.582727f,-77.516615f, 7.507785f,-77.564858f,
                    7.541663f,-77.612279f, 7.651469f,-77.645202f, 7.700040f,-77.728579f, 7.613535f,-77.748587f, 7.506937f,-77.701464f,
                    7.461479f,-77.754389f, 7.472481f,-77.818185f, 7.228372f,-77.889065f, 7.050936f,-78.036406f, 7.404444f,-78.370364f);
            poly[15] = new TzPolygon(7.779632f,-78.641949f, 7.788317f,-78.648235f, 9.802818f,-78.648235f, 9.796949f,-78.571137f, 9.550708f,-78.211930f,
                    9.381695f,-77.846530f, 9.122927f,-77.524482f, 8.810513f,-77.324431f, 8.641568f,-77.364481f, 8.645401f,-77.408923f,
                    8.588352f,-77.393845f, 8.554959f,-77.444862f, 8.509577f,-77.457435f, 8.472170f,-77.447701f, 8.475002f,-77.411968f,
                    8.402126f,-77.358884f, 8.297812f,-77.350241f, 8.266749f,-77.329596f, 8.272291f,-77.301273f, 8.253016f,-77.284217f,
                    8.209045f,-77.279740f, 8.175348f,-77.246796f, 8.156526f,-77.258195f, 8.135652f,-77.227087f, 8.037238f,-77.219039f,
                    8.025575f,-77.235168f, 7.954198f,-77.139378f, 7.959057f,-77.178952f, 7.929365f,-77.153308f, 7.933343f,-77.177377f,
                    7.917464f,-77.178741f, 7.893640f,-77.334815f, 7.830457f,-77.366481f, 7.779632f,-77.347444f);
            poly[16] = new TzPolygon(-9.887332f,40.227580f, -10.151458f,40.556614f, -10.318695f,40.658407f, -10.414722f,40.492778f, -10.565456f,40.352060f,
                    -10.596228f,40.233184f, -10.603183f,40.227580f);
            poly[17] = new TzPolygon(-12.379027f,45.079938f, -12.410517f,45.203578f, -12.480122f,45.314879f, -12.591196f,45.434785f, -12.663742f,45.482985f,
                    -12.782931f,45.507035f, -13.072467f,45.436904f, -13.150354f,45.395022f, -13.241990f,45.266931f, -13.273255f,45.136061f,
                    -13.237377f,44.975470f, -13.110506f,44.823538f, -12.919092f,44.749889f, -12.760359f,44.770136f, -12.661548f,44.743668f,
                    -12.577477f,44.760477f, -12.496259f,44.821940f, -12.396000f,44.990042f);
            poly[18] = new TzPolygon(1.448202f,40.227580f, 1.448202f,40.990761f, -0.833975f,40.993376f, -1.598574f,41.558912f, -1.662078f,41.559365f,
                    -1.803197f,41.718166f, -1.912243f,41.650687f, -2.252429f,41.345545f, -2.763425f,40.751201f, -3.085740f,40.418741f,
                    -3.369973f,40.335936f, -3.562595f,40.227580f);
            poly[19] = new TzPolygon(1.448202f,40.990761f, 2.828298f,40.989180f, 3.141237f,41.312053f, 4.016664f,41.943017f, 4.055481f,41.946277f,
                    4.179113f,42.087372f, 4.202464f,42.525584f, 4.260387f,42.702992f, 4.266755f,42.824904f, 4.380478f,42.951970f,
                    4.559042f,43.034761f, 4.626329f,43.115314f, 4.794544f,43.434687f, 4.902107f,43.809025f, 4.950439f,44.153985f,
                    4.930188f,44.770743f, 1.466525f,44.770743f, 1.448202f,44.746692f);
            poly[20] = new TzPolygon(4.055009f,40.227580f, 4.104848f,40.387772f, 4.245001f,40.717448f, 4.284943f,40.759583f, 4.246260f,40.844100f,
                    4.212840f,40.882380f, 4.154620f,40.904160f, 4.132070f,40.965080f, 3.942580f,41.169266f, 3.958885f,41.235302f,
                    3.938760f,41.326310f, 3.962760f,41.391250f, 3.944940f,41.430190f, 3.954630f,41.509770f, 3.982140f,41.545160f,
                    3.966667f,41.566898f, 3.983294f,41.627705f, 3.959925f,41.674412f, 3.992460f,41.720593f, 3.982106f,41.791788f,
                    3.958645f,41.796766f, 3.946486f,41.833158f, 3.982684f,41.906750f, 3.141237f,41.312053f, 2.828298f,40.989180f,
                    1.448202f,40.990761f, 1.448202f,40.227580f);
            poly[21] = new TzPolygon(6.459000f,46.438637f, 5.956573f,45.845200f, 5.536382f,45.410930f, 4.923383f,44.978011f, 4.927753f,44.770743f,
                    6.459000f,44.770743f);
            poly[22] = new TzPolygon(-9.403320f,141.647501f, -9.409858f,141.592780f, -9.391659f,141.480826f, -9.351343f,141.394594f, -9.425916f,141.241107f,
                    -9.426205f,141.075589f, -9.386877f,140.998300f, -9.304719f,140.915152f, -9.135556f,141.019444f, -6.892357f,141.020035f,
                    -6.904320f,140.991514f, -6.889404f,140.966846f, -6.910453f,140.955612f, -6.891885f,140.940378f, -6.857220f,140.953987f,
                    -6.872289f,140.917147f, -6.849062f,140.900264f, -6.814838f,140.916903f, -6.792055f,140.870037f, -6.751125f,140.899477f,
                    -6.719801f,140.846202f, -6.621837f,140.877066f, -6.610606f,140.841655f, -6.605671f,140.890850f, -6.573283f,140.911744f,
                    -6.561471f,140.891027f, -6.560800f,140.937194f, -6.500474f,140.921753f, -6.487509f,140.961667f, -6.452098f,140.955223f,
                    -6.467034f,140.925173f, -6.445165f,140.938942f, -6.422390f,140.917346f, -6.434850f,140.952162f, -6.412401f,140.942045f,
                    -6.390252f,140.982301f, -6.382644f,140.941958f, -6.365823f,140.977049f, -6.325355f,140.959981f, -6.322308f,140.999973f,
                    -2.387415f,141.000000f, -2.475376f,141.366527f, -2.612818f,141.647501f);
            poly[23] = new TzPolygon(-9.187956f,142.216109f, -9.266242f,142.345755f, -9.320820f,142.329236f, -9.347593f,142.274239f, -9.317351f,142.096032f,
                    -9.260461f,142.059440f, -9.212404f,142.108052f);
            poly[24] = new TzPolygon(-9.484383f,142.526835f, -9.466246f,142.490176f, -9.409206f,142.471923f, -9.366124f,142.495602f, -9.374335f,142.558892f,
                    -9.322311f,142.806531f, -9.378369f,142.851886f, -9.453762f,142.821507f, -9.482153f,142.784947f, -9.459837f,142.585351f,
                    -9.484383f,142.536451f);
            poly[25] = new TzPolygon(-9.484383f,143.248626f, -9.474107f,143.253530f, -9.459675f,143.297032f, -9.484383f,143.338933f);
            poly[26] = new TzPolygon(-6.107149f,154.622311f, -6.086762f,154.603872f, -5.931626f,154.533882f, -5.892219f,154.450641f, -5.824350f,154.390926f,
                    -5.722738f,154.366089f, -5.608977f,154.404508f, -5.531492f,154.398887f, -5.301336f,154.333958f, -5.085948f,153.021059f,
                    -5.100781f,153.369546f, -2.983921f,154.622311f);
            poly[27] = new TzPolygon(-6.377546f,154.865967f, -6.377546f,156.153225f, -6.444858f,156.173819f, -6.550000f,156.035833f, -6.658333f,156.039722f,
                    -6.847222f,155.923056f, -6.925833f,155.693611f, -6.925833f,155.593889f, -7.097516f,155.336184f, -7.017480f,155.297466f,
                    -6.653692f,155.002257f);
            poly[28] = new TzPolygon(54.891446f,53.543209f, 54.978258f,53.475110f, 55.024998f,53.372300f, 55.021895f,53.318393f, 55.044701f,53.317278f,
                    55.040976f,53.276384f, 55.070675f,53.294045f, 55.102723f,53.258799f, 55.109103f,53.164626f, 55.165582f,53.157844f,
                    55.173110f,53.371333f, 55.191883f,53.398238f, 55.202065f,53.362239f, 55.230037f,53.426972f, 55.214323f,53.616626f,
                    55.262642f,53.602269f, 55.277042f,53.685629f, 55.327133f,53.690385f, 55.365909f,53.861956f, 55.354651f,53.895764f,
                    55.394366f,53.872761f, 55.442170f,53.915395f, 54.891446f,53.915395f, 54.891446f,53.639235f, 54.906586f,53.649304f,
                    54.891446f,53.597580f);
            poly[29] = new TzPolygon(55.175889f,59.150751f, 55.162808f,59.172064f, 55.142427f,59.158175f, 55.153803f,59.113569f);
            poly[30] = new TzPolygon(55.210021f,69.957225f, 55.210093f,69.950516f, 55.299966f,69.862930f, 55.345583f,69.745073f, 55.342093f,69.441769f,
                    55.352208f,69.402974f, 55.384553f,69.411653f, 55.386983f,69.363908f, 55.351354f,69.317696f, 55.330115f,69.199475f,
                    55.390437f,69.160572f, 55.442027f,68.932686f, 55.365332f,68.915885f, 55.365765f,68.983669f, 55.288464f,69.001168f,
                    55.327362f,68.956225f, 55.318490f,68.928963f, 55.378842f,68.748654f, 55.288836f,68.696868f, 55.265379f,68.635116f,
                    55.235735f,68.657829f, 55.198213f,68.619795f, 55.219408f,68.594980f, 55.196495f,68.444642f, 55.206463f,68.358804f,
                    55.180954f,68.353543f, 55.203531f,68.304201f, 55.187150f,68.239630f, 55.198793f,68.177148f, 55.154756f,68.218666f,
                    55.151440f,68.189505f, 55.076629f,68.315193f, 55.054098f,68.237586f, 55.014808f,68.237811f, 54.990182f,68.196709f,
                    54.968959f,68.234743f, 54.950457f,68.032268f, 54.983669f,67.910619f, 54.971376f,67.819274f, 54.891446f,67.776503f,
                    54.891446f,59.172064f, 55.442170f,59.172064f, 55.442170f,69.957225f);
            poly[31] = new TzPolygon(26.179962f,-107.815375f, 26.196484f,-107.853967f, 26.438910f,-108.012728f, 26.470118f,-107.969609f, 26.472102f,-107.985476f,
                    26.493996f,-107.957081f, 26.526811f,-107.960858f, 26.615880f,-108.031607f, 26.641929f,-108.081652f, 26.689668f,-108.011685f,
                    26.729418f,-108.008305f, 26.729418f,-107.815375f);
            poly[32] = new TzPolygon(26.729418f,-109.999802f, 26.729418f,-108.600314f, 26.727223f,-108.601024f, 26.718387f,-108.628385f, 26.676573f,-108.630366f,
                    26.642889f,-108.678988f, 26.587015f,-108.678831f, 26.593568f,-108.734293f, 26.551071f,-108.873152f, 26.489595f,-108.891317f,
                    26.479540f,-108.914670f, 26.487217f,-108.847480f, 26.472523f,-108.837762f, 26.447576f,-108.876108f, 26.432770f,-108.860339f,
                    26.406252f,-108.881392f, 26.421715f,-108.910115f, 26.390180f,-108.936522f, 26.402370f,-109.006443f, 26.297015f,-109.125378f,
                    26.344966f,-109.202603f, 26.316185f,-109.246826f, 26.310512f,-109.508033f, 26.403716f,-109.477396f, 26.473497f,-109.534853f,
                    26.478136f,-109.728538f, 26.544417f,-109.894124f, 26.634176f,-109.999802f);
            poly[33] = new TzPolygon(27.764211f,-108.907589f, 27.784752f,-108.920341f, 27.798298f,-108.907589f);
            poly[34] = new TzPolygon(27.851368f,-108.907589f, 27.853703f,-108.914848f, 27.940495f,-108.926480f, 28.018227f,-109.031995f, 28.148745f,-109.073038f,
                    28.272489f,-109.074984f, 28.278261f,-109.022484f, 28.255884f,-108.993813f, 28.298515f,-108.992104f, 28.250867f,-108.921264f,
                    28.255657f,-108.907589f);
            poly[35] = new TzPolygon(27.531508f,-108.907589f, 27.531508f,-108.653029f, 27.465206f,-108.661652f, 27.317990f,-108.590990f, 27.220165f,-108.663025f,
                    27.177111f,-108.653412f, 27.154082f,-108.611415f, 27.036985f,-108.602179f, 27.045866f,-108.562399f, 27.012599f,-108.571999f,
                    26.997077f,-108.551576f, 26.976230f,-108.424271f, 26.970702f,-108.466978f, 26.823753f,-108.557043f, 26.798429f,-108.536912f,
                    26.779857f,-108.554034f, 26.789577f,-108.580849f, 26.729418f,-108.600314f, 26.729418f,-108.907589f);
            poly[36] = new TzPolygon(26.729418f,-108.600314f, 26.789577f,-108.580849f, 26.779857f,-108.554034f, 26.798429f,-108.536912f, 26.823753f,-108.557043f,
                    26.970702f,-108.466978f, 26.976230f,-108.424271f, 26.987366f,-108.502429f, 27.036581f,-108.486977f, 27.013419f,-108.409530f,
                    27.022604f,-108.350083f, 27.004510f,-108.333373f, 27.034043f,-108.317576f, 27.012384f,-108.284344f, 27.042249f,-108.242392f,
                    27.034770f,-108.197788f, 27.000149f,-108.180209f, 26.958793f,-108.234966f, 26.905629f,-108.230258f, 26.881351f,-108.174710f,
                    26.907204f,-108.142117f, 26.867579f,-108.144261f, 26.870410f,-108.094161f, 26.798426f,-108.026810f, 26.769822f,-108.037698f,
                    26.760987f,-108.005620f, 26.729418f,-108.008305f);
            poly[37] = new TzPolygon(28.333599f,-108.636200f, 28.292471f,-108.641052f, 28.303060f,-108.687952f, 28.266951f,-108.797343f, 28.253495f,-108.791585f,
                    28.265560f,-108.879318f, 28.255657f,-108.907589f, 28.333599f,-108.907589f);
            poly[38] = new TzPolygon(27.851368f,-108.907589f, 27.839032f,-108.869241f, 27.798298f,-108.907589f);
            poly[39] = new TzPolygon(27.764211f,-108.907589f, 27.744740f,-108.895501f, 27.730490f,-108.784424f, 27.601137f,-108.739929f, 27.537834f,-108.652206f,
                    27.531508f,-108.653029f, 27.531508f,-108.907589f);
            poly[40] = new TzPolygon(28.333599f,-108.521428f, 28.317737f,-108.550519f, 28.333599f,-108.579013f);
            poly[41] = new TzPolygon(25.579947f,-106.723162f, 25.571661f,-106.873310f, 25.644091f,-106.893301f, 25.661685f,-106.994438f, 25.668331f,-106.966940f,
                    25.697879f,-106.965323f, 25.714924f,-106.990299f, 25.691459f,-107.010680f, 25.699875f,-107.046144f, 25.757368f,-107.057905f,
                    25.924793f,-107.296128f, 26.001977f,-107.276346f, 26.076402f,-107.304890f, 26.109523f,-107.346528f, 26.142860f,-107.431043f,
                    26.104227f,-107.520020f, 26.170640f,-107.582027f, 26.154578f,-107.635749f, 26.174413f,-107.711075f, 26.134506f,-107.755043f,
                    26.136865f,-107.780674f, 26.168627f,-107.788898f, 26.179962f,-107.815375f, 26.729418f,-107.815375f, 26.729418f,-106.723162f);
            poly[42] = new TzPolygon(25.125236f,-107.127206f, 25.186640f,-107.124918f, 25.224548f,-107.148775f, 25.243111f,-107.121057f, 25.331564f,-107.207816f,
                    25.326358f,-107.171551f, 25.417101f,-107.210132f, 25.441992f,-107.158690f, 25.489565f,-107.139295f, 25.515176f,-107.178117f,
                    25.556553f,-107.173879f, 25.550414f,-107.124565f, 25.629570f,-106.973290f, 25.661685f,-106.994438f, 25.644091f,-106.893301f,
                    25.571661f,-106.873310f, 25.579947f,-106.723162f, 25.125236f,-106.723162f);
            poly[43] = new TzPolygon(25.579947f,-106.723162f, 25.581085f,-106.702539f, 25.597082f,-106.705617f, 25.579332f,-106.681968f, 25.602195f,-106.707722f,
                    25.558657f,-106.652569f, 25.647396f,-106.591666f, 25.728722f,-106.463376f, 25.691778f,-106.555806f, 25.952097f,-106.546964f,
                    25.972486f,-106.455447f, 26.004822f,-106.444522f, 26.005396f,-106.470406f, 26.027765f,-106.453244f, 26.060420f,-106.471186f,
                    26.096989f,-106.455996f, 26.344723f,-106.307962f, 26.334746f,-106.287001f, 26.367243f,-106.275112f, 26.364574f,-106.295961f,
                    26.440288f,-106.255964f, 26.531569f,-106.279921f, 26.558754f,-106.233085f, 26.678178f,-106.207824f, 26.674407f,-106.188134f,
                    26.705337f,-106.172046f, 26.700708f,-106.130625f, 26.727674f,-106.176449f, 26.729418f,-106.176495f, 26.729418f,-105.846806f,
                    26.660915f,-105.775777f, 26.698729f,-105.794199f, 26.713838f,-105.746274f, 26.617649f,-105.674854f, 26.615930f,-105.630949f,
                    25.125236f,-105.630949f, 25.125236f,-106.723162f);
            poly[44] = new TzPolygon(26.729418f,-106.176495f, 26.772195f,-106.177626f, 26.779321f,-106.125304f, 26.759285f,-106.100652f, 26.844788f,-106.047366f,
                    26.763234f,-105.939209f, 26.747387f,-105.865438f, 26.729418f,-105.846806f);
            poly[45] = new TzPolygon(29.937781f,-109.999802f, 29.937781f,-108.625878f, 29.847115f,-108.607142f, 29.829767f,-108.635880f, 29.800790f,-108.618695f,
                    29.796156f,-108.541220f, 29.752337f,-108.534622f, 29.717686f,-108.592385f, 29.716169f,-108.659375f, 29.660587f,-108.618210f,
                    29.649450f,-108.655006f, 29.588850f,-108.641317f, 29.584534f,-108.659416f, 29.558283f,-108.638501f, 29.544517f,-108.661996f,
                    29.501171f,-108.625259f, 29.466534f,-108.717789f, 29.308136f,-108.669724f, 29.267289f,-108.682081f, 29.254683f,-108.761902f,
                    29.218582f,-108.735641f, 29.163668f,-108.746024f, 29.171978f,-108.729462f, 29.128502f,-108.698212f, 29.096232f,-108.729563f,
                    29.082692f,-108.708999f, 29.069873f,-108.724498f, 28.889599f,-108.709645f, 28.809963f,-108.657700f, 28.806503f,-108.624062f,
                    28.766033f,-108.643456f, 28.740751f,-108.583717f, 28.632463f,-108.580083f, 28.508553f,-108.507500f, 28.426272f,-108.515572f,
                    28.369551f,-108.479701f, 28.364595f,-108.521719f, 28.334455f,-108.519859f, 28.333599f,-108.579013f, 28.347390f,-108.603786f,
                    28.335144f,-108.636018f, 28.333599f,-108.636200f, 28.333599f,-109.999802f);
            poly[46] = new TzPolygon(31.541963f,-108.907589f, 31.332579f,-108.907589f, 31.332409f,-109.050040f, 31.541963f,-109.049820f);
            poly[47] = new TzPolygon(30.728570f,-108.907589f, 30.739321f,-108.918753f, 30.736901f,-108.948073f, 30.907403f,-108.939335f, 30.906651f,-108.907589f);
            poly[48] = new TzPolygon(31.541963f,-109.999802f, 31.541963f,-109.049753f, 31.332409f,-109.050040f, 31.332316f,-109.999802f);
            poly[49] = new TzPolygon(29.937781f,-108.625878f, 29.952826f,-108.628987f, 30.028856f,-108.606895f, 30.235941f,-108.617516f, 30.179691f,-108.505364f,
                    30.264100f,-108.501728f, 30.304283f,-108.475600f, 30.302227f,-108.441409f, 30.343762f,-108.436022f, 30.339935f,-108.383076f,
                    30.398221f,-108.343965f, 30.376967f,-108.201381f, 30.415196f,-108.219793f, 30.445844f,-108.173685f, 30.479270f,-108.230143f,
                    30.532806f,-108.190001f, 30.529081f,-108.160252f, 30.560915f,-108.171521f, 30.602961f,-108.074088f, 30.675447f,-108.110090f,
                    30.680564f,-108.057912f, 30.651517f,-108.038244f, 30.662162f,-107.935088f, 30.739872f,-107.960395f, 30.739872f,-107.815375f,
                    29.937781f,-107.815375f);
            poly[50] = new TzPolygon(30.728570f,-108.907589f, 30.689491f,-108.867005f, 30.624622f,-108.876403f, 30.587375f,-108.762111f, 30.594338f,-108.726843f,
                    30.556825f,-108.677771f, 30.468183f,-108.664397f, 30.465022f,-108.603785f, 30.416670f,-108.648543f, 30.340095f,-108.622119f,
                    30.337395f,-108.580057f, 30.283485f,-108.541986f, 30.266254f,-108.550290f, 30.298292f,-108.620178f, 30.028856f,-108.606895f,
                    29.952826f,-108.628987f, 29.937781f,-108.625878f, 29.937781f,-108.907589f);
            poly[51] = new TzPolygon(30.739872f,-107.960395f, 30.811527f,-107.983731f, 30.844713f,-107.912255f, 30.805122f,-107.929070f, 30.853452f,-107.815375f,
                    30.739872f,-107.815375f);
            poly[52] = new TzPolygon(31.541963f,-108.208443f, 31.333416f,-108.208486f, 31.332579f,-108.907589f, 31.541963f,-108.907589f);
            poly[53] = new TzPolygon(31.332504f,-108.907589f, 31.332522f,-108.756413f, 31.239548f,-108.816833f, 31.239252f,-108.879829f, 31.207691f,-108.906609f,
                    31.219437f,-108.860603f, 31.195032f,-108.848264f, 31.192955f,-108.805352f, 31.135466f,-108.845643f, 31.103098f,-108.769974f,
                    31.074432f,-108.767906f, 31.052816f,-108.729630f, 31.034138f,-108.752808f, 31.033695f,-108.683968f, 31.006334f,-108.683456f,
                    31.004482f,-108.803316f, 30.904154f,-108.802248f, 30.906651f,-108.907589f);
            poly[54] = new TzPolygon(29.504712f,-105.630949f, 29.504744f,-105.633806f, 29.591481f,-105.633176f, 29.591683f,-105.681598f, 29.646829f,-105.679455f,
                    29.649659f,-105.848966f, 29.613394f,-105.858715f, 29.654463f,-105.866291f, 29.666227f,-105.909903f, 29.700950f,-105.909055f,
                    29.701067f,-105.827056f, 29.747349f,-105.817962f, 29.777500f,-105.879554f, 29.783177f,-105.805710f, 29.881759f,-105.809753f,
                    29.881982f,-105.767952f, 29.937781f,-105.769718f, 29.937781f,-105.630949f);
            poly[55] = new TzPolygon(31.163909f,-106.723162f, 31.160276f,-106.745603f, 31.137931f,-106.745776f, 31.119957f,-106.821288f, 31.152077f,-106.894815f,
                    31.085365f,-106.894857f, 31.086114f,-107.044916f, 30.954102f,-107.046640f, 30.955263f,-107.073691f, 30.886460f,-107.100737f,
                    30.871980f,-107.085933f, 30.864996f,-107.157143f, 30.801074f,-107.189321f, 30.805192f,-107.238520f, 30.756192f,-107.262858f,
                    30.836259f,-107.350690f, 30.758402f,-107.399507f, 30.758388f,-107.525538f, 30.782971f,-107.526230f, 30.719639f,-107.615953f,
                    30.721180f,-107.634799f, 30.764479f,-107.629097f, 30.805867f,-107.704097f, 30.825616f,-107.695370f, 30.814186f,-107.766258f,
                    30.859257f,-107.801720f, 30.853452f,-107.815375f, 31.541963f,-107.815375f, 31.541963f,-106.723162f);
            poly[56] = new TzPolygon(31.163948f,-106.723162f, 31.174292f,-106.659025f, 31.151993f,-106.614689f, 31.152545f,-106.501491f, 31.187330f,-106.507416f,
                    31.187602f,-106.390768f, 31.159046f,-106.396831f, 31.154706f,-106.373991f, 31.187146f,-106.366934f, 31.151251f,-106.304914f,
                    31.037517f,-106.272760f, 31.000450f,-106.178335f, 30.952941f,-106.193684f, 30.956392f,-106.133256f, 30.985189f,-106.132447f,
                    30.985119f,-106.091190f, 30.898958f,-106.075025f, 30.905024f,-106.030028f, 30.896337f,-106.054355f, 30.819754f,-106.053611f,
                    30.819615f,-105.880975f, 30.846669f,-105.876796f, 30.846553f,-105.819675f, 30.770464f,-105.709927f, 30.656690f,-105.728331f,
                    30.641962f,-105.684838f, 30.505157f,-105.685915f, 30.500295f,-105.630949f, 30.309088f,-105.630949f, 30.281711f,-105.692197f,
                    30.239118f,-105.680874f, 30.238848f,-105.630949f, 30.190877f,-105.630949f, 30.219026f,-105.687126f, 30.049876f,-105.905345f,
                    30.029513f,-105.900957f, 30.028342f,-105.772584f, 29.937781f,-105.769718f, 29.937781f,-106.723162f);
            poly[57] = new TzPolygon(31.096774f,-105.630949f, 31.166800f,-105.773040f, 31.288640f,-105.868940f, 31.318310f,-105.938190f, 31.364890f,-105.953960f,
                    31.398640f,-106.080580f, 31.466260f,-106.206680f, 31.541963f,-106.256292f, 31.541963f,-105.630949f);
            poly[58] = new TzPolygon(26.729418f,-105.630949f, 26.729418f,-104.290028f, 26.725375f,-104.286510f, 26.656494f,-104.330316f, 26.604514f,-104.434783f,
                    26.465779f,-104.502852f, 26.414550f,-104.501052f, 26.340468f,-104.574451f, 26.380411f,-104.593865f, 26.368825f,-104.620117f,
                    26.391046f,-104.654134f, 26.478283f,-104.727430f, 26.508488f,-104.809174f, 26.510015f,-104.898922f, 26.473341f,-104.963210f,
                    26.449248f,-104.963102f, 26.454910f,-105.000564f, 26.419309f,-105.056632f, 26.521373f,-105.101637f, 26.462020f,-105.264634f,
                    26.487511f,-105.279249f, 26.462255f,-105.316769f, 26.478864f,-105.352776f, 26.504531f,-105.342611f, 26.534245f,-105.368624f,
                    26.517496f,-105.403561f, 26.527937f,-105.470215f, 26.508686f,-105.471556f, 26.542861f,-105.496133f, 26.546552f,-105.548990f,
                    26.683504f,-105.619556f, 26.614753f,-105.600891f, 26.615930f,-105.630949f);
            poly[59] = new TzPolygon(26.729418f,-103.701283f, 26.725256f,-103.699094f, 26.729418f,-103.742509f);
            poly[60] = new TzPolygon(27.531508f,-104.538735f, 27.531508f,-103.856280f, 27.311592f,-103.876876f, 27.298294f,-103.832123f, 27.213476f,-103.798427f,
                    27.124730f,-103.799398f, 27.077920f,-103.752461f, 27.022522f,-103.740834f, 26.934619f,-103.852089f, 26.935813f,-103.835919f,
                    26.896134f,-103.851701f, 26.829573f,-103.753968f, 26.729418f,-103.701283f, 26.729418f,-103.742509f, 26.753517f,-103.993921f,
                    26.777517f,-103.995129f, 26.774330f,-104.033296f, 26.742827f,-104.045792f, 26.777095f,-104.227863f, 26.842300f,-104.273037f,
                    26.799023f,-104.315295f, 26.760715f,-104.317265f, 26.729418f,-104.290028f, 26.729418f,-104.538735f);
            poly[61] = new TzPolygon(27.048310f,-103.446522f, 27.053160f,-103.453794f, 27.182641f,-103.530715f, 27.281639f,-103.521528f, 27.281630f,-103.462132f,
                    27.300733f,-103.446522f);
            poly[62] = new TzPolygon(27.425605f,-103.446522f, 27.435105f,-103.506027f, 27.531508f,-103.496270f, 27.531508f,-103.446522f);
            poly[63] = new TzPolygon(28.333599f,-103.736782f, 27.971357f,-103.926692f, 27.957490f,-103.877716f, 27.914023f,-103.892886f, 27.950821f,-103.954973f,
                    27.835309f,-103.960002f, 27.826857f,-103.900844f, 27.797553f,-103.935650f, 27.739186f,-103.881145f, 27.740557f,-103.896692f,
                    27.656549f,-103.897263f, 27.549433f,-103.854601f, 27.531508f,-103.856280f, 27.531508f,-104.538735f, 28.333599f,-104.538735f);
            poly[64] = new TzPolygon(27.531508f,-103.446522f, 27.531508f,-103.496270f, 27.764753f,-103.472662f, 27.780422f,-103.493997f, 27.828017f,-103.446522f);
            poly[65] = new TzPolygon(27.857730f,-103.446522f, 27.863472f,-103.449645f, 27.867085f,-103.506989f, 27.907812f,-103.504929f, 27.879970f,-103.537427f,
                    27.902833f,-103.604406f, 27.864562f,-103.634013f, 28.333599f,-103.456882f, 28.333592f,-103.446522f);
            poly[66] = new TzPolygon(27.300733f,-103.446522f, 27.411194f,-103.356256f, 27.425605f,-103.446522f, 27.828017f,-103.446522f, 27.838502f,-103.436063f,
                    27.857730f,-103.446522f, 28.333592f,-103.446522f, 28.332868f,-102.436574f, 28.289561f,-102.492944f, 28.147617f,-102.412415f,
                    28.015507f,-102.384525f, 27.973875f,-102.354308f, 27.256342f,-102.354308f, 27.262001f,-102.365845f, 27.192400f,-102.411886f,
                    27.148235f,-102.354308f, 27.017671f,-102.354308f, 27.026899f,-102.442863f, 27.080604f,-102.485629f, 27.160036f,-102.640201f,
                    27.064374f,-102.695282f, 27.083463f,-102.728071f, 27.044990f,-102.743664f, 27.048355f,-102.782713f, 27.080955f,-102.808391f,
                    26.873131f,-102.799681f, 26.979568f,-102.987568f, 26.963190f,-102.988784f, 26.977935f,-103.027151f, 26.973928f,-103.334998f,
                    27.048310f,-103.446522f);
            poly[67] = new TzPolygon(27.973875f,-102.354308f, 27.964631f,-102.347599f, 28.005032f,-102.282384f, 27.947977f,-102.215023f, 27.897244f,-102.254101f,
                    27.887145f,-102.300301f, 27.848216f,-102.265327f, 27.863911f,-102.246937f, 27.851511f,-102.201336f, 27.818064f,-102.157031f,
                    27.692404f,-102.199515f, 27.657046f,-102.182351f, 27.695147f,-102.136961f, 27.567978f,-102.090081f, 27.420001f,-101.939623f,
                    27.316847f,-101.893455f, 27.247850f,-101.971419f, 27.263171f,-102.011111f, 27.236389f,-102.034447f, 27.248705f,-102.124223f,
                    27.278843f,-102.144687f, 27.272775f,-102.316681f, 27.231634f,-102.303942f, 27.256342f,-102.354308f);
            poly[68] = new TzPolygon(27.148235f,-102.354308f, 27.131519f,-102.332516f, 27.011473f,-102.294823f, 27.017671f,-102.354308f);
            poly[69] = new TzPolygon(29.705406f,-104.538735f, 29.771360f,-104.565900f, 29.920780f,-104.679970f, 29.937781f,-104.683579f, 29.937781f,-104.538735f);
            poly[70] = new TzPolygon(29.504712f,-105.630949f, 29.502590f,-105.442803f, 29.463725f,-105.480325f, 29.409735f,-105.454257f, 29.419804f,-105.365860f,
                    29.400512f,-105.349754f, 29.376317f,-105.364724f, 29.363606f,-105.320328f, 29.239636f,-105.202371f, 29.204732f,-105.140956f,
                    29.212777f,-105.068600f, 29.184177f,-105.045365f, 29.126619f,-105.063648f, 29.101846f,-105.107714f, 29.049377f,-105.132393f,
                    28.977980f,-105.061755f, 28.995968f,-105.037765f, 28.983849f,-104.954996f, 29.007072f,-104.916317f, 28.973901f,-104.896897f,
                    28.994769f,-104.840074f, 28.776479f,-104.662185f, 28.768787f,-104.685402f, 28.735336f,-104.672181f, 28.755700f,-104.617408f,
                    28.726497f,-104.617233f, 28.757786f,-104.538735f, 28.333599f,-104.538735f, 28.333599f,-105.630949f);
            poly[71] = new TzPolygon(28.590302f,-103.992628f, 28.558964f,-104.021831f, 28.600631f,-104.058121f, 28.635285f,-104.050598f, 28.677296f,-104.077218f,
                    28.708047f,-104.118999f, 28.678387f,-104.144749f, 28.704321f,-104.172031f, 28.686855f,-104.184089f, 28.707638f,-104.222449f,
                    28.648461f,-104.260774f, 28.634995f,-104.243302f, 28.583460f,-104.293057f, 28.617322f,-104.327302f, 28.595588f,-104.348409f,
                    28.631426f,-104.419645f, 28.684855f,-104.370940f, 28.689200f,-104.417721f, 28.753239f,-104.465437f, 28.766659f,-104.516474f,
                    28.757786f,-104.538735f, 29.135690f,-104.538735f, 29.135690f,-103.992628f);
            poly[72] = new TzPolygon(29.056642f,-103.446522f, 29.135690f,-103.530062f, 29.135690f,-103.446522f);
            poly[73] = new TzPolygon(28.590302f,-103.992628f, 28.607326f,-103.976764f, 28.605142f,-103.926493f, 28.577443f,-103.925458f, 28.603799f,-103.841361f,
                    28.558061f,-103.722494f, 28.602846f,-103.705747f, 28.592591f,-103.628556f, 28.512462f,-103.643011f, 28.333599f,-103.736782f,
                    28.333599f,-103.992628f);
            poly[74] = new TzPolygon(28.333599f,-103.456882f, 28.361033f,-103.446522f, 28.333599f,-103.446522f);
            poly[75] = new TzPolygon(28.463727f,-103.446522f, 28.554505f,-103.637501f, 28.590834f,-103.591916f, 28.598195f,-103.616046f, 28.639475f,-103.596374f,
                    28.640639f,-103.572659f, 28.611281f,-103.557295f, 28.664998f,-103.514512f, 28.776250f,-103.446522f);
            poly[76] = new TzPolygon(28.333599f,-103.747051f, 28.554505f,-103.637501f, 28.463727f,-103.446522f, 28.361033f,-103.446522f, 28.333599f,-103.456882f);
            poly[77] = new TzPolygon(29.705890f,-104.538735f, 29.632490f,-104.508280f, 29.519700f,-104.337460f, 29.532840f,-104.315550f, 29.484720f,-104.213780f,
                    29.456250f,-104.217590f, 29.393220f,-104.165840f, 29.319800f,-104.037710f, 29.265453f,-103.783930f, 29.226715f,-103.781918f,
                    29.221830f,-103.742320f, 29.180810f,-103.718490f, 29.156680f,-103.650480f, 29.158000f,-103.553640f, 29.135690f,-103.530062f,
                    29.135690f,-104.538735f);
            poly[78] = new TzPolygon(29.937781f,-103.446522f, 29.937781f,-104.683579f, 30.049900f,-104.707380f, 30.098380f,-104.684960f, 30.234910f,-104.706290f,
                    30.332840f,-104.811610f, 30.375440f,-104.816610f, 30.390310f,-104.859480f, 30.419770f,-104.847780f, 30.570530f,-104.898870f,
                    30.605100f,-104.924690f, 30.625300f,-104.980750f, 30.663569f,-104.917229f, 30.836004f,-104.907465f, 31.541963f,-104.914266f,
                    31.541963f,-103.446522f);
            poly[79] = new TzPolygon(30.500295f,-105.630949f, 30.497250f,-105.596524f, 30.393175f,-105.607176f, 30.324669f,-105.563671f, 30.331094f,-105.624822f,
                    30.311720f,-105.625060f, 30.309088f,-105.630949f);
            poly[80] = new TzPolygon(30.238848f,-105.630949f, 30.238818f,-105.625328f, 30.188135f,-105.625477f, 30.190877f,-105.630949f);
            poly[81] = new TzPolygon(31.096774f,-105.630949f, 31.541963f,-105.630949f, 31.541963f,-104.914266f, 30.836004f,-104.907465f, 30.663569f,-104.917229f,
                    30.629398f,-104.979553f, 30.686090f,-105.006590f, 30.685870f,-105.061750f, 30.749859f,-105.118055f, 30.752160f,-105.161460f,
                    30.769830f,-105.156270f, 30.792300f,-105.195200f, 30.783400f,-105.216410f, 30.805910f,-105.215010f, 30.794280f,-105.257470f,
                    30.825850f,-105.290780f, 30.810850f,-105.316670f, 30.840350f,-105.339130f, 30.851990f,-105.399860f, 30.889310f,-105.400040f,
                    30.989680f,-105.557190f, 31.083700f,-105.604420f);
            poly[82] = new TzPolygon(29.135690f,-103.446522f, 29.135690f,-103.016866f, 29.101332f,-103.033514f, 29.060690f,-103.100560f, 28.984610f,-103.115960f,
                    28.972230f,-103.163880f, 28.996100f,-103.267240f, 28.976780f,-103.285930f, 29.024490f,-103.307560f, 29.020650f,-103.338970f,
                    29.043120f,-103.330430f, 29.018470f,-103.360710f, 29.043450f,-103.432580f, 29.056642f,-103.446522f);
            poly[83] = new TzPolygon(28.463727f,-103.446522f, 28.448098f,-103.413642f, 28.361033f,-103.446522f);
            poly[84] = new TzPolygon(28.333599f,-102.436717f, 28.590584f,-102.486892f, 28.582313f,-102.505720f, 28.638292f,-102.569600f, 28.670648f,-102.552839f,
                    28.696971f,-102.638040f, 29.064056f,-102.404698f, 29.054158f,-102.354308f, 28.333599f,-102.354308f);
            poly[85] = new TzPolygon(29.056642f,-103.446522f, 29.043450f,-103.432580f, 29.018470f,-103.360710f, 29.046290f,-103.342800f, 29.018760f,-103.337160f,
                    29.022950f,-103.306690f, 28.869254f,-103.403650f, 28.833529f,-103.396347f, 28.813180f,-103.431663f, 28.786604f,-103.446522f);
            poly[86] = new TzPolygon(29.135690f,-103.016866f, 29.179270f,-102.995750f, 29.173600f,-102.950690f, 29.219420f,-102.912160f, 29.223440f,-102.867660f,
                    29.260000f,-102.906350f, 29.347860f,-102.884150f, 29.358940f,-102.839430f, 29.399390f,-102.812750f, 29.410450f,-102.833440f,
                    29.486280f,-102.800850f, 29.522900f,-102.808560f, 29.548280f,-102.771280f, 29.595190f,-102.768410f, 29.598250f,-102.740200f,
                    29.633090f,-102.742070f, 29.676720f,-102.693660f, 29.743910f,-102.675150f, 29.734130f,-102.630600f, 29.771460f,-102.568660f,
                    29.744650f,-102.548180f, 29.783580f,-102.517580f, 29.786640f,-102.487020f, 29.761240f,-102.387640f, 29.845560f,-102.364450f,
                    29.852712f,-102.354308f, 29.135690f,-102.354308f);
            poly[87] = new TzPolygon(29.621589f,-101.262095f, 29.619206f,-101.280274f, 29.572092f,-101.289445f, 29.580233f,-101.307423f, 29.653060f,-101.303835f,
                    29.650452f,-101.362276f, 29.699634f,-101.371818f, 29.746460f,-101.416220f, 29.771200f,-101.401120f, 29.749890f,-101.447700f,
                    29.789970f,-101.461870f, 29.758070f,-101.536210f, 29.812130f,-101.544540f, 29.769680f,-101.574740f, 29.754210f,-101.645040f,
                    29.771120f,-101.661680f, 29.780230f,-101.804760f, 29.811750f,-101.818080f, 29.787380f,-101.823810f, 29.807890f,-101.852560f,
                    29.782660f,-101.929060f, 29.815910f,-101.976470f, 29.796750f,-101.987530f, 29.786450f,-102.072900f, 29.803220f,-102.143360f,
                    29.848520f,-102.186640f, 29.840520f,-102.223340f, 29.880030f,-102.315570f, 29.852712f,-102.354308f, 29.937781f,-102.354308f,
                    29.937781f,-101.262095f);
            poly[88] = new TzPolygon(29.054158f,-102.354308f, 28.984014f,-101.997202f, 28.509111f,-101.716974f, 28.388718f,-101.262095f, 28.333599f,-101.262095f,
                    28.333599f,-102.354308f);
            poly[89] = new TzPolygon(31.541963f,-104.914266f, 32.000263f,-104.918681f, 32.000391f,-103.064631f, 36.500453f,-103.041654f, 36.500439f,-103.002461f,
                    37.000087f,-103.002441f, 36.993128f,-102.042127f, 37.738541f,-102.041990f, 37.736435f,-101.527054f, 37.958689f,-101.536806f,
                    37.958689f,-101.262095f, 31.541963f,-101.262095f);
            poly[90] = new TzPolygon(31.541963f,-108.208443f, 31.783627f,-108.208394f, 31.783777f,-106.528064f, 31.748190f,-106.489450f, 31.764530f,-106.452090f,
                    31.732710f,-106.382070f, 31.541963f,-106.256511f);
            poly[91] = new TzPolygon(35.167602f,-109.999802f, 35.170948f,-109.625725f, 35.257645f,-109.624168f, 35.231499f,-109.198677f, 35.167481f,-109.199326f,
                    35.166000f,-109.046017f, 34.785265f,-109.045316f, 31.541963f,-109.049753f, 31.541963f,-109.999802f);
            poly[92] = new TzPolygon(26.634176f,-109.999802f, 26.654086f,-110.023243f, 26.887078f,-110.138212f, 26.973159f,-110.404644f, 27.085607f,-110.549517f,
                    27.161088f,-110.747029f, 27.287664f,-110.826696f, 27.489820f,-110.818454f, 27.639274f,-110.858023f, 27.652650f,-110.972247f,
                    27.781493f,-111.250195f, 27.753843f,-111.392089f, 27.808468f,-111.529387f, 27.870635f,-111.584902f, 27.950008f,-111.615637f,
                    28.000000f,-111.612786f, 28.000000f,-109.999802f);
            poly[93] = new TzPolygon(28.000000f,-109.999802f, 28.000000f,-111.612786f, 28.036767f,-111.610689f, 28.111808f,-111.567429f, 28.149497f,-111.588820f,
                    28.233032f,-111.663923f, 28.313718f,-111.871268f, 28.485754f,-111.967032f, 28.595942f,-112.100765f, 28.532976f,-112.178086f,
                    28.463692f,-112.123679f, 28.376445f,-112.104044f, 28.292679f,-112.124144f, 28.221931f,-112.177706f, 28.176310f,-112.255965f,
                    28.162148f,-112.345842f, 28.181032f,-112.436117f, 28.230172f,-112.510459f, 28.341794f,-112.568834f, 28.467195f,-112.545488f,
                    28.460757f,-112.593460f, 29.400000f,-112.880000f, 31.700000f,-114.623000f, 31.812000f,-114.755000f, 31.819726f,-114.815697f,
                    31.864083f,-114.843193f, 31.867601f,-114.910636f, 31.890713f,-114.942025f, 31.921465f,-114.965560f, 32.177995f,-114.975318f,
                    32.245174f,-115.053022f, 32.338794f,-114.966592f, 32.481751f,-114.935118f, 32.492249f,-114.881545f, 32.473424f,-114.848304f,
                    32.494077f,-114.813581f, 31.332239f,-111.074825f, 31.332370f,-109.999802f);
            poly[94] = new TzPolygon(32.494077f,-114.802170f, 32.494077f,-109.999802f, 31.332316f,-109.999802f, 31.332214f,-111.044352f);
            poly[95] = new TzPolygon(32.494077f,-117.526144f, 32.523540f,-117.519113f, 32.590387f,-117.464899f, 32.567155f,-117.338623f, 32.494077f,-117.338623f);
            poly[96] = new TzPolygon(32.567155f,-117.338623f, 32.553400f,-117.263858f, 32.527498f,-117.239059f, 32.634105f,-115.834170f, 32.494077f,-115.834170f,
                    32.494077f,-117.338623f);
            poly[97] = new TzPolygon(33.860230f,-115.834170f, 33.860230f,-114.521907f, 33.856915f,-114.530169f, 33.814693f,-114.528190f, 33.707365f,-114.494090f,
                    33.672877f,-114.531799f, 33.659529f,-114.513934f, 33.590246f,-114.540740f, 33.552743f,-114.524246f, 33.499417f,-114.591601f,
                    33.419683f,-114.638815f, 33.404830f,-114.725598f, 33.353167f,-114.698053f, 33.301714f,-114.731136f, 33.259266f,-114.672236f,
                    33.088846f,-114.706820f, 33.032735f,-114.661775f, 33.049023f,-114.645142f, 33.026980f,-114.616547f, 33.022000f,-114.509589f,
                    32.971920f,-114.493121f, 32.968357f,-114.467703f, 32.844391f,-114.469154f, 32.794697f,-114.530232f, 32.757160f,-114.526846f,
                    32.728646f,-114.616324f, 32.745539f,-114.701322f, 32.718655f,-114.719960f, 32.634105f,-115.834170f);
            poly[98] = new TzPolygon(32.634105f,-115.834170f, 32.718655f,-114.719960f, 32.643121f,-114.765186f, 32.622349f,-114.810505f, 32.557377f,-114.812952f,
                    32.556393f,-114.791494f, 32.494077f,-114.812235f, 32.494077f,-115.834170f);
            poly[99] = new TzPolygon(33.860230f,-114.521907f, 33.867817f,-114.502999f, 33.900790f,-114.526019f, 33.903155f,-114.508138f, 33.938167f,-114.534388f,
                    34.021841f,-114.438544f, 34.107010f,-114.416720f, 34.144165f,-114.329716f, 33.860230f,-114.329716f);
        }
    }

    private static class Initializer2 {
        private static void init() {
            poly[100] = new TzPolygon(34.446382f,-114.329716f, 34.450197f,-114.335722f, 34.456905f,-114.385776f, 34.528222f,-114.380706f, 34.593823f,-114.435934f,
                    34.710430f,-114.469869f, 34.766647f,-114.552212f, 34.874225f,-114.634609f, 35.024760f,-114.637787f, 35.068942f,-114.602813f,
                    35.102257f,-114.646277f, 35.128552f,-114.579302f, 35.185522f,-114.569735f, 35.226383f,-114.577646f, 35.226383f,-114.329716f);
            poly[101] = new TzPolygon(35.226383f,-114.329716f, 35.226383f,-114.577646f, 35.341945f,-114.600019f, 35.497924f,-114.678812f, 35.606492f,-114.653150f,
                    35.651132f,-114.689197f, 35.806757f,-114.711442f, 35.850909f,-114.705164f, 35.872349f,-114.662208f, 35.943217f,-114.730521f,
                    36.008333f,-114.743174f, 36.026910f,-114.723234f, 36.090705f,-114.753638f, 36.142306f,-114.631716f, 36.150956f,-114.511721f,
                    36.128796f,-114.502172f, 36.125970f,-114.446605f, 36.147371f,-114.405475f, 36.143114f,-114.372106f, 36.102724f,-114.329716f);
            poly[102] = new TzPolygon(34.446382f,-114.329716f, 34.348447f,-114.175550f, 34.261939f,-114.130782f, 34.259526f,-114.165133f, 34.187081f,-114.229223f,
                    34.138304f,-114.329716f);
            poly[103] = new TzPolygon(37.000667f,-112.825262f, 37.000191f,-114.050052f, 37.958689f,-114.048396f, 37.958689f,-112.825262f);
            poly[104] = new TzPolygon(37.958689f,-114.043838f, 36.196659f,-114.043982f, 36.111576f,-114.123144f, 36.023862f,-114.154130f, 36.020193f,-114.252651f,
                    36.059494f,-114.315557f, 36.082443f,-114.308430f, 36.102724f,-114.329716f, 37.958689f,-114.329716f);
            poly[105] = new TzPolygon(37.000667f,-112.825262f, 37.001241f,-111.350160f, 36.990246f,-111.402107f, 36.933144f,-111.320808f, 36.966995f,-111.376945f,
                    36.946236f,-111.395546f, 36.954151f,-111.438675f, 36.874314f,-111.425088f, 36.873032f,-111.557213f, 36.841702f,-111.545898f,
                    36.855499f,-111.600449f, 36.714771f,-111.701080f, 36.670296f,-111.685768f, 36.685810f,-111.724724f, 36.613300f,-111.745621f,
                    36.565331f,-111.797348f, 36.551251f,-111.784210f, 36.551289f,-111.809410f, 36.519093f,-111.811783f, 36.504170f,-111.841583f,
                    36.450172f,-111.819389f, 36.424374f,-111.858337f, 36.393040f,-111.828102f, 36.368607f,-111.873871f, 36.223370f,-111.801117f,
                    36.206963f,-111.759529f, 36.008282f,-111.760162f, 35.979126f,-111.705681f, 35.848061f,-111.722649f, 35.825745f,-111.688690f,
                    35.746346f,-111.689018f, 35.746018f,-111.741722f, 35.672962f,-111.740837f, 35.672699f,-111.640633f, 35.641388f,-111.640778f,
                    35.640183f,-111.553062f, 35.758530f,-111.531952f, 35.758414f,-111.320808f, 35.226383f,-111.320808f, 35.226383f,-112.825262f);
            poly[106] = new TzPolygon(35.809635f,-110.146202f, 35.809341f,-110.100975f, 35.782558f,-110.102875f, 35.792759f,-110.083420f, 35.702568f,-110.081573f,
                    35.692028f,-110.213905f, 35.719730f,-110.236206f);
            poly[107] = new TzPolygon(36.430649f,-111.320808f, 36.430649f,-109.999802f, 35.167602f,-109.999802f, 35.156540f,-111.236458f, 35.497009f,-111.242088f,
                    35.572510f,-111.268478f, 35.613194f,-111.317871f, 35.758411f,-111.315582f, 35.758414f,-111.320808f);
            poly[108] = new TzPolygon(36.933975f,-111.320808f, 36.871849f,-111.231049f, 36.905846f,-111.320808f, 36.933144f,-111.320808f);
            poly[109] = new TzPolygon(21.090935f,-105.533986f, 20.931792f,-105.323035f, 20.870667f,-105.372315f, 20.854136f,-105.350380f, 20.949437f,-105.232058f,
                    20.953800f,-105.109835f, 20.973182f,-105.096655f, 20.986428f,-105.001698f, 20.952914f,-104.957415f, 20.909026f,-104.968822f,
                    20.909171f,-105.031613f, 20.934386f,-105.047440f, 20.919434f,-105.098641f, 20.857415f,-105.160563f, 20.767711f,-105.173397f,
                    20.777171f,-105.196961f, 20.747351f,-105.239916f, 20.703907f,-105.242773f, 20.647539f,-105.300929f, 20.624302f,-105.403923f,
                    20.626920f,-105.572490f, 20.685482f,-105.883254f, 20.799501f,-105.835389f, 20.866533f,-105.727601f);
            poly[110] = new TzPolygon(20.163373f,-104.519534f, 20.163373f,-105.788186f, 20.290646f,-105.884183f, 20.410648f,-105.908205f, 20.488740f,-105.891141f,
                    20.554270f,-105.843279f, 20.685482f,-105.883254f, 20.626920f,-105.572490f, 20.634775f,-105.330481f, 20.703907f,-105.242773f,
                    20.747351f,-105.239916f, 20.777171f,-105.196961f, 20.767711f,-105.173397f, 20.887167f,-105.141857f, 20.931471f,-105.080337f,
                    20.909508f,-104.967244f, 20.946341f,-104.900526f, 21.020009f,-104.838099f, 21.012288f,-104.729989f, 20.983154f,-104.729363f,
                    20.943841f,-104.681000f, 20.924152f,-104.556922f, 20.867750f,-104.519534f);
            poly[111] = new TzPolygon(20.867750f,-104.519534f, 21.436715f,-104.519534f, 21.436715f,-103.729129f, 21.425431f,-103.720895f, 21.410304f,-103.764403f,
                    21.388433f,-103.767333f, 21.374055f,-103.741332f, 21.336709f,-103.749352f, 21.281041f,-103.820346f, 21.248435f,-103.819391f,
                    21.226490f,-103.898363f, 21.262547f,-103.931057f, 21.234572f,-103.924020f, 21.256328f,-103.973454f, 21.194673f,-104.027969f,
                    21.205413f,-104.052838f, 21.186773f,-104.068586f, 21.205361f,-104.085659f, 21.176611f,-104.219398f, 21.118601f,-104.210860f,
                    21.027332f,-104.242713f, 20.936373f,-104.206588f, 20.887796f,-104.290916f, 20.845496f,-104.295416f, 20.840931f,-104.361768f,
                    20.811644f,-104.350402f, 20.784073f,-104.375892f, 20.798098f,-104.328322f, 20.770795f,-104.297617f, 20.783481f,-104.282856f,
                    20.713434f,-104.241816f, 20.603221f,-104.254146f, 20.628993f,-104.282011f, 20.689157f,-104.288487f, 20.838187f,-104.499938f);
            poly[112] = new TzPolygon(23.280975f,-105.661076f, 23.280975f,-105.473049f, 23.124277f,-105.473049f, 23.128012f,-105.501978f, 23.098887f,-105.554309f,
                    23.141768f,-105.643991f, 23.235581f,-105.630317f, 23.276479f,-105.643208f);
            poly[113] = new TzPolygon(25.020496f,-107.061817f, 25.025255f,-107.063571f, 25.053139f,-107.129892f, 25.125236f,-107.127206f, 25.125236f,-107.061817f);
            poly[114] = new TzPolygon(23.280975f,-105.661076f, 23.287520f,-105.687084f, 23.340569f,-105.694005f, 23.374897f,-105.730690f, 23.420171f,-105.700289f,
                    23.445206f,-105.738865f, 23.474840f,-105.723445f, 23.502959f,-105.760338f, 23.556465f,-105.769302f, 23.611029f,-105.811644f,
                    23.603256f,-105.845516f, 23.583695f,-105.845186f, 23.590394f,-105.884318f, 23.552645f,-105.892655f, 23.588270f,-105.908905f,
                    23.684136f,-105.926634f, 23.739399f,-105.906093f, 23.840742f,-105.961265f, 23.908585f,-105.953662f, 23.875243f,-105.867241f,
                    23.899296f,-105.857588f, 23.943921f,-105.899919f, 23.948026f,-105.945415f, 23.997534f,-105.912136f, 24.043383f,-105.998720f,
                    24.114390f,-105.989724f, 24.203106f,-106.034856f, 24.203106f,-105.473049f, 23.280975f,-105.473049f);
            poly[115] = new TzPolygon(25.020496f,-107.061817f, 24.909908f,-107.021053f, 24.928241f,-107.000575f, 24.880536f,-106.934508f, 24.866624f,-106.927080f,
                    24.859024f,-106.951418f, 24.820917f,-106.930662f, 24.822955f,-106.865853f, 24.665262f,-106.705948f, 24.528979f,-106.645461f,
                    24.524897f,-106.622607f, 24.506503f,-106.630067f, 24.472711f,-106.560016f, 24.414566f,-106.601588f, 24.286984f,-106.517093f,
                    24.277857f,-106.469655f, 24.301941f,-106.367545f, 24.355695f,-106.336330f, 24.374755f,-106.268869f, 24.338786f,-106.151760f,
                    24.271389f,-106.075843f, 24.220201f,-106.069948f, 24.220850f,-106.043883f, 24.203106f,-106.034856f, 24.203106f,-107.061817f);
            poly[116] = new TzPolygon(21.565542f,-103.884281f, 21.581986f,-103.919235f, 21.618676f,-103.907699f, 21.641914f,-103.930249f, 21.697818f,-103.887725f,
                    21.727744f,-103.895913f, 21.743381f,-103.931828f, 21.771802f,-103.923482f, 21.790451f,-104.130382f, 21.809841f,-104.161748f,
                    21.850772f,-104.197000f, 21.871319f,-104.172233f, 21.891478f,-104.201041f, 21.963393f,-104.173699f, 21.985420f,-104.193319f,
                    21.966938f,-104.246005f, 22.002761f,-104.294077f, 21.975369f,-104.326863f, 21.976038f,-104.371164f, 22.102564f,-104.373191f,
                    22.245359f,-104.328679f, 22.298801f,-104.284496f, 22.356366f,-104.285740f, 22.358845f,-104.289479f, 22.358845f,-103.884281f);
            poly[117] = new TzPolygon(22.358845f,-104.524205f, 22.358845f,-104.485358f, 22.351617f,-104.481210f, 22.345099f,-104.506377f);
            poly[118] = new TzPolygon(22.565595f,-104.678665f, 22.568718f,-104.759812f, 22.648711f,-104.793992f, 22.634249f,-104.814677f, 22.648327f,-104.858397f,
                    22.607070f,-104.862493f, 22.498727f,-104.987912f, 22.585672f,-105.007553f, 22.656498f,-105.072368f, 22.678414f,-105.068422f,
                    22.737409f,-104.892720f, 22.748538f,-104.915637f, 22.819781f,-104.918389f, 22.813605f,-104.958967f, 22.836049f,-104.988405f,
                    22.976983f,-105.003139f, 22.941330f,-105.323570f, 23.060575f,-105.350471f, 23.116897f,-105.415892f, 23.124277f,-105.473049f,
                    23.280975f,-105.473049f, 23.280975f,-104.678665f);
            poly[119] = new TzPolygon(22.564336f,-104.678665f, 22.565262f,-104.669998f, 22.462155f,-104.655292f, 22.460508f,-104.602561f, 22.411955f,-104.593085f,
                    22.358845f,-104.524247f, 22.358845f,-104.678665f);
            poly[120] = new TzPolygon(22.358845f,-104.485358f, 22.376324f,-104.495390f, 22.421659f,-104.371512f, 22.386405f,-104.350041f, 22.365131f,-104.293127f,
                    22.358845f,-104.292364f);
            poly[121] = new TzPolygon(22.358845f,-103.884281f, 22.358845f,-104.289479f, 22.401315f,-104.353533f, 22.472989f,-104.296126f, 22.537397f,-104.325824f,
                    22.586203f,-104.261407f, 22.645610f,-104.289966f, 22.736539f,-104.266344f, 22.779250f,-104.221141f, 22.757995f,-104.181975f,
                    22.766617f,-104.080475f, 22.810311f,-104.111485f, 22.905118f,-104.112644f, 22.924830f,-104.153321f, 22.982445f,-104.173614f,
                    23.128408f,-104.172132f, 23.182214f,-104.129023f, 23.280975f,-104.118616f, 23.280975f,-103.884281f);
            poly[122] = new TzPolygon(21.565542f,-103.884281f, 21.552365f,-103.856272f, 21.524750f,-103.859925f, 21.493047f,-103.823713f, 21.498381f,-103.774129f,
                    21.436715f,-103.729129f, 21.436715f,-103.884281f);
            poly[123] = new TzPolygon(23.280975f,-104.118616f, 23.351205f,-104.111215f, 23.463493f,-104.065977f, 23.556983f,-103.925313f, 23.589175f,-103.921469f,
                    23.579828f,-103.890087f, 23.601871f,-103.906867f, 23.592965f,-103.884281f, 23.280975f,-103.884281f);
            poly[124] = new TzPolygon(25.125236f,-102.295513f, 25.115916f,-102.463325f, 24.999515f,-102.446763f, 25.066637f,-102.669694f, 25.008322f,-102.628885f,
                    24.978648f,-102.642955f, 24.978818f,-102.672984f, 24.942752f,-102.673061f, 24.902221f,-102.566236f, 24.709721f,-102.512182f,
                    24.428014f,-102.480267f, 24.411169f,-102.606593f, 24.373972f,-102.699904f, 24.376983f,-102.756654f, 24.406248f,-102.788852f,
                    24.384692f,-102.831736f, 24.461156f,-102.891880f, 24.428500f,-102.900148f, 24.457704f,-102.967440f, 24.433257f,-102.983573f,
                    24.466501f,-103.043150f, 24.401627f,-103.098527f, 24.435198f,-103.165259f, 24.417103f,-103.222833f, 24.447254f,-103.253532f,
                    24.428837f,-103.282645f, 24.430488f,-103.419332f, 24.332600f,-103.448340f, 24.287964f,-103.506755f, 24.286371f,-103.568350f,
                    24.193789f,-103.559536f, 24.117465f,-103.622007f, 24.110293f,-103.635969f, 24.149326f,-103.660361f, 24.021974f,-103.813274f,
                    24.007022f,-103.872386f, 23.964909f,-103.818360f, 23.874616f,-103.853112f, 23.807700f,-103.816198f, 23.752679f,-103.862295f,
                    23.679570f,-103.850983f, 23.676516f,-103.785059f, 23.630855f,-103.793542f, 23.613649f,-103.811302f, 23.640082f,-103.849178f,
                    23.628970f,-103.877429f, 23.592271f,-103.882522f, 23.592965f,-103.884281f, 25.125236f,-103.884281f);
            poly[125] = new TzPolygon(22.449519f,-99.252157f, 22.477554f,-99.263872f, 22.477554f,-99.252157f);
            poly[126] = new TzPolygon(24.512808f,-100.773835f, 24.556186f,-100.799934f, 24.583918f,-100.902234f, 24.542684f,-100.958793f, 24.591185f,-101.080495f,
                    24.623362f,-101.127620f, 24.775168f,-101.215039f, 24.813353f,-101.342142f, 24.736757f,-101.461639f, 24.758983f,-101.622270f,
                    24.800704f,-101.640767f, 24.789664f,-101.609012f, 24.835563f,-101.601261f, 24.860793f,-101.656332f, 24.840013f,-101.685149f,
                    24.875535f,-101.773463f, 25.017624f,-101.848810f, 25.125236f,-102.295513f, 25.125236f,-100.773835f);
            poly[127] = new TzPolygon(22.729605f,-100.012996f, 22.725925f,-100.022343f, 22.751265f,-100.094060f, 22.824394f,-100.029384f, 22.917892f,-100.044239f,
                    22.916714f,-100.110384f, 22.975719f,-100.110847f, 22.968757f,-100.089421f, 23.013091f,-100.097455f, 22.997357f,-100.071656f,
                    23.039844f,-100.062097f, 23.063095f,-100.012996f);
            poly[128] = new TzPolygon(23.064888f,-100.012996f, 23.095942f,-100.069029f, 23.121156f,-100.068743f, 23.125990f,-100.115597f, 23.231532f,-100.103811f,
                    23.250443f,-100.228242f, 23.307108f,-100.206322f, 23.310328f,-100.278379f, 23.260916f,-100.306212f, 23.265317f,-100.374235f,
                    23.189021f,-100.363793f, 23.195604f,-100.323538f, 23.162665f,-100.331774f, 23.194326f,-100.479881f, 23.366237f,-100.456791f,
                    23.421147f,-100.517143f, 23.528028f,-100.494347f, 23.511158f,-100.458950f, 23.567026f,-100.472450f, 23.568178f,-100.491747f,
                    23.696636f,-100.446996f, 23.688910f,-100.466503f, 23.736296f,-100.497707f, 23.798710f,-100.497605f, 23.801395f,-100.500858f,
                    23.801395f,-100.012996f);
            poly[129] = new TzPolygon(23.064888f,-100.012996f, 23.063921f,-100.011252f, 23.063095f,-100.012996f);
            poly[130] = new TzPolygon(22.729605f,-100.012996f, 22.751667f,-99.956958f, 22.749862f,-99.882397f, 22.730557f,-99.842819f, 22.678435f,-99.847923f,
                    22.660766f,-99.814029f, 22.659608f,-99.724085f, 22.681125f,-99.682535f, 22.641220f,-99.560638f, 22.612765f,-99.534692f,
                    22.620869f,-99.494536f, 22.744140f,-99.544327f, 22.742053f,-99.479220f, 22.663616f,-99.442053f, 22.670268f,-99.385553f,
                    22.629078f,-99.373200f, 22.634888f,-99.329618f, 22.477554f,-99.263872f, 22.477554f,-100.012996f);
            poly[131] = new TzPolygon(24.512808f,-100.773835f, 24.460435f,-100.742324f, 24.491517f,-100.711201f, 24.401300f,-100.603533f, 24.225979f,-100.633068f,
                    24.223929f,-100.585085f, 24.178193f,-100.593516f, 24.173944f,-100.613400f, 24.139897f,-100.516820f, 24.118521f,-100.538676f,
                    24.071443f,-100.523757f, 23.919641f,-100.562411f, 23.888384f,-100.539837f, 23.842200f,-100.550303f, 23.801395f,-100.500858f,
                    23.801395f,-100.773835f);
            poly[132] = new TzPolygon(25.125236f,-97.595507f, 25.125236f,-97.228502f, 24.979410f,-97.305319f, 25.041955f,-97.517400f);
            poly[133] = new TzPolygon(22.449519f,-99.252157f, 25.125236f,-99.252157f, 25.125236f,-97.595507f, 25.041955f,-97.517400f, 24.979410f,-97.305319f,
                    24.662461f,-97.410828f, 24.314511f,-97.486963f, 23.421640f,-97.544067f, 22.877531f,-97.544115f, 22.560543f,-97.636164f,
                    22.420218f,-97.621037f, 22.313607f,-97.574497f, 22.260351f,-97.792415f, 22.206966f,-97.844888f, 22.239131f,-97.917282f,
                    22.293892f,-97.956708f, 22.297432f,-98.000324f, 22.328050f,-97.970510f, 22.350864f,-97.990020f, 22.347161f,-98.072781f,
                    22.395303f,-98.113536f, 22.423869f,-98.187485f, 22.469559f,-98.194995f, 22.471657f,-98.247931f, 22.447291f,-98.272937f,
                    22.468562f,-98.316823f, 22.390740f,-98.318781f, 22.388703f,-98.352272f, 22.407446f,-98.355225f, 22.389284f,-98.387809f,
                    22.424293f,-98.388644f, 22.399927f,-98.409543f, 22.432864f,-98.433766f, 22.412192f,-98.460959f, 22.429472f,-98.505040f,
                    22.393945f,-98.574935f, 22.414524f,-98.638156f, 22.366313f,-98.758935f, 22.355094f,-98.889997f, 22.392775f,-98.931973f,
                    22.415269f,-99.060399f, 22.412862f,-99.236839f);
            poly[134] = new TzPolygon(26.729418f,-99.215680f, 26.729418f,-99.077668f, 26.400223f,-99.077668f, 26.397977f,-99.084530f, 26.432890f,-99.113680f,
                    26.475480f,-99.091690f, 26.499260f,-99.104380f, 26.541680f,-99.171040f, 26.724800f,-99.208790f);
            poly[135] = new TzPolygon(26.729418f,-101.262095f, 26.729418f,-99.630095f, 26.670365f,-99.659164f, 26.664596f,-99.538335f, 26.596566f,-99.396825f,
                    26.351301f,-99.430946f, 26.304799f,-99.401236f, 26.329270f,-99.364150f, 26.306358f,-99.333667f, 26.252822f,-99.332448f,
                    26.139388f,-99.401278f, 25.993512f,-99.334251f, 25.914420f,-99.332288f, 25.925399f,-99.312818f, 25.898677f,-99.296170f,
                    25.916133f,-99.265911f, 25.887817f,-99.241249f, 25.895526f,-99.191334f, 25.978378f,-99.171397f, 25.999519f,-99.194641f,
                    26.073133f,-99.190903f, 26.053597f,-99.128094f, 26.068582f,-99.131355f, 26.071799f,-99.077668f, 25.125236f,-99.077668f,
                    25.125236f,-101.262095f);
            poly[136] = new TzPolygon(28.176561f,-100.169882f, 28.190920f,-100.208560f, 28.232910f,-100.220950f, 28.276300f,-100.291990f, 28.311900f,-100.286370f,
                    28.333599f,-100.302489f, 28.333599f,-100.169882f);
            poly[137] = new TzPolygon(28.333599f,-101.262095f, 28.333098f,-100.596915f, 28.231953f,-100.629959f, 28.226969f,-100.669642f, 28.134438f,-100.641997f,
                    28.119405f,-100.545554f, 28.066741f,-100.591912f, 28.028624f,-100.538123f, 27.998503f,-100.546631f, 28.005144f,-100.571968f,
                    27.974393f,-100.580259f, 27.978203f,-100.601954f, 27.821439f,-100.658516f, 27.730947f,-100.286180f, 27.684599f,-100.350610f,
                    27.392685f,-100.421909f, 27.371055f,-100.385777f, 27.340108f,-100.399729f, 27.245413f,-100.283131f, 27.245470f,-100.252726f,
                    27.218432f,-100.252757f, 27.218465f,-100.182026f, 27.137164f,-100.171862f, 27.137166f,-100.169882f, 26.729418f,-100.169882f,
                    26.729418f,-101.262095f);
            poly[138] = new TzPolygon(26.729418f,-99.215680f, 26.745750f,-99.240050f, 26.843320f,-99.268680f, 26.878630f,-99.328470f, 26.919370f,-99.328460f,
                    26.937680f,-99.384490f, 27.010210f,-99.408580f, 27.021600f,-99.445830f, 27.175660f,-99.426200f, 27.250230f,-99.441660f,
                    27.263230f,-99.491410f, 27.300420f,-99.491570f, 27.316850f,-99.538070f, 27.339220f,-99.504230f, 27.479380f,-99.478720f,
                    27.498160f,-99.528100f, 27.531508f,-99.521371f, 27.531508f,-99.077668f, 26.729418f,-99.077668f);
            poly[139] = new TzPolygon(27.137166f,-100.169882f, 27.137215f,-100.121473f, 27.101066f,-100.121314f, 27.101117f,-100.101018f, 27.028904f,-100.121326f,
                    27.028914f,-100.090843f, 27.008686f,-100.090800f, 27.024427f,-100.012000f, 27.008824f,-99.959846f, 26.956230f,-100.019211f,
                    26.846425f,-99.968660f, 26.873775f,-99.936141f, 26.858309f,-99.929156f, 26.888278f,-99.849232f, 26.871581f,-99.804021f,
                    26.886714f,-99.810009f, 26.912156f,-99.744346f, 26.890694f,-99.630806f, 26.829475f,-99.580842f, 26.729418f,-99.630095f,
                    26.729418f,-100.169882f);
            poly[140] = new TzPolygon(28.176561f,-100.169882f, 28.144840f,-100.084440f, 27.993510f,-99.990440f, 27.980620f,-99.931380f, 27.941500f,-99.937500f,
                    27.899070f,-99.893360f, 27.797560f,-99.876260f, 27.763150f,-99.835870f, 27.774450f,-99.813340f, 27.657690f,-99.710500f,
                    27.659220f,-99.667100f, 27.626700f,-99.639120f, 27.639690f,-99.596020f, 27.603060f,-99.583540f, 27.614400f,-99.554800f,
                    27.566550f,-99.511810f, 27.531508f,-99.520157f, 27.531508f,-100.169882f);
            poly[141] = new TzPolygon(25.927327f,-98.584548f, 25.927327f,-97.999794f, 25.439381f,-97.999794f, 25.425929f,-98.058666f, 25.446437f,-98.058691f,
                    25.445959f,-98.239454f, 25.504373f,-98.262637f, 25.460292f,-98.328027f, 25.458482f,-98.374614f, 25.489787f,-98.377552f,
                    25.496790f,-98.432247f, 25.489362f,-98.581751f);
            poly[142] = new TzPolygon(26.060184f,-97.999794f, 26.067050f,-98.027660f, 26.041290f,-98.038840f, 26.036340f,-98.076550f, 26.071180f,-98.080420f,
                    26.074200f,-98.132130f, 26.049080f,-98.146520f, 26.075270f,-98.176840f, 26.053390f,-98.194920f, 26.104460f,-98.288210f,
                    26.120910f,-98.266400f, 26.103180f,-98.305760f, 26.166160f,-98.335910f, 26.157730f,-98.386520f, 26.200430f,-98.443820f,
                    26.224440f,-98.444580f, 26.219890f,-98.481310f, 26.200900f,-98.481830f, 26.235780f,-98.522400f, 26.225440f,-98.534880f,
                    26.248120f,-98.556250f, 26.224140f,-98.561470f, 26.256810f,-98.583140f, 26.259950f,-98.622920f, 26.236710f,-98.670100f,
                    26.262830f,-98.680990f, 26.272730f,-98.719880f, 26.287280f,-98.702910f, 26.295680f,-98.750560f, 26.330910f,-98.750320f,
                    26.330680f,-98.789100f, 26.368080f,-98.805540f, 26.353160f,-98.896530f, 26.394360f,-98.926280f, 26.369380f,-98.943610f,
                    26.401170f,-98.973870f, 26.392330f,-99.011250f, 26.413510f,-99.037080f, 26.400223f,-99.077668f, 26.729418f,-99.077668f,
                    26.729418f,-97.999794f);
            poly[143] = new TzPolygon(26.071799f,-99.077668f, 26.104057f,-99.023971f, 25.968323f,-98.900752f, 26.047649f,-98.823226f, 26.017918f,-98.585126f,
                    25.927327f,-98.584548f, 25.927327f,-99.077668f);
            poly[144] = new TzPolygon(26.060184f,-97.999794f, 26.729418f,-97.999794f, 26.729418f,-97.093120f, 26.333947f,-96.975299f, 26.092049f,-96.924648f,
                    25.975653f,-96.924030f, 25.949020f,-97.157130f, 25.965930f,-97.175370f, 25.959430f,-97.284000f, 25.935230f,-97.276660f,
                    25.915310f,-97.368890f, 25.867330f,-97.356610f, 25.837060f,-97.394230f, 25.862150f,-97.408600f, 25.840840f,-97.412880f,
                    25.853890f,-97.453850f, 25.884230f,-97.455880f, 25.886930f,-97.522270f, 25.930720f,-97.537180f, 25.933020f,-97.582970f,
                    25.952440f,-97.567900f, 25.957190f,-97.601940f, 25.990340f,-97.634550f, 26.002720f,-97.618650f, 26.010530f,-97.649240f,
                    26.023190f,-97.639030f, 26.019270f,-97.667990f, 26.038150f,-97.662600f, 26.018900f,-97.691520f, 26.037850f,-97.707260f,
                    26.025660f,-97.761430f, 26.047320f,-97.767680f, 26.029160f,-97.777450f, 26.060250f,-97.801110f, 26.045850f,-97.834560f,
                    26.070160f,-97.861610f, 26.051730f,-97.965480f);
            poly[145] = new TzPolygon(25.439381f,-97.999794f, 25.444071f,-97.979270f, 25.425992f,-97.979277f, 25.425991f,-97.949462f, 25.381327f,-97.949385f,
                    25.375792f,-97.899803f, 25.396303f,-97.877987f, 25.346776f,-97.803283f, 25.125236f,-97.595507f, 25.125236f,-97.999794f);
            poly[146] = new TzPolygon(28.333599f,-100.302489f, 28.390140f,-100.344490f, 28.442510f,-100.337440f, 28.476360f,-100.368360f, 28.499290f,-100.333890f,
                    28.515280f,-100.388530f, 28.550070f,-100.411090f, 28.585310f,-100.398700f, 28.609380f,-100.447310f, 28.641850f,-100.446460f,
                    28.661954f,-100.500474f, 28.805220f,-100.535220f, 28.828190f,-100.574340f, 28.901320f,-100.600700f, 28.914850f,-100.640910f,
                    29.100380f,-100.674590f, 29.168350f,-100.772640f, 29.195280f,-100.766820f, 29.263600f,-100.813790f, 29.280580f,-100.877800f,
                    29.307590f,-100.886290f, 29.368310f,-101.009890f, 29.458581f,-101.059875f, 29.475390f,-101.148530f, 29.515992f,-101.176844f,
                    29.522332f,-101.256804f, 29.623352f,-101.248643f, 29.621589f,-101.262095f, 31.541963f,-101.262095f, 31.541963f,-96.893242f,
                    28.333599f,-96.893242f);
            poly[147] = new TzPolygon(28.388718f,-101.262095f, 28.376462f,-101.215787f, 28.400328f,-100.962720f, 28.432214f,-100.938136f, 28.453480f,-100.868834f,
                    28.424450f,-100.808265f, 28.380950f,-100.809663f, 28.377465f,-100.612040f, 28.333599f,-100.597086f, 28.333599f,-101.262095f);
            poly[148] = new TzPolygon(42.449100f,-117.975222f, 42.448522f,-118.215030f, 44.212483f,-118.233641f, 44.256083f,-118.232140f, 44.270682f,-118.152639f,
                    44.299583f,-118.152340f, 44.328683f,-118.092239f, 44.415183f,-118.031442f, 44.441623f,-117.975222f);
            poly[149] = new TzPolygon(41.998206f,-117.009258f, 41.998206f,-111.596724f, 41.989104f,-113.796082f, 41.998127f,-117.009255f);
            poly[150] = new TzPolygon(37.958689f,-114.048396f, 40.726167f,-114.043613f, 40.725489f,-114.112847f, 40.755668f,-114.112976f, 40.755583f,-114.043787f,
                    41.993725f,-114.041735f, 41.998206f,-112.055845f, 41.998206f,-111.043564f, 37.958689f,-111.043564f);
            poly[151] = new TzPolygon(42.449100f,-117.975222f, 42.451386f,-117.026585f, 41.999890f,-117.026197f, 41.998206f,-116.210977f, 41.998206f,-117.975222f);
            poly[152] = new TzPolygon(45.027844f,-117.975222f, 45.027844f,-116.842641f, 45.022184f,-116.848241f, 44.977287f,-116.857775f, 44.983586f,-116.825925f,
                    44.887449f,-116.852490f, 44.783881f,-116.934700f, 44.727143f,-117.062273f, 44.536151f,-117.149242f, 44.482346f,-117.225076f,
                    44.427161f,-117.215068f, 44.390974f,-117.243032f, 44.336585f,-117.189769f, 44.313024f,-117.203323f, 44.301420f,-117.486153f,
                    44.387696f,-117.485899f, 44.415491f,-117.569880f, 44.444461f,-117.590992f, 44.443328f,-117.971596f, 44.441623f,-117.975222f);
            poly[153] = new TzPolygon(45.027844f,-116.842641f, 45.142091f,-116.729607f, 45.321511f,-116.673793f, 45.602785f,-116.463635f, 45.691734f,-116.535396f,
                    45.752735f,-116.549085f, 45.778541f,-116.593004f, 45.781998f,-116.665344f, 45.826267f,-116.711822f, 45.816167f,-116.759787f,
                    45.833471f,-116.789066f, 45.897457f,-116.728745f, 45.966591f,-116.744606f, 45.999191f,-116.698494f, 45.995495f,-116.646637f,
                    46.037723f,-116.624678f, 46.008703f,-116.618920f, 45.973879f,-116.548728f, 45.965206f,-116.447740f, 45.913085f,-116.428483f,
                    45.889411f,-116.329110f, 45.858297f,-116.295897f, 45.743131f,-116.326849f, 45.729009f,-116.302297f, 45.669580f,-116.319038f,
                    45.665777f,-116.280340f, 45.624209f,-116.304596f, 45.599579f,-116.272220f, 45.570729f,-116.305819f, 45.411253f,-116.310825f,
                    45.422497f,-116.283944f, 45.409289f,-116.242308f, 45.027844f,-116.242308f);
            poly[154] = new TzPolygon(45.409289f,-116.242308f, 45.399042f,-116.210006f, 45.427701f,-116.143235f, 45.403502f,-116.093058f, 45.459824f,-115.929634f,
                    45.468106f,-115.801938f, 45.375652f,-115.509351f, 45.456062f,-115.430206f, 45.475202f,-115.354640f, 45.523603f,-115.314175f,
                    45.569747f,-115.214077f, 45.492904f,-114.982064f, 45.393282f,-114.813764f, 45.394949f,-114.736576f, 45.440014f,-114.795133f,
                    45.512612f,-114.787738f, 45.471015f,-114.664329f, 45.557710f,-114.564936f, 45.562198f,-114.509393f, 44.017964f,-114.509393f,
                    44.017964f,-116.242308f);
            poly[155] = new TzPolygon(45.560021f,-114.509393f, 45.557710f,-114.564936f, 45.606592f,-114.537944f, 45.637621f,-114.563987f, 45.656918f,-114.509393f);
            poly[156] = new TzPolygon(45.717820f,-114.509393f, 45.773310f,-114.566465f, 45.845373f,-114.509393f);
            poly[157] = new TzPolygon(41.998206f,-112.055845f, 42.000484f,-111.046280f, 44.017964f,-111.048477f, 44.017964f,-111.043564f, 41.998206f,-111.043564f);
            poly[158] = new TzPolygon(45.027844f,-113.449499f, 45.027844f,-112.776478f, 44.486011f,-112.776478f, 44.484660f,-112.780810f, 44.424714f,-112.839890f,
                    44.377142f,-112.812208f, 44.359588f,-112.854267f, 44.405938f,-112.889557f, 44.452827f,-113.004506f, 44.495512f,-113.026824f,
                    44.525776f,-113.006530f, 44.599663f,-113.088292f, 44.634542f,-113.050722f, 44.772758f,-113.131459f, 44.822973f,-113.246894f,
                    44.784664f,-113.341276f, 44.835239f,-113.377567f, 44.865424f,-113.455071f, 44.942203f,-113.498818f, 44.959380f,-113.443939f);
            poly[159] = new TzPolygon(45.562198f,-114.509393f, 45.565223f,-114.471946f, 45.509911f,-114.424683f, 45.459722f,-114.330047f, 45.484552f,-114.269892f,
                    45.545813f,-114.248450f, 45.536372f,-114.193608f, 45.591464f,-114.086102f, 45.652766f,-114.015270f, 45.695901f,-114.015482f,
                    45.695565f,-113.937462f, 45.622007f,-113.904691f, 45.601630f,-113.806431f, 45.520657f,-113.834778f, 45.520621f,-113.766022f,
                    45.408477f,-113.776043f, 45.390811f,-113.733475f, 45.329409f,-113.738661f, 45.278886f,-113.680279f, 45.262503f,-113.691887f,
                    45.184779f,-113.592133f, 45.123851f,-113.569884f, 45.116129f,-113.511249f, 45.091388f,-113.522187f, 45.059174f,-113.452044f,
                    45.027844f,-113.449499f, 45.027844f,-114.509393f);
            poly[160] = new TzPolygon(46.037723f,-114.503066f, 46.031464f,-114.507504f, 46.030349f,-114.480347f, 45.992902f,-114.479992f, 45.977870f,-114.411755f,
                    45.936040f,-114.431396f, 45.883926f,-114.387868f, 45.851573f,-114.409654f, 45.845373f,-114.509393f, 46.037723f,-114.509393f);
            poly[161] = new TzPolygon(45.717820f,-114.509393f, 45.703970f,-114.495148f, 45.657535f,-114.507646f, 45.656918f,-114.509393f);
            poly[162] = new TzPolygon(44.486011f,-112.776478f, 44.504273f,-112.717930f, 44.462766f,-112.500642f, 44.479297f,-112.472687f, 44.447308f,-112.386524f,
                    44.538021f,-112.352509f, 44.568559f,-112.286568f, 44.520569f,-112.106400f, 44.566621f,-111.869319f, 44.508941f,-111.821530f,
                    44.560148f,-111.703164f, 44.538951f,-111.468002f, 44.604553f,-111.525678f, 44.643997f,-111.516310f, 44.666190f,-111.472483f,
                    44.705643f,-111.488784f, 44.710739f,-111.414273f, 44.754954f,-111.384824f, 44.729548f,-111.324378f, 44.667512f,-111.266804f,
                    44.651265f,-111.278477f, 44.622521f,-111.219319f, 44.614525f,-111.240889f, 44.576687f,-111.227631f, 44.532429f,-111.131382f,
                    44.497620f,-111.127383f, 44.474072f,-111.048974f, 44.017964f,-111.047565f, 44.017964f,-112.776478f);
            poly[163] = new TzPolygon(46.037723f,-124.253042f, 46.069884f,-124.233775f, 46.130190f,-124.314789f, 46.231659f,-124.373345f, 46.543051f,-124.353284f,
                    46.789352f,-124.394747f, 46.895178f,-124.469131f, 47.155984f,-124.493524f, 47.381145f,-124.682064f, 47.522715f,-124.680650f,
                    47.599851f,-124.767041f, 47.697041f,-124.789722f, 47.775106f,-124.890912f, 47.918860f,-125.008005f, 48.048003f,-125.017077f,
                    48.184511f,-125.084094f, 48.307783f,-125.021213f, 48.384212f,-125.046421f, 48.459790f,-125.028928f, 48.495179f,-125.003617f,
                    48.503672f,-124.915809f, 48.493444f,-124.727250f, 48.296667f,-124.012056f, 48.240000f,-123.679056f, 48.224556f,-123.541222f,
                    48.284028f,-123.248444f, 48.422833f,-123.115139f, 48.548722f,-123.218944f, 48.694000f,-123.267889f, 48.767111f,-123.008500f,
                    48.831222f,-123.008500f, 49.002072f,-123.322240f, 49.001597f,-120.508865f, 46.037723f,-120.508865f);
            poly[164] = new TzPolygon(49.000013f,-118.142540f, 49.000954f,-120.508865f, 49.527092f,-120.508865f, 49.527092f,-118.142540f);
            poly[165] = new TzPolygon(47.739643f,-115.776215f, 47.757334f,-115.797498f, 47.755036f,-115.830910f, 47.782407f,-115.838954f, 47.782407f,-115.776215f);
            poly[166] = new TzPolygon(47.782407f,-115.776215f, 47.782407f,-115.838954f, 47.827857f,-115.852312f, 47.853620f,-115.918885f, 47.976842f,-116.049108f,
                    49.000845f,-116.049232f, 49.000823f,-115.776215f);
            poly[167] = new TzPolygon(49.000636f,-115.776215f, 49.000873f,-116.026933f, 49.199791f,-116.027056f, 49.200096f,-116.097580f, 49.260965f,-116.066537f,
                    49.292839f,-116.104873f, 49.289447f,-116.168980f, 49.366738f,-116.160073f, 49.421277f,-116.238356f, 49.523009f,-116.297379f,
                    49.515337f,-116.361749f, 49.527092f,-116.394144f, 49.527092f,-115.776215f);
            poly[168] = new TzPolygon(49.527092f,-116.433699f, 49.492916f,-116.465347f, 49.457535f,-116.557321f, 49.472428f,-116.662892f, 49.527092f,-116.627919f);
            poly[169] = new TzPolygon(49.001198f,-118.142540f, 49.000845f,-116.049232f, 47.976842f,-116.049108f, 47.853620f,-115.918885f, 47.827857f,-115.852312f,
                    47.782407f,-115.838954f, 47.782407f,-118.142540f);
            poly[170] = new TzPolygon(49.000013f,-118.142540f, 49.527092f,-118.142540f, 49.527092f,-116.813730f, 49.348400f,-116.760300f, 49.271900f,-116.683700f,
                    49.177500f,-116.830200f, 49.213500f,-116.861000f, 49.182600f,-116.940100f, 49.149900f,-116.940200f, 49.167300f,-116.988900f,
                    49.155800f,-117.039200f, 49.059400f,-117.038600f, 49.064000f,-116.909500f, 49.037500f,-116.886300f, 48.999528f,-116.921458f);
            poly[171] = new TzPolygon(51.776200f,-118.142540f, 51.786500f,-118.184600f, 51.852215f,-118.142540f);
            poly[172] = new TzPolygon(51.896556f,-118.142540f, 51.895800f,-118.159000f, 51.950400f,-118.192600f, 51.986800f,-118.288100f, 51.980800f,-118.389500f,
                    52.031100f,-118.400400f, 52.012600f,-118.438900f, 52.054500f,-118.512000f, 52.054100f,-118.588400f, 52.104900f,-118.607000f,
                    52.149966f,-118.677906f, 52.189168f,-118.579368f, 52.290461f,-118.544295f, 52.287695f,-118.502246f, 52.310741f,-118.494032f,
                    52.334744f,-118.389253f, 52.364032f,-118.357355f, 52.361045f,-118.306694f, 52.332877f,-118.296382f, 52.384621f,-118.219630f,
                    52.443856f,-118.252459f, 52.485118f,-118.198350f, 52.504579f,-118.263188f, 52.539208f,-118.290633f, 52.564545f,-118.271993f,
                    52.577725f,-118.328762f, 52.615241f,-118.356640f, 52.678963f,-118.288358f, 52.709582f,-118.344445f, 52.737868f,-118.328466f,
                    52.773778f,-118.418889f, 52.847163f,-118.384140f, 52.855392f,-118.453112f, 52.886945f,-118.453059f, 52.905830f,-118.498212f,
                    52.881268f,-118.615493f, 52.935640f,-118.610602f, 52.978385f,-118.672863f, 52.998701f,-118.640158f, 53.016461f,-118.648599f,
                    53.016461f,-118.142540f);
            poly[173] = new TzPolygon(50.808455f,-116.959377f, 50.814770f,-117.039935f, 50.858427f,-117.045993f, 50.861598f,-117.085543f, 50.958134f,-117.039984f,
                    50.980840f,-117.167425f, 51.022617f,-117.135796f, 51.066500f,-117.217300f, 51.271777f,-117.326945f, 51.271777f,-116.959377f);
            poly[174] = new TzPolygon(49.527092f,-116.813730f, 49.589200f,-116.832300f, 49.637700f,-116.911100f, 49.809200f,-116.869700f, 49.798000f,-116.719900f,
                    49.814500f,-116.705800f, 49.737174f,-116.586983f, 49.696965f,-116.588644f, 49.641902f,-116.677949f, 49.627647f,-116.644628f,
                    49.573010f,-116.685648f, 49.536360f,-116.621989f, 49.527092f,-116.627894f);
            poly[175] = new TzPolygon(49.527092f,-116.433699f, 49.537835f,-116.423751f, 49.527092f,-116.394144f);
            poly[176] = new TzPolygon(50.808455f,-116.959377f, 50.771388f,-116.884687f, 50.784988f,-116.813401f, 50.735411f,-116.821000f, 50.678786f,-116.749901f,
                    50.678398f,-116.657584f, 50.641557f,-116.578436f, 50.597275f,-116.655905f, 50.466497f,-116.718835f, 50.410002f,-116.640500f,
                    50.317287f,-116.620543f, 50.319355f,-116.542133f, 50.216599f,-116.561653f, 50.155409f,-116.452936f, 50.065647f,-116.499981f,
                    49.987453f,-116.442456f, 49.965879f,-116.461073f, 49.986438f,-116.511892f, 49.953028f,-116.580360f, 49.887545f,-116.633889f,
                    49.876084f,-116.695151f, 49.802979f,-116.679400f, 49.809200f,-116.869700f, 49.637700f,-116.911100f, 49.589200f,-116.832300f,
                    49.527092f,-116.813730f, 49.527092f,-116.959377f);
            poly[177] = new TzPolygon(51.896556f,-118.142540f, 51.897900f,-118.113300f, 51.852215f,-118.142540f);
            poly[178] = new TzPolygon(51.776200f,-118.142540f, 51.773300f,-118.130700f, 51.732600f,-118.109700f, 51.721400f,-118.031700f, 51.748600f,-118.012600f,
                    51.722100f,-117.943000f, 51.656000f,-117.913300f, 51.623800f,-117.980100f, 51.530500f,-117.940300f, 51.473200f,-117.976000f,
                    51.451400f,-117.923700f, 51.488200f,-117.847500f, 51.453200f,-117.815800f, 51.418300f,-117.717400f, 51.467100f,-117.432000f,
                    51.412200f,-117.420400f, 51.401700f,-117.373600f, 51.367700f,-117.361800f, 51.361100f,-117.249300f, 51.329200f,-117.201200f,
                    51.300000f,-117.235100f, 51.273500f,-117.217300f, 51.283300f,-117.333100f, 51.271777f,-117.326945f, 51.271777f,-118.142540f);
            poly[179] = new TzPolygon(49.000636f,-115.776215f, 53.016461f,-115.776215f, 53.016461f,-111.043564f, 48.997664f,-111.043564f, 48.996667f,-111.575694f);
            poly[180] = new TzPolygon(47.739643f,-115.776215f, 47.695118f,-115.722648f, 47.653811f,-115.736508f, 47.595300f,-115.687758f, 47.547933f,-115.755620f,
                    47.531375f,-115.698314f, 47.484940f,-115.686264f, 47.479610f,-115.629488f, 47.423862f,-115.759304f, 47.367404f,-115.577639f,
                    47.299244f,-115.528509f, 47.281444f,-115.482264f, 47.256684f,-115.319786f, 47.188334f,-115.300577f, 47.101911f,-115.144130f,
                    46.970036f,-115.048789f, 46.971901f,-115.001274f, 46.918681f,-114.925143f, 46.860009f,-114.948261f, 46.801630f,-114.895189f,
                    46.814529f,-114.865779f, 46.782711f,-114.829306f, 46.780145f,-114.784904f, 46.696902f,-114.766786f, 46.739234f,-114.665376f,
                    46.707262f,-114.620787f, 46.672912f,-114.642563f, 46.635900f,-114.605732f, 46.649992f,-114.541822f, 46.631801f,-114.466834f,
                    46.671138f,-114.358224f, 46.653417f,-114.324615f, 46.519652f,-114.342016f, 46.498811f,-114.403184f, 46.436795f,-114.368527f,
                    46.387046f,-114.422447f, 46.283766f,-114.427289f, 46.266041f,-114.470720f, 46.169273f,-114.444091f, 46.167680f,-114.514858f,
                    46.145411f,-114.527359f, 46.097790f,-114.460475f, 46.037723f,-114.503066f, 46.037723f,-115.776215f);
            poly[181] = new TzPolygon(49.000441f,-111.043564f, 49.000262f,-108.824497f, 37.958689f,-108.824497f, 37.958689f,-111.043564f);
            poly[182] = new TzPolygon(48.999483f,-108.824497f, 48.999609f,-110.005078f, 52.667270f,-110.005465f, 52.675360f,-109.440797f, 52.696460f,-109.440597f,
                    52.696660f,-109.396297f, 52.739960f,-109.396397f, 52.739860f,-109.312397f, 52.820260f,-109.323897f, 52.820160f,-109.251297f,
                    52.929661f,-109.252297f, 52.935861f,-109.130497f, 52.885460f,-109.130797f, 52.885360f,-109.009697f, 52.804660f,-109.009397f,
                    52.804260f,-108.888597f, 52.929261f,-108.912897f, 52.929361f,-108.888397f, 53.016461f,-108.888497f, 53.016461f,-108.824497f);
            poly[183] = new TzPolygon(60.001555f,-129.974167f, 60.001555f,-129.932869f, 59.998637f,-129.932869f, 59.998620f,-129.974167f);
            poly[184] = new TzPolygon(63.201980f,-129.932869f, 63.190038f,-129.974167f, 63.201980f,-129.974167f);
            poly[185] = new TzPolygon(57.500087f,-124.290734f, 57.499693f,-124.309273f, 57.516526f,-124.298417f, 57.551822f,-124.407750f, 57.648435f,-124.449058f,
                    57.684766f,-124.592565f, 57.665623f,-124.605847f, 57.739478f,-124.763796f, 57.723380f,-124.790544f, 57.822323f,-124.885614f,
                    57.836473f,-124.944816f, 57.979296f,-124.913315f, 58.000000f,-124.942122f, 58.000000f,-124.290734f);
            poly[186] = new TzPolygon(54.609562f,-121.469667f, 54.651573f,-121.531422f, 54.725058f,-121.474411f, 54.796900f,-121.525390f, 54.888683f,-121.731934f,
                    54.841374f,-121.783560f, 54.867867f,-121.872446f, 54.927442f,-121.848671f, 55.006678f,-121.945442f, 55.099977f,-122.107156f,
                    55.099358f,-122.173484f, 55.137837f,-122.192281f, 55.131633f,-122.265848f, 55.171451f,-122.294529f, 55.191848f,-122.247787f,
                    55.210211f,-122.262707f, 55.227090f,-122.332827f, 55.315386f,-122.431956f, 55.315093f,-122.486368f, 55.408543f,-122.595507f,
                    55.335409f,-122.677471f, 55.380355f,-122.792078f, 55.378117f,-122.853772f, 55.420145f,-122.890478f, 55.402029f,-122.994077f,
                    55.462939f,-122.999615f, 55.460728f,-122.932832f, 55.501073f,-122.966086f, 55.508230f,-122.962461f, 55.508230f,-121.469667f);
            poly[187] = new TzPolygon(56.754115f,-124.290734f, 56.754115f,-123.784835f, 56.740579f,-123.764521f, 56.685251f,-123.761567f, 56.651708f,-123.664181f,
                    56.589994f,-123.670062f, 56.569416f,-123.741461f, 56.534067f,-123.678057f, 56.509162f,-123.698476f, 56.512687f,-123.604406f,
                    56.463774f,-123.553875f, 56.413104f,-123.559602f, 56.384363f,-123.634151f, 56.352997f,-123.618851f, 56.354077f,-123.568948f,
                    56.321116f,-123.529377f, 56.319171f,-123.569541f, 56.258324f,-123.574784f, 56.203269f,-123.487451f, 56.177603f,-123.513816f,
                    56.029904f,-123.448476f, 55.968118f,-123.478223f, 55.939265f,-123.428016f, 55.883908f,-123.453080f, 55.860694f,-123.367078f,
                    55.835225f,-123.385219f, 55.797587f,-123.316687f, 55.756780f,-123.310986f, 55.742275f,-123.350080f, 55.713065f,-123.330306f,
                    55.698971f,-123.259977f, 55.738808f,-123.160278f, 55.693927f,-123.125509f, 55.641474f,-123.150716f, 55.625635f,-123.073132f,
                    55.584715f,-123.079741f, 55.559763f,-123.037867f, 55.583635f,-122.967799f, 55.569548f,-122.931404f, 55.508230f,-122.962461f,
                    55.508230f,-124.290734f);
            poly[188] = new TzPolygon(57.500087f,-124.290734f, 57.502457f,-124.179184f, 57.455189f,-124.183588f, 57.449636f,-124.122223f, 57.404765f,-124.134182f,
                    57.319517f,-124.075250f, 57.294044f,-124.180698f, 57.264720f,-124.188497f, 57.204084f,-124.094305f, 57.163792f,-124.083458f,
                    57.163211f,-124.038763f, 57.104594f,-123.940030f, 57.055017f,-123.923670f, 57.045236f,-123.973385f, 57.013821f,-123.983490f,
                    56.994375f,-123.898045f, 56.938183f,-123.889162f, 56.925831f,-123.817463f, 56.893254f,-123.852654f, 56.809357f,-123.769783f,
                    56.769287f,-123.807603f, 56.754115f,-123.784835f, 56.754115f,-124.290734f);
            poly[189] = new TzPolygon(54.609562f,-121.469667f, 54.566114f,-121.405799f, 54.533009f,-121.398970f, 54.539964f,-121.363540f, 54.512274f,-121.315076f,
                    54.517307f,-121.270480f, 54.553350f,-121.251945f, 54.549179f,-121.127353f, 54.484455f,-121.130910f, 54.449283f,-121.075100f,
                    54.472775f,-121.066068f, 54.452714f,-121.044504f, 54.465825f,-121.003519f, 54.449591f,-120.935729f, 54.461752f,-120.881575f,
                    54.490958f,-120.877018f, 54.493932f,-120.825910f, 54.471601f,-120.792051f, 54.402535f,-120.786132f, 54.409204f,-120.733983f,
                    54.358546f,-120.659741f, 54.299221f,-120.729893f, 54.277301f,-120.591339f, 54.212813f,-120.561853f, 54.177733f,-120.587031f,
                    54.144836f,-120.551624f, 54.104937f,-120.329175f, 54.116807f,-120.183039f, 54.046444f,-120.176987f, 54.029607f,-120.207310f,
                    54.040745f,-120.235835f, 53.981655f,-120.263416f, 53.974365f,-120.207471f, 53.934123f,-120.195457f, 53.978469f,-120.136553f,
                    53.979505f,-120.077971f, 53.901899f,-120.068654f, 53.894953f,-120.059133f, 53.016461f,-120.059133f, 53.016461f,-121.469667f);
            poly[190] = new TzPolygon(53.894953f,-120.059133f, 55.508230f,-120.059133f, 55.508230f,-120.005964f, 53.796623f,-120.009187f, 53.826173f,-120.050849f,
                    53.863339f,-120.015798f);
            poly[191] = new TzPolygon(53.016461f,-118.648599f, 53.034386f,-118.657119f, 53.058119f,-118.731233f, 53.046366f,-118.778164f, 53.113450f,-118.729147f,
                    53.236820f,-118.948138f, 53.223281f,-119.025825f, 53.205269f,-118.993313f, 53.162950f,-119.030079f, 53.141323f,-118.994030f,
                    53.123837f,-119.027356f, 53.190957f,-119.147879f, 53.195370f,-119.228791f, 53.176646f,-119.261305f, 53.359374f,-119.390954f,
                    53.348927f,-119.447432f, 53.384764f,-119.605757f, 53.363171f,-119.606564f, 53.370171f,-119.680946f, 53.429392f,-119.767044f,
                    53.491508f,-119.784937f, 53.518526f,-119.835438f, 53.500232f,-119.865523f, 53.516435f,-119.901082f, 53.553155f,-119.861881f,
                    53.614537f,-119.921757f, 53.589973f,-119.770267f, 53.612598f,-119.716458f, 53.703248f,-119.792713f, 53.711566f,-119.912208f,
                    53.776398f,-119.888731f, 53.798712f,-120.001273f, 55.508230f,-120.001292f, 55.508230f,-118.648599f);
            poly[192] = new TzPolygon(55.508230f,-118.648599f, 55.508230f,-120.001292f, 58.000000f,-120.001319f, 58.000000f,-118.648599f);
            poly[193] = new TzPolygon(59.134960f,-127.111802f, 59.132744f,-127.141734f, 59.197095f,-127.194471f, 59.218994f,-127.164005f, 59.260890f,-127.227862f,
                    59.329319f,-127.179103f, 59.342593f,-127.205980f, 59.308087f,-127.310661f, 59.364413f,-127.332888f, 59.354323f,-127.392039f,
                    59.408338f,-127.376578f, 59.416795f,-127.465680f, 59.512000f,-127.477920f, 59.524209f,-127.501076f, 59.507448f,-127.540002f,
                    59.562730f,-127.553902f, 59.626277f,-127.742770f, 59.758374f,-127.818283f, 59.797371f,-127.813098f, 59.816325f,-127.738828f,
                    59.828759f,-127.765922f, 59.839404f,-127.734219f, 60.001447f,-127.734219f, 60.001586f,-127.111802f);
            poly[194] = new TzPolygon(60.600990f,-129.932869f, 60.600990f,-127.111802f, 59.999812f,-127.111802f, 59.998637f,-129.932869f);
            poly[195] = new TzPolygon(62.084156f,-128.522335f, 62.141059f,-128.597625f, 62.111014f,-128.632946f, 62.133021f,-128.682743f, 62.101634f,-128.713194f,
                    62.099735f,-128.762459f, 62.048279f,-128.774238f, 62.072238f,-128.804039f, 62.058904f,-128.856075f, 62.088321f,-128.825743f,
                    62.121495f,-128.893622f, 62.098094f,-128.939848f, 62.128740f,-128.999833f, 62.106751f,-129.137352f, 62.150810f,-129.281073f,
                    62.212151f,-129.200479f, 62.269447f,-129.304358f, 62.317173f,-129.316514f, 62.370281f,-129.257695f, 62.369418f,-129.216628f,
                    62.396224f,-129.313901f, 62.451104f,-129.268522f, 62.463767f,-129.178176f, 62.487925f,-129.181481f, 62.534214f,-129.356156f,
                    62.584692f,-129.426396f, 62.574034f,-129.558339f, 62.633154f,-129.484114f, 62.708855f,-129.621296f, 62.826890f,-129.693888f,
                    62.873125f,-129.785333f, 62.895744f,-129.765795f, 62.891367f,-129.710237f, 62.922406f,-129.740677f, 63.043350f,-129.602501f,
                    63.079622f,-129.628897f, 63.063638f,-129.709518f, 63.083287f,-129.845781f, 63.128604f,-129.829297f, 63.138125f,-129.888985f,
                    63.201980f,-129.932869f, 63.201980f,-128.522335f);
            poly[196] = new TzPolygon(61.098579f,-127.111802f, 61.128763f,-127.122044f, 61.132862f,-127.111802f);
            poly[197] = new TzPolygon(61.375065f,-127.111802f, 61.386643f,-127.135873f, 61.462900f,-127.139774f, 61.469889f,-127.222032f, 61.511903f,-127.277600f,
                    61.495980f,-127.519343f, 61.539847f,-127.655194f, 61.595701f,-127.697716f, 61.608125f,-127.798063f, 61.685714f,-127.893347f,
                    61.750643f,-128.072204f, 61.793776f,-128.053860f, 61.809614f,-127.994068f, 61.844229f,-128.019165f, 61.865864f,-128.073338f,
                    61.861287f,-128.158830f, 61.841081f,-128.180799f, 61.854643f,-128.215617f, 61.936793f,-128.256095f, 61.951490f,-128.319803f,
                    61.991193f,-128.382488f, 62.024138f,-128.375379f, 62.062202f,-128.493287f, 62.084156f,-128.522335f, 63.201980f,-128.522335f,
                    63.201980f,-127.111802f);
            poly[198] = new TzPolygon(59.134960f,-127.111802f, 59.140147f,-127.041720f, 59.121215f,-126.964096f, 59.052940f,-126.979742f, 58.952928f,-126.914871f,
                    58.841031f,-127.061170f, 58.789592f,-127.011064f, 58.806974f,-126.920182f, 58.735981f,-126.797325f, 58.680132f,-126.819675f,
                    58.682193f,-126.872428f, 58.652628f,-126.932485f, 58.652477f,-126.865450f, 58.628428f,-126.832358f, 58.667150f,-126.795756f,
                    58.672062f,-126.738829f, 58.585702f,-126.592079f, 58.581367f,-126.508815f, 58.607309f,-126.482643f, 58.623935f,-126.338791f,
                    58.536868f,-126.342991f, 58.545530f,-126.266698f, 58.449588f,-126.092431f, 58.447042f,-125.975342f, 58.395569f,-125.938903f,
                    58.413119f,-125.902789f, 58.403543f,-125.853908f, 58.359153f,-125.831458f, 58.349679f,-125.780804f, 58.321222f,-125.787302f,
                    58.306566f,-125.701268f, 58.000000f,-125.701268f, 58.000000f,-127.111802f);
            poly[199] = new TzPolygon(60.600990f,-125.701268f, 60.000400f,-125.701268f, 59.999812f,-127.111802f, 60.600990f,-127.111802f);
        }
    }

    private static class Initializer3 {
        private static void init() {
            poly[200] = new TzPolygon(58.306566f,-125.701268f, 58.299330f,-125.658792f, 58.325333f,-125.555207f, 58.291177f,-125.492480f, 58.339250f,-125.443725f,
                    58.277112f,-125.335263f, 58.328046f,-125.297529f, 58.282567f,-125.260531f, 58.236740f,-125.143153f, 58.262606f,-125.015366f,
                    58.236364f,-124.982126f, 58.228591f,-124.887139f, 58.163701f,-124.880071f, 58.140954f,-124.832919f, 58.059751f,-124.925310f,
                    58.029630f,-124.909559f, 58.024265f,-124.967866f, 58.000000f,-124.938431f, 58.000000f,-125.701268f);
            poly[201] = new TzPolygon(60.600990f,-124.526163f, 60.534285f,-124.417930f, 60.465877f,-124.424106f, 60.458380f,-124.290734f, 60.000987f,-124.290734f,
                    60.000400f,-125.701268f, 60.600990f,-125.701268f);
            poly[202] = new TzPolygon(60.458380f,-124.290734f, 60.465877f,-124.424106f, 60.534285f,-124.417930f, 60.600990f,-124.526163f, 60.600990f,-124.290734f);
            poly[203] = new TzPolygon(60.799632f,-125.701268f, 60.803724f,-125.732209f, 60.910558f,-125.841816f, 60.848800f,-125.976755f, 60.796041f,-126.005355f,
                    60.813119f,-126.108151f, 60.865971f,-126.125686f, 60.853459f,-126.268592f, 60.812973f,-126.219674f, 60.780234f,-126.262177f,
                    60.788491f,-126.325003f, 60.767920f,-126.375071f, 60.813244f,-126.527952f, 60.767728f,-126.627862f, 60.781473f,-126.735869f,
                    60.760727f,-126.848129f, 60.814075f,-126.846336f, 60.861265f,-126.929000f, 60.882574f,-126.897556f, 61.027472f,-126.950669f,
                    61.053027f,-126.924797f, 61.065920f,-127.012355f, 61.033035f,-127.028398f, 61.028536f,-127.088034f, 61.098579f,-127.111802f,
                    61.132862f,-127.111802f, 61.175393f,-127.005531f, 61.223110f,-126.986682f, 61.230850f,-127.040194f, 61.346055f,-127.051490f,
                    61.375065f,-127.111802f, 63.201980f,-127.111802f, 63.201980f,-125.701268f);
            poly[204] = new TzPolygon(60.600990f,-124.526163f, 60.652280f,-124.609385f, 60.702459f,-124.635939f, 60.777842f,-124.482961f, 60.818855f,-124.542906f,
                    60.952339f,-124.579364f, 60.947770f,-124.746953f, 60.969209f,-124.824610f, 60.920867f,-124.883331f, 60.855727f,-124.863968f,
                    60.854465f,-124.979423f, 60.815728f,-125.050927f, 60.843882f,-125.086084f, 60.847677f,-125.183877f, 60.776801f,-125.325919f,
                    60.778620f,-125.439963f, 60.831871f,-125.573393f, 60.795592f,-125.670721f, 60.799632f,-125.701268f, 63.201980f,-125.701268f,
                    63.201980f,-124.290734f, 60.600990f,-124.290734f);
            poly[205] = new TzPolygon(58.000000f,-118.648599f, 58.000000f,-120.001319f, 60.000422f,-120.001341f, 60.000289f,-118.648599f);
            poly[206] = new TzPolygon(60.002217f,-124.290734f, 60.000422f,-120.001341f, 58.000000f,-120.001273f, 58.000000f,-124.290734f);
            poly[207] = new TzPolygon(60.458380f,-124.290734f, 60.453515f,-124.204178f, 60.371080f,-124.232784f, 60.236863f,-124.111698f, 60.198656f,-124.121020f,
                    60.146014f,-124.004868f, 60.074828f,-123.992124f, 60.001187f,-123.811471f, 60.000987f,-124.290734f);
            poly[208] = new TzPolygon(53.016461f,-108.824497f, 53.229461f,-109.073097f, 53.279061f,-109.079897f, 53.333061f,-109.241897f, 53.395661f,-109.294297f,
                    53.375461f,-109.465697f, 53.429561f,-109.571597f, 53.488761f,-109.549797f, 53.520761f,-109.622297f, 53.587161f,-109.643997f,
                    53.599461f,-109.769097f, 53.551761f,-109.839797f, 53.598902f,-110.005616f, 59.999441f,-110.006365f, 59.999511f,-108.824497f);
            poly[209] = new TzPolygon(59.999412f,-118.648599f, 63.201980f,-118.648599f, 63.201980f,-108.824497f, 59.998641f,-108.824497f, 59.998120f,-114.891600f);
            poly[210] = new TzPolygon(63.573302f,-129.974167f, 63.561576f,-129.914470f, 63.459813f,-129.812706f, 63.467646f,-129.915012f, 63.425950f,-129.943454f,
                    63.381111f,-129.897083f, 63.340261f,-129.939362f, 63.330730f,-129.974167f);
            poly[211] = new TzPolygon(63.611464f,-129.974167f, 63.610948f,-129.956640f, 63.588796f,-129.974167f);
            poly[212] = new TzPolygon(64.791916f,-108.824497f, 64.833631f,-109.334405f, 65.500330f,-110.667836f, 65.500314f,-112.501267f, 66.757706f,-116.616223f,
                    68.000283f,-120.682778f, 69.558178f,-120.683021f, 69.647998f,-116.836275f, 69.631901f,-116.638083f, 69.889305f,-117.146563f,
                    70.000422f,-117.118821f, 70.000460f,-112.885251f, 69.833787f,-112.885242f, 69.833789f,-112.651894f, 69.882660f,-112.633449f,
                    69.851674f,-112.613155f, 69.852618f,-112.519225f, 69.877909f,-112.485232f, 69.854287f,-112.507635f, 69.869615f,-112.457630f,
                    69.853036f,-112.483153f, 69.849592f,-112.438355f, 69.880621f,-112.342125f, 69.894573f,-112.393529f, 69.896912f,-112.322306f,
                    69.899178f,-112.554541f, 69.866361f,-112.563508f, 69.899007f,-112.561049f, 69.910823f,-112.655539f, 69.911882f,-112.501887f,
                    70.000463f,-112.501893f, 70.000492f,-110.001642f, 79.129982f,-110.002733f, 79.257032f,-108.824497f);
            poly[213] = new TzPolygon(53.375000f,-107.756288f, 49.384490f,-107.756288f, 49.384490f,-108.824497f, 53.375000f,-108.824497f);
            poly[214] = new TzPolygon(49.530211f,-101.392420f, 49.532731f,-101.392564f, 49.532714f,-101.417774f, 49.886670f,-101.417546f, 49.886660f,-101.447198f,
                    50.240543f,-101.447153f, 50.240506f,-101.476721f, 50.594388f,-101.476995f, 50.594393f,-101.508729f, 50.948485f,-101.508695f,
                    50.948581f,-101.538983f, 51.301712f,-101.539110f, 51.301876f,-101.570544f, 51.968568f,-101.577230f, 51.968581f,-101.609311f,
                    52.318158f,-101.609055f, 52.318150f,-101.637813f, 52.667274f,-101.637705f, 52.667261f,-101.671588f, 53.365781f,-101.700606f,
                    53.365808f,-101.735544f, 53.375000f,-101.735532f, 53.375000f,-101.392420f);
            poly[215] = new TzPolygon(49.384490f,-90.462040f, 49.500000f,-90.000000f, 50.750000f,-90.000000f, 51.000000f,-90.500000f, 51.250000f,-90.750000f,
                    51.500000f,-90.750000f, 51.750000f,-90.500000f, 52.000000f,-90.000000f, 52.750000f,-90.000000f, 52.750000f,-89.000000f,
                    53.000000f,-89.000000f, 53.375000f,-88.500000f, 49.384490f,-88.500000f);
            poly[216] = new TzPolygon(53.375000f,-101.735532f, 53.710706f,-101.735099f, 53.375000f,-101.735099f);
            poly[217] = new TzPolygon(53.710706f,-101.735099f, 53.710899f,-101.770647f, 54.064403f,-101.771323f, 54.064406f,-101.810434f, 54.096808f,-101.810446f,
                    54.259194f,-102.264514f, 54.509138f,-102.514514f, 54.759082f,-102.514514f, 55.009026f,-102.264514f, 55.111547f,-101.924050f,
                    55.809401f,-101.963723f, 55.809383f,-102.004034f, 59.999220f,-102.007591f, 59.999217f,-101.735099f);
            poly[218] = new TzPolygon(59.999511f,-108.824497f, 59.999226f,-102.000476f, 59.998641f,-108.824497f);
            poly[219] = new TzPolygon(56.652520f,-88.500000f, 56.687256f,-88.640613f, 56.687256f,-88.500000f);
            poly[220] = new TzPolygon(53.625000f,-88.500000f, 54.000000f,-89.000000f, 54.000000f,-90.000000f, 56.229664f,-89.999805f, 56.687256f,-89.251433f,
                    56.687256f,-88.640613f, 56.652520f,-88.500000f);
            poly[221] = new TzPolygon(58.343286f,-93.017141f, 58.343286f,-91.808775f, 57.089577f,-91.808775f, 57.054292f,-91.966190f, 57.049549f,-92.123103f,
                    57.072747f,-92.217068f, 57.047274f,-92.443205f, 56.925189f,-92.735427f, 56.940144f,-92.753898f, 57.107378f,-92.540321f,
                    57.237401f,-92.448994f, 57.363230f,-92.426660f, 57.525070f,-92.498610f, 57.541890f,-92.542170f, 57.799665f,-92.728444f,
                    58.171787f,-92.864617f, 58.200530f,-92.918490f);
            poly[222] = new TzPolygon(59.999143f,-95.117549f, 59.999140f,-94.826000f, 59.882520f,-94.833267f, 59.787196f,-94.773046f, 59.741779f,-94.827901f,
                    59.726902f,-94.788920f, 59.709594f,-94.835799f, 59.700915f,-94.794429f, 59.614267f,-94.837809f, 59.568414f,-94.764675f,
                    59.543643f,-94.811212f, 59.383558f,-94.707734f, 59.341757f,-94.728630f, 59.351033f,-94.662928f, 59.266971f,-94.802273f,
                    59.008965f,-94.797971f, 59.018478f,-94.757136f, 58.988168f,-94.691164f, 58.946576f,-94.687268f, 58.942458f,-94.596273f,
                    58.894701f,-94.585133f, 58.887734f,-94.618200f, 58.792745f,-94.473451f, 58.707081f,-94.430336f, 58.719674f,-94.324465f,
                    58.781337f,-94.293490f, 58.817005f,-94.215553f, 58.777255f,-94.146512f, 58.751561f,-93.889687f, 58.763348f,-93.838240f,
                    58.799372f,-93.828922f, 58.769313f,-93.813121f, 58.770561f,-93.744063f, 58.800685f,-93.754397f, 58.765807f,-93.592723f,
                    58.767452f,-93.529447f, 58.780939f,-93.535915f, 58.754302f,-93.486184f, 58.720328f,-93.495224f, 58.698533f,-93.432278f,
                    58.761426f,-93.336548f, 58.756287f,-93.230929f, 58.777508f,-93.241429f, 58.724411f,-93.162284f, 58.476360f,-93.109101f,
                    58.343286f,-93.017141f, 58.343286f,-95.117549f);
            poly[223] = new TzPolygon(56.687256f,-89.251433f, 56.846610f,-88.990816f, 56.839485f,-88.912742f, 56.859364f,-88.882881f, 56.827580f,-88.860802f,
                    56.838909f,-88.823349f, 56.797432f,-88.831207f, 56.688774f,-88.646759f, 56.687256f,-88.640613f);
            poly[224] = new TzPolygon(57.089577f,-91.808775f, 57.268330f,-91.011308f, 57.231216f,-90.623676f, 57.189723f,-90.517952f, 57.192989f,-90.434857f,
                    57.162074f,-90.420956f, 57.002819f,-89.956692f, 56.928488f,-89.385498f, 56.874093f,-89.193315f, 56.846610f,-88.990816f,
                    56.687256f,-89.251433f, 56.687256f,-91.808775f);
            poly[225] = new TzPolygon(64.791916f,-108.824497f, 79.257032f,-108.824497f, 79.545902f,-106.145572f, 80.123024f,-102.001012f, 73.429675f,-102.001534f,
                    72.242433f,-93.894588f, 71.878142f,-92.166233f, 70.017888f,-89.606081f, 69.260324f,-89.000000f, 67.000000f,-89.000000f,
                    67.000000f,-102.000000f, 64.233664f,-102.000596f);
            poly[226] = new TzPolygon(59.999511f,-88.500000f, 59.999511f,-102.000476f, 67.000000f,-102.000000f, 67.000000f,-89.000000f, 69.260324f,-89.000000f,
                    70.017888f,-89.606081f, 71.878142f,-92.166233f, 72.242433f,-93.894588f, 73.429675f,-102.001534f, 80.123024f,-102.001012f,
                    80.325468f,-100.308415f, 80.513782f,-97.549389f, 80.741941f,-97.269837f, 81.457997f,-95.359116f, 81.860549f,-92.769392f,
                    82.090244f,-91.567800f, 82.276869f,-88.777954f, 82.303898f,-88.500000f);
            poly[227] = new TzPolygon(64.791916f,-108.824497f, 64.233664f,-102.000596f, 59.999511f,-102.000476f, 59.999511f,-108.824497f);
            poly[228] = new TzPolygon(56.187094f,-87.694290f, 56.095921f,-87.629822f, 56.042232f,-87.480354f, 55.998974f,-87.430969f, 55.939842f,-87.238563f,
                    55.916050f,-86.908066f, 55.764652f,-86.372040f, 55.707176f,-86.260002f, 55.662723f,-86.055709f, 55.655434f,-85.902816f,
                    55.570255f,-85.652534f, 55.405380f,-85.399285f, 55.375016f,-85.229233f, 55.290497f,-85.072612f, 49.384490f,-85.072612f,
                    49.384490f,-88.500000f, 56.187094f,-88.500000f);
            poly[229] = new TzPolygon(52.496773f,-81.645224f, 52.609474f,-81.768943f, 52.664745f,-81.883857f, 52.759502f,-81.951309f, 52.764469f,-82.000000f,
                    52.777893f,-81.959579f, 52.785792f,-81.971196f, 52.785792f,-81.645224f);
            poly[230] = new TzPolygon(52.785792f,-81.645224f, 52.785792f,-81.971196f, 52.882942f,-82.114074f, 52.947357f,-82.263153f, 53.117104f,-82.281006f,
                    53.193077f,-82.232246f, 53.267982f,-82.112938f, 53.587864f,-82.215851f, 53.819817f,-82.126320f, 54.027718f,-82.232956f,
                    54.164105f,-82.394898f, 54.254684f,-82.436592f, 54.508911f,-82.316246f, 54.655407f,-82.288452f, 54.803795f,-82.197815f,
                    54.873863f,-82.207588f, 54.860290f,-82.239777f, 54.912853f,-82.267212f, 55.109474f,-82.253173f, 55.159210f,-82.348266f,
                    55.054394f,-82.311096f, 55.069969f,-82.404572f, 55.116223f,-82.453315f, 55.090477f,-82.517067f, 55.180107f,-82.680206f,
                    55.140431f,-82.708428f, 55.128262f,-82.803322f, 55.146702f,-82.884864f, 55.221966f,-82.958915f, 55.198608f,-83.338745f,
                    55.267910f,-83.692787f, 55.212089f,-83.630547f, 55.294983f,-83.886490f, 55.251080f,-84.082718f, 55.278450f,-84.171348f,
                    55.278042f,-84.306732f, 55.236660f,-84.550964f, 55.236389f,-84.787575f, 55.271791f,-84.999891f, 56.187094f,-84.999905f,
                    56.187094f,-81.645224f);
            poly[231] = new TzPolygon(55.283933f,-85.072612f, 56.187094f,-85.072612f, 56.187094f,-84.999905f, 55.271791f,-84.999891f, 55.268990f,-85.008796f);
            poly[232] = new TzPolygon(56.187094f,-81.645224f, 56.187094f,-84.999905f, 62.989698f,-85.000012f, 62.989698f,-81.645224f);
            poly[233] = new TzPolygon(56.187094f,-87.694290f, 56.231095f,-87.725403f, 56.389561f,-87.925156f, 56.462406f,-87.972641f, 56.538315f,-88.278473f,
                    56.652520f,-88.500000f, 62.989698f,-88.500000f, 62.989698f,-85.000012f, 56.187094f,-84.999905f);
            poly[234] = new TzPolygon(56.652520f,-88.500000f, 56.538315f,-88.278473f, 56.462406f,-87.972641f, 56.389561f,-87.925156f, 56.231095f,-87.725403f,
                    56.187094f,-87.694290f, 56.187094f,-88.500000f);
            poly[235] = new TzPolygon(52.496773f,-81.645224f, 52.489052f,-81.636749f, 52.443180f,-81.545707f, 52.351895f,-81.553116f, 52.291229f,-81.478386f,
                    52.116081f,-81.384544f, 52.041309f,-81.160148f, 52.037338f,-81.110115f, 52.058304f,-81.080452f, 52.027325f,-81.060181f,
                    52.040215f,-81.043808f, 52.011433f,-80.989090f, 51.898689f,-80.881111f, 51.905666f,-80.850395f, 51.880283f,-80.823792f,
                    51.892727f,-80.795173f, 51.813232f,-80.708428f, 51.846146f,-80.688545f, 51.805630f,-80.688645f, 51.701687f,-80.565765f,
                    51.549820f,-80.513710f, 51.464264f,-80.431786f, 51.382744f,-80.432815f, 51.339314f,-80.384712f, 51.308449f,-80.292457f,
                    51.291893f,-80.116425f, 51.243858f,-79.990204f, 51.200288f,-79.931531f, 49.384490f,-79.931531f, 49.384490f,-81.645224f);
            poly[236] = new TzPolygon(51.200288f,-79.931531f, 51.167770f,-79.887741f, 51.157154f,-79.799064f, 51.280308f,-79.686867f, 51.329529f,-79.744552f,
                    51.370861f,-79.734863f, 51.380703f,-79.707832f, 51.353138f,-79.722573f, 51.343563f,-79.674132f, 51.403736f,-79.681580f,
                    51.416210f,-79.611130f, 51.465935f,-79.573998f, 51.465185f,-79.501413f, 51.561030f,-79.541538f, 51.679863f,-79.329116f,
                    51.655965f,-79.217186f, 51.577089f,-79.244534f, 51.534057f,-79.201320f, 51.538646f,-79.103023f, 51.520714f,-79.074684f,
                    51.085141f,-79.074684f, 51.085141f,-79.931531f);
            poly[237] = new TzPolygon(52.785792f,-78.756715f, 52.757078f,-78.777712f, 52.775094f,-78.836660f, 52.734555f,-78.875524f, 52.711989f,-78.783749f,
                    52.680263f,-78.827034f, 52.669888f,-78.730156f, 52.634225f,-78.819098f, 52.602644f,-78.710368f, 52.551186f,-78.773927f,
                    52.491496f,-78.552801f, 52.332117f,-78.521438f, 52.289708f,-78.584187f, 52.177735f,-78.569691f, 52.057764f,-78.673175f,
                    52.053581f,-78.724436f, 51.989208f,-78.722474f, 51.925380f,-78.893032f, 51.841019f,-78.862177f, 51.767592f,-79.050736f,
                    51.613192f,-78.880770f, 51.516140f,-78.844912f, 51.481797f,-78.795898f, 51.384082f,-78.907835f, 51.333614f,-78.879230f,
                    51.248244f,-78.933198f, 51.167462f,-78.867142f, 51.222862f,-78.951008f, 51.286496f,-78.936212f, 51.459908f,-78.978590f,
                    51.520714f,-79.074684f, 52.785792f,-79.074684f);
            poly[238] = new TzPolygon(53.431739f,-79.074684f, 53.500475f,-79.138578f, 53.516867f,-79.074684f);
            poly[239] = new TzPolygon(53.682954f,-79.074684f, 53.694123f,-79.159220f, 53.716022f,-79.143230f, 53.713831f,-79.090599f, 53.766074f,-79.084248f,
                    53.769699f,-79.074684f);
            poly[240] = new TzPolygon(53.792604f,-79.074684f, 53.795064f,-79.082299f, 53.795765f,-79.074684f);
            poly[241] = new TzPolygon(53.858173f,-79.074684f, 53.870221f,-79.083484f, 53.861974f,-79.074684f);
            poly[242] = new TzPolygon(53.885670f,-79.074684f, 53.902374f,-79.105364f, 53.898251f,-79.074684f);
            poly[243] = new TzPolygon(53.929164f,-79.074684f, 53.948967f,-79.155066f, 53.939203f,-79.074684f);
            poly[244] = new TzPolygon(53.942596f,-79.074684f, 53.949705f,-79.107135f, 53.952761f,-79.074684f);
            poly[245] = new TzPolygon(53.965376f,-79.074684f, 53.973700f,-79.105658f, 53.977333f,-79.074684f);
            poly[246] = new TzPolygon(54.026383f,-79.074684f, 54.023992f,-79.103719f, 54.044557f,-79.090647f, 54.080907f,-79.177888f, 54.105004f,-79.163409f,
                    54.100495f,-79.074684f);
            poly[247] = new TzPolygon(54.104149f,-79.074684f, 54.130158f,-79.124059f, 54.159808f,-79.090832f, 54.137714f,-79.244784f, 54.152630f,-79.274953f,
                    54.174814f,-79.237437f, 54.175454f,-79.401392f, 54.231533f,-79.310222f, 54.300164f,-79.488423f, 54.345332f,-79.470036f,
                    54.367055f,-79.521034f, 54.437280f,-79.487026f, 54.460543f,-79.538528f, 54.486443f,-79.509164f, 54.486443f,-79.074684f);
            poly[248] = new TzPolygon(52.785792f,-78.761862f, 52.798727f,-78.757741f, 52.806984f,-78.794238f, 52.845271f,-78.748980f, 52.851152f,-78.834542f,
                    52.872690f,-78.841376f, 52.861020f,-78.888206f, 52.906982f,-78.881033f, 52.913341f,-78.921321f, 52.975727f,-78.839387f,
                    52.981157f,-78.934591f, 53.013113f,-78.995149f, 53.030630f,-78.955085f, 53.037203f,-78.990952f, 53.055609f,-78.931147f,
                    53.072022f,-78.993482f, 53.140181f,-78.946581f, 53.163901f,-78.943088f, 53.169947f,-78.976959f, 53.198555f,-78.915338f,
                    53.211446f,-78.944841f, 53.227688f,-78.908604f, 53.232356f,-78.953843f, 53.258470f,-78.918921f, 53.269851f,-78.972079f,
                    53.306830f,-78.953331f, 53.327062f,-78.999752f, 53.349197f,-78.941323f, 53.385821f,-78.952611f, 53.399133f,-78.889535f,
                    53.410932f,-79.064980f, 53.438931f,-79.043155f, 53.426835f,-79.070125f, 53.431739f,-79.074684f, 53.516867f,-79.074684f,
                    53.529227f,-79.026505f, 53.564842f,-79.031348f, 53.552378f,-78.916538f, 53.567090f,-78.985261f, 53.585092f,-78.981675f,
                    53.585015f,-79.074351f, 53.636117f,-79.062641f, 53.636117f,-78.217837f, 52.785792f,-78.217837f);
            poly[249] = new TzPolygon(54.104149f,-79.074684f, 54.100105f,-79.067007f, 54.100495f,-79.074684f);
            poly[250] = new TzPolygon(54.026383f,-79.074684f, 54.029108f,-79.041584f, 53.995529f,-78.971581f, 54.000023f,-79.068420f, 53.978142f,-79.067791f,
                    53.977333f,-79.074684f);
            poly[251] = new TzPolygon(53.965376f,-79.074684f, 53.956034f,-79.039920f, 53.952761f,-79.074684f);
            poly[252] = new TzPolygon(53.942596f,-79.074684f, 53.934980f,-79.039917f, 53.939203f,-79.074684f);
            poly[253] = new TzPolygon(53.929501f,-79.074684f, 53.899608f,-78.951247f, 53.884680f,-78.973691f, 53.898071f,-79.074684f);
            poly[254] = new TzPolygon(53.885557f,-79.074684f, 53.873662f,-79.052629f, 53.856420f,-79.068757f, 53.861974f,-79.074684f);
            poly[255] = new TzPolygon(53.858173f,-79.074684f, 53.842375f,-79.063144f, 53.837120f,-78.948760f, 53.806826f,-78.954581f, 53.795765f,-79.074684f);
            poly[256] = new TzPolygon(53.792604f,-79.074684f, 53.782064f,-79.042058f, 53.769699f,-79.074684f);
            poly[257] = new TzPolygon(53.682954f,-79.074684f, 53.680034f,-79.052578f, 53.636117f,-79.062641f, 53.636117f,-79.074684f);
            poly[258] = new TzPolygon(54.486443f,-79.509164f, 54.489501f,-79.505697f, 54.494865f,-79.549013f, 54.523457f,-79.536319f, 54.550978f,-79.592823f,
                    54.565808f,-79.530049f, 54.604806f,-79.548519f, 54.624100f,-79.584818f, 54.605398f,-79.645531f, 54.628028f,-79.665656f,
                    54.614821f,-79.761573f, 54.635567f,-79.774135f, 54.728733f,-79.554477f, 54.860159f,-78.973520f, 55.000000f,-78.540218f,
                    55.043133f,-78.315652f, 55.104528f,-78.217837f, 54.486443f,-78.217837f);
            poly[259] = new TzPolygon(56.187094f,-76.641539f, 56.146650f,-76.642281f, 56.047835f,-76.691017f, 56.000810f,-76.799522f, 55.929778f,-76.830164f,
                    55.827933f,-76.978543f, 55.820223f,-76.948683f, 55.822805f,-76.993321f, 55.752620f,-77.076064f, 55.749124f,-77.052486f,
                    55.667230f,-77.197289f, 55.719814f,-77.078288f, 55.666792f,-77.114831f, 55.395865f,-77.554265f, 55.357940f,-77.672390f,
                    55.271615f,-77.783284f, 55.126956f,-78.182104f, 55.104528f,-78.217837f, 56.187094f,-78.217837f);
            poly[260] = new TzPolygon(58.482664f,-78.217837f, 58.511207f,-78.257790f, 58.520749f,-78.330109f, 58.613431f,-78.392553f, 58.608917f,-78.437192f,
                    58.577533f,-78.451993f, 58.568850f,-78.385153f, 58.531613f,-78.371605f, 58.557419f,-78.470689f, 58.630370f,-78.514551f,
                    58.670122f,-78.615404f, 58.718865f,-78.520381f, 58.772922f,-78.592399f, 58.819216f,-78.548171f, 58.933493f,-78.599530f,
                    58.951266f,-78.558708f, 58.913771f,-78.450987f, 58.925913f,-78.397117f, 58.992424f,-78.302715f, 59.060478f,-78.333443f,
                    59.072711f,-78.299118f, 59.047947f,-78.237732f, 59.114693f,-78.270564f, 59.107473f,-78.217837f);
            poly[261] = new TzPolygon(60.791479f,-78.217837f, 60.789666f,-78.230859f, 60.817553f,-78.217837f);
            poly[262] = new TzPolygon(56.187094f,-76.641539f, 56.190207f,-76.641482f, 56.193783f,-76.670324f, 56.202846f,-76.615197f, 56.236862f,-76.626536f,
                    56.287832f,-76.557255f, 56.379708f,-76.527154f, 56.555942f,-76.556748f, 56.913180f,-76.531624f, 56.924034f,-76.570023f,
                    57.094678f,-76.577184f, 57.326327f,-76.669408f, 57.490789f,-76.802190f, 57.705407f,-76.904868f, 58.000000f,-77.213234f,
                    58.018617f,-77.198699f, 58.158863f,-77.543660f, 58.217559f,-77.522669f, 58.377964f,-78.071282f, 58.482664f,-78.217837f,
                    59.107473f,-78.217837f, 59.097294f,-78.143506f, 59.143958f,-78.206220f, 59.184423f,-78.138085f, 59.208883f,-78.171467f,
                    59.236762f,-78.038235f, 59.371311f,-77.868729f, 59.390858f,-77.765021f, 59.421604f,-77.771880f, 59.384612f,-77.927306f,
                    59.417150f,-77.974331f, 59.448718f,-77.951112f, 59.438065f,-77.866118f, 59.487791f,-77.937091f, 59.581917f,-77.776548f,
                    59.588396f,-77.781198f, 59.588396f,-74.790449f, 56.187094f,-74.790449f);
            poly[263] = new TzPolygon(59.588396f,-77.781198f, 59.679840f,-77.846834f, 59.719928f,-77.835025f, 59.718660f,-77.744044f, 59.691713f,-77.701196f,
                    59.708982f,-77.541054f, 59.738460f,-77.601258f, 59.761884f,-77.592001f, 59.759707f,-77.505192f, 59.827796f,-77.377503f,
                    59.900326f,-77.418596f, 59.912658f,-77.487471f, 60.000000f,-77.567627f, 60.030820f,-77.519119f, 60.061857f,-77.651135f,
                    60.167127f,-77.563688f, 60.313822f,-77.608406f, 60.327766f,-77.660538f, 60.365224f,-77.667988f, 60.386478f,-77.787308f,
                    60.531371f,-77.599743f, 60.589748f,-77.799286f, 60.638313f,-77.844850f, 60.701988f,-77.711881f, 60.769083f,-77.680461f,
                    60.743406f,-77.789232f, 60.786172f,-77.777507f, 60.749669f,-77.926934f, 60.770647f,-77.892165f, 60.790615f,-77.923515f,
                    60.777451f,-77.999847f, 60.803803f,-78.129341f, 60.791479f,-78.217837f, 60.817553f,-78.217837f, 60.862435f,-78.196879f,
                    60.931501f,-78.100054f, 61.044457f,-77.916374f, 61.060078f,-77.837189f, 61.150087f,-77.829425f, 61.197063f,-77.723022f,
                    61.240859f,-77.800614f, 61.246539f,-77.762456f, 61.289047f,-77.774125f, 61.289047f,-76.504143f, 59.588396f,-76.504143f);
            poly[264] = new TzPolygon(61.289047f,-77.774125f, 61.460909f,-77.821303f, 61.438745f,-77.737902f, 61.466286f,-77.725944f, 61.477650f,-77.573674f,
                    61.522204f,-77.716286f, 61.576126f,-77.655797f, 61.601315f,-77.746094f, 61.679934f,-77.798489f, 61.686870f,-77.974057f,
                    61.728739f,-78.032375f, 62.013718f,-78.170000f, 62.157075f,-78.204159f, 62.227340f,-78.169823f, 62.258438f,-78.204239f,
                    62.356690f,-78.105247f, 62.473114f,-77.725256f, 62.508673f,-77.692929f, 62.517479f,-77.594785f, 62.576849f,-77.523886f,
                    62.580486f,-77.430618f, 62.555074f,-77.335162f, 62.516955f,-76.773380f, 62.457502f,-76.504143f, 61.289047f,-76.504143f);
            poly[265] = new TzPolygon(62.457502f,-76.504143f, 62.352392f,-76.028143f, 62.354351f,-75.933517f, 62.266374f,-75.506512f, 62.319052f,-75.363516f,
                    62.258424f,-74.916669f, 62.205728f,-74.803039f, 62.208265f,-74.790449f, 59.588396f,-74.790449f, 59.588396f,-76.504143f);
            poly[266] = new TzPolygon(65.531634f,-86.076901f, 65.531634f,-85.256208f, 65.452991f,-85.072612f, 63.144018f,-85.072612f, 63.106410f,-85.211020f,
                    63.114330f,-85.369300f, 63.096020f,-85.435830f, 63.128320f,-85.562400f, 63.207040f,-85.632730f, 63.399450f,-85.662680f,
                    63.498310f,-85.594500f, 63.546760f,-85.630830f, 63.637670f,-85.588190f, 63.688400f,-85.636100f, 63.682670f,-86.033400f,
                    63.632350f,-86.261720f, 63.662600f,-86.559180f, 63.641390f,-86.660190f, 63.574840f,-86.767180f, 63.545730f,-86.935990f,
                    63.561420f,-87.130440f, 63.656710f,-87.218660f, 63.714790f,-87.207280f, 63.911330f,-86.900300f, 64.019440f,-86.459100f,
                    64.065430f,-86.353080f, 64.091360f,-86.170960f, 64.166890f,-86.183360f, 64.225570f,-86.303820f, 64.260750f,-86.280580f,
                    64.303840f,-86.361640f, 64.406260f,-86.329690f, 64.430280f,-86.383260f, 64.579680f,-86.392680f, 64.823390f,-86.177340f,
                    64.873610f,-86.195050f, 64.918740f,-86.125310f, 64.985710f,-86.210710f, 65.100830f,-86.126310f, 65.286170f,-86.158060f,
                    65.358840f,-86.077620f, 65.373250f,-86.135660f, 65.505980f,-86.093380f);
            poly[267] = new TzPolygon(65.531634f,-86.076901f, 65.764210f,-85.927510f, 65.923670f,-85.515080f, 65.791890f,-85.456630f, 65.794780f,-85.389170f,
                    65.814540f,-85.420360f, 65.833550f,-85.354910f, 65.826080f,-85.258070f, 65.761780f,-85.140430f, 65.725650f,-85.114440f,
                    65.719940f,-85.171390f, 65.647503f,-85.072612f, 65.570505f,-85.072612f, 65.544510f,-85.196050f, 65.567710f,-85.277210f,
                    65.541290f,-85.278750f, 65.531634f,-85.256208f);
            poly[268] = new TzPolygon(65.735862f,-85.072612f, 65.744510f,-85.099380f, 65.988620f,-85.158770f, 66.030715f,-85.083198f, 66.029979f,-85.072612f);
            poly[269] = new TzPolygon(62.989698f,-85.000012f, 63.159975f,-85.000015f, 63.227170f,-84.775260f, 63.295750f,-84.647710f, 63.285160f,-84.565580f,
                    63.312430f,-84.573510f, 63.371240f,-84.453930f, 63.481820f,-84.440090f, 63.606110f,-84.282290f, 63.633470f,-84.294360f,
                    63.592100f,-84.083620f, 63.651760f,-84.003480f, 63.718068f,-83.814951f, 63.773079f,-83.764209f, 63.763943f,-83.605438f,
                    63.923014f,-83.593896f, 64.006607f,-83.663054f, 64.033190f,-83.581481f, 64.101868f,-83.532530f, 64.121058f,-83.438072f,
                    64.097277f,-83.393315f, 64.111508f,-83.358918f, 62.989698f,-83.358918f);
            poly[270] = new TzPolygon(63.144078f,-85.072612f, 63.159975f,-85.000015f, 62.989698f,-85.000012f, 62.989698f,-85.072612f);
            poly[271] = new TzPolygon(65.109593f,-83.358918f, 65.140670f,-83.397030f, 65.166980f,-83.557870f, 65.154600f,-83.690310f, 65.132750f,-83.697890f,
                    65.167350f,-83.699680f, 65.161200f,-83.903130f, 65.193320f,-83.872560f, 65.181760f,-84.008530f, 65.207030f,-84.056880f,
                    65.202980f,-84.111580f, 65.220610f,-84.084040f, 65.218160f,-84.142850f, 65.270060f,-84.235610f, 65.274360f,-84.185050f,
                    65.336130f,-84.128830f, 65.377010f,-84.263010f, 65.374430f,-84.347930f, 65.469880f,-84.467530f, 65.475640f,-84.553180f,
                    65.350710f,-84.711860f, 65.213200f,-84.771910f, 65.213600f,-84.906580f, 65.329800f,-84.986110f, 65.531634f,-84.993627f,
                    65.531634f,-83.358918f);
            poly[272] = new TzPolygon(65.531634f,-85.072612f, 65.531634f,-85.000060f, 65.421008f,-85.000094f, 65.452311f,-85.072612f);
            poly[273] = new TzPolygon(64.260666f,-83.358918f, 64.260666f,-81.718752f, 64.220211f,-81.645224f, 64.104269f,-81.645224f, 64.079860f,-81.706690f,
                    64.041490f,-82.010350f, 63.987200f,-82.001400f, 63.979760f,-81.865460f, 64.006527f,-81.645224f, 63.566442f,-81.645224f,
                    63.565810f,-81.667540f, 63.591420f,-81.660670f, 63.632890f,-81.756530f, 63.624310f,-81.910980f, 63.642760f,-81.908700f,
                    63.686070f,-82.063950f, 63.680660f,-82.199140f, 63.656280f,-82.253380f, 63.668230f,-82.276370f, 63.643650f,-82.293110f,
                    63.662670f,-82.470180f, 63.705930f,-82.468100f, 63.737790f,-82.528360f, 63.788820f,-82.491790f, 63.835930f,-82.303370f,
                    63.874450f,-82.397110f, 63.864240f,-82.340350f, 63.893760f,-82.356270f, 63.956490f,-82.530380f, 63.955660f,-82.782880f,
                    63.981251f,-82.890824f, 63.938755f,-83.064721f, 63.965734f,-83.137686f, 64.007572f,-83.138837f, 64.131145f,-82.933088f,
                    64.178801f,-83.002014f, 64.174996f,-83.092989f, 64.149374f,-83.161197f, 64.110323f,-83.165030f, 64.143178f,-83.282370f,
                    64.111508f,-83.358918f);
            poly[274] = new TzPolygon(65.109593f,-83.358918f, 65.066500f,-83.306070f, 65.003940f,-83.302910f, 64.932310f,-83.183600f, 64.913440f,-83.001680f,
                    64.788010f,-82.725490f, 64.747740f,-82.525900f, 64.735520f,-82.545560f, 64.761240f,-82.346910f, 64.710160f,-82.188920f,
                    64.683640f,-82.211060f, 64.676060f,-82.065260f, 64.633540f,-82.038850f, 64.544127f,-81.815612f, 64.461210f,-81.731320f,
                    64.436710f,-81.770630f, 64.267350f,-81.730900f, 64.260666f,-81.718752f, 64.260666f,-83.358918f);
            poly[275] = new TzPolygon(65.647503f,-85.072612f, 65.610130f,-85.021650f, 65.573030f,-85.060620f, 65.570505f,-85.072612f);
            poly[276] = new TzPolygon(65.735862f,-85.072612f, 66.029979f,-85.072612f, 66.024293f,-84.990774f, 65.990840f,-85.008230f, 66.023677f,-84.983878f,
                    66.018781f,-84.915926f, 65.972920f,-84.837040f, 65.941360f,-84.848480f, 65.950770f,-84.899730f, 65.907810f,-84.791200f,
                    65.867060f,-84.768460f, 65.869750f,-84.725720f, 65.859730f,-84.810330f, 65.832800f,-84.700900f, 65.787900f,-84.709270f,
                    65.767920f,-84.640680f, 65.632450f,-84.551420f, 65.557220f,-84.631370f, 65.540330f,-84.714370f, 65.585620f,-84.819510f,
                    65.672380f,-84.876110f);
            poly[277] = new TzPolygon(68.073571f,-85.000142f, 66.023903f,-85.000090f, 66.024522f,-85.072612f, 68.073571f,-85.072612f);
            poly[278] = new TzPolygon(65.570505f,-85.072612f, 65.573030f,-85.060620f, 65.610130f,-85.021650f, 65.647503f,-85.072612f, 65.740562f,-85.072612f,
                    65.702961f,-85.000008f, 65.531634f,-85.000060f, 65.531634f,-85.072612f);
            poly[279] = new TzPolygon(73.157443f,-85.000270f, 68.073571f,-85.000142f, 68.073571f,-88.500000f, 73.157443f,-88.500000f);
            poly[280] = new TzPolygon(64.220211f,-81.645224f, 64.231510f,-81.628300f, 64.128880f,-81.583250f, 64.104269f,-81.645224f);
            poly[281] = new TzPolygon(64.006527f,-81.645224f, 64.025380f,-81.490110f, 64.044240f,-81.429160f, 64.074870f,-81.450660f, 64.085030f,-81.389460f,
                    64.062430f,-81.418340f, 64.074000f,-81.288230f, 64.041540f,-81.277980f, 64.021070f,-81.074260f, 63.969242f,-80.933669f,
                    63.985499f,-80.904690f, 64.047430f,-80.978030f, 64.079642f,-80.912829f, 64.115282f,-80.960017f, 64.119020f,-80.918290f,
                    64.059730f,-80.740660f, 64.005170f,-80.695410f, 63.988620f,-80.741600f, 64.001380f,-80.608050f, 63.980200f,-80.536720f,
                    63.944830f,-80.513760f, 63.939380f,-80.571410f, 63.911730f,-80.562540f, 63.895590f,-80.475710f, 63.872400f,-80.580260f,
                    63.901230f,-80.690530f, 63.875680f,-80.664330f, 63.861120f,-80.494040f, 63.819460f,-80.315310f, 63.791230f,-80.295170f,
                    63.800990f,-80.204660f, 63.757900f,-80.183920f, 63.786240f,-80.175010f, 63.768960f,-80.149500f, 63.724550f,-80.212000f,
                    63.740140f,-80.208690f, 63.718770f,-80.489660f, 63.633220f,-80.571720f, 63.566440f,-80.791340f, 63.529410f,-80.831150f,
                    63.525900f,-80.910820f, 63.457620f,-80.933320f, 63.445600f,-81.048200f, 63.570010f,-81.519280f, 63.566442f,-81.645224f);
            poly[282] = new TzPolygon(82.303898f,-88.500000f, 82.356200f,-87.962165f, 82.594807f,-86.904367f, 82.771835f,-85.000513f, 73.157443f,-85.000270f,
                    73.157443f,-88.500000f);
            poly[283] = new TzPolygon(47.575298f,-103.437448f, 47.527050f,-103.434273f, 47.515476f,-103.609627f, 47.575298f,-103.610132f);
            poly[284] = new TzPolygon(47.575298f,-103.093448f, 47.570328f,-103.183258f, 47.575298f,-103.219296f);
            poly[285] = new TzPolygon(47.575298f,-102.432684f, 47.565319f,-102.444198f, 47.515064f,-102.438293f, 47.511234f,-102.505493f, 47.544117f,-102.599647f,
                    47.529018f,-102.678001f, 47.574188f,-102.693779f, 47.575298f,-102.700876f);
            poly[286] = new TzPolygon(42.766993f,-102.432684f, 42.766993f,-100.845588f, 42.755013f,-100.845704f, 42.755328f,-100.890666f, 42.611364f,-100.890920f,
                    42.610367f,-100.773315f, 42.438517f,-100.775008f, 42.438502f,-100.829514f, 42.351938f,-100.829514f, 42.352040f,-100.810093f,
                    42.205074f,-100.808526f, 42.204855f,-100.750189f, 42.088661f,-100.750147f, 42.089584f,-100.844398f, 41.740372f,-100.843887f,
                    41.743195f,-101.404457f, 41.395439f,-101.405487f, 41.395943f,-101.270180f, 41.048794f,-101.268829f, 41.047630f,-101.248695f,
                    40.697426f,-101.245575f, 40.697338f,-101.343185f, 40.002728f,-101.322486f, 40.003062f,-102.051756f, 39.568170f,-102.049764f,
                    39.568550f,-101.390160f, 39.134537f,-101.391281f, 39.133850f,-101.477890f, 38.700176f,-101.484985f, 38.700375f,-101.569351f,
                    37.958689f,-101.536806f, 37.958689f,-102.432684f);
            poly[287] = new TzPolygon(45.171146f,-102.432684f, 45.171146f,-100.292771f, 45.095367f,-100.328568f, 45.023617f,-100.280991f, 45.025558f,-100.371338f,
                    44.984058f,-100.426239f, 44.860802f,-100.398048f, 44.759071f,-100.558273f, 44.831036f,-100.691536f, 44.798576f,-100.730042f,
                    44.767117f,-100.716438f, 44.722065f,-100.623131f, 44.577450f,-100.637611f, 44.541946f,-100.515800f, 44.493130f,-100.579178f,
                    44.449493f,-100.560533f, 44.168328f,-100.848518f, 44.168338f,-101.046893f, 43.846847f,-101.068008f, 43.841442f,-101.136740f,
                    43.820253f,-101.141949f, 43.829918f,-101.165590f, 43.808797f,-101.169310f, 43.812404f,-101.206887f, 43.785232f,-101.233552f,
                    42.997896f,-101.227692f, 42.997902f,-100.901392f, 42.813727f,-100.899765f, 42.813867f,-100.865008f, 42.784552f,-100.845418f,
                    42.766993f,-100.845588f, 42.766993f,-102.432684f);
            poly[288] = new TzPolygon(45.171146f,-100.291356f, 45.233192f,-100.260887f, 45.312309f,-100.316345f, 45.383984f,-100.277863f, 45.499245f,-100.363174f,
                    45.536617f,-100.486488f, 45.594879f,-100.430214f, 45.653843f,-100.420937f, 45.654686f,-100.339493f, 45.702648f,-100.298958f,
                    45.816643f,-100.387428f, 45.861507f,-100.357803f, 45.878887f,-100.426544f, 45.914410f,-100.423439f, 45.909294f,-100.473274f,
                    45.943654f,-100.511793f, 45.944165f,-101.324059f, 46.127716f,-101.310051f, 46.149441f,-101.189552f, 46.186039f,-101.196503f,
                    46.215271f,-101.116653f, 46.271698f,-101.096138f, 46.277943f,-101.025177f, 46.303230f,-100.999718f, 46.320118f,-101.017609f,
                    46.325314f,-100.974876f, 46.373222f,-100.924683f, 46.373222f,-100.260872f, 45.171146f,-100.260872f);
            poly[289] = new TzPolygon(46.373222f,-101.299215f, 46.373222f,-100.924683f, 46.325314f,-100.974876f, 46.320118f,-101.017609f, 46.303230f,-100.999718f,
                    46.275612f,-101.036331f, 46.370392f,-101.048958f, 46.370533f,-101.299210f);
            poly[290] = new TzPolygon(47.300749f,-101.346778f, 47.366879f,-101.362907f, 47.462914f,-101.441185f, 47.519905f,-101.374985f, 47.563206f,-101.435257f,
                    47.527866f,-101.611702f, 47.530487f,-101.737099f, 47.495255f,-101.817497f, 47.534542f,-102.022751f, 47.572887f,-102.029465f,
                    47.566730f,-102.183136f, 47.575298f,-102.194947f, 47.575298f,-101.346778f);
            poly[291] = new TzPolygon(47.560222f,-102.432684f, 47.575298f,-102.423863f, 47.575298f,-102.205561f, 47.573383f,-102.203430f, 47.329155f,-102.207764f,
                    47.327629f,-102.144234f, 46.982182f,-102.144226f, 46.980900f,-102.096992f, 46.717060f,-102.093910f, 46.717266f,-101.715202f,
                    46.631027f,-101.716919f, 46.630083f,-101.346778f, 46.373222f,-101.346778f, 46.373222f,-102.432684f);
            poly[292] = new TzPolygon(47.242036f,-101.346778f, 46.981875f,-101.346778f, 46.982071f,-101.763321f, 47.242020f,-101.763672f);
            poly[293] = new TzPolygon(46.630083f,-101.346778f, 46.631027f,-101.716919f, 46.717266f,-101.715202f, 46.717060f,-102.093910f, 46.980900f,-102.096992f,
                    46.981981f,-101.346778f);
            poly[294] = new TzPolygon(46.630083f,-101.346778f, 46.629963f,-101.299706f, 46.373222f,-101.299215f, 46.373222f,-101.346778f);
            poly[295] = new TzPolygon(47.300749f,-101.346778f, 47.291618f,-101.344551f, 47.268230f,-101.256798f, 47.242039f,-101.257156f, 47.242036f,-101.346778f);
            poly[296] = new TzPolygon(47.242036f,-101.346778f, 47.242039f,-101.257156f, 47.268230f,-101.256798f, 47.246471f,-101.201141f, 47.278255f,-101.184792f,
                    47.295284f,-101.078110f, 47.257961f,-100.985664f, 47.185822f,-100.988464f, 47.025436f,-100.879517f, 46.982574f,-100.935104f,
                    46.981875f,-101.346778f);
            poly[297] = new TzPolygon(46.373222f,-101.299215f, 46.629963f,-101.299706f, 46.630083f,-101.346778f, 46.981981f,-101.346778f, 46.982574f,-100.935104f,
                    46.904800f,-100.908463f, 46.806805f,-100.817108f, 46.749069f,-100.834251f, 46.731529f,-100.774475f, 46.691620f,-100.788506f,
                    46.689583f,-100.742447f, 46.656368f,-100.734642f, 46.677670f,-100.639626f, 46.634357f,-100.661606f, 46.593048f,-100.565109f,
                    46.574833f,-100.586197f, 46.531155f,-100.543213f, 46.417394f,-100.608800f, 46.412235f,-100.681858f, 46.380089f,-100.720617f,
                    46.400154f,-100.734940f, 46.385326f,-100.815903f, 46.407135f,-100.889153f, 46.373222f,-100.924683f);
            poly[298] = new TzPolygon(38.511610f,-87.528698f, 38.518406f,-87.540489f, 38.491661f,-87.540695f, 38.499451f,-87.583733f, 38.450817f,-87.598877f,
                    38.458000f,-87.655998f, 38.432560f,-87.662056f, 38.414097f,-87.744130f, 38.475069f,-87.739522f, 38.511911f,-87.654166f,
                    38.568198f,-87.652334f, 38.590988f,-87.613831f, 38.641171f,-87.619362f, 38.682720f,-87.532755f, 38.689590f,-87.528698f);
            poly[299] = new TzPolygon(38.829184f,-87.528698f, 38.863344f,-87.553384f, 38.895093f,-87.544089f, 38.895871f,-87.528698f);
        }
    }

    private static class Initializer4 {
        private static void init() {
            poly[300] = new TzPolygon(38.397577f,-86.679886f, 38.397579f,-86.681435f, 38.444052f,-86.681713f, 38.444052f,-86.679886f);
            poly[301] = new TzPolygon(38.263424f,-86.679886f, 38.397579f,-86.681435f, 38.397577f,-86.679886f);
            poly[302] = new TzPolygon(38.444052f,-87.444677f, 38.444052f,-87.072437f, 38.232304f,-87.072975f, 38.231949f,-87.298546f, 38.377327f,-87.315987f,
                    38.379398f,-87.407593f, 38.436062f,-87.407120f, 38.436230f,-87.444725f);
            poly[303] = new TzPolygon(37.958689f,-86.782360f, 37.998324f,-86.813712f, 38.015083f,-86.797275f, 37.998108f,-86.772720f, 38.029007f,-86.766540f,
                    38.040944f,-86.786442f, 38.101456f,-86.769600f, 38.143066f,-86.806618f, 38.249157f,-86.793579f, 38.256984f,-86.679886f,
                    37.958689f,-86.679886f);
            poly[304] = new TzPolygon(38.444052f,-87.072377f, 38.444052f,-86.681250f, 38.248470f,-86.679886f, 38.249157f,-86.793579f, 38.207005f,-86.793411f,
                    38.206470f,-87.072777f);
            poly[305] = new TzPolygon(38.929415f,-87.523497f, 38.917917f,-87.528698f, 38.929415f,-87.528698f);
            poly[306] = new TzPolygon(38.829184f,-87.528698f, 38.788429f,-87.499245f, 38.743126f,-87.497078f, 38.689590f,-87.528698f);
            poly[307] = new TzPolygon(38.498743f,-87.528698f, 38.495663f,-87.495476f, 38.532169f,-87.464203f, 38.466904f,-87.463936f, 38.467056f,-87.444534f,
                    38.444052f,-87.444677f, 38.444052f,-87.528698f);
            poly[308] = new TzPolygon(38.444052f,-86.679886f, 38.444052f,-86.681713f, 38.907909f,-86.684486f, 38.905399f,-87.528698f, 38.929415f,-87.520966f,
                    38.929402f,-86.679886f);
            poly[309] = new TzPolygon(38.444052f,-87.444677f, 38.467056f,-87.444534f, 38.466904f,-87.463936f, 38.532169f,-87.464203f, 38.539093f,-87.387802f,
                    38.512032f,-87.369240f, 38.544285f,-87.358444f, 38.510220f,-87.302177f, 38.552521f,-87.203186f, 38.515636f,-87.151665f,
                    38.537617f,-87.107735f, 38.514671f,-87.072258f, 38.444052f,-87.072437f);
            poly[310] = new TzPolygon(37.958689f,-86.512997f, 38.027879f,-86.524969f, 38.045672f,-86.490685f, 37.958689f,-86.371197f);
            poly[311] = new TzPolygon(38.397182f,-86.361189f, 38.397577f,-86.679886f, 38.444045f,-86.679886f, 38.444045f,-86.361189f);
            poly[312] = new TzPolygon(38.256984f,-86.679886f, 38.264446f,-86.571495f, 38.208244f,-86.572021f, 38.208260f,-86.461319f, 38.106781f,-86.466217f,
                    38.078303f,-86.430516f, 38.050490f,-86.452192f, 38.038327f,-86.521825f, 37.958689f,-86.511647f, 37.958689f,-86.679886f);
            poly[313] = new TzPolygon(37.958689f,-86.371197f, 38.045672f,-86.490685f, 38.067171f,-86.432789f, 38.124531f,-86.457115f, 38.105040f,-86.401407f,
                    38.129274f,-86.379775f, 38.130577f,-86.361189f, 37.958689f,-86.361189f);
            poly[314] = new TzPolygon(38.166943f,-86.361189f, 38.171395f,-86.375225f, 38.196502f,-86.361189f);
            poly[315] = new TzPolygon(38.397182f,-86.361189f, 38.444045f,-86.361189f, 38.444045f,-86.042493f, 38.419053f,-86.042493f, 38.422497f,-86.309082f,
                    38.397114f,-86.306793f);
            poly[316] = new TzPolygon(37.958689f,-86.043516f, 38.008641f,-86.094663f, 38.011308f,-86.178983f, 38.052721f,-86.261273f, 38.137874f,-86.271802f,
                    38.180989f,-86.331092f, 38.201748f,-86.290321f, 38.291420f,-86.253128f, 38.316414f,-86.289413f, 38.361698f,-86.270500f,
                    38.360294f,-86.248199f, 38.422401f,-86.254448f, 38.419165f,-86.042493f, 37.960669f,-86.042493f);
            poly[317] = new TzPolygon(38.130577f,-86.361189f, 38.132877f,-86.328398f, 38.156236f,-86.327439f, 38.166943f,-86.361189f, 38.196728f,-86.361063f,
                    38.137874f,-86.271802f, 38.052721f,-86.261273f, 38.011308f,-86.178983f, 38.008641f,-86.094663f, 37.958840f,-86.045374f,
                    37.963889f,-86.042493f, 37.958689f,-86.042493f, 37.958689f,-86.361189f);
            poly[318] = new TzPolygon(38.929392f,-86.042493f, 38.929382f,-85.405100f, 38.736694f,-85.405100f, 38.736431f,-85.416435f, 38.691794f,-85.456733f,
                    38.586773f,-85.428366f, 38.586138f,-85.478087f, 38.606736f,-85.496666f, 38.604641f,-85.793938f, 38.563095f,-85.821411f,
                    38.547020f,-85.866867f, 38.503147f,-85.884888f, 38.488686f,-85.993774f, 38.418438f,-85.994843f, 38.419053f,-86.042493f);
            poly[319] = new TzPolygon(37.963889f,-86.042493f, 37.994708f,-86.024907f, 37.997100f,-85.934216f, 38.040669f,-85.882564f, 38.085315f,-85.719773f,
                    38.073924f,-85.556654f, 38.118173f,-85.429050f, 38.263586f,-85.405100f, 37.958689f,-85.405100f, 37.958689f,-86.042493f);
            poly[320] = new TzPolygon(38.263586f,-85.405100f, 38.380139f,-85.637879f, 38.440837f,-85.604147f, 38.467992f,-85.499305f, 38.537747f,-85.417766f,
                    38.686032f,-85.456647f, 38.727023f,-85.437593f, 38.729917f,-85.405100f);
            poly[321] = new TzPolygon(38.929382f,-85.405100f, 38.929379f,-85.203407f, 38.691010f,-85.201473f, 38.739879f,-85.267691f, 38.736694f,-85.405100f);
            poly[322] = new TzPolygon(38.929415f,-85.135857f, 38.903080f,-85.140245f, 38.900969f,-84.870672f, 38.874978f,-84.784609f, 38.830370f,-84.829928f,
                    38.783935f,-84.815615f, 38.778147f,-84.992287f, 38.687508f,-85.188442f, 38.929379f,-85.203407f);
            poly[323] = new TzPolygon(38.929415f,-87.520966f, 38.954417f,-87.512187f, 38.988786f,-87.578319f, 39.057286f,-87.572588f, 39.144900f,-87.645990f,
                    39.218404f,-87.574558f, 39.282050f,-87.609779f, 39.333649f,-87.588813f, 39.347706f,-87.531375f, 40.736892f,-87.526046f,
                    40.736495f,-87.096788f, 40.839874f,-87.099533f, 40.840809f,-86.987160f, 40.913391f,-86.987656f, 40.909332f,-86.467178f,
                    41.432968f,-86.466603f, 41.432869f,-86.524672f, 41.433800f,-86.524674f, 41.433800f,-86.466347f, 38.929415f,-86.466347f);
            poly[324] = new TzPolygon(41.433800f,-86.641510f, 41.432968f,-86.466603f, 41.374874f,-86.466347f, 41.171120f,-86.467056f, 41.172207f,-86.930870f,
                    41.237099f,-86.930038f, 41.285160f,-86.784241f, 41.400585f,-86.702057f);
            poly[325] = new TzPolygon(41.172783f,-86.698959f, 41.171120f,-86.467056f, 40.997345f,-86.466530f, 40.909332f,-86.467178f, 40.913601f,-86.929291f,
                    41.085999f,-86.930954f, 41.172207f,-86.930870f);
            poly[326] = new TzPolygon(38.929415f,-85.135368f, 39.308182f,-85.065224f, 39.305186f,-84.819389f, 41.433800f,-84.807396f, 41.433800f,-74.790449f,
                    38.929415f,-74.790449f);
            poly[327] = new TzPolygon(47.575298f,-89.766677f, 46.566360f,-90.418620f, 46.533768f,-90.395069f, 46.553432f,-90.332230f, 46.516896f,-90.316554f,
                    46.501768f,-90.216811f, 46.336992f,-90.120263f, 46.138388f,-89.091741f, 46.051242f,-88.888320f, 44.504549f,-88.888320f,
                    44.504549f,-90.512970f, 47.575298f,-90.512970f);
            poly[328] = new TzPolygon(46.417681f,-88.888320f, 46.417449f,-88.992379f, 46.330379f,-88.991730f, 46.332202f,-89.365776f, 46.503688f,-89.364647f,
                    46.506355f,-89.738465f, 46.591235f,-89.737343f, 46.592727f,-89.865685f, 46.767847f,-89.862763f, 46.671753f,-90.035311f,
                    46.608837f,-90.332711f, 46.566360f,-90.418620f, 47.575298f,-89.766677f, 47.575298f,-88.888320f);
            poly[329] = new TzPolygon(45.782041f,-88.075995f, 45.809708f,-88.130129f, 45.866410f,-88.075995f);
            poly[330] = new TzPolygon(45.874787f,-88.075995f, 45.882282f,-88.101264f, 45.921546f,-88.102461f, 45.963532f,-88.246894f, 45.955215f,-88.327464f,
                    45.991765f,-88.380503f, 45.975092f,-88.416381f, 45.999514f,-88.458672f, 45.991367f,-88.489355f, 46.020019f,-88.514692f,
                    46.017770f,-88.601178f, 45.987896f,-88.615957f, 45.988547f,-88.670827f, 46.013699f,-88.679073f, 46.015157f,-88.780220f,
                    46.033645f,-88.796557f, 46.020340f,-88.816187f, 46.039924f,-88.861900f, 46.039924f,-88.075995f);
            poly[331] = new TzPolygon(45.874787f,-88.075995f, 45.872938f,-88.069763f, 45.866410f,-88.075995f);
            poly[332] = new TzPolygon(45.782041f,-88.075995f, 45.780085f,-88.072167f, 45.795393f,-87.991447f, 45.758220f,-87.963452f, 45.754379f,-87.876898f,
                    45.681483f,-87.781419f, 45.652987f,-87.825129f, 45.588498f,-87.777199f, 45.563055f,-87.792372f, 45.561045f,-87.833733f,
                    45.499967f,-87.792769f, 45.434473f,-87.861697f, 45.403872f,-87.849322f, 45.354697f,-87.888052f, 45.349442f,-87.754104f,
                    45.389893f,-87.693956f, 45.368754f,-87.657350f, 45.339396f,-87.648126f, 45.197469f,-87.741810f, 45.107512f,-87.659952f,
                    45.076434f,-87.442508f, 45.201969f,-87.405694f, 45.240657f,-87.315422f, 45.280796f,-87.263670f, 44.504549f,-87.263670f,
                    44.504549f,-88.075995f);
            poly[333] = new TzPolygon(45.280796f,-87.263670f, 45.240657f,-87.315422f, 45.201969f,-87.405694f, 45.076434f,-87.442508f, 45.094765f,-87.591660f,
                    45.150084f,-87.599895f, 45.293051f,-87.436172f, 45.539402f,-87.263670f);
            poly[334] = new TzPolygon(45.539402f,-87.263670f, 45.549538f,-87.330078f, 45.898045f,-87.329216f, 45.897785f,-87.370407f, 45.984730f,-87.370888f,
                    45.985188f,-87.620338f, 46.039924f,-87.620033f, 46.039924f,-87.263670f);
            poly[335] = new TzPolygon(46.051242f,-88.888320f, 46.039924f,-88.861900f, 46.039924f,-88.888320f);
            poly[336] = new TzPolygon(46.039924f,-88.861900f, 46.051242f,-88.888320f, 46.417681f,-88.888320f, 46.419403f,-88.117409f, 46.247120f,-88.117798f,
                    46.247551f,-87.618874f, 46.039924f,-87.620033f);
            poly[337] = new TzPolygon(45.280796f,-87.263670f, 45.352540f,-87.171170f, 45.444230f,-87.101133f, 45.443610f,-86.754236f, 45.236125f,-86.249548f,
                    45.080800f,-86.499930f, 44.881002f,-86.686288f, 44.131905f,-87.013234f, 43.734111f,-87.114102f, 43.379859f,-87.147166f,
                    42.493800f,-87.019861f, 41.760956f,-87.207774f, 41.759659f,-86.524217f, 41.650224f,-86.526638f, 41.649516f,-86.487267f,
                    41.570473f,-86.486484f, 41.523012f,-86.499957f, 41.519988f,-86.524839f, 41.433800f,-86.524674f, 41.433800f,-87.263670f);
            poly[338] = new TzPolygon(41.433800f,-86.524674f, 41.519988f,-86.524839f, 41.523012f,-86.499957f, 41.577677f,-86.486173f, 41.649516f,-86.487267f,
                    41.650224f,-86.526638f, 41.759659f,-86.524217f, 41.760216f,-84.805883f, 41.433800f,-84.804620f);
            poly[339] = new TzPolygon(41.433800f,-84.807396f, 41.696046f,-84.805919f, 41.713984f,-84.145365f, 41.433800f,-84.145365f);
            poly[340] = new TzPolygon(46.531101f,-84.145365f, 46.534056f,-84.225889f, 46.492944f,-84.276250f, 46.500583f,-84.421139f, 46.452861f,-84.475639f,
                    46.460806f,-84.556833f, 46.634306f,-84.762833f, 46.888917f,-84.860139f, 47.575298f,-86.560039f, 47.575298f,-84.145365f);
            poly[341] = new TzPolygon(46.531101f,-84.145365f, 46.530500f,-84.129000f, 46.504222f,-84.111139f, 46.420470f,-84.145365f);
            poly[342] = new TzPolygon(46.415536f,-84.145365f, 46.241444f,-84.108250f, 46.187333f,-84.077139f, 46.149444f,-84.005972f, 46.056750f,-83.955472f,
                    46.060444f,-83.903528f, 46.118861f,-83.826333f, 46.105778f,-83.571944f, 45.998167f,-83.433778f, 45.821278f,-83.597167f,
                    45.338639f,-82.518611f, 43.591194f,-82.122806f, 42.925812f,-82.456027f, 42.761906f,-82.467667f, 42.609849f,-82.521568f,
                    42.550978f,-82.589981f, 42.541746f,-82.661886f, 42.373492f,-82.830250f, 42.308680f,-83.079419f, 42.238412f,-83.126361f,
                    42.125263f,-83.119228f, 42.041000f,-83.149694f, 41.959410f,-83.112460f, 41.733794f,-83.415851f, 41.713984f,-84.145365f);
            poly[343] = new TzPolygon(41.713984f,-84.145365f, 41.733794f,-83.415851f, 41.959410f,-83.112460f, 41.863583f,-83.069111f, 41.676556f,-82.679722f,
                    41.676556f,-82.397472f, 42.207556f,-81.245722f, 42.242444f,-81.027060f, 41.433800f,-81.027060f, 41.433800f,-84.145365f);
            poly[344] = new TzPolygon(45.006278f,-74.790449f, 45.015861f,-74.826528f, 44.977500f,-74.992806f, 44.772167f,-75.413722f, 44.515278f,-75.766917f,
                    44.432056f,-75.821389f, 44.367806f,-75.912833f, 44.280722f,-76.161806f, 44.239833f,-76.164306f, 44.215000f,-76.206833f,
                    44.199056f,-76.312722f, 44.134333f,-76.352861f, 44.094056f,-76.438944f, 43.631139f,-76.796694f, 43.631139f,-78.690389f,
                    43.450472f,-79.200667f, 43.254667f,-79.055944f, 43.143667f,-79.042333f, 43.077861f,-79.074111f, 43.057885f,-79.000418f,
                    42.984056f,-79.016418f, 42.933576f,-78.909411f, 42.828304f,-78.935381f, 42.393556f,-80.079944f, 42.242444f,-81.027060f,
                    47.575298f,-81.027060f, 47.575298f,-74.790449f);
            poly[345] = new TzPolygon(49.000262f,-108.824497f, 48.999877f,-104.048736f, 47.997105f,-104.044118f, 47.959892f,-103.965942f, 47.848114f,-103.965576f,
                    47.848930f,-103.800613f, 47.675797f,-103.799232f, 47.675842f,-103.738724f, 47.588871f,-103.737091f, 47.589474f,-103.610252f,
                    47.575298f,-103.610132f, 47.575298f,-108.824497f);
            poly[346] = new TzPolygon(47.575298f,-103.436537f, 47.591843f,-103.438537f, 47.576626f,-103.069450f, 47.633202f,-103.020645f, 47.669712f,-103.038185f,
                    47.674011f,-103.004082f, 47.600971f,-102.865021f, 47.575298f,-102.711964f);
            poly[347] = new TzPolygon(48.999474f,-102.711964f, 48.999483f,-108.824497f, 49.384490f,-108.824497f, 49.384490f,-102.711964f);
            poly[348] = new TzPolygon(47.575298f,-102.423863f, 47.590809f,-102.414787f, 47.615253f,-102.250025f, 47.575298f,-102.250025f);
            poly[349] = new TzPolygon(47.615253f,-102.250025f, 47.575298f,-102.205561f, 47.575298f,-102.250025f);
            poly[350] = new TzPolygon(48.999891f,-102.711964f, 48.999968f,-95.153150f, 47.615253f,-95.153150f, 47.615253f,-102.711964f);
            poly[351] = new TzPolygon(49.384490f,-95.153422f, 48.999968f,-95.153150f, 48.999472f,-101.361990f, 49.384490f,-101.384065f);
            poly[352] = new TzPolygon(49.384401f,-95.153150f, 49.353250f,-95.058306f, 49.370194f,-94.957389f, 49.321389f,-94.816278f, 48.884111f,-94.683444f,
                    48.789444f,-94.694389f, 48.741222f,-94.641278f, 48.692389f,-94.452389f, 48.710972f,-94.415833f, 48.707806f,-94.291194f,
                    48.649444f,-94.224194f, 48.630222f,-93.844361f, 48.516306f,-93.793361f, 48.546444f,-93.467389f, 48.591639f,-93.465472f,
                    48.642806f,-93.254667f, 48.623250f,-93.178389f, 48.631556f,-92.954778f, 48.608361f,-92.950000f, 48.539389f,-92.728417f,
                    48.542556f,-92.634889f, 48.503278f,-92.627028f, 48.494833f,-92.698694f, 48.462972f,-92.712694f, 48.436472f,-92.656222f,
                    48.442630f,-92.576575f, 47.575298f,-92.576575f, 47.575298f,-95.153150f);
            poly[353] = new TzPolygon(48.736900f,-94.540200f, 48.705211f,-94.540403f, 48.736900f,-94.618618f);
            poly[354] = new TzPolygon(48.442630f,-92.576575f, 48.447972f,-92.507472f, 48.414083f,-92.456444f, 48.352083f,-92.469778f, 48.220278f,-92.369917f,
                    48.248194f,-92.269583f, 48.316250f,-92.306167f, 48.354917f,-92.262556f, 48.359361f,-92.055222f, 48.321083f,-92.000111f,
                    48.265417f,-92.006528f, 48.252250f,-91.954111f, 48.233139f,-91.958361f, 48.237972f,-91.893111f, 48.206944f,-91.864361f,
                    48.199500f,-91.715361f, 48.114639f,-91.711750f, 48.122500f,-91.682111f, 48.097111f,-91.639917f, 48.108583f,-91.559111f,
                    48.043778f,-91.567500f, 48.068389f,-91.488194f, 48.048667f,-91.429583f, 48.074848f,-91.288287f, 47.575298f,-91.288287f,
                    47.575298f,-92.576575f);
            poly[355] = new TzPolygon(49.384450f,-92.576575f, 49.384474f,-91.288287f, 49.000000f,-91.288287f, 49.000000f,-91.752800f, 48.661400f,-91.752800f,
                    48.647400f,-91.924900f, 48.617100f,-92.012400f, 48.560600f,-92.097900f, 48.545500f,-92.178500f, 48.464100f,-92.267200f,
                    48.464100f,-92.219900f, 48.405600f,-92.150900f, 48.405600f,-91.955800f, 48.377600f,-91.955800f, 48.353878f,-92.051986f,
                    48.354917f,-92.262556f, 48.316250f,-92.306167f, 48.248194f,-92.269583f, 48.220167f,-92.369139f, 48.352083f,-92.469778f,
                    48.414083f,-92.456444f, 48.447972f,-92.507472f, 48.442630f,-92.576575f);
            poly[356] = new TzPolygon(48.074848f,-91.288287f, 48.078833f,-91.266778f, 48.181139f,-91.082472f, 48.245944f,-90.885750f, 48.239556f,-90.839306f,
                    48.177028f,-90.836389f, 48.163833f,-90.777944f, 48.136889f,-90.798222f, 48.090972f,-90.751583f, 48.123806f,-90.579667f,
                    48.095917f,-90.556694f, 48.108750f,-90.467389f, 48.090917f,-90.374278f, 48.112611f,-90.140833f, 48.084833f,-90.023333f,
                    48.040013f,-90.000000f, 47.575298f,-90.000000f, 47.575298f,-91.288287f);
            poly[357] = new TzPolygon(48.250000f,-90.000000f, 48.500000f,-90.963900f, 49.000000f,-90.963900f, 49.000000f,-91.000000f, 49.250000f,-91.000000f,
                    49.384490f,-90.462040f, 49.384490f,-90.000000f);
            poly[358] = new TzPolygon(49.384474f,-91.288287f, 49.384490f,-90.462040f, 49.250000f,-91.000000f, 49.000000f,-91.000000f, 49.000000f,-91.288287f);
            poly[359] = new TzPolygon(48.040013f,-90.000000f, 48.028167f,-89.993833f, 47.987667f,-89.897194f, 48.022944f,-89.775361f, 48.003694f,-89.650861f,
                    48.018000f,-89.610694f, 47.996028f,-89.580972f, 48.013716f,-89.483385f, 47.575298f,-89.766677f, 47.575298f,-90.000000f);
            poly[360] = new TzPolygon(47.575298f,-89.766677f, 48.013716f,-89.483385f, 47.974261f,-89.337550f, 48.245397f,-88.677442f, 48.306063f,-88.369862f,
                    47.575298f,-86.560039f);
            poly[361] = new TzPolygon(48.515693f,-89.241770f, 48.514520f,-89.182575f, 48.483230f,-89.182238f, 48.498834f,-89.152530f, 48.475771f,-89.151415f,
                    48.337464f,-89.203006f, 48.354095f,-89.289440f, 48.289425f,-89.338349f, 48.289522f,-89.388614f, 48.514883f,-89.427850f);
            poly[362] = new TzPolygon(48.515693f,-74.790449f, 48.515693f,-90.000000f, 49.384490f,-90.000000f, 49.384490f,-74.790449f);
            poly[363] = new TzPolygon(16.259052f,-92.524388f, 16.259052f,-90.424127f, 16.249459f,-90.456243f, 16.233535f,-90.429012f, 16.208770f,-90.458378f,
                    16.163874f,-90.426029f, 16.149302f,-90.452232f, 16.137619f,-90.429320f, 16.111279f,-90.458890f, 16.092712f,-90.454985f,
                    16.103160f,-90.426183f, 16.073805f,-90.442155f, 16.073893f,-91.731518f, 15.260624f,-92.210543f, 15.069636f,-92.059330f,
                    15.021265f,-92.085653f, 14.989379f,-92.150485f, 14.891650f,-92.136216f, 14.828263f,-92.184847f, 14.690168f,-92.142914f,
                    14.575174f,-92.184044f, 14.388624f,-92.374389f, 14.534506f,-92.524388f);
            poly[364] = new TzPolygon(16.259052f,-90.424127f, 16.298406f,-90.437307f, 16.298406f,-90.424127f);
            poly[365] = new TzPolygon(14.277527f,-90.424127f, 14.277527f,-89.540646f, 14.219981f,-89.525447f, 14.185392f,-89.666846f, 14.119336f,-89.725527f,
                    14.031734f,-89.737473f, 14.058552f,-89.855956f, 13.939036f,-90.023241f, 13.897435f,-90.036101f, 13.834582f,-90.112175f,
                    13.782988f,-90.117143f, 13.753666f,-90.093049f, 13.747068f,-90.135096f, 13.634580f,-90.179097f, 13.730129f,-90.424127f);
            poly[366] = new TzPolygon(14.145074f,-88.763006f, 14.164585f,-88.798875f, 14.118432f,-88.807631f, 14.104579f,-88.831290f, 14.178619f,-88.866682f,
                    14.205668f,-88.902709f, 14.213175f,-88.972326f, 14.258578f,-88.991514f, 14.271430f,-89.025804f, 14.277527f,-89.025307f,
                    14.277527f,-88.763006f);
            poly[367] = new TzPolygon(13.100948f,-88.763006f, 14.145074f,-88.763006f, 14.131238f,-88.737571f, 14.010135f,-88.683569f, 14.022820f,-88.627710f,
                    13.978223f,-88.569002f, 13.985429f,-88.528992f, 13.966999f,-88.499758f, 13.910913f,-88.510959f, 13.848557f,-88.468004f,
                    13.885732f,-88.418651f, 13.870320f,-88.356406f, 13.896078f,-88.345368f, 13.889904f,-88.317336f, 13.914481f,-88.265897f,
                    13.937240f,-88.265183f, 13.937823f,-88.226871f, 13.999938f,-88.230003f, 13.992271f,-88.072735f, 13.871008f,-88.014784f,
                    13.902854f,-87.959032f, 13.884478f,-87.922072f, 13.920512f,-87.799886f, 13.892242f,-87.798994f, 13.804020f,-87.708407f,
                    13.689278f,-87.755454f, 13.603910f,-87.754399f, 13.524001f,-87.793452f, 13.505334f,-87.720768f, 13.467370f,-87.716363f,
                    13.442394f,-87.723823f, 13.405345f,-87.821631f, 13.348959f,-87.743498f, 13.197257f,-87.635139f, 13.127742f,-87.662906f,
                    13.055135f,-87.811139f, 12.976046f,-87.901532f, 13.040801f,-88.149177f, 13.028296f,-88.402676f);
            poly[368] = new TzPolygon(12.256649f,-87.101885f, 12.335098f,-87.236893f, 12.676029f,-87.588116f, 12.781743f,-87.741651f, 12.976046f,-87.901532f,
                    13.108935f,-87.720047f, 13.167505f,-87.543216f, 13.078127f,-87.479358f, 12.994697f,-87.376361f, 13.001460f,-87.101885f);
            poly[369] = new TzPolygon(14.277527f,-89.540646f, 14.295730f,-89.545454f, 14.311504f,-89.592266f, 14.347040f,-89.587545f, 14.351679f,-89.563425f,
                    14.416928f,-89.573916f, 14.416140f,-89.542585f, 14.379612f,-89.529608f, 14.419990f,-89.491408f, 14.412105f,-89.434759f,
                    14.451049f,-89.392882f, 14.427541f,-89.385231f, 14.438066f,-89.334515f, 14.364758f,-89.181962f, 14.402375f,-89.097665f,
                    14.341079f,-89.082640f, 14.314239f,-89.022311f, 14.277527f,-89.025307f);
            poly[370] = new TzPolygon(14.277527f,-89.025307f, 14.314239f,-89.022311f, 14.341079f,-89.082640f, 14.402375f,-89.097665f, 14.367367f,-89.194944f,
                    14.438066f,-89.334515f, 14.420616f,-89.355987f, 14.466834f,-89.356821f, 14.493859f,-89.301905f, 14.584726f,-89.238782f,
                    14.584238f,-89.153547f, 14.671379f,-89.157208f, 14.712619f,-89.131294f, 14.731076f,-89.165396f, 14.775031f,-89.168907f,
                    14.834737f,-89.223766f, 14.882547f,-89.228084f, 14.928755f,-89.172682f, 14.979754f,-89.156632f, 15.002481f,-89.184430f,
                    15.068276f,-89.153596f, 15.136248f,-88.973842f, 15.287732f,-88.763006f, 14.277527f,-88.763006f);
            poly[371] = new TzPolygon(16.298406f,-88.763006f, 15.966730f,-88.763006f, 15.958374f,-88.770630f, 15.887454f,-88.922818f, 15.894432f,-89.019023f,
                    15.917339f,-89.054640f, 15.895775f,-89.114966f, 15.913280f,-89.176491f, 15.885729f,-89.222330f, 15.896013f,-89.227325f,
                    16.298406f,-89.200533f);
            poly[372] = new TzPolygon(16.298406f,-88.308067f, 16.069956f,-88.498377f, 16.050990f,-88.686124f, 15.966730f,-88.763006f, 16.298406f,-88.763006f);
            poly[373] = new TzPolygon(15.966730f,-88.763006f, 16.050990f,-88.686124f, 16.069956f,-88.498377f, 15.907558f,-88.175585f, 15.723487f,-88.221558f,
                    15.720511f,-88.250984f, 15.688664f,-88.248414f, 15.672459f,-88.324726f, 15.618539f,-88.344576f, 15.426124f,-88.570391f,
                    15.287732f,-88.763006f);
            poly[374] = new TzPolygon(16.298406f,-90.437307f, 16.304503f,-90.439349f, 16.339694f,-90.382597f, 16.363924f,-90.410369f, 16.363477f,-90.372459f,
                    16.394145f,-90.403333f, 16.413297f,-90.389878f, 16.423064f,-90.485338f, 16.460803f,-90.479847f, 16.457908f,-90.529304f,
                    16.482848f,-90.546729f, 16.478371f,-90.631161f, 16.502727f,-90.605928f, 16.521325f,-90.615713f, 16.517957f,-90.646068f,
                    16.560845f,-90.646977f, 16.577744f,-90.626069f, 16.595848f,-90.641200f, 16.581823f,-90.667110f, 16.640335f,-90.658118f,
                    16.727064f,-90.714251f, 16.775668f,-90.802141f, 16.798266f,-90.804094f, 16.821935f,-90.921765f, 16.859326f,-90.933639f,
                    16.863626f,-90.974055f, 16.884474f,-90.954509f, 16.901500f,-90.965009f, 16.897954f,-90.985063f, 16.863085f,-90.987831f,
                    16.902858f,-91.065627f, 17.003384f,-91.122759f, 17.015704f,-91.175253f, 17.095059f,-91.226958f, 17.107878f,-91.266943f,
                    17.170133f,-91.266447f, 17.182747f,-91.324450f, 17.160025f,-91.349162f, 17.190517f,-91.354455f, 17.209295f,-91.418817f,
                    17.250000f,-91.439759f, 17.251299f,-90.987446f, 17.575193f,-90.987601f, 17.575193f,-90.371441f, 16.298406f,-90.371441f);
            poly[375] = new TzPolygon(17.575193f,-90.987601f, 17.815344f,-90.987716f, 17.816509f,-90.371441f, 17.575193f,-90.371441f);
            poly[376] = new TzPolygon(18.849401f,-92.524388f, 18.851981f,-92.511081f, 18.619346f,-92.466890f, 18.561630f,-92.427845f, 18.485672f,-92.412844f,
                    18.442230f,-92.353757f, 18.473050f,-92.322530f, 18.455438f,-92.310338f, 18.458227f,-92.176022f, 18.274024f,-92.183284f,
                    18.210378f,-92.148868f, 18.155359f,-92.160887f, 18.096940f,-92.127485f, 18.097877f,-92.039638f, 18.077910f,-92.041963f,
                    18.015899f,-91.966637f, 18.012147f,-91.900430f, 17.939001f,-91.762300f, 17.957731f,-91.760483f, 17.872736f,-91.638158f,
                    17.913322f,-91.614159f, 18.059632f,-91.619246f, 18.109727f,-91.589369f, 18.121264f,-91.604321f, 18.137312f,-91.572335f,
                    18.157642f,-91.579693f, 18.170173f,-91.509666f, 18.116099f,-91.504344f, 18.063101f,-91.384947f, 18.061876f,-91.327121f,
                    17.974344f,-91.217261f, 17.962393f,-90.987969f, 17.575193f,-90.987684f, 17.575193f,-92.524388f);
            poly[377] = new TzPolygon(16.298406f,-89.200533f, 17.057407f,-89.149998f, 17.939527f,-89.151957f, 17.972034f,-89.132705f, 18.005122f,-89.037521f,
                    17.984429f,-89.000621f, 17.947284f,-88.987224f, 17.959130f,-88.944780f, 17.910595f,-88.913682f, 17.894461f,-88.859766f,
                    17.925191f,-88.859435f, 17.979861f,-88.784455f, 18.034298f,-88.766652f, 18.050158f,-88.736663f, 16.298406f,-88.736663f);
            poly[378] = new TzPolygon(17.816509f,-90.371441f, 17.815629f,-89.151901f, 17.057407f,-89.149998f, 16.298406f,-89.198679f, 16.298406f,-90.371441f);
            poly[379] = new TzPolygon(17.812455f,-90.371441f, 18.851981f,-90.371441f, 18.851981f,-89.148766f, 18.451059f,-89.150238f, 18.450625f,-89.125490f,
                    18.385850f,-89.121229f, 18.385544f,-89.138214f, 18.293403f,-89.132359f, 18.293563f,-89.151674f, 18.145820f,-89.143066f,
                    18.144629f,-89.200237f, 18.083276f,-89.202458f, 18.082443f,-89.144383f, 18.057699f,-89.144753f, 18.057885f,-89.163361f,
                    18.018517f,-89.163004f, 18.021080f,-89.206739f, 17.992649f,-89.207414f, 17.954100f,-89.205872f, 17.953610f,-89.152170f,
                    17.815629f,-89.151901f, 17.812425f,-90.365047f);
            poly[380] = new TzPolygon(18.851981f,-87.129834f, 18.770071f,-87.101885f, 18.667023f,-87.124465f, 18.550777f,-87.117376f, 18.439605f,-87.182276f,
                    18.377497f,-87.307357f, 18.393330f,-87.441241f, 18.478926f,-87.538576f, 18.351753f,-87.561545f, 18.246657f,-87.620556f,
                    18.198073f,-87.384787f, 17.916751f,-87.374960f, 17.924180f,-87.434822f, 18.198662f,-87.864800f, 18.150168f,-87.910739f,
                    18.170324f,-87.932531f, 18.167524f,-88.031167f, 18.414794f,-88.030366f, 18.415552f,-88.249634f, 18.473072f,-88.250094f,
                    18.490429f,-88.326816f, 18.478804f,-88.380268f, 18.496001f,-88.401988f, 18.475466f,-88.447752f, 18.493721f,-88.477921f,
                    18.461118f,-88.519442f, 18.360991f,-88.544032f, 18.291741f,-88.605832f, 18.241034f,-88.604686f, 18.187040f,-88.694135f,
                    18.160635f,-88.679938f, 18.108941f,-88.718544f, 18.060831f,-88.716481f, 18.050158f,-88.736663f, 18.851981f,-88.736663f);
            poly[381] = new TzPolygon(13.720672f,-87.101885f, 13.720672f,-86.774558f, 13.662250f,-86.786064f, 13.639266f,-86.748981f, 13.576901f,-86.769896f,
                    13.565278f,-86.749444f, 13.456838f,-86.723426f, 13.401947f,-86.744380f, 13.365078f,-86.706584f, 13.302806f,-86.705795f,
                    13.267457f,-86.754339f, 13.313278f,-86.829022f, 13.268786f,-86.909146f, 13.179331f,-86.932968f, 13.155258f,-86.913404f,
                    13.125607f,-86.934448f, 13.092221f,-86.918100f, 13.030384f,-86.963393f, 12.980849f,-87.050016f, 13.002376f,-87.064708f,
                    13.001460f,-87.101885f);
            poly[382] = new TzPolygon(13.720672f,-86.774558f, 13.766650f,-86.765502f, 13.805277f,-86.538446f, 13.769475f,-86.490754f, 13.789847f,-86.453698f,
                    13.759092f,-86.416965f, 13.769130f,-86.332264f, 13.816086f,-86.296220f, 13.853328f,-86.298805f, 13.955358f,-86.186003f,
                    13.984034f,-86.190698f, 13.999506f,-86.140736f, 14.035004f,-86.152978f, 14.056080f,-86.087047f, 13.720672f,-86.087047f);
            poly[383] = new TzPolygon(14.559175f,-85.072210f, 14.552383f,-85.085021f, 14.585950f,-85.122754f, 14.571808f,-85.151605f, 14.516122f,-85.138886f,
                    14.467860f,-85.184048f, 14.428347f,-85.181168f, 14.376760f,-85.220760f, 14.302328f,-85.153396f, 14.250447f,-85.184492f,
                    14.248847f,-85.339429f, 14.213072f,-85.360887f, 14.221559f,-85.382688f, 14.182618f,-85.374620f, 14.123121f,-85.404112f,
                    14.114386f,-85.453907f, 14.076191f,-85.493674f, 14.087987f,-85.505505f, 14.047456f,-85.519395f, 14.065053f,-85.573277f,
                    14.009205f,-85.624677f, 14.012045f,-85.663904f, 13.979960f,-85.676409f, 13.992992f,-85.706770f, 13.967796f,-85.753368f,
                    13.884232f,-85.764078f, 13.861490f,-85.733329f, 13.832231f,-85.752179f, 13.849245f,-85.819735f, 13.917630f,-85.845418f,
                    13.929565f,-85.881971f, 13.904389f,-85.892264f, 13.908462f,-85.913741f, 13.937596f,-85.918517f, 13.996174f,-86.042070f,
                    14.080251f,-86.011436f, 14.056080f,-86.087047f, 15.033118f,-86.087047f, 15.033118f,-85.072210f);
            poly[384] = new TzPolygon(15.033118f,-84.057372f, 14.768870f,-84.057372f, 14.757257f,-84.080363f, 14.786595f,-84.081890f, 14.790840f,-84.109833f,
                    14.730143f,-84.095786f, 14.714501f,-84.166838f, 14.733676f,-84.227982f, 14.760610f,-84.235393f, 14.734407f,-84.271861f,
                    14.678450f,-84.257886f, 14.662151f,-84.276870f, 14.684466f,-84.309845f, 14.679823f,-84.349403f, 14.716600f,-84.363387f,
                    14.641557f,-84.414640f, 14.615845f,-84.468591f, 14.630248f,-84.530006f, 14.656355f,-84.524823f, 14.672595f,-84.665449f,
                    14.693937f,-84.671846f, 14.664427f,-84.701532f, 14.692135f,-84.703552f, 14.715354f,-84.744812f, 14.748499f,-84.742977f,
                    14.749021f,-84.771452f, 14.769684f,-84.749964f, 14.816129f,-84.790005f, 14.815225f,-84.898119f, 14.758801f,-84.927052f,
                    14.756339f,-84.960370f, 14.702999f,-85.028408f, 14.673460f,-85.027047f, 14.660705f,-85.050771f, 14.637776f,-85.024545f,
                    14.610495f,-85.043113f, 14.608882f,-85.021580f, 14.574834f,-85.042675f, 14.559175f,-85.072210f, 15.033118f,-85.072210f);
            poly[385] = new TzPolygon(15.033118f,-83.067713f, 14.982508f,-83.232472f, 14.987660f,-83.277698f, 15.005997f,-83.276406f, 15.010115f,-83.344316f,
                    14.995260f,-83.348309f, 15.029703f,-83.402169f, 14.990321f,-83.420436f, 14.980954f,-83.461915f, 15.011168f,-83.498172f,
                    14.993470f,-83.528232f, 14.950065f,-83.529020f, 14.957165f,-83.548585f, 14.942244f,-83.537973f, 14.939113f,-83.559893f,
                    14.912364f,-83.560000f, 14.919717f,-83.598627f, 14.874506f,-83.615744f, 14.880117f,-83.694040f, 14.853365f,-83.722334f,
                    14.851292f,-83.700325f, 14.824157f,-83.701593f, 14.841167f,-83.732111f, 14.819170f,-83.732036f, 14.831578f,-83.753157f,
                    14.806214f,-83.763669f, 14.823592f,-83.783414f, 14.773029f,-83.843796f, 14.777283f,-83.936435f, 14.747678f,-83.923560f,
                    14.760857f,-83.997235f, 14.746565f,-84.033344f, 14.774676f,-84.045877f, 14.768870f,-84.057372f, 15.033118f,-84.057372f);
            poly[386] = new TzPolygon(18.851981f,-89.148766f, 19.423862f,-89.146667f, 19.551174f,-89.296562f, 19.608022f,-89.219556f, 19.636657f,-89.222869f,
                    19.644006f,-89.189203f, 19.637399f,-89.144862f, 19.581249f,-89.149521f, 19.581996f,-89.122003f, 18.851981f,-89.122003f);
            poly[387] = new TzPolygon(19.613575f,-89.122003f, 19.614632f,-89.133641f, 19.703424f,-89.123398f, 19.703018f,-89.122003f);
            poly[388] = new TzPolygon(21.568334f,-89.122003f, 21.594353f,-88.923560f, 21.622503f,-88.822025f, 21.715895f,-88.686540f, 21.767420f,-88.437039f,
                    21.766912f,-88.313606f, 21.817224f,-88.214802f, 21.830571f,-88.137432f, 21.802200f,-87.908309f, 21.736884f,-87.730326f,
                    21.690434f,-87.510980f, 21.490226f,-87.534927f, 20.999602f,-87.533145f, 20.653787f,-87.744259f, 20.446706f,-87.962742f,
                    20.447316f,-87.995065f, 20.417993f,-87.992960f, 20.281372f,-88.136490f, 20.290342f,-88.264634f, 20.269120f,-88.266815f,
                    20.253510f,-88.308788f, 20.252097f,-88.409128f, 20.239489f,-88.402892f, 20.238150f,-88.443426f, 20.192328f,-88.519930f,
                    20.190078f,-88.502345f, 20.143391f,-88.507621f, 20.148078f,-88.576681f, 20.089856f,-88.690609f, 20.010357f,-88.700176f,
                    20.008180f,-88.783503f, 19.879926f,-88.825926f, 19.861114f,-88.900488f, 19.790949f,-88.929512f, 19.818101f,-88.974452f,
                    19.772007f,-89.004087f, 19.776710f,-89.025163f, 19.721493f,-89.048827f, 19.727440f,-88.994741f, 19.704884f,-88.997529f,
                    19.708832f,-89.030524f, 19.678040f,-89.036200f, 19.703018f,-89.122003f);
            poly[389] = new TzPolygon(19.613575f,-89.122003f, 19.612339f,-89.108392f, 19.582349f,-89.109024f, 19.581996f,-89.122003f);
            poly[390] = new TzPolygon(37.958689f,-86.782360f, 37.958689f,-86.511647f, 37.928829f,-86.507831f, 37.921159f,-86.588581f, 37.858272f,-86.604624f,
                    37.841425f,-86.648028f, 37.908621f,-86.647081f, 37.894340f,-86.731460f);
            poly[391] = new TzPolygon(19.973824f,-75.166823f, 19.973820f,-75.086645f, 19.871762f,-75.086563f, 19.869741f,-75.232488f, 19.934591f,-75.232020f);
            poly[392] = new TzPolygon(21.151443f,-74.790449f, 22.032971f,-77.214826f, 22.432278f,-77.820528f, 22.596111f,-78.115444f, 22.875357f,-78.790845f,
                    23.301043f,-79.595880f, 23.481697f,-80.377255f, 23.481697f,-74.790449f);
            poly[393] = new TzPolygon(31.530347f,-86.493266f, 31.530347f,-85.044373f, 31.364576f,-85.092167f, 31.295026f,-85.089774f, 31.276459f,-85.115002f,
                    31.186451f,-85.107516f, 31.108192f,-85.035615f, 30.975908f,-85.005734f, 30.883588f,-84.934424f, 30.765990f,-84.920123f,
                    30.696945f,-84.857970f, 30.621382f,-84.905951f, 30.580353f,-84.965686f, 30.476521f,-85.004434f, 30.444532f,-84.980511f,
                    30.420581f,-85.032729f, 30.409785f,-85.013683f, 30.338185f,-85.050313f, 30.312492f,-85.034069f, 30.170786f,-85.139824f,
                    30.117562f,-85.129544f, 30.095280f,-85.152987f, 30.043015f,-85.135569f, 29.987685f,-85.029921f, 29.950987f,-85.017954f,
                    29.910286f,-85.053762f, 29.818844f,-85.019326f, 29.779549f,-85.039964f, 29.774351f,-85.104830f, 29.827949f,-85.190491f,
                    29.877006f,-85.210854f, 29.968375f,-85.371508f, 30.027346f,-85.391303f, 29.924309f,-85.388447f, 29.810239f,-85.646555f,
                    29.894167f,-85.745172f, 30.094399f,-86.111887f, 30.170999f,-86.366191f, 30.182735f,-86.493266f);
            poly[394] = new TzPolygon(31.530347f,-85.044373f, 31.540987f,-85.041305f, 31.620227f,-85.058169f, 31.694965f,-85.125530f, 31.782181f,-85.141876f,
                    31.892160f,-85.134131f, 31.940159f,-85.078930f, 32.021701f,-85.048825f, 32.132486f,-85.062060f, 32.194989f,-84.964281f,
                    32.217477f,-84.972658f, 32.219851f,-84.928227f, 32.250149f,-84.924427f, 32.260885f,-84.888417f, 32.324018f,-85.003768f,
                    32.356819f,-84.988710f, 32.339000f,-85.031000f, 32.355000f,-85.073000f, 32.444000f,-85.119000f, 32.514000f,-85.214000f,
                    32.571000f,-85.182000f, 32.656000f,-85.198000f, 32.847000f,-85.282000f, 32.954000f,-85.237000f, 32.968098f,-85.204399f,
                    33.673127f,-85.344545f, 33.673127f,-84.575844f, 31.530347f,-84.575844f);
            poly[395] = new TzPolygon(33.673127f,-85.344545f, 34.984610f,-85.605242f, 34.983184f,-85.473875f, 35.047222f,-85.381691f, 35.087975f,-85.361694f,
                    35.109035f,-85.395241f, 35.146053f,-85.388221f, 35.455822f,-85.168365f, 35.446598f,-85.148132f, 35.476330f,-85.117310f,
                    35.491520f,-85.146507f, 35.545612f,-85.096718f, 35.571564f,-85.107719f, 35.773621f,-84.905212f, 35.815908f,-84.799654f,
                    35.815908f,-84.575844f, 33.673127f,-84.575844f);
            poly[396] = new TzPolygon(36.887299f,-86.493266f, 36.887299f,-85.011997f, 36.858303f,-85.064011f, 36.756046f,-85.003731f, 36.703972f,-85.021294f,
                    36.633614f,-85.003380f, 36.616868f,-84.988565f, 36.603372f,-84.785341f, 36.394909f,-84.659531f, 36.376568f,-84.724442f,
                    36.336815f,-84.739395f, 36.334450f,-84.774277f, 36.298820f,-84.794266f, 36.289600f,-84.872047f, 36.208321f,-84.912613f,
                    36.151085f,-84.903748f, 36.084179f,-84.832413f, 36.090717f,-84.805550f, 35.994560f,-84.720062f, 35.907455f,-84.679497f,
                    35.823681f,-84.780251f, 35.815908f,-84.799654f, 35.815908f,-86.493266f);
            poly[397] = new TzPolygon(36.887299f,-85.011997f, 36.887299f,-84.609821f, 36.880714f,-84.604774f, 36.887299f,-84.596516f, 36.887299f,-84.584413f,
                    36.847397f,-84.575844f, 36.840290f,-84.595482f, 36.803455f,-84.581558f, 36.809513f,-84.603325f, 36.754250f,-84.674629f,
                    36.603205f,-84.778269f, 36.616868f,-84.988565f, 36.693539f,-85.020210f, 36.756046f,-85.003731f, 36.858303f,-85.064011f);
            poly[398] = new TzPolygon(37.958689f,-86.371197f, 37.798916f,-86.151718f, 37.593296f,-86.275375f, 37.556240f,-86.180351f, 37.566570f,-86.113098f,
                    37.483006f,-86.051506f, 37.448532f,-86.056473f, 37.422054f,-85.656998f, 37.471039f,-85.633911f, 37.470631f,-85.584618f,
                    37.432098f,-85.584579f, 37.363678f,-85.479118f, 37.242134f,-85.388390f, 37.224472f,-85.410957f, 37.221268f,-85.372246f,
                    37.192234f,-85.353226f, 37.246124f,-85.312653f, 37.272629f,-85.192299f, 37.312031f,-85.176514f, 37.256798f,-85.056480f,
                    37.196941f,-85.053368f, 37.102242f,-84.954109f, 37.116501f,-84.901482f, 37.047607f,-84.905495f, 36.997822f,-84.835594f,
                    36.945606f,-84.908035f, 36.960281f,-84.944199f, 36.915924f,-84.960648f, 36.887299f,-85.011997f, 36.887299f,-86.493266f,
                    37.958689f,-86.493266f);
            poly[399] = new TzPolygon(36.887299f,-85.011997f, 36.915924f,-84.960648f, 36.960281f,-84.944199f, 36.945606f,-84.908035f, 36.997822f,-84.835594f,
                    36.958000f,-84.770294f, 36.982834f,-84.683052f, 36.887299f,-84.609821f);
        }
    }

    private static class Initializer5 {
        private static void init() {
            poly[400] = new TzPolygon(36.887299f,-84.596516f, 36.895538f,-84.586182f, 36.887299f,-84.584413f);
            poly[401] = new TzPolygon(23.481697f,-74.790449f, 23.481697f,-80.377255f, 23.506421f,-80.484193f, 23.592825f,-80.581646f, 23.910715f,-80.700194f,
                    24.065363f,-80.633744f, 24.143564f,-80.524446f, 24.247967f,-80.003586f, 25.004520f,-79.363241f, 25.204628f,-79.370973f,
                    25.322585f,-79.406819f, 25.520448f,-79.514367f, 25.638981f,-79.536084f, 25.811223f,-79.504861f, 26.091627f,-79.316140f,
                    27.020753f,-79.315421f, 27.128711f,-79.210116f, 27.450706f,-78.525181f, 27.473455f,-78.419224f, 27.424560f,-78.182860f,
                    27.274784f,-77.906548f, 27.234373f,-77.702998f, 27.140405f,-77.461399f, 26.757829f,-76.863673f, 26.649623f,-76.761429f,
                    25.276453f,-75.948835f, 24.821016f,-75.514130f, 24.507391f,-74.790449f);
            poly[402] = new TzPolygon(53.299009f,-169.047661f, 53.299009f,-166.534963f, 53.286358f,-166.560593f, 53.247220f,-166.728682f, 53.238927f,-166.987814f,
                    53.099691f,-167.309782f, 53.042476f,-167.563720f, 53.039564f,-167.701567f, 53.088390f,-167.867361f, 53.082363f,-167.959214f,
                    53.028831f,-168.052475f, 52.898702f,-168.109744f, 52.822271f,-168.248691f, 52.794237f,-168.360580f, 52.791331f,-168.493636f,
                    52.605965f,-169.059824f, 52.575956f,-169.247046f, 52.591763f,-169.375135f, 52.634709f,-169.479863f, 53.098748f,-169.331542f,
                    53.128878f,-169.178205f, 53.169365f,-169.122974f, 53.296048f,-169.052268f);
            poly[403] = new TzPolygon(65.467585f,-168.924586f, 65.480794f,-169.016222f, 65.985947f,-168.924586f);
            poly[404] = new TzPolygon(60.306013f,-141.000000f, 60.306369f,-141.001980f, 69.845880f,-141.002750f, 69.845643f,-141.000000f);
            poly[405] = new TzPolygon(55.300967f,-131.568369f, 55.181496f,-131.293888f, 55.138156f,-131.338965f, 55.028623f,-131.342120f, 54.993297f,-131.375685f,
                    55.011397f,-131.539044f, 54.979030f,-131.654746f, 55.040000f,-131.674000f, 55.128513f,-131.614941f, 55.137965f,-131.667861f,
                    55.195295f,-131.602997f, 55.272598f,-131.626116f);
            poly[406] = new TzPolygon(54.456000f,-129.974167f, 54.456000f,-131.357994f, 54.475000f,-131.382748f, 54.567000f,-131.435757f, 54.689553f,-131.435100f,
                    54.707474f,-130.615673f, 54.763058f,-130.659038f, 54.917729f,-130.345938f, 55.062842f,-130.187563f, 55.192602f,-130.102842f,
                    55.281919f,-129.974167f);
            poly[407] = new TzPolygon(55.281919f,-129.974167f, 55.300967f,-129.983957f, 55.300967f,-129.974167f);
            poly[408] = new TzPolygon(56.539643f,-135.487083f, 56.624920f,-135.690659f, 56.742436f,-135.856861f, 56.811287f,-135.906463f, 56.847669f,-136.050838f,
                    56.911249f,-136.158681f, 56.996578f,-136.210248f, 57.148574f,-136.188711f, 57.347892f,-136.236105f, 57.474854f,-136.497218f,
                    57.648721f,-136.628120f, 57.826110f,-136.878354f, 57.835869f,-136.026713f, 58.001387f,-135.899839f, 57.852394f,-135.487083f);
            poly[409] = new TzPolygon(59.798041f,-135.487083f, 59.795767f,-135.487083f, 59.662166f,-135.952645f, 59.640027f,-136.192904f, 59.600556f,-136.346389f,
                    59.559413f,-136.239830f, 59.524326f,-136.238504f, 59.464518f,-136.305022f, 59.448960f,-136.368244f, 59.465824f,-136.477156f,
                    59.284079f,-136.469247f, 59.165854f,-136.584444f, 59.159960f,-136.828728f, 58.999998f,-137.282847f, 58.908349f,-137.451726f,
                    58.906372f,-137.526114f, 58.985395f,-137.500000f, 59.243803f,-137.607356f, 59.768581f,-138.626202f, 59.798041f,-138.643563f);
            poly[410] = new TzPolygon(59.798041f,-141.000000f, 59.798041f,-138.643563f, 59.768581f,-138.626202f, 59.243803f,-137.607356f, 58.985395f,-137.500000f,
                    58.906375f,-137.526120f, 58.721171f,-138.269402f, 58.824302f,-138.314402f, 58.893917f,-138.458509f, 58.965197f,-138.784073f,
                    59.086790f,-139.084818f, 59.223491f,-139.607996f, 59.518837f,-140.421484f, 59.563240f,-141.000000f);
            poly[411] = new TzPolygon(57.549504f,-134.746823f, 57.549504f,-132.730625f, 57.413174f,-132.730625f, 57.396855f,-132.788898f, 57.360620f,-132.810782f,
                    57.368219f,-132.873036f, 57.330823f,-132.986359f, 57.235539f,-133.029298f, 57.191261f,-133.099723f, 57.188390f,-133.155382f,
                    57.238076f,-133.292546f, 57.175290f,-133.472112f, 57.152141f,-133.776532f, 57.160638f,-134.048801f, 56.967539f,-134.335319f,
                    56.863970f,-134.567591f, 57.005599f,-134.682174f, 57.229242f,-134.744610f, 57.318061f,-134.702750f, 57.456667f,-134.709610f);
            poly[412] = new TzPolygon(57.852394f,-135.487083f, 57.765158f,-135.245415f, 57.790108f,-134.843268f, 57.549504f,-134.746823f, 57.549504f,-135.487083f);
            poly[413] = new TzPolygon(57.699405f,-132.730625f, 57.839713f,-132.869368f, 58.000341f,-133.070096f, 58.153676f,-133.172311f, 58.387723f,-133.461504f,
                    58.430548f,-133.377303f, 58.612274f,-133.707118f, 58.729444f,-133.840507f, 58.861036f,-134.258074f, 58.923414f,-134.336464f,
                    58.962182f,-134.313489f, 58.979210f,-134.407149f, 59.038763f,-134.381877f, 59.131603f,-134.483395f, 59.131124f,-134.565566f,
                    59.192275f,-134.679117f, 59.249011f,-134.700716f, 59.280926f,-134.959905f, 59.346348f,-135.030526f, 59.387129f,-134.989744f,
                    59.427531f,-135.101019f, 59.474738f,-135.027562f, 59.563659f,-135.028902f, 59.662776f,-135.219845f, 59.696143f,-135.233668f,
                    59.798041f,-135.479161f, 59.798041f,-132.730625f);
            poly[414] = new TzPolygon(59.798041f,-135.479161f, 59.795767f,-135.487083f, 59.798041f,-135.487083f);
            poly[415] = new TzPolygon(57.684968f,-132.730625f, 57.349747f,-132.369791f, 57.354227f,-132.487307f, 57.400554f,-132.518317f, 57.425137f,-132.687905f,
                    57.413174f,-132.730625f);
            poly[416] = new TzPolygon(55.300967f,-129.983957f, 55.581035f,-130.127904f, 55.682902f,-130.111658f, 55.766287f,-130.152406f, 55.907437f,-130.003784f,
                    56.008075f,-130.003485f, 56.122798f,-130.103799f, 56.096411f,-130.246219f, 56.141561f,-130.426006f, 56.243053f,-130.467870f,
                    56.266878f,-130.623308f, 56.366844f,-130.781981f, 56.406005f,-131.087349f, 56.612232f,-131.581067f, 56.599203f,-131.835327f,
                    56.753675f,-131.901072f, 56.805995f,-131.872876f, 56.873648f,-132.123567f, 57.045059f,-132.045191f, 57.091513f,-132.368983f,
                    57.211253f,-132.247921f, 57.699405f,-132.730625f, 59.798041f,-132.730625f, 59.798041f,-129.974167f, 55.300967f,-129.974167f);
            poly[417] = new TzPolygon(59.798041f,-135.479161f, 59.798041f,-138.643563f, 59.906325f,-138.707377f, 59.994837f,-139.053671f, 60.001780f,-134.659300f,
                    60.001555f,-129.974167f, 59.798041f,-129.974167f);
            poly[418] = new TzPolygon(60.306010f,-141.000000f, 60.219819f,-140.520424f, 60.308085f,-140.458206f, 60.181966f,-139.981094f, 60.335224f,-139.692981f,
                    60.352505f,-139.074819f, 60.088296f,-139.198846f, 59.994837f,-139.053671f, 59.906325f,-138.707377f, 59.798041f,-138.643563f,
                    59.798041f,-141.000000f);
            poly[419] = new TzPolygon(63.190038f,-129.974167f, 63.188462f,-129.979617f, 63.246923f,-130.038880f, 63.250958f,-130.192256f, 63.274312f,-130.146680f,
                    63.305679f,-130.158684f, 63.337384f,-130.078992f, 63.319110f,-130.016604f, 63.330730f,-129.974167f);
            poly[420] = new TzPolygon(63.573302f,-129.974167f, 63.575386f,-129.984777f, 63.588796f,-129.974167f);
            poly[421] = new TzPolygon(69.845643f,-141.000000f, 69.790045f,-140.355601f, 69.833426f,-139.277500f, 63.588796f,-139.277500f, 63.588796f,-141.000000f);
            poly[422] = new TzPolygon(67.002069f,-134.625833f, 67.006029f,-136.168098f, 67.108444f,-136.229742f, 67.149174f,-136.189630f, 67.181670f,-136.238151f,
                    67.234842f,-136.125963f, 67.277941f,-136.145480f, 67.307565f,-136.083943f, 67.360455f,-136.167313f, 67.370146f,-136.132584f,
                    67.402233f,-136.221465f, 67.507958f,-136.170255f, 67.532731f,-136.223181f, 67.618359f,-136.227612f, 67.661179f,-136.445060f,
                    68.893609f,-136.448351f, 69.403107f,-136.588001f, 69.612833f,-136.287181f, 69.817398f,-135.744358f, 69.882458f,-135.131838f,
                    69.965882f,-134.625833f);
            poly[423] = new TzPolygon(64.758700f,-132.300000f, 64.798081f,-132.412569f, 64.782028f,-132.429971f, 64.798076f,-132.515580f, 64.775463f,-132.556591f,
                    64.828351f,-132.632429f, 64.905917f,-132.453769f, 64.963457f,-132.519324f, 65.037033f,-132.342518f, 65.073335f,-132.338202f,
                    65.090608f,-132.357331f, 65.087625f,-132.528829f, 65.126014f,-132.568842f, 65.162941f,-132.517614f, 65.191932f,-132.547201f,
                    65.161913f,-132.736135f, 65.188369f,-132.794449f, 65.208603f,-132.714240f, 65.230638f,-132.788122f, 65.237692f,-132.694163f,
                    65.283688f,-132.647805f, 65.286184f,-132.561719f, 65.308012f,-132.551448f, 65.308012f,-132.300000f);
            poly[424] = new TzPolygon(65.946828f,-133.462917f, 65.961271f,-133.513271f, 65.956831f,-133.631821f, 66.007868f,-133.646702f, 66.028727f,-133.563056f,
                    66.059295f,-133.621030f, 66.054154f,-133.707154f, 66.086180f,-133.703550f, 66.153550f,-133.560458f, 66.244104f,-133.572204f,
                    66.293514f,-133.645711f, 66.291943f,-133.802543f, 66.318045f,-133.847763f, 66.365162f,-133.773507f, 66.405956f,-133.795503f,
                    66.469360f,-133.715983f, 66.509433f,-133.728307f, 66.557757f,-133.576743f, 66.624401f,-133.788934f, 66.680806f,-133.879432f,
                    66.703954f,-134.012230f, 66.721496f,-133.969848f, 66.711217f,-133.866940f, 66.751234f,-133.772432f, 66.784767f,-133.766112f,
                    66.898661f,-133.899261f, 66.910482f,-134.046184f, 66.953285f,-134.103319f, 66.983321f,-134.062184f, 67.000000f,-133.820084f,
                    67.002069f,-134.625833f, 67.027228f,-134.625833f, 67.027228f,-133.462917f);
            poly[425] = new TzPolygon(65.946828f,-133.462917f, 65.937353f,-133.429885f, 65.952146f,-133.348015f, 65.990579f,-133.361160f, 65.977454f,-133.245181f,
                    66.003503f,-133.252665f, 66.042315f,-132.983071f, 66.004858f,-132.910722f, 65.930263f,-132.996870f, 65.900829f,-132.883580f,
                    65.985537f,-132.766081f, 66.022087f,-132.653942f, 66.026617f,-132.555541f, 65.969415f,-132.504177f, 65.993611f,-132.428524f,
                    65.989097f,-132.332660f, 65.958445f,-132.321690f, 65.897956f,-132.529776f, 65.841561f,-132.563965f, 65.777356f,-132.367381f,
                    65.737327f,-132.300000f, 65.691328f,-132.302510f, 65.689975f,-132.300000f, 65.484842f,-132.300000f, 65.440722f,-132.344745f,
                    65.372708f,-132.521007f, 65.308012f,-132.551448f, 65.308012f,-133.462917f);
            poly[426] = new TzPolygon(63.611464f,-129.974167f, 63.615214f,-130.101682f, 63.694346f,-130.143735f, 63.655518f,-130.289682f, 63.704922f,-130.360304f,
                    63.734050f,-130.325948f, 63.721008f,-130.251193f, 63.755094f,-130.231241f, 63.752822f,-130.145240f, 63.855361f,-130.133862f,
                    63.876849f,-130.257033f, 63.845543f,-130.265736f, 63.823792f,-130.355707f, 63.858328f,-130.392365f, 63.858554f,-130.444751f,
                    63.876672f,-130.421266f, 63.912101f,-130.485095f, 63.972067f,-130.773419f, 64.041247f,-130.749978f, 64.037662f,-130.882385f,
                    64.093192f,-130.892566f, 64.104755f,-130.967660f, 64.131189f,-130.983478f, 64.181287f,-130.853326f, 64.193824f,-130.947033f,
                    64.238210f,-130.946453f, 64.274373f,-131.080527f, 64.324087f,-131.033072f, 64.353567f,-131.107474f, 64.372205f,-131.083249f,
                    64.416726f,-131.150320f, 64.463309f,-131.392664f, 64.449366f,-131.457136f, 64.398615f,-131.446325f, 64.397767f,-131.534435f,
                    64.381353f,-131.530278f, 64.380663f,-131.851287f, 64.454239f,-131.804679f, 64.489395f,-131.690782f, 64.532855f,-131.691129f,
                    64.547372f,-131.796649f, 64.529087f,-131.844544f, 64.559011f,-131.837734f, 64.614157f,-131.975993f, 64.698909f,-132.038756f,
                    64.709651f,-132.159794f, 64.758700f,-132.300000f, 65.308012f,-132.300000f, 65.308012f,-129.974167f);
            poly[427] = new TzPolygon(65.737327f,-132.300000f, 65.731287f,-132.289833f, 65.699239f,-132.300000f);
            poly[428] = new TzPolygon(65.689975f,-132.300000f, 65.617466f,-132.165499f, 65.484842f,-132.300000f);
            poly[429] = new TzPolygon(68.416500f,-133.730000f, 68.346400f,-133.634300f, 68.316600f,-133.388800f, 68.298200f,-133.384300f, 68.290000f,-133.471900f,
                    68.317600f,-133.677200f, 68.416100f,-133.799100f);
            poly[430] = new TzPolygon(-44.937760f,-71.919683f, -44.903700f,-71.978940f, -44.901660f,-72.039107f, -44.876883f,-72.064814f, -44.862147f,-72.041330f,
                    -44.849365f,-72.069454f, -44.805833f,-72.027225f, -44.780712f,-72.073832f, -44.760691f,-72.066814f, -44.789423f,-71.919683f);
            poly[431] = new TzPolygon(-43.450540f,-71.919683f, -43.450118f,-71.934083f, -43.426062f,-71.919683f);
            poly[432] = new TzPolygon(-43.407818f,-71.919683f, -43.387401f,-71.932538f, -43.384856f,-71.919683f);
            poly[433] = new TzPolygon(-43.108377f,-71.919683f, -43.102889f,-71.935144f, -43.054373f,-71.934999f, -43.030259f,-72.012970f, -42.900149f,-72.142236f,
                    -42.878891f,-72.118163f, -42.800208f,-72.164844f, -42.777249f,-72.130211f, -42.733782f,-72.132065f, -42.696778f,-72.181059f,
                    -42.670973f,-72.172841f, -42.672613f,-72.123207f, -42.641728f,-72.100731f, -42.603345f,-72.119550f, -42.569681f,-72.053384f,
                    -42.417665f,-72.023000f, -42.386228f,-72.073812f, -42.384200f,-72.133207f, -42.323603f,-72.121135f, -42.260489f,-72.168079f,
                    -42.199138f,-72.155889f, -42.165247f,-72.187818f, -42.138140f,-72.168850f, -42.148259f,-72.066025f, -42.114259f,-72.057871f,
                    -42.141013f,-71.957761f, -42.189237f,-71.923944f, -42.186256f,-71.919683f);
            poly[434] = new TzPolygon(-45.999874f,-71.647592f, -45.964079f,-71.614162f, -45.889973f,-71.652406f, -45.846380f,-71.769355f, -45.806990f,-71.740723f,
                    -45.719439f,-71.801496f, -45.695895f,-71.772534f, -45.666100f,-71.795858f, -45.640808f,-71.772528f, -45.628222f,-71.801670f,
                    -45.608035f,-71.741499f, -45.575394f,-71.727421f, -45.560370f,-71.763621f, -45.513821f,-71.681619f, -45.523648f,-71.560532f,
                    -45.493948f,-71.469224f, -45.433267f,-71.534182f, -45.396634f,-71.531639f, -45.395827f,-71.438287f, -45.367671f,-71.448474f,
                    -45.322056f,-71.336173f, -45.241396f,-71.333005f, -45.157815f,-71.417629f, -45.144106f,-71.487469f, -45.107916f,-71.491583f,
                    -45.103136f,-71.526583f, -45.071205f,-71.505133f, -45.032566f,-71.556488f, -44.997937f,-71.559021f, -44.997937f,-70.484300f,
                    -45.999874f,-70.484300f);
            poly[435] = new TzPolygon(-44.997937f,-71.559021f, -44.978630f,-71.560434f, -44.969419f,-71.684356f, -44.953635f,-71.741502f, -44.926900f,-71.753607f,
                    -44.941353f,-71.778080f, -44.920689f,-71.814042f, -44.960567f,-71.880003f, -44.937760f,-71.919683f, -44.789423f,-71.919683f,
                    -44.801768f,-71.856464f, -44.793873f,-71.815151f, -44.774285f,-71.824510f, -44.751000f,-71.783607f, -44.788055f,-71.657045f,
                    -44.737528f,-71.469694f, -44.790183f,-71.395839f, -44.813615f,-71.292316f, -44.790817f,-71.237041f, -44.736692f,-71.201928f,
                    -44.681534f,-71.197913f, -44.638174f,-71.235040f, -44.591460f,-71.200751f, -44.589879f,-71.100093f, -44.535024f,-71.091156f,
                    -44.503523f,-71.158828f, -44.471103f,-71.132255f, -44.440417f,-71.173253f, -44.417687f,-71.239757f, -44.429603f,-71.330812f,
                    -44.389504f,-71.364869f, -44.409691f,-71.654704f, -44.379885f,-71.714270f, -44.416558f,-71.814521f, -44.349941f,-71.840270f,
                    -44.339507f,-71.798213f, -44.312054f,-71.790529f, -44.268978f,-71.806458f, -44.265162f,-71.833327f, -44.223837f,-71.779062f,
                    -44.157109f,-71.850289f, -44.112455f,-71.849623f, -44.096547f,-71.754574f, -43.996000f,-71.684303f, -43.996000f,-70.484300f,
                    -44.997937f,-70.484300f);
            poly[436] = new TzPolygon(-43.996000f,-71.684303f, -43.945517f,-71.649021f, -43.901891f,-71.665629f, -43.894048f,-71.706875f, -43.855401f,-71.708285f,
                    -43.840936f,-71.762882f, -43.789400f,-71.753917f, -43.703084f,-71.661473f, -43.696297f,-71.599339f, -43.676267f,-71.611322f,
                    -43.651773f,-71.580847f, -43.623324f,-71.626241f, -43.624920f,-71.701600f, -43.584148f,-71.707474f, -43.583989f,-71.759675f,
                    -43.538705f,-71.776608f, -43.553602f,-71.871443f, -43.510950f,-71.891549f, -43.479397f,-71.850140f, -43.451676f,-71.880868f,
                    -43.450540f,-71.919683f, -43.426062f,-71.919683f, -43.416710f,-71.914084f, -43.407818f,-71.919683f, -43.384856f,-71.919683f,
                    -43.379790f,-71.894086f, -43.322316f,-71.904845f, -43.335170f,-71.842502f, -43.296951f,-71.786197f, -43.313571f,-71.734554f,
                    -43.228069f,-71.757181f, -43.201172f,-71.729822f, -43.164496f,-71.761569f, -43.108377f,-71.919683f, -42.186256f,-71.919683f,
                    -42.154558f,-71.874373f, -42.147377f,-71.780778f, -42.110137f,-71.726125f, -42.046242f,-71.728250f, -41.999919f,-71.773859f,
                    -41.996752f,-69.048916f, -43.996000f,-69.048916f);
            poly[437] = new TzPolygon(-42.000147f,-69.048916f, -41.999919f,-71.773859f, -41.992126f,-71.774964f, -41.992126f,-69.048916f);
            poly[438] = new TzPolygon(-42.000147f,-69.048916f, -41.992126f,-69.048916f, -41.992126f,-63.307384f, -41.997100f,-63.313482f, -42.000390f,-66.132587f);
            poly[439] = new TzPolygon(-41.992126f,-71.774964f, -41.841797f,-71.796270f, -41.824908f,-71.751344f, -41.793720f,-71.773993f, -41.787129f,-71.754059f,
                    -41.720446f,-71.810346f, -41.694816f,-71.794039f, -41.605156f,-71.885877f, -41.565628f,-71.844851f, -41.575015f,-71.817310f,
                    -41.533090f,-71.848952f, -41.433489f,-71.834729f, -41.340735f,-71.912070f, -41.307959f,-71.876051f, -41.255404f,-71.899037f,
                    -41.271283f,-71.834181f, -41.161285f,-71.887783f, -41.149792f,-71.840766f, -41.098685f,-71.851529f, -41.060383f,-71.819600f,
                    -40.985164f,-71.905199f, -40.960733f,-71.902452f, -40.955989f,-71.857240f, -40.882583f,-71.858421f, -40.857764f,-71.908006f,
                    -40.821790f,-71.934099f, -40.783198f,-71.923456f, -40.745139f,-71.966608f, -40.609908f,-71.837613f, -40.578130f,-71.825051f,
                    -40.592662f,-71.855085f, -40.556004f,-71.890498f, -40.555364f,-71.859178f, -40.525324f,-71.842910f, -40.420480f,-71.824579f,
                    -40.407410f,-71.791620f, -40.434462f,-71.735315f, -40.397606f,-71.687936f, -40.373939f,-71.693601f, -40.364261f,-71.657037f,
                    -40.292268f,-71.694585f, -40.292268f,-69.592084f, -41.992126f,-69.592084f);
            poly[440] = new TzPolygon(-40.292268f,-71.722758f, -40.305599f,-71.751628f, -40.292268f,-71.764493f);
            poly[441] = new TzPolygon(-39.442339f,-71.997768f, -39.442339f,-71.448113f, -39.450620f,-71.447085f, -39.493267f,-71.472945f, -39.530408f,-71.534381f,
                    -39.560380f,-71.503986f, -39.553265f,-71.470769f, -39.583070f,-71.461172f, -39.637216f,-71.503057f, -39.627961f,-71.610174f,
                    -39.592122f,-71.624765f, -39.565057f,-71.677809f, -39.587348f,-71.698628f, -39.648336f,-71.715547f, -39.682569f,-71.669381f,
                    -39.724555f,-71.712570f, -39.808066f,-71.666822f, -39.842739f,-71.690854f, -39.901234f,-71.592664f, -39.973362f,-71.620473f,
                    -39.970337f,-71.645021f, -40.032482f,-71.688575f, -40.104349f,-71.674343f, -40.117153f,-71.699331f, -40.088110f,-71.825609f,
                    -40.135898f,-71.799688f, -40.172052f,-71.828818f, -40.187324f,-71.798486f, -40.213284f,-71.829213f, -40.292268f,-71.762832f,
                    -40.292268f,-71.997768f);
            poly[442] = new TzPolygon(-40.292268f,-71.736145f, -40.276651f,-71.718007f, -40.292268f,-71.689459f);
            poly[443] = new TzPolygon(-38.592410f,-70.828719f, -38.596271f,-70.827741f, -38.666806f,-70.904130f, -38.700038f,-70.884218f, -38.762976f,-70.925245f,
                    -38.753867f,-71.095039f, -38.814403f,-71.185219f, -38.801357f,-71.237374f, -38.871179f,-71.296032f, -38.928944f,-71.433604f,
                    -38.981027f,-71.441512f, -39.045635f,-71.396008f, -39.151075f,-71.421186f, -39.211327f,-71.381073f, -39.283159f,-71.374093f,
                    -39.350604f,-71.400364f, -39.370570f,-71.457023f, -39.442339f,-71.448113f, -39.442339f,-71.997768f, -38.592410f,-71.997768f);
            poly[444] = new TzPolygon(-37.145169f,-69.592084f, -37.070623f,-69.754073f, -36.964614f,-69.778684f, -36.892553f,-69.763706f, -36.892553f,-69.592084f);
            poly[445] = new TzPolygon(-36.892553f,-71.900482f, -36.892553f,-71.129248f, -36.929041f,-71.144752f, -36.936060f,-71.087143f, -36.971392f,-71.106434f,
                    -36.978198f,-71.222584f, -36.998543f,-71.165024f, -37.069278f,-71.140863f, -37.114556f,-71.092349f, -37.141238f,-71.134576f,
                    -37.206543f,-71.114566f, -37.225151f,-71.170163f, -37.276358f,-71.188188f, -37.274983f,-71.220728f, -37.382493f,-71.198138f,
                    -37.402646f,-71.149771f, -37.489083f,-71.116255f, -37.539055f,-71.150244f, -37.587738f,-71.127798f, -37.648579f,-71.206464f,
                    -37.699197f,-71.209509f, -37.757481f,-71.155998f, -37.784852f,-71.169856f, -37.819789f,-71.123698f, -37.857139f,-71.183413f,
                    -37.859489f,-71.140299f, -37.901348f,-71.099198f, -37.953027f,-71.114662f, -37.970444f,-71.061648f, -38.045348f,-71.052981f,
                    -38.087883f,-70.988759f, -38.104769f,-70.982923f, -38.123813f,-71.043691f, -38.171872f,-70.996141f, -38.249871f,-71.032228f,
                    -38.297540f,-70.997857f, -38.430118f,-70.983953f, -38.538020f,-70.842504f, -38.592410f,-70.828719f, -38.592410f,-71.900482f);
            poly[446] = new TzPolygon(-36.892553f,-71.129248f, -36.869386f,-71.119405f, -36.842014f,-71.180291f, -36.814730f,-71.131786f, -36.679597f,-71.113579f,
                    -36.677695f,-71.085840f, -36.714316f,-71.065648f, -36.690988f,-71.009397f, -36.618051f,-71.057355f, -36.475799f,-71.037270f,
                    -36.503574f,-70.972881f, -36.493759f,-70.935051f, -36.466067f,-70.888735f, -36.396050f,-70.883911f, -36.416230f,-70.850867f,
                    -36.396336f,-70.815848f, -36.428800f,-70.787352f, -36.405731f,-70.747012f, -36.892553f,-70.746283f);
            poly[447] = new TzPolygon(-36.892553f,-69.763706f, -36.870052f,-69.759029f, -36.844760f,-69.851068f, -36.792385f,-69.921661f, -36.720063f,-69.947434f,
                    -36.694280f,-70.011634f, -36.571453f,-70.120752f, -36.454693f,-70.200582f, -36.326955f,-70.225365f, -36.338549f,-70.327956f,
                    -36.309376f,-70.359017f, -36.126311f,-70.398953f, -36.042624f,-70.383605f, -36.042624f,-69.592084f, -36.892553f,-69.592084f);
            poly[448] = new TzPolygon(-36.042624f,-70.746283f, -36.042624f,-70.376976f, -36.061411f,-70.412772f, -36.155683f,-70.420834f, -36.178934f,-70.490668f,
                    -36.142783f,-70.531284f, -36.138486f,-70.577804f, -36.174799f,-70.571281f, -36.217051f,-70.633251f, -36.238653f,-70.632221f,
                    -36.272291f,-70.705005f, -36.304669f,-70.684749f, -36.342290f,-70.712336f, -36.389426f,-70.679377f, -36.426866f,-70.712851f,
                    -36.429767f,-70.739287f, -36.408000f,-70.746283f);
            poly[449] = new TzPolygon(-36.042624f,-70.383605f, -35.994661f,-70.374808f, -35.972432f,-70.423109f, -35.923763f,-70.366686f, -35.906072f,-70.425712f,
                    -35.874225f,-70.420906f, -35.812880f,-70.307611f, -35.787241f,-70.379363f, -35.748938f,-70.358249f, -35.640074f,-70.423773f,
                    -35.606864f,-70.386523f, -35.526123f,-70.412155f, -35.521194f,-70.367930f, -35.463523f,-70.446621f, -35.391565f,-70.452286f,
                    -35.354411f,-70.418624f, -35.318422f,-70.432013f, -35.322442f,-70.500328f, -35.278311f,-70.583584f, -35.199376f,-70.536720f,
                    -35.203077f,-70.470457f, -35.192695f,-70.438253f, -35.192695f,-69.592084f, -36.042624f,-69.592084f);
            poly[450] = new TzPolygon(-37.149128f,-69.592084f, -37.174413f,-69.528537f, -37.144655f,-69.272757f, -37.178046f,-69.215052f, -37.178112f,-69.169509f,
                    -37.251359f,-69.038914f, -37.364905f,-69.025673f, -37.374370f,-68.902336f, -37.401370f,-68.862791f, -37.367106f,-68.764790f,
                    -37.388558f,-68.722475f, -37.443122f,-68.693162f, -37.456163f,-68.500516f, -37.543807f,-68.438250f, -37.574553f,-68.258624f,
                    -36.173761f,-68.250425f, -36.173175f,-68.296416f, -35.997567f,-68.296021f, -35.999085f,-65.107859f, -35.192695f,-65.105515f,
                    -35.192695f,-64.780716f, -41.992126f,-64.780716f, -41.992126f,-69.592084f);
            poly[451] = new TzPolygon(-35.192695f,-66.493081f, -35.192695f,-65.101402f, -35.999085f,-65.107859f, -36.000631f,-66.637783f, -35.850454f,-66.622515f,
                    -35.638322f,-66.547656f, -35.581173f,-66.570442f, -35.538946f,-66.524995f, -35.311285f,-66.495403f, -35.274264f,-66.519915f,
                    -35.240645f,-66.484147f);
            poly[452] = new TzPolygon(-33.492837f,-70.677005f, -33.492837f,-69.831024f, -33.515205f,-69.835131f, -33.539648f,-69.871767f, -33.683244f,-69.884780f,
                    -33.717046f,-69.864440f, -33.774146f,-69.904299f, -33.847444f,-69.898932f, -33.892520f,-69.855283f, -33.963630f,-69.905739f,
                    -33.962891f,-69.853246f, -34.014171f,-69.822212f, -34.055811f,-69.852897f, -34.085956f,-69.833671f, -34.132561f,-69.873521f,
                    -34.208546f,-69.790780f, -34.243036f,-69.795071f, -34.264177f,-69.897038f, -34.291940f,-69.909921f, -34.250105f,-69.970842f,
                    -34.288053f,-70.030944f, -34.413892f,-70.010890f, -34.482265f,-70.127276f, -34.611448f,-70.216827f, -34.683329f,-70.215968f,
                    -34.746332f,-70.306176f, -34.770308f,-70.307957f, -34.798152f,-70.248756f, -34.937568f,-70.331477f, -34.991588f,-70.334395f,
                    -35.005933f,-70.365634f, -35.172661f,-70.376109f, -35.192695f,-70.438253f, -35.192695f,-70.677005f);
            poly[453] = new TzPolygon(-33.492837f,-69.831024f, -33.432467f,-69.819938f, -33.423330f,-69.795747f, -33.396175f,-69.807077f, -33.348334f,-69.771014f,
                    -33.287473f,-69.800816f, -33.273438f,-69.903898f, -33.244897f,-69.918237f, -33.266887f,-69.917260f, -33.322926f,-70.001214f,
                    -33.286100f,-70.006063f, -33.270107f,-70.038872f, -33.235968f,-70.026222f, -33.201745f,-70.064707f, -33.138333f,-70.049858f,
                    -33.052378f,-70.094115f, -33.006253f,-70.019406f, -32.969223f,-70.028604f, -32.900978f,-69.989360f, -32.800298f,-70.108007f,
                    -32.728104f,-70.147603f, -32.642908f,-70.157320f, -32.642908f,-69.694290f, -33.492837f,-69.694290f);
            poly[454] = new TzPolygon(-32.642908f,-70.157320f, -32.597133f,-70.162541f, -32.576464f,-70.122556f, -32.625500f,-70.065400f, -32.528300f,-70.004200f,
                    -32.570600f,-69.847300f, -32.544000f,-69.821600f, -32.546800f,-69.790900f, -32.509400f,-69.756100f, -32.496400f,-69.705000f,
                    -32.451526f,-69.694290f, -32.642908f,-69.694290f);
            poly[455] = new TzPolygon(-32.425619f,-69.694290f, -32.390600f,-69.733200f, -32.330800f,-69.728900f, -32.305770f,-69.694290f);
            poly[456] = new TzPolygon(-31.792980f,-70.462729f, -31.844106f,-70.459989f, -31.885702f,-70.375317f, -31.884090f,-70.279949f, -31.957688f,-70.210597f,
                    -32.051326f,-70.288532f, -32.025551f,-70.353892f, -32.044032f,-70.388251f, -32.070225f,-70.335379f, -32.109746f,-70.341559f,
                    -32.136083f,-70.304072f, -32.267821f,-70.322918f, -32.332929f,-70.217856f, -32.428944f,-70.236390f, -32.487452f,-70.136059f,
                    -32.576341f,-70.126033f, -32.621210f,-70.172135f, -32.642908f,-70.153784f, -32.642908f,-70.677005f, -31.792980f,-70.677005f);
            poly[457] = new TzPolygon(-32.451526f,-69.694290f, -32.430200f,-69.689200f, -32.425619f,-69.694290f, -32.305770f,-69.694290f, -32.260000f,-69.631000f,
                    -32.143100f,-69.596500f, -32.141000f,-69.531100f, -32.074700f,-69.454800f, -32.066500f,-69.415700f, -32.091100f,-69.314200f,
                    -32.016100f,-69.244500f, -31.999400f,-69.128400f, -32.116500f,-69.011600f, -32.114700f,-68.917600f, -32.338000f,-68.917600f,
                    -32.337264f,-68.711575f, -33.492837f,-68.711575f, -33.492837f,-69.694290f);
            poly[458] = new TzPolygon(-31.792980f,-70.462962f, -31.700467f,-70.467607f, -31.689659f,-70.513247f, -31.651984f,-70.506949f, -31.600158f,-70.566913f,
                    -31.511025f,-70.551812f, -31.474014f,-70.569681f, -31.448298f,-70.548502f, -31.420066f,-70.560293f, -31.407302f,-70.532098f,
                    -31.314451f,-70.547065f, -31.122358f,-70.497540f, -31.084345f,-70.456309f, -31.167701f,-70.401453f, -31.135156f,-70.360892f,
                    -31.111198f,-70.369315f, -31.044317f,-70.321813f, -31.043402f,-70.269070f, -31.020345f,-70.297286f, -30.970388f,-70.293156f,
                    -30.929746f,-70.323277f, -30.831139f,-70.279648f, -30.787889f,-70.288494f, -30.728616f,-70.246190f, -30.634681f,-70.247118f,
                    -30.551636f,-70.189708f, -30.491682f,-70.195167f, -30.431020f,-70.117187f, -30.346107f,-70.154266f, -30.352241f,-70.106388f,
                    -30.394708f,-70.063151f, -30.385750f,-69.955176f, -30.357675f,-69.934877f, -30.350671f,-69.891951f, -30.319989f,-69.908130f,
                    -30.219544f,-69.885365f, -30.219247f,-69.834038f, -30.178744f,-69.816872f, -30.125901f,-69.824940f, -30.105855f,-69.899270f,
                    -30.120407f,-69.935662f, -30.093122f,-69.957838f, -30.093122f,-68.711575f, -31.792980f,-68.711575f);
            poly[459] = new TzPolygon(-29.243193f,-68.982018f, -29.243193f,-68.711575f, -29.629941f,-68.711575f, -29.625400f,-68.735100f, -29.635100f,-68.863100f,
                    -29.593400f,-68.885500f, -29.619800f,-68.935600f, -29.651600f,-68.938300f, -29.639100f,-69.014100f, -29.533000f,-69.033700f,
                    -29.456500f,-68.975200f, -29.399700f,-69.002200f, -29.287300f,-68.956700f, -29.274000f,-68.989100f);
            poly[460] = new TzPolygon(-29.243193f,-70.265666f, -29.243193f,-69.940028f, -29.250524f,-69.938337f, -29.285201f,-69.996486f, -29.330257f,-70.020377f,
                    -29.383526f,-70.021589f, -29.414629f,-69.966769f, -29.452154f,-69.981427f, -29.486015f,-69.949034f, -29.653552f,-69.940033f,
                    -29.724618f,-69.879718f, -29.806791f,-69.913479f, -29.862028f,-69.875928f, -30.037139f,-69.923156f, -30.084682f,-69.964698f,
                    -30.093122f,-69.957838f, -30.093122f,-70.265666f);
            poly[461] = new TzPolygon(-29.243193f,-68.982018f, -29.230500f,-68.979100f, -29.186600f,-69.001200f, -29.146300f,-68.969600f, -29.166400f,-68.935000f,
                    -29.128200f,-68.911700f, -29.044900f,-68.908500f, -28.941500f,-68.961300f, -28.861000f,-68.908200f, -28.761100f,-69.162000f,
                    -28.681600f,-69.209800f, -28.596172f,-69.203350f, -28.412000f,-69.316300f, -28.448500f,-69.375900f, -28.451800f,-69.425500f,
                    -28.415500f,-69.469700f, -28.431900f,-69.516200f, -28.405800f,-69.555200f, -28.419000f,-69.605700f, -28.393264f,-69.642201f,
                    -28.393264f,-68.711575f, -29.243193f,-68.711575f);
            poly[462] = new TzPolygon(-28.393264f,-69.639844f, -28.396123f,-69.649809f, -28.430365f,-69.632647f, -28.471286f,-69.680883f, -28.532384f,-69.651206f,
                    -28.581472f,-69.664657f, -28.595848f,-69.693449f, -28.685000f,-69.731142f, -28.736055f,-69.729325f, -28.772686f,-69.692879f,
                    -28.900330f,-69.765448f, -28.984360f,-69.754620f, -29.050635f,-69.792815f, -29.130055f,-69.787113f, -29.138358f,-69.874577f,
                    -29.189048f,-69.952518f, -29.243193f,-69.940028f, -29.243193f,-70.265666f, -28.393264f,-70.265666f);
            poly[463] = new TzPolygon(-34.572276f,-66.746146f, -34.551384f,-66.765254f, -34.442918f,-66.754309f, -34.411427f,-66.795099f, -34.379339f,-66.764022f,
                    -34.345083f,-66.812008f, -34.305136f,-66.802346f, -34.298080f,-66.775686f, -34.257298f,-66.801351f, -34.233715f,-66.785475f,
                    -34.221414f,-66.746146f);
            poly[464] = new TzPolygon(-33.909971f,-66.746146f, -33.832403f,-66.873865f, -33.769567f,-66.882522f, -33.667774f,-67.004156f, -33.632675f,-66.998327f,
                    -33.492837f,-67.112968f, -33.492837f,-66.746146f);
            poly[465] = new TzPolygon(-32.229795f,-67.728860f, -32.222929f,-67.736544f, -32.226135f,-67.831806f, -32.175304f,-67.916499f, -32.113721f,-67.938574f,
                    -32.121118f,-67.959774f, -32.096041f,-67.971025f, -32.070956f,-68.052321f, -32.098873f,-68.073004f, -32.084566f,-68.080622f,
                    -32.119329f,-68.151981f, -32.109170f,-68.188468f, -32.127798f,-68.206085f, -32.091599f,-68.247830f, -32.137700f,-68.304100f,
                    -32.137800f,-68.463000f, -32.237700f,-68.462900f, -32.337100f,-68.665700f, -32.337264f,-68.711575f, -31.792980f,-68.711575f,
                    -31.792980f,-67.728860f);
            poly[466] = new TzPolygon(-31.858814f,-66.746146f, -31.811800f,-66.802400f, -31.792980f,-66.810050f, -31.792980f,-66.746146f);
            poly[467] = new TzPolygon(-32.229795f,-67.728860f, -32.245914f,-67.710822f, -32.225171f,-67.675937f, -32.246021f,-67.597144f, -32.220883f,-67.523543f,
                    -32.306719f,-67.472865f, -32.350470f,-67.331906f, -32.443006f,-67.289186f, -32.536352f,-67.297263f, -32.552589f,-67.262771f,
                    -32.625623f,-67.256806f, -32.682074f,-67.225003f, -32.697483f,-67.187776f, -32.758705f,-67.166420f, -32.769350f,-67.185911f,
                    -32.820146f,-67.177832f, -32.886632f,-67.232281f, -33.003292f,-67.179549f, -33.043992f,-67.198048f, -33.077062f,-67.174153f,
                    -33.252109f,-67.180232f, -33.464962f,-67.135820f, -33.492837f,-67.112968f, -33.492837f,-67.728860f);
            poly[468] = new TzPolygon(-32.229795f,-67.728860f, -31.792980f,-67.728860f, -31.792980f,-66.810050f, -31.811800f,-66.802400f, -31.855347f,-66.746146f,
                    -31.912213f,-66.746146f, -31.897700f,-66.885700f, -31.833800f,-67.137000f, -31.880800f,-67.241800f, -31.859900f,-67.467200f,
                    -31.941500f,-67.438000f, -32.133000f,-67.471500f, -32.199400f,-67.430100f, -32.292300f,-67.278200f, -32.359800f,-67.265500f,
                    -32.318742f,-67.452448f, -32.220883f,-67.523543f, -32.246021f,-67.597144f, -32.225171f,-67.675937f, -32.245914f,-67.710822f);
            poly[469] = new TzPolygon(-33.492837f,-65.125889f, -33.492837f,-64.780716f, -35.012896f,-64.780716f, -35.015368f,-65.105000f, -34.073550f,-65.092441f);
            poly[470] = new TzPolygon(-33.909971f,-66.746146f, -33.958553f,-66.666152f, -34.136302f,-66.733531f, -34.147375f,-66.711233f, -34.212982f,-66.719187f,
                    -34.221414f,-66.746146f);
            poly[471] = new TzPolygon(-34.572276f,-66.746146f, -34.619559f,-66.702900f, -34.690619f,-66.690698f, -34.719168f,-66.639689f, -34.757754f,-66.650427f,
                    -34.774623f,-66.606691f, -34.832940f,-66.561509f, -34.910866f,-66.554941f, -34.943145f,-66.524305f, -35.016032f,-66.539498f,
                    -35.140901f,-66.477856f, -35.172705f,-66.496806f, -35.192695f,-66.493081f, -35.192695f,-66.746146f);
            poly[472] = new TzPolygon(-35.192695f,-65.105515f, -35.015368f,-65.105000f, -35.012896f,-64.780716f, -35.192695f,-64.780716f);
            poly[473] = new TzPolygon(-33.492837f,-65.125889f, -33.195969f,-65.142988f, -33.135487f,-65.045959f, -33.100020f,-65.059240f, -33.002992f,-64.998826f,
                    -32.975542f,-65.022924f, -32.867559f,-64.965825f, -32.805044f,-64.970672f, -32.679179f,-64.916186f, -32.614742f,-64.924121f,
                    -32.570774f,-64.882720f, -32.485182f,-64.895502f, -32.466736f,-64.919786f, -32.298352f,-64.941396f, -32.321508f,-64.977267f,
                    -32.325382f,-65.211604f, -32.088938f,-65.245786f, -31.898895f,-65.627618f, -31.889084f,-65.769911f, -31.792980f,-65.770147f,
                    -31.792980f,-64.780716f, -33.492837f,-64.780716f);
            poly[474] = new TzPolygon(-31.858814f,-66.746146f, -31.792980f,-66.746146f, -31.792980f,-65.770147f, -31.889084f,-65.769911f, -31.910932f,-65.888102f,
                    -31.889163f,-65.979249f, -31.936728f,-66.070545f, -31.970135f,-66.078569f, -31.938470f,-66.141267f, -31.939420f,-66.161047f,
                    -31.963644f,-66.158434f, -31.930546f,-66.299695f, -31.944018f,-66.337841f, -31.998235f,-66.349970f, -31.898800f,-66.698300f);
            poly[475] = new TzPolygon(-31.855347f,-66.746146f, -31.921039f,-66.661283f, -31.912213f,-66.746146f);
            poly[476] = new TzPolygon(-29.629941f,-68.711575f, -29.670546f,-68.501226f, -29.664182f,-68.403665f, -29.746899f,-68.258500f, -29.780700f,-68.253800f,
                    -29.781100f,-68.199000f, -29.885400f,-68.158800f, -29.900300f,-68.054300f, -30.074300f,-67.898300f, -30.298100f,-67.590900f,
                    -30.403000f,-67.578600f, -30.536300f,-67.494800f, -30.627500f,-67.410100f, -30.695300f,-67.282800f, -30.895600f,-67.128800f,
                    -30.914200f,-67.085300f, -31.005600f,-67.112200f, -31.060800f,-67.092200f, -31.160700f,-67.125700f, -31.227400f,-67.075300f,
                    -31.382800f,-67.109100f, -31.632700f,-66.958500f, -31.632700f,-66.875200f, -31.792980f,-66.810050f, -31.792980f,-68.711575f);
            poly[477] = new TzPolygon(-31.792980f,-65.770147f, -31.044523f,-65.771984f, -30.485877f,-65.521213f, -30.119411f,-65.422828f, -30.046920f,-65.158100f,
                    -29.911402f,-65.008098f, -29.846962f,-64.939024f, -29.596008f,-64.964324f, -29.574265f,-64.824647f, -29.473738f,-64.825969f,
                    -29.405442f,-64.786067f, -29.311780f,-64.841868f, -29.274007f,-64.824691f, -29.267794f,-64.780716f, -31.792980f,-64.780716f);
            poly[478] = new TzPolygon(-29.267794f,-64.780716f, -29.198162f,-64.854485f, -29.016049f,-64.863470f, -28.931650f,-64.906800f, -28.838502f,-64.901298f,
                    -28.738725f,-65.016846f, -28.716365f,-65.126770f, -28.647445f,-65.136304f, -28.623595f,-65.187454f, -28.600273f,-65.184619f,
                    -28.611516f,-65.125641f, -28.471149f,-65.097055f, -28.393264f,-65.101266f, -28.393264f,-64.780716f);
            poly[479] = new TzPolygon(-28.393264f,-66.537674f, -28.468125f,-66.514020f, -28.531510f,-66.530901f, -28.531341f,-66.496285f, -28.621755f,-66.496364f,
                    -28.721267f,-66.351460f, -28.814721f,-66.411309f, -28.858168f,-66.402357f, -28.944016f,-66.099378f, -29.180995f,-65.814712f,
                    -29.269552f,-65.814566f, -29.269873f,-65.748386f, -29.328488f,-65.717348f, -29.411858f,-65.719177f, -30.119411f,-65.422828f,
                    -30.485877f,-65.521213f, -31.044523f,-65.771984f, -31.792980f,-65.770147f, -31.792980f,-66.746146f, -28.393264f,-66.746146f);
            poly[480] = new TzPolygon(-41.422645f,-62.609179f, -40.979576f,-62.803051f, -40.824446f,-62.949850f, -40.722183f,-63.184310f, -40.729561f,-63.285669f,
                    -40.707682f,-63.308176f, -40.710189f,-63.379351f, -34.383197f,-63.392673f, -34.384361f,-62.609179f);
            poly[481] = new TzPolygon(-29.267794f,-64.780716f, -28.393264f,-64.780716f, -28.393264f,-62.609179f, -34.384361f,-62.609179f, -34.383197f,-63.392673f,
                    -35.002259f,-63.385587f, -35.012896f,-64.780716f);
            poly[482] = new TzPolygon(-33.261612f,-62.609179f, -33.261612f,-60.260223f, -33.350734f,-60.323943f, -33.412296f,-60.335279f, -33.467725f,-60.410192f,
                    -33.544790f,-60.413768f, -33.582330f,-60.457442f, -33.634118f,-60.462784f, -33.646610f,-60.557088f, -33.585511f,-60.683778f,
                    -33.579018f,-60.781886f, -33.540342f,-60.818173f, -33.554681f,-60.879007f, -33.588514f,-60.918209f, -33.653787f,-60.934192f,
                    -34.385686f,-61.717681f, -34.384361f,-62.609179f);
            poly[483] = new TzPolygon(-33.261612f,-58.393042f, -33.279634f,-58.390545f, -33.363561f,-58.431758f, -33.537643f,-58.443426f, -33.583747f,-58.494708f,
                    -33.720379f,-58.434701f, -33.916298f,-58.423567f, -33.988897f,-58.389303f, -34.037763f,-58.644680f, -33.946724f,-58.758230f,
                    -33.950878f,-58.839899f, -33.890547f,-58.898328f, -33.872694f,-58.972866f, -33.841388f,-58.994148f, -33.847661f,-59.132850f,
                    -33.806264f,-59.172134f, -33.811717f,-59.236545f, -33.726239f,-59.246894f, -33.727338f,-59.442301f, -33.631734f,-59.508333f,
                    -33.689206f,-59.613589f, -33.619980f,-59.661319f, -33.608489f,-59.776325f, -33.589510f,-59.808616f, -33.531851f,-59.824989f,
                    -33.474139f,-59.934303f, -33.448112f,-60.041166f, -33.261612f,-60.260223f);
            poly[484] = new TzPolygon(-35.782448f,-55.703699f, -35.632191f,-55.868778f, -35.173238f,-56.705143f, -35.189034f,-57.000023f, -34.862980f,-57.327981f,
                    -34.780799f,-57.508238f, -34.684798f,-57.934353f, -34.451896f,-57.934502f, -34.232874f,-58.180331f, -34.178090f,-58.295066f,
                    -34.006821f,-58.344293f, -33.999879f,-58.377075f, -33.916298f,-58.423567f, -33.720379f,-58.434701f, -33.585550f,-58.494773f,
                    -33.537643f,-58.443426f, -33.363561f,-58.431758f, -33.279634f,-58.390545f, -33.261612f,-58.393042f, -33.261612f,-55.703699f);
            poly[485] = new TzPolygon(-33.261612f,-53.521037f, -33.261612f,-52.467132f, -33.422913f,-52.615046f, -33.868906f,-53.181090f, -33.743132f,-53.371292f,
                    -33.739471f,-53.430525f, -33.693469f,-53.439511f, -33.688801f,-53.532282f);
            poly[486] = new TzPolygon(-30.085396f,-58.087644f, -31.821977f,-58.087644f, -31.871076f,-58.206771f, -32.001816f,-58.138307f, -32.159083f,-58.183411f,
                    -32.259358f,-58.099923f, -32.309612f,-58.103217f, -32.375891f,-58.182913f, -32.460549f,-58.204637f, -32.572425f,-58.160297f,
                    -32.735830f,-58.149444f, -32.989410f,-58.087644f, -33.004866f,-58.087644f, -33.076862f,-58.175869f, -33.129049f,-58.370649f,
                    -33.180003f,-58.404350f, -33.261612f,-58.393042f, -33.261612f,-62.609179f, -30.085396f,-62.609179f);
            poly[487] = new TzPolygon(-31.673504f,-58.087644f, -31.673504f,-58.010677f, -31.759526f,-58.038331f, -31.821977f,-58.087644f);
            poly[488] = new TzPolygon(-32.989410f,-58.087644f, -33.002302f,-58.084502f, -33.004866f,-58.087644f);
            poly[489] = new TzPolygon(-30.085396f,-57.459256f, -30.144845f,-57.514628f, -30.181515f,-57.644876f, -30.255777f,-57.615244f, -30.341805f,-57.642850f,
                    -30.510438f,-57.889465f, -30.587582f,-57.887298f, -30.695359f,-57.809018f, -30.856258f,-57.799648f, -30.916870f,-57.831591f,
                    -30.920869f,-57.915001f, -31.034678f,-57.861428f, -31.130403f,-57.919249f, -31.217075f,-57.914210f, -31.320029f,-57.981463f,
                    -31.361873f,-57.997148f, -31.390503f,-57.980542f, -31.456470f,-58.082018f, -31.488800f,-58.078247f, -31.531375f,-58.004356f,
                    -31.580292f,-57.980711f, -31.673504f,-58.010677f, -31.673504f,-58.087644f, -30.085396f,-58.087644f);
            poly[490] = new TzPolygon(-30.088811f,-57.067189f, -30.086311f,-57.070451f, -30.121088f,-57.090699f, -30.114028f,-57.116121f, -30.135258f,-57.105867f,
                    -30.198088f,-57.167975f, -30.234495f,-57.155317f, -30.289278f,-57.220813f, -30.289306f,-57.249536f, -30.267152f,-57.259779f,
                    -30.294000f,-57.284000f, -30.257821f,-57.313501f, -30.285000f,-57.353000f, -30.274854f,-57.372651f, -30.304737f,-57.392294f,
                    -30.266052f,-57.464850f, -30.285693f,-57.524310f, -30.258991f,-57.566485f, -30.211343f,-57.560874f, -30.193907f,-57.648930f,
                    -30.123146f,-57.480465f, -30.085396f,-57.451407f, -30.085396f,-57.067189f);
            poly[491] = new TzPolygon(-30.085816f,-57.067189f, -30.105533f,-57.045369f, -30.085929f,-56.994090f, -30.113550f,-56.904972f, -30.086300f,-56.874611f,
                    -30.103859f,-56.807048f, -30.162906f,-56.777510f, -30.176418f,-56.705347f, -30.204946f,-56.697355f, -30.203456f,-56.646280f,
                    -30.218447f,-56.667991f, -30.265656f,-56.610565f, -30.300545f,-56.618695f, -30.288816f,-56.576438f, -30.312907f,-56.541147f,
                    -30.359455f,-56.547058f, -30.360171f,-56.518673f, -30.398418f,-56.489872f, -30.384864f,-56.461264f, -30.422556f,-56.453448f,
                    -30.449495f,-56.397126f, -30.499556f,-56.381765f, -30.491212f,-56.355912f, -30.531342f,-56.322242f, -30.519674f,-56.291926f,
                    -30.585086f,-56.260953f, -30.574071f,-56.235674f, -30.607509f,-56.219200f, -30.615174f,-56.170739f, -30.731972f,-56.132185f,
                    -30.757247f,-56.088586f, -30.746795f,-56.068270f, -30.775368f,-56.046735f, -31.673504f,-56.046735f, -31.673504f,-57.067189f);
            poly[492] = new TzPolygon(-30.775368f,-56.046735f, -30.848082f,-55.991930f, -30.944896f,-56.015329f, -31.082440f,-56.009655f, -31.076539f,-55.883372f,
                    -31.014676f,-55.812486f, -31.015541f,-55.776576f, -30.979391f,-55.728147f, -30.942747f,-55.723757f, -30.953968f,-55.666062f,
                    -30.911597f,-55.642266f, -30.863997f,-55.658342f, -30.833089f,-55.577415f, -30.947598f,-55.486825f, -30.959731f,-55.441381f,
                    -31.018229f,-55.423056f, -31.039216f,-55.349811f, -31.067541f,-55.359921f, -31.088192f,-55.327731f, -31.131436f,-55.340373f,
                    -31.142264f,-55.291184f, -31.260616f,-55.240034f, -31.269459f,-55.169329f, -31.332155f,-55.074459f, -31.269806f,-55.031921f,
                    -31.266919f,-55.007233f, -31.331934f,-54.953276f, -31.351489f,-54.960215f, -31.356503f,-54.935218f, -31.380685f,-54.940871f,
                    -31.377302f,-54.886225f, -31.442003f,-54.836702f, -31.424458f,-54.752240f, -31.456563f,-54.586765f, -31.510194f,-54.515704f,
                    -31.599585f,-54.452798f, -31.651707f,-54.456406f, -31.928245f,-54.100193f, -31.895427f,-54.032779f, -31.904928f,-54.005825f,
                    -33.261612f,-54.005825f, -33.261612f,-56.046735f);
            poly[493] = new TzPolygon(-31.904928f,-54.005825f, -31.917655f,-53.969722f, -31.955318f,-53.960733f, -32.000642f,-53.849776f, -32.055240f,-53.833751f,
                    -32.096148f,-53.725216f, -32.151877f,-53.735001f, -32.296989f,-53.642800f, -32.383854f,-53.645205f, -32.451918f,-53.583210f,
                    -32.488540f,-53.527662f, -32.484461f,-53.464232f, -32.565058f,-53.432604f, -32.581443f,-53.400987f, -32.569735f,-53.370158f,
                    -32.621013f,-53.290780f, -32.604096f,-53.249925f, -32.740881f,-53.075583f, -32.788350f,-53.085802f, -32.792023f,-53.145689f,
                    -32.850431f,-53.184956f, -32.899314f,-53.294539f, -32.918431f,-53.309312f, -32.934454f,-53.244292f, -33.052961f,-53.444381f,
                    -33.153425f,-53.518189f, -33.261612f,-53.521037f, -33.261612f,-54.005825f);
            poly[494] = new TzPolygon(-30.085396f,-57.451407f, -30.036842f,-57.414032f, -29.992845f,-57.337128f, -29.876115f,-57.326184f, -29.787937f,-57.241912f,
                    -29.764937f,-57.120912f, -29.641533f,-56.969840f, -29.581211f,-56.951748f, -29.435326f,-56.777379f, -29.377679f,-56.766182f,
                    -29.359128f,-56.701637f, -29.258538f,-56.648079f, -29.196069f,-56.643787f, -29.125164f,-56.593147f, -29.075000f,-56.418000f,
                    -28.974798f,-56.407753f, -28.896137f,-56.299950f, -28.802720f,-56.296511f, -28.759238f,-56.178580f, -28.687041f,-56.126224f,
                    -28.607182f,-56.009843f, -28.508726f,-56.012491f, -28.479231f,-55.883574f, -30.085396f,-55.883574f);
            poly[495] = new TzPolygon(-28.479231f,-55.883574f, -28.412177f,-55.903229f, -28.393264f,-55.893571f, -28.393264f,-55.883574f);
            poly[496] = new TzPolygon(-28.393264f,-55.686687f, -28.422043f,-55.694328f, -28.423401f,-55.717674f, -28.393264f,-55.737148f);
            poly[497] = new TzPolygon(-27.383750f,-57.601072f, -27.326978f,-57.694530f, -27.334160f,-57.814500f, -27.275266f,-57.874817f, -27.263060f,-57.919449f,
                    -27.275954f,-58.171500f, -27.256324f,-58.171500f, -27.256324f,-57.554695f, -27.383750f,-57.554695f);
            poly[498] = new TzPolygon(-25.443098f,-58.171500f, -25.443098f,-57.554695f, -25.559345f,-57.573697f, -25.568896f,-57.604913f, -25.616495f,-57.617611f,
                    -25.596409f,-57.674058f, -25.659830f,-57.675280f, -25.653057f,-57.743434f, -25.700523f,-57.767600f, -25.716286f,-57.727301f,
                    -25.757760f,-57.773986f, -25.754312f,-57.825696f, -25.822344f,-57.793985f, -25.859709f,-57.866551f, -25.913766f,-57.833879f,
                    -25.955799f,-57.894598f, -25.987296f,-57.853409f, -26.009143f,-57.855737f, -26.107376f,-58.024308f, -26.111846f,-58.084733f,
                    -26.186362f,-58.119694f, -26.182690f,-58.159751f, -26.228508f,-58.103866f, -26.265295f,-58.164025f, -26.344982f,-58.156659f,
                    -26.358070f,-58.171500f);
            poly[499] = new TzPolygon(-25.443098f,-57.554695f, -25.322178f,-57.702950f, -25.285932f,-57.694460f, -25.220289f,-57.759005f, -25.176271f,-57.753587f,
                    -25.131514f,-57.836738f, -25.081396f,-57.861350f, -25.086165f,-57.975387f, -25.033567f,-58.008680f, -25.045757f,-58.068912f,
                    -25.008685f,-58.090843f, -25.011547f,-58.137737f, -24.975004f,-58.150026f, -24.971517f,-58.171500f, -24.971517f,-57.554695f);
        }
    }

    private static class Initializer6 {
        private static void init() {
            poly[500] = new TzPolygon(-27.383750f,-56.217655f, -27.341657f,-56.173053f, -27.308452f,-56.087277f, -27.312518f,-56.037036f, -27.355114f,-55.978926f,
                    -27.342731f,-55.896275f, -27.383750f,-55.859440f);
            poly[501] = new TzPolygon(-27.383750f,-55.687280f, -27.378466f,-55.683009f, -27.337499f,-55.598931f, -27.279151f,-55.600264f, -27.250778f,-55.575678f,
                    -27.182156f,-55.621590f, -27.162407f,-55.605701f, -27.163545f,-55.564983f, -27.108297f,-55.562511f, -27.104263f,-55.454485f,
                    -27.017810f,-55.441962f, -26.966312f,-55.378406f, -26.962682f,-55.305832f, -26.936886f,-55.260090f, -26.969489f,-55.203597f,
                    -26.948583f,-55.135102f, -26.896237f,-55.150208f, -26.852751f,-55.127892f, -26.797297f,-55.052361f, -26.783279f,-54.958271f,
                    -26.682626f,-54.941124f, -26.655576f,-54.869006f, -26.674343f,-54.823364f, -26.631112f,-54.786945f, -26.537220f,-54.801541f,
                    -26.498955f,-54.761145f, -27.383750f,-54.761145f);
            poly[502] = new TzPolygon(-26.780692f,-54.761145f, -26.780692f,-53.714771f, -26.782261f,-53.717054f, -26.847212f,-53.694725f, -26.858288f,-53.662850f,
                    -26.860147f,-53.696837f, -26.869946f,-53.680010f, -26.887078f,-53.695742f, -26.894434f,-53.670997f, -26.929831f,-53.696783f,
                    -26.942484f,-53.671250f, -26.934136f,-53.709196f, -26.960650f,-53.703444f, -26.974462f,-53.737083f, -26.990344f,-53.717999f,
                    -26.991551f,-53.743074f, -27.014724f,-53.740819f, -27.008282f,-53.763594f, -27.032184f,-53.747302f, -27.045352f,-53.763900f,
                    -27.026738f,-53.785853f, -27.065428f,-53.760874f, -27.040278f,-53.802327f, -27.073971f,-53.771876f, -27.078250f,-53.805549f,
                    -27.103307f,-53.776503f, -27.102786f,-53.818939f, -27.122901f,-53.804543f, -27.133247f,-53.824389f, -27.146289f,-53.798789f,
                    -27.145887f,-53.828245f, -27.169915f,-53.836237f, -27.127411f,-53.879053f, -27.176463f,-53.909972f, -27.152051f,-53.951170f,
                    -27.194912f,-53.960253f, -27.200409f,-54.009892f, -27.248372f,-54.021074f, -27.301126f,-54.088891f, -27.296190f,-54.156185f,
                    -27.254000f,-54.172000f, -27.383750f,-54.216578f, -27.383750f,-54.761145f);
            poly[503] = new TzPolygon(-26.177634f,-54.657362f, -26.216938f,-54.618744f, -26.264725f,-54.679579f, -26.311794f,-54.648801f, -26.378675f,-54.697155f,
                    -26.446046f,-54.705291f, -26.498955f,-54.761145f, -26.177634f,-54.761145f);
            poly[504] = new TzPolygon(-26.780692f,-53.662850f, -26.780692f,-53.714771f, -26.769594f,-53.698622f, -26.764284f,-53.743730f, -26.750711f,-53.714038f,
                    -26.720368f,-53.757889f, -26.717058f,-53.734567f, -26.681349f,-53.743391f, -26.684779f,-53.717338f, -26.650887f,-53.720252f,
                    -26.640985f,-53.759459f, -26.644077f,-53.739709f, -26.560856f,-53.707507f, -26.566543f,-53.736356f, -26.545145f,-53.741750f,
                    -26.539159f,-53.720189f, -26.500921f,-53.729022f, -26.508924f,-53.704851f, -26.490330f,-53.695893f, -26.470614f,-53.715186f,
                    -26.430905f,-53.687262f, -26.387569f,-53.709996f, -26.313342f,-53.662850f);
            poly[505] = new TzPolygon(-26.192786f,-53.662850f, -26.177634f,-53.678390f, -26.177634f,-53.662850f);
            poly[506] = new TzPolygon(-25.574576f,-54.761145f, -25.574576f,-54.597496f, -25.662630f,-54.581235f, -25.659618f,-54.640807f, -25.687650f,-54.657778f,
                    -25.830428f,-54.587047f, -25.914252f,-54.622306f, -25.978180f,-54.610621f, -25.995239f,-54.679330f, -26.093444f,-54.643010f,
                    -26.164874f,-54.669899f, -26.177634f,-54.657362f, -26.177634f,-54.761145f);
            poly[507] = new TzPolygon(-25.574576f,-54.233143f, -25.593000f,-54.235000f, -25.596189f,-54.255077f, -25.574576f,-54.272006f);
            poly[508] = new TzPolygon(-25.574576f,-54.332331f, -25.606749f,-54.348221f, -25.597471f,-54.383946f, -25.697560f,-54.432884f, -25.618096f,-54.492703f,
                    -25.628665f,-54.526420f, -25.588129f,-54.552575f, -25.592753f,-54.593535f, -25.574576f,-54.596904f);
            poly[509] = new TzPolygon(-26.177634f,-53.678390f, -26.115572f,-53.742040f, -26.043181f,-53.734204f, -25.970178f,-53.836770f, -25.898539f,-53.819509f,
                    -25.883663f,-53.850008f, -25.872236f,-53.823501f, -25.839815f,-53.850120f, -25.793767f,-53.822137f, -25.790655f,-53.843452f,
                    -25.780858f,-53.830917f, -25.766052f,-53.857018f, -25.751379f,-53.834066f, -25.744423f,-53.866200f, -25.707706f,-53.879314f,
                    -25.687327f,-53.842542f, -25.658641f,-53.862687f, -25.661073f,-53.890301f, -25.622236f,-53.892777f, -25.636287f,-53.912308f,
                    -25.616174f,-53.916511f, -25.611325f,-53.947738f, -25.643519f,-53.962366f, -25.600909f,-53.970265f, -25.574576f,-54.005036f,
                    -25.574576f,-53.662850f, -26.177634f,-53.662850f);
            poly[510] = new TzPolygon(-25.574576f,-54.034108f, -25.585000f,-54.049000f, -25.574576f,-54.063594f);
            poly[511] = new TzPolygon(-25.574576f,-54.087118f, -25.619000f,-54.098000f, -25.574576f,-54.120212f);
            poly[512] = new TzPolygon(-25.574576f,-54.184137f, -25.584000f,-54.178000f, -25.574576f,-54.201407f);
            poly[513] = new TzPolygon(-25.574576f,-54.332331f, -25.553935f,-54.288173f, -25.574576f,-54.272006f);
            poly[514] = new TzPolygon(-25.574576f,-54.233143f, -25.562296f,-54.231905f, -25.574576f,-54.201407f);
            poly[515] = new TzPolygon(-25.574576f,-54.184137f, -25.541000f,-54.206000f, -25.541000f,-54.161000f, -25.495000f,-54.099000f, -25.567000f,-54.124000f,
                    -25.574576f,-54.120212f);
            poly[516] = new TzPolygon(-25.574576f,-54.082008f, -25.557657f,-54.075917f, -25.574576f,-54.059262f);
            poly[517] = new TzPolygon(-25.574576f,-54.026414f, -25.567000f,-54.010000f, -25.574576f,-54.004839f);
            poly[518] = new TzPolygon(-24.971517f,-54.439441f, -25.084088f,-54.458136f, -25.159149f,-54.429502f, -25.313138f,-54.499111f, -25.454309f,-54.619705f,
                    -25.574576f,-54.597496f, -25.574576f,-54.761145f, -24.971517f,-54.761145f);
            poly[519] = new TzPolygon(-26.183765f,-53.662850f, -26.194481f,-53.650406f, -26.249652f,-53.637451f, -26.297939f,-53.662850f);
            poly[520] = new TzPolygon(-26.857392f,-53.662850f, -26.858157f,-53.660456f, -26.858288f,-53.662850f);
            poly[521] = new TzPolygon(-22.204843f,-56.330086f, -22.169491f,-56.364855f, -22.151733f,-56.370302f, -22.151733f,-56.330086f);
            poly[522] = new TzPolygon(-22.151733f,-56.534711f, -22.196549f,-56.556748f, -22.244041f,-56.642261f, -22.263407f,-56.637053f, -22.216928f,-56.703442f,
                    -22.264792f,-56.720261f, -22.235719f,-56.746996f, -22.260414f,-56.776571f, -22.242379f,-56.793443f, -22.283327f,-56.802691f,
                    -22.301554f,-56.842854f, -22.277699f,-56.879965f, -22.247554f,-56.883430f, -22.266490f,-56.905510f, -22.242727f,-56.987088f,
                    -22.222459f,-56.996705f, -22.251128f,-57.082446f, -22.225389f,-57.110259f, -22.236582f,-57.183505f, -22.210984f,-57.201353f,
                    -22.251348f,-57.237664f, -22.218526f,-57.294484f, -22.245548f,-57.320437f, -22.232043f,-57.374403f, -22.197581f,-57.407338f,
                    -22.191154f,-57.489628f, -22.168151f,-57.522847f, -22.175344f,-57.580396f, -22.151733f,-57.589229f);
            poly[523] = new TzPolygon(-23.561625f,-55.528616f, -23.561625f,-54.488672f, -23.893027f,-54.488672f, -23.874332f,-54.568497f, -23.837194f,-54.584378f,
                    -23.851482f,-54.609508f, -23.812615f,-54.669779f, -23.864520f,-54.705325f, -23.856643f,-54.759408f, -23.906000f,-54.849000f,
                    -23.898000f,-54.890000f, -23.922000f,-54.925000f, -23.959000f,-54.924000f, -23.956000f,-54.998000f, -23.993353f,-55.062233f,
                    -23.961918f,-55.107174f, -24.013828f,-55.229072f, -23.965061f,-55.304168f, -23.994601f,-55.345433f, -23.964524f,-55.414243f,
                    -23.916803f,-55.446252f, -23.716646f,-55.436730f, -23.711937f,-55.463962f, -23.640051f,-55.484196f, -23.625015f,-55.539906f,
                    -23.567313f,-55.526385f);
            poly[524] = new TzPolygon(-22.204843f,-56.330086f, -22.218290f,-56.316860f, -22.236588f,-56.238030f, -22.278052f,-56.209831f, -22.288342f,-56.165897f,
                    -22.270323f,-56.117682f, -22.294616f,-56.010168f, -22.280328f,-55.853190f, -22.384601f,-55.789394f, -22.384393f,-55.746947f,
                    -22.459117f,-55.735159f, -22.476824f,-55.752465f, -22.551948f,-55.723408f, -22.655211f,-55.614320f, -22.767498f,-55.618404f,
                    -22.791663f,-55.650634f, -22.852446f,-55.665833f, -23.149926f,-55.596348f, -23.156100f,-55.541986f, -23.197334f,-55.523560f,
                    -23.220467f,-55.546021f, -23.259790f,-55.522720f, -23.279613f,-55.553132f, -23.316532f,-55.555814f, -23.378879f,-55.504574f,
                    -23.477278f,-55.544994f, -23.476213f,-55.562115f, -23.561625f,-55.528616f, -23.561625f,-56.330086f);
            poly[525] = new TzPolygon(-22.151733f,-57.589229f, -22.094620f,-57.610596f, -22.107062f,-57.652655f, -22.091108f,-57.707512f, -22.113653f,-57.716975f,
                    -22.102818f,-57.738089f, -22.134756f,-57.739127f, -22.125232f,-57.779792f, -22.150722f,-57.801829f, -22.120511f,-57.827396f,
                    -22.135925f,-57.865322f, -22.120213f,-57.929674f, -22.082807f,-57.942248f, -22.090233f,-57.993842f, -22.063451f,-57.984244f,
                    -22.040378f,-58.009461f, -22.004996f,-57.965827f, -21.922796f,-57.934951f, -21.901296f,-57.948684f, -21.882660f,-57.912806f,
                    -21.850453f,-57.966028f, -21.773548f,-57.908658f, -21.744133f,-57.947143f, -21.689028f,-57.883287f, -21.650365f,-57.934365f,
                    -21.622382f,-57.942888f, -21.590213f,-57.913865f, -21.563112f,-57.959699f, -21.524324f,-57.967953f, -21.331091f,-57.853501f,
                    -21.280379f,-57.921613f, -21.224075f,-57.850665f, -21.140036f,-57.864535f, -21.097767f,-57.846373f, -21.044168f,-57.868337f,
                    -20.979564f,-57.816504f, -20.940665f,-57.819191f, -20.948466f,-57.863820f, -20.906372f,-57.889070f, -20.900364f,-57.928365f,
                    -20.834026f,-57.855199f, -20.788720f,-57.898631f, -20.791600f,-57.961828f, -20.745653f,-57.934779f, -20.749987f,-57.868689f,
                    -20.741840f,-57.868044f, -20.741840f,-57.250793f, -22.151733f,-57.250793f);
            poly[526] = new TzPolygon(-22.151733f,-56.534711f, -22.095609f,-56.507114f, -22.074341f,-56.394040f, -22.151733f,-56.370302f);
            poly[527] = new TzPolygon(-20.015895f,-58.171500f, -20.120085f,-58.137864f, -20.172900f,-58.168832f, -20.192460f,-58.121521f, -20.228588f,-58.164614f,
                    -20.259525f,-58.162164f, -20.271832f,-58.143519f, -20.254451f,-58.095960f, -20.355544f,-58.093394f, -20.435512f,-57.998465f,
                    -20.515276f,-58.019236f, -20.561592f,-57.995242f, -20.610685f,-58.013809f, -20.642557f,-57.970485f, -20.698787f,-57.988482f,
                    -20.704233f,-57.954870f, -20.663920f,-57.924136f, -20.725585f,-57.869891f, -20.741840f,-57.869090f, -20.741840f,-58.171500f);
            poly[528] = new TzPolygon(-19.822709f,-58.171500f, -19.827268f,-58.163854f, -19.834362f,-58.171500f);
            poly[529] = new TzPolygon(-19.834362f,-58.171500f, -19.827268f,-58.163854f, -19.822709f,-58.171500f, -19.331948f,-58.171500f, -19.331948f,-57.927083f,
                    -19.758000f,-58.131000f, -19.970298f,-57.857957f, -20.042071f,-57.902481f, -20.020944f,-57.953465f, -20.056803f,-57.979452f,
                    -20.063580f,-58.032649f, -20.107267f,-58.050440f, -20.108881f,-58.092529f, -20.145690f,-58.115620f, -20.167124f,-58.169687f,
                    -20.120085f,-58.137864f, -20.015895f,-58.171500f);
            poly[530] = new TzPolygon(-23.893027f,-54.488672f, -23.904464f,-54.439840f, -23.986686f,-54.383689f, -24.004536f,-54.321982f, -24.073356f,-54.282230f,
                    -24.116326f,-54.333898f, -24.154425f,-54.344197f, -24.242406f,-54.324971f, -24.357000f,-54.258000f, -24.470729f,-54.327141f,
                    -24.660587f,-54.324373f, -24.802806f,-54.395372f, -24.947694f,-54.435485f, -24.971517f,-54.439441f, -24.971517f,-54.488672f);
            poly[531] = new TzPolygon(-22.151733f,-54.488672f, -22.151733f,-52.422733f, -22.218000f,-52.489000f, -22.343000f,-52.745000f, -22.439000f,-52.854000f,
                    -22.493000f,-52.998000f, -22.553000f,-53.077000f, -22.621000f,-53.105000f, -22.728000f,-53.198000f, -22.775000f,-53.352000f,
                    -22.890000f,-53.546000f, -22.951000f,-53.607000f, -22.998000f,-53.634000f, -23.125000f,-53.636000f, -23.319000f,-53.730000f,
                    -23.372000f,-53.771000f, -23.456000f,-53.981000f, -23.764000f,-54.075000f, -23.951000f,-54.101000f, -24.073356f,-54.282230f,
                    -24.004536f,-54.321982f, -24.007722f,-54.351711f, -23.958277f,-54.414604f, -23.904464f,-54.439840f, -23.893027f,-54.488672f);
            poly[532] = new TzPolygon(-22.151733f,-52.422733f, -22.106000f,-52.377000f, -21.942000f,-52.301000f, -21.846000f,-52.190000f, -21.770000f,-52.161000f,
                    -21.714000f,-52.076000f, -21.643000f,-52.049000f, -21.570222f,-52.101899f, -21.534828f,-52.094192f, -21.505372f,-52.052602f,
                    -21.503978f,-51.970244f, -21.343515f,-51.861946f, -21.266071f,-51.848440f, -21.197840f,-51.880415f, -21.137189f,-51.878549f,
                    -21.102000f,-51.789000f, -20.974041f,-51.721317f, -20.942271f,-51.623105f, -20.753127f,-51.634210f, -20.643000f,-51.594000f,
                    -20.459000f,-51.409000f, -20.353000f,-51.341000f, -20.295000f,-51.132000f, -20.233189f,-51.058263f, -20.088925f,-50.998257f,
                    -19.959000f,-51.020000f, -19.906000f,-50.999000f, -19.729000f,-51.045000f, -19.589000f,-50.987000f, -19.576000f,-50.923000f,
                    -19.500000f,-50.962000f, -19.467000f,-50.934000f, -19.398676f,-51.026459f, -19.345499f,-51.044461f, -19.331948f,-51.060215f,
                    -19.331948f,-50.806078f, -22.151733f,-50.805961f);
            poly[533] = new TzPolygon(-17.922055f,-58.171500f, -17.922055f,-57.670833f, -18.046000f,-57.600000f, -18.131000f,-57.574000f, -18.231000f,-57.453000f,
                    -18.240000f,-57.557000f, -18.797186f,-57.735232f, -18.899000f,-57.766000f, -18.899000f,-57.719000f, -18.978110f,-57.719215f,
                    -19.010883f,-57.691608f, -19.034630f,-57.710212f, -19.033000f,-57.784000f, -19.331948f,-57.927083f, -19.331948f,-58.171500f);
            poly[534] = new TzPolygon(-16.512163f,-57.250793f, -17.792638f,-57.250793f, -17.793511f,-57.254453f, -17.796948f,-57.250793f, -17.812406f,-57.250793f,
                    -17.810532f,-57.309295f, -17.838163f,-57.345326f, -17.826823f,-57.380877f, -17.903297f,-57.456586f, -17.860189f,-57.477550f,
                    -17.863367f,-57.515847f, -17.800217f,-57.577931f, -17.803411f,-57.605243f, -17.717797f,-57.640721f, -17.730895f,-57.664558f,
                    -17.716536f,-57.684588f, -17.673987f,-57.668216f, -17.531012f,-57.725031f, -17.550931f,-57.745913f, -17.449000f,-57.883000f,
                    -17.515000f,-57.996000f, -17.492000f,-58.043000f, -17.450000f,-58.060000f, -17.447000f,-58.120000f, -17.384000f,-58.151000f,
                    -17.388221f,-58.171500f, -16.512163f,-58.171500f);
            poly[535] = new TzPolygon(-17.388221f,-58.171500f, -17.384000f,-58.151000f, -17.451000f,-58.116000f, -17.450000f,-58.060000f, -17.492000f,-58.043000f,
                    -17.515000f,-57.996000f, -17.449000f,-57.883000f, -17.550931f,-57.745913f, -17.560008f,-57.795670f, -17.597972f,-57.774028f,
                    -17.642698f,-57.782167f, -17.729884f,-57.709642f, -17.774842f,-57.713482f, -17.810412f,-57.684982f, -17.830634f,-57.684920f,
                    -17.830740f,-57.723019f, -17.922055f,-57.670833f, -17.922055f,-58.171500f);
            poly[536] = new TzPolygon(-17.286252f,-56.330086f, -17.288908f,-56.339132f, -17.267412f,-56.360492f, -17.331709f,-56.445067f, -17.297111f,-56.492154f,
                    -17.332128f,-56.579387f, -17.317294f,-56.647131f, -17.340205f,-56.648235f, -17.321808f,-56.657354f, -17.340703f,-56.663864f,
                    -17.317013f,-56.683381f, -17.310246f,-56.735108f, -17.390810f,-56.789239f, -17.392755f,-56.831907f, -17.459604f,-56.826042f,
                    -17.465538f,-56.850469f, -17.532183f,-56.875661f, -17.532406f,-56.911001f, -17.580121f,-56.983146f, -17.610696f,-56.982684f,
                    -17.614478f,-56.960688f, -17.733244f,-57.048119f, -17.782021f,-57.118695f, -17.768437f,-57.149329f, -17.792638f,-57.250793f,
                    -16.512163f,-57.250793f, -16.512163f,-56.330086f);
            poly[537] = new TzPolygon(-17.796948f,-57.250793f, -17.812952f,-57.233748f, -17.812406f,-57.250793f);
            poly[538] = new TzPolygon(-17.513359f,-55.409379f, -17.512463f,-55.444798f, -17.479223f,-55.473057f, -17.482895f,-55.525220f, -17.421675f,-55.590446f,
                    -17.373521f,-55.586883f, -17.365211f,-55.627677f, -17.340052f,-55.642151f, -17.359681f,-55.647660f, -17.338200f,-55.658584f,
                    -17.354321f,-55.704277f, -17.337410f,-55.709644f, -17.329940f,-55.787747f, -17.298000f,-55.806000f, -17.300699f,-55.843553f,
                    -17.269039f,-55.875432f, -17.285149f,-55.888516f, -17.273792f,-55.903853f, -17.264107f,-55.888359f, -17.257880f,-55.928746f,
                    -17.278610f,-55.942337f, -17.249953f,-55.952470f, -17.257964f,-55.988578f, -17.240256f,-56.011925f, -17.204994f,-56.007192f,
                    -17.171000f,-56.045000f, -17.186907f,-56.054462f, -17.167453f,-56.114841f, -17.191339f,-56.140422f, -17.188883f,-56.187843f,
                    -17.227306f,-56.211171f, -17.220108f,-56.254994f, -17.277225f,-56.299346f, -17.286252f,-56.330086f, -16.512163f,-56.330086f,
                    -16.512163f,-55.409379f);
            poly[539] = new TzPolygon(-17.513359f,-55.409379f, -16.512163f,-55.409379f, -16.512163f,-54.488672f, -17.487529f,-54.488672f, -17.488178f,-54.556466f,
                    -17.467265f,-54.581596f, -17.521462f,-54.746686f, -17.567703f,-54.762737f, -17.624247f,-54.861871f, -17.608776f,-54.942455f,
                    -17.639097f,-54.991591f, -17.642427f,-55.062736f, -17.626088f,-55.098549f, -17.654082f,-55.125875f, -17.615924f,-55.223875f,
                    -17.540589f,-55.294693f, -17.548175f,-55.351021f, -17.514195f,-55.376344f);
            poly[540] = new TzPolygon(-17.922055f,-53.865324f, -17.922055f,-53.121210f, -17.990463f,-53.064478f, -18.034632f,-53.072785f, -18.041560f,-53.173775f,
                    -18.007000f,-53.237000f, -18.008000f,-53.380000f, -17.983000f,-53.439000f, -18.039000f,-53.472000f, -18.005000f,-53.557000f,
                    -18.012000f,-53.589000f, -17.976000f,-53.616000f, -17.977000f,-53.661000f, -18.013000f,-53.692000f, -17.994000f,-53.786000f);
            poly[541] = new TzPolygon(-17.922055f,-53.937743f, -17.923000f,-53.948000f, -17.922055f,-53.948127f);
            poly[542] = new TzPolygon(-17.922055f,-53.121210f, -17.922055f,-52.647375f, -18.690325f,-52.647375f, -18.692000f,-52.747000f, -18.637000f,-52.918000f,
                    -18.540000f,-52.962000f, -18.465000f,-52.880000f, -18.426000f,-52.873000f, -18.414000f,-52.798000f, -18.350000f,-52.759000f,
                    -18.313000f,-52.805000f, -18.296000f,-52.935000f, -18.303000f,-52.976000f, -18.351000f,-53.027000f, -18.310000f,-53.101000f,
                    -18.081000f,-53.143000f, -18.051548f,-53.076822f, -17.990463f,-53.064478f);
            poly[543] = new TzPolygon(-17.922055f,-53.948127f, -17.871000f,-53.955000f, -17.702000f,-53.855000f, -17.672000f,-53.806000f, -17.663000f,-53.704000f,
                    -17.254250f,-53.679614f, -17.227590f,-53.705129f, -17.294510f,-53.819352f, -17.355727f,-53.831169f, -17.374013f,-53.877432f,
                    -17.458649f,-53.950309f, -17.506048f,-54.054051f, -17.563118f,-54.051916f, -17.618726f,-54.078639f, -17.603664f,-54.181012f,
                    -17.653837f,-54.273177f, -17.662472f,-54.336167f, -17.633457f,-54.388019f, -17.572391f,-54.382000f, -17.528627f,-54.466883f,
                    -17.487463f,-54.481728f, -17.487529f,-54.488672f, -16.512163f,-54.488672f, -16.512163f,-53.568023f, -17.922055f,-53.568023f,
                    -17.922055f,-53.865324f, -17.916000f,-53.872000f);
            poly[544] = new TzPolygon(-17.922055f,-53.121210f, -17.915589f,-53.126573f, -17.835524f,-53.131687f, -17.765526f,-53.164122f, -17.689788f,-53.244229f,
                    -17.440000f,-53.233000f, -17.380000f,-53.196000f, -17.298512f,-53.218654f, -17.113281f,-53.118068f, -17.070266f,-53.055208f,
                    -17.050489f,-53.071337f, -16.963150f,-53.055882f, -16.861268f,-53.014093f, -16.867190f,-52.963615f, -16.841093f,-52.952854f,
                    -16.840394f,-52.926685f, -16.803295f,-52.933357f, -16.818458f,-52.923662f, -16.776455f,-52.884701f, -16.742593f,-52.786521f,
                    -16.714075f,-52.785547f, -16.704761f,-52.760051f, -16.672697f,-52.754996f, -16.669686f,-52.771375f, -16.657553f,-52.740419f,
                    -16.631082f,-52.746632f, -16.640311f,-52.715364f, -16.589863f,-52.740000f, -16.599613f,-52.705274f, -16.571281f,-52.704770f,
                    -16.584674f,-52.672726f, -16.551074f,-52.668255f, -16.562030f,-52.650701f, -16.558407f,-52.647375f, -17.922055f,-52.647375f);
            poly[545] = new TzPolygon(-18.690325f,-52.647375f, -18.689381f,-52.591203f, -18.658000f,-52.531000f, -18.691000f,-52.449000f, -18.822000f,-52.344000f,
                    -18.847000f,-52.181000f, -18.888000f,-52.157000f, -18.899000f,-52.111000f, -18.942217f,-52.093024f, -18.962996f,-52.017978f,
                    -18.981996f,-52.014978f, -18.969106f,-51.938996f, -19.050484f,-51.857555f, -19.137546f,-51.657844f, -19.126233f,-51.576605f,
                    -19.161373f,-51.498006f, -19.166266f,-51.419890f, -19.221444f,-51.369190f, -19.218000f,-51.307000f, -19.239268f,-51.306705f,
                    -19.273673f,-51.251378f, -19.260845f,-51.202478f, -19.307639f,-51.088474f, -19.331948f,-51.060215f, -19.331948f,-52.647375f);
            poly[546] = new TzPolygon(-16.512163f,-52.634540f, -16.536613f,-52.627370f, -16.558407f,-52.647375f, -16.512163f,-52.647375f);
            poly[547] = new TzPolygon(-16.411179f,-52.647258f, -16.398783f,-52.687634f, -16.302392f,-52.682701f, -16.284558f,-52.647258f);
            poly[548] = new TzPolygon(-16.512163f,-52.634540f, -16.502772f,-52.637294f, -16.502464f,-52.613314f, -16.464419f,-52.604659f, -16.412343f,-52.643465f,
                    -16.411179f,-52.647258f, -16.284558f,-52.647258f, -16.249429f,-52.577441f, -16.261424f,-52.547034f, -16.229966f,-52.570158f,
                    -16.222389f,-52.545170f, -16.165320f,-52.549163f, -16.133644f,-52.515641f, -16.072111f,-52.329673f, -15.891669f,-52.251835f,
                    -15.886575f,-52.011033f, -15.845026f,-51.983958f, -15.838689f,-51.954299f, -15.810756f,-51.950499f, -15.828855f,-51.882751f,
                    -15.636294f,-51.758111f, -15.538431f,-51.778275f, -15.531099f,-51.760258f, -15.560050f,-51.740094f, -15.509225f,-51.735833f,
                    -15.490610f,-51.700465f, -15.410000f,-51.697000f, -15.371000f,-51.671000f, -15.322703f,-51.691462f, -15.263230f,-51.645667f,
                    -15.250822f,-51.672313f, -15.176968f,-51.651204f, -15.156079f,-51.596553f, -15.102270f,-51.558619f, -15.102270f,-50.806254f,
                    -16.512163f,-50.806196f);
            poly[549] = new TzPolygon(-15.102270f,-51.558619f, -15.062881f,-51.530851f, -15.045546f,-51.457640f, -15.005412f,-51.419805f, -15.009343f,-51.365788f,
                    -14.969595f,-51.328306f, -15.037921f,-51.284888f, -15.027660f,-51.227856f, -14.984968f,-51.156704f, -14.944533f,-51.146034f,
                    -14.920177f,-51.085964f, -14.840000f,-51.089000f, -14.789864f,-51.042482f, -14.750995f,-51.057154f, -14.524072f,-50.961122f,
                    -14.416032f,-50.998238f, -14.326515f,-50.965715f, -14.294160f,-50.978501f, -14.169324f,-50.913568f, -14.114261f,-50.918252f,
                    -14.125615f,-50.865533f, -14.089000f,-50.833000f, -13.966628f,-50.867697f, -13.914455f,-50.839952f, -13.733000f,-50.871000f,
                    -13.694158f,-50.806313f, -15.102270f,-50.806254f);
            poly[550] = new TzPolygon(-14.163903f,-46.188044f, -14.164359f,-46.190346f, -14.119259f,-46.219416f, -14.098000f,-46.265000f, -14.072912f,-46.226926f,
                    -14.056365f,-46.248040f, -14.014522f,-46.210017f, -13.973713f,-46.219008f, -13.945039f,-46.267438f, -13.845046f,-46.233460f,
                    -13.796000f,-46.282000f, -13.767154f,-46.223718f, -13.745072f,-46.237194f, -13.740874f,-46.284595f, -13.717227f,-46.238295f,
                    -13.692378f,-46.257237f, -13.692378f,-46.188044f);
            poly[551] = new TzPolygon(-15.102270f,-46.029482f, -15.102270f,-45.711891f, -15.112535f,-45.721285f, -15.113383f,-45.818321f, -15.157685f,-45.872560f,
                    -15.138779f,-45.954580f, -15.194220f,-45.984762f, -15.199072f,-46.027124f, -15.260701f,-46.054929f, -15.262861f,-46.078810f,
                    -15.193932f,-46.120362f, -15.165456f,-46.048563f, -15.118000f,-46.043000f);
            poly[552] = new TzPolygon(-14.163903f,-46.188044f, -14.153000f,-46.133000f, -14.204396f,-46.096657f, -14.194000f,-46.061000f, -14.237967f,-46.054406f,
                    -14.257891f,-45.994421f, -14.343453f,-45.942258f, -14.354970f,-45.906633f, -14.415000f,-45.935000f, -14.432994f,-45.978709f,
                    -14.406268f,-46.008943f, -14.418405f,-46.016882f, -14.516805f,-46.004082f, -14.537950f,-45.977668f, -14.542956f,-45.996508f,
                    -14.626000f,-45.985000f, -14.660318f,-45.990821f, -14.681224f,-46.029448f, -14.711000f,-46.001000f, -14.794000f,-46.008000f,
                    -14.831000f,-46.052000f, -14.975295f,-45.965961f, -15.039224f,-45.975302f, -15.102270f,-46.029482f, -15.102270f,-46.188044f);
            poly[553] = new TzPolygon(-15.102270f,-45.711838f, -14.943665f,-45.565870f, -14.953873f,-45.455014f, -14.921417f,-45.435350f, -14.918441f,-45.400226f,
                    -14.871816f,-45.365008f, -14.851651f,-45.317438f, -14.831457f,-45.317233f, -14.833255f,-45.285795f, -14.744673f,-45.206240f,
                    -14.732347f,-45.164566f, -14.749430f,-45.083684f, -14.679972f,-45.040591f, -14.578955f,-44.843245f, -14.570419f,-44.859403f,
                    -14.537801f,-44.824346f, -14.498007f,-44.833433f, -14.448189f,-44.701404f, -14.415356f,-44.689291f, -14.415782f,-44.657995f,
                    -14.393708f,-44.658116f, -14.388206f,-44.648778f, -15.102270f,-44.648778f);
            poly[554] = new TzPolygon(-14.388206f,-44.648778f, -14.338780f,-44.564892f, -14.328167f,-44.486893f, -14.238936f,-44.315862f, -14.259006f,-44.246736f,
                    -14.231821f,-44.214855f, -14.267655f,-44.170566f, -14.262761f,-44.137111f, -14.281434f,-44.134166f, -14.257371f,-44.113295f,
                    -14.288946f,-44.034514f, -14.264585f,-43.997740f, -14.304928f,-43.942296f, -14.292739f,-43.893193f, -14.311868f,-43.881644f,
                    -14.311640f,-43.819612f, -14.337740f,-43.777256f, -14.377760f,-43.815158f, -14.525676f,-43.873942f, -14.653924f,-43.884509f,
                    -14.675197f,-43.859908f, -14.698811f,-43.725615f, -14.730188f,-43.719516f, -14.722008f,-43.686412f, -14.760473f,-43.615171f,
                    -14.750715f,-43.580667f, -14.784546f,-43.535883f, -14.816515f,-43.530319f, -14.787809f,-43.469488f, -14.768151f,-43.481646f,
                    -14.723202f,-43.434649f, -14.669957f,-43.311732f, -14.650731f,-43.177183f, -14.684120f,-43.109512f, -16.217122f,-43.109512f,
                    -16.217122f,-44.648778f);
            poly[555] = new TzPolygon(-14.684120f,-43.109512f, -14.696519f,-43.084382f, -14.682940f,-43.037621f, -14.707717f,-42.939187f, -14.744336f,-42.927253f,
                    -14.764760f,-42.870308f, -14.885865f,-42.722981f, -14.944884f,-42.626253f, -14.923721f,-42.598581f, -15.017000f,-42.476000f,
                    -15.022714f,-42.436958f, -15.062776f,-42.440807f, -15.071000f,-42.374000f, -15.098000f,-42.355000f, -15.080000f,-42.331000f,
                    -15.125383f,-42.265014f, -15.086086f,-42.173022f, -15.186476f,-42.091443f, -15.158829f,-41.997362f, -15.174000f,-41.932000f,
                    -15.115000f,-41.870000f, -15.100254f,-41.801819f, -15.307070f,-41.570246f, -16.217122f,-41.570246f, -16.217122f,-43.109512f);
            poly[556] = new TzPolygon(-18.099873f,-40.030979f, -17.979559f,-40.222818f, -17.922000f,-40.263000f, -17.851000f,-40.174000f, -17.795000f,-40.218000f,
                    -17.737604f,-40.219773f, -17.726033f,-40.276257f, -17.619177f,-40.342947f, -17.644276f,-40.355390f, -17.612651f,-40.372507f,
                    -17.625000f,-40.396000f, -17.609393f,-40.415076f, -17.567462f,-40.412154f, -17.568525f,-40.460551f, -17.520939f,-40.488961f,
                    -17.489472f,-40.482978f, -17.445462f,-40.519939f, -17.406000f,-40.623000f, -17.389631f,-40.598750f, -17.326000f,-40.609000f,
                    -17.284202f,-40.547143f, -17.251867f,-40.571343f, -17.199830f,-40.551596f, -17.163427f,-40.578032f, -17.102900f,-40.556944f,
                    -17.062101f,-40.570851f, -16.885069f,-40.492081f, -16.899000f,-40.417000f, -16.874000f,-40.366000f, -16.907828f,-40.331036f,
                    -16.901000f,-40.281000f, -16.846176f,-40.247825f, -16.805402f,-40.258563f, -16.785793f,-40.345059f, -16.736000f,-40.310000f,
                    -16.586744f,-40.283582f, -16.556677f,-40.234308f, -16.579364f,-40.157947f, -16.524098f,-40.170751f, -16.421373f,-40.097901f,
                    -16.463845f,-40.083629f, -16.459018f,-40.066769f, -16.390046f,-40.030979f);
            poly[557] = new TzPolygon(-16.217122f,-39.906950f, -16.244563f,-39.936510f, -16.284049f,-39.916383f, -16.327000f,-39.966000f, -16.313000f,-39.991000f,
                    -16.390046f,-40.030979f, -16.217122f,-40.030979f);
            poly[558] = new TzPolygon(-18.099873f,-40.030979f, -18.329545f,-39.664770f, -18.348003f,-39.669190f, -18.367914f,-39.471719f, -18.529939f,-39.522997f,
                    -18.741865f,-39.541482f, -18.741865f,-40.030979f);
            poly[559] = new TzPolygon(-15.307070f,-41.570246f, -15.498402f,-41.356010f, -15.741560f,-41.329993f, -15.737000f,-41.215000f, -15.770375f,-41.140869f,
                    -15.719000f,-41.077000f, -15.712733f,-41.005300f, -15.648000f,-40.963000f, -15.694000f,-40.881000f, -15.683000f,-40.842000f,
                    -15.646550f,-40.823399f, -15.714079f,-40.767664f, -15.703647f,-40.739861f, -15.680251f,-40.741362f, -15.668618f,-40.699072f,
                    -15.728888f,-40.644889f, -15.716115f,-40.629307f, -15.736542f,-40.606841f, -15.802973f,-40.561329f, -15.797049f,-40.517949f,
                    -15.769205f,-40.510730f, -15.774532f,-40.479574f, -15.753304f,-40.460755f, -15.807039f,-40.423885f, -15.823203f,-40.376211f,
                    -15.803000f,-40.231000f, -15.861859f,-40.200518f, -15.868317f,-40.164855f, -15.904000f,-40.175000f, -15.912193f,-40.106020f,
                    -15.896720f,-40.084818f, -15.921773f,-40.085297f, -15.911452f,-40.065745f, -15.940758f,-40.079607f, -15.989493f,-40.023510f,
                    -15.997616f,-39.916689f, -16.025079f,-39.933982f, -16.113385f,-39.856783f, -16.141000f,-39.897000f, -16.195207f,-39.883343f,
                    -16.217122f,-39.906950f, -16.217122f,-41.570246f);
            poly[560] = new TzPolygon(-27.782686f,-69.003680f, -27.794759f,-69.095210f, -27.717576f,-69.093372f, -27.696915f,-69.044483f, -27.616953f,-69.053169f,
                    -27.580538f,-69.003680f);
            poly[561] = new TzPolygon(-28.393264f,-69.642201f, -28.327687f,-69.522826f, -28.183574f,-69.456789f, -28.226797f,-69.391459f, -28.184372f,-69.383819f,
                    -28.128662f,-69.308756f, -28.069677f,-69.299612f, -28.046693f,-69.263974f, -28.010287f,-69.267303f, -27.967557f,-69.236306f,
                    -27.972151f,-69.177358f, -27.948475f,-69.155857f, -27.794759f,-69.095210f, -27.782686f,-69.003680f, -28.393264f,-69.003680f);
            poly[562] = new TzPolygon(-27.782686f,-69.003680f, -27.755690f,-68.799005f, -27.788574f,-68.725469f, -27.815204f,-68.716028f, -27.791687f,-68.624253f,
                    -27.819721f,-68.582389f, -27.709766f,-68.543315f, -27.838393f,-68.514690f, -27.873642f,-68.440297f, -28.015468f,-68.456798f,
                    -28.004064f,-68.396931f, -28.037611f,-68.335776f, -28.026398f,-68.286295f, -28.068440f,-68.295457f, -28.095039f,-68.274729f,
                    -28.071128f,-68.246233f, -28.085952f,-68.182998f, -28.110730f,-68.164544f, -28.101796f,-68.141220f, -28.173396f,-68.107445f,
                    -28.124791f,-68.022451f, -28.114089f,-67.914895f, -28.172261f,-67.930269f, -28.259096f,-67.894188f, -28.313786f,-67.840776f,
                    -28.375508f,-67.846359f, -28.375937f,-67.815551f, -28.348498f,-67.806108f, -28.351398f,-67.770677f, -28.393264f,-67.770677f,
                    -28.393264f,-69.003680f);
            poly[563] = new TzPolygon(-26.780915f,-69.003680f, -26.780915f,-68.367225f, -26.916228f,-68.263802f, -26.925767f,-68.291511f, -26.982490f,-68.318325f,
                    -27.033590f,-68.295992f, -27.064374f,-68.430905f, -27.094585f,-68.451061f, -27.057879f,-68.483650f, -27.120923f,-68.476926f,
                    -27.135139f,-68.496384f, -27.113794f,-68.555859f, -27.175202f,-68.572847f, -27.169898f,-68.618377f, -27.103758f,-68.668674f,
                    -27.100259f,-68.703959f, -27.113087f,-68.751080f, -27.098868f,-68.778190f, -27.152634f,-68.806971f, -27.154640f,-68.841202f,
                    -27.260622f,-68.868393f, -27.301107f,-68.808478f, -27.317038f,-68.868668f, -27.398370f,-68.887598f, -27.411229f,-68.930027f,
                    -27.444406f,-68.936618f, -27.430293f,-68.966849f, -27.446770f,-68.988719f, -27.523250f,-68.942310f, -27.523604f,-68.987525f,
                    -27.560637f,-68.976634f, -27.580538f,-69.003680f);
            poly[564] = new TzPolygon(-28.351398f,-67.770677f, -28.352621f,-67.755728f, -28.329947f,-67.760686f, -28.311741f,-67.695856f, -28.384185f,-67.376695f,
                    -28.383546f,-67.155801f, -28.270403f,-67.075075f, -28.254312f,-67.015427f, -28.288509f,-66.570774f, -28.393264f,-66.537674f,
                    -28.393264f,-67.770677f);
            poly[565] = new TzPolygon(-26.352551f,-66.537674f, -26.352209f,-66.539941f, -26.292376f,-66.560733f, -26.266479f,-66.538503f, -26.248621f,-66.567514f,
                    -26.160946f,-66.584423f, -26.107103f,-66.660490f, -26.076675f,-66.660705f, -26.080992f,-66.704221f, -26.048108f,-66.778636f,
                    -25.980363f,-66.839408f, -25.916577f,-66.852794f, -25.796273f,-66.847582f, -25.764648f,-66.872170f, -25.712538f,-66.842623f,
                    -25.698772f,-66.794708f, -25.711919f,-66.648731f, -25.629397f,-66.606717f, -25.620942f,-66.563845f, -25.585588f,-66.571655f,
                    -25.539160f,-66.537674f);
            poly[566] = new TzPolygon(-25.372480f,-66.537674f, -25.362215f,-66.599851f, -25.298643f,-66.559343f, -25.241243f,-66.879499f, -25.237685f,-67.864494f,
                    -25.168567f,-68.507223f, -25.168567f,-66.537674f);
            poly[567] = new TzPolygon(-25.168567f,-68.507223f, -25.207084f,-68.501416f, -25.298507f,-68.545775f, -25.314192f,-68.522283f, -25.374353f,-68.522605f,
                    -25.414405f,-68.589953f, -25.448390f,-68.589256f, -25.574439f,-68.514951f, -25.630461f,-68.545780f, -25.708099f,-68.478917f,
                    -26.178220f,-68.381075f, -26.287103f,-68.557536f, -26.492936f,-68.587336f, -26.780915f,-68.367225f, -26.780915f,-69.003680f,
                    -25.168567f,-69.003680f);
            poly[568] = new TzPolygon(-27.046989f,-66.537674f, -27.046989f,-65.958290f, -27.261056f,-66.140793f, -27.333128f,-65.971895f, -27.525227f,-65.970733f,
                    -27.669067f,-65.915372f, -27.688848f,-65.865655f, -27.851059f,-65.832287f, -27.806610f,-65.793683f, -27.768394f,-65.802504f,
                    -27.768864f,-65.750367f, -27.818009f,-65.702254f, -27.970182f,-65.667817f, -27.971455f,-65.618279f, -28.013268f,-65.569823f,
                    -27.929197f,-65.506348f, -27.845797f,-65.365251f, -27.946457f,-65.171045f, -28.186361f,-65.112451f, -28.393264f,-65.101266f,
                    -28.393264f,-66.537674f);
            poly[569] = new TzPolygon(-28.393264f,-65.101266f, -28.186361f,-65.112451f, -27.906972f,-65.167722f, -27.879171f,-65.039730f, -27.791474f,-65.016099f,
                    -27.739157f,-65.032738f, -27.733876f,-64.988228f, -27.586819f,-65.029798f, -27.546087f,-64.955768f, -27.466251f,-65.012245f,
                    -27.344999f,-64.932636f, -27.318417f,-64.854573f, -27.046989f,-64.776507f, -27.046989f,-64.268303f, -28.393264f,-64.268303f);
            poly[570] = new TzPolygon(-26.352551f,-66.537674f, -26.364106f,-66.461085f, -26.416701f,-66.382141f, -26.149217f,-66.230607f, -26.133847f,-66.170712f,
                    -26.216600f,-66.099200f, -26.377030f,-66.118984f, -26.401326f,-66.158466f, -26.471495f,-66.177693f, -26.628931f,-66.172285f,
                    -26.600379f,-66.042152f, -26.744211f,-65.830078f, -26.863778f,-65.900524f, -26.901214f,-65.857630f, -26.929072f,-65.857759f,
                    -27.046989f,-65.958290f, -27.046989f,-66.537674f);
            poly[571] = new TzPolygon(-25.700714f,-65.402989f, -26.091851f,-65.402989f, -26.109000f,-65.424400f, -26.087500f,-65.548100f, -26.123500f,-65.613600f,
                    -26.117300f,-65.688500f, -26.352800f,-65.719400f, -26.238700f,-66.071400f, -26.142263f,-66.158509f, -26.130860f,-66.196383f,
                    -26.229432f,-66.292427f, -26.416701f,-66.382141f, -26.364106f,-66.461085f, -26.352551f,-66.537674f, -25.700714f,-66.537674f);
            poly[572] = new TzPolygon(-27.046989f,-64.776507f, -26.966038f,-64.753224f, -26.973659f,-64.710900f, -26.800420f,-64.672192f, -26.809138f,-64.622092f,
                    -26.660523f,-64.590135f, -26.676681f,-64.504552f, -26.409361f,-64.534125f, -26.307450f,-64.481687f, -26.239168f,-64.502526f,
                    -26.113450f,-64.412142f, -26.031169f,-64.403658f, -25.700714f,-64.268303f, -27.046989f,-64.268303f);
            poly[573] = new TzPolygon(-25.700714f,-64.268303f, -26.031169f,-64.403658f, -26.113450f,-64.412142f, -26.219265f,-64.495279f, -26.224100f,-64.622300f,
                    -26.244200f,-64.662100f, -26.223700f,-64.790400f, -26.306800f,-64.951200f, -26.276900f,-64.973700f, -26.287542f,-65.040056f,
                    -26.229700f,-65.040200f, -26.170876f,-65.275608f, -26.081700f,-65.297900f, -26.058300f,-65.361100f, -26.091851f,-65.402989f,
                    -25.700714f,-65.402989f);
            poly[574] = new TzPolygon(-25.726228f,-64.150670f, -25.700714f,-64.268303f, -25.700714f,-64.150670f);
            poly[575] = new TzPolygon(-25.372480f,-66.537674f, -25.436570f,-66.519277f, -25.539160f,-66.537674f);
            poly[576] = new TzPolygon(-19.430473f,-74.790449f, -19.430473f,-72.976999f, -19.973439f,-73.753272f, -20.198447f,-73.730717f, -19.656660f,-74.263954f,
                    -19.558613f,-74.466513f, -19.432884f,-74.790449f);
            poly[577] = new TzPolygon(-24.077061f,-66.810615f, -24.064601f,-66.830268f, -23.972529f,-66.882126f, -23.967109f,-66.949692f, -23.886303f,-66.996817f,
                    -23.734043f,-67.168374f, -23.734043f,-66.810615f);
            poly[578] = new TzPolygon(-23.734043f,-69.470560f, -23.734043f,-67.225926f, -24.034400f,-67.322308f, -24.402228f,-68.259580f, -24.491762f,-68.308504f,
                    -24.484188f,-68.387240f, -24.606416f,-68.434809f, -24.623236f,-68.468454f, -24.599304f,-68.493270f, -24.617438f,-68.503098f,
                    -24.663959f,-68.491838f, -24.724546f,-68.544280f, -24.797393f,-68.567891f, -24.873808f,-68.519556f, -24.905808f,-68.431730f,
                    -25.028830f,-68.406908f, -25.034205f,-68.376830f, -25.110627f,-68.343297f, -25.145304f,-68.409274f, -25.125956f,-68.459405f,
                    -25.168567f,-68.507223f, -25.168567f,-69.470560f);
            poly[579] = new TzPolygon(-23.734043f,-66.810615f, -23.734043f,-67.168374f, -23.694512f,-67.212916f, -23.000436f,-66.990519f, -22.813803f,-67.180656f,
                    -22.722333f,-67.128376f, -22.655016f,-67.013697f, -22.540892f,-67.028274f, -22.540943f,-66.973014f, -22.492479f,-66.927949f,
                    -22.448361f,-66.810615f);
            poly[580] = new TzPolygon(-23.734043f,-67.225639f, -23.694512f,-67.212916f, -23.734043f,-67.168374f);
            poly[581] = new TzPolygon(-22.299520f,-67.938783f, -22.381526f,-67.942563f, -22.440794f,-67.884638f, -22.508057f,-67.887483f, -22.536328f,-67.839975f,
                    -22.557295f,-67.853085f, -22.580914f,-67.833538f, -22.628357f,-67.883389f, -22.666053f,-67.888670f, -22.680214f,-67.867612f,
                    -22.719023f,-67.890315f, -22.743450f,-67.867301f, -22.832767f,-67.883268f, -22.845747f,-67.825129f, -22.880826f,-67.798672f,
                    -22.898274f,-67.567386f, -22.813803f,-67.180656f, -23.000436f,-66.990519f, -23.734043f,-67.225926f, -23.734043f,-69.470560f,
                    -22.299520f,-69.470560f);
            poly[582] = new TzPolygon(-24.077061f,-66.810615f, -24.092795f,-66.785796f, -24.092230f,-66.740709f, -24.173147f,-66.647443f, -24.213219f,-66.483154f,
                    -24.182940f,-66.477624f, -24.161790f,-66.420628f, -24.118392f,-66.417934f, -24.116644f,-66.377731f, -23.984214f,-66.339483f,
                    -23.971236f,-66.367570f, -23.734043f,-66.370107f, -23.734043f,-66.002629f, -23.921816f,-66.015472f, -23.981704f,-65.991011f,
                    -23.969984f,-65.938585f, -24.007483f,-65.946186f, -24.003366f,-65.867307f, -24.060610f,-65.747039f, -24.186886f,-65.725493f,
                    -24.251856f,-65.671120f, -24.306585f,-65.682524f, -24.376821f,-65.656936f, -24.380918f,-65.622646f, -24.448646f,-65.543330f,
                    -24.456639f,-65.506560f, -24.427423f,-65.486854f, -24.431500f,-65.480642f, -25.168567f,-65.480642f, -25.168567f,-66.810615f);
            poly[583] = new TzPolygon(-24.431500f,-65.480642f, -24.461721f,-65.434596f, -24.462419f,-65.357790f, -24.497258f,-65.346508f, -24.485594f,-65.227311f,
                    -24.467885f,-65.228113f, -24.459077f,-65.193704f, -24.562181f,-65.079231f, -24.599575f,-64.927400f, -24.581862f,-64.887918f,
                    -24.520592f,-64.885280f, -24.466996f,-64.842861f, -24.529602f,-64.725892f, -24.607830f,-64.664922f, -24.604255f,-64.573233f,
                    -24.507952f,-64.536756f, -24.506592f,-64.500085f, -24.400752f,-64.421167f, -24.427212f,-64.318140f, -24.407536f,-64.285151f,
                    -24.221540f,-64.162156f, -23.734043f,-64.158059f, -23.734043f,-64.150670f, -25.168567f,-64.150670f, -25.168567f,-65.480642f);
            poly[584] = new TzPolygon(-23.734043f,-66.370107f, -23.694365f,-66.370531f, -23.660197f,-66.333359f, -23.573691f,-66.316807f, -23.556752f,-66.260991f,
                    -23.414402f,-66.177146f, -23.509763f,-65.987288f, -23.734043f,-66.002629f);
            poly[585] = new TzPolygon(-22.299520f,-66.752239f, -22.437778f,-66.782470f, -22.448361f,-66.810615f, -22.299520f,-66.810615f);
            poly[586] = new TzPolygon(-23.734043f,-64.158059f, -23.518844f,-64.156251f, -23.518502f,-64.358095f, -23.569915f,-64.396397f, -23.606765f,-64.391345f,
                    -23.641135f,-64.444824f, -23.520329f,-64.533374f, -23.484739f,-64.654206f, -23.452306f,-64.682720f, -23.495359f,-64.788775f,
                    -23.483960f,-64.863831f, -23.446114f,-64.868534f, -23.423052f,-64.906843f, -23.334341f,-64.899479f, -23.269653f,-64.946806f,
                    -23.278869f,-65.021934f, -23.227181f,-65.038384f, -23.232009f,-65.077141f, -23.162159f,-65.045770f, -23.138159f,-65.070652f,
                    -23.041337f,-65.068223f, -23.016782f,-65.102674f, -23.016782f,-64.150670f, -23.734043f,-64.150670f);
            poly[587] = new TzPolygon(-22.299520f,-65.233489f, -22.319964f,-65.226495f, -22.338963f,-65.263209f, -22.540006f,-65.350277f, -22.602184f,-65.350649f,
                    -22.649567f,-65.271318f, -22.723370f,-65.304734f, -22.789876f,-65.274307f, -22.895065f,-65.273441f, -23.016782f,-65.102674f,
                    -23.016782f,-65.480642f, -22.299520f,-65.480642f);
            poly[588] = new TzPolygon(-22.444452f,-64.150670f, -22.453911f,-64.152920f, -22.560393f,-64.243321f, -22.848522f,-64.283604f, -22.883319f,-64.337563f,
                    -22.749618f,-64.339603f, -22.723634f,-64.362432f, -22.719351f,-64.404070f, -22.689530f,-64.393685f, -22.638778f,-64.441803f,
                    -22.634205f,-64.423330f, -22.580247f,-64.432201f, -22.541250f,-64.411857f, -22.480188f,-64.483290f, -22.436528f,-64.491473f,
                    -22.446284f,-64.521276f, -22.412671f,-64.513125f, -22.379515f,-64.563966f, -22.323793f,-64.564044f, -22.299520f,-64.542897f,
                    -22.299520f,-64.150670f);
            poly[589] = new TzPolygon(-19.430473f,-68.417472f, -19.605476f,-68.572539f, -19.701042f,-68.622898f, -19.738608f,-68.695972f, -19.784349f,-68.625138f,
                    -19.828161f,-68.599252f, -19.845412f,-68.528356f, -19.889553f,-68.542671f, -19.924297f,-68.521515f, -20.050071f,-68.566444f,
                    -20.078454f,-68.762269f, -20.129665f,-68.773703f, -20.134778f,-68.704422f, -20.178006f,-68.690748f, -20.193747f,-68.712570f,
                    -20.246582f,-68.711883f, -20.319119f,-68.660608f, -20.357690f,-68.676166f, -20.368370f,-68.741533f, -20.456822f,-68.738743f,
                    -20.572261f,-68.580885f, -20.569618f,-68.534772f, -20.604798f,-68.515007f, -20.635425f,-68.441541f, -20.728351f,-68.553277f,
                    -20.907739f,-68.541641f, -20.945975f,-68.493032f, -20.934386f,-68.412277f, -21.302424f,-68.179023f, -21.604440f,-68.180480f,
                    -21.779405f,-68.059776f, -21.978756f,-68.071379f, -22.053709f,-67.964668f, -22.107803f,-67.939179f, -22.176829f,-67.955562f,
                    -22.272537f,-67.915549f, -22.273550f,-67.937586f, -22.299520f,-67.938783f, -22.299520f,-69.470560f, -19.430473f,-69.470560f);
            poly[590] = new TzPolygon(-22.299520f,-66.752239f, -22.238931f,-66.738991f, -22.209470f,-66.685838f, -22.226261f,-66.638020f, -22.197673f,-66.623098f,
                    -22.128252f,-66.347745f, -22.088384f,-66.325189f, -22.087361f,-66.288770f, -21.944643f,-66.274767f, -21.852784f,-66.235983f,
                    -21.793512f,-66.242730f, -21.781168f,-66.219601f, -21.834929f,-66.075885f, -21.871931f,-66.043355f, -21.918857f,-66.047693f,
                    -21.933078f,-65.924809f, -22.075601f,-65.804134f, -22.109120f,-65.747639f, -22.098643f,-65.589204f, -22.076192f,-65.574395f,
                    -22.095662f,-65.483397f, -22.084788f,-65.187155f, -22.279416f,-65.240366f, -22.299520f,-65.233489f);
            poly[591] = new TzPolygon(-22.299520f,-65.233489f, -22.279416f,-65.240366f, -22.149602f,-65.214669f, -22.146733f,-65.193007f, -22.084788f,-65.187155f,
                    -22.082389f,-64.993217f, -22.121060f,-64.923784f, -22.121810f,-64.861674f, -22.193896f,-64.736477f, -22.205437f,-64.616719f,
                    -22.291366f,-64.535793f, -22.299520f,-64.542897f);
            poly[592] = new TzPolygon(-17.372583f,-69.470560f, -17.291425f,-69.576246f, -17.281588f,-69.645007f, -17.159275f,-69.556902f, -17.118663f,-69.470560f);
            poly[593] = new TzPolygon(-19.430473f,-70.457793f, -19.338000f,-70.494553f, -19.170000f,-70.490174f, -18.805000f,-70.571088f, -18.475301f,-70.544414f,
                    -18.350117f,-70.590836f, -18.350117f,-70.376316f, -18.308981f,-70.301978f, -18.319383f,-70.149435f, -18.269245f,-70.050462f,
                    -18.262180f,-69.965901f, -18.116881f,-69.816359f, -17.989266f,-69.754684f, -17.947296f,-69.750212f, -17.865486f,-69.799199f,
                    -17.762180f,-69.800853f, -17.743975f,-69.822199f, -17.646393f,-69.796210f, -17.660275f,-69.666536f, -17.500098f,-69.470560f,
                    -19.430473f,-69.470560f);
            poly[594] = new TzPolygon(-16.561425f,-69.470560f, -16.561425f,-69.036328f, -16.572260f,-69.040135f, -16.656576f,-68.996102f, -16.727535f,-69.170014f,
                    -16.797555f,-69.186187f, -16.915841f,-69.304675f, -16.980265f,-69.335429f, -17.020568f,-69.393578f, -17.073123f,-69.373739f,
                    -17.118663f,-69.470560f);
            poly[595] = new TzPolygon(-17.372583f,-69.470560f, -17.374129f,-69.468546f, -17.498400f,-69.468482f, -17.500098f,-69.470560f);
            poly[596] = new TzPolygon(-17.500098f,-69.470560f, -17.498400f,-69.468482f, -17.604902f,-69.467882f, -17.729089f,-69.338005f, -17.967576f,-69.283499f,
                    -17.954071f,-69.255892f, -17.988994f,-69.231087f, -18.005083f,-69.121173f, -18.061221f,-69.056633f, -18.163056f,-69.145836f,
                    -18.233729f,-69.063270f, -18.292339f,-69.075078f, -18.323380f,-69.037871f, -18.426443f,-69.047454f, -18.483649f,-69.001469f,
                    -18.600809f,-69.006764f, -18.600259f,-69.025493f, -18.629068f,-69.032739f, -18.667313f,-68.991002f, -18.890331f,-68.911704f,
                    -18.936518f,-68.950333f, -19.060144f,-68.870850f, -19.083672f,-68.805928f, -19.276484f,-68.619797f, -19.296801f,-68.542572f,
                    -19.416186f,-68.404813f, -19.430473f,-68.417472f, -19.430473f,-69.470560f);
            poly[597] = new TzPolygon(-15.126902f,-69.470560f, -15.126902f,-69.226735f, -15.158776f,-69.190451f, -15.259031f,-69.119623f, -15.261360f,-69.176296f,
                    -15.315039f,-69.194793f, -15.374036f,-69.260329f, -15.460393f,-69.240827f, -15.436880f,-69.290072f, -15.518037f,-69.314461f,
                    -15.606007f,-69.401826f, -16.168108f,-69.196402f, -16.225659f,-69.098314f, -16.197362f,-69.055259f, -16.219953f,-69.011519f,
                    -16.194424f,-68.961323f, -16.331411f,-68.795489f, -16.349205f,-68.800674f, -16.425356f,-68.988514f, -16.561425f,-69.036328f,
                    -16.561425f,-69.470560f);
            poly[598] = new TzPolygon(-13.692378f,-69.055115f, -13.739293f,-69.025947f, -13.760588f,-68.974455f, -13.787004f,-68.994823f, -13.814172f,-68.917236f,
                    -13.878670f,-68.950965f, -13.894712f,-68.982528f, -13.948670f,-68.963301f, -13.976530f,-68.978893f, -14.046605f,-68.890320f,
                    -14.111057f,-68.871129f, -14.144873f,-68.833289f, -14.162668f,-68.856180f, -14.215607f,-68.826756f, -14.220055f,-68.962406f,
                    -14.237115f,-68.985006f, -14.265625f,-68.979249f, -14.314709f,-69.015243f, -14.374663f,-68.985407f, -14.521618f,-69.154032f,
                    -14.580314f,-69.150030f, -14.581788f,-69.221352f, -14.654161f,-69.227901f, -14.683977f,-69.258373f, -14.739025f,-69.224871f,
                    -14.759474f,-69.239940f, -14.765299f,-69.301204f, -14.801666f,-69.353797f, -14.961061f,-69.360574f, -15.109902f,-69.277285f,
                    -15.112206f,-69.243463f, -15.126902f,-69.226735f, -15.126902f,-69.470560f, -13.692378f,-69.470560f);
            poly[599] = new TzPolygon(-27.275954f,-58.171500f, -27.258423f,-58.265314f, -27.299843f,-58.599045f, -27.224191f,-58.594278f, -27.183188f,-58.662932f,
                    -27.120433f,-58.641416f, -27.109543f,-58.555318f, -27.037184f,-58.558339f, -27.053219f,-58.500788f, -27.003907f,-58.519555f,
                    -26.992541f,-58.468062f, -26.924073f,-58.502427f, -26.930316f,-58.463422f, -26.893179f,-58.386097f, -26.865161f,-58.372597f,
                    -26.865100f,-58.322831f, -26.809223f,-58.333850f, -26.796475f,-58.284550f, -26.755903f,-58.290727f, -26.750848f,-58.246533f,
                    -26.646407f,-58.261373f, -26.650242f,-58.192021f, -26.620781f,-58.209703f, -26.563218f,-58.198888f, -26.537573f,-58.223435f,
                    -26.499634f,-58.206784f, -26.472285f,-58.233907f, -26.456538f,-58.180865f, -26.402963f,-58.222406f, -26.358070f,-58.171500f);
        }
    }

    private static class Initializer7 {
        private static void init() {
            poly[600] = new TzPolygon(-22.822858f,-64.150670f, -22.822858f,-62.339850f, -24.392029f,-62.342550f, -25.709830f,-63.476092f, -25.673305f,-64.007785f,
                    -25.753393f,-64.025421f, -25.726228f,-64.150670f);
            poly[601] = new TzPolygon(-23.283992f,-61.609799f, -23.285982f,-61.670247f, -23.259524f,-61.682731f, -23.241704f,-61.731940f, -23.158105f,-61.765560f,
                    -23.156684f,-61.804137f, -23.090000f,-61.855278f, -23.070921f,-61.927299f, -23.025124f,-61.955613f, -23.024627f,-61.979655f,
                    -22.995122f,-62.006408f, -22.930366f,-61.998486f, -22.922438f,-62.031331f, -22.888649f,-62.019873f, -22.837876f,-62.058679f,
                    -22.850539f,-62.071361f, -22.822858f,-62.080078f, -22.822858f,-61.609799f);
            poly[602] = new TzPolygon(-24.634697f,-59.068928f, -24.617010f,-59.130078f, -24.519732f,-59.257440f, -24.483067f,-59.350429f, -24.422807f,-59.373140f,
                    -24.408775f,-59.421626f, -24.335533f,-59.471118f, -24.011556f,-60.039414f, -24.044308f,-60.183953f, -24.037979f,-60.308834f,
                    -24.024001f,-60.373532f, -23.994124f,-60.388548f, -23.950938f,-60.477805f, -23.967793f,-60.513667f, -23.958512f,-60.589396f,
                    -23.916188f,-60.588872f, -23.901629f,-60.613986f, -23.902871f,-60.692979f, -23.872222f,-60.732222f, -23.873889f,-60.849167f,
                    -23.823056f,-60.921389f, -23.818080f,-60.989898f, -23.655600f,-61.099693f, -23.613928f,-61.088235f, -23.554722f,-61.182500f,
                    -23.555278f,-61.224722f, -23.487455f,-61.282880f, -23.498656f,-61.294727f, -23.447948f,-61.351702f, -23.460453f,-61.387071f,
                    -23.420126f,-61.445123f, -23.423756f,-61.486890f, -23.380556f,-61.520278f, -23.349881f,-61.509387f, -23.340833f,-61.560278f,
                    -23.283635f,-61.598948f, -23.283992f,-61.609799f, -22.822858f,-61.609799f, -22.822858f,-59.068928f);
            poly[603] = new TzPolygon(-21.055253f,-62.880235f, -21.999945f,-62.880235f, -21.999362f,-63.665262f, -22.054048f,-63.681019f, -22.000000f,-63.709034f,
                    -22.000000f,-63.931395f, -22.085959f,-63.957993f, -22.080671f,-63.978457f, -22.107794f,-64.000351f, -22.242970f,-64.033402f,
                    -22.238189f,-64.062247f, -22.257858f,-64.073288f, -22.404860f,-64.117498f, -22.406972f,-64.141755f, -22.444452f,-64.150670f,
                    -21.055253f,-64.150670f);
            poly[604] = new TzPolygon(-22.822858f,-62.342080f, -22.477492f,-62.341976f, -22.471414f,-62.327056f, -22.487823f,-62.309576f, -22.473193f,-62.289784f,
                    -22.519123f,-62.296320f, -22.539006f,-62.245017f, -22.578156f,-62.245017f, -22.604080f,-62.260934f, -22.610522f,-62.245017f,
                    -22.822858f,-62.245017f);
            poly[605] = new TzPolygon(-22.610522f,-62.245017f, -22.604080f,-62.260934f, -22.578156f,-62.245017f);
            poly[606] = new TzPolygon(-22.539006f,-62.245017f, -22.519123f,-62.296320f, -22.472757f,-62.290565f, -22.486861f,-62.316745f, -22.457852f,-62.361714f,
                    -22.482385f,-62.377845f, -22.421146f,-62.421270f, -22.418333f,-62.453522f, -22.375473f,-62.471972f, -22.374468f,-62.542928f,
                    -22.315121f,-62.567664f, -22.305578f,-62.628385f, -22.259003f,-62.621333f, -22.249285f,-62.644204f, -21.939056f,-62.544338f,
                    -21.939056f,-62.245017f);
            poly[607] = new TzPolygon(-21.939056f,-62.880235f, -21.939056f,-62.549774f, -22.255576f,-62.653620f, -22.190992f,-62.690657f, -22.211473f,-62.717276f,
                    -22.154671f,-62.757694f, -22.175177f,-62.778095f, -22.156169f,-62.795285f, -22.111813f,-62.813562f, -22.000000f,-62.806171f,
                    -21.999945f,-62.880235f);
            poly[608] = new TzPolygon(-22.539006f,-62.245017f, -22.546531f,-62.225599f, -22.578156f,-62.245017f);
            poly[609] = new TzPolygon(-22.610522f,-62.245017f, -22.614610f,-62.234916f, -22.647081f,-62.237122f, -22.661385f,-62.197413f, -22.704176f,-62.206711f,
                    -22.711304f,-62.172490f, -22.761224f,-62.157012f, -22.759870f,-62.130424f, -22.791447f,-62.134790f, -22.822858f,-62.104343f,
                    -22.822858f,-62.245017f);
            poly[610] = new TzPolygon(-22.822858f,-62.102779f, -22.811879f,-62.083536f, -22.822858f,-62.080078f);
            poly[611] = new TzPolygon(-21.055253f,-62.260956f, -21.058628f,-62.260919f, -21.939056f,-62.549774f, -21.939056f,-62.880235f, -21.055253f,-62.880235f);
            poly[612] = new TzPolygon(-21.055253f,-62.260956f, -20.563156f,-62.266342f, -20.089211f,-61.922536f, -19.634406f,-61.735211f, -19.614692f,-61.609799f,
                    -21.055253f,-61.609799f);
            poly[613] = new TzPolygon(-19.287647f,-59.068928f, -19.294686f,-59.977778f, -19.456639f,-60.604325f, -19.614692f,-61.609799f, -19.287647f,-61.609799f);
            poly[614] = new TzPolygon(-24.634697f,-59.068928f, -24.634697f,-58.171500f, -24.971517f,-58.171500f, -24.967885f,-58.193873f, -24.926937f,-58.225028f,
                    -24.998939f,-58.336562f, -24.859956f,-58.475772f, -24.821145f,-58.573077f, -24.831925f,-58.672428f, -24.774619f,-58.726066f,
                    -24.772553f,-58.807349f, -24.663181f,-58.970453f);
            poly[615] = new TzPolygon(-20.015895f,-58.171500f, -19.969757f,-58.186395f, -19.953383f,-58.214042f, -19.862692f,-58.202032f, -19.834362f,-58.171500f);
            poly[616] = new TzPolygon(-19.822709f,-58.171500f, -19.287647f,-59.068928f, -19.287647f,-58.171500f);
            poly[617] = new TzPolygon(-16.490012f,-58.333013f, -16.490012f,-58.171500f, -17.388221f,-58.171500f, -17.391000f,-58.185000f, -17.357000f,-58.202000f,
                    -17.352000f,-58.254000f, -17.300000f,-58.276000f, -17.298000f,-58.298000f, -17.270000f,-58.303000f, -17.181000f,-58.396000f,
                    -17.111000f,-58.386000f, -17.112000f,-58.425000f, -17.086000f,-58.434000f, -16.989000f,-58.423000f, -16.935000f,-58.474000f,
                    -16.703000f,-58.470000f, -16.592000f,-58.436000f);
            poly[618] = new TzPolygon(-16.490012f,-58.333013f, -16.428000f,-58.356000f, -16.389000f,-58.344000f, -16.371723f,-58.307860f, -16.265589f,-58.322265f,
                    -16.261849f,-58.389374f, -16.296911f,-58.394969f, -16.322642f,-58.430595f, -16.266729f,-60.173820f, -15.474916f,-60.239205f,
                    -15.097731f,-60.575185f, -15.097430f,-60.245003f, -14.620958f,-60.273591f, -14.610391f,-60.322870f, -14.510836f,-60.339543f,
                    -14.413522f,-60.407937f, -14.364526f,-60.395794f, -14.314043f,-60.453983f, -14.265170f,-60.467183f, -14.239832f,-60.450148f,
                    -14.191783f,-60.472829f, -14.189024f,-60.493331f, -14.095456f,-60.480378f, -14.078328f,-60.440767f, -13.987325f,-60.381705f,
                    -13.968806f,-60.423993f, -13.937610f,-60.418394f, -13.936950f,-60.450972f, -13.883367f,-60.450938f, -13.885982f,-60.476060f,
                    -13.854459f,-60.456275f, -13.855991f,-60.492913f, -13.794120f,-60.468127f, -13.793774f,-60.526921f, -13.771066f,-60.519104f,
                    -13.782221f,-60.549243f, -13.717455f,-60.619710f, -13.736553f,-60.656088f, -13.692378f,-60.703664f, -13.692378f,-58.171500f,
                    -16.490012f,-58.171500f);
            poly[619] = new TzPolygon(-1.366227f,-61.909707f, -1.366227f,-61.594025f, -1.402377f,-61.615412f, -1.433000f,-61.538000f, -1.504762f,-61.507665f,
                    -1.527000f,-61.473000f, -1.593865f,-61.473624f, -1.448000f,-61.604000f, -1.379000f,-61.790000f, -1.403115f,-61.831168f,
                    -1.395000f,-61.896000f);
            poly[620] = new TzPolygon(-1.366227f,-61.909707f, -1.141000f,-62.017000f, -1.099000f,-62.062000f, -1.093264f,-62.103405f, -1.048956f,-62.122674f,
                    -0.983000f,-62.203000f, -0.976000f,-62.259000f, -0.948000f,-62.293000f, -0.861650f,-62.380483f, -0.836000f,-62.376000f,
                    -0.813599f,-62.399561f, -0.778678f,-62.504653f, -0.710415f,-62.509547f, -0.677902f,-62.488306f, -0.689511f,-62.426989f,
                    -0.722672f,-62.403551f, -0.703115f,-62.357128f, -0.667218f,-62.369081f, -0.647664f,-62.292633f, -0.599381f,-62.289916f,
                    -0.545005f,-62.318344f, -0.531214f,-62.300139f, -0.511357f,-62.308548f, -0.393000f,-62.202000f, -0.369216f,-62.196715f,
                    -0.369216f,-61.358472f, -0.606717f,-61.358472f, -0.634050f,-61.433980f, -0.652760f,-61.430204f, -0.660141f,-61.465738f,
                    -0.719189f,-61.486852f, -0.761929f,-61.538865f, -0.848781f,-61.538350f, -0.936661f,-61.582296f, -0.985062f,-61.577661f,
                    -0.992958f,-61.542127f, -1.012696f,-61.560151f, -1.068648f,-61.544530f, -1.084438f,-61.579034f, -1.182609f,-61.570794f,
                    -1.298723f,-61.629695f, -1.346681f,-61.582462f, -1.366227f,-61.594025f);
            poly[621] = new TzPolygon(0.627796f,-62.524958f, 0.584000f,-62.518000f, 0.509000f,-62.532000f, 0.444000f,-62.518000f, 0.454000f,-62.485000f,
                    0.379000f,-62.446000f, 0.276000f,-62.468000f, 0.174000f,-62.428000f, 0.092000f,-62.424000f, 0.031466f,-62.342454f,
                    -0.102000f,-62.319000f, -0.181000f,-62.241000f, -0.302000f,-62.248000f, -0.330000f,-62.188000f, -0.369216f,-62.196715f,
                    -0.369216f,-62.673840f, 0.627796f,-62.673840f);
            poly[622] = new TzPolygon(-7.348293f,-58.134040f, -7.315468f,-58.171994f, -7.213957f,-58.173580f, -7.130226f,-58.210419f, -7.075617f,-58.279850f,
                    -6.976311f,-58.350852f, -6.934052f,-58.415396f, -6.765320f,-58.480628f, -6.699516f,-58.474791f, -6.606761f,-58.424666f,
                    -6.466749f,-58.260191f, -3.360249f,-56.820941f, -3.360249f,-56.097000f, -7.348293f,-56.097000f);
            poly[623] = new TzPolygon(-0.369216f,-61.358472f, -0.369216f,-60.332285f, -0.405687f,-60.351627f, -0.437621f,-60.346076f, -0.459581f,-60.382616f,
                    -0.514811f,-60.405361f, -0.569483f,-60.376522f, -0.576563f,-60.389225f, -0.632871f,-60.314599f, -0.717102f,-60.309574f,
                    -0.743536f,-60.363690f, -0.731435f,-60.374161f, -0.771600f,-60.425960f, -0.761387f,-60.474326f, -0.825711f,-60.518743f,
                    -0.840773f,-60.502264f, -0.869523f,-60.535780f, -0.842746f,-60.586463f, -0.866176f,-60.596248f, -0.851157f,-60.619165f,
                    -0.887760f,-60.668947f, -0.865489f,-60.683795f, -0.866691f,-60.734994f, -0.853131f,-60.727698f, -0.863644f,-60.760700f,
                    -0.792455f,-60.756065f, -0.782027f,-60.787694f, -0.754564f,-60.771944f, -0.740189f,-60.806448f, -0.694187f,-60.807649f,
                    -0.685347f,-60.856573f, -0.644838f,-60.861637f, -0.618060f,-60.920173f, -0.547683f,-60.933820f, -0.561758f,-60.982486f,
                    -0.545966f,-61.048404f, -0.499000f,-61.096000f, -0.498847f,-61.160327f, -0.516272f,-61.167645f, -0.499560f,-61.220948f,
                    -0.560817f,-61.231674f, -0.606717f,-61.358472f);
            poly[624] = new TzPolygon(-0.369216f,-60.332285f, -0.294744f,-60.292790f, -0.210339f,-60.303390f, -0.209996f,-60.280559f, -0.141452f,-60.220349f,
                    -0.113471f,-60.239746f, -0.039537f,-60.212924f, 0.027637f,-60.132491f, 0.082084f,-60.116841f, 0.104379f,-60.133974f,
                    0.163000f,-60.059000f, 0.235977f,-60.043104f, -0.369216f,-60.043104f);
            poly[625] = new TzPolygon(0.627796f,-60.043104f, 0.627796f,-58.895329f, 0.263472f,-58.895360f, 0.264000f,-60.037000f, 0.235977f,-60.043104f);
            poly[626] = new TzPolygon(-0.638058f,-58.727736f, -0.617468f,-58.737889f, -0.592110f,-58.727736f);
            poly[627] = new TzPolygon(-0.495544f,-58.727736f, -0.470858f,-58.737045f, -0.445679f,-58.727736f);
            poly[628] = new TzPolygon(-0.436739f,-58.727736f, -0.343000f,-58.872000f, -0.196000f,-58.881000f, -0.078000f,-58.863000f, -0.017000f,-58.897000f,
                    0.627796f,-58.896108f, 0.627796f,-58.727736f);
            poly[629] = new TzPolygon(-1.679157f,-57.412368f, -1.691837f,-57.435135f, -1.665392f,-57.440393f, -1.679408f,-57.472273f, -1.642286f,-57.505138f,
                    -1.656029f,-57.526062f, -1.629638f,-57.521296f, -1.600947f,-57.594531f, -1.572201f,-57.602199f, -1.595253f,-57.677789f,
                    -1.576637f,-57.703917f, -1.503593f,-57.712024f, -1.510224f,-57.779572f, -1.485753f,-57.772569f, -1.486656f,-57.795603f,
                    -1.438536f,-57.822891f, -1.403253f,-57.958180f, -1.381710f,-57.953525f, -1.366227f,-57.967688f, -1.366227f,-57.412368f);
            poly[630] = new TzPolygon(-1.679157f,-57.412368f, -1.675028f,-57.404954f, -1.724940f,-57.391535f, -1.715060f,-57.370695f, -1.737619f,-57.352739f,
                    -1.716048f,-57.328769f, -1.733502f,-57.304717f, -1.708720f,-57.289726f, -1.722964f,-57.263862f, -1.697523f,-57.256613f,
                    -1.727327f,-57.232644f, -1.711684f,-57.203485f, -1.736055f,-57.200519f, -1.719588f,-57.165759f, -1.769399f,-57.163700f,
                    -1.765200f,-57.129599f, -1.793274f,-57.113949f, -1.779443f,-57.086520f, -1.811817f,-57.060469f, -1.855827f,-57.067342f,
                    -1.917416f,-57.029716f, -1.919155f,-56.975094f, -2.025184f,-56.843962f, -2.016952f,-56.748248f, -2.070808f,-56.727491f,
                    -2.162767f,-56.764019f, -2.212436f,-56.684748f, -2.210293f,-56.609332f, -2.174588f,-56.599288f, -2.177560f,-56.573280f,
                    -2.139280f,-56.526455f, -2.170338f,-56.480104f, -2.153685f,-56.448229f, -2.180459f,-56.396334f, -2.143235f,-56.381742f,
                    -2.145636f,-56.323721f, -2.102865f,-56.300666f, -2.056947f,-56.227762f, -2.026784f,-56.121429f, -2.037000f,-56.097000f,
                    -2.195000f,-56.220000f, -2.270000f,-56.384000f, -2.423000f,-56.465000f, -2.456000f,-56.402000f, -3.360249f,-56.820941f,
                    -3.360249f,-57.412368f);
            poly[631] = new TzPolygon(-0.436739f,-58.727736f, -0.438471f,-58.725071f, -0.445679f,-58.727736f);
            poly[632] = new TzPolygon(-0.495544f,-58.727736f, -0.545273f,-58.708983f, -0.592110f,-58.727736f);
            poly[633] = new TzPolygon(-0.638058f,-58.727736f, -0.678864f,-58.707615f, -0.719265f,-58.634010f, -0.830798f,-58.533013f, -0.832605f,-58.490268f,
                    -0.860142f,-58.489151f, -0.875027f,-58.439229f, -0.924412f,-58.451297f, -0.981398f,-58.410379f, -1.028423f,-58.427164f,
                    -1.070662f,-58.364022f, -1.145423f,-58.321541f, -1.131290f,-58.255488f, -1.232774f,-58.154804f, -1.187805f,-58.117596f,
                    -1.163623f,-58.123192f, -1.161687f,-58.092947f, -1.105890f,-58.057572f, -1.103964f,-58.017407f, -1.139550f,-58.009262f,
                    -1.168897f,-57.966032f, -1.222422f,-57.958287f, -1.332166f,-57.998844f, -1.366227f,-57.967688f, -1.366227f,-58.727736f);
            poly[634] = new TzPolygon(1.022021f,-66.619944f, 0.744944f,-66.310320f, 0.781614f,-66.197375f, 0.747627f,-66.145467f, 0.761742f,-66.077833f,
                    0.812300f,-66.070240f, 0.815110f,-65.967121f, 0.890962f,-65.940926f, 0.906682f,-65.889908f, 0.941589f,-65.883691f,
                    0.958591f,-65.772612f, 1.001253f,-65.742103f, 1.003858f,-65.696614f, 0.986337f,-65.685226f, 1.012854f,-65.658303f,
                    0.988290f,-65.628455f, 1.014253f,-65.626907f, 1.004706f,-65.588935f, 0.980814f,-65.585695f, 0.991692f,-65.557660f,
                    0.970345f,-65.564435f, 0.968894f,-65.543116f, 0.874150f,-65.496240f, 0.835078f,-65.504478f, 0.714009f,-65.604905f,
                    0.647529f,-65.545664f, 0.668961f,-65.529746f, 0.689212f,-65.444985f, 0.753059f,-65.417190f, 0.756917f,-65.392132f,
                    0.824145f,-65.411977f, 0.864883f,-65.355922f, 0.935960f,-65.327341f, 0.931863f,-65.304576f, 0.627796f,-65.304576f,
                    0.627796f,-66.619944f);
            poly[635] = new TzPolygon(0.931863f,-65.304576f, 0.912741f,-65.198311f, 1.003139f,-65.149040f, 1.015569f,-65.175308f, 1.050778f,-65.156590f,
                    1.121978f,-65.160728f, 1.155616f,-65.106491f, 1.152782f,-65.071857f, 1.111193f,-65.061985f, 1.109051f,-65.013614f,
                    1.164238f,-64.975114f, 1.202878f,-64.974445f, 1.218630f,-64.922581f, 1.251532f,-64.904386f, 1.227132f,-64.869656f,
                    1.272313f,-64.856395f, 1.315271f,-64.800533f, 1.263669f,-64.786377f, 1.225695f,-64.744461f, 1.284620f,-64.694983f,
                    1.340406f,-64.578896f, 1.377408f,-64.578593f, 1.443222f,-64.526079f, 1.470064f,-64.435855f, 1.529006f,-64.393901f,
                    1.529209f,-64.351112f, 1.495083f,-64.347774f, 1.403010f,-64.410191f, 1.388532f,-64.356572f, 1.361619f,-64.337527f,
                    1.456166f,-64.313597f, 1.502218f,-64.260607f, 1.520713f,-64.197073f, 1.573374f,-64.172984f, 1.578509f,-64.125929f,
                    1.624807f,-64.091502f, 1.624807f,-63.989208f, 0.627796f,-63.989208f, 0.627796f,-65.304576f);
            poly[636] = new TzPolygon(2.621818f,-64.005575f, 2.621818f,-63.989208f, 2.474252f,-63.989208f, 2.478498f,-64.001457f, 2.461232f,-64.017998f,
                    2.496452f,-64.056427f, 2.572773f,-64.044083f);
            poly[637] = new TzPolygon(1.624807f,-64.091502f, 1.649020f,-64.073497f, 1.703084f,-64.061182f, 1.756558f,-64.079629f, 1.822586f,-64.049933f,
                    1.852356f,-64.069413f, 1.924849f,-64.061159f, 1.982990f,-63.991577f, 1.983235f,-63.989208f, 1.624807f,-63.989208f);
            poly[638] = new TzPolygon(2.621818f,-64.005575f, 2.642662f,-63.989208f, 2.621818f,-63.989208f);
            poly[639] = new TzPolygon(2.661162f,-63.989208f, 2.707019f,-64.001671f, 2.716763f,-63.989208f);
            poly[640] = new TzPolygon(2.729521f,-63.989208f, 2.737009f,-64.000634f, 2.810795f,-64.014519f, 2.872615f,-64.077088f, 2.921416f,-64.071556f,
                    2.990477f,-64.123489f, 2.982431f,-64.157540f, 3.034593f,-64.145917f, 3.123560f,-64.226417f, 3.201207f,-64.197945f,
                    3.430363f,-64.244400f, 3.506585f,-64.178619f, 3.568408f,-64.174370f, 3.670885f,-64.269570f, 3.709279f,-64.280998f,
                    3.783569f,-64.416146f, 3.788714f,-64.470924f, 3.857134f,-64.543565f, 3.918042f,-64.572939f, 3.980677f,-64.648101f,
                    4.117745f,-64.722389f, 4.174225f,-64.802033f, 4.235124f,-64.819365f, 4.270475f,-64.811229f, 4.287000f,-64.780000f,
                    4.253229f,-64.695220f, 4.135000f,-64.623000f, 4.105295f,-64.556502f, 4.144000f,-64.289000f, 4.116000f,-64.218000f,
                    4.127000f,-64.164000f, 4.092000f,-64.112000f, 3.950000f,-64.050000f, 3.933000f,-64.001000f, 3.912284f,-63.989208f);
            poly[641] = new TzPolygon(1.460506f,-62.673840f, 1.489000f,-62.720000f, 1.530000f,-62.736000f, 1.592000f,-62.805000f, 1.624807f,-62.797429f,
                    1.624807f,-62.673840f);
            poly[642] = new TzPolygon(2.181656f,-63.331524f, 2.197000f,-63.359000f, 2.226424f,-63.387432f, 2.269454f,-63.367336f, 2.350475f,-63.384354f,
                    2.376965f,-63.363266f, 2.410748f,-63.370765f, 2.451019f,-63.421234f, 2.396839f,-63.460358f, 2.430556f,-63.494709f,
                    2.418073f,-63.557991f, 2.445727f,-63.563976f, 2.439943f,-63.768047f, 2.477101f,-63.797341f, 2.491598f,-63.843575f,
                    2.454598f,-63.932503f, 2.474252f,-63.989208f, 2.621818f,-63.989208f, 2.621818f,-63.331524f);
            poly[643] = new TzPolygon(1.983235f,-63.989208f, 1.993044f,-63.894188f, 1.966443f,-63.835555f, 1.995643f,-63.821943f, 1.979750f,-63.790947f,
                    2.000405f,-63.741867f, 2.049404f,-63.699535f, 2.018614f,-63.665009f, 2.065108f,-63.663867f, 2.073436f,-63.635837f,
                    2.112221f,-63.626795f, 2.140846f,-63.546560f, 2.111508f,-63.511129f, 2.141322f,-63.473962f, 2.125998f,-63.440594f,
                    2.150706f,-63.400852f, 2.197183f,-63.404118f, 2.212712f,-63.378949f, 2.183992f,-63.331524f, 1.624807f,-63.331524f,
                    1.624807f,-63.989208f);
            poly[644] = new TzPolygon(2.183992f,-63.331524f, 2.154000f,-63.282000f, 2.182000f,-63.194000f, 2.173000f,-63.141000f, 2.080000f,-63.107000f,
                    2.015000f,-63.023000f, 2.031000f,-62.948000f, 2.017000f,-62.838000f, 1.954000f,-62.719000f, 1.912000f,-62.698000f,
                    1.819000f,-62.731000f, 1.713000f,-62.723000f, 1.631000f,-62.796000f, 1.624807f,-62.797429f, 1.624807f,-63.331524f);
            poly[645] = new TzPolygon(1.460506f,-62.673840f, 1.439000f,-62.639000f, 1.089000f,-62.529000f, 1.087000f,-62.471000f, 1.028000f,-62.477000f,
                    0.959000f,-62.442000f, 0.867000f,-62.486000f, 0.786000f,-62.457000f, 0.691000f,-62.535000f, 0.627796f,-62.524958f,
                    0.627796f,-62.673840f);
            poly[646] = new TzPolygon(3.618829f,-62.997578f, 3.618829f,-62.953170f, 3.608000f,-62.960000f, 3.612000f,-62.990000f);
            poly[647] = new TzPolygon(2.729521f,-63.989208f, 2.723703f,-63.980331f, 2.716763f,-63.989208f);
            poly[648] = new TzPolygon(2.661162f,-63.989208f, 2.647419f,-63.985473f, 2.642662f,-63.989208f);
            poly[649] = new TzPolygon(3.618829f,-62.997578f, 3.694000f,-63.081000f, 3.748000f,-63.059000f, 3.794000f,-63.103000f, 3.812000f,-63.204000f,
                    3.836000f,-63.226000f, 3.882000f,-63.233000f, 3.952000f,-63.204000f, 3.956000f,-63.280000f, 3.982000f,-63.311000f,
                    3.961000f,-63.312000f, 3.957000f,-63.338000f, 3.977000f,-63.428000f, 3.956000f,-63.452000f, 3.912000f,-63.411000f,
                    3.865000f,-63.434000f, 3.874000f,-63.489000f, 3.840000f,-63.497000f, 3.865000f,-63.551000f, 3.891000f,-63.554000f,
                    3.886000f,-63.591000f, 3.929000f,-63.592000f, 4.019000f,-63.676000f, 3.950000f,-63.700000f, 3.922000f,-63.663000f,
                    3.908000f,-63.682000f, 3.915000f,-63.738000f, 3.941000f,-63.755000f, 3.950000f,-63.850000f, 3.925000f,-63.928000f,
                    3.868000f,-63.964000f, 3.912284f,-63.989208f, 4.615840f,-63.989208f, 4.615840f,-62.673840f, 4.043097f,-62.673840f,
                    4.032000f,-62.753000f, 4.007000f,-62.768000f, 3.975000f,-62.743000f, 3.930000f,-62.786000f, 3.894000f,-62.788000f,
                    3.850000f,-62.753000f, 3.834000f,-62.771000f, 3.805000f,-62.729000f, 3.674000f,-62.743000f, 3.739000f,-62.835000f,
                    3.673000f,-62.919000f, 3.618829f,-62.953170f);
            poly[650] = new TzPolygon(4.424350f,-61.358472f, 4.439000f,-61.448000f, 4.406000f,-61.513000f, 4.342000f,-61.527000f, 4.322000f,-61.508000f,
                    4.252000f,-61.560000f, 4.261000f,-61.608000f, 4.238000f,-61.642000f, 4.263000f,-61.670000f, 4.245000f,-61.725000f,
                    4.270000f,-61.724000f, 4.250000f,-61.774000f, 4.232000f,-61.764000f, 4.229000f,-61.802000f, 4.164000f,-61.824000f,
                    4.161264f,-61.922128f, 4.120087f,-61.931749f, 4.181000f,-61.982000f, 4.150000f,-62.029000f, 4.154000f,-62.076000f,
                    4.126000f,-62.071000f, 4.118000f,-62.117000f, 4.088000f,-62.114000f, 4.077683f,-62.143085f, 4.130000f,-62.252000f,
                    4.135000f,-62.329000f, 4.178000f,-62.389000f, 4.178000f,-62.462000f, 4.139000f,-62.465000f, 4.137000f,-62.531000f,
                    4.118000f,-62.523000f, 4.109000f,-62.552000f, 4.081000f,-62.558000f, 4.046000f,-62.533000f, 4.037000f,-62.562000f,
                    4.019000f,-62.555000f, 4.047000f,-62.646000f, 4.043097f,-62.673840f, 4.615840f,-62.673840f, 4.615840f,-61.358472f);
            poly[651] = new TzPolygon(5.906735f,-61.358472f, 5.970795f,-61.414905f, 5.968886f,-61.358472f);
            poly[652] = new TzPolygon(1.624807f,-59.471719f, 1.624807f,-58.727736f, 1.225498f,-58.727736f, 1.199901f,-58.739558f, 1.171002f,-58.821226f,
                    1.239000f,-58.912000f, 1.261000f,-58.886000f, 1.290000f,-58.922000f, 1.317000f,-58.918000f, 1.302000f,-58.978000f,
                    1.327000f,-58.993000f, 1.323000f,-59.048000f, 1.389000f,-59.253000f, 1.411000f,-59.282000f, 1.450000f,-59.284000f,
                    1.464000f,-59.327000f, 1.514000f,-59.329000f, 1.507000f,-59.381000f, 1.556000f,-59.396000f, 1.567000f,-59.431000f,
                    1.620000f,-59.447000f);
            poly[653] = new TzPolygon(0.627796f,-58.896108f, 1.227222f,-58.895278f, 1.171002f,-58.821226f, 1.199901f,-58.739558f, 1.225498f,-58.727736f,
                    0.627796f,-58.727736f);
            poly[654] = new TzPolygon(1.624807f,-59.471719f, 1.627000f,-59.483000f, 1.674000f,-59.493000f, 1.669000f,-59.511000f, 1.723000f,-59.539000f,
                    1.736000f,-59.566000f, 1.716000f,-59.617000f, 1.741000f,-59.632000f, 1.757000f,-59.690000f, 1.844000f,-59.649000f,
                    1.871000f,-59.663000f, 1.839000f,-59.677000f, 1.852000f,-59.746000f, 1.901000f,-59.759000f, 2.027253f,-59.720829f,
                    2.069024f,-59.742676f, 2.103465f,-59.721762f, 2.162506f,-59.741968f, 2.276153f,-59.723133f, 2.292947f,-59.741033f,
                    2.283860f,-59.787475f, 2.360148f,-59.871394f, 2.361454f,-59.898170f, 2.480606f,-59.897068f, 2.551856f,-59.938399f,
                    2.569108f,-59.929107f, 2.593102f,-59.972060f, 2.609302f,-59.957947f, 2.621818f,-59.963447f, 2.621818f,-58.727736f,
                    1.624807f,-58.727736f);
            poly[655] = new TzPolygon(4.615840f,-61.358472f, 4.615840f,-60.939428f, 4.587000f,-60.932000f, 4.584000f,-60.956000f, 4.544000f,-60.964000f,
                    4.519000f,-60.994000f, 4.522000f,-61.095000f, 4.480165f,-61.145587f, 4.536000f,-61.217000f, 4.535000f,-61.323000f,
                    4.504000f,-61.322000f, 4.478000f,-61.278000f, 4.458000f,-61.288000f, 4.458000f,-61.313000f, 4.421000f,-61.338000f,
                    4.424350f,-61.358472f);
            poly[656] = new TzPolygon(4.489584f,-60.043104f, 4.493306f,-60.070660f, 4.521072f,-60.064533f, 4.517340f,-60.086478f, 4.533560f,-60.087813f,
                    4.502028f,-60.117787f, 4.517726f,-60.161141f, 4.572475f,-60.157246f, 4.564866f,-60.136429f, 4.605011f,-60.123420f,
                    4.615840f,-60.075142f, 4.615840f,-60.043104f);
            poly[657] = new TzPolygon(2.621818f,-59.963447f, 2.686097f,-59.991696f, 2.834642f,-59.991799f, 2.929589f,-59.984212f, 2.998348f,-59.946973f,
                    3.079086f,-59.956466f, 3.121481f,-59.921639f, 3.112883f,-59.908214f, 3.211569f,-59.908379f, 3.224461f,-59.874551f,
                    3.241465f,-59.888066f, 3.330522f,-59.827869f, 3.352633f,-59.834000f, 3.360666f,-59.804188f, 3.428356f,-59.813131f,
                    3.428754f,-59.841628f, 3.505126f,-59.803358f, 3.563853f,-59.873038f, 3.604489f,-59.850645f, 3.618829f,-59.793717f,
                    3.618829f,-58.727736f, 2.621818f,-58.727736f);
            poly[658] = new TzPolygon(4.489584f,-60.043104f, 4.480105f,-59.972916f, 4.509552f,-59.970943f, 4.500043f,-59.935587f, 4.460430f,-59.909406f,
                    4.487172f,-59.874831f, 4.452403f,-59.861538f, 4.447086f,-59.812241f, 4.465541f,-59.795027f, 4.448072f,-59.794522f,
                    4.376295f,-59.669479f, 4.285869f,-59.731895f, 4.268761f,-59.709454f, 4.233904f,-59.739486f, 4.180764f,-59.730691f,
                    4.131660f,-59.618177f, 4.069432f,-59.654058f, 4.051935f,-59.617841f, 4.007373f,-59.607250f, 4.000591f,-59.579431f,
                    3.968513f,-59.584169f, 3.979132f,-59.544684f, 3.944925f,-59.515301f, 3.885385f,-59.592788f, 3.817196f,-59.577449f,
                    3.814975f,-59.597272f, 3.793864f,-59.596307f, 3.781259f,-59.665547f, 3.702775f,-59.668415f, 3.626282f,-59.764127f,
                    3.618829f,-59.793717f, 3.618829f,-60.043104f);
            poly[659] = new TzPolygon(2.621818f,-57.412368f, 1.911660f,-57.412368f, 1.905976f,-57.433428f, 1.826814f,-57.437760f, 1.786088f,-57.501869f,
                    1.700495f,-57.537597f, 1.682369f,-57.650421f, 1.730931f,-57.705090f, 1.715455f,-57.718397f, 1.729727f,-57.774307f,
                    1.726644f,-57.792257f, 1.685210f,-57.799789f, 1.688899f,-57.844171f, 1.667820f,-57.852056f, 1.680292f,-57.877119f,
                    1.644809f,-57.926757f, 1.658439f,-57.990093f, 1.645678f,-58.002615f, 1.633206f,-57.980311f, 1.572779f,-57.978559f,
                    1.503026f,-58.004228f, 1.525341f,-58.060927f, 1.507337f,-58.069449f, 1.498895f,-58.129425f, 1.560114f,-58.160643f,
                    1.572218f,-58.193035f, 1.546687f,-58.236003f, 1.570732f,-58.262255f, 1.568437f,-58.317139f, 1.597015f,-58.322366f,
                    1.538017f,-58.363087f, 1.526512f,-58.394723f, 1.481573f,-58.371754f, 1.469988f,-58.385587f, 1.462946f,-58.508726f,
                    1.403166f,-58.505113f, 1.371452f,-58.457871f, 1.267963f,-58.496224f, 1.277631f,-58.512890f, 1.257909f,-58.522891f,
                    1.294603f,-58.564559f, 1.262124f,-58.585393f, 1.297324f,-58.694563f, 1.225498f,-58.727736f, 2.621818f,-58.727736f);
            poly[660] = new TzPolygon(2.114745f,-56.754684f, 2.205278f,-56.819451f, 2.265556f,-56.826396f, 2.297222f,-56.884174f, 2.362222f,-56.887507f,
                    2.393056f,-56.932229f, 2.436111f,-56.930007f, 2.465000f,-56.956118f, 2.515000f,-56.950007f, 2.509444f,-56.996674f,
                    2.555278f,-56.996951f, 2.592222f,-57.027229f, 2.621818f,-57.020653f, 2.621818f,-56.754684f);
            poly[661] = new TzPolygon(1.911660f,-57.412368f, 1.923722f,-57.367678f, 1.956381f,-57.369118f, 1.996653f,-57.307117f, 1.937587f,-57.229228f,
                    1.978665f,-57.199895f, 2.026442f,-57.086676f, 1.955966f,-57.063931f, 1.914893f,-57.014207f, 1.902949f,-56.976097f,
                    1.930360f,-56.919708f, 1.899327f,-56.893482f, 1.872539f,-56.798850f, 1.853358f,-56.797930f, 1.894066f,-56.754684f,
                    1.624807f,-56.754684f, 1.624807f,-57.412368f);
            poly[662] = new TzPolygon(2.114745f,-56.754684f, 2.026667f,-56.691674f, 2.023889f,-56.562785f, 1.949182f,-56.468954f, 1.905880f,-56.579760f,
                    1.945878f,-56.621453f, 1.917116f,-56.651043f, 1.925815f,-56.720956f, 1.894066f,-56.754684f);
            poly[663] = new TzPolygon(1.847551f,-56.097000f, 1.850973f,-56.117621f, 1.900481f,-56.170899f, 1.898611f,-56.234460f, 1.878080f,-56.244042f,
                    1.937101f,-56.334934f, 1.928265f,-56.411816f, 2.023889f,-56.562785f, 2.026667f,-56.691674f, 2.114745f,-56.754684f,
                    2.621818f,-56.754684f, 2.621818f,-56.097000f, 2.317191f,-56.097000f, 2.265745f,-56.138873f, 2.249186f,-56.097000f);
            poly[664] = new TzPolygon(2.621818f,-57.020653f, 2.634722f,-57.017785f, 2.637500f,-57.060285f, 2.687500f,-57.065007f, 2.734722f,-57.102785f,
                    2.771667f,-57.090285f, 2.770833f,-57.137785f, 2.826389f,-57.127507f, 2.816111f,-57.182785f, 2.847500f,-57.206118f,
                    2.903056f,-57.223896f, 2.951667f,-57.183618f, 2.960556f,-57.228063f, 3.017222f,-57.228063f, 3.025556f,-57.204729f,
                    3.070000f,-57.215007f, 3.097500f,-57.250840f, 3.141111f,-57.238340f, 3.139722f,-57.285007f, 3.278611f,-57.294729f,
                    3.324444f,-57.278896f, 3.384167f,-57.300007f, 3.358056f,-57.357785f, 3.382778f,-57.421951f, 3.356667f,-57.430285f,
                    3.338333f,-57.473340f, 3.364722f,-57.520563f, 3.341667f,-57.597507f, 3.364167f,-57.650278f, 3.395556f,-57.666389f,
                    3.461389f,-57.636389f, 3.523611f,-57.656389f, 3.559167f,-57.709722f, 3.610278f,-57.734444f, 3.669167f,-57.838611f,
                    3.809444f,-57.876111f, 3.906389f,-57.943333f, 3.998056f,-58.043333f, 4.159444f,-58.070833f, 4.288056f,-57.953611f,
                    4.403333f,-57.958611f, 4.615840f,-57.855057f, 4.615840f,-56.097000f, 2.621818f,-56.097000f);
            poly[665] = new TzPolygon(5.612851f,-61.358472f, 5.612851f,-61.103245f, 5.187423f,-60.732828f, 5.189000f,-60.680000f, 5.115000f,-60.656000f,
                    5.118000f,-60.642000f, 5.057000f,-60.644000f, 4.956000f,-60.584000f, 4.774000f,-60.726000f, 4.749000f,-60.806000f,
                    4.704000f,-60.852000f, 4.704000f,-60.911000f, 4.665000f,-60.917000f, 4.653000f,-60.949000f, 4.615840f,-60.939428f,
                    4.615840f,-61.358472f);
            poly[666] = new TzPolygon(4.615840f,-60.075142f, 4.616881f,-60.070500f, 4.655482f,-60.075425f, 4.688334f,-60.043104f, 4.615840f,-60.043104f);
            poly[667] = new TzPolygon(5.113468f,-60.043104f, 5.140000f,-60.094000f, 5.249000f,-60.135000f, 5.227000f,-60.172000f, 5.239150f,-60.193167f,
                    5.270477f,-60.179332f, 5.283457f,-60.208247f, 5.208000f,-60.319000f, 5.222000f,-60.384000f, 5.182000f,-60.434000f,
                    5.203000f,-60.451000f, 5.196000f,-60.569000f, 5.231000f,-60.652000f, 5.201898f,-60.737554f, 5.612851f,-61.099578f,
                    5.612851f,-60.043104f);
            poly[668] = new TzPolygon(5.612851f,-60.043104f, 5.612851f,-61.099578f, 5.906735f,-61.358472f, 5.968868f,-61.357940f, 6.109637f,-61.269881f,
                    6.126312f,-61.231619f, 6.111978f,-61.209290f, 6.187074f,-61.179252f, 6.176566f,-61.138135f, 6.193698f,-61.124543f,
                    6.216256f,-61.142361f, 6.271364f,-61.114036f, 6.271478f,-61.136250f, 6.330127f,-61.184163f, 6.429151f,-61.143160f,
                    6.464443f,-61.152354f, 6.471753f,-61.182564f, 6.519451f,-61.172420f, 6.537371f,-61.196469f, 6.525839f,-61.222189f,
                    6.549317f,-61.209746f, 6.570472f,-61.231959f, 6.609862f,-61.207568f, 6.609862f,-60.043104f);
            poly[669] = new TzPolygon(5.121578f,-60.043104f, 5.063345f,-59.969842f, 4.801084f,-60.034442f, 4.706496f,-60.025235f, 4.688334f,-60.043104f);
            poly[670] = new TzPolygon(7.606873f,-61.358472f, 7.606873f,-60.629404f, 7.577579f,-60.638868f, 7.578202f,-60.689439f, 7.558105f,-60.687675f,
                    7.538838f,-60.720363f, 7.479065f,-60.697637f, 7.447242f,-60.639214f, 7.418389f,-60.643110f, 7.393565f,-60.607224f,
                    7.314277f,-60.588135f, 7.245995f,-60.637953f, 7.125722f,-60.546525f, 7.188799f,-60.501536f, 7.204774f,-60.459505f,
                    7.173308f,-60.409424f, 7.184794f,-60.367115f, 7.133533f,-60.293551f, 7.071217f,-60.289386f, 7.023396f,-60.317861f,
                    6.997910f,-60.366295f, 6.941111f,-60.368291f, 6.929940f,-60.380253f, 6.950662f,-60.408802f, 6.859000f,-60.548259f,
                    6.829960f,-60.663613f, 6.755505f,-60.718501f, 6.794204f,-60.809728f, 6.782302f,-60.853540f, 6.816601f,-60.913886f,
                    6.789455f,-60.925577f, 6.755681f,-60.900600f, 6.719501f,-60.946184f, 6.729470f,-61.075910f, 6.703515f,-61.087913f,
                    6.721511f,-61.138434f, 6.609862f,-61.207568f, 6.609862f,-61.358472f);
            poly[671] = new TzPolygon(7.606873f,-60.629404f, 7.642679f,-60.617837f, 7.631478f,-60.590323f, 7.673901f,-60.593377f, 7.705602f,-60.568138f,
                    7.734219f,-60.583635f, 7.795094f,-60.532231f, 7.815728f,-60.540174f, 7.838321f,-60.466966f, 7.820792f,-60.404816f,
                    7.839812f,-60.379498f, 7.831281f,-60.348252f, 7.910702f,-60.247768f, 7.957744f,-60.219113f, 7.989915f,-60.140796f,
                    8.028875f,-60.121934f, 8.032776f,-60.043104f, 7.606873f,-60.043104f);
            poly[672] = new TzPolygon(8.603884f,-59.773739f, 8.528377f,-59.986725f, 8.300833f,-59.809167f, 8.275000f,-59.801389f, 8.236111f,-59.825556f,
                    8.213463f,-59.946031f, 8.158201f,-59.993405f, 8.132711f,-59.980625f, 8.033331f,-60.031897f, 8.032776f,-60.043104f,
                    8.603884f,-60.043104f);
            poly[673] = new TzPolygon(4.615840f,-57.855057f, 4.643889f,-57.841389f, 4.764722f,-57.884444f, 4.805000f,-57.926389f, 4.924444f,-57.843889f,
                    4.925278f,-57.766667f, 4.964167f,-57.749444f, 5.011944f,-57.682500f, 4.991944f,-57.607778f, 5.014800f,-57.532020f,
                    4.990503f,-57.475431f, 4.991430f,-57.414780f, 5.037302f,-57.329364f, 5.016247f,-57.290717f, 5.072050f,-57.326120f,
                    5.174420f,-57.298400f, 5.187330f,-57.253920f, 5.134100f,-57.223040f, 5.164670f,-57.183960f, 5.262110f,-57.226940f,
                    5.269060f,-57.264490f, 5.229880f,-57.251100f, 5.222130f,-57.276560f, 5.252485f,-57.296625f, 5.321587f,-57.291879f,
                    5.310301f,-57.329199f, 5.325376f,-57.341382f, 5.390490f,-57.274320f, 5.481500f,-57.264330f, 5.550620f,-57.199000f,
                    5.623860f,-57.165060f, 5.699400f,-57.160320f, 5.743740f,-57.183490f, 5.895350f,-57.135010f, 6.051360f,-57.162573f,
                    6.084519f,-57.078722f, 6.225000f,-57.014948f, 6.197000f,-56.999074f, 6.172000f,-56.814039f, 6.175000f,-56.621948f,
                    6.114000f,-56.485443f, 6.040202f,-56.097000f, 4.615840f,-56.097000f);
            poly[674] = new TzPolygon(-9.893535f,-71.171189f, -9.969890f,-71.220414f, -9.963139f,-71.253107f, -9.992411f,-71.298085f, -9.966986f,-71.342658f,
                    -10.000447f,-71.377955f, -10.000447f,-72.181027f, -9.966337f,-72.149987f, -9.930934f,-72.174337f, -9.893535f,-72.148719f);
            poly[675] = new TzPolygon(-11.792956f,-71.171189f, -11.792956f,-69.045107f, -11.912991f,-68.970408f, -12.050486f,-68.895567f, -13.436012f,-68.895567f,
                    -13.437068f,-68.905998f, -13.461260f,-68.896076f, -13.525328f,-68.919338f, -13.522282f,-68.940827f, -13.604400f,-68.952473f,
                    -13.624119f,-69.005045f, -13.651779f,-68.994666f, -13.640283f,-69.037215f, -13.673305f,-69.066973f, -13.692378f,-69.055115f,
                    -13.692378f,-71.171189f);
            poly[676] = new TzPolygon(-11.792956f,-68.895567f, -11.792956f,-69.045025f, -10.945535f,-69.571811f, -10.936061f,-69.501293f, -10.954960f,-69.478218f,
                    -10.925411f,-69.417032f, -10.956595f,-69.374900f, -10.936109f,-69.354269f, -10.954965f,-69.274481f, -10.939780f,-69.233539f,
                    -10.958306f,-69.215522f, -10.954668f,-69.152192f, -10.981331f,-69.121091f, -10.976506f,-69.038752f, -11.011387f,-68.992406f,
                    -10.989628f,-68.952953f, -11.012023f,-68.947901f, -11.022079f,-68.910738f, -11.017936f,-68.895567f);
            poly[677] = new TzPolygon(-9.893535f,-70.623237f, -10.999821f,-70.621025f, -10.934652f,-70.530334f, -10.996571f,-70.452647f, -11.039102f,-70.437674f,
                    -11.070776f,-70.308595f, -11.042771f,-70.158254f, -10.985336f,-70.092229f, -10.993700f,-70.064460f, -10.921232f,-69.933490f,
                    -10.930320f,-69.769138f, -10.975219f,-69.739438f, -10.976892f,-69.715094f, -10.942590f,-69.574303f, -11.792956f,-69.045107f,
                    -11.792956f,-71.171189f, -9.893535f,-71.171189f);
            poly[678] = new TzPolygon(-12.050486f,-68.895567f, -12.497969f,-68.651991f, -12.533810f,-68.655077f, -12.522822f,-68.683331f, -12.552034f,-68.674421f,
                    -12.634311f,-68.741917f, -12.680656f,-68.712658f, -12.693365f,-68.736138f, -12.712466f,-68.728794f, -12.756566f,-68.803953f,
                    -12.808618f,-68.807631f, -12.823897f,-68.839373f, -12.857839f,-68.834799f, -12.870592f,-68.870701f, -12.947768f,-68.860212f,
                    -12.940760f,-68.878171f, -12.957629f,-68.882162f, -12.981303f,-68.861675f, -12.988866f,-68.879776f, -13.046449f,-68.848919f,
                    -13.047595f,-68.863877f, -13.113288f,-68.859242f, -13.136203f,-68.878020f, -13.150525f,-68.858089f, -13.181356f,-68.872132f,
                    -13.246693f,-68.845287f, -13.329378f,-68.878788f, -13.359242f,-68.868797f, -13.383186f,-68.891678f, -13.435396f,-68.889486f,
                    -13.436012f,-68.895567f);
            poly[679] = new TzPolygon(-11.017936f,-68.895567f, -10.989867f,-68.792765f, -11.014583f,-68.788831f, -10.998151f,-68.780276f, -11.009527f,-68.747675f,
                    -11.066239f,-68.766218f, -11.109409f,-68.722234f, -11.146802f,-68.716798f, -11.108874f,-68.544474f, -11.036712f,-68.436482f,
                    -11.056709f,-68.402229f, -11.020733f,-68.385525f, -11.015862f,-68.331872f, -10.961179f,-68.236716f, -10.859659f,-68.195758f,
                    -10.776926f,-68.103738f, -10.715023f,-68.105227f, -10.655779f,-68.033002f, -10.640681f,-67.864593f, -10.710828f,-67.708251f,
                    -10.605166f,-67.675718f, -10.615549f,-67.658637f, -10.598069f,-67.640275f, -10.502796f,-67.579247f, -10.454920f,-67.443611f,
                    -10.427200f,-67.413252f, -10.373864f,-67.407166f, -10.393682f,-67.355283f, -10.376375f,-67.311168f, -10.319971f,-67.316745f,
                    -10.332934f,-67.265323f, -10.315086f,-67.224393f, -10.339232f,-67.177450f, -10.316553f,-67.129032f, -10.290478f,-67.126105f,
                    -10.258725f,-67.015759f, -10.221624f,-66.988812f, -10.199018f,-66.996851f, -10.188858f,-66.952801f, -10.082680f,-66.875097f,
                    -10.083996f,-66.837600f, -9.999258f,-66.763564f, -9.967507f,-66.675414f, -9.936871f,-66.662925f, -9.950054f,-66.637146f,
                    -9.893535f,-66.619944f, -11.792956f,-66.619944f, -11.792956f,-68.895567f);
            poly[680] = new TzPolygon(-9.411841f,-72.982482f, -9.411396f,-73.200439f, -9.363223f,-73.188760f, -9.354101f,-73.148366f, -9.318317f,-73.131406f,
                    -9.308117f,-73.101434f, -9.275348f,-73.107328f, -9.234607f,-73.073518f, -9.222365f,-73.009298f, -9.195447f,-73.003343f,
                    -9.177857f,-73.026124f, -9.155477f,-72.982482f);
            poly[681] = new TzPolygon(-8.951741f,-72.982482f, -8.917781f,-72.999307f, -8.905774f,-73.058886f, -8.698298f,-73.167241f, -8.690216f,-73.255472f,
                    -8.681076f,-73.262825f, -8.681076f,-72.982482f);
            poly[682] = new TzPolygon(-8.681076f,-72.982482f, -8.681076f,-73.262825f, -8.610906f,-73.319275f, -8.616784f,-73.341042f, -8.474035f,-73.331831f,
                    -8.470240f,-73.388115f, -8.431291f,-73.406715f, -8.350223f,-73.541908f, -8.270786f,-73.526262f, -8.240861f,-73.587386f,
                    -8.223660f,-73.571412f, -8.164561f,-73.595695f, -8.128678f,-73.584471f, -8.057460f,-73.626253f, -8.034250f,-73.616851f,
                    -8.006529f,-73.639248f, -8.013148f,-73.668023f, -7.954732f,-73.705605f, -7.965846f,-73.726783f, -7.909164f,-73.772256f,
                    -7.860600f,-73.761543f, -7.878811f,-73.735451f, -7.859643f,-73.679223f, -7.781441f,-73.678747f, -7.742386f,-73.714799f,
                    -7.715760f,-73.819818f, -7.666871f,-73.839180f, -7.676240f,-73.866539f, -7.640228f,-73.900459f, -7.603553f,-73.889023f,
                    -7.561471f,-73.978568f, -7.534734f,-73.983062f, -7.533434f,-73.941711f, -7.472988f,-73.909759f, -7.468617f,-73.911326f,
                    -7.468617f,-72.982482f);
            poly[683] = new TzPolygon(-7.715415f,-71.174515f, -7.552000f,-72.584719f, -7.468617f,-72.815278f, -7.468617f,-71.174515f);
            poly[684] = new TzPolygon(-8.951741f,-72.982482f, -8.981013f,-72.967980f, -8.984940f,-72.940911f, -9.012099f,-72.963071f, -9.093248f,-72.939994f,
                    -9.143024f,-72.958197f, -9.155477f,-72.982482f);
            poly[685] = new TzPolygon(-9.409531f,-72.982482f, -9.412383f,-72.717037f, -9.439365f,-72.695146f, -9.455868f,-72.576780f, -9.491281f,-72.519535f,
                    -9.477154f,-72.407492f, -9.494598f,-72.356876f, -9.543794f,-72.318586f, -9.539953f,-72.282898f, -9.603158f,-72.288209f,
                    -9.616334f,-72.252818f, -9.750855f,-72.262955f, -9.797416f,-72.151361f, -9.830402f,-72.162833f, -9.874872f,-72.135935f,
                    -9.893535f,-72.148719f, -9.893535f,-72.982482f);
            poly[686] = new TzPolygon(-7.408148f,-72.982482f, -7.113061f,-73.798420f, -7.046760f,-73.757100f, -6.977730f,-73.761280f, -6.964160f,-73.743890f,
                    -6.935830f,-73.760790f, -6.754150f,-73.638260f, -6.722033f,-73.561792f, -6.676141f,-73.521927f, -6.635760f,-73.379917f,
                    -6.593267f,-73.352809f, -6.588843f,-73.227413f, -6.564429f,-73.221791f, -6.577113f,-73.206692f, -6.545779f,-73.181677f,
                    -6.523016f,-73.187967f, -6.531325f,-73.163387f, -6.510461f,-73.135226f, -6.406664f,-73.104726f, -6.380259f,-73.135576f,
                    -6.276668f,-73.160705f, -6.219577f,-73.220285f, -6.183181f,-73.216272f, -6.149625f,-73.246638f, -6.043992f,-73.238213f,
                    -6.005125f,-73.186802f, -5.944716f,-73.186950f, -5.867960f,-73.152068f, -5.864329f,-73.117020f, -5.833184f,-73.114216f,
                    -5.795170f,-73.053029f, -5.733411f,-73.027531f, -5.728522f,-73.000465f, -5.661276f,-72.985570f, -5.660764f,-72.982482f);
            poly[687] = new TzPolygon(-7.468617f,-73.911326f, -7.357483f,-73.951172f, -7.389247f,-73.863548f, -7.354310f,-73.853662f, -7.338618f,-73.821097f,
                    -7.336904f,-73.761626f, -7.353786f,-73.754640f, -7.322462f,-73.700394f, -7.227558f,-73.716619f, -7.206423f,-73.752076f,
                    -7.113061f,-73.798420f, -7.408148f,-72.982482f, -7.468617f,-72.982482f);
            poly[688] = new TzPolygon(-5.043700f,-72.618503f, -5.051804f,-72.621198f, -5.051993f,-72.727648f, -5.088593f,-72.739860f, -5.076617f,-72.756367f,
                    -5.113442f,-72.785947f, -5.102776f,-72.818312f, -5.139117f,-72.815473f, -5.136013f,-72.850853f, -5.164011f,-72.887570f,
                    -5.179063f,-72.869027f, -5.271167f,-72.860525f, -5.466129f,-72.958885f, -5.521978f,-72.960594f, -5.541280f,-72.938574f,
                    -5.612911f,-72.973678f, -5.656891f,-72.959116f, -5.660764f,-72.982482f, -5.043700f,-72.982482f);
            poly[689] = new TzPolygon(-7.408148f,-72.982482f, -7.468617f,-72.815278f, -7.468617f,-72.982482f);
            poly[690] = new TzPolygon(-5.043700f,-69.578418f, -9.541382f,-67.558582f, -9.049000f,-68.647000f, -7.845148f,-70.054979f, -7.715415f,-71.174515f,
                    -5.043700f,-71.174515f);
            poly[691] = new TzPolygon(-9.893535f,-71.171189f, -9.872365f,-71.157541f, -9.815836f,-71.051225f, -9.817209f,-70.993912f, -9.748912f,-70.963367f,
                    -9.741298f,-70.923827f, -9.643235f,-70.836149f, -9.638462f,-70.793319f, -9.604253f,-70.757241f, -9.560426f,-70.750669f,
                    -9.570256f,-70.729797f, -9.525963f,-70.662115f, -9.441795f,-70.596273f, -9.424320f,-70.494616f, -9.463667f,-70.503759f,
                    -9.467837f,-70.523908f, -9.505566f,-70.505061f, -9.490329f,-70.514887f, -9.518518f,-70.528105f, -9.514688f,-70.546001f,
                    -9.536463f,-70.538898f, -9.531469f,-70.567973f, -9.570573f,-70.553318f, -9.568042f,-70.586281f, -9.548644f,-70.590215f,
                    -9.560193f,-70.600832f, -9.640840f,-70.584701f, -9.714978f,-70.525230f, -9.765840f,-70.536629f, -9.820545f,-70.623383f,
                    -9.893535f,-70.623237f);
            poly[692] = new TzPolygon(-9.541382f,-67.558582f, -5.043700f,-69.578418f, -5.043700f,-67.558582f);
            poly[693] = new TzPolygon(-5.043700f,-72.618503f, -4.983427f,-72.598459f, -4.997965f,-72.584674f, -4.955561f,-72.551936f, -4.960019f,-72.522168f,
                    -4.932872f,-72.521159f, -4.950802f,-72.482029f, -4.915688f,-72.451348f, -4.891863f,-72.471133f, -4.900978f,-72.415656f,
                    -4.875994f,-72.421856f, -4.888655f,-72.406110f, -4.871989f,-72.381433f, -4.833670f,-72.389878f, -4.823771f,-72.359661f,
                    -4.805187f,-72.371524f, -4.793564f,-72.339800f, -4.812081f,-72.323540f, -4.780377f,-72.327698f, -4.790807f,-72.307322f,
                    -4.771412f,-72.278864f, -4.798737f,-72.271971f, -4.765845f,-72.256540f, -4.781745f,-72.244328f, -4.747845f,-72.210096f,
                    -4.763333f,-72.193182f, -4.711893f,-72.141173f, -4.733985f,-72.125928f, -4.669055f,-72.081098f, -4.669646f,-72.078499f,
                    -5.043700f,-72.078499f);
            poly[694] = new TzPolygon(-4.399647f,-71.174515f, -4.396812f,-71.185122f, -4.424710f,-71.194220f, -4.379868f,-71.202632f, -4.408622f,-71.226149f,
                    -4.385687f,-71.229754f, -4.385003f,-71.269751f, -4.442167f,-71.277819f, -4.420089f,-71.320906f, -4.462876f,-71.307517f,
                    -4.427278f,-71.350261f, -4.430932f,-71.395505f, -4.470577f,-71.425620f, -4.449698f,-71.432143f, -4.438402f,-71.412402f,
                    -4.428818f,-71.434375f, -4.450211f,-71.436950f, -4.434979f,-71.478663f, -4.458426f,-71.485530f, -4.439087f,-71.507159f,
                    -4.487006f,-71.494284f, -4.464416f,-71.537028f, -4.529275f,-71.596251f, -4.515243f,-71.633502f, -4.468695f,-71.615477f,
                    -4.503948f,-71.650325f, -4.472460f,-71.654788f, -4.502066f,-71.659079f, -4.511649f,-71.708175f, -4.468866f,-71.751090f,
                    -4.504462f,-71.766368f, -4.485295f,-71.796752f, -4.527222f,-71.864215f, -4.516441f,-71.907302f, -4.537473f,-71.885404f,
                    -4.529240f,-71.919000f, -4.608216f,-71.947347f, -4.609404f,-71.994551f, -4.626396f,-71.982021f, -4.645667f,-72.006804f,
                    -4.623288f,-72.043260f, -4.673738f,-72.060487f, -4.669646f,-72.078499f, -3.831241f,-72.078499f, -3.831241f,-71.174515f);
            poly[695] = new TzPolygon(-1.406323f,-73.556708f, -1.406323f,-72.982482f, -2.350880f,-72.982482f, -2.360334f,-73.002868f, -2.313681f,-73.032737f,
                    -2.361020f,-73.058143f, -2.324239f,-73.096201f, -2.327231f,-73.119598f, -2.288982f,-73.115650f, -2.236749f,-73.165279f,
                    -2.189651f,-73.170876f, -2.179995f,-73.128718f, -2.130656f,-73.116508f, -2.093259f,-73.069301f, -2.071816f,-73.113590f,
                    -2.041623f,-73.092132f, -1.991572f,-73.130061f, -1.885846f,-73.108268f, -1.859253f,-73.152385f, -1.805410f,-73.146250f,
                    -1.788564f,-73.194442f, -1.748586f,-73.217788f, -1.802633f,-73.235469f, -1.806408f,-73.256069f, -1.782387f,-73.246627f,
                    -1.777476f,-73.299939f, -1.827512f,-73.315120f, -1.772092f,-73.386703f, -1.790505f,-73.427816f, -1.741894f,-73.454338f,
                    -1.708092f,-73.531585f, -1.639972f,-73.516307f, -1.575345f,-73.457267f, -1.570809f,-73.490333f, -1.483625f,-73.490870f,
                    -1.473274f,-73.524592f, -1.432336f,-73.536049f, -1.428228f,-73.579887f, -1.416935f,-73.552378f);
            poly[696] = new TzPolygon(-1.173431f,-73.886466f, -1.116461f,-73.912072f, -1.131146f,-73.958164f, -1.081770f,-73.964794f, -1.106432f,-73.978420f,
                    -1.098880f,-74.006057f, -1.061496f,-74.026829f, -1.005684f,-74.018074f, -1.053569f,-74.064937f, -0.978803f,-74.272582f,
                    -0.941148f,-74.262176f, -0.899061f,-74.279334f, -0.880733f,-74.320458f, -0.865144f,-74.301540f, -0.880632f,-74.270255f,
                    -0.820764f,-74.243390f, -0.828187f,-74.279471f, -0.779011f,-74.279074f, -0.793354f,-74.312505f, -0.754230f,-74.315735f,
                    -0.758349f,-74.344370f, -0.727968f,-74.375129f, -0.677503f,-74.337879f, -0.653729f,-74.373906f, -0.630128f,-74.359508f,
                    -0.541905f,-74.392301f, -0.559922f,-74.420448f, -0.499335f,-74.422357f, -0.472673f,-74.473673f, -0.487655f,-74.497009f,
                    -0.461907f,-74.497867f, -0.458603f,-74.537143f, -0.407690f,-74.553708f, -0.377606f,-74.616322f, -0.352047f,-74.608074f,
                    -0.374482f,-74.660370f, -0.331104f,-74.679142f, -0.342786f,-74.728383f, -0.296944f,-74.728580f, -0.193865f,-74.790449f,
                    -0.193865f,-73.886466f);
            poly[697] = new TzPolygon(-1.173431f,-73.886466f, -1.229316f,-73.861347f, -1.239441f,-73.783069f, -1.261580f,-73.770195f, -1.200483f,-73.743930f,
                    -1.248366f,-73.726936f, -1.240621f,-73.673925f, -1.267244f,-73.648487f, -1.263779f,-73.619401f, -1.318729f,-73.611065f,
                    -1.326609f,-73.567157f, -1.346173f,-73.581254f, -1.406323f,-73.556708f, -1.406323f,-73.886466f);
            poly[698] = new TzPolygon(-2.350880f,-72.982482f, -2.337008f,-72.952572f, -2.457193f,-72.930932f, -2.434744f,-72.895970f, -2.439674f,-72.857277f,
                    -2.385305f,-72.777111f, -2.427668f,-72.744495f, -2.386411f,-72.711663f, -2.451965f,-72.681166f, -2.358493f,-72.635193f,
                    -2.401084f,-72.566311f, -2.433671f,-72.448551f, -2.414152f,-72.408039f, -2.490781f,-72.368557f, -2.459568f,-72.259208f,
                    -2.432243f,-72.259325f, -2.448763f,-72.216476f, -2.426484f,-72.171379f, -2.479944f,-72.157303f, -2.410003f,-72.128917f,
                    -2.365397f,-72.078499f, -2.618782f,-72.078499f, -2.618782f,-72.982482f);
            poly[699] = new TzPolygon(-2.365397f,-72.078499f, -2.335737f,-72.044975f, -2.370565f,-72.005417f, -2.355801f,-71.944900f, -2.380674f,-71.922409f,
                    -2.316111f,-71.939317f, -2.314149f,-71.887093f, -2.187379f,-71.828935f, -2.204826f,-71.796548f, -2.140985f,-71.734454f,
                    -2.230949f,-71.720944f, -2.199914f,-71.652362f, -2.239037f,-71.599166f, -2.249117f,-71.520206f, -2.354049f,-71.493369f,
                    -2.334144f,-71.479206f, -2.276206f,-71.495101f, -2.279992f,-71.452743f, -2.355119f,-71.391803f, -2.391994f,-71.406910f,
                    -2.410497f,-71.393220f, -2.379474f,-71.353523f, -2.379131f,-71.316616f, -2.336268f,-71.296353f, -2.348429f,-71.275589f,
                    -2.389421f,-71.280910f, -2.336793f,-71.231967f, -2.382218f,-71.176197f, -2.376547f,-71.174515f, -2.618782f,-71.174515f,
                    -2.618782f,-72.078499f);
        }
    }

    private static class Initializer8 {
        private static void init() {
            poly[700] = new TzPolygon(-3.831241f,-70.722524f, -4.182248f,-70.722524f, -4.159443f,-70.759012f, -4.218722f,-70.845805f, -4.230047f,-70.816768f,
                    -4.254721f,-70.831595f, -4.252452f,-70.864474f, -4.279054f,-70.844829f, -4.293282f,-70.877915f, -4.323554f,-70.876647f,
                    -4.359157f,-70.934325f, -4.384318f,-70.935698f, -4.345335f,-70.997411f, -4.386543f,-70.993892f, -4.402118f,-71.037837f,
                    -4.369940f,-71.049510f, -4.397668f,-71.076976f, -4.375075f,-71.079894f, -4.377643f,-71.106158f, -4.411189f,-71.114913f,
                    -4.381579f,-71.144782f, -4.405713f,-71.151820f, -4.399647f,-71.174515f, -3.831241f,-71.174515f);
            poly[701] = new TzPolygon(-3.850772f,-70.270532f, -3.831241f,-70.280274f, -3.831241f,-70.270532f);
            poly[702] = new TzPolygon(-3.831241f,-70.414129f, -3.880750f,-70.514873f, -3.831241f,-70.563175f);
            poly[703] = new TzPolygon(-3.831241f,-70.598734f, -3.843484f,-70.616453f, -3.831241f,-70.633439f);
            poly[704] = new TzPolygon(-4.182248f,-70.722524f, -4.207908f,-70.681467f, -4.145624f,-70.670715f, -4.163278f,-70.652130f, -4.130113f,-70.647931f,
                    -4.126403f,-70.626711f, -4.182852f,-70.632233f, -4.173730f,-70.565433f, -4.211693f,-70.573570f, -4.198921f,-70.552914f,
                    -4.137579f,-70.551982f, -4.148242f,-70.510363f, -4.200981f,-70.504167f, -4.161321f,-70.485349f, -4.176260f,-70.466986f,
                    -4.161929f,-70.433474f, -4.132082f,-70.436507f, -4.133409f,-70.380232f, -4.179968f,-70.338920f, -4.142062f,-70.322808f,
                    -4.165548f,-70.287693f, -4.230233f,-70.278605f, -4.253304f,-70.310002f, -4.287935f,-70.288808f, -4.282352f,-70.270532f,
                    -4.437470f,-70.270532f, -4.437470f,-70.722524f);
            poly[705] = new TzPolygon(-3.850772f,-70.270532f, -3.831241f,-70.270532f, -3.831241f,-69.865871f, -4.231687f,-69.947926f, -4.082699f,-70.061874f,
                    -4.017346f,-70.140324f, -3.930636f,-70.180320f, -3.896726f,-70.247611f);
            poly[706] = new TzPolygon(-4.282352f,-70.270532f, -4.274836f,-70.245930f, -4.296561f,-70.269516f, -4.309799f,-70.256061f, -4.317158f,-70.224486f,
                    -4.298687f,-70.213252f, -4.361791f,-70.191940f, -4.327869f,-70.151365f, -4.306448f,-70.172021f, -4.273079f,-70.155083f,
                    -4.285850f,-70.117489f, -4.254540f,-70.108814f, -4.289969f,-70.093941f, -4.294089f,-70.041889f, -4.314275f,-70.079482f,
                    -4.332400f,-70.043128f, -4.367283f,-70.049590f, -4.372119f,-70.029160f, -4.330904f,-70.011218f, -4.322103f,-69.985673f,
                    -4.347836f,-69.985809f, -4.311148f,-69.951998f, -4.226664f,-69.945336f, -5.043700f,-69.578418f, -5.043700f,-70.270532f);
            poly[707] = new TzPolygon(-5.043700f,-69.366549f, -5.043700f,-69.578418f, -4.226664f,-69.945336f, -3.831241f,-69.874686f, -3.831241f,-69.366549f);
            poly[708] = new TzPolygon(-3.831241f,-70.280274f, -3.823764f,-70.284003f, -3.802059f,-70.354747f, -3.831241f,-70.414129f, -3.831241f,-70.563175f,
                    -3.816565f,-70.577493f, -3.831241f,-70.598734f, -3.831241f,-70.633439f, -3.793988f,-70.685123f, -3.796515f,-70.713192f,
                    -2.757270f,-70.058827f, -2.649478f,-70.084389f, -2.703760f,-70.135544f, -2.690883f,-70.160356f, -2.636548f,-70.165381f,
                    -2.658533f,-70.196160f, -2.645342f,-70.219087f, -2.618782f,-70.226957f, -2.618782f,-69.651572f, -3.686152f,-69.836141f,
                    -3.831241f,-69.865871f);
            poly[709] = new TzPolygon(-3.831241f,-69.366549f, -3.831241f,-69.874686f, -2.618782f,-69.658056f, -2.618782f,-69.366549f);
            poly[710] = new TzPolygon(-2.376547f,-71.174515f, -2.332908f,-71.161577f, -2.338824f,-71.128818f, -2.285882f,-71.132694f, -2.264898f,-71.046077f,
                    -2.306579f,-70.993892f, -2.229297f,-71.020411f, -2.210196f,-71.000842f, -2.255293f,-70.941536f, -2.223825f,-70.898111f,
                    -2.225961f,-70.863430f, -2.294655f,-70.832486f, -2.297831f,-70.767814f, -2.328755f,-70.750527f, -2.354964f,-70.663394f,
                    -2.405389f,-70.677332f, -2.395762f,-70.627168f, -2.474660f,-70.631687f, -2.472088f,-70.557701f, -2.448946f,-70.553166f,
                    -2.421737f,-70.597764f, -2.418407f,-70.570404f, -2.476375f,-70.508606f, -2.454072f,-70.471916f, -2.524110f,-70.432971f,
                    -2.491761f,-70.367958f, -2.501497f,-70.302945f, -2.520656f,-70.295093f, -2.542641f,-70.348171f, -2.568081f,-70.353510f,
                    -2.577189f,-70.314565f, -2.552063f,-70.246726f, -2.618782f,-70.224282f, -2.618782f,-71.174515f);
            poly[711] = new TzPolygon(-2.618782f,-69.658056f, -1.491186f,-69.456589f, -1.454204f,-69.432630f, -1.406323f,-69.435648f, -1.406323f,-69.366549f,
                    -2.618782f,-69.366549f);
            poly[712] = new TzPolygon(-1.406323f,-69.435648f, -1.400921f,-69.435989f, -1.365080f,-69.397303f, -1.227562f,-69.430557f, -1.125548f,-69.395234f,
                    -1.071399f,-69.432867f, -1.043847f,-69.418584f, -1.024110f,-69.444890f, -0.998273f,-69.418606f, -0.993870f,-69.458816f,
                    -0.957450f,-69.471154f, -0.925137f,-69.527995f, -0.867949f,-69.525818f, -0.839166f,-69.572676f, -0.806730f,-69.564087f,
                    -0.746671f,-69.624907f, -0.636925f,-69.561785f, -0.595312f,-69.602974f, -0.561210f,-69.591131f, -0.534324f,-69.613651f,
                    -0.500798f,-69.607832f, -0.375686f,-69.828161f, -0.337321f,-69.844601f, -0.325734f,-69.920535f, -0.193865f,-70.039716f,
                    -0.193865f,-69.366549f, -1.406323f,-69.366549f);
            poly[713] = new TzPolygon(-9.888653f,-66.619944f, -9.814051f,-66.805868f, -9.753091f,-66.775364f, -9.756072f,-66.725390f, -9.673151f,-66.619944f);
            poly[714] = new TzPolygon(-9.541196f,-67.558582f, -9.560000f,-67.517000f, -9.592159f,-67.324086f, -9.893535f,-66.619944f, -9.893535f,-67.558582f);
            poly[715] = new TzPolygon(0.905854f,-70.705196f, 0.905854f,-69.179018f, 0.872042f,-69.135762f, 0.842691f,-69.166146f, 0.767511f,-69.148809f,
                    0.740563f,-69.190007f, 0.644840f,-69.115632f, 0.649818f,-69.194253f, 0.605905f,-69.199748f, 0.603894f,-69.294839f,
                    0.649971f,-69.289139f, 0.626157f,-69.319670f, 0.642779f,-69.336054f, 0.614160f,-69.352767f, 0.712581f,-69.433377f,
                    0.735768f,-69.480024f, 0.702136f,-69.532043f, 0.678919f,-69.535206f, 0.683962f,-69.561559f, 0.654202f,-69.597007f,
                    0.613280f,-69.605289f, 0.667593f,-69.671096f, 0.571624f,-69.802724f, 0.591255f,-69.822683f, 0.576893f,-69.887408f,
                    0.590043f,-69.916320f, 0.552661f,-69.935642f, 0.577818f,-69.977812f, 0.573760f,-70.000136f, 0.544125f,-70.005508f,
                    0.562842f,-70.047046f, -0.189979f,-70.043228f, -0.193865f,-70.039716f, -0.193865f,-70.705196f);
            poly[716] = new TzPolygon(0.905854f,-69.179018f, 0.913236f,-69.188462f, 0.941556f,-69.164602f, 0.972451f,-69.216787f, 0.999741f,-69.197732f,
                    1.056552f,-69.244939f, 1.052433f,-69.287339f, 1.088647f,-69.320298f, 1.087938f,-69.376410f, 1.042650f,-69.423124f,
                    1.073887f,-69.439431f, 1.070798f,-69.561998f, 1.098258f,-69.609891f, 1.069939f,-69.677182f, 1.075060f,-69.703862f,
                    1.118167f,-69.709626f, 1.103407f,-69.773656f, 1.063625f,-69.806272f, 1.072719f,-69.842658f, 1.718929f,-69.839717f,
                    1.692438f,-69.782358f, 1.729548f,-69.745033f, 1.723046f,-69.628558f, 1.776907f,-69.534643f, 1.729351f,-69.391089f,
                    1.729409f,-68.662570f, 0.905854f,-68.662570f);
            poly[717] = new TzPolygon(2.005573f,-68.201985f, 1.956761f,-68.212268f, 1.830840f,-68.285547f, 1.829184f,-68.226881f, 1.770444f,-68.239542f,
                    1.779700f,-68.192071f, 1.766068f,-68.177758f, 1.737491f,-68.193263f, 1.729448f,-68.164499f, 1.729409f,-68.662570f,
                    2.005573f,-68.662570f);
            poly[718] = new TzPolygon(2.005573f,-67.765601f, 1.972597f,-67.813851f, 1.902332f,-67.836638f, 1.862142f,-67.890349f, 1.811652f,-67.901623f,
                    1.891214f,-68.033517f, 1.897741f,-68.090429f, 1.978541f,-68.144166f, 1.976705f,-68.180335f, 2.005573f,-68.188036f);
            poly[719] = new TzPolygon(1.022021f,-66.619944f, 1.228959f,-66.851191f, 1.286597f,-66.881212f, 1.321385f,-66.855383f, 1.369762f,-66.854919f,
                    1.423585f,-66.911048f, 1.530999f,-66.919057f, 1.591217f,-66.963943f, 1.632035f,-66.959682f, 1.786412f,-67.033072f,
                    1.920567f,-67.065320f, 1.976886f,-67.122996f, 2.005573f,-67.113034f, 2.005573f,-66.619944f);
            poly[720] = new TzPolygon(2.005480f,-67.641257f, 2.005265f,-67.352973f, 1.941575f,-67.330830f, 1.841269f,-67.228307f, 1.831497f,-67.153836f,
                    1.675037f,-67.159221f, 1.639863f,-67.127255f, 1.603527f,-67.140431f, 1.454411f,-67.082601f, 1.385457f,-67.080170f,
                    1.320017f,-67.139231f, 1.258288f,-67.099555f, 1.167036f,-67.086753f, 1.228959f,-66.851191f, 1.022021f,-66.619944f,
                    0.905854f,-66.619944f, 0.905854f,-67.641257f);
            poly[721] = new TzPolygon(2.005573f,-67.113034f, 2.051286f,-67.097158f, 2.119304f,-67.108022f, 2.136991f,-67.121726f, 2.132836f,-67.161579f,
                    2.254247f,-67.221971f, 2.350310f,-67.187902f, 2.398596f,-67.221757f, 2.441948f,-67.297092f, 2.522512f,-67.342544f,
                    2.619430f,-67.467627f, 2.663118f,-67.490134f, 2.656898f,-67.563265f, 2.723099f,-67.563176f, 2.811550f,-67.614386f,
                    2.795834f,-67.655755f, 2.837544f,-67.750423f, 2.831265f,-67.815380f, 2.794256f,-67.837145f, 2.789438f,-67.864103f,
                    2.866229f,-67.864331f, 3.105291f,-67.595727f, 3.105291f,-66.619944f, 2.005573f,-66.619944f);
            poly[722] = new TzPolygon(2.005573f,-68.201985f, 2.034791f,-68.195830f, 2.005573f,-68.188036f);
            poly[723] = new TzPolygon(2.005573f,-67.765601f, 2.028504f,-67.732048f, 2.047692f,-67.550949f, 2.163124f,-67.495186f, 2.169604f,-67.449229f,
                    2.221272f,-67.436904f, 2.230110f,-67.400800f, 2.208507f,-67.367659f, 2.156881f,-67.349555f, 2.099980f,-67.358983f,
                    2.063872f,-67.326716f, 2.005573f,-67.352835f);
            poly[724] = new TzPolygon(3.105291f,-67.595727f, 3.248472f,-67.434853f, 3.245540f,-67.382722f, 3.292584f,-67.381603f, 3.377893f,-67.310785f,
                    3.451022f,-67.339150f, 3.479997f,-67.401468f, 3.585236f,-67.444072f, 3.676484f,-67.447957f, 3.767449f,-67.501286f,
                    3.752120f,-67.606820f, 3.785550f,-67.634427f, 4.122886f,-67.733203f, 4.205010f,-67.782280f, 4.205010f,-66.619944f,
                    3.105291f,-66.619944f);
            poly[725] = new TzPolygon(7.100381f,-70.705196f, 7.053014f,-70.918155f, 7.023692f,-70.921564f, 7.016364f,-70.969778f, 6.974293f,-71.022217f,
                    6.989928f,-71.111671f, 7.008627f,-71.103602f, 7.033085f,-71.130990f, 7.011829f,-71.240949f, 7.032726f,-71.264332f,
                    7.015352f,-71.369846f, 7.038959f,-71.424624f, 7.011895f,-71.465137f, 7.035017f,-71.527137f, 7.015544f,-71.588288f,
                    7.055197f,-71.587724f, 7.032467f,-71.705005f, 7.066263f,-71.766985f, 7.062664f,-71.814381f, 7.025662f,-71.834959f,
                    7.009577f,-71.942171f, 7.039104f,-72.047582f, 7.252104f,-72.173822f, 7.326996f,-72.153844f, 7.384214f,-72.196454f,
                    7.375931f,-72.325715f, 7.396781f,-72.353855f, 7.403337f,-72.439423f, 7.461801f,-72.447039f, 7.487851f,-72.475982f,
                    7.559729f,-72.452763f, 7.632628f,-72.476482f, 7.758592f,-72.473818f, 7.857611f,-72.444417f, 7.943689f,-72.487692f,
                    7.995381f,-72.419223f, 8.033886f,-72.416235f, 8.005170f,-72.349250f, 8.080027f,-72.350903f, 8.105806f,-72.373707f,
                    8.157498f,-72.352263f, 8.252426f,-72.393697f, 8.357292f,-72.391599f, 8.603884f,-72.644071f, 8.603884f,-70.705196f);
            poly[726] = new TzPolygon(6.135795f,-68.662570f, 6.152103f,-68.706721f, 6.147410f,-68.792712f, 6.179966f,-68.829880f, 6.167374f,-68.882490f,
                    6.192929f,-69.014164f, 6.221698f,-69.046177f, 6.191071f,-69.123509f, 6.079534f,-69.238609f, 6.088653f,-69.308869f,
                    6.139971f,-69.342134f, 6.107798f,-69.430461f, 6.404447f,-69.664337f, 6.404447f,-68.662570f);
            poly[727] = new TzPolygon(6.135795f,-68.662570f, 6.129146f,-68.644571f, 6.166326f,-68.588469f, 6.148979f,-68.541996f, 6.179067f,-68.510085f,
                    6.187729f,-68.448568f, 6.162990f,-68.306973f, 6.228675f,-68.141854f, 6.227096f,-68.077686f, 6.196109f,-68.027538f,
                    6.236215f,-67.930040f, 6.324304f,-67.810260f, 6.291432f,-67.762033f, 6.291350f,-67.625259f, 6.262523f,-67.586635f,
                    6.266314f,-67.547452f, 6.209354f,-67.466974f, 6.193307f,-67.456846f, 6.130940f,-67.494642f, 5.994295f,-67.410130f,
                    5.904291f,-67.532367f, 5.828245f,-67.597147f, 5.675008f,-67.637930f, 5.565994f,-67.620100f, 5.544089f,-67.598886f,
                    5.475957f,-67.624970f, 5.303958f,-67.849507f, 5.196136f,-67.824443f, 5.135225f,-67.854283f, 5.054005f,-67.805927f,
                    4.943478f,-67.838732f, 4.707233f,-67.817844f, 4.531179f,-67.857593f, 4.486982f,-67.801068f, 4.437064f,-67.797825f,
                    4.418997f,-67.773182f, 4.349345f,-67.761610f, 4.327285f,-67.804012f, 4.229666f,-67.797014f, 4.205010f,-67.782280f,
                    4.205010f,-68.662570f);
            poly[728] = new TzPolygon(7.100381f,-70.705196f, 7.104381f,-70.687214f, 7.068769f,-70.641943f, 7.079320f,-70.556335f, 7.005668f,-70.502337f,
                    7.007284f,-70.431107f, 6.980871f,-70.416671f, 6.980913f,-70.372112f, 6.934568f,-70.322388f, 6.941242f,-70.265846f,
                    6.974720f,-70.224333f, 6.979704f,-70.117865f, 6.404447f,-69.664337f, 6.404447f,-70.705196f);
            poly[729] = new TzPolygon(-13.692378f,-50.805843f, -13.530000f,-50.763000f, -13.442000f,-50.665000f, -13.376000f,-50.665000f, -13.307251f,-50.607191f,
                    -13.217988f,-50.584456f, -13.187212f,-50.604685f, -13.118421f,-50.592583f, -13.118421f,-50.101268f, -13.692378f,-50.101268f);
            poly[730] = new TzPolygon(-12.544463f,-50.468292f, -12.706064f,-50.468292f, -12.710000f,-50.478000f, -12.725828f,-50.468292f, -12.733038f,-50.468292f,
                    -12.744726f,-50.487505f, -12.755740f,-50.468292f, -12.861631f,-50.509999f, -12.829146f,-50.517369f, -12.845080f,-50.534703f,
                    -12.830615f,-50.593800f, -12.798472f,-50.580290f, -12.821762f,-50.623139f, -12.774642f,-50.611026f, -12.775077f,-50.636405f,
                    -12.732780f,-50.623559f, -12.679842f,-50.654099f, -12.653363f,-50.645172f, -12.644985f,-50.684379f, -12.607890f,-50.707507f,
                    -12.586891f,-50.679523f, -12.567997f,-50.689554f, -12.544463f,-50.676937f);
            poly[731] = new TzPolygon(-13.118421f,-50.592583f, -13.112156f,-50.591481f, -13.064000f,-50.611000f, -13.039000f,-50.569000f, -13.002000f,-50.593000f,
                    -12.976000f,-50.525000f, -12.784283f,-50.493323f, -12.755337f,-50.468292f, -13.118421f,-50.468292f);
            poly[732] = new TzPolygon(-12.754846f,-50.468292f, -12.744726f,-50.487505f, -12.733038f,-50.468292f);
            poly[733] = new TzPolygon(-12.725828f,-50.468292f, -12.710000f,-50.478000f, -12.706064f,-50.468292f);
            poly[734] = new TzPolygon(-12.903812f,-50.101268f, -12.897403f,-50.183773f, -12.853795f,-50.231186f, -12.838560f,-50.292882f, -12.798000f,-50.311000f,
                    -12.717862f,-50.283283f, -12.680382f,-50.299023f, -12.682268f,-50.265269f, -12.579000f,-50.238000f, -12.564000f,-50.193000f,
                    -12.544463f,-50.214966f, -12.544463f,-50.101268f);
            poly[735] = new TzPolygon(-12.544463f,-50.364278f, -12.545529f,-50.365971f, -12.611371f,-50.390847f, -12.624000f,-50.418000f, -12.650000f,-50.413000f,
                    -12.652568f,-50.440568f, -12.691635f,-50.432703f, -12.706064f,-50.468292f, -12.544463f,-50.468292f);
            poly[736] = new TzPolygon(-12.725828f,-50.468292f, -12.731079f,-50.465071f, -12.733038f,-50.468292f);
            poly[737] = new TzPolygon(-11.396548f,-50.731113f, -11.444062f,-50.741266f, -11.581178f,-50.717363f, -11.594947f,-50.656029f, -11.671917f,-50.661652f,
                    -11.733760f,-50.724586f, -11.855669f,-50.687458f, -11.886264f,-50.637101f, -11.921628f,-50.666557f, -11.974898f,-50.658634f,
                    -11.990321f,-50.685454f, -12.091635f,-50.668908f, -12.207605f,-50.686814f, -12.222432f,-50.645252f, -12.249838f,-50.654032f,
                    -12.277155f,-50.628237f, -12.302526f,-50.652000f, -12.451132f,-50.619130f, -12.455111f,-50.651143f, -12.478694f,-50.641675f,
                    -12.544463f,-50.676937f, -12.544463f,-51.569364f, -11.396548f,-51.569364f);
            poly[738] = new TzPolygon(-12.544463f,-50.364278f, -12.431000f,-50.184000f, -12.413000f,-50.196000f, -12.423000f,-50.175000f, -12.397384f,-50.148585f,
                    -12.531378f,-50.229678f, -12.544463f,-50.214966f);
            poly[739] = new TzPolygon(-12.903812f,-50.101268f, -11.396548f,-50.101268f, -11.396548f,-48.633171f, -13.031307f,-48.633171f, -12.994000f,-48.675000f,
                    -13.002000f,-48.717000f, -12.921000f,-48.736000f, -12.803221f,-48.870228f, -12.957000f,-48.975000f, -12.907000f,-49.023000f,
                    -12.904000f,-49.077000f, -12.847000f,-49.067000f, -12.836000f,-49.106000f, -12.790000f,-49.121000f, -12.884000f,-49.237000f,
                    -13.103000f,-49.354000f, -13.253000f,-49.340000f, -13.274000f,-49.369000f, -12.964831f,-49.912520f, -12.935833f,-50.039331f,
                    -12.905512f,-50.079382f);
            poly[740] = new TzPolygon(-9.100719f,-51.569364f, -9.100719f,-49.873703f, -9.185186f,-49.910029f, -9.228289f,-49.986131f, -9.308229f,-50.047940f,
                    -9.379342f,-50.048412f, -9.439678f,-50.092159f, -9.577659f,-50.105153f, -9.621562f,-50.138851f, -9.702951f,-50.136405f,
                    -9.744136f,-50.187627f, -9.839025f,-50.207568f, -9.749611f,-51.569364f);
            poly[741] = new TzPolygon(-9.748706f,-51.569364f, -9.839025f,-50.207568f, -9.897629f,-50.265472f, -10.014416f,-50.291609f, -10.069593f,-50.325337f,
                    -10.126163f,-50.388527f, -10.215457f,-50.384970f, -10.354558f,-50.424904f, -10.410928f,-50.475486f, -10.488920f,-50.481633f,
                    -10.498349f,-50.509408f, -10.595520f,-50.532919f, -10.662516f,-50.604279f, -10.731887f,-50.574772f, -10.835137f,-50.619708f,
                    -10.898648f,-50.602726f, -10.932006f,-50.631639f, -11.073347f,-50.607809f, -11.103888f,-50.644832f, -11.159169f,-50.665274f,
                    -11.258700f,-50.660784f, -11.372569f,-50.725989f, -11.396548f,-50.731113f, -11.396548f,-51.569364f);
            poly[742] = new TzPolygon(-13.031307f,-48.633171f, -13.060000f,-48.601000f, -13.123000f,-48.577000f, -13.152000f,-48.596000f, -13.207000f,-48.579000f,
                    -13.238000f,-48.600000f, -13.317000f,-48.586000f, -13.302000f,-48.553000f, -13.205000f,-48.554000f, -13.192000f,-48.530000f,
                    -13.128000f,-48.508000f, -13.134000f,-48.475000f, -13.234814f,-48.475659f, -13.292320f,-48.441832f, -13.271128f,-48.430019f,
                    -13.248304f,-48.340170f, -13.228226f,-48.342154f, -13.236999f,-48.307785f, -13.168814f,-48.230914f, -13.152548f,-48.143361f,
                    -13.186969f,-48.165129f, -13.305000f,-48.165000f, -13.288000f,-48.083000f, -13.235000f,-48.062000f, -13.274000f,-48.032000f,
                    -13.276000f,-47.986000f, -13.315000f,-47.966000f, -13.290000f,-47.935000f, -13.310698f,-47.899123f, -13.692378f,-47.899123f,
                    -13.692378f,-48.633171f);
            poly[743] = new TzPolygon(-13.310698f,-47.899123f, -13.320000f,-47.883000f, -13.311000f,-47.824000f, -13.467000f,-47.679000f, -13.368806f,-47.622118f,
                    -13.349036f,-47.650216f, -13.302845f,-47.661556f, -13.264403f,-47.639744f, -13.210806f,-47.667725f, -13.178216f,-47.654164f,
                    -13.166202f,-47.668819f, -13.149696f,-47.643778f, -13.102477f,-47.633138f, -13.119460f,-47.564005f, -13.185144f,-47.561570f,
                    -13.184793f,-47.478689f, -13.220402f,-47.485932f, -13.233309f,-47.431772f, -13.248632f,-47.454347f, -13.290161f,-47.429135f,
                    -13.228877f,-47.376328f, -13.265073f,-47.281528f, -13.194785f,-47.229772f, -13.187514f,-47.183209f, -13.204812f,-47.183917f,
                    -13.208176f,-47.165075f, -13.692378f,-47.165075f, -13.692378f,-47.899123f);
            poly[744] = new TzPolygon(-13.208176f,-47.165075f, -13.210202f,-47.153726f, -13.177967f,-47.132268f, -13.181853f,-47.087744f, -13.121655f,-47.002117f,
                    -13.131810f,-46.978878f, -13.053000f,-46.892000f, -13.067711f,-46.854772f, -13.002000f,-46.819000f, -12.969000f,-46.750000f,
                    -12.971000f,-46.454000f, -12.879016f,-46.431026f, -13.692378f,-46.431026f, -13.692378f,-47.165075f);
            poly[745] = new TzPolygon(-12.544659f,-46.431026f, -12.544706f,-46.256623f, -12.583927f,-46.286191f, -12.636623f,-46.296309f, -12.652466f,-46.260647f,
                    -12.691911f,-46.296018f, -12.714567f,-46.267086f, -12.783000f,-46.283000f, -12.833092f,-46.268089f, -12.863353f,-46.300430f,
                    -12.949406f,-46.304598f, -12.943699f,-46.216981f, -12.909066f,-46.135060f, -12.921853f,-46.117176f, -12.991000f,-46.364000f,
                    -12.863297f,-46.365778f, -12.822720f,-46.416966f, -12.879016f,-46.431026f);
            poly[746] = new TzPolygon(-12.879016f,-46.431026f, -12.822720f,-46.416966f, -12.863297f,-46.365778f, -12.991000f,-46.364000f, -12.956000f,-46.194000f,
                    -12.917252f,-46.114515f, -12.960931f,-46.126225f, -13.010559f,-46.275942f, -13.094043f,-46.330551f, -13.139390f,-46.299340f,
                    -13.250501f,-46.331131f, -13.255000f,-46.298000f, -13.304257f,-46.315638f, -13.314405f,-46.288966f, -13.347395f,-46.279267f,
                    -13.262093f,-46.066965f, -13.277839f,-46.040892f, -13.375547f,-46.134984f, -13.427123f,-46.241372f, -13.465506f,-46.206111f,
                    -13.481000f,-46.230000f, -13.560361f,-46.236191f, -13.567620f,-46.184156f, -13.592107f,-46.162055f, -13.687374f,-46.261051f,
                    -13.692378f,-46.257237f, -13.692378f,-46.431026f);
            poly[747] = new TzPolygon(-12.544463f,-46.255883f, -12.511466f,-46.155314f, -12.483000f,-46.153000f, -12.500969f,-46.250034f, -12.415971f,-46.269885f,
                    -12.406541f,-46.310777f, -12.379000f,-46.285000f, -12.337000f,-46.352000f, -12.303000f,-46.323000f, -12.289000f,-46.374000f,
                    -12.247000f,-46.380000f, -12.224000f,-46.359000f, -12.193000f,-46.391000f, -12.111000f,-46.366000f, -12.036639f,-46.397316f,
                    -11.958000f,-46.325000f, -11.929000f,-46.192000f, -11.900796f,-46.171040f, -11.883759f,-46.190540f, -11.898000f,-46.318000f,
                    -11.872006f,-46.373243f, -11.836000f,-46.373000f, -11.836032f,-46.349033f, -11.770619f,-46.322708f, -11.751000f,-46.373000f,
                    -11.737000f,-46.329000f, -11.692000f,-46.294000f, -11.629372f,-46.313570f, -11.621000f,-46.256000f, -11.656607f,-46.154109f,
                    -11.636000f,-46.083000f, -11.607222f,-46.114549f, -11.602000f,-46.202000f, -11.567665f,-46.230860f, -11.540957f,-46.305643f,
                    -11.541518f,-46.411000f, -11.516339f,-46.479091f, -11.483052f,-46.520390f, -11.396548f,-46.544406f, -11.396548f,-45.696978f,
                    -12.544463f,-45.696978f);
            poly[748] = new TzPolygon(-11.396548f,-46.544406f, -11.380000f,-46.549000f, -11.347000f,-46.601000f, -11.289000f,-46.617000f, -11.255000f,-46.609000f,
                    -11.191000f,-46.472000f, -10.994000f,-46.399000f, -10.906000f,-46.283000f, -10.867000f,-46.297000f, -10.822576f,-46.281481f,
                    -10.797311f,-46.231065f, -10.768737f,-46.228183f, -10.759787f,-46.256394f, -10.718882f,-46.194125f, -10.658943f,-46.207015f,
                    -10.487598f,-45.845218f, -10.367447f,-45.827029f, -10.346000f,-45.743000f, -10.263000f,-45.697000f, -11.396548f,-45.696978f);
            poly[749] = new TzPolygon(-10.248634f,-45.848099f, -10.248634f,-45.764744f, -10.267000f,-45.793000f);
            poly[750] = new TzPolygon(-10.248634f,-45.929960f, -10.262038f,-46.003648f, -10.248634f,-46.007856f);
            poly[751] = new TzPolygon(-10.072974f,-46.431026f, -10.047000f,-46.457000f, -9.988000f,-46.477000f, -9.877000f,-46.472000f, -9.870000f,-46.491000f,
                    -9.855000f,-46.480000f, -9.801000f,-46.509000f, -9.805000f,-46.577000f, -9.758000f,-46.575000f, -9.733000f,-46.646000f,
                    -9.693000f,-46.653000f, -9.665000f,-46.613000f, -9.587000f,-46.592000f, -9.557000f,-46.536000f, -9.517000f,-46.575000f,
                    -9.484000f,-46.561000f, -9.457000f,-46.640000f, -9.411000f,-46.632000f, -9.392000f,-46.666000f, -9.410000f,-46.761000f,
                    -9.365000f,-46.768000f, -9.304000f,-46.813000f, -9.292000f,-46.847000f, -9.260000f,-46.819000f, -9.194000f,-46.827000f,
                    -9.191000f,-46.850000f, -9.154000f,-46.852000f, -9.122000f,-46.893000f, -9.128000f,-46.931000f, -9.100719f,-46.927536f,
                    -9.100719f,-46.431026f);
            poly[752] = new TzPolygon(-10.248634f,-45.697459f, -10.184369f,-45.699510f, -10.155000f,-45.723000f, -10.144635f,-45.696978f, -10.248634f,-45.696978f);
            poly[753] = new TzPolygon(-10.248634f,-46.007856f, -10.176344f,-46.030550f, -10.213038f,-46.098648f, -10.214038f,-46.164648f, -10.169000f,-46.210000f,
                    -10.183000f,-46.327000f, -10.168000f,-46.367000f, -10.120000f,-46.384000f, -10.072974f,-46.431026f, -9.100719f,-46.431026f,
                    -9.100719f,-45.696978f, -10.146481f,-45.696978f, -10.156000f,-45.726000f, -10.228000f,-45.733000f, -10.248634f,-45.764744f,
                    -10.248634f,-45.848099f, -10.239000f,-45.877000f, -10.248634f,-45.929960f);
            poly[754] = new TzPolygon(-9.100719f,-49.873703f, -9.027000f,-49.842000f, -8.906170f,-49.745053f, -8.856482f,-49.684323f, -8.839499f,-49.592377f,
                    -8.612505f,-49.451439f, -8.580010f,-49.409856f, -8.451000f,-49.374000f, -8.379565f,-49.283292f, -8.175498f,-49.209552f,
                    -8.050561f,-49.174851f, -7.976973f,-49.181999f, -7.807000f,-49.148000f, -7.677804f,-49.328050f, -7.546167f,-49.383926f,
                    -7.497000f,-49.378000f, -7.325000f,-49.231000f, -7.235182f,-49.185257f, -6.925000f,-49.209000f, -6.784000f,-49.018000f,
                    -6.754000f,-48.832000f, -6.678000f,-48.682000f, -6.639963f,-48.651939f, -6.570583f,-48.664336f, -6.507020f,-48.645319f,
                    -6.493425f,-48.633171f, -9.100719f,-48.633171f);
            poly[755] = new TzPolygon(-5.406690f,-48.633171f, -5.352899f,-48.756746f, -5.351000f,-48.708000f, -5.305000f,-48.679000f, -5.324462f,-48.633171f);
            poly[756] = new TzPolygon(-5.324462f,-48.633171f, -5.305000f,-48.679000f, -5.351000f,-48.708000f, -5.349680f,-48.756078f, -5.253833f,-48.633171f);
            poly[757] = new TzPolygon(-7.878427f,-47.165075f, -7.855996f,-47.175725f, -7.816251f,-47.245438f, -7.758117f,-47.246762f, -7.760829f,-47.267205f,
                    -7.730288f,-47.275092f, -7.730635f,-47.314195f, -7.690078f,-47.302592f, -7.666745f,-47.338576f, -7.659538f,-47.315140f,
                    -7.616037f,-47.358027f, -7.624544f,-47.373729f, -7.648132f,-47.353403f, -7.654268f,-47.382371f, -7.568361f,-47.399248f,
                    -7.556380f,-47.439519f, -7.527798f,-47.425125f, -7.518483f,-47.461732f, -7.533825f,-47.475309f, -7.439870f,-47.501588f,
                    -7.439316f,-47.591812f, -7.372367f,-47.487733f, -7.298306f,-47.496660f, -7.267826f,-47.532880f, -7.265102f,-47.588670f,
                    -7.305968f,-47.647722f, -7.249436f,-47.680166f, -7.202985f,-47.747027f, -7.161428f,-47.742392f, -7.142181f,-47.715956f,
                    -7.144396f,-47.643000f, -6.985452f,-47.531935f, -6.907237f,-47.506701f, -6.833442f,-47.529703f, -6.804889f,-47.516896f,
                    -6.804889f,-47.165075f);
            poly[758] = new TzPolygon(-7.878427f,-47.165075f, -7.924883f,-47.143017f, -7.937121f,-47.108279f, -7.990091f,-47.107681f, -7.998242f,-47.067543f,
                    -8.053163f,-47.045541f, -8.066565f,-46.997502f, -8.005942f,-46.953601f, -7.985700f,-46.895493f, -7.955249f,-46.872846f,
                    -7.964359f,-46.830455f, -7.922890f,-46.756394f, -7.896000f,-46.614000f, -7.920000f,-46.562000f, -8.012000f,-46.477000f,
                    -8.074000f,-46.467000f, -8.166000f,-46.514000f, -8.200000f,-46.487000f, -8.270000f,-46.507000f, -8.319000f,-46.543000f,
                    -8.321000f,-46.641000f, -8.351000f,-46.706000f, -8.383000f,-46.726000f, -8.368000f,-46.782000f, -8.399000f,-46.787000f,
                    -8.399000f,-46.806000f, -8.446000f,-46.796000f, -8.476000f,-46.851000f, -8.533000f,-46.846000f, -8.595000f,-46.916000f,
                    -8.601000f,-46.897000f, -8.648000f,-46.916000f, -8.686000f,-46.887000f, -8.726000f,-46.931000f, -8.778000f,-46.904000f,
                    -8.847000f,-46.913000f, -8.880000f,-46.993000f, -8.914000f,-46.970000f, -8.953000f,-47.018000f, -8.988000f,-47.021000f,
                    -8.979000f,-47.035000f, -9.012000f,-47.068000f, -9.026000f,-47.043000f, -9.063000f,-47.068000f, -9.082000f,-47.007000f,
                    -9.065000f,-46.923000f, -9.100719f,-46.927536f, -9.100719f,-47.165075f);
            poly[759] = new TzPolygon(-5.656975f,-48.633171f, -5.656975f,-48.156071f, -5.709958f,-48.173579f, -5.725504f,-48.272526f, -5.751209f,-48.293495f,
                    -5.839441f,-48.290797f, -5.946152f,-48.231613f, -6.004288f,-48.334699f, -6.038282f,-48.332694f, -6.070405f,-48.285771f,
                    -6.116904f,-48.303836f, -6.177306f,-48.431919f, -6.298599f,-48.417104f, -6.328617f,-48.381163f, -6.375638f,-48.381301f,
                    -6.350940f,-48.500196f, -6.453741f,-48.613134f, -6.496713f,-48.633171f);
            poly[760] = new TzPolygon(-6.804889f,-47.516896f, -6.753839f,-47.493998f, -6.661265f,-47.496229f, -6.488004f,-47.417265f, -6.429839f,-47.433230f,
                    -6.266000f,-47.377000f, -6.112000f,-47.433000f, -6.039000f,-47.428000f, -5.993000f,-47.448000f, -5.869000f,-47.431000f,
                    -5.730000f,-47.493000f, -5.662000f,-47.473000f, -5.656975f,-47.473990f, -5.656975f,-47.165075f, -6.804889f,-47.165075f);
            poly[761] = new TzPolygon(-5.656975f,-48.149720f, -5.618144f,-48.132234f, -5.554253f,-48.212586f, -5.523020f,-48.300691f, -5.395996f,-48.381593f,
                    -5.429833f,-48.513886f, -5.422558f,-48.596716f, -5.406690f,-48.633171f, -5.324462f,-48.633171f, -5.336000f,-48.606000f,
                    -5.283000f,-48.568000f, -5.230000f,-48.561000f, -5.193000f,-48.523000f, -5.168000f,-48.363000f, -5.260000f,-48.178000f,
                    -5.275000f,-48.079000f, -5.234000f,-48.004000f, -5.260000f,-47.885000f, -5.376000f,-47.843000f, -5.380000f,-47.744000f,
                    -5.459000f,-47.618000f, -5.465000f,-47.555000f, -5.565000f,-47.483000f, -5.656975f,-47.473518f);
            poly[762] = new TzPolygon(-4.509060f,-47.577612f, -4.557372f,-47.611933f, -4.608632f,-47.679948f, -4.586425f,-47.792559f, -5.070390f,-48.396258f,
                    -5.073671f,-48.440315f, -5.098137f,-48.433519f, -5.253833f,-48.633171f, -4.509060f,-48.633171f);
            poly[763] = new TzPolygon(-5.397041f,-48.633171f, -5.422558f,-48.596716f, -5.429833f,-48.513886f, -5.395996f,-48.381593f, -5.523020f,-48.300691f,
                    -5.602704f,-48.138137f, -5.656975f,-48.156071f, -5.656975f,-48.633171f);
            poly[764] = new TzPolygon(-4.509060f,-47.577612f, -4.403721f,-47.502780f, -4.315058f,-47.474727f, -4.245600f,-47.371761f, -4.048590f,-47.320411f,
                    -4.058926f,-47.304202f, -3.997500f,-47.240367f, -3.983435f,-47.188670f, -3.923936f,-47.172673f, -3.918023f,-47.165075f,
                    -4.509060f,-47.165075f);
            poly[765] = new TzPolygon(-3.361145f,-47.165075f, -3.361145f,-46.911764f, -3.377694f,-46.943736f, -3.477093f,-46.947728f, -3.494726f,-46.981203f,
                    -3.529812f,-46.975664f, -3.562288f,-47.038954f, -3.599278f,-47.027046f, -3.655079f,-47.056735f, -3.668470f,-47.037169f,
                    -3.855893f,-47.085241f, -3.918023f,-47.165075f);
            poly[766] = new TzPolygon(-3.361145f,-46.911764f, -3.310148f,-46.813238f, -3.297896f,-46.826665f, -3.243889f,-46.804763f, -3.215703f,-46.754245f,
                    -3.178230f,-46.771359f, -3.189384f,-46.750557f, -3.165592f,-46.748191f, -3.157460f,-46.720290f, -3.122403f,-46.747861f,
                    -3.109215f,-46.719025f, -3.126579f,-46.705322f, -3.101247f,-46.706478f, -3.094763f,-46.675825f, -3.034810f,-46.677751f,
                    -3.012059f,-46.657500f, -2.998650f,-46.672964f, -2.996397f,-46.651171f, -2.970537f,-46.646776f, -2.948735f,-46.670899f,
                    -2.931028f,-46.653691f, -2.882774f,-46.679822f, -2.880112f,-46.633950f, -2.851671f,-46.639798f, -2.858185f,-46.612505f,
                    -2.829515f,-46.613419f, -2.842045f,-46.574537f, -2.789393f,-46.601788f, -2.805077f,-46.619194f, -2.792297f,-46.637056f,
                    -2.754124f,-46.635727f, -2.758107f,-46.650516f, -2.729103f,-46.652260f, -2.733211f,-46.673820f, -2.705767f,-46.669487f,
                    -2.684148f,-46.632723f, -2.643855f,-46.616895f, -2.665516f,-46.591347f, -2.633383f,-46.580935f, -2.615871f,-46.505995f,
                    -2.536897f,-46.488630f, -2.534345f,-46.431026f, -3.361145f,-46.431026f);
            poly[767] = new TzPolygon(-2.473229f,-46.431026f, -2.418928f,-46.441536f, -2.403426f,-46.431026f);
            poly[768] = new TzPolygon(-2.372118f,-46.431026f, -2.374343f,-46.466752f, -2.332935f,-46.431026f);
            poly[769] = new TzPolygon(-2.213230f,-46.344550f, -2.249627f,-46.382844f, -2.237261f,-46.431026f, -2.213230f,-46.431026f);
            poly[770] = new TzPolygon(-2.237850f,-46.431026f, -2.270263f,-46.415345f, -2.332935f,-46.431026f);
            poly[771] = new TzPolygon(-2.372118f,-46.431026f, -2.370737f,-46.408864f, -2.403426f,-46.431026f);
            poly[772] = new TzPolygon(-2.473229f,-46.431026f, -2.533826f,-46.419298f, -2.534345f,-46.431026f);
            poly[773] = new TzPolygon(-2.213230f,-46.344550f, -2.154732f,-46.283003f, -2.140406f,-46.302664f, -2.119064f,-46.271699f, -2.055695f,-46.274354f,
                    -1.914142f,-46.222282f, -1.882624f,-46.244494f, -1.832465f,-46.210261f, -1.795441f,-46.255300f, -1.805730f,-46.311426f,
                    -1.761297f,-46.322212f, -1.728546f,-46.303525f, -1.732026f,-46.221973f, -1.681433f,-46.156636f, -1.629189f,-46.164451f,
                    -1.579437f,-46.133064f, -1.517989f,-46.143580f, -1.474909f,-46.175964f, -1.441682f,-46.138480f, -1.420988f,-46.153623f,
                    -1.337668f,-46.103532f, -1.332389f,-46.130347f, -1.285547f,-46.160436f, -1.247109f,-46.139842f, -1.227820f,-46.151203f,
                    -1.201486f,-46.094943f, -0.759383f,-45.943794f, -0.832976f,-45.696978f, -2.213230f,-45.696978f);
            poly[774] = new TzPolygon(-10.477527f,-45.422756f, -10.477527f,-44.026742f, -10.582053f,-44.074150f, -10.644000f,-44.153000f, -10.615000f,-44.208000f,
                    -10.624000f,-44.264000f, -10.548000f,-44.333000f, -10.606000f,-44.398000f, -10.606193f,-44.452010f, -10.650000f,-44.504000f,
                    -10.626000f,-44.577000f, -10.670695f,-44.617842f, -10.682000f,-44.666000f, -10.761741f,-44.669426f, -10.775770f,-44.743468f,
                    -10.804000f,-44.759000f, -10.808000f,-44.788000f, -10.900000f,-44.844000f, -10.883040f,-44.859037f, -10.928056f,-44.931457f,
                    -10.840268f,-45.073164f, -10.822000f,-45.248000f, -10.775873f,-45.268381f, -10.732000f,-45.358000f, -10.653676f,-45.382851f,
                    -10.629463f,-45.432561f, -10.559340f,-45.446847f, -10.507000f,-45.447000f);
            poly[775] = new TzPolygon(-10.477527f,-45.422756f, -10.445000f,-45.396000f, -10.421081f,-45.426411f, -10.360000f,-45.430000f, -10.281999f,-45.520890f,
                    -10.111557f,-45.590503f, -10.146481f,-45.696978f, -7.262677f,-45.696978f, -7.262677f,-42.929790f, -9.521088f,-42.929790f,
                    -9.518000f,-42.946000f, -9.405803f,-42.975005f, -9.419000f,-43.057000f, -9.394160f,-43.062035f, -9.371000f,-43.119000f,
                    -9.378729f,-43.160720f, -9.420000f,-43.191000f, -9.399618f,-43.213944f, -9.424215f,-43.280005f, -9.356036f,-43.369740f,
                    -9.272000f,-43.427000f, -9.265000f,-43.485000f, -9.414411f,-43.680771f, -9.446293f,-43.776005f, -9.550014f,-43.851280f,
                    -9.637000f,-43.842000f, -9.692000f,-43.799000f, -9.762000f,-43.785000f, -9.839000f,-43.653000f, -9.913000f,-43.709000f,
                    -9.929000f,-43.690000f, -9.966000f,-43.703000f, -10.008968f,-43.661865f, -10.077000f,-43.693000f, -10.079821f,-43.765831f,
                    -10.179861f,-43.779005f, -10.250661f,-43.837480f, -10.304000f,-43.838000f, -10.383785f,-43.914419f, -10.428977f,-43.918148f,
                    -10.432416f,-43.973781f, -10.407645f,-44.023301f, -10.477527f,-44.026742f);
            poly[776] = new TzPolygon(-9.522465f,-42.929790f, -9.526000f,-42.904000f, -9.563117f,-42.873630f, -9.550000f,-42.837000f, -9.620605f,-42.819823f,
                    -9.619662f,-42.771478f, -9.558000f,-42.718000f, -9.531000f,-42.720000f, -9.549000f,-42.680000f, -9.541604f,-42.623740f,
                    -9.496000f,-42.586000f, -9.493000f,-42.491000f, -9.462000f,-42.489000f, -9.456000f,-42.440000f, -9.411307f,-42.420782f,
                    -9.377000f,-42.359000f, -9.316404f,-42.316777f, -9.283625f,-42.234362f, -9.286630f,-42.132157f, -9.249000f,-42.022000f,
                    -9.266000f,-42.000000f, -9.248000f,-41.972000f, -9.278845f,-41.921380f, -9.237000f,-41.870000f, -9.242000f,-41.838000f,
                    -9.148000f,-41.800000f, -9.094000f,-41.735000f, -9.016255f,-41.726838f, -9.012000f,-41.680000f, -8.957000f,-41.605000f,
                    -8.959892f,-41.546196f, -10.477527f,-41.546196f, -10.477527f,-42.929790f);
            poly[777] = new TzPolygon(-8.870102f,-41.505075f, -8.960000f,-41.544000f, -8.959892f,-41.546196f, -8.870102f,-41.546196f);
            poly[778] = new TzPolygon(-8.870102f,-40.899999f, -8.870102f,-40.162602f, -9.087664f,-40.162602f, -9.053620f,-40.226410f, -9.064809f,-40.257343f,
                    -9.355719f,-40.340339f, -9.373324f,-40.380828f, -9.353749f,-40.423192f, -9.420253f,-40.466160f, -9.405802f,-40.516439f,
                    -9.458309f,-40.555593f, -9.476359f,-40.619373f, -9.444059f,-40.721872f, -9.448434f,-40.775842f, -9.401902f,-40.742315f,
                    -9.336000f,-40.737000f, -9.313000f,-40.755000f, -9.278000f,-40.687000f, -9.233162f,-40.694383f, -9.159000f,-40.667000f,
                    -9.081863f,-40.819049f, -8.952000f,-40.851000f);
            poly[779] = new TzPolygon(-8.870102f,-41.505075f, -8.863000f,-41.502000f, -8.802000f,-41.424000f, -8.707000f,-41.381000f, -8.736100f,-41.281538f,
                    -8.704702f,-41.226978f, -8.703797f,-41.113710f, -8.752674f,-41.124569f, -8.781964f,-41.101761f, -8.785876f,-41.036234f,
                    -8.843561f,-41.021241f, -8.823417f,-40.979094f, -8.843379f,-40.955093f, -8.835000f,-40.921000f, -8.870102f,-40.899999f);
            poly[780] = new TzPolygon(-8.066389f,-41.546196f, -8.066389f,-40.590084f, -8.095330f,-40.603123f, -8.138808f,-40.589698f, -8.139449f,-40.633951f,
                    -8.223494f,-40.707256f, -8.253304f,-40.782482f, -8.301933f,-40.779880f, -8.321909f,-40.819509f, -8.363494f,-40.820098f,
                    -8.380528f,-40.850212f, -8.357310f,-40.893472f, -8.421627f,-40.901535f, -8.446326f,-40.925149f, -8.400300f,-40.999953f,
                    -8.436657f,-41.043718f, -8.480474f,-41.051099f, -8.472503f,-41.078927f, -8.518533f,-41.095584f, -8.541956f,-41.126733f,
                    -8.533119f,-41.149250f, -8.583091f,-41.168746f, -8.601820f,-41.212288f, -8.644155f,-41.213543f, -8.660839f,-41.287434f,
                    -8.708357f,-41.336917f, -8.707000f,-41.381000f, -8.802000f,-41.424000f, -8.863000f,-41.502000f, -8.870102f,-41.505075f,
                    -8.870102f,-41.546196f);
            poly[781] = new TzPolygon(-8.066389f,-40.590084f, -7.964597f,-40.544222f, -7.845993f,-40.540459f, -7.808759f,-40.568405f, -7.764829f,-40.672072f,
                    -7.651360f,-40.621990f, -7.484437f,-40.715536f, -7.456356f,-40.701201f, -7.392691f,-40.548464f, -7.318450f,-40.523723f,
                    -7.368168f,-40.393878f, -7.303000f,-40.318000f, -7.301000f,-40.263000f, -7.358000f,-40.195000f, -7.365500f,-40.162602f,
                    -8.066389f,-40.162602f);
            poly[782] = new TzPolygon(-10.996508f,-38.150959f, -10.989100f,-38.169865f, -10.943094f,-38.180882f, -10.915598f,-38.227116f, -10.823000f,-38.245000f,
                    -10.760454f,-38.209420f, -10.711876f,-38.209194f, -10.713416f,-38.150959f);
            poly[783] = new TzPolygon(-10.477527f,-37.830002f, -10.507128f,-37.812934f, -10.549990f,-37.840595f, -10.691000f,-37.814000f, -10.759000f,-37.985000f,
                    -10.696816f,-38.049217f, -10.715615f,-38.067819f, -10.713416f,-38.150959f, -10.477527f,-38.150959f);
            poly[784] = new TzPolygon(-10.996508f,-38.150959f, -11.015465f,-38.102576f, -11.171866f,-38.062035f, -11.193788f,-37.973766f, -11.271176f,-37.986544f,
                    -11.285007f,-38.014922f, -11.374263f,-37.969081f, -11.392738f,-37.977837f, -11.394521f,-37.952903f, -11.424283f,-37.944280f,
                    -11.401494f,-37.927887f, -11.407926f,-37.905827f, -11.438341f,-37.898936f, -11.426324f,-37.867360f, -11.433506f,-37.880199f,
                    -11.443227f,-37.847884f, -11.466675f,-37.864241f, -11.496979f,-37.808704f, -11.516852f,-37.812183f, -11.525184f,-37.757500f,
                    -11.553604f,-37.726724f, -11.540075f,-37.702440f, -11.566795f,-37.689527f, -11.564462f,-37.669953f, -11.516666f,-37.651076f,
                    -11.538825f,-37.614597f, -11.531555f,-37.580674f, -11.551977f,-37.578490f, -11.548601f,-37.519892f, -11.443058f,-37.345636f,
                    -11.566876f,-37.188891f, -12.342119f,-37.602013f, -12.758442f,-37.896682f, -13.023639f,-38.150959f);
            poly[785] = new TzPolygon(-8.870102f,-39.900631f, -8.946297f,-39.881876f, -9.050080f,-39.960302f, -9.058922f,-40.066717f, -9.104982f,-40.130142f,
                    -9.087664f,-40.162602f, -8.870102f,-40.162602f);
            poly[786] = new TzPolygon(-10.477527f,-37.830002f, -10.427441f,-37.858882f, -10.378628f,-37.838096f, -10.332944f,-37.734469f, -10.003340f,-37.827808f,
                    -9.971000f,-37.957000f, -9.916000f,-37.997000f, -9.816323f,-37.966554f, -9.770450f,-38.032473f, -9.697284f,-38.045032f,
                    -9.673815f,-38.017995f, -9.673815f,-37.395413f, -10.477527f,-37.395413f);
            poly[787] = new TzPolygon(-9.440806f,-38.087210f, -9.441517f,-38.153353f, -9.417717f,-38.204447f, -9.384757f,-38.194388f, -9.329000f,-38.237000f,
                    -9.284869f,-38.173426f, -9.217604f,-38.144180f, -9.174213f,-38.093824f, -9.173042f,-38.087210f);
            poly[788] = new TzPolygon(-8.870102f,-38.087210f, -9.173042f,-38.087210f, -9.174213f,-38.093824f, -9.217604f,-38.144180f, -9.284869f,-38.173426f,
                    -9.329000f,-38.237000f, -9.141890f,-38.313040f, -9.076336f,-38.318599f, -9.043619f,-38.285984f, -9.013298f,-38.297412f,
                    -8.987093f,-38.331130f, -9.044636f,-38.398937f, -9.020046f,-38.472949f, -8.960360f,-38.510792f, -8.870102f,-38.480187f);
            poly[789] = new TzPolygon(-8.870102f,-38.587455f, -8.936987f,-38.605652f, -8.988009f,-38.647331f, -8.967323f,-38.679775f, -8.870102f,-38.700880f);
            poly[790] = new TzPolygon(-9.440806f,-38.087210f, -9.440725f,-38.079699f, -9.498061f,-37.999748f, -9.599740f,-38.040243f, -9.647294f,-37.987442f,
                    -9.673815f,-38.017995f, -9.673815f,-38.087210f);
            poly[791] = new TzPolygon(-8.870102f,-37.798192f, -8.884960f,-37.825003f, -8.974046f,-37.834476f, -9.154820f,-37.984325f, -9.173042f,-38.087210f,
                    -8.870102f,-38.087210f);
            poly[792] = new TzPolygon(-9.025042f,-37.395413f, -9.009283f,-37.410992f, -8.993360f,-37.493205f, -8.968132f,-37.499862f, -8.959930f,-37.531377f,
                    -8.969040f,-37.597362f, -9.003746f,-37.637978f, -8.991062f,-37.698244f, -8.974468f,-37.672228f, -8.870102f,-37.739949f,
                    -8.870102f,-37.395413f);
            poly[793] = new TzPolygon(-8.870102f,-39.900631f, -8.859220f,-39.903309f, -8.827261f,-39.891612f, -8.785954f,-39.675018f, -8.659776f,-39.694122f,
                    -8.656109f,-39.610345f, -8.526006f,-39.383090f, -8.556779f,-39.344434f, -8.568614f,-39.274847f, -8.687226f,-39.216939f,
                    -8.681626f,-39.182950f, -8.709840f,-39.146651f, -8.734273f,-39.036960f, -8.798403f,-38.953875f, -8.783810f,-38.793415f,
                    -8.796716f,-38.779007f, -8.870102f,-38.779007f);
            poly[794] = new TzPolygon(-7.365500f,-40.162602f, -7.383000f,-40.087000f, -7.325210f,-39.851448f, -7.335000f,-39.715000f, -7.372000f,-39.653000f,
                    -7.425000f,-39.629000f, -7.430746f,-39.571274f, -7.483942f,-39.545853f, -7.464000f,-39.502000f, -7.474000f,-39.458000f,
                    -7.538000f,-39.485000f, -7.575000f,-39.472000f, -7.573000f,-39.435000f, -7.604000f,-39.419000f, -7.614000f,-39.372000f,
                    -7.666000f,-39.305000f, -7.660159f,-39.272504f, -7.705000f,-39.252000f, -7.689000f,-39.208000f, -7.723549f,-39.135682f,
                    -7.775792f,-39.099994f, -7.857991f,-39.091019f, -7.819305f,-39.053756f, -7.812238f,-39.015771f, -7.840219f,-39.001137f,
                    -7.844007f,-38.961835f, -7.758000f,-38.939000f, -7.747000f,-38.881000f, -7.711000f,-38.869000f, -7.719000f,-38.828000f,
                    -7.664000f,-38.819000f, -7.661922f,-38.779007f, -8.066389f,-38.779007f, -8.066389f,-40.162602f);
            poly[795] = new TzPolygon(-8.796716f,-38.779007f, -8.870102f,-38.697086f, -8.870102f,-38.779007f);
            poly[796] = new TzPolygon(-8.870102f,-38.596874f, -8.859881f,-38.594353f, -8.821451f,-38.556775f, -8.819460f,-38.526378f, -8.861840f,-38.477386f,
                    -8.870102f,-38.481186f);
            poly[797] = new TzPolygon(-7.357409f,-37.395413f, -7.364822f,-37.496038f, -7.395054f,-37.486958f, -7.472953f,-37.533067f, -7.532511f,-37.630378f,
                    -7.523137f,-37.659530f, -7.550584f,-37.706506f, -7.619522f,-37.755848f, -7.662889f,-37.750648f, -7.625798f,-37.785828f,
                    -7.651969f,-37.857159f, -7.694737f,-37.902747f, -7.713626f,-37.894335f, -7.715112f,-37.923935f, -7.777577f,-37.970600f,
                    -7.748000f,-38.039000f, -7.772324f,-38.069478f, -7.830000f,-38.077000f, -7.779909f,-38.164219f, -7.830726f,-38.238571f,
                    -7.830922f,-38.285707f, -7.763196f,-38.299817f, -7.764607f,-38.316760f, -7.716313f,-38.312029f, -7.677162f,-38.357496f,
                    -7.730493f,-38.409508f, -7.717581f,-38.455018f, -7.751482f,-38.500548f, -7.755681f,-38.589958f, -7.677637f,-38.642084f,
                    -7.621919f,-38.715113f, -7.660000f,-38.742000f, -7.661922f,-38.779007f, -7.262677f,-38.779007f, -7.262677f,-37.395413f);
            poly[798] = new TzPolygon(-8.870102f,-37.798287f, -8.846362f,-37.755354f, -8.870102f,-37.739949f);
            poly[799] = new TzPolygon(-8.870102f,-37.395413f, -8.870102f,-35.918307f, -8.902397f,-35.963395f, -8.915000f,-36.064000f, -8.955000f,-36.126000f,
                    -9.017000f,-36.111000f, -9.044786f,-36.195725f, -9.103490f,-36.236458f, -9.103924f,-36.268391f, -9.171277f,-36.262445f,
                    -9.172362f,-36.309791f, -9.220000f,-36.353000f, -9.229569f,-36.419799f, -9.212100f,-36.437004f, -9.262408f,-36.491338f,
                    -9.292583f,-36.571840f, -9.332135f,-36.567469f, -9.341508f,-36.605047f, -9.271457f,-36.761772f, -9.288628f,-36.836041f,
                    -9.268084f,-36.871259f, -9.299021f,-36.915820f, -9.383022f,-36.946486f, -9.352613f,-37.003364f, -9.315715f,-37.024290f,
                    -9.317540f,-37.057584f, -9.281788f,-37.057200f, -9.246362f,-37.090672f, -9.240931f,-37.116475f, -9.275705f,-37.164334f,
                    -9.239102f,-37.158947f, -9.215482f,-37.198315f, -9.240000f,-37.234000f, -9.160000f,-37.262000f, -9.025042f,-37.395413f);
        }
    }

    private static class Initializer9 {
        private static void init() {
            poly[800] = new TzPolygon(-8.870102f,-34.914857f, -8.989445f,-34.963436f, -8.913959f,-35.154664f, -8.890561f,-35.171232f, -8.870102f,-35.288689f);
            poly[801] = new TzPolygon(-8.870102f,-35.614737f, -8.882510f,-35.633650f, -8.916685f,-35.748088f, -8.897076f,-35.782670f, -8.870102f,-35.777838f);
            poly[802] = new TzPolygon(-8.870102f,-35.837774f, -8.872459f,-35.842204f, -8.870102f,-35.849200f);
            poly[803] = new TzPolygon(-8.066389f,-37.146464f, -8.066389f,-36.641486f, -8.079809f,-36.658682f, -8.111050f,-36.628612f, -8.140773f,-36.693862f,
                    -8.155679f,-36.687036f, -8.150965f,-36.722810f, -8.167316f,-36.715781f, -8.196294f,-36.761570f, -8.190509f,-36.797395f,
                    -8.240820f,-36.895950f, -8.299273f,-36.954629f, -8.302955f,-36.991154f, -8.264560f,-37.043334f, -8.266374f,-37.081202f,
                    -8.230102f,-37.067418f, -8.233707f,-37.100428f, -8.209066f,-37.122915f, -8.175352f,-37.118260f, -8.165762f,-37.163616f,
                    -8.117945f,-37.142558f);
            poly[804] = new TzPolygon(-7.357409f,-37.395413f, -7.356694f,-37.385714f, -7.337028f,-37.349512f, -7.288283f,-37.330586f, -7.272954f,-37.241907f,
                    -7.336595f,-37.165341f, -7.386044f,-37.025623f, -7.440197f,-37.021226f, -7.482262f,-36.984226f, -7.518336f,-37.087455f,
                    -7.574715f,-37.163569f, -7.635298f,-37.197946f, -7.741934f,-37.140003f, -7.779844f,-37.151951f, -7.819002f,-37.243656f,
                    -7.842250f,-37.222093f, -7.846804f,-37.247150f, -7.874900f,-37.244648f, -7.910502f,-37.322172f, -7.934176f,-37.308976f,
                    -7.946644f,-37.349904f, -7.974956f,-37.357368f, -7.960598f,-37.192676f, -7.982867f,-37.193395f, -8.015264f,-37.150338f,
                    -8.066389f,-37.146464f, -8.066389f,-37.395413f);
            poly[805] = new TzPolygon(-8.066389f,-36.641486f, -8.055749f,-36.627852f, -7.947897f,-36.611877f, -7.957434f,-36.573482f, -7.900998f,-36.563879f,
                    -7.924763f,-36.480136f, -7.915283f,-36.444110f, -7.815778f,-36.424048f, -7.806687f,-36.309131f, -7.832077f,-36.261333f,
                    -7.817681f,-36.240012f, -7.792145f,-36.252000f, -7.764104f,-36.216634f, -7.789903f,-36.200958f, -7.779056f,-36.080932f,
                    -7.807344f,-36.011819f, -8.066389f,-36.011819f);
            poly[806] = new TzPolygon(-7.500578f,-34.628225f, -7.579204f,-34.634021f, -7.538311f,-34.959296f, -7.461997f,-34.985000f, -7.398000f,-35.070000f,
                    -7.397943f,-35.190783f, -7.374681f,-35.248589f, -7.406804f,-35.335021f, -7.440261f,-35.351103f, -7.471900f,-35.414605f,
                    -7.453411f,-35.450370f, -7.482206f,-35.494312f, -7.580643f,-35.537272f, -7.585021f,-35.515194f, -7.621666f,-35.531687f,
                    -7.643247f,-35.515070f, -7.654818f,-35.532812f, -7.653779f,-35.609662f, -7.695248f,-35.646429f, -7.707551f,-35.683556f,
                    -7.691000f,-35.700000f, -7.738000f,-35.780000f, -7.750055f,-35.873721f, -7.792000f,-35.905000f, -7.789000f,-35.970000f,
                    -7.813000f,-35.998000f, -7.807344f,-36.011819f, -7.262677f,-36.011819f, -7.262677f,-34.628225f);
            poly[807] = new TzPolygon(-8.870102f,-35.918555f, -8.854268f,-35.896200f, -8.870102f,-35.849200f);
            poly[808] = new TzPolygon(-8.870102f,-35.837928f, -8.846933f,-35.795899f, -8.857991f,-35.775669f, -8.870102f,-35.777838f);
            poly[809] = new TzPolygon(-8.870102f,-35.614737f, -8.820224f,-35.538710f, -8.813128f,-35.470125f, -8.841230f,-35.454446f, -8.870102f,-35.288689f);
            poly[810] = new TzPolygon(-12.365968f,-64.499112f, -12.352837f,-64.513848f, -12.307635f,-64.499112f);
            poly[811] = new TzPolygon(-12.271131f,-64.499112f, -12.224617f,-64.512818f, -12.240862f,-64.553698f, -12.209966f,-64.576442f, -12.182029f,-64.704142f,
                    -12.106357f,-64.709650f, -12.106357f,-64.499112f);
            poly[812] = new TzPolygon(-12.106357f,-64.727094f, -12.153883f,-64.762605f, -12.106357f,-64.759576f);
            poly[813] = new TzPolygon(-12.106357f,-64.499112f, -12.106357f,-64.709650f, -12.085084f,-64.711199f, -12.106357f,-64.727094f, -12.106357f,-64.759576f,
                    -12.096270f,-64.758933f, -12.086325f,-64.803680f, -12.009934f,-64.841233f, -12.026686f,-64.917729f, -11.992795f,-64.946952f,
                    -12.018429f,-64.977854f, -11.996007f,-65.033496f, -11.962479f,-65.042237f, -11.925706f,-65.020423f, -11.888924f,-65.029705f,
                    -11.872954f,-65.070546f, -11.791463f,-65.059477f, -11.708204f,-65.086718f, -11.722659f,-65.189838f, -11.756092f,-65.182161f,
                    -11.710531f,-65.259304f, -11.647631f,-65.215687f, -11.604841f,-65.234130f, -11.528565f,-65.211777f, -11.496155f,-65.308524f,
                    -11.336877f,-65.332515f, -11.320296f,-65.290214f, -11.304439f,-65.346360f, -11.220303f,-65.359926f, -11.195782f,-65.312944f,
                    -11.186160f,-65.352080f, -11.146774f,-65.362137f, -11.115156f,-65.343426f, -11.090091f,-65.282689f, -11.031416f,-65.300713f,
                    -10.985063f,-65.250529f, -10.954286f,-65.272973f, -10.873020f,-65.274764f, -10.797576f,-65.366613f, -10.767308f,-65.343226f,
                    -10.681551f,-65.346670f, -10.639345f,-65.405689f, -10.574560f,-65.399380f, -10.520335f,-65.417995f, -10.520335f,-64.499112f);
            poly[814] = new TzPolygon(-12.607694f,-63.438697f, -12.607484f,-63.440830f, -12.580776f,-63.438697f);
            poly[815] = new TzPolygon(-12.564317f,-63.438697f, -12.565669f,-63.504103f, -12.505207f,-63.556113f, -12.427762f,-63.785395f, -12.462080f,-63.834380f,
                    -12.445841f,-63.889051f, -12.503000f,-63.901022f, -12.529773f,-63.955007f, -12.501491f,-63.992648f, -12.516684f,-64.038730f,
                    -12.483483f,-64.093717f, -12.505066f,-64.124276f, -12.476336f,-64.132904f, -12.513517f,-64.167248f, -12.466398f,-64.173935f,
                    -12.453638f,-64.230675f, -12.501809f,-64.290626f, -12.457403f,-64.294789f, -12.444235f,-64.411279f, -12.365968f,-64.499112f,
                    -12.307635f,-64.499112f, -12.290305f,-64.493463f, -12.271131f,-64.499112f, -12.106357f,-64.499112f, -12.106357f,-63.438697f);
            poly[816] = new TzPolygon(-13.137830f,-62.378281f, -13.134210f,-62.392789f, -13.112436f,-62.398914f, -13.127748f,-62.415131f, -13.061647f,-62.458321f,
                    -13.082214f,-62.504195f, -13.042912f,-62.609928f, -13.015035f,-62.599686f, -13.014799f,-62.630778f, -12.964470f,-62.648866f,
                    -13.002801f,-62.701571f, -13.008484f,-62.780986f, -12.940761f,-62.805431f, -12.948139f,-62.847673f, -12.923906f,-62.843354f,
                    -12.908358f,-62.872382f, -12.855820f,-62.894137f, -12.839220f,-62.927814f, -12.859513f,-62.976143f, -12.835793f,-63.011697f,
                    -12.741199f,-63.046459f, -12.723104f,-63.081902f, -12.686117f,-63.061626f, -12.682390f,-63.098465f, -12.655099f,-63.084272f,
                    -12.624739f,-63.114698f, -12.637820f,-63.146179f, -12.612935f,-63.160901f, -12.642617f,-63.168152f, -12.623117f,-63.193972f,
                    -12.657564f,-63.198600f, -12.663512f,-63.248008f, -12.689157f,-63.235712f, -12.682514f,-63.296871f, -12.658589f,-63.374306f,
                    -12.610331f,-63.411864f, -12.607694f,-63.438697f, -12.564290f,-63.437380f, -12.564317f,-63.438697f, -12.106357f,-63.438697f,
                    -12.106357f,-62.378281f);
            poly[817] = new TzPolygon(-9.727325f,-66.619944f, -9.727325f,-65.559528f, -9.806452f,-65.559528f, -9.811317f,-65.565034f, -9.845653f,-65.560742f,
                    -9.843351f,-65.597146f, -9.825378f,-65.599841f, -9.838042f,-65.627003f, -9.781288f,-65.669630f, -9.813695f,-65.688837f,
                    -9.808573f,-65.710231f, -9.769413f,-65.708825f, -9.767458f,-65.680474f, -9.749925f,-65.683947f, -9.782964f,-65.743200f,
                    -9.734417f,-65.770134f, -9.792952f,-65.794374f, -9.772557f,-65.813511f, -9.757469f,-65.799052f, -9.755513f,-65.816488f,
                    -9.791136f,-65.841153f, -9.793231f,-65.870355f, -9.767248f,-65.862487f, -9.752230f,-65.886090f, -9.771736f,-65.968240f,
                    -9.803461f,-65.964420f, -9.810112f,-65.982222f, -9.794689f,-66.002436f, -9.813292f,-66.023539f, -9.785443f,-66.036673f,
                    -9.782774f,-66.069937f, -9.814000f,-66.093000f, -9.782092f,-66.103191f, -9.784161f,-66.152512f, -9.804644f,-66.195089f,
                    -9.835108f,-66.203793f, -9.812807f,-66.235559f, -9.844470f,-66.285110f, -9.838167f,-66.347211f, -9.865348f,-66.358922f,
                    -9.863209f,-66.404375f, -9.899325f,-66.427963f, -9.865207f,-66.436588f, -9.879904f,-66.562275f, -9.904283f,-66.580991f,
                    -9.888653f,-66.619944f);
            poly[818] = new TzPolygon(-9.673151f,-66.619944f, -9.664898f,-66.609449f, -9.673559f,-66.586307f, -9.633564f,-66.500613f, -9.601583f,-66.494917f,
                    -9.500480f,-66.392414f, -9.406947f,-66.408858f, -9.436845f,-66.307497f, -9.409763f,-66.267804f, -9.434419f,-66.173633f,
                    -9.408779f,-66.123891f, -9.413160f,-65.970301f, -9.483750f,-65.912634f, -9.530091f,-65.825077f, -9.585644f,-65.791522f,
                    -9.553623f,-65.750327f, -9.559057f,-65.723548f, -9.500407f,-65.680998f, -9.451393f,-65.679435f, -9.413865f,-65.596776f,
                    -9.427832f,-65.559528f, -9.727325f,-65.559528f, -9.727325f,-66.619944f);
            poly[819] = new TzPolygon(-9.844841f,-65.559528f, -9.844976f,-65.556107f, -9.832076f,-65.559528f, -9.806452f,-65.559528f, -9.782153f,-65.532028f,
                    -9.785605f,-65.500489f, -9.730284f,-65.501347f, -9.696275f,-65.446169f, -9.668944f,-65.444294f, -9.700200f,-65.372874f,
                    -9.853466f,-65.284297f, -9.965000f,-65.333000f, -10.214544f,-65.288429f, -10.301000f,-65.324000f, -10.372842f,-65.391526f,
                    -10.433469f,-65.382564f, -10.485047f,-65.430109f, -10.520335f,-65.417995f, -10.520335f,-65.559528f);
            poly[820] = new TzPolygon(-8.977581f,-64.499112f, -8.978271f,-64.550124f, -9.016452f,-64.611074f, -9.014796f,-64.671376f, -8.988262f,-64.699267f,
                    -9.020748f,-64.753570f, -8.986403f,-64.791627f, -8.994111f,-64.839324f, -9.043141f,-64.917267f, -9.124566f,-64.939930f,
                    -9.220280f,-64.919683f, -9.255811f,-64.936078f, -9.304614f,-65.000515f, -9.343529f,-65.005847f, -9.432516f,-65.097850f,
                    -9.446812f,-65.142881f, -9.427032f,-65.185463f, -9.385448f,-65.173544f, -9.375263f,-65.196158f, -9.285633f,-65.208025f,
                    -9.257664f,-65.246661f, -9.338031f,-65.385211f, -9.316376f,-65.447018f, -9.401209f,-65.456600f, -9.466333f,-65.434716f,
                    -9.473664f,-65.492801f, -9.447698f,-65.506550f, -9.427832f,-65.559528f, -8.934314f,-65.559528f, -8.934314f,-64.499112f);
            poly[821] = new TzPolygon(-8.977581f,-64.499112f, -8.976870f,-64.446574f, -8.928861f,-64.323400f, -8.996471f,-64.311318f, -8.992308f,-64.233205f,
                    -8.958937f,-64.149452f, -8.843167f,-64.158203f, -8.805163f,-64.129459f, -8.776447f,-64.144762f, -8.722160f,-64.130868f,
                    -8.715666f,-64.027869f, -8.693558f,-64.035482f, -8.585634f,-63.986210f, -8.609485f,-63.945954f, -8.575525f,-63.924569f,
                    -8.487238f,-63.974505f, -8.452264f,-63.940838f, -8.420133f,-63.977895f, -8.387826f,-63.945373f, -8.331188f,-63.944122f,
                    -8.328525f,-63.910836f, -8.288820f,-63.870759f, -8.333215f,-63.791231f, -8.320733f,-63.773508f, -8.249499f,-63.722761f,
                    -8.198583f,-63.747034f, -8.121743f,-63.669898f, -8.081603f,-63.667000f, -8.029611f,-63.621779f, -7.969294f,-63.620789f,
                    -7.975000f,-62.866000f, -8.093000f,-62.692000f, -8.145000f,-62.673000f, -8.173000f,-62.686000f, -8.229000f,-62.654000f,
                    -8.284000f,-62.561000f, -8.358000f,-62.551000f, -8.383000f,-62.526000f, -8.339000f,-62.465000f, -8.372000f,-62.432000f,
                    -8.387234f,-62.378281f, -10.520335f,-62.378281f, -10.520335f,-64.499112f);
            poly[822] = new TzPolygon(-13.506974f,-61.317865f, -13.554391f,-61.469123f, -13.518000f,-61.572000f, -13.487156f,-61.578408f, -13.516922f,-61.624930f,
                    -13.499180f,-61.694920f, -13.527512f,-61.731490f, -13.519548f,-61.754158f, -13.540950f,-61.758579f, -13.516062f,-61.773419f,
                    -13.537000f,-61.784000f, -13.521547f,-61.825910f, -13.538209f,-61.856028f, -13.428100f,-61.895816f, -13.407237f,-61.969467f,
                    -13.368082f,-61.974567f, -13.357314f,-62.013069f, -13.327000f,-62.017000f, -13.259315f,-62.114773f, -13.157411f,-62.116838f,
                    -13.163114f,-62.150019f, -13.113436f,-62.167454f, -13.153345f,-62.193053f, -13.110534f,-62.215510f, -13.157298f,-62.274155f,
                    -13.133860f,-62.313733f, -13.151783f,-62.322354f, -13.137830f,-62.378281f, -12.106357f,-62.378281f, -12.106357f,-61.317865f);
            poly[823] = new TzPolygon(-13.692378f,-60.703664f, -13.681474f,-60.715408f, -13.576999f,-60.633702f, -13.561629f,-60.566220f, -13.515625f,-60.527812f,
                    -13.449131f,-60.383553f, -13.314490f,-60.371922f, -13.254758f,-60.326648f, -13.178671f,-60.305838f, -13.147531f,-60.269076f,
                    -13.080327f,-60.284207f, -13.059614f,-60.257449f, -13.692378f,-60.257449f);
            poly[824] = new TzPolygon(-13.506974f,-61.317865f, -13.503506f,-61.306803f, -13.477885f,-61.299322f, -13.506025f,-61.279501f, -13.496628f,-61.246240f,
                    -13.526062f,-61.233959f, -13.536951f,-61.194749f, -13.506021f,-61.183493f, -13.532031f,-61.149166f, -13.531713f,-61.103781f,
                    -13.491797f,-61.095334f, -13.512637f,-61.056557f, -13.500042f,-61.035846f, -13.485916f,-61.048506f, -13.488399f,-61.015182f,
                    -13.501097f,-60.988398f, -13.509369f,-61.010018f, -13.550627f,-61.007620f, -13.541634f,-60.921551f, -13.619847f,-60.877575f,
                    -13.659827f,-60.773806f, -13.683296f,-60.768435f, -13.690981f,-60.707804f, -13.692378f,-60.707010f, -13.692378f,-61.317865f);
            poly[825] = new TzPolygon(-11.099787f,-60.257449f, -11.095172f,-60.277004f, -11.057011f,-60.299105f, -11.074154f,-60.347466f, -11.108762f,-60.348078f,
                    -11.092829f,-60.392020f, -11.043414f,-60.414142f, -11.042306f,-60.446343f, -11.018485f,-60.437461f, -10.989132f,-60.459159f,
                    -10.986000f,-61.550000f, -10.949000f,-61.519000f, -10.794000f,-61.511000f, -10.797000f,-61.473000f, -10.736000f,-61.488000f,
                    -10.715000f,-61.472000f, -10.700000f,-61.498000f, -10.520335f,-61.474259f, -10.520335f,-60.257449f);
            poly[826] = new TzPolygon(-11.099787f,-60.257449f, -11.113682f,-60.198581f, -11.095185f,-60.158166f, -11.110225f,-60.098000f, -11.096554f,-60.083326f,
                    -11.124512f,-60.064788f, -11.130166f,-60.024745f, -11.114233f,-59.982762f, -11.155365f,-59.995712f, -11.188908f,-59.963182f,
                    -11.234010f,-59.983333f, -11.295597f,-59.958885f, -11.323153f,-59.919644f, -11.398475f,-59.920234f, -11.589060f,-60.113932f,
                    -11.713352f,-60.120458f, -11.799353f,-60.095094f, -11.838985f,-60.108377f, -11.895409f,-60.060225f, -11.912337f,-59.983142f,
                    -12.027704f,-59.978271f, -12.117000f,-59.899000f, -12.186000f,-59.910000f, -12.245000f,-59.892000f, -12.340956f,-59.774353f,
                    -12.401399f,-59.832549f, -12.472052f,-59.847975f, -12.487084f,-59.935226f, -12.613183f,-60.067942f, -12.727950f,-60.090551f,
                    -12.889304f,-60.081283f, -12.959556f,-60.117165f, -12.971143f,-60.189278f, -13.026981f,-60.215292f, -13.059614f,-60.257449f);
            poly[827] = new TzPolygon(-8.934314f,-62.378281f, -8.934314f,-61.476608f, -9.092000f,-61.555000f, -9.191000f,-61.520000f, -9.242000f,-61.524000f,
                    -9.237000f,-61.575000f, -9.270000f,-61.633000f, -9.279000f,-61.612000f, -9.363017f,-61.625118f, -9.387068f,-61.552081f,
                    -9.472912f,-61.578226f, -9.502664f,-61.526441f, -9.515855f,-61.550012f, -9.528991f,-61.513039f, -9.614911f,-61.503290f,
                    -9.629468f,-61.476681f, -9.694114f,-61.506750f, -9.720390f,-61.574614f, -9.740763f,-61.530186f, -9.789105f,-61.547923f,
                    -9.797984f,-61.524793f, -9.888045f,-61.507478f, -9.989046f,-61.531009f, -10.060565f,-61.584533f, -10.153708f,-61.602022f,
                    -10.198264f,-61.551418f, -10.226150f,-61.576724f, -10.307000f,-61.553000f, -10.420000f,-61.461000f, -10.520335f,-61.474259f,
                    -10.520335f,-62.378281f);
            poly[828] = new TzPolygon(-8.934314f,-61.476608f, -8.917000f,-61.468000f, -8.818000f,-61.523000f, -8.798000f,-61.583000f, -8.795372f,-60.257449f,
                    -8.934314f,-60.257449f);
            poly[829] = new TzPolygon(-7.348293f,-60.257449f, -8.795372f,-60.257449f, -8.798000f,-61.583000f, -8.794000f,-61.606000f, -8.722000f,-61.630000f,
                    -8.707000f,-61.705000f, -8.687000f,-61.713000f, -8.695000f,-61.741000f, -8.748000f,-61.774000f, -8.732000f,-61.836000f,
                    -8.853000f,-61.860000f, -8.878000f,-61.985000f, -8.799000f,-62.031000f, -8.801000f,-62.124000f, -8.679000f,-62.165000f,
                    -8.644000f,-62.200000f, -8.628000f,-62.174000f, -8.590000f,-62.188000f, -8.575000f,-62.268000f, -8.605000f,-62.294000f,
                    -8.638000f,-62.281000f, -8.609000f,-62.335000f, -8.563000f,-62.325000f, -8.493000f,-62.366000f, -8.391000f,-62.365000f,
                    -8.387234f,-62.378281f, -7.348293f,-62.378281f);
            poly[830] = new TzPolygon(-7.348293f,-58.136618f, -7.433057f,-58.214826f, -7.553880f,-58.220718f, -7.619386f,-58.199253f, -7.699793f,-58.279950f,
                    -7.772465f,-58.296936f, -7.840018f,-58.386491f, -7.907399f,-58.376803f, -8.093244f,-58.285527f, -8.130725f,-58.287026f,
                    -8.172392f,-58.323713f, -8.321075f,-58.315512f, -8.344705f,-58.349897f, -8.393233f,-58.354812f, -8.490757f,-58.418472f,
                    -8.571692f,-58.410872f, -8.600714f,-58.388627f, -8.695925f,-58.440913f, -8.721038f,-58.413618f, -8.704239f,-58.357314f,
                    -8.720000f,-58.326000f, -8.791710f,-58.409868f, -8.795372f,-60.257449f, -7.348293f,-60.257449f);
            poly[831] = new TzPolygon(-9.507748f,-54.852991f, -9.367000f,-56.671000f, -9.405829f,-56.760717f, -9.249875f,-56.816135f, -9.218699f,-56.964107f,
                    -9.233879f,-56.995826f, -9.185018f,-57.061119f, -9.099051f,-57.037578f, -8.922048f,-57.205291f, -8.913569f,-57.297473f,
                    -8.885925f,-57.315498f, -8.875409f,-57.395492f, -8.859975f,-57.417979f, -8.782793f,-57.425704f, -8.784829f,-57.465015f,
                    -8.744620f,-57.529388f, -8.761640f,-57.556745f, -8.748818f,-57.615558f, -8.694541f,-57.595336f, -8.640954f,-57.625396f,
                    -8.591889f,-57.620883f, -8.576383f,-57.648568f, -8.518282f,-57.633337f, -8.405803f,-57.690749f, -8.211994f,-57.639431f,
                    -8.152524f,-57.720447f, -8.095886f,-57.726088f, -7.971690f,-57.832370f, -7.671277f,-57.898862f, -7.652735f,-57.939681f,
                    -7.534771f,-57.973042f, -7.422430f,-58.048319f, -7.348293f,-58.134040f, -7.348293f,-54.852991f);
            poly[832] = new TzPolygon(-9.509851f,-54.852991f, -9.645000f,-53.133000f, -9.748706f,-51.569364f, -13.692378f,-51.569364f, -13.692378f,-54.852991f);
            poly[833] = new TzPolygon(-9.507748f,-54.852991f, -7.348293f,-54.852991f, -7.348293f,-52.593568f, -7.385987f,-52.644412f, -7.476279f,-52.691968f,
                    -7.511084f,-52.665881f, -7.583271f,-52.664690f, -7.648235f,-52.735344f, -7.817867f,-52.755433f, -7.866048f,-52.797975f,
                    -8.052924f,-52.698243f, -8.087284f,-52.714635f, -8.201856f,-52.669478f, -8.222074f,-52.626713f, -8.420269f,-52.649199f,
                    -8.542102f,-52.547414f, -8.571108f,-52.477278f, -8.566137f,-52.388256f, -8.626850f,-52.294708f, -8.714351f,-52.267517f,
                    -8.827187f,-52.277259f, -8.849137f,-52.258365f, -8.854096f,-52.197701f, -8.925626f,-52.108253f, -9.092381f,-52.046481f,
                    -9.163788f,-52.071205f, -9.187722f,-52.059151f, -9.189832f,-52.025997f, -9.219322f,-52.034532f, -9.273992f,-52.001480f,
                    -9.349514f,-52.085728f, -9.403502f,-52.099967f, -9.427780f,-52.148118f, -9.495018f,-52.147860f, -9.644281f,-52.202728f,
                    -9.664709f,-52.255465f, -9.648736f,-52.383533f, -9.587321f,-52.534129f, -9.601578f,-52.568405f, -9.647512f,-52.574291f,
                    -9.648147f,-52.603277f, -9.680658f,-52.619543f);
            poly[834] = new TzPolygon(-5.656006f,-53.833182f, -5.656006f,-52.684397f, -5.735777f,-52.658330f, -5.816239f,-52.546868f, -5.871674f,-52.554452f,
                    -5.909746f,-52.603296f, -6.024220f,-52.600740f, -6.084128f,-52.566542f, -6.128161f,-52.509823f, -6.276077f,-52.489279f,
                    -6.305916f,-52.471132f, -6.323532f,-52.409736f, -6.404354f,-52.350037f, -6.564949f,-52.277660f, -6.591612f,-52.218639f,
                    -6.547637f,-52.081771f, -6.710313f,-51.974096f, -6.886320f,-52.023831f, -6.897053f,-52.095773f, -6.935059f,-52.131256f,
                    -6.964548f,-52.334717f, -7.001692f,-52.423267f, -7.105024f,-52.459563f, -7.142700f,-52.539952f, -7.206091f,-52.575448f,
                    -7.330391f,-52.569421f, -7.348293f,-52.593568f, -7.348293f,-53.833182f);
            poly[835] = new TzPolygon(-3.963720f,-52.599364f, -3.972148f,-52.605578f, -4.083343f,-52.583367f, -4.165500f,-52.634832f, -4.190043f,-52.630723f,
                    -4.227341f,-52.695795f, -4.325072f,-52.733871f, -4.364305f,-52.723838f, -4.438751f,-52.652791f, -4.483196f,-52.709086f,
                    -4.656596f,-52.724191f, -4.750731f,-52.754854f, -4.825731f,-52.829882f, -4.897750f,-52.837800f, -5.005157f,-52.921855f,
                    -5.082516f,-52.929976f, -5.189791f,-52.898913f, -5.377332f,-52.889760f, -5.408598f,-52.864065f, -5.458191f,-52.734948f,
                    -5.509346f,-52.678722f, -5.571225f,-52.672022f, -5.617383f,-52.697018f, -5.656006f,-52.684397f, -5.656006f,-53.833182f,
                    -3.963720f,-53.833182f);
            poly[836] = new TzPolygon(-2.271433f,-53.833182f, -2.271433f,-52.145543f, -2.565518f,-51.994041f, -2.619703f,-51.991087f, -2.702329f,-52.029778f,
                    -2.835458f,-52.011159f, -2.916001f,-51.902196f, -3.101009f,-51.794203f, -3.130921f,-51.657439f, -3.155150f,-51.659226f,
                    -3.153172f,-51.608760f, -3.196974f,-51.620406f, -3.242465f,-51.691153f, -3.260383f,-51.678926f, -3.266332f,-51.709922f,
                    -3.318269f,-51.715497f, -3.333299f,-51.760567f, -3.358228f,-51.722862f, -3.412265f,-51.743584f, -3.481349f,-51.688111f,
                    -3.510755f,-51.745207f, -3.614334f,-51.838303f, -3.528187f,-51.948544f, -3.433605f,-51.945626f, -3.375168f,-52.004348f,
                    -3.280065f,-52.029321f, -3.234228f,-52.076816f, -3.216840f,-52.130684f, -3.236033f,-52.189470f, -3.339631f,-52.185738f,
                    -3.401562f,-52.210671f, -3.419109f,-52.225259f, -3.410395f,-52.262579f, -3.484153f,-52.264744f, -3.644003f,-52.373578f,
                    -3.789506f,-52.578465f, -3.864336f,-52.596051f, -3.941910f,-52.583283f, -3.963720f,-52.599364f, -3.963720f,-53.833182f);
            poly[837] = new TzPolygon(-0.579146f,-52.652003f, -0.593881f,-52.639497f, -0.579146f,-52.591262f, -0.579146f,-52.553743f, -0.592654f,-52.526124f,
                    -0.732208f,-52.495204f, -0.787399f,-52.526122f, -0.817069f,-52.514779f, -0.853933f,-52.545021f, -0.826316f,-52.453710f,
                    -0.877000f,-52.403000f, -0.914382f,-52.400854f, -0.935710f,-52.437259f, -1.009000f,-52.414000f, -1.050000f,-52.427000f,
                    -1.062000f,-52.358000f, -1.116000f,-52.333000f, -1.146000f,-52.120000f, -1.218000f,-52.109000f, -1.236000f,-52.070000f,
                    -1.219000f,-52.047000f, -1.186000f,-52.064000f, -1.171000f,-51.991000f, -1.116814f,-51.979523f, -1.167000f,-51.961000f,
                    -1.132000f,-51.926000f, -1.166000f,-51.882000f, -1.180968f,-51.909927f, -1.280889f,-51.900380f, -1.434735f,-51.955011f,
                    -1.490627f,-51.926051f, -1.516168f,-51.846453f, -1.598946f,-52.024070f, -1.618971f,-52.159274f, -1.661343f,-52.187387f,
                    -1.692092f,-52.252444f, -1.734757f,-52.263777f, -1.811579f,-52.230718f, -2.089464f,-52.211863f, -2.192955f,-52.185972f,
                    -2.271433f,-52.145543f, -2.271433f,-53.833182f, -0.579146f,-53.833182f);
            poly[838] = new TzPolygon(1.848602f,-56.097000f, 1.835521f,-55.983212f, 1.888028f,-55.903854f, 1.986466f,-55.936349f, 1.990519f,-55.913739f,
                    2.041078f,-55.903102f, 2.057741f,-55.932820f, 2.078634f,-55.929095f, 2.088428f,-55.966816f, 2.167602f,-56.003072f,
                    2.184641f,-56.055046f, 2.227783f,-56.042880f, 2.249186f,-56.097000f, 2.317191f,-56.097000f, 2.321170f,-56.093761f,
                    2.372277f,-56.090122f, 2.334981f,-56.050601f, 2.342469f,-56.021814f, 2.366272f,-56.039965f, 2.420327f,-55.987015f,
                    2.452820f,-56.011511f, 2.489609f,-55.977487f, 2.504548f,-55.992877f, 2.527329f,-55.978236f, 2.530541f,-55.924157f,
                    2.462176f,-55.838819f, 2.455237f,-55.766629f, 2.410445f,-55.746961f, 2.399167f,-55.716944f, 2.421543f,-55.698344f,
                    2.443237f,-55.499712f, 2.418360f,-55.385327f, 2.447988f,-55.345572f, 2.475558f,-55.356155f, 2.515368f,-55.320184f,
                    2.503380f,-55.234736f, 2.559342f,-55.172796f, 2.567624f,-55.123404f, 2.525640f,-55.103017f, 2.590930f,-55.003738f,
                    2.585203f,-54.965091f, 1.113140f,-54.965091f, 1.113140f,-56.097000f);
            poly[839] = new TzPolygon(1.393358f,-53.833182f, 1.393595f,-53.854160f, 1.408963f,-53.848838f, 1.404903f,-53.888092f, 1.440462f,-53.876888f,
                    1.456625f,-53.894259f, 1.437492f,-53.934754f, 1.470758f,-53.922421f, 1.478050f,-53.991568f, 1.523632f,-54.005169f,
                    1.493483f,-54.083125f, 1.533970f,-54.082824f, 1.563517f,-54.116933f, 1.598703f,-54.100725f, 1.601860f,-54.135773f,
                    1.611747f,-54.120618f, 1.651893f,-54.146340f, 1.664937f,-54.182404f, 1.632608f,-54.190920f, 1.749627f,-54.312001f,
                    1.747108f,-54.345319f, 1.773908f,-54.376831f, 1.755641f,-54.387811f, 1.770375f,-54.464637f, 1.754175f,-54.495435f,
                    1.795369f,-54.575081f, 1.774899f,-54.670153f, 1.786782f,-54.745970f, 1.809181f,-54.757742f, 1.841569f,-54.736527f,
                    1.950768f,-54.777325f, 1.959283f,-54.769780f, 1.959283f,-53.833182f);
            poly[840] = new TzPolygon(2.209549f,-54.399136f, 2.210833f,-54.463889f, 2.265556f,-54.537778f, 2.289722f,-54.515000f, 2.316389f,-54.541944f,
                    2.333698f,-54.602780f, 2.354270f,-54.572203f, 2.338536f,-54.505196f, 2.392735f,-54.504504f, 2.433976f,-54.473760f,
                    2.436233f,-54.420328f, 2.457414f,-54.399136f);
            poly[841] = new TzPolygon(2.805427f,-54.399136f, 2.461419f,-54.399136f, 2.436233f,-54.420328f, 2.433976f,-54.473760f, 2.392735f,-54.504504f,
                    2.338536f,-54.505196f, 2.332285f,-54.526094f, 2.354270f,-54.572203f, 2.321111f,-54.628889f, 2.324722f,-54.688611f,
                    2.378611f,-54.712500f, 2.403333f,-54.683889f, 2.453889f,-54.689167f, 2.471667f,-54.753611f, 2.435556f,-54.806389f,
                    2.439886f,-54.868459f, 2.518489f,-54.935354f, 2.583595f,-54.954239f, 2.585203f,-54.965091f, 2.805427f,-54.965091f);
            poly[842] = new TzPolygon(2.585203f,-54.965091f, 2.583595f,-54.954239f, 2.518489f,-54.935354f, 2.313064f,-54.793775f, 2.266709f,-54.810946f,
                    2.206311f,-54.769949f, 2.150586f,-54.813071f, 2.078793f,-54.818782f, 2.034643f,-54.807204f, 1.976553f,-54.754478f,
                    1.959283f,-54.769780f, 1.959283f,-54.965091f);
            poly[843] = new TzPolygon(2.210239f,-54.399136f, 2.208889f,-54.365833f, 2.164444f,-54.328056f, 2.146667f,-54.249167f, 2.172500f,-54.180556f,
                    2.113611f,-54.123333f, 2.135556f,-54.079444f, 2.194444f,-54.057500f, 2.181389f,-54.013056f, 2.219167f,-53.940833f,
                    2.271944f,-53.931944f, 2.267778f,-53.886667f, 2.302778f,-53.866944f, 2.307330f,-53.833182f, 1.959283f,-53.833182f,
                    1.959283f,-54.399136f);
            poly[844] = new TzPolygon(2.805427f,-54.206802f, 2.776701f,-54.205764f, 2.629595f,-54.317442f, 2.521251f,-54.348794f, 2.461419f,-54.399136f,
                    2.805427f,-54.399136f);
            poly[845] = new TzPolygon(1.113140f,-53.833182f, 1.113140f,-53.463759f, 1.080004f,-53.460914f, 1.036818f,-53.427382f, 0.930899f,-53.420126f,
                    0.854371f,-53.302163f, 0.770775f,-53.200589f, 0.694640f,-53.150290f, 0.679830f,-53.109991f, 0.584389f,-53.155590f,
                    0.475490f,-53.159951f, 0.445116f,-53.181115f, 0.391775f,-53.165252f, 0.365235f,-53.184311f, 0.257047f,-53.092774f,
                    0.230959f,-53.108450f, 0.193677f,-53.096309f, 0.080780f,-53.005777f, 0.049990f,-53.018130f, 0.018448f,-52.984895f,
                    -0.034665f,-52.987842f, -0.144973f,-52.937093f, -0.151066f,-52.841204f, -0.285729f,-52.740119f, -0.315273f,-52.684399f,
                    -0.369728f,-52.678157f, -0.385292f,-52.707545f, -0.425759f,-52.677554f, -0.460133f,-52.703562f, -0.549633f,-52.677052f,
                    -0.579146f,-52.652003f, -0.579146f,-53.833182f);
            poly[846] = new TzPolygon(-0.579146f,-52.591262f, -0.572092f,-52.568168f, -0.579146f,-52.553743f);
            poly[847] = new TzPolygon(2.805427f,-52.701273f, 2.354921f,-52.701273f, 2.281581f,-52.858262f, 2.186179f,-52.902663f, 2.194554f,-52.934445f,
                    2.167271f,-52.983894f, 2.222500f,-53.105000f, 2.208333f,-53.239167f, 2.186027f,-53.278992f, 2.253333f,-53.216667f,
                    2.353333f,-53.328333f, 2.316389f,-53.352222f, 2.257500f,-53.458611f, 2.249167f,-53.529722f, 2.312222f,-53.733889f,
                    2.344444f,-53.719444f, 2.373056f,-53.751111f, 2.350556f,-53.802500f, 2.309444f,-53.817500f, 2.307330f,-53.833182f,
                    2.805427f,-53.833182f);
            poly[848] = new TzPolygon(1.393358f,-53.833182f, 1.393107f,-53.810961f, 1.415809f,-53.825925f, 1.425581f,-53.809119f, 1.387243f,-53.738435f,
                    1.432833f,-53.723336f, 1.422835f,-53.700326f, 1.383820f,-53.717320f, 1.373071f,-53.682054f, 1.408928f,-53.652728f,
                    1.340896f,-53.661150f, 1.358111f,-53.598287f, 1.337633f,-53.578931f, 1.341015f,-53.543594f, 1.320646f,-53.539534f,
                    1.301254f,-53.568781f, 1.263370f,-53.528933f, 1.211581f,-53.542918f, 1.250216f,-53.435630f, 1.163398f,-53.406083f,
                    1.134909f,-53.465628f, 1.113140f,-53.463759f, 1.113140f,-53.833182f);
            poly[849] = new TzPolygon(2.805427f,-52.460509f, 2.658948f,-52.526181f, 2.636944f,-52.555107f, 2.580248f,-52.526030f, 2.550042f,-52.560563f,
                    2.521360f,-52.550583f, 2.474813f,-52.618508f, 2.451998f,-52.609433f, 2.432128f,-52.644964f, 2.373960f,-52.660520f,
                    2.354921f,-52.701273f, 2.805427f,-52.701273f);
            poly[850] = new TzPolygon(4.497713f,-56.097000f, 4.497713f,-54.450728f, 4.419722f,-54.440556f, 4.416207f,-54.415744f, 4.377058f,-54.417878f,
                    4.350923f,-54.385724f, 4.202654f,-54.396180f, 4.144626f,-54.323096f, 4.049060f,-54.357870f, 4.015002f,-54.318865f,
                    3.933333f,-54.289373f, 3.908455f,-54.248859f, 3.860055f,-54.236573f, 3.846573f,-54.191432f, 3.806615f,-54.198437f,
                    3.797916f,-54.126840f, 3.715196f,-54.078994f, 3.675445f,-54.083339f, 3.634973f,-54.050979f, 3.649319f,-54.007628f,
                    3.607456f,-53.979968f, 3.537236f,-54.009320f, 3.427073f,-54.011871f, 3.383789f,-54.059835f, 3.307490f,-54.066584f,
                    3.286256f,-54.128097f, 3.150779f,-54.214045f, 3.126416f,-54.210407f, 3.135435f,-54.183599f, 3.108115f,-54.173808f,
                    3.072313f,-54.174362f, 3.064080f,-54.194711f, 3.015218f,-54.169726f, 2.984569f,-54.181711f, 2.968434f,-54.160540f,
                    2.920989f,-54.191982f, 2.854723f,-54.179848f, 2.829119f,-54.207658f, 2.805427f,-54.206802f, 2.805427f,-56.097000f);
            poly[851] = new TzPolygon(4.497713f,-54.450728f, 4.509167f,-54.452222f, 4.593333f,-54.420000f, 4.714167f,-54.435833f, 4.747778f,-54.477500f,
                    4.898611f,-54.486389f, 4.936571f,-54.445255f, 5.084167f,-54.405556f, 5.240556f,-54.296667f, 5.315000f,-54.193056f,
                    5.551073f,-54.007772f, 5.629444f,-54.025278f, 5.688611f,-54.009444f, 5.978000f,-53.843336f, 5.973019f,-53.833182f,
                    4.497713f,-53.833182f);
            poly[852] = new TzPolygon(2.805427f,-52.460509f, 2.891049f,-52.422122f, 2.917353f,-52.377061f, 2.947570f,-52.393193f, 3.078800f,-52.325965f,
                    3.126440f,-52.352973f, 3.171378f,-52.331107f, 3.173522f,-52.301351f, 3.227270f,-52.292286f, 3.253042f,-52.261923f,
                    3.239441f,-52.236381f, 3.298745f,-52.189622f, 3.627774f,-51.988706f, 3.706957f,-51.971035f, 3.724219f,-51.921484f,
                    3.781984f,-51.919006f, 3.888877f,-51.797307f, 3.974056f,-51.777827f, 4.052762f,-51.658667f, 4.235524f,-51.614710f,
                    4.394939f,-51.645669f, 4.508337f,-51.637160f, 4.587060f,-51.569364f, 2.805427f,-51.569364f);
            poly[853] = new TzPolygon(9.128479f,-72.858752f, 9.132962f,-72.881197f, 9.102942f,-72.887292f, 9.091651f,-72.947697f, 9.142360f,-72.986913f,
                    9.181240f,-72.955915f, 9.220787f,-72.996219f, 9.252937f,-72.985821f, 9.291294f,-73.010613f, 9.263387f,-73.073045f,
                    9.225558f,-73.090361f, 9.228309f,-73.131298f, 9.177167f,-73.176580f, 9.183647f,-73.213782f, 9.158209f,-73.250146f,
                    9.173405f,-73.347262f, 9.217530f,-73.352963f, 9.213054f,-73.333753f, 9.402898f,-73.240894f, 9.445538f,-73.189263f,
                    9.469263f,-73.203259f, 9.480631f,-73.172017f, 9.550467f,-73.136668f, 9.556277f,-73.085190f, 9.678263f,-73.054816f,
                    9.837627f,-72.945436f, 9.875025f,-72.992808f, 9.888767f,-72.977466f, 9.923865f,-72.999036f, 10.066003f,-72.954089f,
                    10.112724f,-72.911633f, 10.446657f,-72.893301f, 10.475010f,-72.858752f);
            poly[854] = new TzPolygon(8.603884f,-72.644071f, 8.614665f,-72.655109f, 9.105581f,-72.766384f, 9.103230f,-72.796340f, 9.140538f,-72.821919f,
                    9.121627f,-72.824447f, 9.128479f,-72.858752f, 10.475010f,-72.858752f, 10.485797f,-72.845609f, 10.570206f,-72.820645f,
                    10.651463f,-72.735114f, 10.740116f,-72.716567f, 10.763971f,-72.679952f, 10.879546f,-72.648966f, 10.882702f,-72.612404f,
                    10.940204f,-72.553774f, 11.059113f,-72.481635f, 11.085886f,-72.497640f, 11.127658f,-72.443589f, 11.151373f,-72.349314f,
                    11.140186f,-72.249416f, 11.646267f,-71.971363f, 11.686839f,-71.782694f, 11.812129f,-71.378405f, 11.830439f,-71.386725f,
                    11.849232f,-71.341823f, 11.961238f,-70.927056f, 8.603884f,-70.927056f);
            poly[855] = new TzPolygon(12.157405f,-70.927056f, 12.287395f,-71.048794f, 12.401962f,-71.079828f, 12.523406f,-71.146887f, 12.599194f,-71.122362f,
                    12.662434f,-71.070873f, 12.702673f,-71.002730f, 12.716034f,-70.927056f);
            poly[856] = new TzPolygon(12.157405f,-70.927056f, 12.716034f,-70.927056f, 12.716688f,-70.923351f, 12.558597f,-70.416674f, 12.350026f,-70.416662f,
                    12.350000f,-70.164167f, 12.365000f,-70.140278f, 12.262778f,-69.736667f, 12.218782f,-69.661226f, 8.603884f,-69.661226f,
                    8.603884f,-70.927056f, 11.961238f,-70.927056f);
            poly[857] = new TzPolygon(12.218782f,-69.661226f, 11.879296f,-69.079095f, 11.758230f,-68.954252f, 11.741638f,-68.829117f, 11.666679f,-68.600038f,
                    11.666678f,-67.990797f, 8.603884f,-67.990797f, 8.603884f,-69.661226f);
            poly[858] = new TzPolygon(12.592000f,-69.147203f, 12.524000f,-68.966469f, 12.466000f,-68.904144f, 12.376000f,-68.857011f, 12.356000f,-68.767062f,
                    12.292000f,-68.672990f, 11.932000f,-68.441347f, 11.818000f,-68.518527f, 11.777000f,-68.645296f, 11.864000f,-68.912221f,
                    12.043000f,-69.210695f, 12.211000f,-69.342189f, 12.381000f,-69.367349f, 12.463000f,-69.349015f, 12.532000f,-69.300835f,
                    12.578000f,-69.229781f);
            poly[859] = new TzPolygon(11.562837f,-67.990797f, 11.562837f,-62.803121f, 10.947917f,-61.729444f, 10.714445f,-61.802778f, 10.588889f,-61.802778f,
                    10.588611f,-61.862500f, 10.046111f,-62.083056f, 9.986667f,-61.855000f, 9.970000f,-61.500000f, 9.874531f,-61.207427f,
                    9.799487f,-61.093013f, 9.751163f,-60.900960f, 8.685788f,-59.542708f, 8.603884f,-59.773739f, 8.603884f,-67.990797f);
            poly[860] = new TzPolygon(12.324735f,-61.861472f, 12.494000f,-61.702626f, 12.596653f,-61.665747f, 12.530136f,-61.382722f, 12.516655f,-61.173214f,
                    12.404000f,-61.207000f, 12.324735f,-61.280369f);
            poly[861] = new TzPolygon(13.583000f,-61.133776f, 13.583000f,-60.791134f, 13.536000f,-60.837991f, 13.508000f,-60.950006f, 13.580148f,-61.130393f);
            poly[862] = new TzPolygon(-28.570615f,16.475659f, -28.572880f,16.468250f, -28.632768f,16.453131f, -28.800418f,16.333521f, -28.685516f,16.158932f,
                    -28.570615f,16.040387f);
            poly[863] = new TzPolygon(-28.570615f,17.396573f, -28.570615f,19.544312f, -28.587130f,19.536050f, -28.601000f,19.503870f, -28.706090f,19.466820f,
                    -28.736820f,19.403650f, -28.743930f,19.267700f, -28.812590f,19.239190f, -28.869640f,19.265030f, -28.885420f,19.296390f,
                    -28.908180f,19.285380f, -28.902520f,19.245200f, -28.949980f,19.191380f, -28.969450f,19.118470f, -28.929020f,19.008740f,
                    -28.870530f,18.972240f, -28.844400f,18.855710f, -28.840450f,18.632120f, -28.889460f,18.512180f, -28.900820f,18.423470f,
                    -28.879390f,18.263490f, -28.916150f,18.188440f, -28.870650f,18.083120f, -28.874270f,18.046070f, -28.809500f,17.993520f,
                    -28.764090f,17.917600f, -28.739910f,17.749510f, -28.773690f,17.647070f, -28.760670f,17.616110f, -28.694650f,17.598860f,
                    -28.685590f,17.568380f, -28.722870f,17.420360f, -28.574220f,17.431770f);
            poly[864] = new TzPolygon(-34.965818f,19.544312f, -28.570615f,19.544312f, -28.570615f,29.455710f, -32.001322f,29.455710f, -32.217014f,29.260385f,
                    -32.701593f,28.732420f, -32.855333f,28.529802f, -32.957649f,28.321425f, -33.061846f,28.238536f, -33.200424f,28.049854f,
                    -33.285753f,27.878084f, -33.691140f,27.245590f, -33.747017f,27.121748f, -34.029603f,26.372758f, -34.240225f,25.691531f,
                    -34.413295f,24.856936f, -34.294419f,22.990015f, -34.378139f,22.260436f, -34.530805f,22.031103f, -34.570496f,21.890081f,
                    -34.668559f,20.916269f, -35.009194f,20.125081f, -35.033759f,20.010019f);
            poly[865] = new TzPolygon(-28.570615f,16.475659f, -28.533880f,16.595830f, -28.472350f,16.672430f, -28.499450f,16.724770f, -28.453020f,16.768930f,
                    -28.396840f,16.768960f, -28.361950f,16.808440f, -28.272790f,16.754490f, -28.269020f,16.824740f, -28.222020f,16.803060f,
                    -28.211690f,16.856060f, -28.166680f,16.831280f, -28.172880f,16.887930f, -28.074550f,16.898460f, -28.058730f,16.973810f,
                    -28.075480f,17.002030f, -28.032820f,17.078510f, -28.034887f,17.080560f, -28.570615f,17.080560f);
            poly[866] = new TzPolygon(-28.570615f,17.396573f, -28.568940f,17.380220f, -28.475540f,17.333100f, -28.439030f,17.348670f, -28.436960f,17.384800f,
                    -28.399580f,17.410000f, -28.570615f,17.410000f);
            poly[867] = new TzPolygon(-28.399580f,17.410000f, -28.295600f,17.382140f, -28.225790f,17.333270f, -28.247790f,17.214560f, -28.203430f,17.182450f,
                    -28.108230f,17.191930f, -28.093060f,17.138230f, -28.032820f,17.080727f, -28.032820f,17.410000f);
            poly[868] = new TzPolygon(-17.390082f,17.410000f, -17.391599f,14.216120f, -17.410048f,14.212641f, -17.438732f,14.102125f, -17.414675f,14.015962f,
                    -17.433032f,13.955744f, -17.361674f,13.899746f, -17.141411f,13.517756f, -17.091584f,13.521684f, -17.010657f,13.462121f,
                    -16.974122f,13.352983f, -17.001320f,13.246339f, -16.963485f,13.168592f, -16.982309f,12.983381f, -17.171882f,12.713012f,
                    -17.172918f,12.672225f, -17.231577f,12.605614f, -17.247705f,12.541325f, -17.241959f,12.478201f, -17.264055f,12.445918f,
                    -17.222583f,12.436147f, -17.206483f,12.405918f, -17.233798f,12.369511f, -17.218725f,12.351356f, -17.240072f,12.249843f,
                    -17.161959f,12.161349f, -17.141877f,12.079883f, -17.181981f,11.941650f, -17.273769f,11.794818f, -17.250000f,11.748939f,
                    -17.250000f,11.542102f, -16.839570f,11.566921f, -16.681235f,11.490233f, -16.554324f,11.460979f, -16.467022f,11.476127f,
                    -16.204559f,11.589178f, -16.052299f,11.586924f, -15.948462f,11.531774f, -15.827162f,11.531171f, -15.662271f,11.610470f,
                    -15.609703f,11.702113f, -15.609703f,17.410000f);
            poly[869] = new TzPolygon(-28.570615f,19.544312f, -28.527680f,19.565790f, -28.510930f,19.625200f, -28.531090f,19.668340f, -28.485740f,19.738630f,
                    -28.508300f,19.813250f, -28.442730f,19.877050f, -28.427820f,19.999160f, -25.330387f,19.999077f, -25.330387f,20.421428f,
                    -28.570615f,20.421428f);
            poly[870] = new TzPolygon(-26.140444f,20.858664f, -26.140444f,21.927141f, -26.668094f,21.927141f, -26.659689f,21.823459f, -26.675893f,21.787415f,
                    -26.695158f,21.769098f, -26.770724f,21.793350f, -26.802320f,21.780990f, -26.861270f,21.694700f, -26.866650f,21.626880f,
                    -26.839900f,21.575570f, -26.861840f,21.525380f, -26.822130f,21.404200f, -26.873652f,21.133666f, -26.796300f,20.898120f,
                    -26.819270f,20.820700f, -26.841660f,20.816340f, -26.866350f,20.763510f, -26.870140f,20.714980f, -26.905967f,20.687731f,
                    -26.840039f,20.682511f, -26.828786f,20.644931f, -26.786523f,20.621967f, -26.592177f,20.632371f, -26.514271f,20.604604f,
                    -26.443589f,20.617644f, -26.397360f,20.693374f);
            poly[871] = new TzPolygon(-25.330387f,20.549922f, -25.389223f,20.562036f, -25.394550f,20.601450f, -25.428003f,20.603086f, -25.425072f,20.630937f,
                    -25.461874f,20.622275f, -25.450100f,20.672970f, -25.475252f,20.636163f, -25.519582f,20.629782f, -25.592363f,20.698419f,
                    -25.635752f,20.651556f, -25.635006f,20.687540f, -25.686363f,20.677122f, -25.716297f,20.716710f, -25.770017f,20.730998f,
                    -25.780633f,20.762952f, -25.822917f,20.739748f, -25.801138f,20.786729f, -25.853770f,20.783002f, -25.868332f,20.812756f,
                    -25.920194f,20.803538f, -25.959447f,20.840679f, -26.007501f,20.816594f, -26.081693f,20.842087f, -26.105367f,20.821092f,
                    -26.133663f,20.863027f, -26.140444f,20.858664f, -26.140444f,20.421428f, -25.330387f,20.421428f);
            poly[872] = new TzPolygon(-25.330387f,23.011181f, -25.335860f,23.011320f, -25.339860f,22.977940f, -25.381140f,22.970000f, -25.422310f,22.909950f,
                    -25.468390f,22.885740f, -25.486850f,22.900440f, -25.490170f,22.846370f, -25.533510f,22.853490f, -25.582420f,22.814070f,
                    -25.615170f,22.853370f, -25.632770f,22.800420f, -25.657770f,22.830210f, -25.690470f,22.821480f, -25.732840f,22.769320f,
                    -25.788660f,22.759330f, -25.793660f,22.734580f, -25.823267f,22.781717f, -25.892960f,22.712030f, -25.918000f,22.749240f,
                    -25.950090f,22.723900f, -26.015240f,22.724745f, -26.017900f,22.665710f, -26.073460f,22.673118f, -26.094500f,22.631720f,
                    -26.149219f,22.604859f, -26.142098f,22.578233f, -26.223450f,22.555180f, -26.199990f,22.473360f, -26.227900f,22.454130f,
                    -26.224420f,22.420060f, -26.272700f,22.402910f, -26.285780f,22.363110f, -26.325530f,22.362950f, -26.349940f,22.242330f,
                    -26.401133f,22.189983f, -26.424780f,22.200240f, -26.508589f,22.163480f, -26.581345f,22.077259f, -26.632661f,22.051473f,
                    -26.669849f,21.948791f, -26.668094f,21.927141f, -25.330387f,21.927141f);
            poly[873] = new TzPolygon(-25.330387f,23.080325f, -25.331970f,23.078690f, -25.330387f,23.075817f);
            poly[874] = new TzPolygon(-25.330387f,19.999077f, -24.763751f,19.999062f, -24.833057f,20.090539f, -24.884963f,20.121596f, -24.923600f,20.259120f,
                    -24.980620f,20.296510f, -25.034375f,20.384046f, -25.061750f,20.378830f, -25.082270f,20.412355f, -25.154503f,20.431441f,
                    -25.156696f,20.469348f, -25.199160f,20.446570f, -25.228420f,20.498940f, -25.268980f,20.496440f, -25.286170f,20.545880f,
                    -25.317140f,20.513900f, -25.320472f,20.547881f, -25.330387f,20.549922f);
            poly[875] = new TzPolygon(-25.330387f,23.011181f, -25.297230f,23.010340f, -25.312930f,23.030790f, -25.289940f,23.058420f, -25.318610f,23.054440f,
                    -25.330387f,23.075817f);
            poly[876] = new TzPolygon(-25.330387f,23.080325f, -25.304180f,23.107390f, -25.317420f,23.134540f, -25.273420f,23.212020f, -25.274100f,23.278050f,
                    -25.294090f,23.295010f, -25.285140f,23.355550f, -25.315800f,23.414300f, -25.290004f,23.432855f, -25.330387f,23.432855f);
            poly[877] = new TzPolygon(-22.090159f,19.999147f, -25.330387f,19.999154f, -25.330387f,17.410000f, -22.090159f,17.410000f);
            poly[878] = new TzPolygon(-25.330387f,23.495008f, -25.330387f,25.692772f, -25.469921f,25.662603f, -25.637943f,25.581280f, -25.684239f,25.513883f,
                    -25.771152f,25.337117f, -25.764394f,25.121306f, -25.721419f,25.038116f, -25.811055f,24.897122f, -25.825693f,24.794257f,
                    -25.803883f,24.728325f, -25.823921f,24.683178f, -25.733024f,24.447024f, -25.762427f,24.400992f, -25.758313f,24.357220f,
                    -25.711003f,24.326735f, -25.726032f,24.285461f, -25.693234f,24.287879f, -25.706748f,24.260671f, -25.643839f,24.226944f,
                    -25.620144f,24.191010f, -25.630058f,24.160052f, -25.608195f,24.157015f, -25.643005f,24.085964f, -25.630771f,24.067605f,
                    -25.651297f,24.061944f, -25.634072f,24.030093f, -25.650899f,24.005307f, -25.624664f,24.012229f, -25.614548f,23.969961f,
                    -25.638234f,23.928121f, -25.576443f,23.879240f, -25.567294f,23.839465f, -25.540935f,23.835751f, -25.545718f,23.809251f,
                    -25.511608f,23.820083f, -25.503013f,23.762938f, -25.446292f,23.729332f, -25.462722f,23.703385f, -25.441387f,23.666577f,
                    -25.416255f,23.669049f, -25.431580f,23.637460f, -25.383920f,23.616000f, -25.396460f,23.589310f, -25.354660f,23.559590f,
                    -25.351570f,23.496180f);
            poly[879] = new TzPolygon(-25.290004f,23.432855f, -25.276970f,23.442230f, -25.276750f,23.465790f, -25.297740f,23.458140f, -25.317950f,23.494320f,
                    -25.330387f,23.495008f, -25.330387f,23.432855f);
            poly[880] = new TzPolygon(-25.330387f,25.692772f, -25.289181f,25.701681f, -24.924003f,25.860018f, -24.914933f,25.882476f, -24.753761f,25.848101f,
                    -24.747680f,25.955827f, -24.645859f,26.409067f, -24.614160f,26.444282f, -25.330387f,26.444282f);
            poly[881] = new TzPolygon(-23.710273f,26.444282f, -23.710273f,26.970650f, -23.830736f,26.958347f, -23.851342f,26.932503f, -23.874114f,26.955132f,
                    -24.089470f,26.884820f, -24.106560f,26.860200f, -24.160110f,26.879130f, -24.179130f,26.864480f, -24.189501f,26.883142f,
                    -24.263576f,26.856211f, -24.306752f,26.785935f, -24.304237f,26.733484f, -24.344145f,26.675676f, -24.381112f,26.663636f,
                    -24.410788f,26.587263f, -24.487944f,26.509944f, -24.590480f,26.470590f, -24.614160f,26.444282f);
            poly[882] = new TzPolygon(-23.710273f,26.970650f, -23.702807f,26.971413f, -23.688023f,27.002312f, -23.637959f,27.010103f, -23.682676f,27.036909f,
                    -23.670908f,27.070547f, -23.643300f,27.081145f, -23.612665f,27.059168f, -23.597763f,27.105162f, -23.559323f,27.114118f,
                    -23.568466f,27.154126f, -23.523971f,27.134548f, -23.534205f,27.201212f, -23.498038f,27.192819f, -23.462998f,27.302833f,
                    -23.400352f,27.337171f, -23.427003f,27.374634f, -23.399249f,27.377333f, -23.389208f,27.408208f, -23.413236f,27.400950f,
                    -23.426753f,27.421567f, -23.384650f,27.441615f, -23.385613f,27.528416f, -23.340585f,27.567361f, -23.217113f,27.600830f,
                    -23.225453f,27.649987f, -23.196191f,27.689376f, -23.229943f,27.742540f, -23.169113f,27.785435f, -23.133751f,27.766923f,
                    -23.134732f,27.809310f, -23.106227f,27.814230f, -23.051971f,27.935635f, -22.963211f,27.935178f, -22.955850f,27.949996f,
                    -23.710273f,27.949996f);
            poly[883] = new TzPolygon(-22.090159f,29.275771f, -22.195471f,29.375304f, -22.178705f,29.217704f, -22.215824f,29.150273f, -22.217134f,29.035870f,
                    -22.305773f,28.967072f, -22.376079f,28.971935f, -22.460798f,28.917836f, -22.453557f,28.849292f, -22.488344f,28.831407f,
                    -22.588510f,28.514880f, -22.571035f,28.479876f, -22.574276f,28.339595f, -22.687179f,28.180886f, -22.774948f,28.145566f,
                    -22.833355f,28.041534f, -22.911897f,28.038480f, -22.954934f,27.949996f, -22.090159f,27.949996f);
            poly[884] = new TzPolygon(-22.090159f,29.275521f, -22.090159f,29.455710f, -22.168830f,29.455710f, -22.195188f,29.373921f);
            poly[885] = new TzPolygon(-18.849931f,17.410000f, -18.849931f,20.998919f, -22.000342f,20.998739f, -21.999917f,19.999147f, -22.090159f,19.999147f,
                    -22.090159f,17.410000f);
            poly[886] = new TzPolygon(-17.390082f,17.410000f, -17.389601f,18.421455f, -17.582071f,18.562916f, -17.601183f,18.619015f, -17.635835f,18.623853f,
                    -17.736887f,18.742493f, -17.735681f,18.775409f, -17.765779f,18.789060f, -17.772233f,18.835955f, -17.819614f,18.903182f,
                    -17.836911f,19.115675f, -17.808967f,19.134979f, -17.805992f,19.173952f, -17.833923f,19.329107f, -17.854777f,19.327430f,
                    -17.874623f,19.547385f, -17.849466f,19.673821f, -17.911057f,19.756734f, -17.867960f,19.809121f, -17.883527f,19.863068f,
                    -17.862427f,19.924904f, -17.905667f,20.027787f, -17.885410f,20.057999f, -17.910927f,20.108000f, -17.876535f,20.172501f,
                    -17.892762f,20.245282f, -17.866589f,20.267479f, -17.862287f,20.326055f, -17.897477f,20.369971f, -17.907796f,20.421428f,
                    -18.849931f,20.421428f, -18.849931f,17.410000f);
            poly[887] = new TzPolygon(-18.849931f,20.998919f, -18.317569f,20.998950f, -18.317647f,21.453045f, -18.000819f,23.098367f, -18.000786f,23.296928f,
                    -18.051877f,23.334834f, -18.082758f,23.324181f, -18.174641f,23.402951f, -18.208107f,23.397462f, -18.211625f,23.432855f,
                    -18.849931f,23.432855f);
            poly[888] = new TzPolygon(-17.229817f,22.935474f, -17.229817f,23.432855f, -17.636332f,23.432855f, -17.636669f,23.431158f, -17.576314f,23.393338f,
                    -17.546646f,23.241295f, -17.474858f,23.177693f, -17.466567f,23.136133f, -17.422660f,23.128194f, -17.413513f,23.087139f,
                    -17.337742f,23.058643f, -17.346696f,23.043989f, -17.298122f,22.997069f, -17.284124f,23.008831f);
            poly[889] = new TzPolygon(-17.907796f,20.421428f, -17.914814f,20.456425f, -17.950348f,20.474354f, -17.981770f,20.540024f, -17.976794f,20.645468f,
                    -18.037477f,20.802701f, -18.029747f,20.866687f, -18.003492f,20.864135f, -17.957942f,20.976990f, -17.928941f,21.210167f,
                    -18.026577f,21.422779f, -17.633635f,23.432855f, -18.211625f,23.432855f, -18.208107f,23.397462f, -18.174641f,23.402951f,
                    -18.082758f,23.324181f, -18.051877f,23.334834f, -18.000786f,23.296928f, -18.000819f,23.098367f, -18.317647f,21.453045f,
                    -18.317569f,20.998950f, -18.849931f,20.998919f, -18.849931f,20.421428f);
            poly[890] = new TzPolygon(-17.229817f,22.935474f, -17.201125f,22.896718f, -17.165340f,22.801894f, -17.119929f,22.791612f, -16.835108f,22.492155f,
                    -16.814755f,22.496796f, -16.698761f,22.350822f, -16.574116f,22.252594f, -16.573296f,22.218053f, -16.489624f,22.149993f,
                    -16.490233f,22.120844f, -16.475143f,22.148257f, -16.445372f,22.125382f, -16.439482f,22.139753f, -16.348122f,22.120447f,
                    -16.290252f,22.070685f, -16.260905f,22.081255f, -16.206397f,21.999351f, -15.609703f,22.000165f, -15.609703f,23.432855f,
                    -17.229817f,23.432855f);
            poly[891] = new TzPolygon(-19.748102f,26.444282f, -19.744697f,26.432339f, -19.671146f,26.391709f, -19.664215f,26.328035f, -19.614851f,26.358608f,
                    -19.576126f,26.312335f, -19.585689f,26.246967f, -19.546352f,26.170226f, -19.272018f,26.072390f, -19.107931f,25.964528f,
                    -19.066674f,25.965343f, -19.031537f,25.996584f, -18.912961f,25.951755f, -18.849931f,25.846455f, -18.849931f,26.444282f);
            poly[892] = new TzPolygon(-19.748102f,26.444282f, -19.781724f,26.562198f, -19.881291f,26.618882f, -19.887721f,26.702768f, -19.939910f,26.726518f,
                    -19.961765f,26.851407f, -20.014502f,26.978865f, -20.008846f,27.040349f, -20.079619f,27.143292f, -20.081983f,27.205938f,
                    -20.296348f,27.300136f, -20.498942f,27.288662f, -20.468192f,27.362311f, -20.482061f,27.433806f, -20.467510f,27.471402f,
                    -20.494201f,27.576629f, -20.486707f,27.683318f, -20.513677f,27.723918f, -20.652845f,27.702610f, -20.703761f,27.733261f,
                    -20.759789f,27.732685f, -20.866187f,27.693343f, -20.934278f,27.689445f, -20.957827f,27.710313f, -21.086888f,27.693030f,
                    -21.153116f,27.750364f, -21.175350f,27.805314f, -21.302692f,27.904565f, -21.456975f,27.977740f, -21.472804f,27.957344f,
                    -21.484932f,27.983699f, -21.517502f,27.970217f, -21.516316f,28.002192f, -21.573912f,28.018628f, -21.603347f,28.199135f,
                    -21.589378f,28.293977f, -21.602516f,28.365542f, -21.668870f,28.502779f, -21.629399f,28.579114f, -21.755742f,28.862319f,
                    -21.771061f,28.999486f, -21.817848f,29.076979f, -21.914718f,29.020665f, -22.022263f,29.053826f, -22.072104f,29.139108f,
                    -22.059798f,29.247076f, -22.090159f,29.275771f, -22.090159f,26.444282f);
            poly[893] = new TzPolygon(-18.039874f,23.432855f, -18.039874f,24.175314f, -18.110516f,24.108073f, -18.110019f,24.051326f, -18.138270f,24.048775f,
                    -18.204400f,23.931496f, -18.250542f,23.932093f, -18.273432f,23.876851f, -18.326792f,23.844551f, -18.339950f,23.802913f,
                    -18.384526f,23.786992f, -18.435161f,23.720056f, -18.430790f,23.686975f, -18.502334f,23.616093f, -18.480732f,23.567644f,
                    -18.337226f,23.558774f, -18.321951f,23.528879f, -18.273114f,23.525821f, -18.241818f,23.500418f, -18.236191f,23.453127f,
                    -18.212885f,23.445530f, -18.211625f,23.432855f);
            poly[894] = new TzPolygon(-18.039874f,24.593143f, -18.073872f,24.575423f, -18.051251f,24.522129f, -18.064622f,24.505998f, -18.039874f,24.494100f);
            poly[895] = new TzPolygon(-18.039874f,24.173869f, -18.019824f,24.192544f, -18.011292f,24.268679f, -18.036635f,24.294548f, -17.949924f,24.370599f,
                    -17.951792f,24.423463f, -17.963502f,24.457381f, -18.039874f,24.494100f);
            poly[896] = new TzPolygon(-18.039874f,24.593143f, -17.994370f,24.616861f, -17.942878f,24.699233f, -17.884268f,24.739569f, -17.894948f,24.757183f,
                    -17.810075f,24.911118f, -17.819921f,24.931953f, -17.812516f,24.938569f, -18.039874f,24.938569f);
            poly[897] = new TzPolygon(-17.635802f,23.432855f, -17.637867f,23.434227f, -17.638132f,23.432855f);
            poly[898] = new TzPolygon(-17.549689f,24.938569f, -17.554446f,24.907727f, -17.527279f,24.879981f, -17.536660f,24.794303f, -17.509190f,24.782527f,
                    -17.497208f,24.708301f, -17.539443f,24.563933f, -17.509323f,24.545566f, -17.513252f,24.512092f, -17.479853f,24.453040f,
                    -17.470193f,24.387809f, -17.491693f,24.269802f, -17.474161f,24.248638f, -17.636332f,23.432855f, -17.229817f,23.432855f,
                    -17.229817f,24.938569f);
            poly[899] = new TzPolygon(-18.849931f,25.846455f, -18.837364f,25.825460f, -18.624486f,25.782445f, -18.573010f,25.692199f, -18.496100f,25.647495f,
                    -18.477895f,25.603795f, -18.383926f,25.523552f, -18.152886f,25.415663f, -18.078031f,25.319001f, -18.039874f,25.300513f,
                    -18.039874f,26.444282f, -18.849931f,26.444282f);
        }
    }

    private static class Initializer10 {
        private static void init() {
            poly[900] = new TzPolygon(-17.812516f,24.938569f, -17.788046f,24.960429f, -17.792741f,24.982176f, -17.804521f,24.964545f, -17.825925f,24.976372f,
                    -17.815657f,25.004148f, -17.838283f,25.013392f, -17.807759f,25.054174f, -17.841003f,25.066116f, -17.807969f,25.143938f,
                    -17.778137f,25.163303f, -17.791365f,25.262940f, -17.912609f,25.237413f, -18.039874f,25.300155f, -18.039874f,24.938569f);
            poly[901] = new TzPolygon(-18.039874f,25.300513f, -17.909412f,25.237300f, -17.791365f,25.262940f, -17.852310f,25.379105f, -17.843568f,25.455194f,
                    -17.865503f,25.515618f, -17.839720f,25.546672f, -17.847747f,25.591566f, -17.809454f,25.687795f, -17.815563f,25.691426f,
                    -18.039874f,25.691426f);
            poly[902] = new TzPolygon(-17.811541f,25.691426f, -17.847747f,25.591566f, -17.838300f,25.551086f, -17.865503f,25.515618f, -17.843568f,25.455194f,
                    -17.852310f,25.379105f, -17.769096f,25.227601f, -17.766644f,25.188462f, -17.693179f,25.131022f, -17.709795f,25.095413f,
                    -17.665325f,25.104993f, -17.615653f,25.065729f, -17.629176f,25.044002f, -17.589939f,25.047172f, -17.594884f,25.001807f,
                    -17.553996f,24.980040f, -17.568836f,24.944715f, -17.548708f,24.944930f, -17.549689f,24.938569f, -17.229817f,24.938569f,
                    -17.229817f,25.691426f);
            poly[903] = new TzPolygon(-17.811541f,25.691426f, -17.229817f,25.691426f, -17.229817f,26.444282f, -17.957490f,26.444282f, -17.936171f,26.402297f,
                    -17.917886f,26.245236f, -17.884155f,26.219680f, -17.934365f,26.088939f, -17.950508f,26.106232f, -17.980926f,26.091825f,
                    -17.976652f,26.002708f, -18.002807f,25.970460f, -17.974732f,25.857411f, -17.911686f,25.861065f, -17.852037f,25.771967f,
                    -17.838625f,25.705132f, -17.810851f,25.693328f);
            poly[904] = new TzPolygon(-17.957490f,26.444282f, -15.609703f,26.444282f, -15.609703f,29.455710f, -15.689937f,29.455710f, -15.686468f,29.415739f,
                    -15.773155f,29.213496f, -15.896434f,29.048008f, -15.946526f,29.013369f, -15.946578f,28.928440f, -16.049160f,28.845647f,
                    -16.106913f,28.869877f, -16.169391f,28.838791f, -16.244067f,28.857844f, -16.309486f,28.820368f, -16.374302f,28.851126f,
                    -16.485549f,28.815597f, -16.554306f,28.735598f, -16.571297f,28.642126f, -16.717970f,28.269093f, -16.824720f,28.135280f,
                    -16.962498f,27.829325f, -17.246623f,27.630024f, -17.332630f,27.624358f, -17.423784f,27.543205f, -17.598943f,27.311201f,
                    -17.806452f,27.144094f, -17.837013f,27.152956f, -17.960873f,27.042654f, -17.990846f,26.836527f, -18.023852f,26.803076f,
                    -18.031394f,26.732018f, -18.076594f,26.695784f, -18.048905f,26.598637f, -17.987772f,26.563328f, -17.990030f,26.508368f);
            poly[905] = new TzPolygon(-26.920943f,33.102357f, -26.857967f,32.902228f, -26.863920f,32.331050f, -26.832830f,32.219200f, -26.863190f,32.183970f,
                    -26.840262f,32.134622f, -26.527250f,32.134992f, -26.405646f,32.077418f, -26.161684f,32.105350f, -26.008525f,32.087300f,
                    -25.996945f,32.003050f, -25.840770f,31.930550f, -25.645194f,32.006099f, -25.474690f,31.977400f, -25.382500f,32.015280f,
                    -25.132539f,32.033716f, -24.302200f,31.987130f, -24.181792f,31.908179f, -23.952489f,31.880591f, -23.884862f,31.767769f,
                    -23.805513f,31.733502f, -23.805513f,33.102357f);
            poly[906] = new TzPolygon(-25.718760f,31.416300f, -25.999600f,31.867860f, -25.952646f,31.975191f, -25.996945f,32.003050f, -26.008525f,32.087300f,
                    -26.161684f,32.105350f, -26.405646f,32.077418f, -26.527250f,32.134992f, -26.840262f,32.134622f, -26.804590f,32.098240f,
                    -26.810195f,32.011348f, -27.116410f,31.974550f, -27.317520f,31.977760f, -27.315160f,31.493690f, -27.202080f,31.150550f,
                    -27.036980f,30.984760f, -26.992129f,30.958326f, -26.908210f,30.973560f, -26.859930f,30.907420f, -26.785060f,30.891910f,
                    -26.844427f,30.813209f, -26.712290f,30.790800f, -26.466671f,30.805060f, -26.320820f,30.891860f, -26.261732f,30.961438f,
                    -25.921150f,31.126570f, -25.743040f,31.315940f);
            poly[907] = new TzPolygon(-21.756560f,29.455710f, -21.756560f,31.982437f, -22.181870f,31.574497f, -22.424110f,31.307377f, -22.367550f,31.268500f,
                    -22.368690f,31.213100f, -22.330700f,31.171570f, -22.349164f,31.088906f, -22.292080f,30.839170f, -22.310960f,30.663260f,
                    -22.336290f,30.631680f, -22.316350f,30.489390f, -22.356250f,30.290240f, -22.295860f,30.231140f, -22.311050f,30.126170f,
                    -22.253630f,30.025630f, -22.228940f,30.017600f, -22.224170f,29.969890f, -22.189930f,29.925720f, -22.194560f,29.884530f,
                    -22.141420f,29.773590f, -22.125110f,29.656710f, -22.155690f,29.610240f, -22.140900f,29.580220f, -22.152660f,29.539250f,
                    -22.178000f,29.527960f, -22.166120f,29.464120f, -22.168830f,29.455710f);
            poly[908] = new TzPolygon(-23.805513f,31.733502f, -23.721890f,31.697390f, -23.625529f,31.689984f, -23.481960f,31.561020f, -23.198230f,31.563600f,
                    -22.424110f,31.307377f, -22.181870f,31.574497f, -21.756560f,31.982437f, -21.756560f,33.102357f, -23.805513f,33.102357f);
            poly[909] = new TzPolygon(-21.756560f,31.982437f, -21.315388f,32.405591f, -21.328108f,32.480015f, -21.206570f,32.399330f, -21.169890f,32.405830f,
                    -21.136680f,32.366720f, -21.011780f,32.468410f, -20.914370f,32.516840f, -20.618550f,32.492050f, -20.560860f,32.567070f,
                    -20.556175f,32.668133f, -20.339190f,32.807845f, -20.287060f,32.863990f, -20.234604f,32.871498f, -20.221889f,32.846421f,
                    -20.195573f,32.847788f, -20.187260f,32.875544f, -20.124425f,32.867089f, -20.126717f,32.923628f, -20.038560f,32.949518f,
                    -20.034564f,33.028814f, -19.776760f,33.062782f, -19.723096f,32.958720f, -19.707608f,32.962356f, -19.707608f,33.102357f,
                    -21.756560f,33.102357f);
            poly[910] = new TzPolygon(-19.707608f,32.962356f, -19.651273f,32.975583f, -19.684140f,32.892098f, -19.673529f,32.834432f, -19.618549f,32.857374f,
                    -19.483646f,32.845370f, -19.459900f,32.777187f, -19.361320f,32.776410f, -19.293630f,32.849840f, -19.097870f,32.877400f,
                    -19.016390f,32.833460f, -19.025069f,32.713745f, -18.938757f,32.698944f, -18.927924f,32.735110f, -18.833630f,32.711910f,
                    -18.781340f,32.813740f, -18.796280f,32.892420f, -18.766280f,32.927790f, -18.690190f,32.954120f, -18.579074f,32.885902f,
                    -18.514440f,32.887024f, -18.473269f,32.978940f, -18.503376f,32.984589f, -18.497591f,33.020476f, -18.421125f,33.018644f,
                    -18.348660f,33.068341f, -18.298522f,33.016154f, -18.228579f,33.021657f, -18.136801f,32.972197f, -18.112054f,32.982062f,
                    -18.029428f,32.950907f, -18.032621f,32.936014f, -18.000010f,32.955700f, -17.984939f,32.937601f, -17.917999f,32.983420f,
                    -17.913181f,32.953000f, -17.814939f,32.960563f, -17.802794f,33.018321f, -17.748261f,33.029597f, -17.731547f,33.007278f,
                    -17.722220f,33.029071f, -17.688635f,33.015737f, -17.658655f,33.029451f, -17.658655f,33.102357f, -19.707608f,33.102357f);
            poly[911] = new TzPolygon(-15.609703f,30.409697f, -15.622543f,30.418988f, -15.655607f,30.354065f, -15.627950f,30.260218f, -15.668572f,30.215112f,
                    -15.618760f,30.162200f, -15.643534f,29.970554f, -15.609937f,29.824518f, -15.692642f,29.486878f, -15.689937f,29.455710f,
                    -15.609703f,29.455710f);
            poly[912] = new TzPolygon(-16.005896f,31.279033f, -16.007075f,31.188227f, -15.983640f,31.140415f, -16.016002f,31.072365f, -15.996799f,31.063163f,
                    -16.060462f,30.992286f, -15.999772f,30.922465f, -15.999772f,30.424565f, -15.628041f,30.425125f, -15.609703f,30.413147f,
                    -15.609703f,31.279033f);
            poly[913] = new TzPolygon(-16.005896f,31.279033f, -16.047333f,31.344566f, -16.137150f,31.404530f, -16.143692f,31.434638f, -16.160553f,31.427516f,
                    -16.179633f,31.630136f, -16.236710f,31.770810f, -16.312560f,31.835850f, -16.336470f,31.893790f, -16.412870f,31.913480f,
                    -16.442370f,32.037540f, -16.449170f,32.344180f, -16.599970f,32.709160f, -16.685540f,32.709180f, -16.719202f,32.887977f,
                    -16.696047f,32.923133f, -16.706877f,32.978682f, -16.894220f,32.912210f, -16.920759f,32.835674f, -17.179280f,32.986520f,
                    -17.308570f,32.997410f, -17.342273f,33.052393f, -17.398695f,33.004403f, -17.453704f,33.000103f, -17.479926f,32.965432f,
                    -17.559455f,32.983556f, -17.604780f,33.054097f, -17.658655f,33.029451f, -17.658655f,31.279033f);
            poly[914] = new TzPolygon(-16.684630f,34.883663f, -16.675904f,34.858255f, -16.607233f,34.842530f, -16.585916f,34.772473f, -16.549196f,34.777199f,
                    -16.512777f,34.752435f, -16.502974f,34.682276f, -16.438471f,34.681017f, -16.453223f,34.652059f, -16.417862f,34.593880f,
                    -16.314358f,34.570420f, -16.279880f,34.524020f, -16.296385f,34.490161f, -16.264299f,34.430902f, -16.185296f,34.397689f,
                    -16.043250f,34.430168f, -16.026037f,34.388325f, -15.964151f,34.355377f, -15.920721f,34.260136f, -15.896627f,34.251476f,
                    -15.796756f,34.271990f, -15.744283f,34.326264f, -15.742514f,34.364462f, -15.685952f,34.391429f, -15.664698f,34.435165f,
                    -15.619143f,34.433392f, -15.609703f,34.456021f, -15.609703f,34.883663f);
            poly[915] = new TzPolygon(-16.684630f,34.883663f, -15.609703f,34.883663f, -15.609703f,35.836385f, -15.964683f,35.805229f, -16.027691f,35.817639f,
                    -16.101207f,35.712291f, -16.095725f,35.673002f, -16.133709f,35.593852f, -16.121635f,35.557502f, -16.168212f,35.523250f,
                    -16.120582f,35.486620f, -16.113850f,35.429637f, -16.229426f,35.297298f, -16.325814f,35.278330f, -16.345718f,35.302873f,
                    -16.398664f,35.263227f, -16.474995f,35.261919f, -16.562337f,35.143452f, -16.619576f,35.166977f, -16.646504f,35.228464f,
                    -16.710325f,35.288627f, -16.796314f,35.289518f, -16.830480f,35.314675f, -16.940035f,35.263092f, -16.981560f,35.304862f,
                    -17.034534f,35.291951f, -17.062452f,35.313826f, -17.123229f,35.309137f, -17.129603f,35.097395f, -17.107984f,35.077968f,
                    -17.087249f,35.108522f, -17.049395f,35.056540f, -17.010473f,35.051049f, -16.937869f,35.171517f, -16.873946f,35.146241f,
                    -16.839772f,35.157457f, -16.818120f,35.135828f, -16.828814f,35.041798f, -16.789006f,34.990092f, -16.748933f,34.984715f,
                    -16.747367f,34.919660f, -16.693700f,34.910070f);
            poly[916] = new TzPolygon(-15.609703f,22.000165f, -12.999688f,22.003724f, -13.000767f,24.058127f, -12.896038f,23.981923f, -12.893796f,23.939792f,
                    -12.840515f,23.893522f, -12.761026f,23.899034f, -12.698194f,23.932934f, -12.668182f,23.923162f, -12.593419f,23.959855f,
                    -12.537001f,23.947902f, -12.424420f,24.065636f, -12.380775f,24.077272f, -12.333960f,24.043014f, -12.310366f,24.066851f,
                    -12.269437f,24.062446f, -12.208033f,23.999944f, -12.136440f,23.980392f, -11.855963f,23.998018f, -11.829245f,24.023031f,
                    -11.660648f,23.960555f, -11.531225f,24.037901f, -11.446033f,24.024138f, -11.404498f,24.087886f, -15.609703f,24.087886f);
            poly[917] = new TzPolygon(-5.867515f,14.907735f, -5.877845f,14.699551f, -5.904712f,14.595772f, -5.891823f,14.347963f, -5.857074f,14.282713f,
                    -5.880785f,14.238951f, -5.869412f,14.197609f, -5.840477f,14.187767f, -5.852343f,14.039940f, -5.826426f,13.999907f,
                    -5.850908f,13.959918f, -5.867939f,13.587086f, -5.886523f,13.560470f, -5.862452f,13.514261f, -5.860113f,13.430998f,
                    -5.872514f,13.377478f, -5.908990f,13.354151f, -5.861911f,13.222670f, -5.903476f,13.113667f, -5.872514f,13.088219f,
                    -5.863608f,13.042413f, -5.912383f,12.951224f, -5.924259f,12.855794f, -5.998058f,12.751033f, -6.078219f,12.444385f,
                    -6.068181f,12.389689f, -6.005789f,12.312360f, -5.990189f,12.114648f, -5.889632f,12.039074f, -5.752477f,12.219062f,
                    -5.742117f,12.528415f, -5.149089f,12.533084f, -5.149089f,14.907735f);
            poly[918] = new TzPolygon(-6.712941f,16.771898f, -6.712941f,17.967785f, -8.087427f,17.967785f, -8.080841f,17.870074f, -8.113420f,17.796611f,
                    -8.100739f,17.678324f, -8.131037f,17.612268f, -8.128663f,17.566153f, -8.079336f,17.504682f, -8.045711f,17.532371f,
                    -8.002273f,17.481941f, -7.949277f,17.481474f, -7.942796f,17.450823f, -7.870888f,17.449754f, -7.866007f,17.422205f,
                    -7.834279f,17.424047f, -7.840260f,17.392525f, -7.813750f,17.395307f, -7.823937f,17.378225f, -7.776850f,17.380859f,
                    -7.779502f,17.331442f, -7.752041f,17.318778f, -7.719129f,17.333772f, -7.692851f,17.290026f, -7.622997f,17.295933f,
                    -7.580912f,17.218914f, -7.497431f,17.196353f, -7.470029f,17.150176f, -7.427987f,17.179530f, -7.403985f,17.139190f,
                    -7.424072f,17.107089f, -7.349848f,17.106231f, -7.295705f,17.026065f, -7.292640f,16.980403f, -7.233893f,16.940578f,
                    -7.203291f,16.956607f, -7.105302f,16.915687f, -7.117396f,16.951564f, -7.053344f,16.966670f, -7.021144f,16.932166f,
                    -7.023700f,16.906074f, -6.909536f,16.910709f, -6.879201f,16.879295f, -6.881417f,16.841014f, -6.824491f,16.841358f,
                    -6.800458f,16.807712f, -6.731419f,16.800331f);
            poly[919] = new TzPolygon(-5.867515f,14.907735f, -5.865682f,14.944686f, -5.870391f,16.424045f, -5.844012f,16.491970f, -5.873342f,16.577215f,
                    -5.941343f,16.576990f, -5.949734f,16.603515f, -6.031511f,16.587894f, -6.037144f,16.624114f, -6.060165f,16.599477f,
                    -6.065140f,16.644370f, -6.096889f,16.636130f, -6.108667f,16.688315f, -6.165673f,16.730029f, -6.207245f,16.703665f,
                    -6.331354f,16.720361f, -6.334030f,16.676593f, -6.355352f,16.694567f, -6.386121f,16.678992f, -6.404484f,16.723406f,
                    -6.424688f,16.695455f, -6.450201f,16.718256f, -6.481435f,16.708492f, -6.522611f,16.752035f, -6.578477f,16.731494f,
                    -6.602692f,16.756729f, -6.707211f,16.763080f, -6.712941f,16.771898f, -6.712941f,14.907735f);
            poly[920] = new TzPolygon(-9.840646f,22.557861f, -11.039479f,22.557861f, -11.039479f,22.508930f, -11.064330f,22.488848f, -11.111912f,22.502364f,
                    -11.167759f,22.450266f, -11.182424f,22.346240f, -11.236191f,22.311464f, -11.264140f,22.249898f, -11.178218f,22.268516f,
                    -11.109652f,22.215734f, -10.935395f,22.204812f, -10.866104f,22.166880f, -10.809057f,22.223055f, -10.760136f,22.328300f,
                    -10.665363f,22.307268f, -10.564175f,22.316125f, -10.530416f,22.307143f, -10.507853f,22.271488f, -10.379555f,22.326257f,
                    -10.157618f,22.215177f, -10.071112f,22.221668f, -9.921277f,22.186838f, -9.869989f,22.111170f, -9.874921f,22.069119f,
                    -9.840646f,22.033681f);
            poly[921] = new TzPolygon(-10.901448f,24.087886f, -10.887911f,24.061981f, -10.905935f,23.973169f, -11.035274f,23.862838f, -10.987303f,23.759381f,
                    -11.003144f,23.668621f, -10.940670f,23.514014f, -10.946651f,23.428588f, -11.108579f,23.195145f, -11.081545f,23.152533f,
                    -11.113367f,23.081251f, -11.090637f,23.040761f, -11.086697f,22.906682f, -11.062694f,22.863039f, -11.118398f,22.773269f,
                    -11.113307f,22.709927f, -11.070574f,22.633432f, -11.039479f,22.618339f, -11.039479f,22.557861f, -9.840646f,22.557861f,
                    -9.840646f,24.087886f);
            poly[922] = new TzPolygon(-11.404498f,24.087886f, -11.274737f,24.031326f, -11.139054f,24.035376f, -11.117166f,24.001019f, -11.098018f,24.021792f,
                    -10.984795f,24.024016f, -10.942299f,24.018016f, -10.911178f,23.980528f, -10.889962f,23.999872f, -10.902345f,24.087886f);
            poly[923] = new TzPolygon(-9.840646f,22.033681f, -9.821243f,22.013620f, -9.749868f,21.997780f, -9.761299f,21.977561f, -9.686916f,21.936724f,
                    -9.650331f,21.874344f, -9.456616f,21.830953f, -9.417920f,21.791151f, -9.227482f,21.859537f, -9.098000f,21.834214f,
                    -9.043972f,21.856104f, -8.854432f,21.861063f, -8.785758f,21.895816f, -8.700399f,21.892762f, -8.559885f,21.942593f,
                    -8.525983f,21.930005f, -8.504907f,21.953438f, -8.440467f,21.949169f, -8.394006f,21.918374f, -8.327432f,21.932700f,
                    -8.291163f,21.892738f, -8.276794f,21.891596f, -8.276794f,24.087886f, -9.840646f,24.087886f);
            poly[924] = new TzPolygon(-6.712941f,17.967785f, -6.712941f,19.800099f, -6.769233f,19.838663f, -6.860497f,19.931594f, -6.991553f,19.975228f,
                    -7.000000f,19.547955f, -7.055530f,19.562227f, -7.167522f,19.498509f, -7.243994f,19.507977f, -7.315709f,19.485356f,
                    -7.457670f,19.544568f, -7.504452f,19.486200f, -7.571971f,19.473334f, -7.571945f,19.383207f, -7.591308f,19.368572f,
                    -7.701570f,19.412430f, -7.901446f,19.341656f, -7.909022f,19.360379f, -8.000000f,19.381333f, -8.000000f,18.796451f,
                    -7.913366f,18.767612f, -7.916667f,18.530592f, -8.000000f,18.531911f, -8.000000f,18.407325f, -8.024685f,18.359153f,
                    -7.977444f,18.213838f, -8.036904f,18.140164f, -8.029180f,18.105867f, -8.096584f,18.103629f, -8.087427f,17.967785f);
            poly[925] = new TzPolygon(-6.712941f,19.800099f, -6.712941f,21.027836f, -7.283333f,21.027836f, -7.283333f,20.553021f, -7.166636f,20.562136f,
                    -7.145907f,20.546096f, -7.062430f,20.594792f, -6.916668f,20.627162f, -6.916667f,20.321995f, -7.000000f,20.302885f,
                    -7.000045f,19.966205f, -6.860497f,19.931594f, -6.769233f,19.838663f);
            poly[926] = new TzPolygon(-6.712941f,19.800099f, -6.583970f,19.711743f, -6.529964f,19.698210f, -6.425275f,19.720918f, -6.345803f,19.684782f,
                    -6.302101f,19.698657f, -6.242268f,19.673775f, -6.164736f,19.691198f, -6.043719f,19.871099f, -6.019136f,19.876593f,
                    -6.032623f,19.892900f, -6.007186f,19.951952f, -5.955797f,20.014952f, -5.867806f,20.049235f, -5.843778f,20.107026f,
                    -5.798180f,20.117669f, -5.746601f,20.166421f, -5.631813f,20.180669f, -5.546353f,20.130119f, -5.418196f,20.126857f,
                    -5.350347f,20.137328f, -5.283687f,20.195693f, -5.187274f,20.205135f, -5.149089f,20.196621f, -5.149089f,21.027836f,
                    -6.712941f,21.027836f);
            poly[927] = new TzPolygon(-7.283333f,21.027836f, -7.283333f,21.789226f, -7.374855f,21.843902f, -7.409034f,21.835182f, -7.426874f,21.859344f,
                    -7.524345f,21.842205f, -7.560966f,21.859528f, -7.775054f,21.776160f, -7.907684f,21.777607f, -7.940019f,21.751542f,
                    -8.028953f,21.776265f, -8.070117f,21.823821f, -8.143018f,21.849238f, -8.176350f,21.883612f, -8.276794f,21.891596f,
                    -8.276794f,21.027836f);
            poly[928] = new TzPolygon(-13.998540f,33.239352f, -14.001513f,33.205300f, -13.998540f,33.203646f);
            poly[929] = new TzPolygon(-13.998540f,33.068531f, -14.021592f,33.065137f, -14.049778f,33.022606f, -14.018389f,32.990661f, -13.998540f,32.992559f);
            poly[930] = new TzPolygon(-15.609703f,30.413147f, -15.539029f,30.366985f, -15.476359f,30.401596f, -15.437229f,30.376962f, -15.369604f,30.384837f,
                    -15.322259f,30.363208f, -15.264305f,30.283214f, -15.087157f,30.213820f, -15.035977f,30.234805f, -14.996583f,30.216723f,
                    -14.959570f,30.365150f, -14.784650f,30.796370f, -14.620160f,31.472610f, -14.506430f,31.683310f, -14.323340f,32.241370f,
                    -14.282690f,32.451430f, -13.998540f,33.220324f, -14.006477f,33.239352f, -15.609703f,33.239352f);
            poly[931] = new TzPolygon(-13.998540f,33.242700f, -13.998540f,33.701099f, -14.589984f,33.701099f, -14.615774f,33.665131f, -14.587152f,33.634241f,
                    -14.492111f,33.607900f, -14.478512f,33.562280f, -14.419739f,33.528445f, -14.400989f,33.470172f, -14.219747f,33.385076f,
                    -14.216961f,33.341943f, -14.148215f,33.298586f, -14.084435f,33.322230f, -14.031888f,33.300272f);
            poly[932] = new TzPolygon(-11.823031f,25.764102f, -11.816750f,25.714760f, -11.731434f,25.651065f, -11.734490f,25.595910f, -11.791291f,25.505670f,
                    -11.682411f,25.472349f, -11.626927f,25.331983f, -11.580359f,25.330556f, -11.519321f,25.292853f, -11.494546f,25.332053f,
                    -11.487744f,25.308400f, -11.356714f,25.280046f, -11.346894f,25.313482f, -11.305892f,25.292007f, -11.280765f,25.338032f,
                    -11.259901f,25.316404f, -11.196125f,25.352400f, -11.191711f,25.302179f, -11.254733f,25.118359f, -11.245046f,25.027824f,
                    -11.274559f,24.911632f, -11.266343f,24.870439f, -11.296760f,24.850607f, -11.303085f,24.750497f, -11.316402f,24.728572f,
                    -11.331222f,24.738843f, -11.333118f,24.694038f, -11.401220f,24.641617f, -11.419831f,24.591436f, -11.452883f,24.584336f,
                    -11.467194f,24.441231f, -11.427029f,24.419887f, -11.388312f,24.279586f, -11.353204f,24.358136f, -11.264614f,24.401644f,
                    -11.199923f,24.401878f, -11.173626f,24.377202f, -11.134911f,24.384727f, -11.134911f,25.764102f);
            poly[933] = new TzPolygon(-11.823031f,25.764102f, -11.830624f,25.823751f, -11.808262f,25.886943f, -11.868917f,25.905824f, -11.907207f,25.992159f,
                    -11.947892f,25.979775f, -11.937984f,26.185564f, -11.920791f,26.208133f, -11.963600f,26.312734f, -11.910467f,26.428331f,
                    -11.918636f,26.477932f, -11.952005f,26.499932f, -11.985886f,26.572340f, -11.967245f,26.590981f, -12.006384f,26.709163f,
                    -11.955406f,26.774466f, -11.986999f,26.819525f, -11.984942f,26.877597f, -11.919365f,26.958063f, -11.842405f,27.006920f,
                    -11.749231f,27.003863f, -11.707180f,27.047559f, -11.614822f,27.017862f, -11.593114f,27.050343f, -11.601346f,27.159405f,
                    -11.563135f,27.205080f, -11.683375f,27.235382f, -11.785262f,27.229350f, -11.830651f,27.338889f, -11.911020f,27.440317f,
                    -13.998540f,27.440317f, -13.998540f,25.764102f);
            poly[934] = new TzPolygon(-10.902345f,24.087886f, -10.906289f,24.115917f, -11.041632f,24.149793f, -11.020549f,24.186209f, -11.050664f,24.244839f,
                    -11.041385f,24.301896f, -11.085121f,24.379338f, -11.121481f,24.392538f, -11.134911f,24.388588f, -11.134911f,24.087886f);
            poly[935] = new TzPolygon(-12.566726f,28.452285f, -12.566726f,29.116533f, -13.368983f,29.116533f, -13.423191f,29.005688f, -13.389286f,28.983248f,
                    -13.368536f,28.997128f, -13.375155f,28.961744f, -13.164316f,28.903924f, -13.145768f,28.838489f, -13.005010f,28.825697f,
                    -12.938614f,28.782722f, -12.941587f,28.753871f, -12.881256f,28.728959f, -12.814737f,28.653806f, -12.832944f,28.609886f,
                    -12.896985f,28.582595f, -12.897398f,28.565177f, -12.852727f,28.536460f, -12.823484f,28.542954f, -12.731551f,28.456652f,
                    -12.696603f,28.461419f, -12.686580f,28.512810f, -12.637666f,28.534695f);
            poly[936] = new TzPolygon(-11.911020f,27.440317f, -11.928770f,27.462719f, -12.052970f,27.470110f, -12.058726f,27.497603f, -12.177275f,27.533615f,
                    -12.221871f,27.616450f, -12.270365f,27.622486f, -12.293204f,27.762703f, -12.251378f,27.814991f, -12.221684f,27.812213f,
                    -12.241167f,27.931962f, -12.314518f,27.961017f, -12.359039f,27.955799f, -12.338543f,27.990861f, -12.348846f,28.078981f,
                    -12.439015f,28.122414f, -12.427941f,28.150155f, -12.398811f,28.145350f, -12.377714f,28.170726f, -12.422498f,28.230338f,
                    -12.407943f,28.257577f, -12.425032f,28.278425f, -12.566726f,28.278425f, -12.566726f,27.440317f);
            poly[937] = new TzPolygon(-12.425032f,28.278425f, -12.426979f,28.280801f, -12.419597f,28.322832f, -12.500387f,28.399142f, -12.516378f,28.447980f,
                    -12.553842f,28.437319f, -12.566726f,28.452285f, -12.566726f,28.278425f);
            poly[938] = new TzPolygon(-12.386409f,29.116533f, -12.375373f,29.107468f, -12.384325f,29.042280f, -12.285352f,29.005695f, -12.172418f,28.917526f,
                    -12.147125f,28.865528f, -12.046430f,28.776206f, -11.979122f,28.754472f, -11.984396f,28.700062f, -11.908313f,28.615380f,
                    -11.883454f,28.494273f, -11.844988f,28.493235f, -11.828124f,28.474798f, -11.840093f,28.452747f, -11.815959f,28.435590f,
                    -11.775235f,28.455284f, -11.724293f,28.418661f, -11.651344f,28.433904f, -11.591444f,28.387422f, -11.545145f,28.385353f,
                    -11.391228f,28.425843f, -11.370566f,28.456353f, -11.298698f,28.453816f, -11.240116f,28.489466f, -11.146942f,28.499752f,
                    -11.134911f,28.493335f, -11.134911f,29.116533f);
            poly[939] = new TzPolygon(-13.368983f,29.116533f, -12.386409f,29.116533f, -12.396716f,29.124999f, -12.360570f,29.269548f, -12.422088f,29.321749f,
                    -12.412663f,29.373651f, -12.460158f,29.479430f, -12.405572f,29.530482f, -12.396720f,29.488983f, -12.333966f,29.460594f,
                    -12.249399f,29.482381f, -12.230770f,29.531333f, -12.181820f,29.575085f, -12.221337f,29.616833f, -12.232164f,29.681504f,
                    -12.204092f,29.737555f, -12.149369f,29.772546f, -12.149947f,29.814790f, -13.444499f,29.814759f, -13.433170f,29.776424f,
                    -13.459035f,29.726404f, -13.424006f,29.672409f, -13.433105f,29.639046f, -13.403673f,29.613116f, -13.375137f,29.621703f,
                    -13.363390f,29.604829f, -13.349763f,29.649939f, -13.294444f,29.646308f, -13.251555f,29.682661f, -13.224600f,29.675014f,
                    -13.243567f,29.640883f, -13.203668f,29.585563f, -13.247970f,29.504409f, -13.313285f,29.441285f, -13.325537f,29.361616f,
                    -13.353148f,29.351998f, -13.333942f,29.316159f, -13.374752f,29.297604f, -13.448835f,29.178509f, -13.404249f,29.166373f,
                    -13.367511f,29.119544f);
            poly[940] = new TzPolygon(-11.134911f,28.493335f, -11.103479f,28.476571f, -11.020340f,28.512599f, -10.970210f,28.510365f, -10.947537f,28.540304f,
                    -10.847130f,28.549417f, -10.768615f,28.603769f, -10.724992f,28.608726f, -10.722300f,28.662335f, -10.683519f,28.663692f,
                    -10.673800f,28.697246f, -10.637592f,28.688393f, -10.626490f,28.659173f, -10.563421f,28.673458f, -10.518294f,28.629829f,
                    -10.449687f,28.647545f, -10.364691f,28.618374f, -10.299902f,28.634357f, -10.226195f,28.575822f, -10.163785f,28.626856f,
                    -10.046194f,28.644290f, -9.997119f,28.621223f, -9.944905f,28.627850f, -9.811769f,28.675746f, -9.801607f,28.696679f,
                    -9.751002f,28.668470f, -9.746895f,28.635796f, -9.718205f,28.618234f, -9.697828f,28.631098f, -9.592655f,28.612234f,
                    -9.575947f,28.581133f, -9.552457f,28.618911f, -9.557359f,28.576728f, -9.484813f,28.571904f, -9.478083f,28.535243f,
                    -9.454917f,28.537078f, -9.448200f,28.513287f, -9.358889f,28.520833f, -9.311667f,28.402222f, -9.260833f,28.372222f,
                    -9.228889f,28.395556f, -9.093889f,28.622500f, -8.840000f,28.860833f, -8.667778f,28.961667f, -8.546944f,28.937500f,
                    -8.479167f,28.896944f, -8.271282f,30.792749f, -11.134911f,30.792749f);
            poly[941] = new TzPolygon(-8.265476f,30.792749f, -7.970278f,30.696944f, -7.580278f,30.455833f, -7.356389f,30.406944f, -7.136944f,30.311389f,
                    -6.962500f,30.188333f, -6.860278f,30.082500f, -6.755278f,29.891389f, -6.627500f,29.732500f, -6.455556f,29.661111f,
                    -6.300833f,29.552500f, -5.991389f,29.495833f, -5.918889f,29.518889f, -5.798889f,29.614167f, -5.697222f,29.628333f,
                    -5.184444f,29.458611f, -5.149089f,29.440749f, -5.149089f,30.792749f);
            poly[942] = new TzPolygon(-11.786177f,30.792749f, -11.786177f,33.328851f, -11.890052f,33.327606f, -11.923663f,33.348439f, -12.140198f,33.256902f,
                    -12.186765f,33.307413f, -12.248652f,33.311437f, -12.347920f,33.376109f, -12.325448f,33.475501f, -12.363927f,33.548555f,
                    -12.421672f,33.492002f, -12.417455f,33.473736f, -12.474728f,33.458669f, -12.553990f,33.375399f, -12.532783f,33.334224f,
                    -12.548461f,33.271888f, -12.637663f,33.179940f, -12.613542f,33.181313f, -12.598464f,33.152817f, -12.599172f,33.048669f,
                    -12.768230f,32.937075f, -12.860822f,32.954801f, -12.903850f,33.020353f, -13.112252f,32.983961f, -13.210203f,33.006792f,
                    -13.298619f,32.943391f, -13.405888f,32.920106f, -13.463110f,32.887606f, -13.468943f,32.859828f, -13.525849f,32.847688f,
                    -13.576721f,32.747328f, -13.559227f,32.697312f, -13.574746f,32.670362f, -13.639499f,32.692606f, -13.649500f,32.783717f,
                    -13.707556f,32.842050f, -13.785056f,32.768717f, -13.815889f,32.809272f, -13.839778f,32.910384f, -13.883389f,32.917328f,
                    -13.942833f,32.997884f, -13.998540f,32.992559f, -13.998540f,30.792749f);
            poly[943] = new TzPolygon(-13.998540f,33.068531f, -13.986615f,33.070287f, -13.961167f,33.135384f, -13.922746f,33.161491f, -13.998540f,33.215808f);
            poly[944] = new TzPolygon(-9.573815f,33.418387f, -9.573815f,33.701099f, -9.611583f,33.701099f, -9.614468f,33.698889f, -9.579288f,33.586555f,
                    -9.625868f,33.510781f, -9.614252f,33.443259f);
            poly[945] = new TzPolygon(-9.573815f,33.004886f, -9.626094f,32.996071f, -9.616094f,33.060516f, -9.665816f,33.099682f, -9.586650f,33.113571f,
                    -9.603039f,33.206071f, -9.792761f,33.296904f, -9.823039f,33.361904f, -9.912205f,33.391071f, -9.936094f,33.360238f,
                    -10.051111f,33.315266f, -10.212222f,33.555266f, -10.341944f,33.544432f, -10.462500f,33.636099f, -10.510484f,33.636934f,
                    -10.577446f,33.676825f, -10.568333f,33.701099f, -10.702222f,33.553333f, -10.776389f,33.510556f, -10.807778f,33.453611f,
                    -10.793056f,33.413056f, -10.807500f,33.359722f, -10.861750f,33.316356f, -10.845556f,33.280278f, -10.889167f,33.259167f,
                    -10.938889f,33.305000f, -11.070554f,33.328029f, -11.158114f,33.404576f, -11.235912f,33.379685f, -11.376497f,33.289405f,
                    -11.433939f,33.292884f, -11.403196f,33.243757f, -11.417835f,33.230710f, -11.474773f,33.255939f, -11.587551f,33.242884f,
                    -11.611996f,33.330939f, -11.786177f,33.328851f, -11.786177f,30.792749f, -9.573815f,30.792749f);
            poly[946] = new TzPolygon(-9.573815f,33.002741f, -9.507483f,33.016071f, -9.415387f,32.948084f, -9.368326f,32.992709f, -9.493295f,33.144293f,
                    -9.509750f,33.212448f, -9.488116f,33.244833f, -9.500823f,33.278236f, -9.486112f,33.326002f, -9.535027f,33.394529f,
                    -9.573815f,33.418387f);
            poly[947] = new TzPolygon(-8.271282f,30.792749f, -8.538316f,30.978071f, -8.621816f,31.077941f, -8.631390f,31.149640f, -8.583538f,31.211052f,
                    -8.632150f,31.278122f, -8.606841f,31.312361f, -8.617067f,31.348050f, -8.587210f,31.375010f, -8.631410f,31.398140f,
                    -8.640340f,31.458730f, -8.684140f,31.489520f, -8.683610f,31.536170f, -8.709550f,31.570480f, -8.823560f,31.576390f,
                    -8.911260f,31.679900f, -8.923260f,31.734750f, -8.895350f,31.766370f, -8.890280f,31.821660f, -8.936776f,31.947051f,
                    -9.018010f,31.936660f, -9.071180f,31.984380f, -9.051370f,32.060910f, -9.062930f,32.164072f, -9.133575f,32.267020f,
                    -9.118255f,32.431400f, -9.153105f,32.493520f, -9.172335f,32.486630f, -9.254665f,32.540910f, -9.246345f,32.584490f,
                    -9.275765f,32.648529f, -9.285126f,32.755682f, -9.323136f,32.765450f, -9.401161f,32.954093f, -9.491927f,32.988849f,
                    -9.507483f,33.016071f, -9.573815f,33.004886f, -9.573815f,30.792749f);
            poly[948] = new TzPolygon(-14.386368f,34.358479f, -14.431277f,34.264367f, -14.458610f,34.084883f, -14.489603f,34.087049f, -14.470590f,33.936017f,
                    -14.549837f,33.814140f, -14.501344f,33.716264f, -14.537773f,33.702650f, -14.577867f,33.717998f, -14.589984f,33.701099f,
                    -14.386368f,33.701099f);
            poly[949] = new TzPolygon(-15.002667f,34.358479f, -15.002667f,34.622374f, -15.080658f,34.571439f, -15.096157f,34.591939f, -15.124790f,34.568761f,
                    -15.265405f,34.603263f, -15.326200f,34.574697f, -15.353738f,34.518884f, -15.414064f,34.510686f, -15.423293f,34.441124f,
                    -15.493324f,34.426395f, -15.608898f,34.457951f, -15.609004f,34.358479f);
            poly[950] = new TzPolygon(-15.002667f,34.622374f, -14.898901f,34.565292f, -14.811327f,34.584002f, -14.688096f,34.520733f, -14.646376f,34.551564f,
                    -14.555128f,34.516104f, -14.519512f,34.464636f, -14.395707f,34.393408f, -14.386368f,34.359039f, -14.386368f,34.622374f);
            poly[951] = new TzPolygon(-15.609703f,35.836385f, -15.419138f,35.853111f, -15.169963f,35.790065f, -14.895350f,35.918573f, -14.895363f,35.872112f,
                    -14.675621f,35.872098f, -14.386368f,35.627946f, -14.386368f,40.227580f, -15.609703f,40.227580f);
            poly[952] = new TzPolygon(-14.386368f,35.627946f, -14.259227f,35.520629f, -14.170657f,35.486785f, -13.699308f,35.089576f, -13.483110f,34.866898f,
                    -13.483110f,34.607174f, -13.348167f,34.561527f, -13.232242f,34.576116f, -12.907414f,34.532412f, -12.736354f,34.535023f,
                    -12.570796f,34.455736f, -12.265443f,34.417260f, -12.171652f,34.378231f, -12.077048f,34.428389f, -12.077048f,36.964340f,
                    -14.386368f,36.964340f);
            poly[953] = new TzPolygon(-11.569075f,35.332719f, -11.575345f,34.960433f, -11.400000f,34.929000f, -11.324750f,34.794750f, -11.279111f,34.800529f,
                    -11.211159f,34.759604f, -11.118500f,34.638000f, -11.053124f,34.637388f, -11.045500f,34.615000f, -11.002750f,34.622750f,
                    -10.939500f,34.673250f, -10.761000f,34.683250f, -10.713250f,34.650000f, -10.688750f,34.660750f, -10.617250f,34.617250f,
                    -10.597000f,34.625750f, -10.572250f,34.584500f, -10.529000f,34.570000f, -10.485000f,34.596500f, -10.428500f,34.559500f,
                    -10.308000f,34.586750f, -10.206500f,34.570500f, -10.119000f,34.520500f, -10.067250f,34.541500f, -9.767729f,34.333988f,
                    -9.767729f,35.332719f);
            poly[954] = new TzPolygon(-12.077048f,34.428389f, -11.972391f,34.483877f, -11.856008f,34.590756f, -11.739242f,34.634426f, -11.573566f,34.636897f,
                    -11.568976f,35.332719f, -12.077048f,35.332719f);
            poly[955] = new TzPolygon(-11.568976f,35.332719f, -11.568913f,35.342316f, -11.585084f,35.387440f, -11.562091f,35.415355f, -11.584215f,35.441946f,
                    -11.576507f,35.478377f, -11.559626f,35.477888f, -11.582192f,35.515192f, -11.558688f,35.528067f, -11.569741f,35.550137f,
                    -11.548838f,35.574603f, -11.562921f,35.644761f, -11.506730f,35.711484f, -11.477472f,35.711639f, -11.470657f,35.774572f,
                    -11.419842f,35.810930f, -11.411228f,35.843352f, -11.438248f,35.913531f, -11.422892f,35.943818f, -11.465587f,35.957946f,
                    -11.457663f,35.985547f, -11.494471f,36.042192f, -11.540585f,36.062893f, -11.512823f,36.120043f, -11.570353f,36.154096f,
                    -11.547985f,36.183413f, -11.566800f,36.175360f, -11.582068f,36.199761f, -11.670874f,36.183230f, -11.708525f,36.217465f,
                    -11.690431f,36.270217f, -11.719746f,36.307039f, -11.713096f,36.355770f, -11.678515f,36.386768f, -11.680225f,36.482846f,
                    -11.698283f,36.517658f, -11.759261f,36.511461f, -11.698523f,36.573255f, -11.737779f,36.627242f, -11.648194f,36.768322f,
                    -11.550491f,36.814589f, -11.595382f,36.867529f, -11.589811f,36.964340f, -12.077048f,36.964340f, -12.077048f,35.332719f);
            poly[956] = new TzPolygon(-11.589811f,36.964340f, -11.586129f,37.028323f, -11.625113f,37.080046f, -11.655315f,37.220281f, -11.634360f,37.273811f,
                    -11.677959f,37.332265f, -11.691263f,37.398726f, -11.636313f,37.445275f, -11.614112f,37.501854f, -11.626115f,37.582392f,
                    -11.575462f,37.656892f, -11.546822f,37.752804f, -11.506450f,37.786640f, -11.457268f,37.777250f, -11.372271f,37.827490f,
                    -11.311206f,37.830280f, -11.260281f,37.930590f, -11.271239f,38.215691f, -11.289381f,38.268840f, -11.328712f,38.284052f,
                    -11.331431f,38.333561f, -11.373730f,38.368672f, -11.419405f,38.470308f, -11.286101f,38.636391f, -11.273193f,38.752408f,
                    -11.171765f,38.882995f, -11.143433f,39.124245f, -11.175432f,39.246038f, -10.980957f,39.523081f, -10.914043f,39.763603f,
                    -10.849727f,39.865150f, -10.806914f,39.999104f, -10.670602f,40.173255f, -10.603183f,40.227580f, -14.386368f,40.227580f,
                    -14.386368f,36.964340f);
            poly[957] = new TzPolygon(-9.611583f,33.701099f, -9.583660f,33.722487f, -9.586363f,33.773357f, -9.718675f,33.938925f, -9.619009f,33.967551f,
                    -9.559071f,33.949536f, -9.493500f,34.040000f, -9.757889f,34.327171f, -9.767729f,34.333988f, -9.767729f,33.701099f);
            poly[958] = new TzPolygon(9.636901f,-4.286175f, 9.596716f,-4.312933f, 9.625437f,-4.341473f, 9.596478f,-4.390435f, 9.636901f,-4.413726f);
            poly[959] = new TzPolygon(7.088077f,-4.045655f, 7.088077f,-3.030016f, 7.071809f,-3.031893f, 7.052705f,-3.087603f, 6.822296f,-3.232027f,
                    6.777575f,-3.236115f, 6.731702f,-3.208998f, 6.623015f,-3.260786f, 6.601251f,-3.233268f, 6.252820f,-3.175691f,
                    6.251522f,-3.154513f, 6.153126f,-3.102740f, 5.985004f,-3.073809f, 5.856884f,-3.020033f, 5.709230f,-3.026427f,
                    5.716022f,-2.953969f, 5.641276f,-2.966448f, 5.619962f,-2.933506f, 5.657319f,-2.857874f, 5.599837f,-2.761294f,
                    5.437734f,-2.748967f, 5.387981f,-2.724216f, 5.342807f,-2.724146f, 5.356565f,-2.769282f, 5.304442f,-2.766837f,
                    5.289931f,-2.785249f, 5.250691f,-2.753181f, 5.216962f,-2.764245f, 5.140927f,-2.723532f, 5.101642f,-2.757012f,
                    5.128030f,-2.876199f, 5.126928f,-2.948670f, 5.103333f,-2.963056f, 5.134464f,-3.068524f, 5.124754f,-3.108305f,
                    4.895925f,-3.148288f, 4.994171f,-3.758068f, 5.046503f,-3.965016f, 5.038403f,-4.045655f);
            poly[960] = new TzPolygon(7.088077f,-3.030016f, 7.141769f,-3.023819f, 7.237718f,-2.952799f, 7.269923f,-2.975304f, 7.612207f,-2.922151f,
                    7.820013f,-2.831048f, 7.862630f,-2.791195f, 7.952178f,-2.781419f, 7.922653f,-2.746703f, 8.020386f,-2.679616f,
                    8.030426f,-2.604682f, 8.123750f,-2.626841f, 8.152074f,-2.608096f, 8.145660f,-2.551387f, 8.206478f,-2.493031f,
                    8.786579f,-2.584254f, 8.794263f,-2.630319f, 8.827969f,-2.596807f, 8.878310f,-2.623229f, 8.921731f,-2.618056f,
                    8.943087f,-2.651290f, 9.019233f,-2.663835f, 9.032116f,-2.748035f, 9.063156f,-2.780181f, 9.090598f,-2.760830f,
                    9.143359f,-2.772785f, 9.158293f,-2.735016f, 9.257247f,-2.657061f, 9.313522f,-2.721153f, 9.372280f,-2.675979f,
                    9.486392f,-2.684108f, 9.569059f,-2.768477f, 9.636901f,-2.746990f, 9.636901f,-0.723987f, 7.088077f,-0.723987f);
            poly[961] = new TzPolygon(9.636901f,-2.961019f, 9.636901f,-2.746990f, 9.569059f,-2.768477f, 9.491666f,-2.687203f, 9.410472f,-2.767721f,
                    9.575542f,-2.935340f);
            poly[962] = new TzPolygon(10.271946f,-7.367323f, 10.274467f,-7.363089f, 10.332002f,-7.357427f, 10.337964f,-7.367323f, 10.998676f,-7.367323f,
                    10.998676f,-6.536906f, 10.591899f,-6.536906f, 10.628390f,-6.595214f, 10.671935f,-6.615223f, 10.673269f,-6.640854f,
                    10.634290f,-6.644065f, 10.598677f,-6.676063f, 10.536404f,-6.659395f, 10.526980f,-6.682369f, 10.467694f,-6.676656f,
                    10.438694f,-6.625990f, 10.398041f,-6.654553f, 10.364058f,-6.643946f, 10.340825f,-6.698501f, 10.386824f,-6.806505f,
                    10.344946f,-6.859148f, 10.354713f,-6.940187f, 10.262254f,-7.011270f, 10.218386f,-6.977491f, 10.172364f,-6.995023f,
                    10.147811f,-7.049049f, 10.165190f,-7.086045f, 10.209164f,-7.084597f, 10.251953f,-7.148583f, 10.266040f,-7.278004f,
                    10.236172f,-7.337537f, 10.242986f,-7.367323f);
            poly[963] = new TzPolygon(10.591899f,-6.536906f, 10.562645f,-6.427134f, 10.598567f,-6.397501f, 10.700758f,-6.413795f, 10.684025f,-6.320884f,
                    10.740197f,-6.246191f, 10.724488f,-6.210674f, 10.660038f,-6.231403f, 10.634245f,-6.183113f, 10.615769f,-6.223228f,
                    10.581067f,-6.205066f, 10.529258f,-6.247732f, 10.486274f,-6.160440f, 10.449091f,-6.185643f, 10.418941f,-6.155388f,
                    10.387995f,-6.187500f, 10.363453f,-6.159603f, 10.339240f,-6.192515f, 10.302649f,-6.189132f, 10.316304f,-6.206246f,
                    10.301972f,-6.233048f, 10.227152f,-6.177825f, 10.197135f,-5.985932f, 10.278032f,-5.954100f, 10.266982f,-5.885976f,
                    10.377784f,-5.866918f, 10.379406f,-5.840459f, 10.433439f,-5.785716f, 10.431181f,-5.706489f, 9.636901f,-5.706489f,
                    9.636901f,-6.536906f);
            poly[964] = new TzPolygon(10.317788f,-5.197092f, 10.317788f,-4.876072f, 9.881581f,-4.876072f, 9.891179f,-4.912808f, 9.868258f,-4.929519f,
                    9.892372f,-4.966957f, 9.946322f,-4.963884f, 9.953859f,-4.940390f, 9.992084f,-4.987612f, 10.023691f,-4.961258f,
                    10.072621f,-5.015148f, 10.107264f,-4.999303f, 10.082576f,-5.055264f, 10.108504f,-5.038393f, 10.111259f,-5.073111f,
                    10.122127f,-5.036777f, 10.139102f,-5.069697f, 10.180756f,-5.060542f, 10.175528f,-5.104580f, 10.194631f,-5.080255f,
                    10.224068f,-5.083159f, 10.204687f,-5.121975f, 10.236970f,-5.105604f, 10.256548f,-5.119517f, 10.272982f,-5.097830f,
                    10.283133f,-5.120450f, 10.307651f,-5.110961f, 10.287832f,-5.188943f);
            poly[965] = new TzPolygon(10.317788f,-5.211651f, 10.305438f,-5.256699f, 10.317788f,-5.284404f);
            poly[966] = new TzPolygon(10.317788f,-5.292417f, 10.290359f,-5.322865f, 10.305241f,-5.348741f, 10.282479f,-5.362910f, 10.317788f,-5.429921f);
            poly[967] = new TzPolygon(10.431181f,-5.706489f, 10.431107f,-5.703907f, 10.468109f,-5.651395f, 10.451180f,-5.617637f, 10.463243f,-5.557725f,
                    10.424538f,-5.499865f, 10.321806f,-5.437546f, 10.317788f,-5.429921f, 10.317788f,-5.706489f);
            poly[968] = new TzPolygon(10.317788f,-5.292417f, 10.320178f,-5.289764f, 10.317788f,-5.284404f);
            poly[969] = new TzPolygon(10.317788f,-5.211651f, 10.321503f,-5.198102f, 10.317788f,-5.197092f);
            poly[970] = new TzPolygon(10.998676f,-5.706489f, 10.998676f,-5.481553f, 10.973614f,-5.492525f, 10.976044f,-5.452003f, 10.901324f,-5.451622f,
                    10.854347f,-5.402723f, 10.774869f,-5.432628f, 10.764731f,-5.468008f, 10.643995f,-5.461520f, 10.623197f,-5.478925f,
                    10.557722f,-5.456998f, 10.431726f,-5.512140f, 10.463953f,-5.559955f, 10.451180f,-5.617637f, 10.468109f,-5.649571f,
                    10.431107f,-5.703907f, 10.431402f,-5.706489f);
            poly[971] = new TzPolygon(9.636901f,-4.413726f, 9.664151f,-4.429427f, 9.646781f,-4.504978f, 9.751433f,-4.515380f, 9.741919f,-4.553703f,
                    9.718202f,-4.542943f, 9.693190f,-4.561851f, 9.725141f,-4.612509f, 9.702850f,-4.620837f, 9.713127f,-4.645830f,
                    9.686958f,-4.656353f, 9.678492f,-4.690594f, 9.747114f,-4.733283f, 9.755573f,-4.761698f, 9.736792f,-4.774956f,
                    9.783664f,-4.816693f, 9.781454f,-4.783853f, 9.835547f,-4.785854f, 9.872090f,-4.839742f, 9.881581f,-4.876072f,
                    10.998676f,-4.876072f, 10.998676f,-4.045655f, 9.810969f,-4.045655f, 9.803041f,-4.051230f, 9.847235f,-4.127239f,
                    9.773817f,-4.188891f, 9.760091f,-4.266451f, 9.640775f,-4.283595f, 9.636901f,-4.286175f);
            poly[972] = new TzPolygon(10.998676f,-5.481553f, 11.016507f,-5.473747f, 11.083035f,-5.488879f, 11.105675f,-5.382965f, 11.138299f,-5.332996f,
                    11.206331f,-5.324420f, 11.249399f,-5.253339f, 11.392515f,-5.244954f, 11.428803f,-5.198715f, 11.579182f,-5.216561f,
                    11.615543f,-5.294994f, 11.679406f,-5.265239f, 11.762937f,-5.259327f, 11.830716f,-5.404521f, 11.843171f,-5.378075f,
                    11.821165f,-5.354006f, 11.854764f,-5.284959f, 11.833182f,-5.257498f, 11.927671f,-5.172246f, 11.982503f,-5.074635f,
                    12.018711f,-4.832580f, 11.999476f,-4.739715f, 12.066080f,-4.700418f, 12.059607f,-4.630051f, 12.139016f,-4.607346f,
                    12.141653f,-4.544065f, 12.202869f,-4.579941f, 12.283371f,-4.473276f, 12.331783f,-4.473417f, 12.333753f,-4.439641f,
                    12.302590f,-4.418609f, 12.310532f,-4.396295f, 12.360451f,-4.416353f, 12.360451f,-4.045655f, 10.998676f,-4.045655f);
            poly[973] = new TzPolygon(12.360451f,-4.416353f, 12.418755f,-4.439781f, 12.485780f,-4.419907f, 12.533000f,-4.364649f, 12.560397f,-4.402291f,
                    12.609841f,-4.411587f, 12.658155f,-4.480677f, 12.722821f,-4.479101f, 12.711044f,-4.431418f, 12.743846f,-4.346758f,
                    12.701378f,-4.300473f, 12.726606f,-4.232792f, 12.816605f,-4.208981f, 12.866143f,-4.226150f, 12.960996f,-4.218269f,
                    12.990832f,-4.265696f, 13.039498f,-4.274882f, 13.119637f,-4.346929f, 13.189566f,-4.288174f, 13.187061f,-4.225566f,
                    13.236763f,-4.258892f, 13.296096f,-4.136759f, 13.396076f,-4.092644f, 13.413022f,-4.045655f, 12.360451f,-4.045655f);
            poly[974] = new TzPolygon(9.810969f,-4.045655f, 9.835245f,-4.028583f, 9.832811f,-3.973394f, 9.874986f,-3.968127f, 9.873779f,-3.931369f,
                    9.905731f,-3.895923f, 9.894730f,-3.803282f, 9.926713f,-3.776553f, 9.928406f,-3.667671f, 9.958485f,-3.618287f,
                    9.934653f,-3.599631f, 9.910974f,-3.311272f, 9.870566f,-3.317644f, 9.845801f,-3.271703f, 9.935518f,-3.189225f,
                    9.840556f,-3.186587f, 9.851391f,-3.153830f, 9.820478f,-3.103454f, 9.725491f,-3.056710f, 9.743046f,-3.005442f,
                    9.636901f,-2.961019f, 9.636901f,-4.045655f);
            poly[975] = new TzPolygon(9.636901f,-2.746990f, 9.641285f,-2.745601f, 9.680714f,-2.757614f, 9.697108f,-2.787175f, 9.746514f,-2.790052f,
                    9.826363f,-2.726519f, 9.883963f,-2.761897f, 9.960741f,-2.743056f, 10.069591f,-2.790470f, 10.190787f,-2.798259f,
                    10.253004f,-2.757624f, 10.318830f,-2.850473f, 10.387842f,-2.831507f, 10.422508f,-2.773343f, 10.454496f,-2.866360f,
                    10.614443f,-2.941140f, 10.686122f,-2.905675f, 10.721892f,-2.937987f, 10.764413f,-2.895283f, 10.887705f,-2.864039f,
                    10.924999f,-2.817496f, 10.967128f,-2.840803f, 11.006688f,-2.833702f, 10.992322f,-2.384821f, 9.636901f,-2.384821f);
            poly[976] = new TzPolygon(10.995854f,-0.723987f, 11.005831f,-0.807563f, 10.998042f,-0.855074f, 10.962393f,-0.893458f, 11.001978f,-0.916519f,
                    10.986350f,-1.387380f, 11.021033f,-1.425245f, 11.021028f,-1.615577f, 10.985086f,-1.616308f, 10.972004f,-1.749934f,
                    10.992322f,-2.384821f, 12.360451f,-2.384821f, 12.360451f,-0.723987f);
            poly[977] = new TzPolygon(15.084000f,-0.723987f, 14.785124f,-1.069027f, 14.729800f,-1.318300f, 14.501500f,-1.678000f, 14.475666f,-1.980500f,
                    14.191679f,-1.998162f, 14.147003f,-2.103259f, 14.248917f,-2.297285f, 14.299451f,-2.473564f, 14.135172f,-2.676377f,
                    14.054385f,-2.838967f, 14.006217f,-2.854854f, 13.992887f,-2.836147f, 13.823712f,-2.908240f, 13.727169f,-2.905943f,
                    13.654096f,-2.874002f, 13.624663f,-2.952490f, 13.657017f,-3.001398f, 13.613599f,-3.040313f, 13.688995f,-3.107995f,
                    13.677491f,-3.181224f, 13.706131f,-3.212181f, 13.707476f,-3.268807f, 13.683881f,-3.247434f, 13.585730f,-3.250420f,
                    13.555871f,-3.278835f, 13.288968f,-3.234142f, 13.276557f,-3.437479f, 13.178668f,-3.422262f, 13.158050f,-3.441779f,
                    13.166898f,-3.552322f, 13.196848f,-3.552500f, 13.200016f,-3.586656f, 13.303178f,-3.737571f, 13.372188f,-3.797905f,
                    13.377852f,-3.960441f, 13.407634f,-3.963190f, 13.442792f,-3.895670f, 13.452134f,-3.940362f, 13.504436f,-3.967139f,
                    13.474288f,-3.982839f, 13.490373f,-3.964923f, 13.472940f,-3.959626f, 13.435086f,-3.984476f, 13.413937f,-4.045655f,
                    15.084000f,-4.045655f);
            poly[978] = new TzPolygon(6.752252f,-0.723987f, 6.752252f,0.607952f, 6.737609f,0.649959f, 6.641511f,0.635398f, 6.607584f,0.657178f,
                    6.584151f,0.741341f, 6.562948f,0.747563f, 6.529177f,0.712423f, 6.444123f,0.749588f, 6.380469f,0.861879f,
                    6.333333f,0.893104f, 6.335475f,1.003468f, 6.256126f,1.024198f, 6.223399f,1.063258f, 6.169635f,1.082896f,
                    6.169121f,1.199438f, 6.113160f,1.199352f, 5.926547f,1.273294f, 5.866848f,1.195395f, 5.700248f,1.127286f,
                    5.599666f,0.995806f, 5.566463f,0.717362f, 5.580780f,0.334919f, 5.517259f,0.186659f, 5.438167f,0.088537f,
                    5.344039f,-0.143586f, 5.314208f,-0.273935f, 5.203790f,-0.400143f, 5.131994f,-0.599363f, 5.037841f,-0.723987f);
            poly[979] = new TzPolygon(6.752252f,1.619171f, 6.752252f,2.408972f, 6.151687f,2.408972f, 6.132875f,2.171817f, 6.039870f,1.673024f,
                    6.236389f,1.629444f, 6.288785f,1.808761f, 6.308161f,1.787759f, 6.383226f,1.785142f, 6.413054f,1.763948f,
                    6.427037f,1.778976f, 6.475095f,1.752610f, 6.504432f,1.693843f, 6.555235f,1.697641f, 6.555580f,1.671030f,
                    6.579723f,1.667192f, 6.613416f,1.610160f, 6.650991f,1.615559f, 6.688464f,1.575055f);
            poly[980] = new TzPolygon(6.752252f,0.607952f, 6.761493f,0.581441f, 6.788668f,0.566203f, 6.807286f,0.579840f, 6.828771f,0.532145f,
                    6.921055f,0.566006f, 6.943217f,0.522832f, 6.971071f,0.521241f, 7.022296f,0.603545f, 7.099326f,0.614158f,
                    7.113836f,0.591430f, 7.317309f,0.658271f, 7.401160f,0.644127f, 7.412817f,0.618530f, 7.392208f,0.568686f,
                    7.460079f,0.519535f, 7.592577f,0.518090f, 7.622082f,0.586039f, 7.703112f,0.590358f, 7.704283f,0.627113f,
                    7.753867f,0.611397f, 7.767771f,0.631076f, 7.867469f,0.627453f, 8.093466f,0.584628f, 8.185035f,0.613936f,
                    8.202469f,0.588614f, 8.215801f,0.619290f, 8.260299f,0.638437f, 8.286651f,0.731133f, 8.340880f,0.730040f,
                    8.404740f,0.696493f, 8.422440f,0.651659f, 8.466663f,0.647973f, 8.466663f,0.842492f, 6.752252f,0.842492f);
            poly[981] = new TzPolygon(6.752252f,1.619171f, 6.761109f,1.625297f, 6.799474f,1.594322f, 6.825103f,1.612561f, 6.830920f,1.597624f,
                    6.905183f,1.606130f, 6.919701f,1.578409f, 6.997177f,1.559175f, 6.995556f,1.642500f, 7.532500f,1.655833f,
                    8.357778f,1.634722f, 8.374722f,1.613056f, 8.466663f,1.648996f, 8.466663f,2.408972f, 6.752252f,2.408972f);
            poly[982] = new TzPolygon(8.466663f,0.647973f, 8.493518f,0.645734f, 8.595649f,0.469556f, 8.754676f,0.373824f, 8.756869f,0.400920f,
                    8.792793f,0.380067f, 8.779136f,0.427770f, 8.811355f,0.448214f, 8.791780f,0.469049f, 8.800359f,0.491319f,
                    8.877826f,0.527585f, 8.938686f,0.516568f, 9.043858f,0.456238f, 9.108665f,0.486697f, 9.144977f,0.476761f,
                    9.163661f,0.511570f, 9.209416f,0.533602f, 9.256413f,0.505835f, 9.311206f,0.555794f, 9.323868f,0.551245f,
                    9.323868f,0.842492f, 8.466663f,0.842492f);
            poly[983] = new TzPolygon(9.323868f,0.551245f, 9.340876f,0.545134f, 9.405926f,0.567003f, 9.437939f,0.499967f, 9.474895f,0.502923f,
                    9.499486f,0.448704f, 9.499213f,0.359421f, 9.451738f,0.337541f, 9.427417f,0.275777f, 9.463508f,0.229232f,
                    9.485950f,0.229040f, 9.478874f,0.269704f, 9.506631f,0.311194f, 9.524532f,0.243250f, 9.574648f,0.240063f,
                    9.571963f,0.351337f, 9.591457f,0.383690f, 9.625075f,0.356310f, 9.595625f,0.295852f, 9.657239f,0.263496f,
                    9.686272f,0.279253f, 9.650912f,0.322973f, 9.674806f,0.350878f, 9.717686f,0.344802f, 9.727898f,0.318905f,
                    9.846696f,0.357399f, 9.921893f,0.355176f, 9.937388f,0.387322f, 10.027509f,0.360492f, 10.020951f,0.410229f,
                    10.057604f,0.417747f, 10.098681f,0.353076f, 10.181074f,0.357477f, 10.181074f,0.842492f, 9.323868f,0.842492f);
            poly[984] = new TzPolygon(8.466663f,1.648996f, 8.496944f,1.660833f, 8.548056f,1.624722f, 9.049722f,1.617778f, 9.170000f,1.567222f,
                    9.321111f,1.416667f, 9.487500f,1.390556f, 9.485556f,1.361111f, 9.542500f,1.337500f, 9.646667f,1.373889f,
                    9.995278f,1.355000f, 10.181074f,1.073261f, 10.181074f,2.408972f, 8.466663f,2.408972f);
            poly[985] = new TzPolygon(10.564411f,0.059253f, 10.601442f,0.041287f, 10.632333f,-0.059247f, 10.711561f,-0.090090f, 10.720047f,-0.072346f,
                    10.769827f,-0.072847f, 10.818676f,-0.021767f, 10.963250f,-0.006107f, 10.978806f,0.033526f, 11.038280f,0.026697f,
                    11.038280f,0.059253f);
            poly[986] = new TzPolygon(11.038280f,-0.723987f, 11.038280f,-0.437025f, 11.030337f,-0.438013f, 11.036049f,-0.474990f, 10.974715f,-0.544792f,
                    10.992317f,-0.568294f, 10.923578f,-0.593186f, 10.910424f,-0.618436f, 10.939680f,-0.626796f, 10.958282f,-0.671080f,
                    10.987498f,-0.653986f, 10.995854f,-0.723987f);
            poly[987] = new TzPolygon(10.564411f,0.059253f, 10.560818f,0.060996f, 10.526270f,0.142670f, 10.404317f,0.190356f, 10.426923f,0.217696f,
                    10.407587f,0.259261f, 10.421586f,0.285950f, 10.376406f,0.290316f, 10.325151f,0.338370f, 10.308640f,0.318671f,
                    10.312484f,0.396899f, 10.258108f,0.361591f, 10.181074f,0.357477f, 10.181074f,0.059253f);
            poly[988] = new TzPolygon(10.996495f,0.842492f, 10.997360f,0.656310f, 10.931000f,0.494680f, 11.009080f,0.502850f, 11.038280f,0.365791f,
                    11.038280f,0.842492f);
            poly[989] = new TzPolygon(10.333258f,0.842492f, 10.376667f,0.776667f, 10.579722f,0.806944f, 10.714167f,0.802500f, 10.758635f,0.842492f);
            poly[990] = new TzPolygon(11.038280f,0.026697f, 11.062617f,0.023902f, 11.114303f,-0.017876f, 11.084144f,-0.081163f, 11.117785f,-0.143975f,
                    11.139510f,-0.136231f, 11.038280f,0.359778f);
            poly[991] = new TzPolygon(11.038280f,0.842492f, 11.038280f,0.365791f, 11.174856f,-0.275282f, 11.147961f,-0.289357f, 11.126267f,-0.270947f,
                    11.109296f,-0.332746f, 11.069886f,-0.359076f, 11.123257f,-0.372445f, 11.114344f,-0.427566f, 11.038280f,-0.437025f,
                    11.038280f,-0.723987f, 11.895485f,-0.723987f, 11.895485f,0.842492f);
            poly[992] = new TzPolygon(10.996495f,0.842492f, 10.996171f,0.912209f, 10.799722f,0.879444f, 10.758635f,0.842492f);
            poly[993] = new TzPolygon(10.333258f,0.842492f, 10.181074f,1.073261f, 10.181074f,0.842492f);
            poly[994] = new TzPolygon(11.038280f,0.842492f, 11.038280f,0.944161f, 10.996171f,0.912209f, 10.996495f,0.842492f);
            poly[995] = new TzPolygon(11.038280f,1.112318f, 11.031799f,1.114305f, 11.038280f,1.104793f);
            poly[996] = new TzPolygon(11.038280f,0.944161f, 11.094434f,0.986770f, 11.087259f,1.013535f, 11.052707f,1.026935f, 11.061870f,1.070169f,
                    11.038280f,1.105342f);
            poly[997] = new TzPolygon(11.038280f,1.112661f, 11.121279f,1.086865f, 11.131734f,1.049632f, 11.176971f,1.116670f, 11.169796f,1.165027f,
                    11.235653f,1.156529f, 11.247964f,1.129548f, 11.279023f,1.146164f, 11.250064f,1.262568f, 11.266082f,1.283863f,
                    11.302564f,1.259543f, 11.327434f,1.269131f, 11.298058f,1.294360f, 11.292693f,1.333351f, 11.307367f,1.351690f,
                    11.366730f,1.326673f, 11.368302f,1.351054f, 11.395803f,1.359378f, 11.389221f,1.382343f, 11.444424f,1.388455f,
                    11.481042f,1.447749f, 11.453317f,1.484943f, 11.478626f,1.506247f, 11.459650f,1.500624f, 11.451143f,1.530884f,
                    11.478057f,1.553851f, 11.407897f,1.589215f, 11.393368f,1.623846f, 11.407960f,1.699710f, 11.429130f,1.714140f,
                    11.416740f,1.752390f, 11.444380f,1.841670f, 11.427710f,2.019250f, 11.594114f,2.183972f, 11.679052f,2.314287f,
                    11.734176f,2.304626f, 11.784253f,2.340799f, 11.791057f,2.375653f, 11.856788f,2.380240f, 11.874474f,2.404186f,
                    11.895485f,2.408972f, 11.038280f,2.408972f);
            poly[998] = new TzPolygon(13.489743f,-0.723987f, 13.489743f,1.022275f, 13.462500f,1.031667f, 13.396389f,1.170833f, 13.393056f,1.244444f,
                    13.354469f,1.284284f, 13.338856f,1.241580f, 13.380272f,1.211370f, 13.332141f,1.202549f, 13.321453f,1.175468f,
                    13.374676f,0.991913f, 13.007796f,0.973755f, 13.007276f,1.159573f, 12.611690f,1.566306f, 12.605380f,1.868563f,
                    12.700556f,1.928056f, 12.692222f,1.950278f, 12.731111f,1.988889f, 12.725556f,2.096111f, 12.694444f,2.142500f,
                    12.651499f,2.154637f, 12.630833f,2.200833f, 12.593611f,2.220833f, 12.516389f,2.225556f, 12.473333f,2.263889f,
                    12.418611f,2.264167f, 12.390000f,2.087778f, 12.347350f,2.065588f, 11.902544f,2.408972f, 11.895485f,2.405627f,
                    11.895485f,-0.723987f);
            poly[999] = new TzPolygon(11.909474f,2.408972f, 11.931259f,2.391928f, 11.942550f,2.408972f);
        }
    }

    private static class Initializer11 {
        private static void init() {
            poly[1000] = new TzPolygon(12.079607f,2.408972f, 12.112624f,2.390317f, 12.251282f,2.381540f, 12.251864f,2.408972f);
            poly[1001] = new TzPolygon(15.084000f,1.086532f, 14.981871f,0.968179f, 14.944581f,0.701735f, 14.998422f,0.519270f, 14.963993f,0.394631f,
                    15.001042f,0.227435f, 14.974683f,0.061520f, 15.079000f,-0.245750f, 15.004103f,-0.390241f, 15.083284f,-0.431378f,
                    15.084000f,-0.723987f);
            poly[1002] = new TzPolygon(15.084000f,-0.455990f, 15.083284f,-0.431378f, 15.004103f,-0.390241f, 15.079000f,-0.245750f, 14.974683f,0.061520f,
                    14.999829f,0.232230f, 14.914000f,0.244360f, 14.826320f,0.196358f, 14.746547f,0.238139f, 14.522067f,0.168965f,
                    14.050911f,0.381085f, 14.023056f,0.417222f, 13.983611f,0.424167f, 13.955556f,0.471111f, 13.913611f,0.465000f,
                    13.788611f,0.582778f, 13.778056f,0.616667f, 13.717778f,0.596944f, 13.686944f,0.620278f, 13.684167f,0.781111f,
                    13.644167f,0.774444f, 13.622778f,0.902222f, 13.568056f,0.995278f, 13.489743f,1.022275f, 13.489743f,-0.723987f,
                    15.084000f,-0.723987f);
            poly[1003] = new TzPolygon(6.822822f,2.408972f, 6.822822f,2.736543f, 6.784282f,2.734515f, 6.747337f,2.791663f, 6.693531f,2.783087f,
                    6.635420f,2.730245f, 6.569648f,2.750632f, 6.512052f,2.704630f, 6.487045f,2.724148f, 6.464166f,2.705186f,
                    6.377422f,2.706714f, 6.177783f,2.737949f, 6.151687f,2.408972f);
            poly[1004] = new TzPolygon(9.576548f,3.223630f, 9.518867f,3.195059f, 9.496747f,3.153223f, 9.437560f,3.132465f, 9.283908f,3.157868f,
                    9.232595f,3.122794f, 9.101948f,3.088313f, 9.058787f,2.890086f, 9.067759f,2.778543f, 8.992706f,2.791376f,
                    8.962624f,2.772463f, 8.939759f,2.782871f, 8.913874f,2.755129f, 8.901328f,2.772379f, 8.869428f,2.754019f,
                    8.811296f,2.766534f, 8.783668f,2.729577f, 8.708142f,2.761037f, 8.663585f,2.734847f, 8.654577f,2.755364f,
                    8.537622f,2.751669f, 8.524398f,2.769031f, 8.449759f,2.748016f, 8.422628f,2.706912f, 8.387939f,2.717720f,
                    8.321437f,2.693104f, 8.187122f,2.754625f, 7.881580f,2.676932f, 7.766559f,2.733560f, 7.636474f,2.716642f,
                    7.549986f,2.734879f, 7.518575f,2.782252f, 7.479609f,2.795670f, 7.429746f,2.793901f, 7.424327f,2.744840f,
                    7.133006f,2.772804f, 7.104953f,2.740462f, 7.043364f,2.761423f, 7.016800f,2.728928f, 6.951420f,2.712541f,
                    6.926480f,2.741998f, 6.822822f,2.736543f, 6.822822f,2.408972f, 9.576548f,2.408972f);
            poly[1005] = new TzPolygon(10.953411f,2.408972f, 10.953411f,3.764132f, 10.924227f,3.769666f, 10.817094f,3.745729f, 10.735134f,3.780269f,
                    10.698861f,3.834232f, 10.592964f,3.843343f, 10.409030f,3.788037f, 10.461647f,3.683455f, 10.417712f,3.623735f,
                    10.272266f,3.576600f, 10.211502f,3.608029f, 10.176823f,3.679370f, 10.114262f,3.662747f, 10.078819f,3.614454f,
                    9.968893f,3.602537f, 9.924857f,3.560815f, 9.898133f,3.562172f, 9.861305f,3.517764f, 9.870738f,3.462655f,
                    9.827444f,3.352287f, 9.771603f,3.323478f, 9.703206f,3.358335f, 9.659431f,3.313877f, 9.655788f,3.262879f,
                    9.576548f,3.223630f, 9.576548f,2.408972f);
            poly[1006] = new TzPolygon(11.028164f,3.724348f, 11.033867f,3.715685f, 11.129606f,3.720315f, 11.295346f,3.493726f, 11.601921f,3.549892f,
                    11.703094f,3.593725f, 11.693756f,3.609500f, 11.754747f,3.680954f, 11.810683f,3.669243f, 11.830986f,3.629341f,
                    11.920285f,3.619786f, 11.976468f,3.678461f, 12.119320f,3.631658f, 12.258877f,3.666685f, 12.330274f,3.663104f,
                    12.330274f,3.724348f);
            poly[1007] = new TzPolygon(12.330274f,2.923244f, 12.330274f,3.663104f, 12.258877f,3.666685f, 12.119320f,3.631658f, 11.976468f,3.678461f,
                    11.920285f,3.619786f, 11.830986f,3.629341f, 11.810683f,3.669243f, 11.754747f,3.680954f, 11.693756f,3.609500f,
                    11.732962f,3.550077f, 11.774471f,3.564487f, 11.789583f,3.520084f, 11.815505f,3.521887f, 11.860142f,3.481321f,
                    11.858333f,3.432222f, 11.895278f,3.378056f, 11.890000f,3.312222f, 11.993569f,3.255818f, 12.029326f,3.257076f);
            poly[1008] = new TzPolygon(12.330274f,2.717057f, 12.281421f,2.695105f, 12.306099f,2.661749f, 12.272019f,2.543627f, 12.293979f,2.517246f,
                    12.267385f,2.504335f, 12.274239f,2.472902f, 12.252995f,2.462265f, 12.251864f,2.408972f, 12.330274f,2.408972f);
            poly[1009] = new TzPolygon(12.079607f,2.408972f, 11.979880f,2.465320f, 11.954690f,2.408972f);
            poly[1010] = new TzPolygon(11.028164f,3.724348f, 11.008900f,3.753611f, 10.953411f,3.764132f, 10.953411f,3.724348f);
            poly[1011] = new TzPolygon(12.330274f,3.663104f, 12.522698f,3.653454f, 12.746709f,3.941830f, 12.987683f,4.103459f, 13.161925f,4.142085f,
                    13.478063f,4.141604f, 13.477944f,4.234671f, 13.681421f,4.465735f, 13.781003f,4.873818f, 13.734483f,4.949557f,
                    13.742946f,5.246930f, 13.834558f,5.350681f, 13.885645f,5.529830f, 13.644750f,6.155536f, 13.676514f,6.277334f,
                    13.600376f,6.427932f, 13.339288f,6.696697f, 13.143423f,6.820123f, 13.003533f,6.942091f, 13.000072f,7.052867f,
                    13.020471f,7.121574f, 13.129070f,7.221638f, 13.098325f,7.388865f, 13.114850f,7.439373f, 13.256671f,7.670478f,
                    12.330274f,7.670478f);
            poly[1012] = new TzPolygon(12.330274f,2.717057f, 12.364956f,2.732641f, 12.352390f,2.765683f, 12.409245f,2.826144f, 12.330274f,2.930381f);
            poly[1013] = new TzPolygon(21.773345f,0.151578f, 25.000000f,-4.833334f, 26.529692f,-7.367323f, 27.433543f,-7.367323f, 27.433543f,0.151578f);
            poly[1014] = new TzPolygon(26.529692f,-7.367323f, 25.000000f,-4.833334f, 25.000072f,-6.571880f, 16.500149f,-5.609034f, 16.333333f,-5.333333f,
                    15.500000f,-5.500000f, 15.500783f,-7.367323f);
            poly[1015] = new TzPolygon(15.084000f,1.085816f, 15.278128f,1.311499f, 15.346796f,2.636366f, 15.338195f,3.019968f, 15.428574f,3.031485f,
                    15.365330f,3.507104f, 15.403418f,3.536306f, 15.485183f,3.536893f, 15.521040f,3.595828f, 15.648148f,3.703728f,
                    15.675656f,3.833681f, 15.715259f,3.885853f, 15.804220f,3.911028f, 15.084000f,3.911028f);
            poly[1016] = new TzPolygon(20.263616f,2.031303f, 20.242941f,1.999862f, 20.266976f,1.978931f, 20.259812f,1.946854f, 20.224207f,1.923759f,
                    20.297235f,1.882274f, 20.297876f,1.797805f, 20.337223f,1.775031f, 20.406402f,1.668216f, 20.530003f,1.667574f,
                    20.596081f,1.599572f, 20.656598f,1.383804f, 20.740211f,1.316550f, 20.723745f,1.229730f, 20.736148f,1.165150f,
                    20.943255f,1.193591f, 21.116365f,1.166556f, 21.258772f,0.946550f, 21.258772f,2.031303f);
            poly[1017] = new TzPolygon(20.263616f,2.031303f, 21.258772f,2.031303f, 21.258772f,3.911028f, 19.076172f,3.911028f, 18.968147f,3.357648f,
                    19.125653f,3.124732f, 19.155678f,3.114680f, 19.277088f,3.200581f, 19.359073f,3.178257f, 19.417037f,3.200189f,
                    19.448499f,3.266116f, 19.497843f,3.248110f, 19.526828f,3.266377f, 19.584463f,3.231869f, 19.642682f,3.252191f,
                    19.713642f,3.229954f, 19.834791f,3.254628f, 19.856724f,3.149014f, 19.952884f,2.978123f, 19.962732f,2.831622f,
                    19.993553f,2.734948f, 20.101169f,2.684475f, 20.050863f,2.665264f, 20.053872f,2.622458f, 20.032098f,2.595890f,
                    20.034096f,2.560432f, 20.094666f,2.519918f, 20.098554f,2.470326f, 20.075615f,2.412825f, 20.028382f,2.375423f,
                    20.133178f,2.399822f, 20.218177f,2.317919f, 20.271115f,2.312027f, 20.318726f,2.214543f, 20.313352f,2.192347f,
                    20.277906f,2.190171f, 20.238254f,2.120554f, 20.269614f,2.040424f);
            poly[1018] = new TzPolygon(20.970852f,7.670478f, 20.842495f,7.459686f, 19.446978f,5.810545f, 19.076172f,3.911028f, 21.258772f,3.911028f,
                    21.258772f,7.670478f);
            poly[1019] = new TzPolygon(19.075284f,3.911028f, 19.144146f,4.266708f, 17.001741f,4.266669f, 17.000021f,4.214297f, 16.395069f,4.199854f,
                    16.323219f,4.097133f, 16.080829f,3.986066f, 15.940592f,3.980084f, 15.864421f,3.928064f, 15.804220f,3.911028f);
            poly[1020] = new TzPolygon(21.773345f,0.151578f, 21.258772f,0.946550f, 21.258772f,0.151578f);
            poly[1021] = new TzPolygon(-5.149089f,11.847684f, -4.874770f,11.644011f, -4.706988f,11.584748f, -4.633875f,11.583809f, -4.388063f,11.293210f,
                    -4.388063f,12.745379f, -4.414169f,12.745379f, -4.407883f,12.719734f, -4.441421f,12.745379f, -4.496467f,12.745379f,
                    -4.477842f,12.699655f, -4.562289f,12.643761f, -4.563371f,12.563626f, -4.588848f,12.537301f, -4.565076f,12.487110f,
                    -4.602876f,12.451731f, -4.609268f,12.392913f, -4.665966f,12.398902f, -4.790460f,12.331338f, -4.814448f,12.241248f,
                    -4.798189f,12.242894f, -4.790754f,12.197593f, -4.896201f,12.166210f, -5.040742f,12.016274f);
            poly[1022] = new TzPolygon(-5.149089f,12.533084f, -5.144820f,12.533118f, -5.120687f,12.470483f, -5.080618f,12.463866f, -5.047521f,12.503217f,
                    -5.058857f,12.530412f, -5.024048f,12.608614f, -4.949038f,12.626596f, -4.949895f,12.720466f, -4.899734f,12.745379f,
                    -5.149089f,12.745379f);
            poly[1023] = new TzPolygon(-4.899734f,12.745379f, -4.869275f,12.760506f, -4.875021f,12.786114f, -4.847198f,12.812569f, -4.750274f,12.853410f,
                    -4.764080f,12.869003f, -4.735153f,12.895728f, -4.747564f,12.922979f, -4.705112f,12.982428f, -4.715410f,13.029954f,
                    -4.674784f,13.051325f, -4.691465f,13.097409f, -4.622012f,13.095833f, -4.582741f,13.118355f, -4.758545f,13.272979f,
                    -4.799991f,13.373495f, -4.858360f,13.372927f, -4.916029f,13.430804f, -4.862081f,13.415055f, -4.853373f,13.471463f,
                    -5.149089f,13.471463f, -5.149089f,12.745379f);
            poly[1024] = new TzPolygon(-4.496467f,12.745379f, -4.505538f,12.767647f, -4.488432f,12.781326f, -4.441421f,12.745379f, -4.414169f,12.745379f,
                    -4.417344f,12.758331f, -4.388063f,12.766741f, -4.437732f,12.816242f, -4.442669f,12.833333f, -4.415547f,12.844098f,
                    -4.683994f,13.102718f, -4.674784f,13.051325f, -4.715410f,13.029954f, -4.705112f,12.982428f, -4.747564f,12.922979f,
                    -4.735153f,12.895728f, -4.764080f,12.869003f, -4.750274f,12.853410f, -4.847198f,12.812569f, -4.875021f,12.786114f,
                    -4.869275f,12.760506f, -4.899734f,12.745379f);
            poly[1025] = new TzPolygon(-4.388063f,14.197547f, -4.397791f,14.175852f, -4.409904f,14.050111f, -4.514932f,13.948758f, -4.495929f,13.854472f,
                    -4.464057f,13.858552f, -4.425061f,13.823032f, -4.444752f,13.731799f, -4.590065f,13.728810f, -4.612881f,13.708287f,
                    -4.637446f,13.717559f, -4.653988f,13.690323f, -4.678746f,13.723316f, -4.705490f,13.723580f, -4.712295f,13.674170f,
                    -4.744944f,13.699284f, -4.768308f,13.680257f, -4.735604f,13.619283f, -4.754568f,13.636220f, -4.805362f,13.585853f,
                    -4.747471f,13.514756f, -4.853373f,13.471463f, -4.388063f,13.471463f);
            poly[1026] = new TzPolygon(-4.388063f,15.176360f, -4.390785f,15.175500f, -4.480124f,15.107523f, -4.688197f,14.898611f, -4.820605f,14.836641f,
                    -4.913245f,14.685218f, -4.903668f,14.590804f, -4.864807f,14.561732f, -4.845827f,14.493747f, -4.895497f,14.415365f,
                    -4.860193f,14.398851f, -4.651476f,14.419349f, -4.553697f,14.351302f, -4.511146f,14.433956f, -4.438226f,14.480672f,
                    -4.388063f,14.427510f);
            poly[1027] = new TzPolygon(-4.388063f,14.197547f, -4.363402f,14.252545f, -4.319722f,14.288356f, -4.316395f,14.352523f, -4.295427f,14.351353f,
                    -4.278450f,14.401526f, -4.355574f,14.393079f, -4.388063f,14.427510f);
            poly[1028] = new TzPolygon(-4.278450f,11.204916f, -4.214785f,11.164126f, -4.101226f,11.004821f, -3.923333f,11.139722f, -3.693611f,11.225556f,
                    -3.604167f,11.348056f, -3.591111f,11.431111f, -3.511111f,11.487222f, -3.507913f,11.519834f, -4.278450f,11.519834f);
            poly[1029] = new TzPolygon(-2.433809f,11.519834f, -2.433809f,11.601611f, -2.503889f,11.593333f, -2.550278f,11.629722f, -2.620833f,11.647500f,
                    -2.715833f,11.611944f, -2.793889f,11.546111f, -2.856944f,11.543333f, -2.867222f,11.564722f, -2.818056f,11.642778f,
                    -3.013056f,11.804444f, -3.047222f,11.766111f, -3.050556f,11.717500f, -3.178056f,11.701111f, -3.311389f,11.972500f,
                    -3.351667f,11.963611f, -3.394167f,11.910000f, -3.556111f,11.839444f, -3.589722f,11.852500f, -3.636944f,11.925833f,
                    -3.710000f,11.868333f, -3.694444f,11.683333f, -3.535000f,11.583889f, -3.506944f,11.529722f, -3.507913f,11.519834f);
            poly[1030] = new TzPolygon(-2.433809f,14.137028f, -2.496111f,14.107778f, -2.475556f,14.069167f, -2.499722f,14.006111f, -2.468889f,13.991111f,
                    -2.490833f,13.926111f, -2.474167f,13.873889f, -2.433809f,13.868495f);
            poly[1031] = new TzPolygon(-2.433809f,13.486182f, -2.437500f,13.482778f, -2.433809f,13.470937f);
            poly[1032] = new TzPolygon(-2.433809f,11.738223f, -2.436667f,11.735278f, -2.433809f,11.734056f);
            poly[1033] = new TzPolygon(-2.433809f,11.601611f, -2.333333f,11.574167f, -2.353889f,11.676944f, -2.390000f,11.685278f, -2.398333f,11.718889f,
                    -2.433809f,11.734056f);
            poly[1034] = new TzPolygon(-2.433809f,11.738223f, -2.372222f,11.801667f, -2.357222f,11.916111f, -2.331389f,11.951944f, -2.416944f,12.052500f,
                    -2.327222f,12.478056f, -2.299167f,12.463611f, -2.226389f,12.495278f, -2.164167f,12.484167f, -2.095008f,12.517193f,
                    -2.081944f,12.478889f, -2.024444f,12.448056f, -1.895833f,12.438333f, -1.877222f,12.452778f, -1.921667f,12.506944f,
                    -1.872500f,12.520556f, -1.827222f,12.585000f, -1.822500f,12.650000f, -1.857222f,12.724722f, -1.900556f,12.763889f,
                    -1.912778f,12.821389f, -2.039444f,12.866667f, -2.074444f,12.900278f, -2.096944f,12.888611f, -2.111389f,12.913889f,
                    -2.131389f,12.899444f, -2.184167f,12.921389f, -2.182500f,12.967500f, -2.265556f,13.007778f, -2.271835f,13.029639f,
                    -2.281579f,13.029639f, -2.372222f,12.984444f, -2.336948f,13.029639f, -2.433809f,13.029639f);
            poly[1035] = new TzPolygon(-2.433809f,13.470937f, -2.416111f,13.414167f, -2.428333f,13.387500f, -2.360556f,13.203056f, -2.372222f,13.141389f,
                    -2.327778f,13.041389f, -2.336948f,13.029639f, -2.281579f,13.029639f, -2.273056f,13.033889f, -2.271835f,13.029639f,
                    -1.511488f,13.029639f, -1.511488f,14.463344f, -1.545556f,14.480556f, -1.610833f,14.383889f, -1.671667f,14.424167f,
                    -1.686111f,14.468056f, -1.750556f,14.416111f, -1.891667f,14.429722f, -1.973056f,14.258333f, -2.011389f,14.248889f,
                    -2.039444f,14.269444f, -2.137500f,14.250278f, -2.153889f,14.219444f, -2.190278f,14.225556f, -2.238889f,14.155000f,
                    -2.292778f,14.221389f, -2.352500f,14.252222f, -2.360556f,14.196667f, -2.391389f,14.156944f, -2.433809f,14.137028f,
                    -2.433809f,13.868495f, -2.418056f,13.866389f, -2.352500f,13.931667f, -2.318889f,13.881389f, -2.144444f,13.809444f,
                    -2.088889f,13.762222f, -2.184167f,13.727222f, -2.287500f,13.624444f, -2.321667f,13.618333f, -2.330556f,13.581389f,
                    -2.433809f,13.486182f);
            poly[1036] = new TzPolygon(-1.511488f,14.463344f, -1.492222f,14.453611f, -1.406667f,14.505000f, -1.338056f,14.444722f, -1.283889f,14.478333f,
                    -1.212778f,14.481944f, -1.166944f,14.446111f, -1.120833f,14.453611f, -1.033889f,14.417500f, -0.906389f,14.430000f,
                    -0.841111f,14.489167f, -0.785000f,14.465833f, -0.720000f,14.474722f, -0.644722f,14.531944f, -0.589167f,14.539444f,
                    -1.511488f,14.539444f);
            poly[1037] = new TzPolygon(2.305104f,11.529307f, 2.294480f,11.372882f, 2.243097f,11.376888f, 2.224767f,11.351751f, 2.171892f,11.359863f,
                    2.161308f,10.169245f, 2.175300f,10.157332f, 2.156568f,10.121555f, 2.197672f,9.906463f, 2.245694f,9.848172f,
                    2.348858f,9.822532f, 2.337498f,9.812204f, 2.390620f,9.761857f, 2.449845f,9.621122f, 2.449845f,11.529307f);
            poly[1038] = new TzPolygon(-0.589167f,8.519169f, -0.518678f,8.539267f, 0.366974f,9.103149f, 0.611238f,9.109213f, 0.753447f,9.149294f,
                    0.846457f,9.354785f, 0.962984f,9.519126f, 1.022618f,9.547461f, 1.029444f,9.620000f, 1.066944f,9.683056f,
                    1.064722f,9.743889f, 1.000989f,9.796144f, 0.993443f,9.871259f, 0.953237f,9.894842f, 0.922017f,9.952044f,
                    0.936378f,9.993269f, 1.002527f,9.991876f, 1.002160f,11.353313f, 2.224767f,11.351751f, 2.263374f,11.380278f,
                    2.286241f,11.363444f, 2.304693f,11.529307f, -0.589167f,11.529307f);
            poly[1039] = new TzPolygon(0.930339f,11.529307f, 0.930339f,14.478687f, 0.909722f,14.468056f, 0.872500f,14.483889f, 0.729722f,14.366944f,
                    0.665278f,14.376389f, 0.566944f,14.238333f, 0.594167f,14.143333f, 0.575278f,14.094444f, 0.537222f,14.064167f,
                    0.508056f,14.083611f, 0.460556f,14.055278f, 0.406389f,13.972778f, 0.360833f,13.943333f, 0.243611f,13.880000f,
                    0.158611f,13.910833f, 0.089444f,13.908889f, 0.072778f,13.945278f, -0.018056f,13.952222f, -0.030556f,13.913056f,
                    -0.114167f,13.876667f, -0.222222f,13.906667f, -0.220833f,13.930278f, -0.171667f,13.965278f, -0.208333f,14.018889f,
                    -0.218056f,14.085000f, -0.256944f,14.121944f, -0.252778f,14.146667f, -0.340000f,14.190000f, -0.427222f,14.191389f,
                    -0.397500f,14.226667f, -0.417500f,14.260278f, -0.405000f,14.346944f, -0.455000f,14.435000f, -0.589167f,14.539444f,
                    -0.589167f,11.529307f);
            poly[1040] = new TzPolygon(2.304693f,11.529307f, 2.308893f,11.567060f, 2.295283f,11.611840f, 2.318217f,11.667898f, 2.296779f,11.746886f,
                    2.270215f,11.758190f, 2.290541f,12.014829f, 2.278983f,12.109913f, 2.293420f,12.124026f, 2.272911f,12.153797f,
                    2.278762f,12.209763f, 2.249284f,12.246226f, 2.288098f,12.307963f, 2.252029f,12.454503f, 2.270253f,12.574430f,
                    2.221089f,12.745582f, 2.258038f,12.819520f, 2.227595f,12.861641f, 2.254427f,12.919224f, 2.244885f,13.034375f,
                    0.930339f,13.034375f, 0.930339f,11.529307f);
            poly[1041] = new TzPolygon(0.930339f,14.478687f, 0.963056f,14.495556f, 1.015000f,14.437778f, 1.143056f,14.392222f, 1.146389f,14.344167f,
                    1.338333f,14.300278f, 1.397778f,14.243056f, 1.363333f,14.236111f, 1.396667f,14.147222f, 1.375278f,14.073889f,
                    1.435475f,14.009031f, 1.414113f,13.981412f, 1.437290f,13.804677f, 1.361105f,13.782488f, 1.347023f,13.759445f,
                    1.370402f,13.735854f, 1.347467f,13.704845f, 1.345895f,13.638278f, 1.277134f,13.560218f, 1.264157f,13.494808f,
                    1.298083f,13.413795f, 1.277655f,13.397414f, 1.288539f,13.373097f, 1.262936f,13.370895f, 1.263901f,13.322883f,
                    1.218333f,13.307858f, 1.215702f,13.191636f, 1.235743f,13.151534f, 1.249101f,13.178621f, 1.290940f,13.188228f,
                    1.283353f,13.222582f, 1.327751f,13.262767f, 1.340869f,13.240600f, 1.386200f,13.256824f, 1.473796f,13.219008f,
                    1.485380f,13.189364f, 1.520694f,13.188392f, 1.522310f,13.159675f, 1.582230f,13.125260f, 1.599301f,13.148658f,
                    1.690092f,13.136769f, 1.690092f,14.539444f, 0.930339f,14.539444f);
            poly[1042] = new TzPolygon(1.690092f,13.136769f, 1.701932f,13.135219f, 1.758564f,13.183792f, 1.842958f,13.204052f, 1.892737f,13.155383f,
                    1.945911f,13.214721f, 1.986170f,13.209987f, 2.039972f,13.288189f, 2.170589f,13.294224f, 2.162601f,14.303220f,
                    2.187413f,14.362831f, 2.181393f,14.413208f, 2.125580f,14.460679f, 2.162144f,14.496940f, 2.168588f,14.539444f,
                    1.690092f,14.539444f);
            poly[1043] = new TzPolygon(2.244885f,13.034375f, 2.449845f,13.034375f, 2.449845f,14.539444f, 2.168588f,14.539444f, 2.162144f,14.496940f,
                    2.125580f,14.460679f, 2.181393f,14.413208f, 2.187413f,14.362831f, 2.162601f,14.303220f, 2.170589f,13.294224f,
                    2.189960f,13.285457f, 2.207781f,13.305611f, 2.248434f,13.286230f, 2.286593f,13.157670f, 2.240710f,13.084764f);
            poly[1044] = new TzPolygon(2.449845f,9.621122f, 2.612062f,9.628621f, 2.968564f,9.704413f, 3.095473f,9.753985f, 3.226388f,9.698765f,
                    3.459143f,9.457561f, 3.551523f,9.429657f, 3.617881f,9.437811f, 3.657555f,9.414185f, 3.770907f,9.125295f,
                    3.905936f,8.983255f, 3.960447f,8.831346f, 3.989000f,8.812720f, 3.989000f,14.539444f, 2.449845f,14.539444f);
            poly[1045] = new TzPolygon(-4.388063f,15.176360f, -4.324801f,15.196357f, -4.314818f,15.260017f, -4.269069f,15.328294f, -4.285389f,15.403775f,
                    -4.234898f,15.476578f, -4.086742f,15.513317f, -4.043198f,15.551151f, -3.971814f,15.834901f, -3.933267f,15.905928f,
                    -3.768727f,15.967675f, -3.305540f,16.213361f, -3.256525f,16.181260f, -3.117866f,16.171475f, -3.010600f,16.191880f,
                    -2.891454f,16.179864f, -2.642222f,16.237222f, -2.344654f,16.174668f, -2.175833f,16.195833f, -2.093611f,16.265556f,
                    -2.027047f,16.377385f, -1.874722f,16.519444f, -1.620000f,16.663056f, -1.428056f,16.740000f, -1.240000f,16.875278f,
                    -1.108867f,17.045704f, -0.990099f,17.343811f, -0.744673f,17.529677f, -0.669319f,17.635592f, -0.582347f,17.686841f,
                    -0.365718f,17.715508f, -0.257402f,17.664696f, -0.199531f,17.672457f, -0.199531f,18.643611f, -4.388063f,18.643611f);
            poly[1046] = new TzPolygon(1.894734f,15.770172f, 1.894734f,16.086057f, 1.893200f,16.086779f, 1.892054f,16.109202f, 1.704376f,16.149758f,
                    1.688294f,16.141673f, 1.696571f,16.091277f, 1.654666f,16.056206f, 1.671355f,16.021178f, 1.765282f,16.026002f,
                    1.766502f,15.960145f, 1.797557f,15.905648f, 1.785553f,15.881105f, 1.829640f,15.867463f, 1.856241f,15.805292f);
            poly[1047] = new TzPolygon(-0.199531f,17.672457f, -0.167795f,17.676713f, -0.064112f,17.734219f, 0.122484f,17.774045f, 0.233377f,17.821252f,
                    0.323333f,17.931111f, 0.378056f,17.958056f, 0.477778f,17.965833f, 0.614040f,17.868029f, 0.775904f,17.889144f,
                    0.977926f,17.839877f, 1.028902f,17.847945f, 1.145610f,17.926051f, 1.350010f,17.971026f, 1.528611f,18.070556f,
                    1.855833f,18.063611f, 1.894734f,18.072423f, 1.894734f,18.643611f, -0.199531f,18.643611f);
            poly[1048] = new TzPolygon(1.950160f,15.565486f, 1.956340f,15.528454f, 1.983595f,15.485659f, 1.912363f,15.343595f, 1.943548f,15.334941f,
                    1.936956f,15.305682f, 1.990405f,15.287792f, 2.008040f,15.245354f, 2.028165f,15.249450f, 2.039656f,15.206576f,
                    2.016482f,15.175517f, 2.039909f,15.147149f, 1.982831f,15.105078f, 2.004381f,15.062587f, 1.978659f,15.040876f,
                    2.036848f,14.983098f, 2.007908f,14.968628f, 2.000274f,14.914725f, 2.021618f,14.889212f, 2.063766f,14.911187f,
                    2.073285f,14.877485f, 2.110875f,14.872987f, 2.106380f,14.856531f, 2.080327f,14.860396f, 2.063160f,14.771696f,
                    2.095891f,14.770254f, 2.092430f,14.736802f, 2.108435f,14.751509f, 2.128189f,14.723248f, 2.105805f,14.723036f,
                    2.135845f,14.684602f, 2.132700f,14.644155f, 2.157531f,14.644020f, 2.206828f,14.595511f, 2.174433f,14.577998f,
                    2.168588f,14.539444f, 2.941867f,14.539444f, 2.941867f,15.565486f);
            poly[1049] = new TzPolygon(2.941867f,16.063824f, 2.941867f,16.468045f, 2.922500f,16.465833f, 2.849444f,16.501667f, 2.215655f,16.192148f,
                    2.253401f,16.159002f, 2.274668f,16.170339f, 2.352441f,16.143843f, 2.463001f,16.073344f, 2.596712f,16.083097f,
                    2.645393f,16.065506f, 2.701181f,16.087589f);
            poly[1050] = new TzPolygon(1.950160f,15.565486f, 1.919821f,15.747283f, 1.894734f,15.770172f, 1.894734f,15.565486f);
            poly[1051] = new TzPolygon(1.894734f,16.086057f, 1.975333f,16.048118f, 2.046686f,16.083190f, 2.066028f,16.058896f, 2.088539f,16.085516f,
                    2.190736f,16.081278f, 2.198516f,16.129218f, 2.177135f,16.144418f, 2.220833f,16.207222f, 2.849444f,16.501667f,
                    2.922500f,16.465833f, 2.941867f,16.468045f, 2.941867f,16.591527f, 1.894734f,16.591527f);
            poly[1052] = new TzPolygon(2.941867f,16.468045f, 3.002778f,16.475000f, 3.060556f,16.512222f, 3.156667f,16.482778f, 3.242222f,16.534722f,
                    3.481944f,16.588889f, 3.483459f,16.591527f, 2.941867f,16.591527f);
            poly[1053] = new TzPolygon(3.989000f,15.101119f, 3.243641f,15.733623f, 3.270249f,15.775423f, 3.020453f,16.056065f, 2.941867f,16.063824f,
                    2.941867f,14.539444f, 3.989000f,14.539444f);
            poly[1054] = new TzPolygon(1.894734f,18.072423f, 1.956389f,18.086389f, 2.042500f,18.071944f, 2.224167f,18.091944f, 2.288611f,18.116111f,
                    2.413611f,18.222778f, 2.519167f,18.233056f, 2.612804f,18.341960f, 2.941867f,18.482194f, 2.941867f,18.643611f,
                    1.894734f,18.643611f);
            poly[1055] = new TzPolygon(3.963134f,18.643611f, 3.894911f,18.597684f, 3.776866f,18.578482f, 3.471247f,18.625818f, 3.480404f,18.597423f,
                    3.598889f,18.533333f, 3.641944f,18.481389f, 3.577500f,18.398056f, 3.583056f,18.272500f, 3.499167f,18.233889f,
                    3.482778f,18.183889f, 3.541111f,18.154722f, 3.560556f,18.119444f, 3.565833f,18.043333f, 3.539167f,17.988889f,
                    3.577500f,17.938889f, 3.535556f,17.858889f, 3.618333f,17.828333f, 3.637500f,17.739444f, 3.629722f,17.615278f,
                    3.713056f,17.482222f, 3.679722f,17.413889f, 3.611111f,17.346667f, 3.628889f,17.278056f, 3.584444f,17.234167f,
                    3.576667f,17.077222f, 3.540278f,17.033333f, 3.565833f,16.876667f, 3.523333f,16.856667f, 3.522222f,16.807500f,
                    3.550556f,16.761111f, 3.533333f,16.659722f, 3.473578f,16.591527f, 3.989000f,16.591527f, 3.989000f,18.643611f);
            poly[1056] = new TzPolygon(2.941867f,18.482194f, 3.075556f,18.539167f, 3.131944f,18.611667f, 3.204444f,18.641389f, 3.450833f,18.633056f,
                    3.525348f,18.606642f, 3.776866f,18.578482f, 3.894911f,18.597684f, 3.963134f,18.643611f, 2.941867f,18.643611f);
            poly[1057] = new TzPolygon(5.392003f,7.670478f, 5.392003f,8.831418f, 5.184724f,8.821095f, 5.112839f,8.783711f, 5.074011f,8.726946f,
                    4.915088f,8.651601f, 4.885393f,8.605639f, 4.824472f,8.629359f, 4.798797f,8.541861f, 4.745622f,8.525122f,
                    4.701767f,8.538976f, 4.633333f,8.464444f, 4.533333f,8.407500f, 4.367260f,8.388005f, 4.334996f,8.291972f,
                    4.343220f,8.047569f, 4.311792f,7.773734f, 4.273511f,7.670478f);
            poly[1058] = new TzPolygon(3.989000f,15.101119f, 4.020510f,15.074380f, 4.056659f,15.179509f, 3.989000f,15.179509f);
            poly[1059] = new TzPolygon(4.056659f,15.179509f, 4.072377f,15.139940f, 4.140126f,15.099316f, 4.301683f,15.086756f, 4.367979f,15.025842f,
                    4.424309f,15.007932f, 4.528186f,14.811149f, 4.613343f,14.730443f, 4.763390f,14.702060f, 4.787659f,14.720689f,
                    4.868751f,14.714642f, 4.989378f,14.676192f, 5.085474f,14.674379f, 5.099826f,14.693488f, 5.197609f,14.664195f,
                    5.236790f,14.569226f, 5.284228f,14.525659f, 5.392003f,14.574987f, 5.392003f,15.179509f);
            poly[1060] = new TzPolygon(4.053118f,18.643611f, 4.113147f,18.629967f, 4.321085f,18.544872f, 4.370924f,18.601229f, 4.355917f,18.623726f,
                    4.358327f,18.643611f);
            poly[1061] = new TzPolygon(-5.149089f,20.196621f, -5.093373f,20.184198f, -4.962167f,20.111568f, -4.825026f,20.084791f, -4.787507f,20.053543f,
                    -4.594667f,20.060758f, -4.502333f,20.123901f, -4.472154f,20.089354f, -4.438080f,20.092421f, -4.360583f,20.039462f,
                    -4.292114f,20.028132f, -4.283762f,20.137767f, -4.337853f,20.168323f, -4.329015f,20.205279f, -4.378762f,20.240936f,
                    -4.381734f,20.321151f, -4.362393f,20.350162f, -4.300258f,20.364925f, -4.282112f,20.398055f, -4.293750f,20.433715f,
                    -4.254549f,20.453112f, -4.262706f,20.508213f, -4.220422f,20.599537f, -4.158245f,20.634504f, -4.133010f,20.675140f,
                    -3.534440f,20.641899f, -3.284014f,20.656448f, -2.766325f,20.744471f, -2.568229f,20.862217f, -2.568756f,20.921967f,
                    -2.532577f,21.005298f, -2.535367f,21.213981f, -2.513816f,21.231263f, -2.513816f,21.349804f, -2.517435f,21.355610f,
                    -2.513816f,21.426639f, -2.549216f,21.523458f, -2.612706f,21.591087f, -2.668791f,21.697429f, -2.535967f,21.851638f,
                    -2.513816f,21.870083f, -2.513816f,23.048844f, -5.149089f,23.048844f);
            poly[1062] = new TzPolygon(-2.513816f,21.231263f, -2.464549f,21.270770f, -2.513816f,21.349804f);
            poly[1063] = new TzPolygon(-2.513816f,21.410194f, -2.512893f,21.424115f, -2.513816f,21.426639f);
            poly[1064] = new TzPolygon(-2.513816f,21.870083f, -2.415560f,21.951901f, -2.370830f,22.048599f, -2.276390f,22.139700f, -2.313330f,22.190599f,
                    -2.434720f,22.188299f, -2.464720f,22.264401f, -2.432500f,22.293301f, -2.395560f,22.293900f, -1.942220f,22.166401f,
                    -1.903330f,22.185000f, -1.958890f,22.509701f, -1.874440f,22.590000f, -1.801110f,22.625601f, -1.816940f,22.642799f,
                    -1.806670f,22.679701f, -1.884170f,22.870300f, -1.962220f,22.936701f, -1.931940f,23.005800f, -1.931940f,23.048844f,
                    -2.513816f,23.048844f);
            poly[1065] = new TzPolygon(-0.405810f,23.048844f, -0.406005f,22.950006f, -0.301638f,23.048844f);
            poly[1066] = new TzPolygon(-1.196180f,23.048844f, -1.196180f,23.952777f, -1.245429f,24.117882f, -1.328410f,24.148030f, -1.312780f,24.192542f,
                    -1.324276f,24.315046f, -1.431390f,24.322201f, -1.538890f,24.375799f, -1.717948f,24.412389f, -1.693910f,24.208231f,
                    -1.740866f,24.212141f, -1.747592f,24.041633f, -1.762776f,24.004826f, -1.870604f,23.988210f, -1.825712f,23.882300f,
                    -1.830967f,23.839135f, -1.943854f,23.849276f, -1.956766f,23.771667f, -2.025066f,23.669920f, -1.983143f,23.569383f,
                    -1.987646f,23.532797f, -2.094769f,23.408106f, -2.076615f,23.345186f, -2.012034f,23.265102f, -1.996498f,23.167227f,
                    -1.931940f,23.073900f, -1.931940f,23.048844f);
            poly[1067] = new TzPolygon(-1.196180f,23.952777f, -1.164671f,23.847147f, -1.106267f,23.798967f, -1.035631f,23.629960f, -0.971981f,23.547773f,
                    -0.742023f,23.479608f, -0.717072f,23.593020f, -0.644594f,23.620001f, -0.627671f,23.669479f, -0.545992f,23.687649f,
                    -0.539820f,23.606477f, -0.499787f,23.606666f, -0.440329f,23.528824f, -0.470058f,23.479577f, -0.463077f,23.421659f,
                    -0.519498f,23.250842f, -0.405416f,23.248982f, -0.405810f,23.048844f, -0.301638f,23.048844f, -0.240462f,23.106779f,
                    -0.240600f,23.413102f, -0.208330f,23.408300f, -0.105070f,23.358014f, -0.076116f,23.313948f, 0.035830f,23.246401f,
                    0.121457f,23.169407f, 0.121457f,25.251460f, -1.196180f,25.251460f);
            poly[1068] = new TzPolygon(0.320278f,23.048844f, 0.413330f,22.972500f, 0.559170f,22.934700f, 0.599999f,22.979260f, 0.722951f,22.883378f,
                    0.821206f,22.876812f, 0.902662f,22.839527f, 0.997360f,22.842282f, 1.054283f,22.790428f, 1.111761f,22.787376f,
                    1.123663f,22.764177f, 1.203480f,22.743846f, 1.236635f,22.704166f, 1.282429f,22.700007f, 1.302658f,22.667177f,
                    1.353510f,22.654914f, 1.490396f,22.477126f, 1.483102f,22.431593f, 1.521444f,22.377218f, 1.499053f,22.358775f,
                    1.503470f,22.307403f, 1.531504f,22.260730f, 1.672559f,22.289445f, 1.732271f,22.388322f, 1.790952f,22.357595f,
                    1.807766f,22.415616f, 1.866444f,22.425401f, 1.914998f,22.490461f, 1.984309f,22.470033f, 2.041094f,22.412870f,
                    2.055333f,22.363603f, 2.171983f,22.361200f, 2.109440f,22.647499f, 2.014271f,22.779241f, 2.036389f,22.793194f,
                    2.048123f,22.858602f, 2.100224f,22.900666f, 2.091718f,22.922827f, 2.120939f,22.945653f, 2.142153f,22.929160f,
                    2.158767f,22.972711f, 2.185767f,22.972703f, 2.176404f,23.002694f, 2.219834f,23.018029f, 2.202753f,23.048844f);
            poly[1069] = new TzPolygon(2.574024f,23.048844f, 2.738620f,22.887023f, 2.756730f,22.886339f, 2.756730f,23.048844f);
            poly[1070] = new TzPolygon(4.453945f,20.846227f, 4.454313f,20.841387f, 4.422090f,20.792601f, 4.433132f,20.709684f, 4.411489f,20.583090f,
                    4.518113f,20.468019f, 4.564489f,20.446319f, 4.621470f,20.459608f, 4.666591f,20.404159f, 4.733572f,20.385609f,
                    4.771574f,20.343094f, 4.789021f,20.251046f, 4.890803f,20.174879f, 4.902764f,20.104129f, 4.971336f,20.007547f,
                    4.982619f,19.913455f, 5.107322f,19.819689f, 5.146298f,19.679673f, 5.132353f,19.429713f, 5.055703f,19.335296f,
                    5.008325f,19.234069f, 4.941531f,19.196843f, 4.934424f,19.098873f, 4.767245f,19.019403f, 4.578829f,18.829100f,
                    4.467970f,18.805757f, 4.403558f,18.762713f, 4.365344f,18.706462f, 4.358183f,18.643611f, 5.392003f,18.643611f,
                    5.392003f,20.846227f);
            poly[1071] = new TzPolygon(4.053118f,18.643611f, 3.985847f,18.658901f, 3.963134f,18.643611f);
            poly[1072] = new TzPolygon(2.756730f,23.048844f, 2.756730f,22.886339f, 2.794769f,22.884903f, 2.809885f,22.905816f, 2.774617f,22.948569f,
                    2.852956f,22.954060f, 3.014839f,23.048844f);
            poly[1073] = new TzPolygon(3.043771f,23.048844f, 3.071389f,23.019725f, 3.053381f,22.991270f, 3.080576f,22.921835f, 3.020028f,22.857884f,
                    3.018986f,22.827751f, 3.040205f,22.788424f, 3.105730f,22.781702f, 3.123951f,22.759748f, 3.169179f,22.574491f,
                    3.283765f,22.651379f, 3.349625f,22.615457f, 3.447500f,22.667500f, 3.507780f,22.862801f, 3.548050f,22.928600f,
                    3.547500f,23.037500f, 3.558585f,23.048844f);
            poly[1074] = new TzPolygon(4.074367f,22.588140f, 4.074367f,23.048844f, 3.873493f,23.048844f, 3.845713f,22.892980f, 3.874144f,22.878388f,
                    3.864724f,22.849893f, 3.905000f,22.765600f, 3.991390f,22.758600f, 3.998050f,22.687201f);
            poly[1075] = new TzPolygon(4.453945f,20.846227f, 4.446182f,20.948296f, 4.400139f,21.076638f, 4.342185f,21.112322f, 4.291088f,21.213481f,
                    4.344795f,21.281970f, 4.282870f,21.361989f, 4.292571f,21.443433f, 4.253588f,21.539015f, 4.313146f,21.651111f,
                    4.294658f,21.704006f, 4.312051f,21.737176f, 4.246735f,21.859005f, 4.245458f,22.001897f, 4.215999f,22.096310f,
                    4.154845f,22.164920f, 4.115013f,22.258415f, 4.130831f,22.412604f, 4.113610f,22.537201f, 4.074367f,22.588140f,
                    4.074367f,20.846227f);
            poly[1076] = new TzPolygon(4.074367f,22.588140f, 4.113610f,22.537201f, 4.128116f,22.433401f, 4.218712f,22.549283f, 4.287764f,22.544191f,
                    4.371867f,22.616653f, 4.393387f,22.582661f, 4.477131f,22.592288f, 4.494364f,22.647461f, 4.466445f,22.678672f,
                    4.477382f,22.704437f, 4.626855f,22.734063f, 4.714671f,22.781843f, 4.728591f,22.801367f, 4.699666f,22.840577f,
                    4.709639f,22.860937f, 4.755851f,22.897627f, 4.791394f,22.884383f, 4.817068f,22.903514f, 4.838412f,22.969425f,
                    4.757221f,23.009905f, 4.735600f,23.048844f, 4.074367f,23.048844f);
            poly[1077] = new TzPolygon(2.574024f,23.048844f, 2.518110f,23.240267f, 2.476124f,23.296352f, 2.459083f,23.287909f, 2.460178f,23.310973f,
                    2.496908f,23.311656f, 2.495057f,23.335673f, 2.566399f,23.360564f, 2.502884f,23.427261f, 2.511081f,23.451921f,
                    2.451276f,23.536449f, 2.396540f,23.572473f, 2.194189f,23.579607f, 2.183024f,23.477547f, 2.284941f,23.321782f,
                    2.255936f,23.307842f, 2.105572f,23.321880f, 2.089857f,23.312563f, 2.106118f,23.271167f, 2.085449f,23.224255f,
                    2.099406f,23.177406f, 2.171663f,23.104929f, 2.202753f,23.048844f);
            poly[1078] = new TzPolygon(0.320278f,23.048844f, 0.278890f,23.082800f, 0.156940f,23.137501f, 0.121457f,23.169407f, 0.121457f,23.048844f);
            poly[1079] = new TzPolygon(3.873493f,23.048844f, 3.891806f,23.151588f, 3.851729f,23.151588f, 3.869712f,23.216305f, 3.838541f,23.329773f,
                    3.808224f,23.364448f, 3.839911f,23.403072f, 3.819700f,23.515682f, 3.738330f,23.486900f, 3.609170f,23.356100f,
                    3.640560f,23.300600f, 3.641940f,23.229401f, 3.678060f,23.171101f, 3.558585f,23.048844f);
            poly[1080] = new TzPolygon(3.043771f,23.048844f, 3.033441f,23.059735f, 3.014839f,23.048844f);
            poly[1081] = new TzPolygon(4.735600f,23.048844f, 4.719582f,23.077690f, 4.711563f,23.110598f, 4.741605f,23.170339f, 4.675616f,23.230627f,
                    4.671802f,23.262300f, 4.633541f,23.275396f, 4.593090f,23.420547f, 4.652150f,23.428613f, 4.698666f,23.534880f,
                    4.761270f,23.591464f, 4.786707f,23.779477f, 4.834795f,23.832884f, 4.813071f,23.854751f, 4.832797f,23.890871f,
                    4.810105f,23.955909f, 4.874777f,23.961796f, 4.860875f,24.032528f, 4.918561f,24.110923f, 4.893947f,24.150152f,
                    4.074367f,24.150152f, 4.074367f,23.048844f);
            poly[1082] = new TzPolygon(4.893947f,24.150152f, 4.892911f,24.151802f, 4.957941f,24.228135f, 4.935432f,24.267610f, 4.996370f,24.282078f,
                    5.008267f,24.364835f, 5.034679f,24.397315f, 5.058355f,24.340874f, 5.113320f,24.378017f, 5.055809f,24.441597f,
                    5.094951f,24.442763f, 5.104278f,24.462988f, 5.083030f,24.533753f, 5.033061f,24.568374f, 5.023353f,24.618748f,
                    4.975240f,24.631501f, 4.968530f,24.671286f, 4.918514f,24.660436f, 4.894933f,24.723396f, 4.910804f,24.765870f,
                    4.895599f,24.782145f, 4.925747f,24.797754f, 4.924248f,24.847961f, 4.955276f,24.864712f, 4.951207f,24.910493f,
                    4.987910f,24.956665f, 4.926366f,25.063374f, 4.979266f,25.086679f, 4.987306f,25.123522f, 5.011455f,25.120552f,
                    5.030072f,25.149648f, 4.998823f,25.190979f, 5.018555f,25.251460f, 4.074367f,25.251460f, 4.074367f,24.150152f);
            poly[1083] = new TzPolygon(5.018555f,25.251460f, 5.042864f,25.325971f, 5.153051f,25.348446f, 5.149934f,25.326214f, 5.191158f,25.308082f,
                    5.207844f,25.329194f, 5.263261f,25.335902f, 5.291217f,25.376497f, 5.309216f,25.356921f, 5.316116f,25.385945f,
                    5.338343f,25.390144f, 5.310577f,25.421530f, 5.340630f,25.433832f, 5.363830f,25.478518f, 5.343866f,25.498601f,
                    5.357834f,25.538647f, 5.392003f,25.532746f, 5.378271f,25.578793f, 5.348268f,25.590020f, 5.349458f,25.622166f,
                    5.325473f,25.594588f, 5.304153f,25.630399f, 5.332135f,25.647912f, 5.307484f,25.658072f, 5.302535f,25.706518f,
                    5.240455f,25.739950f, 5.278193f,25.785064f, 5.240883f,25.781114f, 5.246614f,25.802114f, 5.224746f,25.802114f,
                    5.220515f,25.799912f, 5.218235f,25.802114f, 4.733185f,25.802114f, 4.733185f,25.251460f);
            poly[1084] = new TzPolygon(5.246614f,25.802114f, 5.250234f,25.815378f, 5.224746f,25.802114f);
            poly[1085] = new TzPolygon(5.218235f,25.802114f, 5.190843f,25.828561f, 5.216922f,25.842266f, 5.223918f,25.881028f, 5.168547f,25.899421f,
                    5.205500f,25.903395f, 5.199552f,25.962596f, 5.247260f,25.974660f, 5.225250f,25.986343f, 5.236148f,26.004379f,
                    5.210426f,26.007996f, 5.225440f,26.048613f, 5.194864f,26.060582f, 5.217588f,26.066150f, 5.213591f,26.093918f,
                    5.244167f,26.089516f, 5.261537f,26.157616f, 5.238789f,26.156641f, 5.247902f,26.184837f, 5.223703f,26.186812f,
                    5.242458f,26.205533f, 5.194898f,26.214420f, 5.213744f,26.234497f, 5.188542f,26.233346f, 5.202200f,26.249740f,
                    5.177549f,26.248384f, 5.171267f,26.285194f, 5.141691f,26.297234f, 5.160798f,26.348845f, 5.159834f,26.352768f,
                    4.733185f,26.352768f, 4.733185f,25.802114f);
            poly[1086] = new TzPolygon(5.002966f,27.454076f, 5.007201f,27.448175f, 5.097019f,27.435464f, 5.258413f,27.272964f, 5.392003f,27.236097f,
                    5.392003f,27.454076f);
            poly[1087] = new TzPolygon(5.159834f,26.352768f, 5.151708f,26.385822f, 5.123179f,26.395363f, 5.136004f,26.412353f, 5.047611f,26.484716f,
                    5.046781f,26.523045f, 5.074380f,26.536832f, 5.048710f,26.536990f, 5.087032f,26.572786f, 5.094020f,26.613559f,
                    5.067242f,26.625988f, 5.093511f,26.637452f, 5.078233f,26.652760f, 5.101007f,26.681046f, 5.109124f,26.767805f,
                    5.049289f,26.802714f, 5.058418f,26.840721f, 5.035475f,26.869294f, 5.142063f,26.933270f, 5.206982f,27.077302f,
                    5.201334f,27.151226f, 5.075767f,27.440032f, 5.007201f,27.448175f, 5.002966f,27.454076f, 4.074367f,27.454076f,
                    4.074367f,26.352768f);
            poly[1088] = new TzPolygon(5.392003f,8.831418f, 5.430745f,8.833348f, 5.564172f,8.921486f, 5.625444f,8.900434f, 5.678747f,8.838010f,
                    5.706214f,8.832639f, 5.707294f,8.855352f, 5.775102f,8.883796f, 5.803268f,8.874202f, 5.794217f,8.847305f,
                    5.824821f,8.841134f, 5.862375f,8.904176f, 5.903398f,8.912843f, 6.000294f,9.054520f, 6.094178f,9.153626f,
                    6.133430f,9.169236f, 6.181325f,9.264433f, 6.292077f,9.334492f, 6.352577f,9.345186f, 6.315655f,9.432777f,
                    6.454097f,9.465081f, 6.442678f,9.529238f, 6.473631f,9.587119f, 6.529572f,9.596785f, 6.512029f,9.705982f,
                    6.678206f,9.749897f, 6.678363f,9.752025f, 5.392003f,9.752025f);
            poly[1089] = new TzPolygon(6.961340f,10.792799f, 6.955622f,10.764739f, 7.016235f,10.683304f, 7.039739f,10.678627f, 7.049512f,10.624648f,
                    7.076657f,10.595640f, 7.146672f,10.595295f, 7.162243f,10.571577f, 6.939719f,10.541417f, 6.899941f,10.488943f,
                    6.916012f,10.462147f, 6.889346f,10.215537f, 6.941781f,10.172182f, 7.013912f,10.176459f, 7.038377f,10.150528f,
                    6.775934f,9.863029f, 6.794580f,9.779489f, 6.679326f,9.765074f, 6.678363f,9.752025f, 7.262135f,9.752025f,
                    7.262135f,10.792799f);
            poly[1090] = new TzPolygon(6.961340f,10.792799f, 6.962513f,10.798557f, 6.938316f,10.838056f, 6.843813f,10.816285f, 6.765916f,10.910705f,
                    6.709079f,10.916363f, 6.686980f,10.993142f, 6.715366f,11.058039f, 6.681522f,11.094994f, 6.519909f,11.097762f,
                    6.530142f,11.137562f, 6.500027f,11.166624f, 6.512510f,11.199987f, 6.537612f,11.197759f, 6.522515f,11.244520f,
                    6.538093f,11.279235f, 6.500974f,11.350948f, 6.525443f,11.356522f, 6.530666f,11.427773f, 6.598138f,11.417225f,
                    6.599502f,11.495781f, 6.666728f,11.553998f, 6.714879f,11.549956f, 6.733910f,11.583761f, 6.772828f,11.569381f,
                    6.801428f,11.595218f, 6.858308f,11.553336f, 6.901504f,11.572708f, 6.913591f,11.606916f, 6.976628f,11.617487f,
                    6.986411f,11.657511f, 7.047452f,11.720643f, 7.043025f,11.774665f, 7.082654f,11.802519f, 7.080694f,11.833573f,
                    5.392003f,11.833573f, 5.392003f,10.792799f);
            poly[1091] = new TzPolygon(12.872529f,8.857666f, 12.872529f,9.712705f, 12.807702f,9.658716f, 12.807406f,9.627707f, 12.833601f,8.977927f);
            poly[1092] = new TzPolygon(9.132266f,11.833573f, 9.132266f,12.897334f, 9.114237f,12.900960f, 8.919688f,12.806853f, 8.895645f,12.818943f,
                    8.853946f,12.800164f, 8.830412f,12.818942f, 8.745363f,12.783955f, 8.763102f,12.720653f, 8.672170f,12.699898f,
                    8.647671f,12.675707f, 8.648905f,12.635005f, 8.613785f,12.575230f, 8.642280f,12.499621f, 8.620357f,12.431400f,
                    8.544533f,12.460957f, 8.516146f,12.446462f, 8.460055f,12.342126f, 8.430319f,12.339498f, 8.442073f,12.259808f,
                    8.386559f,12.243795f, 8.176364f,12.255934f, 8.097617f,12.191072f, 7.983271f,12.214077f, 7.862205f,12.136106f,
                    7.847747f,12.098059f, 7.735655f,12.052252f, 7.678969f,11.999189f, 7.527851f,12.025096f, 7.478078f,11.922775f,
                    7.393844f,11.928063f, 7.363311f,11.883103f, 7.324387f,11.885816f, 7.269983f,11.841774f, 7.248357f,11.880266f,
                    7.194597f,11.855711f, 7.098824f,11.879740f, 7.071407f,11.833573f);
            poly[1093] = new TzPolygon(5.392003f,14.574987f, 5.511907f,14.629866f, 5.595424f,14.589785f, 5.710856f,14.626472f, 5.891273f,14.618941f,
                    5.923172f,14.599201f, 5.904722f,14.555833f, 5.920000f,14.485000f, 6.044679f,14.415543f, 6.088333f,14.430000f,
                    6.133611f,14.510000f, 6.193333f,14.552778f, 6.188889f,14.580278f, 6.262500f,14.740278f, 6.340000f,14.800278f,
                    6.390000f,14.796944f, 6.673611f,14.932778f, 6.726624f,14.939015f, 6.756555f,14.966209f, 6.769601f,15.055165f,
                    6.948624f,15.139125f, 7.058611f,15.158333f, 7.115195f,15.219132f, 7.176829f,15.206056f, 7.215704f,15.233621f,
                    7.223850f,15.211156f, 7.241321f,15.217339f, 7.262135f,15.241665f, 7.262135f,15.996667f, 5.392003f,15.996667f);
            poly[1094] = new TzPolygon(7.262135f,15.241665f, 7.414492f,15.419732f, 7.525485f,15.493321f, 7.519130f,15.727950f, 7.478530f,15.742970f,
                    7.441070f,15.809590f, 7.483339f,15.974811f, 7.500521f,15.996667f, 7.262135f,15.996667f);
            poly[1095] = new TzPolygon(9.132266f,14.441619f, 9.114894f,14.464023f, 9.059154f,14.489444f, 8.811848f,14.843792f, 8.814041f,14.899255f,
                    8.779671f,14.922836f, 8.763601f,14.908265f, 8.728469f,14.989221f, 8.687992f,14.983649f, 8.659348f,15.109015f,
                    8.512252f,15.200064f, 8.098412f,15.393138f, 7.885290f,15.451778f, 7.792022f,15.506378f, 7.766291f,15.591449f,
                    7.585324f,15.561727f, 7.528937f,15.493325f, 7.414492f,15.419732f, 7.262135f,15.241665f, 7.262135f,13.915120f,
                    9.132266f,13.915120f);
            poly[1096] = new TzPolygon(9.132266f,12.897334f, 9.178547f,12.888026f, 9.248589f,12.917292f, 9.340568f,12.923826f, 9.371875f,12.847290f,
                    9.414867f,12.939542f, 9.469123f,12.975024f, 9.506595f,13.034673f, 9.555099f,13.206878f, 9.582523f,13.227062f,
                    9.773330f,13.259469f, 9.826484f,13.302024f, 9.863463f,13.243296f, 9.910132f,13.236293f, 9.938369f,13.281755f,
                    9.978647f,13.288065f, 10.002772f,13.247932f, 10.034623f,13.246873f, 10.045860f,13.286351f, 10.085838f,13.298107f,
                    10.116573f,13.343751f, 10.121517f,13.412199f, 10.160753f,13.469917f, 10.196203f,13.483587f, 10.245853f,13.465860f,
                    10.295020f,13.490873f, 10.328753f,13.478605f, 10.334112f,13.499960f, 10.389463f,13.496671f, 10.419140f,13.537292f,
                    10.468472f,13.530610f, 10.536793f,13.578637f, 10.612438f,13.547220f, 10.634822f,13.574636f, 10.697766f,13.588319f,
                    10.711472f,13.626691f, 10.812922f,13.650513f, 10.863064f,13.716762f, 10.923746f,13.730187f, 10.959892f,13.710398f,
                    10.999965f,13.731405f, 11.004299f,13.792378f, 11.066188f,13.815846f, 11.094977f,13.859888f, 11.150800f,13.879275f,
                    11.187068f,13.915120f, 9.132266f,13.915120f);
            poly[1097] = new TzPolygon(9.132266f,14.441619f, 9.204332f,14.348681f, 9.294147f,14.373162f, 9.309876f,14.339203f, 9.371684f,14.304327f,
                    9.358180f,14.268520f, 9.502368f,14.149818f, 9.517937f,14.104302f, 9.610980f,14.038050f, 9.637937f,13.976605f,
                    9.727969f,14.022445f, 9.820074f,14.130979f, 10.002114f,14.206609f, 10.002224f,14.463358f, 9.935219f,14.802421f,
                    9.982890f,14.957853f, 9.945692f,15.059965f, 9.994282f,15.148312f, 9.989541f,15.248100f, 9.933482f,15.413858f,
                    9.998714f,15.688998f, 10.117960f,15.483668f, 10.244172f,15.397837f, 10.310357f,15.304571f, 10.474839f,15.238535f,
                    10.541677f,15.144980f, 10.621998f,15.160086f, 10.820320f,15.067565f, 10.881547f,15.094511f, 11.002398f,15.053040f,
                    11.002398f,15.996667f, 9.132266f,15.996667f);
            poly[1098] = new TzPolygon(11.937464f,13.915120f, 11.937464f,14.642571f, 11.869472f,14.604655f, 11.782511f,14.615356f, 11.718842f,14.549128f,
                    11.649917f,14.643853f, 11.574781f,14.647602f, 11.510238f,14.617906f, 11.421061f,14.430362f, 11.240847f,14.186293f,
                    11.311753f,13.977175f, 11.206429f,13.934255f, 11.187068f,13.915120f);
            poly[1099] = new TzPolygon(12.872529f,14.129703f, 12.538171f,14.203251f, 12.478988f,14.176189f, 12.434710f,14.194740f, 12.410956f,14.173377f,
                    12.362419f,14.228334f, 12.374688f,14.326942f, 12.352536f,14.483277f, 12.326788f,14.520511f, 12.297068f,14.511118f,
                    12.280388f,14.547769f, 12.236301f,14.549615f, 12.227800f,14.594134f, 12.186001f,14.613523f, 12.197994f,14.659307f,
                    12.164143f,14.678014f, 12.092649f,14.635911f, 12.063839f,14.653380f, 12.042301f,14.622308f, 11.962279f,14.656409f,
                    11.937464f,14.642571f, 11.937464f,13.915120f, 12.872529f,13.915120f);
        }
    }

    private static class Initializer12 {
        private static void init() {
            poly[1100] = new TzPolygon(12.108895f,14.955893f, 12.165188f,14.885277f, 12.188180f,14.911397f, 12.205951f,14.892183f, 12.383802f,14.908468f,
                    12.463374f,14.877822f, 12.467729f,14.843142f, 12.574331f,14.854745f, 12.633501f,14.832524f, 12.634693f,14.772210f,
                    12.688671f,14.745712f, 12.658877f,14.711764f, 12.722204f,14.717992f, 12.743415f,14.616064f, 12.774572f,14.618811f,
                    12.745520f,14.591111f, 12.783724f,14.573843f, 12.775860f,14.555749f, 12.865906f,14.554379f, 12.872529f,14.559758f,
                    12.872529f,14.955893f);
            poly[1101] = new TzPolygon(11.002398f,15.053040f, 11.025200f,15.045215f, 11.033038f,15.092464f, 11.088129f,15.110660f, 11.280581f,15.048508f,
                    11.326734f,15.073925f, 11.345467f,15.049283f, 11.365960f,15.069070f, 11.416938f,15.059849f, 11.514010f,15.133320f,
                    11.562332f,15.144898f, 11.587894f,15.099923f, 11.710911f,15.064483f, 11.734611f,15.077358f, 11.731081f,15.105510f,
                    11.765870f,15.080105f, 11.790909f,15.122848f, 11.854471f,15.089623f, 11.857109f,15.050750f, 11.973675f,15.050064f,
                    11.995740f,15.085848f, 12.031449f,15.038651f, 12.057046f,15.060650f, 12.104072f,15.037780f, 12.121321f,15.001408f,
                    12.088095f,14.981985f, 12.108895f,14.955893f, 12.872529f,14.955893f, 12.872529f,15.996667f, 11.002398f,15.996667f);
            poly[1102] = new TzPolygon(12.872529f,8.857666f, 12.936997f,8.658508f, 13.023335f,8.596764f, 13.074238f,8.502157f, 13.057199f,8.416249f,
                    13.213942f,8.249476f, 13.313778f,8.069222f, 13.341374f,7.845216f, 13.320420f,7.774361f, 13.256671f,7.670478f,
                    20.353056f,7.670478f, 20.353056f,11.833573f, 13.266334f,11.833573f, 13.299044f,11.678427f, 13.346314f,11.590626f,
                    13.380613f,11.459247f, 13.360672f,10.656115f, 13.287472f,10.465271f, 13.270741f,10.204041f, 13.182376f,10.011259f,
                    13.026595f,9.841013f, 12.872529f,9.712705f);
            poly[1103] = new TzPolygon(14.742661f,12.874346f, 13.500102f,12.874346f, 13.501053f,12.871266f, 13.471930f,12.873402f, 13.476459f,12.841881f,
                    13.440602f,12.856693f, 13.455282f,12.835728f, 13.431113f,12.810600f, 13.402989f,12.826825f, 13.397517f,12.782875f,
                    13.377112f,12.792195f, 13.390376f,12.765511f, 13.326418f,12.740238f, 13.323252f,12.709009f, 13.307471f,12.717431f,
                    13.320418f,12.682299f, 13.275766f,12.676639f, 13.305766f,12.644522f, 13.277885f,12.624021f, 13.283978f,12.578423f,
                    13.268640f,12.590726f, 13.275445f,12.577134f, 13.204120f,12.549516f, 13.198862f,12.559946f, 13.159584f,12.550410f,
                    13.141504f,12.538355f, 13.144522f,12.501728f, 13.055230f,12.473627f, 13.075263f,12.449013f, 13.075004f,12.369504f,
                    13.091239f,12.368913f, 13.071876f,12.333579f, 13.100217f,12.295619f, 13.081305f,12.273966f, 13.114150f,12.263885f,
                    13.106254f,12.233064f, 13.130334f,12.199911f, 13.098112f,12.163721f, 13.114881f,12.106231f, 13.140983f,12.038438f,
                    13.255907f,11.883026f, 13.266334f,11.833573f, 14.742661f,11.833573f);
            poly[1104] = new TzPolygon(13.500102f,12.874346f, 13.486962f,12.916921f, 13.499885f,12.957689f, 13.521333f,12.955773f, 13.509280f,13.002347f,
                    13.536645f,13.021981f, 13.521190f,13.043633f, 13.543736f,13.041561f, 13.550016f,13.063124f, 13.527431f,13.061055f,
                    13.516082f,13.088528f, 13.539862f,13.104157f, 13.521731f,13.125212f, 13.541240f,13.122518f, 13.550505f,13.146734f,
                    13.517627f,13.140516f, 13.537532f,13.181114f, 13.513373f,13.197761f, 13.549107f,13.206669f, 13.564915f,13.239600f,
                    13.589331f,13.226536f, 13.595284f,13.262657f, 13.616308f,13.243326f, 13.696249f,13.309275f, 13.693536f,13.335389f,
                    13.721310f,13.338365f, 13.708160f,13.633381f, 13.316923f,13.915120f, 12.872529f,13.915120f, 12.872529f,12.874346f);
            poly[1105] = new TzPolygon(13.316923f,13.915120f, 13.708160f,13.633381f, 14.442820f,13.473480f, 14.477850f,13.499750f, 14.510480f,13.633160f,
                    14.551120f,13.696020f, 14.636560f,13.677310f, 14.698340f,13.745570f, 14.691970f,13.768730f, 14.721730f,13.809960f,
                    14.742661f,13.806960f, 14.742661f,13.915120f);
            poly[1106] = new TzPolygon(14.742661f,13.915120f, 14.742661f,13.806960f, 14.863210f,13.789680f, 15.031340f,13.862210f, 15.102238f,13.915120f);
            poly[1107] = new TzPolygon(12.872529f,14.129703f, 13.083333f,14.083333f, 13.083333f,14.466666f, 12.887574f,14.571977f, 12.872529f,14.559758f);
            poly[1108] = new TzPolygon(13.316923f,13.915120f, 13.083333f,14.083333f, 12.872529f,14.129703f, 12.872529f,13.915120f);
            poly[1109] = new TzPolygon(16.612793f,15.231601f, 15.731550f,14.384760f, 15.102238f,13.915120f, 16.612793f,13.915120f);
            poly[1110] = new TzPolygon(16.612793f,15.231601f, 16.897870f,15.505550f, 18.782222f,15.602500f, 19.932500f,15.753889f, 20.353056f,15.996667f,
                    16.612793f,15.996667f);
            poly[1111] = new TzPolygon(20.970852f,7.670478f, 21.778590f,8.996974f, 23.422283f,11.833573f, 20.353056f,11.833573f, 20.353056f,7.670478f);
            poly[1112] = new TzPolygon(23.828622f,11.833573f, 24.264727f,11.604258f, 24.200501f,11.422523f, 24.392829f,11.135854f, 24.429783f,11.044819f,
                    24.532734f,10.949659f, 24.568887f,10.847256f, 24.564018f,10.815651f, 24.510391f,10.766643f, 24.573067f,10.706074f,
                    24.573582f,10.614730f, 24.541327f,10.588023f, 24.533881f,10.545496f, 24.536972f,10.356677f, 24.599078f,10.302570f,
                    24.650641f,10.216372f, 24.965634f,10.037772f, 25.359573f,10.032093f, 26.195638f,9.398983f, 26.253330f,9.455908f,
                    26.385101f,9.512373f, 26.519911f,9.863299f, 26.646871f,9.913332f, 26.743180f,9.902106f, 26.861947f,9.925362f,
                    26.953616f,9.858083f, 27.256579f,9.782495f, 27.353630f,9.783926f, 27.433543f,9.805519f, 27.433543f,11.833573f);
            poly[1113] = new TzPolygon(23.828622f,11.833573f, 23.517178f,11.997337f, 23.422283f,11.833573f);
            poly[1114] = new TzPolygon(20.353056f,15.996667f, 20.698889f,15.673889f, 20.766389f,15.575833f, 20.884444f,15.558333f, 20.955278f,15.627222f,
                    21.445278f,15.284444f, 21.495833f,15.202500f, 21.998889f,15.194722f, 23.001239f,14.998583f, 23.497371f,15.996667f);
            poly[1115] = new TzPolygon(23.828622f,11.833573f, 27.433543f,11.833573f, 27.433543f,15.996667f, 23.497371f,15.996667f, 22.613611f,14.234444f,
                    23.168333f,13.543611f, 23.215556f,13.410833f, 23.517178f,11.997337f);
            poly[1116] = new TzPolygon(8.196696f,17.428843f, 7.871860f,17.428843f, 7.872390f,17.399310f, 7.847384f,17.399210f, 7.856193f,17.359944f,
                    7.826176f,17.325839f, 7.830490f,17.295906f, 7.787300f,17.255291f, 7.752918f,17.257767f, 7.771177f,17.223295f,
                    7.721758f,17.201063f, 7.717761f,17.164024f, 7.670348f,17.154111f, 7.666109f,17.121943f, 7.701544f,17.091505f,
                    7.665428f,17.088388f, 7.658034f,17.039254f, 7.638880f,17.035257f, 7.645338f,16.951193f, 7.609884f,16.922152f,
                    7.620523f,16.891936f, 7.578910f,16.886372f, 7.564847f,16.906428f, 7.561649f,16.864086f, 7.532831f,16.837546f,
                    7.535694f,16.809306f, 7.607618f,16.775954f, 7.639447f,16.729439f, 7.639546f,16.684413f, 7.672196f,16.659600f,
                    7.745498f,16.659909f, 7.774003f,16.589580f, 7.886645f,16.591143f, 7.848101f,16.507650f, 7.790056f,16.480002f,
                    7.787367f,16.450047f, 7.810242f,16.432012f, 7.772697f,16.406016f, 7.715739f,16.423436f, 7.673210f,16.384469f,
                    7.654743f,16.295848f, 7.605841f,16.229791f, 7.614450f,16.185530f, 7.581909f,16.066141f, 7.498369f,15.996667f,
                    8.196696f,15.996667f);
            poly[1117] = new TzPolygon(8.196696f,18.660934f, 8.194950f,18.657700f, 8.141190f,18.628100f, 8.091000f,18.637050f, 8.052470f,18.618050f,
                    8.009300f,18.031980f, 7.958610f,17.921640f, 7.984014f,17.662215f, 7.945253f,17.644019f, 7.914910f,17.563048f,
                    7.924120f,17.533484f, 7.890689f,17.534868f, 7.872443f,17.510592f, 7.902096f,17.461242f, 7.871643f,17.440967f,
                    7.871860f,17.428843f, 8.196696f,17.428843f);
            poly[1118] = new TzPolygon(8.196696f,18.660934f, 8.289884f,18.833527f, 8.346026f,18.848777f, 8.343372f,18.861019f, 8.196696f,18.861019f);
            poly[1119] = new TzPolygon(9.599042f,19.577107f, 9.035327f,19.577107f, 9.038653f,19.560755f, 9.022368f,19.543786f, 9.040073f,19.526625f,
                    9.019148f,19.516080f, 9.011778f,19.479589f, 9.032396f,19.477734f, 9.007540f,19.449899f, 9.026554f,19.443288f,
                    9.014694f,19.390372f, 9.029549f,19.362199f, 9.012272f,19.281901f, 9.039143f,19.219673f, 9.009328f,19.147155f,
                    9.024510f,19.123737f, 9.006632f,19.111094f, 9.013097f,19.052166f, 8.983164f,19.038248f, 8.972527f,18.985415f,
                    8.940589f,18.978186f, 8.960803f,18.956111f, 8.936769f,18.958238f, 8.880710f,18.863265f, 8.853199f,18.863444f,
                    8.854292f,18.902808f, 8.810247f,18.909474f, 8.810550f,18.948868f, 8.671659f,19.124031f, 8.637380f,19.065840f,
                    8.528049f,19.034826f, 8.516090f,18.988724f, 8.491714f,18.992302f, 8.425128f,18.920336f, 8.387347f,18.919241f,
                    8.341654f,18.868943f, 8.343372f,18.861019f, 9.599042f,18.861019f);
            poly[1120] = new TzPolygon(9.114794f,20.293195f, 9.139722f,20.207222f, 9.111944f,20.141667f, 9.151111f,20.104722f, 9.127500f,20.098611f,
                    9.134444f,20.061944f, 9.114444f,20.033611f, 9.088611f,20.029167f, 9.106667f,20.003889f, 9.080000f,19.988333f,
                    9.062500f,19.909167f, 9.041944f,19.894722f, 9.047778f,19.786389f, 9.013611f,19.683889f, 9.035327f,19.577107f,
                    9.599042f,19.577107f, 9.599042f,20.293195f);
            poly[1121] = new TzPolygon(10.641815f,21.725372f, 10.639444f,21.719444f, 10.514444f,21.701389f, 10.458725f,21.725372f, 10.325926f,21.725372f,
                    10.290556f,21.715556f, 10.284722f,21.687778f, 10.238889f,21.670833f, 10.223056f,21.638889f, 10.206389f,21.526944f,
                    10.116389f,21.455278f, 10.045833f,21.438333f, 9.973889f,21.371944f, 9.958333f,21.336111f, 9.973611f,21.256389f,
                    9.883611f,21.191944f, 9.842778f,21.130000f, 9.772500f,21.103056f, 9.752778f,21.068333f, 9.766667f,21.042500f,
                    9.738611f,21.015000f, 9.633611f,20.997222f, 9.628056f,20.975833f, 9.606111f,20.985000f, 9.605556f,20.956389f,
                    9.476478f,20.835708f, 9.415833f,20.822222f, 9.405556f,20.774722f, 9.376944f,20.759722f, 9.359722f,20.677778f,
                    9.338333f,20.656944f, 9.296389f,20.662778f, 9.321667f,20.541389f, 9.281667f,20.528611f, 9.271944f,20.496389f,
                    9.208889f,20.515000f, 9.207778f,20.482778f, 9.138889f,20.438889f, 9.104444f,20.328889f, 9.114794f,20.293195f,
                    11.001389f,20.293195f, 11.001389f,21.725372f);
            poly[1122] = new TzPolygon(10.594385f,23.157548f, 10.613611f,23.136389f, 10.695278f,23.013056f, 10.899722f,22.880556f, 11.001389f,22.911494f,
                    11.001389f,23.157548f);
            poly[1123] = new TzPolygon(11.001389f,22.904930f, 10.920556f,22.877778f, 11.000278f,22.460556f, 10.957778f,22.406389f, 10.941667f,22.322778f,
                    10.904722f,22.276667f, 10.910833f,22.244722f, 10.815833f,22.180833f, 10.830556f,22.047500f, 10.799167f,22.009444f,
                    10.728889f,21.995833f, 10.713889f,21.907500f, 10.666667f,21.857500f, 10.678333f,21.816667f, 10.641815f,21.725372f,
                    11.001389f,21.725372f);
            poly[1124] = new TzPolygon(10.458725f,21.725372f, 10.406667f,21.747778f, 10.325926f,21.725372f);
            poly[1125] = new TzPolygon(8.718677f,23.873636f, 8.728056f,23.824167f, 8.705000f,23.733889f, 8.737500f,23.633889f, 8.708611f,23.526389f,
                    8.772778f,23.497500f, 8.901389f,23.580278f, 8.994722f,23.582778f, 9.004722f,23.559722f, 8.960556f,23.533611f,
                    8.959722f,23.504167f, 9.019444f,23.447778f, 9.174167f,23.493333f, 9.184444f,23.561111f, 9.280000f,23.652500f,
                    9.339722f,23.639444f, 9.435833f,23.666111f, 9.445000f,23.633889f, 9.535278f,23.623611f, 9.599042f,23.657601f,
                    9.599042f,23.873636f);
            poly[1126] = new TzPolygon(8.721067f,23.873636f, 8.728056f,23.824167f, 8.705000f,23.733889f, 8.737500f,23.633889f, 8.705000f,23.558333f,
                    8.717778f,23.514444f, 8.796389f,23.502778f, 8.901389f,23.580278f, 8.994722f,23.582778f, 9.004722f,23.559722f,
                    8.960556f,23.533611f, 8.959722f,23.504167f, 9.019444f,23.447778f, 9.174167f,23.493333f, 9.184444f,23.561111f,
                    9.280000f,23.652500f, 9.339722f,23.639444f, 9.435833f,23.666111f, 9.445000f,23.633889f, 9.535278f,23.623611f,
                    9.599042f,23.657601f, 9.599042f,23.873636f);
            poly[1127] = new TzPolygon(8.721067f,23.873636f, 8.685278f,24.126944f, 8.694167f,24.249722f, 8.630278f,24.228889f, 8.583333f,24.269167f,
                    8.473889f,24.163333f, 8.382500f,24.141944f, 8.316667f,24.177222f, 8.247500f,24.356667f, 8.273333f,24.396111f,
                    8.271667f,24.466389f, 8.234722f,24.483056f, 8.205556f,24.539167f, 8.211225f,24.589724f, 8.196696f,24.589724f,
                    8.196696f,23.873636f);
            poly[1128] = new TzPolygon(8.718677f,23.873636f, 9.599042f,23.873636f, 9.599042f,24.589724f, 8.211225f,24.589724f, 8.205556f,24.539167f,
                    8.234722f,24.483056f, 8.271667f,24.466389f, 8.273333f,24.396111f, 8.247500f,24.356667f, 8.316667f,24.177222f,
                    8.382500f,24.141944f, 8.473889f,24.163333f, 8.583333f,24.269167f, 8.630278f,24.228889f, 8.691111f,24.253611f,
                    8.696667f,23.989722f);
            poly[1129] = new TzPolygon(10.594385f,23.157548f, 10.458889f,23.306667f, 9.867222f,23.669722f, 9.671553f,23.696254f, 9.599042f,23.657601f,
                    9.599042f,23.157548f);
            poly[1130] = new TzPolygon(9.599042f,23.657601f, 9.671553f,23.696254f, 9.867222f,23.669722f, 10.458889f,23.306667f, 10.594385f,23.157548f,
                    11.001389f,23.157548f, 11.001389f,24.589724f, 9.599042f,24.589724f);
            poly[1131] = new TzPolygon(6.991519f,26.021900f, 7.010556f,25.973611f, 7.085278f,25.920556f, 7.111111f,25.825833f, 7.168333f,25.764722f,
                    7.175000f,25.688333f, 7.251944f,25.567222f, 7.262500f,25.477222f, 7.348056f,25.364167f, 7.417500f,25.352778f,
                    7.470556f,25.294444f, 7.465556f,25.254722f, 7.494722f,25.209444f, 7.595000f,25.210278f, 7.680278f,25.292500f,
                    7.792500f,25.278333f, 7.882222f,25.203889f, 7.908056f,25.151667f, 7.893056f,25.090000f, 7.972500f,24.971111f,
                    8.038056f,24.905278f, 8.174167f,24.856111f, 8.196696f,24.758207f, 8.196696f,26.021900f);
            poly[1132] = new TzPolygon(6.991519f,26.021900f, 6.987778f,26.031389f, 6.910278f,26.066944f, 6.706944f,26.283333f, 6.651944f,26.425000f,
                    6.621111f,26.422500f, 6.570556f,26.344722f, 6.517778f,26.364722f, 6.466389f,26.323333f, 6.362500f,26.330833f,
                    6.314167f,26.404444f, 6.280000f,26.417500f, 6.283889f,26.485833f, 6.219722f,26.529444f, 6.202222f,26.579167f,
                    6.153056f,26.582778f, 6.079167f,26.504444f, 6.062500f,26.528333f, 6.077222f,26.584167f, 5.987222f,26.669722f,
                    5.998889f,26.761389f, 5.980000f,26.830556f, 5.888889f,26.920000f, 5.720833f,27.206667f, 5.671944f,27.232222f,
                    5.615278f,27.231389f, 5.555278f,27.293056f, 5.406492f,27.232098f, 5.392003f,27.236097f, 5.392003f,26.021900f);
            poly[1133] = new TzPolygon(8.211225f,24.589724f, 8.219167f,24.660556f, 8.196696f,24.758207f, 8.196696f,24.589724f);
            poly[1134] = new TzPolygon(8.196696f,24.758207f, 8.219167f,24.660556f, 8.211225f,24.589724f, 9.599042f,24.589724f, 9.599042f,26.021900f,
                    8.196696f,26.021900f);
            poly[1135] = new TzPolygon(11.001389f,25.305812f, 10.355954f,25.305812f, 10.360057f,25.275473f, 10.332984f,25.272514f, 10.359672f,25.214983f,
                    10.318433f,25.181587f, 10.336449f,25.144401f, 10.303965f,25.123346f, 10.307512f,25.086956f, 10.222866f,25.048342f,
                    10.179928f,25.055585f, 10.166050f,25.030793f, 10.113918f,25.078897f, 10.084626f,25.076987f, 10.083589f,25.048914f,
                    10.059282f,25.055414f, 10.054266f,25.030842f, 10.016881f,25.047342f, 10.003560f,25.012913f, 9.969010f,25.017553f,
                    9.959784f,24.985968f, 9.896904f,24.980091f, 9.897057f,24.948369f, 9.871570f,24.942305f, 9.860802f,24.902104f,
                    9.750510f,24.788290f, 9.729021f,24.740164f, 9.599042f,24.750891f, 9.599042f,24.589724f, 11.001389f,24.589724f);
            poly[1136] = new TzPolygon(10.133072f,26.021900f, 10.179166f,25.932219f, 10.385162f,25.930038f, 10.378085f,25.898870f, 10.411327f,25.894338f,
                    10.391457f,25.861776f, 10.423889f,25.838226f, 10.419332f,25.762328f, 10.439004f,25.760609f, 10.402683f,25.691025f,
                    10.432663f,25.662943f, 10.398912f,25.644014f, 10.406194f,25.582218f, 10.389111f,25.573828f, 10.407379f,25.553143f,
                    10.385433f,25.537337f, 10.395290f,25.505652f, 10.374544f,25.498478f, 10.390761f,25.473263f, 10.372796f,25.472063f,
                    10.396475f,25.442882f, 10.373087f,25.396210f, 10.389988f,25.389097f, 10.371142f,25.375661f, 10.378903f,25.339205f,
                    10.353653f,25.322831f, 10.355954f,25.305812f, 11.001389f,25.305812f, 11.001389f,26.021900f);
            poly[1137] = new TzPolygon(9.620707f,27.454076f, 9.626374f,27.142360f, 9.488887f,26.702774f, 9.564064f,26.393915f, 9.594234f,26.345882f,
                    9.645273f,26.308283f, 9.916673f,26.213893f, 10.000001f,26.116668f, 10.124876f,26.037846f, 10.133072f,26.021900f,
                    11.001389f,26.021900f, 11.001389f,27.454076f);
            poly[1138] = new TzPolygon(11.001389f,22.911494f, 11.209167f,22.974722f, 11.415833f,22.930833f, 11.401667f,22.791111f, 11.462222f,22.775556f,
                    11.516111f,22.641944f, 11.621667f,22.561667f, 11.799167f,22.572778f, 12.071111f,22.640833f, 12.030101f,22.477804f,
                    12.176944f,22.501389f, 12.403333f,22.432778f, 12.465278f,22.383889f, 12.621667f,22.466944f, 12.670278f,22.335000f,
                    12.747222f,22.223333f, 12.655278f,22.140556f, 12.643889f,21.952778f, 12.684722f,21.893889f, 12.733131f,21.858107f,
                    12.771974f,21.857763f, 12.806459f,21.814505f, 13.055408f,21.954459f, 13.055408f,24.589724f, 11.001389f,24.589724f);
            poly[1139] = new TzPolygon(15.109428f,22.936916f, 15.102479f,22.937319f, 15.088648f,22.882233f, 15.034433f,22.812730f, 14.967999f,22.750530f,
                    14.907796f,22.760227f, 14.863490f,22.667249f, 14.691389f,22.702500f, 14.629444f,22.470000f, 14.592222f,22.403333f,
                    14.554167f,22.384167f, 14.523056f,22.381389f, 14.479722f,22.445556f, 14.384167f,22.447500f, 14.344722f,22.469722f,
                    14.315000f,22.436111f, 14.272222f,22.443889f, 14.247222f,22.466389f, 14.231944f,22.555278f, 14.125556f,22.555000f,
                    14.106389f,22.485278f, 14.051667f,22.434444f, 14.052222f,22.396667f, 13.965833f,22.233889f, 13.779167f,22.084444f,
                    13.728056f,22.138611f, 13.669722f,22.133889f, 13.634444f,22.153611f, 13.571944f,22.224722f, 13.478889f,22.230556f,
                    13.358611f,22.294167f, 13.190278f,22.159722f, 13.142778f,22.029444f, 13.087500f,21.972500f, 13.055408f,21.956401f,
                    13.055408f,21.725372f, 15.109428f,21.725372f);
            poly[1140] = new TzPolygon(19.217466f,23.999543f, 15.697254f,23.999641f, 15.774693f,23.663636f, 15.768415f,23.551884f, 15.697697f,23.396874f,
                    15.717857f,23.126851f, 15.591077f,22.997590f, 15.554275f,22.929672f, 15.482553f,22.919383f, 15.414963f,22.988171f,
                    15.311621f,23.004799f, 15.259460f,22.985058f, 15.231305f,23.005143f, 15.166578f,22.933598f, 15.109428f,22.936916f,
                    15.109428f,21.725372f, 19.217466f,21.725372f);
            poly[1141] = new TzPolygon(27.433543f,27.454076f, 22.000000f,27.454076f, 22.000000f,25.000000f, 27.433543f,24.998334f);
            poly[1142] = new TzPolygon(19.217466f,24.000616f, 20.001944f,24.000833f, 19.999167f,25.000833f, 22.000000f,25.000000f, 22.000000f,27.454076f,
                    19.217466f,27.454076f);
            poly[1143] = new TzPolygon(23.497371f,15.996667f, 22.562778f,18.004444f, 21.673611f,19.826111f, 20.619722f,21.896111f, 19.500814f,23.999535f,
                    19.217466f,23.999543f, 19.217466f,15.996667f);
            poly[1144] = new TzPolygon(-4.112279f,29.379876f, -3.985271f,29.313032f, -3.928044f,29.243925f, -3.858320f,29.227256f, -3.584886f,29.250747f,
                    -3.322590f,29.214115f, -3.322590f,29.379876f);
            poly[1145] = new TzPolygon(-5.028596f,29.379876f, -4.995578f,29.363195f, -4.699707f,29.326977f, -4.578010f,29.379876f);
            poly[1146] = new TzPolygon(-2.409340f,28.878862f, -2.409340f,29.379876f, -2.834132f,29.379876f, -2.839758f,29.370886f, -2.747156f,29.333782f,
                    -2.702530f,29.350521f, -2.688654f,29.327791f, -2.652679f,29.327224f, -2.618486f,29.266554f, -2.631760f,29.220960f,
                    -2.595075f,29.163321f, -2.610244f,29.127862f, -2.592576f,29.086228f, -2.623330f,29.051049f, -2.709943f,29.057169f,
                    -2.743396f,29.039626f, -2.699244f,28.994903f, -2.703465f,28.966964f, -2.660515f,28.897305f, -2.568082f,28.895374f,
                    -2.525276f,28.861755f, -2.490957f,28.893016f, -2.436296f,28.866510f);
            poly[1147] = new TzPolygon(-2.409340f,28.416976f, -2.409340f,28.880369f, -2.428696f,28.867002f, -2.475765f,28.892144f, -2.529651f,28.861809f,
                    -2.568082f,28.895374f, -2.660515f,28.897305f, -2.733999f,29.034795f, -2.760993f,29.038286f, -2.784819f,29.001089f,
                    -2.815846f,29.005655f, -2.820119f,29.050933f, -2.875462f,29.092674f, -2.920532f,29.096731f, -2.950447f,29.158236f,
                    -2.996028f,29.167614f, -3.025161f,29.236978f, -3.067387f,29.258052f, -3.114764f,29.260937f, -3.197762f,29.222627f,
                    -3.270027f,29.240806f, -3.303064f,29.211388f, -3.322590f,29.214115f, -3.322590f,28.416976f);
            poly[1148] = new TzPolygon(-2.409340f,28.878862f, -2.386951f,28.889122f, -2.373070f,28.962045f, -2.293930f,29.001112f, -2.275534f,29.095659f,
                    -2.252341f,29.117627f, -2.120628f,29.174799f, -1.931648f,29.126828f, -1.861104f,29.136053f, -1.698129f,29.244817f,
                    -1.629410f,29.268322f, -1.599725f,29.310350f, -1.508912f,29.361813f, -1.508350f,29.379876f, -2.409340f,29.379876f);
            poly[1149] = new TzPolygon(-3.322590f,29.379876f, -3.322590f,30.664527f, -3.360996f,30.634596f, -3.398098f,30.677622f, -3.432569f,30.662382f,
                    -3.559929f,30.451401f, -3.606082f,30.457081f, -3.624086f,30.428390f, -3.714359f,30.386374f, -3.784147f,30.409578f,
                    -3.784573f,30.329062f, -3.845313f,30.308103f, -3.883658f,30.256327f, -3.940999f,30.231141f, -4.041431f,30.221396f,
                    -4.045814f,30.195813f, -4.114930f,30.158410f, -4.168063f,30.077929f, -4.276125f,30.042391f, -4.280263f,30.003528f,
                    -4.380915f,29.874090f, -4.363846f,29.814266f, -4.469315f,29.753756f, -4.446637f,29.674503f, -4.449006f,29.435951f,
                    -4.249727f,29.418817f, -4.116871f,29.382293f, -4.112279f,29.379876f);
            poly[1150] = new TzPolygon(-4.112279f,29.379876f, -4.116871f,29.382293f, -4.249727f,29.418817f, -4.445560f,29.435926f, -4.576309f,29.379876f);
            poly[1151] = new TzPolygon(-5.028981f,29.379876f, -5.115833f,29.409722f, -5.149089f,29.433419f, -5.149089f,29.379876f);
            poly[1152] = new TzPolygon(-2.834132f,29.379876f, -2.797347f,29.438653f, -2.829977f,29.521640f, -2.786958f,29.648746f, -2.819682f,29.708294f,
                    -2.811542f,29.752950f, -2.764520f,29.771721f, -2.755145f,29.801004f, -2.779287f,29.827833f, -2.759427f,29.877688f,
                    -2.702321f,29.917858f, -2.641939f,29.935610f, -2.557056f,29.920363f, -2.461088f,29.969950f, -2.370335f,29.943237f,
                    -2.329401f,29.956090f, -2.347465f,30.029594f, -2.421248f,30.094664f, -2.437677f,30.135094f, -2.428112f,30.183680f,
                    -2.349608f,30.224453f, -2.372384f,30.253044f, -2.371958f,30.301163f, -2.360619f,30.342776f, -3.322590f,30.342776f,
                    -3.322590f,29.379876f);
            poly[1153] = new TzPolygon(-1.496091f,29.458373f, -1.506156f,29.450326f, -1.508350f,29.379876f, -1.496091f,29.379876f);
            poly[1154] = new TzPolygon(-2.409340f,30.342776f, -2.409340f,30.537875f, -2.413021f,30.543608f, -2.662540f,30.419781f, -2.691213f,30.459301f,
                    -2.653976f,30.526463f, -2.680425f,30.525230f, -2.745108f,30.440433f, -2.793847f,30.442371f, -2.860973f,30.405949f,
                    -2.954394f,30.502341f, -2.894040f,30.575670f, -2.993935f,30.669629f, -2.971804f,30.703977f, -2.997736f,30.747555f,
                    -2.979518f,30.849846f, -3.052460f,30.797595f, -3.094371f,30.836367f, -3.146625f,30.817753f, -3.163629f,30.846193f,
                    -3.206975f,30.847516f, -3.224369f,30.813241f, -3.253653f,30.842551f, -3.292129f,30.758680f, -3.267285f,30.739660f,
                    -3.303037f,30.718979f, -3.320288f,30.666321f, -3.322590f,30.664527f, -3.322590f,30.342776f);
            poly[1155] = new TzPolygon(-2.409340f,30.550759f, -2.409340f,30.588030f, -2.419407f,30.569539f);
            poly[1156] = new TzPolygon(-2.409340f,30.661620f, -2.413661f,30.657208f, -2.409340f,30.641658f);
            poly[1157] = new TzPolygon(-2.360619f,30.342776f, -2.352306f,30.373286f, -2.309680f,30.408709f, -2.328820f,30.430343f, -2.320053f,30.461492f,
                    -2.366533f,30.471191f, -2.409340f,30.537875f, -2.409340f,30.342776f);
            poly[1158] = new TzPolygon(-2.409340f,30.561390f, -2.399291f,30.609942f, -2.409340f,30.642560f);
            poly[1159] = new TzPolygon(-2.409340f,30.661437f, -2.355543f,30.716561f, -2.390101f,30.780120f, -2.313268f,30.856968f, -2.205566f,30.843626f,
                    -2.077515f,30.899074f, -1.938131f,30.807827f, -1.814431f,30.831774f, -1.692822f,30.821364f, -1.650945f,30.839878f,
                    -1.523392f,30.745101f, -1.496091f,30.742638f, -1.496091f,31.305676f, -2.409340f,31.305676f);
            poly[1160] = new TzPolygon(-1.496091f,29.459616f, -1.388132f,29.559257f, -1.383068f,29.677643f, -1.340764f,29.731662f, -1.373239f,29.796858f,
                    -1.308800f,29.824562f, -1.360952f,29.861491f, -1.355895f,29.884447f, -1.423335f,29.885540f, -1.482318f,29.915771f,
                    -1.447779f,29.996117f, -1.412901f,30.021784f, -1.431131f,30.053745f, -1.378735f,30.072770f, -1.384247f,30.122450f,
                    -1.345172f,30.169930f, -1.274416f,30.169669f, -1.276458f,30.210858f, -1.189301f,30.292356f, -1.145096f,30.307049f,
                    -1.132719f,30.342776f, -1.496091f,30.342776f);
            poly[1161] = new TzPolygon(0.330408f,29.379876f, 0.330408f,29.859437f, 0.171769f,29.823737f, 0.163856f,29.769790f, 0.073335f,29.716295f,
                    -0.029610f,29.745211f, -0.042682f,29.729236f, -0.496528f,29.682838f, -0.553532f,29.653651f, -0.625480f,29.663467f,
                    -0.706251f,29.626078f, -0.900530f,29.638262f, -0.906885f,29.581886f, -0.981221f,29.602337f, -0.983058f,29.586848f,
                    -1.186269f,29.573433f, -1.221608f,29.608584f, -1.392979f,29.590028f, -1.411051f,29.526367f, -1.496091f,29.458373f,
                    -1.496091f,29.379876f);
            poly[1162] = new TzPolygon(-0.999996f,31.305676f, -0.999995f,30.799636f, -0.985512f,30.765330f, -1.015099f,30.698515f, -1.065887f,30.649129f,
                    -1.076232f,30.528283f, -1.047408f,30.447789f, -1.064643f,30.427456f, -1.062633f,30.351949f, -1.132111f,30.344531f,
                    -1.132719f,30.342776f, 0.330408f,30.342776f, 0.330408f,31.305676f);
            poly[1163] = new TzPolygon(-1.132719f,30.342776f, -1.132111f,30.344531f, -1.062633f,30.351949f, -1.064643f,30.427456f, -1.047408f,30.447789f,
                    -1.057457f,30.473213f, -1.088911f,30.451274f, -1.121826f,30.476458f, -1.155549f,30.470168f, -1.171783f,30.509316f,
                    -1.337142f,30.568722f, -1.445619f,30.738084f, -1.496091f,30.742638f, -1.496091f,30.342776f);
            poly[1164] = new TzPolygon(0.330408f,29.859437f, 0.388035f,29.872405f, 0.516361f,29.980209f, 0.638924f,29.954495f, 0.744524f,29.977882f,
                    0.778293f,29.963447f, 0.846147f,29.989127f, 0.894375f,30.104737f, 0.886092f,30.155449f, 0.963590f,30.184192f,
                    1.000841f,30.234215f, 1.054157f,30.220531f, 1.126472f,30.234646f, 1.162584f,30.268983f, 1.173364f,30.292535f,
                    1.150328f,30.336226f, 1.201656f,30.359956f, 1.187593f,30.390269f, 1.205700f,30.495437f, 1.266042f,30.519726f,
                    1.266134f,30.549684f, 2.116339f,31.305559f, 0.330408f,31.305676f);
            poly[1165] = new TzPolygon(5.002966f,27.454076f, 4.961285f,27.512156f, 4.921516f,27.512000f, 4.887752f,27.573603f, 4.896095f,27.648306f,
                    4.842823f,27.700356f, 4.794363f,27.701275f, 4.791322f,27.771397f, 4.727634f,27.782334f, 4.691578f,27.765513f,
                    4.608024f,27.790011f, 4.592507f,27.839293f, 4.539207f,27.893383f, 4.537352f,27.927337f, 4.580188f,27.948651f,
                    4.555898f,27.979050f, 4.551990f,28.047620f, 4.479282f,28.037323f, 4.417538f,28.080224f, 4.438329f,28.090624f,
                    4.442757f,28.140454f, 4.401817f,28.138705f, 4.350832f,28.207855f, 4.355462f,28.353098f, 4.285291f,28.380810f,
                    4.292943f,28.461629f, 4.378574f,28.515905f, 4.382415f,28.579437f, 4.420902f,28.603345f, 4.429361f,28.669204f,
                    4.510695f,28.697657f, 4.563972f,28.783521f, 4.480592f,28.834433f, 4.491327f,29.035206f, 4.460050f,29.082616f,
                    4.434524f,29.078743f, 4.431354f,29.136381f, 4.340702f,29.217023f, 4.353850f,29.252090f, 4.398732f,29.270585f,
                    4.382778f,29.306223f, 4.397281f,29.346893f, 4.470563f,29.369115f, 4.475716f,29.379876f, 2.156907f,29.379876f,
                    2.156907f,27.454076f);
            poly[1166] = new TzPolygon(3.579937f,30.839014f, 3.579937f,30.908587f, 3.488980f,30.854388f, 3.571079f,30.861418f);
            poly[1167] = new TzPolygon(2.156907f,31.305676f, 2.220856f,31.203075f, 2.293214f,31.203274f, 2.264059f,31.125475f, 2.302845f,31.070071f,
                    2.309382f,31.085462f, 2.343626f,31.074301f, 2.404795f,30.982844f, 2.393547f,30.948653f, 2.336641f,30.936351f,
                    2.332281f,30.904877f, 2.384108f,30.848439f, 2.426775f,30.834157f, 2.438698f,30.777929f, 2.419697f,30.751643f,
                    2.452837f,30.740202f, 2.510071f,30.761814f, 2.586277f,30.750089f, 2.603702f,30.777963f, 2.749732f,30.822752f,
                    2.773602f,30.859210f, 2.858263f,30.890147f, 2.961666f,30.858003f, 3.051907f,30.767992f, 3.069111f,30.794353f,
                    3.263285f,30.838246f, 3.280478f,30.870670f, 3.341151f,30.887477f, 3.399167f,30.936805f, 3.506244f,30.942020f,
                    3.478026f,30.869568f, 3.496667f,30.848840f, 3.493664f,30.866058f, 3.579937f,30.912603f, 3.579937f,31.305676f);
            poly[1168] = new TzPolygon(4.475716f,29.379876f, 4.500143f,29.430892f, 4.599027f,29.477133f, 4.668489f,29.464462f, 4.696338f,29.493815f,
                    4.655050f,29.534709f, 4.671958f,29.554791f, 4.659100f,29.622929f, 4.617015f,29.710137f, 4.570071f,29.744887f,
                    4.587526f,29.764057f, 4.560207f,29.825899f, 4.520152f,29.799610f, 4.373082f,29.799910f, 4.335356f,29.841552f,
                    4.347610f,29.902985f, 4.310150f,29.954079f, 4.287276f,29.967528f, 4.243995f,29.944251f, 4.209946f,29.973563f,
                    4.207765f,30.026657f, 4.131925f,30.060529f, 4.119715f,30.161293f, 4.048870f,30.161227f, 4.024117f,30.195046f,
                    3.937175f,30.213043f, 3.956474f,30.277103f, 3.914312f,30.296468f, 3.923092f,30.342776f, 3.579937f,30.342776f,
                    3.579937f,29.379876f);
            poly[1169] = new TzPolygon(3.579937f,31.305676f, 3.579937f,30.912603f, 3.691018f,30.972532f, 3.707365f,31.002852f, 3.693630f,31.022521f,
                    3.740399f,31.065634f, 3.736133f,31.100463f, 3.790776f,31.163750f, 3.796602f,31.289064f, 3.787471f,31.305676f);
            poly[1170] = new TzPolygon(3.923092f,30.342776f, 3.923766f,30.346330f, 3.865622f,30.410268f, 3.882418f,30.445983f, 3.832729f,30.466800f,
                    3.855664f,30.529757f, 3.842681f,30.551968f, 3.741481f,30.578780f, 3.619610f,30.562242f, 3.606296f,30.626617f,
                    3.643371f,30.685817f, 3.623298f,30.727272f, 3.636283f,30.757657f, 3.683461f,30.775505f, 3.593377f,30.805019f,
                    3.579937f,30.833804f, 3.579937f,30.342776f);
            poly[1171] = new TzPolygon(-0.998942f,31.831806f, -1.005137f,31.843944f, -1.028136f,31.839137f, -1.004433f,31.823686f);
            poly[1172] = new TzPolygon(-0.998942f,33.933350f, -1.000000f,33.933361f, -0.999996f,31.305676f, -0.998942f,31.305676f);
            poly[1173] = new TzPolygon(-0.998942f,33.933350f, -0.998942f,40.227580f, -3.562595f,40.227580f, -4.144853f,39.900042f, -4.681074f,39.647123f,
                    -4.681071f,39.605154f, -4.891904f,39.477932f, -4.899520f,39.441363f, -4.876042f,39.376929f, -4.680056f,39.219471f,
                    -3.671311f,37.784089f, -3.535680f,37.737660f, -3.504560f,37.678900f, -3.519970f,37.608390f, -3.480046f,37.626169f,
                    -3.461626f,37.585614f, -3.440514f,37.584550f, -3.310335f,37.711760f, -3.060820f,37.672770f, -1.028602f,34.093170f,
                    -1.046155f,34.040899f, -1.000000f,34.018917f, -1.000000f,33.933361f);
            poly[1174] = new TzPolygon(-0.998942f,33.933350f, -0.537005f,33.928582f, -0.129024f,33.982769f, 0.102198f,33.909899f, 0.323793f,34.056263f,
                    0.349777f,34.098959f, 0.456153f,34.088414f, 0.483377f,34.119477f, 0.582873f,34.138227f, 0.625970f,34.200325f,
                    0.640063f,34.277696f, 0.679399f,34.278717f, 0.698018f,34.314219f, 0.761603f,34.314840f, 0.808917f,34.414945f,
                    0.825885f,34.406456f, 0.937520f,34.479148f, 1.102321f,34.522304f, 1.098618f,34.574984f, 1.150042f,34.579372f,
                    1.208067f,34.669566f, 1.223124f,34.795183f, 1.269217f,34.830783f, 1.309730f,34.829073f, 1.365224f,34.787095f,
                    1.383833f,34.806498f, 1.413576f,34.793849f, 1.457112f,34.844239f, 1.528341f,34.864077f, 1.576609f,34.943670f,
                    1.664359f,34.991239f, 1.758546f,35.000308f, 1.962409f,35.000205f, 2.002012f,34.992487f, 2.002012f,35.766628f,
                    -0.998942f,35.766628f);
            poly[1175] = new TzPolygon(3.787471f,31.305676f, 3.676319f,31.507898f, 3.643986f,31.501771f, 3.638164f,31.517765f, 3.682357f,31.575750f,
                    3.723992f,31.707365f, 3.824802f,31.812757f, 3.784746f,31.869806f, 3.659903f,31.957451f, 3.571937f,31.958118f,
                    3.592202f,32.053057f, 3.560412f,32.087067f, 3.531521f,32.086031f, 3.507104f,32.200844f, 3.563712f,32.217889f,
                    3.600492f,32.197166f, 3.745619f,32.415280f, 3.767808f,32.720234f, 3.815606f,32.901165f, 3.893614f,33.027761f,
                    3.778745f,33.178821f, 3.751822f,33.511075f, 3.777192f,33.536152f, 2.002012f,33.536152f, 2.002012f,31.305676f);
            poly[1176] = new TzPolygon(4.628582f,35.766628f, 4.610000f,34.387500f, 3.776377f,33.536152f, 5.002966f,33.536152f, 5.002966f,35.766628f);
            poly[1177] = new TzPolygon(3.777192f,33.536152f, 4.234077f,33.987762f, 4.144009f,34.065686f, 4.121119f,34.049532f, 4.049080f,34.091356f,
                    4.009513f,34.060052f, 3.961347f,34.134641f, 3.861269f,34.088435f, 3.880859f,34.215572f, 3.831007f,34.226011f,
                    3.831560f,34.180062f, 3.806967f,34.153173f, 3.795133f,34.188647f, 3.767706f,34.170877f, 3.783891f,34.245585f,
                    3.711388f,34.307928f, 3.735161f,34.365072f, 3.669496f,34.463224f, 3.517132f,34.451497f, 3.491714f,34.424775f,
                    3.491768f,34.388971f, 3.450657f,34.416607f, 3.370584f,34.400617f, 3.342713f,34.429958f, 3.181988f,34.455822f,
                    3.141352f,34.494840f, 3.136529f,34.545816f, 3.091398f,34.572301f, 2.924676f,34.599040f, 2.906730f,34.639292f,
                    2.867562f,34.652895f, 2.877681f,34.701746f, 2.854986f,34.736348f, 2.787792f,34.775379f, 2.697880f,34.775411f,
                    2.655833f,34.799190f, 2.570588f,34.868247f, 2.592857f,34.893865f, 2.516585f,34.912996f, 2.515940f,34.933060f,
                    2.472408f,34.954412f, 2.402942f,34.914348f, 2.002012f,34.992487f, 2.002012f,33.536152f);
            poly[1178] = new TzPolygon(5.002966f,35.818334f, 5.002966f,40.227580f, 4.055009f,40.227580f, 4.043934f,40.191982f, 3.874727f,39.869568f,
                    3.666064f,39.773931f, 3.485644f,39.589727f, 3.397448f,39.553899f, 3.407031f,39.514898f, 3.464037f,39.495489f,
                    3.463671f,39.330938f, 3.500048f,39.327886f, 3.475024f,39.298894f, 3.476428f,39.195501f, 3.539233f,39.087713f,
                    3.509875f,39.021307f, 3.531054f,38.968511f, 3.512255f,38.906316f, 3.572253f,38.714727f, 3.623644f,38.687688f,
                    3.593249f,38.665533f, 3.603869f,38.579900f, 3.654223f,38.539312f, 3.649035f,38.516546f, 3.625842f,38.523138f,
                    3.601855f,38.448492f, 3.619860f,38.191289f, 3.605822f,38.129888f, 3.726428f,38.008733f, 4.292468f,37.128912f,
                    4.373461f,37.048101f, 4.447253f,36.844732f, 4.449740f,36.037285f, 4.534607f,35.955978f, 4.631039f,35.948997f,
                    4.774210f,35.817937f);
            poly[1179] = new TzPolygon(5.002966f,35.818334f, 4.774210f,35.817937f, 4.631039f,35.948997f, 4.628582f,35.766628f, 5.002966f,35.766628f);
            poly[1180] = new TzPolygon(8.269973f,27.454076f, 8.269973f,33.173177f, 8.256345f,33.174860f, 8.238451f,33.205233f, 8.196093f,33.166396f,
                    8.129026f,33.192548f, 8.110513f,33.120518f, 8.062987f,33.121156f, 8.073386f,33.084544f, 8.022113f,33.077460f,
                    8.008028f,33.038974f, 7.968543f,33.038657f, 7.944053f,32.997584f, 7.893308f,33.016513f, 7.858829f,33.004727f,
                    7.789424f,33.045232f, 7.802884f,33.092189f, 7.779893f,33.108420f, 7.803924f,33.159760f, 7.771995f,33.208230f,
                    7.779003f,33.246903f, 7.707503f,33.323200f, 7.756748f,33.434153f, 7.736665f,33.517679f, 7.691238f,33.549334f,
                    7.693495f,33.646854f, 7.663140f,33.715563f, 7.572843f,33.804442f, 7.559746f,33.840828f, 5.002966f,33.840828f,
                    5.002966f,27.454076f);
            poly[1181] = new TzPolygon(9.620707f,27.454076f, 9.612500f,27.905555f, 9.773131f,27.830588f, 10.166667f,27.833333f, 10.166667f,29.000000f,
                    9.673558f,28.999999f, 9.746928f,29.070488f, 9.750000f,29.537500f, 10.081953f,29.537492f, 10.288055f,29.941108f,
                    10.288068f,29.999998f, 9.960296f,30.529879f, 9.864292f,30.647452f, 8.269973f,30.647452f, 8.269973f,27.454076f);
            poly[1182] = new TzPolygon(8.269973f,33.840828f, 8.269973f,33.173177f, 8.295846f,33.169982f, 8.300310f,33.198137f, 8.334549f,33.191943f,
                    8.342271f,33.217333f, 8.383166f,33.186892f, 8.435524f,33.219130f, 8.425251f,33.235200f, 8.462603f,33.270932f,
                    8.439933f,33.292584f, 8.467686f,33.312306f, 8.426404f,33.397387f, 8.480736f,33.497324f, 8.473709f,33.560335f,
                    8.442883f,33.597432f, 8.471763f,33.618420f, 8.445385f,33.676366f, 8.377586f,33.700473f, 8.367764f,33.769101f,
                    8.399381f,33.801540f, 8.405510f,33.840828f);
            poly[1183] = new TzPolygon(11.536979f,32.391111f, 11.180805f,32.391111f, 11.043305f,32.469730f, 10.737488f,32.148885f, 10.650279f,31.988613f,
                    10.288890f,31.778334f, 9.816197f,31.364848f, 9.762007f,31.289791f, 9.750001f,30.837905f, 9.711747f,30.834268f,
                    9.864292f,30.647452f, 11.536979f,30.647452f);
            poly[1184] = new TzPolygon(10.274657f,33.840828f, 10.335715f,33.803667f, 10.441809f,33.668327f, 10.642550f,33.517171f, 10.777746f,33.246094f,
                    10.827894f,33.271098f, 11.232722f,33.202782f, 11.437224f,33.138323f, 11.536979f,33.153778f, 11.536979f,33.840828f);
            poly[1185] = new TzPolygon(6.636469f,33.840828f, 6.636469f,34.741684f, 6.594498f,34.768106f, 6.610790f,34.864242f, 6.558017f,34.939003f,
                    6.504036f,34.957689f, 6.447416f,35.021823f, 6.246949f,34.950147f, 6.185531f,34.978937f, 6.089775f,34.971951f,
                    6.075383f,35.004779f, 5.896967f,34.997657f, 5.687448f,35.130149f, 5.624417f,35.126028f, 5.498190f,35.314526f,
                    5.380840f,35.288753f, 5.334822f,35.316011f, 5.364531f,35.411743f, 5.412733f,35.473372f, 5.423659f,35.537765f,
                    5.404222f,35.616755f, 5.381796f,35.620613f, 5.392173f,35.717123f, 5.349077f,35.772102f, 5.320180f,35.862339f,
                    5.249368f,35.826450f, 5.183881f,35.865806f, 5.100429f,35.818503f, 5.002966f,35.818334f, 5.002966f,33.840828f);
            poly[1186] = new TzPolygon(7.559746f,33.840828f, 7.538901f,33.898742f, 7.474438f,33.925539f, 7.469004f,33.957712f, 7.421392f,34.001949f,
                    7.382611f,34.007229f, 7.356722f,34.036631f, 7.275899f,34.041349f, 7.269696f,34.011778f, 7.245961f,34.021703f,
                    7.193784f,34.101214f, 7.169813f,34.104884f, 7.131551f,34.190213f, 7.041492f,34.191523f, 6.977913f,34.305387f,
                    6.948005f,34.293094f, 6.912453f,34.373271f, 6.918636f,34.470561f, 6.817106f,34.543326f, 6.745065f,34.531284f,
                    6.723129f,34.617537f, 6.740384f,34.640323f, 6.685173f,34.711024f, 6.636469f,34.741684f, 6.636469f,33.840828f);
            poly[1187] = new TzPolygon(9.903476f,33.840828f, 9.903476f,33.986673f, 9.809405f,33.965672f, 9.730099f,33.904363f, 9.499999f,33.877584f,
                    9.500001f,34.106678f, 9.032806f,34.145517f, 8.607698f,34.145517f, 8.555785f,34.100536f, 8.529791f,34.044935f,
                    8.488511f,34.023590f, 8.503893f,33.971997f, 8.482808f,33.897228f, 8.411017f,33.876133f, 8.405510f,33.840828f);
            poly[1188] = new TzPolygon(9.903476f,33.986673f, 9.903476f,34.206525f, 9.758056f,34.140000f, 9.553056f,34.085833f, 9.500001f,34.106678f,
                    9.499999f,33.877584f, 9.730099f,33.904363f, 9.809405f,33.965672f);
            poly[1189] = new TzPolygon(9.903476f,34.192713f, 10.030278f,34.231389f, 10.117222f,34.323056f, 10.231944f,34.347778f, 10.538579f,34.280011f,
                    10.784444f,34.439722f, 10.887778f,34.594444f, 10.745833f,34.773333f, 10.686944f,34.773333f, 10.729444f,34.808611f,
                    10.735000f,34.864444f, 10.785833f,34.868611f, 10.864444f,34.975278f, 10.915278f,34.978611f, 10.956667f,34.933333f,
                    11.198333f,35.007500f, 11.256944f,34.963889f, 11.536979f,35.084642f, 11.536979f,37.034204f, 9.903476f,37.034204f);
            poly[1190] = new TzPolygon(10.274657f,33.840828f, 10.171371f,33.903690f, 10.145910f,33.970458f, 10.091990f,33.971295f, 10.060354f,33.995551f,
                    9.922644f,33.990952f, 9.903476f,33.986673f, 9.903476f,33.840828f);
            poly[1191] = new TzPolygon(11.536979f,32.391111f, 11.706235f,32.391111f, 11.951050f,32.096585f, 11.951051f,32.745703f, 12.013791f,32.759488f,
                    12.236389f,32.731580f, 12.218997f,33.294404f, 12.172075f,33.252170f, 11.536979f,33.153778f);
            poly[1192] = new TzPolygon(14.256491f,37.034204f, 14.252133f,37.019725f, 14.292728f,36.971514f, 14.322145f,36.852891f, 14.322492f,36.743784f,
                    14.300535f,36.690773f, 14.313503f,36.633441f, 14.283840f,36.555588f, 14.257421f,36.560272f, 14.364444f,36.523611f,
                    14.803986f,36.474209f, 14.803986f,37.034204f);
            poly[1193] = new TzPolygon(14.803986f,33.840828f, 14.803986f,36.474209f, 14.364444f,36.523611f, 14.257421f,36.560272f, 13.956944f,36.446389f,
                    13.839444f,36.486944f, 13.663056f,36.410556f, 13.586944f,36.406389f, 13.368056f,36.248611f, 13.058611f,36.163889f,
                    12.984167f,36.169722f, 12.923333f,36.132778f, 12.875278f,36.165278f, 12.707574f,36.142472f, 12.694167f,36.107778f,
                    12.723611f,36.081111f, 12.724167f,36.006389f, 12.665833f,35.699444f, 12.612222f,35.695278f, 12.594167f,35.649167f,
                    12.250556f,35.438056f, 12.200556f,35.432500f, 12.161111f,35.381111f, 12.032778f,35.345556f, 11.975556f,35.271111f,
                    11.935795f,35.267688f, 11.900833f,35.235556f, 11.863889f,35.134444f, 11.826944f,35.096944f, 11.720556f,35.058056f,
                    11.557778f,35.093611f, 11.536979f,35.084642f, 11.536979f,33.840828f);
            poly[1194] = new TzPolygon(14.256491f,37.034204f, 14.803986f,37.034204f, 14.803986f,37.863496f, 14.182380f,37.523761f, 14.183971f,37.496295f,
                    14.217306f,37.466286f, 14.254288f,37.469030f, 14.301437f,37.393368f, 14.365535f,37.392685f, 14.447924f,37.309114f,
                    14.444047f,37.222432f, 14.409566f,37.135452f, 14.275475f,37.097270f);
            poly[1195] = new TzPolygon(14.445318f,38.630892f, 14.407305f,38.520860f, 14.424554f,38.485159f, 14.413264f,38.455297f, 14.469494f,38.424470f,
                    14.512327f,38.347121f, 14.589744f,38.312826f, 14.618306f,38.269395f, 14.680131f,38.257206f, 14.694873f,38.191086f,
                    14.678617f,38.187354f, 14.675502f,38.143277f, 14.716499f,38.091601f, 14.720204f,38.044608f, 14.803986f,37.981050f,
                    14.803986f,38.630892f);
            poly[1196] = new TzPolygon(14.445318f,38.630892f, 14.803986f,38.630892f, 14.803986f,40.227580f, 14.394561f,40.227580f, 14.387112f,40.213192f,
                    14.546030f,40.134477f, 14.540404f,40.069291f, 14.448291f,40.008617f, 14.454797f,39.988701f, 14.415153f,39.930448f,
                    14.503208f,39.794097f, 14.546152f,39.770087f, 14.555449f,39.713171f, 14.598341f,39.669049f, 14.609022f,39.586794f,
                    14.550181f,39.508106f, 14.514124f,39.510207f, 14.491425f,39.538023f, 14.484060f,39.495864f, 14.505190f,39.489444f,
                    14.539500f,39.373114f, 14.483310f,39.360033f, 14.493940f,39.328644f, 14.466250f,39.346443f, 14.469920f,39.301334f,
                    14.410326f,39.250771f, 14.450227f,39.227767f, 14.484996f,39.266784f, 14.515458f,39.261593f, 14.563238f,39.241032f,
                    14.565330f,39.205283f, 14.608330f,39.157394f, 14.649190f,39.168513f, 14.653246f,39.153878f, 14.638667f,39.032213f,
                    14.544992f,38.978483f, 14.466903f,38.797526f, 14.470889f,38.704908f);
            poly[1197] = new TzPolygon(14.803986f,36.474209f, 15.167382f,36.433365f, 15.229299f,36.534283f, 15.437222f,36.610556f, 15.449722f,36.647778f,
                    15.489444f,36.626111f, 15.753056f,36.697778f, 15.808056f,36.763611f, 16.215000f,36.915833f, 16.269444f,36.973056f,
                    16.358333f,36.947778f, 16.425278f,36.956944f, 16.517778f,36.896389f, 16.641111f,36.912222f, 16.706111f,36.980556f,
                    16.850556f,37.022778f, 16.943056f,36.986944f, 17.003611f,37.018056f, 17.073889f,36.995833f, 17.065842f,37.034204f,
                    14.803986f,37.034204f);
            poly[1198] = new TzPolygon(14.803986f,37.863496f, 14.894054f,37.912722f, 14.803986f,37.981050f);
            poly[1199] = new TzPolygon(18.070992f,38.788101f, 18.020698f,38.582747f, 17.899265f,38.452055f, 17.644444f,38.344444f, 17.603056f,38.273611f,
                    17.535278f,38.261944f, 17.528889f,38.222500f, 17.562222f,38.185833f, 17.548611f,38.133611f, 17.498889f,38.135556f,
                    17.481111f,38.111389f, 17.496667f,38.091944f, 17.543889f,38.095556f, 17.551944f,38.055833f, 17.447500f,37.917222f,
                    17.445000f,37.869722f, 17.481389f,37.818889f, 17.465278f,37.787500f, 17.376667f,37.735833f, 17.325833f,37.516944f,
                    17.306892f,37.498721f, 17.274492f,37.521624f, 17.254688f,37.497665f, 17.201053f,37.505980f, 17.054665f,37.395797f,
                    17.061111f,37.306944f, 17.025000f,37.252222f, 17.015556f,37.151944f, 17.051111f,37.104444f, 17.065842f,37.034204f,
                    18.070992f,37.034204f);
        }
    }

    private static class Initializer13 {
        private static void init() {
            poly[1200] = new TzPolygon(22.000000f,27.454076f, 22.000000f,31.315029f, 22.131552f,31.365019f, 22.224918f,31.469795f, 22.185232f,31.506184f,
                    22.000000f,31.398882f, 22.000000f,33.840828f, 18.070992f,33.840828f, 18.070992f,27.454076f);
            poly[1201] = new TzPolygon(22.752268f,33.840828f, 22.752268f,36.736511f, 22.708019f,36.775746f, 22.478471f,36.844054f, 22.431276f,36.943900f,
                    22.374618f,37.000446f, 22.065117f,37.115352f, 22.000000f,37.106838f, 22.000000f,33.840828f);
            poly[1202] = new TzPolygon(18.693124f,40.227580f, 18.893711f,39.963143f, 19.405013f,39.822946f, 19.640372f,39.724062f, 20.181745f,39.294263f,
                    20.650788f,39.078082f, 21.007849f,38.837496f, 21.608943f,38.631753f, 21.801708f,38.537916f, 22.066339f,38.543059f,
                    22.361175f,38.635811f, 22.674664f,38.411313f, 22.752268f,38.405645f, 22.752268f,40.227580f);
            poly[1203] = new TzPolygon(22.752268f,40.227580f, 22.752268f,38.405645f, 22.978272f,38.389140f, 23.363728f,38.087575f, 23.511514f,37.872612f,
                    24.015943f,37.513185f, 24.155067f,37.291030f, 24.225199f,37.038980f, 24.294464f,36.967298f, 25.124138f,36.654638f,
                    25.272189f,36.502032f, 25.567847f,36.273909f, 25.666170f,36.260581f, 25.820553f,36.308958f, 25.964505f,36.277750f,
                    26.071918f,36.172220f, 26.263092f,36.065695f, 26.548408f,35.802326f, 26.847968f,35.589538f, 27.052458f,35.507182f,
                    27.319863f,35.332708f, 27.433543f,35.203242f, 27.433543f,40.227580f);
            poly[1204] = new TzPolygon(-74.917383f,-34.628225f, -86.000000f,-34.628225f, -86.000000f,-35.000000f, -75.000000f,-35.000000f);
            poly[1205] = new TzPolygon(-64.000000f,-64.000000f, -64.800000f,-63.800000f, -65.250000f,-65.500000f, -64.500000f,-65.000000f);
            poly[1206] = new TzPolygon(-61.800000f,-59.000000f, -62.250000f,-58.800000f, -63.400000f,-57.300000f, -64.000000f,-64.000000f, -62.700000f,-63.000000f);
            poly[1207] = new TzPolygon(-52.168257f,-69.122039f, -52.150443f,-69.190145f, -52.151654f,-69.486316f, -52.000744f,-69.995504f, -51.999914f,-71.922586f,
                    -51.972131f,-71.965540f, -51.977265f,-72.010316f, -51.958861f,-72.032083f, -51.919754f,-71.931763f, -51.873565f,-71.948770f,
                    -51.744052f,-72.121756f, -51.699251f,-72.297230f, -51.638135f,-72.283320f, -51.625427f,-72.319111f, -51.587321f,-72.327058f,
                    -51.584547f,-72.441305f, -51.513573f,-72.405165f, -51.520811f,-72.344922f, -51.484526f,-72.351054f, -51.475055f,-72.324087f,
                    -51.366104f,-72.308916f, -51.336323f,-72.371600f, -51.283303f,-72.269188f, -51.252599f,-72.259215f, -51.200376f,-72.304678f,
                    -51.202595f,-72.346752f, -51.106483f,-72.410394f, -51.080011f,-72.376154f, -51.022385f,-72.373059f, -51.035044f,-72.265599f,
                    -50.972131f,-72.258414f, -50.972131f,-69.122039f);
            poly[1208] = new TzPolygon(-50.373695f,-73.373347f, -50.381667f,-73.416944f, -50.343611f,-73.437778f, -50.307998f,-73.373347f);
            poly[1209] = new TzPolygon(-50.293629f,-73.373347f, -50.242903f,-73.451511f, -50.182628f,-73.430901f, -50.153689f,-73.521806f, -50.106770f,-73.514484f,
                    -50.089282f,-73.475683f, -50.049939f,-73.497465f, -50.053925f,-73.461665f, -50.010242f,-73.435664f, -49.965570f,-73.444526f,
                    -49.942466f,-73.560537f, -49.757830f,-73.438495f, -49.705218f,-73.508808f, -49.618914f,-73.463397f, -49.538104f,-73.549396f,
                    -49.498248f,-73.539325f, -49.482501f,-73.463520f, -49.428729f,-73.490131f, -49.391924f,-73.425922f, -49.319415f,-73.410297f,
                    -49.268328f,-73.496418f, -49.204718f,-73.473070f, -49.229091f,-73.373347f);
            poly[1210] = new TzPolygon(-49.073372f,-73.373347f, -48.716648f,-73.967390f, -48.726341f,-74.027707f, -48.695323f,-74.159088f, -48.724463f,-74.252300f,
                    -48.690535f,-74.305429f, -48.681412f,-74.381561f, -48.706587f,-74.557568f, -48.641295f,-74.682194f, -48.631255f,-74.790449f,
                    -48.486002f,-74.790449f, -48.486002f,-73.373347f);
            poly[1211] = new TzPolygon(-50.972131f,-72.258414f, -50.876478f,-72.247490f, -50.752742f,-72.349541f, -50.657242f,-72.287850f, -50.649807f,-72.337772f,
                    -50.616387f,-72.356772f, -50.637502f,-72.411419f, -50.601685f,-72.494385f, -50.621316f,-72.547016f, -50.681844f,-72.591455f,
                    -50.615734f,-72.731788f, -50.671444f,-72.895256f, -50.741236f,-72.954872f, -50.761865f,-73.043148f, -50.788907f,-73.068504f,
                    -50.780556f,-73.143889f, -50.820556f,-73.200000f, -50.767778f,-73.149722f, -50.741323f,-73.196293f, -50.652494f,-73.145106f,
                    -50.570482f,-73.331530f, -50.534435f,-73.357258f, -50.372778f,-73.368333f, -50.373695f,-73.373347f, -50.307998f,-73.373347f,
                    -50.301389f,-73.361389f, -50.293629f,-73.373347f, -49.729067f,-73.373347f, -49.729067f,-71.956244f, -50.972131f,-71.956244f);
            poly[1212] = new TzPolygon(-49.073372f,-73.373347f, -49.211531f,-73.143273f, -49.265847f,-73.134544f, -49.252987f,-73.089363f, -49.272109f,-73.042002f,
                    -49.283889f,-73.097513f, -49.338210f,-73.095560f, -49.373236f,-73.133583f, -49.420633f,-73.037109f, -49.516321f,-73.022261f,
                    -49.624278f,-73.139591f, -49.676071f,-73.156243f, -49.729067f,-73.294078f, -49.729067f,-73.373347f);
            poly[1213] = new TzPolygon(-49.073372f,-73.373347f, -48.486002f,-73.373347f, -48.486002f,-72.569485f, -48.487366f,-72.585860f, -48.799627f,-72.533240f,
                    -48.867375f,-72.640228f, -48.866211f,-72.689366f, -48.968829f,-72.795893f, -48.943008f,-72.942709f, -48.991041f,-72.988221f,
                    -49.026108f,-72.977261f, -49.033164f,-73.009969f, -49.059837f,-73.000914f, -49.179147f,-73.140826f, -49.211531f,-73.143273f);
            poly[1214] = new TzPolygon(-48.486002f,-72.409653f, -48.514964f,-72.440543f, -48.519521f,-72.501370f, -48.486002f,-72.532000f);
            poly[1215] = new TzPolygon(-48.486002f,-72.569485f, -48.483102f,-72.534651f, -48.486002f,-72.532000f);
            poly[1216] = new TzPolygon(-48.486002f,-72.409653f, -48.451306f,-72.372647f, -48.416961f,-72.405593f, -48.391377f,-72.346763f, -48.350902f,-72.379676f,
                    -48.363328f,-72.277107f, -48.322420f,-72.225673f, -48.234494f,-72.316137f, -48.160122f,-72.298627f, -48.074376f,-72.359822f,
                    -48.065322f,-72.443140f, -47.969140f,-72.424469f, -47.938727f,-72.527184f, -47.813606f,-72.466888f, -47.747154f,-72.523710f,
                    -47.747214f,-72.441670f, -47.661172f,-72.420519f, -47.635718f,-72.344622f, -47.592011f,-72.307954f, -47.571453f,-72.327564f,
                    -47.498924f,-72.294466f, -47.455519f,-72.343117f, -47.405974f,-72.244262f, -47.416734f,-72.197213f, -47.329625f,-72.130104f,
                    -47.340456f,-72.046001f, -47.294770f,-71.996930f, -47.198372f,-72.021783f, -47.211988f,-71.956244f, -48.486002f,-71.956244f);
            poly[1217] = new TzPolygon(-46.975173f,-71.956244f, -46.974253f,-71.958174f, -46.904758f,-71.970878f, -46.891481f,-71.956244f);
            poly[1218] = new TzPolygon(-46.822256f,-71.956244f, -46.816163f,-71.959565f, -46.815647f,-71.956244f);
            poly[1219] = new TzPolygon(-45.999874f,-71.647592f, -46.000007f,-69.122039f, -46.000024f,-71.647732f);
            poly[1220] = new TzPolygon(-45.999874f,-71.643072f, -46.089645f,-71.715576f, -46.139787f,-71.915540f, -46.164399f,-71.901381f, -46.157342f,-71.869104f,
                    -46.194966f,-71.860119f, -46.192339f,-71.790144f, -46.228897f,-71.751031f, -46.284685f,-71.723935f, -46.346223f,-71.756790f,
                    -46.638954f,-71.646060f, -46.688349f,-71.646749f, -46.765864f,-71.770248f, -46.798850f,-71.839168f, -46.815685f,-71.956244f,
                    -45.999874f,-71.956244f);
            poly[1221] = new TzPolygon(-46.822256f,-71.956244f, -46.868576f,-71.930999f, -46.891481f,-71.956244f);
            poly[1222] = new TzPolygon(-46.975173f,-71.956244f, -47.011827f,-71.879346f, -47.076828f,-71.955347f, -47.126997f,-71.863246f, -47.162756f,-71.850571f,
                    -47.213934f,-71.891140f, -47.231009f,-71.864685f, -47.211988f,-71.956244f);
            poly[1223] = new TzPolygon(-51.089499f,-69.122039f, -51.089499f,-68.799167f, -51.500085f,-68.634973f, -51.607390f,-68.629448f, -51.896129f,-68.415487f,
                    -52.270048f,-68.037246f, -52.349500f,-68.026787f, -52.434537f,-68.070925f, -52.523273f,-68.174496f, -52.578244f,-68.307953f,
                    -52.522572f,-68.515748f, -52.386402f,-68.418376f, -52.332497f,-68.418688f, -52.277765f,-68.837980f, -52.203612f,-68.986873f,
                    -52.168257f,-69.122039f);
            poly[1224] = new TzPolygon(-55.940225f,-69.122039f, -52.168257f,-69.122039f, -52.203612f,-68.986873f, -52.277765f,-68.837980f, -52.332497f,-68.418688f,
                    -52.386402f,-68.418376f, -52.659022f,-68.606761f, -54.913692f,-68.609671f, -54.880906f,-68.399190f, -54.873726f,-67.950712f,
                    -54.905562f,-67.706496f, -54.894333f,-67.572310f, -54.923486f,-67.476209f, -54.905627f,-67.264616f, -54.929633f,-67.122637f,
                    -54.976657f,-67.030228f, -54.997049f,-66.826615f, -55.119059f,-66.670940f, -55.121667f,-66.416667f, -55.183333f,-66.078333f,
                    -55.217262f,-66.075347f, -55.306560f,-66.112536f, -55.623486f,-66.429033f, -55.855613f,-66.453857f, -55.937454f,-66.511203f,
                    -56.114545f,-66.832094f, -56.179111f,-67.264759f, -56.042972f,-68.003464f, -55.927462f,-68.219511f);
            poly[1225] = new TzPolygon(-45.999917f,-69.122039f, -45.999981f,-65.401461f, -46.000007f,-69.122039f);
            poly[1226] = new TzPolygon(-27.426989f,-57.411484f, -27.441097f,-57.506667f, -27.383750f,-57.601072f, -27.383750f,-57.411484f);
            poly[1227] = new TzPolygon(-27.565886f,-56.929806f, -27.562194f,-56.937524f, -27.489437f,-56.987878f, -27.466431f,-57.231774f, -27.414530f,-57.327425f,
                    -27.426989f,-57.411484f, -27.383750f,-57.411484f, -27.383750f,-56.929806f);
            poly[1228] = new TzPolygon(-27.565886f,-56.929806f, -27.383750f,-56.929806f, -27.383750f,-56.217655f, -27.401206f,-56.236151f, -27.408220f,-56.283768f,
                    -27.494085f,-56.293697f, -27.594162f,-56.386292f, -27.569581f,-56.462913f, -27.449462f,-56.530368f, -27.421017f,-56.601169f,
                    -27.460740f,-56.649547f, -27.468146f,-56.721080f, -27.548630f,-56.677096f, -27.576937f,-56.685955f, -27.605025f,-56.743305f,
                    -27.586888f,-56.793692f, -27.606393f,-56.845127f);
            poly[1229] = new TzPolygon(-27.383750f,-55.687280f, -27.445158f,-55.736915f, -27.409480f,-55.836335f, -27.383750f,-55.859440f);
            poly[1230] = new TzPolygon(-28.393264f,-55.893571f, -28.361586f,-55.877394f, -28.370951f,-55.751566f, -28.393264f,-55.737148f);
            poly[1231] = new TzPolygon(-28.393264f,-55.686687f, -28.332177f,-55.670467f, -28.274140f,-55.774151f, -28.244807f,-55.775696f, -28.177189f,-55.631672f,
                    -28.116039f,-55.607468f, -28.165234f,-55.559574f, -28.076818f,-55.495201f, -28.097869f,-55.446106f, -28.029000f,-55.368000f,
                    -27.979478f,-55.382994f, -27.972000f,-55.343000f, -27.926637f,-55.327065f, -27.929692f,-55.265742f, -27.867119f,-55.206523f,
                    -28.393264f,-55.206523f);
            poly[1232] = new TzPolygon(-27.383750f,-54.216578f, -27.386035f,-54.217363f, -27.397000f,-54.261000f, -27.448195f,-54.284845f, -27.402263f,-54.337713f,
                    -27.467252f,-54.350459f, -27.405000f,-54.410000f, -27.426739f,-54.470814f, -27.472000f,-54.444000f, -27.481000f,-54.503000f,
                    -27.505902f,-54.524598f, -27.453000f,-54.574000f, -27.541000f,-54.621000f, -27.508003f,-54.677088f, -27.573936f,-54.679261f,
                    -27.561000f,-54.742000f, -27.586000f,-54.775000f, -27.533000f,-54.814000f, -27.624000f,-54.850000f, -27.638708f,-54.906169f,
                    -27.726000f,-54.903000f, -27.772000f,-54.936000f, -27.773000f,-54.989000f, -27.797784f,-55.012999f, -27.769321f,-55.050940f,
                    -27.779000f,-55.081000f, -27.834000f,-55.024000f, -27.855772f,-55.030303f, -27.846000f,-55.106000f, -27.896061f,-55.132624f,
                    -27.856000f,-55.196000f, -27.867119f,-55.206523f, -27.383750f,-55.206523f);
            poly[1233] = new TzPolygon(20.875696f,-74.790449f, 20.786618f,-74.617986f, 20.444741f,-74.047256f, 20.332640f,-73.949476f, 20.216068f,-73.919000f,
                    20.067675f,-73.966645f, 19.901473f,-74.146785f, 19.753908f,-74.790449f);
            poly[1234] = new TzPolygon(20.888781f,-74.068076f, 20.888781f,-72.961406f, 20.836151f,-72.993005f, 20.780223f,-73.047057f, 20.747023f,-73.119238f,
                    20.705985f,-73.629360f, 20.728948f,-73.746754f, 20.805749f,-73.839721f);
            poly[1235] = new TzPolygon(19.079476f,-72.827404f, 19.079476f,-71.701378f, 19.073210f,-71.701150f, 19.030960f,-71.771424f, 18.993074f,-71.788411f,
                    19.005487f,-71.833459f, 18.959283f,-71.886457f, 18.941705f,-71.879738f, 18.970334f,-71.836512f, 18.954721f,-71.781304f,
                    18.906876f,-71.768160f, 18.878448f,-71.722298f, 18.722193f,-71.737955f, 18.685288f,-71.804196f, 18.630613f,-71.815352f,
                    18.627111f,-71.880535f, 18.649019f,-71.908281f, 18.634797f,-71.925697f, 18.656665f,-71.966361f, 18.625016f,-72.008231f,
                    18.603425f,-71.965129f, 18.503719f,-71.880801f, 18.485265f,-71.913721f, 18.457184f,-71.904546f, 18.378810f,-71.795323f,
                    18.340637f,-71.696020f, 18.180586f,-71.788066f, 18.148727f,-71.746865f, 18.068456f,-71.738461f, 17.953787f,-71.829509f,
                    18.090777f,-71.977204f, 18.100931f,-72.019935f, 18.045224f,-72.827404f);
            poly[1236] = new TzPolygon(19.079476f,-71.701378f, 19.105909f,-71.702341f, 19.115873f,-71.654201f, 19.206655f,-71.621755f, 19.235332f,-71.645568f,
                    19.240675f,-71.697080f, 19.278273f,-71.725392f, 19.262319f,-71.731626f, 19.274190f,-71.748093f, 19.329518f,-71.782734f,
                    19.371358f,-71.713641f, 19.360122f,-71.693955f, 19.444757f,-71.678286f, 19.512560f,-71.688070f, 19.584680f,-71.743137f,
                    19.661530f,-71.734993f, 19.731262f,-71.773662f, 19.796456f,-71.913843f, 19.953058f,-72.057471f, 20.888781f,-71.257498f,
                    20.888781f,-70.864359f, 19.079476f,-70.864359f);
            poly[1237] = new TzPolygon(20.888781f,-74.068076f, 21.151443f,-74.790449f, 24.507391f,-74.790449f, 24.305040f,-74.323528f, 23.217770f,-73.441397f,
                    22.470244f,-72.526660f, 22.397729f,-72.470202f, 22.325449f,-72.447752f, 21.948685f,-72.549879f, 21.803964f,-72.630110f,
                    21.540119f,-72.677290f, 21.134138f,-72.814092f, 20.888781f,-72.961406f);
            poly[1238] = new TzPolygon(20.888781f,-71.257498f, 20.979376f,-71.180046f, 21.013958f,-71.110514f, 21.148919f,-70.979051f, 21.181769f,-70.864359f,
                    20.888781f,-70.864359f);
            poly[1239] = new TzPolygon(17.962145f,-68.110146f, 18.032232f,-68.149209f, 18.159037f,-68.161270f, 18.237614f,-68.145212f, 18.287709f,-68.110146f);
            poly[1240] = new TzPolygon(18.090418f,-65.040186f, 18.225000f,-65.100000f, 18.250000f,-65.160000f, 18.430000f,-65.108000f, 18.561463f,-65.194611f,
                    18.605456f,-65.095175f, 18.607818f,-65.040186f);
            poly[1241] = new TzPolygon(18.090418f,-65.040186f, 18.607818f,-65.040186f, 18.611435f,-64.955961f, 18.397500f,-64.863889f, 18.408056f,-64.799167f,
                    18.377222f,-64.755833f, 18.364167f,-64.639444f, 18.321111f,-64.636944f, 18.278611f,-64.661389f, 18.106342f,-64.640138f,
                    18.029421f,-64.850254f, 18.047544f,-64.939115f, 18.100478f,-65.012449f);
            poly[1242] = new TzPolygon(17.615815f,-63.467388f, 17.615815f,-62.786255f, 17.279160f,-63.051129f, 17.329000f,-63.130669f, 17.418074f,-63.193474f,
                    17.421000f,-63.299959f, 17.465000f,-63.392221f, 17.534000f,-63.448399f);
            poly[1243] = new TzPolygon(17.615815f,-63.467388f, 17.622000f,-63.468824f, 17.706000f,-63.454661f, 17.783000f,-63.404870f, 17.835000f,-63.321523f,
                    17.850000f,-63.237785f, 17.814000f,-63.104546f, 17.735835f,-63.019720f, 17.673976f,-62.847226f, 17.615815f,-62.786255f);
            poly[1244] = new TzPolygon(18.063986f,-63.053224f, 18.017220f,-62.949445f, 17.806209f,-63.054445f, 17.851000f,-63.202966f, 17.896354f,-63.267794f,
                    18.053210f,-63.138583f);
            poly[1245] = new TzPolygon(18.190278f,-62.876389f, 18.162863f,-62.767393f, 18.137557f,-62.764406f, 18.017220f,-62.949445f, 18.063852f,-63.052330f,
                    18.053210f,-63.138583f, 17.896354f,-63.267794f, 17.967190f,-63.335665f, 18.061545f,-63.360564f);
            poly[1246] = new TzPolygon(18.137557f,-62.764406f, 18.102717f,-62.691512f, 18.037377f,-62.623930f, 17.895705f,-62.584402f, 17.801834f,-62.602224f,
                    17.733899f,-62.646249f, 17.687045f,-62.716892f, 17.670931f,-62.806973f, 17.735835f,-63.019720f, 17.780835f,-63.066390f,
                    18.017220f,-62.949445f);
            poly[1247] = new TzPolygon(14.272500f,-61.003889f, 14.248663f,-61.096863f, 14.272500f,-61.137076f);
            poly[1248] = new TzPolygon(14.272500f,-61.003889f, 14.272500f,-60.694712f, 14.221738f,-60.753188f);
            poly[1249] = new TzPolygon(15.079510f,-61.515737f, 15.079246f,-61.158913f, 15.007421f,-61.370245f, 15.042183f,-61.481351f);
            poly[1250] = new TzPolygon(15.787222f,-61.850567f, 15.787222f,-61.442500f, 15.644411f,-61.679823f, 15.715000f,-61.806201f);
            poly[1251] = new TzPolygon(15.787222f,-61.041043f, 15.746000f,-61.073256f, 15.701667f,-61.138333f, 15.734167f,-61.323611f, 15.787222f,-61.442500f);
            poly[1252] = new TzPolygon(17.146803f,-62.330352f, 17.108000f,-62.212501f, 17.015298f,-62.140067f, 16.757390f,-62.447583f, 16.818000f,-62.518611f,
                    16.899313f,-62.553652f);
            poly[1253] = new TzPolygon(17.503210f,-62.584402f, 17.419000f,-62.513395f, 17.330000f,-62.402047f, 17.250000f,-62.349104f, 17.146803f,-62.330352f,
                    16.899313f,-62.553652f, 16.896779f,-62.584402f);
            poly[1254] = new TzPolygon(16.714000f,-62.140067f, 16.714000f,-61.938204f, 16.699000f,-61.935382f, 16.609000f,-61.956662f, 16.530000f,-62.018761f,
                    16.487000f,-62.093222f, 16.481245f,-62.140067f);
            poly[1255] = new TzPolygon(17.015298f,-62.140067f, 17.005619f,-62.109034f, 16.837713f,-61.961479f, 16.714000f,-61.938204f, 16.714000f,-62.140067f);
            poly[1256] = new TzPolygon(-69.000000f,-5.500000f, -86.000000f,-5.500000f, -86.000000f,-17.000000f, -71.000000f,-17.000000f);
            poly[1257] = new TzPolygon(-68.000000f,25.000000f, -86.000000f,25.000000f, -86.000000f,0.000000f, -68.000000f,0.000000f);
            poly[1258] = new TzPolygon(6.113484f,-10.881472f, 6.131467f,-10.911890f, 6.217496f,-10.994758f, 6.323764f,-11.018611f, 6.544761f,-11.478392f,
                    6.635449f,-11.556299f, 6.755000f,-11.608076f, 6.929214f,-11.506233f, 6.938163f,-11.418093f, 6.969373f,-11.432173f,
                    7.022377f,-11.369220f, 7.071421f,-11.374588f, 7.078700f,-11.332722f, 7.140514f,-11.352486f, 7.148563f,-11.328003f,
                    7.210294f,-11.310403f, 7.197447f,-11.291633f, 7.238875f,-11.272552f, 7.230473f,-11.251737f, 7.264953f,-11.181941f,
                    7.390724f,-11.102111f, 7.403861f,-11.059504f, 7.513667f,-10.932952f, 7.497456f,-10.922288f, 7.524327f,-10.881472f);
            poly[1259] = new TzPolygon(8.056728f,-13.439885f, 8.124000f,-13.450028f, 8.230000f,-13.399223f, 8.352000f,-13.482388f, 8.494000f,-13.500339f,
                    8.568000f,-13.486636f, 8.638000f,-13.444025f, 8.836000f,-13.449651f, 8.966000f,-13.495776f, 9.036079f,-13.301206f,
                    9.095863f,-13.199646f, 9.050996f,-13.128106f, 9.048735f,-13.081904f, 9.081216f,-13.072756f, 9.096942f,-13.021877f,
                    9.169200f,-12.979297f, 9.180636f,-12.951057f, 9.227069f,-12.971358f, 9.282095f,-12.953768f, 9.288444f,-12.931099f,
                    9.261827f,-12.906930f, 9.293538f,-12.879613f, 9.281062f,-12.847149f, 9.303543f,-12.785498f, 9.344635f,-12.774828f,
                    9.348647f,-12.746287f, 9.396298f,-12.753743f, 9.389026f,-12.707223f, 9.411733f,-12.703913f, 9.408429f,-12.683117f,
                    9.513992f,-12.644625f, 9.538524f,-12.654538f, 9.544659f,-12.638547f, 8.056728f,-12.638547f);
            poly[1260] = new TzPolygon(9.544659f,-12.638547f, 9.548303f,-12.629047f, 9.605798f,-12.615513f, 9.601701f,-12.587666f, 9.703384f,-12.564143f,
                    9.721718f,-12.531691f, 9.706567f,-12.518610f, 9.845347f,-12.495655f, 9.880862f,-12.437889f, 9.932905f,-12.222482f,
                    9.906727f,-12.218454f, 9.869980f,-12.123623f, 9.940182f,-11.906884f, 9.999944f,-11.894622f, 9.999973f,-11.208071f,
                    9.975012f,-11.213198f, 9.960631f,-11.171886f, 9.865509f,-11.155931f, 9.861494f,-11.102933f, 9.813882f,-11.061469f,
                    9.818049f,-11.043227f, 9.787408f,-11.039009f, 9.751102f,-10.991321f, 9.663941f,-10.963905f, 9.654848f,-10.917867f,
                    9.601756f,-10.910969f, 9.591666f,-10.881472f, 8.056728f,-10.881472f, 8.056728f,-12.638547f);
            poly[1261] = new TzPolygon(5.616687f,-7.386640f, 5.616687f,-7.367323f, 4.189802f,-7.367323f, 4.162121f,-7.509634f, 4.162242f,-7.526990f,
                    4.362148f,-7.529589f, 4.393427f,-7.566383f, 4.435477f,-7.539373f, 4.456824f,-7.566897f, 4.511487f,-7.551943f,
                    4.583875f,-7.573500f, 4.611906f,-7.547840f, 4.653025f,-7.576169f, 4.668763f,-7.559442f, 4.783194f,-7.560701f,
                    4.801640f,-7.594605f, 4.896031f,-7.599211f, 4.920609f,-7.526098f, 4.973483f,-7.558175f, 4.996221f,-7.542109f,
                    5.075595f,-7.557050f, 5.107209f,-7.522019f, 5.096323f,-7.506934f, 5.149704f,-7.473951f, 5.278270f,-7.475047f,
                    5.298592f,-7.414660f, 5.259243f,-7.415192f, 5.330139f,-7.367758f, 5.386745f,-7.375840f, 5.365021f,-7.400077f,
                    5.429648f,-7.449083f, 5.443404f,-7.439925f, 5.429437f,-7.420294f, 5.475940f,-7.422875f, 5.508646f,-7.390725f,
                    5.522698f,-7.404398f, 5.526396f,-7.381374f, 5.579458f,-7.395127f, 5.582483f,-7.372480f);
            poly[1262] = new TzPolygon(6.317634f,-8.245860f, 6.323893f,-8.283508f, 6.340861f,-8.271393f, 6.378804f,-8.341246f, 6.354276f,-8.397650f,
                    6.370690f,-8.414707f, 6.386010f,-8.384917f, 6.429255f,-8.412565f, 6.443337f,-8.396310f, 6.498406f,-8.443172f,
                    6.500669f,-8.466286f, 6.471791f,-8.456529f, 6.434952f,-8.482110f, 6.499477f,-8.550298f, 6.506148f,-8.601725f,
                    6.526219f,-8.595998f, 6.523754f,-8.571709f, 6.570854f,-8.563719f, 6.560365f,-8.542026f, 6.576194f,-8.530551f,
                    6.609616f,-8.540484f, 6.596376f,-8.511129f, 6.618110f,-8.507667f, 6.614111f,-8.487690f, 6.662446f,-8.453200f,
                    6.685466f,-8.404930f, 6.712931f,-8.409556f, 6.767268f,-8.359845f, 6.761819f,-8.342923f, 6.797089f,-8.348472f,
                    6.814916f,-8.320354f, 6.837699f,-8.329424f, 6.863647f,-8.309245f, 6.885520f,-8.336588f, 6.912843f,-8.307964f,
                    6.970788f,-8.327148f, 7.004484f,-8.274724f, 7.077782f,-8.301022f, 7.077782f,-8.245860f);
            poly[1263] = new TzPolygon(6.317634f,-8.245860f, 6.310042f,-8.200190f, 6.279650f,-8.175297f, 6.322500f,-8.006177f, 6.296536f,-7.993351f,
                    6.284795f,-7.902793f, 6.195129f,-7.822580f, 6.191577f,-7.844410f, 6.075621f,-7.851266f, 6.096694f,-7.832424f,
                    6.092832f,-7.801545f, 6.055516f,-7.798814f, 6.035948f,-7.769348f, 5.988284f,-7.792358f, 5.932873f,-7.741885f,
                    5.897659f,-7.686724f, 5.952739f,-7.663445f, 5.913179f,-7.661012f, 5.896749f,-7.581485f, 5.831155f,-7.549465f,
                    5.855846f,-7.516585f, 5.837073f,-7.522310f, 5.811831f,-7.483549f, 5.862119f,-7.465958f, 5.845069f,-7.424365f,
                    5.754688f,-7.443774f, 5.616687f,-7.386640f, 5.616687f,-8.245860f);
            poly[1264] = new TzPolygon(8.538878f,-10.002935f, 8.441187f,-10.002935f, 8.427025f,-10.055265f, 8.498696f,-10.045973f, 8.535006f,-10.119289f,
                    8.526036f,-10.162251f, 8.479013f,-10.207489f, 8.506361f,-10.323912f, 8.482837f,-10.357294f, 8.490380f,-10.383676f,
                    8.411639f,-10.431149f, 8.309204f,-10.542492f, 8.354449f,-10.642650f, 8.280327f,-10.701320f, 8.375577f,-10.676068f,
                    8.392305f,-10.639378f, 8.424515f,-10.650757f, 8.538878f,-10.616800f);
            poly[1265] = new TzPolygon(7.524327f,-10.881472f, 7.549146f,-10.843773f, 7.736022f,-10.701644f, 7.774626f,-10.604332f, 8.040542f,-10.605165f,
                    8.048099f,-10.575784f, 8.145422f,-10.501112f, 8.147601f,-10.397145f, 8.165673f,-10.377170f, 8.150163f,-10.351673f,
                    8.197015f,-10.301531f, 8.284757f,-10.320212f, 8.340018f,-10.288465f, 8.490938f,-10.277130f, 8.479013f,-10.207489f,
                    8.526036f,-10.162251f, 8.535006f,-10.119289f, 8.498696f,-10.045973f, 8.427924f,-10.058509f, 8.428238f,-10.040421f,
                    8.449289f,-10.002935f, 7.077782f,-10.002935f, 7.077782f,-10.881472f);
            poly[1266] = new TzPolygon(8.449289f,-10.002935f, 8.499477f,-9.913566f, 8.500830f,-9.854315f, 8.483829f,-9.842383f, 8.507753f,-9.790742f,
                    8.526469f,-9.800966f, 8.538878f,-9.785231f, 8.538878f,-9.746908f, 8.525612f,-9.724947f, 8.503610f,-9.743872f,
                    8.439339f,-9.717750f, 8.484220f,-9.697927f, 8.501782f,-9.663292f, 8.454249f,-9.620021f, 8.405213f,-9.658221f,
                    8.404147f,-9.608808f, 8.424864f,-9.590682f, 8.381562f,-9.552117f, 8.373440f,-9.496846f, 8.348558f,-9.477569f,
                    8.318344f,-9.518782f, 8.267001f,-9.488971f, 8.241740f,-9.512220f, 8.189326f,-9.515499f, 8.176500f,-9.462251f,
                    8.083103f,-9.440836f, 8.043131f,-9.460182f, 8.060909f,-9.409410f, 8.020340f,-9.404725f, 7.976488f,-9.442593f,
                    7.890854f,-9.439611f, 7.746473f,-9.349224f, 7.658560f,-9.379831f, 7.613072f,-9.359180f, 7.472894f,-9.424897f,
                    7.429783f,-9.468057f, 7.367042f,-9.482319f, 7.426459f,-9.420602f, 7.388434f,-9.403479f, 7.435867f,-9.350814f,
                    7.426818f,-9.294154f, 7.375265f,-9.281980f, 7.389297f,-9.206986f, 7.318946f,-9.203205f, 7.271039f,-9.155351f,
                    7.273515f,-9.124398f, 7.077782f,-9.124398f, 7.077782f,-10.002935f);
            poly[1267] = new TzPolygon(9.591666f,-10.881472f, 9.528648f,-10.860019f, 9.516090f,-10.824031f, 9.499018f,-10.848523f, 9.455264f,-10.851985f,
                    9.412596f,-10.802475f, 9.377810f,-10.810901f, 9.379581f,-10.731523f, 9.328307f,-10.705132f, 9.310683f,-10.663425f,
                    9.213131f,-10.656026f, 9.185703f,-10.702634f, 9.200171f,-10.714934f, 9.081140f,-10.730468f, 9.085594f,-10.666421f,
                    9.051220f,-10.573873f, 8.986904f,-10.591202f, 8.805366f,-10.561048f, 8.782636f,-10.519816f, 8.672920f,-10.464359f,
                    8.625686f,-10.492699f, 8.598731f,-10.574771f, 8.573390f,-10.574422f, 8.542202f,-10.615813f, 8.538878f,-10.616800f,
                    8.538878f,-10.881472f);
            poly[1268] = new TzPolygon(8.538878f,-9.785231f, 8.551986f,-9.768609f, 8.538878f,-9.746908f);
            poly[1269] = new TzPolygon(7.077782f,-8.301022f, 7.087964f,-8.304675f, 7.182125f,-8.281116f, 7.246788f,-8.369097f, 7.272830f,-8.355716f,
                    7.328065f,-8.395801f, 7.532628f,-8.424368f, 7.531077f,-8.453217f, 7.557172f,-8.471017f, 7.628078f,-8.397063f,
                    7.593105f,-8.382240f, 7.612193f,-8.307922f, 7.585010f,-8.297981f, 7.556444f,-8.245860f, 7.077782f,-8.245860f);
            poly[1270] = new TzPolygon(8.538878f,-8.245860f, 7.554576f,-8.245860f, 7.585010f,-8.297981f, 7.612193f,-8.307922f, 7.587915f,-8.360238f,
                    7.628078f,-8.397063f, 7.557172f,-8.471017f, 7.631502f,-8.569942f, 7.695752f,-8.553885f, 7.695744f,-8.676459f,
                    7.641369f,-8.714162f, 7.556031f,-8.725855f, 7.515144f,-8.706389f, 7.348944f,-8.853597f, 7.276366f,-8.837304f,
                    7.255804f,-8.905104f, 7.295203f,-8.916573f, 7.290569f,-8.940855f, 7.265285f,-8.943858f, 7.247000f,-9.025236f,
                    7.198511f,-9.069882f, 7.210499f,-9.095943f, 7.190605f,-9.108189f, 7.273515f,-9.124398f, 8.538878f,-9.124398f);
            poly[1271] = new TzPolygon(8.538878f,-7.684003f, 8.496617f,-7.658928f, 8.441261f,-7.678094f, 8.380320f,-7.638199f, 8.377334f,-7.740485f,
                    8.474476f,-7.786696f, 8.495360f,-7.823946f, 8.437291f,-7.828238f, 8.422009f,-7.878706f, 8.441366f,-7.879221f,
                    8.456139f,-7.919218f, 8.490266f,-7.907889f, 8.508772f,-7.932779f, 8.488568f,-7.985308f, 8.510817f,-8.088201f,
                    8.479977f,-8.109535f, 8.506428f,-8.188253f, 8.459659f,-8.237937f, 8.357937f,-8.214965f, 8.235372f,-8.243449f,
                    8.184833f,-8.173607f, 8.181849f,-8.099919f, 8.154895f,-8.052692f, 8.194630f,-8.034691f, 8.179825f,-8.019564f,
                    8.192830f,-7.981026f, 8.102008f,-8.012981f, 8.090208f,-7.975662f, 8.017109f,-7.943015f, 8.017062f,-7.980815f,
                    8.048560f,-7.996697f, 8.036965f,-8.062147f, 7.883110f,-8.134847f, 7.797761f,-8.091256f, 7.657397f,-8.144591f,
                    7.608218f,-8.184913f, 7.584276f,-8.170411f, 7.561416f,-8.183195f, 7.538724f,-8.218713f, 7.554576f,-8.245860f,
                    8.538878f,-8.245860f);
            poly[1272] = new TzPolygon(9.999973f,-8.140173f, 9.983245f,-8.147105f, 9.979639f,-8.114620f, 9.962030f,-8.112053f, 9.950539f,-8.163334f,
                    9.909014f,-8.151473f, 9.904096f,-8.121459f, 9.868941f,-8.138987f, 9.873563f,-8.103153f, 9.833266f,-8.092317f,
                    9.806046f,-8.111899f, 9.762599f,-8.101751f, 9.759569f,-8.121897f, 9.653693f,-8.115101f, 9.624851f,-8.144905f,
                    9.549601f,-8.143753f, 9.461665f,-8.102079f, 9.395482f,-8.035085f, 9.421289f,-7.848958f, 9.339614f,-7.881989f,
                    9.298997f,-7.873934f, 9.213204f,-7.923058f, 9.161609f,-7.882640f, 9.176020f,-7.823357f, 9.106207f,-7.782297f,
                    9.072677f,-7.726566f, 9.066225f,-7.840262f, 9.032525f,-7.856740f, 9.025193f,-7.898678f, 8.987946f,-7.934001f,
                    8.936633f,-7.916443f, 8.900458f,-7.942366f, 8.884126f,-7.925087f, 8.849049f,-7.937639f, 8.829746f,-7.974708f,
                    8.776612f,-7.931540f, 8.791417f,-7.877295f, 8.757368f,-7.831257f, 8.767450f,-7.787564f, 8.741906f,-7.791301f,
                    8.730895f,-7.761474f, 8.658844f,-7.732688f, 8.647130f,-7.688983f, 8.618032f,-7.671642f, 8.559728f,-7.696374f,
                    8.538878f,-7.684003f, 8.538878f,-9.124398f, 9.999973f,-9.124398f);
            poly[1273] = new TzPolygon(9.999973f,-8.140366f, 10.056258f,-8.117690f, 10.097318f,-8.008806f, 10.134687f,-8.014238f, 10.173500f,-7.989511f,
                    10.153077f,-7.936037f, 10.200211f,-7.892721f, 10.213245f,-7.833935f, 10.306107f,-7.748024f, 10.310432f,-7.772628f,
                    10.344594f,-7.753215f, 10.346662f,-7.722573f, 10.373129f,-7.739448f, 10.462040f,-7.626121f, 10.411919f,-7.548070f,
                    10.459645f,-7.518974f, 10.453334f,-7.457228f, 10.341932f,-7.435175f, 10.352537f,-7.391514f, 10.337964f,-7.367323f,
                    10.271946f,-7.367323f, 10.258989f,-7.389089f, 10.245365f,-7.377723f, 10.242986f,-7.367323f, 9.999973f,-7.367323f);
            poly[1274] = new TzPolygon(9.999973f,-11.208071f, 9.999973f,-14.395621f, 10.011000f,-14.408190f, 10.015000f,-14.507029f, 10.060000f,-14.590367f,
                    10.173000f,-14.664172f, 10.253000f,-14.683399f, 10.282000f,-14.765661f, 10.345000f,-14.830337f, 10.462040f,-14.855785f,
                    10.462040f,-8.241570f, 10.419884f,-8.231183f, 10.414881f,-8.182569f, 10.449110f,-8.098713f, 10.393421f,-8.105054f,
                    10.354318f,-8.082277f, 10.331409f,-8.052522f, 10.346286f,-7.988536f, 10.252545f,-7.945088f, 10.134687f,-8.014238f,
                    10.097318f,-8.008806f, 10.058185f,-8.116052f, 9.999973f,-8.140173f);
            poly[1275] = new TzPolygon(10.462040f,-15.487632f, 10.483267f,-15.517969f, 10.538795f,-15.552878f, 10.631383f,-15.568051f, 10.666667f,-15.561771f,
                    10.666667f,-15.341667f, 10.884419f,-15.101679f, 10.977044f,-14.957673f, 11.364614f,-14.772313f, 11.504958f,-14.663604f,
                    11.500663f,-14.586488f, 10.462040f,-14.586488f, 10.462040f,-14.855785f, 10.531000f,-14.870779f, 10.573000f,-14.914423f,
                    10.582000f,-15.053476f, 10.629253f,-15.148679f, 10.565629f,-15.157531f, 10.482806f,-15.208200f, 10.462040f,-15.238664f);
            poly[1276] = new TzPolygon(12.686238f,-16.985033f, 12.686238f,-15.163646f, 12.613723f,-15.337639f, 12.537045f,-15.429051f, 12.424853f,-15.683065f,
                    12.442799f,-15.953417f, 12.472449f,-16.038821f, 12.449675f,-16.162611f, 12.461253f,-16.202766f, 12.362526f,-16.381002f,
                    12.359202f,-16.689724f, 12.237284f,-16.894523f, 12.321000f,-16.957292f, 12.437000f,-16.992877f, 12.577000f,-16.973236f);
            poly[1277] = new TzPolygon(12.681999f,-14.586488f, 12.686238f,-15.163646f, 12.686238f,-14.586488f);
            poly[1278] = new TzPolygon(12.682026f,-14.586488f, 12.675615f,-13.708148f, 12.607889f,-13.709542f, 12.489885f,-13.641637f, 12.430171f,-13.634878f,
                    12.405487f,-13.666319f, 12.319961f,-13.658163f, 12.310637f,-13.686146f, 12.249019f,-13.717877f, 12.277139f,-13.759555f,
                    12.251633f,-13.799938f, 12.297280f,-13.800325f, 12.258186f,-13.822354f, 12.283243f,-13.831120f, 12.281348f,-13.855269f,
                    12.242291f,-13.857077f, 12.234614f,-13.919187f, 12.199802f,-13.957084f, 12.144907f,-13.937796f, 12.136924f,-13.875451f,
                    12.107841f,-13.868168f, 12.092841f,-13.809603f, 12.048205f,-13.789223f, 12.008197f,-13.696349f, 11.707412f,-13.708167f,
                    11.682585f,-13.775727f, 11.693774f,-13.798187f, 11.717533f,-13.795444f, 11.704219f,-13.820634f, 11.734663f,-13.823871f,
                    11.747154f,-13.854383f, 11.729758f,-13.863718f, 11.716951f,-13.845641f, 11.659303f,-13.873299f, 11.685015f,-13.922119f,
                    11.654852f,-13.936302f, 11.654801f,-14.039105f, 11.626110f,-14.082562f, 11.664702f,-14.135062f, 11.677024f,-14.267145f,
                    11.602356f,-14.319521f, 11.496490f,-14.511552f, 11.500663f,-14.586488f);
            poly[1279] = new TzPolygon(12.663650f,-13.383294f, 12.673900f,-13.483647f, 12.681999f,-14.586488f, 12.686238f,-14.586488f, 12.686238f,-13.383294f);
            poly[1280] = new TzPolygon(12.663650f,-13.383294f, 12.686238f,-13.383294f, 12.686238f,-12.180100f, 12.359674f,-12.180100f, 12.334759f,-12.282213f,
                    12.350657f,-12.302219f, 12.314428f,-12.362077f, 12.385185f,-12.403218f, 12.409620f,-12.495844f, 12.366222f,-12.564676f,
                    12.408356f,-12.583388f, 12.435902f,-12.626558f, 12.433511f,-12.765245f, 12.467693f,-12.750831f, 12.493359f,-12.845049f,
                    12.517313f,-12.834324f, 12.555151f,-12.893055f, 12.527449f,-12.949487f, 12.475614f,-12.944720f, 12.484881f,-13.061397f,
                    12.537982f,-13.071130f, 12.587196f,-13.045762f, 12.644052f,-13.063378f, 12.627009f,-13.179054f, 12.654162f,-13.207883f,
                    12.641702f,-13.319079f, 12.658362f,-13.331516f);
            poly[1281] = new TzPolygon(12.686238f,-11.578503f, 12.440931f,-11.578503f, 12.433769f,-11.641329f, 12.381908f,-11.770085f, 12.403361f,-11.804864f,
                    12.392930f,-11.847518f, 12.449131f,-11.899895f, 12.405456f,-11.968085f, 12.402339f,-12.015019f, 12.433291f,-12.062134f,
                    12.417435f,-12.112764f, 12.360285f,-12.177595f, 12.359674f,-12.180100f, 12.686238f,-12.180100f);
            poly[1282] = new TzPolygon(12.436188f,-11.578503f, 12.441798f,-11.432808f, 12.396858f,-11.364931f, 12.388857f,-11.432783f, 12.353546f,-11.449076f,
                    12.282924f,-11.430278f, 12.231525f,-11.486291f, 12.184802f,-11.496682f, 12.134093f,-11.454564f, 12.107568f,-11.366777f,
                    12.062805f,-11.356431f, 12.023905f,-11.310762f, 11.998042f,-11.225089f, 12.019844f,-11.211694f, 12.018918f,-11.180417f,
                    12.066296f,-11.137812f, 12.101563f,-11.141231f, 12.099426f,-11.113588f, 12.130845f,-11.101049f, 12.141176f,-11.067777f,
                    12.221613f,-11.047472f, 12.227873f,-10.976906f, 11.574139f,-10.976906f, 11.574139f,-11.578503f);
            poly[1283] = new TzPolygon(12.686238f,-11.442712f, 12.673314f,-11.448167f, 12.651880f,-11.414452f, 12.609682f,-11.423315f, 12.588186f,-11.404208f,
                    12.548480f,-11.447957f, 12.521956f,-11.409891f, 12.541353f,-11.407487f, 12.538480f,-11.386855f, 12.491791f,-11.383035f,
                    12.510025f,-11.363741f, 12.493371f,-11.354120f, 12.421500f,-11.367413f, 12.404033f,-11.389033f, 12.434552f,-11.413993f,
                    12.452642f,-11.475776f, 12.440931f,-11.578503f, 12.686238f,-11.578503f);
            poly[1284] = new TzPolygon(12.227873f,-10.976906f, 12.231666f,-10.934141f, 12.209863f,-10.895629f, 12.142653f,-10.859139f, 12.115530f,-10.792080f,
                    12.041576f,-10.801596f, 11.971627f,-10.764991f, 11.941797f,-10.773229f, 11.897751f,-10.657181f, 11.908862f,-10.631902f,
                    11.975856f,-10.608221f, 11.990615f,-10.566568f, 12.023941f,-10.580976f, 12.047559f,-10.519115f, 12.125401f,-10.513999f,
                    12.121790f,-10.447644f, 12.144958f,-10.409841f, 12.178864f,-10.408965f, 12.168458f,-10.376699f, 12.197554f,-10.359164f,
                    12.193399f,-10.332519f, 12.226930f,-10.339639f, 12.223301f,-10.308897f, 12.192032f,-10.297729f, 12.217977f,-10.249694f,
                    12.200292f,-10.242544f, 12.205314f,-10.192500f, 12.176449f,-10.148942f, 12.188194f,-10.091264f, 12.150953f,-10.093460f,
                    12.137411f,-10.064699f, 12.154466f,-10.060472f, 12.103152f,-9.968570f, 12.103907f,-9.914239f, 12.057483f,-9.871559f,
                    12.066505f,-9.816981f, 12.038226f,-9.780678f, 12.037168f,-9.773711f, 10.462040f,-9.773711f, 10.462040f,-10.976906f);
            poly[1285] = new TzPolygon(12.037168f,-9.773711f, 12.027946f,-9.712972f, 12.034946f,-9.688370f, 12.118433f,-9.683118f, 12.175298f,-9.635399f,
                    12.197452f,-9.533995f, 12.259934f,-9.473517f, 12.248481f,-9.340687f, 12.362284f,-9.297739f, 12.381514f,-9.339077f,
                    12.452081f,-9.380567f, 12.462207f,-9.407189f, 12.500906f,-9.357702f, 12.479101f,-9.335184f, 12.506235f,-9.314579f,
                    12.485579f,-9.283777f, 12.506174f,-9.251390f, 12.489574f,-9.157560f, 12.420428f,-9.014583f, 12.324808f,-8.933353f,
                    12.218807f,-8.992267f, 12.223904f,-8.978790f, 12.186168f,-8.965911f, 12.204700f,-8.918527f, 12.151440f,-8.883686f,
                    12.093662f,-8.911946f, 12.045462f,-8.908053f, 12.025974f,-8.867342f, 12.047450f,-8.826588f, 11.976816f,-8.772223f,
                    11.828695f,-8.798470f, 11.800488f,-8.830702f, 11.654723f,-8.848837f, 11.633918f,-8.760626f, 11.610313f,-8.745767f,
                    11.645562f,-8.701281f, 11.549798f,-8.641344f, 11.522426f,-8.654728f, 11.476332f,-8.614932f, 11.463346f,-8.570517f,
                    11.136030f,-8.570517f, 11.130352f,-8.604308f, 11.095749f,-8.600959f, 11.002089f,-8.675935f, 10.962388f,-8.671910f,
                    10.959861f,-8.581695f, 10.966113f,-8.570517f, 10.462040f,-8.570517f, 10.462040f,-9.773711f);
            poly[1286] = new TzPolygon(11.463346f,-8.570517f, 11.462186f,-8.566550f, 11.493949f,-8.529791f, 11.416539f,-8.498133f, 11.428529f,-8.473679f,
                    11.376309f,-8.352726f, 11.348490f,-8.408154f, 11.329242f,-8.397951f, 11.325982f,-8.354592f, 11.282912f,-8.367135f,
                    11.288907f,-8.469683f, 11.228588f,-8.476519f, 11.211549f,-8.550616f, 11.137925f,-8.559240f, 11.136030f,-8.570517f);
            poly[1287] = new TzPolygon(10.966113f,-8.570517f, 10.999039f,-8.511648f, 11.071400f,-8.481146f, 11.071663f,-8.362034f, 11.018655f,-8.288725f,
                    10.895173f,-8.256857f, 10.856466f,-8.305966f, 10.817890f,-8.303464f, 10.788134f,-8.331245f, 10.752192f,-8.289114f,
                    10.698738f,-8.288587f, 10.670958f,-8.322687f, 10.591041f,-8.325320f, 10.595386f,-8.287402f, 10.575374f,-8.269496f,
                    10.462040f,-8.241570f, 10.462040f,-8.570517f);
            poly[1288] = new TzPolygon(13.777134f,-15.181512f, 13.539917f,-15.181512f, 13.529483f,-15.197261f, 13.419121f,-15.228762f, 13.365534f,-15.299813f,
                    13.355788f,-15.379644f, 13.395286f,-15.498566f, 13.350655f,-15.582941f, 13.371262f,-15.680466f, 13.349468f,-15.805110f,
                    13.167101f,-15.803606f, 13.168850f,-16.685105f, 13.154292f,-16.709422f, 13.110263f,-16.716385f, 13.111893f,-16.735633f,
                    13.080553f,-16.729236f, 13.061111f,-16.748611f, 13.061000f,-16.976144f, 13.381000f,-17.028825f, 13.502000f,-16.988531f,
                    13.603001f,-16.858020f, 13.587041f,-16.816933f, 13.584183f,-15.477372f, 13.704900f,-15.436954f, 13.781389f,-15.364444f,
                    13.789327f,-15.302330f, 13.740974f,-15.264985f);
            poly[1289] = new TzPolygon(16.581749f,-15.181512f, 16.552261f,-15.231094f, 16.573978f,-15.309362f, 16.534592f,-15.404317f, 16.590825f,-15.469273f,
                    16.560256f,-15.515102f, 16.520773f,-15.514748f, 16.524616f,-15.623057f, 16.491811f,-15.628230f, 16.470133f,-15.699359f,
                    16.507080f,-15.812614f, 16.490766f,-15.859284f, 16.515607f,-15.886641f, 16.483023f,-15.963398f, 16.500811f,-16.002295f,
                    16.477238f,-16.052796f, 16.555258f,-16.115129f, 16.513093f,-16.189762f, 16.524865f,-16.259075f, 16.398588f,-16.331599f,
                    16.347617f,-16.332650f, 16.316726f,-16.365662f, 16.275188f,-16.353213f, 16.234525f,-16.371233f, 16.184683f,-16.453415f,
                    16.083415f,-16.454485f, 16.055311f,-16.487204f, 16.073960f,-16.496951f, 16.080690f,-16.741203f, 16.289994f,-16.728266f,
                    16.677579f,-16.650708f, 17.407117f,-16.329951f, 17.407117f,-15.181512f);
            poly[1290] = new TzPolygon(13.777134f,-15.181512f, 13.825314f,-15.070290f, 13.793755f,-14.985752f, 13.804702f,-14.927194f, 13.783906f,-14.865165f,
                    13.744998f,-14.818562f, 13.653333f,-14.791944f, 13.611944f,-14.718611f, 13.654706f,-14.629616f, 13.647916f,-14.530232f,
                    13.608333f,-14.490000f, 13.534843f,-14.472065f, 13.453889f,-14.337778f, 13.478333f,-14.240833f, 13.512532f,-14.204876f,
                    13.560086f,-14.080439f, 13.556114f,-14.030554f, 13.583059f,-13.973331f, 13.545559f,-13.886109f, 13.453056f,-13.808056f,
                    13.406667f,-13.797778f, 13.322778f,-13.867222f, 13.286389f,-14.113889f, 13.229431f,-14.193652f, 13.246784f,-14.266641f,
                    13.229704f,-14.358868f, 13.300203f,-14.459510f, 13.313134f,-14.532671f, 13.358741f,-14.578074f, 13.344260f,-14.672630f,
                    13.375291f,-14.732259f, 13.417420f,-14.760497f, 13.418207f,-14.813971f, 13.478569f,-14.974859f, 13.535243f,-15.050941f,
                    13.600463f,-15.090123f, 13.539917f,-15.181512f);
            poly[1291] = new TzPolygon(15.045738f,-12.576783f, 15.046677f,-12.578086f, 15.046677f,-12.576783f);
            poly[1292] = new TzPolygon(16.195089f,-13.879147f, 16.195541f,-13.911664f, 16.230227f,-13.920780f, 16.223352f,-13.974130f, 16.270222f,-13.951951f,
                    16.275246f,-13.987297f, 16.303817f,-13.990939f, 16.308484f,-13.958029f, 16.331336f,-13.967945f, 16.348843f,-14.030146f,
                    16.454587f,-14.139163f, 16.477466f,-14.133217f, 16.509906f,-14.201022f, 16.531516f,-14.200001f, 16.545820f,-14.246848f,
                    16.513604f,-14.256220f, 16.584248f,-14.277949f, 16.566396f,-14.330834f, 16.641649f,-14.335425f, 16.632059f,-14.404657f,
                    16.652348f,-14.421231f, 16.623285f,-14.447287f, 16.613703f,-14.497336f, 16.643663f,-14.544603f, 16.616799f,-14.556957f,
                    16.616945f,-14.638604f, 16.649173f,-14.644764f, 16.646671f,-14.725859f, 16.618280f,-14.737210f, 16.655647f,-14.765829f,
                    16.628820f,-14.788987f, 16.653700f,-14.813226f, 16.636166f,-14.861364f, 16.660166f,-14.879744f, 16.630241f,-14.897076f,
                    16.648455f,-14.913677f, 16.630649f,-14.937777f, 16.677097f,-14.952648f, 16.691971f,-14.985333f, 16.641365f,-15.004410f,
                    16.627456f,-15.052129f, 16.675835f,-15.099495f, 16.639750f,-15.119726f, 16.619407f,-15.077964f, 16.578862f,-15.116138f,
                    16.589523f,-15.168440f, 16.581749f,-15.181512f, 17.407117f,-15.181512f, 17.407117f,-13.879147f);
            poly[1293] = new TzPolygon(15.046677f,-12.576783f, 15.109561f,-12.665310f, 15.084717f,-12.693530f, 15.151848f,-12.790722f, 15.214373f,-12.802807f,
                    15.201861f,-12.852940f, 15.259901f,-12.899850f, 15.253500f,-12.850826f, 15.284323f,-12.833820f, 15.316825f,-12.851855f,
                    15.357995f,-12.944614f, 15.416372f,-12.947983f, 15.441623f,-12.924924f, 15.443939f,-12.960002f, 15.500130f,-12.964898f,
                    15.477553f,-13.046710f, 15.495629f,-13.099337f, 15.582097f,-13.088047f, 15.626371f,-13.186724f, 15.615193f,-13.230504f,
                    15.671454f,-13.252521f, 15.695383f,-13.207811f, 15.766543f,-13.292199f, 15.789754f,-13.287726f, 15.789379f,-13.265245f,
                    15.819478f,-13.298428f, 15.871618f,-13.300597f, 15.894273f,-13.334930f, 15.923978f,-13.312603f, 15.971858f,-13.364698f,
                    16.055620f,-13.376766f, 16.108950f,-13.459762f, 16.077833f,-13.491211f, 16.092033f,-13.510835f, 16.144957f,-13.480695f,
                    16.094625f,-13.680590f, 16.132025f,-13.716428f, 16.182109f,-13.715864f, 16.106667f,-13.848516f, 16.154643f,-13.878527f,
                    16.195040f,-13.875648f, 16.195089f,-13.879147f, 17.407117f,-13.879147f, 17.407117f,-12.576783f);
            poly[1294] = new TzPolygon(13.866458f,-12.576783f, 13.866458f,-11.941225f, 13.807322f,-11.949643f, 13.721053f,-12.072629f, 13.624906f,-12.038122f,
                    13.534496f,-11.969058f, 13.461680f,-11.869919f, 13.386699f,-11.888037f, 13.329950f,-11.829010f, 13.309664f,-11.831728f,
                    13.339637f,-11.768386f, 13.415188f,-11.732834f, 13.412795f,-11.703320f, 13.389548f,-11.693064f, 13.394717f,-11.627531f,
                    13.364023f,-11.637797f, 13.366301f,-11.597229f, 13.309439f,-11.590393f, 13.257932f,-11.524072f, 13.211098f,-11.543216f,
                    13.194119f,-11.501851f, 13.148196f,-11.515070f, 13.098512f,-11.474958f, 13.083819f,-11.426697f, 13.058486f,-11.435917f,
                    13.010608f,-11.395261f, 12.999758f,-11.415576f, 12.969604f,-11.410907f, 12.967103f,-11.383369f, 12.992325f,-11.367488f,
                    12.941549f,-11.345900f, 12.927481f,-11.399590f, 12.905893f,-11.386234f, 12.843860f,-11.409965f, 12.829803f,-11.381975f,
                    12.773831f,-11.397958f, 12.737001f,-11.365809f, 12.728041f,-11.425068f, 12.686238f,-11.442712f, 12.686238f,-12.576783f);
            poly[1295] = new TzPolygon(13.866458f,-11.941225f, 13.924322f,-11.932988f, 13.988534f,-12.010035f, 14.185191f,-11.974678f, 14.288338f,-12.026857f,
                    14.305737f,-12.102518f, 14.371516f,-12.098269f, 14.406427f,-12.200721f, 14.439448f,-12.188748f, 14.491302f,-12.221037f,
                    14.548890f,-12.216727f, 14.555869f,-12.186100f, 14.647400f,-12.144617f, 14.665584f,-12.177274f, 14.688480f,-12.160413f,
                    14.702915f,-12.212665f, 14.764719f,-12.240283f, 14.775982f,-12.130075f, 14.720991f,-12.055338f, 14.768118f,-12.042322f,
                    14.767020f,-11.960718f, 14.786649f,-11.932882f, 14.819365f,-11.931107f, 14.820288f,-11.925600f, 13.866458f,-11.925600f);
            poly[1296] = new TzPolygon(15.046677f,-11.925600f, 14.820288f,-11.925600f, 14.819365f,-11.931107f, 14.786649f,-11.932882f, 14.767020f,-11.960718f,
                    14.768118f,-12.042322f, 14.720991f,-12.055338f, 14.775982f,-12.130075f, 14.761156f,-12.172842f, 14.771455f,-12.278353f,
                    14.826353f,-12.327346f, 14.828852f,-12.370621f, 14.892599f,-12.453344f, 14.980071f,-12.461419f, 15.014562f,-12.492310f,
                    15.041779f,-12.571291f, 15.046677f,-12.576783f);
            poly[1297] = new TzPolygon(15.046677f,-11.839351f, 15.041999f,-11.841888f, 15.046677f,-11.814767f, 15.046677f,-11.805851f, 15.029799f,-11.788766f,
                    14.940468f,-11.816436f, 14.895998f,-11.798026f, 14.895221f,-11.824310f, 14.857404f,-11.839836f, 14.826241f,-11.890074f,
                    14.820288f,-11.925600f, 15.046677f,-11.925600f);
            poly[1298] = new TzPolygon(15.046677f,-11.805851f, 15.047987f,-11.807176f, 15.046677f,-11.814767f, 15.046677f,-11.839351f, 15.066951f,-11.828358f,
                    15.096118f,-11.844549f, 15.139148f,-11.809837f, 15.174081f,-11.837452f, 15.227894f,-11.800597f, 15.320358f,-11.793174f,
                    15.346117f,-11.760714f, 15.456213f,-11.745515f, 15.491814f,-11.704350f, 15.537373f,-11.707811f, 15.527248f,-11.616073f,
                    15.593398f,-11.546669f, 15.613304f,-11.493382f, 15.640753f,-11.515285f, 15.636065f,-11.409779f, 15.531247f,-11.358859f,
                    15.419339f,-11.251729f, 15.231773f,-10.992992f, 15.109710f,-10.900492f, 15.198413f,-10.867003f, 15.214667f,-10.832907f,
                    15.285116f,-10.821834f, 15.371172f,-10.715326f, 15.442252f,-10.720920f, 15.420146f,-10.637064f, 15.422110f,-10.575136f,
                    15.451214f,-10.518879f, 15.432908f,-10.419483f, 15.443602f,-10.308482f, 15.361625f,-10.064754f, 15.386666f,-9.972053f,
                    15.046677f,-9.972053f);
            poly[1299] = new TzPolygon(15.500783f,-7.367323f, 15.501607f,-9.331251f, 15.693527f,-9.309575f, 15.702785f,-9.331025f, 15.605695f,-9.446854f,
                    15.438838f,-9.401019f, 15.427097f,-9.685061f, 15.407679f,-9.722090f, 15.419649f,-9.753881f, 15.389191f,-9.799068f,
                    15.400078f,-9.922402f, 15.386666f,-9.972053f, 17.407117f,-9.972053f, 17.407117f,-7.367323f);
        }
    }

    private static class Initializer14 {
        private static void init() {
            poly[1300] = new TzPolygon(26.529692f,-7.367323f, 27.314942f,-8.668117f, 27.433543f,-8.668212f, 27.433543f,-7.367323f);
            poly[1301] = new TzPolygon(17.407117f,-16.329951f, 17.480306f,-16.297772f, 17.611813f,-16.266786f, 18.006344f,-16.233667f, 18.234513f,-16.245587f,
                    18.431719f,-16.266508f, 18.624067f,-16.334851f, 18.867757f,-16.451646f, 19.187900f,-16.706182f, 19.408228f,-16.793636f,
                    19.467184f,-16.771558f, 19.509296f,-16.684400f, 19.560382f,-16.663068f, 19.814459f,-16.667874f, 19.905801f,-16.630899f,
                    20.086833f,-16.507886f, 20.195174f,-16.487006f, 20.312378f,-16.561444f, 20.542095f,-16.844342f, 20.565884f,-16.899274f,
                    20.562373f,-17.010244f, 20.885333f,-17.068081f, 21.334174f,-16.948486f, 21.336718f,-12.999637f, 22.536674f,-13.083986f,
                    22.757513f,-13.150290f, 22.893056f,-13.105278f, 23.024722f,-12.998333f, 23.291389f,-12.571389f, 23.318611f,-12.365833f,
                    23.416389f,-12.155833f, 23.454444f,-12.000278f, 26.000000f,-12.000556f, 26.000278f,-8.666944f, 27.314942f,-8.668117f,
                    26.529692f,-7.367323f, 17.407117f,-7.367323f);
            poly[1302] = new TzPolygon(48.481700f,-71.405337f, 45.235236f,-71.405337f, 45.238293f,-71.442824f, 45.209630f,-71.405337f, 45.182982f,-71.405337f,
                    45.123685f,-71.428400f, 45.070188f,-71.498042f, 45.013446f,-71.501019f, 45.015962f,-73.065362f, 44.991369f,-74.150149f,
                    45.006285f,-74.670529f, 44.990472f,-74.730944f, 45.006278f,-74.790449f, 48.481700f,-74.790449f);
            poly[1303] = new TzPolygon(46.047443f,-71.405337f, 46.047443f,-70.287751f, 46.019081f,-70.317997f, 45.995491f,-70.283941f, 45.962992f,-70.315860f,
                    45.943945f,-70.239134f, 45.891169f,-70.258804f, 45.795534f,-70.416872f, 45.734570f,-70.383841f, 45.719727f,-70.400350f,
                    45.666477f,-70.558582f, 45.569426f,-70.687692f, 45.486473f,-70.716397f, 45.402736f,-70.621269f, 45.377672f,-70.658769f,
                    45.428312f,-70.754585f, 45.426508f,-70.798106f, 45.400259f,-70.825744f, 45.365679f,-70.802532f, 45.234620f,-70.838072f,
                    45.240326f,-70.895058f, 45.311724f,-70.917836f, 45.347667f,-71.010378f, 45.319239f,-71.008519f, 45.301675f,-71.098211f,
                    45.239438f,-71.147568f, 45.249416f,-71.230897f, 45.299144f,-71.296242f, 45.233508f,-71.384144f, 45.235236f,-71.405337f);
            poly[1304] = new TzPolygon(45.209630f,-71.405337f, 45.203522f,-71.397348f, 45.182982f,-71.405337f);
            poly[1305] = new TzPolygon(47.235028f,-68.020224f, 47.355301f,-68.234471f, 47.354657f,-68.363132f, 47.287375f,-68.377856f, 47.287115f,-68.580047f,
                    47.243373f,-68.617512f, 47.240581f,-68.717016f, 47.177741f,-68.900033f, 47.245011f,-69.040900f, 47.297180f,-69.053466f,
                    47.348942f,-68.799628f, 47.427124f,-68.569275f, 47.553199f,-68.383493f, 47.916117f,-68.382334f, 47.916319f,-68.122793f,
                    47.999843f,-68.122604f, 47.999863f,-68.020224f);
            poly[1306] = new TzPolygon(46.047443f,-70.287751f, 46.056291f,-70.278316f, 46.064201f,-70.310950f, 46.082369f,-70.301905f, 46.100128f,-70.253113f,
                    46.145241f,-70.236282f, 46.191474f,-70.292693f, 46.350225f,-70.191184f, 46.415581f,-70.056503f, 46.695523f,-69.997123f,
                    47.459840f,-69.224470f, 47.426784f,-69.043216f, 47.256480f,-69.050745f, 47.177741f,-68.900033f, 47.240581f,-68.717016f,
                    47.243373f,-68.617512f, 47.287115f,-68.580047f, 47.287375f,-68.377856f, 47.354657f,-68.363132f, 47.355301f,-68.234471f,
                    47.235028f,-68.020224f, 46.047443f,-68.020224f);
            poly[1307] = new TzPolygon(43.592924f,-66.327668f, 43.753000f,-66.440375f, 43.977000f,-66.448826f, 44.032000f,-66.482035f, 44.126000f,-66.632341f,
                    44.245000f,-66.677995f, 44.348000f,-66.639733f, 44.448000f,-66.516448f, 44.683322f,-66.327668f);
            poly[1308] = new TzPolygon(45.838850f,-66.327668f, 44.682597f,-66.327668f, 44.482000f,-66.487800f, 44.414000f,-66.580223f, 44.371000f,-66.717744f,
                    44.385443f,-66.870965f, 44.322045f,-66.972284f, 44.299667f,-67.100293f, 44.332091f,-67.253941f, 44.359687f,-67.301231f,
                    44.393389f,-67.303917f, 44.497000f,-67.251972f, 44.582583f,-67.156944f, 44.624251f,-67.038888f, 44.794192f,-66.885416f,
                    44.841611f,-66.974861f, 44.910389f,-66.968722f, 45.162000f,-67.158778f, 45.163417f,-67.227278f, 45.191861f,-67.283361f,
                    45.148561f,-67.295208f, 45.125028f,-67.340861f, 45.193472f,-67.429278f, 45.282139f,-67.489667f, 45.377111f,-67.419250f,
                    45.486694f,-67.503722f, 45.508361f,-67.463583f, 45.501306f,-67.416222f, 45.602466f,-67.450019f, 45.587683f,-67.519241f,
                    45.613339f,-67.645567f, 45.681327f,-67.709572f, 45.688921f,-67.734550f, 45.662640f,-67.727229f, 45.693722f,-67.818111f,
                    45.729447f,-67.809721f, 45.731080f,-67.781986f, 45.794406f,-67.806482f, 45.823350f,-67.755318f, 45.838850f,-67.767966f);
            poly[1309] = new TzPolygon(45.628084f,-64.635112f, 45.380000f,-65.130000f, 45.200000f,-65.300000f, 44.830000f,-66.210000f, 44.682597f,-66.327668f,
                    45.838850f,-66.327668f, 45.838850f,-64.635112f);
            poly[1310] = new TzPolygon(47.235028f,-68.020224f, 47.199694f,-67.957283f, 47.104403f,-67.882917f, 47.067225f,-67.790198f, 45.943451f,-67.781257f,
                    45.917636f,-67.750629f, 45.882897f,-67.803909f, 45.838850f,-67.767966f, 45.838850f,-68.020224f);
            poly[1311] = new TzPolygon(48.128022f,-64.635112f, 47.921103f,-65.111678f, 47.828607f,-65.536139f, 47.933611f,-65.606408f, 48.022234f,-65.858146f,
                    48.048998f,-66.160878f, 48.032830f,-66.303484f, 48.089246f,-66.392042f, 48.081750f,-66.487605f, 48.048121f,-66.530069f,
                    48.011188f,-66.681820f, 48.029000f,-66.723000f, 48.102200f,-66.756000f, 48.086000f,-66.802000f, 48.007420f,-66.716544f,
                    47.984347f,-66.921410f, 47.941403f,-66.964684f, 47.892562f,-66.955300f, 47.935402f,-67.059691f, 47.875655f,-67.210286f,
                    47.895801f,-67.348037f, 47.871853f,-67.336695f, 47.843957f,-67.374196f, 47.902781f,-67.481706f, 47.924627f,-67.593550f,
                    47.999945f,-67.597744f, 47.999863f,-68.020224f, 48.481700f,-68.020224f, 48.481700f,-64.635112f);
            poly[1312] = new TzPolygon(48.128022f,-64.635112f, 48.220568f,-64.421965f, 48.220564f,-63.791667f, 47.659416f,-63.371080f, 47.070000f,-64.460000f,
                    46.690000f,-64.580000f, 46.600000f,-64.560000f, 46.360000f,-64.340000f, 46.229546f,-63.749119f, 46.093097f,-63.614712f,
                    46.022532f,-64.025375f, 45.976873f,-64.046892f, 45.975308f,-64.159145f, 45.832613f,-64.278729f, 45.853035f,-64.352043f,
                    45.702958f,-64.485751f, 45.628084f,-64.635112f);
            poly[1313] = new TzPolygon(48.128022f,-64.635112f, 48.481700f,-64.635112f, 48.481700f,-61.250000f, 47.658453f,-63.370366f, 48.220564f,-63.791667f,
                    48.220568f,-64.421965f);
            poly[1314] = new TzPolygon(52.133449f,-66.327668f, 52.143261f,-66.352341f, 52.143261f,-66.327668f);
            poly[1315] = new TzPolygon(52.824650f,-67.173946f, 52.877711f,-67.268533f, 52.877826f,-67.324580f, 52.936666f,-67.351937f, 52.965406f,-67.321476f,
                    52.979519f,-67.244521f, 52.996192f,-67.363425f, 53.131979f,-67.385379f, 53.117737f,-67.342758f, 53.181291f,-67.262968f,
                    53.149664f,-67.217695f, 53.143461f,-67.173946f);
            poly[1316] = new TzPolygon(52.753522f,-67.173946f, 52.753522f,-67.041611f, 52.747016f,-67.034304f, 52.753522f,-66.990488f, 52.753522f,-66.945563f,
                    52.676675f,-66.894772f, 52.674786f,-66.851191f, 52.727457f,-66.897894f, 52.717308f,-66.855992f, 52.753522f,-66.858960f,
                    52.753522f,-66.846333f, 52.666249f,-66.764988f, 52.751502f,-66.754059f, 52.753522f,-66.755512f, 52.753522f,-66.327668f,
                    52.701124f,-66.327668f, 52.684632f,-66.339085f, 52.671595f,-66.327668f, 52.622572f,-66.327668f, 52.682284f,-66.388657f,
                    52.636400f,-66.440276f, 52.552043f,-66.371111f, 52.530897f,-66.368092f, 52.528774f,-66.399214f, 52.473221f,-66.355584f,
                    52.476112f,-66.393105f, 52.360415f,-66.344042f, 52.383023f,-66.419876f, 52.341638f,-66.490517f, 52.266174f,-66.432892f,
                    52.255655f,-66.470423f, 52.176603f,-66.356840f, 52.152816f,-66.376366f, 52.143261f,-66.352341f, 52.143261f,-67.173946f);
            poly[1317] = new TzPolygon(52.753522f,-66.327668f, 52.753522f,-66.329376f, 52.858338f,-66.416593f, 52.877483f,-66.379734f, 52.858950f,-66.327668f);
            poly[1318] = new TzPolygon(52.753522f,-66.846333f, 52.768376f,-66.860178f, 52.753522f,-66.858960f, 52.753522f,-66.945563f, 52.759596f,-66.949578f,
                    52.753522f,-66.990488f, 52.753522f,-67.041611f, 52.777738f,-67.068812f, 52.875457f,-67.063151f, 52.854443f,-67.149495f,
                    52.817460f,-67.161129f, 52.824650f,-67.173946f, 53.143461f,-67.173946f, 53.137861f,-67.134446f, 53.105112f,-67.116202f,
                    53.139549f,-67.048923f, 53.078875f,-67.068491f, 53.084357f,-66.989531f, 53.137110f,-66.958695f, 53.160025f,-67.013530f,
                    53.181693f,-66.959617f, 53.290412f,-66.953371f, 53.334646f,-67.027051f, 53.363782f,-67.008405f, 53.363782f,-66.327668f,
                    52.973447f,-66.327668f, 53.024773f,-66.370585f, 53.055187f,-66.459532f, 52.946370f,-66.501088f, 52.963955f,-66.520339f,
                    52.937000f,-66.570284f, 52.954258f,-66.625868f, 52.897560f,-66.632729f, 52.890326f,-66.663606f, 52.783657f,-66.647410f,
                    52.791061f,-66.680504f, 52.763714f,-66.686625f, 52.763576f,-66.719670f, 52.797433f,-66.787109f, 52.753522f,-66.755512f);
            poly[1319] = new TzPolygon(52.133449f,-66.327668f, 52.131818f,-66.323567f, 52.143261f,-66.289254f, 52.143261f,-66.078798f, 52.086571f,-66.092635f,
                    52.097770f,-66.066311f, 52.054737f,-65.996196f, 52.056503f,-65.970401f, 52.104636f,-65.961285f, 52.076067f,-65.897710f,
                    52.110405f,-65.876989f, 52.118561f,-65.805336f, 52.082871f,-65.733940f, 52.117275f,-65.668256f, 52.080921f,-65.648562f,
                    52.007681f,-65.677371f, 51.986809f,-65.650175f, 52.043011f,-65.620542f, 52.044560f,-65.539896f, 52.110453f,-65.499325f,
                    52.050206f,-65.496077f, 52.011087f,-65.456185f, 51.965553f,-65.399755f, 51.967345f,-65.371217f, 51.995878f,-65.371224f,
                    51.981102f,-65.359087f, 51.942417f,-65.349333f, 51.901895f,-65.399502f, 51.822753f,-65.359760f, 51.870033f,-65.323299f,
                    51.873847f,-65.283536f, 51.861475f,-65.253870f, 51.822384f,-65.258890f, 51.822079f,-65.169615f, 51.765620f,-65.180418f,
                    51.745972f,-65.091154f, 51.765140f,-65.010035f, 51.714284f,-64.937568f, 51.736670f,-64.909847f, 51.777859f,-64.924675f,
                    51.755954f,-64.709751f, 51.707555f,-64.691615f, 51.705033f,-64.639878f, 51.681957f,-64.635112f, 50.922741f,-64.635112f,
                    50.922741f,-66.327668f);
            poly[1320] = new TzPolygon(52.965367f,-66.327668f, 52.869113f,-66.258131f, 52.860135f,-66.294943f, 52.833395f,-66.283550f, 52.853618f,-66.327668f);
            poly[1321] = new TzPolygon(52.763965f,-66.327668f, 52.728606f,-66.308644f, 52.701124f,-66.327668f);
            poly[1322] = new TzPolygon(52.671595f,-66.327668f, 52.617413f,-66.280219f, 52.604590f,-66.309302f, 52.622572f,-66.327668f);
            poly[1323] = new TzPolygon(52.143261f,-66.289254f, 52.150369f,-66.267942f, 52.285518f,-66.312569f, 52.310078f,-66.266696f, 52.226990f,-66.200791f,
                    52.213465f,-66.172306f, 52.230504f,-66.152103f, 52.198504f,-66.103917f, 52.155030f,-66.075926f, 52.143261f,-66.078798f);
            poly[1324] = new TzPolygon(51.681957f,-64.635112f, 51.628985f,-64.624172f, 51.573897f,-64.548503f, 51.624623f,-64.455327f, 51.676101f,-64.422997f,
                    51.665295f,-64.337125f, 51.742294f,-64.274037f, 51.849276f,-64.352703f, 52.005492f,-64.361046f, 51.977960f,-64.237105f,
                    52.077649f,-64.291866f, 52.079747f,-64.251538f, 52.143261f,-64.249962f, 52.143261f,-64.246386f, 52.112937f,-64.172987f,
                    52.143261f,-64.161810f, 52.143261f,-63.700691f, 52.087616f,-63.702006f, 52.042403f,-63.646380f, 52.084733f,-63.823977f,
                    51.997849f,-63.808111f, 51.997391f,-62.942556f, 50.922741f,-62.942556f, 50.922741f,-64.635112f);
            poly[1325] = new TzPolygon(52.143261f,-64.249962f, 52.144724f,-64.249926f, 52.143261f,-64.246386f);
            poly[1326] = new TzPolygon(52.143261f,-64.161810f, 52.146011f,-64.160797f, 52.275397f,-64.246561f, 52.284544f,-64.209814f, 52.313028f,-64.216224f,
                    52.289698f,-64.191571f, 52.306655f,-64.169456f, 52.363064f,-64.165287f, 52.394057f,-64.109229f, 52.519923f,-64.151949f,
                    52.581982f,-64.225699f, 52.603433f,-64.154550f, 52.677627f,-64.170854f, 52.686423f,-64.127658f, 52.732048f,-64.124224f,
                    52.726625f,-63.969405f, 52.773962f,-63.872941f, 52.758531f,-63.818975f, 52.770312f,-63.721486f, 52.801530f,-63.717537f,
                    52.823760f,-63.644122f, 52.852057f,-63.676560f, 52.844160f,-63.609964f, 52.877406f,-63.619888f, 52.839549f,-63.587062f,
                    52.774184f,-63.616533f, 52.713556f,-63.450049f, 52.659363f,-63.383817f, 52.605683f,-63.939727f, 52.568330f,-64.032599f,
                    52.466073f,-64.093516f, 52.362590f,-64.012720f, 52.322500f,-63.873214f, 52.313089f,-63.742847f, 52.314028f,-63.837389f,
                    52.260655f,-63.751569f, 52.165459f,-63.700166f, 52.143261f,-63.700691f);
            poly[1327] = new TzPolygon(51.997391f,-62.942556f, 51.996496f,-61.250000f, 50.922741f,-61.250000f, 50.922741f,-62.942556f);
            poly[1328] = new TzPolygon(46.471002f,-60.089546f, 46.339000f,-59.637405f, 46.142000f,-59.441901f, 46.044000f,-59.405974f, 45.938000f,-59.443552f,
                    45.874000f,-59.500373f, 45.788000f,-59.647293f, 45.754000f,-59.779093f, 45.650024f,-59.918258f, 45.834498f,-60.740907f,
                    45.802501f,-60.808902f, 45.939339f,-60.811830f, 46.022361f,-60.732968f, 46.127404f,-60.510628f, 46.168666f,-60.480193f,
                    46.190290f,-60.505894f, 46.268386f,-60.381191f, 46.360157f,-60.340865f);
            poly[1329] = new TzPolygon(47.365000f,-59.345249f, 47.242403f,-59.592201f, 47.365000f,-59.784021f);
            poly[1330] = new TzPolygon(46.774007f,-56.678682f, 46.881415f,-56.678682f, 46.942604f,-56.653363f, 47.033755f,-56.678682f, 47.171604f,-56.678682f,
                    47.253553f,-56.618077f, 47.313230f,-56.506593f, 47.365000f,-56.494444f, 47.305278f,-56.255000f, 47.100556f,-56.105000f,
                    46.931111f,-56.129722f, 46.860000f,-56.099444f, 46.802778f,-55.982500f, 46.646111f,-55.903333f, 46.577392f,-56.043555f,
                    46.550717f,-56.218376f, 46.594849f,-56.449980f, 46.639642f,-56.558567f, 46.738408f,-56.668066f);
            poly[1331] = new TzPolygon(51.998495f,-57.107759f, 51.656451f,-57.105486f, 51.202494f,-57.107482f, 50.998607f,-57.736137f, 49.848605f,-58.940371f,
                    48.781380f,-60.476820f, 48.481700f,-61.250000f, 51.996496f,-61.250000f);
            poly[1332] = new TzPolygon(53.363782f,-55.406679f, 53.200000f,-56.590000f, 51.998495f,-57.107759f, 51.998096f,-61.250000f, 53.363782f,-61.250000f);
            poly[1333] = new TzPolygon(48.481700f,-61.250000f, 48.781380f,-60.476820f, 47.761099f,-60.403772f, 47.365000f,-59.784021f, 47.365000f,-61.250000f);
            poly[1334] = new TzPolygon(54.007589f,-67.774405f, 54.025702f,-67.821685f, 54.074678f,-67.774405f);
            poly[1335] = new TzPolygon(54.103014f,-67.774405f, 54.128133f,-67.810252f, 54.151019f,-67.774405f);
            poly[1336] = new TzPolygon(62.208265f,-74.790449f, 62.220049f,-74.731981f, 62.257946f,-74.700745f, 62.245660f,-74.479169f, 62.259911f,-74.376778f,
                    62.331120f,-74.212596f, 62.357121f,-74.049355f, 62.462082f,-73.839638f, 62.477734f,-73.666557f, 62.386754f,-73.546328f,
                    62.386965f,-73.468661f, 62.314991f,-73.186516f, 62.280056f,-73.190567f, 62.180688f,-72.993960f, 62.139980f,-72.870334f,
                    62.146900f,-72.712585f, 62.124331f,-72.625533f, 61.950699f,-72.561096f, 61.876296f,-72.219008f, 61.727933f,-72.008509f,
                    61.632042f,-71.580627f, 61.569046f,-71.529114f, 61.541618f,-71.790880f, 61.476647f,-71.749608f, 61.428808f,-71.865497f,
                    61.393089f,-71.646667f, 61.300360f,-71.713634f, 61.246695f,-71.573455f, 61.215677f,-71.572984f, 61.223445f,-71.438215f,
                    61.175274f,-71.397110f, 61.162447f,-71.282427f, 58.184022f,-71.282427f, 58.184022f,-74.790449f);
            poly[1337] = new TzPolygon(59.348181f,-69.528416f, 59.344179f,-69.540332f, 59.348469f,-69.601793f, 59.430955f,-69.605680f, 59.515298f,-69.676903f,
                    59.559176f,-69.638768f, 59.596057f,-69.530207f, 59.598596f,-69.528416f);
            poly[1338] = new TzPolygon(59.677762f,-69.528416f, 59.704103f,-69.613299f, 59.757374f,-69.539849f, 59.867412f,-69.530333f, 59.914709f,-69.703269f,
                    59.965989f,-69.699671f, 59.976750f,-69.755089f, 60.068988f,-69.836843f, 60.052622f,-69.738541f, 60.083309f,-69.590378f,
                    60.198269f,-69.546896f, 60.303639f,-69.750001f, 60.357989f,-69.668099f, 60.419477f,-69.759823f, 60.455689f,-69.716934f,
                    60.524921f,-69.803858f, 60.584000f,-69.626946f, 60.594142f,-69.633539f, 60.594142f,-69.528416f);
            poly[1339] = new TzPolygon(59.348181f,-69.528416f, 59.598596f,-69.528416f, 59.663541f,-69.482588f, 59.677762f,-69.528416f, 60.594142f,-69.528416f,
                    60.594142f,-67.999997f, 58.587462f,-68.000000f, 58.562488f,-68.124185f, 58.603484f,-68.276148f, 58.693510f,-68.348308f,
                    58.771568f,-68.314442f, 58.816117f,-68.338905f, 58.909527f,-68.576449f, 58.927642f,-68.819261f, 58.897339f,-68.912726f,
                    58.926950f,-69.169860f, 58.971986f,-69.198538f, 59.057596f,-69.081717f, 59.096402f,-69.147109f, 59.147624f,-69.154980f,
                    59.173485f,-69.243692f, 59.143063f,-69.436938f, 59.173478f,-69.481719f, 59.193718f,-69.450983f, 59.188333f,-69.315385f,
                    59.221521f,-69.222856f, 59.333672f,-69.236031f, 59.328217f,-69.330338f, 59.372026f,-69.457424f);
            poly[1340] = new TzPolygon(60.594142f,-67.999997f, 60.594142f,-67.774405f, 58.476965f,-67.774405f, 58.481296f,-67.808073f, 58.391117f,-67.867297f,
                    58.392427f,-67.924770f, 58.494228f,-67.899203f, 58.587462f,-68.000000f);
            poly[1341] = new TzPolygon(60.594142f,-67.999997f, 63.004262f,-67.999992f, 63.004262f,-67.774405f, 60.594142f,-67.774405f);
            poly[1342] = new TzPolygon(61.162447f,-71.282427f, 61.130970f,-71.000996f, 61.058785f,-70.648430f, 61.071313f,-70.428444f, 61.090834f,-70.408829f,
                    61.095123f,-70.153435f, 61.064674f,-70.104126f, 60.999833f,-70.140976f, 60.875043f,-70.074499f, 60.812754f,-69.882738f,
                    60.889413f,-69.828054f, 60.941060f,-69.675234f, 60.989856f,-69.682991f, 61.083936f,-69.613501f, 61.078110f,-69.512107f,
                    60.951823f,-69.432600f, 60.920524f,-69.372846f, 60.807594f,-69.363411f, 60.690578f,-69.696230f, 60.594142f,-69.633539f,
                    60.594142f,-71.282427f);
            poly[1343] = new TzPolygon(53.966312f,-67.774405f, 53.966312f,-67.679653f, 53.930284f,-67.669259f, 53.921695f,-67.596306f, 53.869247f,-67.609119f,
                    53.841143f,-67.569071f, 53.836691f,-67.497790f, 53.801209f,-67.536033f, 53.795465f,-67.602227f, 53.780289f,-67.557282f,
                    53.762699f,-67.603306f, 53.757267f,-67.500000f, 53.728744f,-67.515968f, 53.708883f,-67.465109f, 53.725138f,-67.417791f,
                    53.614654f,-67.394731f, 53.584152f,-67.313550f, 53.552965f,-67.318661f, 53.557389f,-67.257406f, 53.530340f,-67.218769f,
                    53.553034f,-67.180015f, 53.530209f,-67.129887f, 53.528758f,-67.035928f, 53.496146f,-66.985629f, 53.464240f,-66.995822f,
                    53.473137f,-66.937916f, 53.418661f,-66.924448f, 53.414253f,-66.897399f, 53.408405f,-66.897399f, 53.364622f,-66.966103f,
                    53.367966f,-67.005727f, 53.363782f,-67.008405f, 53.363782f,-67.774405f);
            poly[1344] = new TzPolygon(54.568842f,-67.774405f, 54.568842f,-67.524326f, 54.527411f,-67.474122f, 54.481507f,-67.500405f, 54.494109f,-67.581658f,
                    54.465766f,-67.609474f, 54.509387f,-67.647430f, 54.453842f,-67.667812f, 54.436814f,-67.766965f, 54.386856f,-67.724698f,
                    54.350261f,-67.748037f, 54.311924f,-67.679956f, 54.246991f,-67.680828f, 54.195756f,-67.615618f, 54.188575f,-67.653355f,
                    54.160807f,-67.644409f, 54.157000f,-67.765037f, 54.151019f,-67.774405f);
            poly[1345] = new TzPolygon(54.568842f,-67.270133f, 54.565173f,-67.268503f, 54.555879f,-67.302704f, 54.519560f,-67.226832f, 54.486629f,-67.272574f,
                    54.568842f,-67.455916f);
            poly[1346] = new TzPolygon(54.103014f,-67.774405f, 54.091580f,-67.758087f, 54.072906f,-67.774405f);
            poly[1347] = new TzPolygon(54.004055f,-67.774405f, 53.971910f,-67.681268f, 53.966312f,-67.679653f, 53.966312f,-67.774405f);
            poly[1348] = new TzPolygon(53.414253f,-66.897399f, 53.413062f,-66.890091f, 53.408405f,-66.897399f);
            poly[1349] = new TzPolygon(54.568842f,-67.524326f, 54.570951f,-67.526882f, 54.584910f,-67.491749f, 54.568842f,-67.455916f);
            poly[1350] = new TzPolygon(54.568842f,-67.270133f, 54.591792f,-67.280327f, 54.584417f,-67.232833f, 54.615191f,-67.229516f, 54.624539f,-67.138551f,
                    54.692933f,-67.062901f, 54.957859f,-67.399756f, 55.062857f,-67.463704f, 55.088633f,-67.409632f, 55.076427f,-67.272812f,
                    55.051228f,-67.233979f, 55.024212f,-67.272792f, 54.861948f,-67.033043f, 54.802173f,-66.927045f, 54.816010f,-66.875663f,
                    54.711048f,-66.667282f, 54.809081f,-66.739997f, 54.770218f,-66.659428f, 54.813506f,-66.602651f, 55.000017f,-66.765990f,
                    54.983873f,-66.625612f, 55.044053f,-66.735038f, 55.090602f,-66.753627f, 55.069517f,-66.694863f, 55.118414f,-66.788673f,
                    55.153178f,-66.745729f, 55.214994f,-66.755201f, 55.177485f,-66.670363f, 55.306970f,-66.823726f, 55.355314f,-66.818741f,
                    55.312040f,-66.700288f, 55.255145f,-66.658637f, 55.278151f,-66.618035f, 55.195322f,-66.516417f, 55.205107f,-66.495338f,
                    54.975469f,-66.246416f, 54.991807f,-66.235532f, 54.973009f,-66.167983f, 54.985515f,-66.152561f, 54.919084f,-66.040826f,
                    54.942482f,-66.031222f, 54.941570f,-66.020393f, 54.568842f,-66.020393f);
            poly[1351] = new TzPolygon(54.729120f,-64.266382f, 54.731027f,-64.288195f, 54.753359f,-64.294682f, 54.790493f,-64.397475f, 54.791062f,-64.492784f,
                    54.752152f,-64.474805f, 54.761793f,-64.534187f, 54.713662f,-64.556882f, 54.730096f,-64.769672f, 54.755777f,-64.801029f,
                    54.767322f,-64.752328f, 54.829528f,-64.761114f, 54.841041f,-64.861490f, 54.876273f,-64.848431f, 54.920006f,-64.915039f,
                    54.932624f,-65.017721f, 54.969563f,-65.085815f, 54.961478f,-65.126449f, 54.928194f,-65.134517f, 54.930849f,-65.180304f,
                    54.847958f,-65.209623f, 54.844355f,-65.282733f, 54.817583f,-65.296313f, 54.851968f,-65.335791f, 54.818761f,-65.355840f,
                    54.849242f,-65.456336f, 54.834377f,-65.487295f, 54.784184f,-65.434620f, 54.728583f,-65.455530f, 54.753187f,-65.646984f,
                    54.708164f,-65.693173f, 54.850801f,-65.850646f, 54.927211f,-65.849845f, 54.941570f,-66.020393f, 55.773902f,-66.020393f,
                    55.773902f,-64.266382f);
            poly[1352] = new TzPolygon(58.060028f,-64.266382f, 58.061412f,-64.269258f, 58.044519f,-64.299266f, 58.069299f,-64.353911f, 58.061159f,-64.412283f,
                    58.098375f,-64.435395f, 58.184022f,-64.422143f, 58.184022f,-64.266382f);
            poly[1353] = new TzPolygon(55.171372f,-64.266382f, 55.171372f,-63.530386f, 55.168145f,-63.523924f, 55.128733f,-63.602296f, 55.068946f,-63.616055f,
                    55.034444f,-63.556392f, 55.008392f,-63.606130f, 54.999874f,-63.557598f, 54.977044f,-63.611006f, 54.896592f,-63.591444f,
                    54.947958f,-63.820518f, 54.926134f,-63.799573f, 54.876056f,-63.852658f, 54.816922f,-63.817161f, 54.778407f,-63.924009f,
                    54.725642f,-63.802960f, 54.624951f,-63.712625f, 54.650786f,-63.813377f, 54.600704f,-63.897863f, 54.620120f,-63.974422f,
                    54.602126f,-64.004000f, 54.613187f,-64.107329f, 54.655588f,-64.102765f, 54.693588f,-64.180689f, 54.721361f,-64.177635f,
                    54.729120f,-64.266382f);
            poly[1354] = new TzPolygon(55.773902f,-63.683145f, 55.738217f,-63.725837f, 55.731562f,-63.698207f, 55.726638f,-63.725139f, 55.678600f,-63.704933f,
                    55.651588f,-63.764616f, 55.641579f,-63.643690f, 55.625479f,-63.687746f, 55.598888f,-63.662646f, 55.508711f,-63.691483f,
                    55.467239f,-63.792683f, 55.423051f,-63.665397f, 55.429206f,-63.478567f, 55.400384f,-63.434910f, 55.404902f,-63.389377f,
                    55.359209f,-63.389377f, 55.339602f,-63.574407f, 55.320723f,-63.590831f, 55.325497f,-63.532681f, 55.309870f,-63.522555f,
                    55.266887f,-63.679475f, 55.225469f,-63.547410f, 55.257764f,-63.402562f, 55.201945f,-63.452611f, 55.187616f,-63.562918f,
                    55.171372f,-63.530386f, 55.171372f,-64.266382f, 55.773902f,-64.266382f);
            poly[1355] = new TzPolygon(55.404902f,-63.389377f, 55.411806f,-63.319787f, 55.366047f,-63.324849f, 55.359209f,-63.389377f);
            poly[1356] = new TzPolygon(56.376432f,-64.266382f, 56.376432f,-64.108920f, 56.333632f,-64.098192f, 56.303407f,-64.148629f, 56.256889f,-64.087377f,
                    56.271119f,-63.934893f, 56.212589f,-63.862933f, 56.154881f,-64.035963f, 56.102730f,-64.002133f, 56.070145f,-64.034667f,
                    56.137136f,-63.856179f, 56.122499f,-63.838267f, 56.092861f,-63.887581f, 56.084635f,-63.811051f, 56.045045f,-63.837874f,
                    56.071685f,-63.714842f, 56.023523f,-63.636721f, 56.029516f,-63.443545f, 56.009884f,-63.491243f, 55.987777f,-63.471991f,
                    56.005886f,-63.563010f, 55.967473f,-63.624537f, 55.953541f,-63.712396f, 55.930515f,-63.723977f, 55.910012f,-63.854442f,
                    55.904447f,-63.825110f, 55.879073f,-63.845099f, 55.846501f,-63.752902f, 55.789996f,-63.768399f, 55.787790f,-63.666530f,
                    55.773902f,-63.683145f, 55.773902f,-64.266382f);
            poly[1357] = new TzPolygon(56.978962f,-63.910654f, 56.977631f,-63.914129f, 56.904158f,-63.918094f, 56.896823f,-63.863891f, 56.868740f,-63.859156f,
                    56.861744f,-64.003479f, 56.778677f,-64.012759f, 56.767003f,-64.078907f, 56.699755f,-64.145314f, 56.653833f,-64.090836f,
                    56.653008f,-64.024858f, 56.606348f,-64.050461f, 56.533758f,-63.931063f, 56.466207f,-63.930632f, 56.469064f,-63.883717f,
                    56.441960f,-63.874230f, 56.408211f,-63.993016f, 56.441112f,-64.152740f, 56.425244f,-64.177985f, 56.402106f,-64.115356f,
                    56.376432f,-64.108920f, 56.376432f,-64.266382f, 56.978962f,-64.266382f);
            poly[1358] = new TzPolygon(58.060028f,-64.266382f, 58.036983f,-64.218508f, 57.989544f,-64.227439f, 57.770020f,-64.072001f, 57.764404f,-64.025952f,
                    57.809517f,-64.020880f, 57.788551f,-63.938596f, 57.801123f,-63.912356f, 57.712607f,-63.883422f, 57.719023f,-63.847476f,
                    57.684508f,-63.804225f, 57.720744f,-63.753630f, 57.674280f,-63.748551f, 57.652697f,-63.692612f, 57.723942f,-63.668056f,
                    57.741248f,-63.596770f, 57.641969f,-63.622966f, 57.579489f,-63.745575f, 57.592450f,-63.771916f, 57.439332f,-63.761261f,
                    57.438210f,-63.716440f, 57.368334f,-63.701301f, 57.334301f,-63.855821f, 57.277621f,-63.883373f, 57.196256f,-63.884075f,
                    57.262160f,-63.809136f, 57.221596f,-63.737137f, 57.078879f,-63.811810f, 57.086083f,-63.890083f, 57.012774f,-63.891935f,
                    56.999212f,-63.857774f, 56.978962f,-63.910654f, 56.978962f,-64.266382f);
            poly[1359] = new TzPolygon(58.476965f,-67.774405f, 58.469673f,-67.717709f, 58.410493f,-67.678250f, 58.298979f,-67.698730f, 58.265119f,-67.629934f,
                    58.336212f,-67.324027f, 58.438185f,-67.111929f, 58.443442f,-67.013402f, 58.509932f,-66.956978f, 58.472057f,-66.846358f,
                    58.511392f,-66.795003f, 58.500069f,-66.672506f, 58.715065f,-66.547276f, 58.728657f,-66.466009f, 58.807928f,-66.486109f,
                    58.848150f,-66.445238f, 58.857623f,-66.362069f, 58.814695f,-66.258538f, 58.184022f,-66.258538f, 58.184022f,-67.774405f);
            poly[1360] = new TzPolygon(58.946267f,-64.742671f, 58.916893f,-64.820713f, 58.938382f,-64.889111f, 58.956408f,-64.832914f, 59.015405f,-64.865016f,
                    59.074957f,-64.779239f, 59.074857f,-64.742671f);
            poly[1361] = new TzPolygon(59.389082f,-66.258538f, 59.389082f,-65.528635f, 59.383005f,-65.566775f, 59.268178f,-65.568418f, 59.272765f,-65.749691f,
                    59.176834f,-65.747920f, 59.083668f,-65.662859f, 59.046502f,-65.784607f, 58.966649f,-65.852359f, 58.919770f,-66.014308f,
                    58.893603f,-65.998202f, 58.851581f,-65.862116f, 58.871319f,-66.026406f, 58.764039f,-66.136367f, 58.814695f,-66.258538f);
            poly[1362] = new TzPolygon(59.488759f,-64.742671f, 59.553342f,-64.839630f, 59.567046f,-64.939439f, 59.593179f,-64.927060f, 59.591537f,-64.859808f,
                    59.662156f,-64.889508f, 59.717239f,-64.749432f, 59.729693f,-64.810203f, 59.803274f,-64.788474f, 59.825608f,-64.825225f,
                    59.853625f,-64.742671f);
            poly[1363] = new TzPolygon(59.864643f,-64.742671f, 59.886032f,-64.756166f, 59.884385f,-64.742671f);
            poly[1364] = new TzPolygon(59.955093f,-64.742671f, 59.954730f,-64.747421f, 59.974489f,-64.747100f, 59.970319f,-64.840228f, 60.061465f,-64.923643f,
                    60.056166f,-64.742671f);
            poly[1365] = new TzPolygon(60.098494f,-64.742671f, 60.108353f,-64.767296f, 60.109584f,-64.742671f);
            poly[1366] = new TzPolygon(60.169278f,-64.742671f, 60.237294f,-64.873388f, 60.269412f,-64.853778f, 60.295134f,-64.742671f);
            poly[1367] = new TzPolygon(60.358729f,-64.742671f, 60.370971f,-64.858230f, 60.309973f,-64.852420f, 60.247323f,-64.970644f, 60.200993f,-64.931249f,
                    60.102319f,-65.079164f, 60.067330f,-65.052139f, 60.057653f,-65.139278f, 60.004387f,-65.158485f, 59.735925f,-65.559220f,
                    59.680917f,-65.560601f, 59.513750f,-65.423577f, 59.487554f,-65.444043f, 59.474738f,-65.530453f, 59.403471f,-65.438323f,
                    59.389082f,-65.528635f, 59.389082f,-66.258538f, 60.594142f,-66.258538f, 60.594142f,-64.742671f);
            poly[1368] = new TzPolygon(59.389082f,-64.742671f, 59.389082f,-64.530921f, 59.370782f,-64.538339f, 59.349576f,-64.493303f, 59.310435f,-64.543536f,
                    59.257110f,-64.488603f, 59.196741f,-64.521848f, 59.180391f,-64.472715f, 59.106416f,-64.498049f, 59.092608f,-64.376028f,
                    59.012957f,-64.261791f, 58.981514f,-64.460301f, 59.019433f,-64.497781f, 59.002560f,-64.522761f, 59.038614f,-64.670275f,
                    59.074695f,-64.683257f, 59.074857f,-64.742671f);
            poly[1369] = new TzPolygon(58.946267f,-64.742671f, 58.950784f,-64.730670f, 58.943752f,-64.651650f, 58.887455f,-64.550183f, 58.908217f,-64.455801f,
                    58.890279f,-64.420603f, 58.896753f,-64.287613f, 58.864113f,-64.233657f, 58.783649f,-64.229705f, 58.789040f,-64.178785f,
                    58.746167f,-64.137793f, 58.755998f,-64.087148f, 58.810350f,-64.045338f, 58.817506f,-63.984737f, 58.691428f,-63.984737f,
                    58.702629f,-64.047222f, 58.639651f,-64.107927f, 58.563230f,-64.104944f, 58.523450f,-64.034082f, 58.539637f,-63.984737f,
                    58.444097f,-63.984737f, 58.444358f,-63.986579f, 58.365984f,-64.030530f, 58.371034f,-64.158507f, 58.247732f,-64.217777f,
                    58.186674f,-64.421733f, 58.184022f,-64.422143f, 58.184022f,-64.742671f);
            poly[1370] = new TzPolygon(58.817506f,-63.984737f, 58.831977f,-63.862186f, 58.884059f,-63.777683f, 58.887053f,-63.709997f, 58.854712f,-63.661121f,
                    58.836550f,-63.550785f, 58.762047f,-63.467504f, 58.714643f,-63.629845f, 58.696443f,-63.855097f, 58.710254f,-63.909965f,
                    58.685247f,-63.950254f, 58.691428f,-63.984737f);
            poly[1371] = new TzPolygon(58.539637f,-63.984737f, 58.571655f,-63.887129f, 58.546580f,-63.849714f, 58.504514f,-63.858692f, 58.489746f,-63.807850f,
                    58.429440f,-63.881113f, 58.444097f,-63.984737f);
            poly[1372] = new TzPolygon(60.594142f,-64.742671f, 60.594142f,-64.108156f, 60.493053f,-64.074948f, 60.438442f,-64.089101f, 60.381311f,-64.350541f,
                    60.372606f,-64.491408f, 60.341062f,-64.533985f, 60.304398f,-64.517476f, 60.346483f,-64.627072f, 60.358729f,-64.742671f);
            poly[1373] = new TzPolygon(60.358729f,-64.742671f, 60.346483f,-64.627072f, 60.304398f,-64.517476f, 60.303297f,-64.707412f, 60.293090f,-64.742671f);
            poly[1374] = new TzPolygon(60.168595f,-64.742671f, 60.167015f,-64.602471f, 60.117031f,-64.593716f, 60.109584f,-64.742671f);
            poly[1375] = new TzPolygon(60.098494f,-64.742671f, 60.084609f,-64.707987f, 60.056166f,-64.742671f);
            poly[1376] = new TzPolygon(59.955093f,-64.742671f, 59.958876f,-64.693121f, 59.930129f,-64.669419f, 59.930295f,-64.626798f, 59.877198f,-64.683776f,
                    59.884385f,-64.742671f);
            poly[1377] = new TzPolygon(59.864643f,-64.742671f, 59.855568f,-64.736945f, 59.853625f,-64.742671f);
            poly[1378] = new TzPolygon(59.488759f,-64.742671f, 59.446905f,-64.679835f, 59.541974f,-64.433766f, 59.512774f,-64.324069f, 59.422980f,-64.511598f,
                    59.412177f,-64.460725f, 59.395628f,-64.528268f, 59.389082f,-64.530921f, 59.389082f,-64.742671f);
            poly[1379] = new TzPolygon(72.644741f,-74.790449f, 72.608594f,-74.618470f, 72.543323f,-74.512492f, 72.417312f,-74.446867f, 72.373759f,-74.222542f,
                    72.206822f,-73.735419f, 71.923144f,-73.142975f, 71.884915f,-72.935509f, 71.843666f,-72.295496f, 71.658552f,-71.185439f,
                    71.573719f,-70.943502f, 71.344548f,-70.575394f, 71.267288f,-70.357591f, 71.036475f,-69.457356f, 70.957081f,-68.921334f,
                    70.832695f,-68.501176f, 70.743737f,-67.999979f, 63.004262f,-67.999992f, 63.004262f,-74.790449f);
            poly[1380] = new TzPolygon(78.677490f,-63.556823f, 79.657069f,-68.699615f, 80.022825f,-68.258044f, 80.115824f,-68.556278f, 80.224490f,-68.646870f,
                    80.415804f,-68.335121f, 80.749150f,-67.120549f, 80.833879f,-66.268682f, 81.299733f,-64.185608f, 81.476216f,-63.556823f);
            poly[1381] = new TzPolygon(83.325189f,-74.790449f, 83.336213f,-74.138412f, 83.299753f,-71.485535f, 83.309389f,-69.468131f, 83.241681f,-68.000007f,
                    80.508950f,-68.000004f, 80.415804f,-68.335121f, 80.183169f,-68.712880f, 79.667898f,-70.169442f, 79.541939f,-70.904770f,
                    79.504741f,-71.503900f, 79.387873f,-72.372198f, 79.135487f,-73.449017f, 78.753813f,-73.109933f, 77.960182f,-74.757589f,
                    77.949560f,-74.790449f);
            poly[1382] = new TzPolygon(83.048032f,-63.556823f, 81.476216f,-63.556823f, 81.299733f,-64.185608f, 80.833879f,-66.268682f, 80.830647f,-66.490103f,
                    80.749150f,-67.120549f, 80.508950f,-68.000004f, 83.241681f,-68.000007f, 83.142596f,-66.223713f, 83.095137f,-64.274608f);
            poly[1383] = new TzPolygon(83.048032f,-63.556823f, 82.976188f,-62.462056f, 82.517808f,-59.938195f, 82.323965f,-59.613677f, 82.217611f,-59.994972f,
                    81.867611f,-62.162333f, 81.476216f,-63.556823f);
            poly[1384] = new TzPolygon(75.598948f,-63.556823f, 78.677490f,-63.556823f, 78.000000f,-60.000000f, 75.533844f,-62.877181f);
            poly[1385] = new TzPolygon(43.751931f,7.436910f, 43.536667f,7.533167f, 43.516333f,7.500333f, 43.729578f,7.409028f);
            poly[1386] = new TzPolygon(43.589191f,7.718044f, 43.574562f,7.631827f, 43.864350f,7.495498f, 43.898988f,7.561561f, 43.947563f,7.569337f,
                    43.973860f,7.652634f, 44.028837f,7.662527f, 44.043145f,7.702677f, 44.084297f,7.718044f);
            poly[1387] = new TzPolygon(44.084297f,7.718044f, 44.130751f,7.666426f, 44.173961f,7.684484f, 44.130226f,7.429774f, 44.112077f,7.425102f,
                    44.116036f,7.358390f, 44.145207f,7.344628f, 44.140961f,7.280290f, 44.200762f,7.188330f, 44.235242f,7.008514f,
                    44.280085f,6.996078f, 44.361424f,6.887345f, 44.420972f,6.892942f, 44.429701f,6.948077f, 44.528861f,6.854507f,
                    44.620260f,6.968429f, 44.678224f,6.962950f, 44.680920f,7.077129f, 44.789047f,7.000079f, 44.823113f,7.025080f,
                    44.864162f,6.931653f, 44.843282f,6.906800f, 44.851410f,6.864532f, 44.906146f,6.751206f, 45.016165f,6.748265f,
                    45.019764f,6.673405f, 45.106802f,6.627266f, 45.159765f,6.768244f, 45.127325f,6.847797f, 45.136835f,6.892373f,
                    45.167021f,6.891598f, 45.170426f,6.947248f, 45.207876f,6.965771f, 45.225728f,7.047217f, 45.212956f,7.079946f,
                    45.256372f,7.137482f, 45.327709f,7.109395f, 45.403219f,7.185752f, 45.421424f,7.142364f, 45.421424f,7.718044f);
            poly[1388] = new TzPolygon(41.434667f,8.564186f, 41.434667f,9.631667f, 41.407500f,9.451000f, 41.292833f,9.270833f, 41.319167f,9.135861f,
                    41.263219f,8.837897f, 41.418976f,8.575849f);
            poly[1389] = new TzPolygon(42.152863f,10.095160f, 42.190165f,9.919832f, 42.262401f,9.830753f, 42.364404f,9.801532f, 42.779864f,9.793600f,
                    42.939633f,9.648301f, 43.197009f,9.559826f, 43.539093f,9.655787f, 43.598169f,9.728348f, 43.703774f,9.942794f,
                    43.818895f,9.867194f, 43.846930f,9.709609f, 44.063398f,9.285443f, 44.097379f,9.110488f, 44.186206f,8.875419f,
                    44.187812f,8.750816f, 43.831845f,8.399011f, 43.732879f,8.249810f, 43.624446f,7.925817f, 43.589191f,7.718044f,
                    45.421424f,7.718044f, 45.421424f,10.095160f);
            poly[1390] = new TzPolygon(43.992093f,12.509622f, 43.940765f,12.516067f, 43.896469f,12.487404f, 43.893700f,12.457317f, 43.902183f,12.408807f,
                    43.952734f,12.403325f);
            poly[1391] = new TzPolygon(39.997858f,19.650748f, 39.997858f,20.356164f, 39.993901f,20.356164f, 39.991154f,20.311788f, 39.914726f,20.356164f,
                    39.794809f,20.356164f, 39.816294f,20.303164f, 39.766477f,20.292485f, 39.729127f,20.321776f, 39.695465f,20.266057f,
                    39.671476f,20.264685f, 39.685131f,20.231394f, 39.649592f,20.228252f, 39.644863f,20.193033f, 39.701253f,20.032190f,
                    39.671306f,19.991050f, 39.678612f,19.953684f, 39.780291f,19.977566f, 39.827654f,19.952371f);
            poly[1392] = new TzPolygon(42.709641f,16.233256f, 42.709641f,16.436115f, 42.200646f,16.436115f, 42.176599f,16.346986f, 42.224316f,16.101083f,
                    42.289463f,16.017860f, 42.359131f,15.985644f, 42.466570f,16.004636f, 42.548101f,16.085497f, 42.587595f,16.194276f,
                    42.582862f,16.338334f, 42.684213f,16.233188f);
            poly[1393] = new TzPolygon(44.126786f,14.476091f, 44.186665f,14.402093f, 44.598682f,13.701030f, 44.804910f,13.479919f, 44.963993f,13.352088f,
                    45.115477f,13.288644f, 45.421424f,13.217805f, 45.421424f,14.476091f);
            poly[1394] = new TzPolygon(44.032148f,16.436115f, 44.083362f,16.429968f, 44.116391f,16.321050f, 44.209952f,16.226407f, 44.208804f,16.172766f,
                    44.227131f,16.219023f, 44.295596f,16.187243f, 44.346166f,16.217949f, 44.378086f,16.131394f, 44.394724f,16.127465f,
                    44.402467f,16.172217f, 44.421767f,16.143170f, 44.479799f,16.140679f, 44.534455f,16.093560f, 44.562810f,16.018927f,
                    44.625642f,16.054751f, 44.749411f,15.894126f, 44.728648f,15.880870f, 44.722863f,15.819325f, 44.825317f,15.728743f,
                    44.846604f,15.793430f, 44.935831f,15.736414f, 44.994342f,15.786003f, 45.061854f,15.741159f, 45.114994f,15.790994f,
                    45.166279f,15.764625f, 45.224160f,15.838388f, 45.217989f,16.014682f, 45.179893f,16.015662f, 45.178685f,16.048705f,
                    45.104349f,16.089952f, 44.995679f,16.289189f, 45.003048f,16.354315f, 45.112705f,16.394443f, 45.130706f,16.436115f);
            poly[1395] = new TzPolygon(41.934005f,16.436115f, 41.467269f,16.538462f, 41.392162f,16.716774f, 41.245445f,17.214188f, 41.123221f,17.462215f,
                    40.991887f,17.651775f, 40.869420f,18.048493f, 40.810164f,18.174243f, 40.619560f,18.396140f, 39.997858f,18.396140f,
                    39.997858f,16.436115f);
            poly[1396] = new TzPolygon(42.590543f,18.396140f, 42.615621f,18.364267f, 42.603519f,18.250054f, 42.656209f,18.192901f, 42.654780f,18.155752f,
                    42.709641f,18.083562f, 42.709641f,18.396140f);
            poly[1397] = new TzPolygon(40.619560f,18.396140f, 40.403021f,18.648230f, 40.203113f,18.766532f, 40.110523f,18.784475f, 39.997858f,18.739011f,
                    39.997858f,18.396140f);
            poly[1398] = new TzPolygon(42.590543f,18.396140f, 42.709641f,18.396140f, 42.709641f,18.560975f, 42.692152f,18.545450f, 42.642750f,18.574896f,
                    42.618396f,18.520294f, 42.580251f,18.554810f, 42.588134f,18.499916f, 42.555311f,18.440919f);
            poly[1399] = new TzPolygon(41.353750f,19.267993f, 41.583475f,19.310314f, 41.749600f,19.264353f, 41.844366f,19.372955f, 41.859560f,19.376152f,
                    41.353750f,19.376152f);
        }
    }

    private static class Initializer15 {
        private static void init() {
            poly[1400] = new TzPolygon(41.888285f,19.376152f, 41.907753f,19.341750f, 41.923393f,19.371662f, 41.957854f,19.352403f, 41.963431f,19.376152f);
            poly[1401] = new TzPolygon(42.006420f,19.376152f, 42.028832f,19.369167f, 42.044542f,19.376152f);
            poly[1402] = new TzPolygon(42.120214f,19.376152f, 42.180405f,19.280846f, 42.279560f,19.376152f);
            poly[1403] = new TzPolygon(42.593878f,18.396140f, 42.567573f,18.434700f, 42.484149f,18.433762f, 42.392387f,18.539841f, 42.209600f,18.419578f,
                    42.222261f,18.396140f);
            poly[1404] = new TzPolygon(42.317373f,20.356164f, 42.327663f,20.338699f, 42.326371f,20.243062f, 42.368150f,20.246376f, 42.400918f,20.207951f,
                    42.433425f,20.220812f, 42.506244f,20.167305f, 42.555846f,20.077538f, 42.620944f,20.075653f, 42.655383f,20.111580f,
                    42.709641f,20.016030f, 42.709641f,20.356164f);
            poly[1405] = new TzPolygon(42.709641f,20.016030f, 42.655383f,20.111580f, 42.620944f,20.075653f, 42.556208f,20.078310f, 42.543150f,20.016782f,
                    42.508772f,20.003143f, 42.517877f,19.940147f, 42.484928f,19.898704f, 42.495834f,19.877978f, 42.470922f,19.814328f,
                    42.545139f,19.743390f, 42.581447f,19.751535f, 42.584296f,19.775966f, 42.636777f,19.756383f, 42.660975f,19.723095f,
                    42.628246f,19.662080f, 42.575506f,19.609973f, 42.542572f,19.617395f, 42.513978f,19.561845f, 42.392007f,19.472357f,
                    42.371756f,19.425280f, 42.327309f,19.422048f, 42.279560f,19.376152f, 42.709641f,19.376152f);
            poly[1406] = new TzPolygon(42.120214f,19.376152f, 42.103624f,19.402420f, 42.044542f,19.376152f);
            poly[1407] = new TzPolygon(42.006420f,19.376152f, 41.966363f,19.388636f, 41.963431f,19.376152f);
            poly[1408] = new TzPolygon(41.888285f,19.376152f, 41.885229f,19.381553f, 41.859560f,19.376152f);
            poly[1409] = new TzPolygon(44.032148f,16.436115f, 44.030269f,16.436341f, 44.026119f,16.505150f, 43.951845f,16.550785f, 43.851357f,16.716803f,
                    43.775122f,16.746748f, 43.763030f,16.799932f, 43.693639f,16.893935f, 43.575642f,17.008145f, 43.492568f,17.155222f,
                    43.499027f,17.222703f, 43.472006f,17.278099f, 43.443222f,17.289310f, 43.403022f,17.250717f, 43.259667f,17.342290f,
                    43.217644f,17.427773f, 43.178542f,17.431552f, 43.089061f,17.638798f, 42.973195f,17.710336f, 42.928550f,17.540346f,
                    42.884172f,17.642126f, 42.922750f,17.688714f, 42.891767f,17.785773f, 42.917179f,17.809048f, 42.902469f,17.844248f,
                    42.832517f,17.900225f, 42.810193f,17.890939f, 42.773810f,17.999124f, 42.709641f,18.083562f, 42.709641f,16.436115f);
            poly[1410] = new TzPolygon(45.105850f,18.396140f, 45.101271f,18.320541f, 45.138857f,18.263952f, 45.124855f,18.212501f, 45.096890f,18.221353f,
                    45.076919f,18.176348f, 45.082621f,18.111287f, 45.107354f,18.071333f, 45.140603f,18.071427f, 45.125883f,18.034762f,
                    45.151284f,18.001525f, 45.107851f,17.932777f, 45.081175f,17.936193f, 45.044287f,17.851498f, 45.133927f,17.667937f,
                    45.106101f,17.598554f, 45.108877f,17.555297f, 45.130099f,17.548035f, 45.109050f,17.530781f, 45.109695f,17.483919f,
                    45.135367f,17.492392f, 45.127138f,17.450716f, 45.159704f,17.450284f, 45.135033f,17.414997f, 45.137830f,17.363278f,
                    45.189499f,17.273320f, 45.146470f,17.246497f, 45.148381f,17.173979f, 45.225749f,17.037980f, 45.214177f,17.010560f,
                    45.235911f,17.022114f, 45.222029f,16.992276f, 45.251424f,16.970636f, 45.228809f,16.976091f, 45.227630f,16.938171f,
                    45.256037f,16.954250f, 45.276237f,16.927756f, 45.184759f,16.819166f, 45.201968f,16.668530f, 45.231324f,16.598454f,
                    45.220596f,16.513027f, 45.142456f,16.463317f, 45.130706f,16.436115f, 45.421424f,16.436115f, 45.421424f,18.396140f);
            poly[1411] = new TzPolygon(43.417916f,19.376152f, 43.481939f,19.223101f, 43.606808f,19.263590f, 43.588495f,19.336810f, 43.610603f,19.369273f,
                    43.599645f,19.376152f);
            poly[1412] = new TzPolygon(43.818210f,19.376152f, 43.950995f,19.253535f, 44.011794f,19.235686f, 43.964478f,19.376152f);
            poly[1413] = new TzPolygon(42.709641f,18.560975f, 42.719719f,18.569921f, 42.754093f,18.473517f, 42.815364f,18.448332f, 42.886636f,18.509238f,
                    42.928354f,18.482549f, 42.986461f,18.494120f, 43.033602f,18.535842f, 43.037333f,18.660694f, 43.147131f,18.648396f,
                    43.203914f,18.667731f, 43.231968f,18.717138f, 43.254714f,18.688125f, 43.324072f,18.853467f, 43.348517f,18.839385f,
                    43.359853f,18.914463f, 43.250605f,19.008784f, 43.290125f,19.036296f, 43.299780f,19.080249f, 43.445514f,19.011004f,
                    43.452266f,18.956351f, 43.503674f,18.949909f, 43.502080f,18.912557f, 43.558506f,19.005078f, 43.502349f,19.047899f,
                    43.536777f,19.152646f, 43.528332f,19.225939f, 43.481939f,19.223101f, 43.461121f,19.254189f, 43.414988f,19.376152f,
                    42.709641f,19.376152f);
            poly[1414] = new TzPolygon(43.414988f,19.376152f, 43.387338f,19.449249f, 43.344581f,19.460800f, 43.307850f,19.535556f, 43.246391f,19.545083f,
                    43.229622f,19.618944f, 43.168155f,19.685931f, 43.166201f,19.769919f, 43.094506f,19.838421f, 43.112968f,19.870462f,
                    43.085325f,19.916274f, 43.111269f,19.970240f, 43.051797f,19.992196f, 42.971434f,20.096817f, 42.963496f,20.121779f,
                    42.988963f,20.150550f, 42.911277f,20.346414f, 42.832401f,20.356164f, 42.830487f,20.280624f, 42.810789f,20.252441f,
                    42.778033f,20.265795f, 42.746160f,20.212760f, 42.776794f,20.098136f, 42.765186f,20.024633f, 42.709641f,20.016030f,
                    42.709641f,19.376152f);
            poly[1415] = new TzPolygon(43.568357f,19.423551f, 43.553261f,19.429018f, 43.539709f,19.414081f, 43.553925f,19.395141f);
            poly[1416] = new TzPolygon(44.065533f,19.547103f, 44.046661f,19.573842f, 44.065533f,19.585235f, 44.065533f,19.599395f, 44.049845f,19.623731f,
                    44.015528f,19.620316f, 43.999118f,19.563944f, 43.955790f,19.524303f, 43.960264f,19.388663f, 43.964478f,19.376152f,
                    44.065533f,19.376152f);
            poly[1417] = new TzPolygon(43.818183f,19.376152f, 43.798455f,19.394365f, 43.714344f,19.518979f, 43.650649f,19.527015f, 43.631536f,19.487669f,
                    43.586153f,19.511050f, 43.569761f,19.408443f, 43.603430f,19.376152f);
            poly[1418] = new TzPolygon(44.173658f,19.376152f, 44.184253f,19.359079f, 44.271251f,19.325171f, 44.261875f,19.238187f, 44.291151f,19.209644f,
                    44.284312f,19.165737f, 44.371259f,19.102793f, 44.415478f,19.147114f, 44.519947f,19.128447f, 44.526271f,19.170984f,
                    44.619351f,19.214903f, 44.688438f,19.304385f, 44.730926f,19.301743f, 44.743478f,19.323143f, 44.743478f,19.376152f);
            poly[1419] = new TzPolygon(44.852286f,18.886146f, 44.853092f,18.856081f, 44.905268f,18.764329f, 44.940647f,18.750461f, 44.938930f,18.804064f,
                    44.989739f,18.796557f, 44.993938f,18.729180f, 45.017405f,18.737690f, 45.062097f,18.667907f, 45.093551f,18.677141f,
                    45.055992f,18.654563f, 45.065733f,18.606090f, 45.095225f,18.630321f, 45.080432f,18.613046f, 45.094697f,18.569135f,
                    45.066578f,18.574128f, 45.093250f,18.537013f, 45.043879f,18.531257f, 45.107620f,18.425367f, 45.105850f,18.396140f,
                    45.421424f,18.396140f, 45.421424f,18.886146f);
            poly[1420] = new TzPolygon(44.854227f,18.886146f, 44.860915f,19.063288f, 44.921726f,19.177294f, 44.896258f,19.214274f, 44.913445f,19.253164f,
                    44.889523f,19.351764f, 44.878230f,19.371562f, 44.826368f,19.353185f, 44.821638f,19.317876f, 44.785854f,19.294597f,
                    44.783748f,19.324780f, 44.769096f,19.301192f, 44.747898f,19.330678f, 44.743478f,19.323143f, 44.743478f,18.886146f);
            poly[1421] = new TzPolygon(44.852286f,18.886146f, 45.421424f,18.886146f, 45.421424f,19.018649f, 45.411417f,19.030547f, 45.377207f,18.971569f,
                    45.335138f,19.092770f, 45.280238f,19.144508f, 45.264505f,19.220341f, 45.280762f,19.266776f, 45.242947f,19.259884f,
                    45.236101f,19.376152f, 45.165713f,19.376152f, 45.164705f,19.349406f, 45.207629f,19.318863f, 45.209103f,19.280301f,
                    45.171089f,19.286614f, 45.202511f,19.176217f, 45.178915f,19.194539f, 45.129925f,19.142051f, 45.145418f,19.086562f,
                    45.010695f,19.102717f, 44.977328f,19.051948f, 44.980711f,19.138335f, 44.952942f,19.156488f, 44.901152f,19.068583f,
                    44.915560f,18.997976f, 44.855243f,19.019112f, 44.849839f,18.977370f);
            poly[1422] = new TzPolygon(44.173658f,19.376152f, 44.131770f,19.443651f, 44.145905f,19.481727f, 44.118447f,19.472128f, 44.065533f,19.547103f,
                    44.065533f,19.376152f);
            poly[1423] = new TzPolygon(44.065533f,19.585235f, 44.072103f,19.589202f, 44.065533f,19.599395f);
            poly[1424] = new TzPolygon(45.236101f,19.376152f, 45.233462f,19.420966f, 45.196321f,19.447084f, 45.167555f,19.425024f, 45.165713f,19.376152f);
            poly[1425] = new TzPolygon(39.914726f,20.356164f, 39.814640f,20.414277f, 39.784526f,20.381530f, 39.794809f,20.356164f);
            poly[1426] = new TzPolygon(39.914726f,20.356402f, 39.993901f,20.356164f, 39.996225f,20.393716f, 40.050447f,20.409916f, 40.073957f,20.449673f,
                    40.064205f,20.488956f, 40.082821f,20.511711f, 40.065119f,20.565086f, 40.095363f,20.678148f, 40.188846f,20.678088f,
                    40.222692f,20.725921f, 40.282781f,20.712746f, 40.362309f,20.790110f, 40.428844f,20.787203f, 40.440659f,20.823839f,
                    40.480147f,20.842652f, 40.468973f,20.955475f, 40.518512f,20.967918f, 40.549212f,21.025636f, 39.914726f,21.025636f);
            poly[1427] = new TzPolygon(40.699805f,21.025636f, 40.770222f,20.956026f, 40.793244f,20.984955f, 40.855127f,20.980075f, 40.855068f,21.025636f);
            poly[1428] = new TzPolygon(40.854653f,21.025636f, 40.855127f,20.980075f, 40.897791f,20.978614f, 40.924773f,20.940922f, 40.937693f,20.847960f,
                    40.899266f,20.814416f, 40.910848f,20.731760f, 41.080057f,20.674803f, 41.091925f,20.595904f, 41.136913f,20.594764f,
                    41.144131f,20.588696f, 41.144131f,21.025636f);
            poly[1429] = new TzPolygon(40.854653f,21.025636f, 41.144131f,21.025636f, 41.144131f,21.695107f, 40.940650f,21.695107f, 40.941417f,21.687418f,
                    40.899043f,21.671083f, 40.866266f,21.593615f, 40.910124f,21.525403f, 40.917749f,21.417627f, 40.864287f,21.316679f,
                    40.860044f,21.259909f, 40.883832f,21.206922f, 40.853660f,21.121149f);
            poly[1430] = new TzPolygon(40.698808f,21.025636f, 40.666185f,21.057434f, 40.558639f,21.043360f, 40.549212f,21.025636f);
            poly[1431] = new TzPolygon(42.373536f,21.025636f, 42.152177f,21.025636f, 42.128668f,20.920081f, 42.097418f,20.891800f, 42.078794f,20.784754f,
                    42.024742f,20.748243f, 41.918816f,20.776518f, 41.864326f,20.727705f, 41.857701f,20.684919f, 41.875167f,20.663074f,
                    41.857763f,20.618868f, 41.877350f,20.594274f, 41.917740f,20.575665f, 41.939361f,20.619400f, 41.974378f,20.624295f,
                    42.075015f,20.557781f, 42.121115f,20.568205f, 42.224391f,20.513973f, 42.317373f,20.356164f, 42.373536f,20.356164f);
            poly[1432] = new TzPolygon(42.319438f,20.356164f, 42.272073f,20.456733f, 42.210576f,20.524163f, 42.121115f,20.568205f, 42.075015f,20.557781f,
                    41.961000f,20.626658f, 41.917740f,20.575665f, 41.877350f,20.594274f, 41.868346f,20.557432f, 41.789242f,20.574404f,
                    41.776290f,20.532207f, 41.727705f,20.514151f, 41.581985f,20.557708f, 41.553443f,20.456276f, 41.514238f,20.454113f,
                    41.405346f,20.560988f, 41.344221f,20.526375f, 41.332831f,20.491096f, 41.231628f,20.515298f, 41.144131f,20.588708f,
                    41.144131f,20.356164f);
            poly[1433] = new TzPolygon(42.152177f,21.025636f, 42.206737f,21.119105f, 42.191097f,21.167904f, 42.093638f,21.222450f, 42.094695f,21.268721f,
                    42.108084f,21.321511f, 42.141267f,21.302398f, 42.207246f,21.335169f, 42.246526f,21.385211f, 42.238362f,21.443283f,
                    42.278299f,21.444079f, 42.270525f,21.511403f, 42.241326f,21.521276f, 42.262699f,21.586607f, 42.233216f,21.695107f,
                    41.144131f,21.695107f, 41.144131f,21.025636f);
            poly[1434] = new TzPolygon(41.144131f,21.695107f, 41.144131f,22.025395f, 41.092443f,21.910524f, 41.050446f,21.914227f, 40.974613f,21.800810f,
                    40.931332f,21.788560f, 40.940650f,21.695107f);
            poly[1435] = new TzPolygon(41.144131f,22.616348f, 41.116773f,22.583846f, 41.131106f,22.561942f, 41.119434f,22.417108f, 41.137910f,22.397716f,
                    41.121124f,22.330095f, 41.144131f,22.325283f);
            poly[1436] = new TzPolygon(41.144131f,22.167026f, 41.123396f,22.128716f, 41.144131f,22.091782f);
            poly[1437] = new TzPolygon(41.144131f,22.025395f, 41.160713f,22.062246f, 41.144131f,22.091782f);
            poly[1438] = new TzPolygon(41.144131f,22.167026f, 41.170007f,22.214834f, 41.151468f,22.323748f, 41.144131f,22.325283f);
            poly[1439] = new TzPolygon(41.144131f,22.616348f, 41.186292f,22.666436f, 41.144131f,22.707668f);
            poly[1440] = new TzPolygon(41.144131f,22.717935f, 41.167748f,22.748490f, 41.305215f,22.755261f, 41.344073f,22.810912f, 41.328743f,23.034051f,
                    41.144131f,23.034051f);
            poly[1441] = new TzPolygon(42.373536f,22.293896f, 42.312879f,22.166729f, 42.298256f,22.032172f, 42.344446f,21.946277f, 42.301052f,21.899657f,
                    42.323230f,21.837445f, 42.232244f,21.698684f, 42.233216f,21.695107f, 42.373536f,21.695107f);
            poly[1442] = new TzPolygon(42.373536f,22.469776f, 42.331721f,22.452930f, 42.311375f,22.356534f, 42.349107f,22.292753f, 42.373536f,22.293896f);
            poly[1443] = new TzPolygon(41.330249f,23.034051f, 41.338685f,22.927253f, 41.353493f,22.965558f, 41.417498f,22.952022f, 41.446722f,22.979617f,
                    41.632515f,22.948283f, 41.722380f,23.033372f, 41.768897f,23.008370f, 41.774200f,22.963653f, 41.876325f,22.902232f,
                    42.022067f,22.867129f, 42.097920f,22.599703f, 42.153583f,22.511408f, 42.195340f,22.501498f, 42.200971f,22.468990f,
                    42.311774f,22.359812f, 42.333594f,22.455478f, 42.373536f,22.483739f, 42.373536f,23.034051f);
            poly[1444] = new TzPolygon(37.761205f,27.162449f, 37.790558f,27.160491f, 37.913859f,27.053962f, 37.964784f,26.918742f, 38.101484f,26.343805f,
                    38.167534f,26.221702f, 38.241496f,26.194618f, 38.445932f,26.242888f, 38.453030f,26.315292f, 38.498461f,26.320971f,
                    38.651549f,26.215782f, 38.694448f,26.225651f, 38.751890f,26.303632f, 38.809116f,26.618532f, 38.909730f,26.646564f,
                    38.979992f,26.699302f, 39.121822f,26.674168f, 39.434207f,26.431800f, 39.396180f,25.981733f, 39.418109f,25.955090f,
                    39.473182f,25.927913f, 39.714353f,25.928242f, 39.890548f,25.891613f, 39.971907f,25.714247f, 40.067370f,25.662179f,
                    40.067370f,27.332433f, 37.761205f,27.332433f);
            poly[1445] = new TzPolygon(41.304951f,25.183242f, 41.342386f,25.124870f, 41.338133f,25.082743f, 41.407778f,24.916962f, 41.401081f,24.819606f,
                    41.346244f,24.804287f, 41.416073f,24.729832f, 41.415652f,24.660058f, 41.435165f,24.657677f, 41.424763f,24.612003f,
                    41.568748f,24.525399f, 41.521873f,24.450382f, 41.539092f,24.396544f, 41.510435f,24.304864f, 41.573668f,24.261544f,
                    41.514643f,24.182348f, 41.550357f,24.100904f, 41.522247f,24.060389f, 41.467101f,24.073373f, 41.450818f,24.046686f,
                    41.467526f,24.017511f, 41.439435f,23.965988f, 41.481820f,23.914137f, 41.450055f,23.890145f, 41.437491f,23.800691f,
                    41.396042f,23.767588f, 41.410700f,23.674227f, 41.375583f,23.637197f, 41.406587f,23.438669f, 41.363521f,23.340493f,
                    41.401884f,23.301456f, 41.375979f,23.232447f, 41.337212f,23.225008f, 41.318690f,23.180384f, 41.330249f,23.034051f,
                    42.373536f,23.034051f, 42.373536f,25.183242f);
            poly[1446] = new TzPolygon(40.067370f,25.662179f, 40.142340f,25.621289f, 40.227140f,25.679176f, 40.371418f,26.049915f, 40.729474f,25.955178f,
                    40.742368f,26.124439f, 40.808773f,26.156352f, 40.834119f,26.219981f, 40.890292f,26.222626f, 40.881489f,26.249842f,
                    40.915241f,26.261582f, 40.894032f,26.292640f, 40.930725f,26.285362f, 40.945266f,26.359009f, 40.984579f,26.325461f,
                    41.020405f,26.366566f, 41.071508f,26.312434f, 41.108396f,26.335371f, 41.113489f,26.302978f, 41.143419f,26.336785f,
                    41.174632f,26.306641f, 41.220453f,26.316524f, 41.220453f,27.332433f, 40.067370f,27.332433f);
            poly[1447] = new TzPolygon(41.304951f,25.183242f, 41.280998f,25.220591f, 41.247372f,25.232161f, 41.235473f,25.283269f, 41.288469f,25.474183f,
                    41.276872f,25.525697f, 41.319467f,25.560352f, 41.291017f,25.711695f, 41.317278f,25.719581f, 41.321348f,25.781791f,
                    41.348113f,25.822366f, 41.306524f,25.903132f, 41.349685f,26.032084f, 41.354492f,26.131245f, 41.420281f,26.159538f,
                    41.438392f,26.201304f, 41.474087f,26.155131f, 41.520110f,26.184880f, 41.554966f,26.176484f, 41.554347f,26.147320f,
                    41.605584f,26.153959f, 41.632556f,26.137522f, 41.626822f,26.094213f, 41.688606f,26.060365f, 41.748886f,26.173682f,
                    41.728782f,26.257838f, 41.220453f,26.257838f, 41.220453f,25.183242f);
            poly[1448] = new TzPolygon(41.728782f,26.257838f, 41.672888f,26.491805f, 41.621613f,26.529498f, 41.610191f,26.595173f, 41.348767f,26.627659f,
                    41.322149f,26.583812f, 41.339500f,26.518334f, 41.253685f,26.406329f, 41.253931f,26.323744f, 41.220453f,26.316524f,
                    41.220453f,26.257838f);
            poly[1449] = new TzPolygon(42.075575f,27.332433f, 42.097166f,27.293666f, 42.098434f,27.221763f, 42.059379f,27.200863f, 42.086111f,27.107222f,
                    42.081751f,27.024596f, 41.996478f,26.965587f, 41.991075f,26.871031f, 41.968966f,26.842275f, 41.989658f,26.787235f,
                    41.958324f,26.750926f, 41.979087f,26.622394f, 41.925537f,26.561113f, 41.873651f,26.581039f, 41.823490f,26.538461f,
                    41.820751f,26.368937f, 41.751904f,26.329511f, 41.711128f,26.357961f, 41.711469f,26.284857f, 41.720563f,26.257838f,
                    42.373536f,26.257838f, 42.373536f,27.332433f);
            poly[1450] = new TzPolygon(42.373536f,28.088603f, 42.317393f,28.073155f, 42.254050f,28.099924f, 42.216380f,28.167310f, 42.098119f,28.271541f,
                    41.981333f,28.323833f, 41.989975f,27.976065f, 41.972516f,27.915317f, 42.006521f,27.861902f, 41.986609f,27.818609f,
                    41.948028f,27.836048f, 41.978078f,27.696478f, 41.937471f,27.574339f, 41.905127f,27.560005f, 41.958181f,27.510795f,
                    41.967066f,27.447059f, 42.057045f,27.365704f, 42.075575f,27.332433f, 42.373536f,27.332433f);
            poly[1451] = new TzPolygon(42.373536f,22.483739f, 42.480266f,22.559255f, 42.525243f,22.524266f, 42.565511f,22.438887f, 42.675785f,22.475968f,
                    42.689498f,22.458443f, 42.739643f,22.501353f, 42.824051f,22.440154f, 42.882126f,22.535469f, 42.865918f,22.569112f,
                    42.373536f,22.569112f);
            poly[1452] = new TzPolygon(43.458592f,22.569112f, 43.471182f,22.533555f, 43.556137f,22.489972f, 43.639201f,22.491827f, 43.695626f,22.408096f,
                    43.758903f,22.402455f, 43.809530f,22.357146f, 43.897480f,22.380783f, 43.897480f,22.569112f);
            poly[1453] = new TzPolygon(44.308818f,22.569112f, 44.312850f,22.554983f, 44.468557f,22.456047f, 44.478994f,22.539919f, 44.522167f,22.569112f);
            poly[1454] = new TzPolygon(44.642929f,22.569112f, 44.715534f,22.454509f, 44.665483f,22.311861f, 44.484982f,22.187079f, 44.474601f,22.133717f,
                    44.549501f,22.033089f, 44.632140f,21.995495f, 44.660083f,21.641805f, 44.755634f,21.594494f, 44.779565f,21.395308f,
                    44.862140f,21.359303f, 44.896111f,21.558611f, 44.938611f,21.540833f, 44.965278f,21.421389f, 45.019716f,21.360709f,
                    45.039846f,21.456200f, 45.120772f,21.478743f, 45.138179f,21.527311f, 45.171264f,21.514760f, 45.228877f,21.402988f,
                    45.229745f,21.274500f, 45.250290f,21.218898f, 45.325208f,21.175970f, 45.295749f,21.096268f, 45.331916f,21.063703f,
                    45.324211f,21.017123f, 45.417063f,20.920984f, 45.421424f,20.904228f, 45.421424f,22.569112f);
            poly[1455] = new TzPolygon(43.897480f,22.569112f, 43.897480f,22.380783f, 44.004205f,22.409466f, 44.019731f,22.527498f, 44.051818f,22.533510f,
                    44.056514f,22.569112f);
            poly[1456] = new TzPolygon(43.458592f,22.569112f, 43.426015f,22.661119f, 43.395503f,22.676437f, 43.377084f,22.767262f, 43.226793f,22.896350f,
                    43.187537f,23.006309f, 43.111247f,22.983178f, 43.080085f,22.918564f, 43.036196f,22.898376f, 42.981442f,22.783745f,
                    42.886145f,22.744646f, 42.865485f,22.678212f, 42.892167f,22.584040f, 42.862823f,22.575537f, 42.865918f,22.569112f);
            poly[1457] = new TzPolygon(43.897480f,22.846860f, 43.897480f,24.782060f, 43.699931f,24.782060f, 43.684230f,24.740947f, 43.741778f,24.622949f,
                    43.762645f,24.501072f, 43.697762f,24.349266f, 43.681903f,24.174703f, 43.757440f,23.854380f, 43.801465f,23.771096f,
                    43.792632f,23.612943f, 43.849964f,23.430319f, 43.846101f,23.268019f, 43.796123f,23.056575f, 43.837657f,22.867369f,
                    43.881964f,22.840830f);
            poly[1458] = new TzPolygon(44.642929f,22.569112f, 44.622000f,22.602147f, 44.617467f,22.672995f, 44.562100f,22.757672f, 44.536782f,22.760859f,
                    44.517563f,22.707718f, 44.551092f,22.588671f, 44.522167f,22.569112f);
            poly[1459] = new TzPolygon(44.304619f,22.569112f, 44.283654f,22.673088f, 44.248287f,22.685668f, 44.165607f,22.612987f, 44.063392f,22.621262f,
                    44.056514f,22.569112f);
            poly[1460] = new TzPolygon(44.056514f,22.569112f, 44.063392f,22.621262f, 44.165607f,22.612987f, 44.216706f,22.676185f, 44.100093f,22.921988f,
                    44.070617f,23.047174f, 44.013023f,23.011835f, 43.981123f,22.879368f, 43.897480f,22.849925f, 43.897480f,22.569112f);
            poly[1461] = new TzPolygon(45.421424f,29.207957f, 45.330982f,28.965885f, 45.280499f,28.941882f, 45.334730f,28.796183f, 45.303102f,28.803259f,
                    45.284082f,28.752028f, 45.243478f,28.792588f, 45.223666f,28.710938f, 45.320399f,28.349033f, 45.421424f,28.293184f);
            poly[1462] = new TzPolygon(43.699931f,24.782060f, 43.712350f,24.814581f, 43.729090f,24.985770f, 43.684855f,25.099924f, 43.698264f,25.179619f,
                    43.683172f,25.251787f, 43.618682f,25.390868f, 43.707487f,25.775363f, 43.983513f,26.139322f, 44.042337f,26.381413f,
                    44.077491f,26.760251f, 44.138925f,26.916635f, 44.149032f,27.066248f, 44.117876f,27.196007f, 44.127282f,27.270037f,
                    44.075286f,27.290986f, 44.058699f,27.356070f, 44.012246f,27.399329f, 44.012246f,27.611894f, 44.047358f,27.644655f,
                    43.953552f,27.737841f, 43.966330f,27.843543f, 44.008275f,27.916809f, 43.842910f,27.994360f, 43.758491f,28.236223f,
                    43.733721f,28.446520f, 43.738611f,28.855556f, 43.539345f,28.887541f, 43.400408f,28.831436f, 43.218897f,28.659471f,
                    43.162052f,28.502637f, 43.184494f,28.287819f, 42.982932f,28.163540f, 42.687625f,28.175029f, 42.373536f,28.088603f,
                    42.373536f,24.782060f);
            poly[1463] = new TzPolygon(45.421424f,29.499706f, 45.401040f,29.567114f, 45.339619f,29.650930f, 45.191724f,29.690635f, 45.169674f,29.952073f,
                    45.086661f,30.045426f, 44.761285f,29.877360f, 44.695675f,29.815151f, 44.588788f,29.620906f, 44.541258f,29.223884f,
                    44.523383f,29.207957f, 45.421424f,29.207957f);
            poly[1464] = new TzPolygon(44.933057f,36.674992f, 44.940667f,36.609723f, 45.199202f,36.530486f, 45.359940f,36.663502f, 45.421424f,36.664643f,
                    45.421424f,36.674992f);
            poly[1465] = new TzPolygon(43.007839f,40.227580f, 43.024838f,40.135382f, 43.091263f,40.048105f, 43.170887f,40.013406f, 43.224431f,39.884480f,
                    43.385570f,40.008451f, 43.565979f,40.097883f, 43.584362f,40.227580f);
            poly[1466] = new TzPolygon(46.906838f,12.185960f, 46.913786f,12.143808f, 46.937299f,12.168679f, 47.007007f,12.121338f, 47.022409f,12.185960f);
            poly[1467] = new TzPolygon(47.092146f,12.185960f, 47.033178f,11.916676f, 46.968870f,11.747036f, 47.013302f,11.627212f, 46.984080f,11.538529f,
                    47.010980f,11.478767f, 46.964813f,11.405602f, 46.992371f,11.320503f, 46.965809f,11.164423f, 46.939844f,11.164008f,
                    46.911895f,11.095935f, 46.822508f,11.083415f, 46.804867f,11.039055f, 46.765448f,11.022267f, 46.788336f,10.730331f,
                    46.823547f,10.763456f, 46.875489f,10.667373f, 46.837267f,10.546174f, 46.849692f,10.492294f, 47.092146f,10.492294f);
            poly[1468] = new TzPolygon(46.906838f,12.185960f, 46.906838f,12.240745f, 46.878530f,12.240745f, 46.874006f,12.215410f, 46.906115f,12.190348f);
            poly[1469] = new TzPolygon(47.069168f,12.185960f, 47.069168f,12.240745f, 47.026880f,12.204717f, 47.022409f,12.185960f);
            poly[1470] = new TzPolygon(47.069168f,12.240745f, 47.092146f,12.185960f, 47.092146f,12.240745f);
            poly[1471] = new TzPolygon(46.556214f,13.329751f, 46.551233f,13.320574f, 46.551701f,13.239790f, 46.602057f,13.083742f, 46.604614f,12.852714f,
                    46.646697f,12.775940f, 46.634296f,12.731396f, 46.656976f,12.690643f, 46.652510f,12.561259f, 46.716336f,12.384062f,
                    46.774965f,12.357427f, 46.782928f,12.283929f, 46.841237f,12.306771f, 46.884410f,12.273673f, 46.878530f,12.240745f,
                    47.092146f,12.240745f, 47.092146f,13.329751f);
            poly[1472] = new TzPolygon(45.421424f,13.217805f, 45.453057f,13.210481f, 45.546166f,13.312103f, 45.551117f,13.329751f, 45.421424f,13.329751f);
            poly[1473] = new TzPolygon(46.256785f,13.329751f, 46.256785f,13.396848f, 46.206055f,13.423356f, 46.224728f,13.483198f, 46.208984f,13.552616f,
                    46.185765f,13.566989f, 46.177973f,13.664237f, 46.137211f,13.643950f, 46.058502f,13.496507f, 46.034948f,13.508652f,
                    46.006082f,13.476164f, 45.966253f,13.530592f, 45.990086f,13.590762f, 45.982890f,13.642980f, 45.853499f,13.575166f,
                    45.808122f,13.595873f, 45.799702f,13.669362f, 45.744086f,13.794412f, 45.687094f,13.833643f, 45.633517f,13.918655f,
                    45.580899f,13.810112f, 45.594721f,13.718716f, 45.638882f,13.638879f, 45.551173f,13.329751f);
            poly[1474] = new TzPolygon(45.551117f,13.329751f, 45.589572f,13.466816f, 45.474382f,13.590403f, 45.442574f,13.675317f, 45.466460f,13.786428f,
                    45.434174f,13.814703f, 45.425804f,13.887109f, 45.453543f,13.914641f, 45.456065f,13.984925f, 45.505986f,13.962213f,
                    45.519982f,14.001918f, 45.484594f,14.073109f, 45.469272f,14.207614f, 45.505377f,14.244983f, 45.470415f,14.322772f,
                    45.508954f,14.418757f, 45.421424f,14.418757f, 45.421424f,13.329751f);
            poly[1475] = new TzPolygon(46.556214f,13.329751f, 46.579277f,13.372240f, 46.522990f,13.714079f, 46.439984f,13.689256f, 46.439378f,13.597746f,
                    46.397971f,13.565537f, 46.360005f,13.438747f, 46.331132f,13.448262f, 46.297697f,13.375470f, 46.256785f,13.396848f,
                    46.256785f,13.329751f);
            poly[1476] = new TzPolygon(46.556214f,13.329751f, 47.092146f,13.329751f, 47.092146f,14.418757f, 46.446496f,14.418757f, 46.433604f,14.163301f,
                    46.476610f,14.121520f, 46.493192f,14.050751f, 46.481361f,14.006498f, 46.521129f,13.912054f, 46.505340f,13.794463f,
                    46.579277f,13.372240f);
            poly[1477] = new TzPolygon(45.508954f,14.418757f, 45.537754f,14.490486f, 45.607826f,14.501341f, 45.613914f,14.535023f, 45.672944f,14.570010f,
                    45.664200f,14.607925f, 45.627076f,14.595730f, 45.580679f,14.690323f, 45.526618f,14.690577f, 45.534143f,14.720627f,
                    45.503329f,14.795603f, 45.459502f,14.817620f, 45.477080f,14.907507f, 45.529277f,14.931132f, 45.496668f,14.986917f,
                    45.482838f,15.086203f, 45.422085f,15.166721f, 45.426410f,15.225596f, 45.466002f,15.273807f, 45.456347f,15.345809f,
                    45.488979f,15.385666f, 45.535616f,15.302079f, 45.604455f,15.277053f, 45.645860f,15.343339f, 45.650014f,15.406203f,
                    45.693379f,15.369221f, 45.671136f,15.348140f, 45.713966f,15.357108f, 45.673851f,15.322786f, 45.724534f,15.257516f,
                    45.792064f,15.399452f, 45.795888f,15.471283f, 45.818395f,15.465921f, 45.822031f,15.507764f, 45.421424f,15.507764f,
                    45.421424f,14.418757f);
            poly[1478] = new TzPolygon(47.092146f,15.507764f, 46.616747f,15.507764f, 46.613908f,15.502269f, 46.615255f,15.462099f, 46.655544f,15.414071f,
                    46.639381f,15.235903f, 46.659838f,15.145342f, 46.651770f,15.041037f, 46.601398f,14.979315f, 46.632708f,14.955612f,
                    46.602079f,14.919567f, 46.607219f,14.870401f, 46.509384f,14.818609f, 46.499960f,14.714764f, 46.463688f,14.699395f,
                    46.436820f,14.595973f, 46.372276f,14.563489f, 46.427260f,14.521762f, 46.413494f,14.478812f, 46.447043f,14.429606f,
                    46.446496f,14.418757f, 47.092146f,14.418757f);
            poly[1479] = new TzPolygon(46.256785f,15.507764f, 46.256785f,15.790294f, 46.208798f,15.767950f, 46.217173f,15.647187f, 46.146355f,15.596126f,
                    46.089430f,15.621149f, 46.044523f,15.732487f, 45.997026f,15.699854f, 45.921833f,15.707302f, 45.904498f,15.679475f,
                    45.846519f,15.709316f, 45.820417f,15.642273f, 45.853572f,15.572550f, 45.834274f,15.559382f, 45.847599f,15.538554f,
                    45.823790f,15.528006f, 45.822031f,15.507764f);
            poly[1480] = new TzPolygon(47.092146f,16.052267f, 46.851319f,16.052267f, 46.832827f,15.991012f, 46.751961f,15.984783f, 46.711611f,16.029818f,
                    46.656139f,16.038092f, 46.722389f,15.839693f, 46.699032f,15.768962f, 46.705758f,15.649992f, 46.680045f,15.629976f,
                    46.690013f,15.595118f, 46.669293f,15.543684f, 46.638486f,15.549833f, 46.616747f,15.507764f, 47.092146f,15.507764f);
            poly[1481] = new TzPolygon(46.256785f,15.790294f, 46.259329f,15.791479f, 46.308779f,16.014139f, 46.331141f,16.052267f, 46.256785f,16.052267f);
            poly[1482] = new TzPolygon(46.481425f,16.596770f, 46.505404f,16.523616f, 46.565269f,16.508411f, 46.644249f,16.385941f, 46.693974f,16.428634f,
                    46.704008f,16.368921f, 46.754145f,16.318595f, 46.846891f,16.340337f, 46.872845f,16.291226f, 46.853707f,16.156087f,
                    46.869059f,16.113887f, 46.941801f,16.199902f, 46.962608f,16.276470f, 47.013962f,16.290094f, 46.998273f,16.303353f,
                    47.001554f,16.512319f, 47.029715f,16.438893f, 47.056214f,16.520559f, 47.092146f,16.467523f, 47.092146f,16.596770f);
            poly[1483] = new TzPolygon(47.092146f,16.467523f, 47.056214f,16.520559f, 47.029715f,16.438893f, 47.001554f,16.512319f, 46.998273f,16.303353f,
                    47.013962f,16.290094f, 46.962608f,16.276470f, 46.941801f,16.199902f, 46.875739f,16.133159f, 46.851319f,16.052267f,
                    47.092146f,16.052267f);
            poly[1484] = new TzPolygon(46.331141f,16.052267f, 46.345953f,16.077523f, 46.393569f,16.058120f, 46.405139f,16.146007f, 46.377813f,16.189027f,
                    46.378294f,16.301559f, 46.498356f,16.241632f, 46.555029f,16.368797f, 46.481004f,16.515862f, 46.469221f,16.596770f,
                    46.256785f,16.596770f, 46.256785f,16.052267f);
            poly[1485] = new TzPolygon(46.469221f,16.596770f, 46.459464f,16.663765f, 46.391545f,16.718715f, 46.374085f,16.837398f, 46.261881f,16.913794f,
                    46.169682f,17.159286f, 46.108458f,17.175927f, 46.097931f,17.233425f, 46.077432f,17.201589f, 46.056706f,17.270955f,
                    46.030005f,17.254152f, 46.028517f,17.296320f, 46.011026f,17.257973f, 45.988778f,17.323647f, 45.967984f,17.309731f,
                    45.996078f,17.333958f, 45.973584f,17.356720f, 45.991182f,17.372431f, 45.964274f,17.358354f, 45.958192f,17.390538f,
                    45.960533f,17.343877f, 45.942341f,17.347621f, 45.935820f,17.570068f, 45.838185f,17.663292f, 45.809996f,17.826275f,
                    45.767734f,17.862031f, 45.792569f,17.906676f, 45.795731f,17.995881f, 45.764521f,18.081892f, 45.789628f,18.124652f,
                    45.787876f,18.190870f, 45.747161f,18.339421f, 45.772936f,18.364226f, 45.737128f,18.446853f, 45.794717f,18.490671f,
                    45.782686f,18.522351f, 45.800435f,18.574985f, 45.824081f,18.604188f, 45.421424f,18.604188f, 45.421424f,16.596770f);
            poly[1486] = new TzPolygon(45.421424f,19.018649f, 45.446834f,18.988437f, 45.494343f,19.000159f, 45.488292f,19.082298f, 45.514323f,19.101142f,
                    45.557153f,19.021138f, 45.533951f,18.950376f, 45.566071f,18.889211f, 45.618902f,18.907761f, 45.666358f,18.966273f,
                    45.712292f,18.904349f, 45.908804f,18.814288f, 45.935274f,18.906005f, 45.923287f,19.008856f, 45.958709f,19.005814f,
                    45.963535f,19.079550f, 46.000043f,19.065676f, 46.039988f,19.104579f, 46.039842f,19.106042f, 45.421424f,19.106042f);
            poly[1487] = new TzPolygon(46.256785f,19.106042f, 46.039842f,19.106042f, 46.039988f,19.104579f, 46.000043f,19.065676f, 45.963535f,19.079550f,
                    45.958709f,19.005814f, 45.923287f,19.008856f, 45.935274f,18.906005f, 45.911238f,18.868205f, 45.914634f,18.821634f,
                    45.878163f,18.791096f, 45.916886f,18.659533f, 45.839853f,18.623666f, 45.824081f,18.604188f, 46.256785f,18.604188f);
            poly[1488] = new TzPolygon(46.039842f,19.106042f, 46.037071f,19.133786f, 45.996125f,19.147739f, 45.987797f,19.296538f, 46.014522f,19.281601f,
                    46.052170f,19.364162f, 46.035806f,19.380180f, 46.045731f,19.415439f, 46.120937f,19.527069f, 46.151735f,19.516759f,
                    46.175855f,19.607897f, 45.421424f,19.607897f, 45.421424f,19.106042f);
            poly[1489] = new TzPolygon(45.853750f,20.611605f, 45.869380f,20.580850f, 45.910437f,20.568882f, 45.892145f,20.515481f, 45.953382f,20.483629f,
                    45.999411f,20.347974f, 46.047822f,20.345876f, 46.120854f,20.261977f, 46.169674f,20.355608f, 46.142879f,20.459110f,
                    46.189933f,20.501500f, 46.139406f,20.611605f);
            poly[1490] = new TzPolygon(46.137986f,20.611605f, 46.189933f,20.501500f, 46.142879f,20.459110f, 46.169674f,20.355608f, 46.115796f,20.254919f,
                    46.160049f,20.181825f, 46.144226f,20.137287f, 46.176966f,20.101254f, 46.143667f,20.063734f, 46.176777f,20.015794f,
                    46.176193f,19.935139f, 46.127787f,19.817834f, 46.187930f,19.698095f, 46.169256f,19.631617f, 46.172764f,19.607897f,
                    47.092146f,19.607897f, 47.092146f,20.611605f);
            poly[1491] = new TzPolygon(45.853750f,20.611605f, 45.829170f,20.659972f, 45.750720f,20.700814f, 45.754520f,20.774028f, 45.785944f,20.782884f,
                    45.774861f,20.823137f, 45.657189f,20.804827f, 45.612443f,20.765994f, 45.535694f,20.833070f, 45.499916f,20.769309f,
                    45.479745f,20.771550f, 45.464638f,20.866150f, 45.431651f,20.864933f, 45.421424f,20.904228f, 45.421424f,20.611605f);
            poly[1492] = new TzPolygon(47.092146f,21.615314f, 46.934303f,21.615314f, 46.927466f,21.598684f, 46.861317f,21.596816f, 46.835914f,21.519212f,
                    46.764715f,21.483219f, 46.720810f,21.529342f, 46.685980f,21.492218f, 46.693866f,21.430051f, 46.661155f,21.454886f,
                    46.621837f,21.409989f, 46.637831f,21.365614f, 46.617594f,21.314088f, 46.582814f,21.320780f, 46.501961f,21.260414f,
                    46.450692f,21.317767f, 46.406720f,21.296189f, 46.403383f,21.206421f, 46.304116f,21.180594f, 46.301660f,21.115501f,
                    46.242939f,21.066083f, 46.279303f,20.946585f, 46.261835f,20.922156f, 46.287756f,20.873271f, 46.275960f,20.775654f,
                    46.250849f,20.749047f, 46.204473f,20.761840f, 46.207377f,20.727374f, 46.166854f,20.714998f, 46.126458f,20.636041f,
                    46.137986f,20.611605f, 47.092146f,20.611605f);
            poly[1493] = new TzPolygon(47.092146f,21.720843f, 47.045710f,21.682616f, 47.040437f,21.648739f, 47.001820f,21.688951f, 46.960414f,21.678827f,
                    46.934303f,21.615314f, 47.092146f,21.615314f);
            poly[1494] = new TzPolygon(47.548552f,10.492294f, 47.533472f,10.571106f, 47.569741f,10.597948f, 47.558770f,10.691003f, 47.513921f,10.777508f,
                    47.537314f,10.890311f, 47.513631f,10.918007f, 47.483255f,10.870040f, 47.481137f,10.937174f, 47.430018f,10.983612f,
                    47.399558f,10.971896f, 47.395456f,11.114824f, 47.433940f,11.206990f, 47.428238f,11.253416f, 47.395252f,11.224959f,
                    47.397565f,11.269885f, 47.449923f,11.338613f, 47.444592f,11.421194f, 47.472375f,11.383843f, 47.517917f,11.442090f,
                    47.514506f,11.572417f, 47.594555f,11.636180f, 47.581212f,11.844042f, 47.602358f,11.854955f, 47.625178f,12.008533f,
                    47.606765f,12.203961f, 47.701167f,12.162425f, 47.743035f,12.257029f, 47.679451f,12.255250f, 47.695231f,12.440071f,
                    47.625101f,12.499170f, 47.632315f,12.575027f, 47.643845f,12.584024f, 47.092146f,12.584024f, 47.092146f,10.492294f);
            poly[1495] = new TzPolygon(48.304719f,12.584024f, 48.304719f,13.283627f, 48.293560f,13.256216f, 48.257818f,13.021680f, 48.209281f,12.956133f,
                    48.201310f,12.870051f, 48.123711f,12.786919f, 48.126069f,12.758126f, 48.075167f,12.759481f, 48.016211f,12.850205f,
                    47.963923f,12.873910f, 47.943283f,12.938171f, 47.849322f,13.003615f, 47.723438f,12.905268f, 47.707153f,12.973805f,
                    47.722875f,13.018338f, 47.687034f,13.080748f, 47.635172f,13.098936f, 47.583364f,13.043652f, 47.492163f,13.047647f,
                    47.464012f,13.001047f, 47.550125f,12.803936f, 47.579142f,12.779150f, 47.612107f,12.824484f, 47.651550f,12.758576f,
                    47.673818f,12.781165f, 47.673727f,12.607344f, 47.643845f,12.584024f);
            poly[1496] = new TzPolygon(48.947631f,13.629890f, 48.938623f,13.610246f, 48.970739f,13.580078f, 48.969112f,13.507073f, 48.941260f,13.497848f,
                    48.972493f,13.426195f, 49.050664f,13.397373f, 49.118638f,13.289183f, 49.134489f,13.182778f, 49.173624f,13.170897f,
                    49.263927f,13.033985f, 49.304326f,13.029114f, 49.343796f,12.945285f, 49.345459f,12.785783f, 49.394799f,12.757669f,
                    49.434796f,12.655553f, 49.517291f,12.644928f, 49.517269f,13.629890f);
            poly[1497] = new TzPolygon(48.304719f,13.283627f, 48.323514f,13.329798f, 48.374710f,13.411357f, 48.430840f,13.439313f, 48.557442f,13.437839f,
                    48.556061f,13.475373f, 48.590600f,13.508963f, 48.549209f,13.629890f, 48.304719f,13.629890f);
            poly[1498] = new TzPolygon(48.947167f,13.629890f, 48.880141f,13.671433f, 48.886012f,13.737938f, 48.780929f,13.803650f, 48.771621f,13.839552f,
                    48.715036f,13.794879f, 48.700546f,13.837419f, 48.691833f,13.813489f, 48.618576f,13.825790f, 48.514767f,13.730512f,
                    48.549209f,13.629890f);
            poly[1499] = new TzPolygon(48.947631f,13.629890f, 49.517269f,13.629890f, 49.517245f,14.675755f, 48.582827f,14.675755f, 48.581959f,14.663459f,
                    48.628099f,14.610450f, 48.603331f,14.562056f, 48.617308f,14.503515f, 48.648494f,14.469871f, 48.643432f,14.443761f,
                    48.589127f,14.431424f, 48.592667f,14.386238f, 48.571876f,14.388086f, 48.551808f,14.333235f, 48.581372f,14.271542f,
                    48.594864f,14.066961f, 48.639652f,14.010561f, 48.673323f,14.060079f, 48.766605f,13.876116f, 48.773996f,13.813180f,
                    48.886012f,13.737938f, 48.880141f,13.671433f, 48.947863f,13.630395f);
        }
    }

    private static class Initializer16 {
        private static void init() {
            poly[1500] = new TzPolygon(47.092146f,16.467523f, 47.094973f,16.463350f, 47.127243f,16.529343f, 47.149329f,16.516775f, 47.142297f,16.454298f,
                    47.187556f,16.454808f, 47.194915f,16.419501f, 47.252944f,16.431792f, 47.252899f,16.467134f, 47.280287f,16.489422f,
                    47.352868f,16.433737f, 47.383296f,16.461354f, 47.407216f,16.445459f, 47.408899f,16.485321f, 47.389050f,16.496570f,
                    47.410600f,16.516910f, 47.406359f,16.575735f, 47.455714f,16.662032f, 47.500326f,16.652339f, 47.539934f,16.714524f,
                    47.566261f,16.664557f, 47.622910f,16.652046f, 47.619826f,16.572515f, 47.662370f,16.424761f, 47.696306f,16.447322f,
                    47.681258f,16.474659f, 47.722513f,16.552218f, 47.751010f,16.547045f, 47.760383f,16.609542f, 47.735357f,16.720941f,
                    47.681411f,16.749032f, 47.681721f,16.767485f, 47.092146f,16.767485f);
            poly[1501] = new TzPolygon(48.582196f,14.675755f, 48.582692f,14.701529f, 48.687069f,14.726968f, 48.733884f,14.808131f, 48.778802f,14.808658f,
                    48.758085f,14.955793f, 48.772260f,14.979502f, 48.789786f,14.953255f, 48.904171f,14.992950f, 48.970962f,14.976170f,
                    49.020531f,15.020637f, 48.993291f,15.156272f, 48.941691f,15.160244f, 48.953648f,15.261618f, 48.994659f,15.278874f,
                    48.951817f,15.468490f, 48.914122f,15.513390f, 48.898255f,15.612436f, 48.855676f,15.689687f, 48.877125f,15.841543f,
                    48.834634f,15.893240f, 48.823060f,15.958382f, 48.805249f,15.949630f, 48.779335f,15.994365f, 48.746643f,16.094165f,
                    48.731245f,16.329888f, 48.745618f,16.342823f, 48.728467f,16.378001f, 48.809025f,16.460415f, 48.798244f,16.518639f,
                    48.814287f,16.540730f, 48.782687f,16.593493f, 48.781007f,16.663747f, 48.727800f,16.682584f, 48.738031f,16.724742f,
                    48.719867f,16.767485f, 48.304695f,16.767485f, 48.304695f,14.675755f);
            poly[1502] = new TzPolygon(47.746339f,17.813351f, 47.755175f,17.712816f, 47.821886f,17.608402f, 47.815636f,17.566709f, 47.866445f,17.525172f,
                    47.885258f,17.453920f, 47.993125f,17.334651f, 47.998655f,17.257955f, 48.022465f,17.241769f, 48.006657f,17.160776f,
                    48.031224f,17.110060f, 48.019783f,17.089866f, 48.055395f,17.068250f, 48.099645f,17.092707f, 48.143724f,17.057195f,
                    48.172139f,16.976246f, 48.263818f,16.957066f, 48.273519f,16.920148f, 48.304719f,16.913386f, 48.304719f,17.813351f);
            poly[1503] = new TzPolygon(48.304719f,16.767485f, 48.304719f,16.907970f, 48.288423f,16.907533f, 48.263818f,16.957066f, 48.172139f,16.976246f,
                    48.143724f,17.057195f, 48.099645f,17.092707f, 48.031428f,17.067423f, 48.006657f,17.160776f, 47.970878f,17.094657f,
                    47.960895f,17.117015f, 47.874435f,17.085190f, 47.858361f,17.009954f, 47.808274f,17.074434f, 47.793983f,17.050977f,
                    47.708261f,17.093089f, 47.688331f,16.875202f, 47.721659f,16.866913f, 47.682744f,16.828358f, 47.681721f,16.767485f);
            poly[1504] = new TzPolygon(47.741846f,17.813351f, 47.757681f,18.038058f, 47.731462f,18.295878f, 47.765123f,18.454068f, 47.759092f,18.646087f,
                    47.813825f,18.741179f, 47.826077f,18.855876f, 47.871353f,18.763776f, 47.897570f,18.756801f, 47.955092f,18.776746f,
                    47.976347f,18.755250f, 47.993442f,18.815743f, 48.052572f,18.845585f, 48.052675f,18.859216f, 47.092146f,18.859216f,
                    47.092146f,17.813351f);
            poly[1505] = new TzPolygon(49.517197f,16.767485f, 49.517149f,18.850908f, 49.488383f,18.754482f, 49.507628f,18.677825f, 49.500510f,18.545748f,
                    49.467862f,18.547951f, 49.408546f,18.475691f, 49.396691f,18.403661f, 49.367549f,18.415567f, 49.330546f,18.378918f,
                    49.286996f,18.184026f, 49.247930f,18.146972f, 49.059243f,18.095471f, 49.028505f,18.057123f, 49.019966f,17.924300f,
                    48.927677f,17.885311f, 48.925275f,17.781318f, 48.860022f,17.703336f, 48.812160f,17.528483f, 48.846725f,17.453181f,
                    48.813434f,17.361515f, 48.845298f,17.321665f, 48.877569f,17.200176f, 48.764259f,17.043287f, 48.616539f,16.940190f,
                    48.717973f,16.902021f, 48.705905f,16.800342f, 48.719867f,16.767485f);
            poly[1506] = new TzPolygon(48.719867f,16.767485f, 48.705905f,16.800342f, 48.717973f,16.902021f, 48.543260f,16.953933f, 48.449159f,16.850008f,
                    48.352398f,16.842703f, 48.326190f,16.908545f, 48.304719f,16.907970f, 48.304719f,16.767485f);
            poly[1507] = new TzPolygon(49.551689f,12.584024f, 49.619605f,12.560743f, 49.618099f,12.528104f, 49.686441f,12.521987f, 49.703818f,12.442451f,
                    49.753801f,12.400555f, 49.786107f,12.472650f, 49.833670f,12.473058f, 49.920493f,12.547675f, 49.938523f,12.474931f,
                    49.972046f,12.499558f, 49.992812f,12.467161f, 49.984390f,12.431479f, 50.053370f,12.317280f, 50.058442f,12.260983f,
                    50.076473f,12.275411f, 50.110825f,12.199566f, 50.198995f,12.197170f, 50.252399f,12.090590f, 50.277834f,12.140060f,
                    50.321705f,12.104675f, 50.322221f,12.184604f, 50.272837f,12.201324f, 50.270975f,12.253842f, 50.250178f,12.265939f,
                    50.246154f,12.239475f, 50.221035f,12.293904f, 50.176891f,12.289361f, 50.171647f,12.334373f, 50.242448f,12.331293f,
                    50.242128f,12.359227f, 50.321427f,12.398380f, 50.349812f,12.489544f, 50.397258f,12.512030f, 50.405985f,12.584024f);
            poly[1508] = new TzPolygon(49.517291f,12.644928f, 49.522963f,12.644197f, 49.538485f,12.588551f, 49.551689f,12.584024f, 50.405985f,12.584024f,
                    50.416804f,12.673273f, 50.397120f,12.707115f, 50.432396f,12.734106f, 50.449430f,12.794853f, 50.430898f,12.810497f,
                    50.460292f,12.819033f, 50.404251f,12.948091f, 50.446669f,13.019970f, 50.509765f,13.031696f, 50.503241f,13.195292f,
                    50.592495f,13.248872f, 50.581103f,13.323213f, 50.650865f,13.370250f, 50.601737f,13.464853f, 50.638984f,13.524277f,
                    50.711504f,13.545541f, 50.732164f,13.664689f, 50.716681f,13.706683f, 50.735821f,13.758297f, 50.726968f,13.854972f,
                    50.745136f,13.898799f, 50.793379f,13.900778f, 50.820011f,13.990778f, 50.812481f,14.078466f, 50.859087f,14.223505f,
                    50.895314f,14.267434f, 50.899199f,14.388004f, 50.936378f,14.396982f, 50.954010f,14.311442f, 50.985399f,14.323507f,
                    50.987539f,14.258681f, 51.039798f,14.273855f, 51.055704f,14.315591f, 51.018783f,14.408570f, 51.035944f,14.453831f,
                    51.023412f,14.492717f, 51.043310f,14.508401f, 51.022090f,14.498598f, 50.987176f,14.599074f, 50.918574f,14.564360f,
                    50.931524f,14.650201f, 50.857759f,14.618916f, 50.838142f,14.675755f, 49.517291f,14.675755f);
            poly[1509] = new TzPolygon(51.720361f,14.675755f, 51.725857f,14.668163f, 51.795528f,14.645475f, 51.820444f,14.590390f, 51.887433f,14.675755f);
            poly[1510] = new TzPolygon(52.251142f,14.675755f, 52.289048f,14.575288f, 52.395000f,14.534376f, 52.491484f,14.633926f, 52.531031f,14.603838f,
                    52.571925f,14.639548f, 52.751291f,14.350431f, 52.838620f,14.122971f, 52.886771f,14.160814f, 52.961109f,14.143936f,
                    53.057392f,14.349985f, 53.199131f,14.376247f, 53.261640f,14.449995f, 53.543567f,14.305748f, 53.618064f,14.316946f,
                    53.698695f,14.266823f, 53.725332f,14.272899f, 53.725332f,14.675755f);
            poly[1511] = new TzPolygon(50.569301f,16.404769f, 50.569301f,16.767485f, 50.152539f,16.767485f, 50.098549f,16.688992f, 50.142448f,16.580192f,
                    50.220390f,16.557283f, 50.324680f,16.431079f, 50.328812f,16.383232f, 50.379560f,16.360659f, 50.367441f,16.278638f,
                    50.432128f,16.195716f, 50.506132f,16.311528f, 50.501340f,16.360451f, 50.569271f,16.404650f);
            poly[1512] = new TzPolygon(51.621312f,14.675755f, 51.621312f,14.763161f, 51.607470f,14.765120f, 51.562762f,14.711320f, 51.531172f,14.729415f,
                    51.468987f,14.951899f, 51.361429f,14.965106f, 51.272846f,15.041932f, 51.050132f,14.964714f, 50.820325f,14.794057f,
                    50.845610f,14.675755f);
            poly[1513] = new TzPolygon(50.838142f,14.675755f, 50.822063f,14.722344f, 50.822393f,14.799407f, 50.872752f,14.829517f, 50.868779f,15.001929f,
                    50.921633f,14.989431f, 50.967159f,15.021668f, 50.990026f,14.968214f, 51.010953f,14.985334f, 51.022896f,15.060999f,
                    50.990122f,15.129014f, 51.020030f,15.171851f, 50.982992f,15.180008f, 50.998670f,15.236563f, 50.979528f,15.274074f,
                    50.890989f,15.277126f, 50.838028f,15.367339f, 50.777626f,15.374788f, 50.809059f,15.439530f, 50.737255f,15.705709f,
                    50.755320f,15.816195f, 50.674449f,15.860963f, 50.683412f,15.990905f, 50.630174f,16.021767f, 50.613711f,15.986375f,
                    50.598698f,16.024693f, 50.663342f,16.103705f, 50.627176f,16.187206f, 50.671627f,16.234913f, 50.661508f,16.343081f,
                    50.579570f,16.444908f, 50.569301f,16.404769f, 50.569301f,14.675755f);
            poly[1514] = new TzPolygon(50.001443f,17.813351f, 50.025036f,17.771915f, 50.106068f,17.718338f, 50.110692f,17.650626f, 50.159999f,17.592729f,
                    50.206640f,17.758503f, 50.236354f,17.765103f, 50.256716f,17.725015f, 50.299076f,17.752032f, 50.322588f,17.713006f,
                    50.327962f,17.686951f, 50.298934f,17.685839f, 50.265910f,17.611755f, 50.275089f,17.495593f, 50.251663f,17.438234f,
                    50.282881f,17.386205f, 50.263807f,17.350289f, 50.328350f,17.348662f, 50.319005f,17.282052f, 50.364016f,17.201143f,
                    50.386359f,17.203268f, 50.380421f,17.143330f, 50.404962f,17.110749f, 50.417756f,16.974010f, 50.447719f,16.898540f,
                    50.407750f,16.860325f, 50.389053f,16.910847f, 50.315388f,16.946147f, 50.302117f,17.002639f, 50.229989f,17.028313f,
                    50.216083f,16.998023f, 50.244906f,16.976067f, 50.197645f,16.875398f, 50.207428f,16.847286f, 50.152539f,16.767485f,
                    50.569301f,16.767485f, 50.569301f,17.813351f);
            poly[1515] = new TzPolygon(50.001423f,17.813351f, 49.972527f,17.868478f, 49.977956f,17.918579f, 50.018412f,18.004681f, 50.005128f,18.045463f,
                    50.036608f,18.044382f, 50.038996f,18.004073f, 50.066021f,18.033606f, 50.044101f,18.089288f, 49.994713f,18.115879f,
                    49.982323f,18.153861f, 49.997926f,18.206576f, 49.915683f,18.317964f, 49.929587f,18.350007f, 49.949387f,18.332958f,
                    49.899468f,18.523742f, 49.925702f,18.539391f, 49.921639f,18.572811f, 49.873452f,18.569555f, 49.861599f,18.605728f,
                    49.829394f,18.568836f, 49.722380f,18.625225f, 49.676850f,18.739985f, 49.678878f,18.804589f, 49.550297f,18.859216f,
                    49.517291f,18.850944f, 49.517291f,17.813351f);
            poly[1516] = new TzPolygon(52.251142f,14.675755f, 52.236128f,14.715550f, 52.115640f,14.681812f, 52.065383f,14.759094f, 51.901895f,14.694184f,
                    51.887433f,14.675755f);
            poly[1517] = new TzPolygon(51.720361f,14.675755f, 51.661167f,14.757519f, 51.621312f,14.763161f, 51.621312f,14.675755f);
            poly[1518] = new TzPolygon(48.352981f,18.859216f, 48.352981f,20.301022f, 48.265706f,20.301022f, 48.261640f,20.286858f, 48.279933f,20.234947f,
                    48.250979f,20.206162f, 48.253982f,20.133188f, 48.225182f,20.134091f, 48.167699f,20.051884f, 48.166005f,19.974394f,
                    48.124127f,19.900433f, 48.166312f,19.898745f, 48.178431f,19.855173f, 48.153529f,19.794812f, 48.194820f,19.798733f,
                    48.216512f,19.746180f, 48.203894f,19.691219f, 48.250067f,19.630798f, 48.203130f,19.526044f, 48.083933f,19.467354f,
                    48.101436f,19.454053f, 48.082304f,19.400018f, 48.088711f,19.303112f, 48.053653f,19.241368f, 48.074146f,19.135289f,
                    48.057353f,19.058525f, 48.078179f,19.014864f, 48.053601f,18.981610f, 48.045523f,18.859216f);
            poly[1519] = new TzPolygon(49.613816f,20.301022f, 49.344675f,20.301022f, 49.351790f,20.220823f, 49.302816f,20.157720f, 49.317978f,20.146050f,
                    49.179510f,20.087901f, 49.236490f,19.932217f, 49.195797f,19.869438f, 49.199363f,19.783829f, 49.236598f,19.766768f,
                    49.276794f,19.822802f, 49.299740f,19.792474f, 49.410688f,19.790592f, 49.386422f,19.717643f, 49.408797f,19.631728f,
                    49.457560f,19.641119f, 49.455409f,19.581468f, 49.573019f,19.529331f, 49.613763f,19.467376f, 49.567442f,19.371363f,
                    49.536088f,19.362300f, 49.531229f,19.260688f, 49.411086f,19.191606f, 49.417984f,19.072731f, 49.395222f,18.979854f,
                    49.504336f,18.971646f, 49.520473f,18.859216f, 49.613816f,18.859216f);
            poly[1520] = new TzPolygon(48.352981f,20.301022f, 48.352981f,20.398162f, 48.272794f,20.325711f, 48.265706f,20.301022f);
            poly[1521] = new TzPolygon(48.346469f,21.742829f, 48.349682f,21.724435f, 48.352981f,21.719785f, 48.352981f,21.742829f);
            poly[1522] = new TzPolygon(47.092146f,21.720843f, 47.098527f,21.726096f, 47.100556f,21.742829f, 47.092146f,21.742829f);
            poly[1523] = new TzPolygon(48.352981f,20.398162f, 48.365875f,20.409812f, 48.418988f,20.416724f, 48.489316f,20.507760f, 48.534415f,20.506507f,
                    48.582840f,20.836359f, 48.551818f,20.868155f, 48.559453f,20.922323f, 48.521666f,20.956198f, 48.525894f,21.066321f,
                    48.491055f,21.117448f, 48.537497f,21.221061f, 48.522249f,21.305488f, 48.561201f,21.319384f, 48.558951f,21.415450f,
                    48.585257f,21.439482f, 48.551065f,21.514091f, 48.508395f,21.542020f, 48.509416f,21.613933f, 48.392164f,21.664561f,
                    48.352981f,21.738003f);
            poly[1524] = new TzPolygon(49.391222f,21.742829f, 49.412284f,21.721771f, 49.416801f,21.658905f, 49.447309f,21.630945f, 49.412284f,21.434083f,
                    49.460940f,21.277525f, 49.400993f,21.192128f, 49.436580f,21.124024f, 49.418339f,21.047543f, 49.365056f,21.094109f,
                    49.364881f,21.042548f, 49.306621f,20.986545f, 49.295969f,20.924084f, 49.347484f,20.865549f, 49.343527f,20.796828f,
                    49.358992f,20.809626f, 49.373393f,20.758994f, 49.416301f,20.740105f, 49.400670f,20.646988f, 49.417845f,20.614934f,
                    49.376106f,20.575525f, 49.417917f,20.433569f, 49.395877f,20.431404f, 49.401755f,20.322156f, 49.343508f,20.314177f,
                    49.344675f,20.301022f, 49.613816f,20.301022f, 49.613816f,21.742829f);
            poly[1525] = new TzPolygon(48.352981f,21.742829f, 48.352981f,21.832229f, 48.332582f,21.822332f, 48.346469f,21.742829f);
            poly[1526] = new TzPolygon(47.100556f,21.742829f, 47.106589f,21.792582f, 47.172799f,21.817519f, 47.187009f,21.858015f, 47.239244f,21.851832f,
                    47.372999f,21.938523f, 47.390840f,22.023118f, 47.483620f,22.007189f, 47.532665f,22.036722f, 47.528803f,22.061787f,
                    47.548539f,22.055263f, 47.598019f,22.128164f, 47.594376f,22.176640f, 47.687993f,22.226193f, 47.697906f,22.258996f,
                    47.731068f,22.264325f, 47.743366f,22.317624f, 47.766089f,22.317772f, 47.739812f,22.431332f, 47.798550f,22.444834f,
                    47.804960f,22.463732f, 47.092146f,22.463732f, 47.092146f,21.742829f);
            poly[1527] = new TzPolygon(48.244281f,22.463732f, 48.233963f,22.384755f, 48.352981f,22.318679f, 48.352981f,22.463732f);
            poly[1528] = new TzPolygon(47.804960f,22.463732f, 47.810889f,22.481212f, 47.772225f,22.549002f, 47.787753f,22.680194f, 47.836093f,22.713635f,
                    47.842251f,22.777750f, 47.893410f,22.758051f, 47.907758f,22.847330f, 47.951388f,22.886451f, 47.967281f,22.947637f,
                    48.019141f,22.927046f, 47.990551f,23.013547f, 48.005694f,23.090326f, 48.087141f,23.113876f, 48.119953f,23.166740f,
                    48.106380f,23.184635f, 47.092146f,23.184635f, 47.092146f,22.463732f);
            poly[1529] = new TzPolygon(48.248598f,22.463732f, 48.253442f,22.489873f, 48.196143f,22.571144f, 48.107342f,22.590276f, 48.091955f,22.674274f,
                    48.119848f,22.734719f, 48.115708f,22.826835f, 48.053282f,22.881993f, 47.990310f,22.836304f, 47.954041f,22.897709f,
                    47.907758f,22.847330f, 47.893410f,22.758051f, 47.842251f,22.777750f, 47.836093f,22.713635f, 47.787753f,22.680194f,
                    47.772225f,22.549002f, 47.810889f,22.481212f, 47.804960f,22.463732f);
            poly[1530] = new TzPolygon(48.352981f,21.836097f, 48.363253f,21.837213f, 48.361597f,21.928186f, 48.392749f,22.021326f, 48.371564f,22.086743f,
                    48.380519f,22.135909f, 48.425715f,22.207395f, 48.410211f,22.264540f, 48.387006f,22.239876f, 48.354544f,22.317811f,
                    48.352981f,22.318679f);
            poly[1531] = new TzPolygon(48.352981f,22.318679f, 48.354544f,22.317811f, 48.387006f,22.239876f, 48.409803f,22.265330f, 48.425715f,22.207395f,
                    48.403844f,22.143973f, 48.418795f,22.137059f, 48.587537f,22.171379f, 48.683893f,22.339611f, 48.865040f,22.383536f,
                    48.884602f,22.421124f, 48.965426f,22.463732f, 48.352981f,22.463732f);
            poly[1532] = new TzPolygon(49.098101f,22.463732f, 49.099490f,22.422654f, 49.146597f,22.367258f, 49.152541f,22.225713f, 49.184460f,22.222462f,
                    49.174018f,22.189904f, 49.211586f,22.061964f, 49.348548f,21.961952f, 49.349964f,21.903767f, 49.391673f,21.838319f,
                    49.356048f,21.777994f, 49.391222f,21.742829f, 49.613816f,21.742829f, 49.613816f,22.463732f);
            poly[1533] = new TzPolygon(49.096190f,22.463732f, 49.087996f,22.565710f, 49.006765f,22.545495f, 48.991182f,22.477309f, 48.965426f,22.463732f);
            poly[1534] = new TzPolygon(48.965426f,22.463732f, 48.991182f,22.477309f, 49.006765f,22.545495f, 49.079483f,22.553237f, 49.097324f,22.582478f,
                    49.039382f,22.680184f, 49.053530f,22.765495f, 49.002387f,22.847092f, 49.005047f,22.898020f, 48.970395f,22.919013f,
                    48.957375f,22.873796f, 48.933387f,22.876926f, 48.829418f,23.000904f, 48.862868f,23.098779f, 48.777253f,23.184635f,
                    48.352981f,23.184635f, 48.352981f,22.463732f);
            poly[1535] = new TzPolygon(49.098101f,22.463732f, 49.613816f,22.463732f, 49.613816f,22.734748f, 49.529992f,22.640831f, 49.495128f,22.696686f,
                    49.359891f,22.746811f, 49.226490f,22.714888f, 49.215622f,22.747680f, 49.174980f,22.707265f, 49.182626f,22.756172f,
                    49.157978f,22.739133f, 49.157728f,22.789198f, 49.111015f,22.831509f, 49.094556f,22.892757f, 49.066786f,22.864531f,
                    49.008072f,22.891635f, 49.002047f,22.859667f, 49.051814f,22.773050f, 49.038984f,22.681796f, 49.093498f,22.599813f);
            poly[1536] = new TzPolygon(48.106380f,23.184635f, 48.095645f,23.198787f, 48.100076f,23.267644f, 48.059690f,23.277110f, 48.021070f,23.333250f,
                    47.968200f,23.494950f, 48.021788f,23.529727f, 47.983486f,23.664902f, 47.998354f,23.751187f, 47.983255f,23.819167f,
                    47.931795f,23.864279f, 47.967772f,24.007238f, 47.914669f,24.112538f, 47.916870f,24.195330f, 47.897471f,24.228228f,
                    47.924120f,24.374969f, 47.970383f,24.436135f, 47.951848f,24.507589f, 47.967615f,24.577799f, 47.948682f,24.626441f,
                    47.092146f,24.626441f, 47.092146f,23.184635f);
            poly[1537] = new TzPolygon(47.948534f,24.626441f, 47.968370f,24.563200f, 48.015456f,24.573851f, 48.049178f,24.626441f);
            poly[1538] = new TzPolygon(48.049178f,24.626441f, 48.153189f,24.504057f, 48.215843f,24.545813f, 48.245680f,24.484175f, 48.279789f,24.487774f,
                    48.352981f,24.373617f, 48.352981f,24.626441f);
            poly[1539] = new TzPolygon(48.352981f,24.260174f, 48.350244f,24.258832f, 48.352981f,24.244476f);
            poly[1540] = new TzPolygon(48.777253f,23.184635f, 48.760413f,23.201522f, 48.775881f,23.285877f, 48.753396f,23.325753f, 48.770625f,23.361996f,
                    48.732868f,23.396940f, 48.718270f,23.471858f, 48.734715f,23.511618f, 48.704292f,23.630945f, 48.638023f,23.707386f,
                    48.640213f,23.789882f, 48.581211f,23.804026f, 48.552730f,23.858995f, 48.552371f,23.928968f, 48.464382f,23.925229f,
                    48.459197f,23.966331f, 48.506583f,24.003901f, 48.533370f,24.124848f, 48.388618f,24.148455f, 48.352981f,24.247894f,
                    48.352981f,23.184635f);
            poly[1541] = new TzPolygon(48.352981f,24.257704f, 48.402178f,24.284291f, 48.380419f,24.353525f, 48.352981f,24.356610f);
            poly[1542] = new TzPolygon(49.613816f,22.734748f, 50.015354f,23.184635f, 49.613816f,23.184635f);
            poly[1543] = new TzPolygon(50.641695f,23.184635f, 50.641695f,24.094407f, 50.637437f,24.098189f, 50.503388f,24.070105f, 50.412141f,23.997543f,
                    50.404764f,23.803364f, 50.379264f,23.708757f, 50.331635f,23.686326f, 50.100545f,23.280084f, 50.015354f,23.184635f);
            poly[1544] = new TzPolygon(51.669574f,23.548221f, 51.669574f,24.127584f, 51.666521f,24.120392f, 51.580470f,23.995340f, 51.592243f,23.882438f,
                    51.631450f,23.912770f, 51.640502f,23.788417f, 51.667526f,23.782714f, 51.623170f,23.610097f, 51.584141f,23.661018f,
                    51.548870f,23.636301f, 51.506634f,23.676887f, 51.503410f,23.625882f, 51.528711f,23.612828f, 51.535088f,23.564514f,
                    51.644798f,23.537024f);
            poly[1545] = new TzPolygon(51.669574f,23.548221f, 51.644798f,23.537024f, 51.534757f,23.564682f, 51.528711f,23.612828f, 51.496366f,23.620130f,
                    51.483027f,23.669819f, 51.446259f,23.649442f, 51.419545f,23.702933f, 51.328515f,23.635773f, 51.291819f,23.645959f,
                    51.291638f,23.695011f, 51.211968f,23.739189f, 51.150312f,23.869269f, 51.099951f,23.856859f, 51.074600f,23.911092f,
                    51.007051f,23.915080f, 50.990762f,23.956755f, 50.950299f,23.970381f, 50.891414f,24.052345f, 50.868612f,24.145783f,
                    50.835948f,24.100156f, 50.840324f,24.001133f, 50.814375f,23.963523f, 50.774974f,23.968821f, 50.766178f,24.023915f,
                    50.723189f,24.016429f, 50.720342f,24.072200f, 50.677859f,24.062288f, 50.641695f,24.094407f, 50.641695f,23.184635f,
                    51.669574f,23.184635f);
            poly[1546] = new TzPolygon(51.669574f,24.127584f, 51.751123f,24.319693f, 51.806994f,24.295912f, 51.878231f,24.372228f, 51.902524f,24.626441f,
                    51.669574f,24.626441f);
            poly[1547] = new TzPolygon(53.725332f,23.570543f, 53.274188f,23.798979f, 53.157396f,23.918242f, 53.082001f,23.871775f, 52.958733f,23.946270f,
                    52.938843f,23.916467f, 52.712916f,23.938640f, 52.606522f,23.734218f, 52.607456f,23.641411f, 52.549448f,23.466628f,
                    52.283141f,23.178334f, 52.226554f,23.203666f, 52.201074f,23.395467f, 52.172294f,23.424278f, 52.179053f,23.500715f,
                    52.150742f,23.489341f, 52.109709f,23.549188f, 52.108804f,23.618544f, 52.073758f,23.652942f, 51.991910f,23.689023f,
                    51.951146f,23.627571f, 51.892995f,23.637970f, 51.840480f,23.600148f, 51.800882f,23.641749f, 51.729680f,23.527190f,
                    51.699238f,23.561626f, 51.669574f,23.548221f, 51.669574f,21.742829f, 53.725332f,21.742829f);
            poly[1548] = new TzPolygon(47.948682f,24.626441f, 47.840017f,24.705803f, 47.820740f,24.827730f, 47.724553f,24.883330f, 47.725926f,25.039344f,
                    47.790680f,25.165509f, 47.895729f,25.236936f, 47.974389f,26.010750f, 46.956647f,26.010750f, 46.956647f,24.626441f);
            poly[1549] = new TzPolygon(47.591321f,27.395058f, 47.596721f,27.373741f, 47.662279f,27.294888f, 47.719597f,27.250996f, 47.723311f,27.293051f,
                    47.724259f,27.293203f, 47.724259f,27.395058f);
            poly[1550] = new TzPolygon(48.262736f,26.702904f, 48.265391f,26.699447f, 48.246390f,26.666232f, 48.274000f,26.616219f, 48.327207f,26.695942f,
                    48.363358f,26.691440f, 48.350601f,26.702904f);
            poly[1551] = new TzPolygon(48.491870f,26.702904f, 48.340388f,26.702904f, 48.358904f,26.680078f, 48.327207f,26.695942f, 48.274000f,26.616219f,
                    48.240911f,26.622056f, 48.185102f,26.333738f, 47.994664f,26.184373f, 47.981399f,26.010750f, 48.491870f,26.010750f);
            poly[1552] = new TzPolygon(47.724259f,27.293203f, 47.751729f,27.297624f, 47.817277f,27.215768f, 47.843942f,27.230839f, 47.848156f,27.194957f,
                    47.852843f,27.217200f, 47.900580f,27.201324f, 47.915514f,27.142670f, 47.947691f,27.178190f, 47.964606f,27.143987f,
                    47.993849f,27.164338f, 48.008864f,27.089241f, 48.031302f,27.107765f, 48.089532f,27.025338f, 48.108064f,27.032177f,
                    48.108064f,27.395058f, 47.724259f,27.395058f);
            poly[1553] = new TzPolygon(48.264246f,26.702904f, 48.245654f,26.725144f, 48.253964f,26.810493f, 48.200992f,26.909177f, 48.180724f,26.903351f,
                    48.194310f,26.945175f, 48.164366f,26.934911f, 48.150446f,26.991679f, 48.152084f,26.954840f, 48.133242f,26.959335f,
                    48.129011f,27.039907f, 48.108064f,27.032177f, 48.108064f,26.702904f);
            poly[1554] = new TzPolygon(48.409814f,27.395058f, 48.410034f,27.384427f, 48.441718f,27.373227f, 48.443588f,27.319724f, 48.371530f,27.286371f,
                    48.394887f,27.192463f, 48.379228f,27.123814f, 48.434669f,27.084918f, 48.425114f,27.014410f, 48.376425f,27.046825f,
                    48.380033f,27.004014f, 48.359481f,26.995190f, 48.363293f,26.931733f, 48.420707f,26.871134f, 48.418363f,26.774964f,
                    48.398920f,26.753570f, 48.410460f,26.720330f, 48.353686f,26.764920f, 48.344423f,26.824122f, 48.295236f,26.817364f,
                    48.302360f,26.766940f, 48.323688f,26.757735f, 48.312917f,26.736770f, 48.340388f,26.702904f, 48.491870f,26.702904f,
                    48.491870f,27.395058f);
            poly[1555] = new TzPolygon(46.189036f,27.395058f, 46.189036f,28.132104f, 46.164357f,28.143083f, 46.008244f,28.085349f, 45.876934f,28.132696f,
                    45.859413f,28.105459f, 45.792682f,28.112803f, 45.782514f,28.153955f, 45.645630f,28.174274f, 45.604598f,28.088562f,
                    45.571867f,28.121618f, 45.575362f,28.156723f, 45.509928f,28.153979f, 45.473871f,28.186567f, 45.444068f,28.280666f,
                    45.421424f,28.291675f, 45.421424f,27.395058f);
            poly[1556] = new TzPolygon(45.421424f,28.293184f, 45.444068f,28.280666f, 45.467414f,28.213046f, 45.547049f,28.304956f, 45.512697f,28.420841f,
                    45.485224f,28.420624f, 45.499952f,28.515388f, 45.571065f,28.491159f, 45.579816f,28.544248f, 45.665257f,28.515832f,
                    45.660474f,28.486138f, 45.678224f,28.480706f, 45.737295f,28.520366f, 45.729339f,28.588758f, 45.770688f,28.580710f,
                    45.779905f,28.709376f, 45.817878f,28.697093f, 45.831402f,28.779367f, 45.421424f,28.779367f);
            poly[1557] = new TzPolygon(45.853124f,28.779367f, 45.929316f,28.754639f, 45.970694f,28.776500f, 45.971158f,28.779367f);
            poly[1558] = new TzPolygon(46.189036f,28.132617f, 46.242708f,28.109855f, 46.251457f,28.146398f, 46.262092f,28.126204f, 46.292362f,28.149876f,
                    46.285286f,28.180412f, 46.310347f,28.202429f, 46.352419f,28.182597f, 46.426545f,28.258546f, 46.462248f,28.258431f,
                    46.505633f,28.209294f, 46.612355f,28.252558f, 46.777930f,28.176580f, 46.821985f,28.114359f, 46.891872f,28.113954f,
                    46.903007f,28.082931f, 46.921171f,28.112593f, 46.937700f,28.080964f, 46.956647f,28.087808f, 46.956647f,28.779367f,
                    46.189036f,28.779367f);
            poly[1559] = new TzPolygon(45.421424f,29.207957f, 45.432705f,29.238151f, 45.442584f,29.429732f, 45.421424f,29.499706f);
            poly[1560] = new TzPolygon(46.189036f,28.779367f, 46.189036f,29.059995f, 46.093659f,28.950720f, 46.049445f,29.005501f, 46.003452f,28.979101f,
                    45.971158f,28.779367f);
            poly[1561] = new TzPolygon(45.853124f,28.779367f, 45.832502f,28.786060f, 45.831402f,28.779367f);
            poly[1562] = new TzPolygon(46.189036f,29.059995f, 46.195613f,29.067531f, 46.258659f,28.953959f, 46.316608f,29.003726f, 46.457542f,28.930663f,
                    46.462343f,29.025533f, 46.489009f,28.981283f, 46.515295f,29.163915f, 46.544501f,29.161788f, 46.558290f,29.235876f,
                    46.485533f,29.255138f, 46.463766f,29.219447f, 46.416168f,29.246633f, 46.386551f,29.206645f, 46.376099f,29.240829f,
                    46.406216f,29.263966f, 46.414880f,29.324260f, 46.464886f,29.307760f, 46.504277f,29.351412f, 46.425190f,29.396120f,
                    46.446637f,29.386786f, 46.498572f,29.448503f, 46.482627f,29.471522f, 46.189036f,29.471522f);
            poly[1563] = new TzPolygon(46.956647f,29.558599f, 46.940246f,29.572091f, 46.955181f,29.639654f, 46.919428f,29.647923f, 46.932117f,29.718064f,
                    46.860959f,29.749357f, 46.886127f,29.884074f, 46.820437f,29.905955f, 46.831842f,29.968595f, 46.816256f,29.978699f,
                    46.805812f,29.935205f, 46.752119f,29.974704f, 46.648469f,29.945927f, 46.594936f,29.968298f, 46.581747f,29.935469f,
                    46.555594f,29.945005f, 46.546736f,29.876122f, 46.493758f,29.937170f, 46.510185f,29.986755f, 46.442088f,30.022569f,
                    46.423903f,30.078398f, 46.440069f,30.095724f, 46.411018f,30.134279f, 46.429070f,30.156998f, 46.413530f,30.163676f,
                    46.375208f,30.096903f, 46.397055f,30.069925f, 46.384055f,29.987943f, 46.400465f,29.938624f, 46.352242f,29.891151f,
                    46.385474f,29.805106f, 46.395807f,29.822939f, 46.473417f,29.742384f, 46.435027f,29.734494f, 46.435796f,29.660070f,
                    46.361197f,29.677614f, 46.353762f,29.603096f, 46.416455f,29.566173f, 46.427966f,29.494415f, 46.461665f,29.501782f,
                    46.482627f,29.471522f, 46.956647f,29.471522f);
            poly[1564] = new TzPolygon(47.591321f,27.395058f, 47.583010f,27.427869f, 47.485189f,27.474917f, 47.490804f,27.516353f, 47.473707f,27.516315f,
                    47.489023f,27.538205f, 47.462968f,27.573188f, 47.373078f,27.568975f, 47.340122f,27.615174f, 47.327830f,27.580928f,
                    47.299458f,27.646472f, 47.309475f,27.679228f, 47.284262f,27.686121f, 47.292658f,27.732268f, 47.165882f,27.811124f,
                    47.142371f,27.781268f, 47.135636f,27.842587f, 47.121362f,27.826104f, 47.107906f,27.874845f, 47.073384f,27.897567f,
                    47.024735f,28.048559f, 47.011512f,28.032028f, 46.978963f,28.095868f, 46.956647f,28.087808f, 46.956647f,27.395058f);
            poly[1565] = new TzPolygon(48.125174f,28.779367f, 48.124626f,28.687788f, 48.146792f,28.682087f, 48.143291f,28.647500f, 48.182449f,28.577346f,
                    48.150789f,28.502940f, 48.066194f,28.500365f, 48.074163f,28.463514f, 48.122174f,28.421710f, 48.172392f,28.428371f,
                    48.175104f,28.383157f, 48.135689f,28.349255f, 48.139494f,28.306635f, 48.191940f,28.361591f, 48.244952f,28.356030f,
                    48.204756f,28.208334f, 48.257023f,28.177712f, 48.235203f,28.086369f, 48.319264f,28.070548f, 48.328138f,27.954409f,
                    48.446591f,27.786334f, 48.441817f,27.643608f, 48.461293f,27.591424f, 48.491781f,27.587007f, 48.448634f,27.466625f,
                    48.408786f,27.444729f, 48.409814f,27.395058f, 48.491870f,27.395058f, 48.491870f,28.779367f);
            poly[1566] = new TzPolygon(48.125174f,28.779367f, 48.125544f,28.841119f, 48.034946f,28.839449f, 48.012558f,28.901888f, 48.000808f,28.877663f,
                    47.960140f,28.925847f, 47.979190f,28.961602f, 47.943896f,29.073763f, 47.983071f,29.092889f, 47.993778f,29.175315f,
                    47.884369f,29.200638f, 47.887916f,29.281629f, 47.819845f,29.198421f, 47.798435f,29.219308f, 47.803708f,29.276135f,
                    47.719069f,29.204364f, 47.683763f,29.231107f, 47.642297f,29.209387f, 47.642589f,29.233957f, 47.571964f,29.184660f,
                    47.554424f,29.116945f, 47.506554f,29.151540f, 47.513966f,29.189672f, 47.459233f,29.157564f, 47.467106f,29.190555f,
                    47.425058f,29.190968f, 47.461969f,29.242346f, 47.415307f,29.243755f, 47.449200f,29.317490f, 47.370553f,29.337622f,
                    47.379761f,29.390722f, 47.300472f,29.398362f, 47.292148f,29.427045f, 47.305878f,29.485716f, 47.355861f,29.487653f,
                    47.370401f,29.574194f, 47.257392f,29.598693f, 47.251388f,29.552110f, 47.135764f,29.579925f, 47.131522f,29.494747f,
                    47.075449f,29.530202f, 47.096057f,29.613469f, 47.044726f,29.628676f, 47.041634f,29.602483f, 46.963570f,29.595786f,
                    46.958091f,29.557411f, 46.956647f,29.558599f, 46.956647f,28.779367f);
            poly[1567] = new TzPolygon(51.902524f,24.626441f, 51.881058f,24.749688f, 51.911854f,24.810195f, 51.896012f,24.843100f, 51.916873f,24.914533f,
                    51.891212f,24.934199f, 51.969236f,25.191415f, 51.919196f,25.458280f, 51.940755f,25.527307f, 51.921626f,25.780682f,
                    51.950015f,25.765302f, 51.915417f,25.924456f, 51.933392f,25.995432f, 51.912257f,26.093130f, 51.865217f,26.156210f,
                    51.862946f,26.371044f, 51.878258f,26.395531f, 51.831160f,26.395656f, 51.799560f,26.466617f, 51.796025f,26.546698f,
                    51.830334f,26.592624f, 51.823304f,26.693605f, 51.758764f,26.796078f, 51.766924f,26.850588f, 51.736194f,26.950488f,
                    51.768554f,26.993748f, 51.773829f,27.207200f, 51.666504f,27.213218f, 51.654421f,27.273006f, 51.601807f,27.240360f,
                    51.614910f,27.395058f, 48.491870f,27.395058f, 48.491870f,24.626441f);
            poly[1568] = new TzPolygon(51.509262f,28.779367f, 51.493647f,28.766680f, 51.465880f,28.779367f, 51.445531f,28.779367f, 51.415874f,28.757398f,
                    51.466944f,28.739978f, 51.444714f,28.687788f, 51.562564f,28.635778f, 51.568134f,28.662728f, 51.593459f,28.471544f,
                    51.539384f,28.359488f, 51.578094f,28.345578f, 51.622894f,28.260268f, 51.681434f,28.264388f, 51.643924f,28.173748f,
                    51.583074f,28.117278f, 51.566424f,28.051008f, 51.558184f,27.945788f, 51.595604f,27.980288f, 51.578604f,27.926388f,
                    51.617234f,27.918058f, 51.630552f,27.843869f, 51.618066f,27.822487f, 51.545474f,27.854288f, 51.531067f,27.805329f,
                    51.474064f,27.759098f, 51.517844f,27.668808f, 51.562304f,27.724168f, 51.604614f,27.727598f, 51.605409f,27.618852f,
                    51.637645f,27.517223f, 51.587874f,27.510618f, 51.620234f,27.457918f, 51.614910f,27.395058f, 53.725332f,27.395058f,
                    53.725332f,28.779367f);
            poly[1569] = new TzPolygon(51.509262f,28.779367f, 53.725332f,28.779367f, 53.725332f,30.163676f, 51.489027f,30.163676f, 51.506040f,30.018119f,
                    51.471172f,29.962499f, 51.492094f,29.926588f, 51.478444f,29.885638f, 51.446254f,29.881348f, 51.459994f,29.813458f,
                    51.441714f,29.797328f, 51.457414f,29.744278f, 51.531054f,29.740418f, 51.529944f,29.716728f, 51.506344f,29.633648f,
                    51.463934f,29.585408f, 51.482474f,29.538798f, 51.396768f,29.495688f, 51.415104f,29.421558f, 51.377674f,29.326198f,
                    51.454234f,29.309118f, 51.495614f,29.251008f, 51.567964f,29.257448f, 51.573849f,29.208752f, 51.653415f,29.165770f,
                    51.652339f,29.117303f, 51.573522f,28.999378f, 51.590203f,28.912548f, 51.558821f,28.819633f);
            poly[1570] = new TzPolygon(51.465880f,28.779367f, 51.453294f,28.785118f, 51.445531f,28.779367f);
            poly[1571] = new TzPolygon(45.421424f,32.208000f, 45.478795f,32.223017f, 45.596938f,32.321802f, 45.712325f,32.589062f, 45.826642f,32.772702f,
                    45.838117f,32.820238f, 45.421424f,32.820238f);
            poly[1572] = new TzPolygon(45.838117f,32.820238f, 46.012031f,33.540719f, 46.061247f,33.591187f, 46.102564f,33.572133f, 46.142443f,33.641275f,
                    46.213917f,33.613551f, 46.229580f,33.646771f, 46.185247f,33.739978f, 46.199667f,33.848686f, 46.066863f,34.184374f,
                    46.057880f,34.339623f, 45.944139f,34.476221f, 45.994384f,34.561169f, 45.986403f,34.628541f, 45.900648f,34.802169f,
                    45.810464f,34.799087f, 45.756568f,34.959775f, 45.791730f,35.233420f, 45.742558f,35.289352f, 45.421424f,35.289352f,
                    45.421424f,32.820238f);
            poly[1573] = new TzPolygon(46.257563f,35.289352f, 46.264581f,35.278063f, 46.299899f,35.073536f, 46.481629f,35.054623f, 46.512356f,34.946811f,
                    46.506780f,34.890386f, 46.562570f,34.891220f, 46.549324f,34.757601f, 46.584190f,34.748275f, 46.581467f,34.723299f,
                    46.620074f,34.712764f, 46.626976f,34.756309f, 46.683219f,34.746177f, 46.687619f,34.632236f, 46.723972f,34.625226f,
                    46.757895f,34.750486f, 46.783177f,34.753469f, 46.783177f,35.289352f);
            poly[1574] = new TzPolygon(46.783177f,35.289352f, 46.783177f,34.753469f, 46.822707f,34.758132f, 46.828935f,34.817047f, 46.882527f,34.804683f,
                    46.879537f,34.752569f, 46.961456f,34.736151f, 46.973397f,34.623843f, 47.026792f,34.591657f, 47.024492f,34.567270f,
                    47.240600f,34.490998f, 47.250760f,34.530098f, 47.307786f,34.480456f, 47.336228f,34.515886f, 47.323341f,34.413485f,
                    47.287172f,34.401226f, 47.290704f,34.329064f, 47.269141f,34.305347f, 47.433865f,34.242689f, 47.477250f,34.139465f,
                    47.561616f,34.572379f, 47.515072f,34.862273f, 47.533994f,34.952961f, 47.673885f,34.905713f, 47.677400f,34.938240f,
                    47.769629f,34.957517f, 47.760161f,34.893573f, 47.852815f,34.897232f, 47.850626f,34.870804f, 47.880530f,34.860842f,
                    47.864329f,34.817113f, 47.915638f,34.801974f, 47.941951f,34.876423f, 47.933461f,34.919089f, 47.985719f,34.904884f,
                    47.982394f,34.869539f, 48.013920f,34.846968f, 48.050513f,34.839214f, 48.054464f,34.875664f, 48.133049f,34.855113f,
                    48.130604f,34.915813f, 48.090937f,34.914723f, 48.089190f,34.990259f, 48.131607f,35.101746f, 48.144930f,35.284295f,
                    48.143278f,35.289352f);
            poly[1575] = new TzPolygon(46.257563f,35.289352f, 46.146486f,35.468039f, 45.985265f,35.327373f, 45.973682f,35.289352f);
            poly[1576] = new TzPolygon(46.783177f,37.119425f, 46.783177f,37.539197f, 46.701587f,37.397939f, 46.688042f,37.279713f, 46.710379f,37.168722f);
            poly[1577] = new TzPolygon(45.742558f,35.289352f, 45.627804f,35.419882f, 45.560338f,35.459695f, 45.489533f,35.574751f, 45.583784f,35.638433f,
                    45.637030f,35.751885f, 45.645401f,35.871149f, 45.616733f,35.981773f, 45.671500f,36.338701f, 45.626621f,36.668450f,
                    45.456612f,36.681568f, 45.421424f,36.674992f, 45.421424f,35.289352f);
            poly[1578] = new TzPolygon(46.783177f,35.289352f, 46.783177f,37.119425f, 46.710379f,37.168722f, 46.638923f,37.024161f, 46.512931f,36.947317f,
                    46.469222f,36.845648f, 46.459831f,36.743574f, 46.483645f,36.628806f, 46.535651f,36.545704f, 46.528155f,36.498783f,
                    46.352883f,36.292107f, 46.301961f,36.137440f, 46.321956f,35.968556f, 46.409999f,35.844422f, 46.262811f,35.581937f,
                    46.146486f,35.468039f, 46.257563f,35.289352f);
            poly[1579] = new TzPolygon(48.143278f,35.289352f, 48.100188f,35.421262f, 48.096098f,35.514657f, 48.074415f,35.523657f, 48.140215f,35.703412f,
                    48.095748f,35.742825f, 48.100611f,35.806053f, 48.066123f,35.816863f, 48.092513f,35.974996f, 48.043179f,35.975291f,
                    48.059072f,36.052484f, 48.025199f,36.065531f, 48.018716f,36.034434f, 47.971518f,36.070745f, 47.965521f,36.047946f,
                    47.927863f,36.119729f, 47.864762f,36.119227f, 47.880001f,36.054061f, 47.848833f,36.073651f, 47.859448f,36.195824f,
                    47.832545f,36.197574f, 47.833203f,36.266186f, 47.815475f,36.275517f, 47.820649f,36.332645f, 47.839467f,36.324133f,
                    47.824198f,36.475956f, 47.834120f,36.523909f, 46.783177f,36.523909f, 46.783177f,35.289352f);
            poly[1580] = new TzPolygon(46.783177f,37.758466f, 46.783177f,37.545337f, 46.829891f,37.620074f, 46.838158f,37.758466f);
            poly[1581] = new TzPolygon(47.834120f,36.523909f, 47.850838f,36.604701f, 47.785356f,36.587632f, 47.793582f,36.671306f, 47.678871f,36.713380f,
                    47.684922f,36.791644f, 47.658847f,36.718272f, 47.631093f,36.725195f, 47.634113f,36.765849f, 47.606596f,36.748103f,
                    47.624229f,36.830317f, 47.544915f,36.893411f, 47.576132f,36.944339f, 47.538865f,37.001596f, 47.552798f,37.021027f,
                    47.493700f,37.074217f, 47.456132f,37.154445f, 47.483657f,37.179798f, 47.457234f,37.248629f, 47.355765f,37.203418f,
                    47.341438f,37.161980f, 47.381105f,37.146039f, 47.375957f,37.106553f, 47.340373f,37.122177f, 47.299984f,37.036127f,
                    47.319416f,36.926022f, 47.201656f,36.962614f, 47.199134f,36.854610f, 47.127163f,37.002222f, 47.089360f,37.012767f,
                    47.079772f,36.985416f, 47.047479f,37.081212f, 47.059249f,37.098695f, 47.039107f,37.124917f, 47.007462f,37.089337f,
                    46.981994f,37.141133f, 46.927899f,37.021422f, 46.783177f,37.119425f, 46.783177f,36.523909f);
            poly[1582] = new TzPolygon(48.144930f,39.895619f, 48.079195f,39.868888f, 48.067014f,39.833967f, 48.041607f,39.883388f, 48.039784f,39.776498f,
                    47.981221f,39.823100f, 47.870376f,39.794920f, 47.870690f,39.763449f, 47.827780f,39.738043f, 47.825060f,39.542516f,
                    47.860680f,39.477806f, 47.829727f,39.413225f, 47.871160f,39.387309f, 47.842672f,39.109463f, 47.869532f,39.083110f,
                    47.877692f,38.879210f, 47.864457f,38.837614f, 47.815919f,38.828819f, 47.815917f,38.788923f, 47.685525f,38.772608f,
                    47.698729f,38.665828f, 47.669314f,38.666027f, 47.669396f,38.629272f, 47.644581f,38.616437f, 47.644044f,38.456485f,
                    47.617111f,38.456750f, 47.616646f,38.350461f, 47.576197f,38.350716f, 47.576145f,38.310793f, 47.544310f,38.284727f,
                    47.392848f,38.302390f, 47.327078f,38.221134f, 47.305397f,38.220892f, 47.306254f,38.336040f, 47.256950f,38.324490f,
                    47.228951f,38.232909f, 47.122607f,38.228514f, 46.980752f,38.338122f, 46.861000f,38.140864f, 46.838158f,37.758466f,
                    48.144930f,37.758466f);
            poly[1583] = new TzPolygon(50.935131f,30.163920f, 51.488995f,30.163950f, 51.512522f,30.180171f, 51.423490f,30.348868f, 51.379654f,30.362688f,
                    51.360506f,30.324176f, 51.312709f,30.397559f, 51.306479f,30.462565f, 51.275247f,30.458576f, 51.257598f,30.567447f,
                    51.288054f,30.617985f, 51.311842f,30.593602f, 51.335418f,30.651555f, 51.376181f,30.655698f, 51.428877f,30.621517f,
                    51.430499f,30.586117f, 51.449754f,30.580096f, 51.464841f,30.623226f, 51.511444f,30.568350f, 51.546258f,30.583926f,
                    51.541634f,30.545717f, 51.569584f,30.526763f, 51.578866f,30.553735f, 51.600618f,30.506515f, 51.646103f,30.579762f,
                    51.704142f,30.560329f, 51.713577f,30.625127f, 51.760027f,30.651209f, 51.766848f,30.613727f, 51.791112f,30.669761f,
                    51.868461f,30.706888f, 51.903584f,30.749673f, 51.899056f,30.802579f, 51.946853f,30.805138f, 51.969377f,30.890014f,
                    52.002858f,30.895551f, 52.013500f,30.939852f, 52.089481f,30.949328f, 52.077601f,30.991648f, 52.103113f,31.139918f,
                    52.042229f,31.252996f, 52.051623f,31.297521f, 52.105264f,31.327768f, 52.139501f,31.421664f, 50.935131f,31.421664f);
            poly[1584] = new TzPolygon(52.139501f,31.421664f, 52.143408f,31.432380f, 52.116557f,31.483439f, 52.117680f,31.659250f, 52.096740f,31.721390f,
                    52.110178f,31.867792f, 52.074718f,31.960990f, 52.042205f,31.916570f, 52.033627f,32.096324f, 52.146496f,32.367903f,
                    52.151543f,32.323895f, 52.182471f,32.346867f, 52.223413f,32.324542f, 52.246044f,32.401502f, 52.316218f,32.351885f,
                    52.330231f,32.368461f, 52.330231f,32.411663f, 52.314381f,32.489679f, 52.326866f,32.550034f, 52.258883f,32.679652f,
                    50.935131f,32.679652f, 50.935131f,31.421664f);
            poly[1585] = new TzPolygon(52.330231f,31.598064f, 52.328220f,31.581830f, 52.266000f,31.712210f, 52.194464f,31.688264f, 52.185570f,31.781040f,
                    52.126010f,31.792800f, 52.096740f,31.721390f, 52.117680f,31.659250f, 52.116557f,31.483439f, 52.136714f,31.421664f,
                    52.330231f,31.421664f);
            poly[1586] = new TzPolygon(52.894914f,31.421664f, 52.911270f,31.393520f, 52.984735f,31.356082f, 53.032324f,31.242258f, 53.041807f,31.330609f,
                    53.091232f,31.334780f, 53.096492f,31.391200f, 53.143960f,31.363560f, 53.178290f,31.414890f, 53.211850f,31.401840f,
                    53.209458f,31.421664f);
            poly[1587] = new TzPolygon(52.330231f,32.368461f, 52.337308f,32.376832f, 52.330231f,32.411663f);
            poly[1588] = new TzPolygon(52.894914f,31.421664f, 52.860540f,31.480810f, 52.860030f,31.533420f, 52.831530f,31.519430f, 52.791369f,31.589628f,
                    52.734477f,31.592854f, 52.695225f,31.497790f, 52.635151f,31.569472f, 52.594278f,31.563952f, 52.561145f,31.673623f,
                    52.517650f,31.557630f, 52.492500f,31.626120f, 52.459290f,31.579600f, 52.453450f,31.610840f, 52.414902f,31.594092f,
                    52.398180f,31.632560f, 52.333469f,31.624193f, 52.330231f,31.598064f, 52.330231f,31.421664f);
            poly[1589] = new TzPolygon(53.209458f,31.421664f, 53.192279f,31.564014f, 53.231080f,31.628350f, 53.179727f,31.786399f, 53.113004f,31.826052f,
                    53.106540f,31.917430f, 53.083064f,31.934674f, 53.100116f,32.019064f, 53.076191f,32.094753f, 53.108855f,32.187569f,
                    53.099169f,32.236073f, 53.129171f,32.245244f, 53.127664f,32.302219f, 53.185125f,32.357738f, 53.208254f,32.448315f,
                    53.281630f,32.509490f, 53.303520f,32.488460f, 53.290525f,32.583307f, 53.340340f,32.616520f, 53.336125f,32.679652f,
                    53.027782f,32.679652f, 53.027782f,31.421664f);
            poly[1590] = new TzPolygon(53.467119f,32.679652f, 53.469859f,32.655914f, 53.478651f,32.679652f);
            poly[1591] = new TzPolygon(53.485595f,32.679652f, 53.504122f,32.647068f, 53.478814f,32.604242f, 53.512869f,32.603302f, 53.548880f,32.477916f,
                    53.607440f,32.425800f, 53.637346f,32.449797f, 53.650663f,32.413898f, 53.681135f,32.498951f, 53.725332f,32.469025f,
                    53.725332f,32.679652f);
            poly[1592] = new TzPolygon(53.725332f,32.405016f, 53.717399f,32.369175f, 53.725332f,32.363125f);
            poly[1593] = new TzPolygon(52.258883f,32.679652f, 52.247901f,32.700590f, 52.258938f,32.817053f, 52.278295f,32.833022f, 52.273371f,32.884404f,
                    52.245768f,32.903041f, 52.271860f,32.995741f, 52.329554f,33.059918f, 52.302594f,33.066987f, 52.330231f,33.110628f,
                    52.330231f,33.492561f, 52.313645f,33.482473f, 52.301927f,33.560506f, 52.323620f,33.543903f, 52.310883f,33.581748f,
                    52.330231f,33.623782f, 52.330231f,33.835637f, 52.320047f,33.839330f, 52.285327f,33.937640f, 50.935131f,33.937640f,
                    50.935131f,32.679652f);
            poly[1594] = new TzPolygon(51.054917f,35.195628f, 51.082569f,35.147555f, 51.098688f,35.176918f, 51.165138f,35.123351f, 51.223420f,35.150266f,
                    51.232027f,35.075192f, 51.204421f,35.038756f, 51.235543f,34.979959f, 51.193014f,34.898200f, 51.199156f,34.862314f,
                    51.169341f,34.834803f, 51.184781f,34.784451f, 51.171520f,34.716637f, 51.197351f,34.668936f, 51.247442f,34.662643f,
                    51.253669f,34.602982f, 51.233516f,34.580467f, 51.273769f,34.384180f, 51.238443f,34.305761f, 51.265068f,34.230800f,
                    51.335087f,34.281333f, 51.329325f,34.314573f, 51.355534f,34.338553f, 51.417153f,34.220780f, 51.519200f,34.308408f,
                    51.533277f,34.259867f, 51.584811f,34.237452f, 51.574344f,34.216291f, 51.600376f,34.210997f, 51.596765f,34.182334f,
                    51.632681f,34.171261f, 51.632681f,35.195628f);
            poly[1595] = new TzPolygon(51.632681f,35.195628f, 51.632681f,34.171261f, 51.645658f,34.167260f, 51.666141f,34.080223f, 51.720262f,34.308898f,
                    51.722327f,34.422853f, 51.825296f,34.415372f, 51.887170f,34.302857f, 51.881644f,34.245607f, 51.909282f,34.261492f,
                    51.920386f,34.219117f, 51.968942f,34.189590f, 51.967985f,34.142928f, 51.999722f,34.139722f, 52.004262f,34.096917f,
                    52.073060f,34.062654f, 52.141084f,34.116280f, 52.166597f,34.059306f, 52.201395f,34.052827f, 52.249458f,33.937640f,
                    52.330231f,33.937640f, 52.330231f,35.195628f);
            poly[1596] = new TzPolygon(52.330231f,33.110628f, 52.345008f,33.133961f, 52.340846f,33.169563f, 52.379147f,33.188660f, 52.350143f,33.306382f,
                    52.371641f,33.380563f, 52.342656f,33.446812f, 52.364970f,33.454520f, 52.358271f,33.509616f, 52.330231f,33.492561f);
            poly[1597] = new TzPolygon(52.330231f,33.623782f, 52.357180f,33.682326f, 52.364174f,33.823330f, 52.330231f,33.835637f);
            poly[1598] = new TzPolygon(53.485595f,32.679652f, 53.481390f,32.687047f, 53.478651f,32.679652f);
            poly[1599] = new TzPolygon(53.467119f,32.679652f, 53.458180f,32.757110f, 53.424277f,32.762781f, 53.374070f,32.722950f, 53.332530f,32.733500f,
                    53.336125f,32.679652f);
        }
    }

    private static class Initializer17 {
        private static void init() {
            poly[1600] = new TzPolygon(50.115373f,37.711604f, 50.175930f,37.640700f, 50.220050f,37.614440f, 50.311370f,37.635550f, 50.306570f,37.577020f,
                    50.369220f,37.471960f, 50.457460f,37.491020f, 50.435476f,37.327272f, 50.401301f,37.292486f, 50.356464f,37.152979f,
                    50.337728f,36.870278f, 50.269140f,36.692960f, 50.217650f,36.648670f, 50.250610f,36.560440f, 50.285800f,36.584990f,
                    50.311200f,36.439930f, 50.330770f,36.433410f, 50.287510f,36.363030f, 50.291630f,36.295740f, 50.335580f,36.283720f,
                    50.431540f,36.160640f, 50.448360f,36.086650f, 50.438570f,35.889760f, 50.422440f,35.872420f, 50.433770f,35.831740f,
                    50.354460f,35.738180f, 50.352028f,35.626223f, 50.392662f,35.584247f, 50.448799f,35.585831f, 50.488533f,35.476419f,
                    50.579986f,35.390346f, 50.603176f,35.425650f, 50.649999f,35.392916f, 50.655864f,35.485734f, 50.678792f,35.496181f,
                    50.689089f,35.459298f, 50.776804f,35.488713f, 50.802563f,35.411406f, 50.843828f,35.419118f, 50.870043f,35.382315f,
                    50.914590f,35.400609f, 50.935131f,35.352758f, 50.935131f,37.711604f);
            poly[1601] = new TzPolygon(48.144930f,39.895619f, 48.179846f,39.909817f, 48.180959f,39.937016f, 48.228610f,39.942000f, 48.225119f,40.009591f,
                    48.253857f,40.020759f, 48.317058f,39.990334f, 48.269628f,39.915035f, 48.308549f,39.887606f, 48.310054f,39.841160f,
                    48.332856f,39.845318f, 48.355060f,39.947622f, 48.386320f,39.941515f, 48.390379f,39.905720f, 48.447388f,39.898189f,
                    48.473752f,39.846444f, 48.567896f,39.850427f, 48.593009f,39.791632f, 48.586802f,39.687888f, 48.609086f,39.660649f,
                    48.655139f,39.710918f, 48.720508f,39.704308f, 48.770200f,39.743730f, 48.765838f,39.768274f, 48.842602f,39.800105f,
                    48.793034f,39.975528f, 48.870137f,40.080107f, 48.915888f,40.035112f, 48.868206f,39.993232f, 48.895836f,39.924972f,
                    48.903129f,39.839405f, 48.886460f,39.826994f, 48.920686f,39.776504f, 48.985943f,39.752947f, 48.975715f,39.726482f,
                    49.000885f,39.663700f, 49.050480f,39.693157f, 49.056400f,39.938050f, 49.179759f,40.031113f, 49.186987f,40.077370f,
                    49.239839f,40.137254f, 49.249899f,40.221282f, 49.281223f,40.185930f, 49.346472f,40.194611f, 49.453605f,40.029344f,
                    49.520718f,40.039205f, 49.540031f,40.091620f, 49.540031f,40.227580f, 48.144930f,40.227580f);
            poly[1602] = new TzPolygon(50.115373f,37.711604f, 50.078430f,37.754860f, 50.084090f,37.796920f, 50.033800f,37.926520f, 49.932944f,38.043720f,
                    49.900151f,38.032974f, 49.942388f,38.124554f, 49.924620f,38.132170f, 49.979138f,38.221848f, 50.079996f,38.178230f,
                    50.088189f,38.314179f, 50.006911f,38.350535f, 49.981774f,38.416295f, 50.001350f,38.434120f, 49.995340f,38.469310f,
                    49.963240f,38.488710f, 49.977490f,38.582610f, 49.955860f,38.647500f, 50.007700f,38.686980f, 49.983500f,38.718050f,
                    49.934926f,38.693973f, 49.878373f,38.790971f, 49.869347f,38.901209f, 49.796833f,38.930691f, 49.815629f,39.066840f,
                    49.888802f,39.179943f, 49.755360f,39.285220f, 49.738540f,39.378780f, 49.760000f,39.443660f, 49.733730f,39.610520f,
                    49.718280f,39.591290f, 49.616660f,39.657900f, 49.597430f,39.750250f, 49.557950f,39.806040f, 49.558300f,39.891180f,
                    49.597090f,39.952120f, 49.617102f,40.135392f, 49.568770f,40.169620f, 49.540031f,40.091620f, 49.540031f,37.711604f);
            poly[1603] = new TzPolygon(51.054917f,35.195628f, 51.046731f,35.209859f, 51.078738f,35.304382f, 51.048040f,35.406019f, 51.008771f,35.374721f,
                    51.013712f,35.322969f, 50.973302f,35.352093f, 50.946752f,35.325686f, 50.935131f,35.352758f, 50.935131f,35.195628f);
            poly[1604] = new TzPolygon(53.725332f,14.272899f, 53.772292f,14.283610f, 53.911975f,14.185316f, 53.927739f,14.226073f, 53.988478f,14.242120f,
                    54.126897f,14.201342f, 54.152844f,14.394846f, 54.331540f,15.164534f, 54.399122f,15.553064f, 53.725332f,15.553064f);
            poly[1605] = new TzPolygon(54.399122f,8.113125f, 54.601573f,7.964576f, 54.698699f,7.938049f, 54.920829f,7.947187f, 55.099161f,8.044381f,
                    55.064762f,8.290037f, 55.085010f,8.318650f, 55.054718f,8.472381f, 55.000013f,8.501565f, 54.992817f,8.557248f,
                    54.920839f,8.555431f, 54.892750f,8.727911f, 54.902549f,8.947878f, 54.871978f,9.048087f, 54.873010f,9.143029f,
                    54.849949f,9.240340f, 54.809680f,9.250108f, 54.801675f,9.294939f, 54.800247f,9.343714f, 54.839188f,9.382835f,
                    54.841226f,9.497759f, 54.886994f,9.591819f, 54.879789f,9.628013f, 54.854517f,9.604632f, 54.823311f,9.739948f,
                    54.841796f,9.894307f, 54.766084f,10.051551f, 54.738185f,10.169379f, 54.593182f,10.338823f, 54.520681f,10.592155f,
                    54.514292f,10.754655f, 54.547348f,10.819932f, 54.577071f,11.141320f, 54.529570f,11.311042f, 54.399122f,11.529757f);
            poly[1606] = new TzPolygon(54.541309f,11.529757f, 55.099161f,11.529757f, 55.099161f,12.854608f, 54.960148f,12.905830f, 54.855604f,12.837837f,
                    54.626667f,12.240000f, 54.468333f,12.145000f, 54.451667f,11.795000f);
            poly[1607] = new TzPolygon(62.278222f,10.246714f, 58.771697f,10.246714f, 58.747919f,10.073833f, 58.672279f,9.788358f, 58.169217f,8.930945f,
                    57.944172f,8.466337f, 57.781482f,7.785412f, 57.759005f,7.557423f, 57.763182f,7.163854f, 57.790587f,6.911183f,
                    57.878010f,6.502065f, 57.935701f,6.343954f, 58.279790f,5.610457f, 58.428829f,5.362522f, 58.599257f,5.179829f,
                    58.923149f,5.005936f, 58.969021f,4.940364f, 62.278222f,4.940364f);
            poly[1608] = new TzPolygon(58.688691f,10.607329f, 58.688691f,15.553064f, 55.767154f,15.553064f, 55.782806f,15.491591f, 55.889083f,15.298843f,
                    55.898157f,15.152973f, 55.817805f,15.002583f, 55.755712f,14.591441f, 55.593614f,14.713306f, 55.467357f,14.698417f,
                    55.184507f,14.289427f, 55.177704f,14.012884f, 55.216535f,13.791729f, 55.133119f,13.366489f, 55.167829f,13.013009f,
                    55.134990f,12.876107f, 55.250000f,12.677222f, 55.431722f,12.610583f, 55.643295f,12.895874f, 55.827194f,12.708611f,
                    55.926465f,12.652354f, 56.057120f,12.642107f, 56.216361f,12.363333f, 56.303917f,12.087750f, 56.637041f,12.299621f,
                    56.812974f,12.046213f, 56.957378f,11.926535f, 57.152065f,11.635995f, 57.452289f,11.406369f, 57.700257f,11.160502f,
                    58.257843f,10.845084f, 58.486560f,10.647139f);
            poly[1609] = new TzPolygon(62.278222f,12.291750f, 62.267459f,12.299349f, 61.723818f,12.137666f, 61.562981f,12.419610f, 61.568747f,12.569326f,
                    61.356496f,12.870855f, 61.059536f,12.681402f, 61.050730f,12.447622f, 61.013078f,12.223992f, 60.890172f,12.332790f,
                    60.733887f,12.395371f, 60.512742f,12.606883f, 60.405896f,12.606041f, 60.323653f,12.498796f, 60.193389f,12.541886f,
                    60.039177f,12.448559f, 59.889805f,12.174293f, 59.900719f,11.985176f, 59.841231f,11.839761f, 59.794000f,11.926022f,
                    59.700461f,11.946005f, 59.693208f,11.889217f, 59.648291f,11.855614f, 59.608781f,11.697964f, 59.241607f,11.829796f,
                    59.207250f,11.783257f, 59.087994f,11.776226f, 59.033676f,11.710516f, 58.906233f,11.652003f, 58.898932f,11.553399f,
                    58.877418f,11.537413f, 58.889183f,11.455813f, 58.991152f,11.464598f, 59.114979f,11.339912f, 59.079257f,11.153506f,
                    58.977394f,11.066417f, 58.892276f,10.638924f, 58.760960f,10.593095f, 58.775026f,10.270920f, 58.771697f,10.246714f,
                    62.278222f,10.246714f);
            poly[1610] = new TzPolygon(62.278222f,12.291750f, 62.611919f,12.056144f, 62.747926f,12.136374f, 62.902566f,12.074707f, 63.000335f,12.218233f,
                    63.269211f,11.974581f, 63.478591f,12.212878f, 63.593945f,12.149771f, 63.671973f,12.299463f, 63.974222f,12.683568f,
                    64.057936f,12.926685f, 64.095367f,13.211110f, 64.007970f,13.967527f, 64.195093f,14.157102f, 64.462483f,14.113884f,
                    64.580341f,13.654260f, 65.118915f,14.325986f, 65.247620f,14.378798f, 65.309717f,14.506854f, 65.521297f,14.498773f,
                    65.700744f,14.541454f, 65.811807f,14.625478f, 66.132578f,14.516290f, 66.153557f,15.035683f, 66.282459f,15.484732f,
                    66.484305f,15.377227f, 66.563551f,15.553064f, 62.278222f,15.553064f);
            poly[1611] = new TzPolygon(56.375174f,21.914593f, 56.371620f,21.835662f, 56.313729f,21.725038f, 56.324548f,21.602943f, 56.294841f,21.499332f,
                    56.248679f,21.452555f, 56.218470f,21.329391f, 56.162330f,21.230796f, 56.076723f,21.201755f, 56.045417f,20.709717f,
                    56.247689f,20.671541f, 56.450421f,20.685268f, 56.450421f,21.914593f);
            poly[1612] = new TzPolygon(55.081475f,21.914593f, 55.133053f,21.722599f, 55.180811f,21.649195f, 55.198128f,21.570132f, 55.186820f,21.501512f,
                    55.293700f,21.384371f, 55.245006f,21.270983f, 55.256388f,21.098362f, 55.280965f,20.954949f, 55.384000f,20.653783f,
                    55.564933f,20.748517f, 55.915567f,20.689350f, 56.045417f,20.709717f, 56.076723f,21.201755f, 56.162330f,21.230796f,
                    56.316851f,21.563311f, 56.313717f,21.724985f, 56.371620f,21.835662f, 56.374587f,21.914593f);
            poly[1613] = new TzPolygon(54.866931f,16.993665f, 54.920782f,17.146934f, 55.028307f,17.932368f, 55.033696f,18.276214f, 55.005017f,18.527130f,
                    54.936666f,18.842424f, 54.823007f,19.091411f, 54.693390f,19.196960f, 54.646438f,19.287624f, 54.651736f,19.353296f,
                    54.453269f,19.647215f, 54.318215f,21.446113f, 54.332149f,21.914593f, 53.725332f,21.914593f, 53.725332f,16.993665f);
            poly[1614] = new TzPolygon(55.081475f,21.914593f, 55.084098f,22.032408f, 55.042544f,22.036913f, 55.024998f,22.075815f, 55.055639f,22.158566f,
                    55.064764f,22.291360f, 55.044526f,22.470597f, 55.070243f,22.589236f, 54.969896f,22.644063f, 54.987501f,22.678072f,
                    54.935477f,22.766351f, 54.918606f,22.754486f, 54.897382f,22.846313f, 54.813500f,22.886684f, 54.766847f,22.844099f,
                    54.731498f,22.743582f, 54.630895f,22.748774f, 54.585972f,22.683859f, 54.563868f,22.713352f, 54.533030f,22.680588f,
                    54.453614f,22.701183f, 54.363325f,22.792006f, 54.333917f,21.914593f);
            poly[1615] = new TzPolygon(54.332149f,21.914593f, 54.353770f,22.641545f, 54.363325f,22.792006f, 54.406481f,22.836302f, 54.409528f,22.883406f,
                    54.382796f,23.010215f, 54.361899f,22.993913f, 54.340959f,23.063165f, 54.312436f,23.050971f, 54.298454f,23.092169f,
                    54.313240f,23.144825f, 53.725332f,23.144825f, 53.725332f,21.914593f);
            poly[1616] = new TzPolygon(53.725332f,23.568106f, 53.767780f,23.549050f, 53.956268f,23.514978f, 53.924715f,23.610364f, 53.939450f,23.709766f,
                    53.898917f,23.778119f, 53.911082f,23.818069f, 53.935435f,23.798596f, 53.955968f,23.842027f, 53.943918f,23.886888f,
                    53.969684f,23.913018f, 53.923947f,23.982893f, 53.970019f,24.201611f, 53.896789f,24.352059f, 53.897952f,24.375056f,
                    53.725332f,24.375056f);
            poly[1617] = new TzPolygon(54.313240f,23.144825f, 54.314355f,23.148796f, 54.260910f,23.233884f, 54.251724f,23.337519f, 54.163416f,23.475521f,
                    54.065780f,23.528601f, 53.998015f,23.480697f, 53.851440f,23.551739f, 53.767780f,23.549050f, 53.725332f,23.570543f,
                    53.725332f,23.144825f);
            poly[1618] = new TzPolygon(56.374587f,21.914593f, 56.376652f,21.969540f, 56.424281f,22.015300f, 56.432437f,22.129696f, 56.399761f,22.243398f,
                    56.410037f,22.423122f, 56.390542f,22.580239f, 56.351588f,22.680003f, 56.373102f,22.730062f, 56.374160f,22.899698f,
                    56.413891f,22.969172f, 56.406424f,23.002250f, 56.331154f,23.026941f, 56.304638f,23.093250f, 56.337416f,23.184110f,
                    56.366887f,23.170412f, 56.383054f,23.306452f, 56.332100f,23.544936f, 56.373324f,23.764795f, 56.323808f,23.766690f,
                    56.342111f,23.803608f, 56.329762f,24.018997f, 56.279661f,24.046005f, 56.277265f,24.097829f, 56.248898f,24.121463f,
                    56.285602f,24.290133f, 56.300637f,24.285742f, 56.278108f,24.375056f, 55.087877f,24.375056f, 55.087877f,21.914593f);
            poly[1619] = new TzPolygon(55.087877f,24.375056f, 55.087877f,26.255842f, 55.077595f,26.271233f, 54.997414f,26.208513f, 54.988566f,26.115941f,
                    54.941609f,26.061912f, 54.957828f,25.983952f, 54.927600f,25.857818f, 54.815064f,25.742983f, 54.682823f,25.730206f,
                    54.576895f,25.762555f, 54.460828f,25.602233f, 54.423516f,25.632960f, 54.338342f,25.532031f, 54.314995f,25.552332f,
                    54.319202f,25.684293f, 54.280533f,25.698712f, 54.238010f,25.784685f, 54.221919f,25.750134f, 54.154614f,25.785372f,
                    54.168932f,25.703630f, 54.127654f,25.638956f, 54.156032f,25.533872f, 54.186337f,25.516336f, 54.199215f,25.562336f,
                    54.227730f,25.547368f, 54.232182f,25.590046f, 54.308451f,25.512852f, 54.262893f,25.346167f, 54.275314f,25.270028f,
                    54.133653f,25.070634f, 54.144231f,24.992929f, 54.172058f,24.957373f, 54.144862f,24.813380f, 54.132501f,24.831230f,
                    54.103855f,24.776564f, 54.043439f,24.822569f, 54.034894f,24.871140f, 53.997722f,24.819568f, 54.000241f,24.757127f,
                    53.965992f,24.738840f, 53.962109f,24.684591f, 54.017142f,24.697865f, 54.010505f,24.625907f, 53.966421f,24.517054f,
                    53.904167f,24.447985f, 53.898558f,24.375056f);
            poly[1620] = new TzPolygon(56.278108f,24.375056f, 56.258158f,24.454150f, 56.288244f,24.579504f, 56.375577f,24.628762f, 56.421858f,24.806360f,
                    56.415740f,24.861585f, 56.450421f,24.885211f, 56.365285f,24.969491f, 56.310244f,24.973320f, 56.265697f,25.056594f,
                    56.186044f,25.092035f, 56.173925f,25.166406f, 56.192225f,25.233740f, 56.144918f,25.314861f, 56.144542f,25.504736f,
                    56.165407f,25.536050f, 56.134404f,25.601989f, 56.135098f,25.605288f, 55.087877f,25.605288f, 55.087877f,24.375056f);
            poly[1621] = new TzPolygon(55.087877f,26.255842f, 55.105605f,26.229304f, 55.121354f,26.260800f, 55.150573f,26.354683f, 55.128562f,26.461119f,
                    55.160963f,26.516942f, 55.143235f,26.539978f, 55.155974f,26.668688f, 55.171935f,26.705838f, 55.197382f,26.674918f,
                    55.215621f,26.729708f, 55.245157f,26.731415f, 55.285511f,26.835475f, 55.321203f,26.791969f, 55.338933f,26.664323f,
                    55.319264f,26.563708f, 55.347935f,26.439929f, 55.388833f,26.554148f, 55.509923f,26.524219f, 55.572312f,26.627855f,
                    55.704284f,26.644434f, 55.677791f,26.783964f, 55.699232f,26.835520f, 55.087877f,26.835520f);
            poly[1622] = new TzPolygon(56.135098f,25.605288f, 56.450421f,25.605288f, 56.450421f,26.835520f, 55.699232f,26.835520f, 55.677791f,26.783964f,
                    55.707504f,26.652862f, 55.674651f,26.597454f, 55.709396f,26.375627f, 55.954231f,26.045951f, 55.999740f,25.860356f,
                    56.054775f,25.820083f, 56.086457f,25.687857f, 56.149367f,25.673123f);
            poly[1623] = new TzPolygon(55.763161f,29.599322f, 55.701576f,29.515286f, 55.767973f,29.358618f, 55.871884f,29.426990f, 55.902240f,29.394335f,
                    55.918126f,29.479532f, 55.968931f,29.422613f, 55.987883f,29.216147f, 56.026700f,29.155782f, 56.016010f,29.113988f,
                    56.034096f,29.088155f, 55.988538f,28.858073f, 55.953880f,28.849022f, 55.967007f,28.733827f, 56.074558f,28.636204f,
                    56.104634f,28.681272f, 56.115986f,28.548342f, 56.086310f,28.419287f, 56.111237f,28.378370f, 56.060224f,28.376190f,
                    56.058170f,28.320611f, 56.143176f,28.157427f, 56.230396f,28.185515f, 56.278858f,28.241480f, 56.379571f,28.163165f,
                    56.448566f,28.192765f, 56.450421f,28.190104f, 56.450421f,29.599322f);
            poly[1624] = new TzPolygon(56.450421f,28.190104f, 56.448566f,28.192765f, 56.379571f,28.163165f, 56.278554f,28.241490f, 56.179478f,28.178722f,
                    56.118780f,28.044487f, 56.120361f,27.971930f, 56.048614f,27.905145f, 56.035464f,27.806407f, 56.021789f,27.833020f,
                    55.981304f,27.801570f, 55.929566f,27.652998f, 55.786943f,27.615558f, 55.814649f,27.367060f, 55.785221f,27.287367f,
                    55.850857f,27.125320f, 55.788050f,26.920555f, 55.713755f,26.870441f, 55.699232f,26.835520f, 56.450421f,26.835520f);
            poly[1625] = new TzPolygon(54.713322f,30.981224f, 54.712908f,30.977807f, 54.743230f,30.953384f, 54.805040f,30.754510f, 54.879799f,30.821803f,
                    54.940220f,30.818710f, 54.958466f,30.943755f, 54.985487f,30.962719f, 55.018285f,30.908418f, 55.036626f,30.937575f,
                    55.032669f,30.981224f);
            poly[1626] = new TzPolygon(55.173701f,30.981224f, 55.200660f,30.923523f, 55.280540f,30.875620f, 55.282000f,30.819830f, 55.332491f,30.828039f,
                    55.395810f,30.933550f, 55.476368f,30.893033f, 55.497090f,30.958620f, 55.522070f,30.913900f, 55.542410f,30.955010f,
                    55.622625f,30.925132f, 55.628529f,30.838451f, 55.598922f,30.832646f, 55.590351f,30.764773f, 55.661968f,30.732269f,
                    55.636127f,30.672668f, 55.730567f,30.629037f, 55.752680f,30.526279f, 55.799314f,30.511727f, 55.809042f,30.366681f,
                    55.835254f,30.339480f, 55.831639f,30.286730f, 55.870136f,30.277085f, 55.862484f,30.180462f, 55.878997f,30.165639f,
                    55.832055f,30.128889f, 55.870351f,29.997088f, 55.851727f,29.940932f, 55.862680f,29.894984f, 55.783420f,29.806340f,
                    55.778880f,29.769170f, 55.802254f,29.745292f, 55.780255f,29.622649f, 55.763161f,29.599322f, 56.450421f,29.599322f,
                    56.450421f,30.981224f);
            poly[1627] = new TzPolygon(55.173701f,30.981224f, 55.171782f,30.985332f, 55.076850f,30.990302f, 55.062308f,31.027888f, 55.029480f,31.016400f,
                    55.032669f,30.981224f);
            poly[1628] = new TzPolygon(54.713322f,30.981224f, 54.717068f,31.012134f, 54.672228f,30.991273f, 54.659040f,31.197829f, 54.619907f,31.204353f,
                    54.508504f,31.085659f, 54.466270f,31.232590f, 54.380183f,31.252541f, 54.340587f,31.322720f, 54.319670f,31.285800f,
                    54.311940f,31.320220f, 54.244140f,31.317820f, 54.222330f,31.410600f, 54.210060f,31.380470f, 54.185545f,31.490592f,
                    54.158900f,31.495140f, 54.137110f,31.563460f, 54.142019f,31.655567f, 54.103290f,31.675730f, 54.112755f,31.774293f,
                    54.078444f,31.753364f, 54.096842f,31.823476f, 54.086818f,31.894789f, 54.005657f,31.853966f, 53.966189f,31.891877f,
                    53.950093f,31.844729f, 53.917098f,31.856831f, 53.875540f,31.798578f, 53.865501f,31.838343f, 53.832602f,31.756575f,
                    53.796162f,31.761220f, 53.806531f,31.811407f, 53.774532f,31.898170f, 53.818492f,32.126841f, 53.799567f,32.208050f,
                    53.765980f,32.229704f, 53.775930f,32.284844f, 53.758499f,32.272356f, 53.750575f,32.343873f, 53.725332f,32.363125f,
                    53.725332f,30.981224f);
            poly[1629] = new TzPolygon(53.725332f,32.405016f, 53.737653f,32.460683f, 53.725332f,32.470617f);
            poly[1630] = new TzPolygon(57.972246f,25.570846f, 57.974815f,25.485853f, 58.017058f,25.448598f, 58.031399f,25.363862f, 58.081450f,25.295673f,
                    58.060086f,25.264866f, 57.993120f,25.301411f, 58.015418f,25.230458f, 58.083281f,25.206527f, 58.077826f,25.105845f,
                    58.017856f,25.020415f, 57.971935f,24.832330f, 57.990518f,24.808296f, 57.982038f,24.742142f, 57.946416f,24.692095f,
                    57.962051f,24.585094f, 57.946930f,24.531021f, 57.924954f,24.462262f, 57.880220f,24.459801f, 57.864544f,24.411325f,
                    57.917217f,24.261117f, 57.899167f,24.209450f, 57.899167f,23.601117f, 57.782900f,23.648500f, 57.669550f,23.582333f,
                    57.593833f,23.406017f, 57.586383f,23.180833f, 57.940833f,22.707500f, 57.927400f,22.583600f, 57.779167f,22.143333f,
                    57.749450f,21.916117f, 57.786666f,21.716666f, 57.856666f,21.646666f, 58.301505f,21.382607f, 58.599619f,21.454526f,
                    58.599619f,25.570846f);
            poly[1631] = new TzPolygon(57.972246f,25.570846f, 57.971954f,25.580502f, 57.944206f,25.580461f, 57.904362f,25.679638f, 57.924156f,25.737463f,
                    57.847054f,25.888170f, 57.848432f,26.056459f, 57.768621f,26.024105f, 57.714995f,26.205740f, 57.687667f,26.179311f,
                    57.595305f,26.278032f, 57.575559f,26.469492f, 57.516248f,26.524905f, 57.539879f,26.584882f, 57.509354f,26.616937f,
                    57.566654f,26.675901f, 57.569274f,26.730801f, 57.587720f,26.737814f, 57.559964f,26.776604f, 57.580586f,26.778517f,
                    57.582477f,26.792240f, 56.450421f,26.792240f, 56.450421f,25.570846f);
            poly[1632] = new TzPolygon(57.525020f,26.792240f, 57.525020f,27.315407f, 57.517719f,27.350636f, 57.525020f,27.360445f, 57.525020f,27.551860f,
                    57.426961f,27.517335f, 57.395023f,27.671273f, 57.289795f,27.870157f, 57.143265f,27.818273f, 57.097531f,27.715621f,
                    57.085614f,27.768779f, 57.006294f,27.715398f, 57.005217f,27.769615f, 56.920076f,27.737443f, 56.895748f,27.672161f,
                    56.834345f,27.659344f, 56.880125f,27.847328f, 56.820600f,27.901642f, 56.836707f,27.968106f, 56.811694f,27.976441f,
                    56.752133f,27.898730f, 56.672437f,28.012734f, 56.450421f,28.013635f, 56.450421f,26.792240f);
            poly[1633] = new TzPolygon(57.525020f,27.346745f, 57.517719f,27.350636f, 57.525020f,27.315407f);
            poly[1634] = new TzPolygon(57.525020f,28.013635f, 57.525020f,27.551860f, 57.537774f,27.556350f, 57.535426f,27.374426f, 57.525020f,27.360632f,
                    57.525020f,27.347822f, 57.579984f,27.317455f, 57.612574f,27.404757f, 57.668657f,27.376315f, 57.700476f,27.411090f,
                    57.722882f,27.492572f, 57.709414f,27.525589f, 57.733337f,27.545464f, 57.788902f,27.494324f, 57.794170f,27.536229f,
                    57.833348f,27.549218f, 57.848448f,27.708050f, 57.833464f,27.776320f, 57.890529f,27.819106f, 57.900129f,27.705432f,
                    57.920008f,27.718227f, 57.923713f,27.678910f, 57.955356f,27.656435f, 57.998990f,27.698569f, 58.019894f,27.649074f,
                    57.995409f,27.653933f, 58.005189f,27.621281f, 58.054064f,27.606539f, 58.099936f,27.635985f, 58.224368f,27.491262f,
                    58.303687f,27.486844f, 58.366184f,27.553190f, 58.599619f,27.444449f, 58.599619f,28.013635f);
            poly[1635] = new TzPolygon(57.582477f,26.792240f, 57.592042f,26.861667f, 57.633113f,26.906869f, 57.602782f,26.945588f, 57.604517f,27.031447f,
                    57.580659f,27.046936f, 57.525020f,27.315407f, 57.525020f,26.792240f);
            poly[1636] = new TzPolygon(57.525020f,27.360445f, 57.535426f,27.374426f, 57.537774f,27.556350f, 57.525020f,27.551860f);
            poly[1637] = new TzPolygon(56.670011f,28.013635f, 56.590376f,28.043213f, 56.571921f,28.143374f, 56.516885f,28.094768f, 56.450421f,28.190104f,
                    56.450421f,28.013635f);
            poly[1638] = new TzPolygon(63.686411f,21.721693f, 59.485031f,21.721693f, 59.475662f,21.496401f, 59.499216f,21.179689f, 59.761916f,21.262782f,
                    59.885563f,21.345656f, 59.950161f,21.171364f, 60.077451f,21.114942f, 60.123925f,21.023830f, 60.201892f,21.084504f,
                    60.547408f,21.143822f, 60.712881f,20.969962f, 60.723090f,20.730003f, 60.876650f,20.377537f, 61.126908f,20.771450f,
                    61.646249f,20.903203f, 62.366138f,20.664890f, 63.164858f,20.165812f, 63.331882f,20.401001f, 63.482870f,20.696310f,
                    63.519395f,20.938718f, 63.667100f,21.509179f);
            poly[1639] = new TzPolygon(60.876650f,20.377537f, 60.723090f,20.730003f, 60.712881f,20.969962f, 60.638750f,21.061794f, 60.498668f,21.151336f,
                    60.201892f,21.084504f, 60.123925f,21.023830f, 60.077451f,21.114942f, 59.950161f,21.171364f, 59.885563f,21.345656f,
                    59.761916f,21.262782f, 59.499216f,21.179689f, 59.532482f,20.760866f, 59.454158f,20.347150f, 59.595063f,19.940644f,
                    60.191690f,19.083210f, 60.611510f,19.220211f, 60.689655f,19.594056f, 60.727555f,20.025166f);
            poly[1640] = new TzPolygon(58.599619f,21.454526f, 58.688333f,21.606666f, 58.831666f,21.696666f, 58.918333f,21.651666f, 58.967175f,21.721693f,
                    58.599619f,21.721693f);
            poly[1641] = new TzPolygon(58.599619f,27.444449f, 58.787261f,27.357040f, 58.972752f,27.731090f, 59.219552f,27.890322f, 58.599619f,27.890322f);
            poly[1642] = new TzPolygon(59.563457f,27.890322f, 59.582156f,27.857208f, 59.631666f,26.915000f, 59.938375f,26.440169f, 60.115259f,26.872458f,
                    60.223534f,27.455093f, 60.257311f,27.514177f, 60.391389f,27.725000f, 60.433333f,27.686111f, 60.450919f,27.747136f,
                    60.533333f,27.773611f, 60.561438f,27.847392f, 60.604559f,27.873414f, 60.613713f,27.890322f);
            poly[1643] = new TzPolygon(64.992249f,22.306353f, 64.955472f,22.136349f, 64.887774f,21.910238f, 64.836361f,21.825056f, 64.499135f,22.078886f,
                    64.398898f,22.077380f, 64.227535f,21.912239f, 64.139357f,21.721693f, 64.992249f,21.721693f);
            poly[1644] = new TzPolygon(58.967175f,21.721693f, 59.056666f,21.850000f, 59.245000f,22.308333f, 59.288665f,22.496107f, 59.291666f,22.733333f,
                    59.483333f,23.191666f, 59.481666f,23.521666f, 59.703333f,24.481666f, 59.826666f,25.578333f, 59.815000f,26.021666f,
                    59.900000f,26.153333f, 59.938375f,26.440169f, 59.631666f,26.915000f, 59.582156f,27.857208f, 59.562278f,27.890322f,
                    59.219045f,27.890322f, 58.978456f,27.738636f, 58.787261f,27.357040f, 58.599619f,27.444449f, 58.599619f,21.721693f);
            poly[1645] = new TzPolygon(66.563551f,15.553064f, 66.594335f,15.621369f, 66.912442f,16.038776f, 67.045470f,16.387716f, 67.205008f,16.404086f,
                    67.435278f,16.089830f, 67.519158f,16.158002f, 67.534025f,16.407469f, 67.594451f,16.494807f, 67.914210f,16.738120f,
                    68.050437f,17.180497f, 68.118815f,17.281525f, 67.969343f,17.899800f, 68.198789f,18.151355f, 68.536515f,18.125924f,
                    68.581877f,18.405690f, 68.506939f,18.621231f, 68.507385f,18.637379f, 64.992249f,18.637379f, 64.992249f,15.553064f);
            poly[1646] = new TzPolygon(68.590379f,21.721693f, 68.590519f,21.717743f, 68.665006f,21.616755f, 68.691352f,21.429869f, 68.764790f,21.390420f,
                    68.762748f,21.299030f, 68.813857f,21.234919f, 68.896741f,20.996792f, 68.893529f,20.878033f, 68.936564f,20.844191f,
                    68.968824f,20.911646f, 69.020279f,20.807523f, 69.059970f,20.548642f, 69.119791f,20.717321f, 69.036290f,21.057543f,
                    69.103929f,21.108674f, 69.191927f,20.987574f, 69.222338f,21.003312f, 69.311884f,21.278820f, 69.276588f,21.627086f,
                    69.221366f,21.721693f);
            poly[1647] = new TzPolygon(70.448505f,18.637379f, 70.487198f,18.847174f, 70.856580f,21.721693f, 69.221366f,21.721693f, 69.276588f,21.627086f,
                    69.311884f,21.278820f, 69.222338f,21.003312f, 69.191927f,20.987574f, 69.103929f,21.108674f, 69.036290f,21.057543f,
                    69.119791f,20.717321f, 69.060077f,20.552326f, 69.045758f,20.060047f, 68.926150f,20.306590f, 68.802314f,20.335873f,
                    68.665923f,20.202897f, 68.557942f,19.937504f, 68.490858f,20.226654f, 68.356014f,19.921397f, 68.516952f,18.983818f,
                    68.507385f,18.637379f);
            poly[1648] = new TzPolygon(64.992249f,24.031276f, 65.080166f,24.083868f, 65.292478f,24.154506f, 65.862572f,24.152978f, 66.076719f,23.938363f,
                    66.159785f,23.920810f, 66.195135f,23.728084f, 66.301390f,23.645620f, 66.387386f,23.689233f, 66.455187f,23.650365f,
                    66.559550f,23.860535f, 66.763509f,23.880337f, 66.794955f,23.912447f, 66.785730f,23.981595f, 66.822049f,23.995663f,
                    67.170385f,23.552377f, 67.208206f,23.596079f, 67.224994f,23.548030f, 67.260673f,23.563783f, 67.282764f,23.721284f,
                    67.336949f,23.774237f, 67.385898f,23.717059f, 67.430318f,23.762715f, 67.460986f,23.544847f, 67.446389f,23.493884f,
                    67.484277f,23.394423f, 67.619676f,23.559287f, 67.666494f,23.491773f, 67.842778f,23.479069f, 67.884335f,23.517192f,
                    67.917094f,23.643732f, 67.960709f,23.651197f, 68.047318f,23.389595f, 68.148377f,23.307762f, 68.136701f,23.154507f,
                    68.188564f,23.153506f, 68.188564f,27.890322f, 64.992249f,27.890322f);
            poly[1649] = new TzPolygon(68.620838f,24.806007f, 68.636235f,24.783425f, 68.681902f,24.608388f, 68.727132f,24.250965f, 68.753591f,24.152962f,
                    68.789710f,24.158551f, 68.779967f,24.075592f, 68.827143f,23.983331f, 68.836519f,23.871461f, 68.818851f,23.775392f,
                    68.705521f,23.673520f, 68.692164f,23.440636f, 68.628519f,23.167582f, 68.689344f,23.045952f, 68.687548f,22.800824f,
                    68.744513f,22.535389f, 68.716667f,22.374522f, 68.827226f,22.340781f, 68.956324f,22.175762f, 69.221366f,21.721693f,
                    70.856580f,21.721693f, 71.282834f,23.748759f, 71.314085f,24.629253f, 71.325963f,24.806007f);
            poly[1650] = new TzPolygon(68.590379f,21.721693f, 68.584405f,21.889869f, 68.479576f,22.043957f, 68.481676f,22.348039f, 68.445278f,22.344191f,
                    68.466620f,22.411613f, 68.422114f,22.572778f, 68.434213f,22.638805f, 68.399832f,22.687743f, 68.386687f,22.833331f,
                    68.333733f,22.916959f, 68.305834f,23.060708f, 68.233381f,23.152641f, 68.188564f,23.153506f, 68.188564f,21.721693f);
            poly[1651] = new TzPolygon(68.620838f,24.806007f, 68.554592f,24.903166f, 68.605247f,24.916923f, 68.639588f,25.116388f, 68.799893f,25.157126f,
                    68.890799f,25.398001f, 68.905063f,25.481411f, 68.892644f,25.627092f, 69.013481f,25.774641f, 69.250468f,25.701685f,
                    69.393376f,25.846516f, 69.420930f,25.793015f, 69.475811f,25.864617f, 69.550992f,25.841436f, 69.610225f,25.976040f,
                    69.669684f,25.897476f, 69.722856f,26.007140f, 69.738680f,26.135756f, 69.816681f,26.243597f, 69.854159f,26.383589f,
                    69.940196f,26.466630f, 69.960135f,26.851289f, 69.933415f,26.878297f, 69.938486f,26.969723f, 69.910559f,27.039760f,
                    69.953460f,27.296194f, 69.979223f,27.277704f, 70.022788f,27.524123f, 70.067243f,27.576902f, 70.064288f,27.744113f,
                    70.083646f,27.890322f, 68.188564f,27.890322f, 68.188564f,24.806007f);
            poly[1652] = new TzPolygon(61.779734f,27.890322f, 61.779734f,30.047691f, 61.765001f,30.038728f, 61.655328f,29.818587f, 61.573704f,29.740299f,
                    61.500465f,29.607330f, 61.491569f,29.496460f, 61.461339f,29.503072f, 61.268010f,29.239990f, 61.151620f,28.956774f,
                    61.121647f,28.818984f, 61.044595f,28.713799f, 60.949531f,28.655473f, 60.957137f,28.524670f, 60.613713f,27.890322f);
            poly[1653] = new TzPolygon(59.562278f,27.890322f, 59.370368f,28.210018f, 59.290941f,28.129532f, 59.287483f,28.026407f, 59.241265f,27.904331f,
                    59.219045f,27.890322f);
            poly[1654] = new TzPolygon(61.779734f,30.047691f, 61.818684f,30.071388f, 62.032287f,30.444682f, 62.208588f,30.656406f, 62.208906f,30.720412f,
                    62.270692f,30.810959f, 62.312265f,30.955169f, 62.332999f,30.942443f, 62.498296f,31.221835f, 62.649707f,31.373025f,
                    62.785375f,31.439061f, 62.908709f,31.586707f, 62.996249f,31.502133f, 63.006058f,31.448759f, 63.024251f,31.463000f,
                    63.107626f,31.272119f, 63.219220f,31.237532f, 63.307838f,30.979190f, 63.355440f,30.934418f, 63.405271f,30.787705f,
                    63.466696f,30.483994f, 63.545493f,30.384526f, 63.583940f,30.258254f, 63.757168f,29.971890f, 63.822003f,30.260416f,
                    63.909533f,30.320908f, 64.048877f,30.528017f, 64.132244f,30.553427f, 64.204432f,30.466400f, 64.221691f,30.509599f,
                    64.262339f,30.482440f, 64.269057f,30.388285f, 64.299679f,30.366928f, 64.402012f,30.044893f, 64.587585f,29.989423f,
                    64.634717f,30.130150f, 64.741186f,30.041398f, 64.773986f,30.086510f, 64.792890f,30.042936f, 64.789783f,29.739631f,
                    64.917437f,29.615244f, 64.959848f,29.618718f, 64.959848f,34.058951f, 61.779734f,34.058951f);
            poly[1655] = new TzPolygon(64.959848f,29.618718f, 65.060599f,29.626970f, 65.105149f,29.896873f, 65.144459f,29.819345f, 65.206306f,29.885765f,
                    65.231302f,29.634791f, 65.259944f,29.601847f, 65.347417f,29.746577f, 65.472637f,29.733121f, 65.560470f,29.863751f,
                    65.637045f,29.722433f, 65.696527f,30.017092f, 65.668688f,30.138463f, 65.702350f,30.133434f, 66.126249f,29.923935f,
                    66.268490f,29.696645f, 66.641083f,29.357648f, 66.790069f,29.105562f, 66.925472f,29.033124f, 66.996154f,29.073254f,
                    67.309917f,29.522710f, 67.335917f,29.644543f, 67.351549f,29.621753f, 67.522821f,29.930510f, 67.673170f,30.015667f,
                    67.802972f,29.659389f, 68.074553f,29.326989f, 68.139963f,28.960460f, 68.139963f,34.058951f, 64.959848f,34.058951f);
            poly[1656] = new TzPolygon(70.083646f,27.890322f, 70.092294f,27.955635f, 70.013971f,27.984285f, 69.920994f,28.160713f, 69.880832f,28.345269f,
                    69.849193f,28.330476f, 69.818425f,28.404225f, 69.695340f,29.133910f, 69.478323f,29.336496f, 69.224362f,28.831539f,
                    69.111156f,28.805430f, 69.051941f,28.929451f, 68.915451f,28.415778f, 68.885514f,28.468076f, 68.869367f,28.801450f,
                    68.732555f,28.707213f, 68.539795f,28.434120f, 68.196216f,28.645242f, 68.139963f,28.960460f, 68.139963f,27.890322f);
            poly[1657] = new TzPolygon(68.139963f,28.960460f, 68.196216f,28.645242f, 68.539795f,28.434120f, 68.732555f,28.707213f, 68.869367f,28.801450f,
                    68.885514f,28.468076f, 68.915451f,28.415778f, 69.051941f,28.929451f, 69.015220f,29.056700f, 69.113060f,29.242230f,
                    69.233684f,29.314093f, 69.296913f,29.290767f, 69.322219f,29.390536f, 69.318517f,29.572990f, 69.423025f,29.852189f,
                    69.405109f,29.947580f, 69.424947f,30.035163f, 69.565826f,30.188101f, 69.658111f,30.085325f, 69.669379f,30.151663f,
                    69.653127f,30.224023f, 69.540501f,30.516070f, 69.528709f,30.816412f, 69.560737f,30.938802f, 69.683539f,30.944765f,
                    69.794822f,30.817529f, 69.895875f,30.974637f, 68.139963f,30.974637f);
            poly[1658] = new TzPolygon(70.716350f,30.974637f, 70.532567f,31.586597f, 70.463227f,31.717998f, 70.388257f,31.761491f, 70.143752f,31.585495f,
                    69.979302f,31.104341f, 69.895875f,30.974637f);
            poly[1659] = new TzPolygon(72.400000f,-24.000000f, 71.570930f,-21.039035f, 70.671062f,-20.780940f, 70.474769f,-20.914264f, 70.232561f,-21.255856f,
                    70.500000f,-25.000000f);
            poly[1660] = new TzPolygon(75.805071f,-17.482364f, 75.485968f,-17.253823f, 75.240707f,-16.633531f, 75.138500f,-16.523940f, 74.988597f,-16.587803f,
                    74.910631f,-16.703745f, 74.496449f,-17.764235f, 74.174483f,-18.712394f, 73.404031f,-19.774346f, 73.037637f,-20.571758f,
                    72.862621f,-20.750653f, 73.500000f,-24.200000f);
            poly[1661] = new TzPolygon(27.433543f,-13.550846f, 27.627207f,-13.433624f, 27.657171f,-9.816326f, 27.433543f,-9.816326f);
            poly[1662] = new TzPolygon(29.911805f,-13.523581f, 29.884965f,-13.406690f, 29.810731f,-13.320981f, 29.497050f,-13.261502f, 29.388414f,-13.140543f,
                    29.275412f,-13.101258f, 29.197531f,-13.118818f, 28.917185f,-13.262568f, 28.788708f,-13.438391f, 28.528410f,-13.597171f,
                    28.323710f,-13.637972f, 28.123997f,-13.736408f, 28.046235f,-13.836170f, 27.861857f,-14.226320f, 27.839852f,-14.327305f,
                    27.861892f,-14.547528f, 27.891253f,-14.630552f, 27.957780f,-14.702784f, 28.059115f,-14.735222f, 28.230309f,-14.673274f,
                    28.454678f,-14.388998f, 28.803205f,-14.221444f, 29.116356f,-14.025826f, 29.809098f,-13.725097f, 29.884022f,-13.640181f);
            poly[1663] = new TzPolygon(27.433543f,-8.668212f, 28.667193f,-8.668749f, 28.739461f,-8.587837f, 28.807106f,-8.433772f, 28.900742f,-8.332448f,
                    29.121672f,-7.957917f, 29.183183f,-7.891299f, 29.270389f,-7.744774f, 29.298042f,-7.637286f, 29.367441f,-7.610223f,
                    29.360130f,-7.488727f, 29.388596f,-7.350889f, 29.478182f,-7.251404f, 29.522714f,-7.149831f, 29.462101f,-6.777250f,
                    29.515239f,-6.694669f, 29.529754f,-6.618740f, 29.515345f,-6.541068f, 29.565642f,-6.448508f, 29.549829f,-6.390306f,
                    29.568157f,-6.373870f, 29.582295f,-6.165324f, 29.564145f,-6.029000f, 29.607720f,-5.813675f, 29.586196f,-5.723236f,
                    29.518265f,-5.749243f, 29.541187f,-5.685828f, 29.504543f,-5.650809f, 29.478686f,-5.558330f, 29.769071f,-5.328927f,
                    29.881142f,-5.288863f, 29.932870f,-5.239381f, 30.140473f,-4.936618f, 30.157526f,-4.897429f, 27.433543f,-4.897429f);
            poly[1664] = new TzPolygon(27.657171f,-9.816326f, 27.666683f,-8.667993f, 27.433543f,-8.667759f, 27.433543f,-9.816326f);
            poly[1665] = new TzPolygon(31.376848f,-4.897429f, 31.376848f,-3.671899f, 31.342117f,-3.722566f, 31.360990f,-3.749309f, 31.292765f,-3.785554f,
                    31.263430f,-3.758794f, 31.236217f,-3.790699f, 31.179997f,-3.759310f, 31.100898f,-3.775059f, 31.125719f,-3.760258f,
                    31.117121f,-3.730511f, 31.146092f,-3.733906f, 31.154377f,-3.710543f, 31.136835f,-3.705450f, 31.176034f,-3.702060f,
                    31.151250f,-3.671551f, 31.086518f,-3.679536f, 31.081955f,-3.643864f, 31.090270f,-3.666450f, 31.099660f,-3.636583f,
                    31.111301f,-3.636938f, 31.119486f,-3.615993f, 31.058343f,-3.592180f, 31.043014f,-3.573893f, 31.063937f,-3.552388f,
                    31.038604f,-3.542002f, 30.955089f,-3.540543f, 30.865770f,-3.615723f, 30.875682f,-3.636231f, 30.851395f,-3.658447f,
                    30.744649f,-3.629587f, 30.674696f,-3.653931f, 30.590355f,-3.816799f, 30.610690f,-3.886537f, 30.585137f,-4.148332f,
                    30.536312f,-4.296337f, 30.292927f,-4.586268f, 30.157526f,-4.897429f);
            poly[1666] = new TzPolygon(31.376848f,-3.671899f, 31.393917f,-3.646997f, 31.401464f,-3.664840f, 31.633535f,-3.664666f, 31.793643f,-2.820696f,
                    31.883618f,-2.842322f, 32.028394f,-2.930556f, 32.111359f,-2.873435f, 32.112911f,-2.600034f, 32.146315f,-2.536342f,
                    32.148389f,-2.437981f, 31.376848f,-2.437981f);
            poly[1667] = new TzPolygon(35.320152f,-2.952033f, 35.288838f,-2.923102f, 35.265628f,-2.950543f, 35.288800f,-2.970202f);
            poly[1668] = new TzPolygon(35.320152f,-2.207127f, 35.047988f,-2.218368f, 34.926833f,-2.045871f, 34.935779f,-1.973387f, 34.878791f,-1.972724f,
                    34.841639f,-1.893362f, 34.806219f,-1.888732f, 34.743018f,-1.738885f, 34.616229f,-1.853826f, 34.604420f,-1.816663f,
                    34.507819f,-1.741365f, 34.490332f,-1.686778f, 34.392203f,-1.781899f, 34.306870f,-1.705332f, 34.230231f,-1.706718f,
                    34.105379f,-1.647893f, 33.869688f,-1.698747f, 33.773102f,-1.671320f, 33.740565f,-1.720946f, 33.701108f,-1.732475f,
                    33.675629f,-1.701939f, 33.680610f,-1.652748f, 33.605486f,-1.594709f, 33.529064f,-1.588157f, 33.378122f,-1.663549f,
                    33.284080f,-1.670267f, 33.145802f,-1.573337f, 33.053446f,-1.464804f, 32.975354f,-1.485929f, 32.957761f,-1.543783f,
                    32.762663f,-1.398991f, 32.513115f,-0.998429f, 32.411467f,-1.124182f, 32.402719f,-1.195686f, 32.329492f,-1.246332f,
                    32.205708f,-1.241120f, 32.167999f,-1.299721f, 32.163625f,-1.183153f, 32.111074f,-1.152361f, 32.084563f,-1.203801f,
                    32.092240f,-1.580311f, 32.164357f,-1.903399f, 32.157321f,-1.968579f, 32.182183f,-2.014916f, 32.144197f,-2.150235f,
                    32.168605f,-2.277609f, 32.151301f,-2.299930f, 32.148389f,-2.437981f, 35.320152f,-2.437981f);
            poly[1669] = new TzPolygon(35.320152f,-6.377607f, 35.823720f,-6.173587f, 35.917950f,-6.106650f, 35.917950f,-5.048803f, 35.320152f,-5.048803f);
            poly[1670] = new TzPolygon(36.050527f,-6.220891f, 36.050527f,-5.110521f, 36.047199f,-5.111910f, 36.036069f,-5.285468f, 35.935675f,-5.666515f,
                    35.964882f,-5.885446f, 35.959481f,-6.056688f, 36.040092f,-6.210947f);
            poly[1671] = new TzPolygon(36.050527f,-6.220891f, 36.155038f,-6.320483f, 36.155038f,-5.048803f, 36.136011f,-5.074855f, 36.050527f,-5.110521f);
            poly[1672] = new TzPolygon(35.979353f,-5.048803f, 35.910069f,-5.020928f, 35.749925f,-5.018811f, 35.552733f,-4.843220f, 35.414651f,-4.582748f,
                    35.391144f,-4.298035f, 35.486455f,-3.678686f, 35.438921f,-3.301974f, 35.599213f,-3.130707f, 35.637346f,-2.977627f,
                    35.590863f,-2.811975f, 35.320152f,-2.811975f, 35.320152f,-5.048803f);
            poly[1673] = new TzPolygon(35.590863f,-2.811975f, 35.588038f,-2.801907f, 35.489383f,-2.696016f, 35.440230f,-2.605140f, 35.337216f,-2.206422f,
                    35.320152f,-2.207127f, 35.320152f,-2.811975f);
            poly[1674] = new TzPolygon(36.155038f,-6.320483f, 36.267551f,-6.427700f, 36.937387f,-6.911625f, 36.968406f,-7.006435f, 36.967946f,-7.369819f,
                    37.387216f,-7.439565f, 37.408989f,-7.462707f, 37.419921f,-7.445595f, 37.488254f,-7.464283f, 37.553065f,-7.522665f,
                    37.664606f,-7.443571f, 37.758942f,-7.421372f, 37.815820f,-7.324337f, 37.868861f,-7.283514f, 37.954493f,-7.248297f,
                    37.979856f,-7.262433f, 38.004633f,-7.120706f, 38.029505f,-7.128319f, 38.043822f,-7.098688f, 38.014249f,-7.046775f,
                    38.022391f,-7.002008f, 38.152778f,-6.952175f, 38.166313f,-6.969145f, 38.208298f,-6.931499f, 38.204624f,-7.010670f,
                    38.169299f,-7.085337f, 38.419677f,-7.279748f, 38.435820f,-7.335848f, 38.469605f,-7.298561f, 38.478270f,-7.321572f,
                    38.513876f,-7.314552f, 38.624024f,-7.243595f, 38.638406f,-7.272498f, 38.724199f,-7.259420f, 38.864935f,-7.039322f,
                    38.864935f,-6.189159f, 36.155038f,-6.189159f);
            poly[1675] = new TzPolygon(38.864935f,-7.039322f, 38.906953f,-7.052181f, 39.023598f,-6.951130f, 39.054471f,-6.959416f, 39.117322f,-7.032577f,
                    39.108633f,-7.144025f, 39.171198f,-7.134667f, 39.208255f,-7.241460f, 39.278259f,-7.231472f, 39.336109f,-7.307485f,
                    39.381294f,-7.322816f, 39.456828f,-7.294261f, 39.491237f,-7.381881f, 39.529717f,-7.390685f, 39.534509f,-7.430259f,
                    39.589645f,-7.499312f, 39.663680f,-7.541680f, 39.640847f,-7.333676f, 39.666811f,-7.251522f, 39.653072f,-7.151350f,
                    39.670428f,-7.015516f, 39.772321f,-6.976833f, 39.810027f,-6.987204f, 39.870706f,-6.903591f, 40.012009f,-6.863785f,
                    40.112510f,-6.940870f, 40.126130f,-7.012936f, 40.186390f,-7.029972f, 40.219884f,-7.008397f, 40.219884f,-6.189159f,
                    38.864935f,-6.189159f);
            poly[1676] = new TzPolygon(40.219884f,-7.008397f, 40.235219f,-6.998518f, 40.264342f,-6.867990f, 40.299612f,-6.861377f, 40.328400f,-6.794107f,
                    40.364556f,-6.780961f, 40.451520f,-6.849693f, 40.511369f,-6.795268f, 40.550353f,-6.800862f, 40.565954f,-6.845357f,
                    40.661297f,-6.794014f, 40.752804f,-6.831171f, 40.840283f,-6.826916f, 40.860715f,-6.801921f, 41.029411f,-6.931357f,
                    41.036497f,-6.808931f, 41.104062f,-6.754194f, 41.134837f,-6.767871f, 41.247550f,-6.648377f, 41.255237f,-6.591609f,
                    41.239042f,-6.571330f, 41.275627f,-6.522598f, 41.266163f,-6.496288f, 41.359332f,-6.376837f, 41.384709f,-6.389647f,
                    41.385742f,-6.317660f, 41.410327f,-6.333269f, 41.574832f,-6.189159f, 40.219884f,-6.189159f);
            poly[1677] = new TzPolygon(41.899040f,-7.685539f, 41.907666f,-7.700851f, 41.881279f,-7.845188f, 41.844855f,-7.872805f, 41.924316f,-7.884689f,
                    41.927096f,-7.906343f, 41.877791f,-7.921252f, 41.869216f,-7.987692f, 41.828992f,-8.014058f, 41.808035f,-8.093917f,
                    41.818113f,-8.165013f, 41.876528f,-8.169304f, 41.873700f,-8.200018f, 41.913453f,-8.216833f, 41.982692f,-8.163019f,
                    42.016492f,-8.086035f, 42.047334f,-8.084455f, 42.082307f,-8.118701f, 42.065109f,-8.182171f, 42.154311f,-8.198754f,
                    42.154311f,-7.685539f);
            poly[1678] = new TzPolygon(42.154311f,-8.198754f, 42.083835f,-8.331891f, 42.079549f,-8.519815f, 42.054185f,-8.546049f, 42.047874f,-8.635930f,
                    42.002549f,-8.662184f, 41.863929f,-8.870966f, 41.865833f,-9.140278f, 42.154311f,-9.181919f);
            poly[1679] = new TzPolygon(41.899040f,-7.685539f, 41.881199f,-7.653871f, 41.881871f,-7.585873f, 41.829178f,-7.611456f, 41.841967f,-7.521053f,
                    41.869384f,-7.502225f, 41.865082f,-7.452499f, 41.807367f,-7.427636f, 41.852787f,-7.365788f, 41.842545f,-7.315315f,
                    41.879979f,-7.196738f, 41.919102f,-7.173492f, 41.972324f,-7.185435f, 41.990758f,-7.141459f, 41.949652f,-7.071939f,
                    41.950566f,-7.006238f, 41.973783f,-6.979365f, 41.944658f,-6.944305f, 41.939857f,-6.893253f, 41.946005f,-6.821607f,
                    41.992521f,-6.811348f, 41.933315f,-6.700006f, 41.939737f,-6.621386f, 41.967567f,-6.588307f, 41.939456f,-6.546512f,
                    41.883496f,-6.571179f, 41.871659f,-6.515514f, 41.743598f,-6.568898f, 41.685595f,-6.548274f, 41.657099f,-6.499567f,
                    41.684840f,-6.444272f, 41.661812f,-6.302297f, 41.574832f,-6.189159f, 41.574832f,-7.685539f);
            poly[1680] = new TzPolygon(42.826220f,-0.503068f, 42.827479f,-0.505574f, 42.780759f,-0.567617f, 42.832523f,-0.603333f, 42.896739f,-0.731976f,
                    42.967162f,-0.751676f, 42.953244f,-0.943456f, 43.023998f,-1.111512f, 43.007610f,-1.141661f, 43.035093f,-1.164334f,
                    43.055449f,-1.229292f, 43.044022f,-1.263615f, 43.069172f,-1.309811f, 43.118327f,-1.270059f, 43.107837f,-1.332320f,
                    43.027761f,-1.354056f, 43.046295f,-1.441351f, 43.086774f,-1.473098f, 43.128507f,-1.414297f, 43.250079f,-1.378924f,
                    43.294652f,-1.535333f, 43.288037f,-1.565043f, 43.249933f,-1.575191f, 43.251851f,-1.608789f, 43.306000f,-1.624022f,
                    43.295749f,-1.730155f, 43.330084f,-1.737461f, 43.353265f,-1.790167f, 43.488523f,-1.772042f, 43.595278f,-1.802222f,
                    43.690610f,-1.719526f, 43.993309f,-1.645345f, 43.993309f,-0.503068f);
            poly[1681] = new TzPolygon(42.826220f,-0.503068f, 43.993309f,-0.503068f, 43.993309f,1.311409f, 42.722642f,1.311409f, 42.727833f,1.229261f,
                    42.708954f,1.166075f, 42.788338f,1.078887f, 42.786624f,0.985913f, 42.805854f,0.960286f, 42.789357f,0.926445f,
                    42.861523f,0.708647f, 42.839839f,0.660726f, 42.803834f,0.669711f, 42.783085f,0.644853f, 42.773711f,0.665116f,
                    42.754997f,0.639318f, 42.726100f,0.678636f, 42.690975f,0.677125f, 42.705702f,0.597538f, 42.690502f,0.422379f,
                    42.723972f,0.360415f, 42.674178f,0.295691f, 42.717253f,0.260885f, 42.737001f,0.175742f, 42.685119f,-0.015980f,
                    42.720878f,-0.106650f, 42.798447f,-0.160829f, 42.786807f,-0.188824f, 42.849410f,-0.313311f, 42.798922f,-0.394126f,
                    42.795360f,-0.441648f);
            poly[1682] = new TzPolygon(42.655936f,1.549299f, 42.625877f,1.600384f, 42.617838f,1.736080f, 42.588269f,1.727654f, 42.573972f,1.786384f,
                    42.556498f,1.740124f, 42.492256f,1.711374f, 42.505792f,1.669095f, 42.468450f,1.657026f, 42.458586f,1.560547f,
                    42.433457f,1.552631f, 42.428824f,1.515751f, 42.441424f,1.444393f, 42.482386f,1.417389f, 42.509996f,1.468400f,
                    42.540077f,1.450724f, 42.535378f,1.413578f, 42.651450f,1.478777f);
            poly[1683] = new TzPolygon(42.431258f,2.218648f, 42.414540f,2.132632f, 42.361763f,2.084671f, 42.347070f,2.015959f, 42.381154f,1.965355f,
                    42.453682f,1.937050f, 42.447715f,1.891171f, 42.486526f,1.823474f, 42.492386f,1.729967f, 42.549961f,1.734940f,
                    42.573972f,1.786384f, 42.588269f,1.727654f, 42.617838f,1.736080f, 42.653557f,1.493443f, 42.613082f,1.476602f,
                    42.602798f,1.438127f, 42.719738f,1.357362f, 42.722642f,1.311409f, 43.073810f,1.311409f, 43.073810f,2.218648f);
            poly[1684] = new TzPolygon(42.431258f,2.218648f, 43.073810f,2.218648f, 43.073810f,3.125887f, 42.426908f,3.125887f, 42.425844f,3.085199f,
                    42.474577f,3.040551f, 42.465232f,2.967468f, 42.481337f,2.947320f, 42.456179f,2.918441f, 42.459409f,2.839067f,
                    42.411898f,2.776902f, 42.424732f,2.733931f, 42.405195f,2.674137f, 42.385751f,2.651484f, 42.340751f,2.671693f,
                    42.358500f,2.571155f, 42.332755f,2.532811f, 42.340771f,2.481220f, 42.393299f,2.433427f, 42.438700f,2.256935f);
            poly[1685] = new TzPolygon(42.426660f,3.125887f, 42.435333f,3.558333f, 42.323048f,3.605122f, 42.154311f,3.561377f, 42.154311f,3.125887f);
            poly[1686] = new TzPolygon(54.710606f,-7.899183f, 54.710606f,-7.767105f, 54.704280f,-7.750064f, 54.710606f,-7.734862f, 54.710606f,-6.997022f,
                    54.411684f,-6.997022f, 54.417906f,-7.040061f, 54.355738f,-7.103881f, 54.337649f,-7.188825f, 54.309676f,-7.179187f,
                    54.299624f,-7.212186f, 54.255594f,-7.142249f, 54.224727f,-7.145029f, 54.204460f,-7.248056f, 54.122555f,-7.278946f,
                    54.132113f,-7.308911f, 54.171965f,-7.291298f, 54.146717f,-7.339563f, 54.113289f,-7.318671f, 54.131600f,-7.363198f,
                    54.120127f,-7.391806f, 54.139627f,-7.372794f, 54.137053f,-7.420784f, 54.156458f,-7.409589f, 54.122265f,-7.479193f,
                    54.135741f,-7.528097f, 54.122143f,-7.547375f, 54.181961f,-7.676592f, 54.207761f,-7.685434f, 54.200729f,-7.811733f,
                    54.217280f,-7.860169f, 54.293431f,-7.861869f, 54.312469f,-7.961595f, 54.464761f,-8.177510f, 54.487631f,-8.042647f,
                    54.545941f,-8.006008f, 54.533135f,-7.850550f, 54.581876f,-7.793408f, 54.610070f,-7.697252f, 54.634946f,-7.708773f,
                    54.617972f,-7.741646f, 54.644110f,-7.813665f, 54.630776f,-7.852128f, 54.702821f,-7.918043f);
            poly[1687] = new TzPolygon(54.710606f,-7.899183f, 54.736422f,-7.836645f, 54.710606f,-7.767105f);
            poly[1688] = new TzPolygon(54.710606f,-7.734862f, 54.751510f,-7.636568f, 54.747021f,-7.534693f, 54.789371f,-7.549223f, 54.869414f,-7.444215f,
                    54.935241f,-7.447274f, 54.945446f,-7.392021f, 55.022349f,-7.391323f, 55.050832f,-7.345159f, 55.048540f,-7.286169f,
                    55.186520f,-6.997022f, 54.710606f,-6.997022f);
            poly[1689] = new TzPolygon(54.411684f,-6.997022f, 55.186520f,-6.997022f, 55.195488f,-6.978228f, 55.216468f,-6.821724f, 55.280171f,-6.719426f,
                    55.414976f,-6.744269f, 55.443585f,-6.578736f, 55.537000f,-6.777827f, 55.621777f,-6.864730f, 55.636000f,-6.868413f,
                    55.636000f,-5.658236f, 53.979601f,-5.658236f, 53.870168f,-5.826004f, 54.111355f,-6.281731f, 54.090976f,-6.317881f,
                    54.113742f,-6.366201f, 54.058852f,-6.391053f, 54.077087f,-6.477795f, 54.052681f,-6.510507f, 54.057572f,-6.586429f,
                    54.036460f,-6.623810f, 54.072891f,-6.668985f, 54.179994f,-6.643940f, 54.200165f,-6.691686f, 54.181916f,-6.740764f,
                    54.223024f,-6.816169f, 54.261487f,-6.827743f, 54.279243f,-6.878038f, 54.297279f,-6.850872f, 54.346412f,-6.875942f,
                    54.409462f,-6.981649f);
            poly[1690] = new TzPolygon(49.941607f,-2.249565f, 49.922178f,-2.054411f, 49.804806f,-2.050881f, 49.460500f,-2.097500f, 49.407458f,-2.133569f,
                    49.220833f,-2.559167f, 49.304077f,-2.937245f, 49.359893f,-2.995432f, 49.437953f,-3.020401f, 49.515690f,-2.997734f,
                    49.590599f,-2.924610f, 49.686258f,-2.696914f, 49.784785f,-2.685396f, 49.863177f,-2.610686f, 49.915822f,-2.483655f);
            poly[1691] = new TzPolygon(49.460500f,-2.097500f, 49.364667f,-1.992500f, 49.316667f,-1.891667f, 49.250833f,-1.833333f, 49.183333f,-1.833333f,
                    49.065833f,-1.859167f, 48.941667f,-1.983333f, 48.883333f,-1.983333f, 48.872167f,-2.241667f, 48.927833f,-2.525333f,
                    49.220833f,-2.559167f, 49.362468f,-2.217660f, 49.407458f,-2.133569f);
            poly[1692] = new TzPolygon(48.663863f,-1.783162f, 48.663863f,-5.259866f, 48.837718f,-4.682751f, 48.960384f,-4.078331f, 49.062169f,-3.764877f,
                    49.103939f,-3.506849f, 49.116509f,-3.156796f, 49.233256f,-3.086562f, 49.304077f,-2.937245f, 49.220833f,-2.559167f,
                    48.927833f,-2.525333f, 48.872167f,-2.241667f, 48.883333f,-1.983333f, 48.941667f,-1.983333f, 49.065833f,-1.859167f,
                    49.250833f,-1.833333f, 49.460500f,-2.097500f, 49.922178f,-2.054411f, 49.934777f,-1.901527f, 49.909007f,-1.783162f);
            poly[1693] = new TzPolygon(51.227462f,1.821167f, 51.199347f,1.887536f, 51.098586f,1.723905f, 50.949130f,1.355574f, 50.895518f,1.281407f,
                    50.801000f,1.241893f, 50.734000f,1.121956f, 50.712000f,1.002875f, 50.717000f,0.867068f, 50.642000f,0.549983f,
                    50.568000f,0.426288f, 50.536000f,0.285376f, 50.545000f,0.128351f, 50.626000f,-0.234686f, 50.600000f,-0.505432f,
                    50.531000f,-0.692731f, 50.527924f,-0.866918f, 50.426000f,-1.023166f, 50.376000f,-1.262391f, 50.386000f,-1.403527f,
                    50.459000f,-1.569563f, 50.474348f,-1.699026f, 50.436904f,-1.783162f, 51.227462f,-1.783162f);
            poly[1694] = new TzPolygon(54.553429f,-4.196242f, 54.479000f,-4.034430f, 54.296000f,-3.965406f, 54.081000f,-4.106243f, 53.905000f,-4.396930f,
                    53.859000f,-4.548184f, 53.845000f,-4.828800f, 53.861000f,-4.957775f, 53.906000f,-5.069047f, 53.978000f,-5.145584f,
                    54.054000f,-5.170728f, 54.285905f,-5.045528f, 54.433983f,-4.868555f, 54.529539f,-4.532588f);
            poly[1695] = new TzPolygon(50.488237f,3.516138f, 50.486721f,3.500678f, 50.516360f,3.516138f);
            poly[1696] = new TzPolygon(50.524453f,3.516138f, 50.533679f,3.474389f, 50.491132f,3.376327f, 50.525867f,3.288447f, 50.658638f,3.240068f,
                    50.701309f,3.261038f, 50.712021f,3.204937f, 50.790081f,3.150427f, 50.752079f,2.951451f, 50.692354f,2.905457f,
                    50.725768f,2.790092f, 50.813468f,2.718114f, 50.812906f,2.635103f, 50.918643f,2.590244f, 50.946062f,2.632912f,
                    51.116515f,2.503852f, 51.116515f,3.516138f);
            poly[1697] = new TzPolygon(50.524453f,3.516138f, 50.523617f,3.519923f, 50.516360f,3.516138f);
            poly[1698] = new TzPolygon(50.488237f,3.516138f, 50.497188f,3.607438f, 50.455779f,3.662832f, 50.368581f,3.657263f, 50.303338f,3.709582f,
                    50.350992f,3.747135f, 50.353230f,3.845783f, 50.326956f,3.900922f, 50.359172f,4.024179f, 50.303148f,4.118143f,
                    50.257408f,4.135515f, 50.259526f,4.167559f, 50.288955f,4.162616f, 50.272980f,4.208051f, 50.251670f,4.220130f,
                    50.213573f,4.150416f, 50.135639f,4.127122f, 50.134151f,4.199508f, 50.073549f,4.230833f, 50.019793f,4.135758f,
                    49.994989f,4.163097f, 49.978998f,4.140546f, 49.954600f,4.197455f, 49.969556f,4.309527f, 49.937215f,4.445509f,
                    49.995412f,4.693410f, 50.068050f,4.679764f, 50.169225f,4.824962f, 50.137919f,4.897111f, 50.087557f,4.872010f,
                    50.101159f,4.849684f, 50.065927f,4.819384f, 50.039665f,4.841489f, 49.969829f,4.790334f, 49.908935f,4.890131f,
                    49.868087f,4.847535f, 49.819257f,4.876393f, 49.793048f,4.851997f, 49.797925f,4.940364f, 48.742113f,4.940364f,
                    48.742113f,3.516138f);
            poly[1699] = new TzPolygon(51.116515f,2.503852f, 51.268318f,2.388914f, 51.551667f,3.081389f, 51.433406f,3.307953f, 51.341205f,3.383513f,
                    51.314980f,3.358383f, 51.277214f,3.375717f, 51.244657f,3.427479f, 51.246040f,3.527594f, 51.287156f,3.515414f,
                    51.286913f,3.581812f, 51.305947f,3.590007f, 51.263888f,3.774264f, 51.214012f,3.791127f, 51.223018f,3.888549f,
                    51.200162f,3.886350f, 51.292896f,4.166126f, 51.353967f,4.242049f, 51.373885f,4.217577f, 51.363853f,4.431352f,
                    51.446746f,4.379317f, 51.478145f,4.475961f, 51.473383f,4.548089f, 51.423030f,4.535409f, 51.422014f,4.641290f,
                    51.504487f,4.778787f, 51.480736f,4.841878f, 51.422442f,4.841469f, 51.432355f,4.780910f, 51.414903f,4.771224f,
                    51.414671f,4.899994f, 51.393693f,4.920953f, 51.408804f,4.940364f, 51.116515f,4.940364f);
        }
    }

    private static class Initializer18 {
        private static void init() {
            poly[1700] = new TzPolygon(51.447378f,4.923035f, 51.438014f,4.940364f, 51.429465f,4.936153f, 51.435355f,4.915012f);
            poly[1701] = new TzPolygon(51.227462f,2.091912f, 51.268318f,2.388914f, 51.116515f,2.503852f, 51.116515f,2.091912f);
            poly[1702] = new TzPolygon(32.597374f,4.940364f, 32.597374f,8.346721f, 32.502602f,8.356830f, 32.087376f,9.065308f, 30.230236f,9.558453f,
                    30.178669f,9.398919f, 30.065861f,9.407538f, 29.901201f,9.538688f, 29.424757f,9.779948f, 29.027662f,9.871652f,
                    28.759132f,9.902313f, 28.285950f,9.832934f, 27.866574f,9.962578f, 27.679511f,9.924022f, 27.606979f,9.886819f,
                    27.571916f,9.816291f, 27.562405f,9.877991f, 27.504425f,9.862791f, 27.462886f,9.813447f, 27.433543f,9.808866f,
                    27.433543f,4.940364f);
            poly[1703] = new TzPolygon(32.597374f,8.346721f, 32.597374f,11.530124f, 32.519177f,11.599935f, 32.454452f,11.595000f, 32.408650f,11.548930f,
                    32.199722f,11.029167f, 32.105297f,10.861430f, 31.998144f,10.795141f, 31.960938f,10.634012f, 31.933062f,10.638046f,
                    31.916343f,10.612640f, 31.879255f,10.634949f, 31.740835f,10.526845f, 31.740470f,10.386147f, 31.672396f,10.276262f,
                    31.478747f,10.133912f, 31.091260f,10.294135f, 31.040807f,10.275145f, 30.894995f,10.305593f, 30.800508f,10.272077f,
                    30.508365f,10.069602f, 30.469775f,10.007096f, 30.383424f,9.944150f, 30.336932f,9.877502f, 30.337247f,9.831754f,
                    30.230236f,9.558453f, 32.087376f,9.065308f, 32.502602f,8.356830f);
            poly[1704] = new TzPolygon(32.597374f,8.346721f, 32.823472f,8.322605f, 33.049835f,8.116149f, 33.099813f,8.117256f, 33.184487f,7.905653f,
                    33.188116f,7.832152f, 33.323640f,7.777753f, 33.327352f,7.749216f, 33.424659f,7.736576f, 33.648103f,7.596498f,
                    33.777445f,7.562152f, 33.798297f,7.525414f, 33.836840f,7.547215f, 33.905076f,7.521981f, 34.014617f,7.560387f,
                    34.070271f,7.532053f, 34.113662f,7.614053f, 34.200869f,7.651514f, 34.170555f,7.722758f, 34.209190f,7.796570f,
                    34.405304f,7.856513f, 34.419949f,7.932655f, 34.515801f,8.083059f, 34.533643f,8.149115f, 34.574288f,8.170025f,
                    34.578022f,8.222240f, 34.603530f,8.211017f, 34.654803f,8.280836f, 34.687910f,8.240624f, 34.732810f,8.324207f,
                    34.766891f,8.283794f, 34.921054f,8.245209f, 34.946790f,8.311894f, 34.946790f,8.410239f, 32.597374f,8.410239f);
            poly[1705] = new TzPolygon(34.946790f,8.311894f, 34.948092f,8.315268f, 35.098708f,8.357157f, 35.161427f,8.410239f, 34.946790f,8.410239f);
            poly[1706] = new TzPolygon(35.244867f,8.410239f, 35.280450f,8.333596f, 35.315064f,8.311548f, 35.414212f,8.315461f, 35.487419f,8.385363f,
                    35.525741f,8.359967f, 35.669768f,8.356044f, 35.730655f,8.264271f, 35.878645f,8.270714f, 35.886469f,8.253484f,
                    35.937619f,8.262905f, 35.953150f,8.290479f, 36.040236f,8.296907f, 36.097034f,8.346006f, 36.174362f,8.306971f,
                    36.232371f,8.354671f, 36.264522f,8.337915f, 36.304945f,8.391056f, 36.349093f,8.376194f, 36.411860f,8.409657f,
                    36.446179f,8.354868f, 36.432336f,8.327862f, 36.448067f,8.208944f, 36.496864f,8.153652f, 36.539617f,8.291499f,
                    36.617420f,8.410239f);
            poly[1707] = new TzPolygon(37.122486f,8.410239f, 37.121037f,8.417769f, 37.143094f,8.590487f, 36.915688f,8.653986f, 36.853766f,8.625005f,
                    36.838951f,8.681129f, 36.773199f,8.572483f, 36.779485f,8.484147f, 36.759518f,8.429930f, 36.748358f,8.464080f,
                    36.697319f,8.487450f, 36.662079f,8.451321f, 36.618071f,8.449201f, 36.622394f,8.417829f, 36.617420f,8.410239f);
            poly[1708] = new TzPolygon(35.244867f,8.410239f, 35.239755f,8.476531f, 35.161427f,8.410239f);
            poly[1709] = new TzPolygon(32.597374f,11.530124f, 32.655913f,11.477862f, 32.917861f,11.495501f, 33.175987f,11.561736f, 33.354590f,11.667578f,
                    33.282408f,11.880113f, 32.597374f,11.880113f);
            poly[1710] = new TzPolygon(36.557525f,11.880113f, 36.600952f,11.798723f, 36.710097f,11.703067f, 36.804557f,11.673080f, 36.887130f,11.687516f,
                    36.962978f,11.742110f, 37.010532f,11.814764f, 37.023344f,11.880113f);
            poly[1711] = new TzPolygon(27.433543f,24.998334f, 29.248889f,24.997778f, 29.506389f,24.877500f, 29.663889f,24.886944f, 29.784444f,24.812500f,
                    29.865278f,24.836111f, 29.941111f,24.812222f, 30.098611f,24.740278f, 30.126369f,24.649911f, 30.229633f,24.697870f,
                    30.437222f,24.881944f, 30.776461f,25.010746f, 30.900027f,24.980308f, 31.154950f,24.858479f, 31.393491f,24.852061f,
                    31.551144f,25.076277f, 31.615441f,25.084037f, 31.676637f,25.145563f, 31.833085f,25.870010f, 31.799935f,26.294860f,
                    31.648567f,27.038386f, 31.599662f,27.150561f, 31.560275f,27.423800f, 31.507466f,27.520258f, 31.402821f,27.605719f,
                    31.446926f,27.848436f, 31.436984f,27.933512f, 31.375271f,28.039166f, 31.300291f,28.085323f, 31.289670f,28.374229f,
                    27.433543f,28.374229f);
            poly[1712] = new TzPolygon(36.561110f,28.374229f, 36.561373f,28.209405f, 36.469590f,28.002097f, 36.470373f,27.960677f, 36.697277f,27.895497f,
                    36.708633f,27.813951f, 36.574322f,27.641671f, 36.542785f,27.462142f, 36.586101f,27.351479f, 36.725991f,27.247118f,
                    36.807575f,27.351010f, 36.905093f,27.393714f, 36.942682f,27.245762f, 36.973080f,27.237022f, 36.997548f,27.156232f,
                    37.040734f,27.146522f, 37.051642f,27.173670f, 37.061455f,27.140922f, 37.311796f,27.153627f, 37.564047f,27.054100f,
                    37.649170f,26.958483f, 37.696726f,27.008265f, 37.724056f,27.164928f, 37.761205f,27.162449f, 37.761205f,28.374229f);
            poly[1713] = new TzPolygon(27.709506f,34.567324f, 27.713530f,34.519034f, 27.789704f,34.477073f, 27.900510f,34.457172f, 28.024965f,34.466182f,
                    28.120017f,34.512967f, 28.277091f,34.545197f, 28.327764f,34.567324f);
            poly[1714] = new TzPolygon(31.704229f,34.294791f, 31.540121f,34.567324f, 31.389574f,34.380266f, 31.290529f,34.366548f, 31.220129f,34.267499f,
                    31.323580f,34.218798f, 31.478174f,34.068973f);
            poly[1715] = new TzPolygon(30.397487f,34.567324f, 30.413044f,34.542685f, 30.497914f,34.553725f, 30.533630f,34.515575f, 30.680851f,34.496401f,
                    30.858308f,34.403429f, 31.220129f,34.267499f, 31.290529f,34.366548f, 31.389574f,34.380266f, 31.533243f,34.565431f,
                    31.704229f,34.294791f, 31.852616f,34.401103f, 32.150076f,34.543187f, 32.227163f,34.567324f);
            poly[1716] = new TzPolygon(30.397487f,34.567324f, 30.368074f,34.613908f, 29.779190f,34.843791f, 29.648694f,34.880253f, 29.543323f,34.878553f,
                    29.453380f,34.921211f, 29.082028f,34.767993f, 28.952658f,34.761567f, 28.905180f,34.733562f, 28.550571f,34.668762f,
                    28.326064f,34.567324f);
            poly[1717] = new TzPolygon(30.769331f,34.567324f, 30.769331f,35.303996f, 30.762011f,35.295807f, 30.712251f,35.293662f, 30.581956f,35.204033f,
                    30.441312f,35.161954f, 30.346085f,35.192038f, 30.282048f,35.146011f, 30.122488f,35.162191f, 30.012255f,35.100864f,
                    29.995234f,35.116228f, 29.950344f,35.075287f, 29.885547f,35.084535f, 29.771922f,35.029990f, 29.639091f,35.014605f,
                    29.453380f,34.921211f, 29.543323f,34.878553f, 29.648694f,34.880253f, 29.779190f,34.843791f, 30.368074f,34.613908f,
                    30.397487f,34.567324f);
            poly[1718] = new TzPolygon(27.433543f,35.203242f, 27.635956f,34.972720f, 27.700125f,34.679919f, 27.709506f,34.567324f, 28.327764f,34.567324f,
                    28.579107f,34.677076f, 28.905180f,34.733562f, 28.952658f,34.761567f, 29.082028f,34.767993f, 29.375196f,34.884437f,
                    29.183401f,36.072812f, 29.380109f,36.341741f, 29.430374f,36.449338f, 29.867901f,36.784903f, 29.980846f,37.397452f,
                    27.433543f,37.397452f);
            poly[1719] = new TzPolygon(30.769331f,37.730895f, 30.500661f,37.997146f, 30.332623f,37.665557f, 30.000769f,37.505505f, 29.980846f,37.397452f,
                    30.769331f,37.397452f);
            poly[1720] = new TzPolygon(30.769331f,35.303996f, 30.798742f,35.336901f, 30.908302f,35.354280f, 30.950940f,35.416466f, 31.104449f,35.454738f,
                    31.252946f,35.399300f, 31.393758f,35.467552f, 31.660826f,35.502305f, 31.757917f,35.558328f, 31.872730f,35.549870f,
                    31.907679f,35.524321f, 31.968917f,35.548343f, 32.035376f,35.518909f, 32.211267f,35.573902f, 32.400581f,35.546318f,
                    32.437225f,35.560607f, 32.437225f,35.982388f, 30.769331f,35.982388f);
            poly[1721] = new TzPolygon(32.227163f,34.567324f, 32.437225f,34.633097f, 32.437225f,35.560607f, 32.400581f,35.546318f, 32.211267f,35.573902f,
                    32.035376f,35.518909f, 31.968917f,35.548343f, 31.907679f,35.524321f, 31.872730f,35.549870f, 31.757917f,35.558328f,
                    31.660826f,35.502305f, 31.393758f,35.467552f, 31.252946f,35.399300f, 31.104449f,35.454738f, 30.950940f,35.416466f,
                    30.908302f,35.354280f, 30.798742f,35.336901f, 30.769331f,35.303996f, 30.769331f,34.567324f);
            poly[1722] = new TzPolygon(32.437225f,36.324641f, 32.437225f,36.960152f, 32.333755f,36.880893f, 32.311354f,36.838094f, 32.313642f,36.721531f,
                    32.339629f,36.665114f, 32.377144f,36.406835f);
            poly[1723] = new TzPolygon(32.437225f,37.081237f, 32.433419f,37.077263f, 32.437225f,37.010555f);
            poly[1724] = new TzPolygon(31.105804f,37.397452f, 31.500640f,37.006171f, 31.598451f,37.397452f);
            poly[1725] = new TzPolygon(32.437225f,35.560607f, 32.487407f,35.580175f, 32.514749f,35.552513f, 32.552624f,35.576971f, 32.645902f,35.561264f,
                    32.755459f,35.795623f, 32.735977f,35.801576f, 32.732715f,35.868864f, 32.713955f,35.884016f, 32.720807f,35.933642f,
                    32.663938f,35.964680f, 32.658925f,36.015275f, 32.437225f,36.015275f);
            poly[1726] = new TzPolygon(33.271172f,34.955132f, 33.271172f,35.562936f, 33.119127f,35.526881f, 33.089483f,35.503510f, 33.090649f,35.445865f,
                    33.047986f,35.379913f, 33.104905f,35.316830f, 33.083521f,35.189269f, 33.096154f,35.079549f, 33.172036f,34.882567f,
                    33.260866f,34.952995f);
            poly[1727] = new TzPolygon(33.271172f,35.622051f, 33.242386f,35.624239f, 33.271172f,35.589919f);
            poly[1728] = new TzPolygon(32.658925f,36.015275f, 32.663938f,35.964680f, 32.720579f,35.934483f, 32.713955f,35.884016f, 32.732715f,35.868864f,
                    32.735977f,35.801576f, 32.755495f,35.797084f, 32.745090f,35.756483f, 32.828166f,35.837677f, 32.944877f,35.895023f,
                    33.102351f,35.850451f, 33.112992f,35.816977f, 33.193059f,35.837681f, 33.271172f,35.781411f, 33.271172f,36.015275f);
            poly[1729] = new TzPolygon(32.437225f,35.063930f, 32.450389f,35.066303f, 32.552148f,35.224570f, 32.510721f,35.288590f, 32.518756f,35.356305f,
                    32.501160f,35.402968f, 32.437225f,35.423095f);
            poly[1730] = new TzPolygon(33.271172f,36.015275f, 33.271172f,35.781411f, 33.276731f,35.777406f, 33.316960f,35.813197f, 33.335632f,35.773335f,
                    33.405000f,35.826944f, 33.480556f,35.948056f, 33.527778f,35.941111f, 33.545850f,36.015275f);
            poly[1731] = new TzPolygon(33.608980f,36.015275f, 33.646111f,35.935000f, 33.715000f,35.968333f, 33.766815f,36.015275f);
            poly[1732] = new TzPolygon(33.271172f,35.562936f, 33.290049f,35.567412f, 33.271172f,35.589919f);
            poly[1733] = new TzPolygon(33.271172f,35.622051f, 33.272558f,35.621946f, 33.335632f,35.773335f, 33.316960f,35.813197f, 33.276731f,35.777406f,
                    33.271172f,35.781411f);
            poly[1734] = new TzPolygon(32.658925f,36.015275f, 32.658078f,36.023820f, 32.602265f,36.025684f, 32.568288f,36.068957f, 32.513485f,36.078734f,
                    32.529855f,36.199998f, 32.494839f,36.211860f, 32.498946f,36.240203f, 32.437225f,36.324641f, 32.437225f,36.015275f);
            poly[1735] = new TzPolygon(32.437225f,36.960152f, 32.439980f,36.962262f, 32.437225f,37.010555f);
            poly[1736] = new TzPolygon(32.437225f,37.081237f, 32.557422f,37.206745f, 32.571916f,37.255432f, 32.560229f,37.359916f, 32.596984f,37.397452f,
                    32.437225f,37.397452f);
            poly[1737] = new TzPolygon(34.105119f,36.514957f, 34.101667f,36.511111f, 34.063611f,36.503611f, 34.049167f,36.404167f, 33.917778f,36.283333f,
                    33.878889f,36.325278f, 33.877500f,36.366667f, 33.830629f,36.393446f, 33.859722f,36.246111f, 33.833056f,36.201944f,
                    33.856389f,36.155278f, 33.820833f,36.094722f, 33.827222f,36.070000f, 33.757866f,36.015275f, 34.105119f,36.015275f);
            poly[1738] = new TzPolygon(33.605818f,36.015275f, 33.579444f,36.059167f, 33.549167f,36.028889f, 33.545850f,36.015275f);
            poly[1739] = new TzPolygon(31.979666f,40.227580f, 32.154338f,39.200916f, 32.230589f,39.301298f, 32.355224f,39.259916f, 32.303686f,39.043147f,
                    32.477657f,38.985583f, 32.502008f,39.086064f, 33.375062f,38.793672f, 34.105119f,40.227580f);
            poly[1740] = new TzPolygon(34.103351f,40.227580f, 33.244471f,38.554732f, 33.162929f,38.362911f, 32.898358f,37.901525f, 32.893430f,37.785447f,
                    32.761800f,37.740796f, 32.717501f,37.520529f, 32.596984f,37.397452f, 34.105119f,37.397452f, 34.105119f,40.227580f);
            poly[1741] = new TzPolygon(30.769331f,37.730895f, 31.105804f,37.397452f, 31.598451f,37.397452f, 32.000630f,39.006312f, 32.154338f,39.200916f,
                    31.979666f,40.227580f, 30.769331f,40.227580f);
            poly[1742] = new TzPolygon(36.185313f,29.483821f, 36.158643f,29.563327f, 36.169040f,29.613194f, 36.085772f,29.700458f, 35.923000f,29.729699f,
                    35.916185f,29.555934f, 35.947485f,29.399908f, 36.011000f,29.310589f);
            poly[1743] = new TzPolygon(35.384917f,32.545946f, 35.384917f,34.539147f, 35.237875f,34.288184f, 35.172643f,34.233596f, 35.069626f,33.999531f,
                    35.071784f,33.906205f, 35.123742f,33.884025f, 35.072152f,33.854572f, 35.075903f,33.819477f, 35.042472f,33.760623f,
                    35.037257f,33.714912f, 35.076575f,33.708565f, 35.039054f,33.676866f, 35.052141f,33.611162f, 35.038105f,33.587720f,
                    35.080479f,33.527831f, 35.062390f,33.483768f, 35.002986f,33.458663f, 35.062241f,33.480335f, 35.200512f,33.404612f,
                    35.166048f,33.289440f, 35.198240f,33.157563f, 35.160192f,33.108042f, 35.163471f,33.034272f, 35.103574f,32.955210f,
                    35.106242f,32.874207f, 35.081628f,32.852750f, 35.151029f,32.708254f, 35.244217f,32.686043f, 35.229355f,32.640381f,
                    35.172185f,32.604205f);
            poly[1744] = new TzPolygon(35.384917f,32.545946f, 35.399121f,32.671189f, 35.513637f,32.711632f, 35.594163f,32.837579f, 35.603965f,32.949971f,
                    35.553834f,33.302016f, 35.562032f,33.553453f, 35.666397f,33.937128f, 35.747248f,34.076368f, 35.898705f,34.513387f,
                    35.913252f,34.608360f, 35.897042f,34.703778f, 35.852299f,34.784230f, 35.785874f,34.837429f, 35.707916f,34.855318f,
                    35.630310f,34.835271f, 35.506472f,34.746611f, 35.384917f,34.539147f);
            poly[1745] = new TzPolygon(34.105119f,36.514957f, 34.203889f,36.625000f, 34.264722f,36.581667f, 34.309444f,36.600556f, 34.320278f,36.561944f,
                    34.371667f,36.533056f, 34.423333f,36.553889f, 34.462922f,36.464807f, 34.505279f,36.446284f, 34.513056f,36.341389f,
                    34.559722f,36.403333f, 34.611667f,36.409722f, 34.593056f,36.451389f, 34.635278f,36.460000f, 34.633936f,36.381019f,
                    34.692267f,36.335350f, 34.628156f,36.276960f, 34.642397f,36.127302f, 34.627377f,36.033642f, 34.650607f,35.989927f,
                    34.600667f,35.839611f, 34.661806f,35.754111f, 34.685969f,35.674506f, 34.692354f,35.671694f, 34.692354f,40.227580f,
                    34.105119f,40.227580f);
            poly[1746] = new TzPolygon(36.226779f,35.471729f, 36.226779f,36.489670f, 36.196944f,36.465101f, 36.216757f,36.381825f, 36.192573f,36.400425f,
                    36.167026f,36.365445f, 36.146031f,36.389110f, 36.011593f,36.376217f, 35.988468f,36.339216f, 36.010552f,36.290316f,
                    35.956419f,36.294490f, 35.944141f,36.193946f, 35.807680f,36.153943f, 35.862006f,36.112856f, 35.880034f,35.999522f,
                    35.940810f,36.006540f, 35.921473f,35.923498f, 36.033799f,35.692222f, 36.158000f,35.595079f);
            poly[1747] = new TzPolygon(36.226779f,36.623764f, 36.214325f,36.624687f, 36.226779f,36.570186f);
            poly[1748] = new TzPolygon(36.226779f,36.489670f, 36.242265f,36.502422f, 36.226779f,36.570186f);
            poly[1749] = new TzPolygon(36.226779f,36.623764f, 36.238216f,36.622916f, 36.240621f,36.690606f, 36.295014f,36.695127f, 36.298106f,36.656323f,
                    36.337599f,36.657252f, 36.327320f,36.605213f, 36.392255f,36.605951f, 36.418976f,36.566333f, 36.485768f,36.542538f,
                    36.585539f,36.591436f, 36.659134f,36.573628f, 36.705392f,36.628746f, 36.745534f,36.612946f, 36.799547f,36.671719f,
                    36.828361f,36.665670f, 36.765571f,36.997535f, 36.742156f,36.992730f, 36.726201f,37.046551f, 36.666159f,37.020742f,
                    36.634501f,37.085911f, 36.671548f,37.106192f, 36.677322f,37.142075f, 36.656867f,37.162561f, 36.675316f,37.216762f,
                    36.633014f,37.474147f, 36.673644f,37.495281f, 36.695015f,37.541449f, 36.226779f,37.541449f);
            poly[1750] = new TzPolygon(36.899584f,40.227580f, 36.877692f,40.182890f, 36.856111f,40.062275f, 36.826709f,40.031168f, 36.756701f,39.820774f,
                    36.669152f,39.213004f, 36.710722f,39.020575f, 36.708148f,38.739271f, 36.844811f,38.554410f, 36.902327f,38.390712f,
                    36.924099f,38.242029f, 36.864565f,38.045742f, 36.825977f,38.018477f, 36.818564f,37.940712f, 36.749622f,37.783378f,
                    36.749049f,37.658179f, 36.695015f,37.541449f, 37.761205f,37.541449f, 37.761205f,40.227580f);
            poly[1751] = new TzPolygon(45.645251f,6.959839f, 45.651031f,6.916460f, 45.680661f,6.903053f, 45.689674f,6.847326f, 45.725069f,6.808632f,
                    45.835876f,6.818102f, 45.847880f,6.942411f, 45.861165f,6.959839f);
            poly[1752] = new TzPolygon(46.036348f,6.959839f, 46.064270f,6.937506f, 46.051005f,6.872067f, 46.123940f,6.900008f, 46.136710f,6.797569f,
                    46.204868f,6.803843f, 46.280191f,6.864934f, 46.353816f,6.771101f, 46.427152f,6.821083f, 46.454337f,6.681878f,
                    46.456373f,6.519124f, 46.403722f,6.335208f, 46.360426f,6.252975f, 46.311884f,6.219565f, 46.301824f,6.248920f,
                    46.251677f,6.260159f, 46.256224f,6.309762f, 46.225153f,6.294686f, 46.141597f,6.136460f, 46.151387f,6.052300f,
                    46.132357f,5.955911f, 46.181865f,5.994923f, 46.197021f,5.963716f, 46.215008f,5.974567f, 46.251253f,6.124467f,
                    46.284943f,6.102352f, 46.366084f,6.169917f, 46.416395f,6.063858f, 46.463702f,6.072480f, 46.463702f,6.959839f);
            poly[1753] = new TzPolygon(46.043746f,6.959839f, 45.997268f,7.010417f, 45.922546f,7.044382f, 45.860642f,6.959839f);
            poly[1754] = new TzPolygon(45.645251f,6.959839f, 45.639771f,7.000968f, 45.588214f,6.977992f, 45.503281f,7.002286f, 45.495690f,7.052730f,
                    45.472447f,7.048617f, 45.468022f,7.103619f, 45.433079f,7.114587f, 45.421424f,7.143075f, 45.421424f,6.959839f);
            poly[1755] = new TzPolygon(46.463702f,7.969577f, 46.005786f,7.969577f, 45.996967f,7.908696f, 45.916700f,7.863563f, 45.941055f,7.747680f,
                    45.923582f,7.720131f, 45.973966f,7.668203f, 45.970926f,7.586981f, 45.987679f,7.570121f, 45.954905f,7.538446f,
                    45.962417f,7.499273f, 45.897005f,7.385701f, 45.921813f,7.294437f, 45.860439f,7.196750f, 45.879271f,7.153650f,
                    45.859176f,7.101549f, 46.036348f,6.959839f, 46.463702f,6.959839f);
            poly[1756] = new TzPolygon(46.463702f,8.446126f, 46.463702f,8.979315f, 45.833800f,8.979315f, 45.843481f,8.956318f, 45.830465f,8.912239f,
                    45.867021f,8.945315f, 45.957773f,8.894732f, 45.989150f,8.785922f, 46.075631f,8.852035f, 46.122257f,8.742349f,
                    46.098043f,8.714815f, 46.121721f,8.611822f, 46.218363f,8.532547f, 46.248958f,8.444463f, 46.298315f,8.427750f,
                    46.333848f,8.465346f, 46.395987f,8.471136f);
            poly[1757] = new TzPolygon(46.463702f,8.446126f, 46.425825f,8.307690f, 46.408715f,8.288623f, 46.377162f,8.312761f, 46.364526f,8.264307f,
                    46.302255f,8.198657f, 46.301998f,8.138142f, 46.266551f,8.085672f, 46.182864f,8.165067f, 46.146219f,8.154025f,
                    46.111625f,8.108218f, 46.100852f,8.034723f, 46.011988f,8.012397f, 46.005786f,7.969577f, 46.463702f,7.969577f);
            poly[1758] = new TzPolygon(46.463702f,6.072480f, 46.545298f,6.156659f, 46.576478f,6.110527f, 46.773983f,6.452400f, 46.812234f,6.431275f,
                    46.890278f,6.464546f, 46.928684f,6.432655f, 46.974110f,6.496503f, 46.991627f,6.618171f, 47.051179f,6.719178f,
                    47.081984f,6.702563f, 47.156375f,6.849928f, 47.171200f,6.840976f, 47.242993f,6.955461f, 47.286372f,6.940793f,
                    47.294240f,6.959839f, 46.463702f,6.959839f);
            poly[1759] = new TzPolygon(47.364605f,6.959839f, 47.352580f,6.879326f, 47.433327f,6.940272f, 47.439917f,6.959839f);
            poly[1760] = new TzPolygon(47.808465f,7.969577f, 47.546202f,7.969577f, 47.543787f,7.944265f, 47.587423f,7.891998f, 47.587988f,7.822544f,
                    47.557382f,7.795685f, 47.532629f,7.682682f, 47.561224f,7.633956f, 47.565610f,7.685919f, 47.600772f,7.693790f,
                    47.576870f,7.619134f, 47.589897f,7.589039f, 47.697775f,7.511746f, 47.731941f,7.548412f, 47.780920f,7.529817f,
                    47.808465f,7.537407f);
            poly[1761] = new TzPolygon(47.808465f,7.537407f, 47.780920f,7.529817f, 47.731941f,7.548412f, 47.697775f,7.511746f, 47.603602f,7.591969f,
                    47.575516f,7.584653f, 47.540113f,7.499175f, 47.528159f,7.531225f, 47.521248f,7.497870f, 47.482135f,7.487621f,
                    47.497168f,7.433141f, 47.480367f,7.420816f, 47.470701f,7.455825f, 47.431814f,7.385599f, 47.441758f,7.330212f,
                    47.420342f,7.246518f, 47.442979f,7.170218f, 47.494278f,7.200977f, 47.494551f,6.982967f, 47.454158f,7.002126f,
                    47.439917f,6.959839f, 47.808465f,6.959839f);
            poly[1762] = new TzPolygon(47.364605f,6.959839f, 47.372915f,7.015477f, 47.334368f,7.056984f, 47.294240f,6.959839f);
            poly[1763] = new TzPolygon(47.715199f,8.701270f, 47.690698f,8.717856f, 47.684854f,8.669950f, 47.691349f,8.658591f, 47.713373f,8.664653f);
            poly[1764] = new TzPolygon(47.546202f,7.969577f, 47.557630f,8.089356f, 47.621112f,8.206310f, 47.609158f,8.291912f, 47.571017f,8.329389f,
                    47.572193f,8.464170f, 47.581115f,8.494694f, 47.602327f,8.456675f, 47.633791f,8.515647f, 47.596126f,8.582557f,
                    47.643038f,8.595691f, 47.648985f,8.628632f, 47.672105f,8.606706f, 47.670415f,8.560792f, 47.638416f,8.473485f,
                    47.674200f,8.405576f, 47.770955f,8.484071f, 47.781674f,8.577318f, 47.808465f,8.568014f, 47.798330f,8.618589f,
                    47.758196f,8.631653f, 47.800454f,8.656848f, 47.758369f,8.688693f, 47.762277f,8.727310f, 47.692684f,8.728053f,
                    47.675501f,8.788611f, 47.693362f,8.810095f, 47.718463f,8.769753f, 47.738293f,8.806676f, 47.712785f,8.819036f,
                    47.704098f,8.872737f, 47.681177f,8.850531f, 47.647972f,8.896479f, 47.673081f,8.979315f, 46.463702f,8.979315f,
                    46.463702f,7.969577f);
            poly[1765] = new TzPolygon(45.834032f,8.979315f, 45.818113f,9.018060f, 45.900720f,9.089089f, 45.928427f,9.019308f, 45.970342f,8.988971f,
                    45.993661f,9.028422f, 46.037382f,9.009541f, 46.065302f,9.078293f, 46.118510f,9.072945f, 46.170620f,9.183944f,
                    46.233699f,9.248590f, 46.327546f,9.299244f, 46.414645f,9.279947f, 46.436073f,9.247956f, 46.496763f,9.282694f,
                    46.509382f,9.363222f, 46.466889f,9.411659f, 46.508876f,9.463549f, 46.375856f,9.461186f, 46.302342f,9.549538f,
                    46.291812f,9.709832f, 46.348354f,9.735805f, 45.421424f,9.735805f, 45.421424f,8.979315f);
            poly[1766] = new TzPolygon(46.348354f,9.735805f, 46.350704f,9.736884f, 46.334793f,9.777525f, 46.379301f,9.952759f, 46.351170f,9.996288f,
                    46.284943f,9.995907f, 46.265841f,10.055524f, 46.229639f,10.043943f, 46.224879f,10.132300f, 46.258277f,10.176503f,
                    46.342197f,10.105944f, 46.407385f,10.166884f, 46.442724f,10.042054f, 46.540118f,10.043958f, 46.610720f,10.102350f,
                    46.616950f,10.215315f, 46.635352f,10.238877f, 46.575009f,10.246058f, 46.549976f,10.296064f, 46.542624f,10.471227f,
                    46.615116f,10.492294f, 45.421424f,10.492294f, 45.421424f,9.735805f);
            poly[1767] = new TzPolygon(46.615116f,10.492294f, 46.641277f,10.446126f, 46.637182f,10.401302f, 46.684305f,10.381797f, 46.708999f,10.416068f,
                    46.733732f,10.400621f, 46.753840f,10.442602f, 46.788243f,10.422706f, 46.859075f,10.478728f, 46.854689f,10.492294f);
            poly[1768] = new TzPolygon(46.859075f,10.079057f, 46.859075f,10.196466f, 46.840885f,10.105242f);
            poly[1769] = new TzPolygon(46.849692f,10.492294f, 46.854913f,10.469654f, 46.859075f,10.470643f, 46.859075f,10.492294f);
            poly[1770] = new TzPolygon(47.536729f,9.529250f, 47.536925f,9.514684f, 47.594830f,9.445129f, 47.659123f,9.255817f, 47.653984f,9.175971f,
                    47.686540f,9.023718f, 47.673081f,8.979315f, 47.808465f,8.979315f, 47.808465f,9.529250f);
            poly[1771] = new TzPolygon(47.053492f,9.529250f, 47.063310f,9.471674f, 47.096556f,9.519311f, 47.181443f,9.485841f, 47.267605f,9.529250f);
            poly[1772] = new TzPolygon(47.391818f,10.079184f, 47.409794f,10.069171f, 47.414997f,10.079184f);
            poly[1773] = new TzPolygon(47.466553f,10.079184f, 47.487622f,10.044775f, 47.482106f,10.000764f, 47.545859f,9.970480f, 47.529636f,9.921895f,
                    47.548143f,9.881247f, 47.528537f,9.874505f, 47.547695f,9.815755f, 47.579972f,9.827282f, 47.596101f,9.799986f,
                    47.589117f,9.765531f, 47.533956f,9.734784f, 47.536729f,9.529250f, 47.808465f,9.529250f, 47.808465f,10.079184f);
            poly[1774] = new TzPolygon(47.053492f,9.529250f, 47.267605f,9.529250f, 47.270581f,9.530749f, 47.205347f,9.584895f, 47.170246f,9.564626f,
                    47.151295f,9.621721f, 47.096237f,9.635714f, 47.048429f,9.558942f);
            poly[1775] = new TzPolygon(47.545995f,9.529250f, 47.537176f,9.550566f, 47.463310f,9.595143f, 47.452205f,9.658976f, 47.383875f,9.673845f,
                    47.351478f,9.605284f, 47.267607f,9.529250f);
            poly[1776] = new TzPolygon(47.054436f,9.529250f, 47.062098f,9.681840f, 47.012531f,9.836120f, 47.021227f,9.876246f, 46.934628f,9.876130f,
                    46.901615f,10.017818f, 46.859075f,10.079184f, 46.859075f,9.529250f);
            poly[1777] = new TzPolygon(46.859075f,10.196558f, 46.866293f,10.232665f, 46.931370f,10.240583f, 46.925177f,10.316052f, 46.989590f,10.346511f,
                    46.993881f,10.376011f, 46.859075f,10.376011f);
            poly[1778] = new TzPolygon(46.993881f,10.376011f, 46.997125f,10.398309f, 46.958902f,10.423887f, 46.937789f,10.489352f, 46.859075f,10.471738f,
                    46.859075f,10.376011f);
            poly[1779] = new TzPolygon(47.391818f,10.079184f, 47.414997f,10.079184f, 47.428717f,10.105586f, 47.458928f,10.091638f, 47.466553f,10.079184f,
                    47.808465f,10.079184f, 47.808465f,10.492294f, 47.548552f,10.492294f, 47.555797f,10.454429f, 47.503763f,10.431301f,
                    47.432223f,10.475946f, 47.412688f,10.437421f, 47.380363f,10.436765f, 47.375605f,10.394730f, 47.304816f,10.330333f,
                    47.270111f,10.178342f, 47.381921f,10.236186f, 47.392426f,10.181849f, 47.354786f,10.099812f);
            poly[1780] = new TzPolygon(49.199539f,4.940364f, 49.199539f,6.717566f, 49.163672f,6.738557f, 49.151282f,6.834175f, 49.178924f,6.861944f,
                    49.199539f,6.847509f, 49.199539f,7.009738f, 49.191436f,7.035031f, 49.112947f,7.052035f, 49.155764f,7.102006f,
                    49.120827f,7.157451f, 49.114989f,7.293556f, 49.143261f,7.362681f, 49.172041f,7.365325f, 49.184267f,7.445790f,
                    49.164733f,7.434638f, 49.169406f,7.493976f, 49.097117f,7.528568f, 49.073569f,7.629522f, 49.054911f,7.631330f,
                    49.048435f,7.716329f, 48.312917f,7.716329f, 48.301636f,7.693542f, 48.221560f,7.666537f, 48.121948f,7.578077f,
                    48.034570f,7.568901f, 47.972499f,7.621897f, 47.878036f,7.556578f, 47.808465f,7.537407f, 47.808465f,4.940364f);
            poly[1781] = new TzPolygon(49.797925f,4.940364f, 49.800900f,4.994275f, 49.763456f,5.094389f, 49.693430f,5.164256f, 49.696571f,5.268511f,
                    49.654492f,5.332169f, 49.611653f,5.312107f, 49.630986f,5.352139f, 49.596025f,5.428408f, 49.498799f,5.465123f,
                    49.529277f,5.556029f, 49.505954f,5.610967f, 49.538808f,5.634355f, 49.199539f,5.634355f, 49.199539f,4.940364f);
            poly[1782] = new TzPolygon(49.895076f,6.246260f, 49.895076f,6.328347f, 49.840450f,6.328347f, 49.838453f,6.321425f, 49.869131f,6.311735f);
            poly[1783] = new TzPolygon(49.895076f,5.739429f, 49.872927f,5.784033f, 49.871920f,5.753927f, 49.833616f,5.739191f, 49.791456f,5.755156f,
                    49.795755f,5.790365f, 49.749546f,5.830561f, 49.723520f,5.826334f, 49.709282f,5.886934f, 49.680450f,5.862047f,
                    49.662495f,5.910643f, 49.595936f,5.847780f, 49.574295f,5.872801f, 49.546381f,5.818575f, 49.563341f,5.771264f,
                    49.539462f,5.747154f, 49.550630f,5.643238f, 49.538333f,5.634355f, 49.895076f,5.634355f);
            poly[1784] = new TzPolygon(49.538808f,5.634355f, 49.550444f,5.642639f, 49.539462f,5.747154f, 49.563230f,5.774427f, 49.542583f,5.837076f,
                    49.499912f,5.866262f, 49.500232f,5.943154f, 49.451870f,5.980314f, 49.447854f,6.041774f, 49.466440f,6.058107f,
                    49.452890f,6.100775f, 49.510307f,6.174974f, 49.514937f,6.240651f, 49.469858f,6.328347f, 49.199539f,6.328347f,
                    49.199539f,5.634355f);
            poly[1785] = new TzPolygon(49.895076f,6.246260f, 49.900122f,6.233526f, 49.950085f,6.223913f, 49.968859f,6.190428f, 49.953489f,6.177614f,
                    50.059698f,6.112249f, 50.141639f,6.154502f, 50.169082f,6.139677f, 50.182034f,6.192321f, 50.235283f,6.175596f,
                    50.266452f,6.278515f, 50.320190f,6.306470f, 50.314422f,6.328347f, 49.895076f,6.328347f);
            poly[1786] = new TzPolygon(50.489572f,6.328347f, 50.494324f,6.226578f, 50.530274f,6.196914f, 50.590613f,6.234097f, 50.590613f,6.328347f);
            poly[1787] = new TzPolygon(50.590613f,6.241090f, 50.590232f,6.242513f, 50.536095f,6.197034f, 50.556391f,6.174083f);
            poly[1788] = new TzPolygon(49.895076f,5.740342f, 49.896927f,5.735701f, 49.960800f,5.775023f, 49.982290f,5.838556f, 50.012810f,5.818987f,
                    50.028877f,5.859877f, 50.112162f,5.895316f, 50.131360f,5.961331f, 50.172630f,5.963679f, 50.182796f,6.024782f,
                    50.154233f,6.057571f, 50.171913f,6.083643f, 50.163353f,6.119818f, 49.998598f,6.137976f, 49.953573f,6.178762f,
                    49.969545f,6.190371f, 49.950085f,6.223913f, 49.900114f,6.233904f, 49.895076f,6.246840f);
            poly[1789] = new TzPolygon(50.489572f,6.328347f, 50.488544f,6.350361f, 50.462402f,6.340426f, 50.439640f,6.377497f, 50.380332f,6.342976f,
                    50.335407f,6.408097f, 50.305187f,6.363375f, 50.314422f,6.328347f);
            poly[1790] = new TzPolygon(49.837038f,6.328347f, 49.850966f,6.364096f, 49.810839f,6.429697f, 49.822786f,6.471567f, 49.805746f,6.531248f,
                    49.789755f,6.506121f, 49.722967f,6.517397f, 49.668741f,6.431086f, 49.620649f,6.422300f, 49.573397f,6.358545f,
                    49.556654f,6.383329f, 49.530581f,6.357695f, 49.459868f,6.368853f, 49.477268f,6.328347f);
            poly[1791] = new TzPolygon(49.469858f,6.328347f, 49.466940f,6.334024f, 49.476948f,6.428027f, 49.432552f,6.541634f, 49.401199f,6.540992f,
                    49.367111f,6.602300f, 49.347831f,6.565773f, 49.280265f,6.670322f, 49.199539f,6.717566f, 49.199539f,6.328347f);
            poly[1792] = new TzPolygon(49.199539f,6.847509f, 49.213348f,6.837839f, 49.222448f,6.938230f, 49.199539f,7.009738f);
            poly[1793] = new TzPolygon(49.048435f,7.716329f, 49.045315f,7.757288f, 49.065751f,7.794434f, 49.032962f,7.867340f, 49.057923f,7.933977f,
                    48.989700f,8.088006f, 48.966447f,8.232522f, 48.898004f,8.142094f, 48.803562f,8.089000f, 48.758173f,7.972375f,
                    48.721486f,7.963228f, 48.640971f,7.839391f, 48.585230f,7.800773f, 48.512588f,7.804730f, 48.489241f,7.767986f,
                    48.395677f,7.732599f, 48.326749f,7.744269f, 48.312917f,7.716329f);
            poly[1794] = new TzPolygon(51.193868f,5.634355f, 51.222269f,5.560610f, 51.295203f,5.515774f, 51.300165f,5.483017f, 51.262286f,5.417412f,
                    51.275764f,5.346140f, 51.261353f,5.237914f, 51.305219f,5.242193f, 51.315539f,5.134330f, 51.374293f,5.086725f,
                    51.374293f,5.634355f);
            poly[1795] = new TzPolygon(50.982453f,5.745626f, 50.982453f,5.894023f, 50.974865f,5.897086f, 50.982453f,6.026372f, 50.934701f,6.018202f,
                    50.920572f,6.094181f, 50.846538f,6.074171f, 50.846256f,6.018946f, 50.814132f,6.025029f, 50.802353f,5.975742f,
                    50.774153f,6.027643f, 50.754288f,6.021009f, 50.750366f,5.915081f, 50.770157f,5.886477f, 50.756054f,5.807621f,
                    50.783245f,5.773575f, 50.757074f,5.739179f, 50.757535f,5.682060f, 50.811515f,5.693854f, 50.847675f,5.638866f,
                    50.951657f,5.758822f, 50.962421f,5.720128f);
            poly[1796] = new TzPolygon(50.982453f,5.634355f, 50.982453f,5.745626f, 50.962421f,5.720128f, 50.951657f,5.758822f, 50.871350f,5.644159f,
                    50.820082f,5.653991f, 50.811515f,5.693854f, 50.757535f,5.682060f, 50.757074f,5.739179f, 50.783245f,5.773575f,
                    50.756045f,5.807696f, 50.770157f,5.886477f, 50.751401f,5.901630f, 50.754676f,6.019823f, 50.718392f,6.039231f,
                    50.720028f,6.118596f, 50.662140f,6.165814f, 50.663146f,6.194752f, 50.640408f,6.187157f, 50.642337f,6.265972f,
                    50.590613f,6.234097f, 50.590613f,5.634355f);
            poly[1797] = new TzPolygon(50.982453f,6.026372f, 50.982453f,5.894023f, 51.051104f,5.866315f, 51.066883f,5.913208f, 51.034726f,5.957778f,
                    51.084246f,5.997794f, 51.158464f,6.175422f, 51.173339f,6.138802f, 51.194414f,6.165170f, 51.171634f,6.082190f,
                    51.242556f,6.072653f, 51.360336f,6.226387f, 51.374293f,6.225077f, 51.374293f,6.328347f, 50.982453f,6.328347f);
            poly[1798] = new TzPolygon(51.193868f,5.634355f, 51.184745f,5.658044f, 51.188678f,5.749090f, 51.151304f,5.777646f, 51.167841f,5.824311f,
                    51.144626f,5.855783f, 51.118422f,5.809850f, 51.097364f,5.832421f, 51.091479f,5.796023f, 50.999738f,5.767628f,
                    50.982453f,5.745626f, 50.982453f,5.634355f);
            poly[1799] = new TzPolygon(51.374293f,6.225077f, 51.513391f,6.212024f, 51.605849f,6.091424f, 51.655973f,6.118088f, 51.674056f,6.032350f,
                    51.716913f,6.044939f, 51.738118f,5.955155f, 51.770246f,5.992067f, 51.824266f,5.945479f, 51.865451f,6.063486f,
                    51.840722f,6.166560f, 51.892474f,6.103448f, 51.905195f,6.154272f, 51.869021f,6.210177f, 51.874115f,6.279730f,
                    51.855458f,6.328347f, 51.374293f,6.328347f);
        }
    }

    private static class Initializer19 {
        private static void init() {
            poly[1800] = new TzPolygon(51.408804f,4.940364f, 51.486533f,5.040210f, 51.431349f,5.104573f, 51.393495f,5.071166f, 51.374293f,5.086725f,
                    51.374293f,4.940364f);
            poly[1801] = new TzPolygon(52.157972f,6.901910f, 52.120462f,6.855474f, 52.118780f,6.760572f, 52.081925f,6.747612f, 52.069800f,6.694663f,
                    52.039856f,6.687853f, 51.993527f,6.826608f, 51.964105f,6.828529f, 51.896063f,6.721970f, 51.917577f,6.683994f,
                    51.853833f,6.472511f, 51.873968f,6.390566f, 51.828020f,6.407206f, 51.856535f,6.328347f, 52.157972f,6.328347f);
            poly[1802] = new TzPolygon(53.490918f,4.940364f, 53.536006f,5.044296f, 53.636463f,5.437024f, 53.696390f,6.224829f, 53.725332f,6.346001f,
                    53.457358f,6.915925f, 53.326540f,7.005912f, 53.332182f,7.187602f, 53.180279f,7.227499f, 53.138286f,7.178902f,
                    53.007037f,7.217445f, 52.849887f,7.087258f, 52.643420f,7.055729f, 52.648111f,6.752598f, 52.627493f,6.710033f,
                    52.561637f,6.766692f, 52.553317f,6.680880f, 52.486323f,6.697524f, 52.435426f,6.941658f, 52.469767f,6.987623f,
                    52.373611f,7.072154f, 52.291968f,7.026454f, 52.234711f,7.061284f, 52.225347f,6.985315f, 52.157972f,6.901910f,
                    52.157972f,4.940364f);
            poly[1803] = new TzPolygon(-3.553387f,100.300923f, -3.424582f,100.176380f, -2.964457f,99.844738f, -1.803979f,98.721478f, -1.332093f,98.433470f,
                    -0.169271f,97.663582f, 0.727396f,97.134961f, 4.176873f,97.134961f, 4.176873f,99.172697f, 3.935072f,99.622349f,
                    3.325631f,100.300923f);
            poly[1804] = new TzPolygon(6.222332f,99.504759f, 6.306667f,99.458333f, 6.459000f,99.504759f);
            poly[1805] = new TzPolygon(6.459000f,100.145117f, 6.417029f,100.118084f, 6.406152f,100.075877f, 6.459000f,100.004163f);
            poly[1806] = new TzPolygon(-1.935469f,105.915805f, -1.935469f,100.300923f, 3.325631f,100.300923f, 3.002867f,100.660301f, 2.830029f,101.039862f,
                    1.920000f,102.223333f, 1.686667f,102.583333f, 1.325000f,103.065000f, 1.184772f,103.658320f, 1.130361f,103.740694f,
                    1.269500f,104.033333f, 1.283518f,104.315712f, 1.251780f,104.375792f, 1.256107f,104.415769f, 1.400590f,104.573297f,
                    1.417090f,104.634254f, 1.355714f,104.924190f, 2.310499f,105.368734f, 2.653459f,105.200173f, 2.748322f,105.179603f,
                    2.841524f,105.206713f, 3.229672f,105.438484f, 3.498222f,105.842201f, 3.527061f,105.915805f);
            poly[1807] = new TzPolygon(1.513160f,104.484564f, 1.442101f,104.570680f, 1.410949f,104.552966f, 1.317201f,104.389134f, 1.333227f,104.348840f,
                    1.410472f,104.378484f);
            poly[1808] = new TzPolygon(1.478472f,103.812667f, 1.427944f,103.897861f, 1.434639f,104.071194f, 1.405944f,104.092667f, 1.357500f,104.079722f,
                    1.275820f,104.125176f, 1.269500f,104.033333f, 1.130361f,103.740694f, 1.184772f,103.658320f, 1.195500f,103.566667f,
                    1.428139f,103.673889f, 1.457472f,103.714111f, 1.448382f,103.760490f);
            poly[1809] = new TzPolygon(6.459000f,100.673031f, 6.442584f,100.652058f, 6.459000f,100.624518f);
            poly[1810] = new TzPolygon(6.459000f,100.752832f, 6.459000f,102.158549f, 6.225371f,102.080293f, 6.145603f,102.092832f, 6.080038f,102.053897f,
                    6.030808f,101.977879f, 5.948741f,101.929431f, 5.861696f,101.938358f, 5.837726f,101.884297f, 5.790679f,101.866431f,
                    5.789340f,101.836423f, 5.732966f,101.817145f, 5.796998f,101.754056f, 5.755099f,101.691310f, 5.812515f,101.658266f,
                    5.874668f,101.659336f, 5.877125f,101.623328f, 5.934389f,101.581776f, 5.869828f,101.485938f, 5.875732f,101.391499f,
                    5.808435f,101.346132f, 5.800732f,101.263769f, 5.711545f,101.259990f, 5.612851f,101.135866f, 5.720430f,101.082949f,
                    5.744327f,101.060196f, 5.737950f,101.033922f, 5.807188f,100.983990f, 5.837487f,101.011915f, 5.912997f,101.025848f,
                    5.909150f,101.085024f, 5.977001f,101.124436f, 6.050244f,101.100330f, 6.106913f,101.126637f, 6.142269f,101.058677f,
                    6.192645f,101.126671f, 6.251647f,101.112415f, 6.246667f,101.015275f, 6.283147f,100.968991f, 6.243286f,100.944661f,
                    6.234653f,100.898934f, 6.264557f,100.872348f, 6.232137f,100.853324f, 6.442185f,100.812580f, 6.457799f,100.753164f);
            poly[1811] = new TzPolygon(-9.213233f,116.484180f, -9.116408f,115.959179f, -9.020404f,115.570006f, -9.050229f,115.167114f, -9.030136f,114.932466f,
                    -8.640124f,114.775299f, -8.515231f,114.553804f, -8.317852f,114.423837f, -8.167545f,114.412678f, -8.083922f,114.430950f,
                    -8.032990f,114.493281f, -7.745848f,114.640455f, -7.462796f,114.940578f, -7.559994f,116.343764f, -5.413892f,116.484180f);
            poly[1812] = new TzPolygon(-4.787207f,111.199993f, -4.636698f,110.152550f, -4.038794f,109.069791f, -2.420267f,109.389795f, -1.499140f,109.613986f,
                    -1.287466f,109.349316f, -1.050869f,109.374226f, -0.941903f,108.770155f, -0.278773f,108.104511f, -0.211034f,108.099105f,
                    -0.211034f,111.199993f);
            poly[1813] = new TzPolygon(-0.211034f,108.099105f, 0.463495f,108.045268f, 1.036378f,108.176047f, 1.672612f,108.557899f, -0.211034f,108.557899f);
            poly[1814] = new TzPolygon(1.983621f,108.557899f, 1.983621f,108.826576f, 1.705643f,108.577723f, 1.672612f,108.557899f);
            poly[1815] = new TzPolygon(1.983621f,109.602469f, 1.983621f,110.385133f, 1.943325f,110.762619f, 1.983621f,110.775504f, 1.983621f,111.199993f,
                    1.080563f,111.199993f, 1.052356f,111.142006f, 1.028350f,110.905498f, 0.950351f,110.859907f, 0.949542f,110.808793f,
                    0.900484f,110.804848f, 0.932043f,110.768873f, 0.900012f,110.755319f, 0.907969f,110.722513f, 0.875973f,110.667690f,
                    0.908880f,110.633232f, 0.872061f,110.628208f, 0.853821f,110.575779f, 0.907950f,110.445990f, 0.996504f,110.395363f,
                    0.983340f,110.359112f, 1.012883f,110.338983f, 0.993429f,110.324291f, 0.995608f,110.277732f, 1.044174f,110.286464f,
                    1.056443f,110.262579f, 1.117429f,110.241385f, 1.118425f,110.209244f, 1.183033f,110.192202f, 1.208644f,110.063714f,
                    1.264529f,110.064896f, 1.298320f,109.979388f, 1.386160f,109.970898f, 1.424988f,109.930779f, 1.422531f,109.835739f,
                    1.486129f,109.839284f, 1.465806f,109.806848f, 1.499455f,109.798879f, 1.618805f,109.662244f, 1.782389f,109.685380f,
                    1.805430f,109.636342f, 1.792406f,109.585432f, 1.926707f,109.538003f, 1.936602f,109.564366f, 1.971165f,109.560275f);
            poly[1816] = new TzPolygon(4.178276f,108.557899f, 3.130781f,109.087641f, 2.765220f,109.327860f, 2.314645f,109.712679f, 2.240892f,109.284549f,
                    2.060420f,108.895328f, 1.983621f,108.826576f, 1.983621f,108.557899f);
            poly[1817] = new TzPolygon(1.983621f,108.826576f, 2.060420f,108.895328f, 2.240892f,109.284549f, 2.314645f,109.712679f, 1.990885f,109.627076f,
                    1.983621f,109.602469f);
            poly[1818] = new TzPolygon(-5.166854f,113.842086f, -4.787207f,111.199993f, -0.156353f,111.199993f, -0.156353f,113.842086f);
            poly[1819] = new TzPolygon(-5.166854f,113.842086f, -5.188271f,113.991131f, -4.962731f,114.569983f, -5.413892f,116.484180f, -5.413892f,113.842086f);
            poly[1820] = new TzPolygon(-2.785122f,113.842086f, -2.785122f,114.668830f, -2.801798f,114.664398f, -2.820952f,114.591110f, -2.985991f,114.504349f,
                    -3.123973f,114.479454f, -3.256827f,114.397675f, -3.409321f,114.352249f, -5.188271f,113.991131f, -5.166854f,113.842086f);
            poly[1821] = new TzPolygon(-0.156353f,114.929198f, -0.187609f,114.934532f, -0.172656f,114.989830f, -0.189664f,115.042076f, -0.156353f,115.077487f,
                    -0.156353f,115.270192f, -0.185406f,115.271118f, -0.237449f,115.238037f, -0.290918f,115.252952f, -0.297019f,115.227531f,
                    -0.377468f,115.240296f, -0.392700f,115.259987f, -0.445195f,115.245659f, -0.584802f,115.353432f, -0.807876f,115.384628f,
                    -0.847368f,115.500595f, -0.941658f,115.577721f, -0.991624f,115.651795f, -1.053920f,115.673500f, -1.089950f,115.743690f,
                    -1.133034f,115.756523f, -1.110980f,115.796669f, -1.159088f,115.848801f, -1.225874f,115.773033f, -1.309029f,115.755051f,
                    -1.362798f,115.695687f, -1.369236f,115.639267f, -1.430521f,115.522308f, -1.434890f,115.400528f, -1.806883f,115.310280f,
                    -1.930419f,115.351013f, -2.001198f,115.278229f, -2.084868f,115.324738f, -2.226269f,115.291229f, -2.198445f,115.240793f,
                    -2.241325f,115.205765f, -2.464023f,114.875748f, -2.516467f,114.867706f, -2.592400f,114.797592f, -2.677604f,114.789429f,
                    -2.721837f,114.760796f, -2.741452f,114.680435f, -2.785122f,114.668830f, -2.785122f,113.842086f, -0.156353f,113.842086f);
            poly[1822] = new TzPolygon(1.080563f,111.199993f, 1.092659f,111.224859f, 1.063542f,111.254495f, 1.009402f,111.405038f, 1.034425f,111.489160f,
                    0.948770f,111.540036f, 0.978351f,111.548115f, 0.974471f,111.576784f, 1.008344f,111.595319f, 1.042810f,111.666717f,
                    1.025919f,111.713783f, 1.007522f,111.716339f, 1.021217f,111.761899f, 0.985382f,111.825993f, 1.009120f,111.866257f,
                    1.065864f,111.880363f, 1.087913f,111.927977f, 1.118363f,111.935099f, 1.141844f,112.153926f, 1.185633f,112.141734f,
                    1.219024f,112.168339f, 1.249536f,112.158417f, 1.384027f,112.226127f, 1.410877f,112.194981f, 1.450102f,112.207967f,
                    1.466334f,112.276421f, 1.504802f,112.318599f, 1.522840f,112.430465f, 1.580127f,112.500396f, 1.576884f,112.521039f,
                    -0.156353f,112.521039f, -0.156353f,111.199993f);
            poly[1823] = new TzPolygon(1.378445f,113.842086f, 1.363842f,113.814832f, 1.347243f,113.831015f, 1.298865f,113.810023f, 1.262716f,113.702905f,
                    1.214801f,113.664608f, 1.216023f,113.630021f, 1.306261f,113.581862f, 1.319808f,113.544468f, 1.285490f,113.419081f,
                    1.376949f,113.325766f, 1.397501f,113.232756f, 1.379463f,113.181474f, 1.393376f,113.141321f, 1.445000f,113.106343f,
                    1.404214f,113.018862f, 1.408681f,112.974682f, 1.449565f,112.982078f, 1.473583f,113.040317f, 1.492817f,113.031726f,
                    1.529479f,113.070780f, 1.558477f,113.058502f, 1.581031f,113.002996f, 1.563456f,112.975146f, 1.587597f,112.884834f,
                    1.536973f,112.842289f, 1.561504f,112.775873f, 1.552326f,112.677372f, 1.576884f,112.521039f, 2.251313f,112.521039f,
                    2.251313f,113.842086f);
            poly[1824] = new TzPolygon(0.678057f,113.842086f, 0.682427f,113.835930f, 0.688293f,113.842086f);
            poly[1825] = new TzPolygon(0.567496f,114.502610f, 0.570971f,114.458847f, 0.496475f,114.411675f, 0.544621f,114.315567f, 0.542460f,114.196503f,
                    0.571010f,114.186737f, 0.588004f,114.148285f, 0.624841f,114.172524f, 0.668237f,114.154976f, 0.702554f,114.108139f,
                    0.654619f,114.005112f, 0.669926f,113.979294f, 0.644550f,113.889290f, 0.678057f,113.842086f, 0.688293f,113.842086f,
                    0.738568f,113.894852f, 0.787091f,113.888802f, 0.837593f,113.926224f, 0.892773f,113.874580f, 0.986690f,113.918297f,
                    1.051824f,113.894195f, 1.062758f,113.941544f, 1.144212f,113.986115f, 1.132457f,114.046440f, 1.158032f,114.076144f,
                    1.158032f,114.098293f, 1.154349f,114.116730f, 1.158032f,114.118632f, 1.158032f,114.502610f);
            poly[1826] = new TzPolygon(0.567496f,114.502610f, 0.566203f,114.518898f, 0.631387f,114.538437f, 0.642474f,114.615219f, 0.707473f,114.658226f,
                    0.729420f,114.699554f, 0.707390f,114.711044f, 0.744053f,114.760040f, 0.752551f,114.823639f, 0.701840f,114.876495f,
                    0.739129f,114.864182f, 0.795387f,114.907959f, 0.755860f,114.970169f, 0.606785f,115.012581f, 0.429567f,115.135979f,
                    0.387551f,115.132294f, 0.303103f,115.050056f, 0.330075f,115.017662f, 0.318639f,114.907868f, 0.178784f,114.802017f,
                    0.096718f,114.788262f, 0.071208f,114.808861f, 0.079081f,114.835091f, 0.043918f,114.895020f, -0.156353f,114.929198f,
                    -0.156353f,114.502610f);
            poly[1827] = new TzPolygon(-0.156353f,115.077487f, -0.152006f,115.082108f, -0.136540f,115.143883f, -0.112539f,115.163133f, -0.156353f,115.163133f);
            poly[1828] = new TzPolygon(2.472417f,114.502610f, 1.463936f,114.502610f, 1.520857f,114.409349f, 1.456316f,114.301106f, 1.447183f,114.240070f,
                    1.410170f,114.212800f, 1.464838f,114.143050f, 1.450053f,113.975734f, 1.378445f,113.842086f, 2.472417f,113.842086f);
            poly[1829] = new TzPolygon(1.375381f,113.842086f, 1.415637f,113.937169f, 1.442389f,113.954206f, 1.462072f,114.148806f, 1.409688f,114.206948f,
                    1.378585f,114.147705f, 1.292598f,114.141708f, 1.266364f,114.160767f, 1.223713f,114.125969f, 1.198879f,114.139725f,
                    1.158032f,114.118994f, 1.158032f,114.105240f, 1.161623f,114.080315f, 1.158032f,114.076144f, 1.158032f,113.842086f);
            poly[1830] = new TzPolygon(2.472417f,115.133177f, 2.405602f,115.090740f, 2.407500f,115.046330f, 2.389266f,115.048163f, 2.351031f,114.993688f,
                    2.368460f,114.958234f, 2.319098f,114.946271f, 2.295237f,114.966466f, 2.259317f,114.914757f, 2.271990f,114.863978f,
                    2.250538f,114.799825f, 2.199211f,114.779485f, 2.144541f,114.780241f, 2.100404f,114.810469f, 2.050270f,114.793103f,
                    2.022807f,114.808797f, 2.038590f,114.878745f, 1.952575f,114.847595f, 1.915208f,114.878692f, 1.893051f,114.816434f,
                    1.850281f,114.791930f, 1.869543f,114.743725f, 1.856295f,114.716295f, 1.832595f,114.726135f, 1.808154f,114.691855f,
                    1.785323f,114.714011f, 1.671484f,114.711149f, 1.589578f,114.648779f, 1.574207f,114.614209f, 1.500762f,114.611000f,
                    1.426394f,114.564120f, 1.463936f,114.502610f, 2.472417f,114.502610f);
            poly[1831] = new TzPolygon(2.472417f,115.196042f, 2.471333f,115.194706f, 2.472417f,115.181036f);
            poly[1832] = new TzPolygon(-0.112539f,115.163133f, -0.072771f,115.195030f, -0.031912f,115.300827f, -0.094687f,115.321472f, -0.146387f,115.269875f,
                    -0.156353f,115.270192f, -0.156353f,115.163133f);
            poly[1833] = new TzPolygon(2.472417f,115.133177f, 2.476028f,115.135471f, 2.473835f,115.163133f, 2.472417f,115.163133f);
            poly[1834] = new TzPolygon(2.602831f,115.163133f, 2.581023f,115.109890f, 2.604176f,115.086801f, 2.647171f,115.117157f, 2.698431f,115.092075f,
                    2.744320f,115.141147f, 2.786702f,115.152945f, 2.823242f,115.089701f, 2.872227f,115.151115f, 2.913823f,115.151546f,
                    2.920102f,115.163133f);
            poly[1835] = new TzPolygon(4.143958f,114.502610f, 4.147168f,114.495056f, 4.277930f,114.450666f, 4.253058f,114.422414f, 4.263627f,114.316447f,
                    4.348711f,114.332961f, 4.366241f,114.306565f, 4.415427f,114.307962f, 4.507013f,114.260148f, 4.531405f,114.199079f,
                    4.573385f,114.162633f, 4.585762f,114.075873f, 4.644981f,114.084068f, 4.711617f,114.387875f, 4.793189f,114.502610f);
            poly[1836] = new TzPolygon(4.143958f,114.502610f, 4.126005f,114.544863f, 4.082332f,114.553755f, 4.030251f,114.627305f, 4.003752f,114.610283f,
                    4.006242f,114.649205f, 4.043715f,114.718511f, 4.125509f,114.793267f, 4.157216f,114.808841f, 4.163593f,114.793827f,
                    4.278230f,114.856871f, 4.257110f,114.814042f, 4.370680f,114.880175f, 4.425415f,114.882836f, 4.431277f,114.828498f,
                    4.675364f,114.802287f, 4.724727f,114.770046f, 4.744994f,114.823854f, 4.791400f,114.850850f, 4.816056f,114.896272f,
                    4.808121f,114.971114f, 4.872678f,114.988478f, 4.896608f,115.025019f, 4.879355f,115.052196f, 4.807100f,115.026916f,
                    4.790447f,115.055182f, 4.748180f,115.022028f, 4.731235f,115.043384f, 4.699158f,115.029060f, 4.650714f,115.051180f,
                    4.619458f,115.041124f, 4.491729f,115.094916f, 4.385356f,115.090630f, 4.375983f,115.163133f, 3.786801f,115.163133f,
                    3.786801f,114.502610f);
            poly[1837] = new TzPolygon(4.869922f,115.163133f, 4.871965f,115.149559f, 5.025120f,115.158255f, 5.101186f,115.127175f, 5.101186f,115.163133f);
            poly[1838] = new TzPolygon(3.786801f,115.163133f, 3.786801f,115.592549f, 3.746949f,115.579430f, 3.610793f,115.576107f, 3.439953f,115.652220f,
                    3.409477f,115.618518f, 3.447643f,115.603961f, 3.450207f,115.579626f, 3.320044f,115.524817f, 3.193500f,115.521719f,
                    3.162243f,115.567383f, 3.113556f,115.519050f, 3.057923f,115.519564f, 3.014589f,115.483647f, 3.028477f,115.453258f,
                    2.982320f,115.406385f, 2.973734f,115.335026f, 3.049621f,115.285465f, 2.966703f,115.249122f, 2.920102f,115.163133f);
            poly[1839] = new TzPolygon(2.602831f,115.163133f, 2.606299f,115.171601f, 2.505989f,115.237426f, 2.472417f,115.196042f, 2.474379f,115.163133f);
            poly[1840] = new TzPolygon(4.375983f,115.163133f, 4.869922f,115.163133f, 4.866841f,115.183609f, 4.803432f,115.234862f, 4.654929f,115.259010f,
                    4.617146f,115.288086f, 4.447714f,115.272289f, 4.344772f,115.363562f, 4.296282f,115.322593f, 4.338030f,115.295885f,
                    4.341178f,115.245820f, 4.366136f,115.239297f);
            poly[1841] = new TzPolygon(3.786801f,115.592549f, 3.868863f,115.619562f, 3.919186f,115.558352f, 3.965616f,115.641812f, 4.198469f,115.704937f,
                    4.193915f,115.730658f, 4.250636f,115.766061f, 4.225911f,115.801082f, 4.240417f,115.829175f, 4.262310f,115.824314f,
                    4.300458f,115.869539f, 4.381725f,115.871926f, 4.394929f,115.901053f, 4.354244f,115.929873f, 4.358224f,115.975764f,
                    4.329962f,116.034957f, 4.294902f,116.039047f, 4.276432f,116.079010f, 4.338853f,116.119837f, 4.342334f,116.162773f,
                    4.393069f,116.171055f, 4.363134f,116.271777f, 4.391382f,116.348513f, 4.325673f,116.432749f, 4.288749f,116.440956f,
                    4.304104f,116.475474f, 4.332117f,116.484180f, 3.786801f,116.484180f);
            poly[1842] = new TzPolygon(-8.456017f,127.805486f, -8.419017f,127.533539f, -8.278743f,127.396826f, -8.223622f,127.189225f, -8.232061f,126.762467f,
                    -8.175800f,126.459693f, -8.250913f,125.827526f, -8.089546f,125.672749f, -8.232748f,125.339849f, -6.757426f,125.550085f,
                    -4.729002f,125.596191f, -3.881070f,125.039536f, -3.881070f,127.805486f);
            poly[1843] = new TzPolygon(-10.952956f,122.144833f, -3.881070f,122.144833f, -3.881070f,125.039536f, -4.729002f,125.596191f, -6.757426f,125.550085f,
                    -8.232748f,125.339849f, -8.444061f,125.239797f, -8.519182f,125.098021f, -8.741556f,124.936249f, -8.965317f,124.952974f,
                    -8.995987f,124.933881f, -9.046556f,124.940045f, -9.063977f,125.002643f, -9.022168f,125.076943f, -8.965648f,125.112829f,
                    -9.029054f,125.187207f, -9.123018f,125.171046f, -9.156458f,125.192625f, -9.174904f,125.174863f, -9.200527f,125.097099f,
                    -9.175379f,125.074535f, -9.169020f,125.013610f, -9.201237f,124.981996f, -9.289943f,124.994288f, -9.328838f,125.051229f,
                    -9.463234f,125.087007f, -9.575219f,125.256347f, -9.754785f,125.159427f, -10.281660f,124.604072f, -11.004075f,123.320488f,
                    -11.185785f,122.972047f, -11.208567f,122.890027f, -11.196335f,122.805700f);
            poly[1844] = new TzPolygon(-3.881070f,127.805486f, -3.881070f,125.039536f, -3.762846f,124.961924f, -2.795617f,124.961924f, -2.560815f,124.400629f,
                    -2.309948f,124.257366f, -1.461553f,123.923230f, -0.553412f,124.869435f, 0.252980f,125.522474f, 0.937001f,125.526076f,
                    1.740634f,125.911966f, 2.043478f,126.251824f, 2.904694f,127.087383f, 3.446428f,127.805486f);
            poly[1845] = new TzPolygon(4.332117f,116.484180f, 4.336921f,116.485673f, 4.323244f,116.537019f, 4.375662f,116.536021f, 4.407823f,116.567627f,
                    4.374295f,116.586406f, 4.376697f,116.611950f, 4.334260f,116.630064f, 4.351524f,116.666993f, 4.333299f,116.701778f,
                    4.389008f,116.752053f, 4.337895f,116.789688f, 4.351181f,116.810854f, 4.327203f,116.840211f, 4.368741f,116.907719f,
                    4.337996f,116.965015f, 4.346185f,117.004118f, 4.318717f,117.019327f, 4.346800f,117.041863f, 4.333271f,117.106142f,
                    4.353974f,117.151325f, 4.335833f,117.196510f, 4.373960f,117.245912f, 4.310210f,117.296203f, 4.285203f,117.371583f,
                    4.171232f,117.476161f, 4.161496f,117.529338f, 4.180764f,117.578629f, 4.141305f,117.608159f, 4.165461f,117.641939f,
                    4.165851f,117.899197f, 4.190580f,117.958606f, 4.096962f,118.264775f, 3.446428f,118.472828f, 3.446428f,116.484180f);
            poly[1846] = new TzPolygon(5.115101f,119.438198f, 4.992470f,119.278603f, 4.848414f,118.989559f, 4.813268f,118.626088f, 4.710189f,118.588547f,
                    4.587590f,118.695789f, 4.525749f,118.796903f, 4.452692f,118.837734f, 4.300022f,118.472828f, 5.115101f,118.472828f);
            poly[1847] = new TzPolygon(5.123982f,119.439088f, 5.335249f,119.424588f, 5.533282f,119.351704f, 5.637040f,119.082705f, 6.257730f,117.882329f,
                    6.459000f,117.885240f, 6.459000f,119.439088f);
            poly[1848] = new TzPolygon(5.115101f,119.439088f, 6.459000f,119.439088f, 6.459000f,126.482711f, 6.158626f,126.359432f, 5.256972f,125.624537f,
                    5.177872f,125.490749f, 5.166893f,125.347485f, 5.194041f,125.262903f, 5.964372f,124.179766f, 6.229067f,122.315812f,
                    5.897730f,122.077245f, 5.023963f,120.785794f, 4.615980f,119.955013f, 4.297512f,119.439088f);
            poly[1849] = new TzPolygon(3.067000f,131.133677f, 3.051000f,131.169761f, 3.015000f,131.183524f, 2.965000f,131.163257f, 2.948000f,131.122726f,
                    2.966000f,131.084655f, 3.009000f,131.068546f, 3.052000f,131.088010f);
            poly[1850] = new TzPolygon(-65.969656f,40.227580f, -64.000000f,55.000000f, -86.000000f,55.000000f, -86.000000f,40.227580f);
            poly[1851] = new TzPolygon(-64.000000f,55.000000f, -68.000000f,77.500000f, -86.000000f,77.500000f, -86.000000f,55.000000f);
            poly[1852] = new TzPolygon(-83.450436f,86.000000f, -84.666699f,77.500000f, -64.000000f,77.500000f, -64.000000f,86.000000f);
            poly[1853] = new TzPolygon(-64.000000f,97.000000f, -65.000000f,120.000000f, -70.000000f,120.000000f, -70.000000f,97.000000f);
            poly[1854] = new TzPolygon(-65.000000f,160.000000f, -70.000000f,160.000000f, -70.000000f,120.000000f, -65.000000f,120.000000f);
            poly[1855] = new TzPolygon(-64.000000f,97.000000f, -70.000000f,97.000000f, -70.000000f,115.000000f, -86.000000f,115.000000f, -86.000000f,86.000000f,
                    -65.000000f,86.000000f);
            poly[1856] = new TzPolygon(-70.000000f,160.000000f, -86.000000f,160.000000f, -86.000000f,115.000000f, -70.000000f,115.000000f);
            poly[1857] = new TzPolygon(-40.272229f,144.228491f, -40.308592f,144.208295f, -40.322885f,144.162477f, -40.321453f,144.147165f);
            poly[1858] = new TzPolygon(-25.996391f,129.000570f, -25.997567f,134.366448f, -25.998606f,129.000570f);
            poly[1859] = new TzPolygon(-31.300000f,129.001919f, -31.687564f,129.002049f, -31.741613f,129.001395f, -31.898525f,128.672388f, -32.039765f,128.304163f,
                    -32.127842f,128.026224f, -32.185412f,127.730819f, -32.267953f,127.534090f, -32.323276f,127.269647f, -32.363031f,126.674959f,
                    -32.326376f,126.352160f, -32.294245f,126.236921f, -32.302016f,126.154684f, -32.335994f,125.979073f, -32.615355f,125.500000f,
                    -31.300000f,125.500000f);
            poly[1860] = new TzPolygon(-25.996391f,129.001483f, -31.300000f,129.001919f, -31.300000f,125.500000f, -32.615355f,125.500000f, -32.658573f,125.328331f,
                    -32.760928f,125.130021f, -32.775204f,125.061151f, -32.879144f,124.921139f, -32.944849f,124.773710f, -32.998492f,124.407549f,
                    -33.056787f,124.276980f, -33.099635f,124.235687f, -25.996391f,124.235687f);
            poly[1861] = new TzPolygon(-25.996672f,134.366448f, -25.996863f,137.999053f, -25.997567f,134.366448f);
            poly[1862] = new TzPolygon(-39.198478f,146.253664f, -39.198483f,146.594326f, -39.198487f,146.253674f);
            poly[1863] = new TzPolygon(-35.454133f,140.962267f, -35.454133f,141.923254f, -38.335742f,141.923254f, -38.320928f,141.890887f, -38.303609f,141.746940f,
                    -38.327639f,141.684497f, -38.406844f,141.734490f, -38.458326f,141.690218f, -38.454617f,141.608336f, -38.482877f,141.537983f,
                    -38.424864f,141.333109f, -38.380072f,141.300654f, -38.325317f,141.322584f, -38.278971f,141.276493f, -38.188257f,141.149832f,
                    -38.108457f,140.965810f, -35.799788f,140.961902f);
            poly[1864] = new TzPolygon(-32.425390f,141.002106f, -34.021140f,141.002780f, -34.030023f,140.987711f, -33.980797f,140.963821f, -35.454133f,140.964531f,
                    -35.454133f,137.999053f, -32.425390f,137.999053f);
            poly[1865] = new TzPolygon(-34.128301f,141.923254f, -34.111223f,141.903384f, -34.137886f,141.877667f, -34.090715f,141.732385f, -34.114233f,141.718455f,
                    -34.095354f,141.707598f, -34.100844f,141.677736f, -34.138113f,141.611788f, -34.155074f,141.618991f, -34.151817f,141.583188f,
                    -34.190979f,141.602124f, -34.191188f,141.532975f, -34.215917f,141.511320f, -34.154879f,141.497499f, -34.168178f,141.446071f,
                    -34.109970f,141.358746f, -34.138783f,141.324935f, -34.112414f,141.317450f, -34.078134f,141.259564f, -34.087584f,141.242813f,
                    -34.061928f,141.242715f, -34.061722f,141.205906f, -34.091951f,141.184950f, -34.073326f,141.174601f, -34.082118f,141.153668f,
                    -34.054530f,141.153047f, -34.050658f,141.094236f, -34.076054f,141.089013f, -34.049937f,141.065644f, -34.061103f,141.042460f,
                    -34.035717f,141.034875f, -34.057312f,141.019443f, -34.038184f,141.001703f, -32.425390f,141.001174f, -32.425390f,141.923254f);
            poly[1866] = new TzPolygon(-35.639889f,144.130866f, -35.639889f,145.847455f, -35.975778f,145.847455f, -35.991370f,145.810040f, -35.960240f,145.778210f,
                    -35.950590f,145.716770f, -35.920980f,145.698180f, -35.925920f,145.673990f, -35.884010f,145.620420f, -35.862155f,145.625888f,
                    -35.874588f,145.600542f, -35.802105f,145.535336f, -35.818190f,145.522426f, -35.804765f,145.477977f, -35.866978f,145.355408f,
                    -35.850556f,145.258587f, -35.830465f,145.246429f, -35.842789f,145.153699f, -35.820577f,145.126921f, -35.852021f,144.992387f,
                    -35.865567f,144.967900f, -35.960163f,144.957231f, -35.988609f,144.923256f, -36.072648f,144.981010f, -36.082761f,144.948590f,
                    -36.058908f,144.863086f, -36.123135f,144.807693f, -36.117066f,144.726575f, -36.085319f,144.719133f, -36.094588f,144.684207f,
                    -36.061506f,144.689864f, -36.074553f,144.654417f, -36.047440f,144.633530f, -36.076842f,144.618150f, -36.031369f,144.616145f,
                    -36.042562f,144.591498f, -36.007409f,144.564107f, -35.995242f,144.516796f, -35.969365f,144.520862f, -35.903940f,144.407870f,
                    -35.858780f,144.411270f, -35.852040f,144.381260f, -35.792980f,144.376850f, -35.767140f,144.349110f, -35.754685f,144.295558f,
                    -35.737362f,144.295698f, -35.752709f,144.265927f, -35.693250f,144.221232f, -35.640800f,144.131354f);
            poly[1867] = new TzPolygon(-34.129618f,141.923254f, -34.137609f,141.932946f, -34.119480f,141.945000f, -34.136110f,141.970440f, -34.112700f,141.977650f,
                    -34.125180f,142.021590f, -34.105250f,142.012930f, -34.099430f,142.037540f, -34.122980f,142.027560f, -34.131420f,142.075640f,
                    -34.173550f,142.082770f, -34.152270f,142.165860f, -34.182780f,142.165940f, -34.181110f,142.219230f, -34.209527f,142.243590f,
                    -34.306970f,142.235890f, -34.296500f,142.285880f, -34.326570f,142.283870f, -34.337750f,142.396570f, -34.396630f,142.350970f,
                    -34.468930f,142.353090f, -34.478090f,142.384160f, -34.498800f,142.359590f, -34.493640f,142.394820f, -34.515280f,142.374940f,
                    -34.522750f,142.400570f, -34.530450f,142.367690f, -34.560005f,142.413779f, -34.836264f,142.413779f, -34.836264f,141.923254f);
            poly[1868] = new TzPolygon(-34.560005f,142.413779f, -34.032639f,142.413779f, -34.032639f,142.904304f, -34.665258f,142.904304f, -34.680180f,142.887770f,
                    -34.665460f,142.860660f, -34.627450f,142.868340f, -34.590180f,142.787690f, -34.560720f,142.810090f, -34.546390f,142.791430f,
                    -34.580390f,142.784070f, -34.576760f,142.748290f, -34.600140f,142.759170f, -34.599740f,142.699780f, -34.652710f,142.689260f,
                    -34.676750f,142.710440f, -34.680150f,142.678930f, -34.724160f,142.699510f, -34.739210f,142.678670f, -34.721810f,142.661960f,
                    -34.728750f,142.618320f, -34.780750f,142.638690f, -34.759380f,142.524220f, -34.739120f,142.499560f, -34.703670f,142.518860f,
                    -34.674290f,142.497430f, -34.662570f,142.517110f, -34.672620f,142.475590f, -34.636430f,142.483640f, -34.633500f,142.452330f,
                    -34.564190f,142.467880f, -34.559720f,142.448690f, -34.584270f,142.451620f);
            poly[1869] = new TzPolygon(-35.484778f,143.885355f, -35.479980f,143.858780f, -35.437810f,143.818460f, -35.423070f,143.762850f, -35.387830f,143.751000f,
                    -35.392540f,143.709180f, -35.368450f,143.684520f, -35.401040f,143.642340f, -35.387680f,143.620420f, -35.337170f,143.561840f,
                    -35.281660f,143.590860f, -35.243550f,143.563720f, -35.207240f,143.571270f, -35.219310f,143.472120f, -35.189190f,143.449650f,
                    -35.192140f,143.394460f, -35.145510f,143.390790f, -35.036730f,143.322080f, -35.010890f,143.338120f, -34.952600f,143.317700f,
                    -34.932530f,143.342790f, -34.888460f,143.321390f, -34.858240f,143.352560f, -34.792440f,143.349250f, -34.791770f,143.275870f,
                    -34.772800f,143.252130f, -34.752690f,143.274020f, -34.758730f,143.224380f, -34.729470f,143.218850f, -34.718140f,143.165360f,
                    -34.697880f,143.161410f, -34.714650f,143.148130f, -34.692660f,143.127790f, -34.701470f,143.107240f, -34.681020f,143.113160f,
                    -34.701270f,143.092830f, -34.678510f,143.071040f, -34.698850f,143.054820f, -34.685870f,143.040630f, -34.702610f,143.039700f,
                    -34.662590f,142.989750f, -34.695140f,142.972430f, -34.647880f,142.923560f, -34.665258f,142.904304f, -34.032639f,142.904304f,
                    -34.032639f,143.885355f);
            poly[1870] = new TzPolygon(-35.484778f,143.885355f, -35.500080f,143.970100f, -35.554660f,143.989860f, -35.549290f,144.039310f, -35.591352f,144.104858f,
                    -35.639889f,144.130866f, -35.639889f,143.885355f);
            poly[1871] = new TzPolygon(-25.996945f,137.999053f, -25.996391f,140.999389f, -32.425390f,141.002106f, -32.425390f,137.999053f);
            poly[1872] = new TzPolygon(-28.999078f,145.847455f, -28.999101f,140.999265f, -25.996391f,140.999389f, -25.996391f,145.847455f);
            poly[1873] = new TzPolygon(-31.556108f,141.486461f, -31.596576f,141.502453f, -31.569808f,141.599095f, -31.587384f,141.608940f, -31.595651f,141.697162f,
                    -31.641739f,141.694114f, -31.630820f,141.776268f, -31.594015f,141.782027f, -31.593012f,141.972585f, -31.780015f,141.959984f,
                    -31.779926f,142.000239f, -31.831700f,141.999972f, -31.831608f,141.972328f, -31.975438f,141.970795f, -31.974451f,141.855829f,
                    -32.045098f,141.868613f, -32.060923f,141.943437f, -32.213280f,141.942826f, -32.210831f,141.920251f, -32.256551f,141.908605f,
                    -32.304175f,141.928095f, -32.294343f,141.847611f, -32.269489f,141.851104f, -32.266714f,141.305501f, -32.246809f,141.304690f,
                    -32.241255f,141.244292f, -32.199720f,141.248315f, -32.186303f,141.111949f, -32.228512f,141.112624f, -32.218293f,141.001106f,
                    -31.591590f,141.000917f, -31.591970f,141.211964f, -31.559531f,141.211846f, -31.559750f,141.296904f, -31.591879f,141.296829f,
                    -31.592045f,141.424714f);
            poly[1874] = new TzPolygon(-35.990353f,147.537553f, -35.943567f,147.494037f, -35.960800f,147.450680f, -35.943496f,147.404633f, -36.061326f,147.319099f,
                    -36.039703f,147.285487f, -36.036802f,147.144115f, -35.994500f,147.123360f, -36.107880f,147.052960f, -36.078100f,146.956540f,
                    -36.115950f,146.943390f, -36.073680f,146.872950f, -36.088720f,146.825030f, -36.055120f,146.803690f, -36.060660f,146.748540f,
                    -36.023720f,146.731640f, -36.039430f,146.683470f, -35.995890f,146.613630f, -35.974020f,146.617550f, -35.968720f,146.561950f,
                    -35.992200f,146.549190f, -35.957870f,146.502150f, -35.991440f,146.498300f, -35.965630f,146.422460f, -36.051060f,146.369480f,
                    -36.026360f,146.338680f, -36.042150f,146.284470f, -36.011000f,146.282890f, -36.041990f,146.185380f, -36.020340f,146.174160f,
                    -36.020610f,146.132500f, -36.003090f,146.134330f, -36.021070f,146.094210f, -35.994710f,146.031490f, -36.015800f,145.972370f,
                    -35.961390f,145.953530f, -35.973830f,145.927390f, -35.952560f,145.903170f, -35.975778f,145.847455f, -35.639889f,145.847455f,
                    -35.639889f,147.537553f);
            poly[1875] = new TzPolygon(-37.207349f,149.227650f, -36.796100f,148.194440f, -36.800600f,148.108261f, -36.734284f,148.130813f, -36.672123f,148.198555f,
                    -36.598715f,148.216918f, -36.558087f,148.150187f, -36.566712f,148.133284f, -36.463139f,148.123256f, -36.390439f,148.037865f,
                    -36.319700f,148.059366f, -36.310270f,148.034751f, -36.142045f,148.038985f, -36.121480f,147.990544f, -36.046082f,147.999472f,
                    -36.042601f,147.924245f, -35.995309f,147.912207f, -35.968635f,147.776599f, -35.928650f,147.707769f, -35.979117f,147.601146f,
                    -35.964663f,147.548874f, -35.984216f,147.583958f, -36.004291f,147.550517f, -35.990353f,147.537553f, -35.639889f,147.537553f,
                    -35.639889f,149.227650f);
            poly[1876] = new TzPolygon(-37.207349f,149.227650f, -37.528014f,150.033282f, -37.615503f,149.945185f, -37.603912f,149.817266f, -37.724153f,149.718078f,
                    -37.824894f,149.501123f, -37.826520f,149.354801f, -37.857667f,149.289474f, -37.834354f,149.227650f);
            poly[1877] = new TzPolygon(-28.999078f,145.847455f, -28.999064f,148.958088f, -28.956577f,149.031888f, -28.841904f,149.080637f, -28.835541f,149.127868f,
                    -28.806729f,149.139570f, -28.803032f,149.179195f, -28.775082f,149.188651f, -28.743269f,149.269295f, -28.709748f,149.296744f,
                    -28.684063f,149.358575f, -28.696172f,149.387485f, -28.594808f,149.452617f, -28.574344f,149.503005f, -28.573376f,149.587236f,
                    -28.601097f,149.610967f, -28.609299f,149.660710f, -28.631865f,149.666661f, -28.633916f,149.703938f, -28.609426f,149.721174f,
                    -28.610244f,149.771656f, -32.425390f,149.771656f, -32.425390f,145.847455f);
            poly[1878] = new TzPolygon(-28.610244f,149.771656f, -28.613577f,149.977245f, -28.580564f,150.015358f, -28.584279f,150.080043f, -28.550201f,150.152515f,
                    -28.574300f,150.212604f, -28.537181f,150.290049f, -28.664309f,150.442216f, -28.654311f,150.525002f, -28.671524f,150.544079f,
                    -28.653064f,150.554094f, -28.676621f,150.632054f, -28.633464f,150.752343f, -28.693797f,150.874008f, -28.687706f,150.906384f,
                    -28.730938f,150.938189f, -28.740805f,151.010650f, -28.844482f,151.045321f, -28.836489f,151.103147f, -28.938926f,151.274808f,
                    -29.100769f,151.279649f, -29.134499f,151.315471f, -29.165531f,151.314762f, -29.177875f,151.393962f, -29.070805f,151.502292f,
                    -29.019909f,151.498230f, -28.952998f,151.545566f, -28.929234f,151.634688f, -28.871784f,151.706536f, -28.871579f,151.733756f,
                    -29.210890f,151.733756f, -29.210890f,149.771656f);
            poly[1879] = new TzPolygon(-28.871579f,151.733756f, -28.959885f,151.777834f, -28.944636f,151.806394f, -28.959829f,151.832232f, -28.907850f,151.849363f,
                    -28.929307f,151.916048f, -28.895483f,151.997593f, -28.907663f,152.009703f, -28.864696f,152.038126f, -28.850626f,152.015064f,
                    -28.731623f,152.042726f, -28.708175f,152.076049f, -28.680968f,152.066354f, -28.664951f,152.010168f, -28.518904f,151.955645f,
                    -28.503395f,151.982893f, -28.525613f,151.988951f, -28.525281f,152.016864f, -28.468003f,152.070200f, -28.433123f,152.160504f,
                    -28.449236f,152.217189f, -28.363168f,152.309659f, -28.368554f,152.386160f, -28.333089f,152.417259f, -28.298101f,152.414572f,
                    -28.298822f,152.444831f, -28.259373f,152.463586f, -28.262631f,152.534221f, -28.306250f,152.525981f, -28.338976f,152.579242f,
                    -28.269555f,152.614517f, -28.310997f,152.638288f, -28.346902f,152.714807f, -29.210890f,152.714807f, -29.210890f,151.733756f);
            poly[1880] = new TzPolygon(-27.603641f,153.534850f, -27.618403f,153.528719f, -27.890851f,153.482936f, -28.055767f,153.500630f, -28.111770f,153.542700f,
                    -28.141526f,153.603882f, -28.177630f,153.534643f, -28.157020f,153.476931f, -28.249619f,153.356812f, -28.233636f,153.278912f,
                    -28.265110f,153.231833f, -28.247458f,153.178049f, -28.294163f,153.168505f, -28.318641f,153.124665f, -28.357543f,153.108829f,
                    -28.338311f,152.933856f, -28.309607f,152.880013f, -28.363914f,152.751062f, -28.346902f,152.714807f, -27.603641f,152.714807f);
            poly[1881] = new TzPolygon(-25.996391f,129.000570f, -14.707478f,129.000445f, -14.708009f,129.001483f, -25.996391f,129.001483f);
            poly[1882] = new TzPolygon(-25.996391f,137.999053f, -16.539456f,137.994646f, -16.484366f,138.027371f, -25.996391f,138.027371f);
            poly[1883] = new TzPolygon(-19.977697f,148.787694f, -20.016283f,148.992117f, -20.205394f,149.212503f, -20.255385f,149.238945f, -20.475565f,149.189641f,
                    -20.530763f,149.214170f, -20.570000f,149.120000f, -20.570000f,149.030000f, -20.450000f,148.950000f, -20.420000f,148.860000f,
                    -20.380000f,148.842000f, -20.320000f,148.834000f, -20.270000f,148.880000f);
            poly[1884] = new TzPolygon(-21.090611f,166.874347f, -21.080477f,166.865086f, -20.929584f,166.468337f, -20.930015f,166.367461f, -20.879970f,166.254915f,
                    -20.703179f,166.058459f, -20.106159f,166.058459f, -20.102631f,166.064135f, -20.086588f,166.159441f, -20.138913f,166.329693f,
                    -20.201515f,166.674506f, -20.295830f,166.800609f, -20.456060f,167.088431f, -20.487535f,167.274583f, -20.530540f,167.369629f,
                    -20.949373f,167.973079f, -21.090611f,168.068422f);
            poly[1885] = new TzPolygon(21.738194f,89.060866f, 21.790972f,89.028729f, 21.861154f,89.044145f, 21.906791f,89.023664f, 21.923331f,89.060866f);
            poly[1886] = new TzPolygon(22.048888f,89.060866f, 22.102492f,89.039936f, 22.121441f,89.060866f);
            poly[1887] = new TzPolygon(22.208629f,89.060866f, 22.285746f,88.995978f, 22.298709f,89.024052f, 22.326189f,88.984774f, 22.391153f,88.992074f,
                    22.411279f,88.972343f, 22.429582f,89.000087f, 22.469407f,88.996204f, 22.560277f,88.941530f, 22.616647f,88.960010f,
                    22.618998f,88.934542f, 22.652065f,88.926853f, 22.694160f,88.962134f, 22.757699f,88.911741f, 22.796835f,88.959147f,
                    22.844969f,88.968522f, 22.880812f,88.945278f, 22.879846f,88.910689f, 22.952410f,88.893969f, 22.942687f,88.859516f,
                    22.978859f,88.871128f, 23.009241f,88.844903f, 23.006929f,88.879971f, 23.101101f,88.868423f, 23.174888f,88.952459f,
                    23.174888f,89.060866f);
            poly[1888] = new TzPolygon(24.228335f,88.740514f, 24.192778f,88.745278f, 24.171389f,88.708333f, 24.090556f,88.698611f, 24.031609f,88.747053f,
                    24.002222f,88.722778f, 23.919167f,88.736944f, 23.868056f,88.669722f, 23.879154f,88.619261f, 23.863169f,88.574583f,
                    23.816675f,88.600351f, 23.785258f,88.554567f, 23.762033f,88.578692f, 23.649490f,88.555798f, 23.638390f,88.591108f,
                    23.602679f,88.577678f, 23.607595f,88.641067f, 23.547992f,88.657694f, 23.480823f,88.742988f, 23.498849f,88.799207f,
                    23.447112f,88.788792f, 23.449074f,88.764746f, 23.401516f,88.747925f, 23.367527f,88.763174f, 23.341111f,88.734722f,
                    23.307616f,88.745306f, 23.319775f,88.730457f, 23.298807f,88.725758f, 23.302238f,88.696208f, 23.248056f,88.724722f,
                    23.245223f,88.769355f, 23.218517f,88.789814f, 23.221573f,88.811451f, 23.256613f,88.811653f, 23.233880f,88.824126f,
                    23.213018f,88.995886f, 23.174888f,88.952459f, 23.174888f,87.852748f, 24.228335f,87.852748f);
            poly[1889] = new TzPolygon(25.281781f,87.852748f, 25.281781f,89.008545f, 25.264838f,89.008220f, 25.255143f,88.956081f, 25.208643f,88.960891f,
                    25.210654f,88.936853f, 25.176692f,88.948017f, 25.164422f,88.922738f, 25.213537f,88.843550f, 25.170533f,88.805820f,
                    25.189943f,88.769187f, 25.176748f,88.749112f, 25.207594f,88.709077f, 25.204254f,88.612719f, 25.175266f,88.563806f,
                    25.210849f,88.498763f, 25.195306f,88.463157f, 25.207806f,88.438687f, 25.069444f,88.460000f, 24.870278f,88.342500f,
                    24.885556f,88.264167f, 24.920087f,88.263450f, 24.961855f,88.222752f, 24.937527f,88.136851f, 24.851373f,88.162259f,
                    24.812506f,88.109020f, 24.781087f,88.103657f, 24.770710f,88.067650f, 24.725324f,88.062793f, 24.668858f,88.007531f,
                    24.625556f,88.082222f, 24.508611f,88.125556f, 24.434444f,88.323889f, 24.320833f,88.497778f, 24.294167f,88.652222f,
                    24.316667f,88.691111f, 24.250833f,88.737500f, 24.228335f,88.740514f, 24.228335f,87.852748f);
            poly[1890] = new TzPolygon(25.594218f,88.456807f, 25.597138f,88.444532f, 25.664507f,88.454244f, 25.696774f,88.371173f, 25.717050f,88.374232f,
                    25.783290f,88.266475f, 25.808387f,88.269228f, 25.786347f,88.210182f, 25.801902f,88.183789f, 25.775765f,88.151801f,
                    25.798346f,88.114505f, 25.916747f,88.085681f, 25.947476f,88.121575f, 26.013007f,88.139448f, 26.025478f,88.182271f,
                    26.073065f,88.182815f, 26.080037f,88.158690f, 26.147894f,88.177370f, 26.220479f,88.350723f, 26.282472f,88.349541f,
                    26.315305f,88.415136f, 26.328951f,88.403346f, 26.335228f,88.433596f, 26.335228f,88.456807f);
            poly[1891] = new TzPolygon(25.594218f,88.456807f, 25.584053f,88.499533f, 25.559314f,88.493780f, 25.542127f,88.532725f, 25.508715f,88.539823f,
                    25.516504f,88.608898f, 25.496797f,88.648609f, 25.477937f,88.646864f, 25.471314f,88.699411f, 25.502046f,88.722540f,
                    25.496073f,88.765507f, 25.526607f,88.759345f, 25.523339f,88.810385f, 25.458332f,88.839595f, 25.410585f,88.813826f,
                    25.397606f,88.841070f, 25.363973f,88.840838f, 25.325688f,88.884212f, 25.337747f,88.906119f, 25.304275f,88.929667f,
                    25.303183f,89.008956f, 25.281781f,89.008545f, 25.281781f,88.456807f);
            poly[1892] = new TzPolygon(26.335228f,88.952320f, 26.331683f,88.952286f, 26.335228f,88.953828f, 26.335228f,88.991173f, 26.329826f,89.000879f,
                    26.308837f,88.982390f, 26.291973f,88.995447f, 26.304758f,89.006900f, 26.290272f,89.018335f, 26.309300f,89.021512f,
                    26.276626f,89.039803f, 26.291410f,89.060866f, 26.241551f,89.050713f, 26.242057f,88.953253f, 26.288768f,88.898344f,
                    26.273475f,88.861742f, 26.233551f,88.877815f, 26.230782f,88.841703f, 26.310060f,88.793449f, 26.309227f,88.749084f,
                    26.289312f,88.745534f, 26.262995f,88.666487f, 26.297483f,88.668326f, 26.287371f,88.709785f, 26.320169f,88.675147f,
                    26.321464f,88.747533f, 26.335228f,88.746746f);
            poly[1893] = new TzPolygon(26.335228f,88.711947f, 26.332605f,88.704627f, 26.335228f,88.703311f);
            poly[1894] = new TzPolygon(21.738194f,89.060866f, 21.608393f,89.139904f, 21.426719f,89.139934f, 21.399144f,89.060866f);
            poly[1895] = new TzPolygon(22.048888f,89.060866f, 21.992306f,89.082959f, 21.928832f,89.073238f, 21.923331f,89.060866f);
            poly[1896] = new TzPolygon(22.208629f,89.060866f, 22.196900f,89.070735f, 22.150477f,89.070063f, 22.155090f,89.098032f, 22.121441f,89.060866f);
            poly[1897] = new TzPolygon(26.236786f,89.139934f, 26.279503f,89.100053f, 26.315911f,89.104685f, 26.287154f,89.123246f, 26.320197f,89.136206f,
                    26.323278f,89.083587f, 26.335228f,89.098607f, 26.335228f,89.139934f);
            poly[1898] = new TzPolygon(21.008819f,92.005127f, 21.008819f,92.265655f, 20.946866f,92.271914f, 20.724815f,92.375761f, 20.649211f,92.342932f,
                    20.589273f,92.362834f, 20.565212f,92.428584f, 20.384866f,92.398306f, 20.375658f,92.337882f, 20.390847f,92.256422f,
                    20.434093f,92.187363f, 20.550570f,92.110539f, 20.626828f,92.094335f, 20.737469f,92.130210f, 20.970596f,92.030041f);
            poly[1899] = new TzPolygon(23.864359f,91.242650f, 23.864359f,91.809154f, 23.346406f,91.809154f, 23.274167f,91.768611f, 23.121735f,91.809154f,
                    23.078124f,91.809154f, 22.994722f,91.725000f, 22.986389f,91.647222f, 22.943056f,91.613611f, 22.973611f,91.601667f,
                    22.998333f,91.549444f, 23.186667f,91.493333f, 23.266111f,91.416667f, 23.263333f,91.392778f, 23.206944f,91.377500f,
                    23.069444f,91.402222f, 23.066944f,91.374722f, 23.102871f,91.348368f, 23.252974f,91.327494f, 23.328333f,91.288611f,
                    23.364167f,91.314722f, 23.373333f,91.282222f, 23.481389f,91.248889f, 23.512500f,91.207500f, 23.640556f,91.159444f,
                    23.663056f,91.162222f, 23.654444f,91.190000f, 23.678056f,91.200278f, 23.700833f,91.159167f, 23.736667f,91.158611f,
                    23.756111f,91.216389f, 23.837410f,91.254079f);
        }
    }

    private static class Initializer20 {
        private static void init() {
            poly[1900] = new TzPolygon(26.001897f,89.807239f, 26.041944f,89.778056f, 26.083889f,89.781389f, 26.156389f,89.739167f, 26.163828f,89.681519f,
                    26.172525f,89.701237f, 26.201801f,89.673555f, 26.213063f,89.691850f, 26.238246f,89.679267f, 26.220378f,89.671848f,
                    26.229604f,89.634238f, 26.190625f,89.648609f, 26.184521f,89.627699f, 26.181274f,89.655554f, 26.164513f,89.649187f,
                    26.180498f,89.608907f, 26.154637f,89.610302f, 26.157303f,89.590835f, 26.117539f,89.603909f, 26.118513f,89.630088f,
                    26.098562f,89.596279f, 26.107282f,89.629775f, 26.062831f,89.650118f, 26.063649f,89.605080f, 25.969083f,89.577048f,
                    25.970106f,89.540226f, 26.005655f,89.543871f, 26.011575f,89.430088f, 26.047507f,89.423717f, 26.006680f,89.393258f,
                    26.009608f,89.349337f, 26.065607f,89.282209f, 26.064091f,89.254069f, 26.092106f,89.267487f, 26.123939f,89.229636f,
                    26.138324f,89.155327f, 26.236786f,89.139934f, 26.335228f,89.139934f, 26.335228f,89.807239f);
            poly[1901] = new TzPolygon(25.822924f,89.807239f, 25.936111f,89.865833f, 25.946944f,89.820556f, 25.988056f,89.855833f, 26.002500f,89.834167f,
                    25.989722f,89.816111f, 26.001897f,89.807239f, 26.335228f,89.807239f, 26.335228f,90.474544f, 25.158937f,90.474544f,
                    25.147222f,90.438333f, 25.224722f,90.110556f, 25.310000f,89.917222f, 25.286873f,89.877111f, 25.293000f,89.842588f,
                    25.373889f,89.814444f, 25.640556f,89.864444f, 25.725556f,89.819722f);
            poly[1902] = new TzPolygon(25.158937f,90.474544f, 25.174722f,90.523333f, 25.181111f,90.653056f, 25.159722f,90.682500f, 25.176111f,90.776111f,
                    25.149722f,90.862500f, 25.197883f,91.081959f, 25.207778f,91.257778f, 25.174262f,91.336821f, 25.172674f,91.415511f,
                    25.152496f,91.470203f, 25.135023f,91.471095f, 25.172778f,91.590278f, 25.141944f,91.600833f, 25.126667f,91.648889f,
                    25.134167f,91.694722f, 25.159444f,91.711111f, 25.150556f,91.746944f, 25.173889f,91.757500f, 25.172577f,91.809154f,
                    24.230123f,91.809154f, 24.239167f,91.757778f, 24.162778f,91.757778f, 24.148333f,91.734722f, 24.156944f,91.694722f,
                    24.224167f,91.657222f, 24.117500f,91.634167f, 24.102222f,91.611944f, 24.086944f,91.546389f, 24.101944f,91.373333f,
                    23.995278f,91.361111f, 23.993889f,91.298333f, 23.896424f,91.229052f, 23.864359f,91.242650f, 23.864359f,90.474544f);
            poly[1903] = new TzPolygon(21.008819f,92.265655f, 21.077748f,92.258691f, 21.120575f,92.203333f, 21.159113f,92.200500f, 21.159869f,92.176143f,
                    21.181229f,92.171942f, 21.233321f,92.219626f, 21.329070f,92.197886f, 21.362872f,92.258528f, 21.430670f,92.270233f,
                    21.419407f,92.324266f, 21.479008f,92.367767f, 21.434634f,92.424171f, 21.364911f,92.438892f, 21.359469f,92.476458f,
                    21.008819f,92.476458f);
            poly[1904] = new TzPolygon(22.340421f,92.568760f, 22.162778f,92.606111f, 22.137222f,92.598889f, 22.133333f,92.562222f, 21.881667f,92.621667f,
                    21.794722f,92.599444f, 21.483333f,92.616389f, 21.287354f,92.680498f, 21.246104f,92.597624f, 21.382621f,92.558901f,
                    21.388472f,92.517386f, 21.355817f,92.501666f, 21.359469f,92.476458f, 22.340421f,92.476458f);
            poly[1905] = new TzPolygon(22.340421f,92.568760f, 22.340421f,93.143763f, 22.246112f,93.143763f, 22.245800f,93.142626f, 22.239829f,93.143763f,
                    22.188491f,93.143763f, 22.205833f,93.047500f, 22.118889f,93.052778f, 22.115000f,93.016111f, 22.060833f,92.989444f,
                    22.003889f,93.006111f, 21.991389f,92.984722f, 22.028333f,92.943056f, 21.953611f,92.901111f, 22.048889f,92.865556f,
                    22.159722f,92.718611f, 22.152222f,92.697500f, 22.095000f,92.699444f, 22.099722f,92.678056f, 22.026944f,92.679722f,
                    21.981944f,92.600833f, 22.133333f,92.562222f, 22.137222f,92.598889f, 22.162778f,92.606111f);
            poly[1906] = new TzPolygon(23.078124f,91.809154f, 23.087222f,91.818333f, 23.121735f,91.809154f, 23.346406f,91.809154f, 23.410278f,91.845000f,
                    23.444444f,91.933056f, 23.496667f,91.964444f, 23.672023f,91.936959f, 23.672023f,92.005776f, 23.645278f,92.030556f,
                    23.651905f,92.069761f, 23.672023f,92.089591f, 23.672023f,92.206656f, 23.652222f,92.211667f, 23.672023f,92.223094f,
                    23.672023f,92.281675f, 23.605000f,92.278333f, 23.277778f,92.384444f, 23.223611f,92.348611f, 23.052778f,92.383611f,
                    22.941944f,92.374722f, 22.889444f,92.443889f, 22.756389f,92.470556f, 22.715833f,92.516389f, 22.547222f,92.525278f,
                    22.340421f,92.568760f, 22.340421f,91.809154f);
            poly[1907] = new TzPolygon(22.452392f,93.143763f, 22.455060f,93.139028f, 22.524202f,93.129285f, 22.526401f,93.107463f, 22.593594f,93.141277f,
                    22.671903f,93.096113f, 22.806921f,93.095362f, 22.911823f,93.135390f, 22.911065f,93.143763f);
            poly[1908] = new TzPolygon(22.952966f,93.143763f, 23.003056f,93.119474f, 23.058444f,93.133372f, 23.050979f,93.143763f);
            poly[1909] = new TzPolygon(23.672023f,93.431080f, 23.647954f,93.416165f, 23.540203f,93.418316f, 23.504048f,93.394236f, 23.383498f,93.401371f,
                    23.352682f,93.355366f, 23.217173f,93.388908f, 23.144137f,93.367998f, 23.143025f,93.386897f, 23.006148f,93.292592f,
                    23.011446f,93.229700f, 23.059843f,93.184041f, 23.043499f,93.154175f, 23.052557f,93.143763f, 23.672023f,93.143763f);
            poly[1910] = new TzPolygon(22.952966f,93.143763f, 22.909140f,93.165015f, 22.911065f,93.143763f);
            poly[1911] = new TzPolygon(22.452392f,93.143763f, 22.428552f,93.186068f, 22.262140f,93.202204f, 22.246112f,93.143763f);
            poly[1912] = new TzPolygon(22.239829f,93.143763f, 22.186667f,93.153889f, 22.188491f,93.143763f);
            poly[1913] = new TzPolygon(23.672023f,91.936959f, 23.732222f,91.950000f, 23.672023f,92.005776f);
            poly[1914] = new TzPolygon(23.672023f,92.089591f, 23.735000f,92.151667f, 23.720278f,92.194444f, 23.672023f,92.206656f);
            poly[1915] = new TzPolygon(23.672023f,92.223094f, 23.722500f,92.252222f, 23.705278f,92.283333f, 23.672023f,92.281675f);
            poly[1916] = new TzPolygon(25.172577f,91.809154f, 25.168339f,91.976016f, 25.187778f,92.040833f, 25.140000f,92.193056f, 25.093056f,92.241667f,
                    25.079444f,92.332500f, 25.051389f,92.342222f, 25.030556f,92.406389f, 24.968889f,92.422778f, 24.960976f,92.471260f,
                    24.941942f,92.448055f, 24.948433f,92.488015f, 24.889444f,92.496944f, 24.871667f,92.478611f, 24.857778f,92.389444f,
                    24.905000f,92.293611f, 24.896389f,92.248056f, 24.773889f,92.256667f, 24.565278f,92.191111f, 24.513889f,92.132500f,
                    24.414167f,92.135278f, 24.374722f,92.086389f, 24.378889f,91.974722f, 24.319444f,91.989444f, 24.349722f,91.948333f,
                    24.335000f,91.923611f, 24.270000f,91.931667f, 24.149722f,91.892500f, 24.188056f,91.838611f, 24.226111f,91.831944f,
                    24.230123f,91.809154f);
            poly[1917] = new TzPolygon(23.672023f,93.431080f, 23.682173f,93.437370f, 23.758927f,93.393458f, 23.929777f,93.391725f, 23.940336f,93.356999f,
                    23.984816f,93.331532f, 24.083021f,93.331355f, 24.092267f,93.354554f, 24.104826f,93.340425f, 24.081179f,93.406835f,
                    23.972085f,93.465316f, 23.948225f,93.502778f, 23.978890f,93.555842f, 23.961970f,93.594740f, 24.011684f,93.626484f,
                    24.006105f,93.756605f, 23.925344f,93.810853f, 23.950813f,93.932078f, 23.885429f,94.094924f, 23.837881f,94.116851f,
                    23.847133f,94.156096f, 23.927559f,94.169076f, 23.930351f,94.188661f, 24.080845f,94.255378f, 24.164131f,94.260365f,
                    24.275905f,94.322920f, 24.327595f,94.322365f, 24.332815f,94.350888f, 24.377264f,94.379597f, 24.391799f,94.362106f,
                    24.439772f,94.408403f, 24.482707f,94.394376f, 24.484925f,94.423938f, 24.570742f,94.455551f, 24.579991f,94.478373f,
                    23.672023f,94.478373f);
            poly[1918] = new TzPolygon(27.452092f,84.049616f, 27.433372f,84.026879f, 27.449745f,83.932336f, 27.424599f,83.862260f, 27.350941f,83.856578f,
                    27.469222f,83.614526f, 27.479763f,83.388914f, 27.457035f,83.401781f, 27.436681f,83.384041f, 27.412479f,83.409403f,
                    27.343115f,83.359182f, 27.330165f,83.317191f, 27.352667f,83.272466f, 27.383452f,83.272202f, 27.454376f,83.187897f,
                    27.448783f,83.034627f, 27.467779f,82.954143f, 27.501238f,82.929348f, 27.502349f,82.735571f, 27.585803f,82.758021f,
                    27.662968f,82.712370f, 27.722606f,82.708454f, 27.679493f,82.448805f, 27.842797f,82.209144f, 27.865872f,82.121095f,
                    27.923710f,82.070018f, 27.929054f,81.968283f, 27.860072f,81.925889f, 27.856970f,81.884959f, 27.988200f,81.698463f,
                    28.001336f,81.624785f, 28.082650f,81.478339f, 28.118548f,81.484015f, 28.160950f,81.447054f, 28.177205f,81.374716f,
                    28.141678f,81.370448f, 28.133657f,81.318137f, 28.148333f,81.328047f, 28.165570f,81.301174f, 28.169615f,81.321975f,
                    28.197717f,81.320774f, 28.246987f,81.273318f, 28.246987f,84.049616f);
            poly[1919] = new TzPolygon(27.452092f,84.049616f, 27.489238f,84.094734f, 27.517325f,84.098604f, 27.518703f,84.145552f, 27.486290f,84.148915f,
                    27.469570f,84.205758f, 27.442836f,84.207811f, 27.452834f,84.254080f, 27.384915f,84.293962f, 27.336455f,84.622125f,
                    27.214933f,84.690881f, 27.096562f,84.674502f, 27.046168f,84.643298f, 27.002887f,84.756684f, 27.017730f,84.773314f,
                    26.995881f,84.793243f, 27.020981f,84.825389f, 26.985559f,84.855483f, 26.960515f,84.962496f, 26.916444f,84.969157f,
                    26.885761f,85.060836f, 26.854398f,85.024093f, 26.869897f,85.190745f, 26.810260f,85.176505f, 26.758042f,85.213040f,
                    26.335443f,85.213040f, 26.335400f,84.049616f);
            poly[1920] = new TzPolygon(26.758042f,85.213040f, 26.741908f,85.334074f, 26.791422f,85.407561f, 26.797310f,85.495379f, 26.873879f,85.623873f,
                    26.820439f,85.720701f, 26.654022f,85.732012f, 26.602919f,85.817322f, 26.608671f,85.850970f, 26.568021f,85.851585f,
                    26.612757f,85.946678f, 26.648971f,85.956082f, 26.666763f,86.026882f, 26.628939f,86.138738f, 26.606404f,86.135796f,
                    26.614759f,86.192511f, 26.588571f,86.217294f, 26.617186f,86.252425f, 26.619121f,86.333064f, 26.602400f,86.376464f,
                    26.335486f,86.376464f, 26.335443f,85.213040f);
            poly[1921] = new TzPolygon(27.933822f,86.376464f, 27.965770f,86.336040f, 27.948218f,86.315163f, 27.977908f,86.288389f, 27.981290f,86.226295f,
                    28.078287f,86.204494f, 28.098980f,86.221861f, 28.173806f,86.186388f, 28.093068f,86.122277f, 28.090602f,86.081189f,
                    28.015470f,86.081076f, 27.927701f,86.124698f, 27.899812f,86.064818f, 27.911588f,86.000154f, 27.941793f,85.947576f,
                    27.996631f,85.976827f, 28.054516f,85.899812f, 28.111057f,85.897169f, 28.123687f,85.870293f, 28.183312f,85.849439f,
                    28.236476f,85.750309f, 28.246987f,85.747611f, 28.246987f,86.376464f);
            poly[1922] = new TzPolygon(26.335529f,87.539887f, 26.335486f,86.376464f, 26.602400f,86.376464f, 26.538704f,86.541784f, 26.496520f,86.570078f,
                    26.422438f,86.730881f, 26.459364f,86.765431f, 26.438867f,86.833400f, 26.461973f,86.894102f, 26.487964f,86.894101f,
                    26.489035f,86.929218f, 26.515929f,86.931844f, 26.531982f,87.015171f, 26.587307f,87.044615f, 26.586016f,87.071158f,
                    26.450408f,87.091500f, 26.404233f,87.161661f, 26.409415f,87.260687f, 26.373956f,87.265837f, 26.347758f,87.340938f,
                    26.408155f,87.368601f, 26.439864f,87.463908f, 26.408086f,87.539887f);
            poly[1923] = new TzPolygon(27.857640f,87.539887f, 27.822545f,87.451771f, 27.833595f,87.402641f, 27.843459f,87.432139f, 27.861274f,87.418224f,
                    27.828551f,87.360652f, 27.850788f,87.264518f, 27.820200f,87.194096f, 27.839849f,87.116025f, 27.950253f,87.038105f,
                    27.961639f,86.932673f, 28.025196f,86.866671f, 28.014031f,86.828744f, 28.035767f,86.757076f, 28.075419f,86.762951f,
                    28.108609f,86.715515f, 28.102482f,86.665383f, 28.071307f,86.634007f, 28.110078f,86.563074f, 28.069104f,86.566598f,
                    28.047956f,86.533261f, 27.957091f,86.513882f, 27.946035f,86.468055f, 27.905942f,86.442061f, 27.906236f,86.411367f,
                    27.933822f,86.376464f, 28.246987f,86.376464f, 28.246987f,87.539887f);
            poly[1924] = new TzPolygon(27.291108f,88.034874f, 27.286412f,88.031577f, 27.171190f,88.019222f, 27.119507f,87.987290f, 27.036786f,88.037493f,
                    27.035515f,88.077487f, 26.997082f,88.121599f, 26.953694f,88.121599f, 26.950770f,88.120312f, 26.949282f,88.121599f,
                    26.582750f,88.121599f, 26.560833f,88.105648f, 26.437898f,88.095111f, 26.361033f,88.007209f, 26.392716f,87.991682f,
                    26.417527f,87.926921f, 26.486951f,87.888119f, 26.436890f,87.848651f, 26.469005f,87.792803f, 26.408986f,87.759965f,
                    26.435625f,87.677408f, 26.393578f,87.651646f, 26.380520f,87.605795f, 26.408794f,87.539887f, 27.291108f,87.539887f);
            poly[1925] = new TzPolygon(26.335228f,88.433596f, 26.335562f,88.435206f, 26.376560f,88.457624f, 26.349831f,88.482339f, 26.359758f,88.523871f,
                    26.460115f,88.486294f, 26.488029f,88.371997f, 26.447766f,88.352370f, 26.481950f,88.331592f, 26.638253f,88.408502f,
                    26.545266f,88.435772f, 26.541126f,88.485138f, 26.510174f,88.489072f, 26.510577f,88.521365f, 26.480698f,88.526315f,
                    26.485432f,88.556789f, 26.457576f,88.559893f, 26.449533f,88.591906f, 26.470862f,88.594341f, 26.471019f,88.622889f,
                    26.435063f,88.623766f, 26.388842f,88.701725f, 26.379792f,88.680953f, 26.335228f,88.703311f);
            poly[1926] = new TzPolygon(26.997082f,88.121599f, 26.985055f,88.135404f, 26.953694f,88.121599f);
            poly[1927] = new TzPolygon(26.949282f,88.121599f, 26.921182f,88.145899f, 26.898876f,88.136242f, 26.859750f,88.174365f, 26.746749f,88.189282f,
                    26.636795f,88.160932f, 26.582750f,88.121599f);
            poly[1928] = new TzPolygon(27.291108f,88.034874f, 27.336104f,88.066469f, 27.372214f,88.041540f, 27.413112f,88.050413f, 27.430012f,88.080088f,
                    27.496171f,88.043602f, 27.645942f,88.121599f, 27.291108f,88.121599f);
            poly[1929] = new TzPolygon(27.911193f,88.121599f, 27.918068f,88.117999f, 27.925016f,88.121599f);
            poly[1930] = new TzPolygon(28.246987f,88.121599f, 27.925016f,88.121599f, 27.918068f,88.117999f, 27.912740f,88.121599f, 27.876263f,88.121599f,
                    27.868383f,88.111294f, 27.906077f,88.029931f, 27.886128f,87.984703f, 27.918072f,87.932034f, 27.910960f,87.865758f,
                    27.948148f,87.856837f, 27.953049f,87.831664f, 27.805471f,87.725211f, 27.807047f,87.665325f, 27.837509f,87.664446f,
                    27.810765f,87.610323f, 27.866800f,87.562885f, 27.857640f,87.539887f, 28.246987f,87.539887f);
            poly[1931] = new TzPolygon(27.876761f,88.121599f, 27.881597f,88.134974f, 27.839597f,88.201526f, 27.820762f,88.173018f, 27.791013f,88.197149f,
                    27.736734f,88.156124f, 27.665817f,88.144480f, 27.627338f,88.121599f);
            poly[1932] = new TzPolygon(28.076519f,88.703311f, 28.074115f,88.670614f, 28.122641f,88.633368f, 28.089627f,88.602365f, 28.082288f,88.554446f,
                    28.034001f,88.545952f, 28.055118f,88.494911f, 27.981077f,88.413591f, 27.985807f,88.340400f, 27.941664f,88.251328f,
                    27.969512f,88.237638f, 27.962374f,88.208847f, 27.940673f,88.206991f, 27.965277f,88.142460f, 27.925016f,88.121599f,
                    28.246987f,88.121599f, 28.246987f,88.703311f);
            poly[1933] = new TzPolygon(27.912740f,88.121599f, 27.888689f,88.137851f, 27.876263f,88.121599f);
            poly[1934] = new TzPolygon(26.335228f,88.711947f, 26.347447f,88.746048f, 26.335228f,88.746746f);
            poly[1935] = new TzPolygon(26.335228f,88.991173f, 26.351961f,88.961109f, 26.335228f,88.953828f, 26.335228f,88.952320f, 26.365488f,88.952610f,
                    26.358909f,88.919046f, 26.408670f,88.904723f, 26.407992f,88.929381f, 26.458975f,88.957061f, 26.411423f,88.993849f,
                    26.393835f,89.093147f, 26.362960f,89.079479f, 26.337177f,89.101057f, 26.335228f,89.098607f);
            poly[1936] = new TzPolygon(27.352981f,88.882330f, 27.352981f,89.168688f, 27.318099f,89.152031f, 27.284574f,89.069155f, 27.240894f,89.066205f,
                    27.212045f,88.990245f, 27.262756f,88.948145f, 27.271110f,88.911495f, 27.327288f,88.921368f, 27.332955f,88.895066f);
            poly[1937] = new TzPolygon(27.352981f,88.990745f, 27.352981f,90.147077f, 26.758973f,90.147077f, 26.721991f,89.968573f, 26.736629f,89.860596f,
                    26.702530f,89.862567f, 26.702016f,89.770854f, 26.734924f,89.751639f, 26.722874f,89.625433f, 26.777184f,89.644736f,
                    26.813510f,89.557159f, 26.802220f,89.476433f, 26.862281f,89.378940f, 26.815482f,89.262326f, 26.812103f,89.131102f,
                    26.835757f,89.102097f, 26.891703f,89.095640f, 26.898364f,89.046764f, 26.940780f,89.021369f, 26.917842f,88.979538f,
                    26.932918f,88.945066f, 26.969705f,88.952030f, 26.993028f,88.922546f, 26.946461f,88.876669f, 27.109147f,88.870492f,
                    27.141850f,88.746472f, 27.185310f,88.789075f, 27.248366f,88.802284f, 27.272973f,88.904489f, 27.336283f,88.930215f,
                    27.305425f,88.970558f, 27.326996f,89.004668f);
            poly[1938] = new TzPolygon(28.076519f,88.703311f, 28.080301f,88.754741f, 28.015297f,88.836082f, 27.930582f,88.834082f, 27.919711f,88.867636f,
                    27.856407f,88.888121f, 27.815528f,88.857085f, 27.668192f,88.848230f, 27.646914f,88.814822f, 27.574232f,88.791806f,
                    27.566424f,88.763302f, 27.526935f,88.793572f, 27.469293f,88.776827f, 27.405437f,88.806754f, 27.379610f,88.837896f,
                    27.386304f,88.861137f, 27.352981f,88.882330f, 27.352981f,88.703311f);
            poly[1939] = new TzPolygon(27.352981f,88.990745f, 27.402393f,88.964270f, 27.460287f,88.992326f, 27.487356f,88.978069f, 27.502809f,89.010329f,
                    27.522697f,88.997262f, 27.545225f,89.033053f, 27.588371f,89.037758f, 27.614860f,89.128061f, 27.721515f,89.197140f,
                    27.731165f,89.228722f, 27.802458f,89.235528f, 27.890266f,89.389121f, 28.092585f,89.508846f, 28.085403f,89.536300f,
                    28.163895f,89.596542f, 28.182394f,89.765601f, 28.222883f,89.769045f, 28.246987f,89.798175f, 28.229971f,89.861475f,
                    28.183108f,89.896703f, 28.194563f,89.976923f, 28.137145f,90.038667f, 28.170131f,90.122537f, 28.194239f,90.123324f,
                    28.192918f,90.147077f, 27.352981f,90.147077f);
            poly[1940] = new TzPolygon(27.352981f,90.147077f, 27.352981f,91.590842f, 26.813341f,91.590842f, 26.792073f,91.499722f, 26.840561f,91.414365f,
                    26.794362f,91.380221f, 26.782276f,91.341412f, 26.814033f,91.239509f, 26.824109f,91.101511f, 26.781255f,91.055597f,
                    26.769361f,90.699697f, 26.816478f,90.547519f, 26.904639f,90.417853f, 26.901270f,90.354678f, 26.849888f,90.302173f,
                    26.859771f,90.247871f, 26.835007f,90.200419f, 26.767998f,90.190637f, 26.758973f,90.147077f);
            poly[1941] = new TzPolygon(27.547707f,91.590842f, 27.557018f,91.581963f, 27.584144f,91.565973f, 27.608438f,91.584485f, 27.632209f,91.562308f,
                    27.661008f,91.590842f);
            poly[1942] = new TzPolygon(27.815127f,91.590842f, 27.811367f,91.576673f, 27.826655f,91.565846f, 27.827254f,91.590842f);
            poly[1943] = new TzPolygon(27.895117f,91.590842f, 27.898195f,91.555245f, 27.944666f,91.483338f, 28.006305f,91.465316f, 28.003300f,91.435839f,
                    28.065683f,91.338926f, 28.063872f,91.247358f, 27.985453f,91.203024f, 28.001698f,91.167796f, 27.991907f,91.070297f,
                    28.024714f,91.021561f, 28.001592f,90.976514f, 28.044561f,90.928547f, 28.025661f,90.906121f, 28.053525f,90.855534f,
                    28.041487f,90.781129f, 28.080781f,90.691473f, 28.022915f,90.584565f, 28.066310f,90.507287f, 28.047173f,90.455395f,
                    28.064141f,90.442786f, 28.064210f,90.374680f, 28.163965f,90.290448f, 28.142945f,90.254705f, 28.148003f,90.209230f,
                    28.192142f,90.161035f, 28.192918f,90.147077f, 28.246987f,90.147077f, 28.246987f,91.590842f);
            poly[1944] = new TzPolygon(27.827373f,91.590842f, 27.826249f,91.540318f, 27.857650f,91.558278f, 27.861023f,91.590842f);
            poly[1945] = new TzPolygon(27.352981f,91.590842f, 27.352981f,92.056957f, 27.327294f,92.064913f, 27.281770f,92.125232f, 27.258485f,92.037693f,
                    27.234779f,92.071838f, 27.168574f,92.026927f, 27.080039f,92.031192f, 27.040575f,92.081703f, 26.960672f,92.121346f,
                    26.869267f,92.103644f, 26.849616f,92.056524f, 26.860819f,91.987063f, 26.919635f,91.893784f, 26.913386f,91.859349f,
                    26.863901f,91.824786f, 26.809059f,91.695333f, 26.822578f,91.630416f, 26.813341f,91.590842f);
            poly[1946] = new TzPolygon(27.861023f,91.590842f, 27.863955f,91.619154f, 27.892111f,91.625595f, 27.895117f,91.590842f, 28.246987f,91.590842f,
                    28.246987f,92.312725f, 27.826605f,92.312725f, 27.872276f,92.293954f, 27.887753f,92.244387f, 27.779860f,92.057276f,
                    27.780133f,91.987954f, 27.716491f,91.924968f, 27.720233f,91.872697f, 27.787757f,91.829043f, 27.769089f,91.791456f,
                    27.782937f,91.721951f, 27.828926f,91.660689f, 27.827373f,91.590842f);
            poly[1947] = new TzPolygon(27.895117f,91.590842f, 27.892111f,91.625595f, 27.859812f,91.613491f, 27.861627f,91.590842f);
            poly[1948] = new TzPolygon(27.815622f,91.590842f, 27.803820f,91.634437f, 27.699821f,91.629088f, 27.660648f,91.590842f);
            poly[1949] = new TzPolygon(27.547707f,91.590842f, 27.484069f,91.651525f, 27.505568f,91.694528f, 27.498296f,91.717054f, 27.474637f,91.714753f,
                    27.465432f,91.774190f, 27.486380f,91.849491f, 27.460110f,91.960635f, 27.480122f,92.017576f, 27.352981f,92.056957f,
                    27.352981f,91.590842f);
            poly[1950] = new TzPolygon(28.246987f,92.940807f, 28.200690f,92.921611f, 28.175169f,92.832726f, 28.186706f,92.784394f, 28.161309f,92.762847f,
                    28.151168f,92.677746f, 28.076998f,92.656889f, 28.054560f,92.731862f, 27.980001f,92.730489f, 27.912444f,92.646976f,
                    27.914605f,92.599339f, 27.880849f,92.581015f, 27.852130f,92.500463f, 27.792921f,92.456002f, 27.802981f,92.426391f,
                    27.835699f,92.421842f, 27.797515f,92.324681f, 27.826605f,92.312725f, 28.246987f,92.312725f);
            poly[1951] = new TzPolygon(18.050637f,101.170080f, 18.065100f,101.183956f, 18.100389f,101.170080f, 18.149411f,101.170080f, 18.213042f,101.192660f,
                    18.216924f,101.170080f, 18.219182f,101.170080f, 18.219182f,102.082795f, 18.030899f,101.906916f, 18.067301f,101.780764f,
                    17.911528f,101.723795f, 17.893556f,101.616750f, 17.849151f,101.593238f, 17.869615f,101.574841f, 17.821071f,101.551256f,
                    17.784449f,101.574253f, 17.776475f,101.521703f, 17.724073f,101.490827f, 17.760632f,101.482134f, 17.728826f,101.447152f,
                    17.735558f,101.403866f, 17.717611f,101.431174f, 17.689193f,101.409666f, 17.697827f,101.382116f, 17.658898f,101.345672f,
                    17.650696f,101.306477f, 17.536386f,101.229550f, 17.524421f,101.175135f, 17.500585f,101.170080f);
            poly[1952] = new TzPolygon(18.089177f,102.253288f, 18.147898f,102.185541f, 18.204438f,102.163325f, 18.219182f,102.082795f, 18.219182f,102.253288f);
            poly[1953] = new TzPolygon(18.345556f,101.170080f, 18.340537f,101.182166f, 18.314450f,101.170080f);
            poly[1954] = new TzPolygon(11.749251f,102.253288f, 11.749251f,102.908693f, 11.745531f,102.911331f, 11.654660f,102.913892f, 11.389554f,102.620906f,
                    11.409259f,102.477586f, 11.467483f,102.377928f, 11.620453f,102.253288f);
            poly[1955] = new TzPolygon(10.621091f,104.944143f, 8.190135f,104.944143f, 8.179066f,104.867348f, 8.208917f,104.767363f, 9.099378f,103.316162f,
                    9.277315f,103.165336f, 9.380127f,103.125141f, 9.475264f,103.117846f, 10.004368f,103.859869f, 10.172051f,103.932616f,
                    10.261268f,103.900867f, 10.290793f,103.826623f, 10.383680f,103.805099f, 10.402011f,103.837750f, 10.390276f,103.914162f,
                    10.479963f,103.971516f, 10.480453f,104.011128f, 10.383573f,104.110596f, 10.231901f,104.124336f, 10.271424f,104.227253f,
                    10.423802f,104.440242f, 10.430661f,104.479174f, 10.404744f,104.498596f, 10.530238f,104.590689f, 10.522200f,104.869074f);
            poly[1956] = new TzPolygon(10.859472f,104.944143f, 10.859472f,105.042655f, 10.721012f,105.098302f, 10.637834f,104.956853f, 10.621091f,104.944143f);
            poly[1957] = new TzPolygon(10.859472f,106.175198f, 10.840055f,106.187558f, 10.788907f,106.190950f, 10.811677f,106.165416f, 10.811099f,106.072650f,
                    10.859472f,106.014266f);
            poly[1958] = new TzPolygon(10.859472f,105.930970f, 10.839170f,105.935964f, 10.859472f,105.862734f);
            poly[1959] = new TzPolygon(10.859472f,105.042655f, 10.892385f,105.029427f, 10.956512f,105.082932f, 10.960720f,105.117377f, 10.919329f,105.105610f,
                    10.896855f,105.265040f, 10.859885f,105.338135f, 10.972753f,105.427239f, 10.951881f,105.536500f, 11.032143f,105.777440f,
                    10.899342f,105.864281f, 10.863089f,105.849688f, 10.859472f,105.862734f);
            poly[1960] = new TzPolygon(10.859472f,105.930970f, 10.863091f,105.930080f, 10.883698f,105.956234f, 10.917189f,105.944604f, 10.859472f,106.014266f);
            poly[1961] = new TzPolygon(10.859472f,106.175198f, 10.914785f,106.139988f, 10.978298f,106.144979f, 10.975953f,106.205822f, 11.051623f,106.187276f,
                    11.102085f,106.153876f, 11.073817f,106.101388f, 11.140392f,106.023096f, 11.190790f,106.013797f, 11.218342f,105.926302f,
                    11.287502f,105.907487f, 11.284259f,105.865463f, 11.362785f,105.885026f, 11.405520f,105.874071f, 11.446959f,105.903438f,
                    11.461951f,105.874685f, 11.545746f,105.880679f, 11.569002f,105.817432f, 11.618715f,105.809730f, 11.676967f,105.884010f,
                    11.641216f,105.954495f, 11.726956f,106.015150f, 11.749251f,106.014948f, 11.749251f,106.102067f, 11.742848f,106.115251f,
                    11.749251f,106.159414f, 11.749251f,106.194881f, 11.728850f,106.212463f, 11.720510f,106.266430f, 11.686391f,106.289571f,
                    10.859472f,106.289571f);
            poly[1962] = new TzPolygon(11.749251f,106.420780f, 11.670637f,106.450930f, 11.696737f,106.385132f, 11.673014f,106.298644f, 11.686391f,106.289571f,
                    11.749251f,106.289571f);
            poly[1963] = new TzPolygon(11.749251f,102.908693f, 11.856310f,102.832787f, 12.074485f,102.770291f, 12.172251f,102.703590f, 12.364311f,102.725802f,
                    12.400362f,102.784958f, 12.433868f,102.781388f, 12.486617f,102.720349f, 12.512677f,102.728502f, 12.538876f,102.677887f,
                    12.611101f,102.645269f, 12.653830f,102.578923f, 12.654053f,102.531444f, 12.704447f,102.497282f, 12.783375f,102.535886f,
                    12.858786f,102.497923f, 12.895058f,102.509144f, 12.978576f,102.485444f, 13.002475f,102.530128f, 13.013414f,102.494368f,
                    13.082174f,102.459499f, 13.090930f,102.433838f, 13.277356f,102.349406f, 13.505040f,102.363547f, 13.534344f,102.336696f,
                    13.534344f,104.944143f, 11.749251f,104.944143f);
            poly[1964] = new TzPolygon(13.534344f,102.336696f, 13.537473f,102.333828f, 13.577938f,102.366649f, 13.564516f,102.526850f, 13.606146f,102.579897f,
                    13.608714f,102.624201f, 13.665276f,102.550725f, 13.706776f,102.590991f, 13.770888f,102.732030f, 13.793260f,102.723220f,
                    13.856377f,102.766252f, 13.932817f,102.782910f, 14.004259f,102.866633f, 14.017309f,102.911348f, 14.083413f,102.900727f,
                    14.148399f,102.940407f, 14.194848f,102.938482f, 14.228506f,103.022078f, 14.284086f,103.055955f, 14.335150f,103.169680f,
                    14.323590f,103.218930f, 14.348650f,103.262164f, 14.357792f,103.401994f, 14.390767f,103.435040f, 14.364701f,103.467666f,
                    14.412125f,103.498170f, 14.431922f,103.557572f, 14.426723f,103.598716f, 13.534344f,103.598716f);
            poly[1965] = new TzPolygon(14.426723f,103.598716f, 14.425250f,103.610371f, 14.404055f,103.621449f, 14.413269f,103.654432f, 14.438634f,103.653860f,
                    14.440370f,103.688902f, 14.431126f,103.708204f, 14.380653f,103.707118f, 14.352971f,103.826850f, 14.370481f,103.847441f,
                    14.338021f,103.881709f, 14.330234f,103.942182f, 14.354529f,103.979529f, 14.345369f,104.076911f, 14.378435f,104.108068f,
                    14.354623f,104.145416f, 14.384760f,104.186773f, 14.367654f,104.218874f, 14.408532f,104.275355f, 14.370656f,104.330041f,
                    14.383558f,104.376222f, 14.345183f,104.463246f, 14.376234f,104.498989f, 14.354025f,104.564472f, 14.423193f,104.640949f,
                    14.398410f,104.685058f, 14.433963f,104.711150f, 14.403283f,104.723689f, 14.437301f,104.806864f, 14.397922f,104.837907f,
                    14.418192f,104.871690f, 14.395443f,104.944143f, 13.534344f,104.944143f, 13.534344f,103.598716f);
            poly[1966] = new TzPolygon(11.749251f,106.014948f, 11.765088f,106.014804f, 11.778382f,106.042086f, 11.749251f,106.102067f);
            poly[1967] = new TzPolygon(11.749251f,106.159414f, 11.753822f,106.190942f, 11.749251f,106.194881f);
            poly[1968] = new TzPolygon(13.534344f,107.614074f, 13.525857f,107.616953f, 13.366496f,107.627679f, 13.020460f,107.491422f, 12.975819f,107.504266f,
                    12.948260f,107.484797f, 12.878174f,107.498771f, 12.817535f,107.554223f, 12.708015f,107.559899f, 12.679650f,107.582056f,
                    12.642580f,107.569234f, 12.558668f,107.589536f, 12.522199f,107.562571f, 12.495320f,107.579793f, 12.415483f,107.543805f,
                    12.350877f,107.543897f, 12.310608f,107.468445f, 12.240200f,107.417688f, 12.334893f,107.344606f, 12.295080f,107.190737f,
                    12.276162f,107.152201f, 12.230080f,107.138606f, 12.181250f,107.092742f, 12.187364f,107.073540f, 12.163030f,107.078938f,
                    12.115263f,107.003420f, 12.087822f,106.994403f, 12.061964f,106.916296f, 12.082987f,106.792933f, 11.968502f,106.721112f,
                    11.964976f,106.683390f, 11.989709f,106.655241f, 11.965275f,106.659696f, 11.961144f,106.635795f, 11.968947f,106.491996f,
                    11.988819f,106.454479f, 11.973559f,106.411855f, 11.867526f,106.466681f, 11.856934f,106.439875f, 11.822743f,106.447514f,
                    11.766158f,106.414296f, 11.749251f,106.420780f, 11.749251f,106.289571f, 13.534344f,106.289571f);
            poly[1969] = new TzPolygon(14.395443f,104.944143f, 14.379669f,104.994382f, 14.318292f,104.984489f, 14.214896f,105.050194f, 14.213451f,105.107383f,
                    14.238060f,105.142891f, 14.334942f,105.168374f, 14.348451f,105.198046f, 14.176476f,105.275340f, 14.162968f,105.320521f,
                    14.104457f,105.362014f, 14.101796f,105.454504f, 14.160435f,105.558438f, 14.137376f,105.616857f, 13.534344f,105.616857f,
                    13.534344f,104.944143f);
            poly[1970] = new TzPolygon(14.137376f,105.616857f, 14.160435f,105.558438f, 14.101796f,105.454504f, 14.104457f,105.362014f, 14.162968f,105.320521f,
                    14.176476f,105.275340f, 14.312671f,105.206167f, 14.343339f,105.206471f, 14.353714f,105.281332f, 14.397454f,105.320293f,
                    14.384254f,105.342389f, 14.396117f,105.386721f, 14.426890f,105.406140f, 14.426890f,105.410986f, 14.416089f,105.429139f,
                    14.426890f,105.437355f, 14.426890f,105.616857f);
            poly[1971] = new TzPolygon(14.137376f,105.616857f, 14.426890f,105.616857f, 14.426890f,106.242639f, 14.398705f,106.237559f, 14.350970f,106.186541f,
                    14.375758f,106.103737f, 14.337368f,106.079165f, 14.371698f,106.001335f, 14.324062f,105.996836f, 14.309542f,106.025003f,
                    14.227780f,106.035739f, 14.198375f,106.058362f, 14.185901f,106.109974f, 14.109734f,106.121405f, 14.063011f,106.187717f,
                    14.020446f,106.169148f, 13.990931f,106.102335f, 13.909675f,106.105346f, 13.930400f,105.910777f, 14.023654f,105.792666f,
                    14.084335f,105.785384f, 14.109232f,105.724157f, 14.086861f,105.703859f, 14.120157f,105.658466f, 14.097385f,105.644812f,
                    14.130742f,105.633664f);
            poly[1972] = new TzPolygon(15.319436f,105.581413f, 15.314532f,105.584888f, 15.271222f,105.590961f, 15.204707f,105.494352f, 15.130769f,105.466541f,
                    15.063395f,105.513412f, 15.063740f,105.554242f, 15.038376f,105.546954f, 14.998341f,105.574820f, 14.975738f,105.624152f,
                    14.941315f,105.583229f, 14.952186f,105.552957f, 14.926390f,105.545296f, 14.878940f,105.579959f, 14.874886f,105.549220f,
                    14.839600f,105.559871f, 14.799139f,105.511194f, 14.753242f,105.512595f, 14.731368f,105.546557f, 14.727097f,105.519882f,
                    14.696253f,105.515211f, 14.619768f,105.542259f, 14.553248f,105.533476f, 14.426890f,105.437355f, 14.426890f,105.410986f,
                    14.428986f,105.407463f, 14.426890f,105.406140f, 14.426890f,104.944143f, 15.319436f,104.944143f);
            poly[1973] = new TzPolygon(14.426890f,106.242639f, 14.487729f,106.253604f, 14.460334f,106.289571f, 14.426890f,106.289571f);
            poly[1974] = new TzPolygon(13.534344f,107.613759f, 13.741462f,107.535805f, 13.794599f,107.451383f, 13.853207f,107.472779f, 13.870821f,107.453953f,
                    13.917843f,107.473062f, 13.930033f,107.453302f, 13.980243f,107.455457f, 13.997592f,107.442550f, 13.989611f,107.386299f,
                    14.016497f,107.357929f, 14.083580f,107.373530f, 14.114975f,107.335381f, 14.235508f,107.408017f, 14.326285f,107.390847f,
                    14.418533f,107.449764f, 14.407208f,107.488955f, 14.426890f,107.495065f, 14.426890f,107.634999f, 13.534344f,107.634999f);
            poly[1975] = new TzPolygon(14.426890f,106.742938f, 14.426890f,107.044481f, 14.416113f,107.046144f, 14.354938f,106.995575f, 14.359670f,106.977287f,
                    14.314712f,106.968054f, 14.333523f,106.894887f, 14.313583f,106.894485f, 14.317576f,106.865507f, 14.292315f,106.849127f,
                    14.325810f,106.798304f);
            poly[1976] = new TzPolygon(14.426890f,107.170827f, 14.414948f,107.163735f, 14.391815f,107.093621f, 14.426890f,107.061354f);
            poly[1977] = new TzPolygon(14.460334f,106.289571f, 14.441279f,106.314589f, 14.451131f,106.409810f, 14.487532f,106.440022f, 14.523429f,106.437962f,
                    14.512627f,106.478131f, 14.554502f,106.464055f, 14.591967f,106.545125f, 14.500626f,106.564553f, 14.508353f,106.601380f,
                    14.443561f,106.630921f, 14.428413f,106.742104f, 14.426890f,106.742879f, 14.426890f,106.289571f);
            poly[1978] = new TzPolygon(14.426890f,107.495065f, 14.546348f,107.532150f, 14.584909f,107.516963f, 14.622553f,107.559563f, 14.721350f,107.555716f,
                    14.721599f,107.523357f, 14.750702f,107.541924f, 14.785847f,107.505354f, 14.873552f,107.591463f, 14.950897f,107.483241f,
                    15.007018f,107.467766f, 15.049483f,107.540166f, 15.028361f,107.583924f, 15.051239f,107.594045f, 15.050886f,107.621520f,
                    15.087862f,107.597868f, 15.106159f,107.622706f, 15.132841f,107.607664f, 15.149724f,107.626754f, 15.195844f,107.582681f,
                    15.230395f,107.633058f, 15.287138f,107.615357f, 15.319436f,107.634999f, 14.426890f,107.634999f);
            poly[1979] = new TzPolygon(14.426890f,107.043141f, 14.446737f,107.037611f, 14.426890f,107.057851f);
            poly[1980] = new TzPolygon(14.426890f,107.170827f, 14.487657f,107.206915f, 14.492289f,107.258320f, 14.542221f,107.260757f, 14.587916f,107.298758f,
                    14.584749f,107.339986f, 14.540186f,107.375976f, 14.528420f,107.448653f, 14.614088f,107.463393f, 14.648441f,107.518640f,
                    14.690422f,107.537563f, 14.686085f,107.556613f, 14.622553f,107.559563f, 14.584909f,107.516963f, 14.546348f,107.532150f,
                    14.426890f,107.495065f);
            poly[1981] = new TzPolygon(18.448556f,103.407830f, 18.432626f,103.309592f, 18.361022f,103.243460f, 18.304024f,103.298211f, 18.254492f,103.166128f,
                    18.173457f,103.148936f, 18.123234f,103.080049f, 18.033740f,103.078551f, 17.982300f,103.041952f, 17.971293f,103.018771f,
                    18.004702f,102.953897f, 17.970849f,102.855060f, 17.933403f,102.784735f, 17.893745f,102.758259f, 17.870001f,102.688351f,
                    17.844296f,102.676965f, 17.818783f,102.698139f, 17.803270f,102.682450f, 17.842565f,102.589423f, 17.910321f,102.613374f,
                    17.955298f,102.603389f, 17.984048f,102.430950f, 18.044625f,102.346463f, 18.060587f,102.286273f, 18.089177f,102.253288f,
                    18.448556f,102.253288f);
            poly[1982] = new TzPolygon(15.323394f,105.521414f, 15.320747f,105.496221f, 15.350339f,105.467632f, 15.386402f,105.494072f, 15.396227f,105.521414f);
            poly[1983] = new TzPolygon(16.883996f,104.752178f, 16.883996f,105.521414f, 15.760712f,105.521414f, 15.767179f,105.504025f, 15.745570f,105.466599f,
                    15.753500f,105.437588f, 15.802384f,105.394290f, 15.922246f,105.342227f, 15.983512f,105.376935f, 15.990715f,105.425142f,
                    16.012139f,105.417860f, 16.102562f,105.046941f, 16.191030f,105.012126f, 16.243842f,105.014911f, 16.348150f,104.890225f,
                    16.452698f,104.843718f, 16.528537f,104.744035f, 16.571959f,104.733866f, 16.700011f,104.764049f, 16.797621f,104.737492f,
                    16.844452f,104.759386f);
            poly[1984] = new TzPolygon(18.448556f,103.407830f, 18.404077f,103.607312f, 18.343211f,103.697619f, 18.338251f,103.818088f, 18.283761f,103.858088f,
                    18.336880f,103.973041f, 18.218574f,104.060570f, 18.115444f,104.105323f, 17.999698f,104.213048f, 17.858442f,104.279191f,
                    17.822603f,104.355134f, 17.651817f,104.471869f, 17.520799f,104.707817f, 17.394542f,104.799798f, 17.164734f,104.801488f,
                    17.008272f,104.729525f, 16.883996f,104.752178f, 16.883996f,103.407830f);
            poly[1985] = new TzPolygon(18.119891f,105.521414f, 18.124452f,105.505769f, 18.202920f,105.491114f, 18.204449f,105.442726f, 18.154086f,105.409268f,
                    18.160902f,105.367934f, 18.200381f,105.319906f, 18.264611f,105.328609f, 18.236275f,105.299585f, 18.254844f,105.299289f,
                    18.254948f,105.255444f, 18.296390f,105.243073f, 18.324791f,105.184341f, 18.386287f,105.184619f, 18.388649f,105.150563f,
                    18.447354f,105.103469f, 18.448556f,105.103730f, 18.448556f,105.521414f);
            poly[1986] = new TzPolygon(15.759688f,105.521414f, 15.722261f,105.599298f, 15.633801f,105.636812f, 15.509892f,105.592813f, 15.420478f,105.588905f,
                    15.396227f,105.521414f);
            poly[1987] = new TzPolygon(15.323394f,105.521414f, 15.328987f,105.574645f, 15.319436f,105.581413f, 15.319436f,105.521414f);
            poly[1988] = new TzPolygon(16.621574f,106.578207f, 16.694344f,106.551297f, 16.865157f,106.551325f, 16.883996f,106.528622f, 16.883996f,106.578207f);
            poly[1989] = new TzPolygon(16.621574f,106.578207f, 16.601208f,106.585738f, 16.584132f,106.667329f, 16.522335f,106.647148f, 16.452083f,106.675991f,
                    16.424841f,106.726119f, 16.439150f,106.734722f, 16.410825f,106.740282f, 16.431958f,106.772024f, 16.467816f,106.771079f,
                    16.463547f,106.802177f, 16.548751f,106.830775f, 16.541002f,106.862779f, 16.511487f,106.890429f, 16.428371f,106.871928f,
                    16.425689f,106.898656f, 16.388891f,106.899339f, 16.353916f,106.964885f, 16.302828f,106.971956f, 16.311129f,107.088831f,
                    16.256705f,107.157024f, 16.167922f,107.159379f, 16.136905f,107.262208f, 16.054889f,107.333135f, 16.088058f,107.452610f,
                    16.039735f,107.446189f, 16.024630f,107.466644f, 15.912044f,107.415396f, 15.887170f,107.393135f, 15.893833f,107.347382f,
                    15.835688f,107.221309f, 15.738829f,107.213124f, 15.744635f,107.249465f, 15.707783f,107.276555f, 15.632931f,107.277652f,
                    15.613928f,107.343793f, 15.493534f,107.382239f, 15.498561f,107.468965f, 15.472436f,107.513783f, 15.412565f,107.521065f,
                    15.394424f,107.559488f, 15.414637f,107.624513f, 15.382809f,107.596352f, 15.319436f,107.634999f, 15.319436f,106.578207f);
            poly[1990] = new TzPolygon(18.119891f,105.521414f, 18.115860f,105.535239f, 18.081964f,105.540129f, 18.084008f,105.571088f, 18.014031f,105.581168f,
                    17.992497f,105.643509f, 17.877007f,105.607924f, 17.833367f,105.683398f, 17.795361f,105.675668f, 17.744609f,105.730096f,
                    17.668502f,105.750717f, 17.676298f,105.781543f, 17.627345f,105.861834f, 17.309096f,106.145868f, 17.243757f,106.249728f,
                    17.264604f,106.277366f, 17.294479f,106.275367f, 17.295247f,106.303800f, 17.239155f,106.307489f, 17.233975f,106.334221f,
                    17.208019f,106.304251f, 17.078680f,106.416007f, 17.053231f,106.402068f, 16.994926f,106.439805f, 16.971516f,106.515309f,
                    17.005153f,106.549323f, 16.925769f,106.547523f, 16.921944f,106.519540f, 16.895885f,106.514295f, 16.883996f,106.528622f,
                    16.883996f,105.521414f);
            poly[1991] = new TzPolygon(19.049923f,101.170080f, 19.049923f,101.357205f, 18.888640f,101.245758f, 18.808685f,101.258451f, 18.731903f,101.223803f,
                    18.688609f,101.272742f, 18.624288f,101.226124f, 18.612231f,101.181924f, 18.560522f,101.183278f, 18.554059f,101.170080f);
            poly[1992] = new TzPolygon(19.575048f,101.170080f, 19.576745f,101.197545f, 19.605225f,101.206714f, 19.603621f,101.243740f, 19.568919f,101.287641f,
                    19.470363f,101.266351f, 19.473311f,101.210499f, 19.431440f,101.215218f, 19.397905f,101.187040f, 19.350161f,101.205096f,
                    19.324584f,101.241892f, 19.304690f,101.227324f, 19.230795f,101.259537f, 19.124507f,101.256665f, 19.049923f,101.357205f,
                    19.049923f,101.170080f);
            poly[1993] = new TzPolygon(19.605225f,101.357205f, 19.605225f,101.170080f, 21.355555f,101.170080f, 21.328576f,101.185198f, 21.296108f,101.249939f,
                    21.231342f,101.216590f, 21.179078f,101.280170f, 21.213817f,101.357205f);
            poly[1994] = new TzPolygon(21.561410f,101.170080f, 21.556057f,101.216942f, 21.500017f,101.221937f, 21.473958f,101.190439f, 21.435878f,101.199679f,
                    21.421150f,101.170080f);
            poly[1995] = new TzPolygon(18.788925f,104.790246f, 18.800391f,104.739926f, 18.835167f,104.713684f, 18.835992f,104.679072f, 18.885857f,104.630068f,
                    18.900853f,104.581165f, 18.985619f,104.529355f, 19.004790f,104.481871f, 18.983965f,104.445486f, 19.058583f,104.392748f,
                    19.090708f,104.308605f, 19.118312f,104.288264f, 19.118949f,104.218045f, 19.156716f,104.222814f, 19.197670f,104.179191f,
                    19.215211f,104.100939f, 19.248017f,104.069205f, 19.232525f,103.999557f, 19.304476f,103.913487f, 19.305672f,103.875757f,
                    19.357425f,103.952407f, 19.398425f,103.976430f, 19.416609f,104.069232f, 19.453655f,104.062977f, 19.498474f,104.091382f,
                    19.501496f,104.119657f, 19.569723f,104.104854f, 19.620130f,104.058320f, 19.673360f,104.066936f, 19.673360f,104.098881f,
                    19.661691f,104.136975f, 19.673360f,104.145721f, 19.673360f,104.316914f, 19.666752f,104.320460f, 19.673360f,104.336426f,
                    19.673360f,104.437642f, 19.657321f,104.450308f, 19.655622f,104.489791f, 19.624915f,104.506826f, 19.610202f,104.557767f,
                    19.635580f,104.607617f, 19.624801f,104.646094f, 19.673360f,104.656919f, 19.673360f,104.790246f);
            poly[1996] = new TzPolygon(20.898164f,103.894674f, 20.858893f,103.852545f, 20.863932f,103.813685f, 20.822680f,103.809291f, 20.801598f,103.780513f,
                    20.746619f,103.790956f, 20.731368f,103.733432f, 20.668145f,103.736099f, 20.661610f,103.683328f, 20.698378f,103.667719f,
                    20.742633f,103.601684f, 20.753137f,103.509577f, 20.826139f,103.467336f, 20.793477f,103.440871f, 20.784080f,103.390168f,
                    20.837624f,103.290683f, 20.833660f,103.237342f, 20.898164f,103.212530f);
            poly[1997] = new TzPolygon(20.898164f,103.116071f, 20.897184f,103.113404f, 20.898164f,103.112923f);
            poly[1998] = new TzPolygon(20.898164f,104.316493f, 20.880847f,104.333552f, 20.856054f,104.329300f, 20.766278f,104.483830f, 20.712271f,104.499372f,
                    20.698644f,104.524416f, 20.718406f,104.557286f, 20.674044f,104.593694f, 20.670519f,104.638694f, 20.606009f,104.601999f,
                    20.598514f,104.541382f, 20.549632f,104.523358f, 20.489965f,104.387601f, 20.443134f,104.376750f, 20.426808f,104.415552f,
                    20.381065f,104.414158f, 20.368954f,104.474480f, 20.413309f,104.527722f, 20.421866f,104.608857f, 20.461228f,104.624838f,
                    20.474904f,104.660985f, 20.406711f,104.719741f, 20.361146f,104.617286f, 20.242782f,104.614058f, 20.198291f,104.775247f,
                    20.188476f,104.790246f, 19.781174f,104.790246f, 19.773894f,104.761135f, 19.750165f,104.753390f, 19.753758f,104.712305f,
                    19.701362f,104.663162f, 19.673360f,104.656919f, 19.673360f,104.437642f, 19.704932f,104.412708f, 19.673360f,104.336426f,
                    19.673360f,104.316914f, 19.697095f,104.304176f, 19.707582f,104.236699f, 19.696556f,104.163106f, 19.673360f,104.145721f,
                    19.673360f,104.098881f, 19.682683f,104.068445f, 19.673360f,104.066936f, 19.673360f,103.931986f, 20.898164f,103.931986f);
            poly[1999] = new TzPolygon(22.122968f,101.357205f, 22.122968f,101.587574f, 22.103406f,101.577962f, 22.011424f,101.632879f, 21.970231f,101.601219f,
                    21.931054f,101.668611f, 21.945160f,101.699023f, 21.903234f,101.695257f, 21.824448f,101.784860f, 21.728555f,101.745879f,
                    21.717603f,101.768154f, 21.637803f,101.782794f, 21.647177f,101.807342f, 21.626294f,101.834164f, 21.577027f,101.804388f,
                    21.575357f,101.747760f, 21.516790f,101.778930f, 21.482184f,101.734300f, 21.442963f,101.755157f, 21.322866f,101.733657f,
                    21.289202f,101.764249f, 21.291806f,101.800410f, 21.256479f,101.810969f, 21.252605f,101.844671f, 21.207311f,101.840689f,
                    21.207759f,101.794767f, 21.143916f,101.757088f, 21.148822f,101.698583f, 21.203258f,101.670764f, 21.177179f,101.596553f,
                    21.191649f,101.585674f, 21.229605f,101.613773f, 21.256287f,101.548006f, 21.226246f,101.384766f, 21.211166f,101.357205f);
        }
    }

    private static class Initializer21 {
        private static void init() {
            poly[2000] = new TzPolygon(20.978074f,103.073725f, 21.058506f,103.034272f, 21.070703f,102.968052f, 21.141221f,102.949388f, 21.165820f,102.903012f,
                    21.229732f,102.911838f, 21.263691f,102.807696f, 21.299713f,102.852220f, 21.304716f,102.897213f, 21.386018f,102.896188f,
                    21.456580f,102.942231f, 21.428721f,102.869390f, 21.476244f,102.885875f, 21.585934f,102.991913f, 21.744966f,102.974101f,
                    21.702399f,102.877589f, 21.722559f,102.856218f, 21.842295f,102.851543f, 21.846004f,102.833530f, 21.824917f,102.810498f,
                    21.735381f,102.826137f, 21.664452f,102.749125f, 21.654905f,102.674453f, 21.733228f,102.644930f, 21.792704f,102.661827f,
                    21.858308f,102.645370f, 21.878306f,102.610524f, 21.920015f,102.612763f, 21.973535f,102.506155f, 22.006614f,102.488026f,
                    22.029966f,102.518908f, 22.074093f,102.441402f, 22.116931f,102.434789f, 22.122968f,102.409907f, 22.122968f,103.073725f);
            poly[2001] = new TzPolygon(22.290022f,102.215465f, 22.304773f,102.177466f, 22.337059f,102.195160f, 22.399755f,102.144410f, 22.433558f,102.187045f,
                    22.425871f,102.215465f);
            poly[2002] = new TzPolygon(22.122968f,101.591788f, 22.130597f,101.606201f, 22.156160f,101.603885f, 22.242709f,101.549206f, 22.276459f,101.566833f,
                    22.275635f,101.624908f, 22.358689f,101.644027f, 22.373988f,101.670871f, 22.412854f,101.647482f, 22.475762f,101.672459f,
                    22.472549f,101.705804f, 22.508672f,101.760736f, 22.480611f,101.813461f, 22.414286f,101.836314f, 22.381657f,101.895359f,
                    22.439663f,101.914688f, 22.429019f,101.985410f, 22.458051f,102.046079f, 22.432315f,102.125902f, 22.349461f,102.167739f,
                    22.337059f,102.195160f, 22.304773f,102.177466f, 22.290022f,102.215465f, 22.122968f,102.215465f);
            poly[2003] = new TzPolygon(22.449859f,103.073725f, 22.442706f,103.031412f, 22.478319f,102.988440f, 22.484396f,102.928773f, 22.611136f,102.863277f,
                    22.625342f,102.788996f, 22.670392f,102.750087f, 22.703133f,102.688516f, 22.689398f,102.656163f, 22.731909f,102.607670f,
                    22.703408f,102.570037f, 22.762176f,102.532842f, 22.779524f,102.483216f, 22.700591f,102.436832f, 22.681773f,102.384323f,
                    22.635882f,102.418450f, 22.589853f,102.347402f, 22.566618f,102.355008f, 22.557458f,102.320921f, 22.460980f,102.249632f,
                    22.412907f,102.263391f, 22.425871f,102.215465f, 23.347772f,102.215465f, 23.347772f,103.073725f);
            poly[2004] = new TzPolygon(22.290022f,102.215465f, 22.282770f,102.234147f, 22.239015f,102.240488f, 22.236089f,102.272526f, 22.204599f,102.279169f,
                    22.208130f,102.312531f, 22.166044f,102.335127f, 22.122968f,102.422539f, 22.122968f,102.215465f);
            poly[2005] = new TzPolygon(20.978431f,103.073725f, 20.898164f,103.113273f, 20.898164f,103.073725f);
            poly[2006] = new TzPolygon(20.898164f,103.117493f, 20.916616f,103.166297f, 20.901023f,103.211430f, 20.898164f,103.212530f);
            poly[2007] = new TzPolygon(20.898164f,103.894674f, 20.902978f,103.899839f, 20.901897f,104.031864f, 20.949483f,104.052949f, 20.976565f,104.107230f,
                    20.948089f,104.131580f, 20.956103f,104.191130f, 20.932974f,104.242616f, 20.898192f,104.257594f, 20.922713f,104.292309f,
                    20.898164f,104.316493f);
            poly[2008] = new TzPolygon(22.908472f,104.790246f, 22.900592f,104.775140f, 22.858200f,104.756159f, 22.849526f,104.726486f, 22.823336f,104.732941f,
                    22.816773f,104.675553f, 22.835845f,104.654538f, 22.816306f,104.600304f, 22.858250f,104.578495f, 22.690207f,104.373902f,
                    22.729813f,104.325427f, 22.741454f,104.269407f, 22.844915f,104.258838f, 22.812093f,104.116516f, 22.722176f,104.038568f,
                    22.523847f,104.012275f, 22.506763f,103.977584f, 22.565210f,103.877311f, 22.789495f,103.659323f, 22.786067f,103.619439f,
                    22.705896f,103.564011f, 22.664179f,103.579526f, 22.595071f,103.530166f, 22.660389f,103.456564f, 22.713697f,103.426416f,
                    22.753466f,103.440155f, 22.813929f,103.327316f, 22.681256f,103.281577f, 22.644411f,103.184931f, 22.594715f,103.157897f,
                    22.557443f,103.182373f, 22.509846f,103.087706f, 22.451017f,103.080579f, 22.449859f,103.073725f, 23.347772f,103.073725f,
                    23.347772f,104.790246f);
            poly[2009] = new TzPolygon(20.188476f,104.790246f, 20.141594f,104.861893f, 20.158924f,104.927138f, 20.126319f,104.934322f, 20.094807f,104.993768f,
                    20.015943f,104.918212f, 19.967800f,104.902909f, 19.924395f,104.842414f, 19.791357f,104.830964f, 19.781174f,104.790246f);
            poly[2010] = new TzPolygon(18.788925f,104.790246f, 18.773256f,104.859010f, 18.786673f,104.913921f, 18.739280f,104.940834f, 18.749246f,105.022507f,
                    18.731763f,105.023287f, 18.724705f,105.060752f, 18.708740f,105.051835f, 18.716705f,105.133899f, 18.686642f,105.137005f,
                    18.640331f,105.198180f, 18.605185f,105.190747f, 18.613591f,105.159869f, 18.591428f,105.134780f, 18.448556f,105.103730f,
                    18.448556f,104.790246f);
            poly[2011] = new TzPolygon(23.347772f,105.287780f, 23.342463f,105.283665f, 23.337890f,105.252793f, 23.261337f,105.234518f, 23.289189f,105.171475f,
                    23.246098f,105.111973f, 23.266246f,105.079830f, 23.198683f,104.962682f, 23.151015f,104.947586f, 23.179711f,104.897262f,
                    23.125423f,104.876175f, 23.116217f,104.801824f, 22.999029f,104.829226f, 22.947309f,104.864695f, 22.908472f,104.790246f,
                    23.347772f,104.790246f);
            poly[2012] = new TzPolygon(22.928592f,106.506766f, 22.904021f,106.496989f, 22.894896f,106.421312f, 22.874905f,106.413965f, 22.883632f,106.373205f,
                    22.856082f,106.345484f, 22.877186f,106.258061f, 22.915127f,106.261572f, 22.986328f,106.200607f, 23.001202f,106.082954f,
                    22.992649f,106.001887f, 22.940992f,105.997321f, 22.946381f,105.921835f, 22.916766f,105.875711f, 22.987909f,105.837264f,
                    23.036257f,105.731864f, 23.070710f,105.711157f, 23.072312f,105.572094f, 23.160406f,105.574021f, 23.202578f,105.498769f,
                    23.299733f,105.441713f, 23.285267f,105.418925f, 23.318574f,105.371185f, 23.347772f,105.352439f, 23.347772f,106.506766f);
            poly[2013] = new TzPolygon(22.122968f,106.697185f, 22.122968f,108.223287f, 21.295836f,108.223287f, 21.275556f,108.134722f, 21.492699f,108.088550f,
                    21.547398f,108.033687f, 21.536853f,107.954820f, 21.654381f,107.859082f, 21.641116f,107.842266f, 21.655459f,107.782863f,
                    21.608839f,107.676187f, 21.618110f,107.576961f, 21.589431f,107.542544f, 21.598794f,107.482606f, 21.614505f,107.497782f,
                    21.663490f,107.463482f, 21.595217f,107.382633f, 21.599428f,107.362797f, 21.663561f,107.360469f, 21.742649f,107.301053f,
                    21.707775f,107.222121f, 21.793818f,107.111689f, 21.827864f,107.008762f, 21.861557f,107.016123f, 21.895760f,107.063737f,
                    21.944780f,107.023811f, 21.951723f,106.991569f, 21.919443f,106.961190f, 21.930794f,106.929822f, 21.975693f,106.916226f,
                    21.973221f,106.811995f, 22.012799f,106.765233f, 21.964330f,106.690496f, 22.096068f,106.713080f);
            poly[2014] = new TzPolygon(22.919182f,106.506766f, 22.948501f,106.525675f, 22.918835f,106.565640f, 22.929090f,106.601678f, 22.865305f,106.653364f,
                    22.892685f,106.669137f, 22.888861f,106.706389f, 22.810759f,106.765437f, 22.813645f,106.827817f, 22.772078f,106.818074f,
                    22.741594f,106.764744f, 22.708987f,106.779589f, 22.638075f,106.722243f, 22.594142f,106.728519f, 22.575955f,106.653471f,
                    22.605246f,106.611103f, 22.476644f,106.584836f, 22.458820f,106.557473f, 22.393551f,106.586545f, 22.348441f,106.559923f,
                    22.333782f,106.659699f, 22.285945f,106.666920f, 22.277714f,106.690614f, 22.219648f,106.702008f, 22.185955f,106.669586f,
                    22.159437f,106.705935f, 22.138276f,106.688139f, 22.122968f,106.697185f, 22.122968f,106.506766f);
            poly[2015] = new TzPolygon(23.347772f,105.287780f, 23.393395f,105.323146f, 23.347772f,105.352439f);
            poly[2016] = new TzPolygon(6.459000f,99.504759f, 6.481667f,99.511667f, 6.503333f,99.556667f, 6.471456f,99.689076f, 6.523299f,99.916910f,
                    6.459000f,100.004163f);
            poly[2017] = new TzPolygon(6.459000f,100.145117f, 6.480652f,100.159063f, 6.579322f,100.156846f, 6.572808f,100.183570f, 6.693389f,100.171463f,
                    6.726082f,100.205056f, 6.459000f,100.205056f);
            poly[2018] = new TzPolygon(6.726082f,100.205056f, 6.693401f,100.228761f, 6.707848f,100.293035f, 6.679751f,100.294256f, 6.664089f,100.327501f,
                    6.621392f,100.326029f, 6.605229f,100.305175f, 6.540054f,100.365947f, 6.518643f,100.418273f, 6.525473f,100.490209f,
                    6.488562f,100.518825f, 6.495959f,100.562516f, 6.459000f,100.624518f, 6.459000f,100.205056f);
            poly[2019] = new TzPolygon(6.459000f,100.673031f, 6.510354f,100.738640f, 6.459000f,100.752832f);
            poly[2020] = new TzPolygon(18.487057f,97.395561f, 18.576145f,97.343807f, 18.599493f,97.361891f, 18.559904f,97.363054f, 18.565420f,97.395561f);
            poly[2021] = new TzPolygon(25.835113f,94.478373f, 25.835113f,95.035226f, 25.742583f,95.041014f, 25.672092f,94.940282f, 25.606854f,94.912939f,
                    25.588884f,94.880908f, 25.568180f,94.896143f, 25.560366f,94.844971f, 25.481845f,94.782863f, 25.493907f,94.751279f,
                    25.466217f,94.686378f, 25.395509f,94.635598f, 25.215810f,94.577399f, 25.166590f,94.638729f, 25.134950f,94.737559f,
                    25.000860f,94.737210f, 24.982667f,94.703619f, 24.930192f,94.713720f, 24.835094f,94.633165f, 24.711173f,94.606808f,
                    24.706968f,94.546724f, 24.592670f,94.509656f, 24.579991f,94.478373f);
            poly[2022] = new TzPolygon(25.835113f,95.035226f, 25.935049f,95.028974f, 25.974710f,95.115358f, 26.069223f,95.184705f, 26.104443f,95.117405f,
                    26.213727f,95.142011f, 26.236872f,95.116229f, 26.383072f,95.132925f, 26.393793f,95.100873f, 26.417523f,95.104095f,
                    26.452215f,95.063196f, 26.517258f,95.112706f, 26.543334f,95.108018f, 26.582595f,95.153134f, 26.614492f,95.151914f,
                    26.680160f,95.232527f, 26.650863f,95.302841f, 26.702352f,95.439743f, 26.806471f,95.503694f, 26.830255f,95.549764f,
                    26.813944f,95.609250f, 26.904604f,95.675992f, 26.889124f,95.731969f, 27.014887f,95.801580f, 27.014283f,95.872701f,
                    27.047349f,95.936967f, 25.835113f,95.936967f);
            poly[2023] = new TzPolygon(27.047349f,95.936967f, 27.051943f,95.945895f, 27.180012f,96.022244f, 27.223630f,96.090772f, 27.293635f,96.314149f,
                    27.305025f,96.433355f, 27.289244f,96.526308f, 27.314043f,96.581891f, 27.366823f,96.610742f, 27.333826f,96.663766f,
                    27.336200f,96.666264f, 27.041050f,96.666264f, 27.041050f,95.936967f);
            poly[2024] = new TzPolygon(28.246987f,97.385162f, 28.240734f,97.349728f, 28.214658f,97.345948f, 28.233621f,97.284507f, 28.246987f,97.274264f);
            poly[2025] = new TzPolygon(27.336200f,96.666264f, 27.376638f,96.708821f, 27.353945f,96.781557f, 27.246286f,96.888837f, 27.212076f,96.856916f,
                    27.176336f,96.890107f, 27.144812f,97.010564f, 27.095707f,97.076143f, 27.093329f,97.148439f, 27.145857f,97.173768f,
                    27.454908f,96.915456f, 27.507154f,96.934365f, 27.610912f,96.898373f, 27.638361f,96.941465f, 27.660776f,96.937612f,
                    27.671163f,96.994950f, 27.736620f,97.027952f, 27.751902f,97.074456f, 27.739111f,97.102597f, 27.782800f,97.103715f,
                    27.815355f,97.173139f, 27.893805f,97.255136f, 27.915822f,97.303182f, 27.873168f,97.360241f, 27.892064f,97.379136f,
                    27.965321f,97.363148f, 28.018519f,97.394253f, 28.066631f,97.354863f, 28.069860f,97.306681f, 28.116881f,97.344360f,
                    28.139665f,97.325799f, 28.165617f,97.361030f, 28.240734f,97.349728f, 28.246987f,97.395561f, 27.041050f,97.395561f,
                    27.041050f,96.666264f);
            poly[2026] = new TzPolygon(11.823147f,97.395561f, 11.823147f,99.664904f, 11.727168f,99.636262f, 11.688511f,99.588087f, 11.626675f,99.565462f,
                    11.636555f,99.507804f, 11.615105f,99.467844f, 11.533174f,99.474400f, 11.480284f,99.444274f, 11.461220f,99.393728f,
                    11.389192f,99.402298f, 11.316381f,99.312387f, 11.282154f,99.324582f, 11.214809f,99.263630f, 11.109150f,99.226479f,
                    11.082965f,99.179428f, 11.043530f,99.170953f, 11.013948f,99.104527f, 10.955574f,99.080294f, 10.947284f,99.056712f,
                    10.970734f,99.023852f, 10.911178f,98.997743f, 10.856696f,99.011490f, 10.811986f,98.958806f, 10.825714f,98.922846f,
                    10.779174f,98.902322f, 10.776183f,98.858861f, 10.684056f,98.782738f, 10.620488f,98.770790f, 10.592225f,98.810739f,
                    10.558885f,98.798438f, 10.528806f,98.821788f, 10.469337f,98.808882f, 10.393246f,98.755470f, 10.213171f,98.700197f,
                    10.161036f,98.652320f, 9.943513f,98.567210f, 9.924328f,98.524336f, 9.957393f,98.473350f, 9.942910f,98.366360f,
                    9.750721f,98.275237f, 9.565678f,98.217698f, 9.439943f,98.105916f, 9.574722f,97.869444f, 9.609925f,97.718892f,
                    9.807306f,97.675665f, 10.411064f,97.485179f, 10.625445f,97.490568f, 11.047369f,97.395561f);
            poly[2027] = new TzPolygon(18.314450f,97.548732f, 18.286171f,97.536588f, 18.267440f,97.501818f, 18.314450f,97.461327f);
            poly[2028] = new TzPolygon(11.823147f,99.664904f, 11.833085f,99.622011f, 11.868528f,99.609965f, 11.872245f,99.588009f, 11.992515f,99.592249f,
                    12.016890f,99.536520f, 12.066005f,99.534100f, 12.144508f,99.571294f, 12.131602f,99.473312f, 12.197542f,99.496395f,
                    12.234697f,99.471003f, 12.273757f,99.484465f, 12.342799f,99.433841f, 12.407101f,99.445888f, 12.459914f,99.400994f,
                    12.581460f,99.440483f, 12.677780f,99.294581f, 12.715050f,99.289497f, 12.726562f,99.238627f, 12.822149f,99.222138f,
                    12.845152f,99.188630f, 12.911170f,99.182534f, 12.928251f,99.162256f, 12.952523f,99.193562f, 12.990575f,99.194853f,
                    13.072735f,99.099511f, 13.097311f,99.131147f, 13.194720f,99.123292f, 13.208397f,99.156626f, 13.193978f,99.199820f,
                    13.255114f,99.196364f, 13.261568f,99.211641f, 13.291117f,99.186935f, 13.413629f,99.210314f, 13.445973f,99.205916f,
                    13.445973f,99.664904f);
            poly[2029] = new TzPolygon(13.445973f,99.664904f, 13.445973f,99.205916f, 13.545019f,99.192448f, 13.574239f,99.163586f, 13.585750f,99.178848f,
                    13.724119f,99.168169f, 13.773030f,99.121417f, 13.838055f,99.099442f, 13.893235f,99.107729f, 13.894047f,99.077250f,
                    13.929294f,99.059349f, 13.945622f,99.020783f, 14.097369f,98.958589f, 14.109090f,98.899153f, 14.273762f,98.699813f,
                    14.321671f,98.601555f, 14.376196f,98.593943f, 14.384916f,98.564954f, 14.540626f,98.491861f, 14.530862f,98.461617f,
                    14.613089f,98.437168f, 14.709828f,98.323582f, 14.813849f,98.253945f, 14.858468f,98.259338f, 14.889879f,98.229768f,
                    14.915984f,98.250971f, 14.980466f,98.208585f, 15.044423f,98.231354f, 15.068799f,98.208956f, 15.068799f,99.664904f);
            poly[2030] = new TzPolygon(15.068799f,98.208956f, 15.096308f,98.183678f, 15.182008f,98.213371f, 15.234347f,98.198120f, 15.223653f,98.258612f,
                    15.280852f,98.303820f, 15.313504f,98.297712f, 15.254069f,98.401447f, 15.272034f,98.417544f, 15.301958f,98.407348f,
                    15.301088f,98.386146f, 15.308157f,98.401664f, 15.334627f,98.389589f, 15.365362f,98.417070f, 15.368122f,98.454956f,
                    15.383242f,98.450069f, 15.371226f,98.470938f, 15.389278f,98.499970f, 15.336037f,98.559624f, 15.471216f,98.585365f,
                    15.685239f,98.548287f, 15.864699f,98.606818f, 15.068799f,98.606818f);
            poly[2031] = new TzPolygon(15.882899f,98.606818f, 15.918138f,98.584024f, 15.989157f,98.605493f, 16.044881f,98.562582f, 16.076158f,98.589207f,
                    16.044570f,98.606818f);
            poly[2032] = new TzPolygon(16.523735f,98.606818f, 16.558518f,98.576837f, 16.631827f,98.571442f, 16.644858f,98.512037f, 16.691624f,98.515558f,
                    16.691624f,98.606818f);
            poly[2033] = new TzPolygon(16.523735f,98.606818f, 16.471461f,98.651875f, 16.412478f,98.637620f, 16.400038f,98.656059f, 16.272014f,98.674750f,
                    16.270791f,98.703234f, 16.328758f,98.726784f, 16.344059f,98.777344f, 16.421918f,98.829806f, 16.423026f,98.881438f,
                    16.387257f,98.917981f, 16.346804f,98.909374f, 16.328888f,98.931746f, 16.253732f,98.902832f, 16.219575f,98.851960f,
                    16.127866f,98.848512f, 16.104573f,98.805414f, 16.135718f,98.699128f, 16.043846f,98.627950f, 16.041887f,98.608314f,
                    16.044570f,98.606818f);
            poly[2034] = new TzPolygon(15.882899f,98.606818f, 15.876798f,98.610764f, 15.864699f,98.606818f);
            poly[2035] = new TzPolygon(16.691624f,98.495319f, 16.714631f,98.501907f, 16.712452f,98.470939f, 16.730221f,98.463173f, 16.789375f,98.485280f,
                    16.813537f,98.547435f, 16.842008f,98.492142f, 16.858615f,98.516192f, 16.880017f,98.509220f, 16.861465f,98.540143f,
                    16.917607f,98.521514f, 16.936624f,98.482610f, 16.947968f,98.508494f, 17.053498f,98.412521f, 17.064256f,98.322956f,
                    17.092635f,98.300223f, 17.110869f,98.323378f, 17.107312f,98.301807f, 17.127769f,98.298604f, 17.115816f,98.280058f,
                    17.147414f,98.298509f, 17.151166f,98.272397f, 17.172900f,98.280533f, 17.182323f,98.250225f, 17.210075f,98.247722f,
                    17.204856f,98.227909f, 17.226991f,98.244217f, 17.228444f,98.213592f, 17.320885f,98.111621f, 17.385309f,98.110399f,
                    17.390321f,98.080095f, 17.503037f,97.997649f, 17.503037f,98.606818f, 16.691624f,98.606818f, 16.691624f,98.515558f,
                    16.694826f,98.515799f);
            poly[2036] = new TzPolygon(18.314450f,97.622409f, 18.287669f,97.639460f, 18.237887f,97.609287f, 18.161708f,97.675900f, 18.064137f,97.681795f,
                    18.056607f,97.707935f, 17.974620f,97.737521f, 17.877783f,97.672086f, 17.819156f,97.699359f, 17.753014f,97.774171f,
                    17.725482f,97.762727f, 17.679361f,97.793786f, 17.583600f,97.906539f, 17.539461f,97.923218f, 17.509875f,97.992648f,
                    17.503037f,97.997649f, 17.503037f,97.548732f, 18.314450f,97.548732f);
            poly[2037] = new TzPolygon(17.500585f,101.170080f, 17.469289f,101.163443f, 17.479941f,101.109919f, 17.509258f,101.103229f, 17.502531f,101.080055f,
                    17.545900f,101.045057f, 17.571515f,100.967550f, 17.699665f,101.009010f, 17.761334f,100.977389f, 17.784270f,101.006612f,
                    17.820795f,100.998623f, 17.833296f,101.032137f, 17.892582f,101.019764f, 17.951058f,101.116703f, 18.000127f,101.121620f,
                    18.050637f,101.170080f);
            poly[2038] = new TzPolygon(18.100389f,101.170080f, 18.123643f,101.160936f, 18.149411f,101.170080f);
            poly[2039] = new TzPolygon(18.216924f,101.170080f, 18.217731f,101.165386f, 18.258599f,101.144204f, 18.314450f,101.170080f);
            poly[2040] = new TzPolygon(18.487057f,97.395561f, 18.389797f,97.452062f, 18.330335f,97.447645f, 18.314450f,97.461327f, 18.314450f,97.395561f);
            poly[2041] = new TzPolygon(18.314450f,97.548732f, 18.339370f,97.559433f, 18.317873f,97.620230f, 18.314450f,97.622409f);
            poly[2042] = new TzPolygon(18.554059f,97.410440f, 18.554059f,97.616000f, 18.539254f,97.619865f, 18.529458f,97.545967f, 18.491094f,97.534386f,
                    18.511137f,97.481755f, 18.495010f,97.443973f);
            poly[2043] = new TzPolygon(18.345556f,101.170080f, 18.381081f,101.084529f, 18.442121f,101.054111f, 18.521494f,101.103581f, 18.554059f,101.170080f);
            poly[2044] = new TzPolygon(18.565420f,97.395561f, 18.566724f,97.403248f, 18.554059f,97.410440f, 18.554059f,97.395561f);
            poly[2045] = new TzPolygon(19.765675f,97.410440f, 19.765675f,98.029796f, 19.722110f,98.024747f, 19.653547f,98.044310f, 19.634383f,97.972567f,
                    19.592673f,97.960732f, 19.575830f,97.861743f, 19.531425f,97.855175f, 19.500610f,97.888172f, 19.398389f,97.785416f,
                    19.292874f,97.842894f, 19.267459f,97.782711f, 19.215869f,97.845179f, 19.094955f,97.837046f, 19.073236f,97.768950f,
                    19.045025f,97.768973f, 19.040482f,97.735587f, 18.978735f,97.738324f, 18.937917f,97.665527f, 18.881642f,97.741274f,
                    18.689190f,97.774020f, 18.578813f,97.769151f, 18.577232f,97.651101f, 18.561216f,97.614132f, 18.554059f,97.616000f,
                    18.554059f,97.410440f);
            poly[2046] = new TzPolygon(19.765675f,98.998217f, 19.739085f,98.985646f, 19.765675f,98.955211f);
            poly[2047] = new TzPolygon(19.765675f,98.791713f, 19.752790f,98.778854f, 19.765675f,98.724606f);
            poly[2048] = new TzPolygon(19.765675f,98.706440f, 19.715039f,98.626229f, 19.715830f,98.589957f, 19.672076f,98.566032f, 19.717686f,98.509193f,
                    19.692267f,98.466019f, 19.704320f,98.393100f, 19.676379f,98.248528f, 19.727721f,98.228817f, 19.765675f,98.175483f);
            poly[2049] = new TzPolygon(19.765675f,98.029796f, 19.805544f,98.034416f, 19.810341f,98.083352f, 19.772087f,98.100616f, 19.788187f,98.135426f,
                    19.770799f,98.168282f, 19.765675f,98.175483f);
            poly[2050] = new TzPolygon(19.765675f,98.706440f, 19.768810f,98.711406f, 19.765675f,98.724606f);
            poly[2051] = new TzPolygon(19.765675f,98.791713f, 19.813616f,98.839557f, 19.765832f,98.898418f, 19.768840f,98.951588f, 19.765675f,98.955211f);
            poly[2052] = new TzPolygon(19.765675f,98.998217f, 19.834402f,99.030710f, 19.927170f,99.021834f, 19.931267f,99.042627f, 20.038265f,99.044441f,
                    20.101131f,99.076954f, 20.130889f,99.210408f, 20.112047f,99.290260f, 19.765675f,99.290260f);
            poly[2053] = new TzPolygon(19.765675f,100.415652f, 19.765675f,101.170080f, 19.575048f,101.170080f, 19.572127f,101.122800f, 19.628509f,101.035342f,
                    19.634070f,100.892793f, 19.487359f,100.771432f, 19.511649f,100.757572f, 19.556321f,100.651837f, 19.548300f,100.609302f,
                    19.498852f,100.580467f, 19.523328f,100.513037f, 19.548221f,100.482411f, 19.609161f,100.483217f, 19.627435f,100.447487f,
                    19.672665f,100.427875f, 19.707063f,100.446054f, 19.752539f,100.403966f);
            poly[2054] = new TzPolygon(20.339271f,100.230170f, 20.317744f,100.221229f, 20.298123f,100.167476f, 20.244671f,100.167987f, 20.266008f,100.093057f,
                    20.356719f,100.084325f, 20.405480f,100.123684f, 20.635278f,100.175278f, 20.714614f,100.230170f);
            poly[2055] = new TzPolygon(20.977291f,100.230170f, 20.714614f,100.230170f, 20.635278f,100.175278f, 20.405480f,100.123684f, 20.352275f,100.084653f,
                    20.389669f,100.071602f, 20.412807f,100.003539f, 20.464834f,99.960332f, 20.446061f,99.864971f, 20.337839f,99.809146f,
                    20.350117f,99.730143f, 20.316183f,99.681463f, 20.392796f,99.458410f, 20.362399f,99.455749f, 20.325770f,99.507097f,
                    20.233442f,99.522577f, 20.205936f,99.563785f, 20.147665f,99.538597f, 20.151939f,99.511783f, 20.116223f,99.498172f,
                    20.086013f,99.400595f, 20.112047f,99.290260f, 20.977291f,99.290260f);
            poly[2056] = new TzPolygon(20.334956f,100.230170f, 20.397732f,100.264270f, 20.402032f,100.313253f, 20.378548f,100.354803f, 20.254927f,100.413547f,
                    20.151016f,100.507395f, 20.167794f,100.578496f, 19.903365f,100.520290f, 19.864583f,100.496559f, 19.847301f,100.449278f,
                    19.790989f,100.438173f, 19.765675f,100.415652f, 19.765675f,100.230170f);
            poly[2057] = new TzPolygon(20.977291f,100.532688f, 20.893575f,100.509165f, 20.870351f,100.544072f, 20.898100f,100.636768f, 20.881137f,100.648635f,
                    20.824157f,100.571344f, 20.826878f,100.364427f, 20.751077f,100.255399f, 20.714614f,100.230170f, 20.977291f,100.230170f);
            poly[2058] = new TzPolygon(22.107437f,99.290260f, 22.149641f,99.167696f, 22.168091f,99.156190f, 22.170969f,99.198731f, 22.189999f,99.173503f,
                    22.250360f,99.235572f, 22.297027f,99.233072f, 22.348694f,99.278072f, 22.395361f,99.251405f, 22.425306f,99.290260f);
            poly[2059] = new TzPolygon(23.104451f,99.290260f, 23.079957f,99.249202f, 23.111673f,99.199819f, 23.091722f,99.103167f, 23.124017f,99.046753f,
                    23.173555f,99.060871f, 23.162958f,99.004816f, 23.182777f,98.885252f, 23.309898f,98.945180f, 23.335241f,98.909543f,
                    23.329112f,98.877183f, 23.354892f,98.919659f, 23.400523f,98.920465f, 23.400523f,99.290260f);
            poly[2060] = new TzPolygon(21.483982f,100.230170f, 21.514659f,100.201165f, 21.517128f,100.178694f, 21.486052f,100.168609f, 21.512179f,100.125541f,
                    21.594986f,100.107439f, 21.650071f,100.172795f, 21.676818f,100.162070f, 21.706749f,100.096097f, 21.667486f,100.050233f,
                    21.715713f,99.984361f, 21.824938f,99.943523f, 21.909611f,99.959342f, 21.974482f,99.998729f, 22.032611f,99.959073f,
                    22.059284f,99.971924f, 22.070693f,99.879029f, 22.059555f,99.862033f, 22.038811f,99.878324f, 22.025993f,99.854283f,
                    22.074374f,99.742635f, 22.041522f,99.700961f, 22.071669f,99.696916f, 22.105598f,99.651416f, 22.096759f,99.613735f,
                    22.117868f,99.561506f, 22.097414f,99.525994f, 22.136471f,99.476162f, 22.104112f,99.433863f, 22.095241f,99.325677f,
                    22.107437f,99.290260f, 22.188907f,99.290260f, 22.188907f,100.230170f);
            poly[2061] = new TzPolygon(21.355308f,101.170080f, 21.410884f,101.140995f, 21.423272f,101.170080f);
            poly[2062] = new TzPolygon(21.483982f,100.230170f, 22.188907f,100.230170f, 22.188907f,101.170080f, 21.565533f,101.170080f, 21.572083f,101.137691f,
                    21.605488f,101.169940f, 21.670681f,101.152507f, 21.693371f,101.115115f, 21.776391f,101.120590f, 21.776180f,101.087588f,
                    21.707780f,101.010327f, 21.687292f,100.884602f, 21.619479f,100.809949f, 21.570949f,100.793560f, 21.571838f,100.771201f,
                    21.479466f,100.667791f, 21.451276f,100.578987f, 21.472524f,100.521285f, 21.458778f,100.479613f, 21.541469f,100.430930f,
                    21.531245f,100.349484f, 21.481444f,100.298794f, 21.466359f,100.246832f);
            poly[2063] = new TzPolygon(20.977291f,100.532688f, 21.024666f,100.545999f, 21.029198f,100.596210f, 21.061526f,100.637008f, 21.128462f,100.673552f,
                    21.311915f,100.724649f, 21.297881f,100.829554f, 21.349681f,100.886734f, 21.386294f,100.999689f, 21.455032f,101.058887f,
                    21.525099f,101.162866f, 21.563792f,101.149227f, 21.561410f,101.170080f, 21.421150f,101.170080f, 21.406848f,101.141338f,
                    21.355555f,101.170080f, 20.977291f,101.170080f);
            poly[2064] = new TzPolygon(23.104451f,99.290260f, 23.137506f,99.345670f, 23.082579f,99.436665f, 23.084681f,99.510494f, 23.054164f,99.532587f,
                    22.996902f,99.520050f, 22.933009f,99.566030f, 22.900765f,99.535410f, 22.942400f,99.441191f, 22.847335f,99.462111f,
                    22.829292f,99.400871f, 22.764953f,99.385422f, 22.739341f,99.314749f, 22.587139f,99.384739f, 22.537027f,99.358905f,
                    22.496194f,99.382239f, 22.425306f,99.290260f);
            poly[2065] = new TzPolygon(24.099593f,98.350350f, 24.117468f,98.224093f, 24.095110f,98.108908f, 24.017638f,97.901601f, 23.997887f,97.883356f,
                    23.977780f,97.895467f, 23.971833f,97.820635f, 23.945694f,97.813307f, 23.962911f,97.813935f, 23.956493f,97.793994f,
                    23.910851f,97.764362f, 23.885122f,97.705042f, 23.866481f,97.709044f, 23.882419f,97.683638f, 23.843530f,97.645851f,
                    23.882993f,97.632655f, 23.929391f,97.528183f, 23.987311f,97.575168f, 24.005013f,97.628695f, 24.049326f,97.632001f,
                    24.114825f,97.730135f, 24.167548f,97.752857f, 24.188166f,97.728256f, 24.229883f,97.729558f, 24.264250f,97.769206f,
                    24.300979f,97.719155f, 24.300187f,97.666338f, 24.347432f,97.667502f, 24.345461f,97.702846f, 24.365456f,97.716505f,
                    24.408847f,97.675729f, 24.456352f,97.669496f, 24.436703f,97.528467f, 24.496669f,97.556156f, 24.612139f,97.569353f,
                    24.612139f,98.350350f);
            poly[2066] = new TzPolygon(24.099593f,98.350350f, 24.098769f,98.356172f, 24.131124f,98.543513f, 24.082718f,98.592825f, 24.107676f,98.695880f,
                    24.130611f,98.716587f, 24.131116f,98.848414f, 24.155870f,98.877342f, 24.110256f,98.897954f, 24.066930f,98.863608f,
                    24.026078f,98.799159f, 24.029710f,98.770194f, 23.972944f,98.737976f, 23.987477f,98.700409f, 23.963758f,98.675456f,
                    23.940588f,98.704659f, 23.913030f,98.678472f, 23.842558f,98.705071f, 23.806514f,98.672154f, 23.771914f,98.805295f,
                    23.642637f,98.846187f, 23.617458f,98.890889f, 23.539592f,98.801806f, 23.483987f,98.821329f, 23.488675f,98.872726f,
                    23.420251f,98.920813f, 23.400523f,98.920465f, 23.400523f,98.350350f);
            poly[2067] = new TzPolygon(25.823755f,98.511231f, 25.783886f,98.475231f, 25.691454f,98.460409f, 25.664022f,98.410736f, 25.599410f,98.402930f,
                    25.548659f,98.315065f, 25.607295f,98.253343f, 25.625569f,98.167347f, 25.574000f,98.188427f, 25.509605f,98.124972f,
                    25.452827f,98.157745f, 25.386988f,98.137938f, 25.392859f,98.100272f, 25.314768f,98.070726f, 25.307108f,98.012961f,
                    25.217615f,97.944186f, 25.217988f,97.904505f, 25.261668f,97.875559f, 25.272700f,97.839723f, 25.125187f,97.778956f,
                    25.080543f,97.744223f, 25.084203f,97.720692f, 24.911828f,97.729650f, 24.851520f,97.797036f, 24.828418f,97.765486f,
                    24.846118f,97.702353f, 24.742020f,97.546864f, 24.659310f,97.574744f, 24.612139f,97.564990f, 24.612139f,97.410440f,
                    25.823755f,97.410440f);
            poly[2068] = new TzPolygon(25.823755f,98.663677f, 25.799809f,98.632280f, 25.823755f,98.582114f);
            poly[2069] = new TzPolygon(27.035371f,97.410440f, 27.035371f,98.764691f, 27.021477f,98.762994f, 27.005010f,98.733194f, 26.883706f,98.757905f,
                    26.854580f,98.730998f, 26.802153f,98.762343f, 26.712973f,98.743020f, 26.693290f,98.770522f, 26.605335f,98.782209f,
                    26.565619f,98.754003f, 26.354742f,98.733901f, 26.279289f,98.676517f, 26.242681f,98.672412f, 26.241432f,98.706246f,
                    26.189999f,98.735917f, 26.153440f,98.707872f, 26.130272f,98.720174f, 26.091379f,98.668338f, 26.147616f,98.646658f,
                    26.132834f,98.603035f, 26.146559f,98.583874f, 26.121296f,98.573048f, 25.973806f,98.615685f, 25.977471f,98.641927f,
                    25.941681f,98.681657f, 25.855488f,98.705283f, 25.823755f,98.663677f, 25.823755f,98.582114f, 25.847399f,98.532580f,
                    25.823755f,98.511231f, 25.823755f,97.410440f);
            poly[2070] = new TzPolygon(28.246987f,98.014537f, 28.198078f,98.019806f, 28.205488f,98.080634f, 28.167161f,98.096857f, 28.143137f,98.140998f,
                    28.088519f,98.160670f, 28.044708f,98.137718f, 27.955816f,98.139692f, 27.940842f,98.190449f, 27.891913f,98.206033f,
                    27.841591f,98.172514f, 27.812861f,98.224925f, 27.767241f,98.217525f, 27.741558f,98.245733f, 27.715765f,98.222346f,
                    27.631959f,98.301987f, 27.523120f,98.317123f, 27.510932f,98.376412f, 27.551534f,98.428582f, 27.669042f,98.441956f,
                    27.622724f,98.527666f, 27.648581f,98.557267f, 27.569094f,98.589654f, 27.568398f,98.646767f, 27.589873f,98.664396f,
                    27.562826f,98.704924f, 27.429448f,98.686380f, 27.332113f,98.741054f, 27.224131f,98.723312f, 27.200040f,98.691690f,
                    27.078241f,98.711889f, 27.052123f,98.766737f, 27.035371f,98.764691f, 27.035371f,97.410440f, 28.246987f,97.410440f);
            poly[2071] = new TzPolygon(30.597342f,42.791612f, 31.111658f,42.085599f, 31.373207f,41.440726f, 31.948076f,40.413254f, 31.979666f,40.227580f,
                    31.979666f,42.791612f);
            poly[2072] = new TzPolygon(34.680299f,40.227580f, 34.680299f,41.144910f, 34.653705f,41.122297f, 34.397851f,40.978032f, 34.315105f,40.640015f,
                    34.103351f,40.227580f);
            poly[2073] = new TzPolygon(34.680299f,41.144910f, 34.778334f,41.228272f, 35.132249f,41.218105f, 35.384918f,41.274922f, 35.456026f,41.262175f,
                    35.625278f,41.382038f, 35.843617f,41.369412f, 36.059980f,41.255821f, 36.366770f,41.294872f, 36.524067f,41.402112f,
                    36.587650f,41.817194f, 37.055553f,42.369192f, 37.115280f,42.363053f, 37.145855f,42.578834f, 37.266653f,42.653791f,
                    37.291689f,42.697579f, 37.308307f,42.687920f, 37.318496f,42.735289f, 37.380932f,42.791612f, 34.680299f,42.791612f);
            poly[2074] = new TzPolygon(37.380932f,40.227580f, 37.380932f,42.791612f, 37.318496f,42.735289f, 37.308307f,42.687920f, 37.270873f,42.682862f,
                    37.266653f,42.653791f, 37.143621f,42.570978f, 37.142159f,42.464059f, 37.105265f,42.351505f, 37.185396f,42.320605f,
                    37.232439f,42.342724f, 37.281470f,42.284124f, 37.280519f,42.204832f, 37.313467f,42.225894f, 37.318459f,42.206951f,
                    37.182048f,42.034918f, 37.077947f,41.517546f, 37.079639f,41.265687f, 37.061883f,41.218055f, 37.094743f,41.163581f,
                    37.131735f,40.914284f, 37.106798f,40.834597f, 37.127807f,40.766029f, 37.028384f,40.530910f, 37.015392f,40.413103f,
                    36.962806f,40.356638f, 36.899584f,40.227580f);
            poly[2075] = new TzPolygon(29.062039f,46.900321f, 29.100273f,46.552684f, 29.437013f,46.866769f, 29.494846f,46.900321f);
            poly[2076] = new TzPolygon(30.597342f,42.791612f, 29.196033f,44.715219f, 29.058566f,46.424535f, 29.100045f,46.563121f, 29.062615f,46.900321f,
                    28.246987f,46.900321f, 28.246987f,42.791612f);
            poly[2077] = new TzPolygon(32.623826f,46.900321f, 32.631954f,46.887238f, 32.785960f,46.720615f, 32.813960f,46.644937f, 32.813960f,46.900321f);
            poly[2078] = new TzPolygon(29.062615f,46.900321f, 28.999917f,47.465167f, 28.835613f,47.584698f, 28.654889f,47.605374f, 28.543086f,47.709038f,
                    28.524362f,47.704461f, 28.534354f,48.430564f, 28.672689f,48.669444f, 28.622032f,48.696519f, 28.451704f,48.954676f,
                    28.246987f,48.954676f, 28.246987f,46.900321f);
            poly[2079] = new TzPolygon(29.494846f,46.900321f, 29.663422f,46.998122f, 29.722137f,47.006949f, 29.986796f,47.139357f, 30.028350f,47.189553f,
                    30.103808f,47.411187f, 30.103693f,47.707604f, 29.989910f,48.011689f, 30.027877f,48.068133f, 30.024583f,48.154833f,
                    29.852676f,48.414122f, 29.666637f,48.592031f, 29.571623f,48.539464f, 29.502482f,48.623116f, 29.431302f,48.663747f,
                    29.388730f,48.663738f, 29.388730f,46.900321f);
            poly[2080] = new TzPolygon(29.754585f,48.954676f, 29.747704f,48.854465f, 29.811784f,48.826035f, 29.996255f,48.456059f, 30.072500f,48.438333f,
                    30.123195f,48.382750f, 30.170565f,48.415957f, 30.211389f,48.408056f, 30.336087f,48.272733f, 30.320577f,48.202733f,
                    30.435120f,48.151161f, 30.477347f,48.024415f, 30.530473f,48.025212f, 30.530473f,48.954676f);
            poly[2081] = new TzPolygon(28.933279f,48.954676f, 28.876990f,48.994547f, 28.806071f,49.004681f, 28.788821f,48.954676f);
            poly[2082] = new TzPolygon(28.451704f,48.954676f, 28.334350f,49.132542f, 28.246987f,49.195075f, 28.246987f,48.954676f);
            poly[2083] = new TzPolygon(32.623826f,46.900321f, 32.457281f,47.168401f, 32.463729f,47.247204f, 32.496125f,47.285872f, 32.473212f,47.379567f,
                    32.391316f,47.465348f, 32.351867f,47.435256f, 32.314316f,47.463140f, 32.304516f,47.519494f, 32.277875f,47.499849f,
                    32.214263f,47.570527f, 32.170546f,47.527892f, 32.141752f,47.529201f, 32.112076f,47.565708f, 32.109142f,47.613738f,
                    32.018185f,47.682828f, 32.018895f,47.712418f, 31.939258f,47.731711f, 31.881373f,47.809860f, 31.842578f,47.805337f,
                    31.818223f,47.852568f, 31.783613f,47.865855f, 31.394609f,47.682971f, 31.002957f,47.687388f, 30.995374f,48.032190f,
                    30.530473f,48.025212f, 30.530473f,46.900321f);
            poly[2084] = new TzPolygon(32.813960f,46.644937f, 32.822218f,46.622615f, 32.933275f,46.447421f, 32.972447f,46.266369f, 32.955131f,46.159405f,
                    32.981680f,46.096511f, 33.019813f,46.099162f, 33.020975f,46.129911f, 33.069428f,46.164625f, 33.094539f,46.040370f,
                    33.128255f,46.053174f, 33.117080f,46.125454f, 33.197072f,46.212346f, 33.206344f,46.180584f, 33.263970f,46.189827f,
                    33.351755f,46.080962f, 33.507810f,46.007252f, 33.481894f,45.939491f, 33.493148f,45.863003f, 33.561330f,45.961002f,
                    33.606284f,45.905254f, 33.638097f,45.907062f, 33.628415f,45.814716f, 33.592917f,45.753165f, 33.636936f,45.771670f,
                    33.733966f,45.642104f, 33.772000f,45.643764f, 33.945574f,45.511585f, 33.945556f,45.431545f, 33.955703f,45.423900f,
                    33.955703f,46.900321f, 32.813960f,46.900321f);
            poly[2085] = new TzPolygon(33.955703f,45.423900f, 33.977255f,45.407661f, 34.009822f,45.466848f, 34.075608f,45.473516f, 34.146130f,45.581594f,
                    34.195116f,45.554874f, 34.302663f,45.583566f, 34.352107f,45.538075f, 34.336867f,45.496178f, 34.453823f,45.439841f,
                    34.480982f,45.521255f, 34.599875f,45.529074f, 34.549889f,45.594687f, 34.559577f,45.683472f, 34.538035f,45.743204f,
                    34.693772f,45.702625f, 34.723110f,45.653259f, 34.770020f,45.698760f, 34.815711f,45.689876f, 34.853026f,45.792074f,
                    34.912296f,45.788431f, 34.896328f,45.865040f, 34.959992f,45.897312f, 35.031513f,45.876525f, 35.045347f,45.930795f,
                    35.095489f,45.921987f, 35.037953f,46.059426f, 35.083131f,46.071919f, 35.074065f,46.116562f, 35.097446f,46.164011f,
                    35.097446f,46.900321f, 33.955703f,46.900321f);
            poly[2086] = new TzPolygon(36.786863f,44.845967f, 36.797129f,44.836814f, 36.815504f,44.845967f);
            poly[2087] = new TzPolygon(37.046556f,44.845967f, 37.044148f,44.807265f, 37.112879f,44.749666f, 37.145086f,44.784929f, 37.228341f,44.757568f,
                    37.278060f,44.814586f, 37.310113f,44.799184f, 37.380932f,44.686200f, 37.380932f,44.845967f);
            poly[2088] = new TzPolygon(37.380932f,44.686200f, 37.310113f,44.799184f, 37.278060f,44.814586f, 37.228341f,44.757568f, 37.143850f,44.784306f,
                    37.166539f,44.764031f, 37.189440f,44.625370f, 37.074089f,44.466789f, 37.052264f,44.358602f, 37.024644f,44.367333f,
                    36.962705f,44.309523f, 36.982849f,44.251091f, 37.097863f,44.185120f, 37.159512f,44.224026f, 37.166074f,44.277951f,
                    37.244400f,44.268368f, 37.322719f,44.126128f, 37.327790f,44.018485f, 37.292179f,43.954750f, 37.224773f,43.919411f,
                    37.224408f,43.854262f, 37.193085f,43.830395f, 37.229100f,43.789677f, 37.235255f,43.689132f, 37.217217f,43.642527f,
                    37.257579f,43.565950f, 37.242385f,43.498498f, 37.327591f,43.361088f, 37.303705f,43.301488f, 37.372451f,43.147827f,
                    37.355927f,43.022714f, 37.312218f,42.959152f, 37.343684f,42.835983f, 37.380932f,42.791612f);
            poly[2089] = new TzPolygon(35.097446f,46.164011f, 35.110888f,46.191291f, 35.128999f,46.155059f, 35.159001f,46.154758f, 35.201229f,46.201247f,
                    35.228359f,46.177792f, 35.241129f,46.108403f, 35.284223f,46.158538f, 35.312972f,46.145457f, 35.368768f,46.067567f,
                    35.496023f,45.985425f, 35.520698f,46.017991f, 35.584696f,45.973302f, 35.577581f,46.030089f, 35.634401f,45.992997f,
                    35.678707f,46.009149f, 35.706728f,46.042465f, 35.688964f,46.165081f, 35.722322f,46.199560f, 35.728866f,46.277041f,
                    35.763349f,46.333321f, 35.801026f,46.345923f, 35.835867f,46.294615f, 35.794952f,46.212274f, 35.812492f,46.183814f,
                    35.800110f,46.167360f, 35.843527f,46.137288f, 35.858430f,46.078562f, 35.834468f,46.024647f, 35.843593f,45.964013f,
                    35.822803f,45.954344f, 35.837649f,45.896036f, 35.811362f,45.874868f, 35.827039f,45.800380f, 35.799014f,45.763701f,
                    35.926916f,45.665625f, 36.001954f,45.550300f, 35.998965f,45.439923f, 35.966995f,45.393380f, 35.978578f,45.348510f,
                    36.084180f,45.381363f, 36.139867f,45.327046f, 36.214017f,45.330546f, 36.239189f,45.288929f, 36.239189f,46.900321f,
                    35.097446f,46.900321f);
            poly[2090] = new TzPolygon(37.047274f,44.845967f, 37.047090f,44.854548f, 37.009779f,44.905552f, 36.954349f,44.882687f, 36.917009f,44.912415f,
                    36.861410f,44.903699f, 36.821071f,44.845967f);
            poly[2091] = new TzPolygon(36.778777f,44.845967f, 36.785928f,44.940179f, 36.749348f,44.972409f, 36.740471f,45.030589f, 36.689456f,45.065388f,
                    36.630243f,45.070777f, 36.603375f,45.026986f, 36.564951f,45.038814f, 36.551637f,45.004416f, 36.524238f,45.007866f,
                    36.506649f,45.053896f, 36.430530f,45.078198f, 36.405762f,45.113700f, 36.434102f,45.236530f, 36.393518f,45.272404f,
                    36.336817f,45.283314f, 36.301289f,45.260964f, 36.273747f,45.304553f, 36.253206f,45.265754f, 36.239189f,45.288929f,
                    36.239189f,44.845967f);
            poly[2092] = new TzPolygon(39.025131f,42.751408f, 39.025131f,44.210055f, 39.020950f,44.211677f, 38.991791f,44.171794f, 38.890557f,44.211352f,
                    38.850682f,44.245308f, 38.840802f,44.300988f, 38.808795f,44.314820f, 38.718334f,44.254067f, 38.674969f,44.282641f,
                    38.646248f,44.272119f, 38.624092f,44.321620f, 38.502081f,44.325460f, 38.447229f,44.301938f, 38.408606f,44.319832f,
                    38.394168f,44.299987f, 38.358592f,44.379645f, 38.385492f,44.449371f, 38.341260f,44.512531f, 38.303696f,44.492951f,
                    38.252000f,44.402269f, 38.146443f,44.392693f, 38.134994f,44.351181f, 38.103909f,44.364509f, 38.072894f,44.311362f,
                    37.965056f,44.240713f, 37.888239f,44.222746f, 37.867305f,44.267398f, 37.862511f,44.388189f, 37.823061f,44.394447f,
                    37.799449f,44.423753f, 37.806585f,44.448377f, 37.770917f,44.444951f, 37.780626f,44.554572f, 37.727020f,44.620623f,
                    37.644762f,44.568160f, 37.602176f,44.614409f, 37.447606f,44.579829f, 37.380932f,44.686200f, 37.380932f,42.751408f);
            poly[2093] = new TzPolygon(40.023626f,44.013323f, 40.021017f,43.899416f, 40.112514f,43.656498f, 40.145699f,43.650799f, 40.171895f,43.712843f,
                    40.224885f,43.653100f, 40.226645f,43.683711f, 40.257339f,43.682808f, 40.272422f,43.640942f, 40.345129f,43.590814f,
                    40.421507f,43.619721f, 40.476895f,43.542128f, 40.519285f,43.634371f, 40.537878f,43.628445f, 40.531252f,43.649929f,
                    40.561738f,43.643398f, 40.669330f,43.740823f, 40.669330f,44.013323f);
            poly[2094] = new TzPolygon(39.025131f,44.210055f, 39.074591f,44.190867f, 39.095050f,44.225910f, 39.130305f,44.213566f, 39.204492f,44.097257f,
                    39.256022f,44.084307f, 39.284297f,44.108060f, 39.371726f,44.031891f, 39.412343f,44.071089f, 39.405409f,44.130105f,
                    39.389644f,44.130141f, 39.415536f,44.233122f, 39.375258f,44.295200f, 39.411604f,44.421957f, 39.442725f,44.432857f,
                    39.471149f,44.408434f, 39.505069f,44.440367f, 39.556440f,44.416204f, 39.610424f,44.480148f, 39.684102f,44.467197f,
                    39.782462f,44.614695f, 39.733274f,44.644280f, 39.025131f,44.644280f);
            poly[2095] = new TzPolygon(39.808827f,44.644280f, 39.824441f,44.594536f, 39.847231f,44.592837f, 39.847231f,44.644280f);
            poly[2096] = new TzPolygon(39.733274f,44.644280f, 39.727355f,44.647840f, 39.714278f,44.715083f, 39.611270f,44.821914f, 39.615209f,44.875520f,
                    39.593006f,44.876025f, 39.605233f,44.897206f, 39.525071f,44.909772f, 39.492169f,44.951850f, 39.459659f,44.939928f,
                    39.448774f,44.977180f, 39.421043f,44.965144f, 39.351247f,45.086704f, 39.286835f,45.117819f, 39.284471f,45.141981f,
                    39.216351f,45.152932f, 39.185600f,45.247630f, 39.192868f,45.275237f, 39.025131f,45.275237f, 39.025131f,44.644280f);
            poly[2097] = new TzPolygon(39.808827f,44.644280f, 39.847231f,44.644280f, 39.847231f,45.275237f, 39.611903f,45.275237f, 39.611675f,45.242876f,
                    39.581857f,45.212880f, 39.592005f,45.173031f, 39.683366f,45.184631f, 39.794381f,45.061139f, 39.726422f,44.942261f,
                    39.748416f,44.885973f, 39.713879f,44.753021f, 39.743669f,44.744352f, 39.773091f,44.686467f, 39.793083f,44.694437f);
            poly[2098] = new TzPolygon(39.808827f,44.644280f, 39.793083f,44.694437f, 39.772025f,44.687348f, 39.743669f,44.744352f, 39.651666f,44.817664f,
                    39.627336f,44.809380f, 39.714278f,44.715083f, 39.718140f,44.661749f, 39.742020f,44.644280f);
            poly[2099] = new TzPolygon(40.023626f,44.013323f, 40.027285f,44.173051f, 40.049075f,44.248381f, 40.027217f,44.351827f, 39.966288f,44.481351f,
                    39.859107f,44.591951f, 39.847231f,44.592837f, 39.847231f,44.013323f);
        }
    }

    private static class Initializer22 {
        private static void init() {
            poly[2100] = new TzPolygon(39.025131f,45.443681f, 39.025131f,46.092430f, 38.889445f,46.149708f, 38.844518f,46.140676f, 38.887439f,46.065420f,
                    38.871889f,46.012005f, 38.896593f,45.944522f, 38.873917f,45.908708f, 38.924928f,45.797997f, 38.951495f,45.692446f,
                    38.941417f,45.615871f, 38.978503f,45.581898f, 38.964590f,45.543958f, 38.990536f,45.454951f, 39.011778f,45.436890f);
            poly[2101] = new TzPolygon(39.025131f,46.539626f, 39.025131f,46.746706f, 39.019030f,46.696938f, 38.954091f,46.654977f, 38.867172f,46.533983f,
                    38.948209f,46.506531f);
            poly[2102] = new TzPolygon(39.025131f,46.092626f, 39.025131f,46.539626f, 38.948209f,46.506531f, 38.867172f,46.533983f, 38.888907f,46.522600f,
                    38.899007f,46.453500f, 38.883022f,46.421044f, 38.916363f,46.339259f, 38.840478f,46.173374f, 38.844518f,46.140676f,
                    38.894901f,46.148068f);
            poly[2103] = new TzPolygon(39.192868f,45.275237f, 39.201626f,45.308499f, 39.185903f,45.327581f, 39.166023f,45.304240f, 39.170574f,45.349781f,
                    39.126394f,45.354688f, 39.051128f,45.456903f, 39.025131f,45.443681f, 39.025131f,45.275237f);
            poly[2104] = new TzPolygon(39.326389f,45.906194f, 39.369119f,45.792722f, 39.429265f,45.804581f, 39.461046f,45.841082f, 39.585277f,45.779551f,
                    39.603034f,45.693920f, 39.563254f,45.623305f, 39.567888f,45.577867f, 39.490769f,45.471794f, 39.524110f,45.435163f,
                    39.563448f,45.311289f, 39.612118f,45.305639f, 39.611903f,45.275237f, 39.847231f,45.275237f, 39.847231f,45.815792f,
                    39.825988f,45.826132f, 39.805334f,45.906194f);
            poly[2105] = new TzPolygon(39.025131f,46.092626f, 39.079991f,46.069271f, 39.107621f,46.019254f, 39.212331f,45.987822f, 39.291637f,45.998481f,
                    39.326389f,45.906194f, 39.805334f,45.906194f, 39.786869f,45.977769f, 39.690754f,46.057510f, 39.650763f,46.155131f,
                    39.579264f,46.177663f, 39.602041f,46.196187f, 39.638714f,46.357066f, 39.619554f,46.371070f, 39.630787f,46.412690f,
                    39.568946f,46.430498f, 39.586773f,46.488792f, 39.577552f,46.537151f, 39.539518f,46.537151f, 39.515611f,46.498966f,
                    39.468964f,46.536867f, 39.483349f,46.484608f, 39.447693f,46.454414f, 39.455501f,46.392003f, 39.401556f,46.385252f,
                    39.339509f,46.447889f, 39.339855f,46.508225f, 39.284858f,46.537151f, 39.159562f,46.537151f, 39.192231f,46.527628f,
                    39.189919f,46.431962f, 39.154375f,46.440414f, 39.150286f,46.496462f, 39.133737f,46.483736f, 39.083784f,46.536658f,
                    39.062938f,46.516138f, 39.059828f,46.537151f, 39.025131f,46.537151f);
            poly[2106] = new TzPolygon(39.847231f,45.815792f, 39.903019f,45.788635f, 39.935632f,45.799461f, 39.974090f,45.611250f, 40.010486f,45.603132f,
                    40.033846f,45.679783f, 40.029233f,45.788393f, 39.990065f,45.833815f, 40.020892f,45.880513f, 40.104232f,45.903958f,
                    40.120023f,45.960983f, 40.222580f,45.978003f, 40.254339f,45.933561f, 40.251671f,45.955084f, 40.275736f,45.959516f,
                    40.368407f,45.648971f, 40.430672f,45.589736f, 40.428400f,45.559397f, 40.499607f,45.452834f, 40.541295f,45.430769f,
                    40.579706f,45.460537f, 40.599224f,45.406008f, 40.654781f,45.363278f, 40.669330f,45.367189f, 40.669330f,46.537151f,
                    39.847231f,46.537151f);
            poly[2107] = new TzPolygon(39.025131f,46.746706f, 39.025914f,46.753093f, 39.137497f,46.839019f, 39.164729f,46.925544f, 39.140358f,46.962495f,
                    39.167001f,47.019110f, 39.263621f,47.081402f, 39.369194f,47.315114f, 39.469119f,47.395017f, 39.513775f,47.562937f,
                    39.606023f,47.752969f, 39.651113f,47.799065f, 39.025131f,47.799065f);
            poly[2108] = new TzPolygon(39.577552f,46.537151f, 39.571998f,46.566278f, 39.528674f,46.588273f, 39.546394f,46.548134f, 39.539518f,46.537151f);
            poly[2109] = new TzPolygon(39.284858f,46.537151f, 39.254832f,46.552943f, 39.230912f,46.633309f, 39.215281f,46.573519f, 39.201178f,46.586860f,
                    39.159562f,46.537151f);
            poly[2110] = new TzPolygon(39.059828f,46.537151f, 39.057407f,46.553513f, 39.025131f,46.539626f, 39.025131f,46.537151f);
            poly[2111] = new TzPolygon(39.651113f,47.799065f, 40.669330f,47.799065f, 40.669330f,50.070291f, 40.597907f,50.322893f, 40.172981f,50.322893f,
                    40.183356f,50.057847f, 40.143834f,49.918756f, 40.063914f,49.798949f, 39.904019f,49.711007f, 38.408387f,49.212399f,
                    38.451748f,48.791324f, 38.411121f,48.738303f, 38.392955f,48.662272f, 38.417360f,48.601878f, 38.547000f,48.505508f,
                    38.557199f,48.468563f, 38.607688f,48.459293f, 38.607500f,48.309915f, 38.647319f,48.294942f, 38.661908f,48.252657f,
                    38.726096f,48.249156f, 38.769881f,48.107310f, 38.837890f,48.020703f, 38.907306f,48.010270f, 38.910937f,48.069265f,
                    38.946951f,48.088235f, 38.967302f,48.270753f, 39.021166f,48.333223f, 39.108527f,48.307793f, 39.129665f,48.234979f,
                    39.162744f,48.218415f, 39.198255f,48.150283f, 39.271376f,48.129773f, 39.329108f,48.211001f, 39.379836f,48.368622f,
                    39.692528f,48.032058f, 39.709146f,47.985606f, 39.661500f,47.917423f, 39.659190f,47.807322f);
            poly[2112] = new TzPolygon(42.127880f,41.385500f, 42.127880f,42.688258f, 41.598792f,42.688258f, 41.584851f,42.600945f, 41.509911f,42.572898f,
                    41.472079f,42.512774f, 41.436706f,42.520234f, 41.438447f,42.448301f, 41.492769f,42.284952f, 41.490924f,42.205382f,
                    41.514602f,42.178230f, 41.493946f,42.040660f, 41.523300f,41.955316f, 41.430572f,41.823607f, 41.461247f,41.786880f,
                    41.474495f,41.707818f, 41.496232f,41.709758f, 41.487231f,41.633678f, 41.612000f,41.299440f, 41.700911f,41.343394f,
                    41.823957f,41.487249f, 41.892822f,41.507682f);
            poly[2113] = new TzPolygon(43.171668f,42.688258f, 43.169946f,42.681628f, 43.136019f,42.666535f, 43.212929f,42.457196f, 43.256982f,42.413776f,
                    43.210923f,42.295232f, 43.230982f,42.216194f, 43.187034f,42.045440f, 43.217094f,42.019139f, 43.202526f,41.958836f,
                    43.249848f,41.885093f, 43.202038f,41.803944f, 43.243901f,41.725773f, 43.219854f,41.699554f, 43.237763f,41.658119f,
                    43.220990f,41.614239f, 43.315553f,41.422981f, 43.366229f,41.393641f, 43.337043f,41.291003f, 43.403334f,41.152642f,
                    43.404079f,41.105347f, 43.385163f,41.096373f, 43.432222f,41.004295f, 43.419725f,40.949938f, 43.457140f,40.893329f,
                    43.489335f,40.891521f, 43.487960f,40.827833f, 43.563048f,40.661776f, 43.519058f,40.564559f, 43.586187f,40.259604f,
                    43.582185f,40.227580f, 43.586429f,40.227580f, 43.586429f,42.688258f);
            poly[2114] = new TzPolygon(40.669330f,43.740823f, 40.675804f,43.746685f, 40.730889f,43.748312f, 40.847517f,43.677006f, 40.936657f,43.671597f,
                    40.993311f,43.577764f, 41.016163f,43.484099f, 41.098814f,43.447140f, 41.119722f,43.458633f, 41.144491f,43.557838f,
                    41.109326f,43.750739f, 41.160883f,43.841351f, 41.163353f,43.918596f, 40.669330f,43.918596f);
            poly[2115] = new TzPolygon(41.586620f,42.688258f, 41.589683f,42.839422f, 41.495777f,42.802390f, 41.470554f,42.851401f, 41.500300f,42.900942f,
                    41.375661f,43.018652f, 41.357131f,43.096154f, 41.318730f,43.135427f, 41.306231f,43.212594f, 41.253476f,43.127956f,
                    41.253988f,43.194366f, 41.172344f,43.229621f, 41.203384f,43.367357f, 41.176399f,43.448480f, 41.123038f,43.474145f,
                    41.098814f,43.447140f, 41.030615f,43.468408f, 40.930283f,43.676128f, 40.847517f,43.677006f, 40.740698f,43.745247f,
                    40.675804f,43.746685f, 40.669330f,43.740823f, 40.669330f,42.688258f);
            poly[2116] = new TzPolygon(41.096437f,45.008951f, 41.067490f,45.046337f, 41.034012f,45.011947f, 41.073798f,44.955002f);
            poly[2117] = new TzPolygon(41.087647f,45.148935f, 41.094733f,45.130869f, 41.049498f,45.115030f, 41.053510f,45.065520f, 41.119885f,45.098948f,
                    41.120197f,45.148935f);
            poly[2118] = new TzPolygon(41.191154f,45.148935f, 41.208620f,45.125032f, 41.190910f,45.099097f, 41.196237f,45.029124f, 41.246234f,45.063008f,
                    41.296467f,45.013817f, 41.390475f,45.148935f);
            poly[2119] = new TzPolygon(41.395372f,45.148935f, 41.341451f,45.098172f, 41.256597f,44.960267f, 41.274613f,44.850244f, 41.299943f,44.817236f,
                    41.237935f,44.814433f, 41.221149f,44.892308f, 41.203822f,44.883541f, 41.229959f,44.794266f, 41.203382f,44.727455f,
                    41.225168f,44.727052f, 41.223182f,44.681788f, 41.240394f,44.688257f, 41.240631f,44.611455f, 41.192784f,44.595251f,
                    41.212449f,44.578287f, 41.190767f,44.543894f, 41.226188f,44.533665f, 41.180882f,44.465167f, 41.231581f,44.356063f,
                    41.202535f,44.343912f, 41.247143f,44.180083f, 41.189045f,44.162065f, 41.202468f,44.086531f, 41.164791f,43.963562f,
                    41.163353f,43.918596f, 42.127880f,43.918596f, 42.127880f,45.148935f);
            poly[2120] = new TzPolygon(43.171668f,42.688258f, 43.586429f,42.688258f, 43.586429f,45.148935f, 42.707000f,45.148935f, 42.692800f,45.038047f,
                    42.746414f,44.975738f, 42.747044f,44.887471f, 42.617159f,44.829035f, 42.614730f,44.803788f, 42.642795f,44.766573f,
                    42.727412f,44.741342f, 42.755910f,44.679969f, 42.744751f,44.580175f, 42.766391f,44.552487f, 42.736198f,44.499928f,
                    42.696941f,44.518111f, 42.722771f,44.316867f, 42.680859f,44.249127f, 42.626686f,44.231850f, 42.597196f,44.021778f,
                    42.550357f,43.944886f, 42.598672f,43.838703f, 42.588780f,43.770458f, 42.631954f,43.715305f, 42.720725f,43.807533f,
                    42.757934f,43.779227f, 42.813681f,43.608910f, 42.867706f,43.561047f, 42.899134f,43.389892f, 42.890121f,43.334799f,
                    42.914819f,43.317549f, 42.937613f,43.186296f, 43.000289f,43.112833f, 43.029871f,43.035035f, 43.071149f,43.015619f,
                    43.090764f,43.041231f, 43.124097f,42.927467f, 43.148414f,42.932116f, 43.153537f,42.881110f, 43.178558f,42.860267f,
                    43.166253f,42.815983f, 43.187689f,42.749937f);
            poly[2121] = new TzPolygon(41.104637f,46.379274f, 41.105434f,46.369577f, 41.190013f,46.279127f, 41.177856f,45.953168f, 41.221987f,45.805790f,
                    41.297772f,45.700654f, 41.351846f,45.759996f, 41.375977f,45.576732f, 41.398605f,45.567561f, 41.398605f,46.379274f);
            poly[2122] = new TzPolygon(41.398605f,45.151978f, 41.395372f,45.148935f, 41.398605f,45.148935f);
            poly[2123] = new TzPolygon(41.193975f,45.148935f, 41.161580f,45.201809f, 41.120379f,45.178161f, 41.120197f,45.148935f);
            poly[2124] = new TzPolygon(41.087647f,45.148935f, 41.081910f,45.163562f, 41.049877f,45.166279f, 41.004131f,45.257720f, 41.038344f,45.287947f,
                    41.000453f,45.318726f, 41.021751f,45.423996f, 40.958789f,45.422269f, 40.968790f,45.454002f, 40.924073f,45.481250f,
                    40.921182f,45.516906f, 40.878868f,45.557863f, 40.882484f,45.601848f, 40.850683f,45.607953f, 40.774541f,45.545623f,
                    40.745960f,45.428894f, 40.696602f,45.391757f, 40.710044f,45.378765f, 40.669330f,45.367355f, 40.669330f,45.148935f);
            poly[2125] = new TzPolygon(41.398605f,45.160620f, 41.467336f,45.259407f, 41.472646f,45.311372f, 41.427380f,45.391266f, 41.455921f,45.461213f,
                    41.407136f,45.564103f, 41.398605f,45.567561f);
            poly[2126] = new TzPolygon(41.478490f,46.379274f, 41.499605f,46.332613f, 41.571852f,46.297418f, 41.569397f,46.344157f, 41.609505f,46.323022f,
                    41.599548f,46.280764f, 41.635183f,46.263875f, 41.595358f,46.240296f, 41.626859f,46.192294f, 41.661163f,46.208668f,
                    41.713576f,46.178144f, 41.769822f,46.201766f, 41.756061f,46.242069f, 41.775669f,46.304449f, 41.830275f,46.379274f);
            poly[2127] = new TzPolygon(41.942151f,46.379274f, 41.946056f,46.338853f, 41.929270f,46.320048f, 41.945439f,46.282439f, 42.016045f,46.236954f,
                    41.990153f,46.159265f, 42.007740f,46.133048f, 41.986029f,46.106290f, 42.040610f,46.073375f, 42.019917f,46.040485f,
                    42.045341f,45.987334f, 42.024081f,45.957576f, 42.031844f,45.927299f, 42.106486f,45.896377f, 42.102069f,45.786030f,
                    42.127880f,45.744799f, 42.127880f,46.379274f);
            poly[2128] = new TzPolygon(41.398605f,46.379274f, 41.398605f,46.554806f, 41.378366f,46.620217f, 41.390362f,46.631628f, 41.373822f,46.650902f,
                    41.359895f,46.624319f, 41.351996f,46.647690f, 41.370600f,46.659199f, 41.350557f,46.649160f, 41.284486f,46.736537f,
                    41.203126f,46.657213f, 41.101710f,46.639629f, 41.112671f,46.550118f, 41.055292f,46.492599f, 41.098167f,46.457967f,
                    41.104637f,46.379274f);
            poly[2129] = new TzPolygon(41.398605f,47.231732f, 41.398605f,47.609613f, 41.229157f,47.609613f, 41.198026f,47.557588f, 41.228227f,47.503240f,
                    41.268275f,47.498423f, 41.262298f,47.408240f, 41.307790f,47.300412f, 41.339302f,47.257882f, 41.395542f,47.259442f);
            poly[2130] = new TzPolygon(41.478490f,46.379274f, 41.470255f,46.397472f, 41.481684f,46.410522f, 41.413162f,46.507758f, 41.398605f,46.554806f,
                    41.398605f,46.379274f);
            poly[2131] = new TzPolygon(41.942151f,46.379274f, 41.940196f,46.399514f, 41.913005f,46.426389f, 41.844283f,46.398727f, 41.830125f,46.379274f);
            poly[2132] = new TzPolygon(41.398605f,47.231732f, 41.400038f,47.218765f, 41.446348f,47.242125f, 41.498662f,47.159444f, 41.527044f,47.171622f,
                    41.550821f,47.128996f, 41.595287f,47.113360f, 41.554795f,47.066202f, 41.555875f,47.018572f, 41.599794f,46.990689f,
                    41.627448f,47.012304f, 41.676574f,46.927476f, 41.727006f,46.913199f, 41.720263f,46.866316f, 41.773827f,46.790753f,
                    41.862527f,46.760249f, 41.847467f,46.716299f, 41.828415f,46.721793f, 41.834323f,46.624588f, 41.802598f,46.584325f,
                    41.881067f,46.536096f, 41.863784f,46.442946f, 41.940196f,46.399514f, 41.942151f,46.379274f, 42.127880f,46.379274f,
                    42.127880f,47.609613f, 41.398605f,47.609613f);
            poly[2133] = new TzPolygon(42.707000f,45.148935f, 42.708165f,45.158036f, 42.605752f,45.257467f, 42.606938f,45.285032f, 42.522576f,45.341616f,
                    42.551894f,45.417998f, 42.534989f,45.493319f, 42.548291f,45.571561f, 42.505841f,45.613658f, 42.505736f,45.684992f,
                    42.475768f,45.722616f, 42.488494f,45.775450f, 42.428526f,45.774590f, 42.378317f,45.734701f, 42.309294f,45.753474f,
                    42.288985f,45.721866f, 42.292216f,45.652429f, 42.212182f,45.608441f, 42.165305f,45.719662f, 42.127880f,45.758941f,
                    42.127880f,45.148935f);
            poly[2134] = new TzPolygon(41.229157f,47.609613f, 41.236403f,47.621722f, 41.226005f,47.701108f, 41.192579f,47.727810f, 41.185097f,47.783264f,
                    41.219239f,47.810505f, 41.233225f,47.900438f, 41.291869f,47.892864f, 41.320793f,47.968963f, 41.351601f,47.950274f,
                    41.355721f,47.991339f, 41.424659f,48.007592f, 41.457513f,48.063734f, 41.492288f,48.064789f, 41.516933f,48.224276f,
                    41.591014f,48.377344f, 41.838479f,48.585877f, 41.950295f,48.814096f, 40.845453f,49.716852f, 40.749936f,49.851247f,
                    40.702822f,49.951838f, 40.669330f,50.070291f, 40.669330f,47.609613f);
            poly[2135] = new TzPolygon(29.423578f,62.851652f, 29.389587f,62.471042f, 29.858546f,60.872855f, 30.832577f,61.801624f, 30.933259f,61.785528f,
                    30.974099f,61.834702f, 31.036451f,61.839035f, 31.145579f,61.809933f, 31.145579f,62.851652f);
            poly[2136] = new TzPolygon(28.246987f,62.788931f, 28.278904f,62.792961f, 28.248420f,62.597191f, 28.322855f,62.512278f, 28.373405f,62.488771f,
                    28.432248f,62.389486f, 28.510134f,62.043906f, 28.564377f,61.910018f, 28.802927f,61.645572f, 29.010222f,61.533361f,
                    29.023639f,61.478861f, 29.061686f,61.507259f, 29.090872f,61.471443f, 29.123403f,61.474371f, 29.135652f,61.420823f,
                    29.199095f,61.430218f, 29.275983f,61.352909f, 29.321058f,61.372156f, 29.378458f,61.360123f, 29.395202f,61.308947f,
                    29.533339f,61.162524f, 29.858546f,60.872855f, 29.389587f,62.471042f, 29.423578f,62.851652f, 28.246987f,62.851652f);
            poly[2137] = new TzPolygon(29.423578f,62.851652f, 29.457643f,63.233081f, 29.451997f,63.346918f, 29.467570f,63.347572f, 29.487106f,63.576675f,
                    29.407714f,64.052650f, 29.377200f,64.115128f, 29.390538f,64.159644f, 29.410677f,64.170194f, 29.436666f,64.142133f,
                    29.483358f,64.178735f, 29.484809f,64.231242f, 29.522074f,64.263398f, 29.548244f,64.449829f, 29.587937f,64.542940f,
                    29.529430f,65.065071f, 29.571231f,65.220176f, 28.246987f,65.220176f, 28.246987f,62.851652f);
            poly[2138] = new TzPolygon(34.044171f,60.534987f, 33.805444f,60.582214f, 33.731410f,60.546894f, 33.640030f,60.551464f, 33.597023f,60.581277f,
                    33.545520f,60.703418f, 33.539967f,60.902795f, 33.513494f,60.945904f, 33.482001f,60.850923f, 33.421487f,60.866484f,
                    33.228141f,60.634055f, 33.129905f,60.583378f, 32.695856f,60.709581f, 32.481295f,60.814771f, 32.197736f,60.882921f,
                    32.026539f,60.815967f, 31.979859f,60.832519f, 31.708701f,60.813484f, 31.486519f,60.856057f, 31.375896f,61.706667f,
                    31.302269f,61.778385f, 31.206259f,61.771631f, 31.165779f,61.804546f, 31.145579f,61.809933f, 31.145579f,60.483127f,
                    34.044171f,60.483127f);
            poly[2139] = new TzPolygon(31.145579f,65.220176f, 31.145579f,66.712330f, 31.076517f,66.692050f, 30.976688f,66.578383f, 30.940610f,66.391919f,
                    30.568913f,66.278044f, 30.499956f,66.308417f, 30.483640f,66.356252f, 30.445405f,66.338968f, 30.420800f,66.366896f,
                    30.356898f,66.333737f, 30.227168f,66.318740f, 30.068711f,66.228933f, 29.971093f,66.373474f, 29.857321f,66.266802f,
                    29.571750f,65.220176f);
            poly[2140] = new TzPolygon(31.145579f,66.712330f, 31.209123f,66.730989f, 31.209906f,66.796456f, 31.264787f,66.834046f, 31.307978f,66.955901f,
                    31.311869f,67.038312f, 31.286350f,67.058781f, 31.237200f,67.023900f, 31.213860f,67.070040f, 31.248366f,67.155187f,
                    31.198280f,67.277810f, 31.231530f,67.484080f, 31.260791f,67.588701f, 31.145579f,67.588701f);
            poly[2141] = new TzPolygon(31.485431f,67.588701f, 31.523220f,67.567780f, 31.526167f,67.588701f);
            poly[2142] = new TzPolygon(32.594875f,67.588701f, 32.594875f,69.408404f, 32.559990f,69.383460f, 32.529230f,69.278210f, 32.457670f,69.237800f,
                    32.344540f,69.282000f, 32.156710f,69.270270f, 31.925345f,69.331159f, 31.919250f,69.288440f, 31.855450f,69.199880f,
                    31.700880f,69.116590f, 31.629250f,69.019910f, 31.648990f,68.959900f, 31.601950f,68.927330f, 31.593420f,68.856160f,
                    31.622380f,68.789790f, 31.660500f,68.783400f, 31.695260f,68.727750f, 31.770890f,68.708550f, 31.777810f,68.642900f,
                    31.834240f,68.575520f, 31.763120f,68.433050f, 31.753100f,68.591120f, 31.713150f,68.543990f, 31.755646f,68.427311f,
                    31.756950f,68.279460f, 31.784020f,68.254270f, 31.803260f,68.265530f, 31.817000f,68.179370f, 31.835320f,68.171030f,
                    31.696020f,68.070380f, 31.644740f,67.984610f, 31.623790f,67.857510f, 31.513290f,67.714410f, 31.533320f,67.639470f,
                    31.526167f,67.588701f);
            poly[2143] = new TzPolygon(31.485431f,67.588701f, 31.449090f,67.608820f, 31.426210f,67.599520f, 31.396733f,67.636605f, 31.416490f,67.749900f,
                    31.399870f,67.785690f, 31.344100f,67.792660f, 31.322040f,67.772830f, 31.326970f,67.722010f, 31.277580f,67.648730f,
                    31.260791f,67.588701f);
            poly[2144] = new TzPolygon(32.594875f,69.408404f, 32.658290f,69.453750f, 32.729310f,69.441940f, 32.770090f,69.387630f, 32.800990f,69.407240f,
                    32.803970f,69.441200f, 32.854910f,69.469420f, 32.875050f,69.546670f, 32.885920f,69.496310f, 33.020680f,69.496280f,
                    33.102910f,69.582480f, 33.089640f,69.710630f, 33.132380f,69.795090f, 33.093920f,69.876710f, 33.103250f,69.925060f,
                    33.131750f,69.939330f, 33.133221f,69.957225f, 32.594875f,69.957225f);
            poly[2145] = new TzPolygon(33.798521f,69.957225f, 33.833730f,69.948897f, 33.850620f,69.916000f, 33.897090f,69.910090f, 33.924740f,69.858600f,
                    33.967330f,69.861360f, 33.987020f,69.903360f, 34.019530f,69.888710f, 34.039700f,69.904700f, 34.044171f,69.957225f);
            poly[2146] = new TzPolygon(38.285000f,56.756389f, 38.240556f,56.613889f, 38.266111f,56.546667f, 38.258611f,56.436389f, 38.179072f,56.318521f,
                    38.117164f,56.352079f, 38.077250f,56.335248f, 38.072222f,56.216111f, 38.095000f,56.164444f, 38.078333f,55.962500f,
                    38.125278f,55.756111f, 38.086111f,55.442778f, 37.979289f,55.227130f, 37.947307f,55.201510f, 37.949200f,55.127656f,
                    37.842963f,55.023323f, 37.745694f,54.840213f, 37.634340f,54.782755f, 37.606230f,54.815248f, 37.525489f,54.792515f,
                    37.437055f,54.673668f, 37.460031f,54.586762f, 37.360700f,54.397660f, 37.351769f,54.285193f, 37.319986f,54.244678f,
                    37.347357f,53.896656f, 37.379052f,53.846353f, 37.707811f,53.721830f, 37.896217f,53.707258f, 38.285000f,53.746366f);
            poly[2147] = new TzPolygon(36.999454f,60.056598f, 37.020764f,60.043069f, 37.051446f,59.899529f, 37.125350f,59.771848f, 37.107780f,59.747405f,
                    37.141220f,59.678999f, 37.119237f,59.643399f, 37.136204f,59.552541f, 37.177568f,59.551731f, 37.214775f,59.474738f,
                    37.248484f,59.483426f, 37.317303f,59.396898f, 37.407590f,59.377877f, 37.435774f,59.411345f, 37.449746f,59.381421f,
                    37.479137f,59.392131f, 37.528416f,59.353479f, 37.512050f,59.229250f, 37.630000f,59.060278f, 37.669167f,58.876389f,
                    37.703611f,58.822778f, 37.666944f,58.804444f, 37.648611f,58.712778f, 37.705833f,58.550000f, 37.647778f,58.498056f,
                    37.626985f,58.388434f, 37.661107f,58.359651f, 37.684037f,58.227047f, 37.771096f,58.208303f, 37.793617f,58.155062f,
                    37.805903f,58.027855f, 37.870762f,57.891577f, 37.863247f,57.825474f, 37.899553f,57.795835f, 37.921856f,57.720368f,
                    37.938042f,57.579624f, 37.919263f,57.512192f, 37.939167f,57.450278f, 37.989444f,57.353056f, 38.093056f,57.371111f,
                    38.280455f,57.216285f, 38.284178f,57.183675f, 38.199444f,57.076111f, 38.187190f,57.012233f, 38.214344f,56.991999f,
                    38.229900f,56.840471f, 38.285000f,56.756389f, 38.285000f,60.056598f);
            poly[2148] = new TzPolygon(35.104378f,60.056598f, 35.104378f,61.140094f, 35.080611f,61.145771f, 35.073975f,61.117421f, 35.024205f,61.099702f,
                    35.003515f,61.121625f, 34.904862f,61.055943f, 34.844264f,61.075061f, 34.709217f,61.002802f, 34.642976f,61.000798f,
                    34.619758f,60.984492f, 34.623018f,60.922214f, 34.567260f,60.897272f, 34.542077f,60.848650f, 34.518086f,60.739083f,
                    34.471653f,60.809274f, 34.368448f,60.849631f, 34.304756f,60.918373f, 34.310708f,60.686496f, 34.272504f,60.669490f,
                    34.189086f,60.562629f, 34.106511f,60.522654f, 34.044171f,60.534987f, 34.044171f,60.056598f);
            poly[2149] = new TzPolygon(35.420965f,61.706702f, 35.436950f,61.587758f, 35.553135f,61.401033f, 35.623664f,61.373303f, 35.624908f,61.322042f,
                    35.595938f,61.292468f, 35.650690f,61.226226f, 35.683253f,61.216236f, 35.717500f,61.246389f, 35.813333f,61.261944f,
                    35.897222f,61.245000f, 35.962131f,61.117168f, 35.995278f,61.170000f, 36.035278f,61.164722f, 36.117590f,61.230976f,
                    36.127745f,61.210608f, 36.164585f,61.215584f, 36.164585f,61.706702f);
            poly[2150] = new TzPolygon(35.104378f,61.140094f, 35.135873f,61.132570f, 35.164807f,61.087117f, 35.209644f,61.117854f, 35.263737f,61.091775f,
                    35.292865f,61.190296f, 35.399592f,61.187459f, 35.421655f,61.227161f, 35.520278f,61.277778f, 35.604842f,61.274095f,
                    35.595337f,61.302521f, 35.624908f,61.322042f, 35.623664f,61.373303f, 35.553135f,61.401033f, 35.436950f,61.587758f,
                    35.420965f,61.706702f, 35.104378f,61.706702f);
            poly[2151] = new TzPolygon(35.420965f,61.706702f, 35.411173f,61.779568f, 35.454013f,61.968227f, 35.434420f,62.064280f, 35.340903f,62.153722f,
                    35.295160f,62.266188f, 35.129093f,62.305539f, 35.278924f,62.477560f, 35.273665f,62.525005f, 35.220716f,62.577663f,
                    35.236578f,62.608839f, 35.207930f,62.627865f, 35.251289f,62.742761f, 35.301161f,62.785671f, 35.299828f,62.824116f,
                    35.380841f,62.935826f, 35.401247f,63.023329f, 35.418558f,63.015108f, 35.417985f,63.099102f, 35.543220f,63.130245f,
                    35.549355f,63.106185f, 35.618425f,63.094889f, 35.681239f,63.248616f, 35.815826f,63.099184f, 35.873787f,63.123149f,
                    35.882045f,63.314127f, 35.921482f,63.330105f, 35.888410f,63.356807f, 34.044171f,63.356807f, 34.044171f,61.706702f);
            poly[2152] = new TzPolygon(36.999454f,60.056598f, 36.924466f,60.104204f, 36.757210f,60.266905f, 36.629394f,60.345542f, 36.622212f,60.675221f,
                    36.646493f,61.146194f, 36.564321f,61.186003f, 36.507402f,61.156877f, 36.464163f,61.175758f, 36.392778f,61.142500f,
                    36.317480f,61.149169f, 36.192308f,61.219328f, 36.164585f,61.215584f, 36.164585f,60.056598f);
            poly[2153] = new TzPolygon(36.164585f,63.356807f, 36.164585f,64.291227f, 36.151517f,64.283844f, 36.163019f,64.169781f, 36.129387f,64.093274f,
                    36.102161f,64.057833f, 35.997294f,64.068541f, 36.036334f,63.989178f, 35.951438f,63.570691f, 35.903273f,63.535379f,
                    35.870873f,63.370966f, 35.888410f,63.356807f);
            poly[2154] = new TzPolygon(36.164585f,64.291227f, 36.208557f,64.316071f, 36.242727f,64.445229f, 36.290021f,64.507568f, 36.351645f,64.579957f,
                    36.442278f,64.636311f, 36.636619f,64.618501f, 36.921782f,64.797659f, 37.112644f,64.755260f, 37.218185f,64.989773f,
                    37.221620f,65.006912f, 36.164585f,65.006912f);
            poly[2155] = new TzPolygon(37.221620f,65.006912f, 37.246796f,65.132543f, 37.233406f,65.273338f, 37.290377f,65.420888f, 37.294595f,65.511732f,
                    37.539654f,65.703970f, 37.549630f,65.767910f, 37.499848f,65.818266f, 37.441667f,66.062222f, 37.378065f,66.139056f,
                    37.356111f,66.246111f, 37.320160f,66.306764f, 37.319247f,66.430999f, 37.369872f,66.583730f, 37.323028f,66.655365f,
                    37.324534f,66.657016f, 36.164585f,66.657016f, 36.164585f,65.006912f);
            poly[2156] = new TzPolygon(37.325423f,66.657016f, 37.322985f,66.654269f, 37.368724f,66.593677f, 37.355385f,66.554138f, 37.375126f,66.521635f,
                    37.443696f,66.584419f, 37.506115f,66.572738f, 37.537888f,66.527658f, 37.791774f,66.548225f, 37.868478f,66.606795f,
                    37.897579f,66.657016f);
            poly[2157] = new TzPolygon(37.980545f,66.657016f, 38.029453f,66.527914f, 38.032964f,66.391743f, 38.107358f,66.272364f, 38.155255f,66.248011f,
                    38.157085f,66.166478f, 38.226971f,66.029466f, 38.227815f,65.977576f, 38.276930f,65.913045f, 38.274352f,65.854533f,
                    38.249960f,65.837890f, 38.285000f,65.572439f, 38.285000f,66.657016f);
            poly[2158] = new TzPolygon(37.224793f,67.813137f, 37.224793f,68.307120f, 37.107926f,68.307120f, 37.108333f,68.294722f, 37.012222f,68.275000f,
                    37.020556f,68.187222f, 36.928611f,68.051389f, 36.925278f,68.015556f, 37.061389f,67.885556f, 37.101667f,67.778889f);
            poly[2159] = new TzPolygon(37.224793f,67.232739f, 37.224793f,67.383494f, 37.182116f,67.270036f);
            poly[2160] = new TzPolygon(37.224793f,67.803339f, 37.186826f,67.789194f, 37.224793f,67.654513f);
            poly[2161] = new TzPolygon(37.224793f,67.580547f, 37.218385f,67.565980f, 37.224793f,67.558050f);
            poly[2162] = new TzPolygon(37.978922f,66.657016f, 37.956638f,66.689518f, 37.914946f,66.686986f, 37.897579f,66.657016f);
            poly[2163] = new TzPolygon(37.224793f,67.813137f, 37.328564f,67.842002f, 37.418203f,67.790161f, 37.638421f,67.863391f, 37.623375f,67.924351f,
                    37.687529f,67.994469f, 37.807891f,68.080717f, 37.930615f,68.129847f, 37.932837f,68.221645f, 37.909136f,68.268103f,
                    37.999287f,68.288833f, 38.015891f,68.307120f, 37.224793f,68.307120f);
            poly[2164] = new TzPolygon(38.252406f,68.307120f, 38.255669f,68.302392f, 38.285000f,68.296645f, 38.285000f,68.307120f);
            poly[2165] = new TzPolygon(37.324534f,66.657016f, 37.357019f,66.692621f, 37.353490f,66.851211f, 37.398494f,66.947482f, 37.372518f,67.059192f,
                    37.328109f,67.112035f, 37.284801f,67.110703f, 37.243864f,67.223629f, 37.224793f,67.234258f, 37.224793f,66.657016f);
            poly[2166] = new TzPolygon(37.224793f,67.415805f, 37.269596f,67.502605f, 37.224793f,67.558050f);
            poly[2167] = new TzPolygon(37.224793f,67.576460f, 37.237767f,67.597679f, 37.224793f,67.684737f);
            poly[2168] = new TzPolygon(37.107926f,68.307120f, 37.104444f,68.413056f, 37.145000f,68.406111f, 37.134133f,68.449275f, 37.198447f,68.617004f,
                    37.243892f,68.646203f, 37.245064f,68.675196f, 37.275556f,68.671389f, 37.277222f,68.758333f, 37.245000f,68.821667f,
                    37.318056f,68.806667f, 37.327222f,68.831389f, 37.275556f,68.919444f, 37.338611f,68.887778f, 37.307778f,68.999722f,
                    37.184708f,69.109081f, 37.093410f,69.256209f, 37.166427f,69.401887f, 37.250717f,69.470427f, 37.245857f,69.425158f,
                    37.399815f,69.364403f, 37.588085f,69.523798f, 37.569540f,69.622666f, 37.592275f,69.755342f, 37.568508f,69.814215f,
                    37.603555f,69.841430f, 37.614444f,69.905833f, 37.608061f,69.940723f, 37.568336f,69.957225f, 36.164585f,69.957225f,
                    36.164585f,68.307120f);
            poly[2169] = new TzPolygon(38.252406f,68.307120f, 38.234297f,68.333358f, 38.245836f,68.370790f, 38.180743f,68.405344f, 38.084515f,68.377070f,
                    38.016951f,68.307120f);
            poly[2170] = new TzPolygon(43.544881f,51.009030f, 43.586429f,51.009030f, 43.586429f,55.999916f, 41.324280f,56.001792f, 41.331786f,55.876714f,
                    41.278338f,55.811717f, 41.302058f,55.743336f, 41.279493f,55.727086f, 41.282813f,55.635610f, 41.246392f,55.603316f,
                    41.294407f,55.567019f, 41.259293f,55.542728f, 41.251587f,55.499612f, 41.293220f,55.414691f, 41.337222f,55.398313f,
                    41.390882f,55.315465f, 41.604653f,55.119606f, 41.810219f,54.964006f, 41.906308f,54.952115f, 42.052549f,54.779482f,
                    42.379087f,54.217810f, 42.288924f,53.570558f, 42.121175f,52.984788f, 41.761967f,52.449984f, 41.719338f,52.335076f,
                    41.724447f,52.259144f, 42.117106f,52.229019f, 42.212153f,52.258633f, 42.469697f,52.440644f, 42.601758f,52.392847f,
                    42.650800f,52.195397f, 42.695872f,51.836542f, 42.757403f,51.737094f, 42.967481f,51.557783f, 43.003889f,51.262286f,
                    43.051450f,51.132642f, 43.160703f,51.071017f, 43.450783f,51.096811f);
            poly[2171] = new TzPolygon(41.272621f,56.882133f, 41.324280f,56.001792f, 43.586429f,55.999244f, 43.586429f,56.882133f);
            poly[2172] = new TzPolygon(43.586429f,58.350409f, 42.667659f,58.350409f, 42.685237f,58.281239f, 42.621285f,58.156345f, 42.548264f,58.306485f,
                    42.486270f,58.350409f, 42.424364f,58.350409f, 42.448089f,58.323433f, 42.470498f,58.198874f, 42.443525f,58.133509f,
                    42.488900f,58.125806f, 42.504153f,58.040189f, 42.484241f,57.977184f, 42.426079f,57.966785f, 42.460533f,57.929929f,
                    42.450988f,57.910299f, 42.371631f,57.947305f, 42.254784f,57.932386f, 42.236301f,57.911105f, 42.246292f,57.847205f,
                    42.174942f,57.854209f, 42.181271f,57.769200f, 42.149051f,57.659687f, 42.174080f,57.521701f, 42.157750f,57.367358f,
                    42.094418f,57.238309f, 41.943589f,57.129975f, 41.898282f,57.003863f, 41.804566f,56.967575f, 41.672356f,56.972199f,
                    41.567730f,57.025021f, 41.445867f,57.031635f, 41.374897f,57.086548f, 41.384323f,57.148548f, 41.369377f,57.158672f,
                    41.321788f,57.070756f, 41.263215f,57.042415f, 41.272621f,56.882133f, 43.586429f,56.882133f);
            poly[2173] = new TzPolygon(42.274724f,59.818685f, 42.272034f,59.811597f, 42.297398f,59.613893f, 42.281383f,59.566804f, 42.292651f,59.434330f,
                    42.325777f,59.417410f, 42.388709f,59.275754f, 42.429242f,59.270299f, 42.530826f,59.171906f, 42.527025f,59.014606f,
                    42.797427f,58.626941f, 42.726279f,58.653716f, 42.703658f,58.612137f, 42.644311f,58.589894f, 42.636955f,58.471226f,
                    42.667659f,58.350409f, 43.586429f,58.350409f, 43.586429f,59.818685f);
            poly[2174] = new TzPolygon(42.486270f,58.350409f, 42.379870f,58.425795f, 42.321515f,58.521808f, 42.273308f,58.520222f, 42.295183f,58.450355f,
                    42.287175f,58.395217f, 42.398668f,58.379626f, 42.424364f,58.350409f);
            poly[2175] = new TzPolygon(39.806350f,62.755236f, 39.951394f,62.487949f, 39.991101f,62.442658f, 40.099281f,62.396497f, 40.173507f,62.413784f,
                    40.317929f,62.391480f, 40.374947f,62.334573f, 40.438297f,62.349460f, 40.508515f,62.207718f, 40.596107f,62.113073f,
                    40.836943f,61.985688f, 40.935715f,61.993412f, 40.935715f,62.755236f);
            poly[2176] = new TzPolygon(42.274724f,59.818685f, 42.302191f,59.891067f, 42.231505f,59.954866f, 42.212923f,60.012781f, 42.164915f,60.015266f,
                    42.179192f,59.967144f, 42.143940f,59.949870f, 42.090152f,60.048295f, 42.026695f,60.040884f, 41.991172f,60.010607f,
                    42.012252f,59.927824f, 41.961735f,59.936628f, 41.940132f,59.971640f, 41.950358f,60.024821f, 41.910869f,60.039897f,
                    41.903498f,60.104061f, 41.768371f,60.325800f, 41.752274f,60.297919f, 41.811083f,60.092081f, 41.766049f,60.057298f,
                    41.591358f,60.178993f, 41.542131f,60.103908f, 41.434836f,60.076917f, 41.337202f,60.230022f, 41.217479f,60.491466f,
                    41.258588f,60.766867f, 41.243241f,61.000462f, 41.222658f,61.029796f, 41.269236f,61.033531f, 41.214726f,61.082444f,
                    41.230105f,61.090418f, 41.190227f,61.128608f, 41.145333f,61.240384f, 41.147812f,61.330455f, 41.214647f,61.408450f,
                    41.287813f,61.408498f, 41.286728f,61.481034f, 41.261550f,61.545410f, 41.264988f,61.626885f, 41.231434f,61.649934f,
                    41.116201f,61.875208f, 41.053418f,61.900956f, 41.027358f,61.963734f, 40.973536f,61.996369f, 40.935715f,61.993412f,
                    40.935715f,59.818685f);
            poly[2177] = new TzPolygon(43.586429f,62.755236f, 43.505401f,62.004055f, 43.586429f,61.906615f);
            poly[2178] = new TzPolygon(38.285000f,65.572439f, 38.289316f,65.539742f, 38.502563f,65.171182f, 38.605740f,65.037461f, 38.670817f,64.897027f,
                    38.683030f,64.820451f, 38.846787f,64.524809f, 38.976735f,64.354852f, 38.961860f,64.181194f, 39.053419f,64.008669f,
                    39.223866f,63.705149f, 39.272439f,63.694214f, 39.412189f,63.430607f, 39.445390f,63.420414f, 39.806350f,62.755236f,
                    39.806350f,65.572439f);
            poly[2179] = new TzPolygon(43.586429f,64.572848f, 43.570687f,64.534861f, 43.586429f,64.161720f);
            poly[2180] = new TzPolygon(43.269525f,65.572439f, 43.289475f,65.559258f, 43.495162f,65.184862f, 43.586429f,65.109147f, 43.586429f,65.572439f);
            poly[2181] = new TzPolygon(39.015382f,67.764832f, 39.000560f,67.703800f, 39.065805f,67.670752f, 39.146438f,67.677154f, 39.144577f,67.635513f,
                    39.188339f,67.584182f, 39.186571f,67.499270f, 39.231673f,67.342953f, 39.262466f,67.364174f, 39.304229f,67.333278f,
                    39.322948f,67.474024f, 39.462721f,67.464543f, 39.533435f,67.401923f, 39.531307f,67.468711f, 39.550232f,67.443928f,
                    39.578618f,67.452171f, 39.600811f,67.627561f, 39.659658f,67.707976f, 39.639918f,67.760789f, 39.642048f,67.764832f);
            poly[2182] = new TzPolygon(40.009289f,67.042969f, 40.009289f,67.764832f, 39.642048f,67.764832f, 39.639918f,67.760789f, 39.659658f,67.707976f,
                    39.600811f,67.627561f, 39.579663f,67.506505f, 39.592828f,67.475570f, 39.635938f,67.465004f, 39.655818f,67.395665f,
                    39.711333f,67.403977f, 39.738146f,67.380322f, 39.824654f,67.533482f, 39.888429f,67.421716f, 39.924983f,67.407309f,
                    39.906684f,67.363532f, 39.915830f,67.235554f, 39.936056f,67.204387f, 39.921847f,67.178004f, 39.940553f,67.095950f,
                    39.986745f,67.080278f, 39.967748f,67.054660f, 39.984324f,67.033414f, 39.999396f,67.021372f);
            poly[2183] = new TzPolygon(41.171560f,67.764832f, 41.183135f,67.733055f, 41.127079f,67.364295f, 41.142615f,66.709329f, 41.493591f,66.606628f,
                    41.733579f,66.560215f, 41.733579f,67.764832f);
            poly[2184] = new TzPolygon(41.733579f,66.562979f, 41.344802f,66.645637f, 41.142615f,66.709329f, 41.142657f,66.752395f, 41.123040f,66.760133f,
                    41.111816f,66.643363f, 40.906665f,66.654617f, 40.897343f,66.772549f, 40.837037f,66.786710f, 40.707618f,66.767869f,
                    40.555766f,66.668512f, 40.477652f,66.652406f, 40.494659f,66.720350f, 40.468391f,66.758358f, 40.486117f,66.885824f,
                    40.435592f,66.899653f, 40.310977f,66.861119f, 40.257004f,66.877280f, 40.192014f,66.993875f, 40.127264f,66.927139f,
                    40.086763f,67.046511f, 40.024398f,67.075950f, 40.009289f,67.042969f, 40.009289f,65.572439f, 41.733579f,65.572439f);
            poly[2185] = new TzPolygon(38.285000f,68.296645f, 38.323069f,68.289185f, 38.321862f,68.232778f, 38.410746f,68.136571f, 38.392726f,68.061915f,
                    38.468112f,68.116424f, 38.559367f,68.061271f, 38.642455f,68.092832f, 38.714569f,68.056690f, 38.732599f,68.129163f,
                    38.818343f,68.069735f, 38.831163f,68.171402f, 38.856704f,68.201333f, 38.892855f,68.178878f, 38.921654f,68.207825f,
                    39.026366f,68.078842f, 39.010077f,68.027756f, 39.035035f,67.982690f, 39.001359f,67.869066f, 39.016120f,67.767871f,
                    39.015382f,67.764832f, 39.147145f,67.764832f, 39.147145f,68.861028f, 38.285000f,68.861028f);
            poly[2186] = new TzPolygon(39.642048f,67.764832f, 39.656959f,67.793137f, 39.560256f,68.114820f, 39.532200f,68.524128f, 39.599784f,68.551724f,
                    39.637263f,68.617568f, 39.695704f,68.626201f, 39.724452f,68.586750f, 39.777324f,68.643221f, 39.851985f,68.626996f,
                    39.844719f,68.759121f, 39.867397f,68.749883f, 39.874994f,68.772525f, 39.839820f,68.785372f, 39.890962f,68.831110f,
                    39.946932f,68.828233f, 39.969964f,68.800675f, 39.986701f,68.824398f, 39.863140f,68.854750f, 39.863459f,68.861028f,
                    39.147145f,68.861028f, 39.147145f,67.764832f);
            poly[2187] = new TzPolygon(40.009289f,69.352552f, 40.009289f,69.360916f, 39.995983f,69.372170f, 39.988281f,69.431919f, 39.922186f,69.430505f,
                    39.936857f,69.454986f, 39.915818f,69.462657f, 39.944542f,69.510189f, 39.929733f,69.534063f, 40.009289f,69.513427f,
                    40.009289f,69.957225f, 39.570200f,69.957225f, 39.576189f,69.901638f, 39.529487f,69.867222f, 39.580103f,69.783976f,
                    39.600534f,69.698378f, 39.578251f,69.660999f, 39.592015f,69.602020f, 39.553118f,69.573973f, 39.526358f,69.485619f,
                    39.528714f,69.445202f, 39.563046f,69.403579f, 39.521107f,69.361682f, 39.542461f,69.334174f, 39.595695f,69.359888f,
                    39.670896f,69.318378f, 39.700659f,69.337055f, 39.806038f,69.264952f, 39.878054f,69.329576f, 39.920458f,69.296884f,
                    39.971603f,69.357612f);
            poly[2188] = new TzPolygon(40.009289f,68.884055f, 39.919196f,68.943258f, 39.887086f,68.913984f, 39.865678f,68.861028f, 40.009289f,68.861028f);
            poly[2189] = new TzPolygon(40.871434f,68.008330f, 40.871434f,68.589622f, 40.865088f,68.590459f, 40.805828f,68.562293f, 40.708324f,68.583854f,
                    40.680050f,68.653594f, 40.630491f,68.621813f, 40.599553f,68.663121f, 40.568648f,68.581766f, 40.572429f,68.492737f,
                    40.617441f,68.371137f, 40.832093f,67.976552f, 40.861892f,67.972275f, 40.860643f,68.005966f);
            poly[2190] = new TzPolygon(40.044332f,68.861028f, 40.050570f,68.856929f, 40.050305f,68.861028f);
            poly[2191] = new TzPolygon(40.129572f,68.861028f, 40.076677f,68.633236f, 40.117770f,68.531026f, 40.143821f,68.532861f, 40.203926f,68.779565f,
                    40.172603f,68.797300f, 40.209044f,68.861028f);
            poly[2192] = new TzPolygon(41.171560f,67.764832f, 41.135139f,67.864814f, 41.150077f,67.965561f, 41.026053f,67.983571f, 41.018280f,68.024196f,
                    41.081906f,68.080513f, 41.038497f,68.127704f, 41.018958f,68.048927f, 40.998355f,68.083834f, 40.945642f,68.063273f,
                    40.936405f,68.096737f, 40.890516f,68.012510f, 40.871434f,68.008330f, 40.871434f,67.764832f);
            poly[2193] = new TzPolygon(40.871434f,68.589622f, 40.924316f,68.582643f, 40.942355f,68.517467f, 40.962494f,68.514048f, 40.956419f,68.464933f,
                    41.009906f,68.513458f, 41.030532f,68.606016f, 41.001768f,68.619428f, 40.987557f,68.673360f, 40.968588f,68.627727f,
                    40.942854f,68.643684f, 40.973811f,68.736804f, 41.006127f,68.761150f, 41.030761f,68.714553f, 41.053166f,68.726028f,
                    41.119153f,68.804200f, 41.147656f,68.861028f, 40.871434f,68.861028f);
            poly[2194] = new TzPolygon(40.009289f,69.352552f, 40.021045f,69.350973f, 40.009289f,69.360916f);
            poly[2195] = new TzPolygon(40.871434f,69.409127f, 40.753136f,69.409127f, 40.752228f,69.407833f, 40.790647f,69.373457f, 40.704063f,69.328556f,
                    40.585319f,69.347078f, 40.576347f,69.262298f, 40.546786f,69.211031f, 40.492855f,69.279860f, 40.459718f,69.267720f,
                    40.368135f,69.302614f, 40.339022f,69.340508f, 40.281888f,69.307430f, 40.295443f,69.246612f, 40.258280f,69.262694f,
                    40.244813f,69.301455f, 40.187812f,69.304301f, 40.228734f,69.035750f, 40.209044f,68.861028f, 40.871434f,68.861028f);
            poly[2196] = new TzPolygon(40.129572f,68.861028f, 40.145995f,68.931753f, 40.154230f,69.020020f, 40.126037f,69.024100f, 40.083622f,68.956864f,
                    40.041974f,68.977473f, 40.068065f,68.906628f, 40.048214f,68.893337f, 40.050305f,68.861028f);
            poly[2197] = new TzPolygon(40.044332f,68.861028f, 40.009289f,68.884055f, 40.009289f,68.861028f);
            poly[2198] = new TzPolygon(40.009289f,69.513427f, 40.033844f,69.507058f, 40.116938f,69.537018f, 40.104607f,69.582153f, 40.122702f,69.671903f,
                    40.107888f,69.679407f, 40.179422f,69.784041f, 40.224681f,69.957225f, 40.009289f,69.957225f);
            poly[2199] = new TzPolygon(40.733563f,69.957225f, 40.701593f,69.793164f, 40.628689f,69.720487f, 40.634138f,69.669267f, 40.671090f,69.651694f,
                    40.704095f,69.583751f, 40.768487f,69.553296f, 40.780945f,69.500163f, 40.811613f,69.492489f, 40.753136f,69.409127f,
                    40.871434f,69.409127f, 40.871434f,69.957225f);
        }
    }

    private static class Initializer23 {
        private static void init() {
            poly[2200] = new TzPolygon(41.733579f,69.957225f, 41.706760f,69.894317f, 41.719978f,69.839523f, 41.662773f,69.616958f, 41.588661f,69.538887f,
                    41.569374f,69.549896f, 41.547130f,69.500984f, 41.559965f,69.441795f, 41.507576f,69.397789f, 41.488166f,69.454544f,
                    41.464700f,69.457156f, 41.472678f,69.354668f, 41.435622f,69.296463f, 41.462846f,69.226756f, 41.431275f,69.148888f,
                    41.402961f,69.175097f, 41.386608f,69.155102f, 41.391365f,69.113639f, 41.358207f,69.096595f, 41.377059f,69.079025f,
                    41.357124f,69.023696f, 41.349067f,69.047424f, 41.289569f,69.013404f, 41.264740f,69.040145f, 41.224758f,69.029182f,
                    41.238826f,69.000099f, 41.210620f,68.986564f, 41.147656f,68.861028f, 41.733579f,68.861028f);
            poly[2201] = new TzPolygon(43.269525f,65.572439f, 43.586429f,65.572439f, 43.586429f,67.821318f, 43.563050f,67.813837f, 43.480175f,67.734119f,
                    43.407283f,67.725036f, 43.375857f,67.649520f, 43.310095f,67.677788f, 43.367453f,67.708189f, 43.359120f,67.747103f,
                    43.353892f,67.715543f, 43.338478f,67.729225f, 43.329253f,67.793580f, 43.290616f,67.814009f, 43.275142f,67.767729f,
                    43.253076f,67.830478f, 43.225002f,67.786518f, 43.211788f,67.874093f, 42.951245f,67.224276f, 42.322707f,66.148533f,
                    42.337941f,66.070676f, 42.938138f,66.096693f, 42.858255f,65.844156f);
            poly[2202] = new TzPolygon(43.269525f,65.572439f, 42.858255f,65.844156f, 42.938138f,66.096693f, 42.337941f,66.070676f, 42.360736f,66.001937f,
                    41.937179f,65.998710f, 41.877437f,66.532393f, 41.733579f,66.562979f, 41.733579f,65.572439f);
            poly[2203] = new TzPolygon(51.247608f,42.909230f, 51.267220f,42.947337f, 51.316673f,42.858106f, 51.397062f,42.860184f, 51.392462f,42.832533f,
                    51.492412f,42.750450f, 51.538044f,42.566125f, 51.667121f,42.503671f, 51.719683f,42.521847f, 51.806890f,42.667717f,
                    51.885620f,42.712606f, 51.996037f,42.713197f, 52.022217f,42.813583f, 52.085479f,42.756828f, 52.184974f,42.771900f,
                    52.212061f,42.888845f, 52.336069f,42.942237f, 52.360329f,42.920796f, 52.348857f,42.988167f, 52.378770f,43.117153f,
                    52.387711f,43.121065f, 52.387711f,43.124133f, 51.247608f,43.124133f);
            poly[2204] = new TzPolygon(52.387711f,43.501662f, 52.378794f,43.490637f, 52.375835f,43.384096f, 52.353386f,43.368008f, 52.387711f,43.339773f);
            poly[2205] = new TzPolygon(52.387711f,43.878043f, 52.379761f,43.865586f, 52.387711f,43.848071f);
            poly[2206] = new TzPolygon(52.387711f,44.388141f, 52.291266f,44.319918f, 52.344979f,44.196682f, 52.312754f,44.156611f, 52.351677f,44.063022f,
                    52.327972f,44.032393f, 52.387711f,43.925487f);
            poly[2207] = new TzPolygon(52.387711f,45.081667f, 52.378430f,45.066679f, 52.312175f,45.089563f, 52.306116f,45.059970f, 52.339317f,44.982027f,
                    52.365802f,44.981922f, 52.356545f,44.893357f, 52.387711f,44.892499f);
            poly[2208] = new TzPolygon(52.387711f,45.260551f, 52.375677f,45.233534f, 52.387711f,45.217066f);
            poly[2209] = new TzPolygon(52.387711f,45.307564f, 52.376046f,45.295126f, 52.387711f,45.273475f);
            poly[2210] = new TzPolygon(52.387711f,45.360905f, 52.386716f,45.359899f, 52.387711f,45.355728f);
            poly[2211] = new TzPolygon(52.387711f,45.430033f, 52.386290f,45.429318f, 52.387711f,45.426670f);
            poly[2212] = new TzPolygon(52.382252f,49.288299f, 52.383226f,49.284582f, 52.387711f,49.288299f);
            poly[2213] = new TzPolygon(52.387711f,43.121065f, 52.438448f,43.143268f, 52.459178f,43.204769f, 52.427932f,43.243689f, 52.439791f,43.283980f,
                    52.420993f,43.322433f, 52.387711f,43.344869f);
            poly[2214] = new TzPolygon(52.387711f,43.501662f, 52.403287f,43.520922f, 52.391414f,43.671243f, 52.432781f,43.748765f, 52.387711f,43.848071f);
            poly[2215] = new TzPolygon(52.387711f,43.878043f, 52.401845f,43.900193f, 52.387711f,43.925487f);
            poly[2216] = new TzPolygon(52.387711f,44.388141f, 52.407081f,44.401843f, 52.394705f,44.467830f, 52.423388f,44.535063f, 52.514252f,44.485476f,
                    52.532596f,44.532591f, 52.460764f,44.665933f, 52.447721f,44.853116f, 52.416733f,44.891700f, 52.387711f,44.892499f);
            poly[2217] = new TzPolygon(52.387711f,45.085736f, 52.413489f,45.123298f, 52.418277f,45.175237f, 52.387711f,45.217066f);
            poly[2218] = new TzPolygon(52.387711f,45.260551f, 52.390862f,45.267626f, 52.387711f,45.273475f);
            poly[2219] = new TzPolygon(52.387711f,45.307564f, 52.396867f,45.317327f, 52.387711f,45.355728f);
            poly[2220] = new TzPolygon(52.387711f,45.360905f, 52.410579f,45.384038f, 52.387711f,45.426670f);
            poly[2221] = new TzPolygon(52.387711f,45.430033f, 52.424964f,45.448791f, 52.425543f,45.513654f, 52.476530f,45.524166f, 52.452551f,45.600943f,
                    52.507726f,45.640552f, 52.474003f,45.667805f, 52.477883f,45.709004f, 52.432388f,45.707052f, 52.460615f,45.758383f,
                    52.415357f,45.796337f, 52.431239f,45.835675f, 52.397151f,45.962098f, 52.453781f,46.015098f, 52.474522f,45.984561f,
                    52.507903f,46.004324f, 52.524794f,46.067479f, 52.552990f,46.084055f, 52.526387f,46.137591f, 52.607934f,46.166902f,
                    52.609577f,46.267631f, 52.650081f,46.261472f, 52.680843f,46.325899f, 52.669012f,46.392077f, 52.387711f,46.392077f);
            poly[2222] = new TzPolygon(53.013644f,46.392077f, 53.013644f,46.933616f, 52.916610f,46.926556f, 52.890318f,46.884702f, 52.825515f,46.937339f,
                    52.820750f,46.981365f, 52.721964f,46.940143f, 52.697617f,46.818297f, 52.620828f,46.801070f, 52.611410f,46.744176f,
                    52.665828f,46.658339f, 52.661586f,46.609376f, 52.727264f,46.573443f, 52.688496f,46.539043f, 52.685795f,46.435162f,
                    52.664397f,46.417895f, 52.669012f,46.392077f);
            poly[2223] = new TzPolygon(53.013644f,46.933616f, 53.013644f,47.357484f, 52.569650f,47.357484f, 52.552575f,47.259309f, 52.570589f,47.231203f,
                    52.547507f,47.206575f, 52.558304f,47.155379f, 52.595582f,47.163364f, 52.576658f,47.060206f, 52.532669f,47.052874f,
                    52.574279f,47.049943f, 52.583128f,46.987387f, 52.637720f,46.980763f, 52.617560f,46.835594f, 52.599293f,46.830363f,
                    52.613133f,46.800982f, 52.697617f,46.818297f, 52.721964f,46.940143f, 52.820750f,46.981365f, 52.825515f,46.937339f,
                    52.890318f,46.884702f, 52.916610f,46.926556f);
            poly[2224] = new TzPolygon(53.013644f,46.933616f, 53.084016f,46.938736f, 53.086738f,46.904627f, 53.119696f,46.973593f, 53.175391f,46.937433f,
                    53.177713f,46.864173f, 53.238781f,46.872522f, 53.247170f,46.933828f, 53.275030f,46.958190f, 53.278757f,46.898876f,
                    53.362605f,46.908163f, 53.372678f,46.791834f, 53.415971f,46.746153f, 53.428839f,46.675054f, 53.482395f,46.669933f,
                    53.455753f,46.607771f, 53.486761f,46.555964f, 53.464390f,46.521321f, 53.513829f,46.449051f, 53.603505f,46.444955f,
                    53.617991f,46.479751f, 53.639578f,46.463353f, 53.639578f,47.357484f, 53.013644f,47.357484f);
            poly[2225] = new TzPolygon(53.666771f,46.392077f, 53.670359f,46.376481f, 53.752363f,46.320603f, 53.754909f,46.246873f, 53.788253f,46.285179f,
                    53.799513f,46.143608f, 53.885096f,46.217748f, 53.935542f,46.148233f, 53.932647f,46.100432f, 53.975646f,46.083037f,
                    53.985596f,45.975672f, 54.030780f,45.961465f, 53.983101f,45.932399f, 54.005476f,45.928127f, 54.007081f,45.892731f,
                    53.981052f,45.902668f, 53.994651f,45.857451f, 53.966433f,45.815110f, 53.986499f,45.796720f, 54.018048f,45.893456f,
                    54.061633f,45.894506f, 54.100823f,45.963603f, 54.154366f,45.968141f, 54.137973f,45.970547f, 54.149131f,46.006613f,
                    54.121681f,46.015846f, 54.176378f,46.077136f, 54.154637f,46.157146f, 54.208202f,46.319007f, 54.190620f,46.339416f,
                    54.207559f,46.392077f);
            poly[2226] = new TzPolygon(54.221748f,46.392077f, 54.233583f,46.385850f, 54.237119f,46.392077f);
            poly[2227] = new TzPolygon(53.639578f,46.463353f, 53.652658f,46.453417f, 53.666771f,46.392077f, 54.207559f,46.392077f, 54.209613f,46.398462f,
                    54.221748f,46.392077f, 54.237119f,46.392077f, 54.263089f,46.437818f, 54.247215f,46.444401f, 54.265512f,46.472903f,
                    54.265512f,46.519248f, 54.261616f,46.546494f, 54.265512f,46.545360f, 54.265512f,47.357484f, 53.639578f,47.357484f);
            poly[2228] = new TzPolygon(54.265512f,46.472903f, 54.270932f,46.481346f, 54.265512f,46.519248f);
            poly[2229] = new TzPolygon(54.265512f,46.545360f, 54.283504f,46.540123f, 54.287815f,46.654491f, 54.325358f,46.705200f, 54.402174f,46.729568f,
                    54.379893f,46.692285f, 54.398450f,46.708287f, 54.397851f,46.672596f, 54.379072f,46.676167f, 54.405985f,46.625526f,
                    54.399143f,46.535883f, 54.432583f,46.498043f, 54.469775f,46.500807f, 54.468329f,46.545176f, 54.497168f,46.582074f,
                    54.479653f,46.459980f, 54.554328f,46.546784f, 54.560662f,46.496099f, 54.572654f,46.538563f, 54.588299f,46.520389f,
                    54.561295f,46.419674f, 54.574272f,46.403548f, 54.632115f,46.534842f, 54.655202f,46.524954f, 54.688301f,46.421726f,
                    54.719755f,46.455972f, 54.739565f,46.408997f, 54.761625f,46.442798f, 54.757706f,46.493421f, 54.673100f,46.658436f,
                    54.684164f,46.776444f, 54.632065f,46.826185f, 54.705496f,47.034094f, 54.705171f,47.079356f, 54.650467f,47.181496f,
                    54.666574f,47.176470f, 54.671049f,47.226850f, 54.666742f,47.222430f, 54.669233f,47.328180f, 54.595487f,47.357484f,
                    54.265512f,47.357484f);
            poly[2230] = new TzPolygon(52.675424f,48.322892f, 52.683012f,48.307898f, 52.699330f,48.322892f);
            poly[2231] = new TzPolygon(53.013644f,48.216368f, 53.013644f,48.228151f, 53.004747f,48.224549f);
            poly[2232] = new TzPolygon(52.569650f,47.357484f, 52.573690f,47.380715f, 52.563272f,47.442631f, 52.593337f,47.532955f, 52.595096f,47.498819f,
                    52.620908f,47.498266f, 52.597673f,47.679420f, 52.568439f,47.724095f, 52.602477f,47.772441f, 52.699879f,47.778675f,
                    52.687966f,47.804917f, 52.703276f,47.828939f, 52.700814f,47.802695f, 52.736339f,47.812411f, 52.724596f,47.897102f,
                    52.646579f,47.933741f, 52.675976f,48.063798f, 52.732734f,48.092152f, 52.744964f,47.993330f, 52.767422f,48.075097f,
                    52.793566f,48.089287f, 52.768603f,48.197023f, 52.813032f,48.230627f, 52.779779f,48.306780f, 52.785405f,48.322892f,
                    52.701222f,48.322892f, 52.683012f,48.307898f, 52.675424f,48.322892f, 52.387711f,48.322892f, 52.387711f,47.357484f);
            poly[2233] = new TzPolygon(53.013644f,48.216368f, 53.040282f,48.191875f, 53.051571f,48.123151f, 53.137432f,48.212202f, 53.179781f,48.107791f,
                    53.235055f,48.158579f, 53.268010f,48.056873f, 53.361599f,47.930441f, 53.400550f,47.999307f, 53.432774f,48.005448f,
                    53.422807f,48.030318f, 53.471305f,48.035817f, 53.488810f,48.135807f, 53.466360f,48.142127f, 53.466850f,48.180532f,
                    53.491955f,48.208165f, 53.476874f,48.257050f, 53.461724f,48.247863f, 53.469211f,48.322892f, 53.069151f,48.322892f,
                    53.065620f,48.249192f, 53.013644f,48.228151f);
            poly[2234] = new TzPolygon(52.785405f,48.322892f, 52.819371f,48.420170f, 52.701222f,48.322892f);
            poly[2235] = new TzPolygon(52.675424f,48.322892f, 52.661996f,48.349425f, 52.682640f,48.523238f, 52.627327f,48.574395f, 52.639536f,48.692979f,
                    52.543013f,48.727016f, 52.547668f,48.834248f, 52.408252f,48.881715f, 52.407633f,48.923149f, 52.468457f,48.912330f,
                    52.471993f,48.956569f, 52.492514f,48.960312f, 52.494801f,49.108274f, 52.472367f,49.168263f, 52.499761f,49.171450f,
                    52.496366f,49.258082f, 52.486204f,49.288299f, 52.387711f,49.288299f, 52.387711f,48.322892f);
            poly[2236] = new TzPolygon(53.639578f,48.348446f, 53.593476f,48.345203f, 53.556244f,48.465294f, 53.563752f,48.406508f, 53.545555f,48.382128f,
                    53.473851f,48.369389f, 53.469211f,48.322892f, 53.639578f,48.322892f);
            poly[2237] = new TzPolygon(53.059020f,48.322892f, 53.055359f,48.363775f, 52.997345f,48.325122f, 52.993150f,48.371755f, 52.959312f,48.357140f,
                    52.972607f,48.439113f, 52.952114f,48.449405f, 52.949445f,48.522827f, 52.895802f,48.588749f, 52.859531f,48.571630f,
                    52.784631f,48.322892f);
            poly[2238] = new TzPolygon(53.639578f,48.405080f, 53.622848f,48.416310f, 53.639578f,48.379304f);
            poly[2239] = new TzPolygon(54.891446f,48.322892f, 54.694944f,48.322892f, 54.663426f,48.280683f, 54.701703f,48.229686f, 54.730870f,48.277954f,
                    54.723839f,48.152644f, 54.738563f,48.098001f, 54.766523f,48.103415f, 54.742501f,48.056010f, 54.713872f,48.080970f,
                    54.719614f,47.920709f, 54.640457f,47.928691f, 54.641691f,47.816598f, 54.682878f,47.770169f, 54.689736f,47.835559f,
                    54.728389f,47.822985f, 54.735029f,47.717752f, 54.673729f,47.670676f, 54.655783f,47.692094f, 54.612949f,47.612967f,
                    54.581647f,47.633758f, 54.540180f,47.594611f, 54.530415f,47.539343f, 54.567324f,47.450561f, 54.533157f,47.405316f,
                    54.498545f,47.424562f, 54.556868f,47.357484f, 54.891446f,47.357484f);
            poly[2240] = new TzPolygon(54.891446f,49.288299f, 54.880310f,49.239584f, 54.861326f,49.271525f, 54.841559f,49.238971f, 54.841825f,49.148209f,
                    54.788271f,49.089541f, 54.815460f,49.032398f, 54.796073f,49.012552f, 54.796020f,48.881780f, 54.625206f,48.881741f,
                    54.625211f,48.465153f, 54.669603f,48.353725f, 54.703423f,48.334246f, 54.694944f,48.322892f, 54.891446f,48.322892f);
            poly[2241] = new TzPolygon(53.639578f,48.348446f, 53.653099f,48.349397f, 53.639578f,48.379304f);
            poly[2242] = new TzPolygon(53.639578f,48.405080f, 53.649038f,48.398731f, 53.643376f,48.481310f, 53.666871f,48.532947f, 53.695161f,48.496483f,
                    53.734579f,48.517022f, 53.735597f,48.482172f, 53.770663f,48.488910f, 53.720327f,48.606888f, 53.730000f,48.648184f,
                    53.705311f,48.669517f, 53.732872f,48.725343f, 53.705946f,48.851391f, 53.706596f,48.994808f, 53.874945f,48.995609f,
                    53.890761f,49.084687f, 53.876305f,49.078815f, 53.869700f,49.215299f, 53.836763f,49.248200f, 53.832964f,49.288299f,
                    53.639578f,49.288299f);
            poly[2243] = new TzPolygon(51.247608f,50.034781f, 51.276484f,50.220275f, 51.247608f,50.220275f);
            poly[2244] = new TzPolygon(52.035813f,50.220275f, 52.036340f,50.218110f, 52.009824f,50.156395f, 52.090683f,50.159593f, 52.090630f,50.220275f);
            poly[2245] = new TzPolygon(52.129494f,50.220275f, 52.139653f,50.045132f, 52.190111f,50.039759f, 52.189589f,49.999180f, 52.172893f,49.999631f,
                    52.172749f,49.798082f, 52.270038f,49.746467f, 52.275657f,49.714753f, 52.228919f,49.675743f, 52.247820f,49.624494f,
                    52.282221f,49.659351f, 52.321707f,49.601005f, 52.340050f,49.637920f, 52.395936f,49.570031f, 52.395764f,49.520202f,
                    52.324220f,49.510376f, 52.320162f,49.450203f, 52.398620f,49.434658f, 52.398716f,49.348002f, 52.371590f,49.329000f,
                    52.382252f,49.288299f, 52.387711f,49.288299f, 52.464734f,49.352140f, 52.477110f,49.288299f, 52.486204f,49.288299f,
                    52.486204f,50.220275f);
            poly[2246] = new TzPolygon(51.669145f,51.152252f, 51.681375f,50.893614f, 51.753462f,50.871439f, 51.773037f,50.768163f, 51.866906f,50.933687f,
                    51.866906f,51.152252f);
            poly[2247] = new TzPolygon(51.866906f,50.701556f, 51.866906f,50.933687f, 51.773037f,50.768163f, 51.819658f,50.701438f);
            poly[2248] = new TzPolygon(51.866906f,50.220275f, 51.866906f,50.701556f, 51.819658f,50.701438f, 51.773037f,50.768163f, 51.714748f,50.768172f,
                    51.649158f,50.832580f, 51.585043f,50.812034f, 51.574805f,50.767719f, 51.574547f,50.678910f, 51.628517f,50.731705f,
                    51.645835f,50.585182f, 51.590632f,50.586719f, 51.589033f,50.537717f, 51.472728f,50.555853f, 51.465910f,50.497964f,
                    51.427749f,50.496870f, 51.427768f,50.371801f, 51.404310f,50.403848f, 51.382011f,50.338199f, 51.332611f,50.373135f,
                    51.280048f,50.243171f, 51.276484f,50.220275f);
            poly[2249] = new TzPolygon(51.866906f,51.152252f, 51.866906f,50.933687f, 51.923495f,51.033474f, 51.926120f,51.126882f, 51.988392f,51.143760f,
                    51.988334f,51.152252f);
            poly[2250] = new TzPolygon(52.129494f,50.220275f, 52.129312f,50.223421f, 52.090626f,50.224736f, 52.090630f,50.220275f);
            poly[2251] = new TzPolygon(52.035813f,50.220275f, 52.014855f,50.306340f, 52.044798f,50.308682f, 52.044856f,50.352111f, 51.981984f,50.352273f,
                    51.993772f,50.520058f, 51.963829f,50.521259f, 51.958687f,50.649261f, 51.933258f,50.649376f, 51.932973f,50.701720f,
                    51.866906f,50.701556f, 51.866906f,50.220275f);
            poly[2252] = new TzPolygon(51.669145f,51.152252f, 51.666854f,51.200697f, 51.687045f,51.253107f, 51.641057f,51.303713f, 51.641224f,51.380183f,
                    51.563430f,51.380326f, 51.563126f,51.240446f, 51.525226f,51.247733f, 51.531909f,51.285613f, 51.487785f,51.286546f,
                    51.484596f,51.493546f, 51.505800f,51.566119f, 51.550782f,51.604127f, 51.505101f,51.657109f, 51.474960f,51.629825f,
                    51.448636f,51.655825f, 51.497016f,51.813551f, 51.583197f,51.770475f, 51.650976f,51.860807f, 51.673806f,51.856608f,
                    51.683446f,51.999560f, 51.667217f,51.998996f, 51.674037f,52.074732f, 51.664336f,52.084228f, 51.247608f,52.084228f,
                    51.247608f,51.152252f);
            poly[2253] = new TzPolygon(52.486204f,51.506627f, 52.463787f,51.549075f, 52.428867f,51.548065f, 52.428663f,51.473152f, 52.365624f,51.461028f,
                    52.365158f,51.371080f, 52.225384f,51.407818f, 52.225180f,51.461711f, 52.069258f,51.391420f, 51.987937f,51.210024f,
                    51.988334f,51.152252f, 52.486204f,51.152252f);
            poly[2254] = new TzPolygon(51.478645f,53.016204f, 51.472220f,53.002831f, 51.477138f,52.946182f, 51.455108f,52.950131f, 51.497982f,52.924725f,
                    51.474657f,52.871727f, 51.505355f,52.896057f, 51.491035f,52.857434f, 51.505996f,52.838379f, 51.486431f,52.833295f,
                    51.513475f,52.792889f, 51.502149f,52.773491f, 51.522020f,52.771260f, 51.496272f,52.758042f, 51.503218f,52.734696f,
                    51.486274f,52.747128f, 51.498359f,52.723359f, 51.478199f,52.675211f, 51.456713f,52.687832f, 51.490654f,52.655230f,
                    51.455536f,52.622601f, 51.455743f,52.585723f, 51.477771f,52.586491f, 51.453031f,52.560611f, 51.683187f,52.384370f,
                    51.775899f,52.358670f, 51.766339f,52.319506f, 51.743319f,52.335365f, 51.733373f,52.181575f, 51.687453f,52.174568f,
                    51.658377f,52.090061f, 51.664336f,52.084228f, 52.486204f,52.084228f, 52.486204f,53.016204f);
            poly[2255] = new TzPolygon(51.247608f,53.669285f, 51.259855f,53.669784f, 51.306188f,53.595623f, 51.393276f,53.628629f, 51.433156f,53.570419f,
                    51.430616f,53.497164f, 51.454220f,53.487187f, 51.438131f,53.437171f, 51.482231f,53.426416f, 51.501205f,53.296539f,
                    51.482056f,53.276116f, 51.511872f,53.255001f, 51.512086f,53.182217f, 51.535370f,53.188740f, 51.521059f,53.142220f,
                    51.487401f,53.155781f, 51.504714f,53.070465f, 51.478645f,53.016204f, 52.486204f,53.016204f, 52.486204f,56.744109f,
                    51.247608f,56.744109f);
            poly[2256] = new TzPolygon(54.219528f,49.288299f, 54.219528f,50.243401f, 54.143923f,50.191997f, 54.070351f,50.224254f, 54.019835f,50.188688f,
                    54.007111f,50.081107f, 53.958450f,50.060934f, 53.978772f,49.978040f, 53.905269f,49.931196f, 53.889398f,49.927650f,
                    53.880096f,50.035601f, 53.819146f,50.035857f, 53.831996f,49.850447f, 53.889757f,49.816593f, 53.872365f,49.736720f,
                    53.830193f,49.703279f, 53.834159f,49.636021f, 53.802494f,49.600536f, 53.840060f,49.593543f, 53.872490f,49.311613f,
                    53.831872f,49.299830f, 53.832964f,49.288299f);
            poly[2257] = new TzPolygon(54.443698f,50.243401f, 54.501175f,50.195226f, 54.517008f,49.989460f, 54.500719f,49.967143f, 54.535254f,49.941566f,
                    54.537221f,49.848147f, 54.576807f,49.737457f, 54.562065f,49.560147f, 54.597493f,49.584152f, 54.628804f,49.530480f,
                    54.668061f,49.551035f, 54.691495f,49.534840f, 54.688562f,49.479729f, 54.723598f,49.525816f, 54.732251f,49.485784f,
                    54.785176f,49.468750f, 54.827704f,49.377965f, 54.839052f,49.405554f, 54.840107f,49.357766f, 54.891446f,49.288299f,
                    54.891446f,50.243401f);
            poly[2258] = new TzPolygon(54.219528f,50.243401f, 54.277084f,50.208592f, 54.295933f,50.238884f, 54.361487f,50.197049f, 54.374896f,50.149862f,
                    54.421101f,50.155801f, 54.423707f,50.103772f, 54.506600f,50.092459f, 54.492175f,50.223149f, 54.444690f,50.243401f);
            poly[2259] = new TzPolygon(52.486204f,51.506627f, 52.510296f,51.461006f, 52.568762f,51.451673f, 52.560845f,51.513751f, 52.628534f,51.471710f,
                    52.632000f,51.530492f, 52.676763f,51.523228f, 52.681792f,51.611924f, 52.645848f,51.616767f, 52.653247f,51.724319f,
                    52.800333f,51.766512f, 52.804381f,51.725738f, 52.876348f,51.715015f, 52.865248f,51.838496f, 52.917517f,51.868578f,
                    52.486204f,51.868578f);
            poly[2260] = new TzPolygon(54.541164f,51.868578f, 54.565004f,51.633645f, 54.651048f,51.533820f, 54.595378f,51.513160f, 54.588079f,51.381752f,
                    54.677156f,51.388873f, 54.633607f,51.252607f, 54.659565f,51.190288f, 54.540209f,51.074420f, 54.549436f,51.008365f,
                    54.469351f,51.021336f, 54.437996f,50.984444f, 54.402911f,50.999408f, 54.396142f,50.949871f, 54.342639f,50.951261f,
                    54.343385f,50.899561f, 54.384608f,50.875258f, 54.363487f,50.822766f, 54.375902f,50.750244f, 54.404720f,50.736443f,
                    54.328219f,50.503510f, 54.428452f,50.462754f, 54.420996f,50.430944f, 54.493499f,50.374246f, 54.480866f,50.324444f,
                    54.462622f,50.343475f, 54.442655f,50.307484f, 54.442671f,50.244262f, 54.891446f,50.243401f, 54.891446f,51.868578f);
            poly[2261] = new TzPolygon(52.917517f,51.868578f, 52.949774f,51.887143f, 52.945897f,51.990019f, 52.966563f,51.994526f, 52.964568f,52.041815f,
                    53.090567f,52.050012f, 53.087759f,52.162267f, 53.125871f,52.168129f, 53.122880f,52.080247f, 53.149317f,52.066717f,
                    53.165988f,52.136519f, 53.233201f,52.126918f, 53.235245f,52.171772f, 53.301450f,52.142478f, 53.297384f,52.173312f,
                    53.380847f,52.211862f, 53.386786f,52.152981f, 53.429110f,52.159431f, 53.464477f,52.095233f, 53.558273f,52.097669f,
                    53.555880f,52.188837f, 53.662308f,52.264660f, 53.688825f,52.269092f, 53.688825f,53.493755f, 52.486204f,53.493755f,
                    52.486204f,51.868578f);
            poly[2262] = new TzPolygon(53.688825f,52.269092f, 53.741436f,52.277886f, 53.900254f,52.412177f, 53.966233f,52.420842f, 53.947528f,52.392501f,
                    53.974387f,52.371971f, 54.054396f,52.488814f, 54.078402f,52.381433f, 54.148658f,52.372192f, 54.121741f,52.336780f,
                    54.149512f,52.294238f, 54.191199f,52.362553f, 54.294073f,52.345442f, 54.310897f,52.429383f, 54.300519f,52.521138f,
                    54.365639f,52.603342f, 54.339341f,52.628615f, 54.355938f,52.681167f, 53.688825f,52.681167f);
            poly[2263] = new TzPolygon(54.354878f,52.681167f, 54.338272f,52.638067f, 54.365556f,52.601415f, 54.340128f,52.568276f, 54.390070f,52.489178f,
                    54.459062f,52.502117f, 54.474154f,52.431903f, 54.398661f,52.367222f, 54.448221f,52.332345f, 54.435616f,52.217050f,
                    54.364848f,52.157912f, 54.391191f,52.095528f, 54.328302f,52.092543f, 54.355163f,52.036274f, 54.418205f,52.066223f,
                    54.429902f,51.995358f, 54.411966f,51.973568f, 54.414000f,52.016227f, 54.403014f,51.971757f, 54.431597f,51.963490f,
                    54.412539f,51.904272f, 54.473445f,51.951538f, 54.535055f,51.928783f, 54.541164f,51.868578f, 54.891446f,51.868578f,
                    54.891446f,52.681167f);
            poly[2264] = new TzPolygon(54.355938f,52.681167f, 54.360757f,52.696425f, 54.313596f,52.844570f, 54.320039f,52.917656f, 54.306951f,52.952239f,
                    54.276983f,52.890558f, 54.266091f,52.967277f, 54.291641f,53.029466f, 54.318612f,52.990646f, 54.352739f,53.056297f,
                    54.289000f,53.154678f, 54.267219f,53.116426f, 54.247200f,53.140091f, 54.244890f,53.033113f, 54.225246f,53.072339f,
                    54.217455f,53.051917f, 54.218827f,52.999123f, 54.237965f,53.004273f, 54.226687f,52.949293f, 54.182547f,52.968901f,
                    54.168980f,53.025076f, 54.131547f,53.044023f, 54.125690f,53.097017f, 54.065377f,53.062389f, 54.113175f,53.236351f,
                    54.098034f,53.254304f, 54.087275f,53.225771f, 54.087367f,53.287244f, 54.029539f,53.286816f, 53.974244f,53.368860f,
                    54.030531f,53.414488f, 54.054093f,53.493755f, 53.688825f,53.493755f, 53.688825f,52.681167f);
            poly[2265] = new TzPolygon(54.062745f,53.493755f, 54.089318f,53.466239f, 54.328760f,53.432048f, 54.373807f,53.381848f, 54.398032f,53.412577f,
                    54.417218f,53.386341f, 54.430459f,53.429540f, 54.450703f,53.403333f, 54.480917f,53.434642f, 54.566018f,53.423491f,
                    54.566971f,53.464813f, 54.588248f,53.464495f, 54.602620f,53.493755f);
            poly[2266] = new TzPolygon(54.891446f,53.543209f, 54.878503f,53.553362f, 54.891446f,53.597580f, 54.891446f,53.639235f, 54.815840f,53.588952f,
                    54.810622f,53.628773f, 54.747266f,53.639159f, 54.678076f,53.575561f, 54.672392f,53.609101f, 54.660803f,53.562312f,
                    54.640298f,53.570466f, 54.602620f,53.493755f, 54.891446f,53.493755f);
            poly[2267] = new TzPolygon(54.062745f,53.493755f, 54.056129f,53.500606f, 54.054093f,53.493755f);
            poly[2268] = new TzPolygon(56.200467f,50.871335f, 56.240606f,50.832155f, 56.256925f,50.871335f);
            poly[2269] = new TzPolygon(56.943089f,46.879927f, 56.918330f,46.838991f, 56.940716f,46.703663f, 56.987066f,46.785922f, 57.000955f,46.748523f,
                    57.032840f,46.754450f, 57.078449f,46.815439f, 57.096526f,46.767052f, 57.123440f,46.802778f, 57.161911f,46.749178f,
                    57.182228f,46.779901f, 57.177129f,46.838156f, 57.221494f,46.856563f, 57.224149f,46.797229f, 57.290529f,46.798180f,
                    57.285511f,46.717703f, 57.340945f,46.683245f, 57.384357f,46.779061f, 57.409316f,46.771638f, 57.381615f,46.709008f,
                    57.406496f,46.687803f, 57.446633f,46.821639f, 57.521511f,46.752933f, 57.505600f,46.879927f);
            poly[2270] = new TzPolygon(58.029165f,46.879927f, 58.044753f,46.502975f, 58.003203f,46.438757f, 58.077340f,46.329497f, 58.165583f,46.335236f,
                    58.214995f,46.416212f, 58.286217f,46.385378f, 58.329084f,46.395852f, 58.346737f,46.441276f, 58.346411f,46.395610f,
                    58.375020f,46.395691f, 58.393577f,46.426669f, 58.399094f,46.579335f, 58.460351f,46.599043f, 58.488111f,46.558368f,
                    58.588497f,46.658063f, 58.570337f,46.661133f, 58.599940f,46.879927f);
            poly[2271] = new TzPolygon(56.943089f,46.879927f, 56.951830f,46.894380f, 56.917941f,46.910041f, 56.942464f,46.967134f, 56.926675f,47.087902f,
                    56.889857f,47.159434f, 56.870074f,47.119597f, 56.807274f,47.134223f, 56.799219f,47.174702f, 56.824410f,47.198768f,
                    56.807167f,47.265306f, 56.882922f,47.434905f, 56.850756f,47.510934f, 56.871330f,47.488683f, 56.925077f,47.546813f,
                    56.924771f,47.602351f, 56.959028f,47.617643f, 56.992971f,47.705633f, 57.001636f,47.685070f, 56.998604f,47.782673f,
                    57.025950f,47.744068f, 57.039320f,47.764379f, 56.964629f,47.908305f, 56.989462f,47.917680f, 56.986714f,47.949257f,
                    56.957774f,47.954068f, 56.978091f,47.997352f, 57.001972f,47.988478f, 56.988483f,48.106619f, 57.018144f,48.159211f,
                    57.013501f,48.206062f, 57.042523f,48.207719f, 57.069662f,48.137530f, 57.074315f,48.210396f, 56.256925f,48.210396f,
                    56.256925f,46.879927f);
            poly[2272] = new TzPolygon(58.662159f,47.014091f, 58.618604f,47.017877f, 58.599940f,46.879927f, 58.662159f,46.879927f);
            poly[2273] = new TzPolygon(58.029165f,46.879927f, 58.006970f,47.416667f, 57.978303f,47.415327f, 57.948183f,47.690766f, 57.888717f,47.771781f,
                    57.859228f,47.617145f, 57.794705f,47.563039f, 57.784929f,47.599652f, 57.741104f,47.605583f, 57.689273f,47.535192f,
                    57.578076f,47.533365f, 57.578697f,47.494101f, 57.515179f,47.481365f, 57.520732f,47.375067f, 57.556016f,47.368887f,
                    57.561322f,47.293717f, 57.487807f,47.021939f, 57.505600f,46.879927f);
            poly[2274] = new TzPolygon(60.074036f,46.879927f, 60.057675f,46.778626f, 60.041049f,46.778834f, 60.068372f,46.741309f, 60.061902f,46.664523f,
                    60.084665f,46.651502f, 60.064514f,46.598308f, 60.106305f,46.497885f, 60.110449f,46.352685f, 60.132093f,46.377976f,
                    60.166173f,46.326561f, 60.207303f,46.340822f, 60.237154f,46.263784f, 60.253822f,46.283104f, 60.246195f,46.384976f,
                    60.268916f,46.415822f, 60.242548f,46.477851f, 60.262700f,46.635985f, 60.233679f,46.763025f, 60.358231f,46.843537f,
                    60.364781f,46.758457f, 60.396043f,46.779352f, 60.414204f,46.871727f, 60.432903f,46.835654f, 60.450603f,46.879927f);
            poly[2275] = new TzPolygon(60.489266f,46.879927f, 60.513505f,46.873836f, 60.515726f,46.879927f);
            poly[2276] = new TzPolygon(59.864776f,46.879927f, 59.864776f,46.953277f, 59.765497f,46.922349f, 59.752233f,47.152878f, 59.369321f,47.048947f,
                    59.352628f,47.247709f, 59.258869f,47.221029f, 59.246384f,47.253922f, 59.201214f,47.209394f, 59.133551f,47.368364f,
                    59.159150f,47.478534f, 59.093717f,47.444002f, 59.056821f,47.552276f, 59.030644f,47.527282f, 58.916855f,47.639515f,
                    58.895293f,47.492903f, 58.921992f,47.293133f, 58.869416f,47.249268f, 58.822356f,47.261958f, 58.814562f,47.324112f,
                    58.797065f,47.316774f, 58.768537f,47.205737f, 58.780974f,47.111160f, 58.714857f,47.062811f, 58.718388f,47.009203f,
                    58.662159f,47.014091f, 58.662159f,46.879927f);
            poly[2277] = new TzPolygon(59.864776f,46.953277f, 60.126381f,47.034772f, 60.123228f,46.920587f, 60.075795f,46.890820f, 60.074036f,46.879927f,
                    60.450603f,46.879927f, 60.454133f,46.888755f, 60.489266f,46.879927f, 60.515726f,46.879927f, 60.551955f,46.979290f,
                    60.544604f,47.038023f, 60.557705f,47.001618f, 60.624541f,47.013141f, 60.655460f,46.960859f, 60.669941f,47.006089f,
                    60.721814f,46.982951f, 60.725683f,47.033080f, 60.961749f,47.102304f, 60.996978f,47.193951f, 61.067393f,47.193180f,
                    61.035472f,47.482583f, 61.060586f,47.603077f, 61.031023f,47.662563f, 61.016821f,47.897198f, 60.988545f,47.955992f,
                    60.879171f,47.966530f, 60.856587f,48.210396f, 59.864776f,48.210396f);
            poly[2278] = new TzPolygon(57.074315f,48.210396f, 57.096243f,48.247687f, 57.129736f,48.229698f, 57.123576f,48.276759f, 57.166090f,48.328936f,
                    57.162718f,48.372928f, 57.133496f,48.361658f, 57.110189f,48.416842f, 57.171718f,48.555442f, 57.149911f,48.654409f,
                    57.169025f,48.673521f, 57.169236f,48.811107f, 57.114669f,48.865174f, 57.097391f,48.833863f, 57.082602f,48.949374f,
                    57.124532f,49.002940f, 57.180685f,48.973369f, 57.207146f,49.054371f, 57.219817f,49.007425f, 57.288947f,49.007420f,
                    57.295150f,49.085972f, 57.342444f,49.176605f, 57.308299f,49.216913f, 57.278620f,49.183299f, 57.222493f,49.200065f,
                    57.180187f,49.138524f, 57.142352f,49.160409f, 57.157890f,49.208231f, 57.133327f,49.171632f, 57.125234f,49.217926f,
                    57.042111f,49.247709f, 57.039513f,49.328473f, 57.005419f,49.390415f, 57.024076f,49.429828f, 57.044821f,49.402935f,
                    57.057757f,49.468026f, 57.057465f,49.540866f, 56.256925f,49.540866f, 56.256925f,48.210396f);
            poly[2279] = new TzPolygon(57.057465f,49.540866f, 57.057291f,49.584293f, 57.077971f,49.602114f, 57.050640f,49.647774f, 57.057719f,49.695383f,
                    57.012688f,49.691418f, 56.952329f,49.761010f, 56.932225f,49.705227f, 56.911295f,49.748882f, 56.886212f,49.738418f,
                    56.885460f,49.871113f, 56.855695f,49.957315f, 56.869330f,50.020649f, 56.831478f,50.070407f, 56.795976f,50.042915f,
                    56.792259f,50.104437f, 56.659213f,50.060962f, 56.657555f,50.026035f, 56.611177f,50.081424f, 56.604107f,50.149412f,
                    56.650296f,50.172819f, 56.632284f,50.299205f, 56.678167f,50.328953f, 56.608573f,50.430506f, 56.575784f,50.410307f,
                    56.611329f,50.452537f, 56.609720f,50.491241f, 56.550561f,50.438251f, 56.506531f,50.534719f, 56.479762f,50.489056f,
                    56.393444f,50.571828f, 56.404603f,50.639824f, 56.349373f,50.579791f, 56.312820f,50.742640f, 56.346851f,50.827086f,
                    56.409196f,50.741588f, 56.374990f,50.871335f, 56.364903f,50.871335f, 56.355091f,50.853890f, 56.333988f,50.871335f,
                    56.257971f,50.871335f, 56.256925f,50.868975f, 56.256925f,49.540866f);
            poly[2280] = new TzPolygon(60.856587f,48.210396f, 60.837206f,48.419678f, 60.551513f,48.560666f, 60.517251f,48.496803f, 60.472218f,48.496136f,
                    60.423506f,48.632908f, 60.400429f,48.530512f, 60.400813f,48.680117f, 60.352692f,48.785089f, 60.317715f,48.773751f,
                    60.195156f,48.492226f, 59.706844f,48.523224f, 59.686542f,48.801186f, 59.702446f,48.807418f, 59.679033f,48.847280f,
                    59.661699f,49.101547f, 59.482398f,49.039664f, 59.507078f,49.151193f, 59.475030f,49.216094f, 59.465125f,49.351720f,
                    59.409332f,49.344454f, 59.393145f,49.571821f, 59.216969f,49.521869f, 59.198289f,49.728482f, 59.220993f,49.768789f,
                    59.210535f,49.817400f, 59.478514f,49.872192f, 59.485070f,49.798428f, 59.655265f,49.859414f, 59.680315f,50.084932f,
                    59.723025f,49.985762f, 59.779092f,49.991028f, 59.747937f,50.270358f, 59.805919f,50.290289f, 59.839064f,50.402734f,
                    59.863324f,50.831023f, 59.894693f,50.871335f, 58.662159f,50.871335f, 58.662159f,48.210396f);
            poly[2281] = new TzPolygon(56.201553f,50.871335f, 56.195560f,50.877348f, 56.198126f,50.917326f, 55.442170f,50.917326f, 55.442170f,50.871335f);
            poly[2282] = new TzPolygon(56.333988f,50.871335f, 56.278355f,50.917326f, 56.257971f,50.871335f);
            poly[2283] = new TzPolygon(56.374990f,50.871335f, 56.371771f,50.883545f, 56.364903f,50.871335f);
            poly[2284] = new TzPolygon(56.218088f,51.359302f, 56.203405f,51.349729f, 56.218088f,51.412142f, 56.218088f,51.462740f, 56.197263f,51.462740f,
                    56.192176f,51.441036f, 56.127376f,51.444008f, 56.060762f,51.320319f, 56.083867f,51.286631f, 56.084197f,51.218075f,
                    56.123118f,51.207984f, 56.136730f,51.129677f, 56.112816f,51.058532f, 56.131697f,51.066751f, 56.153971f,50.984958f,
                    56.203589f,51.002454f, 56.198643f,50.917326f, 56.218088f,50.917326f);
            poly[2285] = new TzPolygon(55.926832f,51.462740f, 56.008350f,51.405953f, 56.045471f,51.341129f, 56.008832f,51.407941f, 56.042377f,51.417707f,
                    56.052376f,51.462740f);
            poly[2286] = new TzPolygon(56.128176f,51.462740f, 56.127376f,51.444008f, 56.192176f,51.441036f, 56.197263f,51.462740f);
            poly[2287] = new TzPolygon(56.218088f,51.412142f, 56.203405f,51.349729f, 56.218088f,51.359302f);
            poly[2288] = new TzPolygon(56.218088f,51.465272f, 56.205729f,51.498864f, 56.197263f,51.462740f, 56.218088f,51.462740f);
            poly[2289] = new TzPolygon(56.128219f,51.462740f, 56.136153f,51.639118f, 56.090631f,51.635028f, 56.052376f,51.462740f);
            poly[2290] = new TzPolygon(55.926832f,51.462740f, 55.911487f,51.473429f, 55.954518f,51.470138f, 55.936623f,51.511859f, 55.960105f,51.487070f,
                    55.951902f,51.522955f, 55.977040f,51.556819f, 55.952740f,51.601780f, 55.971199f,51.647675f, 55.944045f,51.665684f,
                    55.941350f,51.708453f, 55.981557f,51.742772f, 55.954091f,51.757615f, 55.941683f,51.711387f, 55.939150f,51.781854f,
                    55.886564f,51.780970f, 55.946404f,51.854731f, 55.951743f,51.929855f, 55.989862f,51.952489f, 55.977966f,52.008154f,
                    55.442170f,52.008154f, 55.442170f,51.462740f);
            poly[2291] = new TzPolygon(56.218088f,51.465272f, 56.225712f,51.444550f, 56.218088f,51.412142f, 56.218088f,51.359302f, 56.286327f,51.403791f,
                    56.320586f,51.345801f, 56.307470f,51.286290f, 56.351336f,51.303618f, 56.379529f,51.265141f, 56.421902f,51.299262f,
                    56.427622f,51.186654f, 56.511828f,51.127693f, 56.545827f,51.164757f, 56.684637f,51.180423f, 56.666895f,51.393202f,
                    56.766567f,51.391373f, 56.799073f,51.483415f, 56.885229f,51.536232f, 56.914997f,51.476817f, 56.897749f,51.455258f,
                    56.908362f,51.392154f, 56.941960f,51.424346f, 56.937420f,51.353779f, 56.994006f,51.325029f, 56.994006f,52.008154f,
                    56.218088f,52.008154f);
            poly[2292] = new TzPolygon(55.977966f,52.008154f, 55.971799f,52.037009f, 55.902402f,52.068855f, 55.904398f,52.156222f, 55.936234f,52.198673f,
                    55.950341f,52.179353f, 55.957521f,52.244809f, 56.020600f,52.206435f, 56.036556f,52.261600f, 56.091916f,52.211522f,
                    56.098249f,52.242639f, 56.019136f,52.379718f, 56.036019f,52.415712f, 56.008139f,52.463312f, 56.032898f,52.499403f,
                    56.058084f,52.427005f, 56.082721f,52.456863f, 55.994391f,52.676377f, 55.989558f,52.756727f, 56.130197f,52.712548f,
                    56.080128f,52.845043f, 56.118692f,52.880856f, 56.120532f,52.818890f, 56.159847f,52.882179f, 56.218088f,52.745066f,
                    56.218088f,52.992707f, 56.198586f,53.018284f, 56.212118f,53.061423f, 56.211158f,53.067692f, 56.199916f,53.041346f,
                    56.169234f,53.048892f, 56.174949f,53.088860f, 56.129808f,53.064148f, 56.115705f,53.098981f, 55.442170f,53.098981f,
                    55.442170f,52.008154f);
            poly[2293] = new TzPolygon(56.119641f,53.098981f, 56.141180f,53.088002f, 56.144081f,53.098981f);
            poly[2294] = new TzPolygon(56.218088f,52.745066f, 56.221247f,52.737629f, 56.222258f,52.584101f, 56.242864f,52.555310f, 56.285455f,52.593789f,
                    56.274227f,52.653981f, 56.397833f,52.777968f, 56.378934f,52.829400f, 56.428430f,52.963986f, 56.459967f,52.969235f,
                    56.508093f,52.878214f, 56.490724f,52.935059f, 56.542372f,52.948265f, 56.541096f,53.049402f, 56.512657f,53.089495f,
                    56.514721f,53.098981f, 56.509009f,53.098981f, 56.511086f,53.087018f, 56.454529f,53.088353f, 56.431872f,53.003746f,
                    56.285401f,52.944041f, 56.285780f,52.990802f, 56.240447f,52.963382f, 56.218088f,52.992707f);
            poly[2295] = new TzPolygon(56.994006f,51.325029f, 57.019393f,51.312130f, 57.044933f,51.216643f, 57.135318f,51.245662f, 57.140956f,51.194250f,
                    57.241956f,51.179236f, 57.243277f,51.124165f, 57.440762f,51.165254f, 57.468212f,51.400422f, 57.460752f,51.590067f,
                    57.531568f,51.626881f, 57.515233f,51.695293f, 57.538203f,51.755660f, 57.575104f,51.767267f, 57.571018f,51.835713f,
                    57.596499f,51.846748f, 57.588206f,51.799648f, 57.625729f,51.855992f, 57.729299f,51.864777f, 57.764626f,51.954912f,
                    57.828973f,51.927628f, 57.843815f,51.820076f, 57.886603f,51.851087f, 57.913884f,51.824634f, 57.935859f,51.882430f,
                    58.000705f,51.924883f, 58.021683f,51.814263f, 58.073841f,51.841874f, 58.154358f,51.778351f, 58.135672f,51.749392f,
                    58.151237f,51.681015f, 58.215455f,51.743761f, 58.250284f,51.722780f, 58.285681f,51.820346f, 58.361832f,51.787014f,
                    58.374106f,51.855233f, 58.453088f,51.964705f, 58.489055f,52.180407f, 58.462888f,52.296974f, 58.431696f,52.319952f,
                    58.392879f,52.843075f, 58.533618f,52.892691f, 58.522298f,53.090581f, 58.545842f,53.098981f, 56.994006f,53.098981f);
            poly[2296] = new TzPolygon(56.115705f,53.098981f, 56.114682f,53.101509f, 56.119641f,53.098981f, 56.144081f,53.098981f, 56.158943f,53.155232f,
                    56.103466f,53.193653f, 56.090384f,53.224940f, 56.107618f,53.263174f, 56.062106f,53.332830f, 56.090312f,53.383501f,
                    56.109331f,53.347110f, 56.165816f,53.350944f, 56.216211f,53.315115f, 56.245414f,53.238251f, 56.276134f,53.433793f,
                    56.232986f,53.488775f, 56.236981f,53.575332f, 56.125731f,53.568052f, 56.117237f,53.523714f, 56.136395f,53.497002f,
                    56.065024f,53.440391f, 56.026196f,53.464860f, 56.016730f,53.365395f, 55.993436f,53.389993f, 55.986043f,53.323752f,
                    55.938466f,53.316042f, 55.936238f,53.209732f, 55.872167f,53.240619f, 55.850578f,53.409222f, 55.912106f,53.547655f,
                    55.902058f,53.584666f, 55.910705f,53.625801f, 55.442170f,53.625801f, 55.442170f,53.098981f);
            poly[2297] = new TzPolygon(55.910705f,53.625801f, 55.929086f,53.713246f, 55.906290f,53.720582f, 55.895578f,53.817387f, 55.867247f,53.840981f,
                    55.886982f,53.879525f, 55.865566f,53.895725f, 55.852006f,53.858088f, 55.847449f,53.991750f, 55.812868f,53.942312f,
                    55.778684f,53.959428f, 55.808940f,54.048674f, 55.785811f,54.062719f, 55.757501f,54.014454f, 55.780990f,54.128695f,
                    55.757297f,54.116455f, 55.730669f,54.152621f, 55.607549f,54.152621f, 55.531001f,53.966494f, 55.465870f,53.978624f,
                    55.455099f,53.926926f, 55.442170f,53.915395f, 55.442170f,53.625801f);
            poly[2298] = new TzPolygon(56.153675f,54.152621f, 56.009474f,54.014881f, 56.044852f,53.845360f, 55.972239f,53.818192f, 55.969034f,53.708927f,
                    55.916329f,53.681295f, 55.914575f,53.625801f, 56.276134f,53.625801f, 56.276134f,54.152621f);
            poly[2299] = new TzPolygon(55.730669f,54.152621f, 55.715428f,54.173322f, 55.701347f,54.220947f, 55.726709f,54.241998f, 55.703756f,54.265697f,
                    55.612565f,54.164817f, 55.607549f,54.152621f);
        }
    }

    private static class Initializer24 {
        private static void init() {
            poly[2300] = new TzPolygon(56.276134f,54.403236f, 56.258520f,54.394178f, 56.198227f,54.195177f, 56.153675f,54.152621f, 56.276134f,54.152621f);
            poly[2301] = new TzPolygon(56.276134f,54.401120f, 56.308250f,54.419958f, 56.313338f,54.364719f, 56.482895f,54.328795f, 56.458165f,54.244086f,
                    56.534463f,54.191303f, 56.541972f,54.107960f, 56.579169f,54.103281f, 56.579697f,54.033574f, 56.638933f,54.075991f,
                    56.600298f,53.958062f, 56.596721f,53.841020f, 56.654217f,53.851004f, 56.679069f,53.901705f, 56.779609f,53.806785f,
                    56.797446f,53.831873f, 56.799110f,53.794068f, 56.820930f,53.824338f, 56.755001f,53.957858f, 56.753196f,54.020412f,
                    56.812081f,54.086471f, 56.978818f,54.154218f, 56.991877f,54.221212f, 56.973219f,54.341431f, 57.031004f,54.436131f,
                    57.108531f,54.295711f, 57.158411f,54.347841f, 57.185247f,54.305702f, 57.223288f,54.340702f, 57.240007f,54.297994f,
                    57.306043f,54.311169f, 57.299752f,54.204668f, 57.329141f,54.127582f, 57.371825f,54.149179f, 57.377806f,54.119877f,
                    57.410988f,54.230123f, 57.410988f,55.206261f, 56.276134f,55.206261f);
            poly[2302] = new TzPolygon(56.514721f,53.098981f, 56.524698f,53.144828f, 56.503670f,53.129737f, 56.509009f,53.098981f);
            poly[2303] = new TzPolygon(57.410988f,54.230123f, 57.426353f,54.281172f, 57.461267f,54.273825f, 57.483948f,54.143876f, 57.521944f,54.173095f,
                    57.532376f,54.142203f, 57.523880f,54.031841f, 57.570364f,54.043913f, 57.559337f,53.991837f, 57.586975f,53.986050f,
                    57.615644f,54.126741f, 57.643421f,54.050386f, 57.680584f,54.056055f, 57.705430f,54.155339f, 57.741150f,54.111653f,
                    57.774661f,54.155539f, 57.809495f,54.119574f, 57.873826f,54.138268f, 57.918409f,54.085662f, 57.957979f,54.136469f,
                    58.084837f,53.947080f, 58.146597f,53.945872f, 58.164273f,53.885234f, 58.179682f,53.908204f, 58.236607f,53.785463f,
                    58.314360f,53.886680f, 58.420644f,53.772575f, 58.477615f,53.788105f, 58.545842f,53.741829f, 58.545842f,55.206261f,
                    57.410988f,55.206261f);
            poly[2304] = new TzPolygon(58.545842f,53.737155f, 58.455029f,53.791308f, 58.472183f,53.636346f, 58.455267f,53.629216f, 58.474256f,53.620923f,
                    58.418863f,53.592068f, 58.443574f,53.596213f, 58.454353f,53.504666f, 58.384282f,53.373651f, 58.401361f,53.213692f,
                    58.443735f,53.248020f, 58.450482f,53.160667f, 58.542172f,53.160052f, 58.545842f,53.098981f);
            poly[2305] = new TzPolygon(59.296514f,53.257071f, 59.333703f,53.223935f, 59.365954f,53.257071f);
            poly[2306] = new TzPolygon(60.154597f,53.257071f, 60.151150f,53.069564f, 60.186602f,52.442615f, 60.227479f,52.316959f, 60.356369f,52.371894f,
                    60.360814f,52.332942f, 60.438092f,52.355028f, 60.464576f,52.124069f, 60.541242f,52.152814f, 60.580450f,51.771518f,
                    60.881543f,51.892312f, 60.829175f,52.360944f, 60.976416f,52.431433f, 60.937746f,52.806464f, 61.090131f,52.870731f,
                    61.049817f,53.257071f);
            poly[2307] = new TzPolygon(59.894693f,50.871335f, 60.031904f,51.047665f, 60.048892f,51.179066f, 59.994091f,51.390272f, 59.915573f,51.467194f,
                    59.941533f,51.551321f, 60.085865f,51.766358f, 60.279334f,51.973869f, 60.308488f,52.065457f, 60.186602f,52.442615f,
                    60.153197f,52.927270f, 60.155805f,53.257071f, 59.365954f,53.257071f, 59.333703f,53.223935f, 59.300350f,53.257071f,
                    58.545842f,53.257071f, 58.545842f,50.871335f);
            poly[2308] = new TzPolygon(60.155805f,53.257071f, 60.156718f,53.372461f, 60.224351f,53.437590f, 60.112095f,53.628103f, 60.009277f,53.686566f,
                    59.748234f,53.631811f, 59.687782f,53.598290f, 59.703145f,53.451000f, 59.462192f,53.355949f, 59.365954f,53.257071f);
            poly[2309] = new TzPolygon(59.300350f,53.257071f, 59.146546f,53.409874f, 59.151769f,53.555881f, 59.118569f,53.722017f, 59.152474f,53.682409f,
                    59.182651f,53.724423f, 59.111331f,53.816416f, 59.116024f,53.876803f, 59.087286f,53.903010f, 59.033986f,53.865769f,
                    59.015265f,53.785501f, 58.965256f,53.753185f, 58.862258f,53.796578f, 58.774383f,53.930011f, 58.691221f,53.737992f,
                    58.656579f,53.766400f, 58.602877f,53.703145f, 58.545842f,53.737155f, 58.545842f,53.257071f);
            poly[2310] = new TzPolygon(61.105941f,55.642808f, 61.148713f,55.275878f, 60.991563f,55.199961f, 61.009161f,55.050050f, 60.859908f,54.976851f,
                    60.982651f,53.875831f, 60.831604f,53.813824f, 60.847120f,53.663977f, 60.882661f,53.355153f, 61.033485f,53.413588f,
                    61.049817f,53.257071f, 62.310171f,53.257071f, 62.310171f,55.642808f);
            poly[2311] = new TzPolygon(62.310171f,55.642808f, 62.310171f,59.511996f, 62.258452f,59.501466f, 62.157112f,59.399401f, 61.946615f,59.489022f,
                    61.843348f,59.328030f, 61.783388f,59.325909f, 61.754598f,59.422190f, 61.663067f,59.348969f, 61.626507f,59.239947f,
                    61.629707f,59.148321f, 61.536394f,59.048309f, 61.517880f,58.844108f, 61.495045f,58.843882f, 61.501850f,57.092688f,
                    61.475297f,57.080551f, 61.524300f,56.653124f, 61.418999f,56.566341f, 61.443122f,56.378270f, 61.191858f,56.274501f,
                    61.246778f,55.813087f, 61.095603f,55.731499f, 61.105941f,55.642808f);
            poly[2312] = new TzPolygon(62.310171f,59.511996f, 62.321539f,59.514311f, 62.374869f,59.614206f, 62.419287f,59.582433f, 62.548454f,59.635447f,
                    62.565473f,59.442953f, 62.604623f,59.471717f, 62.750549f,59.358958f, 62.778262f,59.433324f, 62.898072f,59.462157f,
                    62.933238f,59.414852f, 62.982778f,59.224430f, 63.027597f,59.203794f, 63.089303f,59.225312f, 63.123803f,59.322729f,
                    63.183193f,59.287023f, 63.251827f,59.365877f, 63.321088f,59.321766f, 63.369468f,59.373906f, 63.387493f,59.310830f,
                    63.422055f,59.377966f, 63.552800f,59.471299f, 63.908559f,59.561302f, 63.960818f,59.720931f, 64.087144f,59.836947f,
                    64.134407f,59.828359f, 64.147693f,59.681714f, 64.214421f,59.633636f, 64.243126f,59.558743f, 64.434677f,59.651362f,
                    64.497467f,59.598435f, 64.495798f,59.464282f, 64.544007f,59.556749f, 64.649917f,59.618335f, 64.667875f,59.751588f,
                    64.724431f,59.625835f, 64.803266f,59.624632f, 64.825948f,59.724130f, 64.875580f,59.739689f, 64.911096f,59.811100f,
                    64.895313f,59.865213f, 64.932240f,59.892290f, 64.940777f,60.004264f, 64.996658f,60.057463f, 65.028549f,60.034186f,
                    65.051660f,60.173897f, 65.078554f,60.211810f, 65.066039f,60.414280f, 62.310171f,60.414280f);
            poly[2313] = new TzPolygon(66.074501f,60.414280f, 66.074501f,62.886780f, 66.000908f,62.792307f, 65.965945f,62.904436f, 65.903169f,62.775381f,
                    65.868164f,62.826238f, 65.844809f,62.684600f, 65.847722f,62.496709f, 65.757906f,62.229096f, 65.686944f,61.858602f,
                    65.666290f,61.875521f, 65.603809f,61.704272f, 65.578134f,61.720480f, 65.560072f,61.620124f, 65.386712f,61.417671f,
                    65.327348f,61.298457f, 65.277068f,61.295144f, 65.282884f,61.358588f, 65.250371f,61.364979f, 65.211969f,61.281404f,
                    65.172494f,61.286270f, 65.162295f,61.107646f, 65.082692f,61.077514f, 65.066361f,60.995155f, 65.013068f,60.946262f,
                    65.024967f,60.807603f, 64.930471f,60.738820f, 64.918553f,60.618781f, 65.005599f,60.435716f, 65.065679f,60.420103f,
                    65.066039f,60.414280f);
            poly[2314] = new TzPolygon(66.074501f,62.886780f, 66.247982f,63.109482f, 66.219457f,63.278412f, 66.247792f,63.311965f, 66.330948f,63.229665f,
                    66.339047f,63.292664f, 66.417351f,63.323822f, 66.466617f,63.418482f, 66.457538f,63.510363f, 66.519558f,63.630876f,
                    66.532506f,63.804552f, 66.637837f,63.985082f, 66.645543f,64.263616f, 66.722151f,64.395068f, 66.715489f,64.534173f,
                    66.750860f,64.506080f, 66.799888f,64.561083f, 66.801214f,64.677713f, 66.831029f,64.708453f, 66.834849f,64.877128f,
                    66.906223f,65.135898f, 67.039776f,65.081782f, 67.073701f,65.185752f, 66.074501f,65.185752f);
            poly[2315] = new TzPolygon(67.146067f,65.185752f, 67.150023f,65.181366f, 67.151593f,65.185752f);
            poly[2316] = new TzPolygon(68.818429f,65.185752f, 68.802739f,65.129166f, 68.876112f,64.921725f, 68.862344f,64.857945f, 68.893577f,64.788541f,
                    68.853112f,64.746879f, 68.863093f,64.567976f, 68.910664f,64.551408f, 68.948163f,64.628733f, 68.978933f,64.518136f,
                    69.029281f,64.539609f, 69.072201f,64.696729f, 69.123810f,64.740301f, 69.172637f,64.859514f, 69.193918f,65.025041f,
                    69.235888f,65.077134f, 69.338696f,65.131810f, 69.563919f,64.965044f, 69.648704f,65.185752f);
            poly[2317] = new TzPolygon(68.818230f,65.185752f, 68.824516f,65.209440f, 68.801939f,65.232974f, 68.812448f,65.344533f, 68.788339f,65.347424f,
                    68.791903f,65.399996f, 68.728544f,65.351000f, 68.733690f,65.448928f, 68.695573f,65.463755f, 68.681967f,65.402715f,
                    68.646778f,65.436069f, 68.563628f,65.670532f, 68.234566f,65.274676f, 68.108127f,65.352424f, 67.952395f,65.354903f,
                    67.909660f,65.432183f, 67.932918f,65.550222f, 67.917774f,65.750153f, 67.961368f,65.903266f, 67.938814f,66.076610f,
                    67.914221f,66.133489f, 67.879331f,66.057176f, 67.831083f,66.074299f, 67.807482f,66.023006f, 67.733913f,66.251686f,
                    67.649424f,66.161257f, 67.677303f,65.991271f, 67.653882f,65.960725f, 67.668486f,65.852000f, 67.642616f,65.786376f,
                    67.601611f,65.836791f, 67.571333f,65.786651f, 67.538601f,65.822687f, 67.579231f,66.052412f, 67.471723f,66.076915f,
                    67.403813f,65.995698f, 67.380796f,65.698554f, 67.333938f,65.746773f, 67.324271f,65.665897f, 67.294487f,65.662009f,
                    67.299745f,65.601854f, 67.209456f,65.427562f, 67.215417f,65.364080f, 67.151593f,65.185752f);
            poly[2318] = new TzPolygon(67.146067f,65.185752f, 67.092926f,65.244671f, 67.073701f,65.185752f);
            poly[2319] = new TzPolygon(48.217445f,42.088394f, 48.217445f,44.326271f, 48.041328f,44.325132f, 48.042363f,44.423857f, 47.889483f,44.392012f,
                    47.851650f,44.359057f, 47.899435f,44.082590f, 47.753096f,43.945831f, 47.760843f,43.871450f, 47.719002f,43.716835f,
                    47.548888f,43.667597f, 47.467751f,43.713893f, 47.443733f,43.657505f, 47.485709f,43.587170f, 47.447569f,43.314577f,
                    47.456157f,43.194611f, 47.467957f,43.152204f, 47.553664f,43.164356f, 47.553617f,43.049853f, 47.507918f,42.996583f,
                    47.507356f,42.924990f, 47.671727f,42.846395f, 47.761172f,42.759073f, 47.875870f,42.720174f, 47.908836f,42.629610f,
                    48.018645f,42.525202f, 48.009330f,42.391620f, 48.050496f,42.367812f, 48.027268f,42.338384f, 48.032691f,42.216126f,
                    48.005401f,42.158603f, 48.025080f,42.132149f, 48.023924f,42.018131f, 48.106160f,42.031610f, 48.140898f,42.129050f);
            poly[2320] = new TzPolygon(48.217445f,44.911935f, 48.194732f,44.937474f, 48.120248f,44.925662f, 48.050632f,44.809767f, 48.086332f,44.663061f,
                    48.053846f,44.648987f, 48.050487f,44.541061f, 48.188073f,44.544157f, 48.206230f,44.435767f, 48.217445f,44.436494f);
            poly[2321] = new TzPolygon(48.217445f,42.088394f, 48.265648f,42.062793f, 48.276916f,42.181006f, 48.415706f,42.085691f, 48.515275f,42.308733f,
                    48.496896f,42.364668f, 48.519081f,42.400227f, 48.505488f,42.460540f, 48.557432f,42.598290f, 48.543195f,42.622117f,
                    48.590948f,42.662304f, 48.589233f,42.679380f, 48.217445f,42.679380f);
            poly[2322] = new TzPolygon(48.648159f,42.679380f, 48.700576f,42.657963f, 48.718692f,42.679380f);
            poly[2323] = new TzPolygon(48.936668f,42.679380f, 48.953651f,42.652465f, 48.969331f,42.564930f, 49.010149f,42.500368f, 49.008741f,42.388048f,
                    49.050401f,42.350433f, 49.062182f,42.387198f, 49.106679f,42.382730f, 49.139264f,42.339804f, 49.122346f,42.189283f,
                    49.133835f,42.021112f, 49.195383f,42.098703f, 49.211555f,42.045306f, 49.267257f,42.068084f, 49.272549f,42.105855f,
                    49.286759f,42.075307f, 49.340972f,42.078087f, 49.342203f,42.029998f, 49.406949f,42.037076f, 49.675666f,42.184355f,
                    49.732527f,42.113765f, 49.732527f,42.679380f);
            poly[2324] = new TzPolygon(49.732527f,42.679380f, 49.732527f,42.113765f, 49.831590f,41.990783f, 49.850074f,41.920794f, 49.907509f,41.876885f,
                    49.918477f,41.751389f, 49.943959f,41.722128f, 49.959574f,41.617367f, 49.992400f,41.576483f, 50.041516f,41.610803f,
                    50.081221f,41.493767f, 50.227210f,41.382154f, 50.362572f,41.522177f, 50.498893f,41.420479f, 50.563731f,41.487791f,
                    50.574382f,41.539097f, 50.608973f,41.517341f, 50.606221f,41.447823f, 50.711609f,41.346678f, 50.774513f,41.168105f,
                    50.842407f,41.392800f, 50.832276f,41.420534f, 50.915927f,41.428337f, 50.949908f,41.471078f, 50.946212f,41.525203f,
                    51.016145f,41.774380f, 51.118410f,41.820000f, 51.194125f,41.928097f, 51.135876f,42.174743f, 51.160901f,42.422761f,
                    51.145240f,42.434685f, 51.144735f,42.553001f, 51.153082f,42.595525f, 51.223311f,42.679380f);
            poly[2325] = new TzPolygon(48.230631f,45.131181f, 48.270856f,44.960978f, 48.359200f,44.991761f, 48.357655f,45.025853f, 48.424901f,45.014685f,
                    48.426709f,45.052946f, 48.462152f,45.064055f, 48.465970f,45.131181f);
            poly[2326] = new TzPolygon(48.936668f,42.679380f, 48.934236f,42.683235f, 48.870527f,42.685629f, 48.822700f,42.748716f, 48.774256f,42.745068f,
                    48.718692f,42.679380f);
            poly[2327] = new TzPolygon(48.648159f,42.679380f, 48.586712f,42.704487f, 48.589233f,42.679380f);
            poly[2328] = new TzPolygon(48.217445f,44.326271f, 48.238797f,44.326409f, 48.250450f,44.381122f, 48.233604f,44.382409f, 48.229747f,44.437292f,
                    48.217445f,44.436494f);
            poly[2329] = new TzPolygon(48.217445f,44.911935f, 48.219390f,44.909748f, 48.270856f,44.960978f, 48.230631f,45.131181f, 48.217445f,45.131181f);
            poly[2330] = new TzPolygon(51.247608f,42.708392f, 51.223311f,42.679380f, 51.247608f,42.679380f);
            poly[2331] = new TzPolygon(51.247608f,42.918949f, 51.233025f,42.880894f, 51.247608f,42.708392f);
            poly[2332] = new TzPolygon(51.064507f,45.131181f, 51.077214f,45.083942f, 51.119186f,45.068490f, 51.145638f,44.993072f, 51.108716f,44.928124f,
                    51.171213f,44.865186f, 51.148544f,44.789152f, 51.178294f,44.643812f, 51.161954f,44.614069f, 51.126050f,44.627206f,
                    51.119465f,44.592870f, 51.211368f,44.477415f, 51.179842f,44.425089f, 51.174326f,44.345373f, 51.198713f,44.224031f,
                    51.093224f,44.184978f, 51.125131f,44.117872f, 51.097146f,44.094334f, 51.105535f,44.038782f, 51.072112f,44.050976f,
                    51.072218f,44.018499f, 51.159168f,44.018459f, 51.145848f,43.962361f, 51.161720f,43.922590f, 51.104157f,43.865166f,
                    51.118713f,43.667704f, 51.098881f,43.692661f, 51.055545f,43.662740f, 51.060632f,43.561704f, 51.034843f,43.424059f,
                    50.998713f,43.358549f, 51.111749f,43.192574f, 51.233025f,42.880894f, 51.247608f,42.909230f, 51.247608f,45.131181f);
            poly[2333] = new TzPolygon(45.388409f,47.582981f, 45.404747f,47.551402f, 45.495454f,47.563943f, 45.538623f,47.509981f, 45.609431f,47.491574f,
                    45.627631f,47.564493f, 45.660655f,47.520341f, 45.645917f,47.479616f, 45.676783f,47.295991f, 45.647343f,47.284105f,
                    45.618206f,47.212380f, 45.618867f,46.969002f, 45.596445f,46.948795f, 45.565388f,46.814059f, 45.577237f,46.769149f,
                    45.615088f,46.749669f, 45.619475f,46.683401f, 45.648470f,46.693884f, 45.700460f,46.477718f, 45.798013f,46.549815f,
                    45.815958f,46.411932f, 45.914425f,46.295432f, 45.963011f,46.310636f, 45.965448f,46.454929f, 46.177632f,46.449329f,
                    46.280949f,46.501244f, 46.320618f,46.400832f, 46.375777f,46.504665f, 46.354266f,46.560863f, 46.440919f,46.662967f,
                    46.445471f,46.964673f, 46.524452f,46.950327f, 46.619630f,46.866209f, 46.702364f,46.944873f, 46.702364f,47.582981f);
            poly[2334] = new TzPolygon(47.781479f,47.582981f, 47.838260f,47.415260f, 47.681285f,47.385221f, 47.760840f,47.194444f, 47.831678f,47.121844f,
                    47.853850f,47.181044f, 47.997751f,47.049937f, 48.036390f,47.148554f, 48.061109f,47.158768f, 48.054928f,47.200527f,
                    48.082216f,47.211117f, 48.103244f,47.090852f, 48.158065f,47.124800f, 48.217445f,47.114032f, 48.217445f,47.306726f,
                    48.194419f,47.582981f);
            poly[2335] = new TzPolygon(48.186585f,47.582981f, 48.217445f,47.178019f, 48.217445f,47.582981f);
            poly[2336] = new TzPolygon(48.217445f,45.164704f, 48.187713f,45.145672f, 48.164878f,45.238505f, 48.105472f,45.266053f, 48.099755f,45.379406f,
                    47.993780f,45.550385f, 48.032274f,45.698544f, 48.001333f,45.756632f, 47.931219f,45.713866f, 47.830262f,45.740173f,
                    47.814407f,45.783960f, 47.720167f,45.841256f, 47.716952f,45.899871f, 47.644680f,45.921678f, 47.564758f,46.007970f,
                    47.420745f,46.267207f, 47.413302f,46.398887f, 47.607172f,46.703368f, 47.607575f,46.761097f, 47.548898f,46.873143f,
                    47.481976f,46.669314f, 47.403407f,46.536258f, 47.073858f,46.739231f, 46.992215f,46.817065f, 46.974220f,46.962178f,
                    46.715370f,46.957240f, 46.702364f,46.944873f, 46.702364f,45.131181f, 48.217445f,45.131181f);
            poly[2337] = new TzPolygon(46.702364f,48.539169f, 46.702364f,48.732816f, 46.685468f,48.750552f, 46.693412f,48.919995f, 46.702364f,48.933686f,
                    46.702364f,50.034781f, 46.193704f,50.034781f, 46.128958f,50.020869f, 46.045769f,49.886117f, 46.186667f,49.701667f,
                    46.193333f,49.506667f, 46.293301f,49.263727f, 46.377144f,49.179803f, 46.393068f,49.053287f, 46.481563f,48.878679f,
                    46.480169f,48.826656f, 46.542088f,48.786482f, 46.563056f,48.702404f, 46.557266f,48.547941f, 46.585824f,48.557361f,
                    46.603404f,48.622726f, 46.609240f,48.566269f, 46.641874f,48.560284f, 46.670621f,48.477902f, 46.688453f,48.552989f);
            poly[2338] = new TzPolygon(45.388409f,47.582981f, 45.262264f,47.826803f, 45.206459f,47.615495f, 45.187282f,47.603637f, 45.187282f,47.582981f);
            poly[2339] = new TzPolygon(48.186585f,47.582981f, 48.217445f,47.582981f, 48.217445f,50.034781f, 48.081829f,50.034781f, 48.040024f,49.974004f,
                    48.042782f,49.805523f, 48.012977f,49.750904f, 48.024312f,49.438842f, 47.920497f,49.446813f, 48.103063f,48.679001f);
            poly[2340] = new TzPolygon(47.781479f,47.582981f, 47.758002f,47.652327f, 47.763033f,48.028166f, 47.744928f,48.111684f, 47.691627f,48.209370f,
                    47.411652f,48.451563f, 47.411752f,48.519423f, 47.095756f,48.710214f, 46.880604f,48.915276f, 46.743084f,48.995967f,
                    46.702364f,48.933686f, 46.702364f,48.732816f, 46.720912f,48.713344f, 46.731015f,48.643851f, 46.704987f,48.615945f,
                    46.706286f,48.535272f, 46.702364f,48.539169f, 46.702364f,47.582981f);
            poly[2341] = new TzPolygon(48.230631f,45.131181f, 48.222017f,45.167631f, 48.217445f,45.164704f, 48.217445f,45.131181f);
            poly[2342] = new TzPolygon(49.732527f,46.357081f, 48.797333f,46.357081f, 48.821239f,46.308201f, 48.837388f,46.324290f, 48.861628f,46.017229f,
                    48.843104f,45.945425f, 48.728350f,45.878833f, 48.682752f,45.805922f, 48.673304f,45.707524f, 48.602705f,45.604029f,
                    48.574976f,45.507084f, 48.590312f,45.434411f, 48.549033f,45.361676f, 48.573147f,45.302732f, 48.555052f,45.213546f,
                    48.535035f,45.200688f, 48.513442f,45.230755f, 48.513969f,45.326897f, 48.483182f,45.324356f, 48.500151f,45.355722f,
                    48.492555f,45.417571f, 48.432030f,45.339971f, 48.485871f,45.200102f, 48.514068f,45.213009f, 48.512157f,45.174436f,
                    48.469328f,45.190219f, 48.465970f,45.131181f, 49.732527f,45.131181f);
            poly[2343] = new TzPolygon(48.217445f,47.114032f, 48.233753f,47.111075f, 48.217445f,47.306726f);
            poly[2344] = new TzPolygon(48.797333f,46.357081f, 48.667749f,46.622036f, 48.432558f,46.493218f, 48.268503f,47.122974f, 48.217445f,47.105495f,
                    48.217445f,46.357081f);
            poly[2345] = new TzPolygon(49.732527f,46.872413f, 49.339877f,46.782242f, 49.232396f,46.996186f, 49.165588f,47.051343f, 49.027344f,46.972040f,
                    48.951414f,46.779165f, 48.667749f,46.622036f, 48.797333f,46.357081f, 49.732527f,46.357081f);
            poly[2346] = new TzPolygon(51.064507f,45.131181f, 51.040342f,45.221014f, 50.968482f,45.204105f, 50.934021f,45.257829f, 50.935372f,45.223834f,
                    50.913979f,45.303562f, 50.862311f,45.325770f, 50.721352f,45.276031f, 50.710335f,45.185180f, 50.698007f,45.231314f,
                    50.585199f,45.193355f, 50.589885f,45.386367f, 50.613338f,45.405121f, 50.604868f,45.489696f, 50.550881f,45.536249f,
                    50.589599f,45.566354f, 50.578280f,45.698628f, 50.667025f,45.678601f, 50.737716f,45.715632f, 50.757303f,45.744223f,
                    50.756178f,45.842266f, 50.749988f,45.893032f, 50.688249f,45.989773f, 50.687733f,46.035263f, 50.665215f,46.035435f,
                    50.664868f,46.093156f, 50.526166f,46.061460f, 50.527697f,46.278413f, 50.572862f,46.277906f, 50.562978f,46.357081f,
                    49.732527f,46.357081f, 49.732527f,45.131181f);
            poly[2347] = new TzPolygon(49.732527f,46.872413f, 49.863781f,46.902555f, 49.934959f,47.182462f, 50.083868f,47.342953f, 50.152014f,47.317713f,
                    50.191746f,47.257473f, 50.238021f,47.335418f, 50.283680f,47.292017f, 50.331956f,47.339878f, 50.336373f,47.406683f,
                    50.420954f,47.473603f, 50.460652f,47.541685f, 50.455856f,47.582981f, 49.732527f,47.582981f);
            poly[2348] = new TzPolygon(50.562978f,46.357081f, 51.247608f,46.357081f, 51.247608f,47.582981f, 50.458515f,47.582981f, 50.460652f,47.541685f,
                    50.377862f,47.431637f, 50.371156f,47.235016f, 50.509221f,47.205614f, 50.489672f,46.912420f, 50.523093f,46.916688f,
                    50.523748f,46.870769f, 50.577215f,46.870768f, 50.578459f,46.799124f, 50.641828f,46.857205f, 50.658710f,46.742104f,
                    50.711492f,46.718491f, 50.680943f,46.625698f, 50.712288f,46.583388f, 50.614839f,46.568496f, 50.644436f,46.538286f,
                    50.623485f,46.527074f, 50.617594f,46.491559f, 50.634687f,46.491632f, 50.617155f,46.458360f, 50.568447f,46.448178f,
                    50.547106f,46.484214f);
            poly[2349] = new TzPolygon(50.458515f,47.582981f, 51.247608f,47.582981f, 51.247608f,50.034781f, 51.243448f,50.008058f, 51.107155f,49.776163f,
                    51.098502f,49.490344f, 51.125593f,49.454666f, 51.089929f,49.430384f, 51.090067f,49.392833f, 51.048890f,49.396412f,
                    50.987069f,49.338525f, 50.960972f,49.408124f, 50.881488f,49.444654f, 50.848685f,49.422908f, 50.784568f,49.126235f,
                    50.682164f,49.009264f, 50.595518f,48.814683f, 50.612350f,48.689053f, 50.661929f,48.606211f, 50.632365f,48.570628f,
                    50.577908f,48.664246f, 50.257238f,48.732409f, 50.170433f,48.809023f, 50.097913f,48.763692f, 50.090236f,48.850343f,
                    50.018387f,48.903429f, 49.921321f,48.745624f, 49.835136f,48.450341f, 49.801213f,48.439867f, 49.835989f,48.395566f,
                    49.827574f,48.353852f, 49.872185f,48.315135f, 49.868056f,48.226192f, 49.901449f,48.232487f, 49.998021f,48.131627f,
                    50.100014f,48.095210f, 50.142102f,48.009094f, 50.244484f,47.937749f, 50.313020f,47.819448f, 50.330327f,47.827889f,
                    50.340027f,47.763434f, 50.378368f,47.743322f, 50.408555f,47.663385f, 50.455735f,47.636682f);
            poly[2350] = new TzPolygon(43.586429f,55.999244f, 45.000314f,55.998743f, 45.170128f,56.744109f, 43.586429f,56.744109f);
            poly[2351] = new TzPolygon(46.520131f,52.773582f, 46.520131f,55.487919f, 46.367363f,55.270475f, 46.379528f,55.089586f, 46.363543f,54.832578f,
                    46.257033f,54.307690f, 46.246130f,53.971735f, 46.192437f,53.968557f, 46.127348f,53.895303f, 46.015600f,53.684004f,
                    46.011946f,53.176626f, 46.020878f,52.875769f, 46.392933f,52.736419f);
            poly[2352] = new TzPolygon(45.177249f,56.744109f, 45.926133f,56.605778f, 46.097356f,56.516505f, 46.132189f,56.466630f, 46.240325f,56.440627f,
                    46.376052f,56.315564f, 46.513382f,56.287542f, 46.520131f,56.255452f, 46.520131f,56.744109f);
            poly[2353] = new TzPolygon(46.520131f,56.255452f, 46.513382f,56.287542f, 46.376052f,56.315564f, 46.240325f,56.440627f, 46.149135f,56.471824f,
                    46.132189f,56.466630f, 46.151583f,56.286168f, 46.135755f,56.201516f, 46.154545f,56.121737f, 46.211476f,56.044760f,
                    46.210459f,55.981457f, 46.260008f,55.956920f, 46.237314f,55.902490f, 46.251191f,55.837026f, 46.276013f,55.820425f,
                    46.305272f,55.860157f, 46.401193f,55.817980f, 46.421094f,55.602653f, 46.520131f,55.487919f);
            poly[2354] = new TzPolygon(51.247608f,53.389445f, 49.101709f,53.389445f, 49.100088f,53.386237f, 49.094759f,53.389445f, 49.045868f,53.389445f,
                    49.017687f,53.263256f, 49.048084f,52.825523f, 48.981325f,52.782155f, 48.995957f,52.706149f, 48.762009f,52.715828f,
                    48.766191f,52.612621f, 48.591864f,52.536614f, 48.513940f,52.555989f, 48.494085f,52.380066f, 48.577970f,52.152443f,
                    48.551160f,52.059402f, 48.577289f,51.769638f, 48.683255f,51.804657f, 48.716111f,51.645355f, 48.726983f,51.436615f,
                    48.718602f,51.261863f, 48.680988f,51.107025f, 48.688241f,51.041793f, 48.587055f,50.990295f, 48.472467f,50.714263f,
                    48.179607f,50.176934f, 48.081829f,50.034781f, 51.247608f,50.034781f);
            poly[2355] = new TzPolygon(48.883870f,53.389445f, 48.883870f,54.016581f, 48.762814f,54.027021f, 48.703063f,54.302571f, 48.641896f,54.460310f,
                    48.640092f,54.542039f, 48.779346f,54.578771f, 48.770618f,54.634990f, 48.799862f,54.656798f, 48.774490f,54.738207f,
                    48.741507f,54.753316f, 48.709443f,54.912309f, 48.560325f,54.932074f, 48.475029f,54.888197f, 48.365312f,54.879207f,
                    48.270421f,54.969347f, 48.097215f,54.938625f, 47.956272f,55.099125f, 47.778876f,55.121525f, 47.202360f,55.001978f,
                    46.873822f,55.232860f, 46.725994f,55.450369f, 46.628908f,55.738247f, 46.520131f,56.255452f, 46.520131f,53.389445f);
            poly[2356] = new TzPolygon(49.047470f,53.389445f, 49.062209f,53.425441f, 49.096988f,53.389445f, 49.101930f,53.389445f, 49.240349f,53.630538f,
                    49.197124f,53.665516f, 49.143943f,53.832365f, 49.123353f,53.820349f, 49.097658f,53.879095f, 49.164254f,53.913171f,
                    49.172122f,53.991723f, 48.883870f,54.016581f, 48.883870f,53.389445f);
            poly[2357] = new TzPolygon(50.065739f,53.389445f, 50.065739f,54.537145f, 50.062825f,54.543359f, 50.012584f,54.555976f, 49.814892f,54.418588f,
                    49.768345f,54.477086f, 49.768281f,54.366368f, 49.675946f,54.275387f, 49.647991f,54.298908f, 49.610271f,54.200593f,
                    49.618656f,53.991322f, 49.570092f,53.972871f, 49.570302f,53.875187f, 49.525077f,53.797833f, 49.457286f,53.756950f,
                    49.477454f,53.695008f, 49.424916f,53.729835f, 49.277740f,53.663852f, 49.185300f,53.554861f, 49.101709f,53.389445f);
            poly[2358] = new TzPolygon(49.094759f,53.389445f, 49.051662f,53.415390f, 49.045868f,53.389445f);
            poly[2359] = new TzPolygon(50.960730f,54.228111f, 50.967076f,54.194775f, 50.987940f,54.204114f, 51.009918f,54.158051f, 51.031678f,54.194432f,
                    51.066292f,54.160865f, 51.062568f,54.130011f, 51.098619f,54.145012f, 51.136170f,54.041997f, 51.152970f,54.054871f,
                    51.193414f,53.932356f, 51.180432f,53.892643f, 51.200476f,53.884132f, 51.193377f,53.819072f, 51.214780f,53.808429f,
                    51.203908f,53.747447f, 51.236378f,53.692568f, 51.225420f,53.668382f, 51.247608f,53.669285f, 51.247608f,54.228111f);
            poly[2360] = new TzPolygon(50.065739f,54.537145f, 50.118240f,54.425183f, 50.273212f,54.439804f, 50.340237f,54.365044f, 50.403204f,54.464746f,
                    50.552650f,54.574515f, 50.538743f,54.614230f, 50.619329f,54.731355f, 50.823272f,54.657133f, 50.892675f,54.697607f,
                    50.926698f,54.571413f, 50.942377f,54.594218f, 51.000963f,54.547797f, 51.029601f,54.591044f, 51.015795f,54.692037f,
                    51.037635f,54.686037f, 51.038574f,54.739793f, 50.985264f,54.791517f, 50.957758f,54.898033f, 50.920134f,54.893940f,
                    50.904900f,55.014596f, 50.916949f,55.066777f, 50.828077f,55.066777f, 50.819419f,55.056233f, 50.816777f,55.066777f,
                    50.065739f,55.066777f);
            poly[2361] = new TzPolygon(50.960730f,54.228111f, 50.949235f,54.288502f, 50.900519f,54.290001f, 50.882115f,54.441631f, 50.851195f,54.452410f,
                    50.854636f,54.518170f, 50.825390f,54.527282f, 50.778411f,54.473598f, 50.620695f,54.413611f, 50.516460f,54.565237f,
                    50.403204f,54.464746f, 50.340237f,54.365044f, 50.273212f,54.439804f, 50.118240f,54.425183f, 50.065739f,54.537145f,
                    50.065739f,54.228111f);
            poly[2362] = new TzPolygon(51.085392f,56.744109f, 51.077521f,56.704428f, 50.995501f,56.744109f, 50.979009f,56.744109f, 50.970677f,56.712627f,
                    50.986531f,56.618322f, 51.085861f,56.513729f, 51.056850f,56.448162f, 50.965119f,56.460384f, 50.965379f,56.376894f,
                    50.901250f,56.361258f, 50.938126f,56.181283f, 50.830584f,56.132989f, 50.753568f,56.137177f, 50.620710f,55.901173f,
                    50.606740f,55.795123f, 50.550300f,55.736246f, 50.613495f,55.534108f, 50.669916f,55.502616f, 50.681432f,55.402885f,
                    50.653564f,55.383735f, 50.796832f,55.146361f, 50.816777f,55.066777f, 50.828077f,55.066777f, 50.879588f,55.129506f,
                    50.921176f,55.085084f, 50.916949f,55.066777f, 51.247608f,55.066777f, 51.247608f,56.744109f);
            poly[2363] = new TzPolygon(47.827727f,56.744109f, 47.827727f,61.924863f, 47.818785f,61.359797f, 47.790051f,61.314221f, 47.110337f,60.923499f,
                    47.121809f,60.495002f, 46.910811f,60.474422f, 46.894867f,60.129609f, 46.499964f,59.561388f, 46.052982f,59.111813f,
                    46.007044f,59.030602f, 45.322897f,59.096597f, 45.590118f,58.587577f, 45.177249f,56.744109f);
            poly[2364] = new TzPolygon(45.170128f,56.744109f, 45.590118f,58.587577f, 45.322897f,59.096597f, 45.151321f,59.497905f, 45.002986f,59.991375f,
                    44.360433f,61.106566f, 44.225787f,61.137761f, 43.586429f,61.906615f, 43.586429f,56.744109f);
            poly[2365] = new TzPolygon(46.176489f,65.941044f, 46.178002f,65.892569f, 46.212706f,65.585958f, 46.311714f,65.372556f, 46.476547f,65.140843f,
                    46.501354f,64.941767f, 46.688872f,64.447282f, 46.835636f,63.848625f, 46.830106f,63.739542f, 46.928864f,63.508901f,
                    46.971511f,63.303126f, 47.031274f,63.207827f, 47.064156f,63.370617f, 47.113482f,63.407087f, 47.199206f,63.018320f,
                    47.190771f,62.950089f, 47.360673f,63.225465f, 47.515452f,63.653203f, 47.638184f,63.844555f, 47.703234f,64.014674f,
                    47.827727f,64.181147f, 47.827727f,65.941044f);
            poly[2366] = new TzPolygon(47.827727f,64.181147f, 47.703234f,64.014674f, 47.638184f,63.844555f, 47.515452f,63.653203f, 47.360673f,63.225465f,
                    47.296469f,63.145694f, 47.177349f,62.890080f, 47.214653f,62.860154f, 47.242345f,62.581169f, 47.328445f,62.605726f,
                    47.531129f,62.332616f, 47.545556f,62.212529f, 47.723311f,62.075832f, 47.827727f,61.924863f);
            poly[2367] = new TzPolygon(43.586429f,62.755236f, 43.650485f,63.349076f, 43.599258f,63.857628f, 43.586429f,64.161720f);
            poly[2368] = new TzPolygon(43.586429f,64.572848f, 43.735374f,64.932263f, 43.715397f,65.002156f, 43.586429f,65.109147f);
            poly[2369] = new TzPolygon(46.176489f,65.941044f, 46.162474f,66.389996f, 46.172475f,66.901664f, 46.136139f,67.158185f, 46.107641f,67.143841f,
                    46.044659f,67.182584f, 45.955651f,67.163072f, 45.847243f,67.278305f, 45.848800f,67.304118f, 45.757503f,67.365450f,
                    45.687395f,67.293523f, 45.613957f,67.290777f, 45.564411f,67.244843f, 45.503139f,67.264684f, 45.406151f,67.245870f,
                    45.351199f,67.168167f, 45.302239f,67.167903f, 45.181771f,67.390877f, 45.147768f,67.516214f, 44.649145f,67.525949f,
                    44.433433f,67.508987f, 44.367757f,67.462029f, 44.295050f,67.582986f, 44.311187f,67.630688f, 44.271978f,67.733382f,
                    44.166165f,67.806927f, 44.026497f,68.060302f, 43.962493f,68.026346f, 43.886450f,67.921630f, 43.869985f,67.954951f,
                    43.802470f,67.979288f, 43.736952f,67.971461f, 43.701901f,67.918982f, 43.743664f,67.823925f, 43.639219f,67.838210f,
                    43.586429f,67.821318f, 43.586429f,65.941044f);
            poly[2370] = new TzPolygon(51.076747f,58.395748f, 51.074870f,58.384019f, 51.162279f,58.321032f, 51.128184f,58.203016f, 51.096711f,58.216018f,
                    51.062343f,58.168484f, 51.073609f,58.094316f, 51.121211f,58.087971f, 51.086253f,57.948741f, 51.118052f,57.919043f,
                    51.098969f,57.869091f, 51.139167f,57.811412f, 51.138416f,57.771942f, 50.920212f,57.761816f, 50.935936f,57.559087f,
                    50.875951f,57.507028f, 50.940797f,57.326230f, 51.037838f,57.289421f, 51.038857f,57.219329f, 51.114961f,57.184771f,
                    51.087670f,57.146333f, 51.062637f,56.984426f, 51.087538f,56.942786f, 51.060258f,56.887474f, 51.093601f,56.785490f,
                    51.085392f,56.744109f, 51.359587f,56.744109f, 51.359587f,58.395748f);
            poly[2371] = new TzPolygon(50.995501f,56.744109f, 50.980881f,56.751182f, 50.979009f,56.744109f);
            poly[2372] = new TzPolygon(51.076747f,58.395748f, 51.359587f,58.395748f, 51.359587f,60.047388f, 50.825213f,60.047388f, 50.822124f,60.014903f,
                    50.768700f,59.972745f, 50.674848f,59.997510f, 50.633870f,59.906199f, 50.535508f,59.813177f, 50.530778f,59.615254f,
                    50.495313f,59.509517f, 50.528270f,59.516678f, 50.543702f,59.457182f, 50.584283f,59.462929f, 50.581354f,59.569328f,
                    50.641479f,59.479295f, 50.652971f,59.298401f, 50.633555f,59.278576f, 50.672743f,59.193054f, 50.699816f,58.874303f,
                    50.814694f,58.774428f, 50.808637f,58.656400f, 50.841561f,58.663597f, 50.848189f,58.696464f, 50.885634f,58.688182f,
                    50.869333f,58.593586f, 50.939830f,58.578611f, 50.987517f,58.642254f, 51.047402f,58.614174f, 51.091339f,58.486957f);
            poly[2373] = new TzPolygon(48.617543f,63.350667f, 48.682438f,63.078707f, 48.758066f,63.049270f, 48.863410f,63.130174f, 48.929403f,63.020385f,
                    48.848813f,62.845444f, 49.018131f,62.548791f, 49.198247f,62.445753f, 49.200801f,62.361430f, 49.235630f,62.376091f,
                    49.253269f,62.547452f, 49.497267f,62.304843f, 49.577772f,62.367337f, 49.562053f,62.473174f, 49.593657f,62.464023f,
                    49.593657f,63.350667f);
            poly[2374] = new TzPolygon(50.825213f,60.047388f, 50.838571f,60.187871f, 50.812684f,60.216555f, 50.778391f,60.182778f, 50.670254f,60.325208f,
                    50.656605f,60.809000f, 50.806123f,61.449001f, 51.237771f,61.568060f, 51.256523f,61.699027f, 49.593657f,61.699027f,
                    49.593657f,60.047388f);
            poly[2375] = new TzPolygon(51.257214f,61.699027f, 51.255963f,61.689785f, 51.323304f,61.549686f, 51.359587f,61.528935f, 51.359587f,61.699027f);
            poly[2376] = new TzPolygon(51.256523f,61.699027f, 51.269131f,61.787087f, 51.317069f,61.852152f, 51.262459f,61.913658f, 51.089337f,61.994738f,
                    51.073055f,62.073254f, 51.111346f,62.081005f, 51.138759f,62.131163f, 51.080164f,62.283031f, 51.041156f,62.275578f,
                    51.013043f,62.208493f, 50.978418f,62.228578f, 50.852835f,62.430261f, 50.841436f,62.311465f, 50.801556f,62.276492f,
                    50.813618f,62.221837f, 50.721845f,62.276461f, 50.676022f,62.229542f, 50.641507f,62.266925f, 50.688706f,62.439803f,
                    50.515611f,62.528513f, 50.477866f,62.507021f, 50.416313f,62.557610f, 50.385649f,62.634686f, 50.309791f,62.667773f,
                    50.264877f,62.734592f, 50.212121f,62.736695f, 50.165282f,62.821075f, 50.092066f,62.885225f, 50.038567f,62.890976f,
                    49.997440f,62.952980f, 49.916428f,62.910523f, 49.881759f,62.926023f, 49.936889f,62.790665f, 49.940186f,62.739589f,
                    49.908458f,62.658290f, 49.862510f,62.598727f, 49.735305f,62.555089f, 49.683664f,62.437960f, 49.593657f,62.464023f,
                    49.593657f,61.699027f);
            poly[2377] = new TzPolygon(51.914045f,60.047388f, 51.964646f,59.994120f, 51.993281f,60.001992f, 51.992725f,60.047388f);
            poly[2378] = new TzPolygon(51.359587f,61.528935f, 51.409259f,61.500527f, 51.461068f,61.202980f, 51.447770f,61.107564f, 51.468055f,61.087389f,
                    51.467784f,60.998958f, 51.550638f,60.910789f, 51.615264f,60.935627f, 51.618012f,60.538034f, 51.637866f,60.527008f,
                    51.647001f,60.415540f, 51.689282f,60.353292f, 51.773302f,60.518878f, 51.797725f,60.517488f, 51.798449f,60.427985f,
                    51.906886f,60.144821f, 51.857862f,60.157270f, 51.870145f,60.058908f, 51.888273f,60.074519f, 51.914045f,60.047388f,
                    51.992725f,60.047388f, 51.990883f,60.197662f, 52.156384f,60.510847f, 52.156154f,60.716749f, 52.229064f,60.780488f,
                    52.266367f,60.944255f, 52.347091f,61.066798f, 52.423055f,60.992233f, 52.507871f,60.982329f, 52.522252f,60.841829f,
                    52.641033f,60.843069f, 52.626692f,60.761462f, 52.663027f,60.714553f, 52.764361f,60.711907f, 52.774141f,60.834400f,
                    52.832756f,60.870612f, 52.923242f,61.073321f, 52.978109f,61.008637f, 52.969205f,61.112253f, 53.036184f,61.251028f,
                    52.995954f,61.306843f, 52.992349f,61.390740f, 53.036604f,61.469024f, 53.012116f,61.557147f, 52.954120f,61.632086f,
                    52.996475f,61.699027f, 51.359587f,61.699027f);
            poly[2379] = new TzPolygon(53.125516f,62.056248f, 53.111815f,62.119306f, 53.068002f,62.147365f, 52.990060f,62.130440f, 52.951047f,62.029335f,
                    52.950151f,61.960761f, 53.003303f,61.847847f, 52.998212f,61.701773f, 52.996475f,61.699027f, 53.125516f,61.699027f);
            poly[2380] = new TzPolygon(54.008481f,61.255469f, 54.008190f,61.569137f, 53.967599f,61.570988f, 53.968146f,61.611558f, 54.008481f,61.643546f,
                    54.008481f,61.699027f, 53.247208f,61.699027f, 53.265659f,61.673926f, 53.223223f,61.630476f, 53.215336f,61.527120f,
                    53.273894f,61.400233f, 53.283385f,61.226235f, 53.311756f,61.177036f, 53.405503f,61.155253f, 53.431795f,61.216689f,
                    53.508037f,61.258652f, 53.519130f,61.321894f, 53.467377f,61.366882f, 53.455542f,61.428450f, 53.473018f,61.518639f,
                    53.505012f,61.533343f, 53.496702f,61.567243f, 53.526124f,61.593261f, 53.593052f,61.553065f, 53.602103f,61.391199f,
                    53.558714f,61.349509f, 53.563644f,61.215552f, 53.589943f,61.126446f, 53.615133f,61.121777f, 53.628667f,60.900287f,
                    53.667893f,60.895929f, 53.672921f,60.995576f, 53.650795f,60.998604f, 53.653013f,61.042426f, 53.721317f,61.058477f,
                    53.720933f,61.114672f, 53.795613f,61.227176f, 53.841675f,61.237031f, 53.852565f,61.179246f, 53.904515f,61.136899f,
                    53.906975f,60.993495f, 53.955111f,61.029357f, 53.945385f,61.079792f, 53.970470f,61.080160f, 53.971955f,61.180378f,
                    53.918861f,61.205062f, 53.928574f,61.279867f);
            poly[2381] = new TzPolygon(54.008481f,61.255469f, 54.037814f,61.246513f, 54.073875f,61.293834f, 54.086864f,61.400587f, 54.082765f,61.480565f,
                    54.030110f,61.480629f, 54.008481f,61.567962f);
            poly[2382] = new TzPolygon(54.008481f,61.643546f, 54.029772f,61.660431f, 54.029633f,61.699027f, 54.008481f,61.699027f);
            poly[2383] = new TzPolygon(53.125516f,62.056248f, 53.184637f,61.784151f, 53.247208f,61.699027f, 54.029633f,61.699027f, 54.029539f,61.725170f,
                    53.984574f,61.782040f, 54.031717f,61.845915f, 54.008441f,61.850260f, 54.009083f,61.892970f, 53.963367f,61.856245f,
                    53.949908f,61.932332f, 53.948456f,62.043865f, 54.039853f,62.013290f, 54.050998f,62.075111f, 54.028573f,62.175459f,
                    54.046982f,62.418794f, 54.032625f,62.494006f, 54.003787f,62.396416f, 53.926938f,62.446710f, 53.913531f,62.516607f,
                    53.988208f,62.598043f, 54.046540f,62.568753f, 54.073876f,62.594767f, 54.117710f,62.859021f, 54.104357f,63.081298f,
                    54.126617f,63.155604f, 54.193630f,63.170599f, 54.189284f,63.350667f, 53.125516f,63.350667f);
            poly[2384] = new TzPolygon(47.827727f,64.181147f, 47.899538f,64.277174f, 48.002342f,64.120105f, 48.170279f,64.016075f, 48.347707f,64.282850f,
                    48.461781f,64.227456f, 48.510770f,64.578628f, 48.565542f,64.490825f, 48.599732f,64.530714f, 48.674727f,64.468672f,
                    48.675664f,64.698019f, 48.937745f,64.745805f, 48.828328f,65.486130f, 48.875587f,65.736844f, 48.982181f,65.775396f,
                    48.993151f,66.073090f, 49.241516f,66.412434f, 49.270411f,66.542177f, 49.324355f,66.597181f, 49.456682f,66.651436f,
                    49.458333f,66.653946f, 47.827727f,66.653946f);
            poly[2385] = new TzPolygon(48.617543f,63.350667f, 48.601772f,63.416758f, 48.563764f,63.467314f, 48.453998f,63.770803f, 48.170279f,64.016075f,
                    48.002342f,64.120105f, 47.899538f,64.277174f, 47.827727f,64.181147f, 47.827727f,63.350667f);
            poly[2386] = new TzPolygon(50.630478f,66.653946f, 50.673097f,66.495514f, 50.710653f,66.433136f, 50.685432f,66.315597f, 50.827372f,66.240636f,
                    50.788136f,66.132752f, 50.798198f,66.109553f, 50.871741f,66.087997f, 50.959414f,65.949889f, 50.942554f,65.941717f,
                    50.964380f,65.861935f, 50.854446f,65.789292f, 50.830898f,65.604629f, 50.896374f,65.579356f, 51.082366f,65.632958f,
                    51.203373f,65.426058f, 51.243150f,65.481588f, 51.326762f,65.388010f, 51.359587f,65.455900f, 51.359587f,66.653946f);
            poly[2387] = new TzPolygon(50.630478f,66.653946f, 50.611500f,66.724494f, 50.658193f,66.990896f, 50.622153f,67.110798f, 50.530842f,67.065949f,
                    50.383921f,67.131889f, 50.492327f,67.563984f, 50.485161f,67.782389f, 50.553009f,67.938665f, 50.538090f,68.008922f,
                    50.512691f,67.991344f, 50.464906f,68.092020f, 50.317178f,67.964178f, 50.223160f,67.599341f, 50.162848f,67.575857f,
                    50.118809f,67.638180f, 49.915454f,67.399120f, 49.938177f,67.373752f, 49.647476f,67.041716f, 49.578737f,66.837018f,
                    49.458333f,66.653946f);
            poly[2388] = new TzPolygon(53.125516f,63.350667f, 53.125516f,66.401194f, 53.089514f,66.402139f, 53.110925f,66.200221f, 53.093432f,66.206925f,
                    53.060725f,66.050509f, 52.981590f,66.070705f, 52.969936f,66.321358f, 52.886252f,66.307907f, 52.893548f,66.118381f,
                    52.764401f,66.128680f, 52.760916f,66.018770f, 52.204637f,65.998646f, 52.140868f,65.868951f, 52.082683f,65.868143f,
                    51.872437f,65.760476f, 51.795685f,65.517761f, 51.793489f,65.352417f, 51.684900f,65.383141f, 51.684327f,65.520911f,
                    51.628161f,65.577328f, 51.514049f,65.537165f, 51.440078f,65.461513f, 51.403486f,65.546696f, 51.359587f,65.455900f,
                    51.359587f,63.350667f);
            poly[2389] = new TzPolygon(54.891446f,65.002307f, 54.405124f,65.002307f, 54.424178f,64.974791f, 54.353920f,64.738648f, 54.360753f,64.659042f,
                    54.398464f,64.616461f, 54.362171f,64.568063f, 54.366363f,64.479513f, 54.326465f,64.419411f, 54.317889f,64.071117f,
                    54.283396f,64.028881f, 54.306538f,64.023216f, 54.301230f,63.986824f, 54.230332f,64.021267f, 54.200337f,63.961418f,
                    54.198388f,63.912232f, 54.271861f,63.794041f, 54.188136f,63.398224f, 54.189284f,63.350667f, 54.891446f,63.350667f);
            poly[2390] = new TzPolygon(53.125516f,66.401194f, 53.154863f,66.400424f, 53.193727f,66.257203f, 53.503392f,66.249266f, 53.502714f,66.110903f,
                    53.605879f,66.105321f, 53.670875f,66.173706f, 53.805575f,66.179261f, 53.803239f,66.047507f, 53.932668f,66.025333f,
                    53.927560f,66.002134f, 53.999051f,65.963115f, 54.075231f,66.149825f, 54.102019f,66.317728f, 54.183289f,66.266814f,
                    54.183431f,66.191101f, 54.251457f,66.031682f, 54.293461f,66.176895f, 54.419266f,66.084898f, 54.443875f,66.107025f,
                    54.469639f,66.073832f, 54.489460f,66.109912f, 54.640493f,66.075413f, 54.703724f,66.381721f, 54.731881f,66.653946f,
                    53.125516f,66.653946f);
            poly[2391] = new TzPolygon(54.731881f,66.653946f, 54.703724f,66.381721f, 54.625148f,65.998643f, 54.637817f,65.964186f, 54.717041f,65.981779f,
                    54.697243f,65.845286f, 54.624024f,65.799704f, 54.607419f,65.747290f, 54.655537f,65.489554f, 54.624375f,65.456451f,
                    54.570918f,65.503830f, 54.577404f,65.357903f, 54.541393f,65.214454f, 54.452181f,65.200908f, 54.362419f,65.262715f,
                    54.334286f,65.221956f, 54.334534f,65.104243f, 54.405124f,65.002307f, 54.891446f,65.002307f, 54.891446f,66.653946f);
            poly[2392] = new TzPolygon(54.891446f,67.776503f, 54.885953f,67.773564f, 54.863117f,67.691311f, 54.844377f,67.562833f, 54.873258f,67.332351f,
                    54.862376f,67.289709f, 54.825626f,67.281958f, 54.813036f,67.100678f, 54.777153f,67.043515f, 54.789605f,66.994008f,
                    54.768648f,66.782195f, 54.736852f,66.702005f, 54.731881f,66.653946f, 54.891446f,66.653946f);
            poly[2393] = new TzPolygon(28.246987f,72.036975f, 28.394757f,72.206632f, 28.669710f,72.299310f, 28.769714f,72.390253f, 28.948015f,72.733102f,
                    29.027798f,72.945831f, 29.152997f,73.004395f, 29.236189f,73.084420f, 29.572061f,73.282255f, 29.945934f,73.396990f,
                    30.067969f,73.806629f, 30.198253f,73.972689f, 30.276035f,73.956467f, 30.359762f,73.879834f, 30.443952f,73.973817f,
                    30.438913f,73.926506f, 30.490160f,73.934657f, 30.456434f,73.964184f, 30.503973f,73.982030f, 30.514147f,74.019976f,
                    30.533625f,74.011929f, 30.542547f,74.039257f, 30.522888f,74.072342f, 30.611427f,74.095974f, 30.665125f,74.193386f,
                    30.724428f,74.232434f, 30.735528f,74.286515f, 30.774648f,74.261130f, 30.779350f,74.301835f, 30.846550f,74.320439f,
                    30.860342f,74.382185f, 30.892972f,74.365972f, 30.907757f,74.422835f, 30.940348f,74.416494f, 30.992114f,74.545713f,
                    31.054772f,74.568275f, 31.037620f,74.596986f, 31.073943f,74.696088f, 31.090648f,74.693924f, 31.090648f,74.729730f,
                    28.246987f,74.729730f);
            poly[2394] = new TzPolygon(31.090648f,74.591916f, 31.081357f,74.571292f, 31.090648f,74.566087f);
            poly[2395] = new TzPolygon(31.090648f,74.693924f, 31.127942f,74.689093f, 31.133673f,74.603283f, 31.099045f,74.610558f, 31.090648f,74.591916f,
                    31.090648f,74.566087f, 31.122039f,74.548499f, 31.131963f,74.510407f, 31.303728f,74.542096f, 31.312427f,74.526373f,
                    31.364400f,74.551737f, 31.419934f,74.601255f, 31.425910f,74.654671f, 31.484739f,74.636685f, 31.500907f,74.575360f,
                    31.527255f,74.612857f, 31.569040f,74.615890f, 31.607908f,74.555471f, 31.677625f,74.535112f, 31.720348f,74.488267f,
                    31.757857f,74.559419f, 31.804786f,74.557913f, 31.890079f,74.607393f, 31.884223f,74.636247f, 31.922595f,74.666714f,
                    31.923767f,74.719055f, 31.933184f,74.729730f, 31.090648f,74.729730f);
            poly[2396] = new TzPolygon(32.483127f,74.729730f, 32.487019f,74.687995f, 32.512478f,74.689200f, 32.512478f,74.729730f);
            poly[2397] = new TzPolygon(32.512478f,74.729730f, 32.512478f,74.689200f, 32.534256f,74.690230f, 32.545845f,74.661884f, 32.567981f,74.673099f,
                    32.562999f,74.651617f, 32.614611f,74.638484f, 32.660571f,74.695100f, 32.675604f,74.666235f, 32.729099f,74.654472f,
                    32.841955f,74.705251f, 32.808915f,74.632886f, 32.787459f,74.658637f, 32.776004f,74.632034f, 32.751470f,74.637631f,
                    32.745077f,74.512428f, 32.764409f,74.511169f, 32.793572f,74.448271f, 32.897666f,74.414900f, 32.928537f,74.314522f,
                    32.951928f,74.339315f, 33.030912f,74.324750f, 33.073537f,74.170116f, 33.097683f,74.178770f, 33.159639f,74.129534f,
                    33.221708f,74.004931f, 33.269333f,74.015785f, 33.283568f,74.090486f, 33.337733f,74.166286f, 33.478734f,74.192499f,
                    33.557730f,74.140696f, 33.584784f,74.081175f, 33.578511f,74.031567f, 33.641447f,73.981112f, 33.683923f,73.990379f,
                    33.723475f,73.961417f, 33.744989f,74.004795f, 33.823926f,74.060209f, 33.838940f,74.189476f, 33.892600f,74.276802f,
                    33.934308f,74.281919f, 33.934308f,74.729730f);
            poly[2398] = new TzPolygon(32.483127f,74.729730f, 32.476921f,74.796268f, 32.499531f,74.820029f, 32.493911f,74.877099f, 32.477293f,74.876379f,
                    32.471283f,74.939249f, 32.446474f,74.951644f, 32.464386f,75.015501f, 32.497587f,75.026530f, 32.477465f,75.101695f,
                    32.408831f,75.132912f, 32.426150f,75.191773f, 32.401005f,75.192820f, 32.389402f,75.256942f, 32.343697f,75.322001f,
                    32.320583f,75.337513f, 32.297245f,75.320802f, 32.268787f,75.381478f, 32.224628f,75.371586f, 32.208041f,75.316220f,
                    32.179328f,75.322313f, 32.091030f,75.240269f, 32.120223f,75.203406f, 32.067671f,75.174272f, 32.081467f,75.122915f,
                    32.058680f,75.104883f, 32.067176f,75.068710f, 32.035679f,75.012411f, 32.065647f,74.933636f, 32.053751f,74.879427f,
                    31.958708f,74.819006f, 31.955822f,74.755394f, 31.933184f,74.729730f);
            poly[2399] = new TzPolygon(32.512478f,78.415074f, 32.512478f,78.771058f, 32.479016f,78.779367f, 32.412710f,78.838598f, 32.400518f,78.892347f,
                    32.372638f,78.925031f, 31.332834f,78.925031f, 31.289732f,78.899509f, 31.315300f,78.861582f, 31.294407f,78.853411f,
                    31.310160f,78.780790f, 31.367787f,78.749516f, 31.444074f,78.796741f, 31.482878f,78.757541f, 31.483803f,78.725838f,
                    31.508142f,78.720290f, 31.609164f,78.846641f, 31.647571f,78.801893f, 31.681553f,78.798756f, 31.680167f,78.751134f,
                    31.806491f,78.702103f, 31.832561f,78.735384f, 31.873388f,78.748996f, 31.883990f,78.731703f, 31.928575f,78.769378f,
                    31.993574f,78.778865f, 32.004954f,78.734384f, 32.113632f,78.682828f, 32.125593f,78.630683f, 32.167153f,78.591592f,
                    32.197991f,78.595748f, 32.202245f,78.559918f, 32.275637f,78.488363f, 32.303065f,78.510376f, 32.386462f,78.454345f,
                    32.443427f,78.472428f);
        }
    }

    private static class Initializer25 {
        private static void init() {
            poly[2400] = new TzPolygon(32.512478f,78.415074f, 32.539242f,78.392843f, 32.569340f,78.420012f, 32.583603f,78.500948f, 32.617925f,78.525034f,
                    32.606316f,78.635070f, 32.648192f,78.635008f, 32.695747f,78.739516f, 32.655287f,78.742145f, 32.616313f,78.781360f,
                    32.567181f,78.757475f, 32.512478f,78.771058f);
            poly[2401] = new TzPolygon(33.383604f,78.925031f, 33.410458f,78.902208f, 33.426623f,78.835929f, 33.482999f,78.814167f, 33.565500f,78.734035f,
                    33.623437f,78.758063f, 33.622745f,78.717737f, 33.667140f,78.678299f, 33.744530f,78.776601f, 33.784256f,78.754213f,
                    33.912311f,78.763423f, 33.923811f,78.727934f, 33.934308f,78.729917f, 33.934308f,78.925031f);
            poly[2402] = new TzPolygon(35.356138f,70.534430f, 35.356138f,71.582998f, 35.309940f,71.543250f, 35.204620f,71.680440f, 35.138990f,71.624950f,
                    35.138400f,71.589080f, 35.091190f,71.532220f, 35.033370f,71.558600f, 35.005840f,71.505603f, 34.975075f,71.512135f,
                    34.914000f,71.349550f, 34.877488f,71.296167f, 34.818540f,71.289000f, 34.752700f,71.225930f, 34.702460f,71.107340f,
                    34.673410f,71.088850f, 34.628530f,71.117280f, 34.534109f,71.011087f, 34.450507f,71.024112f, 34.424375f,71.058541f,
                    34.433640f,71.107460f, 34.375210f,71.117450f, 34.363330f,71.176100f, 34.240820f,71.118910f, 34.227907f,71.138412f,
                    34.164590f,71.130210f, 34.109290f,71.070850f, 34.063420f,71.082510f, 34.011120f,70.914110f, 33.994560f,70.919460f,
                    33.971350f,70.872310f, 33.962370f,70.583960f, 33.949708f,70.534430f);
            poly[2403] = new TzPolygon(36.747316f,71.583255f, 36.763797f,71.563095f, 36.777969f,71.556919f, 36.777969f,71.583255f);
            poly[2404] = new TzPolygon(35.589196f,71.583255f, 35.629720f,71.499470f, 35.659250f,71.506520f, 35.672620f,71.540640f, 35.726826f,71.551035f,
                    35.749640f,71.493760f, 35.785900f,71.483180f, 35.801010f,71.503440f, 35.887990f,71.431110f, 35.904880f,71.380210f,
                    35.952950f,71.387140f, 35.959686f,71.319065f, 35.982446f,71.313451f, 36.039614f,71.195027f, 36.087528f,71.217370f,
                    36.100947f,71.253279f, 36.130039f,71.251165f, 36.232705f,71.436109f, 36.269098f,71.444890f, 36.310075f,71.521319f,
                    36.333797f,71.523422f, 36.327481f,71.576562f, 36.338912f,71.583255f);
            poly[2405] = new TzPolygon(36.351801f,71.583255f, 36.372691f,71.558005f, 36.386014f,71.583255f);
            poly[2406] = new TzPolygon(36.747316f,71.583255f, 36.777969f,71.583255f, 36.777969f,71.974258f, 36.680617f,71.843638f, 36.671115f,71.676464f);
            poly[2407] = new TzPolygon(35.356437f,71.583255f, 35.442510f,71.657310f, 35.499930f,71.594050f, 35.571230f,71.620400f, 35.589196f,71.583255f,
                    36.338912f,71.583255f, 36.347595f,71.588339f, 36.351801f,71.583255f, 36.386014f,71.583255f, 36.403248f,71.615919f,
                    36.477014f,71.637320f, 36.483566f,71.656951f, 36.399270f,71.806630f, 36.433359f,71.828969f, 36.474515f,71.798732f,
                    36.507759f,71.809566f, 36.508742f,71.916561f, 36.546371f,71.935848f, 36.556693f,72.001941f, 36.591971f,72.030426f,
                    36.588545f,72.081972f, 36.647102f,72.096512f, 36.660255f,72.207618f, 36.711408f,72.184745f, 36.752436f,72.246562f,
                    36.740023f,72.298276f, 36.766706f,72.335443f, 36.777969f,72.484067f, 36.777969f,72.632080f, 35.356138f,72.632080f,
                    35.356138f,71.583255f);
            poly[2408] = new TzPolygon(33.934308f,74.281919f, 34.023636f,74.233496f, 34.016773f,74.197250f, 34.046957f,74.132690f, 34.039614f,74.016111f,
                    34.011967f,73.985962f, 34.023827f,73.925240f, 34.059783f,73.896028f, 34.104851f,73.904551f, 34.103312f,73.926628f,
                    34.172485f,73.962399f, 34.195243f,74.014345f, 34.270513f,73.990530f, 34.283213f,73.935504f, 34.311428f,73.942528f,
                    34.305618f,73.919064f, 34.336531f,73.939008f, 34.351212f,73.915497f, 34.321368f,73.853851f, 34.346724f,73.814938f,
                    34.344077f,73.750034f, 34.427070f,73.804728f, 34.452866f,73.887831f, 34.527936f,73.905029f, 34.566347f,73.956574f,
                    34.607507f,73.928200f, 34.670932f,73.953138f, 34.687246f,73.971157f, 34.679985f,74.106637f, 34.658609f,74.146590f,
                    34.688635f,74.157774f, 34.782504f,74.309727f, 34.782321f,74.448481f, 34.761681f,74.580220f, 34.705942f,74.650843f,
                    34.681454f,74.729730f, 33.934308f,74.729730f);
            poly[2409] = new TzPolygon(36.777969f,71.556919f, 37.071606f,71.428954f, 37.214108f,71.455424f, 37.313427f,71.506600f, 37.387917f,71.474870f,
                    37.479880f,71.526722f, 37.533435f,71.495282f, 37.606966f,71.504356f, 37.714067f,71.549172f, 37.765526f,71.531139f,
                    37.805079f,71.595603f, 37.923385f,71.590972f, 37.952386f,71.502740f, 37.885428f,71.329321f, 37.931964f,71.298760f,
                    37.923728f,71.256112f, 38.042052f,71.284086f, 38.161269f,71.377103f, 38.199799f,71.375994f, 38.199799f,72.632080f,
                    37.026177f,72.632080f, 37.029001f,72.621953f, 37.007625f,72.588471f, 37.006278f,72.427446f, 36.981302f,72.325706f,
                    36.810933f,72.018488f, 36.777969f,71.974258f);
            poly[2410] = new TzPolygon(36.777969f,72.484067f, 36.779285f,72.501440f, 36.828235f,72.558650f, 36.846764f,72.632080f, 36.777969f,72.632080f);
            poly[2411] = new TzPolygon(39.458583f,71.583255f, 39.460318f,71.560006f, 39.518101f,71.543495f, 39.575891f,71.565199f, 39.611573f,71.514387f,
                    39.571028f,71.412849f, 39.568748f,71.335625f, 39.518119f,71.295503f, 39.552026f,71.253204f, 39.511295f,71.193375f,
                    39.506459f,71.099456f, 39.425397f,71.072241f, 39.396255f,71.030339f, 39.390947f,71.002945f, 39.434589f,70.951005f,
                    39.383301f,70.912414f, 39.389473f,70.788445f, 39.486250f,70.752556f, 39.519903f,70.692699f, 39.582207f,70.650130f,
                    39.594578f,70.565443f, 39.621629f,70.534430f, 39.621629f,71.583255f);
            poly[2412] = new TzPolygon(38.208711f,70.534430f, 38.243560f,70.545571f, 38.282772f,70.605604f, 38.346399f,70.610955f, 38.372212f,70.693542f,
                    38.409144f,70.678451f, 38.419038f,70.740752f, 38.456290f,70.771029f, 38.438590f,70.850962f, 38.469181f,70.873286f,
                    38.430076f,70.924720f, 38.440598f,70.958365f, 38.476237f,70.945694f, 38.491068f,70.988352f, 38.461074f,71.031472f,
                    38.398325f,71.057006f, 38.422277f,71.105018f, 38.386594f,71.164926f, 38.343936f,71.186811f, 38.310540f,71.251895f,
                    38.304773f,71.332383f, 38.271265f,71.333789f, 38.255618f,71.374387f, 38.199799f,71.375994f, 38.199799f,70.534430f);
            poly[2413] = new TzPolygon(39.458583f,71.583255f, 39.443414f,71.786470f, 39.380845f,71.800293f, 39.323960f,71.752670f, 39.278053f,71.790627f,
                    39.277283f,71.911111f, 39.331271f,71.957986f, 39.366491f,72.035629f, 39.278054f,72.088766f, 39.269504f,72.173944f,
                    39.172738f,72.237076f, 39.189482f,72.271141f, 39.311224f,72.316255f, 39.350190f,72.462457f, 39.380075f,72.492858f,
                    39.380858f,72.544252f, 39.351633f,72.566538f, 39.399156f,72.621160f, 39.398640f,72.632080f, 38.199799f,72.632080f,
                    38.199799f,71.583255f);
            poly[2414] = new TzPolygon(38.199799f,73.680905f, 37.435489f,73.680905f, 37.433525f,73.640403f, 37.474530f,73.512472f, 37.444045f,73.371966f,
                    37.461950f,73.364273f, 37.463611f,73.306647f, 37.404100f,73.209761f, 37.404312f,73.149558f, 37.324816f,73.094176f,
                    37.290671f,72.952286f, 37.230897f,72.864570f, 37.231168f,72.815261f, 37.017687f,72.662520f, 37.026177f,72.632080f,
                    38.199799f,72.632080f);
            poly[2415] = new TzPolygon(37.250885f,73.680905f, 37.237218f,73.652347f, 37.270519f,73.617237f, 37.283675f,73.650253f, 37.314830f,73.656715f,
                    37.310945f,73.680905f);
            poly[2416] = new TzPolygon(36.846764f,72.632080f, 36.851927f,72.652539f, 36.839223f,72.891258f, 36.842962f,72.930033f, 36.875908f,72.954144f,
                    36.859129f,73.039415f, 36.885576f,73.068614f, 36.894753f,73.147681f, 36.878128f,73.185313f, 36.892841f,73.269264f,
                    36.868587f,73.303555f, 36.889988f,73.332196f, 36.897416f,73.479741f, 36.872587f,73.541951f, 36.908690f,73.601023f,
                    36.914959f,73.680905f, 36.777969f,73.680905f, 36.777969f,72.632080f);
            poly[2417] = new TzPolygon(37.310945f,73.680905f, 37.307079f,73.704981f, 37.339585f,73.774298f, 37.440094f,73.775893f, 37.435489f,73.680905f,
                    37.488884f,73.680905f, 37.488884f,74.205318f, 37.341723f,74.205318f, 37.335834f,74.196970f, 37.326298f,74.065909f,
                    37.291695f,74.016606f, 37.276698f,73.890085f, 37.226801f,73.829199f, 37.238867f,73.781927f, 37.221883f,73.759084f,
                    37.253980f,73.687373f, 37.250885f,73.680905f);
            poly[2418] = new TzPolygon(36.914959f,73.680905f, 36.915797f,73.691580f, 36.890824f,73.815059f, 36.925977f,73.843619f, 36.912967f,73.890620f,
                    36.878157f,73.892667f, 36.874740f,73.932234f, 36.842518f,73.957430f, 36.826253f,74.047120f, 36.838220f,74.120790f,
                    36.916518f,74.175927f, 36.906505f,74.205318f, 36.777969f,74.205318f, 36.777969f,73.680905f);
            poly[2419] = new TzPolygon(36.906505f,74.205318f, 36.894784f,74.239721f, 36.918906f,74.309291f, 36.961087f,74.347112f, 36.975017f,74.415585f,
                    37.011150f,74.426558f, 36.957221f,74.534055f, 37.017367f,74.518930f, 37.084107f,74.690685f, 37.033854f,74.729730f,
                    36.777969f,74.729730f, 36.777969f,74.205318f);
            poly[2420] = new TzPolygon(37.133426f,74.468837f, 37.133426f,74.729730f, 37.035827f,74.729730f, 37.083977f,74.697526f, 37.029585f,74.571764f,
                    37.049459f,74.533256f, 37.080250f,74.526552f, 37.065266f,74.494924f, 37.116852f,74.491387f);
            poly[2421] = new TzPolygon(37.133426f,74.468837f, 37.133426f,74.729730f, 37.035827f,74.729730f, 37.083977f,74.697526f, 37.029585f,74.571764f,
                    37.049459f,74.533256f, 37.080250f,74.526552f, 37.065266f,74.494924f, 37.116852f,74.491387f);
            poly[2422] = new TzPolygon(37.385872f,74.729730f, 37.405888f,74.690305f, 37.376800f,74.637872f, 37.372457f,74.566228f, 37.399208f,74.555007f,
                    37.396183f,74.495199f, 37.426723f,74.466075f, 37.406920f,74.467830f, 37.416367f,74.439455f, 37.389223f,74.418099f,
                    37.424374f,74.375209f, 37.399116f,74.315990f, 37.415385f,74.242281f, 37.395279f,74.229479f, 37.374512f,74.251798f,
                    37.341723f,74.205318f, 37.488884f,74.205318f, 37.488884f,74.729730f);
            poly[2423] = new TzPolygon(37.133426f,74.468837f, 37.142880f,74.455974f, 37.166276f,74.486696f, 37.196612f,74.468474f, 37.239352f,74.501097f,
                    37.235597f,74.582065f, 37.264557f,74.630446f, 37.234413f,74.658309f, 37.279052f,74.729730f, 37.133426f,74.729730f);
            poly[2424] = new TzPolygon(37.133426f,74.468837f, 37.142880f,74.455974f, 37.166276f,74.486696f, 37.196612f,74.468474f, 37.239352f,74.501097f,
                    37.235597f,74.582065f, 37.264557f,74.630446f, 37.234413f,74.658309f, 37.279052f,74.729730f, 37.133426f,74.729730f);
            poly[2425] = new TzPolygon(39.621629f,73.680905f, 39.465790f,73.680905f, 39.455523f,73.567063f, 39.470895f,73.476386f, 39.434966f,73.357105f,
                    39.393343f,73.353206f, 39.383493f,73.258935f, 39.353209f,73.200707f, 39.376400f,73.106516f, 39.346646f,72.958869f,
                    39.371810f,72.932333f, 39.346984f,72.879179f, 39.364314f,72.824207f, 39.345654f,72.782665f, 39.395560f,72.697323f,
                    39.398640f,72.632080f, 39.621629f,72.632080f);
            poly[2426] = new TzPolygon(39.165735f,73.680905f, 39.228297f,73.634577f, 39.247642f,73.613548f, 39.243868f,73.569070f, 39.277796f,73.537943f,
                    39.296679f,73.556123f, 39.310925f,73.527546f, 39.350046f,73.564255f, 39.381740f,73.499735f, 39.411356f,73.592181f,
                    39.455975f,73.596836f, 39.473945f,73.637184f, 39.467499f,73.680905f);
            poly[2427] = new TzPolygon(39.165735f,73.680905f, 39.228297f,73.634577f, 39.247642f,73.613548f, 39.243868f,73.569070f, 39.277796f,73.537943f,
                    39.296679f,73.556123f, 39.310925f,73.527546f, 39.350046f,73.564255f, 39.381740f,73.499735f, 39.411356f,73.592181f,
                    39.455975f,73.596836f, 39.473945f,73.637184f, 39.467499f,73.680905f);
            poly[2428] = new TzPolygon(38.219396f,74.729730f, 38.228164f,74.697939f, 38.294531f,74.704511f, 38.380596f,74.665531f, 38.425102f,74.695418f,
                    38.471504f,74.506685f, 38.640280f,74.186889f, 38.641644f,74.121320f, 38.610441f,74.115428f, 38.610793f,74.074638f,
                    38.578373f,74.062119f, 38.536643f,74.086194f, 38.542742f,74.028093f, 38.521877f,73.998241f, 38.613843f,73.801471f,
                    38.663918f,73.805162f, 38.731808f,73.743852f, 38.778211f,73.767816f, 38.843806f,73.729812f, 38.852890f,73.694557f,
                    38.910714f,73.734121f, 38.910714f,74.729730f);
            poly[2429] = new TzPolygon(38.219396f,74.729730f, 38.228164f,74.697939f, 38.294531f,74.704511f, 38.380596f,74.665531f, 38.425102f,74.695418f,
                    38.471504f,74.506685f, 38.640280f,74.186889f, 38.641644f,74.121320f, 38.610441f,74.115428f, 38.610793f,74.074638f,
                    38.578373f,74.062119f, 38.536643f,74.086194f, 38.542742f,74.028093f, 38.521877f,73.998241f, 38.613843f,73.801471f,
                    38.663918f,73.805162f, 38.731808f,73.743852f, 38.778211f,73.767816f, 38.843806f,73.729812f, 38.852890f,73.694557f,
                    38.910714f,73.734121f, 38.910714f,74.729730f);
            poly[2430] = new TzPolygon(39.621629f,73.948811f, 39.542963f,73.878107f, 39.483241f,73.874395f, 39.465790f,73.680905f, 39.621629f,73.680905f);
            poly[2431] = new TzPolygon(39.165735f,73.680905f, 39.111942f,73.720740f, 39.075916f,73.710468f, 39.031154f,73.742535f, 39.042821f,73.812424f,
                    38.999638f,73.844173f, 38.921522f,73.835407f, 38.941908f,73.755465f, 38.910714f,73.734121f, 38.910714f,73.680905f);
            poly[2432] = new TzPolygon(38.910714f,74.729730f, 38.910714f,73.734121f, 38.941908f,73.755465f, 38.921522f,73.835407f, 38.999638f,73.844173f,
                    39.042821f,73.812424f, 39.036535f,73.736756f, 39.075916f,73.710468f, 39.111942f,73.720740f, 39.165735f,73.680905f,
                    39.467499f,73.680905f, 39.460903f,73.725644f, 39.483241f,73.874395f, 39.542963f,73.878107f, 39.621629f,73.948811f,
                    39.621629f,74.729730f);
            poly[2433] = new TzPolygon(34.681454f,74.729730f, 34.672761f,74.935837f, 34.628988f,75.025176f, 34.654966f,75.086780f, 34.638313f,75.266223f,
                    34.600954f,75.248544f, 34.537929f,75.365101f, 34.536575f,75.656715f, 34.513668f,75.785099f, 34.632370f,75.950518f,
                    34.639246f,75.993060f, 34.685650f,76.033581f, 34.632683f,76.163291f, 34.673187f,76.252612f, 34.717171f,76.257520f,
                    34.737645f,76.419385f, 34.796098f,76.486585f, 34.746644f,76.597098f, 34.764281f,76.633757f, 34.733741f,76.642507f,
                    34.745703f,76.688577f, 34.795780f,76.701725f, 34.805465f,76.736446f, 34.888351f,76.745396f, 34.953075f,76.790940f,
                    34.943841f,76.827381f, 33.934308f,76.827381f, 33.934308f,74.729730f);
            poly[2434] = new TzPolygon(36.719669f,75.778556f, 36.751179f,75.724104f, 36.770324f,75.640323f, 36.771441f,75.533905f, 36.721379f,75.532454f,
                    36.739151f,75.499264f, 36.722443f,75.454624f, 36.773371f,75.419598f, 36.777969f,75.419720f, 36.777969f,75.778556f);
            poly[2435] = new TzPolygon(36.719669f,75.778556f, 36.751179f,75.724104f, 36.770324f,75.640323f, 36.771441f,75.533905f, 36.721379f,75.532454f,
                    36.739151f,75.499264f, 36.722443f,75.454624f, 36.773371f,75.419598f, 36.777969f,75.419720f, 36.777969f,75.778556f);
            poly[2436] = new TzPolygon(35.445959f,76.827381f, 35.516936f,76.796544f, 35.538709f,76.747843f, 35.582935f,76.794149f, 35.629627f,76.755139f,
                    35.661939f,76.782683f, 35.671056f,76.827381f);
            poly[2437] = new TzPolygon(36.067053f,75.946129f, 36.067053f,76.827381f, 35.672074f,76.827381f, 35.662334f,76.759972f, 35.751637f,76.686956f,
                    35.775550f,76.586496f, 35.822520f,76.561059f, 35.900167f,76.598974f, 35.927243f,76.555835f, 35.881546f,76.512628f,
                    35.890844f,76.468583f, 35.852521f,76.427028f, 35.863568f,76.366433f, 35.828165f,76.359378f, 35.842344f,76.224581f,
                    35.822729f,76.164885f, 35.849690f,76.141044f, 35.917140f,76.159421f, 36.016186f,76.100938f, 36.018989f,75.998931f);
            poly[2438] = new TzPolygon(36.067053f,75.946129f, 36.067053f,76.827381f, 35.672074f,76.827381f, 35.662334f,76.759972f, 35.751637f,76.686956f,
                    35.775550f,76.586496f, 35.822520f,76.561059f, 35.900167f,76.598974f, 35.927243f,76.555835f, 35.881546f,76.512628f,
                    35.890844f,76.468583f, 35.852521f,76.427028f, 35.863568f,76.366433f, 35.828165f,76.359378f, 35.842344f,76.224581f,
                    35.822729f,76.164885f, 35.849690f,76.141044f, 35.917140f,76.159421f, 36.016186f,76.100938f, 36.018989f,75.998931f);
            poly[2439] = new TzPolygon(36.719669f,75.778556f, 36.669735f,75.864847f, 36.602919f,75.945096f, 36.564659f,75.925969f, 36.464363f,76.012057f,
                    36.409106f,76.035408f, 36.341644f,75.985215f, 36.227331f,76.061984f, 36.233893f,76.006339f, 36.172491f,76.013761f,
                    36.135626f,75.932635f, 36.067053f,75.951218f, 36.067053f,75.778556f);
            poly[2440] = new TzPolygon(36.067053f,75.946129f, 36.070845f,75.941964f, 36.135626f,75.932635f, 36.172491f,76.013761f, 36.233893f,76.006339f,
                    36.227331f,76.061984f, 36.341644f,75.985215f, 36.409106f,76.035408f, 36.464363f,76.012057f, 36.564659f,75.925969f,
                    36.602919f,75.945096f, 36.669735f,75.864847f, 36.719669f,75.778556f, 36.777969f,75.778556f, 36.777969f,76.827381f,
                    36.067053f,76.827381f);
            poly[2441] = new TzPolygon(35.356138f,76.827381f, 35.356138f,76.986896f, 35.316359f,76.984410f, 35.295452f,77.021868f, 35.260360f,76.977320f,
                    35.232490f,77.004331f, 35.210635f,76.990624f, 35.182993f,77.017472f, 35.167832f,77.087005f, 35.123796f,77.070455f,
                    35.065026f,77.120391f, 35.005919f,76.934844f, 34.925970f,76.897901f, 34.943841f,76.827381f);
            poly[2442] = new TzPolygon(33.934308f,78.925031f, 33.934308f,78.729917f, 34.000014f,78.742330f, 34.031830f,78.656517f, 34.084579f,78.661189f,
                    34.089531f,78.744259f, 34.137846f,78.794686f, 34.127497f,78.833673f, 34.165624f,78.862088f, 34.141595f,78.907604f,
                    34.183478f,78.925031f);
            poly[2443] = new TzPolygon(34.645223f,78.273656f, 34.645223f,78.925031f, 34.383080f,78.925031f, 34.381012f,78.902127f, 34.439790f,78.764039f,
                    34.456534f,78.738466f, 34.481222f,78.761982f, 34.525883f,78.709706f, 34.550494f,78.646194f, 34.504386f,78.579909f,
                    34.511791f,78.559466f, 34.571544f,78.551916f, 34.584148f,78.498229f, 34.541933f,78.435485f, 34.594773f,78.421926f,
                    34.629770f,78.272983f);
            poly[2444] = new TzPolygon(34.645223f,78.273656f, 34.645223f,78.925031f, 34.383080f,78.925031f, 34.381012f,78.902127f, 34.439790f,78.764039f,
                    34.456534f,78.738466f, 34.481899f,78.761409f, 34.550494f,78.646194f, 34.504386f,78.579909f, 34.511791f,78.559466f,
                    34.571544f,78.551916f, 34.584148f,78.498229f, 34.541933f,78.435485f, 34.594773f,78.421926f, 34.629770f,78.272983f);
            poly[2445] = new TzPolygon(34.645223f,78.273656f, 34.696039f,78.275867f, 34.735445f,78.202215f, 34.869788f,78.237217f, 34.937333f,78.173688f,
                    34.973084f,78.201476f, 35.031824f,78.114509f, 35.070509f,78.146352f, 35.099708f,78.131706f, 35.092384f,78.076400f,
                    35.114011f,78.049278f, 35.175141f,78.056359f, 35.239409f,78.003213f, 35.356138f,78.013615f, 35.356138f,78.925031f,
                    34.645223f,78.925031f);
            poly[2446] = new TzPolygon(34.645223f,78.273656f, 34.696039f,78.275867f, 34.735445f,78.202215f, 34.869788f,78.237217f, 34.937333f,78.173688f,
                    34.973084f,78.201476f, 35.031824f,78.114509f, 35.070509f,78.146352f, 35.099708f,78.131706f, 35.092384f,78.076400f,
                    35.114011f,78.049278f, 35.175141f,78.056359f, 35.239409f,78.003213f, 35.356138f,78.013615f, 35.356138f,78.925031f,
                    34.645223f,78.925031f);
            poly[2447] = new TzPolygon(35.445959f,76.827381f, 35.399567f,76.847536f, 35.396853f,76.940010f, 35.356138f,76.986896f, 35.356138f,76.827381f);
            poly[2448] = new TzPolygon(35.483595f,77.876206f, 35.523233f,77.812064f, 35.451791f,77.690592f, 35.486776f,77.652124f, 35.462302f,77.629533f,
                    35.488714f,77.534592f, 35.461831f,77.442315f, 35.470392f,77.392063f, 35.545595f,77.302601f, 35.521841f,77.194011f,
                    35.601976f,77.057034f, 35.594838f,76.967329f, 35.619108f,76.899752f, 35.674546f,76.844488f, 35.672074f,76.827381f,
                    36.777969f,76.827381f, 36.777969f,77.876206f);
            poly[2449] = new TzPolygon(35.483595f,77.876206f, 35.523233f,77.812064f, 35.451791f,77.690592f, 35.486776f,77.652124f, 35.462302f,77.629533f,
                    35.488714f,77.534592f, 35.461831f,77.442315f, 35.470392f,77.392063f, 35.545595f,77.302601f, 35.521841f,77.194011f,
                    35.601976f,77.057034f, 35.594838f,76.967329f, 35.619108f,76.899752f, 35.674546f,76.844488f, 35.672074f,76.827381f,
                    36.777969f,76.827381f, 36.777969f,77.876206f);
            poly[2450] = new TzPolygon(35.483595f,77.876206f, 35.462099f,77.910990f, 35.497211f,77.924097f, 35.478626f,77.947678f, 35.494262f,78.000640f,
                    35.468260f,78.024969f, 35.490578f,78.046374f, 35.493312f,78.135881f, 35.430330f,78.100959f, 35.363366f,78.014259f,
                    35.356138f,78.013615f, 35.356138f,77.876206f);
            poly[2451] = new TzPolygon(35.356138f,78.013615f, 35.363366f,78.014259f, 35.430330f,78.100959f, 35.493312f,78.135881f, 35.490578f,78.046374f,
                    35.468260f,78.024969f, 35.494262f,78.000640f, 35.478626f,77.947678f, 35.497211f,77.924097f, 35.462099f,77.910990f,
                    35.483595f,77.876206f, 36.777969f,77.876206f, 36.777969f,78.925031f, 35.356138f,78.925031f);
            poly[2452] = new TzPolygon(37.133426f,74.729730f, 37.133426f,75.254143f, 36.964709f,75.254143f, 36.959055f,75.233421f, 36.990136f,75.159413f,
                    37.009677f,75.168135f, 37.026747f,75.140645f, 37.006778f,75.114566f, 37.016240f,75.029246f, 36.978512f,74.916970f,
                    36.946348f,74.932433f, 36.929445f,74.908277f, 37.017538f,74.839898f, 37.058568f,74.839072f, 37.021655f,74.739209f,
                    37.035827f,74.729730f);
            poly[2453] = new TzPolygon(37.133426f,74.729730f, 37.133426f,75.254143f, 36.964709f,75.254143f, 36.959055f,75.233421f, 36.990136f,75.159413f,
                    37.009677f,75.168135f, 37.026747f,75.140645f, 37.006778f,75.114566f, 37.016240f,75.029246f, 36.978512f,74.916970f,
                    36.946348f,74.932433f, 36.929445f,74.908277f, 37.017538f,74.839898f, 37.058568f,74.839072f, 37.021655f,74.739209f,
                    37.035827f,74.729730f);
            poly[2454] = new TzPolygon(37.488884f,74.729730f, 37.488884f,75.090935f, 37.409564f,75.153956f, 37.371445f,75.094042f, 37.315712f,75.125139f,
                    37.284078f,74.926784f, 37.233280f,74.906749f, 37.333891f,74.832116f, 37.385872f,74.729730f);
            poly[2455] = new TzPolygon(37.388202f,74.729730f, 37.355417f,74.803800f, 37.234090f,74.889862f, 37.214743f,74.809106f, 37.286128f,74.741052f,
                    37.279052f,74.729730f);
            poly[2456] = new TzPolygon(37.279052f,74.729730f, 37.286128f,74.741052f, 37.214743f,74.809106f, 37.220997f,74.882519f, 37.237344f,74.915359f,
                    37.284078f,74.926784f, 37.320756f,75.128178f, 37.371445f,75.094042f, 37.409564f,75.153956f, 37.466028f,75.125284f,
                    37.488884f,75.100901f, 37.488884f,75.254143f, 37.133426f,75.254143f, 37.133426f,74.729730f);
            poly[2457] = new TzPolygon(36.964709f,75.254143f, 36.974483f,75.289962f, 36.955057f,75.399524f, 36.903406f,75.385606f, 36.886364f,75.422586f,
                    36.777969f,75.419720f, 36.777969f,75.254143f);
            poly[2458] = new TzPolygon(36.777969f,75.419720f, 36.886364f,75.422586f, 36.903406f,75.385606f, 36.955057f,75.399524f, 36.974483f,75.289962f,
                    36.964709f,75.254143f, 37.488884f,75.254143f, 37.488884f,75.778556f, 36.777969f,75.778556f);
            poly[2459] = new TzPolygon(37.488884f,75.100901f, 37.525479f,75.061859f, 37.500971f,75.031283f, 37.554090f,74.943988f, 37.661836f,74.897022f,
                    37.775484f,75.010669f, 37.851162f,74.914597f, 37.894579f,74.937966f, 37.907079f,74.912930f, 38.024583f,74.916475f,
                    38.025716f,74.868341f, 38.069062f,74.854197f, 38.085290f,74.820280f, 38.198829f,74.804308f, 38.199799f,74.800792f,
                    38.199799f,75.778556f, 37.488884f,75.778556f);
            poly[2460] = new TzPolygon(37.488884f,75.100901f, 37.525479f,75.061859f, 37.500971f,75.031283f, 37.554090f,74.943988f, 37.661836f,74.897022f,
                    37.775484f,75.010669f, 37.851162f,74.914597f, 37.894579f,74.937966f, 37.907079f,74.912930f, 38.024583f,74.916475f,
                    38.025716f,74.868341f, 38.069062f,74.854197f, 38.085290f,74.820280f, 38.198829f,74.804308f, 38.199799f,74.800792f,
                    38.199799f,75.778556f, 37.488884f,75.778556f);
            poly[2461] = new TzPolygon(36.777969f,75.778556f, 38.199799f,75.778556f, 38.199799f,76.827381f, 36.777969f,76.827381f);
            poly[2462] = new TzPolygon(38.219396f,74.729730f, 38.199799f,74.800792f, 38.199799f,74.729730f);
            poly[2463] = new TzPolygon(38.199799f,74.800792f, 38.219396f,74.729730f, 39.621629f,74.729730f, 39.621629f,76.827381f, 38.199799f,76.827381f);
            poly[2464] = new TzPolygon(36.777969f,76.827381f, 39.621629f,76.827381f, 39.621629f,78.925031f, 36.777969f,78.925031f);
            poly[2465] = new TzPolygon(39.621629f,73.948811f, 39.726364f,73.919835f, 39.755180f,73.837881f, 39.781619f,73.832208f, 39.835949f,73.849052f,
                    39.873835f,73.912909f, 39.920640f,73.907230f, 40.004808f,73.976987f, 40.032744f,73.937339f, 40.044959f,73.997165f,
                    40.080209f,74.025729f, 39.621629f,74.025729f);
            poly[2466] = new TzPolygon(39.621629f,73.948811f, 39.726364f,73.919835f, 39.755180f,73.837881f, 39.781619f,73.832208f, 39.835949f,73.849052f,
                    39.873835f,73.912909f, 39.920640f,73.907230f, 40.004808f,73.976987f, 40.032744f,73.937339f, 40.044959f,73.997165f,
                    40.080209f,74.025729f, 39.621629f,74.025729f);
            poly[2467] = new TzPolygon(40.080209f,74.025729f, 40.099476f,74.041342f, 40.077545f,74.068636f, 40.111241f,74.123112f, 40.133589f,74.257201f,
                    40.104333f,74.278614f, 40.103243f,74.368966f, 40.208962f,74.525516f, 40.282217f,74.590495f, 40.272882f,74.660519f,
                    40.289406f,74.684728f, 40.349852f,74.691697f, 40.353745f,74.789787f, 40.323765f,74.861761f, 40.337733f,74.901445f,
                    40.452232f,74.787602f, 40.521940f,74.837762f, 40.487230f,74.911723f, 39.621629f,74.911723f, 39.621629f,74.025729f);
            poly[2468] = new TzPolygon(40.080209f,74.025729f, 40.099476f,74.041342f, 40.077545f,74.068636f, 40.111241f,74.123112f, 40.133589f,74.257201f,
                    40.104333f,74.278614f, 40.103243f,74.368966f, 40.208962f,74.525516f, 40.282217f,74.590495f, 40.272882f,74.660519f,
                    40.289406f,74.684728f, 40.349852f,74.691697f, 40.353745f,74.789787f, 40.323765f,74.861761f, 40.337733f,74.901445f,
                    40.452232f,74.787602f, 40.521940f,74.837762f, 40.487230f,74.911723f, 39.621629f,74.911723f, 39.621629f,74.025729f);
            poly[2469] = new TzPolygon(42.753622f,73.139736f, 42.753622f,73.485103f, 42.731430f,73.465460f, 42.548898f,73.432917f, 42.444589f,73.519002f,
                    42.417590f,73.487165f, 42.444516f,73.329298f, 42.517922f,73.309704f, 42.548409f,73.139736f);
            poly[2470] = new TzPolygon(40.487230f,74.911723f, 40.451846f,74.987120f, 40.466612f,75.017956f, 40.434899f,75.090097f, 40.461399f,75.140946f,
                    40.444674f,75.222834f, 40.532029f,75.327898f, 40.555371f,75.414740f, 40.618831f,75.487310f, 40.663256f,75.602762f,
                    40.505645f,75.646403f, 40.472839f,75.723607f, 40.364186f,75.661159f, 40.280084f,75.699612f, 40.317091f,75.797716f,
                    39.621629f,75.797716f, 39.621629f,74.911723f);
            poly[2471] = new TzPolygon(40.487230f,74.911723f, 40.451846f,74.987120f, 40.466612f,75.017956f, 40.434899f,75.090097f, 40.461399f,75.140946f,
                    40.444674f,75.222834f, 40.532029f,75.327898f, 40.555371f,75.414740f, 40.618831f,75.487310f, 40.663256f,75.602762f,
                    40.505645f,75.646403f, 40.472839f,75.723607f, 40.364186f,75.661159f, 40.280084f,75.699612f, 40.317091f,75.797716f,
                    39.621629f,75.797716f, 39.621629f,74.911723f);
            poly[2472] = new TzPolygon(40.317091f,75.797716f, 40.327702f,75.825846f, 40.291123f,75.911526f, 40.375176f,75.954697f, 40.381226f,75.991501f,
                    40.352813f,76.020951f, 40.395196f,76.068821f, 40.379447f,76.184098f, 40.438924f,76.272610f, 40.339260f,76.339998f,
                    40.386701f,76.365582f, 40.389061f,76.439808f, 40.465047f,76.537805f, 40.552357f,76.556780f, 40.610704f,76.611545f,
                    40.621800f,76.654230f, 40.694650f,76.672852f, 40.761827f,76.640013f, 40.789598f,76.683710f, 39.621629f,76.683710f,
                    39.621629f,75.797716f);
            poly[2473] = new TzPolygon(40.317091f,75.797716f, 40.327702f,75.825846f, 40.291123f,75.911526f, 40.375176f,75.954697f, 40.381226f,75.991501f,
                    40.352813f,76.020951f, 40.395196f,76.068821f, 40.379447f,76.184098f, 40.438924f,76.272610f, 40.339260f,76.339998f,
                    40.386701f,76.365582f, 40.389061f,76.439808f, 40.465047f,76.537805f, 40.552357f,76.556780f, 40.610704f,76.611545f,
                    40.621800f,76.654230f, 40.694650f,76.672852f, 40.761827f,76.640013f, 40.789598f,76.683710f, 39.621629f,76.683710f,
                    39.621629f,75.797716f);
            poly[2474] = new TzPolygon(42.753622f,73.485103f, 42.781744f,73.509996f, 42.925971f,73.512634f, 42.982285f,73.557309f, 43.016913f,73.547047f,
                    43.126239f,73.829573f, 43.123905f,73.912086f, 43.222655f,73.969132f, 43.172043f,74.042598f, 43.195893f,74.210849f,
                    43.266797f,74.204283f, 43.249636f,74.281967f, 43.216324f,74.308427f, 43.170610f,74.414661f, 43.132866f,74.577481f,
                    42.989726f,74.749928f, 42.999852f,74.853304f, 42.853552f,75.231300f, 42.843361f,75.484063f, 42.797189f,75.711571f,
                    42.833491f,75.761433f, 42.940253f,75.823518f, 42.955718f,75.926266f, 42.911042f,76.028275f, 42.931772f,76.186939f,
                    42.910942f,76.302069f, 42.874442f,76.303927f, 42.860756f,76.343846f, 42.884302f,76.478280f, 42.922249f,76.522591f,
                    42.906599f,76.683710f, 42.753622f,76.683710f);
            poly[2475] = new TzPolygon(41.187625f,76.683710f, 41.187625f,77.973092f, 41.150282f,77.831539f, 41.110203f,77.802175f, 41.058474f,77.824450f,
                    41.014784f,77.765178f, 41.030057f,77.731213f, 41.003286f,77.686941f, 40.995774f,77.477680f, 41.021431f,77.469752f,
                    41.040691f,77.355168f, 41.001292f,77.276561f, 41.030598f,77.228880f, 41.010692f,77.166976f, 41.063045f,77.085319f,
                    41.071879f,76.995851f, 41.024849f,76.926941f, 41.024539f,76.868841f, 40.976696f,76.853013f, 40.953253f,76.753388f,
                    40.817990f,76.728384f, 40.789598f,76.683710f);
            poly[2476] = new TzPolygon(40.789598f,76.683710f, 40.817990f,76.728384f, 40.953253f,76.753388f, 40.976696f,76.853013f, 41.024539f,76.868841f,
                    41.024849f,76.926941f, 41.071879f,76.995851f, 41.063045f,77.085319f, 41.010692f,77.166976f, 41.030598f,77.228880f,
                    41.001292f,77.276561f, 41.040691f,77.355168f, 41.021431f,77.469752f, 40.995774f,77.477680f, 41.003286f,77.686941f,
                    41.030057f,77.731213f, 41.014784f,77.765178f, 41.058474f,77.824450f, 41.110203f,77.802175f, 41.150282f,77.831539f,
                    41.187625f,77.973092f, 41.187625f,78.455697f, 39.621629f,78.455697f, 39.621629f,76.683710f);
            poly[2477] = new TzPolygon(41.187625f,77.973092f, 41.227076f,78.122632f, 41.381877f,78.156398f, 41.400835f,78.227374f, 41.380886f,78.320882f,
                    41.391595f,78.381867f, 41.412419f,78.394217f, 41.425027f,78.455697f, 41.187625f,78.455697f);
            poly[2478] = new TzPolygon(41.187625f,77.973092f, 41.227076f,78.122632f, 41.381877f,78.156398f, 41.400835f,78.227374f, 41.380886f,78.320882f,
                    41.391595f,78.381867f, 41.412419f,78.394217f, 41.425027f,78.455697f, 41.187625f,78.455697f);
            poly[2479] = new TzPolygon(41.187625f,78.455697f, 41.187625f,80.227684f, 39.621629f,80.227684f, 39.621629f,78.455697f);
            poly[2480] = new TzPolygon(42.602381f,79.341690f, 42.668129f,79.205044f, 42.732447f,79.170184f, 42.753622f,79.178795f, 42.753622f,79.341690f);
            poly[2481] = new TzPolygon(41.425027f,78.455697f, 41.440130f,78.529346f, 41.480363f,78.567435f, 41.468548f,78.645077f, 41.552982f,78.712972f,
                    41.558641f,78.815072f, 41.641667f,78.928174f, 41.656901f,79.017548f, 41.722830f,79.124616f, 41.726146f,79.216722f,
                    41.810766f,79.322774f, 41.799633f,79.341690f, 41.187625f,79.341690f, 41.187625f,78.455697f);
            poly[2482] = new TzPolygon(41.425027f,78.455697f, 41.440130f,78.529346f, 41.480363f,78.567435f, 41.468548f,78.645077f, 41.552982f,78.712972f,
                    41.558641f,78.815072f, 41.641667f,78.928174f, 41.656901f,79.017548f, 41.722830f,79.124616f, 41.726146f,79.216722f,
                    41.810766f,79.322774f, 41.799633f,79.341690f, 41.187625f,79.341690f, 41.187625f,78.455697f);
            poly[2483] = new TzPolygon(41.970624f,79.341690f, 41.970624f,79.831409f, 41.893016f,79.772259f, 41.893524f,79.637758f, 41.842601f,79.565854f,
                    41.837256f,79.485035f, 41.853325f,79.463611f, 41.793432f,79.352228f, 41.799633f,79.341690f);
            poly[2484] = new TzPolygon(41.799633f,79.341690f, 41.793432f,79.352228f, 41.853325f,79.463611f, 41.837256f,79.485035f, 41.842601f,79.565854f,
                    41.893524f,79.637758f, 41.893016f,79.772259f, 41.970624f,79.831409f, 41.970624f,80.227684f, 41.187625f,80.227684f,
                    41.187625f,79.341690f);
            poly[2485] = new TzPolygon(42.447498f,79.784687f, 42.479622f,79.695511f, 42.453974f,79.637153f, 42.459887f,79.504877f, 42.595042f,79.356944f,
                    42.602381f,79.341690f, 42.753622f,79.341690f, 42.753622f,79.784687f);
            poly[2486] = new TzPolygon(42.362123f,80.003141f, 42.362123f,80.227684f, 42.227953f,80.227684f, 42.229005f,80.199166f, 42.210844f,80.174404f,
                    42.276259f,80.118037f, 42.290394f,80.139202f, 42.339383f,80.081662f, 42.343685f,80.028173f);
            poly[2487] = new TzPolygon(41.970624f,79.831409f, 42.034395f,79.880013f, 42.042667f,80.209889f, 42.065873f,80.227124f, 42.100926f,80.165470f,
                    42.151887f,80.138698f, 42.155641f,80.163803f, 42.225281f,80.189198f, 42.225081f,80.227684f, 41.970624f,80.227684f);
            poly[2488] = new TzPolygon(41.970624f,79.831409f, 42.034395f,79.880013f, 42.042318f,80.209397f, 42.065873f,80.227124f, 42.100926f,80.165470f,
                    42.151887f,80.138698f, 42.155641f,80.163803f, 42.225281f,80.189198f, 42.225081f,80.227684f, 41.970624f,80.227684f);
            poly[2489] = new TzPolygon(42.449696f,79.784687f, 42.434587f,79.966911f, 42.377598f,79.982130f, 42.362123f,80.003141f, 42.362123f,79.784687f);
            poly[2490] = new TzPolygon(42.408763f,80.227684f, 42.428545f,80.204502f, 42.469030f,80.207623f, 42.482188f,80.227684f);
            poly[2491] = new TzPolygon(42.545651f,80.227684f, 42.580958f,80.182413f, 42.668368f,80.174600f, 42.694916f,80.227684f);
            poly[2492] = new TzPolygon(42.408763f,80.227684f, 42.428545f,80.204502f, 42.469030f,80.207623f, 42.482188f,80.227684f);
            poly[2493] = new TzPolygon(42.545651f,80.227684f, 42.580958f,80.182413f, 42.668368f,80.174600f, 42.694916f,80.227684f);
            poly[2494] = new TzPolygon(42.906599f,76.683710f, 42.904153f,76.708886f, 42.949774f,76.755876f, 42.955093f,76.822744f, 42.983411f,76.836789f,
                    42.965857f,76.917246f, 42.986802f,76.973359f, 42.947192f,77.035094f, 42.976815f,77.063305f, 42.972661f,77.153600f,
                    42.945902f,77.154789f, 42.911813f,77.234786f, 42.898513f,77.350501f, 42.939266f,77.471560f, 42.924637f,77.485265f,
                    42.941107f,77.552523f, 42.915514f,77.581041f, 42.914754f,77.780651f, 42.884439f,77.823760f, 42.881626f,77.934015f,
                    42.850820f,77.968122f, 42.870654f,78.002178f, 42.847441f,78.052662f, 42.859893f,78.169604f, 42.881989f,78.197829f,
                    42.854848f,78.348808f, 42.886981f,78.370535f, 42.878797f,78.430884f, 42.887044f,78.455697f, 42.753622f,78.455697f,
                    42.753622f,76.683710f);
            poly[2495] = new TzPolygon(42.887044f,78.455697f, 42.900345f,78.495717f, 42.814881f,78.664153f, 42.826114f,78.709549f, 42.774268f,78.930488f,
                    42.777168f,79.022988f, 42.760025f,79.033891f, 42.804223f,79.199372f, 42.753622f,79.178795f, 42.753622f,78.455697f);
            poly[2496] = new TzPolygon(44.735158f,80.227684f, 44.749696f,80.192807f, 44.841565f,80.163957f, 44.809784f,80.114200f, 44.790446f,79.999367f,
                    44.823593f,79.995176f, 44.850044f,79.944715f, 44.881986f,79.963753f, 44.893561f,79.885916f, 44.910678f,79.881985f,
                    45.046946f,80.090078f, 45.039291f,80.128335f, 45.057352f,80.139533f, 45.023252f,80.213527f, 45.029523f,80.227684f);
            poly[2497] = new TzPolygon(44.735158f,80.227684f, 44.749696f,80.192807f, 44.841565f,80.163957f, 44.809784f,80.114200f, 44.790446f,79.999367f,
                    44.823593f,79.995176f, 44.850044f,79.944715f, 44.881986f,79.963753f, 44.893561f,79.885916f, 44.910678f,79.881985f,
                    45.046946f,80.090078f, 45.039291f,80.128335f, 45.057352f,80.139533f, 45.023252f,80.213527f, 45.029523f,80.227684f);
            poly[2498] = new TzPolygon(50.905443f,80.227684f, 50.900366f,80.192951f, 50.827367f,80.184918f, 50.828168f,80.083038f, 50.852890f,80.067977f,
                    50.738208f,80.075866f, 51.923295f,79.187372f, 52.149600f,78.975168f, 52.149600f,80.227684f);
            poly[2499] = new TzPolygon(42.753622f,80.227684f, 42.753622f,80.241869f, 42.695586f,80.227684f);
        }
    }

    private static class Initializer26 {
        private static void init() {
            poly[2500] = new TzPolygon(42.529926f,80.227684f, 42.511178f,80.271885f, 42.482188f,80.227684f);
            poly[2501] = new TzPolygon(42.408763f,80.227684f, 42.403854f,80.233437f, 42.340335f,80.237655f, 42.319155f,80.283896f, 42.303060f,80.259921f,
                    42.261749f,80.289183f, 42.226356f,80.270976f, 42.227953f,80.227684f);
            poly[2502] = new TzPolygon(42.061963f,80.227684f, 42.060584f,80.229579f, 42.059953f,80.227684f);
            poly[2503] = new TzPolygon(42.225081f,80.227684f, 42.224876f,80.266995f, 42.260084f,80.289329f, 42.292853f,80.259485f, 42.319979f,80.283553f,
                    42.340335f,80.237655f, 42.403854f,80.233437f, 42.408763f,80.227684f, 42.482188f,80.227684f, 42.511178f,80.271885f,
                    42.545651f,80.227684f, 42.695212f,80.228275f, 42.753622f,80.248060f, 42.753622f,83.771658f, 39.621629f,83.771658f,
                    39.621629f,80.227684f);
            poly[2504] = new TzPolygon(42.753622f,80.248060f, 42.837782f,80.276568f, 42.829634f,80.405965f, 42.856021f,80.425316f, 42.892799f,80.601001f,
                    42.996060f,80.393986f, 43.053524f,80.393486f, 43.097709f,80.548941f, 43.138578f,80.591015f, 43.137824f,80.781312f,
                    43.177272f,80.807281f, 43.267040f,80.765071f, 43.311382f,80.778532f, 43.328684f,80.683169f, 43.393153f,80.735094f,
                    43.469037f,80.750977f, 43.536620f,80.707270f, 43.536620f,81.113677f, 42.753622f,81.113677f);
            poly[2505] = new TzPolygon(42.753622f,80.248060f, 42.837782f,80.276568f, 42.829634f,80.405965f, 42.856021f,80.425316f, 42.892799f,80.601001f,
                    42.996060f,80.393986f, 43.053524f,80.393486f, 43.097709f,80.548941f, 43.138578f,80.591015f, 43.137824f,80.781312f,
                    43.177272f,80.807281f, 43.267040f,80.765071f, 43.311382f,80.778532f, 43.328684f,80.683169f, 43.393153f,80.735094f,
                    43.469037f,80.750977f, 43.536620f,80.707270f, 43.536620f,81.113677f, 42.753622f,81.113677f);
            poly[2506] = new TzPolygon(43.536620f,80.707270f, 43.821915f,80.522767f, 43.906852f,80.508993f, 43.988485f,80.448503f, 44.074396f,80.445173f,
                    44.112031f,80.394265f, 44.293009f,80.405393f, 44.319618f,80.397190f, 44.319618f,81.113677f, 43.536620f,81.113677f);
            poly[2507] = new TzPolygon(43.536620f,80.707270f, 43.821915f,80.522767f, 43.906852f,80.508993f, 43.988485f,80.448503f, 44.074396f,80.445173f,
                    44.112031f,80.394265f, 44.293009f,80.405393f, 44.319618f,80.397190f, 44.319618f,81.113677f, 43.536620f,81.113677f);
            poly[2508] = new TzPolygon(42.753622f,81.113677f, 44.319618f,81.113677f, 44.319618f,81.999671f, 42.753622f,81.999671f);
            poly[2509] = new TzPolygon(44.319618f,80.397190f, 44.482686f,80.346920f, 44.610393f,80.410483f, 44.689495f,80.337233f, 44.735158f,80.227684f,
                    45.029523f,80.227684f, 45.070022f,80.319120f, 45.041065f,80.344923f, 45.039870f,80.381788f, 45.126494f,80.488890f,
                    45.105973f,80.511686f, 45.104559f,80.600910f, 45.133513f,80.697949f, 45.153985f,80.726444f, 45.170178f,80.711060f,
                    45.124698f,80.896611f, 45.167634f,80.956909f, 45.172383f,81.070029f, 45.221885f,81.106606f, 45.219797f,81.113677f,
                    44.319618f,81.113677f);
            poly[2510] = new TzPolygon(44.319618f,80.397190f, 44.482686f,80.346920f, 44.610393f,80.410483f, 44.689495f,80.337233f, 44.735158f,80.227684f,
                    45.029523f,80.227684f, 45.070022f,80.319120f, 45.041065f,80.344923f, 45.039870f,80.381788f, 45.126494f,80.488890f,
                    45.105973f,80.511686f, 45.104559f,80.600910f, 45.133513f,80.697949f, 45.153985f,80.726444f, 45.170178f,80.711060f,
                    45.124698f,80.896611f, 45.167634f,80.956909f, 45.172383f,81.070029f, 45.221885f,81.106606f, 45.219797f,81.113677f,
                    44.319618f,81.113677f);
            poly[2511] = new TzPolygon(45.219797f,81.113677f, 45.205617f,81.161694f, 45.247887f,81.226593f, 45.252934f,81.376662f, 45.283638f,81.420957f,
                    45.263942f,81.459824f, 45.307351f,81.573420f, 45.351581f,81.619388f, 45.386033f,81.771755f, 45.228887f,81.922035f,
                    45.244937f,81.999671f, 44.319618f,81.999671f, 44.319618f,81.113677f);
            poly[2512] = new TzPolygon(45.219797f,81.113677f, 45.205617f,81.161694f, 45.247887f,81.226593f, 45.252934f,81.376662f, 45.283638f,81.420957f,
                    45.263942f,81.459824f, 45.307351f,81.573420f, 45.351581f,81.619388f, 45.386033f,81.771755f, 45.228887f,81.922035f,
                    45.244937f,81.999671f, 44.319618f,81.999671f, 44.319618f,81.113677f);
            poly[2513] = new TzPolygon(45.885615f,82.339173f, 45.795676f,82.345081f, 45.616577f,82.257909f, 45.535138f,82.279959f, 45.420958f,82.542832f,
                    45.344720f,82.587726f, 45.203484f,82.560101f, 45.177336f,82.472245f, 45.207713f,82.336415f, 45.243062f,82.280731f,
                    45.201490f,82.103918f, 45.245480f,82.090460f, 45.254165f,82.044305f, 45.244937f,81.999671f, 45.885615f,81.999671f);
            poly[2514] = new TzPolygon(45.244937f,81.999671f, 45.254165f,82.044305f, 45.245480f,82.090460f, 45.201490f,82.103918f, 45.243062f,82.280731f,
                    45.207713f,82.336415f, 45.177336f,82.472245f, 45.203484f,82.560101f, 45.344720f,82.587726f, 45.420958f,82.542832f,
                    45.535138f,82.279959f, 45.616577f,82.257909f, 45.795676f,82.345081f, 45.885615f,82.339173f, 45.885615f,83.771658f,
                    42.753622f,83.771658f, 42.753622f,81.999671f);
            poly[2515] = new TzPolygon(39.621629f,83.771658f, 45.885615f,83.771658f, 45.885615f,87.315632f, 39.621629f,87.315632f);
            poly[2516] = new TzPolygon(45.885615f,82.339173f, 45.939158f,82.335656f, 45.977168f,82.456107f, 46.154629f,82.511896f, 46.485047f,82.721631f,
                    47.016096f,82.938067f, 47.064350f,82.993102f, 47.223267f,83.031327f, 47.234652f,83.150894f, 47.178837f,83.240591f,
                    47.177781f,83.364891f, 47.115993f,83.413466f, 47.128020f,83.470781f, 47.078123f,83.566007f, 47.056358f,83.565108f,
                    47.035772f,83.695637f, 47.017391f,83.699201f, 47.023299f,83.771658f, 45.885615f,83.771658f);
            poly[2517] = new TzPolygon(45.885615f,82.339173f, 45.939158f,82.335656f, 45.977168f,82.456107f, 46.154629f,82.511896f, 46.485047f,82.721631f,
                    47.016096f,82.938067f, 47.064350f,82.993102f, 47.223613f,83.031756f, 47.234652f,83.150894f, 47.178837f,83.240591f,
                    47.177781f,83.364891f, 47.115993f,83.413466f, 47.128020f,83.470781f, 47.078123f,83.566007f, 47.056358f,83.565108f,
                    47.035772f,83.695637f, 47.017391f,83.699201f, 47.023299f,83.771658f, 45.885615f,83.771658f);
            poly[2518] = new TzPolygon(50.787634f,81.999671f, 50.804307f,81.885415f, 50.771982f,81.796780f, 50.820919f,81.775857f, 50.760126f,81.727827f,
                    50.742388f,81.582504f, 50.755926f,81.449338f, 50.824178f,81.485988f, 50.862567f,81.471682f, 50.872428f,81.421252f,
                    50.910766f,81.442838f, 50.975742f,81.412587f, 50.947903f,81.059764f, 51.141628f,81.172907f, 51.211880f,81.146364f,
                    51.211523f,81.115159f, 51.180161f,81.102526f, 51.181456f,81.047091f, 51.219025f,80.919800f, 51.259257f,80.940611f,
                    51.316750f,80.677673f, 51.206804f,80.634700f, 51.208286f,80.447087f, 51.135163f,80.433651f, 51.109428f,80.482216f,
                    50.968687f,80.482243f, 50.962046f,80.421076f, 50.927119f,80.375967f, 50.905443f,80.227684f, 52.149600f,80.227684f,
                    52.149600f,81.999671f);
            poly[2519] = new TzPolygon(50.787634f,81.999671f, 52.149600f,81.999671f, 52.149600f,83.771658f, 50.887738f,83.771658f, 50.896211f,83.703568f,
                    50.954777f,83.648704f, 50.949716f,83.506916f, 50.976629f,83.499507f, 50.986714f,83.430223f, 51.009379f,83.432449f,
                    51.015036f,83.284436f, 50.993338f,83.202045f, 51.011004f,83.121021f, 50.965953f,83.112479f, 50.925200f,83.005994f,
                    50.883850f,82.979643f, 50.927272f,82.732817f, 50.850432f,82.739194f, 50.746842f,82.567470f, 50.742257f,82.485215f,
                    50.784596f,82.357314f, 50.752959f,82.316736f, 50.769791f,82.270380f, 50.730064f,82.172702f, 50.746805f,82.172162f,
                    50.750838f,82.078382f, 50.785751f,82.012574f);
            poly[2520] = new TzPolygon(47.023299f,83.771658f, 47.024266f,83.783512f, 46.974769f,83.906904f, 46.995664f,83.986524f, 46.967015f,84.124619f,
                    47.002278f,84.201145f, 47.008717f,84.424263f, 46.980179f,84.514153f, 47.002080f,84.657652f, 45.885615f,84.657652f,
                    45.885615f,83.771658f);
            poly[2521] = new TzPolygon(47.023299f,83.771658f, 47.024266f,83.783512f, 46.974769f,83.906904f, 46.995664f,83.986524f, 46.967015f,84.124619f,
                    47.002278f,84.201145f, 47.008717f,84.424263f, 46.980179f,84.514153f, 47.002080f,84.657652f, 45.885615f,84.657652f,
                    45.885615f,83.771658f);
            poly[2522] = new TzPolygon(47.002080f,84.657652f, 47.014069f,84.736206f, 46.946944f,84.858121f, 46.862851f,84.944232f, 46.873553f,84.979550f,
                    46.918587f,84.988478f, 46.925664f,85.066328f, 46.957894f,85.078843f, 46.992166f,85.175971f, 47.052368f,85.216898f,
                    47.049875f,85.261463f, 47.068774f,85.276360f, 47.042915f,85.323523f, 47.063988f,85.460351f, 47.048872f,85.533940f,
                    47.088015f,85.543645f, 45.885615f,85.543645f, 45.885615f,84.657652f);
            poly[2523] = new TzPolygon(47.002080f,84.657652f, 47.014069f,84.736206f, 46.946944f,84.858121f, 46.862851f,84.944232f, 46.873553f,84.979550f,
                    46.918587f,84.988478f, 46.925664f,85.066328f, 46.957894f,85.078843f, 46.992166f,85.175971f, 47.052368f,85.216898f,
                    47.049875f,85.261463f, 47.068774f,85.276360f, 47.042915f,85.323523f, 47.063988f,85.460351f, 47.048872f,85.533940f,
                    47.088015f,85.543645f, 45.885615f,85.543645f, 45.885615f,84.657652f);
            poly[2524] = new TzPolygon(47.915715f,85.543645f, 48.024663f,85.526454f, 48.074662f,85.543645f);
            poly[2525] = new TzPolygon(47.917272f,85.543645f, 48.025879f,85.526573f, 48.097127f,85.543645f);
            poly[2526] = new TzPolygon(47.451611f,85.543645f, 47.451611f,85.650143f, 47.380073f,85.702958f, 47.320860f,85.672934f, 47.288713f,85.698654f,
                    47.228725f,85.685698f, 47.106121f,85.548134f, 47.088015f,85.543645f);
            poly[2527] = new TzPolygon(47.088015f,85.543645f, 47.106121f,85.548134f, 47.228725f,85.685698f, 47.288713f,85.698654f, 47.320860f,85.672934f,
                    47.380073f,85.702958f, 47.451611f,85.650143f, 47.451611f,87.315632f, 45.885615f,87.315632f, 45.885615f,85.543645f);
            poly[2528] = new TzPolygon(47.451611f,85.650143f, 47.508919f,85.607834f, 47.915715f,85.543645f, 48.074662f,85.543645f, 48.190381f,85.583432f,
                    48.241824f,85.659413f, 48.360755f,85.712500f, 48.418208f,85.792408f, 48.436718f,85.912249f, 48.432532f,86.232376f,
                    48.490502f,86.299925f, 48.501479f,86.375799f, 48.478739f,86.406763f, 48.541456f,86.588113f, 48.626460f,86.635018f,
                    48.640015f,86.688950f, 48.720398f,86.773001f, 48.787702f,86.753307f, 48.833126f,86.819222f, 48.914436f,86.740280f,
                    48.994148f,86.728784f, 49.017607f,86.771293f, 49.017607f,87.315632f, 47.451611f,87.315632f);
            poly[2529] = new TzPolygon(47.451611f,85.650143f, 47.508919f,85.607834f, 47.917272f,85.543645f, 48.097127f,85.543645f, 48.140197f,85.553965f,
                    48.264113f,85.675550f, 48.360755f,85.712500f, 48.418208f,85.792408f, 48.436718f,85.912249f, 48.432532f,86.232376f,
                    48.490502f,86.299925f, 48.501479f,86.375799f, 48.478739f,86.406763f, 48.540882f,86.587252f, 48.626460f,86.635018f,
                    48.640015f,86.688950f, 48.720619f,86.773135f, 48.782086f,86.751076f, 48.847533f,86.818793f, 48.896413f,86.751112f,
                    48.987993f,86.726388f, 49.017607f,86.776027f, 49.017607f,87.315632f, 47.451611f,87.315632f);
            poly[2530] = new TzPolygon(49.594982f,85.543645f, 49.598129f,85.490205f, 49.634803f,85.388440f, 49.590847f,85.321261f, 49.588524f,85.257519f,
                    49.619788f,85.264671f, 49.627086f,85.210125f, 49.745268f,85.203369f, 49.767910f,85.148748f, 49.885036f,85.059699f,
                    49.906772f,84.985489f, 49.976294f,84.978046f, 50.010397f,85.049258f, 50.052494f,85.035544f, 50.096610f,84.945831f,
                    50.093900f,84.850700f, 50.120772f,84.813908f, 50.142985f,84.825375f, 50.136900f,84.757717f, 50.210679f,84.628187f,
                    50.196841f,84.567522f, 50.247256f,84.456801f, 50.209226f,84.409847f, 50.205465f,84.362523f, 50.292513f,84.250679f,
                    50.353755f,84.269559f, 50.468975f,84.203975f, 50.515566f,84.248707f, 50.551745f,84.169136f, 50.605967f,84.144961f,
                    50.727993f,83.966111f, 50.795399f,83.972662f, 50.880022f,83.833666f, 50.887738f,83.771658f, 52.149600f,83.771658f,
                    52.149600f,85.543645f);
            poly[2531] = new TzPolygon(49.614510f,86.429638f, 49.607590f,86.420003f, 49.582700f,86.271600f, 49.466113f,86.202038f, 49.524383f,86.112923f,
                    49.521846f,86.037199f, 49.487116f,85.968991f, 49.535866f,85.929409f, 49.561326f,85.944281f, 49.566907f,85.883737f,
                    49.544254f,85.826225f, 49.577150f,85.756890f, 49.550396f,85.677689f, 49.614381f,85.589914f, 49.594414f,85.553288f,
                    49.594982f,85.543645f, 50.583604f,85.543645f, 50.583604f,86.429638f);
            poly[2532] = new TzPolygon(49.106479f,87.315632f, 49.115872f,87.285790f, 49.233885f,87.309671f, 49.252880f,87.030716f, 49.348878f,86.926469f,
                    49.409624f,86.947328f, 49.452247f,86.833377f, 49.499140f,86.855415f, 49.545425f,86.827174f, 49.571169f,86.739513f,
                    49.570378f,86.618249f, 49.628524f,86.615549f, 49.684973f,86.699725f, 49.696017f,86.778924f, 49.742395f,86.752998f,
                    49.794347f,86.781099f, 49.807068f,86.589908f, 49.768929f,86.610501f, 49.724142f,86.582292f, 49.614510f,86.429638f,
                    50.583604f,86.429638f, 50.583604f,87.315632f);
            poly[2533] = new TzPolygon(49.017607f,86.771293f, 49.052468f,86.834461f, 49.100629f,86.843535f, 49.134858f,86.896697f, 49.130878f,87.081006f,
                    49.152374f,87.141830f, 49.103033f,87.315632f, 49.017607f,87.315632f);
            poly[2534] = new TzPolygon(49.017607f,86.776027f, 49.052468f,86.834461f, 49.100629f,86.843535f, 49.132579f,86.887155f, 49.130878f,87.081006f,
                    49.152374f,87.141830f, 49.103033f,87.315632f, 49.017607f,87.315632f);
            poly[2535] = new TzPolygon(40.765989f,87.315632f, 40.765989f,98.940959f, 29.382378f,98.940959f, 29.382378f,87.315632f);
            poly[2536] = new TzPolygon(46.457794f,90.221964f, 40.765989f,90.221964f, 40.765989f,87.315632f, 46.457794f,87.315632f);
            poly[2537] = new TzPolygon(43.611892f,90.221964f, 43.611892f,93.128295f, 40.765989f,93.128295f, 40.765989f,90.221964f);
            poly[2538] = new TzPolygon(45.064679f,91.675130f, 45.082591f,91.568639f, 45.068318f,91.558608f, 45.152538f,91.449743f, 45.109179f,91.372880f,
                    45.131870f,91.241732f, 45.214054f,91.122238f, 45.189268f,90.883794f, 45.204098f,90.864547f, 45.250311f,90.894961f,
                    45.298925f,90.832894f, 45.288579f,90.801706f, 45.428391f,90.769852f, 45.486432f,90.668311f, 45.551966f,90.668506f,
                    45.725378f,90.712820f, 45.887327f,90.847910f, 46.022309f,91.021993f, 46.123814f,91.011819f, 46.313476f,90.892338f,
                    46.362755f,90.974767f, 46.457794f,91.023623f, 46.457794f,91.675130f);
            poly[2539] = new TzPolygon(46.457794f,91.023094f, 46.362755f,90.974767f, 46.313476f,90.892338f, 46.123814f,91.011819f, 46.022309f,91.021993f,
                    45.887327f,90.847910f, 45.725378f,90.712820f, 45.537048f,90.667700f, 45.486432f,90.668311f, 45.428391f,90.769852f,
                    45.288579f,90.801706f, 45.298925f,90.832894f, 45.250311f,90.894961f, 45.204098f,90.864547f, 45.189268f,90.883794f,
                    45.214054f,91.122238f, 45.131870f,91.241732f, 45.109179f,91.372880f, 45.152538f,91.449743f, 45.068318f,91.558608f,
                    45.082591f,91.568639f, 45.064679f,91.675130f, 43.611892f,91.675130f, 43.611892f,90.221964f, 46.457794f,90.221964f);
            poly[2540] = new TzPolygon(45.064679f,91.675130f, 45.062033f,91.690864f, 45.082750f,92.057580f, 45.013481f,92.234924f, 45.026810f,92.313272f,
                    45.000053f,92.490470f, 45.049824f,92.775911f, 45.046537f,92.881584f, 44.999410f,92.984770f, 45.009373f,93.128295f,
                    43.611892f,93.128295f, 43.611892f,91.675130f);
            poly[2541] = new TzPolygon(45.064679f,91.675130f, 45.062033f,91.690864f, 45.082750f,92.057580f, 45.013481f,92.234924f, 45.026810f,92.313272f,
                    45.000053f,92.490470f, 45.049824f,92.775911f, 45.046537f,92.881584f, 44.999410f,92.984770f, 45.009373f,93.128295f,
                    43.611892f,93.128295f, 43.611892f,91.675130f);
            poly[2542] = new TzPolygon(47.880746f,87.315632f, 47.880746f,88.768798f, 46.457794f,88.768798f, 46.457794f,87.315632f);
            poly[2543] = new TzPolygon(48.556785f,88.042215f, 48.572527f,87.971030f, 48.592222f,87.956374f, 48.592222f,88.042215f);
            poly[2544] = new TzPolygon(48.592222f,87.315632f, 48.592222f,87.956374f, 48.572527f,87.971030f, 48.556785f,88.042215f, 47.880746f,88.042215f,
                    47.880746f,87.315632f);
            poly[2545] = new TzPolygon(49.303697f,87.678923f, 49.160188f,87.678923f, 49.152070f,87.670519f, 49.138516f,87.492854f, 49.092530f,87.503232f,
                    49.071318f,87.427347f, 49.106479f,87.315632f, 49.303697f,87.315632f);
            poly[2546] = new TzPolygon(49.103033f,87.315632f, 49.071318f,87.427347f, 49.092530f,87.503232f, 49.138516f,87.492854f, 49.152070f,87.670519f,
                    49.160188f,87.678923f, 48.592222f,87.678923f, 48.592222f,87.315632f);
            poly[2547] = new TzPolygon(49.244136f,88.042215f, 49.183020f,87.988438f, 49.175738f,87.695023f, 49.160188f,87.678923f, 49.303697f,87.678923f,
                    49.303697f,88.042215f);
            poly[2548] = new TzPolygon(49.160188f,87.678923f, 49.175738f,87.695023f, 49.170183f,87.814538f, 49.116333f,87.866635f, 49.042313f,87.832382f,
                    48.984192f,87.900523f, 48.948734f,87.868308f, 48.932330f,87.756271f, 48.867607f,87.742774f, 48.869462f,87.781281f,
                    48.803570f,87.820515f, 48.753662f,87.932879f, 48.770281f,87.972273f, 48.720319f,88.042215f, 48.672919f,88.042215f,
                    48.648333f,88.011416f, 48.628716f,88.024847f, 48.593356f,87.955530f, 48.592222f,87.956374f, 48.592222f,87.678923f);
            poly[2549] = new TzPolygon(49.160188f,87.678923f, 49.175738f,87.695023f, 49.178729f,87.778504f, 49.116333f,87.866635f, 49.051225f,87.828701f,
                    48.984192f,87.900523f, 48.948734f,87.868308f, 48.932330f,87.756271f, 48.867607f,87.742774f, 48.869462f,87.781281f,
                    48.803570f,87.820515f, 48.753662f,87.932879f, 48.770281f,87.972273f, 48.720319f,88.042215f, 48.672919f,88.042215f,
                    48.648333f,88.011416f, 48.628716f,88.024847f, 48.593356f,87.955530f, 48.592222f,87.956374f, 48.592222f,87.678923f);
            poly[2550] = new TzPolygon(49.303697f,88.168698f, 49.293567f,88.170112f, 49.256569f,88.106706f, 49.258389f,88.054756f, 49.244136f,88.042215f,
                    49.303697f,88.042215f);
            poly[2551] = new TzPolygon(48.720319f,88.042215f, 48.711250f,88.054910f, 48.710979f,88.089893f, 48.672919f,88.042215f);
            poly[2552] = new TzPolygon(48.556785f,88.042215f, 48.544517f,88.097687f, 48.495865f,88.187297f, 48.475565f,88.332223f, 48.432953f,88.350688f,
                    48.386096f,88.440133f, 48.398328f,88.516326f, 48.375755f,88.517743f, 48.334105f,88.603783f, 48.274847f,88.566520f,
                    48.215444f,88.588709f, 48.176350f,88.641707f, 48.173233f,88.712886f, 48.136071f,88.768798f, 47.880746f,88.768798f,
                    47.880746f,88.042215f);
            poly[2553] = new TzPolygon(48.720319f,88.042215f, 48.711250f,88.054910f, 48.710979f,88.089893f, 48.672919f,88.042215f);
            poly[2554] = new TzPolygon(48.556785f,88.042215f, 48.544517f,88.097687f, 48.495865f,88.187297f, 48.475565f,88.332223f, 48.432953f,88.350688f,
                    48.386096f,88.440133f, 48.398328f,88.516326f, 48.375755f,88.517743f, 48.334105f,88.603783f, 48.274847f,88.566520f,
                    48.215444f,88.588709f, 48.167176f,88.666618f, 48.173233f,88.712886f, 48.136071f,88.768798f, 47.880746f,88.768798f,
                    47.880746f,88.042215f);
            poly[2555] = new TzPolygon(47.708683f,90.221964f, 47.731776f,90.123464f, 47.778697f,90.070226f, 47.857900f,90.089682f, 47.885540f,90.056622f,
                    47.871488f,90.037587f, 47.886020f,89.956973f, 47.831169f,89.949887f, 47.826089f,89.758819f, 47.900811f,89.723538f,
                    47.903891f,89.655104f, 47.946276f,89.640187f, 47.967985f,89.592715f, 48.032941f,89.578800f, 48.023479f,89.494572f,
                    48.043412f,89.385868f, 47.975260f,89.236263f, 47.987302f,89.062006f, 48.107124f,88.934277f, 48.099500f,88.823821f,
                    48.136071f,88.768798f, 49.303697f,88.768798f, 49.303697f,90.221964f);
            poly[2556] = new TzPolygon(48.136071f,88.768798f, 48.099500f,88.823821f, 48.107124f,88.934277f, 47.987302f,89.062006f, 47.975260f,89.236263f,
                    48.043412f,89.385868f, 48.023479f,89.494572f, 48.032941f,89.578800f, 47.967985f,89.592715f, 47.946276f,89.640187f,
                    47.903891f,89.655104f, 47.900811f,89.723538f, 47.826089f,89.758819f, 47.831169f,89.949887f, 47.886020f,89.956973f,
                    47.871488f,90.037587f, 47.885540f,90.056622f, 47.857900f,90.089682f, 47.778697f,90.070226f, 47.731776f,90.123464f,
                    47.708683f,90.221964f, 46.457794f,90.221964f, 46.457794f,88.768798f);
            poly[2557] = new TzPolygon(49.303697f,88.168629f, 49.350483f,88.166733f, 49.390801f,88.118763f, 49.415928f,88.184379f, 49.445452f,88.165591f,
                    49.479660f,88.221784f, 49.470898f,88.297742f, 49.493500f,88.331200f, 49.494600f,88.405900f, 49.471900f,88.494900f,
                    49.500900f,88.599200f, 49.462200f,88.683600f, 49.451183f,88.768798f, 49.303697f,88.768798f);
            poly[2558] = new TzPolygon(51.558320f,88.768798f, 51.561429f,88.763075f, 51.528050f,88.658053f, 51.390930f,88.700879f, 51.385349f,88.631385f,
                    51.323347f,88.590383f, 51.286255f,88.424641f, 51.344413f,88.315101f, 51.348495f,88.156395f, 51.394057f,88.125209f,
                    51.428544f,88.141106f, 51.465679f,88.055455f, 51.478927f,87.941398f, 51.551548f,87.900397f, 51.551330f,87.950085f,
                    51.589270f,88.003943f, 51.664388f,88.019145f, 51.674834f,88.076043f, 51.740267f,88.110095f, 51.786111f,87.883284f,
                    51.885704f,87.945307f, 51.916173f,88.001424f, 51.952266f,87.976840f, 52.000021f,88.087596f, 52.016808f,88.057627f,
                    52.049688f,88.066661f, 52.095988f,88.151791f, 52.045800f,88.252470f, 52.111733f,88.286261f, 52.124611f,88.378254f,
                    52.149600f,88.377654f, 52.149600f,88.768798f);
            poly[2559] = new TzPolygon(49.451183f,88.768798f, 49.441600f,88.842900f, 49.478100f,88.880100f, 49.491800f,88.857100f, 49.546741f,88.869615f,
                    49.558961f,88.900090f, 49.465700f,88.970800f, 49.502100f,89.147600f, 49.553700f,89.232700f, 49.586020f,89.191469f,
                    49.634683f,89.193637f, 49.642300f,89.250600f, 49.584400f,89.360000f, 49.666217f,89.461564f, 49.670804f,89.495381f,
                    49.303697f,89.495381f, 49.303697f,88.768798f);
            poly[2560] = new TzPolygon(50.195459f,89.495381f, 50.203696f,89.440603f, 50.177932f,89.403485f, 50.207937f,89.308428f, 50.314032f,89.406595f,
                    50.314921f,89.379479f, 50.338889f,89.381479f, 50.363598f,89.495381f);
            poly[2561] = new TzPolygon(49.670804f,89.495381f, 49.686000f,89.607400f, 49.728300f,89.719200f, 49.790098f,89.711881f, 49.806369f,89.624463f,
                    49.826440f,89.651037f, 49.863520f,89.611742f, 49.899345f,89.630880f, 49.912287f,89.593570f, 49.943941f,89.705957f,
                    49.971259f,89.974830f, 49.998638f,90.031556f, 50.057900f,90.007700f, 50.108164f,90.165213f, 50.109466f,90.221964f,
                    49.303697f,90.221964f, 49.303697f,89.495381f);
            poly[2562] = new TzPolygon(50.195459f,89.495381f, 50.363598f,89.495381f, 50.363913f,89.496835f, 50.459802f,89.502910f, 50.428129f,89.589891f,
                    50.374267f,89.613229f, 50.369729f,89.655164f, 50.409274f,89.735772f, 50.411201f,89.818900f, 50.472046f,89.865650f,
                    50.524889f,89.851350f, 50.576936f,89.649457f, 50.642893f,89.639825f, 50.645801f,89.582776f, 50.726649f,89.511518f,
                    50.726649f,90.221964f, 50.109466f,90.221964f, 50.108164f,90.165213f, 50.057900f,90.007700f, 49.998638f,90.031556f,
                    49.971259f,89.974830f, 49.912627f,89.591721f, 49.970855f,89.624790f, 50.015530f,89.592932f, 50.015030f,89.543959f,
                    50.039350f,89.524696f, 50.065855f,89.533956f, 50.084192f,89.592042f, 50.106974f,89.582410f, 50.119310f,89.511507f,
                    50.191731f,89.520175f);
            poly[2563] = new TzPolygon(51.549382f,88.768798f, 51.553761f,88.791531f, 51.467884f,88.863883f, 51.463920f,88.919894f, 51.394259f,89.008876f,
                    51.222670f,88.961090f, 51.159806f,89.049849f, 51.102517f,89.022288f, 51.047136f,89.054221f, 50.982957f,89.192472f,
                    50.915982f,89.268044f, 50.880456f,89.267748f, 50.881253f,89.346949f, 50.859675f,89.348579f, 50.850525f,89.398663f,
                    50.809925f,89.390217f, 50.792570f,89.453415f, 50.726649f,89.511518f, 50.726649f,88.768798f);
            poly[2564] = new TzPolygon(47.708683f,90.221964f, 47.685035f,90.322828f, 47.654882f,90.370406f, 47.623447f,90.344912f, 47.537597f,90.399595f,
                    47.489079f,90.472906f, 47.406960f,90.458150f, 47.375784f,90.520087f, 47.321019f,90.476455f, 47.206174f,90.559031f,
                    46.989571f,90.760778f, 46.986898f,90.852365f, 46.953718f,90.903799f, 46.873494f,90.953714f, 46.820152f,90.936379f,
                    46.719828f,91.048399f, 46.580558f,91.014437f, 46.557606f,91.074933f, 46.457794f,91.023623f, 46.457794f,90.221964f);
            poly[2565] = new TzPolygon(47.708683f,90.221964f, 47.685035f,90.322828f, 47.654882f,90.370406f, 47.623447f,90.344912f, 47.537597f,90.399595f,
                    47.489079f,90.472906f, 47.406960f,90.458150f, 47.375784f,90.520087f, 47.321019f,90.476455f, 47.166189f,90.594080f,
                    46.989571f,90.760778f, 46.986898f,90.852365f, 46.936536f,90.919843f, 46.873494f,90.953714f, 46.820152f,90.936379f,
                    46.719828f,91.048399f, 46.577957f,91.015100f, 46.559416f,91.074768f, 46.457794f,91.023094f, 46.457794f,90.221964f);
            poly[2566] = new TzPolygon(50.586852f,93.128295f, 50.586316f,93.110724f, 50.601118f,93.049844f, 50.669711f,92.975229f, 50.716238f,93.022891f,
                    50.767992f,93.031948f, 50.791857f,93.003385f, 50.808300f,92.799000f, 50.775900f,92.756600f, 50.727500f,92.754000f,
                    50.703399f,92.627846f, 50.785137f,92.600249f, 50.803243f,92.432061f, 50.884288f,92.360847f, 50.876724f,92.312931f,
                    50.755762f,92.316914f, 50.728706f,92.266693f, 50.696363f,92.072339f, 50.733830f,91.855084f, 50.697479f,91.723258f,
                    50.640059f,91.661109f, 50.586239f,91.649948f, 50.581418f,91.534307f, 50.548525f,91.454903f, 50.508449f,91.459026f,
                    50.476515f,91.400509f, 50.450600f,91.409400f, 50.469600f,91.293300f, 50.420100f,91.160000f, 50.436000f,91.093200f,
                    50.418500f,90.920800f, 50.348200f,90.905600f, 50.356900f,90.829300f, 50.326400f,90.795600f, 50.337700f,90.772600f,
                    50.312900f,90.706400f, 50.243400f,90.730800f, 50.214300f,90.673300f, 50.243900f,90.580700f, 50.235100f,90.504100f,
                    50.197100f,90.452800f, 50.192641f,90.388888f, 50.110916f,90.285204f, 50.109466f,90.221964f, 52.149600f,90.221964f,
                    52.149600f,93.128295f);
            poly[2567] = new TzPolygon(43.154318f,96.034627f, 43.276337f,95.877645f, 43.409914f,95.857465f, 43.611892f,95.743506f, 43.611892f,96.034627f);
            poly[2568] = new TzPolygon(43.611892f,93.128295f, 43.611892f,95.743506f, 43.409914f,95.857465f, 43.276337f,95.877645f, 43.154318f,96.034627f,
                    40.765989f,96.034627f, 40.765989f,93.128295f);
            poly[2569] = new TzPolygon(45.009373f,93.128295f, 45.012508f,93.173465f, 44.981912f,93.288074f, 44.985719f,93.372599f, 44.955826f,93.429942f,
                    44.967541f,93.502765f, 44.897011f,93.709448f, 44.860771f,93.727352f, 44.667806f,94.210293f, 44.580999f,94.327703f,
                    44.517174f,94.344303f, 44.510084f,94.461212f, 44.445964f,94.603795f, 44.337774f,94.725229f, 44.297221f,94.921805f,
                    44.249982f,94.999519f, 44.294069f,95.407737f, 44.269036f,95.424178f, 44.225637f,95.373245f, 44.026980f,95.322980f,
                    44.003374f,95.522625f, 43.611892f,95.743506f, 43.611892f,93.128295f);
            poly[2570] = new TzPolygon(45.009373f,93.128295f, 45.012508f,93.173465f, 44.981912f,93.288074f, 44.985719f,93.372599f, 44.955826f,93.429942f,
                    44.967541f,93.502765f, 44.897011f,93.709448f, 44.860771f,93.727352f, 44.667806f,94.210293f, 44.580999f,94.327703f,
                    44.517174f,94.344303f, 44.510084f,94.461212f, 44.445964f,94.603795f, 44.337774f,94.725229f, 44.297221f,94.921805f,
                    44.249982f,94.999519f, 44.294069f,95.407737f, 44.269036f,95.424178f, 44.225637f,95.373245f, 44.026980f,95.322980f,
                    44.003374f,95.522625f, 43.611892f,95.743506f, 43.611892f,93.128295f);
            poly[2571] = new TzPolygon(43.154318f,96.034627f, 42.899170f,96.362886f, 42.725137f,96.387262f, 42.754765f,96.977348f, 42.794487f,97.171712f,
                    42.652010f,98.192273f, 42.602416f,98.940959f, 40.765989f,98.940959f, 40.765989f,96.034627f);
            poly[2572] = new TzPolygon(42.602416f,98.940959f, 42.652010f,98.192273f, 42.709357f,97.789317f, 43.015049f,97.790847f, 43.249149f,97.753533f,
                    43.330322f,97.779725f, 43.423705f,97.855102f, 43.532714f,97.869080f, 43.614685f,97.913086f, 43.982116f,97.955323f,
                    44.354919f,97.929872f, 44.405883f,97.966675f, 44.451725f,98.101379f, 44.587913f,98.189964f, 44.686096f,98.214477f,
                    44.907090f,98.201554f, 45.306645f,98.436608f, 45.583401f,98.465325f, 45.802815f,98.401443f, 45.931691f,98.220528f,
                    45.990067f,98.206094f, 46.282628f,97.741989f, 46.457794f,97.652394f, 46.457794f,98.940959f);
            poly[2573] = new TzPolygon(43.154318f,96.034627f, 42.899170f,96.362886f, 42.725137f,96.387262f, 42.603136f,96.101704f, 42.550525f,96.034627f);
            poly[2574] = new TzPolygon(42.420728f,96.034627f, 42.412938f,96.064625f, 42.325428f,96.040077f, 42.216695f,96.177750f, 42.148642f,96.075783f,
                    42.018182f,96.136722f, 41.922330f,96.034627f);
            poly[2575] = new TzPolygon(49.999383f,96.034627f, 49.971139f,95.967566f, 50.043625f,95.860873f, 50.017142f,95.765330f, 49.964134f,95.795551f,
                    49.944283f,95.572270f, 49.897225f,95.531960f, 49.957641f,95.425916f, 49.962912f,95.081579f, 49.980528f,95.016529f,
                    50.047412f,94.990329f, 50.054917f,94.760652f, 50.035398f,94.614843f, 50.174252f,94.520289f, 50.213977f,94.389747f,
                    50.501225f,94.341509f, 50.583338f,94.254035f, 50.604832f,93.994415f, 50.586223f,93.703414f, 50.634504f,93.397457f,
                    50.589800f,93.225000f, 50.586852f,93.128295f, 52.149600f,93.128295f, 52.149600f,96.034627f);
            poly[2576] = new TzPolygon(46.457794f,98.940959f, 46.457794f,97.652394f, 46.472870f,97.644683f, 46.530694f,97.653939f, 46.597493f,97.567687f,
                    46.742400f,97.693892f, 46.964324f,97.745902f, 47.069511f,97.854394f, 47.154721f,97.874040f, 47.187299f,97.935280f,
                    47.173781f,98.063370f, 47.246468f,98.229393f, 47.298234f,98.266441f, 47.444351f,98.278206f, 47.562732f,98.406279f,
                    47.614785f,98.416650f, 47.657181f,98.257591f, 47.743793f,98.177643f, 47.996052f,98.201294f, 48.066845f,98.237740f,
                    48.102944f,98.332688f, 48.106953f,98.544135f, 48.202736f,98.705277f, 48.262427f,98.940959f);
            poly[2577] = new TzPolygon(49.303697f,96.993791f, 49.303697f,98.940959f, 49.108092f,98.940959f, 49.103970f,98.814078f, 49.011948f,98.742532f,
                    48.934544f,98.552536f, 49.016433f,98.378807f, 49.016296f,98.211122f, 48.986695f,98.091918f, 49.001710f,97.878723f,
                    49.150556f,97.562598f, 49.181702f,97.322083f, 49.166870f,97.175719f, 49.258484f,97.074890f);
            poly[2578] = new TzPolygon(52.149600f,97.487793f, 49.804285f,97.487793f, 49.742930f,97.231114f, 49.791953f,97.119760f, 49.819551f,97.119700f,
                    49.833364f,97.010128f, 49.892965f,96.994987f, 49.907572f,96.740880f, 49.928731f,96.709200f, 49.873666f,96.603087f,
                    49.944184f,96.525363f, 49.875810f,96.424461f, 49.976585f,96.260708f, 49.989134f,96.106887f, 50.012701f,96.066248f,
                    49.999383f,96.034627f, 52.149600f,96.034627f);
            poly[2579] = new TzPolygon(49.303697f,96.993791f, 49.368530f,96.877501f, 49.508729f,96.875489f, 49.648925f,97.077698f, 49.791140f,97.130523f,
                    49.742930f,97.231114f, 49.780696f,97.421624f, 49.813063f,97.487793f, 49.303697f,97.487793f);
            poly[2580] = new TzPolygon(52.149600f,98.940959f, 52.129000f,98.854200f, 51.869900f,98.764300f, 51.793700f,98.603800f, 51.798100f,98.532800f,
                    51.736600f,98.452300f, 51.731500f,98.354000f, 51.616100f,98.274800f, 51.595100f,98.223200f, 51.529600f,98.257400f,
                    51.456700f,98.224100f, 51.471300f,98.126000f, 51.450200f,98.050100f, 51.334200f,97.953500f, 51.202000f,97.939300f,
                    51.051444f,97.871231f, 51.017672f,97.827190f, 50.930118f,97.887044f, 50.864706f,98.033343f, 50.808100f,97.949700f,
                    50.691900f,98.024500f, 50.669200f,98.008000f, 50.597370f,98.096636f, 50.538882f,98.272796f, 50.495246f,98.323276f,
                    50.396235f,98.269370f, 50.323294f,98.308130f, 50.202677f,98.169785f, 50.151900f,98.176800f, 50.138700f,98.112700f,
                    50.100200f,98.120400f, 50.070000f,98.063700f, 50.035900f,98.069900f, 49.972000f,97.867400f, 49.923500f,97.886600f,
                    49.923000f,97.829600f, 50.000500f,97.762100f, 49.961100f,97.700400f, 49.940797f,97.571560f, 49.859596f,97.581344f,
                    49.806425f,97.496746f, 49.804285f,97.487793f, 52.149600f,97.487793f);
            poly[2581] = new TzPolygon(49.108092f,98.940959f, 49.113709f,99.113892f, 48.758995f,99.215377f, 48.555450f,99.076104f, 48.377377f,99.102036f,
                    48.296185f,99.074249f, 48.262427f,98.940959f);
            poly[2582] = new TzPolygon(42.602416f,98.940959f, 42.565140f,99.503700f, 42.646074f,99.963865f, 42.635273f,100.267823f, 42.686868f,100.318421f,
                    42.671819f,100.848023f, 42.525365f,101.567048f, 42.503419f,101.800727f, 42.252491f,102.048441f, 42.224160f,102.024563f,
                    42.141913f,102.442447f, 42.158910f,102.550743f, 42.127201f,102.760760f, 41.881288f,103.411109f, 41.807325f,103.795288f,
                    41.789065f,104.058960f, 41.873404f,104.523668f, 41.772256f,104.497372f, 41.659575f,104.517016f, 41.652489f,104.916430f,
                    41.580028f,105.007732f, 41.747680f,105.229328f, 41.777773f,105.374100f, 41.930908f,105.696938f, 42.291428f,106.786003f,
                    42.314259f,107.041054f, 42.322236f,107.076564f, 39.248044f,107.076564f, 39.248044f,98.940959f);
            poly[2583] = new TzPolygon(44.180876f,107.076564f, 44.180876f,111.548879f, 44.062042f,111.654266f, 43.932240f,111.873932f, 43.819103f,111.958977f,
                    43.689996f,111.946239f, 43.666416f,111.787682f, 43.490772f,111.572907f, 43.476387f,111.401550f, 43.430721f,111.344887f,
                    43.322006f,111.006073f, 43.063713f,110.709297f, 42.932788f,110.624012f, 42.832583f,110.464126f, 42.777195f,110.432930f,
                    42.672077f,110.136330f, 42.639107f,110.100830f, 42.618607f,109.857483f, 42.453476f,109.469223f, 42.434506f,109.283943f,
                    42.454186f,109.024406f, 42.395607f,108.838532f, 42.440613f,108.539047f, 42.436619f,108.293167f, 42.460640f,108.240791f,
                    42.402268f,107.918793f, 42.411579f,107.565933f, 42.454979f,107.496162f, 42.456661f,107.453178f, 42.408112f,107.292809f,
                    42.362763f,107.256981f, 42.322236f,107.076564f);
            poly[2584] = new TzPolygon(44.792526f,113.178269f, 44.795387f,113.127617f, 44.862572f,112.756813f, 44.931816f,112.590889f, 45.074165f,112.425507f,
                    45.071598f,112.111351f, 45.095871f,112.061829f, 45.071823f,111.953468f, 45.196289f,111.911072f, 45.306884f,111.916077f,
                    45.492126f,111.756287f, 45.534486f,111.685303f, 45.882699f,111.707276f, 46.054325f,111.624840f, 46.094497f,111.575538f,
                    46.231559f,111.167098f, 46.435063f,111.262236f, 46.647293f,111.240819f, 46.647293f,113.178269f);
            poly[2585] = new TzPolygon(44.180876f,111.548879f, 44.191757f,111.539230f, 44.291237f,111.502602f, 44.317452f,111.425148f, 44.344635f,111.409287f,
                    44.471417f,111.463654f, 44.571270f,111.561073f, 44.679550f,111.564980f, 44.928722f,111.726143f, 44.994640f,111.790672f,
                    45.083611f,111.971382f, 45.095871f,112.061829f, 45.071598f,112.111351f, 45.074165f,112.425507f, 44.931816f,112.590889f,
                    44.862572f,112.756813f, 44.795387f,113.127617f, 44.792526f,113.178269f, 44.180876f,113.178269f);
            poly[2586] = new TzPolygon(44.792526f,113.178269f, 44.775700f,113.476212f, 44.742385f,113.625633f, 44.874359f,113.870064f, 44.912014f,113.898567f,
                    44.925581f,114.056154f, 44.966660f,114.133377f, 45.033791f,114.176971f, 45.143387f,114.384722f, 45.206078f,114.456177f,
                    45.292667f,114.528038f, 45.382523f,114.546997f, 45.435032f,114.744751f, 45.373081f,114.954804f, 45.382273f,115.212170f,
                    44.180876f,115.212170f, 44.180876f,113.178269f);
            poly[2587] = new TzPolygon(49.113709f,112.207988f, 48.997680f,112.292114f, 48.857484f,112.237121f, 48.463211f,112.523667f, 48.386635f,112.540863f,
                    48.246308f,112.511551f, 48.086293f,112.543571f, 47.793868f,112.694053f, 47.763631f,112.408936f, 47.644544f,112.116349f,
                    47.490891f,112.051476f, 47.316031f,112.067925f, 47.379640f,111.792961f, 47.252503f,111.550720f, 47.136718f,111.467530f,
                    46.948769f,111.401802f, 46.791871f,111.393494f, 46.729988f,111.300499f, 46.647293f,111.240819f, 46.647293f,111.144367f,
                    49.113709f,111.144367f);
            poly[2588] = new TzPolygon(51.611270f,100.974860f, 51.606802f,100.929841f, 51.726826f,100.656240f, 51.718590f,100.597398f, 51.740450f,100.586455f,
                    51.750064f,100.503852f, 51.726371f,100.443763f, 51.747931f,100.414356f, 51.737537f,100.280642f, 51.759349f,100.138702f,
                    51.732720f,100.061417f, 51.754720f,99.979798f, 51.738159f,99.910913f, 51.805502f,99.864397f, 51.806759f,99.830758f,
                    51.834955f,99.847577f, 51.915385f,99.801183f, 51.887697f,99.682656f, 51.904393f,99.664972f, 51.879108f,99.613847f,
                    51.924188f,99.600979f, 51.967993f,99.521987f, 51.948871f,99.465890f, 51.965900f,99.401018f, 51.942400f,99.353785f,
                    51.973530f,99.265308f, 52.018603f,99.276094f, 52.024554f,99.128117f, 52.069498f,99.071691f, 52.074732f,99.004609f,
                    52.149600f,98.967137f, 52.149600f,100.974860f);
            poly[2589] = new TzPolygon(50.631654f,102.453348f, 50.631654f,103.008762f, 50.305663f,103.008762f, 50.305491f,102.941875f, 50.334191f,102.841829f,
                    50.408529f,102.731819f, 50.402190f,102.647698f, 50.506385f,102.610630f, 50.531563f,102.541005f, 50.588504f,102.536235f,
                    50.601044f,102.469595f);
            poly[2590] = new TzPolygon(51.611270f,100.974860f, 51.612788f,100.990152f, 51.570270f,101.017427f, 51.559848f,101.078678f, 51.591220f,101.104394f,
                    51.521396f,101.136642f, 51.544113f,101.256278f, 51.455846f,101.370098f, 51.455689f,101.438936f, 51.491166f,101.459560f,
                    51.499542f,101.542217f, 51.469944f,101.567716f, 51.469211f,101.622263f, 51.440028f,101.619038f, 51.455342f,101.749057f,
                    51.415155f,101.828531f, 51.400795f,101.888839f, 51.413744f,101.951935f, 51.382190f,102.001432f, 51.395816f,102.022059f,
                    51.361612f,102.124291f, 51.295025f,102.183968f, 51.284034f,102.114160f, 51.246469f,102.104487f, 51.178688f,102.166319f,
                    51.174218f,102.135113f, 51.139101f,102.123325f, 51.095029f,102.170838f, 51.057304f,102.151096f, 51.039492f,102.203624f,
                    50.974887f,102.243008f, 50.953841f,102.213785f, 50.901973f,102.245439f, 50.875846f,102.211974f, 50.817034f,102.209737f,
                    50.732537f,102.340313f, 50.681855f,102.302346f, 50.641584f,102.399939f, 50.645679f,102.445904f, 50.631654f,102.453348f,
                    50.631654f,100.974860f);
            poly[2591] = new TzPolygon(50.066862f,107.076564f, 50.068333f,107.071852f, 50.157182f,106.999999f, 50.199066f,107.012474f, 50.298178f,106.815728f,
                    50.344056f,106.524582f, 50.318138f,106.468711f, 50.298134f,106.261230f, 50.339694f,106.183001f, 50.333400f,106.084101f,
                    50.404505f,106.057371f, 50.412632f,105.899052f, 50.440396f,105.844227f, 50.427396f,105.628757f, 50.458023f,105.525130f,
                    50.442109f,105.443530f, 50.479499f,105.354717f, 50.472143f,105.298419f, 50.389932f,105.120167f, 50.408974f,104.898394f,
                    50.340957f,104.811685f, 50.367215f,104.699160f, 50.324107f,104.650171f, 50.301144f,104.561207f, 50.311627f,104.391917f,
                    50.244970f,104.340154f, 50.241788f,104.293170f, 50.201199f,104.278330f, 50.139350f,104.139193f, 50.150297f,103.998557f,
                    50.197561f,103.846631f, 50.151682f,103.800412f, 50.163815f,103.751510f, 50.124464f,103.710233f, 50.144055f,103.608458f,
                    50.166202f,103.602337f, 50.162679f,103.557250f, 50.199072f,103.514193f, 50.211781f,103.411403f, 50.192893f,103.256290f,
                    50.284896f,103.276425f, 50.331450f,103.206442f, 50.306018f,103.147235f, 50.305663f,103.008762f, 52.149600f,103.008762f,
                    52.149600f,107.076564f);
            poly[2592] = new TzPolygon(50.631654f,108.093515f, 50.312034f,108.093515f, 50.341001f,108.003578f, 50.264004f,107.922644f, 50.240486f,107.940428f,
                    50.153205f,107.734458f, 49.991210f,107.796884f, 49.970584f,107.754305f, 49.988130f,107.702072f, 49.969779f,107.598704f,
                    49.985686f,107.544828f, 49.971669f,107.428258f, 50.003834f,107.319441f, 49.988246f,107.257167f, 50.013399f,107.169001f,
                    50.043321f,107.152003f, 50.066862f,107.076564f, 50.631654f,107.076564f);
            poly[2593] = new TzPolygon(50.064685f,107.076564f, 50.062112f,107.078694f, 49.988246f,107.257167f, 50.003834f,107.319441f, 49.971669f,107.428258f,
                    49.985686f,107.544828f, 49.969779f,107.598704f, 49.987955f,107.706604f, 49.933171f,107.794221f, 49.960970f,107.828742f,
                    49.936456f,107.853196f, 49.941395f,107.969055f, 49.875400f,107.919200f, 49.819200f,107.936700f, 49.802800f,107.981600f,
                    49.784800f,107.948500f, 49.747400f,107.969800f, 49.711400f,107.934300f, 49.670600f,107.947100f, 49.654800f,107.968300f,
                    49.673400f,108.023000f, 49.622300f,108.027500f, 49.592405f,108.093515f, 49.113709f,108.093515f, 49.113709f,107.076564f);
            poly[2594] = new TzPolygon(50.631654f,108.311979f, 50.619287f,108.338337f, 50.622678f,108.407532f, 50.594503f,108.482451f, 50.536585f,108.538200f,
                    50.539497f,108.673827f, 50.511031f,108.688688f, 50.453382f,108.617904f, 50.472495f,108.533627f, 50.449639f,108.469571f,
                    50.463533f,108.433392f, 50.419491f,108.406675f, 50.394310f,108.340143f, 50.412224f,108.207093f, 50.304977f,108.115427f,
                    50.312034f,108.093515f, 50.631654f,108.093515f);
            poly[2595] = new TzPolygon(49.592405f,108.093515f, 49.561800f,108.161100f, 49.539900f,108.297800f, 49.427900f,108.356400f, 49.413500f,108.425800f,
                    49.372100f,108.431000f, 49.322700f,108.517500f, 49.347300f,108.652500f, 49.326600f,108.848800f, 49.346200f,108.941600f,
                    49.323200f,109.058100f, 49.334364f,109.110466f, 49.113709f,109.110466f, 49.113709f,108.093515f);
            poly[2596] = new TzPolygon(50.631654f,108.311979f, 50.665875f,108.239046f, 50.649862f,108.181947f, 50.739755f,108.069161f, 50.774042f,108.060730f,
                    50.828810f,108.215179f, 50.824182f,108.267158f, 50.910039f,108.261036f, 51.063070f,108.341615f, 51.053613f,108.453946f,
                    51.120579f,108.562802f, 51.178227f,108.557620f, 51.238384f,108.425423f, 51.229772f,108.384819f, 51.250583f,108.375017f,
                    51.295353f,108.461403f, 51.405109f,108.500997f, 51.408788f,108.617025f, 51.491404f,108.625228f, 51.504140f,108.680291f,
                    51.436740f,108.785362f, 51.458701f,108.850711f, 51.430969f,108.916496f, 51.474996f,109.046804f, 51.517888f,109.061105f,
                    51.475314f,109.110466f, 50.631654f,109.110466f);
            poly[2597] = new TzPolygon(51.831669f,111.144367f, 51.791939f,111.015807f, 51.734397f,111.013560f, 51.675122f,110.841647f, 51.619853f,110.872871f,
                    51.589203f,110.849650f, 51.582866f,110.776953f, 51.514836f,110.706305f, 51.502319f,110.523151f, 51.524123f,110.424613f,
                    51.587857f,110.393908f, 51.616213f,109.974140f, 51.586960f,109.949730f, 51.449096f,109.620423f, 51.431606f,109.420549f,
                    51.399748f,109.383869f, 51.368715f,109.419402f, 51.353476f,109.393618f, 51.397460f,109.316656f, 51.365062f,109.226883f,
                    51.431997f,109.119142f, 51.462918f,109.124838f, 51.475314f,109.110466f, 52.149600f,109.110466f, 52.149600f,111.144367f);
            poly[2598] = new TzPolygon(49.334364f,109.110466f, 49.352300f,109.194600f, 49.324900f,109.345500f, 49.220800f,109.559100f, 49.205700f,109.902600f,
                    49.154200f,110.199800f, 49.199100f,110.328100f, 49.251500f,110.390500f, 49.190100f,110.524400f, 49.171900f,110.730200f,
                    49.276488f,111.144367f, 49.113709f,111.144367f, 49.113709f,109.110466f);
            poly[2599] = new TzPolygon(49.113709f,112.207988f, 49.127320f,112.198120f, 49.304687f,112.166686f, 49.391886f,111.996056f, 49.484400f,112.278300f,
                    49.522500f,112.474100f, 49.504100f,112.688900f, 49.519300f,112.823400f, 49.608200f,113.043900f, 49.828300f,113.206100f,
                    49.935448f,113.473924f, 49.973600f,113.488800f, 49.991000f,113.636100f, 50.074900f,113.742700f, 50.104900f,113.878700f,
                    50.243000f,114.178400f, 50.282700f,114.338800f, 50.233500f,114.467700f, 50.247200f,114.653500f, 50.217000f,114.856700f,
                    50.163900f,115.007500f, 50.083300f,115.079300f, 49.996098f,115.212170f, 49.113709f,115.212170f);
        }
    }

    private static class Initializer27 {
        private static void init() {
            poly[2600] = new TzPolygon(52.149600f,111.910233f, 52.118985f,111.894616f, 52.068477f,111.774307f, 51.975481f,111.714559f, 51.957221f,111.615343f,
                    51.927920f,111.595801f, 51.913580f,111.515127f, 51.871342f,111.463140f, 51.877718f,111.347438f, 51.838802f,111.287072f,
                    51.832959f,111.148540f, 51.831669f,111.144367f, 52.149600f,111.144367f);
            poly[2601] = new TzPolygon(49.276488f,111.144367f, 49.306800f,111.264400f, 49.357700f,111.374800f, 49.323200f,111.523100f, 49.384200f,111.689000f,
                    49.374200f,111.841700f, 49.391886f,111.996056f, 49.304687f,112.166686f, 49.127320f,112.198120f, 49.113709f,112.207988f,
                    49.113709f,111.144367f);
            poly[2602] = new TzPolygon(54.184945f,71.296101f, 54.164317f,71.269255f, 54.184945f,71.269255f);
            poly[2603] = new TzPolygon(54.184945f,71.296101f, 54.158410f,71.490827f, 54.101146f,71.487873f, 54.105476f,71.677329f, 52.149600f,71.677329f,
                    52.149600f,71.296101f);
            poly[2604] = new TzPolygon(54.668015f,71.269255f, 54.667751f,71.293212f, 54.605815f,71.291265f, 54.606956f,71.269255f);
            poly[2605] = new TzPolygon(56.765223f,71.269255f, 56.765223f,71.677329f, 56.752901f,71.565589f, 56.670291f,71.553729f, 56.678879f,71.381898f,
                    56.631768f,71.369887f, 56.655288f,71.269255f);
            poly[2606] = new TzPolygon(57.122178f,71.269255f, 57.085245f,71.297296f, 56.932929f,71.604991f, 56.765223f,71.677329f, 56.765223f,71.269255f);
            poly[2607] = new TzPolygon(54.693717f,72.517243f, 53.942450f,72.517243f, 53.900754f,72.486688f, 53.944367f,72.369690f, 54.046420f,72.435479f,
                    54.083348f,72.369583f, 54.108698f,72.378316f, 54.101983f,72.433081f, 54.119958f,72.440034f, 54.105059f,72.512947f,
                    54.139971f,72.507003f, 54.186843f,72.299341f, 54.246492f,72.337080f, 54.249641f,72.290710f, 54.317187f,72.278667f,
                    54.357821f,72.192975f, 54.366470f,72.032698f, 54.327267f,72.043743f, 54.305079f,72.136123f, 54.218790f,72.085298f,
                    54.181884f,72.218467f, 54.120593f,72.184306f, 54.147641f,72.101236f, 54.173906f,72.115626f, 54.183714f,72.064776f,
                    54.199573f,72.073333f, 54.243698f,71.948975f, 54.231643f,71.885862f, 54.254150f,71.751217f, 54.187534f,71.726495f,
                    54.147285f,71.764140f, 54.106462f,71.720459f, 54.100030f,71.677329f, 54.693717f,71.677329f);
            poly[2608] = new TzPolygon(53.533412f,73.357157f, 53.567274f,73.238533f, 53.639434f,73.277100f, 53.674228f,73.252896f, 53.675739f,73.322786f,
                    53.788044f,73.343149f, 53.790592f,73.357157f);
            poly[2609] = new TzPolygon(53.944581f,73.357157f, 53.942662f,73.275814f, 53.985495f,73.066826f, 54.040323f,73.059659f, 54.049464f,72.978488f,
                    54.098518f,72.994133f, 54.097974f,72.831662f, 54.121566f,72.825404f, 54.137051f,72.608360f, 54.121951f,72.612859f,
                    54.116448f,72.560163f, 54.043559f,72.532725f, 54.044800f,72.679902f, 53.950890f,72.714483f, 53.979229f,72.544195f,
                    53.942450f,72.517243f, 54.693717f,72.517243f, 54.693717f,73.357157f);
            poly[2610] = new TzPolygon(53.533412f,73.357157f, 53.790592f,73.357157f, 53.807320f,73.449130f, 53.876186f,73.452278f, 53.856229f,73.690957f,
                    54.054055f,73.767675f, 54.070136f,73.627372f, 54.046334f,73.657139f, 54.008358f,73.608847f, 54.004116f,73.518762f,
                    53.941003f,73.522391f, 53.978857f,73.402588f, 53.945681f,73.403796f, 53.944581f,73.357157f, 54.693717f,73.357157f,
                    54.693717f,75.036986f, 53.796999f,75.036986f, 53.822461f,74.982322f, 53.828117f,74.788442f, 53.744251f,74.757017f,
                    53.755990f,74.667726f, 53.668046f,74.634885f, 53.691100f,74.457114f, 53.593864f,74.421017f, 53.572403f,74.486661f,
                    53.455924f,74.382913f, 53.491748f,74.291713f, 53.560321f,74.287373f, 53.569036f,74.234389f, 53.588047f,74.243181f,
                    53.601432f,74.161652f, 53.555076f,74.146289f, 53.566185f,74.051521f, 53.629467f,74.071981f, 53.651137f,73.900775f,
                    53.578258f,73.820899f, 53.613151f,73.666315f, 53.552716f,73.645043f, 53.559178f,73.593852f, 53.519454f,73.579731f,
                    53.435395f,73.438266f, 53.467588f,73.362268f, 53.521859f,73.397630f);
            poly[2611] = new TzPolygon(53.796999f,75.036986f, 53.792666f,75.046288f, 53.941848f,75.330151f, 53.972351f,75.441077f, 54.069969f,75.375108f,
                    54.115014f,75.528774f, 54.098760f,75.597763f, 54.260017f,76.202926f, 54.276096f,76.227822f, 54.301553f,76.186484f,
                    54.359271f,76.257290f, 54.318240f,76.475925f, 54.336778f,76.645675f, 54.405521f,76.716814f, 54.148527f,76.716814f,
                    54.124448f,76.645020f, 54.162005f,76.616280f, 54.148793f,76.582682f, 54.167331f,76.440440f, 54.122572f,76.434915f,
                    54.031786f,76.504100f, 53.919487f,76.716814f, 52.149600f,76.716814f, 52.149600f,75.036986f);
            poly[2612] = new TzPolygon(54.693717f,75.036986f, 54.693717f,75.679315f, 54.674207f,75.685818f, 54.672162f,75.738741f, 54.693717f,75.737413f,
                    54.693717f,75.802526f, 54.610047f,75.851391f, 54.540884f,75.804489f, 54.548148f,75.690831f, 54.122864f,75.689282f,
                    54.098760f,75.597763f, 54.115014f,75.528774f, 54.069969f,75.375108f, 53.972351f,75.441077f, 53.941848f,75.330151f,
                    53.792666f,75.046288f, 53.796999f,75.036986f);
            poly[2613] = new TzPolygon(54.405521f,76.716814f, 54.418029f,76.729759f, 54.457768f,76.928961f, 54.415767f,76.952463f, 54.377652f,76.780725f,
                    54.360039f,76.788078f, 54.361144f,76.860201f, 54.301760f,76.878567f, 54.161826f,76.756466f, 54.148527f,76.716814f);
            poly[2614] = new TzPolygon(53.919487f,76.716814f, 53.291410f,77.906506f, 52.767886f,78.396643f, 52.149600f,78.396643f, 52.149600f,76.716814f);
            poly[2615] = new TzPolygon(52.766568f,78.396643f, 53.252634f,77.940863f, 53.367374f,77.889143f, 53.357109f,77.940983f, 53.390022f,77.965809f,
                    53.420739f,77.917439f, 53.448410f,77.922428f, 53.448380f,78.072712f, 53.473462f,78.073514f, 53.506088f,77.928790f,
                    53.572464f,77.910366f, 53.576124f,78.108745f, 53.585845f,78.156399f, 53.621881f,78.156556f, 53.618321f,78.227552f,
                    53.500516f,78.244924f, 53.475552f,78.363225f, 53.481591f,78.396643f);
            poly[2616] = new TzPolygon(55.965775f,75.036986f, 55.965775f,75.463253f, 55.844122f,75.262428f, 55.805322f,75.367335f, 55.740665f,75.369374f,
                    55.730906f,75.230193f, 55.756425f,75.104415f, 55.726830f,75.088010f, 55.709889f,75.129507f, 55.685977f,75.115461f,
                    55.625503f,75.256359f, 55.583898f,75.140769f, 55.540616f,75.220802f, 55.557629f,75.284722f, 55.537966f,75.312352f,
                    55.498050f,75.321737f, 55.447126f,75.162260f, 55.425702f,75.198630f, 55.376634f,75.091537f, 55.352417f,75.177611f,
                    55.285247f,75.203040f, 55.242948f,75.276320f, 55.171141f,75.293763f, 55.129740f,75.260351f, 55.126860f,75.314511f,
                    55.066999f,75.314395f, 55.068434f,75.370589f, 54.991455f,75.407364f, 54.991416f,75.380119f, 54.913586f,75.330815f,
                    54.913295f,75.518156f, 54.884281f,75.492823f, 54.803472f,75.529935f, 54.809688f,75.640661f, 54.693717f,75.679315f,
                    54.693717f,75.036986f);
            poly[2617] = new TzPolygon(54.693717f,75.737413f, 54.699630f,75.737049f, 54.696677f,75.800797f, 54.693717f,75.802526f);
            poly[2618] = new TzPolygon(57.237834f,76.092670f, 56.948222f,76.199212f, 56.887440f,76.263656f, 56.826313f,76.241269f, 56.697120f,76.289144f,
                    56.661922f,76.136095f, 56.616654f,76.150265f, 56.608274f,76.035876f, 56.507456f,75.960766f, 56.498070f,75.854514f,
                    56.414631f,75.832441f, 56.414180f,75.899900f, 56.465573f,75.982610f, 56.444525f,76.017340f, 56.461696f,76.023094f,
                    56.459078f,76.087769f, 56.424098f,76.123801f, 56.419161f,76.064736f, 56.297772f,76.078125f, 56.259398f,76.118349f,
                    56.281875f,76.172465f, 56.181310f,76.303592f, 56.155620f,76.302743f, 56.121431f,76.138614f, 56.154885f,76.120921f,
                    56.163677f,76.014015f, 56.115103f,75.959545f, 56.112635f,75.731579f, 56.036933f,75.653412f, 56.031678f,75.528493f,
                    55.996722f,75.514339f, 55.965775f,75.463253f, 55.965775f,75.036986f, 57.237834f,75.036986f);
            poly[2619] = new TzPolygon(57.207668f,76.716814f, 57.212784f,76.695583f, 57.235314f,76.094728f, 57.237834f,76.092670f, 57.237834f,76.716814f);
            poly[2620] = new TzPolygon(57.207668f,76.716814f, 57.237834f,76.716814f, 57.237834f,78.396643f, 57.165153f,78.396643f, 57.158370f,76.921420f);
            poly[2621] = new TzPolygon(52.767886f,78.396643f, 52.149600f,78.975499f, 52.149600f,78.396643f);
            poly[2622] = new TzPolygon(54.693717f,80.076471f, 54.051070f,80.076471f, 54.044730f,80.050758f, 54.011865f,80.076471f, 53.984985f,80.076471f,
                    53.914954f,79.864751f, 53.842060f,79.887675f, 53.810269f,79.666295f, 53.794538f,79.623699f, 53.743699f,79.639590f,
                    53.678162f,79.421817f, 53.710189f,79.385491f, 53.703883f,79.298997f, 53.677494f,79.258023f, 53.674383f,79.122476f,
                    53.698245f,79.088054f, 53.652680f,79.040640f, 53.676637f,78.942088f, 53.630875f,78.707661f, 53.651486f,78.690265f,
                    53.636890f,78.616062f, 53.582317f,78.652093f, 53.513198f,78.644689f, 53.503574f,78.558011f, 53.530546f,78.500536f,
                    53.511288f,78.502196f, 53.512335f,78.421704f, 53.485972f,78.420883f, 53.481591f,78.396643f, 54.693717f,78.396643f);
            poly[2623] = new TzPolygon(53.948805f,81.756300f, 53.947653f,81.750633f, 53.973573f,81.705656f, 53.986391f,81.730842f, 53.981223f,81.664785f,
                    53.905854f,81.540841f, 54.004292f,81.565701f, 54.020344f,81.613804f, 54.028921f,81.494206f, 54.075658f,81.467618f,
                    54.051377f,81.384078f, 54.091762f,81.322901f, 54.081586f,81.276581f, 54.113991f,81.208850f, 54.111758f,81.131997f,
                    54.375455f,80.951725f, 54.343612f,80.812028f, 54.245954f,80.863738f, 54.233510f,80.815893f, 54.257570f,80.797116f,
                    54.182838f,80.637280f, 54.196855f,80.622552f, 54.169547f,80.534893f, 54.125051f,80.571284f, 54.105290f,80.517297f,
                    54.115570f,80.459762f, 54.031519f,80.218595f, 54.079464f,80.191633f, 54.051070f,80.076471f, 54.693717f,80.076471f,
                    54.693717f,81.756300f);
            poly[2624] = new TzPolygon(54.011865f,80.076471f, 53.990511f,80.093179f, 53.984985f,80.076471f);
            poly[2625] = new TzPolygon(53.759889f,81.756300f, 53.776606f,81.715004f, 53.804266f,81.752413f, 53.843335f,81.721057f, 53.851829f,81.756300f);
            poly[2626] = new TzPolygon(56.281946f,81.756300f, 56.241888f,81.573403f, 56.537593f,81.220274f, 56.422446f,80.263517f, 56.923160f,79.588576f,
                    57.117342f,78.432083f, 57.165387f,78.447513f, 57.165153f,78.396643f, 57.237834f,78.396643f, 57.237834f,81.756300f);
            poly[2627] = new TzPolygon(53.851829f,81.756300f, 53.871087f,81.836208f, 53.964299f,81.832539f, 53.948805f,81.756300f, 54.693717f,81.756300f,
                    54.693717f,83.436128f, 53.945379f,83.436128f, 53.934700f,83.360115f, 54.084966f,83.300888f, 54.051269f,83.274997f,
                    54.065805f,83.197844f, 54.006337f,83.084460f, 53.979020f,83.110800f, 53.990641f,83.088613f, 53.777518f,82.714469f,
                    53.749753f,82.760436f, 53.669261f,82.621075f, 53.642646f,82.666326f, 53.547311f,82.502126f, 53.504180f,82.580210f,
                    53.494307f,82.486290f, 53.513475f,82.369902f, 53.564875f,82.330196f, 53.590181f,82.206713f, 53.617027f,82.202218f,
                    53.604137f,82.154646f, 53.678090f,82.191431f, 53.647129f,82.138848f, 53.719720f,81.953373f, 53.714219f,81.851866f,
                    53.684634f,81.817622f, 53.743798f,81.796052f, 53.759889f,81.756300f);
            poly[2628] = new TzPolygon(53.945379f,83.436128f, 53.947391f,83.450454f, 53.973742f,83.442258f, 53.978509f,83.488070f, 54.063209f,83.475946f,
                    54.109323f,83.554216f, 54.100974f,83.729011f, 54.127820f,83.829092f, 54.121413f,83.883611f, 54.088543f,83.855695f,
                    54.079841f,83.878190f, 54.193454f,84.229335f, 54.156464f,84.278693f, 54.177941f,84.397799f, 54.138776f,84.437181f,
                    54.161938f,84.551035f, 54.235886f,84.576016f, 54.292779f,84.670910f, 54.344686f,84.798624f, 54.325608f,84.825087f,
                    54.436352f,85.115957f, 52.149600f,85.115957f, 52.149600f,83.436128f);
            poly[2629] = new TzPolygon(54.437830f,85.115957f, 54.608772f,84.931165f, 54.637502f,85.011158f, 54.679859f,85.004051f, 54.693717f,84.973038f,
                    54.693717f,85.115957f);
            poly[2630] = new TzPolygon(55.722023f,83.436128f, 55.710601f,83.336790f, 55.689008f,83.315102f, 55.730319f,83.210779f, 55.855875f,83.316456f,
                    55.852681f,83.382134f, 55.896018f,83.375685f, 55.895182f,83.400827f, 55.961171f,83.313710f, 55.979045f,83.340379f,
                    56.012006f,83.229571f, 56.056269f,83.233748f, 56.095592f,83.302146f, 56.114154f,83.273664f, 56.086164f,83.221324f,
                    56.120356f,83.129390f, 56.207738f,83.211911f, 56.230477f,83.064840f, 56.327988f,83.192988f, 56.375943f,83.144219f,
                    56.408585f,83.259964f, 56.442797f,83.288374f, 56.550308f,83.108747f, 56.516457f,83.028213f, 56.537759f,82.946159f,
                    56.516173f,82.807971f, 56.464712f,82.791492f, 56.434828f,82.824623f, 56.399600f,82.748233f, 56.425517f,82.689596f,
                    56.405300f,82.500698f, 56.357303f,82.340366f, 56.333547f,81.991904f, 56.281946f,81.756300f, 57.237834f,81.756300f,
                    57.237834f,83.436128f);
            poly[2631] = new TzPolygon(55.965775f,83.436128f, 55.965775f,83.906076f, 55.908148f,83.854425f, 55.901964f,83.807646f, 55.852032f,83.787459f,
                    55.836360f,83.739872f, 55.786027f,83.735359f, 55.748696f,83.643634f, 55.605838f,83.604941f, 55.670765f,83.585404f,
                    55.706691f,83.501750f, 55.670226f,83.443539f, 55.723099f,83.445489f, 55.722023f,83.436128f);
            poly[2632] = new TzPolygon(55.965775f,84.534048f, 55.952786f,84.528483f, 55.955324f,84.480760f, 55.922170f,84.536238f, 55.894304f,84.456067f,
                    55.832854f,84.574851f, 55.801605f,84.552087f, 55.799646f,84.607771f, 55.765559f,84.607746f, 55.761033f,84.527285f,
                    55.718052f,84.540045f, 55.669036f,84.711357f, 55.652988f,84.679285f, 55.642731f,84.741817f, 55.529037f,84.785524f,
                    55.523045f,84.727749f, 55.467454f,84.755648f, 55.404216f,84.620791f, 55.372805f,84.693853f, 55.375264f,84.859235f,
                    55.324291f,84.916872f, 55.277748f,84.915761f, 55.227091f,84.818268f, 55.163608f,84.927189f, 55.058678f,84.905596f,
                    54.996910f,84.837013f, 54.952149f,84.887537f, 54.944804f,84.971513f, 54.855581f,85.079092f, 54.844281f,85.047154f,
                    54.816370f,85.088096f, 54.800006f,85.002657f, 54.779620f,85.013217f, 54.781236f,84.964273f, 54.728533f,84.895124f,
                    54.693717f,84.973038f, 54.693717f,84.276043f, 55.965775f,84.276043f);
            poly[2633] = new TzPolygon(55.965775f,84.539141f, 56.004842f,84.571196f, 56.028763f,84.527029f, 56.015805f,84.472341f, 56.041571f,84.447895f,
                    56.161976f,84.885656f, 56.108958f,85.002631f, 56.193974f,85.115957f, 55.965775f,85.115957f);
            poly[2634] = new TzPolygon(55.965775f,83.906076f, 56.015056f,83.950245f, 56.018402f,84.086449f, 56.059869f,84.210002f, 55.980996f,84.342563f,
                    56.042374f,84.438313f, 56.015805f,84.472341f, 56.020067f,84.557307f, 55.965775f,84.534048f);
            poly[2635] = new TzPolygon(54.436352f,85.115957f, 54.453110f,85.159972f, 54.185544f,85.417784f, 54.224563f,85.538478f, 54.198811f,85.563206f,
                    54.214501f,85.624222f, 54.143851f,85.690512f, 54.163264f,85.748616f, 54.037557f,85.871253f, 53.980896f,86.124254f,
                    53.811626f,86.184139f, 53.829952f,86.300385f, 53.597287f,86.393733f, 53.608009f,86.426551f, 53.527643f,86.538865f,
                    53.451447f,86.813633f, 53.477612f,86.833749f, 53.503674f,86.930329f, 53.473515f,86.929022f, 53.451288f,86.868180f,
                    53.413720f,86.905182f, 53.377633f,86.858418f, 53.319581f,86.848700f, 53.322806f,86.822289f, 53.244444f,86.753298f,
                    53.238661f,86.688141f, 53.262479f,86.655436f, 53.240054f,86.627310f, 53.181377f,86.643953f, 53.193540f,86.711589f,
                    53.152485f,86.719783f, 53.147343f,86.849312f, 53.083015f,86.874548f, 53.041223f,87.054578f, 52.899184f,87.007914f,
                    52.875039f,86.929334f, 52.846971f,86.912424f, 52.830933f,86.948337f, 52.756058f,86.974836f, 52.723808f,87.069717f,
                    52.695915f,87.066492f, 52.690075f,87.094298f, 52.717532f,87.114041f, 52.710210f,87.163682f, 52.598563f,87.118880f,
                    52.573210f,87.197136f, 52.585118f,87.259300f, 52.149600f,87.259300f, 52.149600f,85.115957f);
            poly[2636] = new TzPolygon(52.461449f,88.330972f, 52.464244f,88.317271f, 52.414455f,88.281036f, 52.400058f,88.231529f, 52.511055f,88.021112f,
                    52.539479f,87.891369f, 52.491026f,87.845122f, 52.484868f,87.755305f, 52.422416f,87.653327f, 52.471480f,87.611621f,
                    52.498746f,87.371806f, 52.573691f,87.371190f, 52.592370f,87.297162f, 52.585118f,87.259300f, 54.008082f,87.259300f,
                    54.008082f,88.330972f);
            poly[2637] = new TzPolygon(52.460906f,88.330972f, 52.432956f,88.445685f, 52.378341f,88.406032f, 52.341503f,88.463945f, 52.273215f,88.380374f,
                    52.149600f,88.378610f, 52.149600f,88.330972f);
            poly[2638] = new TzPolygon(52.149600f,88.377654f, 52.178313f,88.376964f, 52.169832f,88.473705f, 52.215723f,88.540775f, 52.251665f,88.703757f,
                    52.308354f,88.715442f, 52.334204f,88.676306f, 52.363788f,88.699479f, 52.495626f,88.986759f, 52.595360f,89.062215f,
                    52.591005f,89.116895f, 52.705816f,89.053054f, 52.706822f,89.137409f, 52.782979f,89.188028f, 52.800689f,89.239750f,
                    52.881535f,89.184436f, 52.863294f,89.127799f, 52.880264f,89.103364f, 52.958189f,89.075433f, 52.965951f,88.972378f,
                    52.950451f,88.956705f, 52.990433f,88.911797f, 53.030970f,88.941928f, 53.045191f,88.919476f, 53.076792f,89.008181f,
                    53.078841f,89.008693f, 53.078841f,89.402644f, 52.149600f,89.402644f);
            poly[2639] = new TzPolygon(54.008082f,89.005850f, 54.003970f,89.005484f, 53.972464f,89.061692f, 53.938910f,89.044626f, 53.956496f,89.074112f,
                    53.951833f,89.196839f, 53.914546f,89.206500f, 53.885376f,89.165089f, 53.818898f,89.239109f, 53.796023f,89.187644f,
                    53.786147f,89.037960f, 53.654265f,88.994330f, 53.643893f,88.941601f, 53.611549f,88.933916f, 53.594567f,88.838081f,
                    53.560831f,88.888953f, 53.532190f,88.857235f, 53.492547f,88.874947f, 53.464000f,88.859936f, 53.465215f,88.819630f,
                    53.359175f,88.756957f, 53.343808f,88.806406f, 53.383284f,88.849751f, 53.392139f,88.910521f, 53.317429f,88.945876f,
                    53.280057f,89.036455f, 53.231869f,89.054781f, 53.196190f,89.005738f, 53.154424f,89.076209f, 53.117654f,89.018389f,
                    53.078841f,89.008693f, 53.078841f,88.330972f, 54.008082f,88.330972f);
            poly[2640] = new TzPolygon(54.008082f,89.005850f, 54.080741f,89.012320f, 54.108974f,89.041639f, 54.138645f,89.163789f, 54.265603f,89.238394f,
                    54.345715f,89.125804f, 54.331375f,89.029732f, 54.287739f,88.975172f, 54.386320f,88.927541f, 54.419086f,88.851288f,
                    54.327541f,88.662134f, 54.281093f,88.632625f, 54.288254f,88.581588f, 54.337789f,88.558052f, 54.350357f,88.406730f,
                    54.382062f,88.363813f, 54.432470f,88.546551f, 54.455722f,88.518040f, 54.479391f,88.568741f, 54.616961f,88.578230f,
                    54.667203f,88.622847f, 54.683050f,88.595401f, 54.725857f,88.648647f, 54.756530f,88.635811f, 54.768861f,88.732453f,
                    54.797013f,88.755164f, 54.888913f,88.743688f, 54.875196f,88.687834f, 54.895369f,88.647521f, 54.952156f,88.672776f,
                    54.961648f,88.608182f, 55.001986f,88.599541f, 55.003475f,88.548339f, 55.119048f,88.560741f, 55.159034f,88.508264f,
                    55.212754f,88.513910f, 55.256773f,88.433191f, 55.304842f,88.441410f, 55.342633f,88.535042f, 55.527704f,88.686295f,
                    55.660204f,88.913599f, 55.691771f,89.130054f, 55.734029f,89.181455f, 55.770388f,89.348581f, 55.811453f,89.332535f,
                    55.840229f,89.399929f, 55.866563f,89.402644f, 54.008082f,89.402644f);
            poly[2641] = new TzPolygon(57.237834f,87.259300f, 56.632065f,87.259300f, 56.630271f,87.242787f, 56.664294f,87.172663f, 56.658024f,87.138734f,
                    56.606946f,87.156415f, 56.611008f,87.181821f, 56.587331f,87.158598f, 56.571027f,87.226625f, 56.534320f,87.092083f,
                    56.541910f,87.000494f, 56.578898f,86.969635f, 56.540903f,86.909466f, 56.553126f,86.859303f, 56.626212f,86.804658f,
                    56.603176f,86.746245f, 56.643265f,86.678190f, 56.588123f,86.622200f, 56.613592f,86.591258f, 56.548269f,86.440132f,
                    56.555598f,86.377677f, 56.594563f,86.364136f, 56.592011f,86.334439f, 56.636075f,86.338887f, 56.623997f,86.204623f,
                    56.578759f,86.195642f, 56.539219f,86.106991f, 56.500949f,86.115687f, 56.482318f,86.000625f, 56.436736f,85.986579f,
                    56.412063f,85.804296f, 56.334497f,85.794741f, 56.343920f,85.728296f, 56.280707f,85.562492f, 56.211708f,85.684519f,
                    56.211113f,85.452274f, 56.194967f,85.453073f, 56.228212f,85.228184f, 56.197832f,85.207780f, 56.193974f,85.115957f,
                    57.237834f,85.115957f);
            poly[2642] = new TzPolygon(57.237834f,88.330972f, 56.811331f,88.330972f, 56.668209f,88.050881f, 56.543607f,87.654310f, 56.600611f,87.654000f,
                    56.663656f,87.596665f, 56.592957f,87.364580f, 56.610960f,87.347585f, 56.627060f,87.403373f, 56.645611f,87.383977f,
                    56.632065f,87.259300f, 57.237834f,87.259300f);
            poly[2643] = new TzPolygon(56.795873f,88.330972f, 56.825592f,88.355923f, 56.834420f,88.424416f, 56.768973f,88.523953f, 56.820376f,88.648295f,
                    56.719298f,88.624413f, 56.714701f,88.736076f, 56.682136f,88.718487f, 56.680068f,88.674013f, 56.619767f,88.663149f,
                    56.621890f,88.500879f, 56.529922f,88.546388f, 56.531252f,88.605597f, 56.430664f,88.593416f, 56.418183f,88.696484f,
                    56.366430f,88.695147f, 56.372908f,88.860922f, 56.333893f,88.920763f, 56.302070f,88.900796f, 56.300484f,89.039898f,
                    56.201266f,89.036652f, 56.184532f,89.126689f, 56.151022f,89.104815f, 56.139526f,89.201608f, 56.080891f,89.192979f,
                    56.056595f,89.282448f, 55.995096f,89.241647f, 55.896726f,89.271098f, 55.866563f,89.402644f, 55.866563f,88.330972f);
            poly[2644] = new TzPolygon(57.237834f,88.749175f, 57.208035f,88.734155f, 57.209350f,88.622505f, 57.125396f,88.554806f, 57.124933f,88.504084f,
                    57.090443f,88.516982f, 57.092294f,88.714554f, 56.802210f,88.596967f, 56.768973f,88.523953f, 56.834420f,88.424416f,
                    56.827940f,88.363476f, 56.811331f,88.330972f, 57.237834f,88.330972f);
            poly[2645] = new TzPolygon(57.461580f,75.802602f, 57.624997f,75.704125f, 57.625219f,75.550039f, 57.934585f,75.565762f, 58.116793f,75.071473f,
                    58.202615f,75.242489f, 58.339153f,75.056665f, 58.454101f,75.376835f, 58.575719f,75.109428f, 58.618682f,75.199295f,
                    58.663889f,75.131298f, 58.912346f,75.635376f, 58.968584f,75.701148f, 59.015373f,75.727608f, 59.211711f,75.638128f,
                    59.268036f,75.802602f);
            poly[2646] = new TzPolygon(58.351546f,71.269255f, 58.383454f,71.311576f, 58.399325f,71.269255f, 65.479795f,71.269255f, 65.479795f,75.802602f,
                    59.268036f,75.802602f, 59.211711f,75.638128f, 59.015373f,75.727608f, 58.968584f,75.701148f, 58.912346f,75.635376f,
                    58.663889f,75.131298f, 58.618682f,75.199295f, 58.493586f,74.951106f, 58.428016f,74.911783f, 58.356295f,74.669669f,
                    58.286758f,74.625867f, 58.242033f,74.455494f, 58.136298f,74.219631f, 58.155304f,73.128288f, 58.069963f,72.948049f,
                    58.004540f,72.875762f, 57.996748f,72.811536f, 58.014698f,72.167156f, 58.086335f,72.089906f, 58.115843f,71.990196f,
                    58.062616f,71.453438f, 58.077779f,71.326795f, 58.065272f,71.269255f);
            poly[2647] = new TzPolygon(57.461580f,75.802602f, 57.385801f,75.848268f, 57.393694f,75.965411f, 57.237834f,76.092670f, 57.237834f,75.802602f);
            poly[2648] = new TzPolygon(61.358814f,78.069276f, 60.787749f,78.069276f, 60.740696f,77.969963f, 60.819990f,77.704323f, 60.810981f,77.432839f,
                    60.858520f,77.110482f, 60.794034f,77.067173f, 60.744261f,77.113811f, 60.705290f,77.097546f, 60.692974f,77.014167f,
                    60.653783f,77.009356f, 60.660845f,76.961555f, 60.628484f,76.955640f, 60.612074f,77.063745f, 60.523327f,77.072045f,
                    60.468751f,76.799348f, 60.421192f,76.812846f, 60.377619f,76.756215f, 60.328113f,76.764441f, 60.274762f,76.866911f,
                    60.179729f,76.827956f, 60.115555f,76.714021f, 60.065674f,76.772433f, 59.991184f,76.772889f, 59.711208f,76.740547f,
                    59.685041f,76.668362f, 59.571174f,76.664888f, 59.543769f,76.502464f, 59.530001f,76.177166f, 59.382552f,75.987835f,
                    59.400331f,75.898194f, 59.280959f,75.840339f, 59.268036f,75.802602f, 61.358814f,75.802602f);
            poly[2649] = new TzPolygon(60.724861f,80.335949f, 60.675322f,80.200997f, 60.686547f,79.653362f, 60.634863f,79.390266f, 60.720734f,79.288479f,
                    60.796191f,79.308158f, 60.826272f,79.212947f, 60.819692f,79.101576f, 60.799941f,79.083266f, 60.820424f,78.985516f,
                    60.791843f,78.964610f, 60.797956f,78.919803f, 60.749188f,78.795518f, 60.825218f,78.697947f, 60.763884f,78.487268f,
                    60.802351f,78.194368f, 60.796784f,78.088345f, 60.787749f,78.069276f, 61.358814f,78.069276f, 61.358814f,80.335949f);
            poly[2650] = new TzPolygon(69.330630f,80.335949f, 69.365988f,80.236667f, 69.347896f,80.120282f, 69.370075f,80.121532f, 69.341382f,79.958607f,
                    69.363824f,79.903488f, 69.345536f,79.824395f, 69.366532f,79.869869f, 69.391649f,79.766587f, 69.424468f,79.795473f,
                    69.428579f,79.661787f, 69.443172f,79.698372f, 69.456517f,79.616909f, 69.593397f,79.554720f, 69.600775f,79.500053f,
                    69.600775f,80.335949f);
            poly[2651] = new TzPolygon(72.687575f,78.069276f, 73.025094f,77.764730f, 73.639539f,77.729901f, 73.655967f,78.069276f);
            poly[2652] = new TzPolygon(69.690373f,79.202613f, 69.695444f,79.042148f, 69.743861f,79.165030f, 69.750333f,79.087941f, 69.786615f,79.124523f,
                    69.806612f,78.995000f, 69.834629f,79.044842f, 69.880100f,78.880529f, 69.886546f,78.990458f, 69.972625f,79.202613f);
            poly[2653] = new TzPolygon(69.973041f,79.202613f, 69.989871f,79.142760f, 70.005879f,79.170411f, 69.997191f,79.116594f, 70.022696f,79.169713f,
                    70.017336f,79.202613f);
            poly[2654] = new TzPolygon(71.317391f,79.202613f, 71.332855f,79.175292f, 71.389899f,79.129585f, 71.415466f,79.202613f);
            poly[2655] = new TzPolygon(71.661266f,80.098755f, 71.655143f,80.018390f, 71.603648f,79.970707f, 71.580677f,79.823935f, 71.603859f,79.712348f,
                    71.606237f,79.366714f, 71.586591f,79.312296f, 71.528345f,79.371675f, 71.454336f,79.313637f, 71.414296f,79.202613f,
                    71.661266f,79.202613f);
            poly[2656] = new TzPolygon(71.322858f,79.202613f, 71.307417f,79.220234f, 71.296142f,79.433874f, 71.116462f,79.996963f, 71.074149f,80.335949f,
                    70.425425f,80.334148f, 70.435726f,80.222912f, 70.390601f,80.216942f, 70.387333f,80.109366f, 70.342495f,80.124283f,
                    70.328029f,80.013340f, 70.263333f,79.907251f, 70.275710f,79.755067f, 70.236657f,79.790750f, 70.232815f,79.666234f,
                    70.117016f,79.549635f, 70.125132f,79.405545f, 70.154682f,79.423610f, 70.149651f,79.333372f, 70.045558f,79.369504f,
                    70.063962f,79.331116f, 70.060161f,79.220603f, 70.011394f,79.239085f, 70.017336f,79.202613f);
            poly[2657] = new TzPolygon(69.690373f,79.202613f, 69.688345f,79.266793f, 69.647925f,79.384863f, 69.659888f,79.465386f, 69.636525f,79.451370f,
                    69.627008f,79.510043f, 69.607859f,79.447572f, 69.600775f,79.500053f, 69.600775f,79.202613f);
            poly[2658] = new TzPolygon(72.687575f,78.069276f, 72.669512f,78.085574f, 72.470335f,78.649882f, 72.335171f,78.411144f, 72.298499f,78.488495f,
                    72.285740f,78.611911f, 72.246317f,78.656721f, 72.231340f,78.586724f, 72.210484f,78.628660f, 72.200763f,78.542215f,
                    72.193957f,78.626126f, 72.167442f,78.627009f, 72.167786f,78.757873f, 72.147854f,78.716953f, 72.138334f,78.871865f,
                    72.111478f,78.867973f, 72.125280f,78.944624f, 72.094086f,78.968486f, 72.105608f,79.028589f, 72.060901f,79.054455f,
                    72.078622f,79.183999f, 72.042684f,79.347041f, 72.053329f,79.386502f, 72.031970f,79.371037f, 72.055362f,79.650835f,
                    72.040924f,79.794291f, 72.026799f,79.772911f, 72.020562f,79.871421f, 71.977771f,79.875490f, 71.996139f,79.893962f,
                    71.983648f,80.047203f, 71.947331f,80.066603f, 71.936566f,80.241039f, 71.905803f,80.228510f, 71.885773f,80.335949f,
                    71.872443f,80.335949f, 71.846566f,80.281194f, 71.865034f,80.182614f, 71.835537f,80.163743f, 71.828361f,80.036538f,
                    71.799552f,80.039529f, 71.796409f,80.126964f, 71.757420f,80.148266f, 71.750427f,80.072497f, 71.734327f,80.143443f,
                    71.664637f,80.143005f, 71.661266f,80.098755f, 71.661266f,78.069276f);
            poly[2659] = new TzPolygon(59.890225f,84.869297f, 59.892071f,84.707550f, 59.962095f,84.581069f, 60.029796f,84.633451f, 60.165509f,84.613647f,
                    60.251798f,84.738281f, 60.299171f,84.713628f, 60.352366f,84.791487f, 60.863420f,84.263128f, 61.003499f,84.653920f,
                    61.061402f,84.869297f);
            poly[2660] = new TzPolygon(61.358814f,80.335949f, 61.358814f,84.869297f, 61.061402f,84.869297f, 61.003499f,84.653920f, 60.862518f,84.263110f,
                    60.836217f,83.949694f, 61.035672f,83.476909f, 61.026795f,83.156683f, 60.706879f,82.376451f, 60.608155f,82.409601f,
                    60.516340f,82.167305f, 60.639791f,81.879534f, 60.637983f,81.584263f, 60.607139f,81.458741f, 60.642048f,81.104190f,
                    60.755725f,81.052447f, 60.802779f,80.704837f, 60.770738f,80.639059f, 60.750198f,80.404972f, 60.724861f,80.335949f);
            poly[2661] = new TzPolygon(61.778937f,84.869297f, 61.773046f,84.840892f, 61.808130f,84.677915f, 61.922044f,84.522886f, 62.195657f,84.440860f,
                    62.400496f,84.714108f, 62.457653f,84.869297f);
            poly[2662] = new TzPolygon(64.946529f,84.869297f, 64.957916f,84.830154f, 64.923000f,84.686435f, 64.930743f,84.616685f, 64.908220f,84.587194f,
                    64.927878f,84.549276f, 64.905300f,84.431328f, 64.927765f,84.407874f, 64.899243f,84.381868f, 64.935291f,84.272320f,
                    64.977971f,84.354288f, 64.995697f,84.325554f, 64.994844f,84.360968f, 65.057300f,84.394738f, 65.050932f,84.350452f,
                    65.089242f,84.332451f, 65.058692f,84.300765f, 65.102104f,84.284093f, 65.211184f,84.397766f, 65.248400f,84.544803f,
                    65.317042f,84.567119f, 65.408738f,84.485458f, 65.459548f,84.526238f, 65.479795f,84.503315f, 65.479795f,84.869297f);
            poly[2663] = new TzPolygon(59.895761f,84.869297f, 59.883032f,85.499551f, 59.948568f,86.018937f, 59.948654f,86.636500f, 59.879074f,87.078048f,
                    59.682529f,87.174086f, 59.664410f,87.514225f, 59.256238f,87.902226f, 59.295126f,88.626468f, 59.212216f,88.575826f,
                    59.022605f,88.828660f, 58.893878f,88.383835f, 58.511345f,87.924013f, 58.214258f,88.016988f, 58.220064f,88.069853f,
                    58.112772f,88.106659f, 58.036199f,88.687253f, 57.955186f,88.858954f, 57.949077f,89.297381f, 57.864618f,89.374551f,
                    57.819253f,89.340804f, 57.655867f,89.379033f, 57.615657f,89.355248f, 57.594065f,89.211500f, 57.615341f,89.130337f,
                    57.517209f,89.098764f, 57.497181f,89.158552f, 57.482803f,89.137288f, 57.485498f,89.082818f, 57.502610f,89.090307f,
                    57.454812f,89.053120f, 57.500951f,89.042849f, 57.501420f,88.976081f, 57.438104f,88.944947f, 57.436100f,88.900980f,
                    57.477247f,88.869853f, 57.237834f,88.749175f, 57.237834f,84.869297f);
            poly[2664] = new TzPolygon(61.358814f,84.869297f, 61.358814f,85.646281f, 61.283816f,85.696583f, 61.061402f,84.869297f);
            poly[2665] = new TzPolygon(63.419305f,84.869297f, 63.419305f,85.403295f, 63.393427f,85.374222f, 63.364179f,85.421099f, 63.351142f,85.471993f,
                    63.380033f,85.607796f, 63.355995f,85.708055f, 63.283684f,85.567873f, 63.201534f,85.564508f, 63.181017f,85.502097f,
                    63.114143f,85.515889f, 63.099267f,85.570747f, 63.034473f,85.619849f, 62.981626f,85.502962f, 62.904483f,85.523439f,
                    62.881444f,85.471088f, 62.877892f,85.361575f, 62.801734f,85.217699f, 62.707092f,85.153164f, 62.661353f,85.060384f,
                    62.631683f,85.100168f, 62.553554f,84.895605f, 62.482899f,84.937841f, 62.457653f,84.869297f);
            poly[2666] = new TzPolygon(61.778937f,84.869297f, 61.789838f,84.921858f, 61.751987f,85.096852f, 61.673722f,85.277798f, 61.687147f,85.406556f,
                    61.617216f,85.492853f, 61.572615f,85.712839f, 61.593921f,85.842513f, 61.545120f,85.961137f, 61.459195f,85.965282f,
                    61.454099f,85.798193f, 61.367090f,85.640731f, 61.358814f,85.646281f, 61.358814f,84.869297f);
            poly[2667] = new TzPolygon(64.946529f,84.869297f, 64.935235f,84.908119f, 64.954149f,84.921258f, 64.915127f,85.032414f, 64.863320f,84.922465f,
                    64.836424f,84.944863f, 64.834708f,85.013306f, 64.815508f,85.009956f, 64.827057f,85.131797f, 64.763997f,85.133283f,
                    64.795911f,85.252453f, 64.795039f,85.364297f, 64.852583f,85.529623f, 64.823633f,85.735818f, 64.784335f,85.833713f,
                    64.679925f,85.819372f, 64.598818f,85.905753f, 64.496899f,85.804287f, 64.431646f,85.921623f, 64.272085f,86.007285f,
                    64.127329f,85.931380f, 64.048501f,85.967046f, 63.928271f,85.506213f, 63.870006f,85.481267f, 63.854995f,85.366093f,
                    63.833995f,85.387177f, 63.799503f,85.326219f, 63.796321f,85.373509f, 63.770933f,85.382423f, 63.756041f,85.333155f,
                    63.647649f,85.302541f, 63.607644f,85.229085f, 63.610208f,85.180169f, 63.562733f,85.145257f, 63.596449f,85.062047f,
                    63.582289f,85.023394f, 63.566966f,85.083783f, 63.532066f,85.081715f, 63.522935f,85.221249f, 63.495216f,85.231655f,
                    63.524959f,85.298074f, 63.434468f,85.420330f, 63.419305f,85.403295f, 63.419305f,84.869297f);
            poly[2668] = new TzPolygon(67.044250f,82.602623f, 67.233997f,82.117144f, 67.248743f,82.211337f, 67.283949f,82.197378f, 67.274983f,82.275043f,
                    67.299492f,82.225575f, 67.319569f,82.366745f, 67.343262f,82.351015f, 67.333324f,82.303994f, 67.355520f,82.292809f,
                    67.356636f,82.344918f, 67.360528f,82.289845f, 67.409169f,82.231825f, 67.418973f,82.290999f, 67.432249f,82.251632f,
                    67.445910f,82.317268f, 67.462365f,82.289487f, 67.467503f,82.392646f, 67.489870f,82.340610f, 67.525743f,82.396841f,
                    67.523389f,82.338239f, 67.540285f,82.355273f, 67.540285f,82.602623f);
            poly[2669] = new TzPolygon(67.540285f,82.315721f, 67.533155f,82.290233f, 67.540285f,82.292689f);
            poly[2670] = new TzPolygon(67.540285f,82.267325f, 67.537738f,82.262166f, 67.540285f,82.255722f);
            poly[2671] = new TzPolygon(69.330630f,80.335949f, 69.322592f,80.358521f, 69.331127f,80.432638f, 69.305663f,80.538824f, 69.316787f,80.765519f,
                    69.271529f,80.792265f, 69.237813f,80.931373f, 69.200427f,80.960867f, 69.284426f,81.335078f, 69.248205f,81.437938f,
                    69.252733f,81.469286f, 67.540285f,81.469286f, 67.540285f,80.335949f);
            poly[2672] = new TzPolygon(69.252733f,81.469286f, 69.269522f,81.585507f, 69.316610f,81.676460f, 69.332608f,81.611290f, 69.455111f,81.714328f,
                    69.352549f,81.961172f, 69.253679f,81.805257f, 69.198598f,81.835159f, 69.156849f,82.252054f, 69.173855f,82.395920f,
                    69.152082f,82.466170f, 69.080399f,82.473486f, 69.073964f,82.360662f, 69.047388f,82.316256f, 68.971616f,82.493702f,
                    68.819060f,82.566188f, 68.809758f,82.602623f, 68.271386f,82.602623f, 68.262310f,82.555713f, 68.167067f,82.552209f,
                    68.113932f,82.337415f, 67.971132f,82.397934f, 67.939894f,82.362037f, 67.959532f,81.973863f, 67.929510f,81.827387f,
                    67.947541f,81.767561f, 67.893981f,81.724526f, 67.882941f,81.783617f, 67.785343f,81.870423f, 67.719674f,82.098844f,
                    67.684490f,82.057936f, 67.677945f,82.105246f, 67.644631f,82.027625f, 67.596324f,82.113949f, 67.540285f,82.255722f,
                    67.540285f,81.469286f);
            poly[2673] = new TzPolygon(67.540285f,82.267325f, 67.555377f,82.297888f, 67.540285f,82.292689f);
            poly[2674] = new TzPolygon(67.540285f,82.315721f, 67.555697f,82.370811f, 67.540285f,82.355273f);
            poly[2675] = new TzPolygon(68.809758f,82.602623f, 68.759195f,82.800677f, 68.684453f,82.870239f, 68.641851f,82.837822f, 68.590413f,82.628515f,
                    68.402523f,82.714637f, 68.333877f,82.686904f, 68.278564f,82.639723f, 68.271386f,82.602623f);
            poly[2676] = new TzPolygon(67.044250f,82.602623f, 66.840598f,83.123681f, 66.666761f,83.277275f, 66.658633f,83.327710f, 66.601956f,83.189920f,
                    66.594674f,83.090520f, 66.464769f,83.073548f, 66.403822f,83.116057f, 66.375753f,83.256870f, 66.183679f,83.542522f,
                    66.151712f,83.509166f, 66.119241f,83.351897f, 66.082916f,83.367043f, 66.043577f,83.266926f, 65.956481f,83.367435f,
                    65.902741f,83.551457f, 65.814529f,83.473505f, 65.761979f,83.563395f, 65.789367f,83.762195f, 65.787181f,83.999658f,
                    65.694779f,84.151455f, 65.686093f,84.299349f, 65.617595f,84.282737f, 65.588739f,84.168607f, 65.544437f,84.430129f,
                    65.479795f,84.503315f, 65.479795f,82.602623f);
            poly[2677] = new TzPolygon(71.885773f,80.335949f, 71.882002f,80.356177f, 71.872443f,80.335949f);
            poly[2678] = new TzPolygon(71.074149f,80.335949f, 71.043189f,80.583982f, 70.833051f,80.638733f, 70.809468f,80.715196f, 70.692538f,80.639875f,
                    70.631349f,80.821790f, 70.568510f,80.771948f, 70.567670f,80.714723f, 70.513078f,80.735389f, 70.488650f,80.636107f,
                    70.478492f,80.707234f, 70.437195f,80.734221f, 70.427179f,80.884488f, 70.408072f,80.785617f, 70.379185f,80.820937f,
                    70.376278f,80.740095f, 70.398094f,80.644504f, 70.419384f,80.682276f, 70.453917f,80.617680f, 70.460550f,80.414205f,
                    70.426215f,80.335949f);
            poly[2679] = new TzPolygon(54.176745f,95.855025f, 54.179904f,95.844012f, 54.209796f,95.849265f, 54.237503f,95.684680f, 54.296935f,95.646271f,
                    54.413782f,95.710074f, 54.423412f,95.838943f, 54.408621f,95.855025f);
            poly[2680] = new TzPolygon(53.453474f,97.468121f, 53.456299f,97.454332f, 53.588940f,97.328781f, 53.592554f,97.220093f, 53.623578f,97.182937f,
                    53.614820f,97.126329f, 53.659056f,97.076520f, 53.653011f,97.009908f, 53.728902f,96.887528f, 53.723475f,96.730660f,
                    53.641506f,96.666828f, 53.677257f,96.616820f, 53.660410f,96.592511f, 53.673599f,96.525220f, 53.691552f,96.485135f,
                    53.743675f,96.470360f, 53.759035f,96.400652f, 53.837320f,96.340136f, 53.909083f,96.173428f, 53.982589f,96.120100f,
                    53.985580f,96.070620f, 54.071824f,96.087142f, 54.101545f,95.939756f, 54.164720f,95.896955f, 54.176745f,95.855025f,
                    54.408621f,95.855025f, 54.393452f,95.871519f, 54.396532f,95.918820f, 54.432073f,95.932411f, 54.446973f,95.978410f,
                    54.465887f,95.952409f, 54.508089f,95.978053f, 54.513039f,96.021498f, 54.528717f,96.000072f, 54.524502f,96.029713f,
                    54.554805f,96.025160f, 54.574543f,96.065075f, 54.535229f,96.181192f, 54.557529f,96.290252f, 54.515854f,96.486433f,
                    54.529775f,96.538823f, 54.581315f,96.529414f, 54.626644f,96.580866f, 54.699490f,96.567032f, 54.791259f,96.661748f,
                    54.901775f,96.716945f, 54.992631f,96.625192f, 54.992631f,97.468121f);
            poly[2681] = new TzPolygon(53.453474f,97.468121f, 53.425895f,97.602759f, 53.370437f,97.599862f, 53.373537f,97.812820f, 53.346704f,97.866066f,
                    53.348318f,97.981927f, 53.303296f,97.958405f, 53.248363f,98.004601f, 53.247414f,98.188853f, 53.208021f,98.239674f,
                    53.227283f,98.297075f, 53.096353f,98.303558f, 53.101222f,98.637103f, 53.157566f,98.679244f, 53.117316f,98.892343f,
                    53.155083f,98.918335f, 53.103005f,99.009707f, 53.103726f,99.062062f, 53.027406f,98.999776f, 53.007242f,99.081216f,
                    52.889807f,99.081216f, 52.934114f,98.974136f, 52.937225f,98.935514f, 52.896867f,98.894151f, 52.795336f,98.849121f,
                    52.792043f,98.943569f, 52.715611f,98.960205f, 52.657532f,98.931379f, 52.657887f,98.869996f, 52.626776f,98.863874f,
                    52.604745f,98.786071f, 52.560261f,98.785086f, 52.537687f,98.830941f, 52.508002f,98.802401f, 52.499387f,98.741744f,
                    52.445937f,98.698203f, 52.423103f,98.632846f, 52.355310f,98.685672f, 52.279535f,98.647721f, 52.262813f,98.658059f,
                    52.290930f,98.710750f, 52.274371f,98.832638f, 52.189663f,98.827332f, 52.206699f,98.894644f, 52.160796f,98.988112f,
                    52.149600f,98.940959f, 52.149600f,97.468121f);
            poly[2682] = new TzPolygon(54.992631f,96.625192f, 55.023819f,96.593695f, 55.082735f,96.685306f, 55.099789f,96.650621f, 55.179313f,96.689476f,
                    55.238511f,96.657221f, 55.288453f,96.781277f, 55.290960f,96.875425f, 55.318725f,96.944938f, 55.431695f,96.847501f,
                    55.530786f,96.839890f, 55.550798f,96.808484f, 55.577909f,96.862385f, 55.598650f,96.855167f, 55.655930f,96.744042f,
                    55.688982f,96.825581f, 55.732118f,96.754805f, 55.789580f,96.786108f, 55.861388f,96.915005f, 55.850369f,96.988722f,
                    56.003892f,96.990726f, 56.004181f,97.063652f, 56.112530f,97.131942f, 56.074375f,97.301181f, 56.039563f,97.311312f,
                    56.032070f,97.359519f, 56.105429f,97.438193f, 56.163546f,97.409098f, 56.192983f,97.468121f, 54.992631f,97.468121f);
            poly[2683] = new TzPolygon(57.010628f,97.468121f, 57.031512f,97.343349f, 57.195087f,97.468121f);
            poly[2684] = new TzPolygon(57.775014f,99.081216f, 57.717948f,98.980911f, 57.727960f,98.848295f, 57.752969f,98.844412f, 57.754751f,98.801391f,
                    57.797018f,98.747524f, 57.772268f,98.635829f, 57.830442f,97.952756f, 57.195087f,97.468121f, 57.835661f,97.468121f,
                    57.835661f,99.081216f);
            poly[2685] = new TzPolygon(57.010628f,97.468121f, 57.004210f,97.506464f, 56.969848f,97.530581f, 56.990090f,97.590534f, 56.962691f,97.611586f,
                    56.972802f,97.672584f, 56.906540f,97.570328f, 56.883111f,97.478620f, 56.827013f,97.469405f, 56.784661f,97.540752f,
                    56.805594f,97.669615f, 56.797604f,97.786376f, 56.773224f,97.802762f, 56.738380f,97.747163f, 56.662624f,97.788277f,
                    56.645447f,97.736127f, 56.591282f,97.779681f, 56.549176f,97.741117f, 56.534102f,97.879933f, 56.375360f,97.879988f,
                    56.376301f,97.557020f, 56.187314f,97.574179f, 56.195377f,97.472921f, 56.192983f,97.468121f);
            poly[2686] = new TzPolygon(57.835661f,99.456277f, 57.790723f,99.437094f, 57.797960f,99.344485f, 57.761010f,99.204509f, 57.778079f,99.086604f,
                    57.775014f,99.081216f, 57.835661f,99.081216f);
            poly[2687] = new TzPolygon(57.835661f,100.840559f, 57.783956f,100.869189f, 57.771406f,100.908698f, 57.637771f,100.814906f, 57.589170f,100.879215f,
                    57.577506f,100.946983f, 57.501399f,100.941605f, 57.483221f,100.971758f, 57.444325f,100.923480f, 57.464389f,100.857700f,
                    57.399517f,100.763049f, 57.460458f,100.674016f, 57.493958f,100.515623f, 57.551830f,100.403283f, 57.582520f,100.427476f,
                    57.636768f,100.352378f, 57.667273f,100.383344f, 57.684373f,100.322777f, 57.741634f,100.379996f, 57.768613f,100.285177f,
                    57.806051f,100.314551f, 57.835661f,100.209487f);
            poly[2688] = new TzPolygon(53.007242f,99.081216f, 52.976850f,99.203971f, 52.938765f,99.272200f, 52.915082f,99.223421f, 52.866363f,99.226333f,
                    52.873067f,99.121672f, 52.889807f,99.081216f);
            poly[2689] = new TzPolygon(58.604518f,102.307407f, 58.561474f,102.282598f, 58.522190f,102.202334f, 58.488964f,102.102230f, 58.453290f,101.791303f,
                    58.411146f,101.699847f, 58.342534f,101.669625f, 58.241655f,101.531111f, 58.232678f,101.363814f, 58.136756f,101.218109f,
                    58.102675f,101.107659f, 58.037442f,101.170042f, 57.968196f,101.138630f, 57.930733f,101.039498f, 57.872698f,101.005544f,
                    57.875391f,100.818560f, 57.835661f,100.840559f, 57.835661f,100.209487f, 57.856175f,100.136700f, 57.919499f,100.129432f,
                    57.977071f,100.063989f, 58.035791f,100.099501f, 58.074038f,100.072390f, 58.083315f,99.947301f, 58.056901f,99.801561f,
                    58.084158f,99.757661f, 58.082698f,99.681723f, 58.053343f,99.632899f, 57.993187f,99.638604f, 57.991926f,99.604793f,
                    57.938050f,99.563222f, 57.934431f,99.505526f, 57.911382f,99.533668f, 57.899699f,99.483612f, 57.835661f,99.456277f,
                    57.835661f,95.855025f, 63.521722f,95.855025f, 63.521722f,102.307407f);
            poly[2690] = new TzPolygon(58.604518f,102.307407f, 58.646135f,102.331393f, 58.739556f,102.569435f, 58.882291f,102.535905f, 58.904956f,102.561210f,
                    58.945360f,102.440868f, 58.991060f,102.435504f, 59.008522f,102.493574f, 59.022151f,102.437536f, 59.050888f,102.461296f,
                    59.083479f,102.402553f, 59.144177f,102.425244f, 59.209684f,102.565469f, 59.193050f,102.823785f, 59.218304f,102.866801f,
                    59.249373f,102.855463f, 59.318049f,103.014427f, 59.258482f,103.136945f, 59.255943f,103.210061f, 59.290707f,103.232277f,
                    59.264229f,103.356310f, 59.235042f,103.359802f, 59.237499f,103.216826f, 59.173092f,103.238583f, 59.134035f,103.313074f,
                    59.028945f,103.393713f, 58.998414f,103.565898f, 58.925181f,103.617078f, 58.935132f,103.700119f, 58.908849f,103.783218f,
                    58.922624f,103.894862f, 58.913227f,103.920502f, 58.750149f,103.920502f, 58.736700f,103.891393f, 58.733144f,103.920502f,
                    57.835661f,103.920502f, 57.835661f,102.307407f);
            poly[2691] = new TzPolygon(58.752107f,103.920502f, 58.770761f,103.965114f, 58.834201f,103.949244f, 58.875309f,103.985973f, 58.909309f,103.920502f,
                    59.257177f,103.920502f, 59.257177f,105.277458f, 59.245387f,105.304037f, 59.197129f,105.337767f, 59.156964f,105.292495f,
                    59.116737f,105.367243f, 59.067599f,105.276276f, 59.061288f,105.135744f, 59.014871f,105.095362f, 58.958700f,104.920861f,
                    58.908601f,104.891120f, 58.866833f,104.789292f, 58.807188f,104.754618f, 58.747438f,104.894480f, 58.677485f,104.813475f,
                    58.650116f,104.629432f, 58.622013f,104.608318f, 58.638368f,104.525186f, 58.608785f,104.466400f, 58.672869f,104.346690f,
                    58.726987f,104.382346f, 58.715973f,104.254183f, 58.760438f,104.199376f, 58.786293f,104.211025f, 58.765100f,104.175482f,
                    58.788730f,104.036222f, 58.727298f,103.968347f, 58.734023f,103.920502f);
            poly[2692] = new TzPolygon(60.678692f,104.551757f, 60.617766f,104.502404f, 60.587555f,104.571414f, 60.536944f,104.580704f, 60.519160f,104.644959f,
                    60.406017f,104.656759f, 60.373956f,104.795135f, 60.299521f,104.903699f, 60.302000f,105.082229f, 60.274741f,105.231398f,
                    60.298910f,105.343102f, 60.264295f,105.361269f, 60.268414f,105.414997f, 60.219563f,105.477055f, 60.226393f,105.508916f,
                    60.153881f,105.422249f, 60.001719f,105.504985f, 59.947871f,105.409822f, 59.842432f,105.514397f, 59.831149f,105.466083f,
                    59.857575f,105.432799f, 59.838932f,105.372014f, 59.883546f,105.164172f, 59.875733f,105.064300f, 59.843910f,105.028238f,
                    59.853177f,104.979367f, 59.834884f,105.018908f, 59.777566f,105.023352f, 59.765107f,104.888396f, 59.687545f,104.761889f,
                    59.670870f,104.808037f, 59.635939f,104.784139f, 59.604226f,104.882549f, 59.555546f,104.850420f, 59.470628f,104.967757f,
                    59.464132f,105.081669f, 59.485219f,105.148868f, 59.441726f,105.237198f, 59.401877f,105.196846f, 59.342678f,105.219528f,
                    59.303842f,105.172255f, 59.257177f,105.277458f, 59.257177f,103.920502f, 60.678692f,103.920502f);
            poly[2693] = new TzPolygon(60.678692f,104.551757f, 60.740990f,104.602221f, 60.782850f,104.509870f, 60.846564f,104.460697f, 60.905524f,104.633952f,
                    60.946095f,104.576347f, 61.037737f,104.643398f, 61.078544f,104.625040f, 61.087924f,104.694833f, 61.191754f,104.852553f,
                    61.177693f,105.044477f, 61.316054f,104.950299f, 61.348577f,104.778086f, 61.412949f,105.008351f, 61.423941f,105.281177f,
                    61.464248f,105.257958f, 61.542213f,105.363247f, 61.579320f,105.533598f, 60.678692f,105.533598f);
            poly[2694] = new TzPolygon(63.521722f,106.531699f, 63.502564f,106.578857f, 63.422925f,106.648430f, 63.397767f,106.737036f, 63.316763f,106.620902f,
                    63.357410f,106.417170f, 63.245656f,106.344513f, 63.215936f,106.438794f, 63.125686f,106.396808f, 63.088726f,106.111410f,
                    62.922954f,106.186584f, 62.909676f,106.282070f, 62.874418f,106.313206f, 62.863495f,106.435968f, 62.814399f,106.446644f,
                    62.791116f,106.512518f, 62.698851f,106.469532f, 62.688831f,106.579993f, 62.623216f,106.796434f, 62.603921f,106.781993f,
                    62.607784f,106.715199f, 62.561654f,106.669943f, 62.494475f,106.753373f, 62.463559f,106.628803f, 62.396321f,106.546570f,
                    62.395309f,106.430062f, 62.339763f,106.483239f, 62.329623f,106.409253f, 62.301600f,106.408707f, 62.281190f,106.346942f,
                    62.255038f,106.403220f, 62.259746f,106.464844f, 62.145273f,106.387730f, 62.042694f,106.395700f, 62.023782f,106.275759f,
                    61.845347f,105.898270f, 61.690511f,105.979911f, 61.686567f,105.896776f, 61.629823f,105.813359f, 61.660055f,105.727969f,
                    61.655252f,105.668412f, 61.619904f,105.580829f, 61.590493f,105.584890f, 61.579320f,105.533598f, 63.521722f,105.533598f);
            poly[2695] = new TzPolygon(52.149600f,111.910233f, 52.197441f,111.934638f, 52.205282f,111.985979f, 52.149600f,111.985979f);
            poly[2696] = new TzPolygon(54.992631f,113.599075f, 52.462380f,113.599075f, 52.448805f,113.590714f, 52.488745f,113.542026f, 52.453594f,113.151961f,
                    52.403735f,113.093081f, 52.377837f,112.981145f, 52.329131f,112.919223f, 52.351978f,112.875654f, 52.326151f,112.803803f,
                    52.326401f,112.735582f, 52.354830f,112.679114f, 52.346136f,112.547443f, 52.321138f,112.515181f, 52.248884f,112.511326f,
                    52.201542f,112.382579f, 52.245157f,112.305630f, 52.250896f,112.193759f, 52.303726f,112.176871f, 52.281267f,112.145048f,
                    52.285298f,112.075331f, 52.208708f,112.008414f, 52.205282f,111.985979f, 54.992631f,111.985979f);
            poly[2697] = new TzPolygon(53.571115f,113.599075f, 53.571115f,113.852424f, 53.569812f,113.858151f, 53.521912f,113.883245f, 53.482539f,113.835914f,
                    53.416496f,113.827226f, 53.362574f,113.874644f, 53.346622f,113.946699f, 53.284010f,113.924402f, 53.249534f,113.948630f,
                    53.248380f,114.051698f, 53.203820f,114.052321f, 53.178683f,114.205686f, 53.127452f,114.190689f, 53.117604f,114.146040f,
                    53.072631f,114.146383f, 53.090679f,114.268953f, 53.059530f,114.292257f, 53.054363f,114.375604f, 53.030946f,114.306866f,
                    52.964547f,114.312883f, 52.897742f,114.235642f, 52.816283f,114.260418f, 52.812355f,114.224419f, 52.662345f,114.078475f,
                    52.665572f,114.021862f, 52.626725f,113.960943f, 52.639205f,113.908699f, 52.603713f,113.847824f, 52.612267f,113.803010f,
                    52.576732f,113.769630f, 52.586616f,113.741673f, 52.530099f,113.640781f, 52.462380f,113.599075f);
            poly[2698] = new TzPolygon(53.571115f,113.852424f, 53.588684f,113.775218f, 53.615846f,113.799776f, 53.624180f,113.880420f, 53.663595f,113.933656f,
                    53.645554f,113.932006f, 53.647456f,113.974562f, 53.685985f,113.978855f, 53.702332f,113.946084f, 53.722808f,113.984682f,
                    53.734488f,114.111986f, 53.759317f,114.158802f, 53.736702f,114.193115f, 53.756708f,114.306379f, 53.823013f,114.386319f,
                    53.812882f,114.512176f, 53.916289f,114.577871f, 53.926697f,114.740410f, 53.950524f,114.755597f, 53.950586f,114.861473f,
                    53.974966f,114.876639f, 53.994979f,114.980920f, 54.030104f,114.990406f, 54.032805f,115.025844f, 54.073582f,115.013332f,
                    54.118997f,115.145838f, 54.194629f,115.167899f, 54.197774f,115.212170f, 53.571115f,115.212170f);
            poly[2699] = new TzPolygon(60.678692f,110.372884f, 59.049242f,110.372884f, 58.991048f,110.263097f, 58.980934f,110.158248f, 59.024971f,109.982887f,
                    58.988769f,109.821884f, 59.090552f,109.727389f, 59.060777f,109.642656f, 59.164261f,109.630401f, 59.196506f,109.505352f,
                    59.235458f,109.536504f, 59.253604f,109.478170f, 59.308076f,109.506285f, 59.332060f,109.246015f, 59.351496f,109.274728f,
                    59.390863f,109.240395f, 59.387755f,109.282681f, 59.431439f,109.351957f, 59.466906f,109.252271f, 59.667295f,109.543439f,
                    59.689721f,109.483058f, 59.767633f,109.474766f, 59.844239f,109.563324f, 59.876034f,109.662596f, 59.933975f,109.617161f,
                    59.940119f,109.669001f, 59.994620f,109.682277f, 60.034303f,109.760034f, 60.078165f,109.691853f, 60.241147f,109.726201f,
                    60.273757f,109.815246f, 60.324839f,109.791349f, 60.357093f,109.882760f, 60.386888f,109.844194f, 60.416890f,109.948779f,
                    60.461395f,109.907127f, 60.504864f,109.949669f, 60.533268f,110.022251f, 60.584161f,110.045532f, 60.596930f,110.138172f,
                    60.643062f,110.133293f, 60.678692f,110.065522f);
        }
    }

    private static class Initializer28 {
        private static void init() {
            poly[2700] = new TzPolygon(59.356790f,111.985979f, 59.341290f,111.960455f, 59.278978f,111.944096f, 59.303685f,111.898915f, 59.297599f,111.782657f,
                    59.223849f,111.649821f, 59.235190f,111.560631f, 59.292353f,111.451149f, 59.278318f,111.299121f, 59.245357f,111.287201f,
                    59.201395f,111.189430f, 59.217872f,111.119692f, 59.256028f,111.093641f, 59.216713f,110.983064f, 59.272094f,110.859243f,
                    59.280902f,110.720542f, 59.183345f,110.548603f, 59.140373f,110.603614f, 59.119815f,110.529266f, 59.047770f,110.492112f,
                    59.052578f,110.379177f, 59.049242f,110.372884f, 60.678692f,110.372884f, 60.678692f,111.985979f);
            poly[2701] = new TzPolygon(60.678692f,110.065522f, 60.683279f,110.056797f, 60.696230f,110.167848f, 60.681619f,110.238915f, 60.701981f,110.288624f,
                    60.844633f,110.261865f, 60.935092f,110.355482f, 60.944031f,110.372884f, 60.678692f,110.372884f);
            poly[2702] = new TzPolygon(62.100207f,109.880934f, 62.100207f,110.372884f, 61.190011f,110.372884f, 61.171357f,110.328472f, 61.166948f,110.226559f,
                    61.277886f,110.111251f, 61.314717f,109.997213f, 61.332120f,109.760002f, 61.448522f,109.859936f, 61.477883f,109.808911f,
                    61.549351f,109.870490f, 61.655686f,109.748492f, 61.657456f,109.695587f, 61.699143f,109.730710f, 61.703893f,109.668660f,
                    61.745473f,109.600187f, 61.914704f,109.575309f, 61.976609f,109.725438f, 62.025282f,109.762340f, 62.022757f,109.815796f,
                    62.096721f,109.888645f);
            poly[2703] = new TzPolygon(62.100207f,109.880934f, 62.109600f,109.860159f, 62.164894f,109.989349f, 62.191472f,110.002118f, 62.261407f,109.918236f,
                    62.312685f,109.996493f, 62.333594f,109.926339f, 62.362158f,109.951555f, 62.372225f,109.885700f, 62.437021f,109.910930f,
                    62.435063f,109.674141f, 62.455069f,109.553325f, 62.424841f,109.445182f, 62.473591f,109.430854f, 62.493533f,109.337635f,
                    62.576751f,109.251916f, 62.598725f,109.254805f, 62.612246f,109.390614f, 62.669355f,109.381987f, 62.690827f,109.479665f,
                    62.749394f,109.463396f, 62.795014f,109.507988f, 62.843256f,109.682486f, 62.898698f,109.639320f, 62.918123f,109.526804f,
                    62.970701f,109.483979f, 63.014784f,109.534293f, 63.022981f,109.469319f, 63.026988f,109.515371f, 63.057881f,109.469697f,
                    63.108702f,109.515600f, 63.109771f,109.457460f, 63.140759f,109.496928f, 63.208326f,109.438259f, 63.235273f,109.479724f,
                    63.279973f,109.415870f, 63.376889f,109.406565f, 63.372478f,109.285972f, 63.396227f,109.320684f, 63.455652f,109.266670f,
                    63.496168f,109.177315f, 63.521722f,109.175970f, 63.521722f,110.372884f, 62.100207f,110.372884f);
            poly[2704] = new TzPolygon(61.190011f,110.372884f, 61.209527f,110.419347f, 61.161924f,110.543500f, 61.100268f,110.548786f, 61.049727f,110.484787f,
                    61.000681f,110.483167f, 60.944031f,110.372884f);
            poly[2705] = new TzPolygon(60.678692f,113.599075f, 59.596462f,113.599075f, 59.593448f,113.589432f, 59.585193f,113.599075f, 59.505650f,113.599075f,
                    59.402310f,113.431376f, 59.378740f,113.432036f, 59.351463f,113.532106f, 59.310452f,113.461373f, 59.265593f,113.465212f,
                    59.275195f,113.444395f, 59.247773f,113.429054f, 59.218052f,113.327570f, 59.158104f,113.277557f, 59.188068f,113.192478f,
                    59.150801f,113.109606f, 59.168579f,113.062111f, 59.144201f,113.022305f, 59.156883f,112.931538f, 59.124409f,112.873258f,
                    59.126996f,112.805138f, 59.049535f,112.740093f, 59.048381f,112.608183f, 59.107825f,112.605654f, 59.054391f,112.511791f,
                    58.992301f,112.599206f, 58.945473f,112.591155f, 58.890736f,112.519737f, 58.918129f,112.441539f, 59.150287f,112.445229f,
                    59.237481f,112.504143f, 59.270745f,112.628966f, 59.313623f,112.651461f, 59.316706f,112.569536f, 59.348222f,112.521975f,
                    59.302395f,112.272611f, 59.335640f,112.322940f, 59.373139f,112.275443f, 59.427002f,112.340899f, 59.531504f,112.273681f,
                    59.356790f,111.985979f, 60.678692f,111.985979f);
            poly[2706] = new TzPolygon(60.460705f,115.212170f, 60.413232f,115.096025f, 60.365986f,115.145207f, 60.236097f,115.023475f, 60.184778f,114.906236f,
                    60.203540f,114.804581f, 60.190005f,114.695123f, 60.179064f,114.651151f, 60.151294f,114.650494f, 60.130926f,114.565087f,
                    60.036188f,114.490924f, 60.022594f,114.559409f, 59.989086f,114.573376f, 59.906892f,114.319567f, 59.745556f,114.150321f,
                    59.761008f,114.076382f, 59.690154f,113.967843f, 59.684799f,113.870673f, 59.627648f,113.795431f, 59.630044f,113.706531f,
                    59.596462f,113.599075f, 60.678692f,113.599075f, 60.678692f,115.212170f);
            poly[2707] = new TzPolygon(59.585193f,113.599075f, 59.560820f,113.627546f, 59.515156f,113.614501f, 59.505650f,113.599075f);
            poly[2708] = new TzPolygon(67.003770f,105.533598f, 67.015768f,105.508341f, 67.017171f,105.533598f);
            poly[2709] = new TzPolygon(63.521722f,106.531699f, 63.547256f,106.468848f, 63.567717f,106.522387f, 63.561608f,106.598240f, 63.598942f,106.583400f,
                    63.661333f,106.688989f, 63.723201f,106.602469f, 63.870987f,106.789833f, 63.913078f,106.711873f, 63.935006f,106.730351f,
                    63.984650f,106.605930f, 64.044317f,106.664368f, 64.019565f,106.699577f, 64.018027f,106.807366f, 63.987177f,106.824168f,
                    63.971239f,106.975704f, 63.926526f,107.043493f, 63.948942f,107.146693f, 63.521722f,107.146693f);
            poly[2710] = new TzPolygon(64.351378f,107.146693f, 64.353611f,107.105488f, 64.438280f,106.915167f, 64.422861f,106.736901f, 64.529516f,106.652537f,
                    64.542671f,106.578978f, 64.461785f,106.559048f, 64.447051f,106.256347f, 64.415606f,106.182690f, 64.428981f,106.088075f,
                    64.485387f,106.133812f, 64.541475f,106.021387f, 64.486988f,105.905221f, 64.502215f,105.869119f, 64.493563f,105.755774f,
                    64.534791f,105.792740f, 64.583005f,105.712603f, 64.640663f,105.750906f, 64.680781f,105.685068f, 64.677126f,105.872094f,
                    64.726061f,105.815905f, 64.832933f,105.852876f, 64.829430f,105.987279f, 64.903497f,105.914801f, 64.918700f,106.031820f,
                    64.869955f,106.058708f, 64.873037f,106.207529f, 64.906100f,106.116330f, 64.943238f,106.093633f, 64.943238f,107.146693f);
            poly[2711] = new TzPolygon(64.943238f,107.146693f, 64.943238f,106.093633f, 64.980394f,106.070925f, 65.000750f,105.974185f, 65.039901f,105.950465f,
                    65.069735f,106.108917f, 65.133042f,106.189947f, 65.144269f,106.310062f, 65.227947f,106.410707f, 65.219637f,106.526121f,
                    65.246530f,106.429257f, 65.318115f,106.435978f, 65.396004f,106.612948f, 65.377536f,106.817327f, 65.506618f,106.968192f,
                    65.539858f,106.703752f, 65.602794f,106.702850f, 65.669229f,106.416125f, 65.701233f,106.402170f, 65.733042f,106.459869f,
                    65.765213f,106.428611f, 65.798388f,106.491484f, 65.825931f,106.448051f, 66.000549f,106.517617f, 66.156837f,106.330433f,
                    66.147000f,106.205447f, 66.197240f,106.106043f, 66.364753f,106.111518f, 66.364753f,107.146693f);
            poly[2712] = new TzPolygon(63.948942f,107.146693f, 63.953355f,107.167008f, 63.984432f,107.201326f, 63.977563f,107.307045f, 63.936817f,107.377132f,
                    63.907575f,107.342020f, 63.894269f,107.410870f, 63.927371f,107.473097f, 63.897238f,107.515607f, 63.902170f,107.582932f,
                    63.981370f,107.631215f, 64.021253f,107.764036f, 64.024747f,107.844571f, 63.997562f,107.906356f, 64.015152f,107.953241f,
                    63.521722f,107.953241f, 63.521722f,107.146693f);
            poly[2713] = new TzPolygon(64.200916f,107.953241f, 64.189835f,107.912377f, 64.231146f,107.860089f, 64.258048f,107.707701f, 64.281156f,107.720357f,
                    64.310700f,107.641299f, 64.300898f,107.495908f, 64.261481f,107.373516f, 64.270334f,107.325227f, 64.345425f,107.256510f,
                    64.351378f,107.146693f, 64.943238f,107.146693f, 64.943238f,107.953241f);
            poly[2714] = new TzPolygon(64.200916f,107.953241f, 64.203992f,107.964583f, 64.182009f,107.973404f, 64.185712f,108.055827f, 64.246468f,108.085664f,
                    64.250218f,108.246822f, 64.048812f,108.389070f, 64.010987f,108.313244f, 64.003724f,108.205426f, 64.015889f,108.088315f,
                    64.000807f,108.034400f, 64.019771f,107.965551f, 64.015690f,107.953241f);
            poly[2715] = new TzPolygon(63.611884f,108.759788f, 63.619357f,108.733544f, 63.611747f,108.655082f, 63.636601f,108.526357f, 63.607747f,108.135881f,
                    63.658147f,108.124333f, 63.678134f,108.175527f, 63.668944f,108.225335f, 63.716051f,108.299315f, 63.847093f,108.306325f,
                    63.862845f,108.388198f, 63.822350f,108.496466f, 63.847725f,108.617179f, 63.821910f,108.676830f, 63.854096f,108.759788f);
            poly[2716] = new TzPolygon(63.899312f,108.759788f, 63.932133f,108.710601f, 64.012252f,108.759788f);
            poly[2717] = new TzPolygon(64.017557f,108.759788f, 64.068797f,108.613007f, 64.106627f,108.609359f, 64.137046f,108.519972f, 64.193456f,108.597352f,
                    64.230838f,108.519344f, 64.255198f,108.583116f, 64.321500f,108.425185f, 64.265964f,108.367859f, 64.284289f,108.189293f,
                    64.249805f,108.088068f, 64.185712f,108.055827f, 64.182009f,107.973404f, 64.203992f,107.964583f, 64.200916f,107.953241f,
                    64.943238f,107.953241f, 64.943238f,108.759788f);
            poly[2718] = new TzPolygon(66.364753f,108.759788f, 66.364753f,106.111518f, 66.372290f,106.111764f, 66.429761f,106.189337f, 66.473182f,106.331906f,
                    66.521768f,106.320515f, 66.565746f,106.233109f, 66.682718f,106.257375f, 66.707544f,106.170333f, 66.751612f,106.133226f,
                    66.797782f,106.213301f, 66.788562f,106.014295f, 66.803635f,105.986321f, 66.859184f,106.094150f, 66.895417f,106.080664f,
                    66.910733f,105.855024f, 66.943891f,105.857548f, 66.925205f,105.698989f, 67.003770f,105.533598f, 67.017171f,105.533598f,
                    67.040220f,105.948481f, 67.115325f,106.064825f, 67.167919f,106.071270f, 67.171419f,106.220558f, 67.200771f,106.342143f,
                    67.266641f,106.438486f, 67.291168f,106.545311f, 67.262536f,106.590562f, 67.257436f,106.711234f, 67.334093f,106.822039f,
                    68.254165f,106.920682f, 68.857784f,106.906594f, 69.207784f,106.422010f, 69.207784f,108.759788f);
            poly[2719] = new TzPolygon(69.207784f,108.759788f, 69.207784f,106.422010f, 69.409405f,106.142860f, 69.441680f,106.178337f, 69.476746f,106.341910f,
                    69.580345f,106.479029f, 69.567970f,106.597558f, 69.527968f,106.630677f, 69.522793f,106.852131f, 69.660499f,107.606481f,
                    69.686374f,107.844267f, 69.669024f,107.952931f, 69.698440f,108.019420f, 69.787929f,108.022611f, 69.786449f,108.117876f,
                    69.854403f,108.248733f, 69.828592f,108.689155f, 69.833378f,108.759788f);
            poly[2720] = new TzPolygon(64.017557f,108.759788f, 64.016621f,108.762471f, 64.012252f,108.759788f);
            poly[2721] = new TzPolygon(63.899312f,108.759788f, 63.870720f,108.802638f, 63.854096f,108.759788f);
            poly[2722] = new TzPolygon(63.611884f,108.759788f, 63.578782f,108.876039f, 63.577065f,109.081238f, 63.541665f,109.174920f, 63.521722f,109.175970f,
                    63.521722f,108.759788f);
            poly[2723] = new TzPolygon(69.833378f,108.759788f, 69.842803f,108.898903f, 69.770599f,108.944625f, 69.754623f,109.201107f, 69.774274f,109.295729f,
                    69.821665f,109.329170f, 69.824367f,109.385870f, 69.963017f,109.404419f, 69.993450f,109.529968f, 70.027783f,109.546454f,
                    70.078822f,109.354874f, 70.208350f,109.300858f, 70.252448f,109.575575f, 70.285170f,109.616694f, 70.352237f,109.558342f,
                    70.372323f,109.640479f, 70.390982f,109.952318f, 70.413747f,110.009103f, 70.397510f,110.072972f, 70.408571f,110.313335f,
                    70.434197f,110.306007f, 70.476082f,110.115928f, 70.636983f,110.123517f, 70.670126f,110.308611f, 70.695886f,110.333428f,
                    70.712832f,110.510804f, 70.761794f,110.511692f, 70.784785f,110.619270f, 70.800048f,110.747504f, 70.780877f,110.841755f,
                    70.844616f,111.051331f, 70.861772f,111.372755f, 70.928825f,111.478798f, 70.938144f,111.632712f, 70.971932f,111.738766f,
                    70.957544f,111.801059f, 70.974232f,111.934630f, 71.014233f,111.985979f, 69.207784f,111.985979f, 69.207784f,108.759788f);
            poly[2724] = new TzPolygon(73.153541f,110.372884f, 73.197632f,110.348745f, 73.203682f,110.372884f);
            poly[2725] = new TzPolygon(73.336486f,110.372884f, 73.377281f,110.244841f, 73.373114f,110.168744f, 73.405426f,110.120250f, 73.396727f,110.242916f,
                    73.413977f,110.372884f);
            poly[2726] = new TzPolygon(72.126517f,111.985979f, 72.166469f,111.708247f, 72.220915f,111.691752f, 72.211758f,111.592957f, 72.258420f,111.668359f,
                    72.324402f,111.574806f, 72.315850f,111.324953f, 72.340589f,111.302737f, 72.364430f,111.062775f, 72.388893f,111.008776f,
                    72.412195f,111.074828f, 72.441847f,111.008817f, 72.448086f,111.135860f, 72.510109f,111.309184f, 72.557758f,111.178717f,
                    72.576070f,110.884220f, 72.632042f,110.908832f, 72.645237f,110.768741f, 72.677811f,110.712554f, 72.791381f,110.656685f,
                    72.807870f,110.747521f, 72.846816f,110.628665f, 72.881940f,110.626556f, 72.939260f,110.908443f, 72.952045f,110.657588f,
                    73.019526f,110.719874f, 73.020106f,110.811154f, 73.054379f,110.860169f, 73.102943f,110.745516f, 73.160670f,110.850160f,
                    73.151871f,110.373798f, 73.203682f,110.372884f, 73.267222f,110.626413f, 73.333151f,110.543538f, 73.347384f,110.451000f,
                    73.333913f,110.380960f, 73.336486f,110.372884f, 73.413977f,110.372884f, 73.433652f,110.521116f, 73.428201f,110.642632f,
                    73.472330f,110.676550f, 73.472330f,111.985979f);
            poly[2727] = new TzPolygon(73.472330f,111.985979f, 73.472352f,110.676567f, 73.518475f,110.839942f, 73.546134f,110.811061f, 73.565074f,110.892277f,
                    73.557590f,111.011434f, 73.607290f,111.167409f, 73.609245f,111.282729f, 73.643626f,111.157519f, 73.662526f,111.185642f,
                    73.705951f,110.807932f, 73.748476f,110.825101f, 73.812938f,110.991666f, 73.821940f,111.234498f, 73.841858f,111.227879f,
                    73.842321f,111.307459f, 74.008054f,111.898518f, 74.114312f,111.851297f, 74.189846f,111.140153f, 74.325295f,110.485274f,
                    74.443515f,111.059106f, 74.590929f,111.985979f);
            poly[2728] = new TzPolygon(74.893845f,113.566570f, 74.870803f,112.909269f, 74.651680f,112.367953f, 74.590929f,111.985979f, 74.893845f,111.985979f);
            poly[2729] = new TzPolygon(72.126517f,111.985979f, 72.124400f,112.000695f, 71.402308f,112.000514f, 71.377937f,112.220575f, 71.276587f,112.469258f,
                    71.294110f,112.603685f, 71.253634f,112.722796f, 71.195318f,112.666622f, 71.171260f,112.512341f, 71.102551f,112.594041f,
                    71.071176f,112.355982f, 70.999819f,112.246067f, 71.060097f,112.105777f, 71.054461f,112.037619f, 71.014233f,111.985979f);
            poly[2730] = new TzPolygon(33.798521f,69.957225f, 33.768440f,69.964340f, 33.731620f,70.004090f, 33.724990f,70.142610f, 33.658190f,70.143440f,
                    33.642690f,70.199980f, 33.518370f,70.172910f, 33.471550f,70.244390f, 33.434750f,70.256430f, 33.430240f,70.296770f,
                    33.330940f,70.326950f, 33.328430f,70.292660f, 33.218540f,70.164350f, 33.204410f,70.096900f, 33.219320f,70.071470f,
                    33.138440f,70.020690f, 33.133221f,69.957225f);
            poly[2731] = new TzPolygon(34.044171f,69.957225f, 34.047710f,69.998810f, 34.008550f,70.087690f, 34.014310f,70.148760f, 33.980930f,70.200850f,
                    33.967330f,70.414310f, 33.939730f,70.495400f, 33.949708f,70.534430f, 33.798521f,70.534430f, 33.798521f,69.957225f);
            poly[2732] = new TzPolygon(38.208711f,69.957225f, 38.208711f,70.534430f, 38.121970f,70.506700f, 38.055127f,70.363279f, 37.970286f,70.286325f,
                    37.979075f,70.261336f, 37.937725f,70.269368f, 37.930241f,70.171055f, 37.846771f,70.188062f, 37.815994f,70.279472f,
                    37.698720f,70.303402f, 37.611400f,70.265853f, 37.605793f,70.214067f, 37.567523f,70.213091f, 37.572007f,70.179784f,
                    37.530518f,70.170704f, 37.524455f,70.112254f, 37.565000f,69.958611f, 37.567747f,69.957225f);
            poly[2733] = new TzPolygon(39.621629f,70.534430f, 39.583225f,70.464495f, 39.601044f,70.441454f, 39.574250f,70.424521f, 39.597331f,70.375522f,
                    39.526888f,70.303511f, 39.538494f,70.235449f, 39.560097f,70.243384f, 39.577503f,70.212598f, 39.554084f,70.168090f,
                    39.590225f,70.117342f, 39.536809f,69.995996f, 39.567936f,69.978243f, 39.570200f,69.957225f, 39.621629f,69.957225f);
            poly[2734] = new TzPolygon(29.668817f,78.925031f, 29.668817f,80.389978f, 29.639032f,80.419930f, 29.597069f,80.408190f, 29.552870f,80.342572f,
                    29.512207f,80.343834f, 29.477198f,80.287176f, 29.451747f,80.301766f, 29.442545f,80.242488f, 29.411233f,80.242116f,
                    29.392046f,80.275642f, 29.347673f,80.279391f, 29.314438f,80.316813f, 29.205258f,80.297729f, 29.212559f,80.244033f,
                    29.138702f,80.271697f, 29.116199f,80.233729f, 29.137326f,80.183853f, 29.104645f,80.145258f, 29.007309f,80.135308f,
                    28.916123f,80.058876f, 28.837694f,80.064749f, 28.827903f,80.118726f, 28.755426f,80.215924f, 28.757784f,80.250602f,
                    28.729194f,80.256631f, 28.700562f,80.315909f, 28.636073f,80.360580f, 28.629003f,80.451503f, 28.583918f,80.469581f,
                    28.550701f,80.518402f, 28.664864f,80.503590f, 28.688262f,80.567844f, 28.679968f,80.590564f, 28.647752f,80.590197f,
                    28.641754f,80.667612f, 28.587164f,80.690134f, 28.565679f,80.768220f, 28.525024f,80.787798f, 28.489576f,80.865857f,
                    28.504504f,80.861695f, 28.506962f,80.896144f, 28.458072f,80.915735f, 28.455541f,80.979607f, 28.434101f,80.978884f,
                    28.451893f,81.017859f, 28.435758f,81.022681f, 28.246987f,81.022681f, 28.246987f,78.925031f);
            poly[2735] = new TzPolygon(29.668817f,80.388535f, 29.739961f,80.364631f, 29.794839f,80.406754f, 29.795179f,80.493121f, 29.850706f,80.552894f,
                    29.953504f,80.595693f, 29.957428f,80.675217f, 30.005266f,80.746226f, 30.049367f,80.760721f, 30.128313f,80.877847f,
                    30.168820f,80.863056f, 30.227213f,80.918864f, 30.179687f,80.940144f, 30.191011f,81.022681f, 29.668817f,81.022681f);
            poly[2736] = new TzPolygon(30.237403f,81.022681f, 30.263625f,81.004624f, 30.263411f,80.935916f, 30.303679f,80.907084f, 30.323033f,80.801598f,
                    30.400610f,80.734136f, 30.471487f,80.606630f, 30.449059f,80.540747f, 30.523591f,80.418295f, 30.520332f,80.345478f,
                    30.564537f,80.315390f, 30.584509f,80.211384f, 30.642770f,80.219409f, 30.666027f,80.192574f, 30.686161f,80.197811f,
                    30.690488f,80.232973f, 30.743572f,80.248098f, 30.764911f,80.197740f, 30.806774f,80.178223f, 30.780947f,80.109656f,
                    30.866245f,80.008171f, 30.880540f,79.930972f, 30.917653f,79.888784f, 30.966942f,79.875014f, 31.005804f,79.752312f,
                    30.979515f,79.734932f, 30.982895f,79.665555f, 30.938809f,79.600909f, 30.957968f,79.552631f, 31.032390f,79.506865f,
                    31.022924f,79.427466f, 31.090648f,79.416443f, 31.090648f,81.022681f);
            poly[2737] = new TzPolygon(28.435758f,81.022681f, 28.399096f,81.033638f, 28.413716f,81.035824f, 28.384344f,81.081367f, 28.360793f,81.210932f,
                    28.289183f,81.232676f, 28.246987f,81.273318f, 28.246987f,81.022681f);
            poly[2738] = new TzPolygon(29.668817f,83.012408f, 29.668817f,83.120331f, 29.629604f,83.120331f, 29.602586f,83.085917f);
            poly[2739] = new TzPolygon(29.668817f,82.990480f, 29.661881f,82.956586f, 29.668817f,82.953130f);
            poly[2740] = new TzPolygon(30.250985f,81.022681f, 30.247088f,81.030860f, 30.205043f,81.044063f, 30.196948f,81.022681f);
            poly[2741] = new TzPolygon(30.350726f,82.071506f, 30.333345f,82.055955f, 30.343329f,82.015416f, 30.320942f,81.993786f, 30.358933f,81.949824f,
                    30.349833f,81.915128f, 30.379784f,81.855227f, 30.388708f,81.749947f, 30.445886f,81.628784f, 30.411701f,81.606548f,
                    30.427886f,81.561471f, 30.371767f,81.553000f, 30.420928f,81.407786f, 30.396423f,81.400677f, 30.383263f,81.429115f,
                    30.367985f,81.395382f, 30.323665f,81.395987f, 30.305362f,81.422307f, 30.293109f,81.401584f, 30.282067f,81.416711f,
                    30.206888f,81.395534f, 30.152736f,81.333998f, 30.150769f,81.256975f, 30.112442f,81.290319f, 30.074380f,81.288741f,
                    30.031270f,81.237765f, 30.015085f,81.250622f, 30.015387f,81.133392f, 30.053276f,81.091980f, 30.085271f,81.109038f,
                    30.099490f,81.082113f, 30.149559f,81.083172f, 30.237403f,81.022681f, 31.090648f,81.022681f, 31.090648f,82.071506f);
            poly[2742] = new TzPolygon(30.350726f,82.071506f, 30.362086f,82.081670f, 30.349077f,82.106326f, 30.304000f,82.127050f, 30.239864f,82.099066f,
                    30.197207f,82.140815f, 30.190249f,82.185135f, 30.160299f,82.182715f, 30.154248f,82.206161f, 30.123087f,82.171975f,
                    30.065456f,82.171975f, 30.074985f,82.246851f, 30.038379f,82.298584f, 30.047304f,82.335039f, 30.009639f,82.363477f,
                    30.024463f,82.395545f, 29.947469f,82.497195f, 29.972428f,82.529263f, 29.963806f,82.549835f, 29.888930f,82.602777f,
                    29.872442f,82.641804f, 29.838256f,82.622895f, 29.856408f,82.697015f, 29.834626f,82.726663f, 29.814659f,82.738613f,
                    29.792120f,82.695351f, 29.763126f,82.690309f, 29.770792f,82.744966f, 29.731009f,82.765236f, 29.721480f,82.818632f,
                    29.690319f,82.827557f, 29.704689f,82.935257f, 29.668817f,82.953130f, 29.668817f,82.071506f);
            poly[2743] = new TzPolygon(29.668817f,82.990480f, 29.672474f,83.008349f, 29.668817f,83.012408f);
            poly[2744] = new TzPolygon(33.383604f,78.925031f, 33.339475f,78.962535f, 33.320744f,79.026220f, 33.272681f,79.035201f, 33.244917f,79.079942f,
                    33.224247f,79.071653f, 33.173476f,79.163905f, 33.105778f,79.140058f, 32.985751f,79.174963f, 32.952651f,79.283841f,
                    32.886949f,79.302402f, 32.785460f,79.406997f, 32.735687f,79.415208f, 32.710007f,79.460739f, 32.610296f,79.400352f,
                    32.520232f,79.413463f, 32.528539f,79.350972f, 32.565447f,79.331177f, 32.539559f,79.293452f, 32.556002f,79.276039f,
                    32.516700f,79.248154f, 32.515877f,79.188294f, 32.480951f,79.131546f, 32.370628f,79.100153f, 32.381218f,79.013599f,
                    32.335740f,78.968287f, 32.372638f,78.925031f);
            poly[2745] = new TzPolygon(31.332834f,78.925031f, 31.366250f,78.944818f, 31.349011f,79.018694f, 31.426718f,79.018892f, 31.454677f,79.099114f,
                    31.399064f,79.170909f, 31.363133f,79.170612f, 31.334996f,79.236496f, 31.316502f,79.220248f, 31.284667f,79.249211f,
                    31.260592f,79.226325f, 31.219047f,79.300861f, 31.148275f,79.312353f, 31.108019f,79.412762f, 31.090648f,79.415764f,
                    31.090648f,78.925031f);
            poly[2746] = new TzPolygon(29.153571f,84.169157f, 29.185549f,84.162317f, 29.194195f,84.169157f);
            poly[2747] = new TzPolygon(29.239372f,84.169157f, 29.244391f,84.116181f, 29.274190f,84.121777f, 29.292947f,84.094248f, 29.289619f,84.015438f,
                    29.327889f,83.975958f, 29.326981f,83.902897f, 29.296880f,83.847837f, 29.302325f,83.813954f, 29.247567f,83.792021f,
                    29.244088f,83.711245f, 29.204003f,83.656034f, 29.160590f,83.640756f, 29.178893f,83.578888f, 29.202642f,83.571628f,
                    29.218373f,83.517778f, 29.280543f,83.487676f, 29.274492f,83.465591f, 29.300510f,83.442599f, 29.343469f,83.443204f,
                    29.367218f,83.413556f, 29.402462f,83.425657f, 29.427875f,83.372110f, 29.492767f,83.347605f, 29.508045f,83.268645f,
                    29.556904f,83.255333f, 29.569912f,83.277872f, 29.577627f,83.232039f, 29.611964f,83.197097f, 29.596686f,83.158524f,
                    29.624670f,83.150053f, 29.629604f,83.120331f, 29.668817f,83.120331f, 29.668817f,84.169157f);
            poly[2748] = new TzPolygon(29.153571f,84.169157f, 29.194195f,84.169157f, 29.236222f,84.202402f, 29.239372f,84.169157f, 29.668817f,84.169157f,
                    29.668817f,85.217982f, 28.327401f,85.217982f, 28.340516f,85.203516f, 28.323222f,85.182803f, 28.336352f,85.119594f,
                    28.392471f,85.127376f, 28.458613f,85.100166f, 28.533005f,85.186426f, 28.642005f,85.187019f, 28.643757f,85.157056f,
                    28.686948f,85.114831f, 28.682478f,85.058169f, 28.591867f,84.983746f, 28.593848f,84.902397f, 28.570809f,84.856653f,
                    28.636301f,84.695878f, 28.671211f,84.704696f, 28.736746f,84.625489f, 28.751570f,84.555302f, 28.736595f,84.485721f,
                    28.770133f,84.437394f, 28.821152f,84.435047f, 28.829472f,84.401617f, 28.858817f,84.395567f, 28.862145f,84.323565f,
                    28.898902f,84.266387f, 28.893060f,84.226238f, 29.036704f,84.249143f, 29.047293f,84.189695f, 29.124892f,84.200284f,
                    29.131094f,84.173964f);
            poly[2749] = new TzPolygon(28.327401f,85.217982f, 28.293696f,85.255160f, 28.304416f,85.342836f, 28.277526f,85.376717f, 28.327269f,85.415663f,
                    28.333371f,85.506197f, 28.304766f,85.600218f, 28.256302f,85.608295f, 28.303004f,85.662339f, 28.382455f,85.683634f,
                    28.385833f,85.711978f, 28.246987f,85.747611f, 28.246987f,85.217982f);
            poly[2750] = new TzPolygon(34.383080f,78.925031f, 34.386708f,78.965220f, 34.361824f,78.971872f, 34.327381f,79.044455f, 34.315068f,78.979784f,
                    34.183478f,78.925031f);
            poly[2751] = new TzPolygon(34.183478f,78.925031f, 34.315068f,78.979784f, 34.327381f,79.044455f, 34.361824f,78.971872f, 34.386708f,78.965220f,
                    34.383080f,78.925031f, 39.621629f,78.925031f, 39.621629f,87.315632f, 33.934308f,87.315632f, 33.934308f,78.925031f);
            poly[2752] = new TzPolygon(39.891552f,69.957225f, 39.891552f,70.983890f, 39.621629f,70.983890f, 39.621629f,69.957225f);
            poly[2753] = new TzPolygon(40.224681f,69.957225f, 40.234676f,69.995469f, 40.142990f,70.175289f, 40.169827f,70.193430f, 40.129322f,70.206823f,
                    40.129356f,70.291961f, 40.057729f,70.424404f, 40.051273f,70.470557f, 39.891552f,70.470557f, 39.891552f,69.957225f);
            poly[2754] = new TzPolygon(40.365035f,70.470557f, 40.386520f,70.378953f, 40.455165f,70.328172f, 40.497791f,70.470557f);
            poly[2755] = new TzPolygon(40.785252f,70.094795f, 40.755183f,70.068173f, 40.733563f,69.957225f, 40.785252f,69.957225f);
            poly[2756] = new TzPolygon(40.051273f,70.470557f, 40.039556f,70.554315f, 40.002213f,70.581610f, 39.947313f,70.491744f, 39.929957f,70.497659f,
                    39.965323f,70.547171f, 39.958715f,70.614788f, 39.990517f,70.662617f, 40.102976f,70.669916f, 40.127239f,70.791223f,
                    40.179236f,70.802941f, 40.189343f,70.831665f, 40.162262f,70.834737f, 40.164769f,70.859613f, 40.220842f,70.983890f,
                    39.891552f,70.983890f, 39.891552f,70.470557f);
            poly[2757] = new TzPolygon(40.220842f,70.983890f, 40.289877f,70.962470f, 40.288953f,70.983890f);
            poly[2758] = new TzPolygon(40.365035f,70.470557f, 40.497791f,70.470557f, 40.501519f,70.483011f, 40.549536f,70.513910f, 40.566491f,70.588067f,
                    40.663000f,70.704940f, 40.657952f,70.735198f, 40.686037f,70.730747f, 40.684753f,70.762545f, 40.732543f,70.795845f,
                    40.769215f,70.727674f, 40.785252f,70.723560f, 40.785252f,70.983890f, 40.288953f,70.983890f, 40.289877f,70.962470f,
                    40.225739f,70.982449f, 40.232925f,70.890006f, 40.188189f,70.759905f, 40.177295f,70.632330f, 40.234353f,70.579474f,
                    40.241958f,70.598314f, 40.312059f,70.559797f, 40.338905f,70.581970f);
            poly[2759] = new TzPolygon(40.185134f,70.983890f, 40.185134f,71.226069f, 39.621629f,71.226069f, 39.621629f,70.983890f);
            poly[2760] = new TzPolygon(40.267114f,71.042424f, 40.253325f,71.044600f, 40.226018f,71.038233f, 40.239844f,71.024941f);
            poly[2761] = new TzPolygon(40.340103f,71.226069f, 40.335463f,71.124498f, 40.285131f,71.072446f, 40.288953f,70.983890f, 40.785252f,70.983890f,
                    40.785252f,71.226069f);
            poly[2762] = new TzPolygon(40.008003f,71.226069f, 40.008003f,73.139736f, 39.621629f,73.139736f, 39.621629f,71.226069f);
            poly[2763] = new TzPolygon(40.340103f,71.226069f, 40.340281f,71.229963f, 40.322001f,71.241120f, 40.343180f,71.276398f, 40.307191f,71.310660f,
                    40.318823f,71.369060f, 40.284046f,71.427982f, 40.277771f,71.500558f, 40.226911f,71.517950f, 40.206682f,71.616273f,
                    40.267129f,71.620075f, 40.269628f,71.672768f, 40.202748f,71.706558f, 40.195912f,71.677108f, 40.149225f,71.729049f,
                    40.218476f,71.831230f, 40.253799f,71.841153f, 40.262582f,71.884632f, 40.237550f,71.943415f, 40.244698f,71.966756f,
                    40.256184f,71.949248f, 40.277020f,72.050420f, 40.319449f,71.966361f, 40.405233f,72.089239f, 40.451096f,72.086777f,
                    40.456738f,72.130141f, 40.495859f,72.173947f, 40.494192f,72.182902f, 40.008003f,72.182902f, 40.008003f,71.226069f);
            poly[2764] = new TzPolygon(40.785252f,73.139736f, 40.764627f,72.991056f, 40.731978f,72.946330f, 40.712312f,72.853401f, 40.672697f,72.846475f,
                    40.666682f,72.785599f, 40.607748f,72.749606f, 40.572754f,72.760236f, 40.597921f,72.694782f, 40.585403f,72.663739f,
                    40.510487f,72.655308f, 40.560653f,72.505539f, 40.551246f,72.475985f, 40.618427f,72.412010f, 40.603002f,72.346236f,
                    40.561493f,72.420181f, 40.539577f,72.425989f, 40.511828f,72.378574f, 40.508340f,72.415048f, 40.473332f,72.440926f,
                    40.404926f,72.420815f, 40.446053f,72.321198f, 40.434242f,72.277808f, 40.460299f,72.243501f, 40.481015f,72.253706f,
                    40.494192f,72.182902f, 40.785252f,72.182902f);
            poly[2765] = new TzPolygon(41.495524f,70.339250f, 41.495524f,70.752853f, 41.420466f,70.752853f, 41.465792f,70.717165f, 41.456817f,70.594263f,
                    41.409747f,70.551018f, 41.398174f,70.488009f, 41.470356f,70.407456f, 41.466599f,70.380882f);
            poly[2766] = new TzPolygon(41.495524f,70.249317f, 41.491385f,70.240439f, 41.495524f,70.228726f);
            poly[2767] = new TzPolygon(40.977877f,70.597635f, 40.913657f,70.671722f, 40.910707f,70.668933f);
            poly[2768] = new TzPolygon(40.785252f,70.094795f, 40.822062f,70.127386f, 40.822216f,70.201264f, 40.897997f,70.371823f, 41.002940f,70.374619f,
                    41.045094f,70.444945f, 40.978890f,70.556211f, 40.858291f,70.651792f, 40.809148f,70.727868f, 40.800506f,70.703387f,
                    40.785252f,70.715227f);
            poly[2769] = new TzPolygon(42.205796f,70.752853f, 42.194030f,70.752853f, 42.193305f,70.750926f, 42.016815f,70.637992f, 42.023513f,70.559429f,
                    42.073982f,70.545532f, 42.109185f,70.478109f, 42.084992f,70.459019f, 42.069325f,70.373515f, 42.038663f,70.320841f,
                    41.974706f,70.335250f, 41.934625f,70.228045f, 41.855308f,70.175865f, 41.837307f,70.102737f, 41.781437f,70.049237f,
                    41.798717f,70.005126f, 41.733579f,69.957225f, 42.205796f,69.957225f);
            poly[2770] = new TzPolygon(41.495524f,70.339250f, 41.520614f,70.303138f, 41.495524f,70.249317f, 41.495524f,70.228726f, 41.516531f,70.169274f,
                    41.557496f,70.179287f, 41.574641f,70.209820f, 41.611957f,70.209246f, 41.607455f,70.264249f, 41.719687f,70.496693f,
                    41.798576f,70.527502f, 41.819827f,70.599324f, 41.906951f,70.664961f, 41.913610f,70.752853f, 41.495524f,70.752853f);
            poly[2771] = new TzPolygon(42.205796f,70.784122f, 42.194030f,70.752853f, 42.205796f,70.752853f);
            poly[2772] = new TzPolygon(42.205796f,70.865364f, 42.197589f,70.849556f, 42.205796f,70.811019f);
            poly[2773] = new TzPolygon(41.420466f,70.752853f, 41.913610f,70.752853f, 41.936424f,70.757233f, 41.923105f,70.834805f, 42.054132f,70.865170f,
                    42.030407f,70.992746f, 42.133966f,71.141124f, 42.137210f,71.217871f, 42.167936f,71.258362f, 42.205796f,71.249920f,
                    42.205796f,71.548480f, 41.302011f,71.548480f, 41.316036f,71.487693f, 41.286842f,71.449654f, 41.126992f,71.439641f,
                    41.104630f,71.401412f, 41.149064f,71.382402f, 41.165690f,71.345300f, 41.104236f,71.284652f, 41.173389f,71.272515f,
                    41.191230f,71.239899f, 41.143580f,71.127122f, 41.190423f,71.038938f, 41.163536f,70.965779f, 41.250992f,70.840884f,
                    41.194854f,70.786333f, 41.386614f,70.779507f);
            poly[2774] = new TzPolygon(42.205796f,71.249920f, 42.227787f,71.245016f, 42.224275f,71.209472f, 42.282177f,71.133466f, 42.293568f,71.028483f,
                    42.252710f,70.988482f, 42.263248f,70.890861f, 42.299819f,70.865203f, 42.363689f,70.894027f, 42.400127f,70.955726f,
                    42.417980f,70.932899f, 42.497560f,70.980122f, 42.484377f,71.088975f, 42.558325f,71.000375f, 42.587646f,71.002555f,
                    42.605194f,71.156677f, 42.589805f,71.159889f, 42.674099f,71.178175f, 42.726934f,71.263483f, 42.777724f,71.267029f,
                    42.801498f,71.534108f, 42.795839f,71.548480f, 42.205796f,71.548480f);
            poly[2775] = new TzPolygon(42.205796f,70.784122f, 42.209453f,70.793843f, 42.205796f,70.811019f);
            poly[2776] = new TzPolygon(42.205796f,70.861234f, 42.263467f,70.943305f, 42.253971f,70.993134f, 42.292407f,71.025074f, 42.295078f,71.058392f,
                    42.282177f,71.133466f, 42.224275f,71.209472f, 42.227787f,71.245016f, 42.205796f,71.249920f);
            poly[2777] = new TzPolygon(41.302011f,71.548480f, 41.295378f,71.577229f, 41.348748f,71.641877f, 41.421776f,71.680424f, 41.491214f,71.643144f,
                    41.546774f,71.726142f, 41.424058f,71.707573f, 41.452071f,71.735944f, 41.434159f,71.752930f, 41.439477f,71.792086f,
                    41.355583f,71.837838f, 41.362000f,71.882619f, 41.294563f,71.925190f, 41.200848f,71.862007f, 41.167813f,71.886365f,
                    41.145358f,71.942625f, 41.156521f,72.006605f, 41.117437f,72.071090f, 41.152835f,72.107380f, 41.163996f,72.168559f,
                    41.125340f,72.150032f, 41.116658f,72.178873f, 41.050817f,72.210115f, 41.006970f,72.182224f, 41.013268f,72.162094f,
                    40.988111f,72.171507f, 41.010933f,72.270325f, 41.060351f,72.350392f, 41.029180f,72.388752f, 41.027477f,72.453014f,
                    40.967560f,72.495974f, 40.961821f,72.551467f, 40.867962f,72.591342f, 40.856432f,72.832167f, 40.800424f,72.939054f,
                    40.842779f,72.999995f, 40.851106f,73.084654f, 40.833371f,73.135411f, 40.785252f,73.139736f, 40.785252f,71.548480f);
            poly[2778] = new TzPolygon(42.205796f,73.139736f, 42.205796f,71.548480f, 42.795839f,71.548480f, 42.764766f,71.627404f, 42.832810f,71.863639f,
                    42.736503f,72.120370f, 42.759269f,72.282020f, 42.685138f,72.498939f, 42.681439f,72.606742f, 42.638905f,72.744279f,
                    42.567821f,72.814239f, 42.534988f,72.910790f, 42.551933f,73.120089f, 42.548409f,73.139736f);
            poly[2779] = new TzPolygon(28.246987f,92.940807f, 28.261607f,92.946869f, 28.304607f,93.060225f, 28.366405f,93.148549f, 28.544870f,93.196850f,
                    28.591267f,93.229809f, 28.526924f,93.307400f, 28.532580f,93.389540f, 28.671857f,93.465908f, 28.688354f,93.622965f,
                    28.654530f,93.637254f, 28.678325f,93.688514f, 28.664707f,93.712243f, 28.737021f,93.789848f, 28.757455f,93.896591f,
                    28.742227f,93.917940f, 28.773174f,93.912166f, 28.821472f,93.974898f, 28.795037f,93.988044f, 28.793489f,94.019745f,
                    28.844971f,94.023326f, 28.874970f,94.059228f, 28.890453f,94.135869f, 28.935935f,94.178641f, 28.930225f,94.257702f,
                    28.967869f,94.273960f, 29.025931f,94.366375f, 29.093863f,94.276863f, 29.152312f,94.293217f, 29.154127f,94.378907f,
                    29.184174f,94.390519f, 29.183376f,94.448073f, 29.213132f,94.456855f, 29.207762f,94.491982f, 29.231204f,94.510635f,
                    29.219737f,94.540972f, 29.295798f,94.626468f, 29.315394f,94.697159f, 29.286966f,94.734926f, 29.229680f,94.751664f,
                    29.216218f,94.784606f, 28.246987f,94.784606f);
            poly[2780] = new TzPolygon(29.368326f,96.029435f, 29.362545f,96.016531f, 29.375780f,95.965675f, 29.314569f,95.877492f, 29.321233f,95.841083f,
                    29.353088f,95.838883f, 29.347530f,95.812326f, 29.297963f,95.737147f, 29.225688f,95.743189f, 29.204005f,95.708829f,
                    29.224740f,95.698284f, 29.210403f,95.648046f, 29.235996f,95.605629f, 29.188010f,95.595676f, 29.206612f,95.560131f,
                    29.192157f,95.502074f, 29.126042f,95.503614f, 29.136824f,95.457879f, 29.192749f,95.433945f, 29.125924f,95.412736f,
                    29.136469f,95.299347f, 29.068340f,95.262616f, 29.107559f,95.211549f, 29.096066f,95.103847f, 29.112416f,95.119368f,
                    29.142038f,95.097212f, 29.173582f,94.994651f, 29.127475f,95.021816f, 29.179093f,94.884191f, 29.164868f,94.807259f,
                    29.208415f,94.803702f, 29.216218f,94.784606f, 29.382378f,94.784606f, 29.382378f,96.029435f);
            poly[2781] = new TzPolygon(29.369444f,96.029435f, 29.382378f,96.053628f, 29.345580f,96.136324f, 29.294890f,96.149618f, 29.244636f,96.260763f,
                    29.213806f,96.253209f, 29.190837f,96.299455f, 29.159026f,96.297799f, 29.110958f,96.182917f, 29.023355f,96.198539f,
                    29.096658f,96.269319f, 29.109276f,96.367377f, 29.038997f,96.365894f, 29.006316f,96.434492f, 28.936331f,96.454224f,
                    28.946505f,96.508177f, 28.860951f,96.521435f, 28.817788f,96.589261f, 28.787882f,96.570917f, 28.778633f,96.600669f,
                    28.708205f,96.610136f, 28.681194f,96.535914f, 28.626039f,96.512309f, 28.587225f,96.448074f, 28.554994f,96.481440f,
                    28.507556f,96.409488f, 28.490306f,96.478262f, 28.429930f,96.495966f, 28.529800f,96.514125f, 28.582913f,96.552484f,
                    28.613555f,96.613541f, 28.571337f,96.745415f, 28.514819f,96.766751f, 28.485312f,96.861174f, 28.391451f,96.886939f,
                    28.353041f,96.923520f, 28.324848f,97.002463f, 28.371374f,97.078334f, 28.361187f,97.125772f, 28.294135f,97.238133f,
                    28.246987f,97.274264f, 28.246987f,96.029435f);
            poly[2782] = new TzPolygon(28.246987f,97.391243f, 28.249962f,97.410995f, 28.295464f,97.413558f, 28.270278f,97.462483f, 28.282189f,97.482379f,
                    28.306142f,97.468766f, 28.329965f,97.517458f, 28.379704f,97.478190f, 28.444493f,97.523847f, 28.492235f,97.499832f,
                    28.547835f,97.580695f, 28.521803f,97.590237f, 28.541939f,97.652087f, 28.495702f,97.722347f, 28.398311f,97.735664f,
                    28.329639f,97.797115f, 28.328677f,97.842200f, 28.365740f,97.867391f, 28.368307f,97.908947f, 28.324505f,97.960290f,
                    28.299917f,97.955318f, 28.273534f,98.011677f, 28.246987f,98.014537f);
            poly[2783] = new TzPolygon(54.164317f,71.269255f, 54.094946f,71.178972f, 54.129279f,71.122355f, 54.188221f,71.112810f, 54.191382f,71.054742f,
                    54.274785f,71.073217f, 54.275436f,70.996356f, 54.336079f,70.998572f, 54.311703f,71.198688f, 54.406911f,71.230754f,
                    54.407284f,71.199815f, 54.461175f,71.201652f, 54.460853f,71.170431f, 54.560539f,71.167545f, 54.609784f,71.214683f,
                    54.606956f,71.269255f);
            poly[2784] = new TzPolygon(55.210021f,69.957225f, 55.208943f,70.057079f, 55.146373f,70.204353f, 55.215615f,70.401979f, 55.285828f,70.460140f,
                    55.253313f,70.620353f, 55.289454f,70.695208f, 55.292630f,70.807464f, 55.180215f,70.881281f, 55.166794f,70.925542f,
                    55.130379f,70.921630f, 55.085095f,71.018838f, 54.982542f,70.978198f, 54.970267f,71.008383f, 54.888512f,70.956273f,
                    54.852152f,71.019294f, 54.778482f,71.030462f, 54.701193f,71.095265f, 54.700061f,71.210466f, 54.668348f,71.239020f,
                    54.668015f,71.269255f, 54.609784f,71.269255f, 54.609784f,69.957225f);
            poly[2785] = new TzPolygon(56.046981f,69.957225f, 56.046981f,70.891556f, 55.902622f,70.808540f, 55.905967f,70.480612f, 55.851273f,70.471740f,
                    55.822901f,70.585787f, 55.855256f,70.757141f, 55.834617f,70.828713f, 55.800149f,70.698063f, 55.811069f,70.646012f,
                    55.791749f,70.550487f, 55.772025f,70.589364f, 55.694373f,70.531726f, 55.650732f,70.563457f, 55.625407f,70.710092f,
                    55.584722f,70.756972f, 55.490529f,70.673373f, 55.493869f,70.566960f, 55.407525f,70.439596f, 55.330815f,70.498739f,
                    55.215615f,70.401979f, 55.146373f,70.204353f, 55.208943f,70.057079f, 55.210021f,69.957225f);
            poly[2786] = new TzPolygon(56.046981f,70.887158f, 56.112283f,70.902366f, 56.186314f,70.806177f, 56.218311f,70.814554f, 56.212417f,70.773727f,
                    56.253127f,70.732229f, 56.301798f,70.851894f, 56.304836f,70.948417f, 56.046981f,70.948417f);
            poly[2787] = new TzPolygon(56.304836f,70.948417f, 56.361732f,70.932395f, 56.361732f,70.948417f);
            poly[2788] = new TzPolygon(56.361732f,71.033134f, 56.332147f,71.092014f, 56.322249f,71.081028f, 56.355931f,71.018371f);
            poly[2789] = new TzPolygon(56.317399f,71.196492f, 56.316430f,71.269255f, 56.301396f,71.192629f);
            poly[2790] = new TzPolygon(56.691085f,71.075766f, 56.682954f,71.020382f, 56.645153f,71.012849f, 56.624043f,71.113689f, 56.524166f,71.084598f,
                    56.462236f,70.984133f, 56.451317f,70.801087f, 56.424589f,70.735458f, 56.416457f,70.791186f, 56.442570f,70.812656f,
                    56.387356f,70.877066f, 56.379234f,70.927466f, 56.361732f,70.932395f, 56.361732f,69.957225f, 56.691085f,69.957225f);
            poly[2791] = new TzPolygon(56.655288f,71.269255f, 56.656553f,71.263843f, 56.652955f,71.120526f, 56.691085f,71.075766f, 56.691085f,71.269255f);
            poly[2792] = new TzPolygon(57.122178f,71.269255f, 57.174657f,71.229410f, 57.202398f,71.115605f, 57.258979f,71.070508f, 57.287380f,71.095010f,
                    57.293575f,71.052905f, 57.350892f,71.065009f, 57.351552f,70.974634f, 57.377303f,71.006812f, 57.383686f,70.948648f,
                    57.354927f,70.923780f, 57.378421f,70.837114f, 57.364979f,70.786795f, 57.324302f,70.774897f, 57.298402f,70.712410f,
                    57.264823f,70.778561f, 57.199557f,70.689253f, 57.205670f,70.581932f, 57.234288f,70.629275f, 57.280058f,70.606542f,
                    57.282399f,70.458831f, 57.329437f,70.372349f, 57.415114f,70.418236f, 57.458047f,70.578350f, 57.515541f,70.685693f,
                    57.553787f,70.690201f, 57.588299f,70.646444f, 57.577222f,70.598864f, 57.719781f,70.556548f, 57.735192f,70.478006f,
                    57.768888f,70.475460f, 57.782465f,70.392336f, 57.893274f,70.426659f, 57.900312f,70.358304f, 57.940440f,70.377096f,
                    57.938789f,70.439796f, 58.532484f,70.869395f, 58.528252f,70.949222f, 58.500064f,70.975714f, 58.504963f,71.073783f,
                    58.476959f,71.115297f, 58.427809f,71.101829f, 58.446235f,71.144162f, 58.399325f,71.269255f, 58.351546f,71.269255f,
                    58.327859f,71.237838f, 58.053158f,71.213523f, 58.065272f,71.269255f);
            poly[2793] = new TzPolygon(14.411063f,40.259453f, 14.394561f,40.227580f, 14.411063f,40.227580f);
            poly[2794] = new TzPolygon(8.352755f,45.938612f, 8.948625f,44.149420f, 9.040553f,43.979533f, 9.381904f,43.584557f, 9.411420f,43.500290f,
                    9.471804f,43.432245f, 9.552016f,43.399800f, 9.606075f,43.298227f, 9.842897f,43.256951f, 9.899240f,43.150037f,
                    9.886286f,43.129160f, 9.908089f,43.086198f, 10.051053f,43.024791f, 10.228965f,42.859727f, 10.435032f,42.770579f,
                    10.435032f,45.938612f);
            poly[2795] = new TzPolygon(12.423047f,40.259453f, 12.423047f,42.372609f, 12.371840f,42.337140f, 12.304640f,42.317230f, 12.234470f,42.240220f,
                    11.819650f,41.962198f, 11.793160f,41.899936f, 11.756144f,41.894917f, 11.728051f,41.833405f, 11.493786f,41.771314f,
                    11.318260f,41.807740f, 10.979380f,41.794255f, 10.938941f,41.941598f, 10.914955f,41.946875f, 10.925149f,42.068494f,
                    10.954600f,42.078245f, 10.981152f,42.144999f, 10.971333f,42.267905f, 11.001971f,42.349046f, 10.981871f,42.421253f,
                    11.095579f,42.628886f, 11.056284f,42.688753f, 11.079465f,42.752671f, 10.987302f,42.792411f, 10.969395f,42.867576f,
                    10.984410f,42.961640f, 10.622187f,42.709880f, 10.533637f,42.719882f, 10.511949f,42.747136f, 10.435032f,42.775292f,
                    10.435032f,40.259453f);
            poly[2796] = new TzPolygon(12.423047f,42.625583f, 12.423047f,42.795615f, 12.410628f,42.762802f, 12.382918f,42.748499f, 12.384025f,42.716743f,
                    12.354822f,42.700974f);
            poly[2797] = new TzPolygon(10.435032f,42.770579f, 10.578059f,42.708703f, 10.647487f,42.719000f, 10.721623f,42.765775f, 10.984410f,42.961640f,
                    11.213481f,43.099032f, 10.435032f,43.099032f);
            poly[2798] = new TzPolygon(14.411063f,40.259453f, 14.306844f,40.451745f, 14.172044f,40.810262f, 14.080276f,40.943350f, 13.610394f,41.250744f,
                    13.500883f,41.402824f, 13.384981f,41.642282f, 13.323582f,41.668527f, 13.074465f,41.890636f, 12.923316f,41.966364f,
                    12.868096f,42.030182f, 12.801041f,42.057302f, 12.762334f,42.219260f, 12.635484f,42.278617f, 12.468625f,42.404179f,
                    12.423047f,42.372609f, 12.423047f,40.259453f);
            poly[2799] = new TzPolygon(12.423047f,42.372609f, 12.468625f,42.404179f, 12.517230f,42.455400f, 12.490200f,42.547510f, 12.423047f,42.623634f);
        }
    }

    private static class Initializer29 {
        private static void init() {
            poly[2800] = new TzPolygon(12.423047f,42.795615f, 12.434141f,42.824926f, 12.477429f,42.796973f, 12.509633f,42.801857f, 12.549328f,42.859358f,
                    12.616897f,42.889418f, 12.610924f,42.915946f, 12.697891f,43.099032f, 12.423047f,43.099032f);
            poly[2801] = new TzPolygon(13.104124f,43.099032f, 13.115833f,43.089167f, 13.250823f,43.024409f, 13.654944f,43.078041f, 13.750786f,43.040222f,
                    13.545451f,42.968770f, 13.427520f,42.833861f, 13.457778f,42.723611f, 13.597500f,42.637222f, 14.060833f,42.477500f,
                    14.144167f,42.525833f, 14.252691f,42.642870f, 14.284127f,42.723044f, 14.280210f,42.830210f, 14.411063f,42.772238f,
                    14.411063f,43.099032f);
            poly[2802] = new TzPolygon(13.106553f,43.099032f, 12.969444f,43.212500f, 12.867536f,43.248864f, 12.802340f,43.300171f, 12.708475f,43.132093f,
                    12.693587f,43.099032f);
            poly[2803] = new TzPolygon(12.697891f,43.099032f, 12.792308f,43.297804f, 12.687129f,43.272993f, 12.595333f,43.320495f, 12.552689f,43.430532f,
                    12.552389f,43.535380f, 12.517951f,43.636488f, 12.419608f,43.657905f, 12.288371f,43.599683f, 12.095278f,43.621130f,
                    11.939279f,43.577567f, 11.846197f,43.521162f, 11.783114f,43.409874f, 11.711432f,43.425311f, 11.622329f,43.344252f,
                    11.213481f,43.099032f);
            poly[2804] = new TzPolygon(11.213481f,43.099032f, 11.622329f,43.344252f, 11.711432f,43.425311f, 11.700291f,43.544469f, 11.620215f,43.640333f,
                    11.413586f,43.707212f, 11.314187f,43.702112f, 11.087331f,43.835310f, 10.962034f,43.945409f, 10.605648f,44.390974f,
                    10.584525f,44.581890f, 10.619408f,44.746928f, 10.611046f,44.866559f, 10.726796f,45.107706f, 10.842829f,45.234789f,
                    10.861296f,45.389363f, 11.038810f,45.679923f, 11.066182f,45.767303f, 11.058508f,45.872145f, 11.029615f,45.938612f,
                    10.435032f,45.938612f, 10.435032f,43.099032f);
            poly[2805] = new TzPolygon(8.352755f,45.938612f, 8.001554f,46.993146f, 7.999773f,47.982380f, 7.560949f,47.557065f, 7.382621f,47.337517f,
                    6.520331f,46.511078f, 6.459000f,46.438637f, 6.459000f,45.938612f);
            poly[2806] = new TzPolygon(14.411063f,49.347510f, 14.338777f,49.276926f, 14.311865f,49.201637f, 14.189308f,49.147542f, 13.904463f,48.836938f,
                    13.850610f,48.734294f, 13.847106f,48.619498f, 13.739996f,48.451066f, 13.728937f,48.366704f, 13.776589f,48.249936f,
                    13.774681f,48.133283f, 13.841632f,48.018593f, 13.759588f,47.907384f, 13.722348f,47.786291f, 13.474704f,47.482819f,
                    13.350811f,46.995607f, 13.235422f,46.756821f, 13.235659f,46.618073f, 13.202308f,46.442728f, 13.230056f,46.244932f,
                    13.217601f,46.032522f, 13.198479f,45.938612f, 14.411063f,45.938612f);
            poly[2807] = new TzPolygon(14.411063f,40.259453f, 14.411063f,40.227580f, 16.734131f,40.227580f, 16.719467f,40.290551f, 16.627023f,40.372101f,
                    16.482442f,40.393977f, 16.382653f,40.447825f, 16.238603f,40.451595f, 16.153916f,40.431244f, 16.092206f,40.482263f,
                    16.106874f,40.568026f, 16.063782f,40.716888f, 15.792837f,41.025458f, 15.727069f,41.049446f, 15.627487f,41.040583f,
                    15.500235f,41.084999f, 15.409952f,41.062142f, 15.319039f,40.971713f, 15.287439f,40.864368f, 15.210269f,40.769585f,
                    15.180473f,40.685035f, 15.154475f,40.698273f, 15.044164f,40.861889f, 15.002844f,40.969095f, 14.868446f,41.070093f,
                    14.774391f,41.325681f, 14.627775f,41.465691f, 14.411063f,41.617953f);
            poly[2808] = new TzPolygon(19.000000f,43.075128f, 16.526140f,43.075128f, 16.521694f,42.992167f, 16.496972f,42.950306f, 16.441361f,42.937278f,
                    16.402139f,42.956472f, 16.379528f,42.830611f, 16.404389f,42.781139f, 16.404111f,42.150000f, 16.290000f,41.783333f,
                    16.290000f,41.680149f, 16.404681f,41.516839f, 16.656312f,41.315104f, 16.804857f,41.224990f, 17.567721f,40.840696f,
                    17.973377f,40.594840f, 18.176380f,40.512779f, 18.427896f,40.460605f, 18.623544f,40.319309f, 18.693124f,40.227580f,
                    19.000000f,40.227580f);
            poly[2809] = new TzPolygon(16.705531f,43.075128f, 16.705531f,43.213102f, 16.642833f,43.234722f, 16.671528f,43.128611f, 16.636417f,43.146333f,
                    16.528583f,43.120722f, 16.526140f,43.075128f);
            poly[2810] = new TzPolygon(16.705531f,43.213102f, 16.709694f,43.211667f, 16.745889f,43.226306f, 16.746861f,43.275472f, 16.769722f,43.253056f,
                    16.794944f,43.266611f, 16.853300f,43.199302f, 16.849056f,43.179972f, 16.917583f,43.138111f, 16.944528f,43.194667f,
                    17.032111f,43.180944f, 17.010083f,43.202722f, 17.029528f,43.230944f, 17.015250f,43.248639f, 17.075361f,43.227222f,
                    17.098611f,43.185278f, 17.086972f,43.160167f, 17.172667f,43.170833f, 17.210361f,43.216306f, 17.258806f,43.201722f,
                    17.303999f,43.336502f, 17.385528f,43.228028f, 17.401500f,43.247056f, 17.426167f,43.225500f, 17.457833f,43.256500f,
                    17.480528f,43.240750f, 17.556389f,43.354750f, 17.544000f,43.375556f, 17.565833f,43.419611f, 17.545111f,43.484639f,
                    17.366667f,43.683333f, 17.375000f,43.788895f, 17.338889f,43.831944f, 17.330556f,43.966667f, 17.402472f,44.011361f,
                    17.405833f,44.066667f, 17.366389f,44.110833f, 17.408889f,44.138056f, 17.433333f,44.366111f, 17.433333f,44.466667f,
                    17.405556f,44.566667f, 17.433333f,44.650000f, 17.433333f,45.216667f, 17.333333f,45.400000f, 17.271110f,45.922675f,
                    16.705531f,45.922675f);
            poly[2811] = new TzPolygon(18.933677f,51.617770f, 18.788889f,50.783333f, 18.616667f,49.116667f, 18.166667f,48.183333f, 17.449999f,47.600000f,
                    17.116667f,47.466667f, 16.950000f,47.183333f, 16.950000f,47.000000f, 17.283333f,46.750000f, 17.233333f,46.366667f,
                    17.250000f,46.100000f, 17.271110f,45.922675f, 19.000000f,45.922675f, 19.000000f,51.617770f);
            poly[2812] = new TzPolygon(19.000000f,52.000000f, 18.933677f,51.617770f, 19.000000f,51.617770f);
            poly[2813] = new TzPolygon(19.000000f,52.000000f, 17.349733f,52.782175f, 17.294444f,52.745833f, 17.285531f,52.812283f, 16.464961f,53.188846f,
                    16.397148f,52.949774f, 16.269142f,52.607434f, 16.217847f,52.520912f, 16.099991f,52.419150f, 15.969572f,52.371044f,
                    15.646939f,52.432209f, 15.520307f,52.396252f, 15.430189f,52.285182f, 15.348060f,52.043132f, 15.312847f,52.000000f);
            poly[2814] = new TzPolygon(23.787548f,51.873474f, 24.126971f,51.590376f, 24.265880f,51.589825f, 24.336352f,51.529512f, 24.393194f,51.416071f,
                    24.553035f,51.565206f, 24.664189f,51.586122f, 24.725735f,51.873474f);
            poly[2815] = new TzPolygon(24.765433f,50.807926f, 24.765433f,51.819478f, 24.716246f,51.829131f, 24.631933f,51.406381f, 24.505502f,51.302053f,
                    24.470753f,51.098535f, 24.546820f,50.928351f, 24.744368f,50.811625f);
            poly[2816] = new TzPolygon(26.687244f,50.595486f, 26.666036f,50.688378f, 26.597748f,50.773152f, 26.471269f,50.807684f, 26.390939f,50.871881f,
                    26.267299f,50.923369f, 26.077222f,50.907500f, 26.011111f,50.850000f, 25.895000f,50.815833f, 25.749444f,50.868056f,
                    25.638611f,50.839444f, 25.592500f,50.780278f, 25.562222f,50.817778f, 25.535000f,50.810000f, 25.581389f,50.689444f,
                    25.576111f,50.567500f, 25.679181f,50.433410f, 25.818903f,50.366187f, 25.879181f,50.304243f, 26.079736f,50.269799f,
                    26.171124f,50.311188f, 26.373346f,50.341743f, 26.407513f,50.376743f, 26.530013f,50.387577f, 26.620846f,50.556743f);
            poly[2817] = new TzPolygon(26.687244f,50.475558f, 26.584272f,50.488612f, 26.530013f,50.387577f, 26.407513f,50.376743f, 26.373346f,50.341743f,
                    26.171124f,50.311188f, 26.079736f,50.269799f, 25.879181f,50.304243f, 25.818903f,50.366187f, 25.698347f,50.416743f,
                    25.576111f,50.567500f, 25.478381f,50.615226f, 25.137385f,50.665923f, 25.007554f,50.720805f, 24.922882f,50.706231f,
                    24.893977f,50.785353f, 24.765433f,50.807926f, 24.765433f,48.962001f, 26.687244f,48.962001f);
            poly[2818] = new TzPolygon(28.195105f,50.174312f, 28.175328f,50.270126f, 28.127173f,50.342523f, 28.063384f,50.385939f, 27.985164f,50.400298f,
                    27.887085f,50.366892f, 27.881804f,49.983443f, 27.990731f,49.945241f, 28.127570f,50.001703f, 28.184441f,50.097736f);
            poly[2819] = new TzPolygon(22.004382f,51.873474f, 22.004382f,55.663866f, 22.000015f,55.666685f, 20.000000f,55.000000f, 19.000000f,52.000000f,
                    19.000000f,51.873474f);
            poly[2820] = new TzPolygon(22.004382f,55.663866f, 22.705423f,55.211371f, 23.110348f,55.232271f, 23.629646f,55.572309f, 23.720734f,55.569228f,
                    23.757286f,55.531869f, 23.849352f,55.533726f, 23.942110f,55.484532f, 24.058066f,55.731246f, 24.055948f,55.781754f,
                    24.014630f,55.833109f, 24.051454f,55.964026f, 22.004382f,55.964026f);
            poly[2821] = new TzPolygon(24.198816f,55.964026f, 24.222568f,55.954447f, 24.200902f,55.833523f, 24.234795f,55.752881f, 24.327733f,55.833944f,
                    24.409554f,55.834202f, 24.529654f,55.764822f, 24.572580f,55.767575f, 24.615294f,55.816147f, 24.637131f,55.793702f,
                    24.671313f,55.836581f, 24.910794f,55.812355f, 24.965818f,55.851453f, 24.965663f,55.910907f, 25.005997f,55.961118f,
                    25.004684f,55.964026f);
            poly[2822] = new TzPolygon(25.008764f,52.013155f, 25.008764f,52.370111f, 25.003760f,52.352211f, 24.957722f,52.334699f, 24.900336f,52.378334f,
                    24.842177f,52.309194f, 24.829744f,52.240327f, 24.838253f,52.164737f, 24.885217f,52.077010f, 24.939695f,52.031526f);
            poly[2823] = new TzPolygon(25.008764f,52.454403f, 24.982958f,52.450032f, 25.008764f,52.418250f);
            poly[2824] = new TzPolygon(23.787548f,51.873474f, 22.939204f,52.581040f, 22.631621f,55.137338f, 22.708791f,55.209179f, 22.004382f,55.663866f,
                    22.004382f,51.873474f);
            poly[2825] = new TzPolygon(25.008764f,56.594052f, 24.972761f,56.323327f, 24.934406f,56.348856f, 24.914536f,56.338415f, 24.859817f,56.259358f,
                    24.850507f,56.205659f, 24.785123f,56.201054f, 24.741556f,56.144333f, 24.746639f,56.060585f, 24.877363f,55.978341f,
                    24.894492f,55.980164f, 24.870801f,56.062186f, 24.886589f,56.042048f, 24.949431f,56.058922f, 24.994727f,56.006871f,
                    25.005191f,55.964026f, 25.008764f,55.964026f);
            poly[2826] = new TzPolygon(24.198816f,55.964026f, 24.066467f,56.017398f, 24.051454f,55.964026f);
            poly[2827] = new TzPolygon(25.008764f,52.386826f, 25.016424f,52.415165f, 25.008764f,52.422088f);
            poly[2828] = new TzPolygon(26.627876f,55.859476f, 26.388248f,55.859476f, 26.139838f,55.508783f, 26.070052f,55.422999f, 25.886787f,55.276624f,
                    25.762243f,55.250204f, 25.678086f,55.150441f, 25.654342f,55.000880f, 25.706924f,54.866976f, 25.714791f,54.650496f,
                    25.692518f,54.530063f, 25.707190f,54.461109f, 26.627876f,54.461109f);
            poly[2829] = new TzPolygon(25.284875f,56.281079f, 25.274780f,56.294208f, 25.260747f,56.273945f, 25.265209f,56.269953f);
            poly[2830] = new TzPolygon(26.097459f,55.859476f, 26.151722f,55.888369f, 26.050441f,56.086425f, 26.062127f,56.159120f, 25.979301f,56.195513f,
                    25.947151f,56.164440f, 25.894512f,56.178517f, 25.832500f,56.139167f, 25.769167f,56.172500f, 25.735000f,56.140833f,
                    25.676111f,56.143611f, 25.648056f,56.191111f, 25.611984f,56.201874f, 25.602190f,56.253291f, 25.627665f,56.264174f,
                    25.682657f,56.418384f, 25.692716f,56.549221f, 25.549234f,56.591385f, 25.323577f,56.602446f, 25.008764f,56.594052f,
                    25.008764f,55.859476f);
            poly[2831] = new TzPolygon(25.590279f,57.257843f, 25.603977f,57.216810f, 25.685279f,57.112581f, 25.842645f,57.071228f, 25.935722f,56.978051f,
                    26.104854f,56.951417f, 26.244885f,56.871362f, 26.431808f,56.816008f, 26.568724f,56.859186f, 26.627876f,56.848629f,
                    26.627876f,57.257843f);
            poly[2832] = new TzPolygon(26.627876f,56.343581f, 26.590287f,56.241734f, 26.503741f,56.132255f, 26.412236f,55.893341f, 26.388248f,55.859476f,
                    26.627876f,55.859476f);
            poly[2833] = new TzPolygon(26.627876f,56.359332f, 26.702674f,56.546250f, 26.654629f,56.665429f, 26.627876f,56.687361f);
            poly[2834] = new TzPolygon(26.544310f,60.054577f, 26.544310f,62.429106f, 26.533158f,62.421176f, 26.539378f,62.370225f, 26.508287f,62.303304f,
                    26.462772f,62.306943f, 26.439747f,62.284882f, 26.446225f,62.257767f, 26.380344f,62.284695f, 26.346581f,62.250133f,
                    26.328003f,62.271944f, 26.329538f,62.228244f, 26.267929f,62.215011f, 26.273986f,62.125388f, 26.318861f,62.085181f,
                    26.334491f,62.033364f, 26.260217f,61.961143f, 26.261399f,61.896325f, 25.967194f,61.818359f, 25.911402f,61.831706f,
                    25.914788f,61.856840f, 25.883199f,61.890722f, 25.877674f,61.842190f, 25.849211f,61.820408f, 25.816431f,61.851539f,
                    25.744840f,61.840067f, 25.717887f,61.798234f, 25.741720f,61.736329f, 25.647835f,61.672325f, 25.305813f,61.650582f,
                    25.045388f,61.575548f, 24.846510f,61.549733f, 24.866277f,61.354676f, 25.072768f,60.576576f, 25.136269f,60.054577f);
            poly[2835] = new TzPolygon(28.246987f,62.788931f, 28.025923f,62.761022f, 27.764463f,62.828955f, 27.462939f,62.848423f, 27.338783f,62.791328f,
                    27.299191f,62.824803f, 27.264235f,62.808820f, 27.252896f,62.775572f, 27.218458f,62.820731f, 27.228859f,62.873027f,
                    27.201440f,62.936974f, 27.259436f,63.198716f, 27.225621f,63.224699f, 27.213732f,63.281777f, 27.118400f,63.333270f,
                    27.129646f,63.307125f, 27.092151f,63.251094f, 26.849903f,63.246334f, 26.836726f,63.185979f, 26.773330f,63.208945f,
                    26.770481f,63.191485f, 26.647126f,63.196920f, 26.652392f,63.108061f, 26.627541f,63.048857f, 26.649943f,62.989971f,
                    26.651003f,62.794700f, 26.645016f,62.753537f, 26.613237f,62.738103f, 26.610976f,62.651571f, 26.576273f,62.604098f,
                    26.566895f,62.445165f, 26.544310f,62.429106f, 26.544310f,60.054577f, 28.246987f,60.054577f);
            poly[2836] = new TzPolygon(24.345118f,67.348933f, 24.345118f,70.341847f, 24.295000f,70.109920f, 24.198970f,70.066540f, 24.171030f,70.025020f,
                    24.171040f,69.731520f, 24.292380f,69.594290f, 24.267820f,69.493980f, 24.281430f,69.312760f, 24.236390f,69.194160f,
                    24.274440f,69.094820f, 24.223060f,69.003420f, 24.302530f,68.945380f, 24.212203f,68.866023f, 24.311520f,68.830800f,
                    24.313490f,68.808010f, 24.295789f,68.764696f, 23.971424f,68.752991f, 23.970831f,68.379554f, 23.940377f,68.365076f,
                    23.974153f,68.356976f, 23.912225f,68.326123f, 23.944447f,68.290568f, 23.918892f,68.270845f, 23.897781f,68.281956f,
                    23.868336f,68.214456f, 23.688336f,68.186123f, 23.601451f,68.111379f, 23.539392f,68.115008f, 23.601345f,67.742040f,
                    23.654392f,67.520728f, 23.713308f,67.375332f, 23.741077f,67.348933f);
            poly[2837] = new TzPolygon(24.345118f,70.942294f, 24.294850f,70.873940f, 24.259400f,70.906680f, 24.220830f,70.805370f, 24.215710f,70.714000f,
                    24.251750f,70.571340f, 24.290410f,70.584660f, 24.345118f,70.565260f);
            poly[2838] = new TzPolygon(24.345118f,70.341847f, 24.350910f,70.368650f, 24.420850f,70.561340f, 24.408150f,70.602500f, 24.354000f,70.562110f,
                    24.345118f,70.565260f);
            poly[2839] = new TzPolygon(24.345118f,70.942294f, 24.348520f,70.946920f, 24.365280f,70.986000f, 24.351050f,71.042040f, 24.402450f,71.119650f,
                    24.435720f,71.103150f, 24.444370f,70.998500f, 24.595570f,70.986290f, 24.635410f,71.008880f, 24.688630f,71.096180f,
                    24.938612f,70.937706f, 25.148104f,70.888493f, 25.277708f,70.751671f, 25.332444f,70.736786f, 25.396894f,70.664823f,
                    25.525542f,70.678557f, 25.702021f,70.660150f, 25.714852f,70.608610f, 25.683373f,70.530167f, 25.673740f,70.387023f,
                    25.713643f,70.268640f, 25.938241f,70.099806f, 26.083377f,70.083435f, 26.155971f,70.141203f, 26.251480f,70.175154f,
                    26.296053f,70.175025f, 26.296053f,71.364596f, 24.345118f,71.364596f);
            poly[2840] = new TzPolygon(26.296053f,70.175025f, 26.551333f,70.174284f, 26.600515f,70.056278f, 26.588956f,69.823167f, 26.743539f,69.510300f,
                    26.804873f,69.484437f, 27.009929f,69.513377f, 27.183251f,69.586829f, 27.402154f,69.862888f, 27.497740f,69.933750f,
                    27.562869f,70.025927f, 27.805981f,70.132551f, 28.011824f,70.372233f, 28.036977f,70.505714f, 28.010464f,70.589498f,
                    27.921829f,70.677414f, 27.828200f,70.684346f, 27.741907f,70.739845f, 27.721219f,70.759445f, 27.705548f,70.872003f,
                    27.835337f,71.205569f, 27.868656f,71.364596f, 26.296053f,71.364596f);
            poly[2841] = new TzPolygon(28.246987f,72.036975f, 28.218543f,72.004318f, 28.121703f,71.927333f, 27.961238f,71.898348f, 27.877807f,71.666486f,
                    27.872527f,71.383071f, 27.868656f,71.364596f, 28.246987f,71.364596f);
            poly[2842] = new TzPolygon(9.534601f,79.395921f, 9.353433f,79.420374f, 9.257961f,79.566519f, 9.087215f,79.571336f, 8.897623f,79.496340f,
                    8.964265f,79.395921f);
            poly[2843] = new TzPolygon(9.534601f,79.397721f, 9.549000f,79.395921f, 9.580000f,79.450873f, 9.683000f,79.501621f, 9.933000f,79.758139f,
                    10.007000f,79.946845f, 10.035000f,80.217587f, 10.016000f,80.315727f, 9.979000f,80.381545f, 9.808000f,80.503755f,
                    9.534601f,80.832162f);
            poly[2844] = new TzPolygon(13.661110f,92.695154f, 13.680011f,92.704138f, 13.755082f,92.765328f, 13.850219f,92.902720f, 13.882229f,93.034954f,
                    13.772586f,93.238962f, 13.692188f,93.267737f, 13.661110f,93.266525f);
            poly[2845] = new TzPolygon(10.961416f,114.090872f, 10.926444f,114.120655f, 10.891215f,114.069586f, 10.911022f,114.043236f);
            poly[2846] = new TzPolygon(28.246987f,113.630139f, 21.533997f,113.630139f, 21.386824f,112.952690f, 28.246987f,112.952690f);
            poly[2847] = new TzPolygon(22.140898f,115.212170f, 21.627050f,114.058469f, 21.533997f,113.630139f, 28.246987f,113.630139f, 28.246987f,115.212170f);
            poly[2848] = new TzPolygon(53.560815f,123.271244f, 53.498121f,123.137314f, 53.507546f,123.059926f, 53.456437f,122.849512f, 53.463868f,122.596146f,
                    53.443248f,122.429659f, 53.502290f,122.341691f, 53.463687f,122.243643f, 53.469130f,122.159168f, 53.458529f,122.145820f,
                    53.560815f,122.145820f);
            poly[2849] = new TzPolygon(40.816221f,123.271244f, 40.816221f,125.643249f, 40.809107f,125.631766f, 40.765282f,125.683513f, 40.754493f,125.599080f,
                    40.780748f,125.567262f, 40.719583f,125.532033f, 40.717346f,125.475304f, 40.665861f,125.444641f, 40.669647f,125.411591f,
                    40.627945f,125.414881f, 40.650707f,125.371272f, 40.636997f,125.329224f, 40.654231f,125.277225f, 40.612920f,125.257296f,
                    40.605098f,125.178206f, 40.524780f,125.008263f, 40.460285f,125.035133f, 40.454383f,124.922250f, 40.479921f,124.894964f,
                    40.411356f,124.827195f, 40.379009f,124.749588f, 40.322155f,124.721367f, 40.298415f,124.633740f, 40.229256f,124.521931f,
                    40.175562f,124.485272f, 40.082617f,124.352153f, 40.051652f,124.334144f, 40.031394f,124.370125f, 39.970674f,124.354119f,
                    39.987873f,124.345327f, 39.967825f,124.292375f, 39.927749f,124.284178f, 39.914657f,124.223931f, 39.611778f,124.091390f,
                    39.605000f,123.948353f, 39.551000f,123.792152f, 39.558000f,123.572016f, 39.506000f,123.365818f, 39.273000f,123.299891f,
                    39.196000f,123.402859f, 39.039000f,123.477166f, 38.951000f,123.451389f, 38.880000f,123.377383f, 38.853572f,123.271244f);
            poly[2850] = new TzPolygon(40.816221f,125.643249f, 40.889884f,125.762159f, 40.861640f,125.807540f, 40.905341f,125.868781f, 40.910108f,125.910065f,
                    40.876229f,125.935150f, 40.901126f,125.967566f, 40.901309f,126.018275f, 40.915958f,125.975110f, 40.927074f,126.034218f,
                    40.975992f,126.077642f, 40.999814f,126.069734f, 41.005018f,126.103582f, 41.034458f,126.097955f, 41.039876f,126.111597f,
                    40.816221f,126.111597f);
            poly[2851] = new TzPolygon(43.008964f,127.531774f, 41.475166f,127.531774f, 41.480802f,127.466273f, 41.457829f,127.453766f, 41.455442f,127.410711f,
                    41.478789f,127.391574f, 41.460311f,127.347580f, 41.478770f,127.251245f, 41.512082f,127.273306f, 41.497540f,127.239846f,
                    41.530998f,127.207439f, 41.543126f,127.097621f, 41.592320f,127.178434f, 41.597548f,127.123799f, 41.621526f,127.119005f,
                    41.625354f,127.085621f, 41.642117f,127.102279f, 41.669674f,127.031933f, 41.700458f,127.077003f, 41.701488f,127.049908f,
                    41.741875f,127.045195f, 41.773519f,126.928429f, 41.807099f,126.940980f, 41.786744f,126.878274f, 41.721674f,126.839651f,
                    41.747628f,126.805322f, 41.691222f,126.790567f, 41.749010f,126.693875f, 41.728124f,126.683750f, 41.704760f,126.724978f,
                    41.654147f,126.646565f, 41.672676f,126.614516f, 41.616618f,126.591706f, 41.610880f,126.563243f, 41.549190f,126.583770f,
                    41.430985f,126.504353f, 41.355441f,126.532010f, 41.345647f,126.476575f, 41.371859f,126.502500f, 41.352116f,126.433142f,
                    41.158851f,126.280241f, 41.092666f,126.165840f, 41.088002f,126.117836f, 41.046892f,126.129264f, 41.039876f,126.111597f,
                    43.008964f,126.111597f);
            poly[2852] = new TzPolygon(42.046545f,128.951950f, 42.024797f,128.947003f, 42.009820f,128.914781f, 42.051332f,128.745011f, 42.011861f,128.685099f,
                    42.031851f,128.603693f, 41.997040f,128.563984f, 42.024071f,128.284887f, 42.020385f,128.084445f, 41.995489f,128.031240f,
                    41.944810f,128.099451f, 41.795870f,128.103369f, 41.777794f,128.141534f, 41.727729f,128.149470f, 41.665447f,128.263654f,
                    41.599443f,128.310778f, 41.537178f,128.295961f, 41.495751f,128.233348f, 41.448646f,128.240181f, 41.360644f,128.108116f,
                    41.372631f,128.083731f, 41.395788f,128.099292f, 41.376659f,128.074317f, 41.392242f,128.030858f, 41.415513f,128.039350f,
                    41.428179f,127.996999f, 41.444981f,128.009200f, 41.414859f,127.978017f, 41.456693f,127.931866f, 41.426897f,127.906421f,
                    41.444903f,127.873811f, 41.401097f,127.863846f, 41.420169f,127.845522f, 41.404657f,127.787793f, 41.424220f,127.777183f,
                    41.412124f,127.670315f, 41.426862f,127.652364f, 41.403445f,127.650640f, 41.429997f,127.613243f, 41.432174f,127.555347f,
                    41.474524f,127.539236f, 41.475166f,127.531774f, 43.008964f,127.531774f, 43.008964f,128.951950f);
            poly[2853] = new TzPolygon(43.008964f,129.662038f, 42.425273f,129.662038f, 42.424688f,129.646934f, 42.461709f,129.609155f, 42.360181f,129.545500f,
                    42.440816f,129.448192f, 42.450871f,129.394033f, 42.422585f,129.382371f, 42.452644f,129.348800f, 42.406720f,129.351107f,
                    42.431227f,129.332052f, 42.422930f,129.307719f, 42.384972f,129.320304f, 42.379783f,129.243025f, 42.352251f,129.223659f,
                    42.319679f,129.249717f, 42.314636f,129.192798f, 42.307392f,129.236852f, 42.285967f,129.200663f, 42.265815f,129.217754f,
                    42.259608f,129.176441f, 42.204980f,129.221569f, 42.185772f,129.160574f, 42.163715f,129.165813f, 42.138841f,129.114271f,
                    42.156034f,129.066961f, 42.088696f,129.004069f, 42.094706f,128.962905f, 42.046545f,128.951950f, 43.008964f,128.951950f);
            poly[2854] = new TzPolygon(42.607588f,130.372127f, 42.699974f,130.287180f, 42.706298f,130.252795f, 42.817093f,130.236645f, 42.903417f,130.261965f,
                    42.912345f,130.107135f, 42.971295f,130.146339f, 42.985361f,130.124023f, 42.970541f,129.984462f, 42.978740f,129.954068f,
                    43.007583f,129.955623f, 43.007724f,129.912021f, 42.987119f,129.877345f, 42.967667f,129.909181f, 42.961559f,129.851428f,
                    42.918937f,129.869176f, 42.920276f,129.843809f, 42.789693f,129.808504f, 42.724965f,129.759869f, 42.678746f,129.803853f,
                    42.672129f,129.774255f, 42.642494f,129.784295f, 42.647265f,129.747280f, 42.604682f,129.778971f, 42.575727f,129.736471f,
                    42.466810f,129.744426f, 42.426907f,129.704196f, 42.425273f,129.662038f, 43.008964f,129.662038f, 43.008964f,130.372127f);
            poly[2855] = new TzPolygon(42.607588f,130.372127f, 42.601973f,130.377289f, 42.609056f,130.430087f, 42.571259f,130.415703f, 42.546597f,130.448627f,
                    42.561742f,130.480441f, 42.604144f,130.462331f, 42.613880f,130.516977f, 42.542398f,130.526414f, 42.477936f,130.583655f,
                    42.437230f,130.567599f, 42.422879f,130.630116f, 42.373007f,130.672274f, 42.324801f,130.654542f, 42.170636f,130.924647f,
                    42.103113f,130.812526f, 42.043530f,130.643740f, 42.028712f,130.510066f, 41.945906f,130.372127f);
            poly[2856] = new TzPolygon(43.008964f,131.792303f, 42.627807f,131.792303f, 42.473372f,131.611966f, 42.291572f,131.070996f, 42.215806f,130.950305f,
                    42.170636f,130.924647f, 42.330185f,130.650381f, 42.373007f,130.672274f, 42.518983f,130.552953f, 42.555114f,130.563457f,
                    42.554910f,130.603343f, 42.588220f,130.625639f, 42.669889f,130.584674f, 42.701434f,130.521415f, 42.685219f,130.459173f,
                    42.724967f,130.394650f, 42.845129f,130.658965f, 42.836053f,130.771956f, 42.868503f,130.781648f, 42.880665f,130.826974f,
                    42.850347f,130.883698f, 42.874691f,130.941738f, 42.854546f,130.974335f, 42.860293f,131.035367f, 42.925863f,131.026361f,
                    42.912674f,131.107478f, 42.934039f,131.137532f, 42.965296f,131.143586f, 42.968315f,131.110491f, 43.008964f,131.099043f);
            poly[2857] = new TzPolygon(53.196385f,124.989767f, 53.195757f,124.975464f, 53.171036f,124.894717f, 53.109636f,124.898748f, 53.099022f,124.862069f,
                    53.143090f,124.823912f, 53.151420f,124.711726f, 53.192732f,124.707609f, 53.213998f,124.437335f, 53.374718f,124.243767f,
                    53.346504f,124.109950f, 53.398751f,124.061362f, 53.397558f,124.008109f, 53.480723f,123.879364f, 53.493354f,123.695599f,
                    53.547767f,123.612030f, 53.494966f,123.539210f, 53.553413f,123.533491f, 53.541806f,123.483584f, 53.496077f,123.481067f,
                    53.532381f,123.452798f, 53.560815f,123.271244f, 53.560815f,124.989767f);
            poly[2858] = new TzPolygon(51.577443f,126.708291f, 51.590832f,126.672630f, 51.618215f,126.708291f);
            poly[2859] = new TzPolygon(51.721134f,126.708291f, 51.734155f,126.659069f, 51.944051f,126.456619f, 52.025466f,126.438290f, 52.037188f,126.514803f,
                    52.130324f,126.554232f, 52.206198f,126.300397f, 52.239974f,126.311392f, 52.291650f,126.431694f, 52.303310f,126.334833f,
                    52.337006f,126.310874f, 52.395943f,126.339958f, 52.473585f,126.262571f, 52.469613f,126.184032f, 52.537775f,126.192104f,
                    52.603246f,126.067824f, 52.573906f,126.026953f, 52.608627f,125.972757f, 52.663208f,125.970578f, 52.681401f,126.062955f,
                    52.740260f,126.037713f, 52.770206f,126.105020f, 52.797995f,126.038530f, 52.756977f,125.977965f, 52.763228f,125.939296f,
                    52.895372f,125.829540f, 52.896699f,125.766748f, 52.861169f,125.665462f, 52.915991f,125.656459f, 52.938821f,125.724304f,
                    52.983836f,125.741989f, 53.007309f,125.672697f, 53.078048f,125.614337f, 53.048466f,125.507586f, 53.094768f,125.494724f,
                    53.203757f,125.157808f, 53.196385f,124.989767f, 53.560815f,124.989767f, 53.560815f,126.708291f);
            poly[2860] = new TzPolygon(49.592949f,128.426814f, 49.590265f,128.389234f, 49.542136f,128.335939f, 49.564886f,128.249972f, 49.536064f,128.169489f,
                    49.555574f,128.034466f, 49.596388f,127.959048f, 49.574485f,127.842807f, 49.667035f,127.687240f, 49.770399f,127.665195f,
                    49.790365f,127.556631f, 49.819066f,127.525434f, 49.933661f,127.541241f, 49.990439f,127.489454f, 50.059415f,127.501645f,
                    50.180874f,127.603345f, 50.234715f,127.605633f, 50.285107f,127.380666f, 50.335147f,127.325288f, 50.434399f,127.362662f,
                    50.470230f,127.286180f, 50.573974f,127.367001f, 50.663799f,127.287421f, 50.745257f,127.300224f, 50.773925f,127.233105f,
                    50.922852f,127.117187f, 50.922852f,128.426814f);
            poly[2861] = new TzPolygon(48.920820f,130.145337f, 49.009259f,130.019682f, 49.042492f,129.913791f, 49.094297f,129.922262f, 49.115150f,129.848953f,
                    49.177055f,129.842436f, 49.186504f,129.764566f, 49.291092f,129.710480f, 49.275778f,129.600028f, 49.289463f,129.559300f,
                    49.398036f,129.536643f, 49.424677f,129.500653f, 49.441620f,129.430276f, 49.429369f,129.379970f, 49.351694f,129.352080f,
                    49.399510f,129.226050f, 49.350473f,129.126232f, 49.353596f,129.073450f, 49.456923f,128.983659f, 49.489404f,128.866890f,
                    49.471756f,128.793272f, 49.483099f,128.743189f, 49.550284f,128.802172f, 49.593385f,128.752774f, 49.562325f,128.717362f,
                    49.601958f,128.552929f, 49.592949f,128.426814f, 50.922852f,128.426814f, 50.922852f,130.145337f);
            poly[2862] = new TzPolygon(51.721134f,126.708291f, 51.717035f,126.723785f, 51.637627f,126.733570f, 51.618215f,126.708291f);
            poly[2863] = new TzPolygon(51.577443f,126.708291f, 51.528507f,126.838627f, 51.443847f,126.775799f, 51.420730f,126.801033f, 51.408204f,126.896133f,
                    51.362781f,126.923771f, 51.329542f,126.813736f, 51.252786f,126.843605f, 51.254076f,126.912785f, 51.320960f,126.880855f,
                    51.320209f,126.977329f, 51.203337f,126.894245f, 51.057039f,126.917659f, 50.936908f,127.106247f, 50.922852f,127.117187f,
                    50.922852f,126.708291f);
            poly[2864] = new TzPolygon(43.008964f,131.099043f, 43.021124f,131.095619f, 43.066334f,131.113457f, 43.067067f,131.163578f, 43.095262f,131.155494f,
                    43.143803f,131.210391f, 43.233019f,131.198564f, 43.262320f,131.247919f, 43.375379f,131.272877f, 43.395416f,131.311365f,
                    43.468961f,131.296936f, 43.528852f,131.192494f, 43.558276f,131.186897f, 43.600074f,131.236837f, 43.609291f,131.207174f,
                    43.663558f,131.233365f, 43.783492f,131.203406f, 43.936680f,131.261229f, 43.984699f,131.235960f, 44.030533f,131.255728f,
                    44.043933f,131.303221f, 44.707526f,131.104477f, 44.784002f,131.057196f, 44.783092f,131.011657f, 44.847861f,130.957019f,
                    44.889563f,131.089302f, 44.935554f,131.099755f, 44.921649f,131.272908f, 44.987801f,131.349244f, 44.966268f,131.486276f,
                    44.993497f,131.476186f, 45.116035f,131.680045f, 45.149039f,131.680177f, 45.155148f,131.647047f, 45.219570f,131.673978f,
                    45.210002f,131.785722f, 45.244519f,131.779489f, 45.329654f,131.863861f, 43.008964f,131.863861f);
            poly[2865] = new TzPolygon(45.646927f,133.447326f, 45.644204f,133.438762f, 45.619438f,133.469345f, 45.617099f,133.404641f, 45.571411f,133.412943f,
                    45.575473f,133.364437f, 45.516402f,133.247074f, 45.514339f,133.193568f, 45.427258f,133.133923f, 45.375518f,133.141356f,
                    45.252554f,133.086149f, 45.189974f,133.130725f, 45.125334f,133.132466f, 45.015110f,132.950137f, 45.061194f,132.863202f,
                    45.251774f,131.997163f, 45.280063f,131.927660f, 45.336909f,131.912234f, 45.341505f,131.875606f, 45.329654f,131.863861f,
                    45.646927f,131.863861f);
            poly[2866] = new TzPolygon(48.284889f,130.820857f, 48.095968f,130.654423f, 48.047775f,130.682697f, 47.917820f,130.880451f, 47.825461f,130.949798f,
                    47.708645f,130.967455f, 47.683168f,131.089526f, 47.734781f,131.254649f, 47.743090f,131.452666f, 47.726640f,131.547516f,
                    47.682538f,131.552229f, 47.656518f,131.594433f, 47.708472f,131.710140f, 47.667169f,131.812213f, 47.680789f,131.863861f,
                    45.646927f,131.863861f, 45.646927f,130.145337f, 48.284889f,130.145337f);
            poly[2867] = new TzPolygon(47.680789f,131.863861f, 47.690849f,131.902011f, 47.662394f,131.952136f, 47.711239f,131.999512f, 47.708066f,132.252824f,
                    47.756778f,132.309187f, 47.714323f,132.548728f, 47.742093f,132.603677f, 47.810336f,132.598655f, 47.872080f,132.680488f,
                    47.955878f,132.666225f, 47.961889f,132.719188f, 47.925051f,132.780520f, 47.935005f,132.815792f, 47.991727f,132.863060f,
                    48.040472f,133.007818f, 48.104874f,133.049473f, 48.092762f,133.286700f, 48.123559f,133.391526f, 48.121542f,133.522473f,
                    48.137375f,133.565485f, 48.174231f,133.582384f, 45.868309f,133.582384f, 45.895849f,133.523191f, 45.855597f,133.478227f,
                    45.837082f,133.489707f, 45.835693f,133.461656f, 45.796393f,133.462128f, 45.778077f,133.497692f, 45.777348f,133.462417f,
                    45.738162f,133.479866f, 45.695535f,133.420712f, 45.689599f,133.476961f, 45.657397f,133.480259f, 45.646927f,133.447326f,
                    45.646927f,131.863861f);
            poly[2868] = new TzPolygon(46.965908f,133.582384f, 46.965908f,134.058403f, 46.932872f,134.068083f, 46.823746f,134.014181f, 46.774156f,134.046797f,
                    46.665886f,134.013494f, 46.596178f,133.913096f, 46.472332f,133.841532f, 46.444364f,133.847489f, 46.446847f,133.890848f,
                    46.399516f,133.940165f, 46.343580f,133.861556f, 46.331002f,133.916830f, 46.263482f,133.910707f, 46.248587f,133.853613f,
                    46.234851f,133.873141f, 46.203077f,133.846496f, 46.229225f,133.806613f, 46.184045f,133.777983f, 46.155630f,133.688002f,
                    46.054084f,133.735593f, 45.988412f,133.675562f, 45.940995f,133.668475f, 45.932720f,133.597739f, 45.904822f,133.612031f,
                    45.867222f,133.584720f, 45.868309f,133.582384f);
            poly[2869] = new TzPolygon(48.174231f,133.582384f, 48.198251f,133.593398f, 48.187386f,133.711626f, 48.256754f,133.746404f, 48.284889f,133.899865f,
                    48.284889f,134.727999f, 48.274571f,134.723019f, 48.240141f,134.667918f, 48.152197f,134.667496f, 48.032418f,134.544656f,
                    47.988755f,134.543629f, 47.903568f,134.601259f, 47.881731f,134.669820f, 47.824859f,134.663346f, 47.735418f,134.775456f,
                    47.629510f,134.676338f, 47.593165f,134.677544f, 47.518510f,134.572489f, 47.478445f,134.563132f, 47.443005f,134.486170f,
                    47.433286f,134.311178f, 47.364207f,134.253802f, 47.318385f,134.169334f, 47.252960f,134.150077f, 47.186917f,134.219788f,
                    47.117993f,134.222235f, 47.092521f,134.139837f, 46.975054f,134.055723f, 46.965908f,134.058403f, 46.965908f,133.582384f);
            poly[2870] = new TzPolygon(48.920820f,130.145337f, 48.865247f,130.224296f, 48.903921f,130.421084f, 48.900310f,130.464686f, 48.853796f,130.514983f,
                    48.877103f,130.669346f, 48.852384f,130.681226f, 48.775045f,130.606755f, 48.613162f,130.521062f, 48.585015f,130.599435f,
                    48.488468f,130.625571f, 48.512510f,130.723327f, 48.497286f,130.758197f, 48.430258f,130.732060f, 48.358488f,130.766320f,
                    48.301678f,130.835647f, 48.284889f,130.820857f, 48.284889f,130.145337f);
            poly[2871] = new TzPolygon(49.603871f,130.145337f, 49.603871f,131.509885f, 49.460404f,131.503814f, 49.427865f,131.527884f, 49.255453f,131.420028f,
                    49.233218f,131.110786f, 49.036564f,131.016445f, 48.975195f,131.045136f, 48.994094f,130.863848f, 48.964445f,130.791823f,
                    48.978390f,130.781291f, 48.916546f,130.651544f, 48.881454f,130.629970f, 48.853458f,130.537299f, 48.857975f,130.498160f,
                    48.903470f,130.451468f, 48.865247f,130.224296f, 48.920820f,130.145337f);
            poly[2872] = new TzPolygon(50.922852f,130.820747f, 50.889616f,130.843823f, 50.891484f,130.883307f, 50.864914f,130.787387f, 50.745593f,130.674167f,
                    50.721668f,130.711737f, 50.694775f,130.703826f, 50.662002f,130.644752f, 50.605954f,130.723473f, 50.659018f,130.775112f,
                    50.669439f,130.913489f, 50.647710f,130.967905f, 50.579042f,131.027642f, 50.495098f,130.933201f, 50.482224f,130.880180f,
                    50.455692f,130.876332f, 50.418352f,130.936685f, 50.362337f,130.942123f, 50.433757f,131.019976f, 50.418789f,131.089271f,
                    50.434561f,131.125083f, 50.356659f,131.171355f, 50.348575f,131.243048f, 50.376460f,131.304839f, 50.289332f,131.323935f,
                    50.255827f,131.423274f, 50.216240f,131.412829f, 50.177325f,131.458305f, 50.164525f,131.390308f, 50.098604f,131.375554f,
                    50.051660f,131.430066f, 49.991028f,131.424054f, 49.974250f,131.386675f, 49.902143f,131.523879f, 49.801828f,131.465519f,
                    49.757803f,131.520415f, 49.724379f,131.489403f, 49.735642f,131.446738f, 49.698801f,131.352415f, 49.661144f,131.375506f,
                    49.670273f,131.445723f, 49.614858f,131.510350f, 49.603871f,131.509885f, 49.603871f,130.145337f, 50.922852f,130.145337f);
            poly[2873] = new TzPolygon(50.922852f,130.820747f, 50.947231f,130.803821f, 50.953591f,130.757353f, 50.992791f,130.765432f, 51.025592f,130.798481f,
                    51.039757f,130.946510f, 51.121623f,130.960159f, 51.175772f,131.028984f, 51.239123f,131.042859f, 51.267198f,131.110102f,
                    51.255916f,131.173957f, 51.287567f,131.224404f, 51.364797f,131.255558f, 51.389378f,131.360595f, 51.345265f,131.408862f,
                    51.346711f,131.490443f, 51.483129f,131.470432f, 51.594668f,131.390140f, 51.650144f,131.391433f, 51.668888f,131.440254f,
                    51.691948f,131.400911f, 51.665960f,131.604323f, 51.683887f,131.622100f, 51.700424f,131.779877f, 51.758266f,131.858491f,
                    51.757555f,131.863861f, 50.922852f,131.863861f);
            poly[2874] = new TzPolygon(53.148845f,131.863861f, 53.162787f,131.828641f, 53.231578f,131.854688f, 53.257528f,131.806426f, 53.208020f,131.508950f,
                    53.221315f,131.441549f, 53.271970f,131.513886f, 53.333660f,131.533441f, 53.448214f,131.504989f, 53.510110f,131.451273f,
                    53.560815f,131.477047f, 53.560815f,131.863861f);
            poly[2875] = new TzPolygon(52.241834f,131.863861f, 52.241834f,133.418053f, 52.233701f,133.420450f, 52.232468f,133.375353f, 52.190491f,133.324356f,
                    52.173726f,133.251971f, 52.189480f,133.206031f, 52.162447f,133.171351f, 52.178853f,133.138137f, 52.153126f,133.092696f,
                    52.174808f,133.042132f, 52.147742f,132.936468f, 52.183412f,132.818134f, 52.122053f,132.759327f, 52.127840f,132.702485f,
                    52.112555f,132.643134f, 52.092000f,132.620882f, 52.085705f,132.643649f, 52.080795f,132.572847f, 52.019168f,132.521060f,
                    51.958135f,132.521461f, 51.978283f,132.394708f, 51.885684f,132.450600f, 51.804534f,132.286516f, 51.839784f,132.218875f,
                    51.810771f,132.130038f, 51.770163f,132.097594f, 51.800509f,132.065706f, 51.745314f,131.956290f, 51.757555f,131.863861f);
            poly[2876] = new TzPolygon(53.148845f,131.863861f, 53.135808f,131.896795f, 53.161241f,131.958285f, 53.139232f,132.013113f, 53.240534f,132.105603f,
                    53.220924f,132.141151f, 53.226120f,132.248983f, 53.255438f,132.279676f, 53.217612f,132.398192f, 53.214991f,132.509502f,
                    53.245514f,132.661469f, 53.224062f,132.702958f, 53.249724f,132.770547f, 53.235253f,132.861893f, 53.252937f,132.898012f,
                    53.298342f,132.888645f, 53.283613f,132.967227f, 53.307087f,133.031416f, 53.303421f,133.134873f, 53.340268f,133.122436f,
                    53.431870f,133.198365f, 53.472979f,133.361110f, 53.516849f,133.412550f, 53.506349f,133.489817f, 53.549835f,133.567076f,
                    53.546368f,133.582384f, 52.615809f,133.582384f, 52.619666f,133.512814f, 52.641776f,133.501103f, 52.682232f,133.262142f,
                    52.616671f,133.229284f, 52.557869f,133.245318f, 52.516809f,133.300291f, 52.447453f,133.233804f, 52.411290f,133.304669f,
                    52.361111f,133.306984f, 52.300137f,133.400865f, 52.241834f,133.418053f, 52.241834f,131.863861f);
            poly[2877] = new TzPolygon(48.284889f,133.899865f, 48.302170f,133.994119f, 48.345081f,134.034025f, 48.331890f,134.123154f, 48.383718f,134.188314f,
                    48.388170f,134.408687f, 48.425293f,134.501258f, 48.408073f,134.688099f, 48.364045f,134.766202f, 48.284889f,134.727999f);
            poly[2878] = new TzPolygon(52.464489f,134.441646f, 52.472377f,134.347573f, 52.457656f,134.305730f, 52.513573f,134.167189f, 52.480929f,134.100660f,
                    52.540358f,133.998510f, 52.512600f,133.941008f, 52.514491f,133.869705f, 52.566742f,133.819143f, 52.558646f,133.708484f,
                    52.615580f,133.586509f, 52.615809f,133.582384f, 53.546368f,133.582384f, 53.535923f,133.628511f, 53.467333f,133.706805f,
                    53.493038f,133.787704f, 53.464103f,133.811568f, 53.474426f,133.868107f, 53.438939f,133.946477f, 53.455898f,134.096616f,
                    53.498936f,134.113271f, 53.482235f,134.195285f, 53.521355f,134.205977f, 53.542171f,134.259308f, 53.535550f,134.310647f,
                    53.560815f,134.364667f, 53.560815f,134.441646f);
            poly[2879] = new TzPolygon(52.464489f,134.441646f, 53.560815f,134.441683f, 53.558461f,134.445507f, 53.560815f,134.446020f, 53.560815f,134.631590f,
                    53.531090f,134.721981f, 53.491356f,134.729792f, 53.487480f,134.811036f, 53.455548f,134.801572f, 53.440569f,134.878711f,
                    53.406700f,134.915680f, 53.384798f,134.876975f, 53.405117f,134.854972f, 53.401006f,134.800302f, 53.380239f,134.781636f,
                    53.338948f,134.783393f, 53.317917f,134.868690f, 53.278141f,134.863817f, 53.260720f,134.920913f, 53.209618f,134.887554f,
                    53.193831f,134.824899f, 53.173481f,134.847603f, 53.147771f,134.809729f, 53.097686f,134.863106f, 53.069842f,134.832418f,
                    53.070249f,134.771770f, 52.900874f,134.594599f, 52.889299f,134.641537f, 52.851016f,134.590034f, 52.802983f,134.606056f,
                    52.783211f,134.664882f, 52.722183f,134.646158f, 52.717445f,134.734676f, 52.642348f,134.750560f, 52.623145f,134.738935f,
                    52.627651f,134.672791f, 52.540041f,134.598467f, 52.458820f,134.643588f, 52.425441f,134.600644f, 52.423898f,134.543863f,
                    52.460792f,134.485739f);
            poly[2880] = new TzPolygon(53.560815f,131.477047f, 53.567552f,131.480471f, 53.576637f,131.455222f, 53.600920f,131.491725f, 53.560815f,131.491725f);
            poly[2881] = new TzPolygon(53.600920f,131.491725f, 53.619653f,131.472223f, 53.619653f,131.491725f);
            poly[2882] = new TzPolygon(53.560815f,134.364667f, 53.581283f,134.408431f, 53.560815f,134.441683f);
            poly[2883] = new TzPolygon(53.560815f,134.446020f, 53.608037f,134.456307f, 53.614951f,134.521271f, 53.560815f,134.521271f);
            poly[2884] = new TzPolygon(53.560815f,134.659915f, 53.619653f,134.537062f, 53.619653f,137.019431f, 53.560815f,137.019431f);
            poly[2885] = new TzPolygon(53.648851f,131.441827f, 53.662543f,131.427573f, 53.728478f,131.441827f);
            poly[2886] = new TzPolygon(53.740623f,131.441827f, 53.754476f,131.419740f, 53.793405f,131.312503f, 53.786406f,131.252267f, 53.822338f,131.107558f,
                    53.825197f,131.017445f, 53.774316f,130.900449f, 53.798378f,130.848504f, 53.849167f,130.851848f, 53.848979f,130.745446f,
                    53.900179f,130.686969f, 53.878462f,130.587779f, 53.909166f,130.517043f, 53.888156f,130.441599f, 53.927568f,130.386742f,
                    53.987317f,130.496274f, 54.122416f,130.511178f, 54.186607f,130.635677f, 54.256612f,130.668607f, 54.266441f,130.722229f,
                    54.298827f,130.735983f, 54.284583f,130.814952f, 54.339254f,130.939163f, 54.291301f,131.034686f, 54.335786f,131.120798f,
                    54.553191f,131.233044f, 54.567994f,131.190521f, 54.636421f,131.171260f, 54.658812f,131.286647f, 54.737280f,131.394890f,
                    54.738984f,131.441827f);
            poly[2887] = new TzPolygon(55.670721f,131.441827f, 55.661943f,131.424769f, 55.651016f,131.335245f, 55.694649f,131.226798f, 55.643714f,131.142542f,
                    55.658030f,131.052784f, 55.712177f,130.952768f, 55.810142f,130.963397f, 55.842574f,130.891943f, 55.916815f,130.859931f,
                    55.938340f,130.897167f, 55.938340f,131.441827f);
            poly[2888] = new TzPolygon(54.778997f,131.441827f, 54.778997f,131.576294f, 54.773050f,131.559365f, 54.742955f,131.551196f, 54.738984f,131.441827f);
            poly[2889] = new TzPolygon(54.778997f,131.676173f, 54.775447f,131.671538f, 54.772392f,131.634512f, 54.778997f,131.629542f);
            poly[2890] = new TzPolygon(53.740623f,131.441827f, 53.739173f,131.444139f, 53.728478f,131.441827f);
            poly[2891] = new TzPolygon(53.648851f,131.441827f, 53.619653f,131.472223f, 53.619653f,131.441827f);
            poly[2892] = new TzPolygon(55.670721f,131.441827f, 55.697194f,131.493274f, 55.655092f,131.578192f, 55.709182f,131.637675f, 55.695976f,131.770169f,
                    55.647814f,131.827437f, 55.669199f,131.897156f, 55.659021f,131.940055f, 55.713633f,131.971124f, 55.679326f,132.155717f,
                    55.710622f,132.159717f, 55.707602f,132.220982f, 55.742692f,132.263619f, 55.742782f,132.441057f, 55.710682f,132.501438f,
                    55.709942f,132.558152f, 55.673420f,132.564410f, 55.624682f,132.663448f, 55.585102f,132.688110f, 55.556642f,132.639372f,
                    55.521493f,132.661180f, 55.456295f,132.763258f, 55.429922f,132.935755f, 55.401858f,132.972059f, 55.381172f,132.828201f,
                    55.347835f,132.773620f, 55.356302f,132.679414f, 55.301120f,132.692648f, 55.235266f,132.611489f, 55.244680f,132.361224f,
                    55.222323f,132.337176f, 55.188126f,132.393151f, 55.177240f,132.350239f, 55.162202f,132.403517f, 55.152942f,132.375101f,
                    55.118155f,132.438578f, 55.085268f,132.425798f, 55.058140f,132.261632f, 55.061585f,132.086281f, 55.018900f,131.971112f,
                    55.000978f,132.088864f, 54.891947f,131.938821f, 54.875891f,131.874226f, 54.890040f,131.821176f, 54.778997f,131.676173f,
                    54.778997f,131.629542f, 54.793791f,131.618410f, 54.778997f,131.576294f, 54.778997f,131.441827f);
            poly[2893] = new TzPolygon(55.938340f,130.897167f, 55.960754f,130.935940f, 56.014422f,130.895199f, 56.080218f,130.971521f, 56.167585f,130.991287f,
                    56.246233f,131.120795f, 56.328582f,131.137669f, 56.409936f,131.103629f, 56.419967f,131.154330f, 56.520845f,131.222116f,
                    56.512487f,131.330091f, 56.528258f,131.340510f, 56.499740f,131.388209f, 56.460480f,131.383884f, 56.453253f,131.427961f,
                    56.466191f,131.441827f, 55.938340f,131.441827f);
            poly[2894] = new TzPolygon(56.480744f,131.441827f, 56.509243f,131.408279f, 56.531911f,131.441827f);
            poly[2895] = new TzPolygon(57.124908f,131.441827f, 57.152230f,131.343265f, 57.192029f,131.313257f, 57.167836f,131.192289f, 57.207117f,131.201063f,
                    57.259407f,131.121702f, 57.262212f,131.207679f, 57.336533f,131.280628f, 57.276761f,131.347382f, 57.268265f,131.441827f);
            poly[2896] = new TzPolygon(57.097684f,131.441827f, 57.097684f,131.502994f, 57.089630f,131.506517f, 57.083762f,131.469062f, 57.024462f,131.500426f,
                    57.024198f,131.544393f, 56.976599f,131.611584f, 56.949785f,131.607381f, 56.951563f,131.640193f, 56.860837f,131.723566f,
                    56.865277f,131.773009f, 56.744793f,131.832699f, 56.748950f,131.776829f, 56.720038f,131.801690f, 56.722034f,131.747879f,
                    56.704208f,131.762065f, 56.682488f,131.680201f, 56.665584f,131.720395f, 56.619949f,131.664512f, 56.609924f,131.709192f,
                    56.571967f,131.703247f, 56.541048f,131.643317f, 56.492245f,131.751686f, 56.470715f,131.725008f, 56.496170f,131.682475f,
                    56.455436f,131.648413f, 56.478919f,131.617173f, 56.526606f,131.633751f, 56.565838f,131.494902f, 56.531161f,131.441827f);
            poly[2897] = new TzPolygon(56.480744f,131.441827f, 56.473809f,131.449991f, 56.466191f,131.441827f);
            poly[2898] = new TzPolygon(57.097684f,131.502994f, 57.109369f,131.497882f, 57.124908f,131.441827f, 57.268265f,131.441827f, 57.264120f,131.487912f,
                    57.312540f,131.539886f, 57.309362f,131.608751f, 57.427346f,131.605481f, 57.538616f,131.780773f, 57.578063f,131.724049f,
                    57.622865f,131.849116f, 57.617867f,131.950707f, 57.664212f,131.986753f, 57.687075f,132.071213f, 57.751953f,132.023597f,
                    57.815483f,131.879332f, 57.847846f,131.877758f, 57.873656f,131.754895f, 57.934221f,131.798608f, 57.949542f,131.698052f,
                    57.971830f,131.695441f, 58.024203f,131.575325f, 58.078969f,131.644714f, 58.110512f,131.528286f, 58.196866f,131.453301f,
                    58.201191f,131.705490f, 58.152375f,131.768037f, 58.167022f,131.823298f, 58.149278f,131.863001f, 58.051691f,131.984823f,
                    58.049308f,132.066274f, 58.080230f,132.137239f, 58.123608f,132.102299f, 58.157440f,131.984721f, 58.257028f,132.089021f,
                    58.257028f,132.189632f, 58.254628f,132.198401f, 58.257028f,132.198910f, 58.257028f,133.301028f, 57.097684f,133.301028f);
            poly[2899] = new TzPolygon(59.416372f,132.371428f, 58.842909f,132.371428f, 58.834532f,132.265006f, 58.885505f,132.200939f, 59.002040f,132.256946f,
                    59.037697f,132.145912f, 59.110776f,132.163467f, 59.181601f,132.005153f, 59.187229f,131.919708f, 59.162918f,131.828981f,
                    59.182428f,131.750450f, 59.224801f,131.756536f, 59.264523f,131.692801f, 59.408681f,131.682727f, 59.416372f,131.667579f);
        }
    }

    private static class Initializer30 {
        private static void init() {
            poly[2900] = new TzPolygon(58.257028f,132.089021f, 58.278430f,132.111436f, 58.257028f,132.189632f);
            poly[2901] = new TzPolygon(58.257028f,132.198910f, 58.386228f,132.226305f, 58.415046f,132.179521f, 58.469852f,132.185000f, 58.514863f,132.139929f,
                    58.536909f,132.304434f, 58.516768f,132.319044f, 58.513999f,132.371428f, 58.257028f,132.371428f);
            poly[2902] = new TzPolygon(59.234700f,133.301028f, 59.227556f,133.283581f, 59.241410f,133.170973f, 59.204642f,133.159038f, 59.216390f,133.108225f,
                    59.198475f,133.057787f, 59.105065f,132.933893f, 59.118064f,132.827484f, 59.045475f,132.821919f, 59.018792f,132.748819f,
                    58.990218f,132.845784f, 58.881004f,132.769138f, 58.910006f,132.658366f, 58.884739f,132.574094f, 58.840848f,132.537838f,
                    58.930525f,132.526078f, 58.933040f,132.483886f, 58.846913f,132.422298f, 58.842909f,132.371428f, 59.416372f,132.371428f,
                    59.416372f,133.301028f);
            poly[2903] = new TzPolygon(58.845343f,132.371428f, 58.846913f,132.422298f, 58.921370f,132.458841f, 58.930525f,132.526078f, 58.820878f,132.534671f,
                    58.795265f,132.488511f, 58.782103f,132.536391f, 58.680698f,132.501667f, 58.658676f,132.546354f, 58.561251f,132.386507f,
                    58.510854f,132.430917f, 58.513999f,132.371428f);
            poly[2904] = new TzPolygon(60.575716f,132.438560f, 60.546419f,132.420924f, 60.516681f,132.331211f, 60.305049f,132.260476f, 60.229822f,132.026227f,
                    60.173524f,132.088342f, 60.112978f,132.070451f, 59.999829f,132.020392f, 59.966900f,131.926197f, 59.862947f,131.871601f,
                    59.922316f,131.803879f, 59.904203f,131.651660f, 59.503871f,131.585112f, 59.441526f,131.618035f, 59.416372f,131.667579f,
                    59.416372f,131.441827f, 60.575716f,131.441827f);
            poly[2905] = new TzPolygon(60.575716f,132.428763f, 60.603946f,132.436317f, 60.624897f,132.509904f, 60.576572f,132.718419f, 60.583340f,132.802869f,
                    60.721423f,133.133582f, 61.071338f,133.059590f, 61.261240f,133.099614f, 61.255624f,133.237671f, 61.273907f,133.301028f,
                    60.575716f,133.301028f);
            poly[2906] = new TzPolygon(59.233845f,133.301028f, 59.312262f,133.518561f, 59.229460f,133.634131f, 59.261864f,134.031723f, 59.218530f,134.183703f,
                    59.202258f,134.365691f, 59.138991f,134.486161f, 59.204104f,134.564813f, 59.198671f,134.654859f, 59.218730f,134.721281f,
                    59.153028f,134.748645f, 59.136904f,134.847132f, 59.168825f,134.952623f, 59.111139f,135.177755f, 59.139061f,135.248069f,
                    59.180245f,135.238298f, 59.196028f,135.303946f, 59.235920f,135.261293f, 59.311355f,135.362487f, 59.335389f,135.349140f,
                    59.439284f,135.508042f, 59.508675f,135.687536f, 59.525170f,135.833674f, 59.514043f,135.890556f, 59.458814f,135.947567f,
                    59.473552f,135.986857f, 59.420302f,136.085361f, 59.423811f,136.317351f, 59.383254f,136.389952f, 59.381406f,136.605137f,
                    59.348274f,136.660459f, 59.337242f,136.763075f, 59.388431f,136.821174f, 59.433035f,137.019431f, 58.257028f,137.019431f,
                    58.257028f,133.301028f);
            poly[2907] = new TzPolygon(62.894403f,133.961387f, 62.873737f,133.935265f, 62.800375f,133.940713f, 62.683218f,134.034349f, 62.604401f,134.144489f,
                    62.547088f,134.370608f, 62.560470f,134.609227f, 62.500358f,134.805518f, 62.502052f,134.995922f, 62.372586f,135.160230f,
                    61.447063f,135.160230f, 61.410933f,135.053773f, 61.438778f,135.039718f, 61.405758f,134.978001f, 61.422662f,134.887605f,
                    61.404222f,134.853197f, 61.435690f,134.859066f, 61.424925f,134.795594f, 61.452081f,134.689550f, 61.404017f,134.528618f,
                    61.387703f,134.540741f, 61.393699f,134.463612f, 61.353652f,134.428110f, 61.368549f,134.406256f, 61.349712f,134.374455f,
                    61.356563f,134.317850f, 61.315361f,134.281297f, 61.338038f,134.268583f, 61.342139f,134.199425f, 61.320264f,133.998721f,
                    61.334255f,133.890381f, 61.288540f,133.351740f, 61.273907f,133.301028f, 62.894403f,133.301028f);
            poly[2908] = new TzPolygon(62.372586f,135.160230f, 62.008723f,135.622017f, 61.902772f,135.502615f, 61.813601f,135.528424f, 61.771852f,135.481718f,
                    61.741177f,135.372217f, 61.764829f,135.318706f, 61.762064f,135.201314f, 61.737022f,135.179096f, 61.638189f,135.275643f,
                    61.607853f,135.262642f, 61.588312f,135.368021f, 61.600229f,135.471132f, 61.582441f,135.480298f, 61.588159f,135.441159f,
                    61.536852f,135.378449f, 61.553455f,135.345007f, 61.533305f,135.284433f, 61.482967f,135.266022f, 61.447063f,135.160230f);
            poly[2909] = new TzPolygon(63.345681f,133.301028f, 63.378787f,133.138035f, 63.385824f,132.947084f, 63.353554f,132.819657f, 63.382994f,132.739783f,
                    63.558759f,132.544501f, 63.634331f,132.527047f, 63.684704f,132.348661f, 63.639393f,132.239625f, 63.665713f,132.208036f,
                    63.710079f,132.209212f, 63.824021f,132.433861f, 63.966872f,132.536163f, 64.034726f,132.425771f, 64.053747f,132.423981f,
                    64.053747f,133.301028f);
            poly[2910] = new TzPolygon(64.053747f,133.301028f, 64.053747f,132.423981f, 64.073934f,132.422081f, 64.078621f,132.537577f, 64.167847f,132.621547f,
                    64.219993f,132.769566f, 64.284537f,132.795538f, 64.359121f,132.934856f, 64.582055f,132.707311f, 64.611586f,132.837409f,
                    64.674905f,132.855398f, 64.728013f,132.966983f, 64.786624f,132.943876f, 64.842206f,133.007655f, 64.963218f,132.898436f,
                    65.066522f,132.987571f, 65.127439f,132.964826f, 65.213090f,133.104220f, 65.213090f,133.301028f);
            poly[2911] = new TzPolygon(65.213090f,131.969784f, 65.139408f,132.077997f, 64.985157f,132.156062f, 64.919016f,132.266638f, 64.791750f,132.341841f,
                    64.654016f,132.279792f, 64.609977f,132.432015f, 64.643668f,132.639094f, 64.623030f,132.613810f, 64.500245f,132.812508f,
                    64.428910f,132.832765f, 64.359121f,132.934856f, 64.284537f,132.795538f, 64.219993f,132.769566f, 64.167847f,132.621547f,
                    64.078621f,132.537577f, 64.073934f,132.422081f, 64.053747f,132.423981f, 64.053747f,131.441827f, 65.213090f,131.441827f);
            poly[2912] = new TzPolygon(65.213090f,133.301028f, 65.213090f,133.104220f, 65.272590f,133.201052f, 65.275356f,133.301028f);
            poly[2913] = new TzPolygon(67.531778f,131.378068f, 67.480999f,131.366195f, 67.434728f,131.225893f, 67.366467f,131.134340f, 67.342659f,131.182280f,
                    67.309015f,131.099227f, 67.271720f,131.145882f, 67.208746f,131.090486f, 67.164069f,131.111463f, 67.097761f,130.887802f,
                    67.139693f,130.695645f, 67.097719f,130.483171f, 67.128275f,130.443254f, 67.009588f,130.224874f, 66.919628f,130.285014f,
                    66.845776f,130.058186f, 66.855971f,129.976699f, 66.611889f,129.913168f, 66.551757f,129.964252f, 66.502697f,130.088074f,
                    66.402631f,130.045198f, 66.207326f,130.099244f, 66.223836f,130.214732f, 66.210645f,130.405289f, 66.084028f,130.526705f,
                    65.970549f,130.841932f, 65.946786f,131.114691f, 65.889810f,131.114673f, 65.787310f,131.261449f, 65.795605f,131.351561f,
                    65.692606f,131.393747f, 65.709036f,131.726675f, 65.570584f,131.648384f, 65.455415f,131.492769f, 65.402663f,131.529466f,
                    65.391925f,131.593287f, 65.291408f,131.708007f, 65.302527f,131.838435f, 65.213090f,131.969784f, 65.213090f,129.582626f,
                    67.531778f,129.582626f);
            poly[2914] = new TzPolygon(66.123857f,137.019431f, 66.173447f,136.878576f, 66.203179f,136.861153f, 66.183718f,136.346392f, 66.068430f,136.074046f,
                    66.016102f,136.030864f, 65.999291f,135.845227f, 65.976298f,135.839041f, 65.944878f,135.716572f, 65.892238f,135.679025f,
                    65.892374f,135.404128f, 65.827361f,135.383157f, 65.799203f,135.314772f, 65.759849f,134.994025f, 65.763378f,134.853465f,
                    65.699884f,134.792057f, 65.689088f,134.719162f, 65.567573f,134.654986f, 65.501118f,134.514648f, 65.418930f,134.432242f,
                    65.362213f,134.448321f, 65.400141f,134.307592f, 65.316032f,133.994392f, 65.205599f,133.881356f, 65.229162f,133.562927f,
                    65.280163f,133.474751f, 65.275356f,133.301028f, 67.531778f,133.301028f, 67.531778f,137.019431f);
            poly[2915] = new TzPolygon(63.345681f,133.301028f, 63.338597f,133.335906f, 63.348875f,134.059223f, 63.043870f,134.165267f, 63.007399f,133.972190f,
                    62.970847f,133.948099f, 62.909541f,133.980522f, 62.894403f,133.961387f, 62.894403f,133.301028f);
            poly[2916] = new TzPolygon(69.850465f,129.582626f, 69.850465f,133.160861f, 69.830620f,133.163383f, 69.786727f,133.301028f, 69.658826f,133.301028f,
                    69.656468f,133.166964f, 69.565452f,133.042216f, 69.571803f,132.985591f, 69.499455f,132.787712f, 69.321153f,132.673588f,
                    69.301065f,132.715849f, 69.247478f,132.575696f, 69.192718f,132.538298f, 69.136893f,132.602953f, 69.071698f,132.438254f,
                    69.057717f,132.321525f, 69.020227f,132.306858f, 68.957020f,132.387421f, 68.924397f,132.600067f, 68.741426f,132.794323f,
                    68.688131f,132.984095f, 68.588765f,133.015410f, 68.500240f,133.301028f, 68.414208f,133.301028f, 68.392199f,133.227053f,
                    68.383319f,133.301028f, 68.301155f,133.301028f, 68.241119f,133.084478f, 68.174776f,133.031104f, 68.158503f,132.903686f,
                    67.926313f,132.664270f, 67.895608f,132.567096f, 67.838830f,132.512360f, 67.807372f,132.354340f, 67.709554f,132.320011f,
                    67.695373f,132.256990f, 67.762116f,132.103102f, 67.742260f,132.029156f, 67.667506f,131.780892f, 67.536969f,131.735270f,
                    67.566997f,131.551702f, 67.618826f,131.445857f, 67.594518f,131.392737f, 67.531778f,131.378068f, 67.531778f,129.582626f);
            poly[2917] = new TzPolygon(69.850465f,133.301028f, 69.850465f,133.160861f, 69.911491f,133.153107f, 69.950387f,132.957544f, 69.980987f,133.164299f,
                    70.013205f,133.234513f, 70.017827f,133.133596f, 70.047444f,133.086158f, 70.144519f,133.225976f, 70.339028f,133.080311f,
                    70.333984f,132.249540f, 70.370470f,132.076245f, 70.500093f,132.025806f, 70.593394f,132.145412f, 70.767833f,132.015578f,
                    70.834309f,132.040915f, 70.889993f,132.198229f, 70.924819f,132.209365f, 71.043362f,132.036048f, 71.045354f,131.957851f,
                    71.070710f,131.940399f, 71.058295f,131.885063f, 71.077522f,131.871627f, 71.048042f,131.782171f, 71.272688f,131.234656f,
                    71.300077f,131.378093f, 71.738282f,131.690510f, 71.951677f,131.973228f, 72.063387f,132.203925f, 72.130344f,132.504821f,
                    72.169153f,133.080712f, 72.151880f,133.301028f);
            poly[2918] = new TzPolygon(69.786727f,133.301028f, 69.725572f,133.492805f, 69.688339f,133.472778f, 69.659441f,133.335982f, 69.658826f,133.301028f);
            poly[2919] = new TzPolygon(68.500240f,133.301028f, 68.479345f,133.368444f, 68.467556f,133.480338f, 68.414208f,133.301028f);
            poly[2920] = new TzPolygon(68.383319f,133.301028f, 68.374968f,133.370592f, 68.329627f,133.403726f, 68.301155f,133.301028f);
            poly[2921] = new TzPolygon(45.382273f,115.212170f, 45.387981f,115.371971f, 45.452675f,115.687447f, 45.626610f,115.925430f, 45.656490f,116.026222f,
                    45.679680f,116.030922f, 45.692486f,116.181603f, 45.744825f,116.218758f, 45.770390f,116.280564f, 45.840031f,116.283296f,
                    45.882166f,116.235857f, 45.961218f,116.264630f, 46.299863f,116.592489f, 46.328765f,116.759818f, 46.383298f,116.838564f,
                    46.353984f,117.085647f, 46.360697f,117.368340f, 46.477645f,117.391000f, 46.525552f,117.439034f, 46.578715f,117.413715f,
                    46.602207f,117.585258f, 46.513478f,117.713516f, 46.535675f,117.847516f, 46.570131f,117.856877f, 46.613245f,117.924849f,
                    46.626773f,118.030574f, 46.678658f,118.115556f, 46.682583f,118.191215f, 46.738346f,118.300868f, 46.693442f,118.575476f,
                    46.719565f,118.647725f, 46.696102f,118.673692f, 46.695624f,118.678995f, 42.816687f,118.678995f, 42.816687f,115.212170f);
            poly[2922] = new TzPolygon(47.009896f,119.803042f, 46.964384f,119.864040f, 46.920058f,119.854284f, 46.901621f,119.921322f, 46.864634f,119.898602f,
                    46.847493f,119.931949f, 46.668156f,119.900445f, 46.681804f,119.802559f, 46.628710f,119.778485f, 46.584793f,119.678455f,
                    46.624680f,119.646502f, 46.611950f,119.582023f, 46.633938f,119.555506f, 46.638602f,119.430484f, 46.605471f,119.368630f,
                    46.608732f,119.300639f, 46.650765f,119.220855f, 46.647522f,119.100829f, 46.751144f,118.999907f, 46.721231f,118.942364f,
                    46.732530f,118.901109f, 46.775786f,118.896858f, 46.767340f,118.832426f, 46.717189f,118.783432f, 46.685662f,118.789591f,
                    46.695624f,118.678995f, 47.009896f,118.678995f);
            poly[2923] = new TzPolygon(49.106501f,116.201965f, 49.106501f,118.678995f, 47.856060f,118.678995f, 47.993462f,118.554932f, 47.992275f,118.435287f,
                    48.014006f,118.417493f, 48.003207f,118.290448f, 48.040972f,118.231118f, 48.048217f,118.169866f, 48.011121f,118.043098f,
                    48.014190f,117.804967f, 47.758798f,117.482161f, 47.640041f,117.375183f, 47.820301f,117.086906f, 47.894871f,116.819771f,
                    47.889198f,116.676376f, 47.837859f,116.439445f, 47.878276f,116.253418f, 47.819250f,116.111476f, 47.681231f,115.935331f,
                    47.919093f,115.570512f, 48.152904f,115.520370f, 48.258865f,115.813408f, 48.519881f,115.786970f, 48.819378f,116.071373f,
                    48.867382f,116.036339f);
            poly[2924] = new TzPolygon(49.996098f,115.212170f, 49.988400f,115.223900f, 49.907100f,115.506700f, 49.887176f,115.745395f, 50.013700f,116.072700f,
                    50.035867f,116.232963f, 49.931100f,116.621600f, 49.841833f,116.711296f, 49.106501f,116.201965f, 49.106501f,115.212170f);
            poly[2925] = new TzPolygon(49.106501f,116.201965f, 49.841833f,116.711296f, 49.685600f,117.061400f, 49.630847f,117.273269f, 49.626380f,117.471566f,
                    49.520037f,117.793427f, 49.541897f,117.836630f, 49.508318f,117.868124f, 49.595316f,117.893064f, 49.593707f,117.943380f,
                    49.621490f,117.980939f, 49.613839f,118.073963f, 49.670992f,118.107043f, 49.658984f,118.165524f, 49.736308f,118.227103f,
                    49.744300f,118.284074f, 49.772957f,118.305846f, 49.777923f,118.380763f, 49.825991f,118.378327f, 49.828592f,118.476531f,
                    49.871055f,118.480021f, 49.900331f,118.557669f, 49.930050f,118.566937f, 49.923964f,118.608122f, 49.947225f,118.612487f,
                    49.936480f,118.644034f, 49.953512f,118.653809f, 49.954297f,118.678995f, 49.106501f,118.678995f);
            poly[2926] = new TzPolygon(47.856060f,118.678995f, 47.772080f,118.754822f, 47.664040f,119.121681f, 47.542367f,119.142807f, 47.479595f,119.357643f,
                    47.423222f,119.321860f, 47.428801f,119.347497f, 47.358162f,119.463697f, 47.326298f,119.474754f, 47.300345f,119.554754f,
                    47.246482f,119.560727f, 47.244146f,119.623310f, 47.193368f,119.708097f, 47.059188f,119.799045f, 47.024536f,119.783420f,
                    47.009896f,119.803042f, 47.009896f,118.678995f);
            poly[2927] = new TzPolygon(51.203105f,119.759272f, 51.172030f,119.781274f, 51.163531f,119.751943f, 51.153190f,119.775312f, 51.090587f,119.756328f,
                    51.072026f,119.708883f, 51.015348f,119.696448f, 51.029079f,119.687523f, 51.009020f,119.624400f, 50.904598f,119.515149f,
                    50.746229f,119.491735f, 50.683102f,119.425654f, 50.679984f,119.373555f, 50.629885f,119.351668f, 50.640737f,119.328217f,
                    50.603418f,119.274249f, 50.573723f,119.288546f, 50.500902f,119.225457f, 50.468567f,119.256787f, 50.409197f,119.205942f,
                    50.422008f,119.176033f, 50.392330f,119.142685f, 50.377092f,119.169311f, 50.360380f,119.147837f, 50.361490f,119.188053f,
                    50.346704f,119.175350f, 50.363389f,119.209563f, 50.341727f,119.246774f, 50.364697f,119.269028f, 50.344234f,119.294365f,
                    50.358516f,119.347376f, 50.326088f,119.350123f, 50.320407f,119.379122f, 50.280916f,119.315974f, 50.254722f,119.340095f,
                    50.216374f,119.309820f, 50.194526f,119.352689f, 50.158416f,119.299685f, 50.109352f,119.286075f, 50.073774f,119.228053f,
                    50.087457f,119.181831f, 50.041162f,119.175138f, 49.984260f,119.084080f, 49.992367f,118.933603f, 49.958930f,118.827688f,
                    49.954297f,118.678995f, 51.203105f,118.678995f);
            poly[2928] = new TzPolygon(54.348013f,115.212170f, 54.348013f,115.490244f, 54.308940f,115.493059f, 54.269519f,115.345168f, 54.199108f,115.230939f,
                    54.197774f,115.212170f);
            poly[2929] = new TzPolygon(55.396315f,115.916691f, 55.356024f,115.975269f, 55.381454f,116.075622f, 55.344053f,116.101669f, 55.381072f,116.374443f,
                    55.319051f,116.423885f, 55.315530f,116.472253f, 55.296050f,116.442025f, 55.229411f,116.472611f, 55.145512f,116.622878f,
                    55.111757f,116.720898f, 55.122438f,116.754652f, 55.034264f,116.841168f, 54.985848f,116.806939f, 54.980608f,116.869931f,
                    54.964357f,116.841727f, 54.946487f,116.890871f, 54.919428f,116.860461f, 54.877336f,116.874775f, 54.866923f,116.912579f,
                    54.812240f,116.892077f, 54.799012f,116.921730f, 54.771753f,116.849861f, 54.704146f,116.873343f, 54.664359f,116.746971f,
                    54.615344f,116.748816f, 54.606544f,116.780589f, 54.566196f,116.693298f, 54.528621f,116.719577f, 54.504856f,116.647100f,
                    54.517872f,116.519897f, 54.460017f,116.516597f, 54.502702f,116.399735f, 54.509781f,116.346122f, 54.487546f,116.316455f,
                    54.508488f,116.262597f, 54.489046f,116.240884f, 54.511465f,116.175918f, 54.478950f,116.113330f, 54.481267f,116.013593f,
                    54.455146f,115.976409f, 54.472354f,115.935568f, 54.414332f,115.603014f, 54.383452f,115.583378f, 54.367874f,115.488813f,
                    54.348013f,115.490244f, 54.348013f,115.212170f, 55.396315f,115.212170f);
            poly[2930] = new TzPolygon(51.203105f,119.759272f, 51.212699f,119.752479f, 51.214193f,119.815186f, 51.280300f,119.803878f, 51.296921f,119.874603f,
                    51.337481f,119.878295f, 51.360842f,119.939571f, 51.389021f,119.902273f, 51.399635f,119.964553f, 51.453556f,119.995363f,
                    51.504339f,119.978094f, 51.551271f,120.044391f, 51.583633f,120.027594f, 51.632264f,120.051622f, 51.648986f,120.095284f,
                    51.678319f,120.080365f, 51.678070f,120.166746f, 51.783476f,120.308453f, 51.827275f,120.412408f, 51.203105f,120.412408f);
            poly[2931] = new TzPolygon(52.624156f,120.412408f, 52.615246f,120.390908f, 52.622108f,120.282019f, 52.577037f,120.184611f, 52.586053f,120.061967f,
                    52.635457f,120.026767f, 52.707215f,120.061844f, 52.776256f,120.026644f, 52.808121f,120.179176f, 52.860983f,120.280824f,
                    52.980179f,120.412408f);
            poly[2932] = new TzPolygon(53.299710f,121.071700f, 53.286856f,121.035504f, 53.292694f,120.875015f, 53.266378f,120.812574f, 53.238667f,120.832706f,
                    53.175149f,120.684644f, 53.103924f,120.636034f, 53.080457f,120.555259f, 53.002400f,120.436938f, 52.980179f,120.412408f,
                    53.299710f,120.412408f);
            poly[2933] = new TzPolygon(52.624156f,120.412408f, 52.643464f,120.458999f, 52.543974f,120.722281f, 52.510534f,120.680434f, 52.428941f,120.683567f,
                    52.353465f,120.614206f, 52.312165f,120.631019f, 52.255407f,120.751631f, 52.204451f,120.739055f, 52.158516f,120.779509f,
                    52.078210f,120.745762f, 52.040886f,120.681633f, 52.007235f,120.711839f, 51.922725f,120.647580f, 51.912219f,120.550504f,
                    51.877986f,120.535520f, 51.882527f,120.469709f, 51.851470f,120.469833f, 51.827275f,120.412408f);
            poly[2934] = new TzPolygon(53.299710f,121.273491f, 53.279163f,121.226536f, 53.275227f,121.121786f, 53.299710f,121.093843f);
            poly[2935] = new TzPolygon(53.299710f,121.071700f, 53.305306f,121.087457f, 53.299710f,121.093843f);
            poly[2936] = new TzPolygon(53.299710f,121.273491f, 53.323185f,121.327137f, 53.321982f,121.445563f, 53.426263f,121.870986f, 53.420539f,122.078903f,
                    53.461049f,122.145820f, 53.299710f,122.145820f);
            poly[2937] = new TzPolygon(54.348013f,121.684855f, 54.348013f,122.145820f, 53.458529f,122.145820f, 53.431497f,122.111783f, 53.443683f,122.089352f,
                    53.616665f,121.947716f, 53.703721f,121.973181f, 53.729586f,121.932177f, 53.826615f,121.946312f, 53.955390f,121.846679f,
                    53.966071f,121.809061f, 53.936379f,121.774673f, 54.020499f,121.656365f, 54.092671f,121.625992f, 54.134367f,121.654259f,
                    54.142112f,121.730238f, 54.175584f,121.779210f, 54.222464f,121.712911f, 54.282105f,121.747395f, 54.339042f,121.711361f);
            poly[2938] = new TzPolygon(54.348013f,121.684855f, 54.357817f,121.655885f, 54.404940f,121.689548f, 54.447627f,121.814429f, 54.417087f,121.890032f,
                    54.388049f,121.881064f, 54.378590f,121.940807f, 54.411440f,122.126100f, 54.448081f,122.144886f, 54.549780f,122.025519f,
                    54.570616f,121.928720f, 54.629767f,121.939170f, 54.655439f,121.888911f, 54.713422f,121.937792f, 54.810766f,121.907745f,
                    54.767798f,121.728266f, 54.730370f,121.699114f, 54.729098f,121.664314f, 54.764774f,121.640328f, 54.834498f,121.667207f,
                    54.896420f,121.791475f, 54.963903f,121.852999f, 55.000532f,121.959649f, 55.091264f,121.950250f, 55.119523f,121.913876f,
                    55.199074f,122.035240f, 55.232939f,121.943818f, 55.279089f,121.940285f, 55.312551f,121.985257f, 55.374333f,121.960947f,
                    55.396315f,121.975265f, 55.396315f,122.145820f, 54.348013f,122.145820f);
            poly[2939] = new TzPolygon(57.492920f,116.945583f, 56.794894f,116.945583f, 56.738129f,116.752826f, 56.780511f,116.696121f, 56.757524f,116.646526f,
                    56.773756f,116.520988f, 56.803241f,116.506379f, 56.815081f,116.419602f, 56.870616f,116.321072f, 56.829235f,116.230002f,
                    56.826329f,116.079949f, 56.879636f,116.017217f, 56.870410f,115.979648f, 56.961793f,115.756437f, 56.878803f,115.585007f,
                    56.720764f,115.591908f, 56.664228f,115.428119f, 56.606072f,115.411967f, 56.573546f,115.519420f, 56.571922f,115.678202f,
                    56.497377f,115.684469f, 56.431643f,115.804804f, 56.402931f,115.787842f, 56.428679f,115.721458f, 56.411658f,115.679365f,
                    56.301913f,115.669850f, 56.179059f,115.763795f, 56.153975f,115.829550f, 56.134702f,115.820019f, 56.128904f,115.755071f,
                    56.083874f,115.787704f, 56.057195f,115.749030f, 55.987468f,115.778615f, 55.925914f,115.905778f, 55.854919f,115.835376f,
                    55.739043f,115.864979f, 55.677994f,115.829850f, 55.653677f,115.907776f, 55.603153f,115.875583f, 55.576992f,115.917725f,
                    55.496234f,115.876913f, 55.443252f,115.961642f, 55.405995f,115.902617f, 55.396315f,115.916691f, 55.396315f,115.212170f,
                    57.492920f,115.212170f);
            poly[2940] = new TzPolygon(57.492920f,117.275729f, 57.480812f,117.281669f, 57.466952f,117.339332f, 57.364109f,117.344629f, 57.343158f,117.374485f,
                    57.363009f,117.449115f, 57.289608f,117.416423f, 57.260102f,117.449099f, 57.273248f,117.545617f, 57.354803f,117.581859f,
                    57.322748f,117.629674f, 57.319355f,117.778770f, 57.209258f,117.720991f, 57.167192f,117.576007f, 57.088756f,117.676379f,
                    57.043660f,117.680267f, 56.973610f,117.630625f, 56.954694f,117.547626f, 56.865305f,117.560692f, 56.894847f,117.500066f,
                    56.836492f,117.452256f, 56.845818f,117.399742f, 56.965178f,117.320665f, 56.894534f,117.178051f, 56.819091f,117.117866f,
                    56.825804f,117.009017f, 56.789250f,117.017671f, 56.801754f,116.968877f, 56.794894f,116.945583f, 57.492920f,116.945583f);
            poly[2941] = new TzPolygon(58.541222f,116.945583f, 58.541222f,118.678995f, 58.178859f,118.678995f, 58.232497f,118.576851f, 58.227584f,118.476538f,
                    58.257591f,118.476253f, 58.289434f,118.387845f, 58.397680f,118.254371f, 58.400230f,118.120773f, 58.365524f,118.081360f,
                    58.423339f,118.001544f, 58.409771f,117.871123f, 58.437393f,117.827541f, 58.415135f,117.794770f, 58.429560f,117.678589f,
                    58.373196f,117.622980f, 58.325672f,117.471564f, 58.185099f,117.594540f, 58.144809f,117.577772f, 58.175259f,117.450152f,
                    58.143710f,117.411275f, 58.105505f,117.432976f, 58.079276f,117.396141f, 57.941240f,117.382514f, 57.929893f,117.431708f,
                    57.902287f,117.353057f, 57.864469f,117.346079f, 57.878009f,117.277283f, 57.857850f,117.225682f, 57.860793f,117.119853f,
                    57.826288f,117.076407f, 57.769668f,117.181607f, 57.649512f,117.137139f, 57.662298f,117.176464f, 57.634905f,117.248037f,
                    57.634848f,117.335114f, 57.597958f,117.310984f, 57.559376f,117.342440f, 57.560297f,117.280235f, 57.535626f,117.254777f,
                    57.492920f,117.275729f, 57.492920f,116.945583f);
            poly[2942] = new TzPolygon(59.168763f,118.678995f, 59.183479f,118.669658f, 59.190851f,118.678995f);
            poly[2943] = new TzPolygon(59.440846f,118.678995f, 59.450808f,118.589584f, 59.485821f,118.539956f, 59.513459f,118.388426f, 59.589524f,118.355136f,
                    59.589524f,118.678995f);
            poly[2944] = new TzPolygon(59.589524f,118.035592f, 59.575435f,118.031290f, 59.540070f,117.938673f, 59.498989f,117.970239f, 59.450716f,117.912561f,
                    59.463379f,117.872094f, 59.446015f,117.824401f, 59.565841f,117.774007f, 59.541663f,117.647351f, 59.477549f,117.569694f,
                    59.524978f,117.452013f, 59.513227f,117.249340f, 59.582705f,117.193248f, 59.589524f,117.172824f);
            poly[2945] = new TzPolygon(55.874830f,120.412408f, 55.873673f,120.406083f, 55.881864f,120.340913f, 55.919938f,120.347336f, 55.935482f,120.238749f,
                    55.866488f,120.119443f, 55.912514f,120.121667f, 55.935283f,120.083189f, 55.957798f,120.124822f, 56.023623f,120.130460f,
                    56.108902f,120.032566f, 56.155957f,120.036595f, 56.161339f,120.118859f, 56.206924f,120.175800f, 56.201037f,120.291697f,
                    56.227479f,120.316918f, 56.233380f,120.412408f);
            poly[2946] = new TzPolygon(56.312145f,120.412408f, 56.316667f,120.389820f, 56.337977f,120.362491f, 56.363494f,120.390666f, 56.403327f,120.235379f,
                    56.444617f,120.269200f, 56.444617f,120.412408f);
            poly[2947] = new TzPolygon(57.492920f,119.395777f, 57.435766f,119.399279f, 57.383468f,119.435958f, 57.351368f,119.538448f, 57.236038f,119.602753f,
                    57.176301f,119.692569f, 57.135131f,119.606924f, 57.034643f,119.587993f, 56.990718f,119.666504f, 56.987205f,119.781359f,
                    56.896079f,119.856140f, 56.856193f,119.817815f, 56.826434f,119.701073f, 56.757026f,119.655391f, 56.732244f,119.696473f,
                    56.733397f,119.776596f, 56.696059f,119.779355f, 56.685066f,119.881064f, 56.596617f,119.796982f, 56.566011f,119.833166f,
                    56.550599f,119.923512f, 56.494293f,119.946155f, 56.500828f,120.089185f, 56.461659f,120.219505f, 56.479057f,120.250100f,
                    56.461713f,120.283203f, 56.444617f,120.269200f, 56.444617f,118.678995f, 57.492920f,118.678995f);
            poly[2948] = new TzPolygon(56.312145f,120.412408f, 56.287492f,120.535543f, 56.237848f,120.484722f, 56.233380f,120.412408f);
            poly[2949] = new TzPolygon(55.874830f,120.412408f, 55.886741f,120.477546f, 55.929950f,120.475913f, 55.930567f,120.633166f, 55.966889f,120.657889f,
                    55.977042f,120.778611f, 56.029839f,120.884480f, 56.016634f,120.959190f, 56.042642f,120.990125f, 56.009329f,121.045408f,
                    56.041153f,121.203585f, 55.939731f,121.270591f, 55.880110f,121.246779f, 55.811218f,121.343647f, 55.734866f,121.298557f,
                    55.607218f,121.361110f, 55.522041f,121.342017f, 55.490687f,121.473958f, 55.522358f,121.481649f, 55.525772f,121.607495f,
                    55.614257f,121.696744f, 55.632846f,121.771556f, 55.610691f,121.843193f, 55.619519f,121.899497f, 55.515501f,121.946427f,
                    55.490895f,121.993862f, 55.396315f,121.967154f, 55.396315f,120.412408f);
            poly[2950] = new TzPolygon(58.182496f,118.678995f, 58.230418f,118.807119f, 58.228867f,118.944694f, 58.255210f,119.046778f, 58.230071f,119.128751f,
                    58.159337f,119.192662f, 58.097355f,119.143508f, 58.044775f,119.184517f, 57.968640f,119.109233f, 57.833989f,119.104475f,
                    57.747557f,119.043871f, 57.726167f,119.058217f, 57.717805f,119.167474f, 57.649476f,119.141664f, 57.589429f,119.179844f,
                    57.554995f,119.141290f, 57.505808f,119.206759f, 57.595776f,119.270364f, 57.616684f,119.326316f, 57.621703f,119.416971f,
                    57.599544f,119.502115f, 57.537465f,119.476145f, 57.492920f,119.395777f, 57.492920f,118.678995f);
            poly[2951] = new TzPolygon(58.541222f,118.678995f, 58.541222f,118.999058f, 58.527481f,119.016512f, 58.516282f,119.120441f, 58.367919f,119.061983f,
                    58.295234f,119.139315f, 58.236950f,119.113806f, 58.255210f,119.046778f, 58.228867f,118.944694f, 58.230418f,118.807119f,
                    58.178859f,118.678995f);
            poly[2952] = new TzPolygon(59.440024f,118.678995f, 59.430420f,118.758627f, 59.345128f,118.748801f, 59.315540f,118.836916f, 59.190851f,118.678995f);
            poly[2953] = new TzPolygon(59.168763f,118.678995f, 59.117736f,118.711372f, 59.057558f,118.696272f, 59.036482f,118.841280f, 58.964869f,118.872523f,
                    58.946722f,118.849692f, 58.950215f,118.763634f, 58.921492f,118.749651f, 58.826634f,118.873260f, 58.664272f,118.827421f,
                    58.629187f,118.754963f, 58.603192f,118.853257f, 58.569793f,118.887996f, 58.579385f,118.950582f, 58.541222f,118.999058f,
                    58.541222f,118.678995f);
            poly[2954] = new TzPolygon(60.460705f,115.212170f, 60.490171f,115.212785f, 60.514324f,115.306596f, 60.496469f,115.417318f, 60.548386f,115.731196f,
                    60.517455f,115.768749f, 60.522562f,115.876765f, 60.497533f,115.861108f, 60.492523f,115.902917f, 60.452969f,115.919355f,
                    60.469058f,116.005434f, 60.456175f,116.084679f, 60.429603f,116.167005f, 60.394096f,116.183900f, 60.409948f,116.289715f,
                    60.371132f,116.355832f, 60.382068f,116.594034f, 60.293036f,116.609848f, 60.279590f,116.759277f, 60.243856f,116.778049f,
                    60.199035f,116.934616f, 60.153014f,116.930820f, 60.102927f,117.011924f, 60.047808f,116.990159f, 60.027560f,117.130037f,
                    60.057423f,117.264106f, 60.024205f,117.347190f, 60.008350f,117.349589f, 59.972628f,117.077473f, 59.919184f,117.007274f,
                    59.868453f,117.098245f, 59.872802f,117.225554f, 59.748355f,117.227587f, 59.717437f,117.175099f, 59.681404f,117.205544f,
                    59.609812f,117.112064f, 59.589524f,117.172824f, 59.589524f,115.212170f);
            poly[2955] = new TzPolygon(59.589524f,118.035592f, 59.642211f,118.051681f, 59.623773f,118.078614f, 59.651835f,118.248135f, 59.622342f,118.340773f,
                    59.589524f,118.355136f);
            poly[2956] = new TzPolygon(46.076950f,141.034788f, 46.094036f,141.000102f, 46.164041f,140.938970f, 46.252628f,140.922056f, 46.348235f,140.939573f,
                    46.420316f,141.001179f, 46.436253f,141.034788f);
            poly[2957] = new TzPolygon(41.606056f,139.077770f, 42.253879f,139.152006f, 42.723755f,139.594663f, 43.443993f,140.103007f, 43.512483f,140.198750f,
                    43.837926f,141.034788f, 41.672352f,141.034788f, 41.658899f,140.968848f, 41.692182f,140.873095f, 41.606056f,140.710377f);
            poly[2958] = new TzPolygon(44.016180f,141.034788f, 44.388362f,141.012442f, 45.401188f,140.683491f, 45.513336f,140.676405f, 45.612885f,140.721413f,
                    45.681482f,140.826827f, 45.704006f,140.927526f, 45.707009f,141.034788f);
            poly[2959] = new TzPolygon(43.837926f,141.034788f, 43.841997f,141.045246f, 44.016180f,141.034788f, 45.707009f,141.034788f, 45.711205f,141.184621f,
                    45.569861f,141.978719f, 45.505103f,142.038837f, 45.429941f,142.432748f, 45.172601f,142.738202f, 44.884094f,142.964477f,
                    44.644142f,143.295163f, 44.524007f,143.527513f, 44.462166f,143.600038f, 44.391986f,143.801313f, 44.335512f,144.023217f,
                    44.287828f,144.379464f, 44.221133f,144.480758f, 44.126835f,144.531240f, 44.119034f,144.658218f, 44.137598f,144.690191f,
                    44.409620f,145.050145f, 42.789157f,145.050145f, 42.758432f,144.958576f, 42.733501f,144.789701f, 42.740141f,144.467783f,
                    42.788519f,144.250550f, 42.723855f,144.098404f, 42.500304f,143.790319f, 42.340289f,143.640540f, 42.013887f,143.576157f,
                    41.847668f,143.510155f, 41.767885f,143.438806f, 41.722166f,143.325917f, 41.716708f,143.229285f, 41.740824f,143.127132f,
                    41.890708f,142.924361f, 42.092342f,142.358641f, 42.273176f,142.031526f, 42.312152f,141.889654f, 42.380822f,141.783698f,
                    42.411784f,141.577966f, 42.263589f,141.297422f, 41.834440f,141.454039f, 41.747637f,141.444705f, 41.682614f,141.401685f,
                    41.682951f,141.086742f, 41.672352f,141.034788f);
            poly[2960] = new TzPolygon(53.699049f,141.034788f, 53.593968f,141.389080f, 53.591078f,141.468257f, 53.338288f,141.591707f, 53.238288f,141.708374f,
                    53.163288f,141.636707f, 52.428287f,141.523373f, 52.126620f,141.590040f, 51.561333f,141.414405f, 51.448342f,141.212219f,
                    51.283195f,141.145574f, 51.195380f,141.034788f);
            poly[2961] = new TzPolygon(44.409620f,145.050145f, 44.521730f,145.198495f, 44.544060f,145.360646f, 44.501895f,145.512129f, 44.425985f,145.599605f,
                    44.301610f,145.637497f, 44.132048f,145.513883f, 43.940427f,145.320125f, 43.839732f,145.276359f, 43.735557f,145.278751f,
                    43.623300f,145.447358f, 43.502050f,145.759416f, 43.381511f,145.841593f, 43.225391f,146.008308f, 43.056693f,145.787055f,
                    42.996209f,145.667228f, 42.789157f,145.050145f);
            poly[2962] = new TzPolygon(61.084770f,137.019431f, 61.084770f,138.340334f, 60.991823f,138.356225f, 60.954915f,138.269092f, 60.857035f,138.206922f,
                    60.818167f,138.282988f, 60.738083f,138.312799f, 60.703656f,138.428956f, 60.620655f,138.396839f, 60.604217f,138.331997f,
                    60.561135f,138.359918f, 60.492994f,138.318036f, 60.481167f,138.267445f, 60.401549f,138.335627f, 60.319131f,138.319266f,
                    60.277814f,138.213216f, 60.208225f,138.178095f, 60.173035f,138.239475f, 60.101969f,138.211655f, 60.068806f,138.262422f,
                    59.973723f,138.224759f, 59.935143f,138.265903f, 59.914190f,138.194355f, 59.826788f,138.175704f, 59.814601f,138.219745f,
                    59.730602f,138.220017f, 59.705773f,138.272096f, 59.683585f,138.210209f, 59.643384f,138.208478f, 59.656454f,138.031542f,
                    59.748742f,138.080892f, 59.824763f,138.031175f, 59.740811f,137.898769f, 59.758248f,137.818526f, 59.747926f,137.613578f,
                    59.645583f,137.449811f, 59.592533f,137.448996f, 59.555090f,137.499544f, 59.541673f,137.354726f, 59.440205f,137.178615f,
                    59.451898f,137.103276f, 59.433035f,137.019431f);
            poly[2963] = new TzPolygon(61.084770f,138.340334f, 61.107432f,138.336460f, 61.099381f,138.397131f, 61.207081f,138.703255f, 61.226987f,138.651092f,
                    61.279826f,138.635989f, 61.336687f,138.733418f, 61.313665f,138.770495f, 61.332445f,138.867912f, 61.315580f,138.970095f,
                    61.339559f,139.015303f, 61.084770f,139.015303f);
            poly[2964] = new TzPolygon(62.207551f,139.015303f, 62.207551f,140.315372f, 62.185250f,140.334476f, 62.110256f,140.315923f, 62.068294f,140.241325f,
                    62.037808f,140.275988f, 62.015144f,140.175297f, 61.968638f,140.117320f, 61.988077f,140.040502f, 61.976614f,139.987641f,
                    61.804024f,139.937559f, 61.698964f,139.781382f, 61.639539f,139.775756f, 61.633443f,139.735555f, 61.658597f,139.734157f,
                    61.662242f,139.692293f, 61.473609f,139.553758f, 61.465204f,139.497078f, 61.494965f,139.445755f, 61.430494f,139.301457f,
                    61.432070f,139.056696f, 61.364698f,139.062698f, 61.339559f,139.015303f);
            poly[2965] = new TzPolygon(63.330332f,139.889553f, 63.330332f,141.011174f, 62.479321f,141.011174f, 62.475898f,140.994842f, 62.531746f,140.834571f,
                    62.513493f,140.744714f, 62.416743f,140.667610f, 62.414041f,140.556801f, 62.486081f,140.479002f, 62.529150f,140.517197f,
                    62.571999f,140.322103f, 62.643789f,140.270305f, 62.650494f,140.308414f, 62.663089f,140.218506f, 62.689407f,140.219622f,
                    62.711550f,140.094995f, 62.685016f,139.885826f, 62.654476f,139.888830f, 62.650691f,139.833126f, 62.682496f,139.836109f,
                    62.681143f,139.802688f, 62.771639f,139.713506f, 62.781522f,139.575570f, 62.807656f,139.555829f, 62.921214f,139.712973f,
                    62.944787f,139.705065f, 62.944480f,139.597351f, 62.962102f,139.589760f, 63.026360f,139.641475f, 63.191869f,139.622673f,
                    63.278956f,139.727391f);
            poly[2966] = new TzPolygon(62.207551f,140.333761f, 62.218828f,140.335828f, 62.246608f,140.281914f, 62.373793f,140.341380f, 62.378302f,140.391467f,
                    62.416213f,140.422095f, 62.407903f,140.646096f, 62.453594f,140.724091f, 62.481901f,140.703909f, 62.513493f,140.744714f,
                    62.531746f,140.834571f, 62.475898f,140.994842f, 62.479321f,141.011174f, 62.207551f,141.011174f);
            poly[2967] = new TzPolygon(63.330332f,139.889553f, 63.344814f,139.935264f, 63.395423f,139.974071f, 63.498438f,140.241058f, 63.525336f,140.512347f,
                    63.501679f,140.642145f, 63.686409f,140.675297f, 63.720621f,140.553675f, 63.799516f,140.561861f, 63.867777f,140.683797f,
                    63.884604f,140.875454f, 64.000842f,140.795830f, 64.096238f,140.826879f, 64.105737f,140.781979f, 64.166454f,140.788754f,
                    64.206634f,140.509362f, 64.312065f,140.337422f, 64.369749f,140.060865f, 64.453113f,140.308293f, 64.453113f,141.011174f,
                    63.330332f,141.011174f);
            poly[2968] = new TzPolygon(65.575894f,140.264941f, 65.555041f,140.322814f, 65.472870f,140.150828f, 65.500069f,140.100868f, 65.478321f,139.932286f,
                    65.361853f,139.832155f, 65.340667f,139.741623f, 65.243497f,139.579611f, 65.178192f,139.568483f, 65.156835f,139.478795f,
                    65.074245f,139.440903f, 65.022736f,139.355014f, 64.946020f,139.445689f, 64.922803f,139.562134f, 64.849630f,139.639835f,
                    64.860663f,139.661422f, 64.787273f,139.879346f, 64.636638f,140.127268f, 64.611478f,140.220909f, 64.618286f,140.290861f,
                    64.573437f,140.345879f, 64.573730f,140.408285f, 64.492215f,140.424349f, 64.453113f,140.308293f, 64.453113f,139.015303f,
                    65.575894f,139.015303f);
            poly[2969] = new TzPolygon(65.575894f,141.011174f, 65.565149f,140.966666f, 65.527847f,140.998593f, 65.552831f,140.812975f, 65.524819f,140.622843f,
                    65.555786f,140.459419f, 65.555041f,140.322814f, 65.575894f,140.264941f);
            poly[2970] = new TzPolygon(60.204844f,146.109588f, 60.202118f,145.938378f, 60.170272f,145.857411f, 60.311641f,145.561934f, 60.360310f,145.658800f,
                    60.388140f,145.657323f, 60.414645f,145.637327f, 60.422181f,145.530051f, 60.455540f,145.525005f, 60.496357f,145.530554f,
                    60.517542f,145.640722f, 60.556981f,145.645282f, 60.594978f,145.713609f, 60.617962f,145.928521f, 60.655805f,145.920307f,
                    60.658376f,145.982425f, 60.736039f,146.081722f, 60.738499f,146.109588f);
            poly[2971] = new TzPolygon(61.832713f,143.975059f, 61.832713f,144.411347f, 61.786220f,144.363311f, 61.766743f,144.246610f, 61.727803f,144.223743f,
                    61.756359f,144.148065f, 61.733848f,144.115485f, 61.754986f,143.944683f);
            poly[2972] = new TzPolygon(61.832713f,144.498961f, 61.820931f,144.454055f, 61.832713f,144.413953f);
            poly[2973] = new TzPolygon(62.479321f,141.011174f, 62.489834f,141.061325f, 62.396811f,141.127432f, 62.416705f,141.174550f, 62.399386f,141.218220f,
                    62.416314f,141.314379f, 62.302541f,141.421017f, 62.276988f,141.507518f, 62.155529f,141.559283f, 62.141878f,141.632858f,
                    62.077157f,141.732169f, 62.083845f,141.853931f, 62.011204f,141.843736f, 62.038657f,141.931190f, 62.020176f,142.001710f,
                    62.074213f,142.173402f, 62.039408f,142.189842f, 62.017924f,142.266965f, 61.966500f,142.265991f, 61.958573f,142.397509f,
                    61.927136f,142.425055f, 61.903633f,142.394156f, 61.871580f,142.450571f, 61.973091f,142.713342f, 61.943897f,142.788418f,
                    61.947566f,142.847529f, 61.906898f,142.892480f, 61.896761f,142.954134f, 61.914842f,143.006472f, 61.972166f,143.011443f,
                    62.059373f,143.153418f, 62.088981f,143.114281f, 62.117471f,143.229693f, 62.034158f,143.332546f, 62.021878f,143.413333f,
                    62.053844f,143.506246f, 62.040212f,143.560381f, 61.832713f,143.560381f, 61.832713f,141.011174f);
            poly[2974] = new TzPolygon(65.072191f,143.560381f, 65.069763f,143.504044f, 65.109223f,143.521133f, 65.159425f,143.324195f, 65.175448f,143.137382f,
                    65.158764f,143.011058f, 65.178189f,142.957979f, 65.275609f,142.927080f, 65.328105f,142.783362f, 65.334197f,142.717811f,
                    65.304594f,142.638315f, 65.327574f,142.566949f, 65.357715f,142.071832f, 65.383743f,142.055519f, 65.393875f,141.868957f,
                    65.450299f,141.808502f, 65.455163f,141.751829f, 65.435620f,141.692966f, 65.452794f,141.489801f, 65.439046f,141.433974f,
                    65.473280f,141.391418f, 65.460680f,141.346001f, 65.527255f,141.082106f, 65.575894f,141.011174f, 65.575894f,143.560381f);
            poly[2975] = new TzPolygon(62.047732f,144.834984f, 62.036121f,144.761340f, 62.085814f,144.728624f, 62.119957f,144.834984f);
            poly[2976] = new TzPolygon(62.040212f,143.560381f, 62.018704f,143.645788f, 61.944507f,143.598002f, 61.857208f,143.644318f, 61.867838f,143.696186f,
                    61.904000f,143.698927f, 61.905865f,143.769793f, 61.954826f,143.777093f, 61.994276f,143.922257f, 61.917156f,143.941437f,
                    61.895227f,143.999489f, 61.832713f,143.975059f, 61.832713f,143.560381f);
            poly[2977] = new TzPolygon(61.832713f,144.498961f, 61.844803f,144.545043f, 61.878619f,144.527015f, 61.905439f,144.619817f, 61.973206f,144.582979f,
                    62.045622f,144.722484f, 62.036407f,144.772073f, 62.054000f,144.834984f, 61.832713f,144.834984f);
            poly[2978] = new TzPolygon(62.768508f,145.363317f, 62.746697f,145.353052f, 62.707404f,145.456575f, 62.683367f,145.390963f, 62.632283f,145.450266f,
                    62.606996f,145.388515f, 62.547852f,145.472286f, 62.534817f,145.472286f, 62.499477f,145.384511f, 62.524373f,145.277998f,
                    62.473603f,145.217012f, 62.490313f,145.175538f, 62.478539f,145.137654f, 62.438459f,145.189467f, 62.397267f,145.149231f,
                    62.333696f,145.207517f, 62.301887f,145.209325f, 62.299288f,145.165404f, 62.275526f,145.196193f, 62.268051f,145.126248f,
                    62.234610f,145.098984f, 62.238915f,144.990204f, 62.156606f,144.986845f, 62.158284f,144.877620f, 62.133396f,144.876847f,
                    62.121943f,144.834984f, 62.768508f,144.834984f);
            poly[2979] = new TzPolygon(62.054000f,144.834984f, 62.059789f,144.855687f, 62.063902f,144.971157f, 62.007548f,145.024017f, 62.002154f,145.144669f,
                    61.964145f,145.210803f, 62.005360f,145.290614f, 61.976358f,145.397538f, 61.988265f,145.461918f, 61.949297f,145.454226f,
                    61.954831f,145.472286f, 61.832713f,145.472286f, 61.832713f,144.834984f);
            poly[2980] = new TzPolygon(62.547852f,145.472286f, 62.539551f,145.484044f, 62.534817f,145.472286f);
            poly[2981] = new TzPolygon(61.954831f,145.472286f, 61.965431f,145.506879f, 61.949858f,145.538588f, 61.979670f,145.561317f, 61.982779f,145.641079f,
                    62.058035f,145.650628f, 62.036019f,145.698648f, 62.043432f,145.746282f, 62.001172f,145.820575f, 62.004494f,145.965418f,
                    61.944664f,146.018746f, 61.957471f,146.091533f, 61.936768f,146.099522f, 61.936132f,146.109588f, 61.832713f,146.109588f,
                    61.832713f,145.472286f);
            poly[2982] = new TzPolygon(62.768508f,146.109588f, 62.768508f,145.363317f, 62.866673f,145.409515f, 63.007889f,145.343242f, 63.020976f,145.282752f,
                    63.050642f,145.316205f, 63.159704f,145.249320f, 63.242875f,145.257862f, 63.308217f,145.393119f, 63.378699f,145.440458f,
                    63.544239f,145.482224f, 63.671708f,145.675187f, 63.704303f,145.673148f, 63.704303f,146.109588f);
            poly[2983] = new TzPolygon(63.704303f,146.109588f, 63.704303f,145.673148f, 63.774762f,145.668741f, 63.807865f,145.567507f, 63.881252f,145.830978f,
                    63.920515f,146.109588f);
            poly[2984] = new TzPolygon(64.226086f,146.109588f, 64.238419f,146.077507f, 64.273494f,146.061680f, 64.356391f,145.870650f, 64.434920f,145.766920f,
                    64.416506f,145.587737f, 64.455577f,145.482621f, 64.436191f,145.327004f, 64.544346f,145.140831f, 64.532360f,144.987498f,
                    64.568976f,144.918234f, 64.572821f,144.733194f, 64.656705f,144.534245f, 64.716817f,144.663870f, 64.775643f,144.696014f,
                    64.865922f,144.534695f, 64.890400f,144.353292f, 65.036998f,144.231632f, 65.016482f,144.151401f, 65.032783f,144.053569f,
                    65.018589f,144.011272f, 65.049964f,143.946394f, 65.032788f,143.770860f, 65.075363f,143.633966f, 65.072191f,143.560381f,
                    65.575894f,143.560381f, 65.575894f,146.109588f);
            poly[2985] = new TzPolygon(60.202423f,146.109588f, 60.202536f,146.173179f, 60.244643f,146.313531f, 60.241535f,146.408265f, 60.217274f,146.410521f,
                    60.185272f,146.495814f, 60.097224f,146.537469f, 60.115943f,146.615923f, 60.087294f,146.689112f, 59.979076f,146.697495f,
                    59.905055f,146.800770f, 59.951859f,146.942227f, 59.947898f,147.039270f, 59.930842f,147.063037f, 59.914996f,147.028113f,
                    59.888814f,147.116025f, 59.838928f,147.165654f, 59.796661f,147.146468f, 59.735326f,147.216789f, 59.696005f,147.126050f,
                    59.643890f,147.176823f, 59.502519f,147.148218f, 59.456789f,147.093555f, 59.408988f,147.111805f, 59.386202f,146.936720f,
                    59.146534f,146.912474f, 59.010967f,146.501499f, 58.950622f,146.162739f, 58.948156f,146.109588f);
            poly[2986] = new TzPolygon(61.936132f,146.109588f, 61.933111f,146.157411f, 61.906977f,146.140272f, 61.899087f,146.238214f, 61.855898f,146.243610f,
                    61.855484f,146.317767f, 61.806001f,146.388651f, 61.779278f,146.363581f, 61.719859f,146.461194f, 61.689025f,146.456956f,
                    61.637278f,146.595483f, 61.532831f,146.578916f, 61.468033f,146.740371f, 61.404102f,146.686745f, 61.401813f,146.751545f,
                    61.305145f,146.697720f, 61.235168f,146.753437f, 61.154320f,146.728922f, 61.096601f,146.763776f, 61.093608f,146.689305f,
                    61.061142f,146.661491f, 61.004434f,146.755915f, 60.948713f,146.702971f, 60.940204f,146.498289f, 60.854911f,146.495422f,
                    60.843728f,146.535192f, 60.809335f,146.480923f, 60.782917f,146.495210f, 60.780891f,146.451259f, 60.669921f,146.441356f,
                    60.652664f,146.336103f, 60.701852f,146.197102f, 60.742770f,146.157961f, 60.738499f,146.109588f);
            poly[2987] = new TzPolygon(65.575894f,148.658794f, 64.417918f,148.658794f, 64.450364f,148.555713f, 64.509810f,148.501199f, 64.528079f,148.327615f,
                    64.442230f,148.224911f, 64.410154f,148.048407f, 64.293751f,148.125090f, 64.220696f,148.314505f, 64.200764f,148.260942f,
                    64.152785f,148.263517f, 64.102504f,148.159692f, 64.024059f,148.177329f, 64.006042f,148.085413f, 63.936136f,148.018343f,
                    63.947495f,147.905540f, 63.969760f,147.895041f, 63.950490f,147.862753f, 63.953648f,147.788405f, 64.010654f,147.774178f,
                    64.011346f,147.670816f, 64.066943f,147.651769f, 64.116428f,147.732926f, 64.178001f,147.643774f, 64.145200f,147.568192f,
                    64.114529f,147.346753f, 64.086028f,147.386534f, 64.018846f,147.291925f, 64.134042f,147.008641f, 64.151807f,146.693260f,
                    64.189356f,146.542709f, 64.208612f,146.306104f, 64.186978f,146.211311f, 64.226086f,146.109588f, 65.575894f,146.109588f);
            poly[2988] = new TzPolygon(64.226086f,146.109588f, 64.186978f,146.211311f, 64.208612f,146.306104f, 64.180676f,146.383859f, 64.070100f,146.333488f,
                    64.018673f,146.229077f, 63.929353f,146.172300f, 63.918516f,146.109588f);
            poly[2989] = new TzPolygon(64.351948f,151.208001f, 64.359236f,151.167177f, 64.332985f,150.993956f, 64.339916f,150.656663f, 64.304575f,150.586888f,
                    64.267998f,150.675331f, 64.175846f,150.661676f, 64.166332f,150.548820f, 64.213441f,150.385114f, 64.218831f,150.210973f,
                    64.264035f,150.201630f, 64.281811f,150.092778f, 64.350929f,150.016771f, 64.428909f,150.135027f, 64.469472f,150.143723f,
                    64.496075f,149.994194f, 64.542086f,149.978222f, 64.562013f,149.874067f, 64.472667f,149.583392f, 64.405008f,149.501145f,
                    64.419053f,149.357905f, 64.376755f,149.339492f, 64.381817f,149.195211f, 64.423492f,149.184066f, 64.431475f,149.041135f,
                    64.402203f,148.708723f, 64.417918f,148.658794f, 65.575894f,148.658794f, 65.575894f,151.208001f);
            poly[2990] = new TzPolygon(66.123916f,137.019431f, 66.113174f,137.049980f, 66.125388f,137.110196f, 66.103660f,137.261437f, 66.042879f,137.318350f,
                    66.045998f,137.544171f, 65.977069f,137.697498f, 65.962177f,137.988171f, 65.989269f,138.121998f, 65.950984f,138.208433f,
                    65.934645f,138.378189f, 65.961703f,138.515668f, 65.945501f,138.683038f, 65.968406f,138.793002f, 65.575894f,138.793002f,
                    65.575894f,137.019431f);
            poly[2991] = new TzPolygon(67.137034f,138.793002f, 67.251814f,138.675352f, 67.270513f,138.793002f);
            poly[2992] = new TzPolygon(65.968406f,138.793002f, 66.014547f,139.014516f, 66.023695f,139.258747f, 65.986780f,139.465433f, 65.847224f,139.813099f,
                    65.835911f,139.970362f, 65.868998f,140.147030f, 65.802763f,140.351717f, 65.736149f,140.341918f, 65.654599f,140.177261f,
                    65.607728f,140.176593f, 65.575894f,140.264941f, 65.575894f,138.793002f);
            poly[2993] = new TzPolygon(65.575894f,140.264941f, 65.607728f,140.176593f, 65.654599f,140.177261f, 65.736149f,140.341918f, 65.802763f,140.351717f,
                    65.921351f,140.024812f, 66.035961f,140.084262f, 66.094055f,139.853998f, 66.155754f,139.862077f, 66.216055f,139.729392f,
                    66.265334f,139.699100f, 66.320262f,139.990280f, 66.402986f,140.074124f, 66.392086f,140.224697f, 66.335440f,140.429453f,
                    66.407065f,140.533327f, 66.465392f,140.536974f, 66.474060f,140.524839f, 66.474060f,140.566574f, 65.575894f,140.566574f);
            poly[2994] = new TzPolygon(67.137632f,138.793002f, 67.133260f,138.796871f, 67.124351f,139.088531f, 67.086496f,139.149974f, 67.097229f,139.275479f,
                    67.074296f,139.309170f, 67.073003f,139.414988f, 66.875992f,139.541278f, 66.796625f,139.927850f, 66.698025f,140.041009f,
                    66.685968f,140.183326f, 66.627419f,140.313540f, 66.492948f,140.317968f, 66.478285f,140.363254f, 66.490723f,140.501510f,
                    66.474060f,140.524839f, 66.474060f,138.793002f);
            poly[2995] = new TzPolygon(67.372225f,138.928705f, 67.285758f,138.888923f, 67.276051f,138.793002f, 67.372225f,138.793002f);
            poly[2996] = new TzPolygon(67.372225f,138.928705f, 67.402965f,138.942848f, 67.443456f,138.744079f, 67.516553f,138.749774f, 67.586374f,138.685080f,
                    67.547264f,139.162948f, 67.658620f,139.542761f, 67.776529f,139.783902f, 67.792904f,139.907069f, 67.876430f,140.004637f,
                    67.850314f,140.334206f, 67.887951f,140.398235f, 67.850198f,140.566574f, 67.372225f,140.566574f);
            poly[2997] = new TzPolygon(69.168556f,141.486229f, 69.148290f,141.480619f, 69.064860f,141.594262f, 68.895637f,141.657007f, 68.761681f,141.808357f,
                    68.703411f,141.448612f, 68.570120f,141.384474f, 68.473790f,141.105433f, 68.430835f,141.117851f, 68.410217f,140.914088f,
                    68.373298f,140.898016f, 68.231630f,141.051693f, 68.200305f,141.161366f, 68.092311f,141.011281f, 68.013870f,141.079731f,
                    67.886885f,141.056492f, 67.804575f,141.343456f, 67.789850f,141.268569f, 67.833495f,141.128269f, 67.832185f,140.878029f,
                    67.859794f,140.741558f, 67.844294f,140.592899f, 67.850198f,140.566574f, 69.168556f,140.566574f);
            poly[2998] = new TzPolygon(70.964888f,140.566574f, 70.964888f,142.197842f, 70.946751f,142.128837f, 70.915895f,142.124383f, 70.831703f,141.794327f,
                    70.768069f,141.712450f, 70.741238f,141.587366f, 70.679710f,141.615339f, 70.648157f,141.710707f, 70.145184f,140.733442f,
                    69.989429f,140.955369f, 69.998445f,141.199435f, 69.917194f,141.329919f, 69.857277f,141.566053f, 69.883719f,141.795021f,
                    69.873742f,142.117679f, 69.788217f,142.263321f, 69.740968f,142.089929f, 69.726266f,142.127349f, 69.660047f,142.033004f,
                    69.603885f,142.189828f, 69.582419f,142.369623f, 69.507534f,142.388988f, 69.426201f,142.600123f, 69.296187f,142.673659f,
                    69.249612f,142.628880f, 69.247311f,142.575290f, 69.278839f,142.461210f, 69.257493f,142.380728f, 69.275465f,142.235597f,
                    69.253623f,142.006392f, 69.271720f,141.976509f, 69.260039f,141.887629f, 69.276188f,141.778380f, 69.208892f,141.497394f,
                    69.168556f,141.486229f, 69.168556f,140.566574f);
            poly[2999] = new TzPolygon(70.964888f,142.197842f, 70.981685f,142.261750f, 71.050143f,142.349847f, 71.095931f,142.552097f, 71.132126f,142.569336f,
                    71.256608f,142.416431f, 71.360793f,142.529096f, 71.558731f,142.530823f, 71.565942f,142.603707f, 71.662151f,142.724719f,
                    71.651407f,142.815528f, 71.715220f,142.979250f, 71.681908f,143.070831f, 71.710685f,143.158500f, 71.698140f,143.048515f,
                    71.775811f,143.077588f, 71.916397f,143.343451f, 71.965215f,143.341048f, 71.992671f,143.477089f, 72.041330f,143.369179f,
                    72.071943f,143.438144f, 72.072260f,143.672376f, 72.119532f,143.722587f, 72.142036f,143.665509f, 72.161924f,143.806744f,
                    72.180188f,143.806057f, 72.152588f,143.909998f, 72.161031f,144.024236f, 72.183994f,143.985740f, 72.165458f,144.033627f,
                    72.176696f,144.079405f, 72.204409f,144.036120f, 72.178121f,144.113716f, 70.964888f,144.113716f);
        }
    }

    private static class Initializer31 {
        private static void init() {
            poly[3000] = new TzPolygon(72.761219f,145.217507f, 72.366063f,144.740315f, 72.233671f,144.506757f, 72.273957f,144.296922f, 72.179211f,144.200137f,
                    72.202994f,144.166401f, 72.171239f,144.134031f, 72.178121f,144.113716f, 72.761219f,144.113716f);
            poly[3001] = new TzPolygon(7.511199f,117.166690f, 7.480271f,117.046292f, 7.511199f,117.011096f);
            poly[3002] = new TzPolygon(7.511199f,117.166690f, 7.378446f,117.437160f, 7.184420f,117.468365f, 6.903228f,117.379536f, 6.506248f,117.885923f,
                    6.459000f,117.885240f, 6.459000f,117.166690f);
            poly[3003] = new TzPolygon(15.244109f,117.730179f, 15.142393f,117.869053f, 15.099803f,117.854805f, 15.085301f,117.793608f, 15.104610f,117.712325f,
                    15.210154f,117.695675f);
            poly[3004] = new TzPolygon(8.399960f,167.184146f, 8.404850f,167.184967f, 8.471998f,167.244530f, 8.517965f,167.363222f, 8.501212f,167.463938f,
                    8.468945f,167.520083f, 8.414114f,167.561300f, 8.399960f,167.563442f);
            poly[3005] = new TzPolygon(24.207778f,118.239444f, 24.178889f,118.291667f, 24.130833f,118.294167f, 24.115278f,118.232778f, 24.142222f,118.188889f,
                    24.173055f,118.188889f, 24.205000f,118.206944f);
            poly[3006] = new TzPolygon(24.207778f,118.546111f, 24.207778f,115.212170f, 25.829900f,115.212170f, 25.829900f,118.546111f);
            poly[3007] = new TzPolygon(25.829900f,120.451492f, 25.329364f,120.129192f, 24.813137f,119.605610f, 24.118202f,118.546111f, 25.829900f,118.546111f);
            poly[3008] = new TzPolygon(26.037778f,115.212170f, 26.037778f,120.076944f, 25.829900f,120.076944f, 25.829900f,115.212170f);
            poly[3009] = new TzPolygon(26.037778f,120.076944f, 26.037778f,115.212170f, 38.623477f,115.212170f, 38.623477f,120.076944f);
            poly[3010] = new TzPolygon(38.623477f,120.289722f, 25.829900f,120.289722f, 25.829900f,120.076944f, 38.623477f,120.076944f);
            poly[3011] = new TzPolygon(26.437222f,120.490833f, 26.408611f,120.556111f, 26.359444f,120.577500f, 26.325000f,120.568333f, 26.287222f,120.461667f,
                    26.390556f,120.413056f, 26.433333f,120.446667f);
            poly[3012] = new TzPolygon(34.891740f,129.599528f, 34.777540f,129.710638f, 34.671971f,129.743290f, 34.415514f,129.685666f, 34.058971f,129.283113f,
                    33.908267f,129.071046f, 33.947544f,128.997861f, 34.679488f,129.268486f);
            poly[3013] = new TzPolygon(32.448242f,128.470462f, 32.458994f,128.445958f, 32.548879f,128.372907f, 32.721700f,128.351683f, 32.801366f,128.369922f,
                    33.314213f,128.615907f, 33.505278f,128.859248f, 33.505261f,129.120795f, 33.911170f,129.638776f, 34.057958f,129.803590f,
                    34.162727f,129.832649f, 32.448242f,129.832649f);
            poly[3014] = new TzPolygon(38.623477f,124.534150f, 38.623477f,128.374371f, 38.594376f,128.311022f, 38.436748f,128.282773f, 38.369819f,128.212570f,
                    38.307280f,128.061773f, 38.330918f,127.882233f, 38.304060f,127.821666f, 38.348858f,127.783009f, 38.324200f,127.688961f,
                    38.333548f,127.573638f, 38.301111f,127.505556f, 38.337028f,127.385317f, 38.313125f,127.300240f, 38.332452f,127.242276f,
                    38.313684f,127.133322f, 38.214308f,126.986033f, 38.157840f,126.948992f, 38.136485f,126.965548f, 38.101301f,126.877924f,
                    38.003182f,126.818844f, 37.954809f,126.721513f, 37.957932f,126.670813f, 37.839400f,126.691253f, 37.783562f,126.656027f,
                    37.765294f,126.603485f, 37.844704f,126.413576f, 37.829756f,126.222917f, 37.808450f,126.194120f, 37.715073f,126.185380f,
                    37.712500f,126.111111f, 37.658333f,126.016667f, 37.714722f,125.750000f, 37.691667f,125.695000f, 37.681944f,125.516667f,
                    37.583333f,125.244444f, 37.637500f,125.047222f, 37.766667f,124.866667f, 38.000000f,124.850000f, 38.050000f,124.633333f,
                    38.041892f,124.373618f, 38.188596f,124.398135f, 38.249232f,124.444921f, 38.330659f,124.593391f, 38.492344f,124.505681f);
            poly[3015] = new TzPolygon(38.623477f,128.653809f, 38.617720f,128.655981f, 38.623477f,128.374371f);
            poly[3016] = new TzPolygon(47.088321f,152.619038f, 47.386673f,152.082696f, 47.521722f,152.238104f, 47.697235f,152.619038f);
            poly[3017] = new TzPolygon(50.686734f,156.831768f, 51.071689f,156.309305f, 51.103853f,156.343351f, 51.250681f,156.231927f, 51.507453f,156.167654f,
                    51.839109f,156.174358f, 52.160403f,156.131232f, 52.836619f,155.814585f, 53.813146f,155.606741f, 54.608976f,155.338826f,
                    55.232256f,155.215243f, 55.565445f,155.252033f, 55.565445f,156.831768f);
            poly[3018] = new TzPolygon(55.565445f,155.252033f, 55.994642f,155.299423f, 56.678948f,155.606696f, 56.908682f,155.795425f, 57.049196f,156.111963f,
                    57.114947f,156.163318f, 57.253988f,156.136737f, 57.346617f,156.190102f, 57.414586f,156.318309f, 57.491740f,156.626836f,
                    57.627019f,156.448941f, 57.697814f,156.404765f, 57.795688f,156.424963f, 57.903705f,156.533151f, 58.028433f,156.821716f,
                    58.060928f,157.035719f, 55.565445f,157.035719f);
            poly[3019] = new TzPolygon(61.642182f,159.949578f, 61.642182f,162.452760f, 60.866829f,162.002116f, 60.283526f,160.845356f, 60.438282f,160.496800f,
                    60.388943f,160.316821f, 60.375504f,160.130404f, 60.401586f,159.949578f);
            poly[3020] = new TzPolygon(62.654972f,161.406507f, 62.654972f,162.810200f, 62.620449f,162.800543f, 62.571277f,162.681190f, 62.450964f,162.781384f,
                    62.311785f,162.786235f, 62.253754f,162.700024f, 62.251672f,162.617191f, 62.272306f,162.595765f, 62.241356f,162.534257f,
                    62.238953f,162.397505f, 62.181912f,162.309408f, 62.200762f,162.260402f, 62.166281f,162.162876f, 62.103805f,162.289735f,
                    62.083215f,162.524472f, 62.003586f,162.542339f, 62.002310f,162.490955f, 61.962177f,162.498452f, 61.942071f,162.443875f,
                    61.963934f,162.369514f, 61.941515f,162.293713f, 61.895875f,162.376211f, 61.825581f,162.386419f, 61.799888f,162.474504f,
                    61.761191f,162.390244f, 61.740764f,162.463968f, 61.665734f,162.466449f, 61.642182f,162.452760f, 61.642182f,161.406507f);
            poly[3021] = new TzPolygon(62.654972f,162.810200f, 62.690683f,162.820190f, 62.705960f,162.759282f, 62.691380f,162.657698f, 62.747182f,162.553938f,
                    62.778082f,162.628540f, 62.830213f,162.564559f, 62.903328f,162.279559f, 62.952979f,162.260813f, 63.030107f,162.320836f,
                    63.043400f,162.291870f, 63.108078f,162.379768f, 63.091014f,162.428971f, 63.111745f,162.578171f, 63.153013f,162.574206f,
                    63.166005f,162.755945f, 63.237826f,162.776981f, 63.265603f,162.735715f, 63.306275f,162.784129f, 63.344965f,162.676994f,
                    63.384581f,162.658213f, 63.383453f,162.758541f, 63.417280f,162.824811f, 63.415652f,162.863436f, 62.654972f,162.863436f);
            poly[3022] = new TzPolygon(67.718919f,154.121860f, 65.774547f,154.121860f, 65.776527f,154.106865f, 65.850264f,154.087433f, 65.873049f,153.956673f,
                    65.855026f,153.797740f, 65.870852f,153.754727f, 65.809594f,153.531156f, 65.747972f,153.483706f, 65.736889f,153.549281f,
                    65.697960f,153.580576f, 65.667004f,153.514929f, 65.635579f,153.540602f, 65.483493f,153.441311f, 65.407670f,153.590602f,
                    65.345737f,153.500533f, 65.358092f,153.439916f, 65.300721f,153.202697f, 65.243863f,153.152998f, 65.264191f,153.119256f,
                    65.242989f,152.973499f, 65.255738f,152.933974f, 65.206831f,152.797821f, 65.229331f,152.761854f, 65.221183f,152.717374f,
                    65.060508f,152.630224f, 64.993862f,152.525736f, 64.916384f,152.518714f, 64.811292f,152.585915f, 64.773079f,152.749794f,
                    64.701393f,152.847283f, 64.623176f,152.727062f, 64.532901f,152.376811f, 64.387909f,152.440715f, 64.352269f,152.140931f,
                    64.452285f,152.071538f, 64.489094f,151.972582f, 64.425812f,151.496874f, 64.329911f,151.405383f, 64.372636f,151.326476f,
                    64.344147f,151.251700f, 64.351948f,151.208001f, 67.718919f,151.208001f);
            poly[3023] = new TzPolygon(65.774547f,154.121860f, 65.769547f,154.159725f, 65.805331f,154.265346f, 65.922526f,154.411806f, 65.974170f,154.378689f,
                    65.994357f,154.430058f, 66.030581f,154.370542f, 66.047979f,154.228944f, 66.088621f,154.267330f, 66.103399f,154.364956f,
                    66.183845f,154.395869f, 66.217650f,154.589754f, 66.181260f,154.663521f, 66.168246f,154.843026f, 66.109227f,154.897894f,
                    66.128103f,155.075330f, 66.160338f,155.057722f, 66.157739f,155.144218f, 66.182483f,155.170693f, 66.181404f,155.262680f,
                    66.125449f,155.398221f, 66.144220f,155.528177f, 66.120587f,155.648615f, 66.161196f,155.747972f, 66.067757f,155.948471f,
                    66.073601f,156.006589f, 66.046224f,156.060643f, 66.070478f,156.145336f, 66.060056f,156.355073f, 66.033917f,156.433155f,
                    66.189043f,156.674004f, 66.036505f,156.926616f, 66.007335f,157.034383f, 65.957436f,156.960047f, 65.934195f,157.035719f,
                    63.667761f,157.035719f, 63.667761f,154.121860f);
            poly[3024] = new TzPolygon(65.569569f,159.736319f, 65.569569f,159.949578f, 65.517430f,159.949578f, 65.511256f,159.811506f);
            poly[3025] = new TzPolygon(66.363387f,158.492648f, 66.432102f,158.368665f, 66.460236f,158.492648f);
            poly[3026] = new TzPolygon(67.079769f,158.492648f, 67.101185f,158.380898f, 67.227682f,158.093155f, 67.286079f,157.839066f, 67.351499f,157.807727f,
                    67.419394f,157.909346f, 67.449008f,157.793054f, 67.471376f,157.796622f, 67.471376f,158.492648f);
            poly[3027] = new TzPolygon(65.934195f,157.035719f, 65.900984f,157.143852f, 65.891827f,157.335159f, 65.911023f,157.447549f, 65.997819f,157.438012f,
                    66.034027f,157.655501f, 66.098642f,157.738625f, 66.142603f,158.188291f, 66.100843f,158.284213f, 66.080980f,158.464543f,
                    66.090471f,158.492648f, 65.569569f,158.492648f, 65.569569f,157.035719f);
            poly[3028] = new TzPolygon(66.112907f,158.492648f, 66.219740f,158.403346f, 66.316079f,158.492648f);
            poly[3029] = new TzPolygon(66.090471f,158.492648f, 66.095410f,158.507274f, 66.112907f,158.492648f, 66.316079f,158.492648f, 66.322115f,158.498243f,
                    66.339139f,158.592078f, 66.315994f,158.723100f, 66.265943f,158.783008f, 66.248843f,159.033558f, 66.227484f,159.090743f,
                    66.232139f,159.232571f, 66.149630f,159.257539f, 66.049235f,159.096970f, 66.024259f,159.108860f, 66.004564f,159.035411f,
                    65.947549f,159.024906f, 65.888878f,158.926682f, 65.871137f,158.960973f, 65.856668f,158.921327f, 65.826934f,158.948976f,
                    65.813852f,158.898230f, 65.734168f,158.924685f, 65.724255f,159.038860f, 65.659137f,159.227461f, 65.648628f,159.448378f,
                    65.618100f,159.577516f, 65.597684f,159.581082f, 65.575282f,159.728953f, 65.569569f,159.736319f, 65.569569f,158.492648f);
            poly[3030] = new TzPolygon(67.079769f,158.492648f, 67.037357f,158.713960f, 66.962765f,158.811792f, 66.893871f,158.787335f, 66.869575f,158.863200f,
                    66.817353f,158.858243f, 66.760587f,158.960036f, 66.702493f,158.720499f, 66.641765f,158.722591f, 66.566425f,158.636240f,
                    66.548431f,158.535021f, 66.462901f,158.504391f, 66.460345f,158.492648f);
            poly[3031] = new TzPolygon(66.372894f,158.492648f, 66.342662f,158.551016f, 66.294076f,158.492648f);
            poly[3032] = new TzPolygon(66.112907f,158.492648f, 66.095410f,158.507274f, 66.090471f,158.492648f);
            poly[3033] = new TzPolygon(65.517430f,159.949578f, 67.471376f,159.949578f, 67.471376f,162.863436f, 64.662460f,162.863436f, 64.662186f,162.752481f,
                    64.687361f,162.672600f, 64.740980f,162.650107f, 64.762094f,162.422304f, 64.743661f,162.318979f, 64.785933f,162.224432f,
                    64.837279f,161.805051f, 64.864732f,161.824628f, 64.907003f,161.756147f, 65.003001f,161.718085f, 65.062957f,161.475827f,
                    65.148491f,161.317704f, 65.178427f,161.018790f, 65.142750f,160.852826f, 65.178039f,160.501978f, 65.275960f,160.415959f,
                    65.291918f,160.330924f, 65.339491f,160.297826f, 65.362189f,160.208826f, 65.432953f,160.240945f, 65.502233f,160.092682f,
                    65.520966f,160.028658f);
            poly[3034] = new TzPolygon(63.715467f,162.863436f, 63.724776f,162.777686f, 63.749505f,162.725636f, 63.784027f,162.757185f, 63.792812f,162.704573f,
                    63.849797f,162.773063f, 63.861455f,162.863436f);
            poly[3035] = new TzPolygon(63.993270f,162.863436f, 64.008662f,162.823483f, 64.087386f,162.851947f, 64.099019f,162.806043f, 64.129553f,162.808538f,
                    64.145700f,162.863436f);
            poly[3036] = new TzPolygon(67.471376f,157.796622f, 67.489086f,157.799447f, 67.518002f,157.730566f, 67.622253f,157.777557f, 67.659478f,157.848121f,
                    67.674568f,157.810091f, 67.723970f,157.942039f, 67.694815f,158.169867f, 67.714712f,158.182250f, 67.724236f,158.363940f,
                    67.820674f,158.259023f, 67.821721f,158.106031f, 67.873527f,158.056803f, 67.914022f,158.103566f, 67.934821f,158.215908f,
                    68.060556f,158.325146f, 68.127407f,158.646985f, 68.101771f,158.897971f, 68.189773f,159.244884f, 68.186571f,159.417625f,
                    68.223031f,159.637041f, 68.179964f,159.762516f, 68.249518f,159.831559f, 68.258472f,159.949578f, 67.471376f,159.949578f);
            poly[3037] = new TzPolygon(68.258472f,159.949578f, 68.267139f,160.063825f, 68.238748f,160.393466f, 68.247989f,160.731710f, 68.284424f,161.028757f,
                    68.341693f,161.199905f, 68.377936f,161.449741f, 68.375694f,161.644137f, 68.345293f,161.713980f, 68.340347f,161.893656f,
                    68.359483f,161.980495f, 68.334620f,162.194525f, 68.274317f,162.395413f, 68.284103f,162.447526f, 68.333041f,162.547950f,
                    68.437320f,162.616563f, 68.483344f,162.563824f, 68.583955f,162.751685f, 68.658241f,162.709588f, 68.685370f,162.603244f,
                    68.777632f,162.591608f, 68.769864f,162.738104f, 68.831229f,162.855209f, 68.917188f,162.751800f, 68.982584f,162.539667f,
                    69.035302f,162.577096f, 69.067557f,162.510844f, 69.107462f,162.535732f, 69.123839f,162.685317f, 69.146423f,162.688862f,
                    69.183649f,162.826464f, 69.181352f,162.772473f, 69.244011f,162.698964f, 69.288770f,162.562997f, 69.328505f,162.513533f,
                    69.373727f,162.542781f, 69.408152f,162.347890f, 69.454206f,162.432079f, 69.528534f,162.322333f, 69.555454f,162.414059f,
                    69.590994f,162.324110f, 69.632718f,162.488798f, 69.869038f,162.531060f, 69.853876f,162.818315f, 69.859055f,162.863436f,
                    67.471376f,162.863436f, 67.471376f,159.949578f);
            poly[3038] = new TzPolygon(63.014501f,168.691154f, 63.083486f,168.466368f, 63.178267f,168.619871f, 63.183050f,168.691154f);
            poly[3039] = new TzPolygon(62.363787f,170.148084f, 62.366201f,170.140918f, 62.396536f,170.148084f);
            poly[3040] = new TzPolygon(62.409296f,170.148084f, 62.440927f,170.074183f, 62.490840f,170.118760f, 62.522499f,170.063553f, 62.526331f,169.988964f,
                    62.578731f,170.044572f, 62.623279f,170.028008f, 62.636479f,170.093160f, 62.674604f,170.048049f, 62.659470f,169.832745f,
                    62.715483f,169.727900f, 62.704598f,169.679409f, 62.750573f,169.579482f, 62.792974f,169.578010f, 62.862831f,169.370072f,
                    62.891322f,169.389177f, 62.939391f,169.186518f, 62.973741f,169.155907f, 62.943581f,168.922245f, 63.014501f,168.691154f,
                    63.183050f,168.691154f, 63.187555f,168.758291f, 63.231046f,168.714431f, 63.252185f,168.756183f, 63.237420f,168.800161f,
                    63.303423f,168.826835f, 63.303423f,170.148084f);
            poly[3041] = new TzPolygon(62.409296f,170.148084f, 62.408124f,170.150821f, 62.396536f,170.148084f);
            poly[3042] = new TzPolygon(62.363787f,170.148084f, 62.344565f,170.205130f, 62.295329f,170.194294f, 62.281325f,170.245718f, 62.294910f,170.290280f,
                    62.273227f,170.309054f, 62.313408f,170.397573f, 62.285621f,170.490754f, 62.303805f,170.544239f, 62.267511f,170.641231f,
                    62.277845f,170.736120f, 62.249786f,170.842804f, 62.280754f,170.881703f, 62.277264f,171.057157f, 62.347080f,171.107763f,
                    62.339048f,171.171339f, 62.393352f,171.258404f, 62.372576f,171.314958f, 62.319866f,171.248155f, 62.319549f,171.315538f,
                    62.354320f,171.382744f, 62.301781f,171.402679f, 62.294206f,171.482470f, 62.332119f,171.605013f, 61.516254f,171.605013f,
                    61.516254f,170.148084f);
            poly[3043] = new TzPolygon(62.383959f,173.061943f, 62.399059f,172.924309f, 62.347644f,172.854532f, 62.357890f,172.754696f, 62.412584f,172.756171f,
                    62.445272f,172.561024f, 62.438965f,172.452212f, 62.371698f,172.289890f, 62.461487f,172.218939f, 62.465021f,172.077910f,
                    62.456058f,171.998644f, 62.416243f,171.978614f, 62.402459f,171.923466f, 62.412223f,171.852391f, 62.359225f,171.893390f,
                    62.354163f,171.676266f, 62.332119f,171.605013f, 63.303423f,171.605013f, 63.303423f,173.061943f);
            poly[3044] = new TzPolygon(62.383959f,173.061943f, 63.303423f,173.061943f, 63.303423f,174.518872f, 61.610575f,174.518872f, 61.607801f,174.502394f,
                    61.840948f,174.438774f, 61.837981f,174.496964f, 61.883016f,174.516825f, 61.917776f,174.436126f, 61.975217f,174.490516f,
                    61.986787f,174.447632f, 62.023903f,174.451898f, 62.034351f,174.335020f, 62.078618f,174.353816f, 62.093357f,174.304873f,
                    62.083340f,174.160671f, 62.156999f,174.108163f, 62.197472f,174.145888f, 62.282914f,173.999386f, 62.287900f,174.054646f,
                    62.328560f,174.069572f, 62.337860f,174.151094f, 62.424290f,174.158895f, 62.472250f,174.042267f, 62.435380f,173.898487f,
                    62.509882f,173.839580f, 62.518040f,173.726841f, 62.546819f,173.672190f, 62.499343f,173.613226f, 62.523735f,173.500988f,
                    62.448720f,173.329737f, 62.447456f,173.161524f, 62.421990f,173.180178f, 62.418341f,173.095766f, 62.383074f,173.070009f);
            poly[3045] = new TzPolygon(64.901992f,164.320366f, 64.937469f,164.224707f, 64.893137f,164.151001f, 64.897634f,164.065008f, 64.867590f,164.044649f,
                    64.848028f,163.907742f, 64.861595f,163.828923f, 64.892185f,163.805852f, 64.884989f,163.677854f, 64.928587f,163.544892f,
                    64.801563f,163.363468f, 64.813802f,163.207603f, 64.793097f,163.125913f, 64.693732f,163.266165f, 64.662974f,163.071021f,
                    64.662460f,162.863436f, 65.177208f,162.863436f, 65.177208f,164.320366f);
            poly[3046] = new TzPolygon(64.662460f,162.863436f, 64.662974f,163.071021f, 64.694586f,163.262802f, 64.619065f,163.177361f, 64.536858f,163.192556f,
                    64.445768f,163.414452f, 64.372312f,163.397454f, 64.377293f,163.469251f, 64.358130f,163.495694f, 64.343313f,163.372029f,
                    64.296940f,163.353246f, 64.297835f,163.262415f, 64.157311f,163.179747f, 64.186505f,163.002176f, 64.145700f,162.863436f);
            poly[3047] = new TzPolygon(63.993270f,162.863436f, 63.966554f,162.932787f, 63.922905f,162.954211f, 63.897907f,162.903418f, 63.872114f,162.946072f,
                    63.861455f,162.863436f);
            poly[3048] = new TzPolygon(63.715467f,162.863436f, 63.714187f,162.875229f, 63.645441f,162.892683f, 63.620242f,162.999620f, 63.528581f,162.948028f,
                    63.480369f,162.971039f, 63.415097f,162.876593f, 63.415652f,162.863436f);
            poly[3049] = new TzPolygon(64.901992f,164.320366f, 64.886237f,164.362849f, 64.874799f,164.471833f, 64.825019f,164.516425f, 64.795528f,164.607592f,
                    64.813588f,164.643710f, 64.774320f,164.719691f, 64.767217f,164.800301f, 64.674648f,164.894991f, 64.675938f,165.012585f,
                    64.830462f,165.005101f, 64.854638f,165.137212f, 64.827598f,165.286615f, 64.754340f,165.336542f, 64.764213f,165.387318f,
                    64.733335f,165.445495f, 64.756124f,165.500409f, 64.736539f,165.567374f, 64.751447f,165.681053f, 64.714798f,165.758397f,
                    64.661513f,165.729696f, 64.647931f,165.777295f, 63.303423f,165.777295f, 63.303423f,164.320366f);
            poly[3050] = new TzPolygon(64.647931f,165.777295f, 64.612110f,165.902834f, 64.586512f,165.820972f, 64.547465f,165.850848f, 64.549084f,166.040728f,
                    64.620014f,166.185739f, 64.580803f,166.290592f, 64.590268f,166.407941f, 64.521914f,166.591856f, 64.549762f,166.729994f,
                    64.518863f,166.787804f, 64.544411f,166.859232f, 64.536318f,166.992047f, 64.594463f,167.086985f, 64.592524f,167.135402f,
                    64.619691f,167.126855f, 64.607670f,167.199358f, 64.622668f,167.235509f, 64.501677f,167.339302f, 64.478350f,167.386899f,
                    64.482259f,167.476589f, 64.452476f,167.483564f, 64.428692f,167.587474f, 64.318892f,167.687646f, 64.345986f,167.809568f,
                    64.294216f,167.847339f, 64.265495f,168.038053f, 64.276690f,168.182753f, 64.331137f,168.246553f, 64.297028f,168.367045f,
                    64.317241f,168.482724f, 64.286139f,168.566400f, 64.193683f,168.652026f, 64.191024f,168.691154f, 63.303423f,168.691154f,
                    63.303423f,165.777295f);
            poly[3051] = new TzPolygon(70.798566f,162.863436f, 70.790557f,162.906752f, 70.721297f,163.056431f, 70.641512f,163.105983f, 70.549831f,163.039774f,
                    70.478352f,162.875416f, 70.476842f,162.863436f);
            poly[3052] = new TzPolygon(64.191024f,168.691154f, 64.183617f,168.800179f, 64.108232f,168.808736f, 64.047770f,168.890124f, 63.984723f,168.876823f,
                    63.974183f,169.066729f, 63.935409f,169.090250f, 63.940076f,169.387495f, 63.873241f,169.376450f, 63.805454f,169.574981f,
                    63.691512f,169.570839f, 63.654413f,169.641675f, 63.631820f,169.554445f, 63.564474f,169.527422f, 63.513809f,169.227215f,
                    63.414000f,169.094153f, 63.304942f,168.827449f, 63.303423f,168.826835f, 63.303423f,168.691154f);
        }
    }

    static TzPolygon[] initPolyArray()
    {
        poly = new TzPolygon[3053];

        Initializer1.init();
        Initializer2.init();
        Initializer3.init();
        Initializer4.init();
        Initializer5.init();
        Initializer6.init();
        Initializer7.init();
        Initializer8.init();
        Initializer9.init();
        Initializer10.init();
        Initializer11.init();
        Initializer12.init();
        Initializer13.init();
        Initializer14.init();
        Initializer15.init();
        Initializer16.init();
        Initializer17.init();
        Initializer18.init();
        Initializer19.init();
        Initializer20.init();
        Initializer21.init();
        Initializer22.init();
        Initializer23.init();
        Initializer24.init();
        Initializer25.init();
        Initializer26.init();
        Initializer27.init();
        Initializer28.init();
        Initializer29.init();
        Initializer30.init();
        Initializer31.init();
        return poly;
    }

}